/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ke=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/platform","vs/base/common/async","vs/base/common/strings","vs/platform/log/common/log","vs/base/common/errors","vs/workbench/api/common/extHostTypeConverters","vs/base/common/path","vs/base/common/network","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/base/common/objects","vs/workbench/services/extensions/common/extensions","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/base/common/uuid","vs/base/node/pfs","vs/platform/files/common/files","vs/base/common/extpath","vs/base/common/glob","vs/workbench/api/common/extHostCommands","vs/workbench/services/search/common/search","vs/platform/registry/common/platform","vs/base/common/stopwatch","vs/base/common/severity","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/lazy","vs/base/common/errorMessage","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/position","vs/base/common/process","child_process","vs/platform/configuration/common/configuration","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/hash","vs/base/common/marshalling","fs","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","vs/base/common/themables","net","os","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/ternarySearchTree","vs/base/common/codicons","vs/editor/common/model","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/languages","vs/platform/files/common/watcher","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/stream","vs/editor/common/model/textModelSearch","vs/base/common/mime","vs/base/common/processes","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/api/common/cache","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/filters","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/product/common/productService","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/cache","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/base/node/ports","vs/editor/common/core/eolCounter","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/remote/common/tunnelModel","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","graceful-fs","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],Se=function(me){for(var e=[],D=0,O=me.length;D<O;D++)e[D]=ke[me[D]];return e};define(ke[157],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class D{static get(){const g=new Map,I=new Map,A=new Map,b=new Map;function $(p,S){p.has(S.detail)||p.set(S.detail,-S.timestamp)}function y(p,S){const h=p.get(S.detail);h&&(h>=0||p.set(S.detail,h+S.timestamp))}let L=[];typeof me=="function"&&typeof me.getStats=="function"&&(L=me.getStats().slice(0).sort((p,S)=>p.timestamp-S.timestamp));for(const p of L)switch(p.type){case 10:$(g,p);break;case 11:case 12:y(g,p);break;case 21:$(I,p);break;case 22:y(I,p);break;case 33:$(A,p);break;case 34:y(A,p);break;case 31:$(b,p);break;case 32:y(b,p);break}let C=0;A.forEach(p=>C+=p);function m(p){const S=[];return p.forEach((h,f)=>S.push([f,h])),S}return{amdLoad:m(g),amdInvoke:m(I),nodeRequire:m(A),nodeEval:m(b),nodeRequireTotal:C}}static toMarkdownTable(g,I){let A="";const b=[];return g.forEach(($,y)=>{b[y]=$.length}),I.forEach($=>{$.forEach((y,L)=>{typeof y>"u"&&(y=$[L]="-");const C=y.toString().length;b[L]=Math.max(C,b[L])})}),g.forEach(($,y)=>{A+=`| ${$+" ".repeat(b[y]-$.toString().length)} `}),A+=`|
`,g.forEach(($,y)=>{A+=`| ${"-".repeat(b[y])} `}),A+=`|
`,I.forEach($=>{$.forEach((y,L)=>{typeof y<"u"&&(A+=`| ${y+" ".repeat(b[L]-y.toString().length)} `)}),A+=`|
`}),A}}e.$U=D}),define(ke[158],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rb=e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=void 0;function D(h,f,o){const i=O(h,f);if(i!==-1)return h[i]}e.$fb=D;function O(h,f,o=h.length-1){for(let i=o;i>=0;i--){const r=h[i];if(f(r))return i}return-1}e.$gb=O;function g(h,f){const o=I(h,f);return o===-1?void 0:h[o]}e.$hb=g;function I(h,f,o=0,i=h.length){let r=o,n=i;for(;r<n;){const c=Math.floor((r+n)/2);f(h[c])?r=c+1:n=c}return r-1}e.$ib=I;function A(h,f){const o=b(h,f);return o===h.length?void 0:h[o]}e.$jb=A;function b(h,f,o=0,i=h.length){let r=o,n=i;for(;r<n;){const c=Math.floor((r+n)/2);f(h[c])?n=c:r=c+1}return r}e.$kb=b;function $(h,f,o=0,i=h.length){const r=b(h,f,o,i);return r===h.length?-1:r}e.$lb=$;class y{static{this.assertInvariants=!1}constructor(f){this.e=f,this.c=0}findLastMonotonous(f){if(y.assertInvariants){if(this.d){for(const i of this.e)if(this.d(i)&&!f(i))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=f}const o=I(this.e,f,this.c);return this.c=o+1,o===-1?void 0:this.e[o]}}e.$mb=y;function L(h,f){if(h.length===0)return;let o=h[0];for(let i=1;i<h.length;i++){const r=h[i];f(r,o)>0&&(o=r)}return o}e.$nb=L;function C(h,f){if(h.length===0)return;let o=h[0];for(let i=1;i<h.length;i++){const r=h[i];f(r,o)>=0&&(o=r)}return o}e.$ob=C;function m(h,f){return L(h,(o,i)=>-f(o,i))}e.$pb=m;function p(h,f){if(h.length===0)return-1;let o=0;for(let i=1;i<h.length;i++){const r=h[i];f(r,h[o])>0&&(o=i)}return o}e.$qb=p;function S(h,f){for(const o of h){const i=f(o);if(i!==void 0)return i}}e.$rb=S}),define(ke[73],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N=e.$M=e.$L=e.$K=void 0;function D(A,b){const $=Object.create(null);for(const y of A){const L=b(y);let C=$[L];C||(C=$[L]=[]),C.push(y)}return $}e.$K=D;function O(A,b){const $=[],y=[];for(const L of A)b.has(L)||$.push(L);for(const L of b)A.has(L)||y.push(L);return{removed:$,added:y}}e.$L=O;function g(A,b){const $=[],y=[];for(const[L,C]of A)b.has(L)||$.push(C);for(const[L,C]of b)A.has(L)||y.push(C);return{removed:$,added:y}}e.$M=g;function I(A,b){const $=new Set;for(const y of b)A.has(y)&&$.add(y);return $}e.$N=I}),define(ke[52],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zh=e.$yh=e.$xh=void 0;function D(A){return(b,$,y)=>{let L=null,C=null;if(typeof y.value=="function"?(L="value",C=y.value):typeof y.get=="function"&&(L="get",C=y.get),!C)throw new Error("not supported");y[L]=A(C,$)}}function O(A,b,$){let y=null,L=null;if(typeof $.value=="function"?(y="value",L=$.value,L.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof $.get=="function"&&(y="get",L=$.get),!L)throw new Error("not supported");const C=`$memoize$${b}`;$[y]=function(...m){return this.hasOwnProperty(C)||Object.defineProperty(this,C,{configurable:!1,enumerable:!1,writable:!1,value:L.apply(this,m)}),this[C]}}e.$xh=O;function g(A,b,$){return D((y,L)=>{const C=`$debounce$${L}`,m=`$debounce$result$${L}`;return function(...p){this[m]||(this[m]=$?$():void 0),clearTimeout(this[C]),b&&(this[m]=b(this[m],...p),p=[this[m]]),this[C]=setTimeout(()=>{y.apply(this,p),this[m]=$?$():void 0},A)}})}e.$yh=g;function I(A,b,$){return D((y,L)=>{const C=`$throttle$timer$${L}`,m=`$throttle$result$${L}`,p=`$throttle$lastRun$${L}`,S=`$throttle$pending$${L}`;return function(...h){if(this[m]||(this[m]=$?$():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),b&&(this[m]=b(this[m],...h)),this[S])return;const f=this[p]+A;f<=Date.now()?(this[p]=Date.now(),y.apply(this,[this[m]]),this[m]=$?$():void 0):(this[S]=!0,this[C]=setTimeout(()=>{this[S]=!1,this[p]=Date.now(),y.apply(this,[this[m]]),this[m]=$?$():void 0},f-Date.now()))}})}e.$zh=I}),define(ke[14],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.setUnexpectedErrorHandler=e.$X=e.$W=void 0;class D{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?r.isErrorNoTelemetry(t)?new r(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(u=>{u(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=D,e.$X=new D;function O(c){e.$X.setUnexpectedErrorHandler(c)}e.setUnexpectedErrorHandler=O;function g(c){if(!c||typeof c!="object")return!1;const t=c;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}e.$Z=g;function I(c){y(c)||e.$X.onUnexpectedError(c)}e.$1=I;function A(c){y(c)||e.$X.onUnexpectedExternalError(c)}e.$2=A;function b(c){if(c instanceof Error){const{name:t,message:u}=c,s=c.stacktrace||c.stack;return{$isError:!0,name:t,message:u,stack:s,noTelemetry:r.isErrorNoTelemetry(c)}}return c}e.$3=b;const $="Canceled";function y(c){return c instanceof L?!0:c instanceof Error&&c.name===$&&c.message===$}e.$4=y;class L extends Error{constructor(){super($),this.name=this.message}}e.$5=L;function C(){const c=new Error($);return c.name=c.message,c}e.$6=C;function m(c){return c?new Error(`Illegal argument: ${c}`):new Error("Illegal argument")}e.$7=m;function p(c){return c?new Error(`Illegal state: ${c}`):new Error("Illegal state")}e.$8=p;class S extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=S;function h(c){return c?c.message?c.message:c.stack?c.stack.split(`
`)[0]:String(c):"Error"}e.$0=h;class f extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=f;class o extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=o;class i extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=i;class r extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof r)return t;const u=new r;return u.message=t.message,u.stack=t.stack,u}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=r;class n extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,n.prototype)}}e.$cb=n}),define(ke[19],Se([1,0,14,158]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.CompareResult=e.$6b=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.top=e.$Eb=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=void 0;function g(de,ge=0){return de[de.length-(1+ge)]}e.$sb=g;function I(de){if(de.length===0)throw new Error("Invalid tail call");return[de.slice(0,de.length-1),de[de.length-1]]}e.$tb=I;function A(de,ge,x=(te,G)=>te===G){if(de===ge)return!0;if(!de||!ge||de.length!==ge.length)return!1;for(let te=0,G=de.length;te<G;te++)if(!x(de[te],ge[te]))return!1;return!0}e.$ub=A;function b(de,ge){const x=de.length-1;ge<x&&(de[ge]=de[x]),de.pop()}e.$vb=b;function $(de,ge,x){return y(de.length,te=>x(de[te],ge))}e.$wb=$;function y(de,ge){let x=0,te=de-1;for(;x<=te;){const G=(x+te)/2|0,ie=ge(G);if(ie<0)x=G+1;else if(ie>0)te=G-1;else return G}return-(x+1)}e.$xb=y;function L(de,ge,x){if(de=de|0,de>=ge.length)throw new TypeError("invalid index");const te=ge[Math.floor(ge.length*Math.random())],G=[],ie=[],fe=[];for(const pe of ge){const Pe=x(pe,te);Pe<0?G.push(pe):Pe>0?ie.push(pe):fe.push(pe)}return de<G.length?L(de,G,x):de<G.length+fe.length?fe[0]:L(de-(G.length+fe.length),ie,x)}e.$yb=L;function C(de,ge){const x=[];let te;for(const G of de.slice(0).sort(ge))!te||ge(te[0],G)!==0?(te=[G],x.push(te)):te.push(G);return x}e.$zb=C;function*m(de,ge){let x,te;for(const G of de)te!==void 0&&ge(te,G)?x.push(G):(x&&(yield x),x=[G]),te=G;x&&(yield x)}e.$Ab=m;function p(de,ge){for(let x=0;x<=de.length;x++)ge(x===0?void 0:de[x-1],x===de.length?void 0:de[x])}e.$Bb=p;function S(de,ge){for(let x=0;x<de.length;x++)ge(x===0?void 0:de[x-1],de[x],x+1===de.length?void 0:de[x+1])}e.$Cb=S;function h(de,ge,x){const te=[];function G(pe,Pe,be){if(Pe===0&&be.length===0)return;const De=te[te.length-1];De&&De.start+De.deleteCount===pe?(De.deleteCount+=Pe,De.toInsert.push(...be)):te.push({start:pe,deleteCount:Pe,toInsert:be})}let ie=0,fe=0;for(;;){if(ie===de.length){G(ie,0,ge.slice(fe));break}if(fe===ge.length){G(ie,de.length-ie,[]);break}const pe=de[ie],Pe=ge[fe],be=x(pe,Pe);be===0?(ie+=1,fe+=1):be<0?(G(ie,1,[]),ie+=1):be>0&&(G(ie,0,[Pe]),fe+=1)}return te}e.$Db=h;function f(de,ge,x){const te=h(de,ge,x),G=[],ie=[];for(const fe of te)G.push(...de.slice(fe.start,fe.start+fe.deleteCount)),ie.push(...fe.toInsert);return{removed:G,added:ie}}e.$Eb=f;function o(de,ge,x){if(x===0)return[];const te=de.slice(0,x).sort(ge);return r(de,ge,te,x,de.length),te}e.top=o;function i(de,ge,x,te,G){return x===0?Promise.resolve([]):new Promise((ie,fe)=>{(async()=>{const pe=de.length,Pe=de.slice(0,x).sort(ge);for(let be=x,De=Math.min(x+te,pe);be<pe;be=De,De=Math.min(De+te,pe)){if(be>x&&await new Promise(z=>setTimeout(z)),G&&G.isCancellationRequested)throw new D.$5;r(de,ge,Pe,be,De)}return Pe})().then(ie,fe)})}e.$Gb=i;function r(de,ge,x,te,G){for(const ie=x.length;te<G;te++){const fe=de[te];if(ge(fe,x[ie-1])<0){x.pop();const pe=(0,O.$kb)(x,Pe=>ge(fe,Pe)<0);x.splice(pe,0,fe)}}}function n(de){return de.filter(ge=>!!ge)}e.$Hb=n;function c(de){let ge=0;for(let x=0;x<de.length;x++)de[x]&&(de[ge]=de[x],ge+=1);de.length=ge}e.$Ib=c;function t(de,ge,x){de.splice(x,0,de.splice(ge,1)[0])}e.$Jb=t;function u(de){return!Array.isArray(de)||de.length===0}e.$Kb=u;function s(de){return Array.isArray(de)&&de.length>0}e.$Lb=s;function l(de,ge=x=>x){const x=new Set;return de.filter(te=>{const G=ge(te);return x.has(G)?!1:(x.add(G),!0)})}e.$Mb=l;function a(de){const ge=new Set;return x=>{const te=de(x);return ge.has(te)?!1:(ge.add(te),!0)}}e.$Nb=a;function d(de,ge){return de.length>0?de[0]:ge}e.$Ob=d;function k(de,ge){return de.length>0?de[de.length-1]:ge}e.$Pb=k;function R(de,ge,x=(te,G)=>te===G){let te=0;for(let G=0,ie=Math.min(de.length,ge.length);G<ie&&x(de[G],ge[G]);G++)te++;return te}e.$Qb=R;function v(de){return[].concat(...de)}e.$Rb=v;function w(de,ge){let x=typeof ge=="number"?de:0;typeof ge=="number"?x=de:(x=0,ge=de);const te=[];if(x<=ge)for(let G=x;G<ge;G++)te.push(G);else for(let G=x;G>ge;G--)te.push(G);return te}e.$Sb=w;function E(de,ge,x){return de.reduce((te,G)=>(te[ge(G)]=x?x(G):G,te),Object.create(null))}e.$Tb=E;function P(de,ge){return de.push(ge),()=>N(de,ge)}e.$Ub=P;function N(de,ge){const x=de.indexOf(ge);if(x>-1)return de.splice(x,1),ge}e.$Vb=N;function U(de,ge,x){const te=de.slice(0,ge),G=de.slice(ge);return te.concat(x,G)}e.$Wb=U;function F(de,ge){let x;if(typeof ge=="number"){let te=ge;x=()=>{const G=Math.sin(te++)*179426549;return G-Math.floor(G)}}else x=Math.random;for(let te=de.length-1;te>0;te-=1){const G=Math.floor(x()*(te+1)),ie=de[te];de[te]=de[G],de[G]=ie}}e.$Xb=F;function j(de,ge){const x=de.indexOf(ge);x>-1&&(de.splice(x,1),de.unshift(ge))}e.$Yb=j;function T(de,ge){const x=de.indexOf(ge);x>-1&&(de.splice(x,1),de.push(ge))}e.$Zb=T;function M(de,ge){for(const x of ge)de.push(x)}e.$1b=M;function B(de,ge){return Array.isArray(de)?de.map(ge):ge(de)}e.$2b=B;function Y(de){return Array.isArray(de)?de:[de]}e.$3b=Y;function ue(de){return de[Math.floor(Math.random()*de.length)]}e.$4b=ue;function Z(de,ge,x){const te=X(de,ge),G=de.length,ie=x.length;de.length=G+ie;for(let fe=G-1;fe>=te;fe--)de[fe+ie]=de[fe];for(let fe=0;fe<ie;fe++)de[fe+te]=x[fe]}e.$5b=Z;function J(de,ge,x,te){const G=X(de,ge);let ie=de.splice(G,x);return ie===void 0&&(ie=[]),Z(de,G,te),ie}e.$6b=J;function X(de,ge){return ge<0?Math.max(ge+de.length,0):Math.min(ge,de.length)}var he;(function(de){function ge(ie){return ie<0}de.isLessThan=ge;function x(ie){return ie<=0}de.isLessThanOrEqual=x;function te(ie){return ie>0}de.isGreaterThan=te;function G(ie){return ie===0}de.isNeitherLessOrGreaterThan=G,de.greaterThan=1,de.lessThan=-1,de.neitherLessOrGreaterThan=0})(he||(e.CompareResult=he={}));function _(de,ge){return(x,te)=>ge(de(x),de(te))}e.$7b=_;function we(...de){return(ge,x)=>{for(const te of de){const G=te(ge,x);if(!he.isNeitherLessOrGreaterThan(G))return G}return he.neitherLessOrGreaterThan}}e.$8b=we;const oe=(de,ge)=>de-ge;e.$9b=oe;const K=(de,ge)=>(0,e.$9b)(de?1:0,ge?1:0);e.$0b=K;function W(de){return(ge,x)=>-de(ge,x)}e.$$b=W;class re{constructor(ge){this.g=ge,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(ge){let x=this.c;for(;x<this.g.length&&ge(this.g[x]);)x++;const te=x===this.c?null:this.g.slice(this.c,x);return this.c=x,te}takeFromEndWhile(ge){let x=this.d;for(;x>=0&&ge(this.g[x]);)x--;const te=x===this.d?null:this.g.slice(x+1,this.d+1);return this.d=x,te}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const ge=this.g[this.c];return this.c++,ge}removeLast(){const ge=this.g[this.d];return this.d--,ge}takeCount(ge){const x=this.g.slice(this.c,this.c+ge);return this.c+=ge,x}}e.$_b=re;class ye{static{this.empty=new ye(ge=>{})}constructor(ge){this.iterate=ge}forEach(ge){this.iterate(x=>(ge(x),!0))}toArray(){const ge=[];return this.iterate(x=>(ge.push(x),!0)),ge}filter(ge){return new ye(x=>this.iterate(te=>ge(te)?x(te):!0))}map(ge){return new ye(x=>this.iterate(te=>x(ge(te))))}some(ge){let x=!1;return this.iterate(te=>(x=ge(te),!x)),x}findFirst(ge){let x;return this.iterate(te=>ge(te)?(x=te,!1):!0),x}findLast(ge){let x;return this.iterate(te=>(ge(te)&&(x=te),!0)),x}findLastMaxBy(ge){let x,te=!0;return this.iterate(G=>((te||he.isGreaterThan(ge(G,x)))&&(te=!1,x=G),!0)),x}}e.$ac=ye}),define(ke[60],Se([1,0,14]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9c=e.$8c=e.$7c=e.$6c=e.ok=void 0;function O($,y){if(!$)throw new Error(y?`Assertion failed (${y})`:"Assertion Failed")}e.ok=O;function g($,y="Unreachable"){throw new Error(y)}e.$6c=g;function I($){if(!$)throw new D.$cb("Assertion Failed")}e.$7c=I;function A($){if(!$()){debugger;$(),(0,D.$1)(new D.$cb("Assertion Failed"))}}e.$8c=A;function b($,y){let L=0;for(;L<$.length-1;){const C=$[L],m=$[L+1];if(!y(C,m))return!1;L++}return!0}e.$9c=b}),define(ke[74],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=void 0;function D(O,g){const I=this;let A=!1,b;return function(){if(A)return b;if(A=!0,g)try{b=O.apply(I,arguments)}finally{g()}else b=O.apply(I,arguments);return b}}e.$db=D}),define(ke[121],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dN=e.$cN=void 0;class D{constructor(g){this.a=g,this.b=0}nextId(){return this.a+ ++this.b}}e.$cN=D,e.$dN=new D("id#")}),define(ke[53],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var D;(function(O){function g(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}O.is=g;const I=Object.freeze([]);function A(){return I}O.empty=A;function*b(t){yield t}O.single=b;function $(t){return g(t)?t:b(t)}O.wrap=$;function y(t){return t||I}O.from=y;function*L(t){for(let u=t.length-1;u>=0;u--)yield t[u]}O.reverse=L;function C(t){return!t||t[Symbol.iterator]().next().done===!0}O.isEmpty=C;function m(t){return t[Symbol.iterator]().next().value}O.first=m;function p(t,u){for(const s of t)if(u(s))return!0;return!1}O.some=p;function S(t,u){for(const s of t)if(u(s))return s}O.find=S;function*h(t,u){for(const s of t)u(s)&&(yield s)}O.filter=h;function*f(t,u){let s=0;for(const l of t)yield u(l,s++)}O.map=f;function*o(...t){for(const u of t)yield*u}O.concat=o;function i(t,u,s){let l=s;for(const a of t)l=u(l,a);return l}O.reduce=i;function*r(t,u,s=t.length){for(u<0&&(u+=t.length),s<0?s+=t.length:s>t.length&&(s=t.length);u<s;u++)yield t[u]}O.slice=r;function n(t,u=Number.POSITIVE_INFINITY){const s=[];if(u===0)return[s,t];const l=t[Symbol.iterator]();for(let a=0;a<u;a++){const d=l.next();if(d.done)return[s,O.empty()];s.push(d.value)}return[s,{[Symbol.iterator](){return l}}]}O.consume=n;async function c(t){const u=[];for await(const s of t)u.push(s);return Promise.resolve(u)}O.asyncToArray=c})(D||(e.Iterable=D={}))}),define(ke[159],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var D;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(D||(e.ScanError=D={}));var O;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(O||(e.SyntaxKind=O={}));var g;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(g||(e.ParseErrorCode=g={}));var I;(function(t){t.DEFAULT={allowTrailingComma:!0}})(I||(e.ParseOptions=I={}));function A(t,u=!1){let s=0;const l=t.length;let a="",d=0,k=16,R=0;function v(j){let T=0,M=0;for(;T<j;){const B=t.charCodeAt(s);if(B>=48&&B<=57)M=M*16+B-48;else if(B>=65&&B<=70)M=M*16+B-65+10;else if(B>=97&&B<=102)M=M*16+B-97+10;else break;s++,T++}return T<j&&(M=-1),M}function w(j){s=j,a="",d=0,k=16,R=0}function E(){const j=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&y(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&y(t.charCodeAt(s)))for(s++;s<t.length&&y(t.charCodeAt(s));)s++;else return R=3,t.substring(j,s);let T=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&y(t.charCodeAt(s))){for(s++;s<t.length&&y(t.charCodeAt(s));)s++;T=s}else R=3;return t.substring(j,T)}function P(){let j="",T=s;for(;;){if(s>=l){j+=t.substring(T,s),R=2;break}const M=t.charCodeAt(s);if(M===34){j+=t.substring(T,s),s++;break}if(M===92){if(j+=t.substring(T,s),s++,s>=l){R=2;break}switch(t.charCodeAt(s++)){case 34:j+='"';break;case 92:j+="\\";break;case 47:j+="/";break;case 98:j+="\b";break;case 102:j+="\f";break;case 110:j+=`
`;break;case 114:j+="\r";break;case 116:j+="	";break;case 117:{const Y=v(4);Y>=0?j+=String.fromCharCode(Y):R=4;break}default:R=5}T=s;continue}if(M>=0&&M<=31)if($(M)){j+=t.substring(T,s),R=2;break}else R=6;s++}return j}function N(){if(a="",R=0,d=s,s>=l)return d=l,k=17;let j=t.charCodeAt(s);if(b(j)){do s++,a+=String.fromCharCode(j),j=t.charCodeAt(s);while(b(j));return k=15}if($(j))return s++,a+=String.fromCharCode(j),j===13&&t.charCodeAt(s)===10&&(s++,a+=`
`),k=14;switch(j){case 123:return s++,k=1;case 125:return s++,k=2;case 91:return s++,k=3;case 93:return s++,k=4;case 58:return s++,k=6;case 44:return s++,k=5;case 34:return s++,a=P(),k=10;case 47:{const T=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<l&&!$(t.charCodeAt(s));)s++;return a=t.substring(T,s),k=12}if(t.charCodeAt(s+1)===42){s+=2;const M=l-1;let B=!1;for(;s<M;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,B=!0;break}s++}return B||(s++,R=1),a=t.substring(T,s),k=13}return a+=String.fromCharCode(j),s++,k=16}case 45:if(a+=String.fromCharCode(j),s++,s===l||!y(t.charCodeAt(s)))return k=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=E(),k=11;default:for(;s<l&&U(j);)s++,j=t.charCodeAt(s);if(d!==s){switch(a=t.substring(d,s),a){case"true":return k=8;case"false":return k=9;case"null":return k=7}return k=16}return a+=String.fromCharCode(j),s++,k=16}}function U(j){if(b(j)||$(j))return!1;switch(j){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function F(){let j;do j=N();while(j>=12&&j<=15);return j}return{setPosition:w,getPosition:()=>s,scan:u?F:N,getToken:()=>k,getTokenValue:()=>a,getTokenOffset:()=>d,getTokenLength:()=>s-d,getTokenError:()=>R}}e.$an=A;function b(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function $(t){return t===10||t===13||t===8232||t===8233}function y(t){return t>=48&&t<=57}var L;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(L||(L={}));function C(t,u){const s=[],l=new Object;let a;const d={value:{},offset:0,length:0,type:"object",parent:void 0};let k=!1;function R(v,w,E,P){d.value=v,d.offset=w,d.length=E,d.type=P,d.colonOffset=void 0,a=d}try{r(t,{onObjectBegin:(v,w)=>{if(u<=v)throw l;a=void 0,k=u>v,s.push("")},onObjectProperty:(v,w,E)=>{if(u<w||(R(v,w,E,"property"),s[s.length-1]=v,u<=w+E))throw l},onObjectEnd:(v,w)=>{if(u<=v)throw l;a=void 0,s.pop()},onArrayBegin:(v,w)=>{if(u<=v)throw l;a=void 0,s.push(0)},onArrayEnd:(v,w)=>{if(u<=v)throw l;a=void 0,s.pop()},onLiteralValue:(v,w,E)=>{if(u<w||(R(v,w,E,c(v)),u<=w+E))throw l},onSeparator:(v,w,E)=>{if(u<=w)throw l;if(v===":"&&a&&a.type==="property")a.colonOffset=w,k=!1,a=void 0;else if(v===","){const P=s[s.length-1];typeof P=="number"?s[s.length-1]=P+1:(k=!0,s[s.length-1]=""),a=void 0}}})}catch(v){if(v!==l)throw v}return{path:s,previousNode:a,isAtPropertyKey:k,matches:v=>{let w=0;for(let E=0;w<v.length&&E<s.length;E++)if(v[w]===s[E]||v[w]==="*")w++;else if(v[w]!=="**")return!1;return w===v.length}}}e.$bn=C;function m(t,u=[],s=I.DEFAULT){let l=null,a=[];const d=[];function k(v){Array.isArray(a)?a.push(v):l!==null&&(a[l]=v)}return r(t,{onObjectBegin:()=>{const v={};k(v),d.push(a),a=v,l=null},onObjectProperty:v=>{l=v},onObjectEnd:()=>{a=d.pop()},onArrayBegin:()=>{const v=[];k(v),d.push(a),a=v,l=null},onArrayEnd:()=>{a=d.pop()},onLiteralValue:k,onError:(v,w,E)=>{u.push({error:v,offset:w,length:E})}},s),a[0]}e.$cn=m;function p(t,u=[],s=I.DEFAULT){let l={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(v){l.type==="property"&&(l.length=v-l.offset,l=l.parent)}function d(v){return l.children.push(v),v}r(t,{onObjectBegin:v=>{l=d({type:"object",offset:v,length:-1,parent:l,children:[]})},onObjectProperty:(v,w,E)=>{l=d({type:"property",offset:w,length:-1,parent:l,children:[]}),l.children.push({type:"string",value:v,offset:w,length:E,parent:l})},onObjectEnd:(v,w)=>{l.length=v+w-l.offset,l=l.parent,a(v+w)},onArrayBegin:(v,w)=>{l=d({type:"array",offset:v,length:-1,parent:l,children:[]})},onArrayEnd:(v,w)=>{l.length=v+w-l.offset,l=l.parent,a(v+w)},onLiteralValue:(v,w,E)=>{d({type:c(v),offset:w,length:E,parent:l,value:v}),a(w+E)},onSeparator:(v,w,E)=>{l.type==="property"&&(v===":"?l.colonOffset=w:v===","&&a(w))},onError:(v,w,E)=>{u.push({error:v,offset:w,length:E})}},s);const R=l.children[0];return R&&delete R.parent,R}e.$dn=p;function S(t,u){if(!t)return;let s=t;for(const l of u)if(typeof l=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let a=!1;for(const d of s.children)if(Array.isArray(d.children)&&d.children[0].value===l){s=d.children[1],a=!0;break}if(!a)return}else{const a=l;if(s.type!=="array"||a<0||!Array.isArray(s.children)||a>=s.children.length)return;s=s.children[a]}return s}e.$en=S;function h(t){if(!t.parent||!t.parent.children)return[];const u=h(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;u.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&u.push(s)}return u}e.$fn=h;function f(t){switch(t.type){case"array":return t.children.map(f);case"object":{const u=Object.create(null);for(const s of t.children){const l=s.children[1];l&&(u[s.children[0].value]=f(l))}return u}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$gn=f;function o(t,u,s=!1){return u>=t.offset&&u<t.offset+t.length||s&&u===t.offset+t.length}e.$hn=o;function i(t,u,s=!1){if(o(t,u,s)){const l=t.children;if(Array.isArray(l))for(let a=0;a<l.length&&l[a].offset<=u;a++){const d=i(l[a],u,s);if(d)return d}return t}}e.$in=i;function r(t,u,s=I.DEFAULT){const l=A(t,!1);function a(_){return _?()=>_(l.getTokenOffset(),l.getTokenLength()):()=>!0}function d(_){return _?we=>_(we,l.getTokenOffset(),l.getTokenLength()):()=>!0}const k=a(u.onObjectBegin),R=d(u.onObjectProperty),v=a(u.onObjectEnd),w=a(u.onArrayBegin),E=a(u.onArrayEnd),P=d(u.onLiteralValue),N=d(u.onSeparator),U=a(u.onComment),F=d(u.onError),j=s&&s.disallowComments,T=s&&s.allowTrailingComma;function M(){for(;;){const _=l.scan();switch(l.getTokenError()){case 4:B(14);break;case 5:B(15);break;case 3:B(13);break;case 1:j||B(11);break;case 2:B(12);break;case 6:B(16);break}switch(_){case 12:case 13:j?B(10):U();break;case 16:B(1);break;case 15:case 14:break;default:return _}}}function B(_,we=[],oe=[]){if(F(_),we.length+oe.length>0){let K=l.getToken();for(;K!==17;){if(we.indexOf(K)!==-1){M();break}else if(oe.indexOf(K)!==-1)break;K=M()}}}function Y(_){const we=l.getTokenValue();return _?P(we):R(we),M(),!0}function ue(){switch(l.getToken()){case 11:{let _=0;try{_=JSON.parse(l.getTokenValue()),typeof _!="number"&&(B(2),_=0)}catch{B(2)}P(_);break}case 7:P(null);break;case 8:P(!0);break;case 9:P(!1);break;default:return!1}return M(),!0}function Z(){return l.getToken()!==10?(B(3,[],[2,5]),!1):(Y(!1),l.getToken()===6?(N(":"),M(),he()||B(4,[],[2,5])):B(5,[],[2,5]),!0)}function J(){k(),M();let _=!1;for(;l.getToken()!==2&&l.getToken()!==17;){if(l.getToken()===5){if(_||B(4,[],[]),N(","),M(),l.getToken()===2&&T)break}else _&&B(6,[],[]);Z()||B(4,[],[2,5]),_=!0}return v(),l.getToken()!==2?B(7,[2],[]):M(),!0}function X(){w(),M();let _=!1;for(;l.getToken()!==4&&l.getToken()!==17;){if(l.getToken()===5){if(_||B(4,[],[]),N(","),M(),l.getToken()===4&&T)break}else _&&B(6,[],[]);he()||B(4,[],[4,5]),_=!0}return E(),l.getToken()!==4?B(8,[4],[]):M(),!0}function he(){switch(l.getToken()){case 3:return X();case 1:return J();case 10:return Y(!0);default:return ue()}}return M(),l.getToken()===17?s.allowEmptyContent?!0:(B(4,[],[]),!1):he()?(l.getToken()!==17&&B(9,[],[]),!0):(B(4,[],[]),!1)}e.$jn=r;function n(t,u){const s=A(t),l=[];let a,d=0,k;do switch(k=s.getPosition(),a=s.scan(),a){case 12:case 13:case 17:d!==k&&l.push(t.substring(d,k)),u!==void 0&&l.push(s.getTokenValue().replace(/[^\r\n]/g,u)),d=s.getPosition();break}while(a!==17);return l.join("")}e.$kn=n;function c(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$ln=c}),define(ke[43],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class D{constructor(g){this.d=g,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(g){this.c=g}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=D}),define(ke[75],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=void 0;class D{static{this.Undefined=new D(void 0)}constructor(I){this.element=I,this.next=D.Undefined,this.prev=D.Undefined}}class O{constructor(){this.a=D.Undefined,this.b=D.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===D.Undefined}clear(){let I=this.a;for(;I!==D.Undefined;){const A=I.next;I.prev=D.Undefined,I.next=D.Undefined,I=A}this.a=D.Undefined,this.b=D.Undefined,this.c=0}unshift(I){return this.d(I,!1)}push(I){return this.d(I,!0)}d(I,A){const b=new D(I);if(this.a===D.Undefined)this.a=b,this.b=b;else if(A){const y=this.b;this.b=b,b.prev=y,y.next=b}else{const y=this.a;this.a=b,b.next=y,y.prev=b}this.c+=1;let $=!1;return()=>{$||($=!0,this.e(b))}}shift(){if(this.a!==D.Undefined){const I=this.a.element;return this.e(this.a),I}}pop(){if(this.b!==D.Undefined){const I=this.b.element;return this.e(this.b),I}}e(I){if(I.prev!==D.Undefined&&I.next!==D.Undefined){const A=I.prev;A.next=I.next,I.next.prev=A}else I.prev===D.Undefined&&I.next===D.Undefined?(this.a=D.Undefined,this.b=D.Undefined):I.next===D.Undefined?(this.b=this.b.prev,this.b.next=D.Undefined):I.prev===D.Undefined&&(this.a=this.a.next,this.a.prev=D.Undefined);this.c-=1}*[Symbol.iterator](){let I=this.a;for(;I!==D.Undefined;)yield I.element,I=I.next}}e.$4c=O}),define(ke[28],Se([1,0]),function(me,e){"use strict";var D,O,g;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=e.$zc=e.$yc=e.$xc=void 0;function I(r,n,c){let t=r.get(n);return t===void 0&&(t=c,r.set(n,t)),t}e.$xc=I;function A(r){const n=[];return r.forEach((c,t)=>{n.push(`${t} => ${c}`)}),`Map(${r.size}) {${n.join(", ")}}`}e.$yc=A;function b(r){const n=[];return r.forEach(c=>{n.push(c)}),`Set(${r.size}) {${n.join(", ")}}`}e.$zc=b;class ${constructor(n,c){this.uri=n,this.value=c}}function y(r){return Array.isArray(r)}class L{static{this.c=n=>n.toString()}constructor(n,c){if(this[D]="ResourceMap",n instanceof L)this.d=new Map(n.d),this.e=c??L.c;else if(y(n)){this.d=new Map,this.e=c??L.c;for(const[t,u]of n)this.set(t,u)}else this.d=new Map,this.e=n??L.c}set(n,c){return this.d.set(this.e(n),new $(n,c)),this}get(n){return this.d.get(this.e(n))?.value}has(n){return this.d.has(this.e(n))}get size(){return this.d.size}clear(){this.d.clear()}delete(n){return this.d.delete(this.e(n))}forEach(n,c){typeof c<"u"&&(n=n.bind(c));for(const[t,u]of this.d)n(u.value,u.uri,this)}*values(){for(const n of this.d.values())yield n.value}*keys(){for(const n of this.d.values())yield n.uri}*entries(){for(const n of this.d.values())yield[n.uri,n.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.d)yield[n.uri,n.value]}}e.$Ac=L;class C{constructor(n,c){this[O]="ResourceSet",!n||typeof n=="function"?this.c=new L(n):(this.c=new L(c),n.forEach(this.add,this))}get size(){return this.c.size}add(n){return this.c.set(n,n),this}clear(){this.c.clear()}delete(n){return this.c.delete(n)}forEach(n,c){this.c.forEach((t,u)=>n.call(c,u,u,this))}has(n){return this.c.has(n)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(O=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=C;var m;(function(r){r[r.None=0]="None",r[r.AsOld=1]="AsOld",r[r.AsNew=2]="AsNew"})(m||(e.Touch=m={}));class p{constructor(){this[g]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(n){return this.c.has(n)}get(n,c=0){const t=this.c.get(n);if(t)return c!==0&&this.l(t,c),t.value}set(n,c,t=0){let u=this.c.get(n);if(u)u.value=c,t!==0&&this.l(u,t);else{switch(u={key:n,value:c,next:void 0,previous:void 0},t){case 0:this.j(u);break;case 1:this.i(u);break;case 2:this.j(u);break;default:this.j(u);break}this.c.set(n,u),this.f++}return this}delete(n){return!!this.remove(n)}remove(n){const c=this.c.get(n);if(c)return this.c.delete(n),this.k(c),this.f--,c.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const n=this.d;return this.c.delete(n.key),this.k(n),this.f--,n.value}forEach(n,c){const t=this.g;let u=this.d;for(;u;){if(c?n.bind(c)(u.value,u.key,this):n(u.value,u.key,this),this.g!==t)throw new Error("LinkedMap got modified during iteration.");u=u.next}}keys(){const n=this,c=this.g;let t=this.d;const u={[Symbol.iterator](){return u},next(){if(n.g!==c)throw new Error("LinkedMap got modified during iteration.");if(t){const s={value:t.key,done:!1};return t=t.next,s}else return{value:void 0,done:!0}}};return u}values(){const n=this,c=this.g;let t=this.d;const u={[Symbol.iterator](){return u},next(){if(n.g!==c)throw new Error("LinkedMap got modified during iteration.");if(t){const s={value:t.value,done:!1};return t=t.next,s}else return{value:void 0,done:!0}}};return u}entries(){const n=this,c=this.g;let t=this.d;const u={[Symbol.iterator](){return u},next(){if(n.g!==c)throw new Error("LinkedMap got modified during iteration.");if(t){const s={value:[t.key,t.value],done:!1};return t=t.next,s}else return{value:void 0,done:!0}}};return u}[(g=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(n){if(n>=this.size)return;if(n===0){this.clear();return}let c=this.d,t=this.size;for(;c&&t>n;)this.c.delete(c.key),c=c.next,t--;this.d=c,this.f=t,c&&(c.previous=void 0),this.g++}i(n){if(!this.d&&!this.e)this.e=n;else if(this.d)n.next=this.d,this.d.previous=n;else throw new Error("Invalid list");this.d=n,this.g++}j(n){if(!this.d&&!this.e)this.d=n;else if(this.e)n.previous=this.e,this.e.next=n;else throw new Error("Invalid list");this.e=n,this.g++}k(n){if(n===this.d&&n===this.e)this.d=void 0,this.e=void 0;else if(n===this.d){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this.d=n.next}else if(n===this.e){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this.e=n.previous}else{const c=n.next,t=n.previous;if(!c||!t)throw new Error("Invalid list");c.previous=t,t.next=c}n.next=void 0,n.previous=void 0,this.g++}l(n,c){if(!this.d||!this.e)throw new Error("Invalid list");if(!(c!==1&&c!==2)){if(c===1){if(n===this.d)return;const t=n.next,u=n.previous;n===this.e?(u.next=void 0,this.e=u):(t.previous=u,u.next=t),n.previous=void 0,n.next=this.d,this.d.previous=n,this.d=n,this.g++}else if(c===2){if(n===this.e)return;const t=n.next,u=n.previous;n===this.d?(t.previous=void 0,this.d=t):(t.previous=u,u.next=t),n.next=void 0,n.previous=this.e,this.e.next=n,this.e=n,this.g++}}}toJSON(){const n=[];return this.forEach((c,t)=>{n.push([t,c])}),n}fromJSON(n){this.clear();for(const[c,t]of n)this.set(c,t)}}e.$Cc=p;class S extends p{constructor(n,c=1){super(),this.m=n,this.n=Math.min(Math.max(0,c),1)}get limit(){return this.m}set limit(n){this.m=n,this.o()}get ratio(){return this.n}set ratio(n){this.n=Math.min(Math.max(0,n),1),this.o()}get(n,c=2){return super.get(n,c)}peek(n){return super.get(n,0)}set(n,c){return super.set(n,c,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}e.$Dc=S;class h{constructor(){this.c=new Map}add(n){return this.c.set(n,(this.c.get(n)||0)+1),this}delete(n){let c=this.c.get(n)||0;return c===0?!1:(c--,c===0?this.c.delete(n):this.c.set(n,c),!0)}has(n){return this.c.has(n)}}e.$Ec=h;class f{constructor(n){if(this.c=new Map,this.d=new Map,n)for(const[c,t]of n)this.set(c,t)}clear(){this.c.clear(),this.d.clear()}set(n,c){this.c.set(n,c),this.d.set(c,n)}get(n){return this.c.get(n)}getKey(n){return this.d.get(n)}delete(n){const c=this.c.get(n);return c===void 0?!1:(this.c.delete(n),this.d.delete(c),!0)}forEach(n,c){this.c.forEach((t,u)=>{n.call(c,t,u,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Fc=f;class o{constructor(){this.c=new Map}add(n,c){let t=this.c.get(n);t||(t=new Set,this.c.set(n,t)),t.add(c)}delete(n,c){const t=this.c.get(n);t&&(t.delete(c),t.size===0&&this.c.delete(n))}forEach(n,c){const t=this.c.get(n);t&&t.forEach(c)}get(n){const c=this.c.get(n);return c||new Set}}e.$Gc=o;function i(r,n){if(r===n)return!0;if(r.size!==n.size)return!1;for(const[c,t]of r)if(!n.has(c)||n.get(c)!==t)return!1;for(const[c]of n)if(!r.has(c))return!1;return!0}e.$Hc=i}),define(ke[3],Se([1,0,19,73,28,74,53]),function(me,e,D,O,g,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=void 0;const b=!1;let $=null;class y{constructor(){this.b=new Map}static{this.a=0}c(P){let N=this.b.get(P);return N||(N={parent:null,source:null,isSingleton:!1,value:P,idx:y.a++},this.b.set(P,N)),N}trackDisposable(P){const N=this.c(P);N.source||(N.source=new Error().stack)}setParent(P,N){const U=this.c(P);U.parent=N}markAsDisposed(P){this.b.delete(P)}markAsSingleton(P){this.c(P).isSingleton=!0}f(P,N){const U=N.get(P);if(U)return U;const F=P.parent?this.f(this.c(P.parent),N):P;return N.set(P,F),F}getTrackedDisposables(){const P=new Map;return[...this.b.entries()].filter(([,U])=>U.source!==null&&!this.f(U,P).isSingleton).flatMap(([U])=>U)}computeLeakingDisposables(P=10,N){let U;if(N)U=N;else{const B=new Map,Y=[...this.b.values()].filter(Z=>Z.source!==null&&!this.f(Z,B).isSingleton);if(Y.length===0)return;const ue=new Set(Y.map(Z=>Z.value));if(U=Y.filter(Z=>!(Z.parent&&ue.has(Z.parent))),U.length===0)throw new Error("There are cyclic diposable chains!")}if(!U)return;function F(B){function Y(Z,J){for(;Z.length>0&&J.some(X=>typeof X=="string"?X===Z[0]:Z[0].match(X));)Z.shift()}const ue=B.source.split(`
`).map(Z=>Z.trim().replace("at ","")).filter(Z=>Z!=="");return Y(ue,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),ue.reverse()}const j=new g.$Gc;for(const B of U){const Y=F(B);for(let ue=0;ue<=Y.length;ue++)j.add(Y.slice(0,ue).join(`
`),B)}U.sort((0,D.$7b)(B=>B.idx,D.$9b));let T="",M=0;for(const B of U.slice(0,P)){M++;const Y=F(B),ue=[];for(let Z=0;Z<Y.length;Z++){let J=Y[Z];J=`(shared with ${j.get(Y.slice(0,Z+1).join(`
`)).size}/${U.length} leaks) at ${J}`;const he=j.get(Y.slice(0,Z).join(`
`)),_=(0,O.$K)([...he].map(we=>F(we)[Z]),we=>we);delete _[Y[Z]];for(const[we,oe]of Object.entries(_))ue.unshift(`    - stacktraces of ${oe.length} other leaks continue with ${we}`);ue.unshift(J)}T+=`


==================== Leaking disposable ${M}/${U.length}: ${B.value.constructor.name} ====================
${ue.join(`
`)}
============================================================

`}return U.length>P&&(T+=`


... and ${U.length-P} more leaking disposables

`),{leaks:U,details:T}}}e.$Ic=y;function L(E){$=E}if(e.$Jc=L,b){const E="__is_disposable_tracked__";L(new class{trackDisposable(P){const N=new Error("Potentially leaked disposable").stack;setTimeout(()=>{P[E]||console.log(N)},3e3)}setParent(P,N){if(P&&P!==t.None)try{P[E]=!0}catch{}}markAsDisposed(P){if(P&&P!==t.None)try{P[E]=!0}catch{}}markAsSingleton(P){}})}function C(E){return $?.trackDisposable(E),E}e.$Kc=C;function m(E){$?.markAsDisposed(E)}e.$Lc=m;function p(E,P){$?.setParent(E,P)}function S(E,P){if($)for(const N of E)$.setParent(N,P)}function h(E){return $?.markAsSingleton(E),E}e.$Mc=h;function f(E){return typeof E.dispose=="function"&&E.dispose.length===0}e.$Nc=f;function o(E){if(A.Iterable.is(E)){const P=[];for(const N of E)if(N)try{N.dispose()}catch(U){P.push(U)}if(P.length===1)throw P[0];if(P.length>1)throw new AggregateError(P,"Encountered errors while disposing of store");return Array.isArray(E)?[]:E}else if(E)return E.dispose(),E}e.$Oc=o;function i(E){for(const P of E)f(P)&&P.dispose();return[]}e.$Pc=i;function r(...E){const P=n(()=>o(E));return S(E,P),P}e.$Qc=r;function n(E){const P=C({dispose:(0,I.$db)(()=>{m(P),E()})});return P}e.$Rc=n;class c{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,C(this)}dispose(){this.g||(m(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{o(this.f)}finally{this.f.clear()}}add(P){if(!P)return P;if(P===this)throw new Error("Cannot register a disposable on itself!");return p(P,this),this.g?c.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(P),P}delete(P){if(P){if(P===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(P),P.dispose()}}deleteAndLeak(P){P&&this.f.has(P)&&(this.f.delete(P),p(P,null))}}e.$Sc=c;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new c,C(this),p(this.q,this)}dispose(){m(this),this.q.dispose()}B(P){if(P===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(P)}}e.$Tc=t;class u{constructor(){this.b=!1,C(this)}get value(){return this.b?void 0:this.a}set value(P){this.b||P===this.a||(this.a?.dispose(),P&&p(P,this),this.a=P)}clear(){this.value=void 0}dispose(){this.b=!0,m(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const P=this.a;return this.a=void 0,P&&p(P,null),P}}e.$Uc=u;class s{constructor(P){this.a=new u,this.b=!1,this.a.value=P}get value(){return this.a.value}set value(P){this.b||P===this.a.value||(this.a.value=P)}dispose(){this.b=!0,this.a.dispose()}}e.$Vc=s;class l{constructor(P){this.b=P,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Wc=l;class a{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,C(this)}set(P){let N=P;return this.unset=()=>N=void 0,this.isset=()=>N!==void 0,this.dispose=()=>{N&&(N(),N=void 0,m(this))},this}}e.$Xc=a;class d{constructor(){this.a=new Map}acquire(P,...N){let U=this.a.get(P);U||(U={counter:0,object:this.b(P,...N)},this.a.set(P,U));const{object:F}=U,j=(0,I.$db)(()=>{--U.counter===0&&(this.c(P,U.object),this.a.delete(P))});return U.counter++,{object:F,dispose:j}}}e.$Yc=d;class k{constructor(P){this.a=P}async acquire(P,...N){const U=this.a.acquire(P,...N);try{return{object:await U.object,dispose:()=>U.dispose()}}catch(F){throw U.dispose(),F}}}e.$Zc=k;class R{constructor(P){this.object=P}dispose(){}}e.$1c=R;function v(E){const P=new c;try{E(P)}finally{P.dispose()}}e.$2c=v;class w{constructor(){this.a=new Map,this.b=!1,C(this)}dispose(){m(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{o(this.a.values())}finally{this.a.clear()}}has(P){return this.a.has(P)}get size(){return this.a.size}get(P){return this.a.get(P)}set(P,N,U=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),U||this.a.get(P)?.dispose(),this.a.set(P,N)}deleteAndDispose(P){this.a.get(P)?.dispose(),this.a.delete(P)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$3c=w}),function(me,e){typeof define=="function"&&define.amd?define(ke[160],Se([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(me=typeof globalThis<"u"?globalThis:me||self,e(me.marked={}))}(this,function(me){"use strict";function e(ge,x){for(var te=0;te<x.length;te++){var G=x[te];G.enumerable=G.enumerable||!1,G.configurable=!0,"value"in G&&(G.writable=!0),Object.defineProperty(ge,G.key,G)}}function D(ge,x,te){return x&&e(ge.prototype,x),te&&e(ge,te),Object.defineProperty(ge,"prototype",{writable:!1}),ge}function O(ge,x){if(ge){if(typeof ge=="string")return g(ge,x);var te=Object.prototype.toString.call(ge).slice(8,-1);if(te==="Object"&&ge.constructor&&(te=ge.constructor.name),te==="Map"||te==="Set")return Array.from(ge);if(te==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(te))return g(ge,x)}}function g(ge,x){(x==null||x>ge.length)&&(x=ge.length);for(var te=0,G=new Array(x);te<x;te++)G[te]=ge[te];return G}function I(ge,x){var te=typeof Symbol<"u"&&ge[Symbol.iterator]||ge["@@iterator"];if(te)return(te=te.call(ge)).next.bind(te);if(Array.isArray(ge)||(te=O(ge))||x&&ge&&typeof ge.length=="number"){te&&(ge=te);var G=0;return function(){return G>=ge.length?{done:!0}:{done:!1,value:ge[G++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}me.defaults=A();function b(ge){me.defaults=ge}var $=/[&<>"']/,y=/[&<>"']/g,L=/[<>"']|&(?!#?\w+;)/,C=/[<>"']|&(?!#?\w+;)/g,m={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},p=function(x){return m[x]};function S(ge,x){if(x){if($.test(ge))return ge.replace(y,p)}else if(L.test(ge))return ge.replace(C,p);return ge}var h=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function f(ge){return ge.replace(h,function(x,te){return te=te.toLowerCase(),te==="colon"?":":te.charAt(0)==="#"?te.charAt(1)==="x"?String.fromCharCode(parseInt(te.substring(2),16)):String.fromCharCode(+te.substring(1)):""})}var o=/(^|[^\[])\^/g;function i(ge,x){ge=typeof ge=="string"?ge:ge.source,x=x||"";var te={replace:function(ie,fe){return fe=fe.source||fe,fe=fe.replace(o,"$1"),ge=ge.replace(ie,fe),te},getRegex:function(){return new RegExp(ge,x)}};return te}var r=/[^\w:]/g,n=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function c(ge,x,te){if(ge){var G;try{G=decodeURIComponent(f(te)).replace(r,"").toLowerCase()}catch{return null}if(G.indexOf("javascript:")===0||G.indexOf("vbscript:")===0||G.indexOf("data:")===0)return null}x&&!n.test(te)&&(te=a(x,te));try{te=encodeURI(te).replace(/%25/g,"%")}catch{return null}return te}var t={},u=/^[^:]+:\/*[^/]*$/,s=/^([^:]+:)[\s\S]*$/,l=/^([^:]+:\/*[^/]*)[\s\S]*$/;function a(ge,x){t[" "+ge]||(u.test(ge)?t[" "+ge]=ge+"/":t[" "+ge]=v(ge,"/",!0)),ge=t[" "+ge];var te=ge.indexOf(":")===-1;return x.substring(0,2)==="//"?te?x:ge.replace(s,"$1")+x:x.charAt(0)==="/"?te?x:ge.replace(l,"$1")+x:ge+x}var d={exec:function(){}};function k(ge){for(var x=1,te,G;x<arguments.length;x++){te=arguments[x];for(G in te)Object.prototype.hasOwnProperty.call(te,G)&&(ge[G]=te[G])}return ge}function R(ge,x){var te=ge.replace(/\|/g,function(fe,pe,Pe){for(var be=!1,De=pe;--De>=0&&Pe[De]==="\\";)be=!be;return be?"|":" |"}),G=te.split(/ \|/),ie=0;if(G[0].trim()||G.shift(),G.length>0&&!G[G.length-1].trim()&&G.pop(),G.length>x)G.splice(x);else for(;G.length<x;)G.push("");for(;ie<G.length;ie++)G[ie]=G[ie].trim().replace(/\\\|/g,"|");return G}function v(ge,x,te){var G=ge.length;if(G===0)return"";for(var ie=0;ie<G;){var fe=ge.charAt(G-ie-1);if(fe===x&&!te)ie++;else if(fe!==x&&te)ie++;else break}return ge.slice(0,G-ie)}function w(ge,x){if(ge.indexOf(x[1])===-1)return-1;for(var te=ge.length,G=0,ie=0;ie<te;ie++)if(ge[ie]==="\\")ie++;else if(ge[ie]===x[0])G++;else if(ge[ie]===x[1]&&(G--,G<0))return ie;return-1}function E(ge){ge&&ge.sanitize&&!ge.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function P(ge,x){if(x<1)return"";for(var te="";x>1;)x&1&&(te+=ge),x>>=1,ge+=ge;return te+ge}function N(ge,x,te,G){var ie=x.href,fe=x.title?S(x.title):null,pe=ge[1].replace(/\\([\[\]])/g,"$1");if(ge[0].charAt(0)!=="!"){G.state.inLink=!0;var Pe={type:"link",raw:te,href:ie,title:fe,text:pe,tokens:G.inlineTokens(pe)};return G.state.inLink=!1,Pe}return{type:"image",raw:te,href:ie,title:fe,text:S(pe)}}function U(ge,x){var te=ge.match(/^(\s+)(?:```)/);if(te===null)return x;var G=te[1];return x.split(`
`).map(function(ie){var fe=ie.match(/^\s+/);if(fe===null)return ie;var pe=fe[0];return pe.length>=G.length?ie.slice(G.length):ie}).join(`
`)}var F=function(){function ge(te){this.options=te||me.defaults}var x=ge.prototype;return x.space=function(G){var ie=this.rules.block.newline.exec(G);if(ie&&ie[0].length>0)return{type:"space",raw:ie[0]}},x.code=function(G){var ie=this.rules.block.code.exec(G);if(ie){var fe=ie[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ie[0],codeBlockStyle:"indented",text:this.options.pedantic?fe:v(fe,`
`)}}},x.fences=function(G){var ie=this.rules.block.fences.exec(G);if(ie){var fe=ie[0],pe=U(fe,ie[3]||"");return{type:"code",raw:fe,lang:ie[2]?ie[2].trim():ie[2],text:pe}}},x.heading=function(G){var ie=this.rules.block.heading.exec(G);if(ie){var fe=ie[2].trim();if(/#$/.test(fe)){var pe=v(fe,"#");(this.options.pedantic||!pe||/ $/.test(pe))&&(fe=pe.trim())}return{type:"heading",raw:ie[0],depth:ie[1].length,text:fe,tokens:this.lexer.inline(fe)}}},x.hr=function(G){var ie=this.rules.block.hr.exec(G);if(ie)return{type:"hr",raw:ie[0]}},x.blockquote=function(G){var ie=this.rules.block.blockquote.exec(G);if(ie){var fe=ie[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ie[0],tokens:this.lexer.blockTokens(fe,[]),text:fe}}},x.list=function(G){var ie=this.rules.block.list.exec(G);if(ie){var fe,pe,Pe,be,De,z,Q,ee,q,ae,le,Le,je=ie[1].trim(),He=je.length>1,Je={type:"list",raw:"",ordered:He,start:He?+je.slice(0,-1):"",loose:!1,items:[]};je=He?"\\d{1,9}\\"+je.slice(-1):"\\"+je,this.options.pedantic&&(je=He?je:"[*+-]");for(var _e=new RegExp("^( {0,3}"+je+")((?:[	 ][^\\n]*)?(?:\\n|$))");G&&(Le=!1,!(!(ie=_e.exec(G))||this.rules.block.hr.test(G)));){if(fe=ie[0],G=G.substring(fe.length),ee=ie[2].split(`
`,1)[0],q=G.split(`
`,1)[0],this.options.pedantic?(be=2,le=ee.trimLeft()):(be=ie[2].search(/[^ ]/),be=be>4?1:be,le=ee.slice(be),be+=ie[1].length),z=!1,!ee&&/^ *$/.test(q)&&(fe+=q+`
`,G=G.substring(q.length+1),Le=!0),!Le)for(var ct=new RegExp("^ {0,"+Math.min(3,be-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),ot=new RegExp("^ {0,"+Math.min(3,be-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),rt=new RegExp("^ {0,"+Math.min(3,be-1)+"}(?:```|~~~)"),Re=new RegExp("^ {0,"+Math.min(3,be-1)+"}#");G&&(ae=G.split(`
`,1)[0],ee=ae,this.options.pedantic&&(ee=ee.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(rt.test(ee)||Re.test(ee)||ct.test(ee)||ot.test(G)));){if(ee.search(/[^ ]/)>=be||!ee.trim())le+=`
`+ee.slice(be);else if(!z)le+=`
`+ee;else break;!z&&!ee.trim()&&(z=!0),fe+=ae+`
`,G=G.substring(ae.length+1)}Je.loose||(Q?Je.loose=!0:/\n *\n *$/.test(fe)&&(Q=!0)),this.options.gfm&&(pe=/^\[[ xX]\] /.exec(le),pe&&(Pe=pe[0]!=="[ ] ",le=le.replace(/^\[[ xX]\] +/,""))),Je.items.push({type:"list_item",raw:fe,task:!!pe,checked:Pe,loose:!1,text:le}),Je.raw+=fe}Je.items[Je.items.length-1].raw=fe.trimRight(),Je.items[Je.items.length-1].text=le.trimRight(),Je.raw=Je.raw.trimRight();var Ue=Je.items.length;for(De=0;De<Ue;De++){this.lexer.state.top=!1,Je.items[De].tokens=this.lexer.blockTokens(Je.items[De].text,[]);var Ae=Je.items[De].tokens.filter(function(ne){return ne.type==="space"}),Xe=Ae.every(function(ne){for(var ce=ne.raw.split(""),Ie=0,qe=I(ce),Ye;!(Ye=qe()).done;){var nt=Ye.value;if(nt===`
`&&(Ie+=1),Ie>1)return!0}return!1});!Je.loose&&Ae.length&&Xe&&(Je.loose=!0,Je.items[De].loose=!0)}return Je}},x.html=function(G){var ie=this.rules.block.html.exec(G);if(ie){var fe={type:"html",raw:ie[0],pre:!this.options.sanitizer&&(ie[1]==="pre"||ie[1]==="script"||ie[1]==="style"),text:ie[0]};if(this.options.sanitize){var pe=this.options.sanitizer?this.options.sanitizer(ie[0]):S(ie[0]);fe.type="paragraph",fe.text=pe,fe.tokens=this.lexer.inline(pe)}return fe}},x.def=function(G){var ie=this.rules.block.def.exec(G);if(ie){ie[3]&&(ie[3]=ie[3].substring(1,ie[3].length-1));var fe=ie[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:fe,raw:ie[0],href:ie[2],title:ie[3]}}},x.table=function(G){var ie=this.rules.block.table.exec(G);if(ie){var fe={type:"table",header:R(ie[1]).map(function(Q){return{text:Q}}),align:ie[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ie[3]&&ie[3].trim()?ie[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(fe.header.length===fe.align.length){fe.raw=ie[0];var pe=fe.align.length,Pe,be,De,z;for(Pe=0;Pe<pe;Pe++)/^ *-+: *$/.test(fe.align[Pe])?fe.align[Pe]="right":/^ *:-+: *$/.test(fe.align[Pe])?fe.align[Pe]="center":/^ *:-+ *$/.test(fe.align[Pe])?fe.align[Pe]="left":fe.align[Pe]=null;for(pe=fe.rows.length,Pe=0;Pe<pe;Pe++)fe.rows[Pe]=R(fe.rows[Pe],fe.header.length).map(function(Q){return{text:Q}});for(pe=fe.header.length,be=0;be<pe;be++)fe.header[be].tokens=this.lexer.inline(fe.header[be].text);for(pe=fe.rows.length,be=0;be<pe;be++)for(z=fe.rows[be],De=0;De<z.length;De++)z[De].tokens=this.lexer.inline(z[De].text);return fe}}},x.lheading=function(G){var ie=this.rules.block.lheading.exec(G);if(ie)return{type:"heading",raw:ie[0],depth:ie[2].charAt(0)==="="?1:2,text:ie[1],tokens:this.lexer.inline(ie[1])}},x.paragraph=function(G){var ie=this.rules.block.paragraph.exec(G);if(ie){var fe=ie[1].charAt(ie[1].length-1)===`
`?ie[1].slice(0,-1):ie[1];return{type:"paragraph",raw:ie[0],text:fe,tokens:this.lexer.inline(fe)}}},x.text=function(G){var ie=this.rules.block.text.exec(G);if(ie)return{type:"text",raw:ie[0],text:ie[0],tokens:this.lexer.inline(ie[0])}},x.escape=function(G){var ie=this.rules.inline.escape.exec(G);if(ie)return{type:"escape",raw:ie[0],text:S(ie[1])}},x.tag=function(G){var ie=this.rules.inline.tag.exec(G);if(ie)return!this.lexer.state.inLink&&/^<a /i.test(ie[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ie[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ie[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ie[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ie[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ie[0]):S(ie[0]):ie[0]}},x.link=function(G){var ie=this.rules.inline.link.exec(G);if(ie){var fe=ie[2].trim();if(!this.options.pedantic&&/^</.test(fe)){if(!/>$/.test(fe))return;var pe=v(fe.slice(0,-1),"\\");if((fe.length-pe.length)%2===0)return}else{var Pe=w(ie[2],"()");if(Pe>-1){var be=ie[0].indexOf("!")===0?5:4,De=be+ie[1].length+Pe;ie[2]=ie[2].substring(0,Pe),ie[0]=ie[0].substring(0,De).trim(),ie[3]=""}}var z=ie[2],Q="";if(this.options.pedantic){var ee=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(z);ee&&(z=ee[1],Q=ee[3])}else Q=ie[3]?ie[3].slice(1,-1):"";return z=z.trim(),/^</.test(z)&&(this.options.pedantic&&!/>$/.test(fe)?z=z.slice(1):z=z.slice(1,-1)),N(ie,{href:z&&z.replace(this.rules.inline._escapes,"$1"),title:Q&&Q.replace(this.rules.inline._escapes,"$1")},ie[0],this.lexer)}},x.reflink=function(G,ie){var fe;if((fe=this.rules.inline.reflink.exec(G))||(fe=this.rules.inline.nolink.exec(G))){var pe=(fe[2]||fe[1]).replace(/\s+/g," ");if(pe=ie[pe.toLowerCase()],!pe||!pe.href){var Pe=fe[0].charAt(0);return{type:"text",raw:Pe,text:Pe}}return N(fe,pe,fe[0],this.lexer)}},x.emStrong=function(G,ie,fe){fe===void 0&&(fe="");var pe=this.rules.inline.emStrong.lDelim.exec(G);if(pe&&!(pe[3]&&fe.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Pe=pe[1]||pe[2]||"";if(!Pe||Pe&&(fe===""||this.rules.inline.punctuation.exec(fe))){var be=pe[0].length-1,De,z,Q=be,ee=0,q=pe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(q.lastIndex=0,ie=ie.slice(-1*G.length+be);(pe=q.exec(ie))!=null;)if(De=pe[1]||pe[2]||pe[3]||pe[4]||pe[5]||pe[6],!!De){if(z=De.length,pe[3]||pe[4]){Q+=z;continue}else if((pe[5]||pe[6])&&be%3&&!((be+z)%3)){ee+=z;continue}if(Q-=z,!(Q>0)){if(z=Math.min(z,z+Q+ee),Math.min(be,z)%2){var ae=G.slice(1,be+pe.index+z);return{type:"em",raw:G.slice(0,be+pe.index+z+1),text:ae,tokens:this.lexer.inlineTokens(ae)}}var le=G.slice(2,be+pe.index+z-1);return{type:"strong",raw:G.slice(0,be+pe.index+z+1),text:le,tokens:this.lexer.inlineTokens(le)}}}}}},x.codespan=function(G){var ie=this.rules.inline.code.exec(G);if(ie){var fe=ie[2].replace(/\n/g," "),pe=/[^ ]/.test(fe),Pe=/^ /.test(fe)&&/ $/.test(fe);return pe&&Pe&&(fe=fe.substring(1,fe.length-1)),fe=S(fe,!0),{type:"codespan",raw:ie[0],text:fe}}},x.br=function(G){var ie=this.rules.inline.br.exec(G);if(ie)return{type:"br",raw:ie[0]}},x.del=function(G){var ie=this.rules.inline.del.exec(G);if(ie)return{type:"del",raw:ie[0],text:ie[2],tokens:this.lexer.inlineTokens(ie[2])}},x.autolink=function(G,ie){var fe=this.rules.inline.autolink.exec(G);if(fe){var pe,Pe;return fe[2]==="@"?(pe=S(this.options.mangle?ie(fe[1]):fe[1]),Pe="mailto:"+pe):(pe=S(fe[1]),Pe=pe),{type:"link",raw:fe[0],text:pe,href:Pe,tokens:[{type:"text",raw:pe,text:pe}]}}},x.url=function(G,ie){var fe;if(fe=this.rules.inline.url.exec(G)){var pe,Pe;if(fe[2]==="@")pe=S(this.options.mangle?ie(fe[0]):fe[0]),Pe="mailto:"+pe;else{var be;do be=fe[0],fe[0]=this.rules.inline._backpedal.exec(fe[0])[0];while(be!==fe[0]);pe=S(fe[0]),fe[1]==="www."?Pe="http://"+pe:Pe=pe}return{type:"link",raw:fe[0],text:pe,href:Pe,tokens:[{type:"text",raw:pe,text:pe}]}}},x.inlineText=function(G,ie){var fe=this.rules.inline.text.exec(G);if(fe){var pe;return this.lexer.state.inRawBlock?pe=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(fe[0]):S(fe[0]):fe[0]:pe=S(this.options.smartypants?ie(fe[0]):fe[0]),{type:"text",raw:fe[0],text:pe}}},ge}(),j={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:d,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};j._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,j._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,j.def=i(j.def).replace("label",j._label).replace("title",j._title).getRegex(),j.bullet=/(?:[*+-]|\d{1,9}[.)])/,j.listItemStart=i(/^( *)(bull) */).replace("bull",j.bullet).getRegex(),j.list=i(j.list).replace(/bull/g,j.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+j.def.source+")").getRegex(),j._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",j._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,j.html=i(j.html,"i").replace("comment",j._comment).replace("tag",j._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),j.paragraph=i(j._paragraph).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.blockquote=i(j.blockquote).replace("paragraph",j.paragraph).getRegex(),j.normal=k({},j),j.gfm=k({},j.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),j.gfm.table=i(j.gfm.table).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.gfm.paragraph=i(j._paragraph).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",j.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.pedantic=k({},j.normal,{html:i(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",j._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:d,paragraph:i(j.normal._paragraph).replace("hr",j.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",j.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var T={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:d,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:d,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};T._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",T.punctuation=i(T.punctuation).replace(/punctuation/g,T._punctuation).getRegex(),T.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,T.escapedEmSt=/\\\*|\\_/g,T._comment=i(j._comment).replace("(?:-->|$)","-->").getRegex(),T.emStrong.lDelim=i(T.emStrong.lDelim).replace(/punct/g,T._punctuation).getRegex(),T.emStrong.rDelimAst=i(T.emStrong.rDelimAst,"g").replace(/punct/g,T._punctuation).getRegex(),T.emStrong.rDelimUnd=i(T.emStrong.rDelimUnd,"g").replace(/punct/g,T._punctuation).getRegex(),T._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,T._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,T._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,T.autolink=i(T.autolink).replace("scheme",T._scheme).replace("email",T._email).getRegex(),T._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,T.tag=i(T.tag).replace("comment",T._comment).replace("attribute",T._attribute).getRegex(),T._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,T._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,T._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,T.link=i(T.link).replace("label",T._label).replace("href",T._href).replace("title",T._title).getRegex(),T.reflink=i(T.reflink).replace("label",T._label).replace("ref",j._label).getRegex(),T.nolink=i(T.nolink).replace("ref",j._label).getRegex(),T.reflinkSearch=i(T.reflinkSearch,"g").replace("reflink",T.reflink).replace("nolink",T.nolink).getRegex(),T.normal=k({},T),T.pedantic=k({},T.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:i(/^!?\[(label)\]\((.*?)\)/).replace("label",T._label).getRegex(),reflink:i(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",T._label).getRegex()}),T.gfm=k({},T.normal,{escape:i(T.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),T.gfm.url=i(T.gfm.url,"i").replace("email",T.gfm._extended_email).getRegex(),T.breaks=k({},T.gfm,{br:i(T.br).replace("{2,}","*").getRegex(),text:i(T.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function M(ge){return ge.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function B(ge){var x="",te,G,ie=ge.length;for(te=0;te<ie;te++)G=ge.charCodeAt(te),Math.random()>.5&&(G="x"+G.toString(16)),x+="&#"+G+";";return x}var Y=function(){function ge(te){this.tokens=[],this.tokens.links=Object.create(null),this.options=te||me.defaults,this.options.tokenizer=this.options.tokenizer||new F,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var G={block:j.normal,inline:T.normal};this.options.pedantic?(G.block=j.pedantic,G.inline=T.pedantic):this.options.gfm&&(G.block=j.gfm,this.options.breaks?G.inline=T.breaks:G.inline=T.gfm),this.tokenizer.rules=G}ge.lex=function(G,ie){var fe=new ge(ie);return fe.lex(G)},ge.lexInline=function(G,ie){var fe=new ge(ie);return fe.inlineTokens(G)};var x=ge.prototype;return x.lex=function(G){G=G.replace(/\r\n|\r/g,`
`),this.blockTokens(G,this.tokens);for(var ie;ie=this.inlineQueue.shift();)this.inlineTokens(ie.src,ie.tokens);return this.tokens},x.blockTokens=function(G,ie){var fe=this;ie===void 0&&(ie=[]),this.options.pedantic?G=G.replace(/\t/g,"    ").replace(/^ +$/gm,""):G=G.replace(/^( *)(\t+)/gm,function(Q,ee,q){return ee+"    ".repeat(q.length)});for(var pe,Pe,be,De;G;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Q){return(pe=Q.call({lexer:fe},G,ie))?(G=G.substring(pe.raw.length),ie.push(pe),!0):!1}))){if(pe=this.tokenizer.space(G)){G=G.substring(pe.raw.length),pe.raw.length===1&&ie.length>0?ie[ie.length-1].raw+=`
`:ie.push(pe);continue}if(pe=this.tokenizer.code(G)){G=G.substring(pe.raw.length),Pe=ie[ie.length-1],Pe&&(Pe.type==="paragraph"||Pe.type==="text")?(Pe.raw+=`
`+pe.raw,Pe.text+=`
`+pe.text,this.inlineQueue[this.inlineQueue.length-1].src=Pe.text):ie.push(pe);continue}if(pe=this.tokenizer.fences(G)){G=G.substring(pe.raw.length),ie.push(pe);continue}if(pe=this.tokenizer.heading(G)){G=G.substring(pe.raw.length),ie.push(pe);continue}if(pe=this.tokenizer.hr(G)){G=G.substring(pe.raw.length),ie.push(pe);continue}if(pe=this.tokenizer.blockquote(G)){G=G.substring(pe.raw.length),ie.push(pe);continue}if(pe=this.tokenizer.list(G)){G=G.substring(pe.raw.length),ie.push(pe);continue}if(pe=this.tokenizer.html(G)){G=G.substring(pe.raw.length),ie.push(pe);continue}if(pe=this.tokenizer.def(G)){G=G.substring(pe.raw.length),Pe=ie[ie.length-1],Pe&&(Pe.type==="paragraph"||Pe.type==="text")?(Pe.raw+=`
`+pe.raw,Pe.text+=`
`+pe.raw,this.inlineQueue[this.inlineQueue.length-1].src=Pe.text):this.tokens.links[pe.tag]||(this.tokens.links[pe.tag]={href:pe.href,title:pe.title});continue}if(pe=this.tokenizer.table(G)){G=G.substring(pe.raw.length),ie.push(pe);continue}if(pe=this.tokenizer.lheading(G)){G=G.substring(pe.raw.length),ie.push(pe);continue}if(be=G,this.options.extensions&&this.options.extensions.startBlock&&function(){var Q=1/0,ee=G.slice(1),q=void 0;fe.options.extensions.startBlock.forEach(function(ae){q=ae.call({lexer:this},ee),typeof q=="number"&&q>=0&&(Q=Math.min(Q,q))}),Q<1/0&&Q>=0&&(be=G.substring(0,Q+1))}(),this.state.top&&(pe=this.tokenizer.paragraph(be))){Pe=ie[ie.length-1],De&&Pe.type==="paragraph"?(Pe.raw+=`
`+pe.raw,Pe.text+=`
`+pe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Pe.text):ie.push(pe),De=be.length!==G.length,G=G.substring(pe.raw.length);continue}if(pe=this.tokenizer.text(G)){G=G.substring(pe.raw.length),Pe=ie[ie.length-1],Pe&&Pe.type==="text"?(Pe.raw+=`
`+pe.raw,Pe.text+=`
`+pe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Pe.text):ie.push(pe);continue}if(G){var z="Infinite loop on byte: "+G.charCodeAt(0);if(this.options.silent){console.error(z);break}else throw new Error(z)}}return this.state.top=!0,ie},x.inline=function(G,ie){return ie===void 0&&(ie=[]),this.inlineQueue.push({src:G,tokens:ie}),ie},x.inlineTokens=function(G,ie){var fe=this;ie===void 0&&(ie=[]);var pe,Pe,be,De=G,z,Q,ee;if(this.tokens.links){var q=Object.keys(this.tokens.links);if(q.length>0)for(;(z=this.tokenizer.rules.inline.reflinkSearch.exec(De))!=null;)q.includes(z[0].slice(z[0].lastIndexOf("[")+1,-1))&&(De=De.slice(0,z.index)+"["+P("a",z[0].length-2)+"]"+De.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(z=this.tokenizer.rules.inline.blockSkip.exec(De))!=null;)De=De.slice(0,z.index)+"["+P("a",z[0].length-2)+"]"+De.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(z=this.tokenizer.rules.inline.escapedEmSt.exec(De))!=null;)De=De.slice(0,z.index)+"++"+De.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;G;)if(Q||(ee=""),Q=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(le){return(pe=le.call({lexer:fe},G,ie))?(G=G.substring(pe.raw.length),ie.push(pe),!0):!1}))){if(pe=this.tokenizer.escape(G)){G=G.substring(pe.raw.length),ie.push(pe);continue}if(pe=this.tokenizer.tag(G)){G=G.substring(pe.raw.length),Pe=ie[ie.length-1],Pe&&pe.type==="text"&&Pe.type==="text"?(Pe.raw+=pe.raw,Pe.text+=pe.text):ie.push(pe);continue}if(pe=this.tokenizer.link(G)){G=G.substring(pe.raw.length),ie.push(pe);continue}if(pe=this.tokenizer.reflink(G,this.tokens.links)){G=G.substring(pe.raw.length),Pe=ie[ie.length-1],Pe&&pe.type==="text"&&Pe.type==="text"?(Pe.raw+=pe.raw,Pe.text+=pe.text):ie.push(pe);continue}if(pe=this.tokenizer.emStrong(G,De,ee)){G=G.substring(pe.raw.length),ie.push(pe);continue}if(pe=this.tokenizer.codespan(G)){G=G.substring(pe.raw.length),ie.push(pe);continue}if(pe=this.tokenizer.br(G)){G=G.substring(pe.raw.length),ie.push(pe);continue}if(pe=this.tokenizer.del(G)){G=G.substring(pe.raw.length),ie.push(pe);continue}if(pe=this.tokenizer.autolink(G,B)){G=G.substring(pe.raw.length),ie.push(pe);continue}if(!this.state.inLink&&(pe=this.tokenizer.url(G,B))){G=G.substring(pe.raw.length),ie.push(pe);continue}if(be=G,this.options.extensions&&this.options.extensions.startInline&&function(){var le=1/0,Le=G.slice(1),je=void 0;fe.options.extensions.startInline.forEach(function(He){je=He.call({lexer:this},Le),typeof je=="number"&&je>=0&&(le=Math.min(le,je))}),le<1/0&&le>=0&&(be=G.substring(0,le+1))}(),pe=this.tokenizer.inlineText(be,M)){G=G.substring(pe.raw.length),pe.raw.slice(-1)!=="_"&&(ee=pe.raw.slice(-1)),Q=!0,Pe=ie[ie.length-1],Pe&&Pe.type==="text"?(Pe.raw+=pe.raw,Pe.text+=pe.text):ie.push(pe);continue}if(G){var ae="Infinite loop on byte: "+G.charCodeAt(0);if(this.options.silent){console.error(ae);break}else throw new Error(ae)}}return ie},D(ge,null,[{key:"rules",get:function(){return{block:j,inline:T}}}]),ge}(),ue=function(){function ge(te){this.options=te||me.defaults}var x=ge.prototype;return x.code=function(G,ie,fe){var pe=(ie||"").match(/\S*/)[0];if(this.options.highlight){var Pe=this.options.highlight(G,pe);Pe!=null&&Pe!==G&&(fe=!0,G=Pe)}return G=G.replace(/\n$/,"")+`
`,pe?'<pre><code class="'+this.options.langPrefix+S(pe,!0)+'">'+(fe?G:S(G,!0))+`</code></pre>
`:"<pre><code>"+(fe?G:S(G,!0))+`</code></pre>
`},x.blockquote=function(G){return`<blockquote>
`+G+`</blockquote>
`},x.html=function(G){return G},x.heading=function(G,ie,fe,pe){if(this.options.headerIds){var Pe=this.options.headerPrefix+pe.slug(fe);return"<h"+ie+' id="'+Pe+'">'+G+"</h"+ie+`>
`}return"<h"+ie+">"+G+"</h"+ie+`>
`},x.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},x.list=function(G,ie,fe){var pe=ie?"ol":"ul",Pe=ie&&fe!==1?' start="'+fe+'"':"";return"<"+pe+Pe+`>
`+G+"</"+pe+`>
`},x.listitem=function(G){return"<li>"+G+`</li>
`},x.checkbox=function(G){return"<input "+(G?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},x.paragraph=function(G){return"<p>"+G+`</p>
`},x.table=function(G,ie){return ie&&(ie="<tbody>"+ie+"</tbody>"),`<table>
<thead>
`+G+`</thead>
`+ie+`</table>
`},x.tablerow=function(G){return`<tr>
`+G+`</tr>
`},x.tablecell=function(G,ie){var fe=ie.header?"th":"td",pe=ie.align?"<"+fe+' align="'+ie.align+'">':"<"+fe+">";return pe+G+("</"+fe+`>
`)},x.strong=function(G){return"<strong>"+G+"</strong>"},x.em=function(G){return"<em>"+G+"</em>"},x.codespan=function(G){return"<code>"+G+"</code>"},x.br=function(){return this.options.xhtml?"<br/>":"<br>"},x.del=function(G){return"<del>"+G+"</del>"},x.link=function(G,ie,fe){if(G=c(this.options.sanitize,this.options.baseUrl,G),G===null)return fe;var pe='<a href="'+S(G)+'"';return ie&&(pe+=' title="'+ie+'"'),pe+=">"+fe+"</a>",pe},x.image=function(G,ie,fe){if(G=c(this.options.sanitize,this.options.baseUrl,G),G===null)return fe;var pe='<img src="'+G+'" alt="'+fe+'"';return ie&&(pe+=' title="'+ie+'"'),pe+=this.options.xhtml?"/>":">",pe},x.text=function(G){return G},ge}(),Z=function(){function ge(){}var x=ge.prototype;return x.strong=function(G){return G},x.em=function(G){return G},x.codespan=function(G){return G},x.del=function(G){return G},x.html=function(G){return G},x.text=function(G){return G},x.link=function(G,ie,fe){return""+fe},x.image=function(G,ie,fe){return""+fe},x.br=function(){return""},ge}(),J=function(){function ge(){this.seen={}}var x=ge.prototype;return x.serialize=function(G){return G.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},x.getNextSafeSlug=function(G,ie){var fe=G,pe=0;if(this.seen.hasOwnProperty(fe)){pe=this.seen[G];do pe++,fe=G+"-"+pe;while(this.seen.hasOwnProperty(fe))}return ie||(this.seen[G]=pe,this.seen[fe]=0),fe},x.slug=function(G,ie){ie===void 0&&(ie={});var fe=this.serialize(G);return this.getNextSafeSlug(fe,ie.dryrun)},ge}(),X=function(){function ge(te){this.options=te||me.defaults,this.options.renderer=this.options.renderer||new ue,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Z,this.slugger=new J}ge.parse=function(G,ie){var fe=new ge(ie);return fe.parse(G)},ge.parseInline=function(G,ie){var fe=new ge(ie);return fe.parseInline(G)};var x=ge.prototype;return x.parse=function(G,ie){ie===void 0&&(ie=!0);var fe="",pe,Pe,be,De,z,Q,ee,q,ae,le,Le,je,He,Je,_e,ct,ot,rt,Re,Ue=G.length;for(pe=0;pe<Ue;pe++){if(le=G[pe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[le.type]&&(Re=this.options.extensions.renderers[le.type].call({parser:this},le),Re!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(le.type))){fe+=Re||"";continue}switch(le.type){case"space":continue;case"hr":{fe+=this.renderer.hr();continue}case"heading":{fe+=this.renderer.heading(this.parseInline(le.tokens),le.depth,f(this.parseInline(le.tokens,this.textRenderer)),this.slugger);continue}case"code":{fe+=this.renderer.code(le.text,le.lang,le.escaped);continue}case"table":{for(q="",ee="",De=le.header.length,Pe=0;Pe<De;Pe++)ee+=this.renderer.tablecell(this.parseInline(le.header[Pe].tokens),{header:!0,align:le.align[Pe]});for(q+=this.renderer.tablerow(ee),ae="",De=le.rows.length,Pe=0;Pe<De;Pe++){for(Q=le.rows[Pe],ee="",z=Q.length,be=0;be<z;be++)ee+=this.renderer.tablecell(this.parseInline(Q[be].tokens),{header:!1,align:le.align[be]});ae+=this.renderer.tablerow(ee)}fe+=this.renderer.table(q,ae);continue}case"blockquote":{ae=this.parse(le.tokens),fe+=this.renderer.blockquote(ae);continue}case"list":{for(Le=le.ordered,je=le.start,He=le.loose,De=le.items.length,ae="",Pe=0;Pe<De;Pe++)_e=le.items[Pe],ct=_e.checked,ot=_e.task,Je="",_e.task&&(rt=this.renderer.checkbox(ct),He?_e.tokens.length>0&&_e.tokens[0].type==="paragraph"?(_e.tokens[0].text=rt+" "+_e.tokens[0].text,_e.tokens[0].tokens&&_e.tokens[0].tokens.length>0&&_e.tokens[0].tokens[0].type==="text"&&(_e.tokens[0].tokens[0].text=rt+" "+_e.tokens[0].tokens[0].text)):_e.tokens.unshift({type:"text",text:rt}):Je+=rt),Je+=this.parse(_e.tokens,He),ae+=this.renderer.listitem(Je,ot,ct);fe+=this.renderer.list(ae,Le,je);continue}case"html":{fe+=this.renderer.html(le.text);continue}case"paragraph":{fe+=this.renderer.paragraph(this.parseInline(le.tokens));continue}case"text":{for(ae=le.tokens?this.parseInline(le.tokens):le.text;pe+1<Ue&&G[pe+1].type==="text";)le=G[++pe],ae+=`
`+(le.tokens?this.parseInline(le.tokens):le.text);fe+=ie?this.renderer.paragraph(ae):ae;continue}default:{var Ae='Token with "'+le.type+'" type was not found.';if(this.options.silent){console.error(Ae);return}else throw new Error(Ae)}}}return fe},x.parseInline=function(G,ie){ie=ie||this.renderer;var fe="",pe,Pe,be,De=G.length;for(pe=0;pe<De;pe++){if(Pe=G[pe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Pe.type]&&(be=this.options.extensions.renderers[Pe.type].call({parser:this},Pe),be!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Pe.type))){fe+=be||"";continue}switch(Pe.type){case"escape":{fe+=ie.text(Pe.text);break}case"html":{fe+=ie.html(Pe.text);break}case"link":{fe+=ie.link(Pe.href,Pe.title,this.parseInline(Pe.tokens,ie));break}case"image":{fe+=ie.image(Pe.href,Pe.title,Pe.text);break}case"strong":{fe+=ie.strong(this.parseInline(Pe.tokens,ie));break}case"em":{fe+=ie.em(this.parseInline(Pe.tokens,ie));break}case"codespan":{fe+=ie.codespan(Pe.text);break}case"br":{fe+=ie.br();break}case"del":{fe+=ie.del(this.parseInline(Pe.tokens,ie));break}case"text":{fe+=ie.text(Pe.text);break}default:{var z='Token with "'+Pe.type+'" type was not found.';if(this.options.silent){console.error(z);return}else throw new Error(z)}}}return fe},ge}();function he(ge,x,te){if(typeof ge>"u"||ge===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ge!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ge)+", string expected");if(typeof x=="function"&&(te=x,x=null),x=k({},he.defaults,x||{}),E(x),te){var G=x.highlight,ie;try{ie=Y.lex(ge,x)}catch(De){return te(De)}var fe=function(z){var Q;if(!z)try{x.walkTokens&&he.walkTokens(ie,x.walkTokens),Q=X.parse(ie,x)}catch(ee){z=ee}return x.highlight=G,z?te(z):te(null,Q)};if(!G||G.length<3||(delete x.highlight,!ie.length))return fe();var pe=0;he.walkTokens(ie,function(De){De.type==="code"&&(pe++,setTimeout(function(){G(De.text,De.lang,function(z,Q){if(z)return fe(z);Q!=null&&Q!==De.text&&(De.text=Q,De.escaped=!0),pe--,pe===0&&fe()})},0))}),pe===0&&fe();return}function Pe(De){if(De.message+=`
Please report this to https://github.com/markedjs/marked.`,x.silent)return"<p>An error occurred:</p><pre>"+S(De.message+"",!0)+"</pre>";throw De}try{var be=Y.lex(ge,x);if(x.walkTokens){if(x.async)return Promise.all(he.walkTokens(be,x.walkTokens)).then(function(){return X.parse(be,x)}).catch(Pe);he.walkTokens(be,x.walkTokens)}return X.parse(be,x)}catch(De){Pe(De)}}he.options=he.setOptions=function(ge){return k(he.defaults,ge),b(he.defaults),he},he.getDefaults=A,he.defaults=me.defaults,he.use=function(){for(var ge=arguments.length,x=new Array(ge),te=0;te<ge;te++)x[te]=arguments[te];var G=k.apply(void 0,[{}].concat(x)),ie=he.defaults.extensions||{renderers:{},childTokens:{}},fe;x.forEach(function(pe){if(pe.extensions&&(fe=!0,pe.extensions.forEach(function(be){if(!be.name)throw new Error("extension name required");if(be.renderer){var De=ie.renderers?ie.renderers[be.name]:null;De?ie.renderers[be.name]=function(){for(var z=arguments.length,Q=new Array(z),ee=0;ee<z;ee++)Q[ee]=arguments[ee];var q=be.renderer.apply(this,Q);return q===!1&&(q=De.apply(this,Q)),q}:ie.renderers[be.name]=be.renderer}if(be.tokenizer){if(!be.level||be.level!=="block"&&be.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ie[be.level]?ie[be.level].unshift(be.tokenizer):ie[be.level]=[be.tokenizer],be.start&&(be.level==="block"?ie.startBlock?ie.startBlock.push(be.start):ie.startBlock=[be.start]:be.level==="inline"&&(ie.startInline?ie.startInline.push(be.start):ie.startInline=[be.start]))}be.childTokens&&(ie.childTokens[be.name]=be.childTokens)})),pe.renderer&&function(){var be=he.defaults.renderer||new ue,De=function(ee){var q=be[ee];be[ee]=function(){for(var ae=arguments.length,le=new Array(ae),Le=0;Le<ae;Le++)le[Le]=arguments[Le];var je=pe.renderer[ee].apply(be,le);return je===!1&&(je=q.apply(be,le)),je}};for(var z in pe.renderer)De(z);G.renderer=be}(),pe.tokenizer&&function(){var be=he.defaults.tokenizer||new F,De=function(ee){var q=be[ee];be[ee]=function(){for(var ae=arguments.length,le=new Array(ae),Le=0;Le<ae;Le++)le[Le]=arguments[Le];var je=pe.tokenizer[ee].apply(be,le);return je===!1&&(je=q.apply(be,le)),je}};for(var z in pe.tokenizer)De(z);G.tokenizer=be}(),pe.walkTokens){var Pe=he.defaults.walkTokens;G.walkTokens=function(be){var De=[];return De.push(pe.walkTokens.call(this,be)),Pe&&(De=De.concat(Pe.call(this,be))),De}}fe&&(G.extensions=ie),he.setOptions(G)})},he.walkTokens=function(ge,x){for(var te=[],G=function(){var Pe=fe.value;switch(te=te.concat(x.call(he,Pe)),Pe.type){case"table":{for(var be=I(Pe.header),De;!(De=be()).done;){var z=De.value;te=te.concat(he.walkTokens(z.tokens,x))}for(var Q=I(Pe.rows),ee;!(ee=Q()).done;)for(var q=ee.value,ae=I(q),le;!(le=ae()).done;){var Le=le.value;te=te.concat(he.walkTokens(Le.tokens,x))}break}case"list":{te=te.concat(he.walkTokens(Pe.items,x));break}default:he.defaults.extensions&&he.defaults.extensions.childTokens&&he.defaults.extensions.childTokens[Pe.type]?he.defaults.extensions.childTokens[Pe.type].forEach(function(je){te=te.concat(he.walkTokens(Pe[je],x))}):Pe.tokens&&(te=te.concat(he.walkTokens(Pe.tokens,x)))}},ie=I(ge),fe;!(fe=ie()).done;)G();return te},he.parseInline=function(ge,x){if(typeof ge>"u"||ge===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ge!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ge)+", string expected");x=k({},he.defaults,x||{}),E(x);try{var te=Y.lexInline(ge,x);return x.walkTokens&&he.walkTokens(te,x.walkTokens),X.parseInline(te,x)}catch(G){if(G.message+=`
Please report this to https://github.com/markedjs/marked.`,x.silent)return"<p>An error occurred:</p><pre>"+S(G.message+"",!0)+"</pre>";throw G}},he.Parser=X,he.parser=X.parse,he.Renderer=ue,he.TextRenderer=Z,he.Lexer=Y,he.lexer=Y.lex,he.Tokenizer=F,he.Slugger=J,he.parse=he;var _=he.options,we=he.setOptions,oe=he.use,K=he.walkTokens,W=he.parseInline,re=he,ye=X.parse,de=Y.lex;me.Lexer=Y,me.Parser=X,me.Renderer=ue,me.Slugger=J,me.TextRenderer=Z,me.Tokenizer=F,me.getDefaults=A,me.lexer=de,me.marked=he,me.options=_,me.parse=re,me.parseInline=W,me.parser=ye,me.setOptions=we,me.use=oe,me.walkTokens=K,Object.defineProperty(me,"__esModule",{value:!0})}),define(ke[161],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rj=void 0;function D(h){const f=I(h);if(f&&f.length>0)return new Uint32Array(f)}e.$Rj=D;let O=0;const g=new Uint32Array(10);function I(h){if(O=0,A(h,C,4352),O>0||(A(h,m,4449),O>0)||(A(h,p,4520),O>0)||(A(h,S,12593),O))return g.subarray(0,O);if(h>=44032&&h<=55203){const f=h-44032,o=f%588,i=Math.floor(f/588),r=Math.floor(o/28),n=o%28-1;if(i<C.length?A(i,C,0):4352+i-12593<S.length&&A(4352+i,S,12593),r<m.length?A(r,m,0):4449+r-12593<S.length&&A(4449+r-12593,S,12593),n>=0&&(n<p.length?A(n,p,0):4520+n-12593<S.length&&A(4520+n-12593,S,12593)),O>0)return g.subarray(0,O)}}function A(h,f,o){h>=o&&h<o+f.length&&b(f[h-o])}function b(h){h!==0&&(g[O++]=h&255,h>>8&&(g[O++]=h>>8&255),h>>16&&(g[O++]=h>>16&255))}var $;(function(h){h[h.InitialConsonant=4352]="InitialConsonant",h[h.Vowel=4449]="Vowel",h[h.FinalConsonant=4520]="FinalConsonant",h[h.CompatibilityJamo=12593]="CompatibilityJamo"})($||($={}));var y;(function(h){h[h.NUL=0]="NUL",h[h.A=65]="A",h[h.B=66]="B",h[h.C=67]="C",h[h.D=68]="D",h[h.E=69]="E",h[h.F=70]="F",h[h.G=71]="G",h[h.H=72]="H",h[h.I=73]="I",h[h.J=74]="J",h[h.K=75]="K",h[h.L=76]="L",h[h.M=77]="M",h[h.N=78]="N",h[h.O=79]="O",h[h.P=80]="P",h[h.Q=81]="Q",h[h.R=82]="R",h[h.S=83]="S",h[h.T=84]="T",h[h.U=85]="U",h[h.V=86]="V",h[h.W=87]="W",h[h.X=88]="X",h[h.Y=89]="Y",h[h.Z=90]="Z",h[h.a=97]="a",h[h.b=98]="b",h[h.c=99]="c",h[h.d=100]="d",h[h.e=101]="e",h[h.f=102]="f",h[h.g=103]="g",h[h.h=104]="h",h[h.i=105]="i",h[h.j=106]="j",h[h.k=107]="k",h[h.l=108]="l",h[h.m=109]="m",h[h.n=110]="n",h[h.o=111]="o",h[h.p=112]="p",h[h.q=113]="q",h[h.r=114]="r",h[h.s=115]="s",h[h.t=116]="t",h[h.u=117]="u",h[h.v=118]="v",h[h.w=119]="w",h[h.x=120]="x",h[h.y=121]="y",h[h.z=122]="z"})(y||(y={}));var L;(function(h){h[h.fa=24934]="fa",h[h.fg=26470]="fg",h[h.fq=29030]="fq",h[h.fr=29286]="fr",h[h.ft=29798]="ft",h[h.fv=30310]="fv",h[h.fx=30822]="fx",h[h.hk=27496]="hk",h[h.hl=27752]="hl",h[h.ho=28520]="ho",h[h.ml=27757]="ml",h[h.nj=27246]="nj",h[h.nl=27758]="nl",h[h.np=28782]="np",h[h.qt=29809]="qt",h[h.rt=29810]="rt",h[h.sg=26483]="sg",h[h.sw=30579]="sw"})(L||(L={}));const C=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),m=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),p=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),S=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(ke[76],Se([1,0,28]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Il=e.$Hl=e.$Gl=void 0;const O=new D.$Dc(1e4);function g(y){return $(y,"NFC",O)}e.$Gl=g;const I=new D.$Dc(1e4);function A(y){return $(y,"NFD",I)}e.$Hl=A;const b=/[^\u0000-\u0080]/;function $(y,L,C){if(!y)return y;const m=C.get(y);if(m)return m;let p;return b.test(y)?p=y.normalize(L):p=y,C.set(y,p),p}e.$Il=function(){const y=/[\u0300-\u036f]/g;return function(L){return A(L).replace(y,"")}}()}),define(ke[122],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$l=e.$0l=e.$9l=e.rot=e.$7l=void 0;function D(b,$,y){return Math.min(Math.max(b,$),y)}e.$7l=D;function O(b,$){return($+b%$)%$}e.rot=O;class g{constructor(){this.a=0}getNext(){return this.a++}}e.$9l=g;class I{constructor(){this.a=1,this.b=0}update($){return this.b=this.b+($-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$0l=I;class A{constructor($){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array($),this.c.fill(0,0,$)}update($){const y=this.c[this.d];return this.c[this.d]=$,this.d=(this.d+1)%this.c.length,this.e-=y,this.e+=$,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$$l=A}),function(){function me(g){const I=[];typeof g=="number"&&I.push("code/timeOrigin",g);function A($){I.push($,Date.now())}function b(){const $=[];for(let y=0;y<I.length;y+=2)$.push({name:I[y],startTime:I[y+1]});return $}return{mark:A,getMarks:b}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?me():{mark(g){performance.mark(g)},getMarks(){let g=performance.timeOrigin;typeof g!="number"&&(g=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const I=[{name:"code/timeOrigin",startTime:Math.round(g)}];for(const A of performance.getEntriesByType("mark"))I.push({name:A.name,startTime:Math.round(g+A.startTime)});return I}};if(typeof process=="object"){const g=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return me(g)}else return console.trace("perf-util loaded in UNKNOWN environment"),me()}function D(g){return g.MonacoPerformanceMarks||(g.MonacoPerformanceMarks=e()),g.MonacoPerformanceMarks}var O;typeof global=="object"?O=global:typeof self=="object"?O=self:O={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(O)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(O):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),O.perf=D(O))}(),function(me,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var D=e();for(var O in D)(typeof exports=="object"?exports:me)[O]=D[O]}}(typeof self<"u"?self:this,function(){return function(me){var e={};function D(O){if(e[O])return e[O].exports;var g=e[O]={i:O,l:!1,exports:{}};return me[O].call(g.exports,g,g.exports,D),g.l=!0,g.exports}return D.m=me,D.c=e,D.d=function(O,g,I){D.o(O,g)||Object.defineProperty(O,g,{enumerable:!0,get:I})},D.r=function(O){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(O,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(O,"__esModule",{value:!0})},D.t=function(O,g){if(1&g&&(O=D(O)),8&g||4&g&&typeof O=="object"&&O&&O.__esModule)return O;var I=Object.create(null);if(D.r(I),Object.defineProperty(I,"default",{enumerable:!0,value:O}),2&g&&typeof O!="string")for(var A in O)D.d(I,A,function(b){return O[b]}.bind(null,A));return I},D.n=function(O){var g=O&&O.__esModule?function(){return O.default}:function(){return O};return D.d(g,"a",g),g},D.o=function(O,g){return Object.prototype.hasOwnProperty.call(O,g)},D.p="",D(D.s=0)}([function(me,e,D){(function(O){var g;e=me.exports=oe,g=typeof O=="object"&&O.env&&O.env.NODE_DEBUG&&/\bsemver\b/i.test(O.env.NODE_DEBUG)?function(){var q=Array.prototype.slice.call(arguments,0);q.unshift("SEMVER"),console.log.apply(console,q)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var I=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,b=e.re=[],$=e.src=[],y=0,L=y++;$[L]="0|[1-9]\\d*";var C=y++;$[C]="[0-9]+";var m=y++;$[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var p=y++;$[p]="("+$[L]+")\\.("+$[L]+")\\.("+$[L]+")";var S=y++;$[S]="("+$[C]+")\\.("+$[C]+")\\.("+$[C]+")";var h=y++;$[h]="(?:"+$[L]+"|"+$[m]+")";var f=y++;$[f]="(?:"+$[C]+"|"+$[m]+")";var o=y++;$[o]="(?:-("+$[h]+"(?:\\."+$[h]+")*))";var i=y++;$[i]="(?:-?("+$[f]+"(?:\\."+$[f]+")*))";var r=y++;$[r]="[0-9A-Za-z-]+";var n=y++;$[n]="(?:\\+("+$[r]+"(?:\\."+$[r]+")*))";var c=y++,t="v?"+$[p]+$[o]+"?"+$[n]+"?";$[c]="^"+t+"$";var u="[v=\\s]*"+$[S]+$[i]+"?"+$[n]+"?",s=y++;$[s]="^"+u+"$";var l=y++;$[l]="((?:<|>)?=?)";var a=y++;$[a]=$[C]+"|x|X|\\*";var d=y++;$[d]=$[L]+"|x|X|\\*";var k=y++;$[k]="[v=\\s]*("+$[d]+")(?:\\.("+$[d]+")(?:\\.("+$[d]+")(?:"+$[o]+")?"+$[n]+"?)?)?";var R=y++;$[R]="[v=\\s]*("+$[a]+")(?:\\.("+$[a]+")(?:\\.("+$[a]+")(?:"+$[i]+")?"+$[n]+"?)?)?";var v=y++;$[v]="^"+$[l]+"\\s*"+$[k]+"$";var w=y++;$[w]="^"+$[l]+"\\s*"+$[R]+"$";var E=y++;$[E]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var P=y++;$[P]="(?:~>?)";var N=y++;$[N]="(\\s*)"+$[P]+"\\s+",b[N]=new RegExp($[N],"g");var U=y++;$[U]="^"+$[P]+$[k]+"$";var F=y++;$[F]="^"+$[P]+$[R]+"$";var j=y++;$[j]="(?:\\^)";var T=y++;$[T]="(\\s*)"+$[j]+"\\s+",b[T]=new RegExp($[T],"g");var M=y++;$[M]="^"+$[j]+$[k]+"$";var B=y++;$[B]="^"+$[j]+$[R]+"$";var Y=y++;$[Y]="^"+$[l]+"\\s*("+u+")$|^$";var ue=y++;$[ue]="^"+$[l]+"\\s*("+t+")$|^$";var Z=y++;$[Z]="(\\s*)"+$[l]+"\\s*("+u+"|"+$[k]+")",b[Z]=new RegExp($[Z],"g");var J=y++;$[J]="^\\s*("+$[k]+")\\s+-\\s+("+$[k]+")\\s*$";var X=y++;$[X]="^\\s*("+$[R]+")\\s+-\\s+("+$[R]+")\\s*$";var he=y++;$[he]="(<|>)?=?\\s*\\*";for(var _=0;_<35;_++)g(_,$[_]),b[_]||(b[_]=new RegExp($[_]));function we(q,ae){if(q instanceof oe)return q;if(typeof q!="string"||q.length>I||!(ae?b[s]:b[c]).test(q))return null;try{return new oe(q,ae)}catch{return null}}function oe(q,ae){if(q instanceof oe){if(q.loose===ae)return q;q=q.version}else if(typeof q!="string")throw new TypeError("Invalid Version: "+q);if(q.length>I)throw new TypeError("version is longer than "+I+" characters");if(!(this instanceof oe))return new oe(q,ae);g("SemVer",q,ae),this.loose=ae;var le=q.trim().match(ae?b[s]:b[c]);if(!le)throw new TypeError("Invalid Version: "+q);if(this.raw=q,this.major=+le[1],this.minor=+le[2],this.patch=+le[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");le[4]?this.prerelease=le[4].split(".").map(function(Le){if(/^[0-9]+$/.test(Le)){var je=+Le;if(je>=0&&je<A)return je}return Le}):this.prerelease=[],this.build=le[5]?le[5].split("."):[],this.format()}e.parse=we,e.valid=function(q,ae){var le=we(q,ae);return le?le.version:null},e.clean=function(q,ae){var le=we(q.trim().replace(/^[=v]+/,""),ae);return le?le.version:null},e.SemVer=oe,oe.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},oe.prototype.toString=function(){return this.version},oe.prototype.compare=function(q){return g("SemVer.compare",this.version,this.loose,q),q instanceof oe||(q=new oe(q,this.loose)),this.compareMain(q)||this.comparePre(q)},oe.prototype.compareMain=function(q){return q instanceof oe||(q=new oe(q,this.loose)),W(this.major,q.major)||W(this.minor,q.minor)||W(this.patch,q.patch)},oe.prototype.comparePre=function(q){if(q instanceof oe||(q=new oe(q,this.loose)),this.prerelease.length&&!q.prerelease.length)return-1;if(!this.prerelease.length&&q.prerelease.length)return 1;if(!this.prerelease.length&&!q.prerelease.length)return 0;var ae=0;do{var le=this.prerelease[ae],Le=q.prerelease[ae];if(g("prerelease compare",ae,le,Le),le===void 0&&Le===void 0)return 0;if(Le===void 0)return 1;if(le===void 0)return-1;if(le!==Le)return W(le,Le)}while(++ae)},oe.prototype.inc=function(q,ae){switch(q){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ae);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ae);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ae),this.inc("pre",ae);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ae),this.inc("pre",ae);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var le=this.prerelease.length;--le>=0;)typeof this.prerelease[le]=="number"&&(this.prerelease[le]++,le=-2);le===-1&&this.prerelease.push(0)}ae&&(this.prerelease[0]===ae?isNaN(this.prerelease[1])&&(this.prerelease=[ae,0]):this.prerelease=[ae,0]);break;default:throw new Error("invalid increment argument: "+q)}return this.format(),this.raw=this.version,this},e.inc=function(q,ae,le,Le){typeof le=="string"&&(Le=le,le=void 0);try{return new oe(q,le).inc(ae,Le).version}catch{return null}},e.diff=function(q,ae){if(ge(q,ae))return null;var le=we(q),Le=we(ae);if(le.prerelease.length||Le.prerelease.length){for(var je in le)if((je==="major"||je==="minor"||je==="patch")&&le[je]!==Le[je])return"pre"+je;return"prerelease"}for(var je in le)if((je==="major"||je==="minor"||je==="patch")&&le[je]!==Le[je])return je},e.compareIdentifiers=W;var K=/^[0-9]+$/;function W(q,ae){var le=K.test(q),Le=K.test(ae);return le&&Le&&(q=+q,ae=+ae),le&&!Le?-1:Le&&!le?1:q<ae?-1:q>ae?1:0}function re(q,ae,le){return new oe(q,le).compare(new oe(ae,le))}function ye(q,ae,le){return re(q,ae,le)>0}function de(q,ae,le){return re(q,ae,le)<0}function ge(q,ae,le){return re(q,ae,le)===0}function x(q,ae,le){return re(q,ae,le)!==0}function te(q,ae,le){return re(q,ae,le)>=0}function G(q,ae,le){return re(q,ae,le)<=0}function ie(q,ae,le,Le){var je;switch(ae){case"===":typeof q=="object"&&(q=q.version),typeof le=="object"&&(le=le.version),je=q===le;break;case"!==":typeof q=="object"&&(q=q.version),typeof le=="object"&&(le=le.version),je=q!==le;break;case"":case"=":case"==":je=ge(q,le,Le);break;case"!=":je=x(q,le,Le);break;case">":je=ye(q,le,Le);break;case">=":je=te(q,le,Le);break;case"<":je=de(q,le,Le);break;case"<=":je=G(q,le,Le);break;default:throw new TypeError("Invalid operator: "+ae)}return je}function fe(q,ae){if(q instanceof fe){if(q.loose===ae)return q;q=q.value}if(!(this instanceof fe))return new fe(q,ae);g("comparator",q,ae),this.loose=ae,this.parse(q),this.semver===pe?this.value="":this.value=this.operator+this.semver.version,g("comp",this)}e.rcompareIdentifiers=function(q,ae){return W(ae,q)},e.major=function(q,ae){return new oe(q,ae).major},e.minor=function(q,ae){return new oe(q,ae).minor},e.patch=function(q,ae){return new oe(q,ae).patch},e.compare=re,e.compareLoose=function(q,ae){return re(q,ae,!0)},e.rcompare=function(q,ae,le){return re(ae,q,le)},e.sort=function(q,ae){return q.sort(function(le,Le){return e.compare(le,Le,ae)})},e.rsort=function(q,ae){return q.sort(function(le,Le){return e.rcompare(le,Le,ae)})},e.gt=ye,e.lt=de,e.eq=ge,e.neq=x,e.gte=te,e.lte=G,e.cmp=ie,e.Comparator=fe;var pe={};function Pe(q,ae){if(q instanceof Pe)return q.loose===ae?q:new Pe(q.raw,ae);if(q instanceof fe)return new Pe(q.value,ae);if(!(this instanceof Pe))return new Pe(q,ae);if(this.loose=ae,this.raw=q,this.set=q.split(/\s*\|\|\s*/).map(function(le){return this.parseRange(le.trim())},this).filter(function(le){return le.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+q);this.format()}function be(q){return!q||q.toLowerCase()==="x"||q==="*"}function De(q,ae,le,Le,je,He,Je,_e,ct,ot,rt,Re,Ue){return((ae=be(le)?"":be(Le)?">="+le+".0.0":be(je)?">="+le+"."+Le+".0":">="+ae)+" "+(_e=be(ct)?"":be(ot)?"<"+(+ct+1)+".0.0":be(rt)?"<"+ct+"."+(+ot+1)+".0":Re?"<="+ct+"."+ot+"."+rt+"-"+Re:"<="+_e)).trim()}function z(q,ae){for(var le=0;le<q.length;le++)if(!q[le].test(ae))return!1;if(ae.prerelease.length){for(le=0;le<q.length;le++)if(g(q[le].semver),q[le].semver!==pe&&q[le].semver.prerelease.length>0){var Le=q[le].semver;if(Le.major===ae.major&&Le.minor===ae.minor&&Le.patch===ae.patch)return!0}return!1}return!0}function Q(q,ae,le){try{ae=new Pe(ae,le)}catch{return!1}return ae.test(q)}function ee(q,ae,le,Le){var je,He,Je,_e,ct;switch(q=new oe(q,Le),ae=new Pe(ae,Le),le){case">":je=ye,He=G,Je=de,_e=">",ct=">=";break;case"<":je=de,He=te,Je=ye,_e="<",ct="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Q(q,ae,Le))return!1;for(var ot=0;ot<ae.set.length;++ot){var rt=ae.set[ot],Re=null,Ue=null;if(rt.forEach(function(Ae){Ae.semver===pe&&(Ae=new fe(">=0.0.0")),Re=Re||Ae,Ue=Ue||Ae,je(Ae.semver,Re.semver,Le)?Re=Ae:Je(Ae.semver,Ue.semver,Le)&&(Ue=Ae)}),Re.operator===_e||Re.operator===ct||(!Ue.operator||Ue.operator===_e)&&He(q,Ue.semver)||Ue.operator===ct&&Je(q,Ue.semver))return!1}return!0}fe.prototype.parse=function(q){var ae=this.loose?b[Y]:b[ue],le=q.match(ae);if(!le)throw new TypeError("Invalid comparator: "+q);this.operator=le[1],this.operator==="="&&(this.operator=""),le[2]?this.semver=new oe(le[2],this.loose):this.semver=pe},fe.prototype.toString=function(){return this.value},fe.prototype.test=function(q){return g("Comparator.test",q,this.loose),this.semver===pe||(typeof q=="string"&&(q=new oe(q,this.loose)),ie(q,this.operator,this.semver,this.loose))},fe.prototype.intersects=function(q,ae){if(!(q instanceof fe))throw new TypeError("a Comparator is required");var le;if(this.operator==="")return le=new Pe(q.value,ae),Q(this.value,le,ae);if(q.operator==="")return le=new Pe(this.value,ae),Q(q.semver,le,ae);var Le=!(this.operator!==">="&&this.operator!==">"||q.operator!==">="&&q.operator!==">"),je=!(this.operator!=="<="&&this.operator!=="<"||q.operator!=="<="&&q.operator!=="<"),He=this.semver.version===q.semver.version,Je=!(this.operator!==">="&&this.operator!=="<="||q.operator!==">="&&q.operator!=="<="),_e=ie(this.semver,"<",q.semver,ae)&&(this.operator===">="||this.operator===">")&&(q.operator==="<="||q.operator==="<"),ct=ie(this.semver,">",q.semver,ae)&&(this.operator==="<="||this.operator==="<")&&(q.operator===">="||q.operator===">");return Le||je||He&&Je||_e||ct},e.Range=Pe,Pe.prototype.format=function(){return this.range=this.set.map(function(q){return q.join(" ").trim()}).join("||").trim(),this.range},Pe.prototype.toString=function(){return this.range},Pe.prototype.parseRange=function(q){var ae=this.loose;q=q.trim(),g("range",q,ae);var le=ae?b[X]:b[J];q=q.replace(le,De),g("hyphen replace",q),q=q.replace(b[Z],"$1$2$3"),g("comparator trim",q,b[Z]),q=(q=(q=q.replace(b[N],"$1~")).replace(b[T],"$1^")).split(/\s+/).join(" ");var Le=ae?b[Y]:b[ue],je=q.split(" ").map(function(He){return function(Je,_e){return g("comp",Je),Je=function(ct,ot){return ct.trim().split(/\s+/).map(function(rt){return function(Re,Ue){g("caret",Re,Ue);var Ae=Ue?b[B]:b[M];return Re.replace(Ae,function(Xe,ne,ce,Ie,qe){var Ye;return g("caret",Re,Xe,ne,ce,Ie,qe),be(ne)?Ye="":be(ce)?Ye=">="+ne+".0.0 <"+(+ne+1)+".0.0":be(Ie)?Ye=ne==="0"?">="+ne+"."+ce+".0 <"+ne+"."+(+ce+1)+".0":">="+ne+"."+ce+".0 <"+(+ne+1)+".0.0":qe?(g("replaceCaret pr",qe),qe.charAt(0)!=="-"&&(qe="-"+qe),Ye=ne==="0"?ce==="0"?">="+ne+"."+ce+"."+Ie+qe+" <"+ne+"."+ce+"."+(+Ie+1):">="+ne+"."+ce+"."+Ie+qe+" <"+ne+"."+(+ce+1)+".0":">="+ne+"."+ce+"."+Ie+qe+" <"+(+ne+1)+".0.0"):(g("no pr"),Ye=ne==="0"?ce==="0"?">="+ne+"."+ce+"."+Ie+" <"+ne+"."+ce+"."+(+Ie+1):">="+ne+"."+ce+"."+Ie+" <"+ne+"."+(+ce+1)+".0":">="+ne+"."+ce+"."+Ie+" <"+(+ne+1)+".0.0"),g("caret return",Ye),Ye})}(rt,ot)}).join(" ")}(Je,_e),g("caret",Je),Je=function(ct,ot){return ct.trim().split(/\s+/).map(function(rt){return function(Re,Ue){var Ae=Ue?b[F]:b[U];return Re.replace(Ae,function(Xe,ne,ce,Ie,qe){var Ye;return g("tilde",Re,Xe,ne,ce,Ie,qe),be(ne)?Ye="":be(ce)?Ye=">="+ne+".0.0 <"+(+ne+1)+".0.0":be(Ie)?Ye=">="+ne+"."+ce+".0 <"+ne+"."+(+ce+1)+".0":qe?(g("replaceTilde pr",qe),qe.charAt(0)!=="-"&&(qe="-"+qe),Ye=">="+ne+"."+ce+"."+Ie+qe+" <"+ne+"."+(+ce+1)+".0"):Ye=">="+ne+"."+ce+"."+Ie+" <"+ne+"."+(+ce+1)+".0",g("tilde return",Ye),Ye})}(rt,ot)}).join(" ")}(Je,_e),g("tildes",Je),Je=function(ct,ot){return g("replaceXRanges",ct,ot),ct.split(/\s+/).map(function(rt){return function(Re,Ue){Re=Re.trim();var Ae=Ue?b[w]:b[v];return Re.replace(Ae,function(Xe,ne,ce,Ie,qe,Ye){g("xRange",Re,Xe,ne,ce,Ie,qe,Ye);var nt=be(ce),it=nt||be(Ie),Oe=it||be(qe);return ne==="="&&Oe&&(ne=""),nt?Xe=ne===">"||ne==="<"?"<0.0.0":"*":ne&&Oe?(it&&(Ie=0),Oe&&(qe=0),ne===">"?(ne=">=",it?(ce=+ce+1,Ie=0,qe=0):Oe&&(Ie=+Ie+1,qe=0)):ne==="<="&&(ne="<",it?ce=+ce+1:Ie=+Ie+1),Xe=ne+ce+"."+Ie+"."+qe):it?Xe=">="+ce+".0.0 <"+(+ce+1)+".0.0":Oe&&(Xe=">="+ce+"."+Ie+".0 <"+ce+"."+(+Ie+1)+".0"),g("xRange return",Xe),Xe})}(rt,ot)}).join(" ")}(Je,_e),g("xrange",Je),Je=function(ct,ot){return g("replaceStars",ct,ot),ct.trim().replace(b[he],"")}(Je,_e),g("stars",Je),Je}(He,ae)}).join(" ").split(/\s+/);return this.loose&&(je=je.filter(function(He){return!!He.match(Le)})),je=je.map(function(He){return new fe(He,ae)})},Pe.prototype.intersects=function(q,ae){if(!(q instanceof Pe))throw new TypeError("a Range is required");return this.set.some(function(le){return le.every(function(Le){return q.set.some(function(je){return je.every(function(He){return Le.intersects(He,ae)})})})})},e.toComparators=function(q,ae){return new Pe(q,ae).set.map(function(le){return le.map(function(Le){return Le.value}).join(" ").trim().split(" ")})},Pe.prototype.test=function(q){if(!q)return!1;typeof q=="string"&&(q=new oe(q,this.loose));for(var ae=0;ae<this.set.length;ae++)if(z(this.set[ae],q))return!0;return!1},e.satisfies=Q,e.maxSatisfying=function(q,ae,le){var Le=null,je=null;try{var He=new Pe(ae,le)}catch{return null}return q.forEach(function(Je){He.test(Je)&&(Le&&je.compare(Je)!==-1||(je=new oe(Le=Je,le)))}),Le},e.minSatisfying=function(q,ae,le){var Le=null,je=null;try{var He=new Pe(ae,le)}catch{return null}return q.forEach(function(Je){He.test(Je)&&(Le&&je.compare(Je)!==1||(je=new oe(Le=Je,le)))}),Le},e.validRange=function(q,ae){try{return new Pe(q,ae).range||"*"}catch{return null}},e.ltr=function(q,ae,le){return ee(q,ae,"<",le)},e.gtr=function(q,ae,le){return ee(q,ae,">",le)},e.outside=ee,e.prerelease=function(q,ae){var le=we(q,ae);return le&&le.prerelease.length?le.prerelease:null},e.intersects=function(q,ae,le){return q=new Pe(q,le),ae=new Pe(ae,le),q.intersects(ae)},e.coerce=function(q){if(q instanceof oe)return q;if(typeof q!="string")return null;var ae=q.match(b[E]);return ae==null?null:we((ae[1]||"0")+"."+(ae[2]||"0")+"."+(ae[3]||"0"))}}).call(this,D(1))},function(me,e){var D,O,g=me.exports={};function I(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function b(f){if(D===setTimeout)return setTimeout(f,0);if((D===I||!D)&&setTimeout)return D=setTimeout,setTimeout(f,0);try{return D(f,0)}catch{try{return D.call(null,f,0)}catch{return D.call(this,f,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:I}catch{D=I}try{O=typeof clearTimeout=="function"?clearTimeout:A}catch{O=A}})();var $,y=[],L=!1,C=-1;function m(){L&&$&&(L=!1,$.length?y=$.concat(y):C=-1,y.length&&p())}function p(){if(!L){var f=b(m);L=!0;for(var o=y.length;o;){for($=y,y=[];++C<o;)$&&$[C].run();C=-1,o=y.length}$=null,L=!1,function(i){if(O===clearTimeout)return clearTimeout(i);if((O===A||!O)&&clearTimeout)return O=clearTimeout,clearTimeout(i);try{O(i)}catch{try{return O.call(null,i)}catch{return O.call(this,i)}}}(f)}}function S(f,o){this.fun=f,this.array=o}function h(){}g.nextTick=function(f){var o=new Array(arguments.length-1);if(arguments.length>1)for(var i=1;i<arguments.length;i++)o[i-1]=arguments[i];y.push(new S(f,o)),y.length!==1||L||b(p)},S.prototype.run=function(){this.fun.apply(null,this.array)},g.title="browser",g.browser=!0,g.env={},g.argv=[],g.version="",g.versions={},g.on=h,g.addListener=h,g.once=h,g.off=h,g.removeListener=h,g.removeAllListeners=h,g.emit=h,g.prependListener=h,g.prependOnceListener=h,g.listeners=function(f){return[]},g.binding=function(f){throw new Error("process.binding is not supported")},g.cwd=function(){return"/"},g.chdir=function(f){throw new Error("process.chdir is not supported")},g.umask=function(){return 0}}])}),define(ke[38],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rd=void 0;const D=globalThis.performance&&typeof globalThis.performance.now=="function";class O{static create(I){return new O(I)}constructor(I){this.c=D&&I===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$Rd=O}),define(ke[4],Se([1,0,14,74,3,75,38]),function(me,e,D,O,g,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.$Td=e.Event=void 0;const b=!1,$=!1;var y;(function(v){v.None=()=>g.$Tc.None;function w(ie){if($){const{onDidAddListener:fe}=ie,pe=S.create();let Pe=0;ie.onDidAddListener=()=>{++Pe===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),pe.print()),fe?.()}}}function E(ie,fe){return ue(ie,()=>{},0,void 0,!0,void 0,fe)}v.defer=E;function P(ie){return(fe,pe=null,Pe)=>{let be=!1,De;return De=ie(z=>{if(!be)return De?De.dispose():be=!0,fe.call(pe,z)},null,Pe),be&&De.dispose(),De}}v.once=P;function N(ie,fe,pe){return B((Pe,be=null,De)=>ie(z=>Pe.call(be,fe(z)),null,De),pe)}v.map=N;function U(ie,fe,pe){return B((Pe,be=null,De)=>ie(z=>{fe(z),Pe.call(be,z)},null,De),pe)}v.forEach=U;function F(ie,fe,pe){return B((Pe,be=null,De)=>ie(z=>fe(z)&&Pe.call(be,z),null,De),pe)}v.filter=F;function j(ie){return ie}v.signal=j;function T(...ie){return(fe,pe=null,Pe)=>{const be=(0,g.$Qc)(...ie.map(De=>De(z=>fe.call(pe,z))));return Y(be,Pe)}}v.any=T;function M(ie,fe,pe,Pe){let be=pe;return N(ie,De=>(be=fe(be,De),be),Pe)}v.reduce=M;function B(ie,fe){let pe;const Pe={onWillAddFirstListener(){pe=ie(be.fire,be)},onDidRemoveLastListener(){pe?.dispose()}};fe||w(Pe);const be=new r(Pe);return fe?.add(be),be.event}function Y(ie,fe){return fe instanceof Array?fe.push(ie):fe&&fe.add(ie),ie}function ue(ie,fe,pe=100,Pe=!1,be=!1,De,z){let Q,ee,q,ae=0,le;const Le={leakWarningThreshold:De,onWillAddFirstListener(){Q=ie(He=>{ae++,ee=fe(ee,He),Pe&&!q&&(je.fire(ee),ee=void 0),le=()=>{const Je=ee;ee=void 0,q=void 0,(!Pe||ae>1)&&je.fire(Je),ae=0},typeof pe=="number"?(clearTimeout(q),q=setTimeout(le,pe)):q===void 0&&(q=0,queueMicrotask(le))})},onWillRemoveListener(){be&&ae>0&&le?.()},onDidRemoveLastListener(){le=void 0,Q.dispose()}};z||w(Le);const je=new r(Le);return z?.add(je),je.event}v.debounce=ue;function Z(ie,fe=0,pe){return v.debounce(ie,(Pe,be)=>Pe?(Pe.push(be),Pe):[be],fe,void 0,!0,void 0,pe)}v.accumulate=Z;function J(ie,fe=(Pe,be)=>Pe===be,pe){let Pe=!0,be;return F(ie,De=>{const z=Pe||!fe(De,be);return Pe=!1,be=De,z},pe)}v.latch=J;function X(ie,fe,pe){return[v.filter(ie,fe,pe),v.filter(ie,Pe=>!fe(Pe),pe)]}v.split=X;function he(ie,fe=!1,pe=[],Pe){let be=pe.slice(),De=ie(ee=>{be?be.push(ee):Q.fire(ee)});Pe&&Pe.add(De);const z=()=>{be?.forEach(ee=>Q.fire(ee)),be=null},Q=new r({onWillAddFirstListener(){De||(De=ie(ee=>Q.fire(ee)),Pe&&Pe.add(De))},onDidAddFirstListener(){be&&(fe?setTimeout(z):z())},onDidRemoveLastListener(){De&&De.dispose(),De=null}});return Pe&&Pe.add(Q),Q.event}v.buffer=he;function _(ie,fe){return(Pe,be,De)=>{const z=fe(new oe);return ie(function(Q){const ee=z.evaluate(Q);ee!==we&&Pe.call(be,ee)},void 0,De)}}v.chain=_;const we=Symbol("HaltChainable");class oe{constructor(){this.f=[]}map(fe){return this.f.push(fe),this}forEach(fe){return this.f.push(pe=>(fe(pe),pe)),this}filter(fe){return this.f.push(pe=>fe(pe)?pe:we),this}reduce(fe,pe){let Pe=pe;return this.f.push(be=>(Pe=fe(Pe,be),Pe)),this}latch(fe=(pe,Pe)=>pe===Pe){let pe=!0,Pe;return this.f.push(be=>{const De=pe||!fe(be,Pe);return pe=!1,Pe=be,De?be:we}),this}evaluate(fe){for(const pe of this.f)if(fe=pe(fe),fe===we)break;return fe}}function K(ie,fe,pe=Pe=>Pe){const Pe=(...Q)=>z.fire(pe(...Q)),be=()=>ie.on(fe,Pe),De=()=>ie.removeListener(fe,Pe),z=new r({onWillAddFirstListener:be,onDidRemoveLastListener:De});return z.event}v.fromNodeEventEmitter=K;function W(ie,fe,pe=Pe=>Pe){const Pe=(...Q)=>z.fire(pe(...Q)),be=()=>ie.addEventListener(fe,Pe),De=()=>ie.removeEventListener(fe,Pe),z=new r({onWillAddFirstListener:be,onDidRemoveLastListener:De});return z.event}v.fromDOMEventEmitter=W;function re(ie){return new Promise(fe=>P(ie)(fe))}v.toPromise=re;function ye(ie){const fe=new r;return ie.then(pe=>{fe.fire(pe)},()=>{fe.fire(void 0)}).finally(()=>{fe.dispose()}),fe.event}v.fromPromise=ye;function de(ie,fe,pe){return fe(pe),ie(Pe=>fe(Pe))}v.runAndSubscribe=de;function ge(ie,fe){let pe=null;function Pe(De){pe?.dispose(),pe=new g.$Sc,fe(De,pe)}Pe(void 0);const be=ie(De=>Pe(De));return(0,g.$Rc)(()=>{be.dispose(),pe?.dispose()})}v.runAndSubscribeWithStore=ge;class x{constructor(fe,pe){this._observable=fe,this.f=0,this.g=!1;const Pe={onWillAddFirstListener:()=>{fe.addObserver(this)},onDidRemoveLastListener:()=>{fe.removeObserver(this)}};pe||w(Pe),this.emitter=new r(Pe),pe&&pe.add(this.emitter)}beginUpdate(fe){this.f++}handlePossibleChange(fe){}handleChange(fe,pe){this.g=!0}endUpdate(fe){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function te(ie,fe){return new x(ie,fe).emitter.event}v.fromObservable=te;function G(ie){return(fe,pe,Pe)=>{let be=0,De=!1;const z={beginUpdate(){be++},endUpdate(){be--,be===0&&(ie.reportChanges(),De&&(De=!1,fe.call(pe)))},handlePossibleChange(){},handleChange(){De=!0}};ie.addObserver(z),ie.reportChanges();const Q={dispose(){ie.removeObserver(z)}};return Pe instanceof g.$Sc?Pe.add(Q):Array.isArray(Pe)&&Pe.push(Q),Q}}v.fromObservableLight=G})(y||(e.Event=y={}));class L{static{this.all=new Set}static{this.f=0}constructor(w){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${w}_${L.f++}`,L.all.add(this)}start(w){this.g=new A.$Rd,this.listenerCount=w}stop(){if(this.g){const w=this.g.elapsed();this.durations.push(w),this.elapsedOverall+=w,this.invocationCount+=1,this.g=void 0}}}e.$Td=L;let C=-1;function m(v){const w=C;return C=v,{dispose(){C=w}}}e.$Ud=m;class p{constructor(w,E=Math.random().toString(18).slice(2,5)){this.threshold=w,this.name=E,this.g=0}dispose(){this.f?.clear()}check(w,E){const P=this.threshold;if(P<=0||E<P)return;this.f||(this.f=new Map);const N=this.f.get(w.value)||0;if(this.f.set(w.value,N+1),this.g-=1,this.g<=0){this.g=P*.5;let U,F=0;for(const[j,T]of this.f)(!U||F<T)&&(U=j,F=T);console.warn(`[${this.name}] potential listener LEAK detected, having ${E} listeners already. MOST frequent listener (${F}):`),console.warn(U)}return()=>{const U=this.f.get(w.value)||0;this.f.set(w.value,U-1)}}}class S{static create(){return new S(new Error().stack??"")}constructor(w){this.value=w}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let h=0;class f{constructor(w){this.value=w,this.id=h++}}const o=2,i=(v,w)=>{if(v instanceof f)w(v);else for(let E=0;E<v.length;E++){const P=v[E];P&&w(P)}};class r{constructor(w){this.w=0,this.f=w,this.g=C>0||this.f?.leakWarningThreshold?new p(this.f?.leakWarningThreshold??C):void 0,this.j=this.f?._profName?new L(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(b){const w=this.t;queueMicrotask(()=>{i(w,E=>E.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(w,E,P)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),g.$Tc.None;if(this.m)return g.$Tc.None;E&&(w=w.bind(E));const N=new f(w);let U,F;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(N.stack=S.create(),U=this.g.check(N.stack,this.w+1)),b&&(N.stack=F??S.create()),this.t?this.t instanceof f?(this.u??=new c,this.t=[this.t,N]):this.t.push(N):(this.f?.onWillAddFirstListener?.(this),this.t=N,this.f?.onDidAddFirstListener?.(this)),this.w++;const j=(0,g.$Rc)(()=>{U?.(),this.x(N)});return P instanceof g.$Sc?P.add(j):Array.isArray(P)&&P.push(j),j},this.q}x(w){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const E=this.t,P=E.indexOf(w);if(P===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,E[P]=void 0;const N=this.u.current===this;if(this.w*o<=E.length){let U=0;for(let F=0;F<E.length;F++)E[F]?E[U++]=E[F]:N&&(this.u.end--,U<this.u.i&&this.u.i--);E.length=U}}y(w,E){if(!w)return;const P=this.f?.onListenerError||D.$1;if(!P){w.value(E);return}try{w.value(E)}catch(N){P(N)}}z(w){const E=w.current.t;for(;w.i<w.end;)this.y(E[w.i++],w.value);w.reset()}fire(w){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof f)this.y(this.t,w);else{const E=this.u;E.enqueue(this,w,this.t.length),this.z(E)}this.j?.stop()}hasListeners(){return this.w>0}}e.$Vd=r;const n=()=>new c;e.$Wd=n;class c{constructor(){this.i=-1,this.end=0}enqueue(w,E,P){this.i=0,this.end=P,this.current=w,this.value=E}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends r{async fireAsync(w,E,P){if(this.t)for(this.h||(this.h=new I.$4c),i(this.t,N=>this.h.push([N.value,w]));this.h.size>0&&!E.isCancellationRequested;){const[N,U]=this.h.shift(),F=[],j={...U,token:E,waitUntil:T=>{if(Object.isFrozen(F))throw new Error("waitUntil can NOT be called asynchronous");P&&(T=P(T,N)),F.push(T)}};try{N(j)}catch(T){(0,D.$1)(T);continue}Object.freeze(F),await Promise.allSettled(F).then(T=>{for(const M of T)M.status==="rejected"&&(0,D.$1)(M.reason)})}}}e.$Xd=t;class u extends r{get isPaused(){return this.h!==0}constructor(w){super(w),this.h=0,this.s=new I.$4c,this.A=w?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const w=Array.from(this.s);this.s.clear(),super.fire(this.A(w))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(w){this.w&&(this.h!==0?this.s.push(w):super.fire(w))}}e.$Yd=u;class s extends u{constructor(w){super(w),this.k=w.delay??100}fire(w){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(w)}}e.$Zd=s;class l extends r{constructor(w){super(w),this.h=[],this.k=w?.merge}fire(w){this.hasListeners()&&(this.h.push(w),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(E=>super.fire(E)),this.h=[]}))}}e.$1d=l;class a{constructor(){this.g=!1,this.h=[],this.f=new r({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(w){const E={event:w,listener:null};this.h.push(E),this.g&&this.m(E);const P=()=>{this.g&&this.o(E);const N=this.h.indexOf(E);this.h.splice(N,1)};return(0,g.$Rc)((0,O.$db)(P))}j(){this.g=!0,this.h.forEach(w=>this.m(w))}k(){this.g=!1,this.h.forEach(w=>this.o(w))}m(w){w.listener=w.event(E=>this.f.fire(E))}o(w){w.listener&&w.listener.dispose(),w.listener=null}dispose(){this.f.dispose()}}e.$2d=a;class d{constructor(w,E,P,N){this.f=new g.$Sc;const U=this.f.add(new a),F=this.f.add(new g.$3c);function j(T){F.set(T,U.add(N(T)))}for(const T of w)j(T);this.f.add(E(T=>{j(T)})),this.f.add(P(T=>{F.deleteAndDispose(T)})),this.event=U.event}dispose(){this.f.dispose()}}e.$3d=d;class k{constructor(){this.f=[]}wrapEvent(w){return(E,P,N)=>w(U=>{const F=this.f[this.f.length-1];F?F.push(()=>E.call(P,U)):E.call(P,U)},void 0,N)}bufferEvents(w){const E=[];this.f.push(E);const P=w();return this.f.pop(),E.forEach(N=>N()),P}}e.$4d=k;class R{constructor(){this.f=!1,this.g=y.None,this.h=g.$Tc.None,this.j=new r({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(w){this.g=w,this.f&&(this.h.dispose(),this.h=w(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$5d=R}),define(ke[21],Se([1,0,4]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6d=e.CancellationToken=void 0;const O=Object.freeze(function(b,$){const y=setTimeout(b.bind($),0);return{dispose(){clearTimeout(y)}}});var g;(function(b){function $(y){return y===b.None||y===b.Cancelled||y instanceof I?!0:!y||typeof y!="object"?!1:typeof y.isCancellationRequested=="boolean"&&typeof y.onCancellationRequested=="function"}b.isCancellationToken=$,b.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:D.Event.None}),b.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:O})})(g||(e.CancellationToken=g={}));class I{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?O:(this.b||(this.b=new D.$Vd),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class A{constructor($){this.f=void 0,this.g=void 0,this.g=$&&$.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new I),this.f}cancel(){this.f?this.f instanceof I&&this.f.cancel():this.f=g.Cancelled}dispose($=!1){$&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof I&&this.f.dispose():this.f=g.None}}e.$6d=A}),define(ke[162],Se([1,0,21]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ge=e.$Fe=e.$Ee=void 0;class O{constructor(b){this.b=b,this.a=null}get(){if(this.a)return this.a;const b=new D.$6d,$=this.b(b.token);return this.a={promise:$,dispose:()=>{this.a=null,b.cancel(),b.dispose()}},this.a}}e.$Ee=O;class g{constructor(b){this.c=b,this.a=void 0,this.b=void 0}get(b){const $=JSON.stringify(b);return this.b!==$&&(this.b=$,this.a=this.c(b)),this.a}}e.$Fe=g;class I{get cachedValues(){return this.a}constructor(b){this.b=b,this.a=new Map}get(b){if(this.a.has(b))return this.a.get(b);const $=this.b(b);return this.a.set(b,$),$}}e.$Ge=I}),define(ke[98],Se([1,0,14,3]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=void 0;function g(n){const c=n;return c?typeof c.read=="function":!1}e.$7d=g;function I(n){const c=n;return c?[c.on,c.pause,c.resume,c.destroy].every(t=>typeof t=="function"):!1}e.$8d=I;function A(n){const c=n;return c?I(c.stream)&&Array.isArray(c.buffer)&&typeof c.ended=="boolean":!1}e.$9d=A;function b(n,c){return new $(n,c)}e.$0d=b;class ${constructor(c,t){this.e=c,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(c){if(!this.a.destroyed){if(this.a.flowing)this.g(c);else if(this.b.data.push(c),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(c){this.a.destroyed||(this.a.flowing?this.h(c):this.b.error.push(c))}end(c){this.a.destroyed||(typeof c<"u"&&this.write(c),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(c){this.c.data.slice(0).forEach(t=>t(c))}h(c){this.c.error.length===0?(0,D.$1)(c):this.c.error.slice(0).forEach(t=>t(c))}i(){this.c.end.slice(0).forEach(c=>c())}on(c,t){if(!this.a.destroyed)switch(c){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(c,t){if(this.a.destroyed)return;let u;switch(c){case"data":u=this.c.data;break;case"end":u=this.c.end;break;case"error":u=this.c.error;break}if(u){const s=u.indexOf(t);s>=0&&u.splice(s,1)}}j(){if(this.b.data.length>0){const c=this.e(this.b.data);this.g(c),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(u=>u())}}k(){if(this.c.error.length>0){for(const c of this.b.error)this.h(c);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function y(n,c){const t=[];let u;for(;(u=n.read())!==null;)t.push(u);return c(t)}e.$$d=y;function L(n,c,t){const u=[];let s;for(;(s=n.read())!==null&&u.length<t;)u.push(s);return s===null&&u.length>0?c(u):{read:()=>{if(u.length>0)return u.shift();if(typeof s<"u"){const l=s;return s=void 0,l}return n.read()}}}e.$_d=L;function C(n,c){return new Promise((t,u)=>{const s=[];m(n,{onData:l=>{c&&s.push(l)},onError:l=>{c?u(l):t(void 0)},onEnd:()=>{t(c?c(s):void 0)}})})}e.$ae=C;function m(n,c,t){n.on("error",u=>{t?.isCancellationRequested||c.onError(u)}),n.on("end",()=>{t?.isCancellationRequested||c.onEnd()}),n.on("data",u=>{t?.isCancellationRequested||c.onData(u)})}e.$be=m;function p(n,c){return new Promise((t,u)=>{const s=new O.$Sc,l=[],a=R=>{if(l.push(R),l.length>c)return s.dispose(),n.pause(),t({stream:n,buffer:l,ended:!1})},d=R=>(s.dispose(),u(R)),k=()=>(s.dispose(),t({stream:n,buffer:l,ended:!0}));s.add((0,O.$Rc)(()=>n.removeListener("error",d))),n.on("error",d),s.add((0,O.$Rc)(()=>n.removeListener("end",k))),n.on("end",k),s.add((0,O.$Rc)(()=>n.removeListener("data",a))),n.on("data",a)})}e.$ce=p;function S(n,c){const t=b(c);return t.end(n),t}e.$de=S;function h(){const n=b(()=>{throw new Error("not supported")});return n.end(),n}e.$ee=h;function f(n){let c=!1;return{read:()=>c?null:(c=!0,n)}}e.$fe=f;function o(n,c,t){const u=b(t);return m(n,{onData:s=>u.write(c.data(s)),onError:s=>u.error(c.error?c.error(s):s),onEnd:()=>u.end()}),u}e.$ge=o;function i(n,c,t){let u=!1;return{read:()=>{const s=c.read();return u?s:(u=!0,s!==null?t([n,s]):n)}}}e.$he=i;function r(n,c,t){let u=!1;const s=b(t);return m(c,{onData:l=>u?s.write(l):(u=!0,s.write(t([n,l]))),onError:l=>s.error(l),onEnd:()=>{u||(u=!0,s.write(n)),s.end()}}),s}e.$ie=r}),define(ke[22],Se([1,0,43,98]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$De=e.$Ce=e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=void 0;const g=typeof Buffer<"u",I=new D.$V(()=>new Uint8Array(256));let A,b;class ${static alloc(E){return g?new $(Buffer.allocUnsafe(E)):new $(new Uint8Array(E))}static wrap(E){return g&&!Buffer.isBuffer(E)&&(E=Buffer.from(E.buffer,E.byteOffset,E.byteLength)),new $(E)}static fromString(E,P){return!(P?.dontUseNodeBuffer||!1)&&g?new $(Buffer.from(E)):(A||(A=new TextEncoder),new $(A.encode(E)))}static fromByteArray(E){const P=$.alloc(E.length);for(let N=0,U=E.length;N<U;N++)P.buffer[N]=E[N];return P}static concat(E,P){if(typeof P>"u"){P=0;for(let F=0,j=E.length;F<j;F++)P+=E[F].byteLength}const N=$.alloc(P);let U=0;for(let F=0,j=E.length;F<j;F++){const T=E[F];N.set(T,U),U+=T.byteLength}return N}constructor(E){this.buffer=E,this.byteLength=this.buffer.byteLength}clone(){const E=$.alloc(this.byteLength);return E.set(this),E}toString(){return g?this.buffer.toString():(b||(b=new TextDecoder),b.decode(this.buffer))}slice(E,P){return new $(this.buffer.subarray(E,P))}set(E,P){if(E instanceof $)this.buffer.set(E.buffer,P);else if(E instanceof Uint8Array)this.buffer.set(E,P);else if(E instanceof ArrayBuffer)this.buffer.set(new Uint8Array(E),P);else if(ArrayBuffer.isView(E))this.buffer.set(new Uint8Array(E.buffer,E.byteOffset,E.byteLength),P);else throw new Error("Unknown argument 'array'")}readUInt32BE(E){return m(this.buffer,E)}writeUInt32BE(E,P){p(this.buffer,E,P)}readUInt32LE(E){return S(this.buffer,E)}writeUInt32LE(E,P){h(this.buffer,E,P)}readUInt8(E){return f(this.buffer,E)}writeUInt8(E,P){o(this.buffer,E,P)}indexOf(E,P=0){return y(this.buffer,E instanceof $?E.buffer:E,P)}}e.$je=$;function y(w,E,P=0){const N=E.byteLength,U=w.byteLength;if(N===0)return 0;if(N===1)return w.indexOf(E[0]);if(N>U-P)return-1;const F=I.value;F.fill(E.length);for(let B=0;B<E.length;B++)F[E[B]]=E.length-B-1;let j=P+E.length-1,T=j,M=-1;for(;j<U;)if(w[j]===E[T]){if(T===0){M=j;break}j--,T--}else j+=Math.max(E.length-T,F[w[j]]),T=E.length-1;return M}e.$ke=y;function L(w,E){return w[E+0]<<0>>>0|w[E+1]<<8>>>0}e.$le=L;function C(w,E,P){w[P+0]=E&255,E=E>>>8,w[P+1]=E&255}e.$me=C;function m(w,E){return w[E]*2**24+w[E+1]*2**16+w[E+2]*2**8+w[E+3]}e.$ne=m;function p(w,E,P){w[P+3]=E,E=E>>>8,w[P+2]=E,E=E>>>8,w[P+1]=E,E=E>>>8,w[P]=E}e.$oe=p;function S(w,E){return w[E+0]<<0>>>0|w[E+1]<<8>>>0|w[E+2]<<16>>>0|w[E+3]<<24>>>0}e.$pe=S;function h(w,E,P){w[P+0]=E&255,E=E>>>8,w[P+1]=E&255,E=E>>>8,w[P+2]=E&255,E=E>>>8,w[P+3]=E&255}e.$qe=h;function f(w,E){return w[E]}e.$re=f;function o(w,E,P){w[P]=E}e.$se=o;function i(w){return O.$$d(w,E=>$.concat(E))}e.$te=i;function r(w){return O.$fe(w)}e.$ue=r;function n(w){return O.$ae(w,E=>$.concat(E))}e.$ve=n;async function c(w){return w.ended?$.concat(w.buffer):$.concat([...w.buffer,await n(w.stream)])}e.$we=c;function t(w){return O.$de(w,E=>$.concat(E))}e.$xe=t;function u(w){return O.$ge(w,{data:E=>typeof E=="string"?$.fromString(E):$.wrap(E)},E=>$.concat(E))}e.$ye=u;function s(w){return O.$0d(E=>$.concat(E),w)}e.$ze=s;function l(w,E){return O.$he(w,E,P=>$.concat(P))}e.$Ae=l;function a(w,E){return O.$ie(w,E,P=>$.concat(P))}e.$Be=a;function d(w){let E=0,P=0,N=0;const U=new Uint8Array(Math.floor(w.length/4*3)),F=T=>{switch(P){case 3:U[N++]=E|T,P=0;break;case 2:U[N++]=E|T>>>2,E=T<<6,P=3;break;case 1:U[N++]=E|T>>>4,E=T<<4,P=2;break;default:E=T<<2,P=1}};for(let T=0;T<w.length;T++){const M=w.charCodeAt(T);if(M>=65&&M<=90)F(M-65);else if(M>=97&&M<=122)F(M-97+26);else if(M>=48&&M<=57)F(M-48+52);else if(M===43||M===45)F(62);else if(M===47||M===95)F(63);else{if(M===61)break;throw new SyntaxError(`Unexpected base64 character ${w[T]}`)}}const j=N;for(;P>0;)F(0);return $.wrap(U).slice(0,j)}e.$Ce=d;const k="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",R="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function v({buffer:w},E=!0,P=!1){const N=P?R:k;let U="";const F=w.byteLength%3;let j=0;for(;j<w.byteLength-F;j+=3){const T=w[j+0],M=w[j+1],B=w[j+2];U+=N[T>>>2],U+=N[(T<<4|M>>>4)&63],U+=N[(M<<2|B>>>6)&63],U+=N[B&63]}if(F===1){const T=w[j+0];U+=N[T>>>2],U+=N[T<<4&63],E&&(U+="==")}else if(F===2){const T=w[j+0],M=w[j+1];U+=N[T>>>2],U+=N[(T<<4|M>>>4)&63],U+=N[M<<2&63],E&&(U+="=")}return U}e.$De=v}),define(ke[12],Se([1,0,162,43]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.GraphemeBreakType=e.$Df=e.$Cf=e.$Bf=e.$Af=e.$zf=e.$yf=e.$xf=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=void 0;function g(Re){return!Re||typeof Re!="string"?!0:Re.trim().length===0}e.$Je=g;const I=/{(\d+)}/g;function A(Re,...Ue){return Ue.length===0?Re:Re.replace(I,function(Ae,Xe){const ne=parseInt(Xe,10);return isNaN(ne)||ne<0||ne>=Ue.length?Ae:Ue[ne]})}e.$Ke=A;const b=/{([^}]+)}/g;function $(Re,Ue){return Object.keys(Ue).length===0?Re:Re.replace(b,(Ae,Xe)=>Ue[Xe]??Ae)}e.$Le=$;function y(Re){return Re.replace(/[<>"'&]/g,Ue=>{switch(Ue){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return Ue})}e.$Me=y;function L(Re){return Re.replace(/[<>&]/g,function(Ue){switch(Ue){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Ue}})}e.$Ne=L;function C(Re){return Re.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Oe=C;function m(Re,Ue){let Ae=0;const Xe=Ue.charCodeAt(0);for(let ne=Re.length-1;ne>=0;ne--)Re.charCodeAt(ne)===Xe&&Ae++;return Ae}e.$Pe=m;function p(Re,Ue,Ae="\u2026"){return Re.length<=Ue?Re:`${Re.substr(0,Ue)}${Ae}`}e.$Qe=p;function S(Re,Ue,Ae="\u2026"){if(Re.length<=Ue)return Re;const Xe=Math.ceil(Ue/2)-Ae.length/2,ne=Math.floor(Ue/2)-Ae.length/2;return`${Re.substr(0,Xe)}${Ae}${Re.substr(Re.length-ne)}`}e.$Re=S;function h(Re,Ue=" "){const Ae=f(Re,Ue);return o(Ae,Ue)}e.$Se=h;function f(Re,Ue){if(!Re||!Ue)return Re;const Ae=Ue.length;if(Ae===0||Re.length===0)return Re;let Xe=0;for(;Re.indexOf(Ue,Xe)===Xe;)Xe=Xe+Ae;return Re.substring(Xe)}e.$Te=f;function o(Re,Ue){if(!Re||!Ue)return Re;const Ae=Ue.length,Xe=Re.length;if(Ae===0||Xe===0)return Re;let ne=Xe,ce=-1;for(;ce=Re.lastIndexOf(Ue,ne-1),!(ce===-1||ce+Ae!==ne);){if(ce===0)return"";ne=ce}return Re.substring(0,ne)}e.$Ue=o;function i(Re){return Re.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$Ve=i;function r(Re){return Re.replace(/\*/g,"")}e.$We=r;function n(Re,Ue,Ae={}){if(!Re)throw new Error("Cannot create regex from empty string");Ue||(Re=C(Re)),Ae.wholeWord&&(/\B/.test(Re.charAt(0))||(Re="\\b"+Re),/\B/.test(Re.charAt(Re.length-1))||(Re=Re+"\\b"));let Xe="";return Ae.global&&(Xe+="g"),Ae.matchCase||(Xe+="i"),Ae.multiline&&(Xe+="m"),Ae.unicode&&(Xe+="u"),new RegExp(Re,Xe)}e.$Xe=n;function c(Re){return Re.source==="^"||Re.source==="^$"||Re.source==="$"||Re.source==="^\\s*$"?!1:!!(Re.exec("")&&Re.lastIndex===0)}e.$Ye=c;function t(Re){return Re.split(/\r\n|\r|\n/)}e.$Ze=t;function u(Re){for(let Ue=0,Ae=Re.length;Ue<Ae;Ue++){const Xe=Re.charCodeAt(Ue);if(Xe!==32&&Xe!==9)return Ue}return-1}e.$1e=u;function s(Re,Ue=0,Ae=Re.length){for(let Xe=Ue;Xe<Ae;Xe++){const ne=Re.charCodeAt(Xe);if(ne!==32&&ne!==9)return Re.substring(Ue,Xe)}return Re.substring(Ue,Ae)}e.$2e=s;function l(Re,Ue=Re.length-1){for(let Ae=Ue;Ae>=0;Ae--){const Xe=Re.charCodeAt(Ae);if(Xe!==32&&Xe!==9)return Ae}return-1}e.$3e=l;function a(Re,Ue,Ae){const Xe=[];let ne=0;for(const ce of Re.matchAll(Ue)){if(Xe.push(Re.slice(ne,ce.index)),ce.index===void 0)throw new Error("match.index should be defined");ne=ce.index+ce[0].length,Xe.push(Ae(ce[0],...ce.slice(1),ce.index,Re,ce.groups))}return Xe.push(Re.slice(ne)),Promise.all(Xe).then(ce=>ce.join(""))}e.$4e=a;function d(Re,Ue){return Re<Ue?-1:Re>Ue?1:0}e.$5e=d;function k(Re,Ue,Ae=0,Xe=Re.length,ne=0,ce=Ue.length){for(;Ae<Xe&&ne<ce;Ae++,ne++){const Ye=Re.charCodeAt(Ae),nt=Ue.charCodeAt(ne);if(Ye<nt)return-1;if(Ye>nt)return 1}const Ie=Xe-Ae,qe=ce-ne;return Ie<qe?-1:Ie>qe?1:0}e.$6e=k;function R(Re,Ue){return v(Re,Ue,0,Re.length,0,Ue.length)}e.$7e=R;function v(Re,Ue,Ae=0,Xe=Re.length,ne=0,ce=Ue.length){for(;Ae<Xe&&ne<ce;Ae++,ne++){let Ye=Re.charCodeAt(Ae),nt=Ue.charCodeAt(ne);if(Ye===nt)continue;if(Ye>=128||nt>=128)return k(Re.toLowerCase(),Ue.toLowerCase(),Ae,Xe,ne,ce);E(Ye)&&(Ye-=32),E(nt)&&(nt-=32);const it=Ye-nt;if(it!==0)return it}const Ie=Xe-Ae,qe=ce-ne;return Ie<qe?-1:Ie>qe?1:0}e.$8e=v;function w(Re){return Re>=48&&Re<=57}e.$9e=w;function E(Re){return Re>=97&&Re<=122}e.$0e=E;function P(Re){return Re>=65&&Re<=90}e.$$e=P;function N(Re,Ue){return Re.length===Ue.length&&v(Re,Ue)===0}e.$_e=N;function U(Re,Ue){const Ae=Ue.length;return Ue.length>Re.length?!1:v(Re,Ue,0,Ae)===0}e.$af=U;function F(Re,Ue){const Ae=Math.min(Re.length,Ue.length);let Xe;for(Xe=0;Xe<Ae;Xe++)if(Re.charCodeAt(Xe)!==Ue.charCodeAt(Xe))return Xe;return Ae}e.$bf=F;function j(Re,Ue){const Ae=Math.min(Re.length,Ue.length);let Xe;const ne=Re.length-1,ce=Ue.length-1;for(Xe=0;Xe<Ae;Xe++)if(Re.charCodeAt(ne-Xe)!==Ue.charCodeAt(ce-Xe))return Xe;return Ae}e.$cf=j;function T(Re){return 55296<=Re&&Re<=56319}e.$df=T;function M(Re){return 56320<=Re&&Re<=57343}e.$ef=M;function B(Re,Ue){return(Re-55296<<10)+(Ue-56320)+65536}e.$ff=B;function Y(Re,Ue,Ae){const Xe=Re.charCodeAt(Ae);if(T(Xe)&&Ae+1<Ue){const ne=Re.charCodeAt(Ae+1);if(M(ne))return B(Xe,ne)}return Xe}e.$gf=Y;function ue(Re,Ue){const Ae=Re.charCodeAt(Ue-1);if(M(Ae)&&Ue>1){const Xe=Re.charCodeAt(Ue-2);if(T(Xe))return B(Xe,Ae)}return Ae}class Z{get offset(){return this.e}constructor(Ue,Ae=0){this.c=Ue,this.d=Ue.length,this.e=Ae}setOffset(Ue){this.e=Ue}prevCodePoint(){const Ue=ue(this.c,this.e);return this.e-=Ue>=65536?2:1,Ue}nextCodePoint(){const Ue=Y(this.c,this.d,this.e);return this.e+=Ue>=65536?2:1,Ue}eol(){return this.e>=this.d}}e.$hf=Z;class J{get offset(){return this.c.offset}constructor(Ue,Ae=0){this.c=new Z(Ue,Ae)}nextGraphemeLength(){const Ue=Le.getInstance(),Ae=this.c,Xe=Ae.offset;let ne=Ue.getGraphemeBreakType(Ae.nextCodePoint());for(;!Ae.eol();){const ce=Ae.offset,Ie=Ue.getGraphemeBreakType(Ae.nextCodePoint());if(ae(ne,Ie)){Ae.setOffset(ce);break}ne=Ie}return Ae.offset-Xe}prevGraphemeLength(){const Ue=Le.getInstance(),Ae=this.c,Xe=Ae.offset;let ne=Ue.getGraphemeBreakType(Ae.prevCodePoint());for(;Ae.offset>0;){const ce=Ae.offset,Ie=Ue.getGraphemeBreakType(Ae.prevCodePoint());if(ae(Ie,ne)){Ae.setOffset(ce);break}ne=Ie}return Xe-Ae.offset}eol(){return this.c.eol()}}e.$if=J;function X(Re,Ue){return new J(Re,Ue).nextGraphemeLength()}e.$jf=X;function he(Re,Ue){return new J(Re,Ue).prevGraphemeLength()}e.$kf=he;function _(Re,Ue){Ue>0&&M(Re.charCodeAt(Ue))&&Ue--;const Ae=Ue+X(Re,Ue);return[Ae-he(Re,Ae),Ae]}e.$lf=_;function we(Re){const Ue=new J(Re);let Ae=0;for(;!Ue.eol();)Ae++,Ue.nextGraphemeLength();return Ae}e.$mf=we;let oe;function K(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function W(Re){return oe||(oe=K()),oe.test(Re)}e.$nf=W;const re=/^[\t\n\r\x20-\x7E]*$/;function ye(Re){return re.test(Re)}e.$of=ye,e.$pf=/[\u2028\u2029]/;function de(Re){return e.$pf.test(Re)}e.$qf=de;function ge(Re){return Re>=11904&&Re<=55215||Re>=63744&&Re<=64255||Re>=65281&&Re<=65374}e.$rf=ge;function x(Re){return Re>=127462&&Re<=127487||Re===8986||Re===8987||Re===9200||Re===9203||Re>=9728&&Re<=10175||Re===11088||Re===11093||Re>=127744&&Re<=128591||Re>=128640&&Re<=128764||Re>=128992&&Re<=129008||Re>=129280&&Re<=129535||Re>=129648&&Re<=129782}e.$sf=x;function te(Re,Ue,Ae=""){const Xe=Re.trimStart();if(Xe.length<Ue)return Xe;const ne=/\b/g;let ce=0;for(;ne.test(Xe)&&!(Xe.length-ne.lastIndex<Ue);)ce=ne.lastIndex,ne.lastIndex+=1;return ce===0?Xe:Ae+Xe.substring(ce).trimStart()}e.$tf=te;const G=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,ie=/\x1b\].*?\x07/g;function fe(Re){return Re&&(Re=Re.replace(G,"").replace(ie,"")),Re}e.$uf=fe,e.$vf=String.fromCharCode(65279);function pe(Re){return!!(Re&&Re.length>0&&Re.charCodeAt(0)===65279)}e.$wf=pe;function Pe(Re){return pe(Re)?Re.substr(1):Re}e.$xf=Pe;function be(Re,Ue){if(!Re||!Ue||Re.length<Ue.length)return!1;const Ae=Ue.length,Xe=Re.toLowerCase();let ne=0,ce=-1;for(;ne<Ae;){const Ie=Xe.indexOf(Ue[ne],ce+1);if(Ie<0)return!1;ce=Ie,ne++}return!0}e.$yf=be;function De(Re,Ue=!1){return Re?(Ue&&(Re=Re.replace(/\\./g,"")),Re.toLowerCase()!==Re):!1}e.$zf=De;function z(Re){return Re.charAt(0).toUpperCase()+Re.slice(1)}e.$Af=z;function Q(Re,Ue=1){if(Ue===0)return"";let Ae=-1;do Ae=Re.indexOf(`
`,Ae+1),Ue--;while(Ue>0&&Ae>=0);return Ae===-1?Re:(Re[Ae-1]==="\r"&&Ae--,Re.substr(0,Ae))}e.$Bf=Q;function ee(Re){return Re=Re%(2*26),Re<26?String.fromCharCode(97+Re):String.fromCharCode(65+Re-26)}e.$Cf=ee;function q(Re){return Le.getInstance().getGraphemeBreakType(Re)}e.$Df=q;function ae(Re,Ue){return Re===0?Ue!==5&&Ue!==7:Re===2&&Ue===3?!1:Re===4||Re===2||Re===3||Ue===4||Ue===2||Ue===3?!0:!(Re===8&&(Ue===8||Ue===9||Ue===11||Ue===12)||(Re===11||Re===9)&&(Ue===9||Ue===10)||(Re===12||Re===10)&&Ue===10||Ue===5||Ue===13||Ue===7||Re===1||Re===13&&Ue===14||Re===6&&Ue===6)}var le;(function(Re){Re[Re.Other=0]="Other",Re[Re.Prepend=1]="Prepend",Re[Re.CR=2]="CR",Re[Re.LF=3]="LF",Re[Re.Control=4]="Control",Re[Re.Extend=5]="Extend",Re[Re.Regional_Indicator=6]="Regional_Indicator",Re[Re.SpacingMark=7]="SpacingMark",Re[Re.L=8]="L",Re[Re.V=9]="V",Re[Re.T=10]="T",Re[Re.LV=11]="LV",Re[Re.LVT=12]="LVT",Re[Re.ZWJ=13]="ZWJ",Re[Re.Extended_Pictographic=14]="Extended_Pictographic"})(le||(e.GraphemeBreakType=le={}));class Le{static{this.c=null}static getInstance(){return Le.c||(Le.c=new Le),Le.c}constructor(){this.d=je()}getGraphemeBreakType(Ue){if(Ue<32)return Ue===10?3:Ue===13?2:4;if(Ue<127)return 0;const Ae=this.d,Xe=Ae.length/3;let ne=1;for(;ne<=Xe;)if(Ue<Ae[3*ne])ne=2*ne;else if(Ue>Ae[3*ne+1])ne=2*ne+1;else return Ae[3*ne+2];return 0}}function je(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function He(Re,Ue){if(Re===0)return 0;const Ae=Je(Re,Ue);if(Ae!==void 0)return Ae;const Xe=new Z(Ue,Re);return Xe.prevCodePoint(),Xe.offset}e.$Ef=He;function Je(Re,Ue){const Ae=new Z(Ue,Re);let Xe=Ae.prevCodePoint();for(;_e(Xe)||Xe===65039||Xe===8419;){if(Ae.offset===0)return;Xe=Ae.prevCodePoint()}if(!x(Xe))return;let ne=Ae.offset;return ne>0&&Ae.prevCodePoint()===8205&&(ne=Ae.offset),ne}function _e(Re){return 127995<=Re&&Re<=127999}var ct;(function(Re){Re[Re.zwj=8205]="zwj",Re[Re.emojiVariantSelector=65039]="emojiVariantSelector",Re[Re.enclosingKeyCap=8419]="enclosingKeyCap"})(ct||(ct={})),e.$Ff="\xA0";class ot{static{this.c=new O.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new D.$Fe(Ue=>{function Ae(it){const Oe=new Map;for(let vt=0;vt<it.length;vt+=2)Oe.set(it[vt],it[vt+1]);return Oe}function Xe(it,Oe){const vt=new Map(it);for(const[St,Nt]of Oe)vt.set(St,Nt);return vt}function ne(it,Oe){if(!it)return Oe;const vt=new Map;for(const[St,Nt]of it)Oe.has(St)&&vt.set(St,Nt);return vt}const ce=this.c.value;let Ie=Ue.filter(it=>!it.startsWith("_")&&it in ce);Ie.length===0&&(Ie=["_default"]);let qe;for(const it of Ie){const Oe=Ae(ce[it]);qe=ne(qe,Oe)}const Ye=Ae(ce._common),nt=Xe(Ye,qe);return new ot(nt)})}static getInstance(Ue){return ot.d.get(Array.from(Ue))}static{this.e=new O.$V(()=>Object.keys(ot.c.value).filter(Ue=>!Ue.startsWith("_")))}static getLocales(){return ot.e.value}constructor(Ue){this.f=Ue}isAmbiguous(Ue){return this.f.has(Ue)}getPrimaryConfusable(Ue){return this.f.get(Ue)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$Gf=ot;class rt{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(rt.c())),this.d}static isInvisibleCharacter(Ue){return rt.e().has(Ue)}static get codePoints(){return rt.e()}}e.$Hf=rt}),define(ke[123],Se([1,0,28,161,12]),function(me,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9j=e.$8j=e.$7j=e.$6j=e.FuzzyScore=e.$5j=e.$4j=e.$3j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.or=void 0;function I(...be){return function(De,z){for(let Q=0,ee=be.length;Q<ee;Q++){const q=be[Q](De,z);if(q)return q}return null}}e.or=I,e.$Tj=A.bind(void 0,!1),e.$Uj=A.bind(void 0,!0);function A(be,De,z){if(!z||z.length<De.length)return null;let Q;return be?Q=g.$af(z,De):Q=z.indexOf(De)===0,Q?De.length>0?[{start:0,end:De.length}]:[]:null}function b(be,De){const z=De.toLowerCase().indexOf(be.toLowerCase());return z===-1?null:[{start:z,end:z+be.length}]}e.$Vj=b;function $(be,De){return y(be.toLowerCase(),De.toLowerCase(),0,0)}e.$Wj=$;function y(be,De,z,Q){if(z===be.length)return[];if(Q===De.length)return null;if(be[z]===De[Q]){let ee=null;return(ee=y(be,De,z+1,Q+1))?n({start:Q,end:Q+1},ee):null}return y(be,De,z,Q+1)}function L(be){return 97<=be&&be<=122}function C(be){return 65<=be&&be<=90}e.$Xj=C;function m(be){return 48<=be&&be<=57}function p(be){return be===32||be===9||be===10||be===13}const S=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(be=>S.add(be.charCodeAt(0)));function h(be){return p(be)||S.has(be)}function f(be,De){return be===De||h(be)&&h(De)}const o=new Map;function i(be){if(o.has(be))return o.get(be);let De;const z=(0,O.$Rj)(be);return z&&(De=z),o.set(be,De),De}function r(be){return L(be)||C(be)||m(be)}function n(be,De){return De.length===0?De=[be]:be.end===De[0].start?De[0].start=be.start:De.unshift(be),De}function c(be,De){for(let z=De;z<be.length;z++){const Q=be.charCodeAt(z);if(C(Q)||m(Q)||z>0&&!r(be.charCodeAt(z-1)))return z}return be.length}function t(be,De,z,Q){if(z===be.length)return[];if(Q===De.length)return null;if(be[z]!==De[Q].toLowerCase())return null;{let ee=null,q=Q+1;for(ee=t(be,De,z+1,Q+1);!ee&&(q=c(De,q))<De.length;)ee=t(be,De,z+1,q),q++;return ee===null?null:n({start:Q,end:Q+1},ee)}}function u(be){let De=0,z=0,Q=0,ee=0,q=0;for(let He=0;He<be.length;He++)q=be.charCodeAt(He),C(q)&&De++,L(q)&&z++,r(q)&&Q++,m(q)&&ee++;const ae=De/be.length,le=z/be.length,Le=Q/be.length,je=ee/be.length;return{upperPercent:ae,lowerPercent:le,alphaPercent:Le,numericPercent:je}}function s(be){const{upperPercent:De,lowerPercent:z}=be;return z===0&&De>.6}function l(be){const{upperPercent:De,lowerPercent:z,alphaPercent:Q,numericPercent:ee}=be;return z>.2&&De<.8&&Q>.6&&ee<.2}function a(be){let De=0,z=0,Q=0,ee=0;for(let q=0;q<be.length;q++)Q=be.charCodeAt(q),C(Q)&&De++,L(Q)&&z++,p(Q)&&ee++;return(De===0||z===0)&&ee===0?be.length<=30:De<=5}function d(be,De){if(!De||(De=De.trim(),De.length===0)||!a(be)||De.length>60)return null;const z=u(De);if(!l(z)){if(!s(z))return null;De=De.toLowerCase()}let Q=null,ee=0;for(be=be.toLowerCase();ee<De.length&&(Q=t(be,De,0,ee))===null;)ee=c(De,ee+1);return Q}e.$Yj=d;function k(be,De,z=!1){if(!De||De.length===0)return null;let Q=null,ee=0;for(be=be.toLowerCase(),De=De.toLowerCase();ee<De.length&&(Q=R(be,De,0,ee,z),Q===null);)ee=v(De,ee+1);return Q}e.$Zj=k;function R(be,De,z,Q,ee){let q=0;if(z===be.length)return[];if(Q===De.length)return null;if(!f(be.charCodeAt(z),De.charCodeAt(Q))){const Le=i(be.charCodeAt(z));if(!Le)return null;for(let je=0;je<Le.length;je++)if(!f(Le[je],De.charCodeAt(Q+je)))return null;q+=Le.length-1}let ae=null,le=Q+q+1;if(ae=R(be,De,z+1,le,ee),!ee)for(;!ae&&(le=v(De,le))<De.length;)ae=R(be,De,z+1,le,ee),le++;if(!ae)return null;if(be.charCodeAt(z)!==De.charCodeAt(Q)){const Le=i(be.charCodeAt(z));if(!Le)return ae;for(let je=0;je<Le.length;je++)if(Le[je]!==De.charCodeAt(Q+je))return ae}return n({start:Q,end:Q+q+1},ae)}function v(be,De){for(let z=De;z<be.length;z++)if(h(be.charCodeAt(z))||z>0&&h(be.charCodeAt(z-1)))return z;return be.length}const w=I(e.$Uj,d,b),E=I(e.$Uj,d,$),P=new D.$Dc(1e4);function N(be,De,z=!1){if(typeof be!="string"||typeof De!="string")return null;let Q=P.get(be);Q||(Q=new RegExp(g.$Ve(be),"i"),P.set(be,Q));const ee=Q.exec(De);return ee?[{start:ee.index,end:ee.index+ee[0].length}]:z?E(be,De):w(be,De)}e.$1j=N;function U(be,De){const z=x(be,be.toLowerCase(),0,De,De.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return z?j(z):null}e.$2j=U;function F(be,De,z,Q,ee,q){const ae=Math.min(13,be.length);for(;z<ae;z++){const le=x(be,De,z,Q,ee,q,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(le)return le}return[0,q]}e.$3j=F;function j(be){if(typeof be>"u")return[];const De=[],z=be[1];for(let Q=be.length-1;Q>1;Q--){const ee=be[Q]+z,q=De[De.length-1];q&&q.end===ee?q.end=ee+1:De.push({start:ee,end:ee+1})}return De}e.$4j=j;const T=128;function M(){const be=[],De=[];for(let z=0;z<=T;z++)De[z]=0;for(let z=0;z<=T;z++)be.push(De.slice(0));return be}function B(be){const De=[];for(let z=0;z<=be;z++)De[z]=0;return De}const Y=B(2*T),ue=B(2*T),Z=M(),J=M(),X=M(),he=!1;function _(be,De,z,Q,ee){function q(le,Le,je=" "){for(;le.length<Le;)le=je+le;return le}let ae=` |   |${Q.split("").map(le=>q(le,3)).join("|")}
`;for(let le=0;le<=z;le++)le===0?ae+=" |":ae+=`${De[le-1]}|`,ae+=be[le].slice(0,ee+1).map(Le=>q(Le.toString(),3)).join("|")+`
`;return ae}function we(be,De,z,Q){be=be.substr(De),z=z.substr(Q),console.log(_(J,be,be.length,z,z.length)),console.log(_(X,be,be.length,z,z.length)),console.log(_(Z,be,be.length,z,z.length))}function oe(be,De){if(De<0||De>=be.length)return!1;const z=be.codePointAt(De);switch(z){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!g.$sf(z)}}function K(be,De){if(De<0||De>=be.length)return!1;switch(be.charCodeAt(De)){case 32:case 9:return!0;default:return!1}}function W(be,De,z){return De[be]!==z[be]}function re(be,De,z,Q,ee,q,ae=!1){for(;De<z&&ee<q;)be[De]===Q[ee]&&(ae&&(Y[De]=ee),De+=1),ee+=1;return De===z}e.$5j=re;var ye;(function(be){be[be.Diag=1]="Diag",be[be.Left=2]="Left",be[be.LeftLeft=3]="LeftLeft"})(ye||(ye={}));var de;(function(be){be.Default=[-100,0];function De(z){return!z||z.length===2&&z[0]===-100&&z[1]===0}be.isDefault=De})(de||(e.FuzzyScore=de={}));class ge{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(De,z){this.firstMatchCanBeWeak=De,this.boostFullMatch=z}}e.$6j=ge;function x(be,De,z,Q,ee,q,ae=ge.default){const le=be.length>T?T:be.length,Le=Q.length>T?T:Q.length;if(z>=le||q>=Le||le-z>Le-q||!re(De,z,le,ee,q,Le,!0))return;te(le,Le,z,q,De,ee);let je=1,He=1,Je=z,_e=q;const ct=[!1];for(je=1,Je=z;Je<le;je++,Je++){const Ae=Y[Je],Xe=ue[Je],ne=Je+1<le?ue[Je+1]:Le;for(He=Ae-q+1,_e=Ae;_e<ne;He++,_e++){let ce=Number.MIN_SAFE_INTEGER,Ie=!1;_e<=Xe&&(ce=G(be,De,Je,z,Q,ee,_e,Le,q,Z[je-1][He-1]===0,ct));let qe=0;ce!==Number.MAX_SAFE_INTEGER&&(Ie=!0,qe=ce+J[je-1][He-1]);const Ye=_e>Ae,nt=Ye?J[je][He-1]+(Z[je][He-1]>0?-5:0):0,it=_e>Ae+1&&Z[je][He-1]>0,Oe=it?J[je][He-2]+(Z[je][He-2]>0?-5:0):0;if(it&&(!Ye||Oe>=nt)&&(!Ie||Oe>=qe))J[je][He]=Oe,X[je][He]=3,Z[je][He]=0;else if(Ye&&(!Ie||nt>=qe))J[je][He]=nt,X[je][He]=2,Z[je][He]=0;else if(Ie)J[je][He]=qe,X[je][He]=1,Z[je][He]=Z[je-1][He-1]+1;else throw new Error("not possible")}}if(he&&we(be,z,Q,q),!ct[0]&&!ae.firstMatchCanBeWeak)return;je--,He--;const ot=[J[je][He],q];let rt=0,Re=0;for(;je>=1;){let Ae=He;do{const Xe=X[je][Ae];if(Xe===3)Ae=Ae-2;else if(Xe===2)Ae=Ae-1;else break}while(Ae>=1);rt>1&&De[z+je-1]===ee[q+He-1]&&!W(Ae+q-1,Q,ee)&&rt+1>Z[je][Ae]&&(Ae=He),Ae===He?rt++:rt=1,Re||(Re=Ae),je--,He=Ae-1,ot.push(He)}Le===le&&ae.boostFullMatch&&(ot[0]+=2);const Ue=Re-le;return ot[0]-=Ue,ot}e.$7j=x;function te(be,De,z,Q,ee,q){let ae=be-1,le=De-1;for(;ae>=z&&le>=Q;)ee[ae]===q[le]&&(ue[ae]=le,ae--),le--}function G(be,De,z,Q,ee,q,ae,le,Le,je,He){if(De[z]!==q[ae])return Number.MIN_SAFE_INTEGER;let Je=1,_e=!1;return ae===z-Q?Je=be[z]===ee[ae]?7:5:W(ae,ee,q)&&(ae===0||!W(ae-1,ee,q))?(Je=be[z]===ee[ae]?7:5,_e=!0):oe(q,ae)&&(ae===0||!oe(q,ae-1))?Je=5:(oe(q,ae-1)||K(q,ae-1))&&(Je=5,_e=!0),Je>1&&z===Q&&(He[0]=!0),_e||(_e=W(ae,ee,q)||oe(q,ae-1)||K(q,ae-1)),z===Q?ae>Le&&(Je-=_e?3:5):je?Je+=_e?2:0:Je+=_e?0:1,ae+1===le&&(Je-=_e?3:5),Je}function ie(be,De,z,Q,ee,q,ae){return pe(be,De,z,Q,ee,q,!0,ae)}e.$8j=ie;function fe(be,De,z,Q,ee,q,ae){return pe(be,De,z,Q,ee,q,!1,ae)}e.$9j=fe;function pe(be,De,z,Q,ee,q,ae,le){let Le=x(be,De,z,Q,ee,q,le);if(Le&&!ae)return Le;if(be.length>=3){const je=Math.min(7,be.length-1);for(let He=z+1;He<je;He++){const Je=Pe(be,He);if(Je){const _e=x(Je,Je.toLowerCase(),z,Q,ee,q,le);_e&&(_e[0]-=3,(!Le||_e[0]>Le[0])&&(Le=_e))}}}return Le}function Pe(be,De){if(De+1>=be.length)return;const z=be[De],Q=be[De+1];if(z!==Q)return be.slice(0,De)+Q+z+be.slice(De+2)}}),define(ke[54],Se([1,0,12]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=void 0;function O(o){return g(o,0)}e.$Ti=O;function g(o,i){switch(typeof o){case"object":return o===null?I(349,i):Array.isArray(o)?$(o,i):y(o,i);case"string":return b(o,i);case"boolean":return A(o,i);case"number":return I(o,i);case"undefined":return I(937,i);default:return I(617,i)}}e.$Ui=g;function I(o,i){return(i<<5)-i+o|0}e.$Vi=I;function A(o,i){return I(o?433:863,i)}function b(o,i){i=I(149417,i);for(let r=0,n=o.length;r<n;r++)i=I(o.charCodeAt(r),i);return i}e.$Wi=b;function $(o,i){return i=I(104579,i),o.reduce((r,n)=>g(n,r),i)}function y(o,i){return i=I(181387,i),Object.keys(o).sort().reduce((r,n)=>(r=b(n,r),g(o[n],r)),i)}class L{constructor(){this.g=0}get value(){return this.g}hash(i){return this.g=g(i,this.g),this.g}}e.$Xi=L;var C;(function(o){o[o.BLOCK_SIZE=64]="BLOCK_SIZE",o[o.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(C||(C={}));function m(o,i,r=32){const n=r-i,c=~((1<<n)-1);return(o<<i|(c&o)>>>n)>>>0}function p(o,i=0,r=o.byteLength,n=0){for(let c=0;c<r;c++)o[i+c]=n}function S(o,i,r="0"){for(;o.length<i;)o=r+o;return o}function h(o,i=32){return o instanceof ArrayBuffer?Array.from(new Uint8Array(o)).map(r=>r.toString(16).padStart(2,"0")).join(""):S((o>>>0).toString(16),i/4)}e.$Yi=h;class f{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(i){const r=i.length;if(r===0)return;const n=this.p;let c=this.r,t=this.u,u,s;for(t!==0?(u=t,s=-1,t=0):(u=i.charCodeAt(0),s=0);;){let l=u;if(D.$df(u))if(s+1<r){const a=i.charCodeAt(s+1);D.$ef(a)?(s++,l=D.$ff(u,a)):l=65533}else{t=u;break}else D.$ef(u)&&(l=65533);if(c=this.w(n,c,l),s++,s<r)u=i.charCodeAt(s);else break}this.r=c,this.u=t}w(i,r,n){return n<128?i[r++]=n:n<2048?(i[r++]=192|(n&1984)>>>6,i[r++]=128|(n&63)>>>0):n<65536?(i[r++]=224|(n&61440)>>>12,i[r++]=128|(n&4032)>>>6,i[r++]=128|(n&63)>>>0):(i[r++]=240|(n&1835008)>>>18,i[r++]=128|(n&258048)>>>12,i[r++]=128|(n&4032)>>>6,i[r++]=128|(n&63)>>>0),r>=64&&(this.y(),r-=64,this.t+=64,i[0]=i[64+0],i[1]=i[64+1],i[2]=i[64+2]),r}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),h(this.h)+h(this.l)+h(this.m)+h(this.n)+h(this.o)}x(){this.p[this.r++]=128,p(this.p,this.r),this.r>56&&(this.y(),p(this.p));const i=8*this.t;this.q.setUint32(56,Math.floor(i/4294967296),!1),this.q.setUint32(60,i%4294967296,!1),this.y()}y(){const i=f.g,r=this.q;for(let k=0;k<64;k+=4)i.setUint32(k,r.getUint32(k,!1),!1);for(let k=64;k<320;k+=4)i.setUint32(k,m(i.getUint32(k-12,!1)^i.getUint32(k-32,!1)^i.getUint32(k-56,!1)^i.getUint32(k-64,!1),1),!1);let n=this.h,c=this.l,t=this.m,u=this.n,s=this.o,l,a,d;for(let k=0;k<80;k++)k<20?(l=c&t|~c&u,a=1518500249):k<40?(l=c^t^u,a=1859775393):k<60?(l=c&t|c&u|t&u,a=2400959708):(l=c^t^u,a=3395469782),d=m(n,5)+l+s+a+i.getUint32(k*4,!1)&4294967295,s=u,u=t,t=m(c,30),c=n,n=d;this.h=this.h+n&4294967295,this.l=this.l+c&4294967295,this.m=this.m+t&4294967295,this.n=this.n+u&4294967295,this.o=this.o+s&4294967295}}e.$Zi=f}),define(ke[39],Se([1,0,12]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var O;(function(g){g[g.Ignore=0]="Ignore",g[g.Info=1]="Info",g[g.Warning=2]="Warning",g[g.Error=3]="Error"})(O||(O={})),function(g){const I="error",A="warning",b="warn",$="info",y="ignore";function L(m){return m?D.$_e(I,m)?g.Error:D.$_e(A,m)||D.$_e(b,m)?g.Warning:D.$_e($,m)?g.Info:g.Ignore:g.Ignore}g.fromValue=L;function C(m){switch(m){case g.Error:return I;case g.Warning:return A;case g.Info:return $;default:return y}}g.toString=C}(O||(O={})),e.default=O}),define(ke[163],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sd=void 0,e.$Sd=Symbol("MicrotaskDelay")}),define(ke[77],Se([1,0,19,12]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=void 0;class g{constructor(){this.b="",this.c=0}reset(p){return this.b=p,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(p){const S=p.charCodeAt(0),h=this.b.charCodeAt(this.c);return S-h}value(){return this.b[this.c]}}e.$8h=g;class I{constructor(p=!0){this.e=p}reset(p){return this.b=p,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let p=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(p)this.c++;else break;else p=!1;return this}cmp(p){return this.e?(0,O.$6e)(p,this.b,0,p.length,this.c,this.d):(0,O.$8e)(p,this.b,0,p.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$9h=I;class A{constructor(p=!0,S=!0){this.f=p,this.g=S}reset(p){this.d=0,this.e=0,this.b=p,this.c=p.length;for(let S=p.length-1;S>=0;S--,this.c--){const h=this.b.charCodeAt(S);if(!(h===47||this.f&&h===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let p=!0;for(;this.e<this.c;this.e++){const S=this.b.charCodeAt(this.e);if(S===47||this.f&&S===92)if(p)this.d++;else break;else p=!1}return this}cmp(p){return this.g?(0,O.$6e)(p,this.b,0,p.length,this.d,this.e):(0,O.$8e)(p,this.b,0,p.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$0h=A;var b;(function(m){m[m.Scheme=1]="Scheme",m[m.Authority=2]="Authority",m[m.Path=3]="Path",m[m.Query=4]="Query",m[m.Fragment=5]="Fragment"})(b||(b={}));class ${constructor(p,S){this.f=p,this.g=S,this.d=[],this.e=0}reset(p){return this.c=p,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new A(!1,!this.f(p)),this.b.reset(p.path),this.b.value()&&this.d.push(3)),this.g(p)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(p){if(this.d[this.e]===1)return(0,O.$7e)(p,this.c.scheme);if(this.d[this.e]===2)return(0,O.$7e)(p,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(p);if(this.d[this.e]===4)return(0,O.$5e)(p,this.c.query);if(this.d[this.e]===5)return(0,O.$5e)(p,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$$h=$;class y{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const p=this.right;return this.right=p.left,p.left=this,this.updateHeight(),p.updateHeight(),p}rotateRight(){const p=this.left;return this.left=p.right,p.right=this,this.updateHeight(),p.updateHeight(),p}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var L;(function(m){m[m.Left=-1]="Left",m[m.Mid=0]="Mid",m[m.Right=1]="Right"})(L||(L={}));class C{static forUris(p=()=>!1,S=()=>!1){return new C(new $(p,S))}static forPaths(p=!1){return new C(new A(void 0,!p))}static forStrings(){return new C(new g)}static forConfigKeys(){return new C(new I)}constructor(p){this.b=p}clear(){this.c=void 0}fill(p,S){if(S){const h=S.slice(0);(0,D.$Xb)(h);for(const f of h)this.set(f,p)}else{const h=p.slice(0);(0,D.$Xb)(h);for(const f of h)this.set(f[0],f[1])}}set(p,S){const h=this.b.reset(p);let f;this.c||(this.c=new y,this.c.segment=h.value());const o=[];for(f=this.c;;){const r=h.cmp(f.segment);if(r>0)f.left||(f.left=new y,f.left.segment=h.value()),o.push([-1,f]),f=f.left;else if(r<0)f.right||(f.right=new y,f.right.segment=h.value()),o.push([1,f]),f=f.right;else if(h.hasNext())h.next(),f.mid||(f.mid=new y,f.mid.segment=h.value()),o.push([0,f]),f=f.mid;else break}const i=f.value;f.value=S,f.key=p;for(let r=o.length-1;r>=0;r--){const n=o[r][1];n.updateHeight();const c=n.balanceFactor();if(c<-1||c>1){const t=o[r][0],u=o[r+1][0];if(t===1&&u===1)o[r][1]=n.rotateLeft();else if(t===-1&&u===-1)o[r][1]=n.rotateRight();else if(t===1&&u===-1)n.right=o[r+1][1]=o[r+1][1].rotateRight(),o[r][1]=n.rotateLeft();else if(t===-1&&u===1)n.left=o[r+1][1]=o[r+1][1].rotateLeft(),o[r][1]=n.rotateRight();else throw new Error;if(r>0)switch(o[r-1][0]){case-1:o[r-1][1].left=o[r][1];break;case 1:o[r-1][1].right=o[r][1];break;case 0:o[r-1][1].mid=o[r][1];break}else this.c=o[0][1]}}return i}get(p){return this.d(p)?.value}d(p){const S=this.b.reset(p);let h=this.c;for(;h;){const f=S.cmp(h.segment);if(f>0)h=h.left;else if(f<0)h=h.right;else if(S.hasNext())S.next(),h=h.mid;else break}return h}has(p){const S=this.d(p);return!(S?.value===void 0&&S?.mid===void 0)}delete(p){return this.e(p,!1)}deleteSuperstr(p){return this.e(p,!0)}e(p,S){const h=this.b.reset(p),f=[];let o=this.c;for(;o;){const i=h.cmp(o.segment);if(i>0)f.push([-1,o]),o=o.left;else if(i<0)f.push([1,o]),o=o.right;else if(h.hasNext())h.next(),f.push([0,o]),o=o.mid;else break}if(o){if(S?(o.left=void 0,o.mid=void 0,o.right=void 0,o.height=1):(o.key=void 0,o.value=void 0),!o.mid&&!o.value)if(o.left&&o.right){const i=this.f(o.right);if(i.key){const{key:r,value:n,segment:c}=i;this.e(i.key,!1),o.key=r,o.value=n,o.segment=c}}else{const i=o.left??o.right;if(f.length>0){const[r,n]=f[f.length-1];switch(r){case-1:n.left=i;break;case 0:n.mid=i;break;case 1:n.right=i;break}}else this.c=i}for(let i=f.length-1;i>=0;i--){const r=f[i][1];r.updateHeight();const n=r.balanceFactor();if(n>1?(r.right.balanceFactor()>=0||(r.right=r.right.rotateRight()),f[i][1]=r.rotateLeft()):n<-1&&(r.left.balanceFactor()<=0||(r.left=r.left.rotateLeft()),f[i][1]=r.rotateRight()),i>0)switch(f[i-1][0]){case-1:f[i-1][1].left=f[i][1];break;case 1:f[i-1][1].right=f[i][1];break;case 0:f[i-1][1].mid=f[i][1];break}else this.c=f[0][1]}}}f(p){for(;p.left;)p=p.left;return p}findSubstr(p){const S=this.b.reset(p);let h=this.c,f;for(;h;){const o=S.cmp(h.segment);if(o>0)h=h.left;else if(o<0)h=h.right;else if(S.hasNext())S.next(),f=h.value||f,h=h.mid;else break}return h&&h.value||f}findSuperstr(p){return this.g(p,!1)}g(p,S){const h=this.b.reset(p);let f=this.c;for(;f;){const o=h.cmp(f.segment);if(o>0)f=f.left;else if(o<0)f=f.right;else if(h.hasNext())h.next(),f=f.mid;else return f.mid?this.h(f.mid):S?f.value:void 0}}hasElementOrSubtree(p){return this.g(p,!0)!==void 0}forEach(p){for(const[S,h]of this)p(h,S)}*[Symbol.iterator](){yield*this.h(this.c)}h(p){const S=[];return this.j(p,S),S[Symbol.iterator]()}j(p,S){p&&(p.left&&this.j(p.left,S),p.value&&S.push([p.key,p.value]),p.mid&&this.j(p.mid,S),p.right&&this.j(p.right,S))}_isBalanced(){const p=S=>{if(!S)return!0;const h=S.balanceFactor();return h<-1||h>1?!1:p(S.left)&&p(S.right)};return p(this.c)}}e.$_h=C}),define(ke[18],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=void 0;function D(c){return typeof c=="string"}e.$If=D;function O(c){return Array.isArray(c)&&c.every(t=>D(t))}e.$Jf=O;function g(c){return typeof c=="object"&&c!==null&&!Array.isArray(c)&&!(c instanceof RegExp)&&!(c instanceof Date)}e.$Kf=g;function I(c){const t=Object.getPrototypeOf(Uint8Array);return typeof c=="object"&&c instanceof t}e.$Lf=I;function A(c){return typeof c=="number"&&!isNaN(c)}e.$Mf=A;function b(c){return!!c&&typeof c[Symbol.iterator]=="function"}e.$Nf=b;function $(c){return c===!0||c===!1}e.$Of=$;function y(c){return typeof c>"u"}e.$Pf=y;function L(c){return!C(c)}e.$Qf=L;function C(c){return y(c)||c===null}e.$Rf=C;function m(c,t){if(!c)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.$Sf=m;function p(c){if(C(c))throw new Error("Assertion Failed: argument is undefined or null");return c}e.$Tf=p;function S(...c){const t=[];for(let u=0;u<c.length;u++){const s=c[u];if(C(s))throw new Error(`Assertion Failed: argument at index ${u} is undefined or null`);t.push(s)}return t}e.$Uf=S;const h=Object.prototype.hasOwnProperty;function f(c){if(!g(c))return!1;for(const t in c)if(h.call(c,t))return!1;return!0}e.$Vf=f;function o(c){return typeof c=="function"}e.$Wf=o;function i(...c){return c.length>0&&c.every(o)}e.$Xf=i;function r(c,t){const u=Math.min(c.length,t.length);for(let s=0;s<u;s++)n(c[s],t[s])}e.$Yf=r;function n(c,t){if(D(t)){if(typeof c!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(o(t)){try{if(c instanceof t)return}catch{}if(!C(c)&&c.constructor===t||t.length===1&&t.call(void 0,c)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$Zf=n}),define(ke[78],Se([1,0,18]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_j=e.$$j=e.$0j=void 0;const O=Object.create(null);function g(b,$){if((0,D.$If)($)){const y=O[$];if(y===void 0)throw new Error(`${b} references an unknown codicon: ${$}`);$=y}return O[b]=$,{id:b}}function I(){return O}e.$0j=I;function A(){return Object.values(e.$_j)}e.$$j=A,e.$_j={add:g("add",6e4),plus:g("plus",6e4),gistNew:g("gist-new",6e4),repoCreate:g("repo-create",6e4),lightbulb:g("lightbulb",60001),lightBulb:g("light-bulb",60001),repo:g("repo",60002),repoDelete:g("repo-delete",60002),gistFork:g("gist-fork",60003),repoForked:g("repo-forked",60003),gitPullRequest:g("git-pull-request",60004),gitPullRequestAbandoned:g("git-pull-request-abandoned",60004),recordKeys:g("record-keys",60005),keyboard:g("keyboard",60005),tag:g("tag",60006),tagAdd:g("tag-add",60006),tagRemove:g("tag-remove",60006),gitPullRequestLabel:g("git-pull-request-label",60006),person:g("person",60007),personFollow:g("person-follow",60007),personOutline:g("person-outline",60007),personFilled:g("person-filled",60007),gitBranch:g("git-branch",60008),gitBranchCreate:g("git-branch-create",60008),gitBranchDelete:g("git-branch-delete",60008),sourceControl:g("source-control",60008),mirror:g("mirror",60009),mirrorPublic:g("mirror-public",60009),star:g("star",60010),starAdd:g("star-add",60010),starDelete:g("star-delete",60010),starEmpty:g("star-empty",60010),comment:g("comment",60011),commentAdd:g("comment-add",60011),alert:g("alert",60012),warning:g("warning",60012),search:g("search",60013),searchSave:g("search-save",60013),logOut:g("log-out",60014),signOut:g("sign-out",60014),logIn:g("log-in",60015),signIn:g("sign-in",60015),eye:g("eye",60016),eyeUnwatch:g("eye-unwatch",60016),eyeWatch:g("eye-watch",60016),circleFilled:g("circle-filled",60017),primitiveDot:g("primitive-dot",60017),closeDirty:g("close-dirty",60017),debugBreakpoint:g("debug-breakpoint",60017),debugBreakpointDisabled:g("debug-breakpoint-disabled",60017),debugBreakpointPending:g("debug-breakpoint-pending",60377),debugHint:g("debug-hint",60017),primitiveSquare:g("primitive-square",60018),edit:g("edit",60019),pencil:g("pencil",60019),info:g("info",60020),issueOpened:g("issue-opened",60020),gistPrivate:g("gist-private",60021),gitForkPrivate:g("git-fork-private",60021),lock:g("lock",60021),mirrorPrivate:g("mirror-private",60021),close:g("close",60022),removeClose:g("remove-close",60022),x:g("x",60022),repoSync:g("repo-sync",60023),sync:g("sync",60023),clone:g("clone",60024),desktopDownload:g("desktop-download",60024),beaker:g("beaker",60025),microscope:g("microscope",60025),vm:g("vm",60026),deviceDesktop:g("device-desktop",60026),file:g("file",60027),fileText:g("file-text",60027),more:g("more",60028),ellipsis:g("ellipsis",60028),kebabHorizontal:g("kebab-horizontal",60028),mailReply:g("mail-reply",60029),reply:g("reply",60029),organization:g("organization",60030),organizationFilled:g("organization-filled",60030),organizationOutline:g("organization-outline",60030),newFile:g("new-file",60031),fileAdd:g("file-add",60031),newFolder:g("new-folder",60032),fileDirectoryCreate:g("file-directory-create",60032),trash:g("trash",60033),trashcan:g("trashcan",60033),history:g("history",60034),clock:g("clock",60034),folder:g("folder",60035),fileDirectory:g("file-directory",60035),symbolFolder:g("symbol-folder",60035),logoGithub:g("logo-github",60036),markGithub:g("mark-github",60036),github:g("github",60036),terminal:g("terminal",60037),console:g("console",60037),repl:g("repl",60037),zap:g("zap",60038),symbolEvent:g("symbol-event",60038),error:g("error",60039),stop:g("stop",60039),variable:g("variable",60040),symbolVariable:g("symbol-variable",60040),array:g("array",60042),symbolArray:g("symbol-array",60042),symbolModule:g("symbol-module",60043),symbolPackage:g("symbol-package",60043),symbolNamespace:g("symbol-namespace",60043),symbolObject:g("symbol-object",60043),symbolMethod:g("symbol-method",60044),symbolFunction:g("symbol-function",60044),symbolConstructor:g("symbol-constructor",60044),symbolBoolean:g("symbol-boolean",60047),symbolNull:g("symbol-null",60047),symbolNumeric:g("symbol-numeric",60048),symbolNumber:g("symbol-number",60048),symbolStructure:g("symbol-structure",60049),symbolStruct:g("symbol-struct",60049),symbolParameter:g("symbol-parameter",60050),symbolTypeParameter:g("symbol-type-parameter",60050),symbolKey:g("symbol-key",60051),symbolText:g("symbol-text",60051),symbolReference:g("symbol-reference",60052),goToFile:g("go-to-file",60052),symbolEnum:g("symbol-enum",60053),symbolValue:g("symbol-value",60053),symbolRuler:g("symbol-ruler",60054),symbolUnit:g("symbol-unit",60054),activateBreakpoints:g("activate-breakpoints",60055),archive:g("archive",60056),arrowBoth:g("arrow-both",60057),arrowDown:g("arrow-down",60058),arrowLeft:g("arrow-left",60059),arrowRight:g("arrow-right",60060),arrowSmallDown:g("arrow-small-down",60061),arrowSmallLeft:g("arrow-small-left",60062),arrowSmallRight:g("arrow-small-right",60063),arrowSmallUp:g("arrow-small-up",60064),arrowUp:g("arrow-up",60065),bell:g("bell",60066),bold:g("bold",60067),book:g("book",60068),bookmark:g("bookmark",60069),debugBreakpointConditionalUnverified:g("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:g("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:g("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:g("debug-breakpoint-data-unverified",60072),debugBreakpointData:g("debug-breakpoint-data",60073),debugBreakpointDataDisabled:g("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:g("debug-breakpoint-log-unverified",60074),debugBreakpointLog:g("debug-breakpoint-log",60075),debugBreakpointLogDisabled:g("debug-breakpoint-log-disabled",60075),briefcase:g("briefcase",60076),broadcast:g("broadcast",60077),browser:g("browser",60078),bug:g("bug",60079),calendar:g("calendar",60080),caseSensitive:g("case-sensitive",60081),check:g("check",60082),checklist:g("checklist",60083),chevronDown:g("chevron-down",60084),dropDownButton:g("drop-down-button",60084),chevronLeft:g("chevron-left",60085),chevronRight:g("chevron-right",60086),chevronUp:g("chevron-up",60087),chromeClose:g("chrome-close",60088),chromeMaximize:g("chrome-maximize",60089),chromeMinimize:g("chrome-minimize",60090),chromeRestore:g("chrome-restore",60091),circle:g("circle",60092),circleOutline:g("circle-outline",60092),debugBreakpointUnverified:g("debug-breakpoint-unverified",60092),circleSlash:g("circle-slash",60093),circuitBoard:g("circuit-board",60094),clearAll:g("clear-all",60095),clippy:g("clippy",60096),closeAll:g("close-all",60097),cloudDownload:g("cloud-download",60098),cloudUpload:g("cloud-upload",60099),code:g("code",60100),collapseAll:g("collapse-all",60101),colorMode:g("color-mode",60102),commentDiscussion:g("comment-discussion",60103),compareChanges:g("compare-changes",60157),creditCard:g("credit-card",60105),dash:g("dash",60108),dashboard:g("dashboard",60109),database:g("database",60110),debugContinue:g("debug-continue",60111),debugDisconnect:g("debug-disconnect",60112),debugPause:g("debug-pause",60113),debugRestart:g("debug-restart",60114),debugStart:g("debug-start",60115),debugStepInto:g("debug-step-into",60116),debugStepOut:g("debug-step-out",60117),debugStepOver:g("debug-step-over",60118),debugStop:g("debug-stop",60119),debug:g("debug",60120),deviceCameraVideo:g("device-camera-video",60121),deviceCamera:g("device-camera",60122),deviceMobile:g("device-mobile",60123),diffAdded:g("diff-added",60124),diffIgnored:g("diff-ignored",60125),diffModified:g("diff-modified",60126),diffRemoved:g("diff-removed",60127),diffRenamed:g("diff-renamed",60128),diff:g("diff",60129),discard:g("discard",60130),editorLayout:g("editor-layout",60131),emptyWindow:g("empty-window",60132),exclude:g("exclude",60133),extensions:g("extensions",60134),eyeClosed:g("eye-closed",60135),fileBinary:g("file-binary",60136),fileCode:g("file-code",60137),fileMedia:g("file-media",60138),filePdf:g("file-pdf",60139),fileSubmodule:g("file-submodule",60140),fileSymlinkDirectory:g("file-symlink-directory",60141),fileSymlinkFile:g("file-symlink-file",60142),fileZip:g("file-zip",60143),files:g("files",60144),filter:g("filter",60145),flame:g("flame",60146),foldDown:g("fold-down",60147),foldUp:g("fold-up",60148),fold:g("fold",60149),folderActive:g("folder-active",60150),folderOpened:g("folder-opened",60151),gear:g("gear",60152),gift:g("gift",60153),gistSecret:g("gist-secret",60154),gist:g("gist",60155),gitCommit:g("git-commit",60156),gitCompare:g("git-compare",60157),gitMerge:g("git-merge",60158),githubAction:g("github-action",60159),githubAlt:g("github-alt",60160),globe:g("globe",60161),grabber:g("grabber",60162),graph:g("graph",60163),gripper:g("gripper",60164),heart:g("heart",60165),home:g("home",60166),horizontalRule:g("horizontal-rule",60167),hubot:g("hubot",60168),inbox:g("inbox",60169),issueClosed:g("issue-closed",60324),issueReopened:g("issue-reopened",60171),issues:g("issues",60172),italic:g("italic",60173),jersey:g("jersey",60174),json:g("json",60175),bracket:g("bracket",60175),kebabVertical:g("kebab-vertical",60176),key:g("key",60177),law:g("law",60178),lightbulbAutofix:g("lightbulb-autofix",60179),linkExternal:g("link-external",60180),link:g("link",60181),listOrdered:g("list-ordered",60182),listUnordered:g("list-unordered",60183),liveShare:g("live-share",60184),loading:g("loading",60185),location:g("location",60186),mailRead:g("mail-read",60187),mail:g("mail",60188),markdown:g("markdown",60189),megaphone:g("megaphone",60190),mention:g("mention",60191),milestone:g("milestone",60192),gitPullRequestMilestone:g("git-pull-request-milestone",60192),mortarBoard:g("mortar-board",60193),move:g("move",60194),multipleWindows:g("multiple-windows",60195),mute:g("mute",60196),noNewline:g("no-newline",60197),note:g("note",60198),octoface:g("octoface",60199),openPreview:g("open-preview",60200),package:g("package",60201),paintcan:g("paintcan",60202),pin:g("pin",60203),play:g("play",60204),run:g("run",60204),plug:g("plug",60205),preserveCase:g("preserve-case",60206),preview:g("preview",60207),project:g("project",60208),pulse:g("pulse",60209),question:g("question",60210),quote:g("quote",60211),radioTower:g("radio-tower",60212),reactions:g("reactions",60213),references:g("references",60214),refresh:g("refresh",60215),regex:g("regex",60216),remoteExplorer:g("remote-explorer",60217),remote:g("remote",60218),remove:g("remove",60219),replaceAll:g("replace-all",60220),replace:g("replace",60221),repoClone:g("repo-clone",60222),repoForcePush:g("repo-force-push",60223),repoPull:g("repo-pull",60224),repoPush:g("repo-push",60225),report:g("report",60226),requestChanges:g("request-changes",60227),rocket:g("rocket",60228),rootFolderOpened:g("root-folder-opened",60229),rootFolder:g("root-folder",60230),rss:g("rss",60231),ruby:g("ruby",60232),saveAll:g("save-all",60233),saveAs:g("save-as",60234),save:g("save",60235),screenFull:g("screen-full",60236),screenNormal:g("screen-normal",60237),searchStop:g("search-stop",60238),server:g("server",60240),settingsGear:g("settings-gear",60241),settings:g("settings",60242),shield:g("shield",60243),smiley:g("smiley",60244),sortPrecedence:g("sort-precedence",60245),splitHorizontal:g("split-horizontal",60246),splitVertical:g("split-vertical",60247),squirrel:g("squirrel",60248),starFull:g("star-full",60249),starHalf:g("star-half",60250),symbolClass:g("symbol-class",60251),symbolColor:g("symbol-color",60252),symbolCustomColor:g("symbol-customcolor",60252),symbolConstant:g("symbol-constant",60253),symbolEnumMember:g("symbol-enum-member",60254),symbolField:g("symbol-field",60255),symbolFile:g("symbol-file",60256),symbolInterface:g("symbol-interface",60257),symbolKeyword:g("symbol-keyword",60258),symbolMisc:g("symbol-misc",60259),symbolOperator:g("symbol-operator",60260),symbolProperty:g("symbol-property",60261),wrench:g("wrench",60261),wrenchSubaction:g("wrench-subaction",60261),symbolSnippet:g("symbol-snippet",60262),tasklist:g("tasklist",60263),telescope:g("telescope",60264),textSize:g("text-size",60265),threeBars:g("three-bars",60266),thumbsdown:g("thumbsdown",60267),thumbsup:g("thumbsup",60268),tools:g("tools",60269),triangleDown:g("triangle-down",60270),triangleLeft:g("triangle-left",60271),triangleRight:g("triangle-right",60272),triangleUp:g("triangle-up",60273),twitter:g("twitter",60274),unfold:g("unfold",60275),unlock:g("unlock",60276),unmute:g("unmute",60277),unverified:g("unverified",60278),verified:g("verified",60279),versions:g("versions",60280),vmActive:g("vm-active",60281),vmOutline:g("vm-outline",60282),vmRunning:g("vm-running",60283),watch:g("watch",60284),whitespace:g("whitespace",60285),wholeWord:g("whole-word",60286),window:g("window",60287),wordWrap:g("word-wrap",60288),zoomIn:g("zoom-in",60289),zoomOut:g("zoom-out",60290),listFilter:g("list-filter",60291),listFlat:g("list-flat",60292),listSelection:g("list-selection",60293),selection:g("selection",60293),listTree:g("list-tree",60294),debugBreakpointFunctionUnverified:g("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:g("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:g("debug-breakpoint-function-disabled",60296),debugStackframeActive:g("debug-stackframe-active",60297),circleSmallFilled:g("circle-small-filled",60298),debugStackframeDot:g("debug-stackframe-dot",60298),debugStackframe:g("debug-stackframe",60299),debugStackframeFocused:g("debug-stackframe-focused",60299),debugBreakpointUnsupported:g("debug-breakpoint-unsupported",60300),symbolString:g("symbol-string",60301),debugReverseContinue:g("debug-reverse-continue",60302),debugStepBack:g("debug-step-back",60303),debugRestartFrame:g("debug-restart-frame",60304),callIncoming:g("call-incoming",60306),callOutgoing:g("call-outgoing",60307),menu:g("menu",60308),expandAll:g("expand-all",60309),feedback:g("feedback",60310),gitPullRequestReviewer:g("git-pull-request-reviewer",60310),groupByRefType:g("group-by-ref-type",60311),ungroupByRefType:g("ungroup-by-ref-type",60312),account:g("account",60313),gitPullRequestAssignee:g("git-pull-request-assignee",60313),bellDot:g("bell-dot",60314),debugConsole:g("debug-console",60315),library:g("library",60316),output:g("output",60317),runAll:g("run-all",60318),syncIgnored:g("sync-ignored",60319),pinned:g("pinned",60320),githubInverted:g("github-inverted",60321),debugAlt:g("debug-alt",60305),serverProcess:g("server-process",60322),serverEnvironment:g("server-environment",60323),pass:g("pass",60324),stopCircle:g("stop-circle",60325),playCircle:g("play-circle",60326),record:g("record",60327),debugAltSmall:g("debug-alt-small",60328),vmConnect:g("vm-connect",60329),cloud:g("cloud",60330),merge:g("merge",60331),exportIcon:g("export",60332),graphLeft:g("graph-left",60333),magnet:g("magnet",60334),notebook:g("notebook",60335),redo:g("redo",60336),checkAll:g("check-all",60337),pinnedDirty:g("pinned-dirty",60338),passFilled:g("pass-filled",60339),circleLargeFilled:g("circle-large-filled",60340),circleLarge:g("circle-large",60341),circleLargeOutline:g("circle-large-outline",60341),combine:g("combine",60342),gather:g("gather",60342),table:g("table",60343),variableGroup:g("variable-group",60344),typeHierarchy:g("type-hierarchy",60345),typeHierarchySub:g("type-hierarchy-sub",60346),typeHierarchySuper:g("type-hierarchy-super",60347),gitPullRequestCreate:g("git-pull-request-create",60348),runAbove:g("run-above",60349),runBelow:g("run-below",60350),notebookTemplate:g("notebook-template",60351),debugRerun:g("debug-rerun",60352),workspaceTrusted:g("workspace-trusted",60353),workspaceUntrusted:g("workspace-untrusted",60354),workspaceUnspecified:g("workspace-unspecified",60355),terminalCmd:g("terminal-cmd",60356),terminalDebian:g("terminal-debian",60357),terminalLinux:g("terminal-linux",60358),terminalPowershell:g("terminal-powershell",60359),terminalTmux:g("terminal-tmux",60360),terminalUbuntu:g("terminal-ubuntu",60361),terminalBash:g("terminal-bash",60362),arrowSwap:g("arrow-swap",60363),copy:g("copy",60364),personAdd:g("person-add",60365),filterFilled:g("filter-filled",60366),wand:g("wand",60367),debugLineByLine:g("debug-line-by-line",60368),inspect:g("inspect",60369),layers:g("layers",60370),layersDot:g("layers-dot",60371),layersActive:g("layers-active",60372),compass:g("compass",60373),compassDot:g("compass-dot",60374),compassActive:g("compass-active",60375),azure:g("azure",60376),issueDraft:g("issue-draft",60377),gitPullRequestClosed:g("git-pull-request-closed",60378),gitPullRequestDraft:g("git-pull-request-draft",60379),debugAll:g("debug-all",60380),debugCoverage:g("debug-coverage",60381),runErrors:g("run-errors",60382),folderLibrary:g("folder-library",60383),debugContinueSmall:g("debug-continue-small",60384),beakerStop:g("beaker-stop",60385),graphLine:g("graph-line",60386),graphScatter:g("graph-scatter",60387),pieChart:g("pie-chart",60388),bracketDot:g("bracket-dot",60389),bracketError:g("bracket-error",60390),lockSmall:g("lock-small",60391),azureDevops:g("azure-devops",60392),verifiedFilled:g("verified-filled",60393),newLine:g("newline",60394),layout:g("layout",60395),layoutActivitybarLeft:g("layout-activitybar-left",60396),layoutActivitybarRight:g("layout-activitybar-right",60397),layoutPanelLeft:g("layout-panel-left",60398),layoutPanelCenter:g("layout-panel-center",60399),layoutPanelJustify:g("layout-panel-justify",60400),layoutPanelRight:g("layout-panel-right",60401),layoutPanel:g("layout-panel",60402),layoutSidebarLeft:g("layout-sidebar-left",60403),layoutSidebarRight:g("layout-sidebar-right",60404),layoutStatusbar:g("layout-statusbar",60405),layoutMenubar:g("layout-menubar",60406),layoutCentered:g("layout-centered",60407),layoutSidebarRightOff:g("layout-sidebar-right-off",60416),layoutPanelOff:g("layout-panel-off",60417),layoutSidebarLeftOff:g("layout-sidebar-left-off",60418),target:g("target",60408),indent:g("indent",60409),recordSmall:g("record-small",60410),errorSmall:g("error-small",60411),arrowCircleDown:g("arrow-circle-down",60412),arrowCircleLeft:g("arrow-circle-left",60413),arrowCircleRight:g("arrow-circle-right",60414),arrowCircleUp:g("arrow-circle-up",60415),heartFilled:g("heart-filled",60420),map:g("map",60421),mapFilled:g("map-filled",60422),circleSmall:g("circle-small",60423),bellSlash:g("bell-slash",60424),bellSlashDot:g("bell-slash-dot",60425),commentUnresolved:g("comment-unresolved",60426),gitPullRequestGoToChanges:g("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:g("git-pull-request-new-changes",60428),searchFuzzy:g("search-fuzzy",60429),commentDraft:g("comment-draft",60430),send:g("send",60431),sparkle:g("sparkle",60432),insert:g("insert",60433),mic:g("mic",60434),thumbsDownFilled:g("thumbsdown-filled",60435),thumbsUpFilled:g("thumbsup-filled",60436),coffee:g("coffee",60437),snake:g("snake",60438),game:g("game",60439),vr:g("vr",60440),chip:g("chip",60441),piano:g("piano",60442),music:g("music",60443),micFilled:g("mic-filled",60444),gitFetch:g("git-fetch",60445),copilot:g("copilot",60446),lightbulbSparkle:g("lightbulb-sparkle",60447),lightbulbSparkleAutofix:g("lightbulb-sparkle-autofix",60447),robot:g("robot",60448),sparkleFilled:g("sparkle-filled",60449),diffSingle:g("diff-single",60450),diffMultiple:g("diff-multiple",60451),surroundWith:g("surround-with",60452),gitStash:g("git-stash",60454),gitStashApply:g("git-stash-apply",60455),gitStashPop:g("git-stash-pop",60456),dialogError:g("dialog-error","error"),dialogWarning:g("dialog-warning","warning"),dialogInfo:g("dialog-info","info"),dialogClose:g("dialog-close","close"),treeItemExpanded:g("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:g("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:g("tree-filter-on-type-off","list-selection"),treeFilterClear:g("tree-filter-clear","close"),treeItemLoading:g("tree-item-loading","loading"),menuSelection:g("menu-selection","check"),menuSubmenu:g("menu-submenu","chevron-right"),menuBarMore:g("menubar-more","more"),scrollbarButtonLeft:g("scrollbar-button-left","triangle-left"),scrollbarButtonRight:g("scrollbar-button-right","triangle-right"),scrollbarButtonUp:g("scrollbar-button-up","triangle-up"),scrollbarButtonDown:g("scrollbar-button-down","triangle-down"),toolBarMore:g("toolbar-more","more"),quickInputBack:g("quick-input-back","arrow-left")}}),define(ke[24],Se([1,0,18]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=e.$An=e.$zn=e.$yn=e.$xn=e.$wn=e.$vn=void 0;function O(o){if(!o||typeof o!="object"||o instanceof RegExp)return o;const i=Array.isArray(o)?[]:{};return Object.entries(o).forEach(([r,n])=>{i[r]=n&&typeof n=="object"?O(n):n}),i}e.$vn=O;function g(o){if(!o||typeof o!="object")return o;const i=[o];for(;i.length>0;){const r=i.shift();Object.freeze(r);for(const n in r)if(I.call(r,n)){const c=r[n];typeof c=="object"&&!Object.isFrozen(c)&&!(0,D.$Lf)(c)&&i.push(c)}}return o}e.$wn=g;const I=Object.prototype.hasOwnProperty;function A(o,i){return b(o,i,new Set)}e.$xn=A;function b(o,i,r){if((0,D.$Rf)(o))return o;const n=i(o);if(typeof n<"u")return n;if(Array.isArray(o)){const c=[];for(const t of o)c.push(b(t,i,r));return c}if((0,D.$Kf)(o)){if(r.has(o))throw new Error("Cannot clone recursive data-structure");r.add(o);const c={};for(const t in o)I.call(o,t)&&(c[t]=b(o[t],i,r));return r.delete(o),c}return o}function $(o,i,r=!0){return(0,D.$Kf)(o)?((0,D.$Kf)(i)&&Object.keys(i).forEach(n=>{n in o?r&&((0,D.$Kf)(o[n])&&(0,D.$Kf)(i[n])?$(o[n],i[n],r):o[n]=i[n]):o[n]=i[n]}),o):i}e.$yn=$;function y(o,i){if(o===i)return!0;if(o==null||i===null||i===void 0||typeof o!=typeof i||typeof o!="object"||Array.isArray(o)!==Array.isArray(i))return!1;let r,n;if(Array.isArray(o)){if(o.length!==i.length)return!1;for(r=0;r<o.length;r++)if(!y(o[r],i[r]))return!1}else{const c=[];for(n in o)c.push(n);c.sort();const t=[];for(n in i)t.push(n);if(t.sort(),!y(c,t))return!1;for(r=0;r<c.length;r++)if(!y(o[c[r]],i[c[r]]))return!1}return!0}e.$zn=y;function L(o){const i=new Set;return JSON.stringify(o,(r,n)=>{if((0,D.$Kf)(n)||Array.isArray(n)){if(i.has(n))return"[Circular]";i.add(n)}return n})}e.$An=L;function C(o,i){const r=Object.create(null);return!o||!i||Object.keys(i).forEach(c=>{const t=o[c],u=i[c];y(t,u)||(r[c]=u)}),r}e.$Bn=C;function m(o,i){const r=i.toLowerCase(),n=Object.keys(o).find(c=>c.toLowerCase()===r);return n?o[n]:o[i]}e.$Cn=m;function p(o,i){const r=Object.create(null);for(const[n,c]of Object.entries(o))i(n,c)&&(r[n]=c);return r}e.$Dn=p;function S(o){let i=[];for(;Object.prototype!==o;)i=i.concat(Object.getOwnPropertyNames(o)),o=Object.getPrototypeOf(o);return i}e.$En=S;function h(o){const i=[];for(const r of S(o))typeof o[r]=="function"&&i.push(r);return i}e.$Fn=h;function f(o,i){const r=c=>function(){const t=Array.prototype.slice.call(arguments,0);return i(c,t)},n={};for(const c of o)n[c]=r(c);return n}e.$Gn=f}),define(ke[61],Se([1,0,78]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$ak=e.ThemeColor=void 0;var O;(function(A){function b($){return $&&typeof $=="object"&&typeof $.id=="string"}A.isThemeColor=b})(O||(e.ThemeColor=O={}));function g(A){return{id:A}}e.$ak=g;var I;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const b=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function $(i){const r=b.exec(i.id);if(!r)return $(D.$_j.error);const[,n,c]=r,t=["codicon","codicon-"+n];return c&&t.push("codicon-modifier-"+c.substring(1)),t}A.asClassNameArray=$;function y(i){return $(i).join(" ")}A.asClassName=y;function L(i){return"."+$(i).join(".")}A.asCSSSelector=L;function C(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color>"u"||O.isThemeColor(i.color))}A.isThemeIcon=C;const m=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function p(i){const r=m.exec(i);if(!r)return;const[,n]=r;return{id:n}}A.fromString=p;function S(i){return{id:i}}A.fromId=S;function h(i,r){let n=i.id;const c=n.lastIndexOf("~");return c!==-1&&(n=n.substring(0,c)),r&&(n=`${n}~${r}`),{id:n}}A.modify=h;function f(i){const r=i.id.lastIndexOf("~");if(r!==-1)return i.id.substring(r+1)}A.getModifier=f;function o(i,r){return i.id===r.id&&i.color?.id===r.color?.id}A.isEqual=o})(I||(e.ThemeIcon=I={}))}),define(ke[164],Se([1,0,123,12,61]),function(me,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=void 0;const I="$(",A=new RegExp(`\\$\\(${g.ThemeIcon.iconNameExpression}(?:${g.ThemeIcon.iconModifierExpression})?\\)`,"g"),b=new RegExp(`(\\\\)?${A.source}`,"g");function $(o){return o.replace(b,(i,r)=>r?i:`\\${i}`)}e.$bk=$;const y=new RegExp(`\\\\${A.source}`,"g");function L(o){return o.replace(y,i=>`\\${i}`)}e.$ck=L;const C=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function m(o){return o.indexOf(I)===-1?o:o.replace(C,(i,r,n,c)=>n?i:r||c||"")}e.$dk=m;function p(o){return o?o.replace(/\$\((.*?)\)/g,(i,r)=>` ${r} `).trim():""}e.$ek=p;const S=new RegExp(`\\$\\(${g.ThemeIcon.iconNameCharacter}+\\)`,"g");function h(o){S.lastIndex=0;let i="";const r=[];let n=0;for(;;){const c=S.lastIndex,t=S.exec(o),u=o.substring(c,t?.index);if(u.length>0){i+=u;for(let s=0;s<u.length;s++)r.push(n)}if(!t)break;n+=t[0].length}return{text:i,iconOffsets:r}}e.$fk=h;function f(o,i,r=!1){const{text:n,iconOffsets:c}=i;if(!c||c.length===0)return(0,D.$1j)(o,n,r);const t=(0,O.$Te)(n," "),u=n.length-t.length,s=(0,D.$1j)(o,t,r);if(s)for(const l of s){const a=c[l.start+u]+u;l.start+=a,l.end+=a}return s}e.$gk=f}),define(ke[124],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ie=e.$He=e.Constants=void 0;var D;(function(I){I[I.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",I[I.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",I[I.MAX_UINT_8=255]="MAX_UINT_8",I[I.MAX_UINT_16=65535]="MAX_UINT_16",I[I.MAX_UINT_32=4294967295]="MAX_UINT_32",I[I.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(D||(e.Constants=D={}));function O(I){return I<0?0:I>255?255:I|0}e.$He=O;function g(I){return I<0?0:I>4294967295?4294967295:I|0}e.$Ie=g}),define(ke[30],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qg=e.$pg=void 0;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function O(g){return D.test(g)}e.$pg=O,e.$qg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let g;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?g=crypto.getRandomValues.bind(crypto):g=function(b){for(let $=0;$<b.length;$++)b[$]=Math.floor(Math.random()*256);return b};const I=new Uint8Array(16),A=[];for(let b=0;b<256;b++)A.push(b.toString(16).padStart(2,"0"));return function(){g(I),I[6]=I[6]&15|64,I[8]=I[8]&63|128;let $=0,y="";return y+=A[I[$++]],y+=A[I[$++]],y+=A[I[$++]],y+=A[I[$++]],y+="-",y+=A[I[$++]],y+=A[I[$++]],y+="-",y+=A[I[$++]],y+=A[I[$++]],y+="-",y+=A[I[$++]],y+=A[I[$++]],y+="-",y+=A[I[$++]],y+=A[I[$++]],y+=A[I[$++]],y+=A[I[$++]],y+=A[I[$++]],y+=A[I[$++]],y}}()}),define(ke[165],Se([1,0,19,53,30]),function(me,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rt=e.$qt=e.$pt=e.$ot=e.$nt=void 0;function I(C){return{asString:async()=>C,asFile:()=>{},value:typeof C=="string"?C:void 0}}e.$nt=I;function A(C,m,p){const S={id:(0,g.$qg)(),name:C,uri:m,data:p};return{asString:async()=>"",asFile:()=>S,value:void 0}}e.$ot=A;class b{constructor(){this.a=new Map}get size(){let m=0;for(const p of this.a)m++;return m}has(m){return this.a.has(this.b(m))}matches(m){const p=[...this.a.keys()];return O.Iterable.some(this,([S,h])=>h.asFile())&&p.push("files"),L($(m),p)}get(m){return this.a.get(this.b(m))?.[0]}append(m,p){const S=this.a.get(m);S?S.push(p):this.a.set(this.b(m),[p])}replace(m,p){this.a.set(this.b(m),[p])}delete(m){this.a.delete(this.b(m))}*[Symbol.iterator](){for(const[m,p]of this.a)for(const S of p)yield[m,S]}b(m){return $(m)}}e.$pt=b;function $(C){return C.toLowerCase()}function y(C,m){return L($(C),m.map($))}e.$qt=y;function L(C,m){if(C==="*/*")return m.length>0;if(m.includes(C))return!0;const p=C.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!p)return!1;const[S,h,f]=p;return f==="*"?m.some(o=>o.startsWith(h+"/")):!1}e.$rt=Object.freeze({create:C=>(0,D.$Mb)(C.map(m=>m.toString())).join(`\r
`),split:C=>C.split(`\r
`),parse:C=>e.$rt.split(C).filter(m=>!m.startsWith("#"))})}),define(ke[166],Se([1,0,62]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ug=e.$tg=e.$sg=void 0;function O(b,$,y,L=1){let C=!1;return new Promise(m=>{const p=setTimeout(()=>{if(!C)return C=!0,m(0)},y);g(b,$,L,S=>{if(!C)return C=!0,clearTimeout(p),m(S)})})}e.$sg=O;function g(b,$,y,L){if($===0)return L(0);const C=new D.Socket;C.once("connect",()=>(A(C),g(b+y,$-1,y,L))),C.once("data",()=>{}),C.once("error",m=>(A(C),m.code!=="ECONNREFUSED"?g(b+y,$-1,y,L):L(b))),C.connect(b,"127.0.0.1")}e.$tg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function I(b,$,y,L="127.0.0.1"){let C=!1,m,p=1;const S=D.createServer({pauseOnConnect:!0});function h(f,o){C||(C=!0,S.removeAllListeners(),S.close(),m&&clearTimeout(m),o(f))}return new Promise(f=>{m=setTimeout(()=>{h(0,f)},y),S.on("listening",()=>{h(b,f)}),S.on("error",o=>{o&&(o.code==="EADDRINUSE"||o.code==="EACCES")&&p<$?(b++,p++,S.listen(b,L)):h(0,f)}),S.on("close",()=>{h(0,f)}),S.listen(b,L)})}e.$ug=I;function A(b){try{b.removeAllListeners("connect"),b.removeAllListeners("error"),b.end(),b.destroy(),b.unref()}catch($){console.error($)}}}),define(ke[125],Se([1,0,124]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gt=e.$ft=void 0;class O{constructor(b){const $=(0,D.$He)(b);this.c=$,this.a=O.d($),this.b=new Map}static d(b){const $=new Uint8Array(256);return $.fill(b),$}set(b,$){const y=(0,D.$He)($);b>=0&&b<256?this.a[b]=y:this.b.set(b,y)}get(b){return b>=0&&b<256?this.a[b]:this.b.get(b)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$ft=O;var g;(function(A){A[A.False=0]="False",A[A.True=1]="True"})(g||(g={}));class I{constructor(){this.a=new O(0)}add(b){this.a.set(b,1)}has(b){return this.a.get(b)===1}clear(){return this.a.clear()}}e.$gt=I}),define(ke[167],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ut=e.StringEOL=void 0;var D;(function(g){g[g.Unknown=0]="Unknown",g[g.Invalid=3]="Invalid",g[g.LF=1]="LF",g[g.CRLF=2]="CRLF"})(D||(e.StringEOL=D={}));function O(g){let I=0,A=0,b=0,$=0;for(let y=0,L=g.length;y<L;y++){const C=g.charCodeAt(y);C===13?(I===0&&(A=y),I++,y+1<L&&g.charCodeAt(y+1)===10?($|=2,y++):$|=3,b=y+1):C===10&&($|=1,I===0&&(A=y),I++,b=y+1)}return I===0&&(A=g.length),[I,A,g.length-b,$]}e.$ut=O}),define(ke[48],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ts=void 0;class D{constructor(g,I){this.lineNumber=g,this.column=I}with(g=this.lineNumber,I=this.column){return g===this.lineNumber&&I===this.column?this:new D(g,I)}delta(g=0,I=0){return this.with(this.lineNumber+g,this.column+I)}equals(g){return D.equals(this,g)}static equals(g,I){return!g&&!I?!0:!!g&&!!I&&g.lineNumber===I.lineNumber&&g.column===I.column}isBefore(g){return D.isBefore(this,g)}static isBefore(g,I){return g.lineNumber<I.lineNumber?!0:I.lineNumber<g.lineNumber?!1:g.column<I.column}isBeforeOrEqual(g){return D.isBeforeOrEqual(this,g)}static isBeforeOrEqual(g,I){return g.lineNumber<I.lineNumber?!0:I.lineNumber<g.lineNumber?!1:g.column<=I.column}static compare(g,I){const A=g.lineNumber|0,b=I.lineNumber|0;if(A===b){const $=g.column|0,y=I.column|0;return $-y}return A-b}clone(){return new D(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(g){return new D(g.lineNumber,g.column)}static isIPosition(g){return g&&typeof g.lineNumber=="number"&&typeof g.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}e.$Ts=D}),define(ke[29],Se([1,0,48]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Us=void 0;class O{constructor(I,A,b,$){I>b||I===b&&A>$?(this.startLineNumber=b,this.startColumn=$,this.endLineNumber=I,this.endColumn=A):(this.startLineNumber=I,this.startColumn=A,this.endLineNumber=b,this.endColumn=$)}isEmpty(){return O.isEmpty(this)}static isEmpty(I){return I.startLineNumber===I.endLineNumber&&I.startColumn===I.endColumn}containsPosition(I){return O.containsPosition(this,I)}static containsPosition(I,A){return!(A.lineNumber<I.startLineNumber||A.lineNumber>I.endLineNumber||A.lineNumber===I.startLineNumber&&A.column<I.startColumn||A.lineNumber===I.endLineNumber&&A.column>I.endColumn)}static strictContainsPosition(I,A){return!(A.lineNumber<I.startLineNumber||A.lineNumber>I.endLineNumber||A.lineNumber===I.startLineNumber&&A.column<=I.startColumn||A.lineNumber===I.endLineNumber&&A.column>=I.endColumn)}containsRange(I){return O.containsRange(this,I)}static containsRange(I,A){return!(A.startLineNumber<I.startLineNumber||A.endLineNumber<I.startLineNumber||A.startLineNumber>I.endLineNumber||A.endLineNumber>I.endLineNumber||A.startLineNumber===I.startLineNumber&&A.startColumn<I.startColumn||A.endLineNumber===I.endLineNumber&&A.endColumn>I.endColumn)}strictContainsRange(I){return O.strictContainsRange(this,I)}static strictContainsRange(I,A){return!(A.startLineNumber<I.startLineNumber||A.endLineNumber<I.startLineNumber||A.startLineNumber>I.endLineNumber||A.endLineNumber>I.endLineNumber||A.startLineNumber===I.startLineNumber&&A.startColumn<=I.startColumn||A.endLineNumber===I.endLineNumber&&A.endColumn>=I.endColumn)}plusRange(I){return O.plusRange(this,I)}static plusRange(I,A){let b,$,y,L;return A.startLineNumber<I.startLineNumber?(b=A.startLineNumber,$=A.startColumn):A.startLineNumber===I.startLineNumber?(b=A.startLineNumber,$=Math.min(A.startColumn,I.startColumn)):(b=I.startLineNumber,$=I.startColumn),A.endLineNumber>I.endLineNumber?(y=A.endLineNumber,L=A.endColumn):A.endLineNumber===I.endLineNumber?(y=A.endLineNumber,L=Math.max(A.endColumn,I.endColumn)):(y=I.endLineNumber,L=I.endColumn),new O(b,$,y,L)}intersectRanges(I){return O.intersectRanges(this,I)}static intersectRanges(I,A){let b=I.startLineNumber,$=I.startColumn,y=I.endLineNumber,L=I.endColumn;const C=A.startLineNumber,m=A.startColumn,p=A.endLineNumber,S=A.endColumn;return b<C?(b=C,$=m):b===C&&($=Math.max($,m)),y>p?(y=p,L=S):y===p&&(L=Math.min(L,S)),b>y||b===y&&$>L?null:new O(b,$,y,L)}equalsRange(I){return O.equalsRange(this,I)}static equalsRange(I,A){return!I&&!A?!0:!!I&&!!A&&I.startLineNumber===A.startLineNumber&&I.startColumn===A.startColumn&&I.endLineNumber===A.endLineNumber&&I.endColumn===A.endColumn}getEndPosition(){return O.getEndPosition(this)}static getEndPosition(I){return new D.$Ts(I.endLineNumber,I.endColumn)}getStartPosition(){return O.getStartPosition(this)}static getStartPosition(I){return new D.$Ts(I.startLineNumber,I.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(I,A){return new O(this.startLineNumber,this.startColumn,I,A)}setStartPosition(I,A){return new O(I,A,this.endLineNumber,this.endColumn)}collapseToStart(){return O.collapseToStart(this)}static collapseToStart(I){return new O(I.startLineNumber,I.startColumn,I.startLineNumber,I.startColumn)}collapseToEnd(){return O.collapseToEnd(this)}static collapseToEnd(I){return new O(I.endLineNumber,I.endColumn,I.endLineNumber,I.endColumn)}delta(I){return new O(this.startLineNumber+I,this.startColumn,this.endLineNumber+I,this.endColumn)}static fromPositions(I,A=I){return new O(I.lineNumber,I.column,A.lineNumber,A.column)}static lift(I){return I?new O(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn):null}static isIRange(I){return I&&typeof I.startLineNumber=="number"&&typeof I.startColumn=="number"&&typeof I.endLineNumber=="number"&&typeof I.endColumn=="number"}static areIntersectingOrTouching(I,A){return!(I.endLineNumber<A.startLineNumber||I.endLineNumber===A.startLineNumber&&I.endColumn<A.startColumn||A.endLineNumber<I.startLineNumber||A.endLineNumber===I.startLineNumber&&A.endColumn<I.startColumn)}static areIntersecting(I,A){return!(I.endLineNumber<A.startLineNumber||I.endLineNumber===A.startLineNumber&&I.endColumn<=A.startColumn||A.endLineNumber<I.startLineNumber||A.endLineNumber===I.startLineNumber&&A.endColumn<=I.startColumn)}static compareRangesUsingStarts(I,A){if(I&&A){const y=I.startLineNumber|0,L=A.startLineNumber|0;if(y===L){const C=I.startColumn|0,m=A.startColumn|0;if(C===m){const p=I.endLineNumber|0,S=A.endLineNumber|0;if(p===S){const h=I.endColumn|0,f=A.endColumn|0;return h-f}return p-S}return C-m}return y-L}return(I?1:0)-(A?1:0)}static compareRangesUsingEnds(I,A){return I.endLineNumber===A.endLineNumber?I.endColumn===A.endColumn?I.startLineNumber===A.startLineNumber?I.startColumn-A.startColumn:I.startLineNumber-A.startLineNumber:I.endColumn-A.endColumn:I.endLineNumber-A.endLineNumber}static spansMultipleLines(I){return I.endLineNumber>I.startLineNumber}toJSON(){return this}}e.$Us=O}),define(ke[168],Se([1,0,29]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vs=void 0;class O{static insert(I,A){return{range:new D.$Us(I.lineNumber,I.column,I.lineNumber,I.column),text:A,forceMoveMarkers:!0}}static delete(I){return{range:I,text:null}}static replace(I,A){return{range:I,text:A}}static replaceMove(I,A){return{range:I,text:A,forceMoveMarkers:!0}}}e.$Vs=O}),define(ke[169],Se([1,0,48,29]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ws=e.SelectionDirection=void 0;var g;(function(A){A[A.LTR=0]="LTR",A[A.RTL=1]="RTL"})(g||(e.SelectionDirection=g={}));class I extends O.$Us{constructor(b,$,y,L){super(b,$,y,L),this.selectionStartLineNumber=b,this.selectionStartColumn=$,this.positionLineNumber=y,this.positionColumn=L}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(b){return I.selectionsEqual(this,b)}static selectionsEqual(b,$){return b.selectionStartLineNumber===$.selectionStartLineNumber&&b.selectionStartColumn===$.selectionStartColumn&&b.positionLineNumber===$.positionLineNumber&&b.positionColumn===$.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(b,$){return this.getDirection()===0?new I(this.startLineNumber,this.startColumn,b,$):new I(b,$,this.startLineNumber,this.startColumn)}getPosition(){return new D.$Ts(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new D.$Ts(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(b,$){return this.getDirection()===0?new I(b,$,this.endLineNumber,this.endColumn):new I(this.endLineNumber,this.endColumn,b,$)}static fromPositions(b,$=b){return new I(b.lineNumber,b.column,$.lineNumber,$.column)}static fromRange(b,$){return $===0?new I(b.startLineNumber,b.startColumn,b.endLineNumber,b.endColumn):new I(b.endLineNumber,b.endColumn,b.startLineNumber,b.startColumn)}static liftSelection(b){return new I(b.selectionStartLineNumber,b.selectionStartColumn,b.positionLineNumber,b.positionColumn)}static selectionsArrEqual(b,$){if(b&&!$||!b&&$)return!1;if(!b&&!$)return!0;if(b.length!==$.length)return!1;for(let y=0,L=b.length;y<L;y++)if(!this.selectionsEqual(b[y],$[y]))return!1;return!0}static isISelection(b){return b&&typeof b.selectionStartLineNumber=="number"&&typeof b.selectionStartColumn=="number"&&typeof b.positionLineNumber=="number"&&typeof b.positionColumn=="number"}static createWithDirection(b,$,y,L,C){return C===0?new I(b,$,y,L):new I(y,L,b,$)}}e.$Ws=I}),define(ke[170],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ss=void 0,e.$ss={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(ke[171],Se([1,0,125]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$it=e.$ht=e.WordCharacterClass=void 0;var O;(function(A){A[A.Regular=0]="Regular",A[A.Whitespace=1]="Whitespace",A[A.WordSeparator=2]="WordSeparator"})(O||(e.WordCharacterClass=O={}));class g extends D.$ft{constructor(b){super(0);for(let $=0,y=b.length;$<y;$++)this.set(b.charCodeAt($),2);this.set(32,1),this.set(9,1)}}e.$ht=g;function I(A){const b={};return $=>(b.hasOwnProperty($)||(b[$]=A($)),b[$])}e.$it=I(A=>new g(A))}),define(ke[126],Se([1,0,53,3,75]),function(me,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xs=e.$ws=e.$vs=e.$us=e.$ts=void 0,e.$ts="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function I(C=""){let m="(-?\\d*\\.\\d\\w*)|([^";for(const p of e.$ts)C.indexOf(p)>=0||(m+="\\"+p);return m+="\\s]+)",new RegExp(m,"g")}e.$us=I();function A(C){let m=e.$us;if(C&&C instanceof RegExp)if(C.global)m=C;else{let p="g";C.ignoreCase&&(p+="i"),C.multiline&&(p+="m"),C.unicode&&(p+="u"),m=new RegExp(C.source,p)}return m.lastIndex=0,m}e.$vs=A;const b=new g.$4c;b.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function $(C){const m=b.unshift(C);return(0,O.$Rc)(m)}e.$ws=$;function y(C,m,p,S,h){if(m=A(m),h||(h=D.Iterable.first(b)),p.length>h.maxLen){let n=C-h.maxLen/2;return n<0?n=0:S+=n,p=p.substring(n,C+h.maxLen/2),y(C,m,p,S,h)}const f=Date.now(),o=C-1-S;let i=-1,r=null;for(let n=1;!(Date.now()-f>=h.timeBudget);n++){const c=o-h.windowSize*n;m.lastIndex=Math.max(0,c);const t=L(m,p,o,i);if(!t&&r||(r=t,c<=0))break;i=c}if(r){const n={word:r[0],startColumn:S+1+r.index,endColumn:S+1+r.index+r[0].length};return m.lastIndex=0,n}return null}e.$xs=y;function L(C,m,p,S){let h;for(;h=C.exec(m);){const f=h.index||0;if(f<=p&&C.lastIndex>=p)return h;if(S>0&&f>S)return null}return null}}),define(ke[172],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$St=e.$Rt=e.IndentAction=void 0;var D;(function(A){A[A.None=0]="None",A[A.Indent=1]="Indent",A[A.IndentOutdent=2]="IndentOutdent",A[A.Outdent=3]="Outdent"})(D||(e.IndentAction=D={}));class O{constructor(b){if(this.e=null,this.f=!1,this.open=b.open,this.close=b.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(b.notIn))for(let $=0,y=b.notIn.length;$<y;$++)switch(b.notIn[$]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(b){switch(b){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(b,$){if(b.getTokenCount()===0)return!0;const y=b.findTokenIndexAtOffset($-2),L=b.getStandardTokenType(y);return this.isOK(L)}g(b,$){for(let y=b;y<=$;y++){const L=String.fromCharCode(y);if(!this.open.includes(L)&&!this.close.includes(L))return L}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$Rt=O;class g{constructor(b){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const $ of b)I(this.autoClosingPairsOpenByStart,$.open.charAt(0),$),I(this.autoClosingPairsOpenByEnd,$.open.charAt($.open.length-1),$),I(this.autoClosingPairsCloseByStart,$.close.charAt(0),$),I(this.autoClosingPairsCloseByEnd,$.close.charAt($.close.length-1),$),$.close.length===1&&$.open.length===1&&I(this.autoClosingPairsCloseSingleChar,$.close,$)}}e.$St=g;function I(A,b,$){A.has(b)?A.get(b).push($):A.set(b,[$])}}),define(ke[173],Se([1,0,125]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wZ=e.$vZ=e.$uZ=e.State=void 0;var O;(function(p){p[p.Invalid=0]="Invalid",p[p.Start=1]="Start",p[p.H=2]="H",p[p.HT=3]="HT",p[p.HTT=4]="HTT",p[p.HTTP=5]="HTTP",p[p.F=6]="F",p[p.FI=7]="FI",p[p.FIL=8]="FIL",p[p.BeforeColon=9]="BeforeColon",p[p.AfterColon=10]="AfterColon",p[p.AlmostThere=11]="AlmostThere",p[p.End=12]="End",p[p.Accept=13]="Accept",p[p.LastKnownState=14]="LastKnownState"})(O||(e.State=O={}));class g{constructor(S,h,f){const o=new Uint8Array(S*h);for(let i=0,r=S*h;i<r;i++)o[i]=f;this.a=o,this.rows=S,this.cols=h}get(S,h){return this.a[S*this.cols+h]}set(S,h,f){this.a[S*this.cols+h]=f}}class I{constructor(S){let h=0,f=0;for(let i=0,r=S.length;i<r;i++){const[n,c,t]=S[i];c>h&&(h=c),n>f&&(f=n),t>f&&(f=t)}h++,f++;const o=new g(f,h,0);for(let i=0,r=S.length;i<r;i++){const[n,c,t]=S[i];o.set(n,c,t)}this.a=o,this.b=h}nextState(S,h){return h<0||h>=this.b?0:this.a.get(S,h)}}e.$uZ=I;let A=null;function b(){return A===null&&(A=new I([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),A}var $;(function(p){p[p.None=0]="None",p[p.ForceTermination=1]="ForceTermination",p[p.CannotEndIn=2]="CannotEndIn"})($||($={}));let y=null;function L(){if(y===null){y=new D.$ft(0);const p=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let h=0;h<p.length;h++)y.set(p.charCodeAt(h),1);const S=".,;:";for(let h=0;h<S.length;h++)y.set(S.charCodeAt(h),2)}return y}class C{static a(S,h,f,o,i){let r=i-1;do{const n=h.charCodeAt(r);if(S.get(n)!==2)break;r--}while(r>o);if(o>0){const n=h.charCodeAt(o-1),c=h.charCodeAt(r);(n===40&&c===41||n===91&&c===93||n===123&&c===125)&&r--}return{range:{startLineNumber:f,startColumn:o+1,endLineNumber:f,endColumn:r+2},url:h.substring(o,r+1)}}static computeLinks(S,h=b()){const f=L(),o=[];for(let i=1,r=S.getLineCount();i<=r;i++){const n=S.getLineContent(i),c=n.length;let t=0,u=0,s=0,l=1,a=!1,d=!1,k=!1,R=!1;for(;t<c;){let v=!1;const w=n.charCodeAt(t);if(l===13){let E;switch(w){case 40:a=!0,E=0;break;case 41:E=a?0:1;break;case 91:k=!0,d=!0,E=0;break;case 93:k=!1,E=d?0:1;break;case 123:R=!0,E=0;break;case 125:E=R?0:1;break;case 39:case 34:case 96:s===w?E=1:s===39||s===34||s===96?E=0:E=1;break;case 42:E=s===42?1:0;break;case 124:E=s===124?1:0;break;case 32:E=k?0:1;break;default:E=f.get(w)}E===1&&(o.push(C.a(f,n,i,u,t)),v=!0)}else if(l===12){let E;w===91?(d=!0,E=0):E=f.get(w),E===1?v=!0:l=13}else l=h.nextState(l,w),l===0&&(v=!0);v&&(l=1,a=!1,d=!1,R=!1,u=t+1,s=w),t++}l===13&&o.push(C.a(f,n,i,u,c))}return o}}e.$vZ=C;function m(p){return!p||typeof p.getLineCount!="function"||typeof p.getLineContent!="function"?[]:C.computeLinks(p)}e.$wZ=m}),define(ke[79],Se([1,0,24]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fv=e.$ev=e.$dv=e.$cv=e.ModelConstants=e.PositionAffinity=e.$bv=e.TrackedRangeStickiness=e.$av=e.$_u=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0;var O;(function(n){n[n.Left=1]="Left",n[n.Center=2]="Center",n[n.Right=4]="Right",n[n.Full=7]="Full"})(O||(e.OverviewRulerLane=O={}));var g;(function(n){n[n.Left=1]="Left",n[n.Center=2]="Center",n[n.Right=3]="Right"})(g||(e.GlyphMarginLane=g={}));var I;(function(n){n[n.Inline=1]="Inline",n[n.Gutter=2]="Gutter"})(I||(e.MinimapPosition=I={}));var A;(function(n){n[n.Both=0]="Both",n[n.Right=1]="Right",n[n.Left=2]="Left",n[n.None=3]="None"})(A||(e.InjectedTextCursorStops=A={}));var b;(function(n){n[n.TextDefined=0]="TextDefined",n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(b||(e.EndOfLinePreference=b={}));var $;(function(n){n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})($||(e.DefaultEndOfLine=$={}));var y;(function(n){n[n.LF=0]="LF",n[n.CRLF=1]="CRLF"})(y||(e.EndOfLineSequence=y={}));class L{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(c){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,c.tabSize|0),c.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,c.indentSize|0),this.a=!1),this.insertSpaces=!!c.insertSpaces,this.defaultEOL=c.defaultEOL|0,this.trimAutoWhitespace=!!c.trimAutoWhitespace,this.bracketPairColorizationOptions=c.bracketPairColorizationOptions}equals(c){return this.tabSize===c.tabSize&&this.a===c.a&&this.indentSize===c.indentSize&&this.insertSpaces===c.insertSpaces&&this.defaultEOL===c.defaultEOL&&this.trimAutoWhitespace===c.trimAutoWhitespace&&(0,D.$zn)(this.bracketPairColorizationOptions,c.bracketPairColorizationOptions)}createChangeEvent(c){return{tabSize:this.tabSize!==c.tabSize,indentSize:this.indentSize!==c.indentSize,insertSpaces:this.insertSpaces!==c.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==c.trimAutoWhitespace}}}e.$_u=L;class C{constructor(c,t){this._findMatchBrand=void 0,this.range=c,this.matches=t}}e.$av=C;var m;(function(n){n[n.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",n[n.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",n[n.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",n[n.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(m||(e.TrackedRangeStickiness=m={}));function p(n){return n&&typeof n.read=="function"}e.$bv=p;var S;(function(n){n[n.Left=0]="Left",n[n.Right=1]="Right",n[n.None=2]="None",n[n.LeftOfInjectedText=3]="LeftOfInjectedText",n[n.RightOfInjectedText=4]="RightOfInjectedText"})(S||(e.PositionAffinity=S={}));var h;(function(n){n[n.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(h||(e.ModelConstants=h={}));class f{constructor(c,t,u,s,l,a){this.identifier=c,this.range=t,this.text=u,this.forceMoveMarkers=s,this.isAutoWhitespaceEdit=l,this._isTracked=a}}e.$cv=f;class o{constructor(c,t,u){this.regex=c,this.wordSeparators=t,this.simpleSearch=u}}e.$dv=o;class i{constructor(c,t,u){this.reverseEdits=c,this.changes=t,this.trimAutoWhitespaceLineNumbers=u}}e.$ev=i;function r(n){return!n.isTooLargeForSyncing()&&!n.isForSimpleWidget}e.$fv=r}),define(ke[174],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2B=e.$1B=e.$ZB=e.$YB=e.$XB=e.$WB=e.$VB=e.$UB=e.$TB=e.NodeColor=e.$SB=void 0;class D{constructor(f,o){this.piece=f,this.color=o,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$TB)return g(this.right);let f=this;for(;f.parent!==e.$TB&&f.parent.left!==f;)f=f.parent;return f.parent===e.$TB?e.$TB:f.parent}prev(){if(this.left!==e.$TB)return I(this.left);let f=this;for(;f.parent!==e.$TB&&f.parent.right!==f;)f=f.parent;return f.parent===e.$TB?e.$TB:f.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$SB=D;var O;(function(h){h[h.Black=0]="Black",h[h.Red=1]="Red"})(O||(e.NodeColor=O={})),e.$TB=new D(null,0),e.$TB.parent=e.$TB,e.$TB.left=e.$TB,e.$TB.right=e.$TB,e.$TB.color=0;function g(h){for(;h.left!==e.$TB;)h=h.left;return h}e.$UB=g;function I(h){for(;h.right!==e.$TB;)h=h.right;return h}e.$VB=I;function A(h){return h===e.$TB?0:h.size_left+h.piece.length+A(h.right)}function b(h){return h===e.$TB?0:h.lf_left+h.piece.lineFeedCnt+b(h.right)}function $(){e.$TB.parent=e.$TB}function y(h,f){const o=f.right;o.size_left+=f.size_left+(f.piece?f.piece.length:0),o.lf_left+=f.lf_left+(f.piece?f.piece.lineFeedCnt:0),f.right=o.left,o.left!==e.$TB&&(o.left.parent=f),o.parent=f.parent,f.parent===e.$TB?h.root=o:f.parent.left===f?f.parent.left=o:f.parent.right=o,o.left=f,f.parent=o}e.$WB=y;function L(h,f){const o=f.left;f.left=o.right,o.right!==e.$TB&&(o.right.parent=f),o.parent=f.parent,f.size_left-=o.size_left+(o.piece?o.piece.length:0),f.lf_left-=o.lf_left+(o.piece?o.piece.lineFeedCnt:0),f.parent===e.$TB?h.root=o:f===f.parent.right?f.parent.right=o:f.parent.left=o,o.right=f,f.parent=o}e.$XB=L;function C(h,f){let o,i;if(f.left===e.$TB?(i=f,o=i.right):f.right===e.$TB?(i=f,o=i.left):(i=g(f.right),o=i.right),i===h.root){h.root=o,o.color=0,f.detach(),$(),h.root.parent=e.$TB;return}const r=i.color===1;if(i===i.parent.left?i.parent.left=o:i.parent.right=o,i===f?(o.parent=i.parent,S(h,o)):(i.parent===f?o.parent=i:o.parent=i.parent,S(h,o),i.left=f.left,i.right=f.right,i.parent=f.parent,i.color=f.color,f===h.root?h.root=i:f===f.parent.left?f.parent.left=i:f.parent.right=i,i.left!==e.$TB&&(i.left.parent=i),i.right!==e.$TB&&(i.right.parent=i),i.size_left=f.size_left,i.lf_left=f.lf_left,S(h,i)),f.detach(),o.parent.left===o){const c=A(o),t=b(o);if(c!==o.parent.size_left||t!==o.parent.lf_left){const u=c-o.parent.size_left,s=t-o.parent.lf_left;o.parent.size_left=c,o.parent.lf_left=t,p(h,o.parent,u,s)}}if(S(h,o.parent),r){$();return}let n;for(;o!==h.root&&o.color===0;)o===o.parent.left?(n=o.parent.right,n.color===1&&(n.color=0,o.parent.color=1,y(h,o.parent),n=o.parent.right),n.left.color===0&&n.right.color===0?(n.color=1,o=o.parent):(n.right.color===0&&(n.left.color=0,n.color=1,L(h,n),n=o.parent.right),n.color=o.parent.color,o.parent.color=0,n.right.color=0,y(h,o.parent),o=h.root)):(n=o.parent.left,n.color===1&&(n.color=0,o.parent.color=1,L(h,o.parent),n=o.parent.left),n.left.color===0&&n.right.color===0?(n.color=1,o=o.parent):(n.left.color===0&&(n.right.color=0,n.color=1,y(h,n),n=o.parent.left),n.color=o.parent.color,o.parent.color=0,n.left.color=0,L(h,o.parent),o=h.root));o.color=0,$()}e.$YB=C;function m(h,f){for(S(h,f);f!==h.root&&f.parent.color===1;)if(f.parent===f.parent.parent.left){const o=f.parent.parent.right;o.color===1?(f.parent.color=0,o.color=0,f.parent.parent.color=1,f=f.parent.parent):(f===f.parent.right&&(f=f.parent,y(h,f)),f.parent.color=0,f.parent.parent.color=1,L(h,f.parent.parent))}else{const o=f.parent.parent.left;o.color===1?(f.parent.color=0,o.color=0,f.parent.parent.color=1,f=f.parent.parent):(f===f.parent.left&&(f=f.parent,L(h,f)),f.parent.color=0,f.parent.parent.color=1,y(h,f.parent.parent))}h.root.color=0}e.$ZB=m;function p(h,f,o,i){for(;f!==h.root&&f!==e.$TB;)f.parent.left===f&&(f.parent.size_left+=o,f.parent.lf_left+=i),f=f.parent}e.$1B=p;function S(h,f){let o=0,i=0;if(f!==h.root){for(;f!==h.root&&f===f.parent.right;)f=f.parent;if(f!==h.root)for(f=f.parent,o=A(f.left)-f.size_left,i=b(f.left)-f.lf_left,f.size_left+=o,f.lf_left+=i;f!==h.root&&(o!==0||i!==0);)f.parent.left===f&&(f.parent.size_left+=o,f.parent.lf_left+=i),f=f.parent}}e.$2B=S}),define(ke[175],Se([1,0,19,124]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kv=e.$jv=e.$iv=void 0;class g{constructor($){this.a=$,this.b=new Uint32Array($.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues($,y){$=(0,O.$Ie)($);const L=this.a,C=this.b,m=y.length;return m===0?!1:(this.a=new Uint32Array(L.length+m),this.a.set(L.subarray(0,$),0),this.a.set(L.subarray($),$+m),this.a.set(y,$),$-1<this.c[0]&&(this.c[0]=$-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(C.subarray(0,this.c[0]+1)),!0)}setValue($,y){return $=(0,O.$Ie)($),y=(0,O.$Ie)(y),this.a[$]===y?!1:(this.a[$]=y,$-1<this.c[0]&&(this.c[0]=$-1),!0)}removeValues($,y){$=(0,O.$Ie)($),y=(0,O.$Ie)(y);const L=this.a,C=this.b;if($>=L.length)return!1;const m=L.length-$;return y>=m&&(y=m),y===0?!1:(this.a=new Uint32Array(L.length-y),this.a.set(L.subarray(0,$),0),this.a.set(L.subarray($+y),$),this.b=new Uint32Array(this.a.length),$-1<this.c[0]&&(this.c[0]=$-1),this.c[0]>=0&&this.b.set(C.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum($){return $<0?0:($=(0,O.$Ie)($),this.d($))}d($){if($<=this.c[0])return this.b[$];let y=this.c[0]+1;y===0&&(this.b[0]=this.a[0],y++),$>=this.a.length&&($=this.a.length-1);for(let L=y;L<=$;L++)this.b[L]=this.b[L-1]+this.a[L];return this.c[0]=Math.max(this.c[0],$),this.b[$]}getIndexOf($){$=Math.floor($),this.getTotalSum();let y=0,L=this.a.length-1,C=0,m=0,p=0;for(;y<=L;)if(C=y+(L-y)/2|0,m=this.b[C],p=m-this.a[C],$<p)L=C-1;else if($>=m)y=C+1;else break;return new A(C,$-p)}}e.$iv=g;class I{constructor($){this.a=$,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum($){return this.g(),$===0?0:this.d[$-1]}getIndexOf($){this.g();const y=this.e[$],L=y>0?this.d[y-1]:0;return new A(y,$-L)}removeValues($,y){this.a.splice($,y),this.f($)}insertValues($,y){this.a=(0,D.$Wb)(this.a,$,y),this.f($)}f($){this.b=!1,this.c=Math.min(this.c,$-1)}g(){if(!this.b){for(let $=this.c+1,y=this.a.length;$<y;$++){const L=this.a[$],C=$>0?this.d[$-1]:0;this.d[$]=C+L;for(let m=0;m<L;m++)this.e[C+m]=$}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue($,y){this.a[$]!==y&&(this.a[$]=y,this.f($))}}e.$jv=I;class A{constructor($,y){this.index=$,this.remainder=y,this._prefixSumIndexOfResultBrand=void 0,this.index=$,this.remainder=y}}e.$kv=A}),define(ke[176],Se([1,0,12,48,175]),function(me,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lv=void 0;class I{constructor(b,$,y,L){this.d=b,this.f=$,this.g=y,this.h=L,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(b){b.eol&&b.eol!==this.g&&(this.g=b.eol,this.j=null);const $=b.changes;for(const y of $)this.o(y.range),this.p(new O.$Ts(y.range.startLineNumber,y.range.startColumn),y.text);this.h=b.versionId,this.k=null}l(){if(!this.j){const b=this.g.length,$=this.f.length,y=new Uint32Array($);for(let L=0;L<$;L++)y[L]=this.f[L].length+b;this.j=new g.$iv(y)}}n(b,$){this.f[b]=$,this.j&&this.j.setValue(b,this.f[b].length+this.g.length)}o(b){if(b.startLineNumber===b.endLineNumber){if(b.startColumn===b.endColumn)return;this.n(b.startLineNumber-1,this.f[b.startLineNumber-1].substring(0,b.startColumn-1)+this.f[b.startLineNumber-1].substring(b.endColumn-1));return}this.n(b.startLineNumber-1,this.f[b.startLineNumber-1].substring(0,b.startColumn-1)+this.f[b.endLineNumber-1].substring(b.endColumn-1)),this.f.splice(b.startLineNumber,b.endLineNumber-b.startLineNumber),this.j&&this.j.removeValues(b.startLineNumber,b.endLineNumber-b.startLineNumber)}p(b,$){if($.length===0)return;const y=(0,D.$Ze)($);if(y.length===1){this.n(b.lineNumber-1,this.f[b.lineNumber-1].substring(0,b.column-1)+y[0]+this.f[b.lineNumber-1].substring(b.column-1));return}y[y.length-1]+=this.f[b.lineNumber-1].substring(b.column-1),this.n(b.lineNumber-1,this.f[b.lineNumber-1].substring(0,b.column-1)+y[0]);const L=new Uint32Array(y.length-1);for(let C=1;C<y.length;C++)this.f.splice(b.lineNumber+C-1,0,y[C]),L[C-1]=y[C].length+this.g.length;this.j&&this.j.insertValues(b.lineNumber,L)}}e.$lv=I}),define(ke[99],Se([1,0,12,171,48,29,79]),function(me,e,D,O,g,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8B=e.$7B=e.$6B=e.$5B=e.$4B=e.$3B=void 0;const b=999;class ${constructor(i,r,n,c){this.searchString=i,this.isRegex=r,this.matchCase=n,this.wordSeparators=c}parseSearchRequest(){if(this.searchString==="")return null;let i;this.isRegex?i=y(this.searchString):i=this.searchString.indexOf(`
`)>=0;let r=null;try{r=D.$Xe(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:i,global:!0,unicode:!0})}catch{return null}if(!r)return null;let n=!this.isRegex&&!i;return n&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(n=this.matchCase),new A.$dv(r,this.wordSeparators?(0,O.$it)(this.wordSeparators):null,n?this.searchString:null)}}e.$3B=$;function y(o){if(!o||o.length===0)return!1;for(let i=0,r=o.length;i<r;i++){const n=o.charCodeAt(i);if(n===10)return!0;if(n===92){if(i++,i>=r)break;const c=o.charCodeAt(i);if(c===110||c===114||c===87)return!0}}return!1}e.$4B=y;function L(o,i,r){if(!r)return new A.$av(o,null);const n=[];for(let c=0,t=i.length;c<t;c++)n[c]=i[c];return new A.$av(o,n)}e.$5B=L;class C{constructor(i){const r=[];let n=0;for(let c=0,t=i.length;c<t;c++)i.charCodeAt(c)===10&&(r[n++]=c);this.a=r}findLineFeedCountBeforeOffset(i){const r=this.a;let n=0,c=r.length-1;if(c===-1||i<=r[0])return 0;for(;n<c;){const t=n+((c-n)/2>>0);r[t]>=i?c=t-1:r[t+1]>=i?(n=t,c=t):n=t+1}return n+1}}class m{static findMatches(i,r,n,c,t){const u=r.parseSearchRequest();return u?u.regex.multiline?this.b(i,n,new f(u.wordSeparators,u.regex),c,t):this.c(i,n,u,c,t):[]}static a(i,r,n,c,t,u){let s,l=0;c?(l=c.findLineFeedCountBeforeOffset(t),s=r+t+l):s=r+t;let a;if(c){const v=c.findLineFeedCountBeforeOffset(t+u.length)-l;a=s+u.length+v}else a=s+u.length;const d=i.getPositionAt(s),k=i.getPositionAt(a);return new I.$Us(d.lineNumber,d.column,k.lineNumber,k.column)}static b(i,r,n,c,t){const u=i.getOffsetAt(r.getStartPosition()),s=i.getValueInRange(r,1),l=i.getEOL()===`\r
`?new C(s):null,a=[];let d=0,k;for(n.reset(0);k=n.next(s);)if(a[d++]=L(this.a(i,u,s,l,k.index,k[0]),k,c),d>=t)return a;return a}static c(i,r,n,c,t){const u=[];let s=0;if(r.startLineNumber===r.endLineNumber){const a=i.getLineContent(r.startLineNumber).substring(r.startColumn-1,r.endColumn-1);return s=this.d(n,a,r.startLineNumber,r.startColumn-1,s,u,c,t),u}const l=i.getLineContent(r.startLineNumber).substring(r.startColumn-1);s=this.d(n,l,r.startLineNumber,r.startColumn-1,s,u,c,t);for(let a=r.startLineNumber+1;a<r.endLineNumber&&s<t;a++)s=this.d(n,i.getLineContent(a),a,0,s,u,c,t);if(s<t){const a=i.getLineContent(r.endLineNumber).substring(0,r.endColumn-1);s=this.d(n,a,r.endLineNumber,0,s,u,c,t)}return u}static d(i,r,n,c,t,u,s,l){const a=i.wordSeparators;if(!s&&i.simpleSearch){const R=i.simpleSearch,v=R.length,w=r.length;let E=-v;for(;(E=r.indexOf(R,E+v))!==-1;)if((!a||h(a,r,w,E,v))&&(u[t++]=new A.$av(new I.$Us(n,E+1+c,n,E+1+v+c),null),t>=l))return t;return t}const d=new f(i.wordSeparators,i.regex);let k;d.reset(0);do if(k=d.next(r),k&&(u[t++]=L(new I.$Us(n,k.index+1+c,n,k.index+1+k[0].length+c),k,s),t>=l))return t;while(k);return t}static findNextMatch(i,r,n,c){const t=r.parseSearchRequest();if(!t)return null;const u=new f(t.wordSeparators,t.regex);return t.regex.multiline?this.e(i,n,u,c):this.f(i,n,u,c)}static e(i,r,n,c){const t=new g.$Ts(r.lineNumber,1),u=i.getOffsetAt(t),s=i.getLineCount(),l=i.getValueInRange(new I.$Us(t.lineNumber,t.column,s,i.getLineMaxColumn(s)),1),a=i.getEOL()===`\r
`?new C(l):null;n.reset(r.column-1);const d=n.next(l);return d?L(this.a(i,u,l,a,d.index,d[0]),d,c):r.lineNumber!==1||r.column!==1?this.e(i,new g.$Ts(1,1),n,c):null}static f(i,r,n,c){const t=i.getLineCount(),u=r.lineNumber,s=i.getLineContent(u),l=this.g(n,s,u,r.column,c);if(l)return l;for(let a=1;a<=t;a++){const d=(u+a-1)%t,k=i.getLineContent(d+1),R=this.g(n,k,d+1,1,c);if(R)return R}return null}static g(i,r,n,c,t){i.reset(c-1);const u=i.next(r);return u?L(new I.$Us(n,u.index+1,n,u.index+1+u[0].length),u,t):null}static findPreviousMatch(i,r,n,c){const t=r.parseSearchRequest();if(!t)return null;const u=new f(t.wordSeparators,t.regex);return t.regex.multiline?this.h(i,n,u,c):this.j(i,n,u,c)}static h(i,r,n,c){const t=this.b(i,new I.$Us(1,1,r.lineNumber,r.column),n,c,10*b);if(t.length>0)return t[t.length-1];const u=i.getLineCount();return r.lineNumber!==u||r.column!==i.getLineMaxColumn(u)?this.h(i,new g.$Ts(u,i.getLineMaxColumn(u)),n,c):null}static j(i,r,n,c){const t=i.getLineCount(),u=r.lineNumber,s=i.getLineContent(u).substring(0,r.column-1),l=this.k(n,s,u,c);if(l)return l;for(let a=1;a<=t;a++){const d=(t+u-a-1)%t,k=i.getLineContent(d+1),R=this.k(n,k,d+1,c);if(R)return R}return null}static k(i,r,n,c){let t=null,u;for(i.reset(0);u=i.next(r);)t=L(new I.$Us(n,u.index+1,n,u.index+1+u[0].length),u,c);return t}}e.$6B=m;function p(o,i,r,n,c){if(n===0)return!0;const t=i.charCodeAt(n-1);if(o.get(t)!==0||t===13||t===10)return!0;if(c>0){const u=i.charCodeAt(n);if(o.get(u)!==0)return!0}return!1}function S(o,i,r,n,c){if(n+c===r)return!0;const t=i.charCodeAt(n+c);if(o.get(t)!==0||t===13||t===10)return!0;if(c>0){const u=i.charCodeAt(n+c-1);if(o.get(u)!==0)return!0}return!1}function h(o,i,r,n,c){return p(o,i,r,n,c)&&S(o,i,r,n,c)}e.$7B=h;class f{constructor(i,r){this._wordSeparators=i,this.a=r,this.b=-1,this.c=0}reset(i){this.a.lastIndex=i,this.b=-1,this.c=0}next(i){const r=i.length;let n;do{if(this.b+this.c===r||(n=this.a.exec(i),!n))return null;const c=n.index,t=n[0].length;if(c===this.b&&t===this.c){if(t===0){D.$gf(i,r,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=c,this.c=t,!this._wordSeparators||h(this._wordSeparators,i,r,c,t))return n}while(n);return null}}e.$8B=f}),define(ke[127],Se([1,0,48,29,79,174,99]),function(me,e,D,O,g,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aC=e.$_B=e.$$B=e.$0B=e.$9B=void 0;const b=65535;function $(o){let i;return o[o.length-1]<65536?i=new Uint16Array(o.length):i=new Uint32Array(o.length),i.set(o,0),i}class y{constructor(i,r,n,c,t){this.lineStarts=i,this.cr=r,this.lf=n,this.crlf=c,this.isBasicASCII=t}}function L(o,i=!0){const r=[0];let n=1;for(let c=0,t=o.length;c<t;c++){const u=o.charCodeAt(c);u===13?c+1<t&&o.charCodeAt(c+1)===10?(r[n++]=c+2,c++):r[n++]=c+1:u===10&&(r[n++]=c+1)}return i?$(r):r}e.$9B=L;function C(o,i){o.length=0,o[0]=0;let r=1,n=0,c=0,t=0,u=!0;for(let l=0,a=i.length;l<a;l++){const d=i.charCodeAt(l);d===13?l+1<a&&i.charCodeAt(l+1)===10?(t++,o[r++]=l+2,l++):(n++,o[r++]=l+1):d===10?(c++,o[r++]=l+1):u&&d!==9&&(d<32||d>126)&&(u=!1)}const s=new y($(o),n,c,t,u);return o.length=0,s}e.$0B=C;class m{constructor(i,r,n,c,t){this.bufferIndex=i,this.start=r,this.end=n,this.lineFeedCnt=c,this.length=t}}e.$$B=m;class p{constructor(i,r){this.buffer=i,this.lineStarts=r}}e.$_B=p;class S{constructor(i,r){this.a=[],this.c=i,this.d=r,this.b=0,i.root!==I.$TB&&i.iterate(i.root,n=>(n!==I.$TB&&this.a.push(n.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class h{constructor(i){this.a=i,this.b=[]}get(i){for(let r=this.b.length-1;r>=0;r--){const n=this.b[r];if(n.nodeStartOffset<=i&&n.nodeStartOffset+n.node.piece.length>=i)return n}return null}get2(i){for(let r=this.b.length-1;r>=0;r--){const n=this.b[r];if(n.nodeStartLineNumber&&n.nodeStartLineNumber<i&&n.nodeStartLineNumber+n.node.piece.lineFeedCnt>=i)return n}return null}set(i){this.b.length>=this.a&&this.b.shift(),this.b.push(i)}validate(i){let r=!1;const n=this.b;for(let c=0;c<n.length;c++){const t=n[c];if(t.node.parent===null||t.nodeStartOffset>=i){n[c]=null,r=!0;continue}}if(r){const c=[];for(const t of n)t!==null&&c.push(t);this.b=c}}}class f{constructor(i,r,n){this.create(i,r,n)}create(i,r,n){this.a=[new p("",[0])],this.g={line:0,column:0},this.root=I.$TB,this.b=1,this.c=0,this.d=r,this.e=r.length,this.f=n;let c=null;for(let t=0,u=i.length;t<u;t++)if(i[t].buffer.length>0){i[t].lineStarts||(i[t].lineStarts=L(i[t].buffer));const s=new m(t+1,{line:0,column:0},{line:i[t].lineStarts.length-1,column:i[t].buffer.length-i[t].lineStarts[i[t].lineStarts.length-1]},i[t].lineStarts.length-1,i[t].buffer.length);this.a.push(i[t]),c=this.S(c,s)}this.h=new h(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(i){const r=b,n=r-Math.floor(r/3),c=n*2;let t="",u=0;const s=[];if(this.iterate(this.root,l=>{const a=this.R(l),d=a.length;if(u<=n||u+d<c)return t+=a,u+=d,!0;const k=t.replace(/\r\n|\r|\n/g,i);return s.push(new p(k,L(k))),t=a,u=d,!0}),u>0){const l=t.replace(/\r\n|\r|\n/g,i);s.push(new p(l,L(l)))}this.create(s,i,!0)}getEOL(){return this.d}setEOL(i){this.d=i,this.e=this.d.length,this.normalizeEOL(i)}createSnapshot(i){return new S(this,i)}equal(i){if(this.getLength()!==i.getLength()||this.getLineCount()!==i.getLineCount())return!1;let r=0;return this.iterate(this.root,c=>{if(c===I.$TB)return!0;const t=this.R(c),u=t.length,s=i.G(r),l=i.G(r+u),a=i.getValueInRange2(s,l);return r+=u,t===a})}getOffsetAt(i,r){let n=0,c=this.root;for(;c!==I.$TB;)if(c.left!==I.$TB&&c.lf_left+1>=i)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt+1>=i){n+=c.size_left;const t=this.B(c,i-c.lf_left-2);return n+=t+r-1}else i-=c.lf_left+c.piece.lineFeedCnt,n+=c.size_left+c.piece.length,c=c.right;return n}getPositionAt(i){i=Math.floor(i),i=Math.max(0,i);let r=this.root,n=0;const c=i;for(;r!==I.$TB;)if(r.size_left!==0&&r.size_left>=i)r=r.left;else if(r.size_left+r.piece.length>=i){const t=this.A(r,i-r.size_left);if(n+=r.lf_left+t.index,t.index===0){const u=this.getOffsetAt(n+1,1),s=c-u;return new D.$Ts(n+1,s+1)}return new D.$Ts(n+1,t.remainder+1)}else if(i-=r.size_left+r.piece.length,n+=r.lf_left+r.piece.lineFeedCnt,r.right===I.$TB){const t=this.getOffsetAt(n+1,1),u=c-i-t;return new D.$Ts(n+1,u+1)}else r=r.right;return new D.$Ts(1,1)}getValueInRange(i,r){if(i.startLineNumber===i.endLineNumber&&i.startColumn===i.endColumn)return"";const n=this.H(i.startLineNumber,i.startColumn),c=this.H(i.endLineNumber,i.endColumn),t=this.getValueInRange2(n,c);return r?r!==this.d||!this.f?t.replace(/\r\n|\r|\n/g,r):r===this.getEOL()&&this.f?t:t.replace(/\r\n|\r|\n/g,r):t}getValueInRange2(i,r){if(i.node===r.node){const s=i.node,l=this.a[s.piece.bufferIndex].buffer,a=this.u(s.piece.bufferIndex,s.piece.start);return l.substring(a+i.remainder,a+r.remainder)}let n=i.node;const c=this.a[n.piece.bufferIndex].buffer,t=this.u(n.piece.bufferIndex,n.piece.start);let u=c.substring(t+i.remainder,t+n.piece.length);for(n=n.next();n!==I.$TB;){const s=this.a[n.piece.bufferIndex].buffer,l=this.u(n.piece.bufferIndex,n.piece.start);if(n===r.node){u+=s.substring(l,l+r.remainder);break}else u+=s.substr(l,n.piece.length);n=n.next()}return u}getLinesContent(){const i=[];let r=0,n="",c=!1;return this.iterate(this.root,t=>{if(t===I.$TB)return!0;const u=t.piece;let s=u.length;if(s===0)return!0;const l=this.a[u.bufferIndex].buffer,a=this.a[u.bufferIndex].lineStarts,d=u.start.line,k=u.end.line;let R=a[d]+u.start.column;if(c&&(l.charCodeAt(R)===10&&(R++,s--),i[r++]=n,n="",c=!1,s===0))return!0;if(d===k)return!this.f&&l.charCodeAt(R+s-1)===13?(c=!0,n+=l.substr(R,s-1)):n+=l.substr(R,s),!0;n+=this.f?l.substring(R,Math.max(R,a[d+1]-this.e)):l.substring(R,a[d+1]).replace(/(\r\n|\r|\n)$/,""),i[r++]=n;for(let v=d+1;v<k;v++)n=this.f?l.substring(a[v],a[v+1]-this.e):l.substring(a[v],a[v+1]).replace(/(\r\n|\r|\n)$/,""),i[r++]=n;return!this.f&&l.charCodeAt(a[k]+u.end.column-1)===13?(c=!0,u.end.column===0?r--:n=l.substr(a[k],u.end.column-1)):n=l.substr(a[k],u.end.column),!0}),c&&(i[r++]=n,n=""),i[r++]=n,i}getLength(){return this.c}getLineCount(){return this.b}getLineContent(i){return this.j.lineNumber===i?this.j.value:(this.j.lineNumber=i,i===this.b?this.j.value=this.getLineRawContent(i):this.f?this.j.value=this.getLineRawContent(i,this.e):this.j.value=this.getLineRawContent(i).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(i){if(i.remainder===i.node.piece.length){const r=i.node.next();if(!r)return 0;const n=this.a[r.piece.bufferIndex],c=this.u(r.piece.bufferIndex,r.piece.start);return n.buffer.charCodeAt(c)}else{const r=this.a[i.node.piece.bufferIndex],c=this.u(i.node.piece.bufferIndex,i.node.piece.start)+i.remainder;return r.buffer.charCodeAt(c)}}getLineCharCode(i,r){const n=this.H(i,r+1);return this.l(n)}getLineLength(i){if(i===this.getLineCount()){const r=this.getOffsetAt(i,1);return this.getLength()-r}return this.getOffsetAt(i+1,1)-this.getOffsetAt(i,1)-this.e}getCharCode(i){const r=this.G(i);return this.l(r)}findMatchesInNode(i,r,n,c,t,u,s,l,a,d,k){const R=this.a[i.piece.bufferIndex],v=this.u(i.piece.bufferIndex,i.piece.start),w=this.u(i.piece.bufferIndex,t),E=this.u(i.piece.bufferIndex,u);let P;const N={line:0,column:0};let U,F;r._wordSeparators?(U=R.buffer.substring(w,E),F=j=>j+w,r.reset(0)):(U=R.buffer,F=j=>j,r.reset(w));do if(P=r.next(U),P){if(F(P.index)>=E)return d;this.s(i,F(P.index)-v,N);const j=this.t(i.piece.bufferIndex,t,N),T=N.line===t.line?N.column-t.column+c:N.column+1,M=T+P[0].length;if(k[d++]=(0,A.$5B)(new O.$Us(n+j,T,n+j,M),P,l),F(P.index)+P[0].length>=E||d>=a)return d}while(P);return d}findMatchesLineByLine(i,r,n,c){const t=[];let u=0;const s=new A.$8B(r.wordSeparators,r.regex);let l=this.H(i.startLineNumber,i.startColumn);if(l===null)return[];const a=this.H(i.endLineNumber,i.endColumn);if(a===null)return[];let d=this.s(l.node,l.remainder);const k=this.s(a.node,a.remainder);if(l.node===a.node)return this.findMatchesInNode(l.node,s,i.startLineNumber,i.startColumn,d,k,r,n,c,u,t),t;let R=i.startLineNumber,v=l.node;for(;v!==a.node;){const E=this.t(v.piece.bufferIndex,d,v.piece.end);if(E>=1){const N=this.a[v.piece.bufferIndex].lineStarts,U=this.u(v.piece.bufferIndex,v.piece.start),F=N[d.line+E],j=R===i.startLineNumber?i.startColumn:1;if(u=this.findMatchesInNode(v,s,R,j,d,this.s(v,F-U),r,n,c,u,t),u>=c)return t;R+=E}const P=R===i.startLineNumber?i.startColumn-1:0;if(R===i.endLineNumber){const N=this.getLineContent(R).substring(P,i.endColumn-1);return u=this.n(r,s,N,i.endLineNumber,P,u,t,n,c),t}if(u=this.n(r,s,this.getLineContent(R).substr(P),R,P,u,t,n,c),u>=c)return t;R++,l=this.H(R,1),v=l.node,d=this.s(l.node,l.remainder)}if(R===i.endLineNumber){const E=R===i.startLineNumber?i.startColumn-1:0,P=this.getLineContent(R).substring(E,i.endColumn-1);return u=this.n(r,s,P,i.endLineNumber,E,u,t,n,c),t}const w=R===i.startLineNumber?i.startColumn:1;return u=this.findMatchesInNode(a.node,s,R,w,d,k,r,n,c,u,t),t}n(i,r,n,c,t,u,s,l,a){const d=i.wordSeparators;if(!l&&i.simpleSearch){const R=i.simpleSearch,v=R.length,w=n.length;let E=-v;for(;(E=n.indexOf(R,E+v))!==-1;)if((!d||(0,A.$7B)(d,n,w,E,v))&&(s[u++]=new g.$av(new O.$Us(c,E+1+t,c,E+1+v+t),null),u>=a))return u;return u}let k;r.reset(0);do if(k=r.next(n),k&&(s[u++]=(0,A.$5B)(new O.$Us(c,k.index+1+t,c,k.index+1+k[0].length+t),k,l),u>=a))return u;while(k);return u}insert(i,r,n=!1){if(this.f=this.f&&n,this.j.lineNumber=0,this.j.value="",this.root!==I.$TB){const{node:c,remainder:t,nodeStartOffset:u}=this.G(i),s=c.piece,l=s.bufferIndex,a=this.s(c,t);if(c.piece.bufferIndex===0&&s.end.line===this.g.line&&s.end.column===this.g.column&&u+s.length===i&&r.length<b){this.F(c,r),this.y();return}if(u===i)this.o(r,c),this.h.validate(i);else if(u+c.piece.length>i){const d=[];let k=new m(s.bufferIndex,a,s.end,this.t(s.bufferIndex,a,s.end),this.u(l,s.end)-this.u(l,a));if(this.K()&&this.M(r)&&this.I(c,t)===10){const E={line:k.start.line+1,column:0};k=new m(k.bufferIndex,E,k.end,this.t(k.bufferIndex,E,k.end),k.length-1),r+=`
`}if(this.K()&&this.L(r))if(this.I(c,t-1)===13){const E=this.s(c,t-1);this.C(c,E),r="\r"+r,c.piece.length===0&&d.push(c)}else this.C(c,a);else this.C(c,a);const R=this.w(r);k.length>0&&this.S(c,k);let v=c;for(let w=0;w<R.length;w++)v=this.S(v,R[w]);this.v(d)}else this.q(r,c)}else{const c=this.w(r);let t=this.T(null,c[0]);for(let u=1;u<c.length;u++)t=this.S(t,c[u])}this.y()}delete(i,r){if(this.j.lineNumber=0,this.j.value="",r<=0||this.root===I.$TB)return;const n=this.G(i),c=this.G(i+r),t=n.node,u=c.node;if(t===u){const R=this.s(t,n.remainder),v=this.s(t,c.remainder);if(n.nodeStartOffset===i){if(r===t.piece.length){const w=t.next();(0,I.$YB)(this,t),this.N(w),this.y();return}this.D(t,v),this.h.validate(i),this.N(t),this.y();return}if(n.nodeStartOffset+t.piece.length===i+r){this.C(t,R),this.O(t),this.y();return}this.E(t,R,v),this.y();return}const s=[],l=this.s(t,n.remainder);this.C(t,l),this.h.validate(i),t.piece.length===0&&s.push(t);const a=this.s(u,c.remainder);this.D(u,a),u.piece.length===0&&s.push(u);const d=t.next();for(let R=d;R!==I.$TB&&R!==u;R=R.next())s.push(R);const k=t.piece.length===0?t.prev():t;this.v(s),this.O(k),this.y()}o(i,r){const n=[];if(this.K()&&this.M(i)&&this.L(r)){const u=r.piece,s={line:u.start.line+1,column:0},l=new m(u.bufferIndex,s,u.end,this.t(u.bufferIndex,s,u.end),u.length-1);r.piece=l,i+=`
`,(0,I.$1B)(this,r,-1,-1),r.piece.length===0&&n.push(r)}const c=this.w(i);let t=this.T(r,c[c.length-1]);for(let u=c.length-2;u>=0;u--)t=this.T(t,c[u]);this.N(t),this.v(n)}q(i,r){this.Q(i,r)&&(i+=`
`);const n=this.w(i),c=this.S(r,n[0]);let t=c;for(let u=1;u<n.length;u++)t=this.S(t,n[u]);this.N(c)}s(i,r,n){const c=i.piece,t=i.piece.bufferIndex,u=this.a[t].lineStarts,l=u[c.start.line]+c.start.column+r;let a=c.start.line,d=c.end.line,k=0,R=0,v=0;for(;a<=d&&(k=a+(d-a)/2|0,v=u[k],k!==d);)if(R=u[k+1],l<v)d=k-1;else if(l>=R)a=k+1;else break;return n?(n.line=k,n.column=l-v,null):{line:k,column:l-v}}t(i,r,n){if(n.column===0)return n.line-r.line;const c=this.a[i].lineStarts;if(n.line===c.length-1)return n.line-r.line;const t=c[n.line+1],u=c[n.line]+n.column;if(t>u+1)return n.line-r.line;const s=u-1;return this.a[i].buffer.charCodeAt(s)===13?n.line-r.line+1:n.line-r.line}u(i,r){return this.a[i].lineStarts[r.line]+r.column}v(i){for(let r=0;r<i.length;r++)(0,I.$YB)(this,i[r])}w(i){if(i.length>b){const d=[];for(;i.length>b;){const R=i.charCodeAt(b-1);let v;R===13||R>=55296&&R<=56319?(v=i.substring(0,b-1),i=i.substring(b-1)):(v=i.substring(0,b),i=i.substring(b));const w=L(v);d.push(new m(this.a.length,{line:0,column:0},{line:w.length-1,column:v.length-w[w.length-1]},w.length-1,v.length)),this.a.push(new p(v,w))}const k=L(i);return d.push(new m(this.a.length,{line:0,column:0},{line:k.length-1,column:i.length-k[k.length-1]},k.length-1,i.length)),this.a.push(new p(i,k)),d}let r=this.a[0].buffer.length;const n=L(i,!1);let c=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===r&&r!==0&&this.L(i)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},c=this.g;for(let d=0;d<n.length;d++)n[d]+=r+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(n.slice(1)),this.a[0].buffer+="_"+i,r+=1}else{if(r!==0)for(let d=0;d<n.length;d++)n[d]+=r;this.a[0].lineStarts=this.a[0].lineStarts.concat(n.slice(1)),this.a[0].buffer+=i}const t=this.a[0].buffer.length,u=this.a[0].lineStarts.length-1,s=t-this.a[0].lineStarts[u],l={line:u,column:s},a=new m(0,c,l,this.t(0,c,l),t-r);return this.g=l,[a]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(i,r=0){let n=this.root,c="";const t=this.h.get2(i);if(t){n=t.node;const u=this.B(n,i-t.nodeStartLineNumber-1),s=this.a[n.piece.bufferIndex].buffer,l=this.u(n.piece.bufferIndex,n.piece.start);if(t.nodeStartLineNumber+n.piece.lineFeedCnt===i)c=s.substring(l+u,l+n.piece.length);else{const a=this.B(n,i-t.nodeStartLineNumber);return s.substring(l+u,l+a-r)}}else{let u=0;const s=i;for(;n!==I.$TB;)if(n.left!==I.$TB&&n.lf_left>=i-1)n=n.left;else if(n.lf_left+n.piece.lineFeedCnt>i-1){const l=this.B(n,i-n.lf_left-2),a=this.B(n,i-n.lf_left-1),d=this.a[n.piece.bufferIndex].buffer,k=this.u(n.piece.bufferIndex,n.piece.start);return u+=n.size_left,this.h.set({node:n,nodeStartOffset:u,nodeStartLineNumber:s-(i-1-n.lf_left)}),d.substring(k+l,k+a-r)}else if(n.lf_left+n.piece.lineFeedCnt===i-1){const l=this.B(n,i-n.lf_left-2),a=this.a[n.piece.bufferIndex].buffer,d=this.u(n.piece.bufferIndex,n.piece.start);c=a.substring(d+l,d+n.piece.length);break}else i-=n.lf_left+n.piece.lineFeedCnt,u+=n.size_left+n.piece.length,n=n.right}for(n=n.next();n!==I.$TB;){const u=this.a[n.piece.bufferIndex].buffer;if(n.piece.lineFeedCnt>0){const s=this.B(n,0),l=this.u(n.piece.bufferIndex,n.piece.start);return c+=u.substring(l,l+s-r),c}else{const s=this.u(n.piece.bufferIndex,n.piece.start);c+=u.substr(s,n.piece.length)}n=n.next()}return c}y(){let i=this.root,r=1,n=0;for(;i!==I.$TB;)r+=i.lf_left+i.piece.lineFeedCnt,n+=i.size_left+i.piece.length,i=i.right;this.b=r,this.c=n,this.h.validate(this.c)}A(i,r){const n=i.piece,c=this.s(i,r),t=c.line-n.start.line;if(this.u(n.bufferIndex,n.end)-this.u(n.bufferIndex,n.start)===r){const u=this.t(i.piece.bufferIndex,n.start,c);if(u!==t)return{index:u,remainder:0}}return{index:t,remainder:c.column}}B(i,r){if(r<0)return 0;const n=i.piece,c=this.a[n.bufferIndex].lineStarts,t=n.start.line+r+1;return t>n.end.line?c[n.end.line]+n.end.column-c[n.start.line]-n.start.column:c[t]-c[n.start.line]-n.start.column}C(i,r){const n=i.piece,c=n.lineFeedCnt,t=this.u(n.bufferIndex,n.end),u=r,s=this.u(n.bufferIndex,u),l=this.t(n.bufferIndex,n.start,u),a=l-c,d=s-t,k=n.length+d;i.piece=new m(n.bufferIndex,n.start,u,l,k),(0,I.$1B)(this,i,d,a)}D(i,r){const n=i.piece,c=n.lineFeedCnt,t=this.u(n.bufferIndex,n.start),u=r,s=this.t(n.bufferIndex,u,n.end),l=this.u(n.bufferIndex,u),a=s-c,d=t-l,k=n.length+d;i.piece=new m(n.bufferIndex,u,n.end,s,k),(0,I.$1B)(this,i,d,a)}E(i,r,n){const c=i.piece,t=c.start,u=c.end,s=c.length,l=c.lineFeedCnt,a=r,d=this.t(c.bufferIndex,c.start,a),k=this.u(c.bufferIndex,r)-this.u(c.bufferIndex,t);i.piece=new m(c.bufferIndex,c.start,a,d,k),(0,I.$1B)(this,i,k-s,d-l);const R=new m(c.bufferIndex,n,u,this.t(c.bufferIndex,n,u),this.u(c.bufferIndex,u)-this.u(c.bufferIndex,n)),v=this.S(i,R);this.N(v)}F(i,r){this.Q(r,i)&&(r+=`
`);const n=this.K()&&this.L(r)&&this.M(i),c=this.a[0].buffer.length;this.a[0].buffer+=r;const t=L(r,!1);for(let v=0;v<t.length;v++)t[v]+=c;if(n){const v=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:c-v}}this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1));const u=this.a[0].lineStarts.length-1,s=this.a[0].buffer.length-this.a[0].lineStarts[u],l={line:u,column:s},a=i.piece.length+r.length,d=i.piece.lineFeedCnt,k=this.t(0,i.piece.start,l),R=k-d;i.piece=new m(i.piece.bufferIndex,i.piece.start,l,k,a),this.g=l,(0,I.$1B)(this,i,r.length,R)}G(i){let r=this.root;const n=this.h.get(i);if(n)return{node:n.node,nodeStartOffset:n.nodeStartOffset,remainder:i-n.nodeStartOffset};let c=0;for(;r!==I.$TB;)if(r.size_left>i)r=r.left;else if(r.size_left+r.piece.length>=i){c+=r.size_left;const t={node:r,remainder:i-r.size_left,nodeStartOffset:c};return this.h.set(t),t}else i-=r.size_left+r.piece.length,c+=r.size_left+r.piece.length,r=r.right;return null}H(i,r){let n=this.root,c=0;for(;n!==I.$TB;)if(n.left!==I.$TB&&n.lf_left>=i-1)n=n.left;else if(n.lf_left+n.piece.lineFeedCnt>i-1){const t=this.B(n,i-n.lf_left-2),u=this.B(n,i-n.lf_left-1);return c+=n.size_left,{node:n,remainder:Math.min(t+r-1,u),nodeStartOffset:c}}else if(n.lf_left+n.piece.lineFeedCnt===i-1){const t=this.B(n,i-n.lf_left-2);if(t+r-1<=n.piece.length)return{node:n,remainder:t+r-1,nodeStartOffset:c};r-=n.piece.length-t;break}else i-=n.lf_left+n.piece.lineFeedCnt,c+=n.size_left+n.piece.length,n=n.right;for(n=n.next();n!==I.$TB;){if(n.piece.lineFeedCnt>0){const t=this.B(n,0),u=this.J(n);return{node:n,remainder:Math.min(r-1,t),nodeStartOffset:u}}else if(n.piece.length>=r-1){const t=this.J(n);return{node:n,remainder:r-1,nodeStartOffset:t}}else r-=n.piece.length;n=n.next()}return null}I(i,r){if(i.piece.lineFeedCnt<1)return-1;const n=this.a[i.piece.bufferIndex],c=this.u(i.piece.bufferIndex,i.piece.start)+r;return n.buffer.charCodeAt(c)}J(i){if(!i)return 0;let r=i.size_left;for(;i!==this.root;)i.parent.right===i&&(r+=i.parent.size_left+i.parent.piece.length),i=i.parent;return r}K(){return!(this.f&&this.d===`
`)}L(i){if(typeof i=="string")return i.charCodeAt(0)===10;if(i===I.$TB||i.piece.lineFeedCnt===0)return!1;const r=i.piece,n=this.a[r.bufferIndex].lineStarts,c=r.start.line,t=n[c]+r.start.column;return c===n.length-1||n[c+1]>t+1?!1:this.a[r.bufferIndex].buffer.charCodeAt(t)===10}M(i){return typeof i=="string"?i.charCodeAt(i.length-1)===13:i===I.$TB||i.piece.lineFeedCnt===0?!1:this.I(i,i.piece.length-1)===13}N(i){if(this.K()&&this.L(i)){const r=i.prev();this.M(r)&&this.P(r,i)}}O(i){if(this.K()&&this.M(i)){const r=i.next();this.L(r)&&this.P(i,r)}}P(i,r){const n=[],c=this.a[i.piece.bufferIndex].lineStarts;let t;i.piece.end.column===0?t={line:i.piece.end.line-1,column:c[i.piece.end.line]-c[i.piece.end.line-1]-1}:t={line:i.piece.end.line,column:i.piece.end.column-1};const u=i.piece.length-1,s=i.piece.lineFeedCnt-1;i.piece=new m(i.piece.bufferIndex,i.piece.start,t,s,u),(0,I.$1B)(this,i,-1,-1),i.piece.length===0&&n.push(i);const l={line:r.piece.start.line+1,column:0},a=r.piece.length-1,d=this.t(r.piece.bufferIndex,l,r.piece.end);r.piece=new m(r.piece.bufferIndex,l,r.piece.end,d,a),(0,I.$1B)(this,r,-1,-1),r.piece.length===0&&n.push(r);const k=this.w(`\r
`);this.S(i,k[0]);for(let R=0;R<n.length;R++)(0,I.$YB)(this,n[R])}Q(i,r){if(this.K()&&this.M(i)){const n=r.next();if(this.L(n)){if(i+=`
`,n.piece.length===1)(0,I.$YB)(this,n);else{const c=n.piece,t={line:c.start.line+1,column:0},u=c.length-1,s=this.t(c.bufferIndex,t,c.end);n.piece=new m(c.bufferIndex,t,c.end,s,u),(0,I.$1B)(this,n,-1,-1)}return!0}}return!1}iterate(i,r){if(i===I.$TB)return r(I.$TB);const n=this.iterate(i.left,r);return n&&r(i)&&this.iterate(i.right,r)}R(i){if(i===I.$TB)return"";const r=this.a[i.piece.bufferIndex],n=i.piece,c=this.u(n.bufferIndex,n.start),t=this.u(n.bufferIndex,n.end);return r.buffer.substring(c,t)}getPieceContent(i){const r=this.a[i.bufferIndex],n=this.u(i.bufferIndex,i.start),c=this.u(i.bufferIndex,i.end);return r.buffer.substring(n,c)}S(i,r){const n=new I.$SB(r,1);if(n.left=I.$TB,n.right=I.$TB,n.parent=I.$TB,n.size_left=0,n.lf_left=0,this.root===I.$TB)this.root=n,n.color=0;else if(i.right===I.$TB)i.right=n,n.parent=i;else{const t=(0,I.$UB)(i.right);t.left=n,n.parent=t}return(0,I.$ZB)(this,n),n}T(i,r){const n=new I.$SB(r,1);if(n.left=I.$TB,n.right=I.$TB,n.parent=I.$TB,n.size_left=0,n.lf_left=0,this.root===I.$TB)this.root=n,n.color=0;else if(i.left===I.$TB)i.left=n,n.parent=i;else{const c=(0,I.$VB)(i.left);c.right=n,n.parent=c}return(0,I.$ZB)(this,n),n}U(i){let r="";return this.iterate(i,n=>(r+=this.R(n),!0)),r}}e.$aC=f}),define(ke[177],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$k8=e.$j8=void 0;class D{constructor(){this.a=new Map}removeDragOperationTransfer(I){if(I&&this.a.has(I)){const A=this.a.get(I);return this.a.delete(I),A}}addDragOperationTransfer(I,A){this.a.set(I,A)}}e.$j8=D;class O{constructor(I){this.identifier=I}}e.$k8=O}),define(ke[178],Se([1,0,4,3]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tt=void 0;class g{constructor(){this.a=new Map,this.b=new Map,this.c=new D.$Vd,this.onDidChange=this.c.event,this.d=null}handleChange(b){this.c.fire({changedLanguages:b,changedColorMap:!1})}register(b,$){return this.a.set(b,$),this.handleChange([b]),(0,O.$Rc)(()=>{this.a.get(b)===$&&(this.a.delete(b),this.handleChange([b]))})}get(b){return this.a.get(b)||null}registerFactory(b,$){this.b.get(b)?.dispose();const y=new I(this,b,$);return this.b.set(b,y),(0,O.$Rc)(()=>{const L=this.b.get(b);!L||L!==y||(this.b.delete(b),L.dispose())})}async getOrCreate(b){const $=this.get(b);if($)return $;const y=this.b.get(b);return!y||y.isResolved?null:(await y.resolve(),this.get(b))}isResolved(b){if(this.get(b))return!0;const y=this.b.get(b);return!!(!y||y.isResolved)}setColorMap(b){this.d=b,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.$tt=g;class I extends O.$Tc{get isResolved(){return this.c}constructor(b,$,y){super(),this.f=b,this.g=$,this.h=y,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const b=await this.h.tokenizationSupport;this.c=!0,b&&!this.a&&this.B(this.f.register(this.g,b))}}}),define(ke[179],Se([8,9]),function(me,e){return me.create("vs/base/common/actions",e)}),define(ke[180],Se([1,0,4,3,179]),function(me,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=void 0;class I extends O.$Tc{constructor(m,p="",S="",h=!0,f){super(),this.h=this.B(new D.$Vd),this.onDidChange=this.h.event,this.w=!0,this.j=m,this.m=p,this.u=S,this.w=h,this.C=f}get id(){return this.j}get label(){return this.m}set label(m){this.D(m)}D(m){this.m!==m&&(this.m=m,this.h.fire({label:m}))}get tooltip(){return this.n||""}set tooltip(m){this.F(m)}F(m){this.n!==m&&(this.n=m,this.h.fire({tooltip:m}))}get class(){return this.u}set class(m){this.G(m)}G(m){this.u!==m&&(this.u=m,this.h.fire({class:m}))}get enabled(){return this.w}set enabled(m){this.H(m)}H(m){this.w!==m&&(this.w=m,this.h.fire({enabled:m}))}get checked(){return this.z}set checked(m){this.I(m)}I(m){this.z!==m&&(this.z=m,this.h.fire({checked:m}))}async run(m,p){this.C&&await this.C(m)}}e.$Ki=I;class A extends O.$Tc{constructor(){super(...arguments),this.f=this.B(new D.$Vd),this.onWillRun=this.f.event,this.m=this.B(new D.$Vd),this.onDidRun=this.m.event}async run(m,p){if(!m.enabled)return;this.f.fire({action:m});let S;try{await this.u(m,p)}catch(h){S=h}this.m.fire({action:m,error:S})}async u(m,p){await m.run(p)}}e.$Li=A;class b{constructor(){this.id=b.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...m){let p=[];for(const S of m)S.length&&(p.length?p=[...p,new b,...S]:p=S);return p}static{this.ID="vs.actions.separator"}async run(){}}e.$Mi=b;class ${get actions(){return this.a}constructor(m,p,S,h){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=m,this.label=p,this.class=h,this.a=S}async run(){}}e.$Ni=$;class y extends I{static{this.ID="vs.actions.empty"}constructor(){super(y.ID,g.localize(0,null),void 0,!1)}}e.$Oi=y;function L(C){return{id:C.id,label:C.label,class:C.class,enabled:C.enabled??!0,checked:C.checked??!1,run:async(...m)=>C.run(...m),tooltip:C.label}}e.$Pi=L}),define(ke[181],Se([8,9]),function(me,e){return me.create("vs/base/common/date",e)}),define(ke[182],Se([1,0,181]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wm=e.$vm=void 0;const O=60,g=O*60,I=g*24,A=I*7,b=I*30,$=I*365;function y(C,m,p,S){typeof C!="number"&&(C=C.getTime());const h=Math.round((new Date().getTime()-C)/1e3);if(h<-30)return(0,D.localize)(0,null,y(new Date().getTime()+h*1e3,!1));if(!S&&h<30)return(0,D.localize)(1,null);let f;return h<O?(f=h,m?f===1?p?(0,D.localize)(2,null,f):(0,D.localize)(3,null,f):p?(0,D.localize)(4,null,f):(0,D.localize)(5,null,f):f===1?p?(0,D.localize)(6,null,f):(0,D.localize)(7,null,f):p?(0,D.localize)(8,null,f):(0,D.localize)(9,null,f)):h<g?(f=Math.floor(h/O),m?f===1?p?(0,D.localize)(10,null,f):(0,D.localize)(11,null,f):p?(0,D.localize)(12,null,f):(0,D.localize)(13,null,f):f===1?p?(0,D.localize)(14,null,f):(0,D.localize)(15,null,f):p?(0,D.localize)(16,null,f):(0,D.localize)(17,null,f)):h<I?(f=Math.floor(h/g),m?f===1?p?(0,D.localize)(18,null,f):(0,D.localize)(19,null,f):p?(0,D.localize)(20,null,f):(0,D.localize)(21,null,f):f===1?p?(0,D.localize)(22,null,f):(0,D.localize)(23,null,f):p?(0,D.localize)(24,null,f):(0,D.localize)(25,null,f)):h<A?(f=Math.floor(h/I),m?f===1?(0,D.localize)(26,null,f):(0,D.localize)(27,null,f):f===1?(0,D.localize)(28,null,f):(0,D.localize)(29,null,f)):h<b?(f=Math.floor(h/A),m?f===1?p?(0,D.localize)(30,null,f):(0,D.localize)(31,null,f):p?(0,D.localize)(32,null,f):(0,D.localize)(33,null,f):f===1?p?(0,D.localize)(34,null,f):(0,D.localize)(35,null,f):p?(0,D.localize)(36,null,f):(0,D.localize)(37,null,f)):h<$?(f=Math.floor(h/b),m?f===1?p?(0,D.localize)(38,null,f):(0,D.localize)(39,null,f):p?(0,D.localize)(40,null,f):(0,D.localize)(41,null,f):f===1?p?(0,D.localize)(42,null,f):(0,D.localize)(43,null,f):p?(0,D.localize)(44,null,f):(0,D.localize)(45,null,f)):(f=Math.floor(h/$),m?f===1?p?(0,D.localize)(46,null,f):(0,D.localize)(47,null,f):p?(0,D.localize)(48,null,f):(0,D.localize)(49,null,f):f===1?p?(0,D.localize)(50,null,f):(0,D.localize)(51,null,f):p?(0,D.localize)(52,null,f):(0,D.localize)(53,null,f))}e.$vm=y;function L(C){return C.getFullYear()+"-"+String(C.getMonth()+1).padStart(2,"0")+"-"+String(C.getDate()).padStart(2,"0")+"T"+String(C.getHours()).padStart(2,"0")+":"+String(C.getMinutes()).padStart(2,"0")+":"+String(C.getSeconds()).padStart(2,"0")+"."+(C.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$wm=L}),define(ke[183],Se([8,9]),function(me,e){return me.create("vs/base/common/errorMessage",e)}),define(ke[44],Se([1,0,19,18,183]),function(me,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Si=e.$Ri=e.$Qi=void 0;function I(C,m){return m&&(C.stack||C.stacktrace)?g.localize(0,null,b(C),A(C.stack)||A(C.stacktrace)):b(C)}function A(C){return Array.isArray(C)?C.join(`
`):C}function b(C){return C.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${C.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof C.code=="string"&&typeof C.errno=="number"&&typeof C.syscall=="string"?g.localize(1,null,C.message):C.message||g.localize(2,null)}function $(C=null,m=!1){if(!C)return g.localize(3,null);if(Array.isArray(C)){const p=D.$Hb(C),S=$(p[0],m);return p.length>1?g.localize(4,null,S,p.length):S}if(O.$If(C))return C;if(C.detail){const p=C.detail;if(p.error)return I(p.error,m);if(p.exception)return I(p.exception,m)}return C.stack?I(C,m):C.message?C.message:g.localize(5,null)}e.$Qi=$;function y(C){const m=C;return m instanceof Error&&Array.isArray(m.actions)}e.$Ri=y;function L(C,m){let p;return typeof C=="string"?p=new Error(C):p=C,p.actions=m,p}e.$Si=L}),define(ke[184],Se([8,9]),function(me,e){return me.create("vs/base/common/platform",e)}),define(ke[10],Se([1,0,184]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J=e.$I=e.$H=e.$G=e.$F=e.$E=e.$D=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.Platform=e.$g=void 0,e.$g="en";let O=!1,g=!1,I=!1,A=!1,b=!1,$=!1,y=!1,L=!1,C=!1,m=!1,p,S=e.$g,h=e.$g,f,o;const i=globalThis;let r;typeof i.vscode<"u"&&typeof i.vscode.process<"u"?r=i.vscode.process:typeof process<"u"&&(r=process);const n=typeof r?.versions?.electron=="string",c=n&&r?.type==="renderer";if(typeof r=="object"){O=r.platform==="win32",g=r.platform==="darwin",I=r.platform==="linux",A=I&&!!r.env.SNAP&&!!r.env.SNAP_REVISION,y=n,C=!!r.env.CI||!!r.env.BUILD_ARTIFACTSTAGINGDIRECTORY,p=e.$g,S=e.$g;const w=r.env.VSCODE_NLS_CONFIG;if(w)try{const E=JSON.parse(w),P=E.availableLanguages["*"];p=E.locale,h=E.osLocale,S=P||e.$g,f=E._translationsConfigFile}catch{}b=!0}else typeof navigator=="object"&&!c?(o=navigator.userAgent,O=o.indexOf("Windows")>=0,g=o.indexOf("Macintosh")>=0,L=(o.indexOf("Macintosh")>=0||o.indexOf("iPad")>=0||o.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,I=o.indexOf("Linux")>=0,m=o?.indexOf("Mobi")>=0,$=!0,p=D.getConfiguredDefaultLocale(D.localize(0,null))||e.$g,S=p,h=navigator.language):console.error("Unable to resolve platform.");var t;(function(w){w[w.Web=0]="Web",w[w.Mac=1]="Mac",w[w.Linux=2]="Linux",w[w.Windows=3]="Windows"})(t||(e.Platform=t={}));function u(w){switch(w){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$h=u;let s=0;g?s=1:O?s=3:I&&(s=2),e.$i=O,e.$j=g,e.$k=I,e.$l=A,e.$m=b,e.$n=y,e.$o=$,e.$p=$&&typeof i.importScripts=="function",e.$q=e.$p?i.origin:void 0,e.$r=L,e.$s=m,e.$t=C,e.$u=s,e.$v=o,e.$w=S;var l;(function(w){function E(){return e.$w}w.value=E;function P(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}w.isDefaultVariant=P;function N(){return e.$w==="en"}w.isDefault=N})(l||(e.Language=l={})),e.$x=p,e.$y=h,e.$z=f,e.$A=typeof i.postMessage=="function"&&!i.importScripts,e.$B=(()=>{if(e.$A){const w=[];i.addEventListener("message",P=>{if(P.data&&P.data.vscodeScheduleAsyncWork)for(let N=0,U=w.length;N<U;N++){const F=w[N];if(F.id===P.data.vscodeScheduleAsyncWork){w.splice(N,1),F.callback();return}}});let E=0;return P=>{const N=++E;w.push({id:N,callback:P}),i.postMessage({vscodeScheduleAsyncWork:N},"*")}}return w=>setTimeout(w)})();var a;(function(w){w[w.Windows=1]="Windows",w[w.Macintosh=2]="Macintosh",w[w.Linux=3]="Linux"})(a||(e.OperatingSystem=a={})),e.OS=g||L?2:O?1:3;let d=!0,k=!1;function R(){if(!k){k=!0;const w=new Uint8Array(2);w[0]=1,w[1]=2,d=new Uint16Array(w.buffer)[0]===(2<<8)+1}return d}e.$D=R,e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function v(w){return parseFloat(w)>=20}e.$J=v}),define(ke[49],Se([1,0,10]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let O;const g=globalThis.vscode;if(typeof g<"u"&&typeof g.process<"u"){const I=g.process;O={get platform(){return I.platform},get arch(){return I.arch},get env(){return I.env},cwd(){return I.cwd()}}}else typeof process<"u"?O={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:O={get platform(){return D.$i?"win32":D.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=O.cwd,e.env=O.env,e.$dc=O.platform,e.$ec=O.arch}),define(ke[16],Se([1,0,49]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const O=65,g=97,I=90,A=122,b=46,$=47,y=92,L=58,C=63;class m extends Error{constructor(u,s,l){let a;typeof s=="string"&&s.indexOf("not ")===0?(a="must not be",s=s.replace(/^not /,"")):a="must be";const d=u.indexOf(".")!==-1?"property":"argument";let k=`The "${u}" ${d} ${a} of type ${s}`;k+=`. Received type ${typeof l}`,super(k),this.code="ERR_INVALID_ARG_TYPE"}}function p(t,u){if(t===null||typeof t!="object")throw new m(u,"Object",t)}function S(t,u){if(typeof t!="string")throw new m(u,"string",t)}const h=D.$dc==="win32";function f(t){return t===$||t===y}function o(t){return t===$}function i(t){return t>=O&&t<=I||t>=g&&t<=A}function r(t,u,s,l){let a="",d=0,k=-1,R=0,v=0;for(let w=0;w<=t.length;++w){if(w<t.length)v=t.charCodeAt(w);else{if(l(v))break;v=$}if(l(v)){if(!(k===w-1||R===1))if(R===2){if(a.length<2||d!==2||a.charCodeAt(a.length-1)!==b||a.charCodeAt(a.length-2)!==b){if(a.length>2){const E=a.lastIndexOf(s);E===-1?(a="",d=0):(a=a.slice(0,E),d=a.length-1-a.lastIndexOf(s)),k=w,R=0;continue}else if(a.length!==0){a="",d=0,k=w,R=0;continue}}u&&(a+=a.length>0?`${s}..`:"..",d=2)}else a.length>0?a+=`${s}${t.slice(k+1,w)}`:a=t.slice(k+1,w),d=w-k-1;k=w,R=0}else v===b&&R!==-1?++R:R=-1}return a}function n(t,u){p(u,"pathObject");const s=u.dir||u.root,l=u.base||`${u.name||""}${u.ext||""}`;return s?s===u.root?`${s}${l}`:`${s}${t}${l}`:l}e.$fc={resolve(...t){let u="",s="",l=!1;for(let a=t.length-1;a>=-1;a--){let d;if(a>=0){if(d=t[a],S(d,"path"),d.length===0)continue}else u.length===0?d=D.cwd():(d=D.env[`=${u}`]||D.cwd(),(d===void 0||d.slice(0,2).toLowerCase()!==u.toLowerCase()&&d.charCodeAt(2)===y)&&(d=`${u}\\`));const k=d.length;let R=0,v="",w=!1;const E=d.charCodeAt(0);if(k===1)f(E)&&(R=1,w=!0);else if(f(E))if(w=!0,f(d.charCodeAt(1))){let P=2,N=P;for(;P<k&&!f(d.charCodeAt(P));)P++;if(P<k&&P!==N){const U=d.slice(N,P);for(N=P;P<k&&f(d.charCodeAt(P));)P++;if(P<k&&P!==N){for(N=P;P<k&&!f(d.charCodeAt(P));)P++;(P===k||P!==N)&&(v=`\\\\${U}\\${d.slice(N,P)}`,R=P)}}}else R=1;else i(E)&&d.charCodeAt(1)===L&&(v=d.slice(0,2),R=2,k>2&&f(d.charCodeAt(2))&&(w=!0,R=3));if(v.length>0)if(u.length>0){if(v.toLowerCase()!==u.toLowerCase())continue}else u=v;if(l){if(u.length>0)break}else if(s=`${d.slice(R)}\\${s}`,l=w,w&&u.length>0)break}return s=r(s,!l,"\\",f),l?`${u}\\${s}`:`${u}${s}`||"."},normalize(t){S(t,"path");const u=t.length;if(u===0)return".";let s=0,l,a=!1;const d=t.charCodeAt(0);if(u===1)return o(d)?"\\":t;if(f(d))if(a=!0,f(t.charCodeAt(1))){let R=2,v=R;for(;R<u&&!f(t.charCodeAt(R));)R++;if(R<u&&R!==v){const w=t.slice(v,R);for(v=R;R<u&&f(t.charCodeAt(R));)R++;if(R<u&&R!==v){for(v=R;R<u&&!f(t.charCodeAt(R));)R++;if(R===u)return`\\\\${w}\\${t.slice(v)}\\`;R!==v&&(l=`\\\\${w}\\${t.slice(v,R)}`,s=R)}}}else s=1;else i(d)&&t.charCodeAt(1)===L&&(l=t.slice(0,2),s=2,u>2&&f(t.charCodeAt(2))&&(a=!0,s=3));let k=s<u?r(t.slice(s),!a,"\\",f):"";return k.length===0&&!a&&(k="."),k.length>0&&f(t.charCodeAt(u-1))&&(k+="\\"),l===void 0?a?`\\${k}`:k:a?`${l}\\${k}`:`${l}${k}`},isAbsolute(t){S(t,"path");const u=t.length;if(u===0)return!1;const s=t.charCodeAt(0);return f(s)||u>2&&i(s)&&t.charCodeAt(1)===L&&f(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let u,s;for(let d=0;d<t.length;++d){const k=t[d];S(k,"path"),k.length>0&&(u===void 0?u=s=k:u+=`\\${k}`)}if(u===void 0)return".";let l=!0,a=0;if(typeof s=="string"&&f(s.charCodeAt(0))){++a;const d=s.length;d>1&&f(s.charCodeAt(1))&&(++a,d>2&&(f(s.charCodeAt(2))?++a:l=!1))}if(l){for(;a<u.length&&f(u.charCodeAt(a));)a++;a>=2&&(u=`\\${u.slice(a)}`)}return e.$fc.normalize(u)},relative(t,u){if(S(t,"from"),S(u,"to"),t===u)return"";const s=e.$fc.resolve(t),l=e.$fc.resolve(u);if(s===l||(t=s.toLowerCase(),u=l.toLowerCase(),t===u))return"";let a=0;for(;a<t.length&&t.charCodeAt(a)===y;)a++;let d=t.length;for(;d-1>a&&t.charCodeAt(d-1)===y;)d--;const k=d-a;let R=0;for(;R<u.length&&u.charCodeAt(R)===y;)R++;let v=u.length;for(;v-1>R&&u.charCodeAt(v-1)===y;)v--;const w=v-R,E=k<w?k:w;let P=-1,N=0;for(;N<E;N++){const F=t.charCodeAt(a+N);if(F!==u.charCodeAt(R+N))break;F===y&&(P=N)}if(N!==E){if(P===-1)return l}else{if(w>E){if(u.charCodeAt(R+N)===y)return l.slice(R+N+1);if(N===2)return l.slice(R+N)}k>E&&(t.charCodeAt(a+N)===y?P=N:N===2&&(P=3)),P===-1&&(P=0)}let U="";for(N=a+P+1;N<=d;++N)(N===d||t.charCodeAt(N)===y)&&(U+=U.length===0?"..":"\\..");return R+=P,U.length>0?`${U}${l.slice(R,v)}`:(l.charCodeAt(R)===y&&++R,l.slice(R,v))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const u=e.$fc.resolve(t);if(u.length<=2)return t;if(u.charCodeAt(0)===y){if(u.charCodeAt(1)===y){const s=u.charCodeAt(2);if(s!==C&&s!==b)return`\\\\?\\UNC\\${u.slice(2)}`}}else if(i(u.charCodeAt(0))&&u.charCodeAt(1)===L&&u.charCodeAt(2)===y)return`\\\\?\\${u}`;return t},dirname(t){S(t,"path");const u=t.length;if(u===0)return".";let s=-1,l=0;const a=t.charCodeAt(0);if(u===1)return f(a)?t:".";if(f(a)){if(s=l=1,f(t.charCodeAt(1))){let R=2,v=R;for(;R<u&&!f(t.charCodeAt(R));)R++;if(R<u&&R!==v){for(v=R;R<u&&f(t.charCodeAt(R));)R++;if(R<u&&R!==v){for(v=R;R<u&&!f(t.charCodeAt(R));)R++;if(R===u)return t;R!==v&&(s=l=R+1)}}}}else i(a)&&t.charCodeAt(1)===L&&(s=u>2&&f(t.charCodeAt(2))?3:2,l=s);let d=-1,k=!0;for(let R=u-1;R>=l;--R)if(f(t.charCodeAt(R))){if(!k){d=R;break}}else k=!1;if(d===-1){if(s===-1)return".";d=s}return t.slice(0,d)},basename(t,u){u!==void 0&&S(u,"ext"),S(t,"path");let s=0,l=-1,a=!0,d;if(t.length>=2&&i(t.charCodeAt(0))&&t.charCodeAt(1)===L&&(s=2),u!==void 0&&u.length>0&&u.length<=t.length){if(u===t)return"";let k=u.length-1,R=-1;for(d=t.length-1;d>=s;--d){const v=t.charCodeAt(d);if(f(v)){if(!a){s=d+1;break}}else R===-1&&(a=!1,R=d+1),k>=0&&(v===u.charCodeAt(k)?--k===-1&&(l=d):(k=-1,l=R))}return s===l?l=R:l===-1&&(l=t.length),t.slice(s,l)}for(d=t.length-1;d>=s;--d)if(f(t.charCodeAt(d))){if(!a){s=d+1;break}}else l===-1&&(a=!1,l=d+1);return l===-1?"":t.slice(s,l)},extname(t){S(t,"path");let u=0,s=-1,l=0,a=-1,d=!0,k=0;t.length>=2&&t.charCodeAt(1)===L&&i(t.charCodeAt(0))&&(u=l=2);for(let R=t.length-1;R>=u;--R){const v=t.charCodeAt(R);if(f(v)){if(!d){l=R+1;break}continue}a===-1&&(d=!1,a=R+1),v===b?s===-1?s=R:k!==1&&(k=1):s!==-1&&(k=-1)}return s===-1||a===-1||k===0||k===1&&s===a-1&&s===l+1?"":t.slice(s,a)},format:n.bind(null,"\\"),parse(t){S(t,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return u;const s=t.length;let l=0,a=t.charCodeAt(0);if(s===1)return f(a)?(u.root=u.dir=t,u):(u.base=u.name=t,u);if(f(a)){if(l=1,f(t.charCodeAt(1))){let P=2,N=P;for(;P<s&&!f(t.charCodeAt(P));)P++;if(P<s&&P!==N){for(N=P;P<s&&f(t.charCodeAt(P));)P++;if(P<s&&P!==N){for(N=P;P<s&&!f(t.charCodeAt(P));)P++;P===s?l=P:P!==N&&(l=P+1)}}}}else if(i(a)&&t.charCodeAt(1)===L){if(s<=2)return u.root=u.dir=t,u;if(l=2,f(t.charCodeAt(2))){if(s===3)return u.root=u.dir=t,u;l=3}}l>0&&(u.root=t.slice(0,l));let d=-1,k=l,R=-1,v=!0,w=t.length-1,E=0;for(;w>=l;--w){if(a=t.charCodeAt(w),f(a)){if(!v){k=w+1;break}continue}R===-1&&(v=!1,R=w+1),a===b?d===-1?d=w:E!==1&&(E=1):d!==-1&&(E=-1)}return R!==-1&&(d===-1||E===0||E===1&&d===R-1&&d===k+1?u.base=u.name=t.slice(k,R):(u.name=t.slice(k,d),u.base=t.slice(k,R),u.ext=t.slice(d,R))),k>0&&k!==l?u.dir=t.slice(0,k-1):u.dir=u.root,u},sep:"\\",delimiter:";",win32:null,posix:null};const c=(()=>{if(h){const t=/\\/g;return()=>{const u=D.cwd().replace(t,"/");return u.slice(u.indexOf("/"))}}return()=>D.cwd()})();e.$gc={resolve(...t){let u="",s=!1;for(let l=t.length-1;l>=-1&&!s;l--){const a=l>=0?t[l]:c();S(a,"path"),a.length!==0&&(u=`${a}/${u}`,s=a.charCodeAt(0)===$)}return u=r(u,!s,"/",o),s?`/${u}`:u.length>0?u:"."},normalize(t){if(S(t,"path"),t.length===0)return".";const u=t.charCodeAt(0)===$,s=t.charCodeAt(t.length-1)===$;return t=r(t,!u,"/",o),t.length===0?u?"/":s?"./":".":(s&&(t+="/"),u?`/${t}`:t)},isAbsolute(t){return S(t,"path"),t.length>0&&t.charCodeAt(0)===$},join(...t){if(t.length===0)return".";let u;for(let s=0;s<t.length;++s){const l=t[s];S(l,"path"),l.length>0&&(u===void 0?u=l:u+=`/${l}`)}return u===void 0?".":e.$gc.normalize(u)},relative(t,u){if(S(t,"from"),S(u,"to"),t===u||(t=e.$gc.resolve(t),u=e.$gc.resolve(u),t===u))return"";const s=1,l=t.length,a=l-s,d=1,k=u.length-d,R=a<k?a:k;let v=-1,w=0;for(;w<R;w++){const P=t.charCodeAt(s+w);if(P!==u.charCodeAt(d+w))break;P===$&&(v=w)}if(w===R)if(k>R){if(u.charCodeAt(d+w)===$)return u.slice(d+w+1);if(w===0)return u.slice(d+w)}else a>R&&(t.charCodeAt(s+w)===$?v=w:w===0&&(v=0));let E="";for(w=s+v+1;w<=l;++w)(w===l||t.charCodeAt(w)===$)&&(E+=E.length===0?"..":"/..");return`${E}${u.slice(d+v)}`},toNamespacedPath(t){return t},dirname(t){if(S(t,"path"),t.length===0)return".";const u=t.charCodeAt(0)===$;let s=-1,l=!0;for(let a=t.length-1;a>=1;--a)if(t.charCodeAt(a)===$){if(!l){s=a;break}}else l=!1;return s===-1?u?"/":".":u&&s===1?"//":t.slice(0,s)},basename(t,u){u!==void 0&&S(u,"ext"),S(t,"path");let s=0,l=-1,a=!0,d;if(u!==void 0&&u.length>0&&u.length<=t.length){if(u===t)return"";let k=u.length-1,R=-1;for(d=t.length-1;d>=0;--d){const v=t.charCodeAt(d);if(v===$){if(!a){s=d+1;break}}else R===-1&&(a=!1,R=d+1),k>=0&&(v===u.charCodeAt(k)?--k===-1&&(l=d):(k=-1,l=R))}return s===l?l=R:l===-1&&(l=t.length),t.slice(s,l)}for(d=t.length-1;d>=0;--d)if(t.charCodeAt(d)===$){if(!a){s=d+1;break}}else l===-1&&(a=!1,l=d+1);return l===-1?"":t.slice(s,l)},extname(t){S(t,"path");let u=-1,s=0,l=-1,a=!0,d=0;for(let k=t.length-1;k>=0;--k){const R=t.charCodeAt(k);if(R===$){if(!a){s=k+1;break}continue}l===-1&&(a=!1,l=k+1),R===b?u===-1?u=k:d!==1&&(d=1):u!==-1&&(d=-1)}return u===-1||l===-1||d===0||d===1&&u===l-1&&u===s+1?"":t.slice(u,l)},format:n.bind(null,"/"),parse(t){S(t,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return u;const s=t.charCodeAt(0)===$;let l;s?(u.root="/",l=1):l=0;let a=-1,d=0,k=-1,R=!0,v=t.length-1,w=0;for(;v>=l;--v){const E=t.charCodeAt(v);if(E===$){if(!R){d=v+1;break}continue}k===-1&&(R=!1,k=v+1),E===b?a===-1?a=v:w!==1&&(w=1):a!==-1&&(w=-1)}if(k!==-1){const E=d===0&&s?1:d;a===-1||w===0||w===1&&a===k-1&&a===d+1?u.base=u.name=t.slice(E,k):(u.name=t.slice(E,a),u.base=t.slice(E,k),u.ext=t.slice(a,k))}return d>0?u.dir=t.slice(0,d-1):s&&(u.dir="/"),u},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=h?e.$fc.normalize:e.$gc.normalize,e.$ic=h?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=h?e.$fc.join:e.$gc.join,e.$kc=h?e.$fc.resolve:e.$gc.resolve,e.$lc=h?e.$fc.relative:e.$gc.relative,e.$mc=h?e.$fc.dirname:e.$gc.dirname,e.$nc=h?e.$fc.basename:e.$gc.basename,e.$oc=h?e.$fc.extname:e.$gc.extname,e.$pc=h?e.$fc.format:e.$gc.format,e.$qc=h?e.$fc.parse:e.$gc.parse,e.$rc=h?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=h?e.$fc.sep:e.$gc.sep,e.$tc=h?e.$fc.delimiter:e.$gc.delimiter}),define(ke[128],Se([1,0,43,16]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uq=e.$Tq=e.$Sq=e.$Rq=e.$Qq=e.$Pq=e.$Oq=e.$Nq=e.$Mq=e.$Lq=e.$Kq=e.$Jq=e.$Iq=void 0;const g=new D.$V(()=>{const R=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:R,collatorIsNumeric:R.resolvedOptions().numeric}}),I=new D.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new D.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function b(R,v,w=!1){const E=R||"",P=v||"",N=g.value.collator.compare(E,P);return g.value.collatorIsNumeric&&N===0&&E!==P?E<P?-1:1:N}e.$Iq=b;function $(R,v){const w=I.value.collator;return R=R||"",v=v||"",n(w,R,v)}e.$Jq=$;function y(R,v){const w=I.value.collator;return R=R||"",v=v||"",s(R,v)||n(w,R,v)}e.$Kq=y;function L(R,v){const w=I.value.collator;return R=R||"",v=v||"",u(R,v)||n(w,R,v)}e.$Lq=L;function C(R,v){return R=R||"",v=v||"",R===v?0:R<v?-1:1}e.$Mq=C;function m(R,v){const[w,E]=i(R),[P,N]=i(v);let U=g.value.collator.compare(E,N);if(U===0){if(g.value.collatorIsNumeric&&E!==N)return E<N?-1:1;if(U=g.value.collator.compare(w,P),g.value.collatorIsNumeric&&U===0&&w!==P)return w<P?-1:1}return U}e.$Nq=m;function p(R,v){R=R||"",v=v||"";const w=r(R),E=r(v),P=I.value.collator,N=A.value.collator;return n(N,w,E)||n(P,R,v)}e.$Oq=p;function S(R,v){R=R||"",v=v||"";const w=r(R),E=r(v),P=I.value.collator,N=A.value.collator;return n(N,w,E)||s(R,v)||n(P,R,v)}e.$Pq=S;function h(R,v){R=R||"",v=v||"";const w=r(R),E=r(v),P=I.value.collator,N=A.value.collator;return n(N,w,E)||u(R,v)||n(P,R,v)}e.$Qq=h;function f(R,v){R=R||"",v=v||"";const w=r(R).toLowerCase(),E=r(v).toLowerCase();return w!==E?w<E?-1:1:R!==v?R<v?-1:1:0}e.$Rq=f;const o=/^(.*?)(\.([^.]*))?$/;function i(R,v=!1){const w=R?o.exec(R):[];let E=[w&&w[1]||"",w&&w[3]||""];return v&&(!E[0]&&E[1]||E[0]&&E[0].charAt(0)===".")&&(E=[E[0]+"."+E[1],""]),E}function r(R){const v=R?o.exec(R):[];return v&&v[1]&&v[1].charAt(0)!=="."&&v[3]||""}function n(R,v,w){const E=R.compare(v,w);return E!==0?E:v.length!==w.length?v.length<w.length?-1:1:0}function c(R){const v=R.charAt(0);return v.toLocaleUpperCase()!==v}function t(R){const v=R.charAt(0);return v.toLocaleLowerCase()!==v}function u(R,v){return c(R)&&t(v)?-1:t(R)&&c(v)?1:0}function s(R,v){return t(R)&&c(v)?-1:c(R)&&t(v)?1:0}function l(R,v,w=!1){return w||(R=R&&R.toLowerCase(),v=v&&v.toLowerCase()),R===v?0:R<v?-1:1}function a(R,v,w=!1){const E=R.split(O.sep),P=v.split(O.sep),N=E.length-1,U=P.length-1;let F,j;for(let T=0;;T++){if(F=N===T,j=U===T,F&&j)return b(E[T],P[T],w);if(F)return-1;if(j)return 1;const M=l(E[T],P[T],w);if(M!==0)return M}}e.$Sq=a;function d(R,v,w){const E=R.toLowerCase(),P=v.toLowerCase(),N=k(R,v,w);if(N)return N;const U=E.endsWith(w),F=P.endsWith(w);if(U!==F)return U?-1:1;const j=b(E,P);return j!==0?j:E.localeCompare(P)}e.$Tq=d;function k(R,v,w){const E=R.toLowerCase(),P=v.toLowerCase(),N=E.startsWith(w),U=P.startsWith(w);if(N!==U)return N?-1:1;if(N&&U){if(E.length<P.length)return-1;if(E.length>P.length)return 1}return 0}e.$Uq=k}),define(ke[33],Se([1,0,16,10,12,18]),function(me,e,D,O,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=void 0;function A(d){return d===47||d===92}e.$1f=A;function b(d){return d.replace(/[\\/]/g,D.$gc.sep)}e.$2f=b;function $(d){return d.indexOf("/")===-1&&(d=b(d)),/^[a-zA-Z]:(\/|$)/.test(d)&&(d="/"+d),d}e.$3f=$;function y(d,k=D.$gc.sep){if(!d)return"";const R=d.length,v=d.charCodeAt(0);if(A(v)){if(A(d.charCodeAt(1))&&!A(d.charCodeAt(2))){let E=3;const P=E;for(;E<R&&!A(d.charCodeAt(E));E++);if(P!==E&&!A(d.charCodeAt(E+1))){for(E+=1;E<R;E++)if(A(d.charCodeAt(E)))return d.slice(0,E+1).replace(/[\\/]/g,k)}}return k}else if(o(v)&&d.charCodeAt(1)===58)return A(d.charCodeAt(2))?d.slice(0,2)+k:d.slice(0,2);let w=d.indexOf("://");if(w!==-1){for(w+=3;w<R;w++)if(A(d.charCodeAt(w)))return d.slice(0,w+1)}return""}e.$4f=y;function L(d){if(!O.$i||!d||d.length<5)return!1;let k=d.charCodeAt(0);if(k!==92||(k=d.charCodeAt(1),k!==92))return!1;let R=2;const v=R;for(;R<d.length&&(k=d.charCodeAt(R),k!==92);R++);return!(v===R||(k=d.charCodeAt(R+1),isNaN(k)||k===92))}e.$5f=L;const C=/[\\/:\*\?"<>\|]/g,m=/[\\/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function S(d,k=O.$i){const R=k?C:m;return!(!d||d.length===0||/^\s+$/.test(d)||(R.lastIndex=0,R.test(d))||k&&p.test(d)||d==="."||d===".."||k&&d[d.length-1]==="."||k&&d.length!==d.trim().length||d.length>255)}e.$6f=S;function h(d,k,R){const v=d===k;return!R||v?v:!d||!k?!1:(0,g.$_e)(d,k)}e.$7f=h;function f(d,k,R,v=D.sep){if(d===k)return!0;if(!d||!k||k.length>d.length)return!1;if(R){if(!(0,g.$af)(d,k))return!1;if(k.length===d.length)return!0;let E=k.length;return k.charAt(k.length-1)===v&&E--,d.charAt(E)===v}return k.charAt(k.length-1)!==v&&(k+=v),d.indexOf(k)===0}e.$8f=f;function o(d){return d>=65&&d<=90||d>=97&&d<=122}e.$9f=o;function i(d,k){return O.$i&&d.endsWith(":")&&(d+=D.sep),(0,D.$ic)(d)||(d=(0,D.$jc)(k,d)),d=(0,D.$hc)(d),O.$i?(d=(0,g.$Ue)(d,D.sep),d.endsWith(":")&&(d+=D.sep)):(d=(0,g.$Ue)(d,D.sep),d||(d=D.sep)),d}e.$0f=i;function r(d){const k=(0,D.$hc)(d);return O.$i?d.length>3?!1:n(k)&&(d.length===2||k.charCodeAt(2)===92):k===D.$gc.sep}e.$$f=r;function n(d,k=O.$i){return k?o(d.charCodeAt(0))&&d.charCodeAt(1)===58:!1}e.$_f=n;function c(d,k=O.$i){return n(d,k)?d[0]:void 0}e.$ag=c;function t(d,k,R){return k.length>d.length?-1:d===k?0:(R&&(d=d.toLowerCase(),k=k.toLowerCase()),d.indexOf(k))}e.$bg=t;function u(d){const k=d.split(":");let R,v,w;for(const E of k){const P=Number(E);(0,I.$Mf)(P)?v===void 0?v=P:w===void 0&&(w=P):R=R?[R,E].join(":"):E}if(!R)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:R,line:v!==void 0?v:void 0,column:w!==void 0?w:v!==void 0?1:void 0}}e.$cg=u;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",l="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function a(d,k,R=8){let v="";for(let E=0;E<R;E++){let P;E===0&&O.$i&&!k&&(R===3||R===4)?P=l:P=s,v+=P.charAt(Math.floor(Math.random()*P.length))}let w;return k?w=`${k}-${v}`:w=v,d?(0,D.$jc)(d,w):w}e.$dg=a}),define(ke[129],Se([1,0,128,123,54,16,10,12]),function(me,e,D,O,g,I,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1q=e.$Zq=e.$Yq=e.$Xq=e.$Wq=e.$Vq=void 0;const $=0,y=[$,[]];function L(B,Y,ue,Z){if(!B||!Y)return y;const J=B.length,X=Y.length;if(J<X)return y;const he=B.toLowerCase();return C(Y,ue,X,B,he,J,Z)}e.$Vq=L;function C(B,Y,ue,Z,J,X,he){const _=[],we=[];for(let re=0;re<ue;re++){const ye=re*X,de=ye-X,ge=re>0,x=B[re],te=Y[re];for(let G=0;G<X;G++){const ie=G>0,fe=ye+G,pe=fe-1,Pe=de+G-1,be=ie?_[pe]:0,De=ge&&ie?_[Pe]:0,z=ge&&ie?we[Pe]:0;let Q;!De&&ge?Q=0:Q=m(x,te,Z,J,G,z),Q&&De+Q>=be&&(he||ge||J.startsWith(Y,G))?(we[fe]=z+1,_[fe]=De+Q):(we[fe]=$,_[fe]=be)}}const oe=[];let K=ue-1,W=X-1;for(;K>=0&&W>=0;){const re=K*X+W;we[re]===$||(oe.push(W),K--),W--}return[_[ue*X-1],oe.reverse()]}function m(B,Y,ue,Z,J,X){let he=0;if(!p(Y,Z[J]))return he;if(he+=1,X>0&&(he+=X*5),B===ue[J]&&(he+=1),J===0)he+=8;else{const _=S(ue.charCodeAt(J-1));_?he+=_:(0,O.$Xj)(ue.charCodeAt(J))&&X===0&&(he+=2)}return he}function p(B,Y){return B===Y?!0:B==="/"||B==="\\"?Y==="/"||Y==="\\":!1}function S(B){switch(B){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const h=[void 0,[]];function f(B,Y,ue=0,Z=0){const J=Y;return J.values&&J.values.length>1?o(B,J.values,ue,Z):i(B,Y,ue,Z)}e.$Wq=f;function o(B,Y,ue,Z){let J=0;const X=[];for(const he of Y){const[_,we]=i(B,he,ue,Z);if(typeof _!="number")return h;J+=_,X.push(...we)}return[J,R(X)]}function i(B,Y,ue,Z){const J=(0,O.$7j)(Y.original,Y.originalLowercase,ue,B,B.toLowerCase(),Z,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return J?[J[0],(0,O.$4j)(J)]:h}const r=Object.freeze({score:0}),n=1<<18,c=1<<17,t=1<<16;function u(B,Y,ue,Z){const J=Z.values?Z.values:[Z];return(0,g.$Ti)({[Z.normalized]:{values:J.map(he=>({value:he.normalized,expectContiguousMatch:he.expectContiguousMatch})),label:B,description:Y,allowNonContiguousMatches:ue}})}function s(B,Y,ue,Z,J){if(!B||!Y.normalized)return r;const X=Z.getItemLabel(B);if(!X)return r;const he=Z.getItemDescription(B),_=u(X,he,ue,Y),we=J[_];if(we)return we;const oe=l(X,he,Z.getItemPath(B),Y,ue);return J[_]=oe,oe}e.$Xq=s;function l(B,Y,ue,Z,J){const X=!ue||!Z.containsPathSeparator;return ue&&(A.$k?Z.pathNormalized===ue:(0,b.$_e)(Z.pathNormalized,ue))?{score:n,labelMatch:[{start:0,end:B.length}],descriptionMatch:Y?[{start:0,end:Y.length}]:void 0}:Z.values&&Z.values.length>1?a(B,Y,ue,Z.values,X,J):d(B,Y,ue,Z,X,J)}function a(B,Y,ue,Z,J,X){let he=0;const _=[],we=[];for(const oe of Z){const{score:K,labelMatch:W,descriptionMatch:re}=d(B,Y,ue,oe,J,X);if(K===$)return r;he+=K,W&&_.push(...W),re&&we.push(...re)}return{score:he,labelMatch:R(_),descriptionMatch:R(we)}}function d(B,Y,ue,Z,J,X){if(J||!Y){const[he,_]=L(B,Z.normalized,Z.normalizedLowercase,X&&!Z.expectContiguousMatch);if(he){const we=(0,O.$Uj)(Z.normalized,B);let oe;if(we){oe=c;const K=Math.round(Z.normalized.length/B.length*100);oe+=K}else oe=t;return{score:oe+he,labelMatch:we||k(_)}}}if(Y){let he=Y;ue&&(he=`${Y}${I.sep}`);const _=he.length,we=`${he}${B}`,[oe,K]=L(we,Z.normalized,Z.normalizedLowercase,X&&!Z.expectContiguousMatch);if(oe){const W=k(K),re=[],ye=[];return W.forEach(de=>{de.start<_&&de.end>_?(re.push({start:0,end:de.end-_}),ye.push({start:de.start,end:_})):de.start>=_?re.push({start:de.start-_,end:de.end-_}):ye.push(de)}),{score:oe,labelMatch:re,descriptionMatch:ye}}}return r}function k(B){const Y=[];if(!B)return Y;let ue;for(const Z of B)ue&&ue.end===Z?ue.end+=1:(ue={start:Z,end:Z+1},Y.push(ue));return Y}function R(B){const Y=B.sort((J,X)=>J.start-X.start),ue=[];let Z;for(const J of Y)!Z||!v(Z,J)?(Z=J,ue.push(J)):(Z.start=Math.min(Z.start,J.start),Z.end=Math.max(Z.end,J.end));return ue}function v(B,Y){return!(B.end<Y.start||Y.end<B.start)}function w(B,Y,ue,Z,J,X){const he=s(B,ue,Z,J,X),_=s(Y,ue,Z,J,X),we=he.score,oe=_.score;if((we===n||oe===n)&&we!==oe)return we===n?-1:1;if(we>t||oe>t){if(we!==oe)return we>oe?-1:1;if(we<c&&oe<c){const x=P(he.labelMatch,_.labelMatch);if(x!==0)return x}const de=J.getItemLabel(B)||"",ge=J.getItemLabel(Y)||"";if(de.length!==ge.length)return de.length-ge.length}if(we!==oe)return we>oe?-1:1;const K=Array.isArray(he.labelMatch)&&he.labelMatch.length>0,W=Array.isArray(_.labelMatch)&&_.labelMatch.length>0;if(K&&!W)return-1;if(W&&!K)return 1;const re=E(B,he,J),ye=E(Y,_,J);return re&&ye&&re!==ye?ye>re?-1:1:N(B,Y,ue,J)}e.$Yq=w;function E(B,Y,ue){let Z=-1,J=-1;if(Y.descriptionMatch&&Y.descriptionMatch.length?Z=Y.descriptionMatch[0].start:Y.labelMatch&&Y.labelMatch.length&&(Z=Y.labelMatch[0].start),Y.labelMatch&&Y.labelMatch.length){if(J=Y.labelMatch[Y.labelMatch.length-1].end,Y.descriptionMatch&&Y.descriptionMatch.length){const X=ue.getItemDescription(B);X&&(J+=X.length)}}else Y.descriptionMatch&&Y.descriptionMatch.length&&(J=Y.descriptionMatch[Y.descriptionMatch.length-1].end);return J-Z}function P(B,Y){if(!B&&!Y||(!B||!B.length)&&(!Y||!Y.length))return 0;if(!Y||!Y.length)return-1;if(!B||!B.length)return 1;const ue=B[0].start,J=B[B.length-1].end-ue,X=Y[0].start,_=Y[Y.length-1].end-X;return J===_?0:_<J?1:-1}function N(B,Y,ue,Z){const J=Z.getItemLabel(B)||"",X=Z.getItemLabel(Y)||"",he=Z.getItemDescription(B),_=Z.getItemDescription(Y),we=J.length+(he?he.length:0),oe=X.length+(_?_.length:0);if(we!==oe)return we-oe;const K=Z.getItemPath(B),W=Z.getItemPath(Y);return K&&W&&K.length!==W.length?K.length-W.length:J!==X?(0,D.$Tq)(J,X,ue.normalized):he&&_&&he!==_?(0,D.$Tq)(he,_,ue.normalized):K&&W&&K!==W?(0,D.$Tq)(K,W,ue.normalized):0}function U(B){return B.startsWith('"')&&B.endsWith('"')}const F=" ";function j(B){typeof B!="string"&&(B="");const Y=B.toLowerCase(),{pathNormalized:ue,normalized:Z,normalizedLowercase:J}=T(B),X=ue.indexOf(I.sep)>=0,he=U(B);let _;const we=B.split(F);if(we.length>1)for(const oe of we){const K=U(oe),{pathNormalized:W,normalized:re,normalizedLowercase:ye}=T(oe);re&&(_||(_=[]),_.push({original:oe,originalLowercase:oe.toLowerCase(),pathNormalized:W,normalized:re,normalizedLowercase:ye,expectContiguousMatch:K}))}return{original:B,originalLowercase:Y,pathNormalized:ue,normalized:Z,normalizedLowercase:J,values:_,containsPathSeparator:X,expectContiguousMatch:he}}e.$Zq=j;function T(B){let Y;A.$i?Y=B.replace(/\//g,I.sep):Y=B.replace(/\\/g,I.sep);const ue=(0,b.$We)(Y).replace(/\s|"/g,"");return{pathNormalized:Y,normalized:ue,normalizedLowercase:ue.toLowerCase()}}function M(B){return Array.isArray(B)?j(B.map(Y=>Y.original).join(F)):j(B.original)}e.$1q=M}),define(ke[100],Se([1,0,16]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$js=e.$is=e.$hs=e.$gs=e.$fs=void 0,e.$fs=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const O={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},g={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function I(L){const C=(0,D.$oc)(L),m=O[C.toLowerCase()];return m!==void 0?m:A(L)}e.$gs=I;function A(L){const C=(0,D.$oc)(L);return g[C.toLowerCase()]}e.$hs=A;function b(L){for(const C in g)if(g[C]===L)return C}e.$is=b;const $=/^(.+)\/(.+?)(;.+)?$/;function y(L,C){const m=$.exec(L);return m?`${m[1].toLowerCase()}/${m[2].toLowerCase()}${m[3]??""}`:C?void 0:L}e.$js=y}),define(ke[101],Se([1,0,10]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sl=e.$Rl=e.TerminateResponseCode=e.Source=void 0;var O;(function(b){b[b.stdout=0]="stdout",b[b.stderr=1]="stderr"})(O||(e.Source=O={}));var g;(function(b){b[b.Success=0]="Success",b[b.Unknown=1]="Unknown",b[b.AccessDenied=2]="AccessDenied",b[b.ProcessNotFound=3]="ProcessNotFound"})(g||(e.TerminateResponseCode=g={}));function I(b,...$){const y=$.reduce((m,p)=>(m[p]=!0,m),{}),L=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(b).filter(m=>!y[m]).forEach(m=>{for(let p=0;p<L.length;p++)if(m.search(L[p])!==-1){delete b[m];break}})}e.$Rl=I;function A(b){b&&(delete b.DEBUG,D.$j&&delete b.DYLD_LIBRARY_PATH,D.$k&&delete b.LD_PRELOAD)}e.$Sl=A}),define(ke[2],Se([1,0,16,10]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wc=e.$vc=e.URI=void 0;const g=/^\w[\w\d+.-]*$/,I=/^\//,A=/^\/\//;function b(l,a){if(!l.scheme&&a)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${l.authority}", path: "${l.path}", query: "${l.query}", fragment: "${l.fragment}"}`);if(l.scheme&&!g.test(l.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(l.path){if(l.authority){if(!I.test(l.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(l.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function $(l,a){return!l&&!a?"file":l}function y(l,a){switch(l){case"https":case"http":case"file":a?a[0]!==C&&(a=C+a):a=C;break}return a}const L="",C="/",m=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class p{static isUri(a){return a instanceof p?!0:a?typeof a.authority=="string"&&typeof a.fragment=="string"&&typeof a.path=="string"&&typeof a.query=="string"&&typeof a.scheme=="string"&&typeof a.fsPath=="string"&&typeof a.with=="function"&&typeof a.toString=="function":!1}constructor(a,d,k,R,v,w=!1){typeof a=="object"?(this.scheme=a.scheme||L,this.authority=a.authority||L,this.path=a.path||L,this.query=a.query||L,this.fragment=a.fragment||L):(this.scheme=$(a,w),this.authority=d||L,this.path=y(this.scheme,k||L),this.query=R||L,this.fragment=v||L,b(this,w))}get fsPath(){return n(this,!1)}with(a){if(!a)return this;let{scheme:d,authority:k,path:R,query:v,fragment:w}=a;return d===void 0?d=this.scheme:d===null&&(d=L),k===void 0?k=this.authority:k===null&&(k=L),R===void 0?R=this.path:R===null&&(R=L),v===void 0?v=this.query:v===null&&(v=L),w===void 0?w=this.fragment:w===null&&(w=L),d===this.scheme&&k===this.authority&&R===this.path&&v===this.query&&w===this.fragment?this:new f(d,k,R,v,w)}static parse(a,d=!1){const k=m.exec(a);return k?new f(k[2]||L,s(k[4]||L),s(k[5]||L),s(k[7]||L),s(k[9]||L),d):new f(L,L,L,L,L)}static file(a){let d=L;if(O.$i&&(a=a.replace(/\\/g,C)),a[0]===C&&a[1]===C){const k=a.indexOf(C,2);k===-1?(d=a.substring(2),a=C):(d=a.substring(2,k),a=a.substring(k)||C)}return new f("file",d,a,L,L)}static from(a,d){return new f(a.scheme,a.authority,a.path,a.query,a.fragment,d)}static joinPath(a,...d){if(!a.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let k;return O.$i&&a.scheme==="file"?k=p.file(D.$fc.join(n(a,!0),...d)).path:k=D.$gc.join(a.path,...d),a.with({path:k})}toString(a=!1){return c(this,a)}toJSON(){return this}static revive(a){if(a){if(a instanceof p)return a;{const d=new f(a);return d._formatted=a.external??null,d._fsPath=a._sep===h?a.fsPath??null:null,d}}else return a}}e.URI=p;function S(l){return!l||typeof l!="object"?!1:typeof l.scheme=="string"&&(typeof l.authority=="string"||typeof l.authority>"u")&&(typeof l.path=="string"||typeof l.path>"u")&&(typeof l.query=="string"||typeof l.query>"u")&&(typeof l.fragment=="string"||typeof l.fragment>"u")}e.$vc=S;const h=O.$i?1:void 0;class f extends p{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=n(this,!1)),this._fsPath}toString(a=!1){return a?c(this,!0):(this._formatted||(this._formatted=c(this,!1)),this._formatted)}toJSON(){const a={$mid:1};return this._fsPath&&(a.fsPath=this._fsPath,a._sep=h),this._formatted&&(a.external=this._formatted),this.path&&(a.path=this.path),this.scheme&&(a.scheme=this.scheme),this.authority&&(a.authority=this.authority),this.query&&(a.query=this.query),this.fragment&&(a.fragment=this.fragment),a}}const o={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function i(l,a,d){let k,R=-1;for(let v=0;v<l.length;v++){const w=l.charCodeAt(v);if(w>=97&&w<=122||w>=65&&w<=90||w>=48&&w<=57||w===45||w===46||w===95||w===126||a&&w===47||d&&w===91||d&&w===93||d&&w===58)R!==-1&&(k+=encodeURIComponent(l.substring(R,v)),R=-1),k!==void 0&&(k+=l.charAt(v));else{k===void 0&&(k=l.substr(0,v));const E=o[w];E!==void 0?(R!==-1&&(k+=encodeURIComponent(l.substring(R,v)),R=-1),k+=E):R===-1&&(R=v)}}return R!==-1&&(k+=encodeURIComponent(l.substring(R))),k!==void 0?k:l}function r(l){let a;for(let d=0;d<l.length;d++){const k=l.charCodeAt(d);k===35||k===63?(a===void 0&&(a=l.substr(0,d)),a+=o[k]):a!==void 0&&(a+=l[d])}return a!==void 0?a:l}function n(l,a){let d;return l.authority&&l.path.length>1&&l.scheme==="file"?d=`//${l.authority}${l.path}`:l.path.charCodeAt(0)===47&&(l.path.charCodeAt(1)>=65&&l.path.charCodeAt(1)<=90||l.path.charCodeAt(1)>=97&&l.path.charCodeAt(1)<=122)&&l.path.charCodeAt(2)===58?a?d=l.path.substr(1):d=l.path[1].toLowerCase()+l.path.substr(2):d=l.path,O.$i&&(d=d.replace(/\//g,"\\")),d}e.$wc=n;function c(l,a){const d=a?r:i;let k="",{scheme:R,authority:v,path:w,query:E,fragment:P}=l;if(R&&(k+=R,k+=":"),(v||R==="file")&&(k+=C,k+=C),v){let N=v.indexOf("@");if(N!==-1){const U=v.substr(0,N);v=v.substr(N+1),N=U.lastIndexOf(":"),N===-1?k+=d(U,!1,!1):(k+=d(U.substr(0,N),!1,!1),k+=":",k+=d(U.substr(N+1),!1,!0)),k+="@"}v=v.toLowerCase(),N=v.lastIndexOf(":"),N===-1?k+=d(v,!1,!0):(k+=d(v.substr(0,N),!1,!0),k+=v.substr(N))}if(w){if(w.length>=3&&w.charCodeAt(0)===47&&w.charCodeAt(2)===58){const N=w.charCodeAt(1);N>=65&&N<=90&&(w=`/${String.fromCharCode(N+32)}:${w.substr(3)}`)}else if(w.length>=2&&w.charCodeAt(1)===58){const N=w.charCodeAt(0);N>=65&&N<=90&&(w=`${String.fromCharCode(N+32)}:${w.substr(2)}`)}k+=d(w,!0,!1)}return E&&(k+="?",k+=d(E,!1,!1)),P&&(k+="#",k+=a?P:i(P,!1,!1)),k}function t(l){try{return decodeURIComponent(l)}catch{return l.length>3?l.substr(0,3)+t(l.substr(3)):l}}const u=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(l){return l.match(u)?l.replace(u,a=>t(a)):l}}),define(ke[185],Se([1,0,2]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$oq=e.$nq=e.$mq=void 0;function O(y){const L=y;return L&&typeof L.type=="string"&&typeof L.severity=="string"}e.$mq=O;function g(y){const L=[];let C;try{const m=JSON.parse(y.arguments),p=m[m.length-1];p&&p.__$stack&&(m.pop(),C=p.__$stack),L.push(...m)}catch{L.push("Unable to log remote console arguments",y.arguments)}return{args:L,stack:C}}e.$nq=g;function I(y){if(typeof y!="string")return I(g(y).stack);const L=y;if(L){const C=A(L),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(C||"");if(m&&m.length===4)return{uri:D.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}e.$oq=I;function A(y){if(!y)return y;const L=y.indexOf(`
`);return L===-1?y:y.substring(0,L)}function b(y,L){const{args:C,stack:m}=g(y),p=typeof C[0]=="string"&&C.length===1;let S=A(m);S&&(S=`(${S.trim()})`);let h=[];if(typeof C[0]=="string"?S&&p?h=[`%c[${L}] %c${C[0]} %c${S}`,$("blue"),$(""),$("grey")]:h=[`%c[${L}] %c${C[0]}`,$("blue"),$(""),...C.slice(1)]:h=[`%c[${L}]%`,$("blue"),...C],S&&!p&&h.push(S),typeof console[y.severity]!="function")throw new Error("Unknown console method");console[y.severity].apply(console,h)}e.log=b;function $(y){return`color: ${y}`}}),define(ke[55],Se([1,0,22,2]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ch=e.$Bh=e.$Ah=void 0;function g($){return JSON.stringify($,A)}e.$Ah=g;function I($){let y=JSON.parse($);return y=b(y),y}e.$Bh=I;function A($,y){return y instanceof RegExp?{$mid:2,source:y.source,flags:y.flags}:y}function b($,y=0){if(!$||y>200)return $;if(typeof $=="object"){switch($.$mid){case 1:return O.URI.revive($);case 2:return new RegExp($.source,$.flags);case 17:return new Date($.source)}if($ instanceof D.$je||$ instanceof Uint8Array)return $;if(Array.isArray($))for(let L=0;L<$.length;++L)$[L]=b($[L],y+1);else for(const L in $)Object.hasOwnProperty.call($,L)&&($[L]=b($[L],y+1))}return $}e.$Ch=b}),define(ke[17],Se([1,0,14,10,12,2]),function(me,e,D,O,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.Schemas=void 0;var A;(function(m){m.inMemory="inmemory",m.vscode="vscode",m.internal="private",m.walkThrough="walkThrough",m.walkThroughSnippet="walkThroughSnippet",m.http="http",m.https="https",m.file="file",m.mailto="mailto",m.untitled="untitled",m.data="data",m.command="command",m.vscodeRemote="vscode-remote",m.vscodeRemoteResource="vscode-remote-resource",m.vscodeManagedRemoteResource="vscode-managed-remote-resource",m.vscodeUserData="vscode-userdata",m.vscodeCustomEditor="vscode-custom-editor",m.vscodeNotebookCell="vscode-notebook-cell",m.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",m.vscodeNotebookCellOutput="vscode-notebook-cell-output",m.vscodeInteractiveInput="vscode-interactive-input",m.vscodeSettings="vscode-settings",m.vscodeWorkspaceTrust="vscode-workspace-trust",m.vscodeTerminal="vscode-terminal",m.vscodeChatSesssion="vscode-chat-editor",m.webviewPanel="webview-panel",m.vscodeWebview="vscode-webview",m.extension="extension",m.vscodeFileResource="vscode-file",m.tmp="tmp",m.vsls="vsls",m.vscodeSourceControl="vscode-scm"})(A||(e.Schemas=A={}));function b(m,p){return I.URI.isUri(m)?(0,g.$_e)(m.scheme,p):(0,g.$af)(m,p+":")}e.$eg=b;function $(m,...p){return p.some(S=>b(m,S))}e.$fg=$,e.$gg="vscode-tkn",e.$hg="tkn";class y{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${A.vscodeRemoteResource}`}setPreferredWebSchema(p){this.d=p}setDelegate(p){this.e=p}setServerRootPath(p){this.f=`${p}/${A.vscodeRemoteResource}`}set(p,S,h){this.a[p]=S,this.b[p]=h}setConnectionToken(p,S){this.c[p]=S}getPreferredWebSchema(){return this.d}rewrite(p){if(this.e)try{return this.e(p)}catch(r){return D.$1(r),p}const S=p.authority;let h=this.a[S];h&&h.indexOf(":")!==-1&&h.indexOf("[")===-1&&(h=`[${h}]`);const f=this.b[S],o=this.c[S];let i=`path=${encodeURIComponent(p.path)}`;return typeof o=="string"&&(i+=`&${e.$hg}=${encodeURIComponent(o)}`),I.URI.from({scheme:O.$o?this.d:A.vscodeRemoteResource,authority:`${h}:${f}`,path:this.f,query:i})}}e.$ig=new y,e.$jg="vs/../../extensions",e.$kg="vs/../../node_modules",e.$lg="vs/../../node_modules.asar",e.$mg="vs/../../node_modules.asar.unpacked",e.$ng="vscode-app";class L{static{this.a=e.$ng}asBrowserUri(p){const S=this.b(p,me);return this.uriToBrowserUri(S)}uriToBrowserUri(p){return p.scheme===A.vscodeRemote?e.$ig.rewrite(p):p.scheme===A.file&&(O.$m||O.$q===`${A.vscodeFileResource}://${L.a}`)?p.with({scheme:A.vscodeFileResource,authority:p.authority||L.a,query:null,fragment:null}):p}asFileUri(p){const S=this.b(p,me);return this.uriToFileUri(S)}uriToFileUri(p){return p.scheme===A.vscodeFileResource?p.with({scheme:A.file,authority:p.authority!==L.a?p.authority:null,query:null,fragment:null}):p}b(p,S){return I.URI.isUri(p)?p:I.URI.parse(S.toUrl(p))}}e.$og=new L;var C;(function(m){const p=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);m.CoopAndCoep=Object.freeze(p.get("3"));const S="vscode-coi";function h(o){let i;typeof o=="string"?i=new URL(o).searchParams:o instanceof URL?i=o.searchParams:I.URI.isUri(o)&&(i=new URL(o.toString(!0)).searchParams);const r=i?.get(S);if(r)return p.get(r)}m.getHeadersFromQuery=h;function f(o,i,r){if(!globalThis.crossOriginIsolated)return;const n=i&&r?"3":r?"2":"1";o instanceof URLSearchParams?o.set(S,n):o[S]=n}m.addSearchParam=f})(C||(e.COI=C={}))}),define(ke[186],Se([1,0,157,17,10,2]),function(me,e,D,O,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fD=void 0;class A{constructor(m,p,S){this.id=m,this.dependencies=p,this.callback=S}}class b{static{this.INSTANCE=new b}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(m,p,S)=>{typeof m!="string"&&(S=p,p=m,m=null),(typeof p!="object"||!Array.isArray(p))&&(S=p,p=null),this.c.push(new A(m,p,S))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(m){if(m.startsWith(window.location.origin)||m.startsWith("vscode-file://vscode-app"))return m;throw new Error(`[trusted_script_src] Invalid script url: ${m}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(m){return m}})))}async load(m){this.g();const p=await(this.a?this.i(m):this.b?this.h(m):this.j(m));if(!p)throw new Error(`Did not receive a define call from script ${m}`);if(Array.isArray(p.dependencies)&&p.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${m}. The dependencies are: ${p.dependencies.join(", ")}`);return typeof p.callback=="function"?p.callback([]):p.callback}h(m){return new Promise((p,S)=>{const h=document.createElement("script");h.setAttribute("async","async"),h.setAttribute("type","text/javascript");const f=()=>{h.removeEventListener("load",o),h.removeEventListener("error",i)},o=r=>{f(),p(this.c.pop())},i=r=>{f(),S(r)};h.addEventListener("load",o),h.addEventListener("error",i),this.f&&(m=this.f.createScriptURL(m)),h.setAttribute("src",m),window.document.getElementsByTagName("head")[0].appendChild(h)})}i(m){return new Promise((p,S)=>{try{this.f&&(m=this.f.createScriptURL(m)),importScripts(m),p(this.c.pop())}catch(h){S(h)}})}async j(m){try{const p=globalThis._VSCODE_NODE_MODULES.fs,S=globalThis._VSCODE_NODE_MODULES.vm,h=globalThis._VSCODE_NODE_MODULES.module,f=I.URI.parse(m).fsPath,o=p.readFileSync(f).toString(),i=h.wrap(o.replace(/^#!.*/,""));return new S.Script(i).runInThisContext().apply(),this.c.pop()}catch(p){throw p}}}const $=new Map;let y={};typeof globalThis.require=="object"&&(y=globalThis.require.paths??{});async function L(C,m,p){if(D.$T){p===void 0&&(p=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),y[C]&&(C=y[C]);const S=`${C}/${m}`;if($.has(S))return $.get(S);let h;if(/^\w[\w\d+.-]*:\/\//.test(S))h=S;else{const r=`${p&&!g.$o?O.$lg:O.$kg}/${S}`;h=O.$og.asBrowserUri(r).toString(!0)}const f=b.INSTANCE.load(h);return $.set(S,f),f}else return await new Promise((S,h)=>{me([C],S,h)})}e.$fD=L}),define(ke[23],Se([1,0,33,17,16,10,12,2]),function(me,e,D,O,g,I,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rg=e.DataUri=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=void 0;function $(p){return(0,b.$wc)(p,!0)}e.$vg=$;class y{constructor(S){this.a=S}compare(S,h,f=!1){return S===h?0:(0,A.$5e)(this.getComparisonKey(S,f),this.getComparisonKey(h,f))}isEqual(S,h,f=!1){return S===h?!0:!S||!h?!1:this.getComparisonKey(S,f)===this.getComparisonKey(h,f)}getComparisonKey(S,h=!1){return S.with({path:this.a(S)?S.path.toLowerCase():void 0,fragment:h?null:void 0}).toString()}ignorePathCasing(S){return this.a(S)}isEqualOrParent(S,h,f=!1){if(S.scheme===h.scheme){if(S.scheme===O.Schemas.file)return D.$8f($(S),$(h),this.a(S))&&S.query===h.query&&(f||S.fragment===h.fragment);if((0,e.$Mg)(S.authority,h.authority))return D.$8f(S.path,h.path,this.a(S),"/")&&S.query===h.query&&(f||S.fragment===h.fragment)}return!1}joinPath(S,...h){return b.URI.joinPath(S,...h)}basenameOrAuthority(S){return(0,e.$Eg)(S)||S.authority}basename(S){return g.$gc.basename(S.path)}extname(S){return g.$gc.extname(S.path)}dirname(S){if(S.path.length===0)return S;let h;return S.scheme===O.Schemas.file?h=b.URI.file(g.$mc($(S))).path:(h=g.$gc.dirname(S.path),S.authority&&h.length&&h.charCodeAt(0)!==47&&(console.error(`dirname("${S.toString})) resulted in a relative path`),h="/")),S.with({path:h})}normalizePath(S){if(!S.path.length)return S;let h;return S.scheme===O.Schemas.file?h=b.URI.file(g.$hc($(S))).path:h=g.$gc.normalize(S.path),S.with({path:h})}relativePath(S,h){if(S.scheme!==h.scheme||!(0,e.$Mg)(S.authority,h.authority))return;if(S.scheme===O.Schemas.file){const i=g.$lc($(S),$(h));return I.$i?D.$2f(i):i}let f=S.path||"/";const o=h.path||"/";if(this.a(S)){let i=0;for(const r=Math.min(f.length,o.length);i<r&&!(f.charCodeAt(i)!==o.charCodeAt(i)&&f.charAt(i).toLowerCase()!==o.charAt(i).toLowerCase());i++);f=o.substr(0,i)+f.substr(i)}return g.$gc.relative(f,o)}resolvePath(S,h){if(S.scheme===O.Schemas.file){const f=b.URI.file(g.$kc($(S),h));return S.with({authority:f.authority,path:f.path})}return h=D.$3f(h),S.with({path:g.$gc.resolve(S.path,h)})}isAbsolutePath(S){return!!S.path&&S.path[0]==="/"}isEqualAuthority(S,h){return S===h||S!==void 0&&h!==void 0&&(0,A.$_e)(S,h)}hasTrailingPathSeparator(S,h=g.sep){if(S.scheme===O.Schemas.file){const f=$(S);return f.length>D.$4f(f).length&&f[f.length-1]===h}else{const f=S.path;return f.length>1&&f.charCodeAt(f.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(S.fsPath)}}removeTrailingPathSeparator(S,h=g.sep){return(0,e.$Ng)(S,h)?S.with({path:S.path.substr(0,S.path.length-1)}):S}addTrailingPathSeparator(S,h=g.sep){let f=!1;if(S.scheme===O.Schemas.file){const o=$(S);f=o!==void 0&&o.length===D.$4f(o).length&&o[o.length-1]===h}else{h="/";const o=S.path;f=o.length===1&&o.charCodeAt(o.length-1)===47}return!f&&!(0,e.$Ng)(S,h)?S.with({path:S.path+"/"}):S}}e.$wg=y,e.$xg=new y(()=>!1),e.$yg=new y(p=>p.scheme===O.Schemas.file?!I.$k:!0),e.$zg=new y(p=>!0),e.$Ag=e.$xg.isEqual.bind(e.$xg),e.$Bg=e.$xg.isEqualOrParent.bind(e.$xg),e.$Cg=e.$xg.getComparisonKey.bind(e.$xg),e.$Dg=e.$xg.basenameOrAuthority.bind(e.$xg),e.$Eg=e.$xg.basename.bind(e.$xg),e.$Fg=e.$xg.extname.bind(e.$xg),e.$Gg=e.$xg.dirname.bind(e.$xg),e.$Hg=e.$xg.joinPath.bind(e.$xg),e.$Ig=e.$xg.normalizePath.bind(e.$xg),e.$Jg=e.$xg.relativePath.bind(e.$xg),e.$Kg=e.$xg.resolvePath.bind(e.$xg),e.$Lg=e.$xg.isAbsolutePath.bind(e.$xg),e.$Mg=e.$xg.isEqualAuthority.bind(e.$xg),e.$Ng=e.$xg.hasTrailingPathSeparator.bind(e.$xg),e.$Og=e.$xg.removeTrailingPathSeparator.bind(e.$xg),e.$Pg=e.$xg.addTrailingPathSeparator.bind(e.$xg);function L(p,S){const h=[];for(let f=0;f<p.length;f++){const o=S(p[f]);p.some((i,r)=>r===f?!1:(0,e.$Bg)(o,S(i)))||h.push(p[f])}return h}e.$Qg=L;var C;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function S(h){const f=new Map;h.path.substring(h.path.indexOf(";")+1,h.path.lastIndexOf(";")).split(";").forEach(r=>{const[n,c]=r.split(":");n&&c&&f.set(n,c)});const i=h.path.substring(0,h.path.indexOf(";"));return i&&f.set(p.META_DATA_MIME,i),f}p.parseMetaData=S})(C||(e.DataUri=C={}));function m(p,S,h){if(S){let f=p.path;return f&&f[0]!==g.$gc.sep&&(f=g.$gc.sep+f),p.with({scheme:h,authority:S,path:f})}return p.with({scheme:h})}e.$Rg=m}),define(ke[11],Se([1,0,21,14,4,3,23,10,163,43]),function(me,e,D,O,g,I,A,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.Promises=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=void 0;function L(x){return!!x&&typeof x.then=="function"}e.$Sg=L;function C(x){const te=new D.$6d,G=x(te.token),ie=new Promise((fe,pe)=>{const Pe=te.token.onCancellationRequested(()=>{Pe.dispose(),pe(new O.$5)});Promise.resolve(G).then(be=>{Pe.dispose(),te.dispose(),fe(be)},be=>{Pe.dispose(),te.dispose(),pe(be)})});return new class{cancel(){te.cancel(),te.dispose()}then(fe,pe){return ie.then(fe,pe)}catch(fe){return this.then(void 0,fe)}finally(fe){return ie.finally(fe)}}}e.$Tg=C;function m(x,te,G){return new Promise((ie,fe)=>{const pe=te.onCancellationRequested(()=>{pe.dispose(),ie(G)});x.then(ie,fe).finally(()=>pe.dispose())})}e.$Ug=m;function p(x,te){return new Promise((G,ie)=>{const fe=te.onCancellationRequested(()=>{fe.dispose(),ie(new O.$5)});x.then(G,ie).finally(()=>fe.dispose())})}e.$Vg=p;async function S(x){let te=-1;const G=x.map((ie,fe)=>ie.then(pe=>(te=fe,pe)));try{return await Promise.race(G)}finally{x.forEach((ie,fe)=>{fe!==te&&ie.cancel()})}}e.$Wg=S;function h(x,te,G){let ie;const fe=setTimeout(()=>{ie?.(void 0),G?.()},te);return Promise.race([x.finally(()=>clearTimeout(fe)),new Promise(pe=>ie=pe)])}e.$Xg=h;function f(x){return new Promise((te,G)=>{const ie=x();L(ie)?ie.then(te,G):te(ie)})}e.$Yg=f;class o{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(te){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=te,!this.b){const G=()=>{if(this.b=null,this.f)return;const ie=this.queue(this.d);return this.d=null,ie};this.b=new Promise(ie=>{this.a.then(G,G).then(ie)})}return new Promise((G,ie)=>{this.b.then(G,ie)})}return this.a=te(),new Promise((G,ie)=>{this.a.then(fe=>{this.a=null,G(fe)},fe=>{this.a=null,ie(fe)})})}dispose(){this.f=!0}}e.$Zg=o;class i{constructor(){this.a=Promise.resolve(null)}queue(te){return this.a=this.a.then(()=>te(),()=>te())}}e.$1g=i;class r{constructor(){this.a=new Map}queue(te,G){const fe=(this.a.get(te)??Promise.resolve()).catch(()=>{}).then(G).finally(()=>{this.a.get(te)===fe&&this.a.delete(te)});return this.a.set(te,fe),fe}}e.$2g=r;const n=(x,te)=>{let G=!0;const ie=setTimeout(()=>{G=!1,te()},x);return{isTriggered:()=>G,dispose:()=>{clearTimeout(ie),G=!1}}},c=x=>{let te=!0;return queueMicrotask(()=>{te&&(te=!1,x())}),{isTriggered:()=>te,dispose:()=>{te=!1}}};class t{constructor(te){this.defaultDelay=te,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(te,G=this.defaultDelay){this.g=te,this.h(),this.b||(this.b=new Promise((fe,pe)=>{this.d=fe,this.f=pe}).then(()=>{if(this.b=null,this.d=null,this.g){const fe=this.g;return this.g=null,fe()}}));const ie=()=>{this.a=null,this.d?.(null)};return this.a=G===$.$Sd?c(ie):n(G,ie),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new O.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$3g=t;class u{constructor(te){this.a=new t(te),this.b=new o}trigger(te,G){return this.a.trigger(()=>this.b.queue(te),G)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$4g=u;class s{constructor(){this.a=!1,this.b=new Promise((te,G)=>{this.d=te})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$5g=s;class l extends s{constructor(te){super(),this.f=setTimeout(()=>this.open(),te)}open(){clearTimeout(this.f),super.open()}}e.$6g=l;function a(x,te){return te?new Promise((G,ie)=>{const fe=setTimeout(()=>{pe.dispose(),G()},x),pe=te.onCancellationRequested(()=>{clearTimeout(fe),pe.dispose(),ie(new O.$5)})}):C(G=>a(x,G))}e.$7g=a;function d(x,te=0,G){const ie=setTimeout(()=>{x(),G&&fe.dispose()},te),fe=(0,I.$Rc)(()=>{clearTimeout(ie),G?.deleteAndLeak(fe)});return G?.add(fe),fe}e.$8g=d;function k(x){const te=[];let G=0;const ie=x.length;function fe(){return G<ie?x[G++]():null}function pe(Pe){Pe!=null&&te.push(Pe);const be=fe();return be?be.then(pe):Promise.resolve(te)}return Promise.resolve(null).then(pe)}e.$9g=k;function R(x,te=ie=>!!ie,G=null){let ie=0;const fe=x.length,pe=()=>{if(ie>=fe)return Promise.resolve(G);const Pe=x[ie++];return Promise.resolve(Pe()).then(De=>te(De)?Promise.resolve(De):pe())};return pe()}e.$0g=R;function v(x,te=ie=>!!ie,G=null){if(x.length===0)return Promise.resolve(G);let ie=x.length;const fe=()=>{ie=-1;for(const pe of x)pe.cancel?.()};return new Promise((pe,Pe)=>{for(const be of x)be.then(De=>{--ie>=0&&te(De)?(fe(),pe(De)):ie===0&&pe(G)}).catch(De=>{--ie>=0&&(fe(),Pe(De))})})}e.$$g=v;class w{constructor(te){this.a=0,this.b=!1,this.f=te,this.g=[],this.d=0,this.h=new g.$Vd}whenIdle(){return this.size>0?g.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(te){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((G,ie)=>{this.g.push({factory:te,c:G,e:ie}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const te=this.g.shift();this.d++;const G=te.factory();G.then(te.c,te.e),G.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$_g=w;class E extends w{constructor(){super(1)}}e.$ah=E;class P{constructor(){this.a=new J,this.b=0}queue(te){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,te())):this.a.run(this.b++,te())}}e.$bh=P;class N{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const te=new _;return this.b.add(te),te.p}g(){for(const[,te]of this.a)if(te.size>0)return!1;return!0}queueSize(te,G=A.$xg){const ie=G.getComparisonKey(te);return this.a.get(ie)?.size??0}queueFor(te,G,ie=A.$xg){const fe=ie.getComparisonKey(te);let pe=this.a.get(fe);if(!pe){pe=new E;const Pe=this.f++,be=g.Event.once(pe.onDrained)(()=>{pe?.dispose(),this.a.delete(fe),this.h(),this.d?.deleteAndDispose(Pe),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new I.$3c),this.d.set(Pe,be),this.a.set(fe,pe)}return pe.queue(G)}h(){this.g()&&this.j()}j(){for(const te of this.b)te.complete();this.b.clear()}dispose(){for(const[,te]of this.a)te.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$ch=N;class U{constructor(te,G){this.a=-1,typeof te=="function"&&typeof G=="number"&&this.setIfNotSet(te,G)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(te,G){this.cancel(),this.a=setTimeout(()=>{this.a=-1,te()},G)}setIfNotSet(te,G){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,te()},G))}}e.$dh=U;class F{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(te,G,ie=globalThis){this.cancel();const fe=ie.setInterval(()=>{te()},G);this.d=(0,I.$Rc)(()=>{ie.clearInterval(fe),this.d=void 0})}dispose(){this.cancel()}}e.$eh=F;class j{constructor(te,G){this.b=-1,this.a=te,this.d=G,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(te=this.d){this.cancel(),this.b=setTimeout(this.f,te)}get delay(){return this.d}set delay(te){this.d=te}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$fh=j;class T{constructor(te,G){G%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${G}ms is not a multiple of 1000ms.`),this.a=te,this.b=G,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(te=this.b){te%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${te}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(te/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$gh=T;class M extends j{constructor(te,G){super(te,G),this.j=[]}work(te){this.j.push(te),this.isScheduled()||this.schedule()}h(){const te=this.j;this.j=[],this.a?.(te)}dispose(){this.j=[],super.dispose()}}e.$hh=M;class B extends I.$Tc{constructor(te,G){super(),this.g=te,this.h=G,this.a=[],this.b=this.B(new I.$Uc),this.f=!1}get pending(){return this.a.length}work(te){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+te.length>this.g.maxBufferedWork)return!1}else if(this.pending+te.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const G of te)this.a.push(G);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new j(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$ih=B,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$kh=(x,te)=>{(0,b.$B)(()=>{if(G)return;const ie=Date.now()+15;te(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ie-Date.now())}}))});let G=!1;return{dispose(){G||(G=!0)}}}:e.$kh=(x,te,G)=>{const ie=x.requestIdleCallback(te,typeof G=="number"?{timeout:G}:void 0);let fe=!1;return{dispose(){fe||(fe=!0,x.cancelIdleCallback(ie))}}},e.$jh=x=>(0,e.$kh)(globalThis,x)}();class Y{constructor(te,G){this.g=!1,this.d=()=>{try{this.j=G()}catch(ie){this.l=ie}finally{this.g=!0}},this.f=(0,e.$kh)(te,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$lh=Y;class ue extends Y{constructor(te){super(globalThis,te)}}e.$mh=ue;async function Z(x,te,G){let ie;for(let fe=0;fe<G;fe++)try{return await x()}catch(pe){ie=pe,await a(te)}throw ie}e.$nh=Z;class J{isRunning(te){return typeof te=="number"?this.a?.taskId===te:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(te,G,ie){return this.a={taskId:te,cancel:()=>ie?.(),promise:G},G.then(()=>this.d(te),()=>this.d(te)),G}d(te){this.a&&te===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const te=this.b;this.b=void 0,te.run().then(te.promiseResolve,te.promiseReject)}}queue(te){if(this.b)this.b.run=te;else{let G,ie;const fe=new Promise((pe,Pe)=>{G=pe,ie=Pe});this.b={run:te,promise:fe,promiseResolve:G,promiseReject:ie}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$oh=J;class X{constructor(te,G=()=>Date.now()){this.d=te,this.f=G,this.a=0,this.b=0}increment(){const te=this.f();return te-this.a>this.d&&(this.a=te,this.b=0),this.b++,this.b}}e.$ph=X;var he;(function(x){x[x.Resolved=0]="Resolved",x[x.Rejected=1]="Rejected"})(he||(he={}));class _{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((te,G)=>{this.a=te,this.b=G})}complete(te){return new Promise(G=>{this.a(te),this.d={outcome:0,value:te},G()})}error(te){return new Promise(G=>{this.b(te),this.d={outcome:1,value:te},G()})}cancel(){return this.error(new O.$5)}}e.$qh=_;var we;(function(x){async function te(ie){let fe;const pe=await Promise.all(ie.map(Pe=>Pe.then(be=>be,be=>{fe||(fe=be)})));if(typeof fe<"u")throw fe;return pe}x.settled=te;function G(ie){return new Promise(async(fe,pe)=>{try{await ie(fe,pe)}catch(Pe){pe(Pe)}})}x.withAsyncBody=G})(we||(e.Promises=we={}));class oe{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(te){this.a=void 0,this.b=void 0,this.d=!1,this.promise=te.then(G=>(this.a=G,this.d=!0,G),G=>{throw this.b=G,this.d=!0,G})}requireValue(){if(!this.d)throw new O.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$rh=oe;class K{constructor(te){this.b=te,this.a=new y.$V(()=>new oe(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$sh=K;var W;(function(x){x[x.Initial=0]="Initial",x[x.DoneOK=1]="DoneOK",x[x.DoneError=2]="DoneError"})(W||(W={}));class re{static fromArray(te){return new re(G=>{G.emitMany(te)})}static fromPromise(te){return new re(async G=>{G.emitMany(await te)})}static fromPromises(te){return new re(async G=>{await Promise.all(te.map(async ie=>G.emitOne(await ie)))})}static merge(te){return new re(async G=>{await Promise.all(te.map(async ie=>{for await(const fe of ie)G.emitOne(fe)}))})}static{this.EMPTY=re.fromArray([])}constructor(te){this.a=0,this.b=[],this.d=null,this.f=new g.$Vd,queueMicrotask(async()=>{const G={emitOne:ie=>this.g(ie),emitMany:ie=>this.h(ie),reject:ie=>this.k(ie)};try{await Promise.resolve(te(G)),this.j()}catch(ie){this.k(ie)}finally{G.emitOne=void 0,G.emitMany=void 0,G.reject=void 0}})}[Symbol.asyncIterator](){let te=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(te<this.b.length)return{done:!1,value:this.b[te++]};if(this.a===1)return{done:!0,value:void 0};await g.Event.toPromise(this.f.event)}while(!0)}}}static map(te,G){return new re(async ie=>{for await(const fe of te)ie.emitOne(G(fe))})}map(te){return re.map(this,te)}static filter(te,G){return new re(async ie=>{for await(const fe of te)G(fe)&&ie.emitOne(fe)})}filter(te){return re.filter(this,te)}static coalesce(te){return re.filter(te,G=>!!G)}coalesce(){return re.coalesce(this)}static async toPromise(te){const G=[];for await(const ie of te)G.push(ie);return G}toPromise(){return re.toPromise(this)}g(te){this.a===0&&(this.b.push(te),this.f.fire())}h(te){this.a===0&&(this.b=this.b.concat(te),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(te){this.a===0&&(this.a=2,this.d=te,this.f.fire())}}e.$th=re;class ye extends re{constructor(te,G){super(G),this.l=te}cancel(){this.l.cancel()}}e.$uh=ye;function de(x){const te=new D.$6d,G=x(te.token);return new ye(te,async ie=>{const fe=te.token.onCancellationRequested(()=>{fe.dispose(),te.dispose(),ie.reject(new O.$5)});try{for await(const pe of G){if(te.token.isCancellationRequested)return;ie.emitOne(pe)}fe.dispose(),te.dispose()}catch(pe){fe.dispose(),te.dispose(),ie.reject(pe)}})}e.$vh=de;class ge{constructor(){this.a=new _,this.b=new re(ie=>{if(te){ie.reject(te);return}return G&&ie.emitMany(G),this.d=fe=>ie.reject(fe),this.f=fe=>ie.emitOne(fe),this.a.p});let te,G;this.f=ie=>{G||(G=[]),G.push(ie)},this.d=ie=>{te||(te=ie)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(te){this.d(te),this.a.complete()}emitOne(te){this.f(te)}}e.$wh=ge}),define(ke[34],Se([1,0,19,11,33,28,16,10,12]),function(me,e,D,O,g,I,A,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=void 0;function y(){return Object.create(null)}e.$Hj=y,e.$Ij="**",e.$Jj="/";const L="[/\\\\]",C="[^/\\\\]",m=/\//g;function p(ue,Z){switch(ue){case 0:return"";case 1:return`${C}*?`;default:return`(?:${L}|${C}+${L}${Z?`|${L}${C}+`:""})*?`}}function S(ue,Z){if(!ue)return[];const J=[];let X=!1,he=!1,_="";for(const we of ue){switch(we){case Z:if(!X&&!he){J.push(_),_="";continue}break;case"{":X=!0;break;case"}":X=!1;break;case"[":he=!0;break;case"]":he=!1;break}_+=we}return _&&J.push(_),J}e.$Kj=S;function h(ue){if(!ue)return"";let Z="";const J=S(ue,e.$Jj);if(J.every(X=>X===e.$Ij))Z=".*";else{let X=!1;J.forEach((he,_)=>{if(he===e.$Ij){if(X)return;Z+=p(2,_===J.length-1)}else{let we=!1,oe="",K=!1,W="";for(const re of he){if(re!=="}"&&we){oe+=re;continue}if(K&&(re!=="]"||!W)){let ye;re==="-"?ye=re:(re==="^"||re==="!")&&!W?ye="^":re===e.$Jj?ye="":ye=(0,$.$Oe)(re),W+=ye;continue}switch(re){case"{":we=!0;continue;case"[":K=!0;continue;case"}":{const de=`(?:${S(oe,",").map(ge=>h(ge)).join("|")})`;Z+=de,we=!1,oe="";break}case"]":{Z+="["+W+"]",K=!1,W="";break}case"?":Z+=C;continue;case"*":Z+=p(1);continue;default:Z+=(0,$.$Oe)(re)}}_<J.length-1&&(J[_+1]!==e.$Ij||_+2<J.length)&&(Z+=L)}X=he===e.$Ij})}return Z}const f=/^\*\*\/\*\.[\w\.-]+$/,o=/^\*\*\/([\w\.-]+)\/?$/,i=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,r=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,n=/^\*\*((\/[\w\.-]+)+)\/?$/,c=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new I.$Dc(1e4),u=function(){return!1},s=function(){return null};function l(ue,Z){if(!ue)return s;let J;typeof ue!="string"?J=ue.pattern:J=ue,J=J.trim();const X=`${J}_${!!Z.trimForExclusions}`;let he=t.get(X);if(he)return a(he,ue);let _;return f.test(J)?he=k(J.substr(4),J):(_=o.exec(d(J,Z)))?he=R(_[1],J):(Z.trimForExclusions?r:i).test(J)?he=v(J,Z):(_=n.exec(d(J,Z)))?he=w(_[1].substr(1),J,!0):(_=c.exec(d(J,Z)))?he=w(_[1],J,!1):he=E(J),t.set(X,he),a(he,ue)}function a(ue,Z){if(typeof Z=="string")return ue;const J=function(X,he){return(0,g.$8f)(X,Z.base,!b.$k)?ue((0,$.$Te)(X.substr(Z.base.length),A.sep),he):null};return J.allBasenames=ue.allBasenames,J.allPaths=ue.allPaths,J.basenames=ue.basenames,J.patterns=ue.patterns,J}function d(ue,Z){return Z.trimForExclusions&&ue.endsWith("/**")?ue.substr(0,ue.length-2):ue}function k(ue,Z){return function(J,X){return typeof J=="string"&&J.endsWith(ue)?Z:null}}function R(ue,Z){const J=`/${ue}`,X=`\\${ue}`,he=function(we,oe){return typeof we!="string"?null:oe?oe===ue?Z:null:we===ue||we.endsWith(J)||we.endsWith(X)?Z:null},_=[ue];return he.basenames=_,he.patterns=[Z],he.allBasenames=_,he}function v(ue,Z){const J=B(ue.slice(1,-1).split(",").map(oe=>l(oe,Z)).filter(oe=>oe!==s),ue),X=J.length;if(!X)return s;if(X===1)return J[0];const he=function(oe,K){for(let W=0,re=J.length;W<re;W++)if(J[W](oe,K))return ue;return null},_=J.find(oe=>!!oe.allBasenames);_&&(he.allBasenames=_.allBasenames);const we=J.reduce((oe,K)=>K.allPaths?oe.concat(K.allPaths):oe,[]);return we.length&&(he.allPaths=we),he}function w(ue,Z,J){const X=A.sep===A.$gc.sep,he=X?ue:ue.replace(m,A.sep),_=A.sep+he,we=A.$gc.sep+ue;let oe;return J?oe=function(K,W){return typeof K=="string"&&(K===he||K.endsWith(_)||!X&&(K===ue||K.endsWith(we)))?Z:null}:oe=function(K,W){return typeof K=="string"&&(K===he||!X&&K===ue)?Z:null},oe.allPaths=[(J?"*/":"./")+ue],oe}function E(ue){try{const Z=new RegExp(`^${h(ue)}$`);return function(J){return Z.lastIndex=0,typeof J=="string"&&Z.test(J)?ue:null}}catch{return s}}function P(ue,Z,J){return!ue||typeof Z!="string"?!1:N(ue)(Z,void 0,J)}e.$Lj=P;function N(ue,Z={}){if(!ue)return u;if(typeof ue=="string"||U(ue)){const J=l(ue,Z);if(J===s)return u;const X=function(he,_){return!!J(he,_)};return J.allBasenames&&(X.allBasenames=J.allBasenames),J.allPaths&&(X.allPaths=J.allPaths),X}return T(ue,Z)}e.$Mj=N;function U(ue){const Z=ue;return Z?typeof Z.base=="string"&&typeof Z.pattern=="string":!1}e.$Nj=U;function F(ue){return ue.allBasenames||[]}e.$Oj=F;function j(ue){return ue.allPaths||[]}e.$Pj=j;function T(ue,Z){const J=B(Object.getOwnPropertyNames(ue).map(oe=>M(oe,ue[oe],Z)).filter(oe=>oe!==s)),X=J.length;if(!X)return s;if(!J.some(oe=>!!oe.requiresSiblings)){if(X===1)return J[0];const oe=function(re,ye){let de;for(let ge=0,x=J.length;ge<x;ge++){const te=J[ge](re,ye);if(typeof te=="string")return te;(0,O.$Sg)(te)&&(de||(de=[]),de.push(te))}return de?(async()=>{for(const ge of de){const x=await ge;if(typeof x=="string")return x}return null})():null},K=J.find(re=>!!re.allBasenames);K&&(oe.allBasenames=K.allBasenames);const W=J.reduce((re,ye)=>ye.allPaths?re.concat(ye.allPaths):re,[]);return W.length&&(oe.allPaths=W),oe}const he=function(oe,K,W){let re,ye;for(let de=0,ge=J.length;de<ge;de++){const x=J[de];x.requiresSiblings&&W&&(K||(K=(0,A.$nc)(oe)),re||(re=K.substr(0,K.length-(0,A.$oc)(oe).length)));const te=x(oe,K,re,W);if(typeof te=="string")return te;(0,O.$Sg)(te)&&(ye||(ye=[]),ye.push(te))}return ye?(async()=>{for(const de of ye){const ge=await de;if(typeof ge=="string")return ge}return null})():null},_=J.find(oe=>!!oe.allBasenames);_&&(he.allBasenames=_.allBasenames);const we=J.reduce((oe,K)=>K.allPaths?oe.concat(K.allPaths):oe,[]);return we.length&&(he.allPaths=we),he}function M(ue,Z,J){if(Z===!1)return s;const X=l(ue,J);if(X===s)return s;if(typeof Z=="boolean")return X;if(Z){const he=Z.when;if(typeof he=="string"){const _=(we,oe,K,W)=>{if(!W||!X(we,oe))return null;const re=he.replace("$(basename)",()=>K),ye=W(re);return(0,O.$Sg)(ye)?ye.then(de=>de?ue:null):ye?ue:null};return _.requiresSiblings=!0,_}}return X}function B(ue,Z){const J=ue.filter(oe=>!!oe.basenames);if(J.length<2)return ue;const X=J.reduce((oe,K)=>{const W=K.basenames;return W?oe.concat(W):oe},[]);let he;if(Z){he=[];for(let oe=0,K=X.length;oe<K;oe++)he.push(Z)}else he=J.reduce((oe,K)=>{const W=K.patterns;return W?oe.concat(W):oe},[]);const _=function(oe,K){if(typeof oe!="string")return null;if(!K){let re;for(re=oe.length;re>0;re--){const ye=oe.charCodeAt(re-1);if(ye===47||ye===92)break}K=oe.substr(re)}const W=X.indexOf(K);return W!==-1?he[W]:null};_.basenames=X,_.patterns=he,_.allBasenames=X;const we=ue.filter(oe=>!oe.basenames);return we.push(_),we}function Y(ue,Z){return(0,D.$ub)(ue,Z,(J,X)=>typeof J=="string"&&typeof X=="string"?J===X:typeof J!="string"&&typeof X!="string"?J.base===X.base&&J.pattern===X.pattern:!1)}e.$Qj=Y}),define(ke[80],Se([1,0,14,164,23,12,2]),function(me,e,D,O,g,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.MarkdownStringTextNewlineStyle=void 0;var b;(function(o){o[o.Paragraph=0]="Paragraph",o[o.Break=1]="Break"})(b||(e.MarkdownStringTextNewlineStyle=b={}));class ${constructor(i="",r=!1){if(this.value=i,typeof this.value!="string")throw(0,D.$7)("value");typeof r=="boolean"?(this.isTrusted=r,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=r.isTrusted??void 0,this.supportThemeIcons=r.supportThemeIcons??!1,this.supportHtml=r.supportHtml??!1)}appendText(i,r=0){return this.value+=m(this.supportThemeIcons?(0,O.$bk)(i):i).replace(/([ \t]+)/g,(n,c)=>"&nbsp;".repeat(c.length)).replace(/\>/gm,"\\>").replace(/\n/g,r===1?`\\
`:`

`),this}appendMarkdown(i){return this.value+=i,this}appendCodeblock(i,r){return this.value+=`
${p(r,i)}
`,this}appendLink(i,r,n){return this.value+="[",this.value+=this.c(r,"]"),this.value+="](",this.value+=this.c(String(i),")"),n&&(this.value+=` "${this.c(this.c(n,'"'),")")}"`),this.value+=")",this}c(i,r){const n=new RegExp((0,I.$Oe)(r),"g");return i.replace(n,(c,t)=>i.charAt(t-1)!=="\\"?`\\${c}`:c)}}e.$hk=$;function y(o){return L(o)?!o.value:Array.isArray(o)?o.every(y):!0}e.$ik=y;function L(o){return o instanceof $?!0:o&&typeof o=="object"?typeof o.value=="string"&&(typeof o.isTrusted=="boolean"||typeof o.isTrusted=="object"||o.isTrusted===void 0)&&(typeof o.supportThemeIcons=="boolean"||o.supportThemeIcons===void 0):!1}e.$jk=L;function C(o,i){return o===i?!0:!o||!i?!1:o.value===i.value&&o.isTrusted===i.isTrusted&&o.supportThemeIcons===i.supportThemeIcons&&o.supportHtml===i.supportHtml&&(o.baseUri===i.baseUri||!!o.baseUri&&!!i.baseUri&&(0,g.$Ag)(A.URI.from(o.baseUri),A.URI.from(i.baseUri)))}e.$kk=C;function m(o){return o.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$lk=m;function p(o,i){const r=o.match(/^`+/gm)?.reduce((c,t)=>c.length>t.length?c:t).length??0,n=r>=3?r+1:3;return[`${"`".repeat(n)}${i}`,o,`${"`".repeat(n)}`].join(`
`)}e.$mk=p;function S(o){return o.replace(/"/g,"&quot;")}e.$nk=S;function h(o){return o&&o.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$ok=h;function f(o){const i=[],r=o.split("|").map(c=>c.trim());o=r[0];const n=r[1];if(n){const c=/height=(\d+)/.exec(n),t=/width=(\d+)/.exec(n),u=c?c[1]:"",s=t?t[1]:"",l=isFinite(parseInt(s)),a=isFinite(parseInt(u));l&&i.push(`width="${s}"`),a&&i.push(`height="${u}"`)}return{href:o,dimensions:i}}e.$pk=f}),define(ke[102],Se([1,0,19,33,16,10,23,12]),function(me,e,D,O,g,I,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5v=e.$4v=e.$3v=e.$2v=e.$1v=e.$Zv=e.$Yv=e.$Xv=e.$Wv=e.$Vv=void 0;function $(l,a){const{os:d,tildify:k,relative:R}=a;if(R){const E=y(l,R,d);if(typeof E=="string")return E}let v=l.fsPath;if(d===1&&!I.$i?v=v.replace(/\//g,"\\"):d!==1&&I.$i&&(v=v.replace(/\\/g,"/")),d!==1&&k?.userHome){const E=k.userHome.fsPath;let P;l.scheme!==k.userHome.scheme&&l.path[0]===g.$gc.sep&&l.path[1]!==g.$gc.sep?P=k.userHome.with({path:l.path}).fsPath:P=v,v=m(P,E,d)}return(d===1?g.$fc:g.$gc).normalize(L(v,d===1))}e.$Vv=$;function y(l,a,d){const k=d===1?g.$fc:g.$gc,R=d===3?A.$xg:A.$zg,v=a.getWorkspace(),w=(0,D.$Ob)(v.folders);if(!w)return;l.scheme!==w.uri.scheme&&l.path[0]===g.$gc.sep&&l.path[1]!==g.$gc.sep&&(l=w.uri.with({path:l.path}));const E=a.getWorkspaceFolder(l);if(!E)return;let P;if(R.isEqual(E.uri,l)?P="":P=R.relativePath(E.uri,l)??"",P&&(P=k.normalize(P)),v.folders.length>1&&!a.noPrefix){const N=E.name?E.name:R.basenameOrAuthority(E.uri);P=P?`${N} \u2022 ${P}`:N}return P}function L(l,a=I.$i){return(0,O.$_f)(l,a)?l.charAt(0).toUpperCase()+l.slice(1):l}e.$Wv=L;let C=Object.create(null);function m(l,a,d=I.OS){if(d===1||!l||!a)return l;let k=C.original===a?C.normalized:void 0;k||(k=a,I.$i&&(k=(0,O.$2f)(k)),k=`${(0,b.$Ue)(k,g.$gc.sep)}${g.$gc.sep}`,C={original:a,normalized:k});let R=l;return I.$i&&(R=(0,O.$2f)(R)),(d===3?R.startsWith(k):(0,b.$af)(R,k))?`~/${R.substr(k.length)}`:l}e.$Xv=m;function p(l,a){return l.replace(/^~($|\/|\\)/,`${a}$1`)}e.$Yv=p;const S="\u2026",h="\\\\",f="~";function o(l,a=g.sep){const d=new Array(l.length);let k=!1;for(let R=0;R<l.length;R++){const v=l[R];if(v===""){d[R]=`.${a}`;continue}if(!v){d[R]=v;continue}k=!0;let w="",E=v;E.indexOf(h)===0?(w=E.substr(0,E.indexOf(h)+h.length),E=E.substr(E.indexOf(h)+h.length)):E.indexOf(a)===0?(w=E.substr(0,E.indexOf(a)+a.length),E=E.substr(E.indexOf(a)+a.length)):E.indexOf(f)===0&&(w=E.substr(0,E.indexOf(f)+f.length),E=E.substr(E.indexOf(f)+f.length));const P=E.split(a);for(let N=1;k&&N<=P.length;N++)for(let U=P.length-N;k&&U>=0;U--){k=!1;let F=P.slice(U,U+N).join(a);for(let j=0;!k&&j<l.length;j++)if(j!==R&&l[j]&&l[j].indexOf(F)>-1){const T=U+N===P.length,M=U>0&&l[j].indexOf(a)>-1?a+F:F,B=l[j].endsWith(M);k=!T||B}if(!k){let j="";(P[0].endsWith(":")||w!=="")&&(U===1&&(U=0,N++,F=P[0]+a+F),U>0&&(j=P[0]+a),j=w+j),U>0&&(j=j+S+a),j=j+F,U+N<P.length&&(j=j+a+S),d[R]=j}}k&&(d[R]=v)}return d}e.$Zv=o;var i;(function(l){l[l.TEXT=0]="TEXT",l[l.VARIABLE=1]="VARIABLE",l[l.SEPARATOR=2]="SEPARATOR"})(i||(i={}));function r(l,a=Object.create(null)){const d=[];let k=!1,R="";for(const v of l)if(v==="$"||k&&v==="{")R&&d.push({value:R,type:i.TEXT}),R="",k=!0;else if(v==="}"&&k){const w=a[R];if(typeof w=="string")w.length&&d.push({value:w,type:i.VARIABLE});else if(w){const E=d[d.length-1];(!E||E.type!==i.SEPARATOR)&&d.push({value:w.label,type:i.SEPARATOR})}R="",k=!1}else R+=v;return R&&!k&&d.push({value:R,type:i.TEXT}),d.filter((v,w)=>{if(v.type===i.SEPARATOR){const E=d[w-1],P=d[w+1];return[E,P].every(N=>N&&(N.type===i.VARIABLE||N.type===i.TEXT)&&N.value.length>0)}return!0}).map(v=>v.value).join("")}e.$1v=r;function n(l,a){return I.$j||a?l.replace(/\(&&\w\)|&&/g,"").replace(/&/g,I.$j?"&":"&&"):l.replace(/&&|&/g,d=>d==="&"?"&&":"&")}e.$2v=n;function c(l,a){return I.$j||a?l.replace(/\(&&\w\)|&&/g,""):I.$i?l.replace(/&&|&/g,d=>d==="&"?"&&":"&"):l.replace(/&&/g,"_")}e.$3v=c;function t(l){return l.replace(/&/g,"&&")}e.$4v=t;function u(l){if(l.endsWith("]")){const a=l.lastIndexOf(" [",l.length-2);if(a!==-1){const d=s(l.substring(0,a)),k=l.substring(a);return{name:d.name+k,parentPath:d.parentPath}}}return s(l)}e.$5v=u;function s(l){const a=l.indexOf("/")!==-1?g.$gc:g.$fc,d=a.basename(l),k=a.dirname(l);return d.length?{name:d,parentPath:k}:{name:k,parentPath:""}}}),define(ke[130],Se([1,0,22,2]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8m=e.$7m=e.$6m=e.$5m=e.$4m=void 0;function g(C){return C.toJSON()}class I{constructor(m){this.a=m}transformIncoming(m){const p=this.a.transformIncoming(m);return p===m?m:g(O.URI.from(p))}transformOutgoing(m){const p=this.a.transformOutgoing(m);return p===m?m:g(O.URI.from(p))}transformOutgoingURI(m){const p=this.a.transformOutgoing(m);return p===m?m:O.URI.from(p)}transformOutgoingScheme(m){return this.a.transformOutgoingScheme(m)}}e.$4m=I,e.$5m=new class{transformIncoming(C){return C}transformOutgoing(C){return C}transformOutgoingURI(C){return C}transformOutgoingScheme(C){return C}};function A(C,m,p){if(!C||p>200)return null;if(typeof C=="object"){if(C instanceof O.URI)return m.transformOutgoing(C);for(const S in C)if(Object.hasOwnProperty.call(C,S)){const h=A(C[S],m,p+1);h!==null&&(C[S]=h)}}return null}function b(C,m){const p=A(C,m,0);return p===null?C:p}e.$6m=b;function $(C,m,p,S){if(!C||S>200)return null;if(typeof C=="object"){if(C.$mid===1)return p?O.URI.revive(m.transformIncoming(C)):m.transformIncoming(C);if(C instanceof D.$je)return null;for(const h in C)if(Object.hasOwnProperty.call(C,h)){const f=$(C[h],m,p,S+1);f!==null&&(C[h]=f)}}return null}function y(C,m){const p=$(C,m,!1,0);return p===null?C:p}e.$7m=y;function L(C,m){const p=$(C,m,!0,0);return p===null?C:p}e.$8m=L}),define(ke[31],Se([1,0,56,63,384,11,33,76,16,10,23,2]),function(me,e,D,O,g,I,A,b,$,y,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var m;(function(M){M[M.UNLINK=0]="UNLINK",M[M.MOVE=1]="MOVE"})(m||(e.RimRafMode=m={}));async function p(M,B=m.UNLINK,Y){if((0,A.$$f)(M))throw new Error("rimraf - will refuse to recursively delete root");return B===m.UNLINK?h(M):S(M,Y)}async function S(M,B=(0,A.$dg)((0,O.tmpdir)())){try{try{await D.promises.rename(M,B)}catch(Y){return Y.code==="ENOENT"?void 0:h(M)}h(B).catch(Y=>{})}catch(Y){if(Y.code!=="ENOENT")throw Y}}async function h(M){return(0,g.promisify)(D.rm)(M,{recursive:!0,force:!0,maxRetries:3})}function f(M){if((0,A.$$f)(M))throw new Error("rimraf - will refuse to recursively delete root");D.rmSync(M,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=f;async function o(M,B){return n(await(B?i(M):(0,g.promisify)(D.readdir)(M)))}async function i(M){try{return await(0,g.promisify)(D.readdir)(M,{withFileTypes:!0})}catch(ue){console.warn("[node.js fs] readdir with filetypes failed with error: ",ue)}const B=[],Y=await o(M);for(const ue of Y){let Z=!1,J=!1,X=!1;try{const he=await e.Promises.lstat((0,$.$jc)(M,ue));Z=he.isFile(),J=he.isDirectory(),X=he.isSymbolicLink()}catch(he){console.warn("[node.js fs] unexpected error from lstat after readdir: ",he)}B.push({name:ue,isFile:()=>Z,isDirectory:()=>J,isSymbolicLink:()=>X})}return B}function r(M){return n(D.readdirSync(M))}e.readdirSync=r;function n(M){return M.map(B=>typeof B=="string"?y.$j?(0,b.$Gl)(B):B:(B.name=y.$j?(0,b.$Gl)(B.name):B.name,B))}async function c(M){const B=await o(M),Y=[];for(const ue of B)await u.existsDirectory((0,$.$jc)(M,ue))&&Y.push(ue);return Y}function t(M,B=1e3){return new Promise(Y=>{let ue=!1;const Z=setInterval(()=>{ue||(ue=!0,D.access(M,J=>{ue=!1,J&&(clearInterval(Z),Y(void 0))}))},B)})}e.whenDeleted=t;var u;(function(M){async function B(Z){let J;try{if(J=await e.Promises.lstat(Z),!J.isSymbolicLink())return{stat:J}}catch{}try{return{stat:await e.Promises.stat(Z),symbolicLink:J?.isSymbolicLink()?{dangling:!1}:void 0}}catch(X){if(X.code==="ENOENT"&&J)return{stat:J,symbolicLink:{dangling:!0}};if(y.$i&&X.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(Z)),symbolicLink:{dangling:!1}}}catch(he){if(he.code==="ENOENT"&&J)return{stat:J,symbolicLink:{dangling:!0}};throw he}throw X}}M.stat=B;async function Y(Z){try{const{stat:J,symbolicLink:X}=await M.stat(Z);return J.isFile()&&X?.dangling!==!0}catch{}return!1}M.existsFile=Y;async function ue(Z){try{const{stat:J,symbolicLink:X}=await M.stat(Z);return J.isDirectory()&&X?.dangling!==!0}catch{}return!1}M.existsDirectory=ue})(u||(e.SymlinkSupport=u={}));const s=new I.$ch;function l(M,B,Y){return s.queueFor(C.URI.file(M),()=>{const ue=v(Y);return new Promise((Z,J)=>k(M,B,ue,X=>X?J(X):Z()))},L.$yg)}let a=!0;function d(M){a=M}e.configureFlushOnWrite=d;function k(M,B,Y,ue){if(!a)return D.writeFile(M,B,{mode:Y.mode,flag:Y.flag},ue);D.open(M,Y.flag,Y.mode,(Z,J)=>{if(Z)return ue(Z);D.writeFile(J,B,X=>{if(X)return D.close(J,()=>ue(X));D.fdatasync(J,he=>(he&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",he),d(!1)),D.close(J,_=>ue(_))))})})}function R(M,B,Y){const ue=v(Y);if(!a)return D.writeFileSync(M,B,{mode:ue.mode,flag:ue.flag});const Z=D.openSync(M,ue.flag,ue.mode);try{D.writeFileSync(Z,B);try{D.fdatasyncSync(Z)}catch(J){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",J),d(!1)}}finally{D.closeSync(Z)}}e.writeFileSync=R;function v(M){return M?{mode:typeof M.mode=="number"?M.mode:438,flag:typeof M.flag=="string"?M.flag:"w"}:{mode:438,flag:"w"}}async function w(M,B,Y=6e4){if(M!==B)try{y.$i&&typeof Y=="number"?await E(M,B,Date.now(),Y):await(0,g.promisify)(D.rename)(M,B)}catch(ue){if(M.toLowerCase()!==B.toLowerCase()&&ue.code==="EXDEV"||M.endsWith("."))await P(M,B,{preserveSymlinks:!1}),await p(M,m.MOVE);else throw ue}}async function E(M,B,Y,ue,Z=0){try{return await(0,g.promisify)(D.rename)(M,B)}catch(J){if(J.code!=="EACCES"&&J.code!=="EPERM"&&J.code!=="EBUSY")throw J;if(Date.now()-Y>=ue)throw console.error(`[node.js fs] rename failed after ${Z} retries with error: ${J}`),J;if(Z===0){let X=!1;try{const{stat:he}=await u.stat(B);he.isFile()||(X=!0)}catch{}if(X)throw J}return await(0,I.$7g)(Math.min(100,Z*10)),E(M,B,Y,ue,Z+1)}}async function P(M,B,Y){return U(M,B,{root:{source:M,target:B},options:Y,handledSourcePaths:new Set})}const N=511;async function U(M,B,Y){if(Y.handledSourcePaths.has(M))return;Y.handledSourcePaths.add(M);const{stat:ue,symbolicLink:Z}=await u.stat(M);if(Z){if(Y.options.preserveSymlinks)try{return await T(M,B,Y)}catch{}if(Z.dangling)return}return ue.isDirectory()?F(M,B,ue.mode&N,Y):j(M,B,ue.mode&N)}async function F(M,B,Y,ue){await e.Promises.mkdir(B,{recursive:!0,mode:Y});const Z=await o(M);for(const J of Z)await U((0,$.$jc)(M,J),(0,$.$jc)(B,J),ue)}async function j(M,B,Y){await e.Promises.copyFile(M,B),await e.Promises.chmod(B,Y)}async function T(M,B,Y){let ue=await e.Promises.readlink(M);(0,A.$8f)(ue,Y.root.source,!y.$k)&&(ue=(0,$.$jc)(Y.root.target,ue.substr(Y.root.source.length+1))),await e.Promises.symlink(ue,B)}e.Promises=new class{get access(){return(0,g.promisify)(D.access)}get stat(){return(0,g.promisify)(D.stat)}get lstat(){return(0,g.promisify)(D.lstat)}get utimes(){return(0,g.promisify)(D.utimes)}get read(){return(M,B,Y,ue,Z)=>new Promise((J,X)=>{D.read(M,B,Y,ue,Z,(he,_,we)=>he?X(he):J({bytesRead:_,buffer:we}))})}get readFile(){return(0,g.promisify)(D.readFile)}get write(){return(M,B,Y,ue,Z)=>new Promise((J,X)=>{D.write(M,B,Y,ue,Z,(he,_,we)=>he?X(he):J({bytesWritten:_,buffer:we}))})}get appendFile(){return(0,g.promisify)(D.appendFile)}get fdatasync(){return(0,g.promisify)(D.fdatasync)}get truncate(){return(0,g.promisify)(D.truncate)}get copyFile(){return(0,g.promisify)(D.copyFile)}get open(){return(0,g.promisify)(D.open)}get close(){return(0,g.promisify)(D.close)}get symlink(){return(0,g.promisify)(D.symlink)}get readlink(){return(0,g.promisify)(D.readlink)}get chmod(){return(0,g.promisify)(D.chmod)}get mkdir(){return(0,g.promisify)(D.mkdir)}get unlink(){return(0,g.promisify)(D.unlink)}get rmdir(){return(0,g.promisify)(D.rmdir)}get realpath(){return(0,g.promisify)(D.realpath)}async exists(M){try{return await e.Promises.access(M),!0}catch{return!1}}get readdir(){return o}get readDirsInDir(){return c}get writeFile(){return l}get rm(){return p}get rename(){return w}get copy(){return P}}}),define(ke[103],Se([1,0,56,16,10,12,31]),function(me,e,D,O,g,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wq=e.$vq=e.$uq=e.$tq=void 0;function b(m){if(g.$k)return m;const p=(0,O.$mc)(m);if(m===p)return m;const S=((0,O.$nc)(m)||m).toLowerCase();try{const f=(0,A.readdirSync)(p).filter(o=>o.toLowerCase()===S);if(f.length===1){const o=b(p);if(o)return(0,O.$jc)(o,f[0])}else if(f.length>1){const o=f.indexOf(S);if(o>=0){const i=b(p);if(i)return(0,O.$jc)(i,f[o])}}}catch{}return null}e.$tq=b;async function $(m){if(g.$k)return m;const p=(0,O.$mc)(m);if(m===p)return m;const S=((0,O.$nc)(m)||m).toLowerCase();try{const f=(await A.Promises.readdir(p)).filter(o=>o.toLowerCase()===S);if(f.length===1){const o=await $(p);if(o)return(0,O.$jc)(o,f[0])}else if(f.length>1){const o=f.indexOf(S);if(o>=0){const i=await $(p);if(i)return(0,O.$jc)(i,f[o])}}}catch{}return null}e.$uq=$;async function y(m){try{return await A.Promises.realpath(m)}catch{const S=C(m);return await A.Promises.access(S,D.constants.R_OK),S}}e.$vq=y;function L(m){try{return D.realpathSync(m)}catch{const S=C(m);return D.accessSync(S,D.constants.R_OK),S}}e.$wq=L;function C(m){return(0,I.$Ue)((0,O.$hc)(m),O.sep)}}),define(ke[104],Se([1,0,16,10,49,101,18,31]),function(me,e,D,O,g,I,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$Ul=e.$Tl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return I.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return I.TerminateResponseCode}});function $(C=g.env){return C.comspec||"cmd.exe"}e.$Tl=$;function y(C){let m=[],p=!1;const S=function(h){if(p){m.push(h);return}(!C.send(h,o=>{if(o&&console.error(o),p=!1,m.length>0){const i=m.slice(0);m=[],i.forEach(r=>S(r))}})||O.$i)&&(p=!0)};return{send:S}}e.$Ul=y;var L;(function(C){async function m(p,S,h){if(D.$ic(p))return p;if(S===void 0&&(S=g.cwd()),D.$mc(p)!=="."||(h===void 0&&A.$If(g.env.PATH)&&(h=g.env.PATH.split(D.$tc)),h===void 0||h.length===0))return D.$jc(S,p);async function o(i){if(await b.Promises.exists(i)){let r;try{r=await b.Promises.stat(i)}catch(n){n.message.startsWith("EACCES")&&(r=await b.Promises.lstat(i))}return r?!r.isDirectory():!1}return!1}for(const i of h){let r;if(D.$ic(i)?r=D.$jc(i,p):r=D.$jc(S,i,p),await o(r))return r;let n=r+".com";if(await o(n)||(n=r+".exe",await o(n)))return n}return D.$jc(S,p)}C.findExecutable=m})(L||(e.win32=L={}))});var Ge=this&&this.__decorate||function(me,e,D,O){var g=arguments.length,I=g<3?e:O===null?O=Object.getOwnPropertyDescriptor(e,D):O,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")I=Reflect.decorate(me,e,D,O);else for(var b=me.length-1;b>=0;b--)(A=me[b])&&(I=(g<3?A(I):g>3?A(e,D,I):A(e,D))||I);return g>3&&I&&Object.defineProperty(e,D,I),I};define(ke[81],Se([1,0,19,11,22,21,52,14,4,3,55,12,18]),function(me,e,D,O,g,I,A,b,$,y,L,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oh=e.ProxyChannel=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.RequestInitiator=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=void 0;var p;(function(Z){Z[Z.Promise=100]="Promise",Z[Z.PromiseCancel=101]="PromiseCancel",Z[Z.EventListen=102]="EventListen",Z[Z.EventDispose=103]="EventDispose"})(p||(p={}));function S(Z){switch(Z){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var h;(function(Z){Z[Z.Initialize=200]="Initialize",Z[Z.PromiseSuccess=201]="PromiseSuccess",Z[Z.PromiseError=202]="PromiseError",Z[Z.PromiseErrorObj=203]="PromiseErrorObj",Z[Z.EventFire=204]="EventFire"})(h||(h={}));function f(Z){switch(Z){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var o;(function(Z){Z[Z.Uninitialized=0]="Uninitialized",Z[Z.Idle=1]="Idle"})(o||(o={}));function i(Z){let J=0;for(let X=0;;X+=7){const he=Z.read(1);if(J|=(he.buffer[0]&127)<<X,!(he.buffer[0]&128))return J}}const r=s(0);function n(Z,J){if(J===0){Z.write(r);return}let X=0;for(let _=J;_!==0;_=_>>>7)X++;const he=g.$je.alloc(X);for(let _=0;J!==0;_++)he.buffer[_]=J&127,J=J>>>7,J>0&&(he.buffer[_]|=128);Z.write(he)}class c{constructor(J){this.b=J,this.a=0}read(J){const X=this.b.slice(this.a,this.a+J);return this.a+=X.byteLength,X}}e.$Dh=c;class t{constructor(){this.a=[]}get buffer(){return g.$je.concat(this.a)}write(J){this.a.push(J)}}e.$Eh=t;var u;(function(Z){Z[Z.Undefined=0]="Undefined",Z[Z.String=1]="String",Z[Z.Buffer=2]="Buffer",Z[Z.VSBuffer=3]="VSBuffer",Z[Z.Array=4]="Array",Z[Z.Object=5]="Object",Z[Z.Int=6]="Int"})(u||(u={}));function s(Z){const J=g.$je.alloc(1);return J.writeUInt8(Z,0),J}const l={Undefined:s(u.Undefined),String:s(u.String),Buffer:s(u.Buffer),VSBuffer:s(u.VSBuffer),Array:s(u.Array),Object:s(u.Object),Uint:s(u.Int)},a=typeof Buffer<"u";function d(Z,J){if(typeof J>"u")Z.write(l.Undefined);else if(typeof J=="string"){const X=g.$je.fromString(J);Z.write(l.String),n(Z,X.byteLength),Z.write(X)}else if(a&&Buffer.isBuffer(J)){const X=g.$je.wrap(J);Z.write(l.Buffer),n(Z,X.byteLength),Z.write(X)}else if(J instanceof g.$je)Z.write(l.VSBuffer),n(Z,J.byteLength),Z.write(J);else if(Array.isArray(J)){Z.write(l.Array),n(Z,J.length);for(const X of J)d(Z,X)}else if(typeof J=="number"&&(J|0)===J)Z.write(l.Uint),n(Z,J);else{const X=g.$je.fromString(JSON.stringify(J));Z.write(l.Object),n(Z,X.byteLength),Z.write(X)}}e.$Fh=d;function k(Z){switch(Z.read(1).readUInt8(0)){case u.Undefined:return;case u.String:return Z.read(i(Z)).toString();case u.Buffer:return Z.read(i(Z)).buffer;case u.VSBuffer:return Z.read(i(Z));case u.Array:{const X=i(Z),he=[];for(let _=0;_<X;_++)he.push(k(Z));return he}case u.Object:return JSON.parse(Z.read(i(Z)).toString());case u.Int:return i(Z)}}e.$Gh=k;class R{constructor(J,X,he=null,_=1e3){this.h=J,this.j=X,this.k=he,this.l=_,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(we=>this.q(we)),this.m({type:200})}registerChannel(J,X){this.b.set(J,X),setTimeout(()=>this.w(J),0)}m(J){switch(J.type){case 200:{const X=this.o([J.type]);this.k?.logOutgoing(X,0,1,f(J.type));return}case 201:case 202:case 204:case 203:{const X=this.o([J.type,J.id],J.data);this.k?.logOutgoing(X,J.id,1,f(J.type),J.data);return}}}o(J,X=void 0){const he=new t;return d(he,J),d(he,X),this.p(he.buffer)}p(J){try{return this.h.send(J),J.byteLength}catch{return 0}}q(J){const X=new c(J),he=k(X),_=k(X),we=he[0];switch(we){case 100:return this.k?.logIncoming(J.byteLength,he[1],1,`${S(we)}: ${he[2]}.${he[3]}`,_),this.s({type:we,id:he[1],channelName:he[2],name:he[3],arg:_});case 102:return this.k?.logIncoming(J.byteLength,he[1],1,`${S(we)}: ${he[2]}.${he[3]}`,_),this.t({type:we,id:he[1],channelName:he[2],name:he[3],arg:_});case 101:return this.k?.logIncoming(J.byteLength,he[1],1,`${S(we)}`),this.u({type:we,id:he[1]});case 103:return this.k?.logIncoming(J.byteLength,he[1],1,`${S(we)}`),this.u({type:we,id:he[1]})}}s(J){const X=this.b.get(J.channelName);if(!X){this.v(J);return}const he=new I.$6d;let _;try{_=X.call(this.j,J.name,J.arg,he.token)}catch(K){_=Promise.reject(K)}const we=J.id;_.then(K=>{this.m({id:we,data:K,type:201})},K=>{K instanceof Error?this.m({id:we,data:{message:K.message,name:K.name,stack:K.stack?K.stack.split?K.stack.split(`
`):K.stack:void 0},type:202}):this.m({id:we,data:K,type:203})}).finally(()=>{oe.dispose(),this.d.delete(J.id)});const oe=(0,y.$Rc)(()=>he.cancel());this.d.set(J.id,oe)}t(J){const X=this.b.get(J.channelName);if(!X){this.v(J);return}const he=J.id,we=X.listen(this.j,J.name,J.arg)(oe=>this.m({id:he,data:oe,type:204}));this.d.set(J.id,we)}u(J){const X=this.d.get(J.id);X&&(X.dispose(),this.d.delete(J.id))}v(J){let X=this.g.get(J.channelName);X||(X=[],this.g.set(J.channelName,X));const he=setTimeout(()=>{console.error(`Unknown channel: ${J.channelName}`),J.type===100&&this.m({id:J.id,data:{name:"Unknown channel",message:`Channel name '${J.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);X.push({request:J,timeoutTimer:he})}w(J){const X=this.g.get(J);if(X){for(const he of X)switch(clearTimeout(he.timeoutTimer),he.request.type){case 100:this.s(he.request);break;case 102:this.t(he.request);break}this.g.delete(J)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,y.$Oc)(this.d.values()),this.d.clear()}}e.$Hh=R;var v;(function(Z){Z[Z.LocalSide=0]="LocalSide",Z[Z.OtherSide=1]="OtherSide"})(v||(e.RequestInitiator=v={}));class w{constructor(J,X=null){this.l=J,this.a=!1,this.b=o.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new $.$Vd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(he=>this.s(he)),this.j=X}getChannel(J){const X=this;return{call(he,_,we){return X.a?Promise.reject(new b.$5):X.m(J,he,_,we)},listen(he,_){return X.a?$.Event.None:X.o(J,he,_)}}}m(J,X,he,_=I.CancellationToken.None){const we=this.g++,K={id:we,type:100,channelName:J,name:X,arg:he};if(_.isCancellationRequested)return Promise.reject(new b.$5);let W;return new Promise((ye,de)=>{if(_.isCancellationRequested)return de(new b.$5);const ge=()=>{const ie=fe=>{switch(fe.type){case 201:this.f.delete(we),ye(fe.data);break;case 202:{this.f.delete(we);const pe=new Error(fe.data.message);pe.stack=Array.isArray(fe.data.stack)?fe.data.stack.join(`
`):fe.data.stack,pe.name=fe.data.name,de(pe);break}case 203:this.f.delete(we),de(fe.data);break}};this.f.set(we,ie),this.p(K)};let x=null;this.b===o.Idle?ge():(x=(0,O.$Tg)(ie=>this.u()),x.then(()=>{x=null,ge()}));const te=()=>{x?(x.cancel(),x=null):this.p({id:we,type:101}),de(new b.$5)},G=_.onCancellationRequested(te);W=(0,y.$Qc)((0,y.$Rc)(te),G),this.d.add(W)}).finally(()=>{W.dispose(),this.d.delete(W)})}o(J,X,he){const _=this.g++,oe={id:_,type:102,channelName:J,name:X,arg:he};let K=null;const W=new $.$Vd({onWillAddFirstListener:()=>{K=(0,O.$Tg)(ye=>this.u()),K.then(()=>{K=null,this.d.add(W),this.p(oe)})},onDidRemoveLastListener:()=>{K?(K.cancel(),K=null):(this.d.delete(W),this.p({id:_,type:103}))}}),re=ye=>W.fire(ye.data);return this.f.set(_,re),W.event}p(J){switch(J.type){case 100:case 102:{const X=this.q([J.type,J.id,J.channelName,J.name],J.arg);this.j?.logOutgoing(X,J.id,0,`${S(J.type)}: ${J.channelName}.${J.name}`,J.arg);return}case 101:case 103:{const X=this.q([J.type,J.id]);this.j?.logOutgoing(X,J.id,0,S(J.type));return}}}q(J,X=void 0){const he=new t;return d(he,J),d(he,X),this.r(he.buffer)}r(J){try{return this.l.send(J),J.byteLength}catch{return 0}}s(J){const X=new c(J),he=k(X),_=k(X),we=he[0];switch(we){case 200:return this.j?.logIncoming(J.byteLength,0,0,f(we)),this.t({type:he[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(J.byteLength,he[1],0,f(we),_),this.t({type:he[0],id:he[1],data:_})}}t(J){if(J.type===200){this.b=o.Idle,this.k.fire();return}this.f.get(J.id)?.(J)}get onDidInitializePromise(){return $.Event.toPromise(this.onDidInitialize)}u(){return this.b===o.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,y.$Oc)(this.d.values()),this.d.clear()}}e.$Ih=w,Ge([A.$xh],w.prototype,"onDidInitializePromise",null);class E{get connections(){const J=[];return this.f.forEach(X=>J.push(X)),J}constructor(J){this.a=new Map,this.f=new Set,this.g=new $.$Vd,this.onDidAddConnection=this.g.event,this.h=new $.$Vd,this.onDidRemoveConnection=this.h.event,this.j=new y.$Sc,this.j.add(J(({protocol:X,onDidClientDisconnect:he})=>{const _=$.Event.once(X.onMessage);this.j.add(_(we=>{const oe=new c(we),K=k(oe),W=new R(X,K),re=new w(X);this.a.forEach((de,ge)=>W.registerChannel(ge,de));const ye={channelServer:W,channelClient:re,ctx:K};this.f.add(ye),this.g.fire(ye),this.j.add(he(()=>{W.dispose(),re.dispose(),this.f.delete(ye),this.h.fire(ye)}))}))}))}getChannel(J,X){const he=this;return{call(_,we,oe){let K;if((0,m.$Wf)(X)){const re=(0,D.$4b)(he.connections.filter(X));K=re?Promise.resolve(re):$.Event.toPromise($.Event.filter(he.onDidAddConnection,X))}else K=X.routeCall(he,_,we);const W=K.then(re=>re.channelClient.getChannel(J));return N(W).call(_,we,oe)},listen(_,we){if((0,m.$Wf)(X))return he.k(J,X,_,we);const oe=X.routeEvent(he,_,we).then(K=>K.channelClient.getChannel(J));return N(oe).listen(_,we)}}}k(J,X,he,_){const we=this;let oe;const K=new $.$Vd({onWillAddFirstListener:()=>{oe=new y.$Sc;const W=new $.$2d,re=new Map,ye=ge=>{const te=ge.channelClient.getChannel(J).listen(he,_),G=W.add(te);re.set(ge,G)},de=ge=>{const x=re.get(ge);x&&(x.dispose(),re.delete(ge))};we.connections.filter(X).forEach(ye),$.Event.filter(we.onDidAddConnection,X)(ye,void 0,oe),we.onDidRemoveConnection(de,void 0,oe),W.event(K.fire,K,oe),oe.add(W)},onDidRemoveLastListener:()=>{oe?.dispose(),oe=void 0}});return K.event}registerChannel(J,X){this.a.set(J,X);for(const he of this.f)he.channelServer.registerChannel(J,X)}dispose(){this.j.dispose();for(const J of this.f)J.channelClient.dispose(),J.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$Jh=E;class P{constructor(J,X,he=null){const _=new t;d(_,X),J.send(_.buffer),this.a=new w(J,he),this.d=new R(J,X,he)}getChannel(J){return this.a.getChannel(J)}registerChannel(J,X){this.d.registerChannel(J,X)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Kh=P;function N(Z){return{call(J,X,he){return Z.then(_=>_.call(J,X,he))},listen(J,X){const he=new $.$5d;return Z.then(_=>he.input=_.listen(J,X)),he.event}}}e.$Lh=N;function U(Z){let J=!1;return{call(X,he,_){return J?Z.call(X,he,_):(0,O.$7g)(0).then(()=>J=!0).then(()=>Z.call(X,he,_))},listen(X,he){if(J)return Z.listen(X,he);const _=new $.$5d;return(0,O.$7g)(0).then(()=>J=!0).then(()=>_.input=Z.listen(X,he)),_.event}}}e.$Mh=U;class F{constructor(J){this.a=J}routeCall(J){return this.b(J)}routeEvent(J){return this.b(J)}async b(J){for(const X of J.connections)if(await Promise.resolve(this.a(X.ctx)))return Promise.resolve(X);return await $.Event.toPromise(J.onDidAddConnection),await this.b(J)}}e.$Nh=F;var j;(function(Z){function J(we,oe,K){const W=we,re=K&&K.disableMarshalling,ye=new Map;for(const de in W)he(de)&&ye.set(de,$.Event.buffer(W[de],!0,void 0,oe));return new class{listen(de,ge,x){const te=ye.get(ge);if(te)return te;if(_(ge)){const G=W[ge];if(typeof G=="function")return G.call(W,x)}throw new b.$bb(`Event not found: ${ge}`)}call(de,ge,x){const te=W[ge];if(typeof te=="function"){if(!re&&Array.isArray(x))for(let ie=0;ie<x.length;ie++)x[ie]=(0,L.$Ch)(x[ie]);let G=te.apply(W,x);return G instanceof Promise||(G=Promise.resolve(G)),G}throw new b.$bb(`Method not found: ${ge}`)}}}Z.fromService=J;function X(we,oe){const K=oe&&oe.disableMarshalling;return new Proxy({},{get(W,re){if(typeof re=="string")return oe?.properties?.has(re)?oe.properties.get(re):_(re)?function(ye){return we.listen(re,ye)}:he(re)?we.listen(re):async function(...ye){let de;oe&&!(0,m.$Rf)(oe.context)?de=[oe.context,...ye]:de=ye;const ge=await we.call(re,de);return K?ge:(0,L.$Ch)(ge)};throw new b.$bb(`Property not found: ${String(re)}`)}})}Z.toService=X;function he(we){return we[0]==="o"&&we[1]==="n"&&C.$$e(we.charCodeAt(2))}function _(we){return/^onDynamic/.test(we)&&C.$$e(we.charCodeAt(9))}})(j||(e.ProxyChannel=j={}));const T=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function M(Z){if(Array.isArray(Z))return Z;if(Z&&typeof Z=="object"&&typeof Z.toString=="function"){const J=Z.toString();if(J!=="[object Object]")return J}return Z}function B(Z){return Array.isArray(Z)?Z.map(M):M(Z)}function Y(Z,J,X,he,_,we,oe){oe=B(oe);const K=T[_],W=K[he%K.length];let re=[`%c[${Z}]%c[${String(J).padStart(7," ")}]%c[len: ${String(X).padStart(5," ")}]%c${String(he).padStart(5," ")} - ${we}`,"color: darkgreen","color: grey","color: grey",`color: ${W}`];/\($/.test(we)?(re=re.concat(oe),re.push(")")):re.push(oe),console.log.apply(console,re)}class ue{constructor(J,X){this.d=J,this.f=X,this.a=0,this.b=0}logOutgoing(J,X,he,_,we){this.b+=J,Y(this.d,this.b,J,X,he,_,we)}logIncoming(J,X,he,_,we){this.a+=J,Y(this.f,this.a,J,X,he,_,we)}}e.$Oh=ue}),define(ke[82],Se([1,0,22,4,3,81]),function(me,e,D,O,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Th=e.$Sh=e.$Rh=e.$Qh=e.ProtocolConstants=e.$Ph=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var A;(function(l){l.Created="created",l.Read="read",l.Write="write",l.Open="open",l.Error="error",l.Close="close",l.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",l.NodeEndReceived="nodeEndReceived",l.NodeEndSent="nodeEndSent",l.NodeDrainBegin="nodeDrainBegin",l.NodeDrainEnd="nodeDrainEnd",l.zlibInflateError="zlibInflateError",l.zlibInflateData="zlibInflateData",l.zlibInflateInitialWrite="zlibInflateInitialWrite",l.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",l.zlibInflateWrite="zlibInflateWrite",l.zlibInflateFlushFired="zlibInflateFlushFired",l.zlibDeflateError="zlibDeflateError",l.zlibDeflateData="zlibDeflateData",l.zlibDeflateWrite="zlibDeflateWrite",l.zlibDeflateFlushFired="zlibDeflateFlushFired",l.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",l.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",l.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",l.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",l.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",l.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",l.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",l.ProtocolHeaderRead="protocolHeaderRead",l.ProtocolMessageRead="protocolMessageRead",l.ProtocolHeaderWrite="protocolHeaderWrite",l.ProtocolMessageWrite="protocolMessageWrite",l.ProtocolWrite="protocolWrite"})(A||(e.SocketDiagnosticsEventType=A={}));var b;(function(l){l.enableDiagnostics=!1,l.records=[];const a=new WeakMap;let d=0;function k(v,w){if(!a.has(v)){const E=String(++d);a.set(v,E)}return a.get(v)}function R(v,w,E,P){if(!l.enableDiagnostics)return;const N=k(v,w);if(P instanceof D.$je||P instanceof Uint8Array||P instanceof ArrayBuffer||ArrayBuffer.isView(P)){const U=D.$je.alloc(P.byteLength);U.set(P),l.records.push({timestamp:Date.now(),id:N,label:w,type:E,buff:U})}else l.records.push({timestamp:Date.now(),id:N,label:w,type:E,data:P})}l.traceSocketEvent=R})(b||(e.SocketDiagnostics=b={}));var $;(function(l){l[l.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",l[l.WebSocketCloseEvent=1]="WebSocketCloseEvent"})($||(e.SocketCloseEventType=$={}));let y=null;function L(){return y||(y=D.$je.alloc(0)),y}class C{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(a){this.a.push(a),this.b+=a.byteLength}read(a){return this.c(a,!0)}peek(a){return this.c(a,!1)}c(a,d){if(a===0)return L();if(a>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===a){const w=this.a[0];return d&&(this.a.shift(),this.b-=a),w}if(this.a[0].byteLength>a){const w=this.a[0].slice(0,a);return d&&(this.a[0]=this.a[0].slice(a),this.b-=a),w}const k=D.$je.alloc(a);let R=0,v=0;for(;a>0;){const w=this.a[v];if(w.byteLength>a){const E=w.slice(0,a);k.set(E,R),R+=a,d&&(this.a[v]=w.slice(a),this.b-=a),a-=a}else k.set(w,R),R+=w.byteLength,d?(this.a.shift(),this.b-=w.byteLength):v++,a-=w.byteLength}return k}}e.$Ph=C;var m;(function(l){l[l.None=0]="None",l[l.Regular=1]="Regular",l[l.Control=2]="Control",l[l.Ack=3]="Ack",l[l.Disconnect=5]="Disconnect",l[l.ReplayRequest=6]="ReplayRequest",l[l.Pause=7]="Pause",l[l.Resume=8]="Resume",l[l.KeepAlive=9]="KeepAlive"})(m||(m={}));function p(l){switch(l){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var S;(function(l){l[l.HeaderLength=13]="HeaderLength",l[l.AcknowledgeTime=2e3]="AcknowledgeTime",l[l.TimeoutTime=2e4]="TimeoutTime",l[l.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",l[l.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",l[l.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(S||(e.ProtocolConstants=S={}));class h{constructor(a,d,k,R){this.type=a,this.id=d,this.ack=k,this.data=R,this.writtenTime=0}get size(){return this.data.byteLength}}class f extends g.$Tc{constructor(a){super(),this.f=this.B(new O.$Vd),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=a,this.b=!1,this.c=new C,this.B(this.a.onData(d=>this.acceptChunk(d))),this.lastReadTime=Date.now()}acceptChunk(a){if(!(!a||a.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(a);this.c.byteLength>=this.g.readLen;){const d=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=d.readUInt32BE(9),this.g.messageType=d.readUInt8(0),this.g.id=d.readUInt32BE(1),this.g.ack=d.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:p(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const k=this.g.messageType,R=this.g.id,v=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",d),this.f.fire(new h(k,R,v,d)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class o{constructor(a){this.k=null,this.a=!1,this.b=!1,this.c=a,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(a){if(this.a)return;a.writtenTime=Date.now(),this.lastWriteTime=Date.now();const d=D.$je.alloc(13);d.writeUInt8(a.type,0),d.writeUInt32BE(a.id,1),d.writeUInt32BE(a.ack,5),d.writeUInt32BE(a.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:p(a.type),id:a.id,ack:a.ack,messageSize:a.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",a.data),this.j(d,a.data)}g(a,d){const k=this.f===0;return this.d.push(a,d),this.f+=a.byteLength+d.byteLength,k}h(){const a=D.$je.concat(this.d,this.f);return this.d.length=0,this.f=0,a}j(a,d){this.g(a,d)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const a=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:a.byteLength}),this.c.write(a)}}class i extends g.$Tc{constructor(a){super(),this.f=new O.$Vd,this.onMessage=this.f.event,this.g=new O.$Vd,this.onDidDispose=this.g.event,this.a=a,this.b=this.B(new o(this.a)),this.c=this.B(new f(this.a)),this.B(this.c.onMessage(d=>{d.type===1&&this.f.fire(d.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(a){this.b.write(new h(1,0,0,a))}}e.$Qh=i;class r extends I.$Kh{static fromSocket(a,d){return new r(new i(a),d)}get onDidDispose(){return this.b.onDidDispose}constructor(a,d,k=null){super(a,d,k),this.b=a}dispose(){super.dispose();const a=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),a.end()}}e.$Rh=r;class n{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new O.$Vd({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(a){this.b?this.d.length>0?this.d.push(a):this.a.fire(a):this.d.push(a)}flushBuffer(){this.d=[]}}e.$Sh=n;class c{constructor(a){this.data=a,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let a=0,d=this.a;for(;d;)d=d.next,a++;return a}peek(){return this.a?this.a.data:null}toArray(){const a=[];let d=0,k=this.a;for(;k;)a[d++]=k.data,k=k.next;return a}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(a){const d=new c(a);if(!this.a){this.a=d,this.b=d;return}this.b.next=d,this.b=d}}class u{static{this.a=10}static{this.b=null}static getInstance(){return u.b||(u.b=new u),u.b}constructor(){this.c=[];const a=Date.now();for(let d=0;d<u.a;d++)this.c[d]=a-1e3*d;setInterval(()=>{for(let d=u.a;d>=1;d--)this.c[d]=this.c[d-1];this.c[0]=Date.now()},1e3)}d(){const a=Date.now(),d=(1+u.a)*1e3;let k=0;for(let R=0;R<u.a;R++)a-this.c[R]<=d&&k++;return 1-k/u.a}hasHighLoad(){return this.d()>=.5}}class s{get unacknowledgedCount(){return this.c-this.d}constructor(a){this.u=new n,this.onControlMessage=this.u.event,this.v=new n,this.onMessage=this.v.event,this.w=new n,this.onDidDispose=this.w.event,this.x=new n,this.onSocketClose=this.x.event,this.y=new n,this.onSocketTimeout=this.y.event,this.s=a.loadEstimator??u.getInstance(),this.t=a.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new g.$Sc,this.o=a.socket,this.p=this.r.add(new o(this.o)),this.q=this.r.add(new f(this.o)),this.r.add(this.q.onMessage(d=>this.z(d))),this.r.add(this.o.onClose(d=>this.x.fire(d))),a.initialChunk&&this.q.acceptChunk(a.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const a=new h(5,0,0,L());this.p.write(a),this.p.flush()}sendPause(){const a=new h(7,0,0,L());this.p.write(a)}sendResume(){const a=new h(8,0,0,L());this.p.write(a)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(a,d){this.a=!0,this.r.dispose(),this.r=new g.$Sc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=a,this.p=this.r.add(new o(this.o)),this.q=this.r.add(new f(this.o)),this.r.add(this.q.onMessage(k=>this.z(k))),this.r.add(this.o.onClose(k=>this.x.fire(k))),this.q.acceptChunk(d)}endAcceptReconnection(){this.a=!1,this.h=this.g;const a=new h(3,0,this.h,L());this.p.write(a);const d=this.b.toArray();for(let k=0,R=d.length;k<R;k++)this.p.write(d[k]);this.B()}acceptDisconnect(){this.w.fire()}z(a){if(a.ack>this.d){this.d=a.ack;do{const d=this.b.peek();if(d&&d.id<=a.ack)this.b.pop();else break}while(!0)}switch(a.type){case 0:break;case 1:{if(a.id>this.g)if(a.id!==this.g+1){const d=Date.now();d-this.m>1e4&&(this.m=d,this.p.write(new h(6,0,0,L())))}else this.g=a.id,this.j=Date.now(),this.A(),this.v.fire(a.data);break}case 2:{this.u.fire(a.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const d=this.b.toArray();for(let k=0,R=d.length;k<R;k++)this.p.write(d[k]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(a){const d=++this.c;this.h=this.g;const k=new h(1,d,this.h,a);this.b.push(k),this.a||(this.p.write(k),this.B())}sendControl(a){const d=new h(2,0,0,a);this.p.write(d)}A(){if(this.g<=this.h||this.k)return;const a=Date.now()-this.j;if(a>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-a+5)}B(){if(this.c<=this.d||this.f||this.a)return;const a=this.b.peek(),d=Date.now()-a.writtenTime,k=Date.now()-this.q.lastReadTime,R=Date.now()-this.n;if(d>=2e4&&k>=2e4&&R>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:d,timeSinceLastReceivedSomeData:k});return}const v=Math.max(2e4-d,2e4-k,2e4-R,500);this.f=setTimeout(()=>{this.f=null,this.B()},v)}C(){if(this.g<=this.h)return;this.h=this.g;const a=new h(3,0,this.h,L());this.p.write(a)}D(){this.h=this.g;const a=new h(9,0,this.h,L());this.p.write(a)}}e.$Th=s}),define(ke[187],Se([1,0,50,11,22,21,185,14,4,3,24,104,101,81]),function(me,e,D,O,g,I,A,b,$,y,L,C,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rq=e.$qq=void 0;class S extends p.$Hh{constructor(o){super({send:i=>{try{process.send?.(i.buffer.toString("base64"))}catch{}},onMessage:$.Event.fromNodeEventEmitter(process,"message",i=>g.$je.wrap(Buffer.from(i,"base64")))},o),process.once("disconnect",()=>this.dispose())}}e.$qq=S;class h{constructor(o,i){this.i=o,this.j=i,this.c=new Set,this.g=new Map,this.h=new $.$Vd,this.onDidProcessExit=this.h.event;const r=i&&i.timeout?i.timeout:6e4;this.b=new O.$3g(r),this.d=null,this.f=null}getChannel(o){const i=this;return{call(r,n,c){return i.k(o,r,n,c)},listen(r,n){return i.l(o,r,n)}}}k(o,i,r,n=I.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(n.isCancellationRequested)return Promise.reject(b.$6());this.b.cancel();const c=this.n(o),t=(0,O.$Tg)(l=>c.call(i,r,l)),u=n.onCancellationRequested(()=>t.cancel()),s=(0,y.$Rc)(()=>t.cancel());return this.c.add(s),t.finally(()=>{u.dispose(),this.c.delete(s),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(o,i,r){if(!this.b)return $.Event.None;this.b.cancel();let n;const c=new $.$Vd({onWillAddFirstListener:()=>{n=this.n(o).listen(i,r)(c.fire,c),this.c.add(n)},onDidRemoveLastListener:()=>{this.c.delete(n),n.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return c.event}get m(){if(!this.f){const o=this.j&&this.j.args?this.j.args:[],i=Object.create(null);i.env={...(0,L.$vn)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(i.env={...i.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(i.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(i.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(i.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),i.execArgv===void 0&&(i.execArgv=process.execArgv.filter(a=>!/^--inspect(-brk)?=/.test(a)).filter(a=>!a.startsWith("--vscode-"))),(0,m.$Sl)(i.env),this.d=(0,D.fork)(this.i,o,i);const r=new $.$Vd;$.Event.fromNodeEventEmitter(this.d,"message",a=>a)(a=>{if((0,A.$mq)(a)){(0,A.log)(a,`IPC Library: ${this.j.serverName}`);return}r.fire(g.$je.wrap(Buffer.from(a,"base64")))});const c=this.j.useQueue?(0,C.$Ul)(this.d):this.d,t=a=>this.d&&this.d.connected&&c.send(a.buffer.toString("base64")),u=r.event,s={send:t,onMessage:u};this.f=new p.$Ih(s);const l=()=>this.o();process.once("exit",l),this.d.on("error",a=>console.warn('IPC "'+this.j.serverName+'" errored with '+a)),this.d.on("exit",(a,d)=>{process.removeListener("exit",l),this.c.forEach(k=>(0,y.$Oc)(k)),this.c.clear(),a!==0&&d!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+a+" and signal "+d),this.b?.cancel(),this.o(),this.h.fire({code:a,signal:d})})}return this.f}n(o){let i=this.g.get(o);return i||(i=this.m.getChannel(o),this.g.set(o,i)),i}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$rq=h}),define(ke[188],Se([1,0,11,4,3,55,18]),function(me,e,D,O,g,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rp=e.$qp=e.StorageState=e.$pp=e.StorageHint=void 0;var b;(function(m){m[m.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",m[m.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(b||(e.StorageHint=b={}));function $(m){const p=m;return p?.changed instanceof Map||p?.deleted instanceof Set}e.$pp=$;var y;(function(m){m[m.None=0]="None",m[m.Initialized=1]="Initialized",m[m.Closed=2]="Closed"})(y||(e.StorageState=y={}));class L extends g.$Tc{static{this.a=100}constructor(p,S=Object.create(null)){super(),this.r=p,this.s=S,this.b=this.B(new O.$Yd),this.onDidChangeStorage=this.b.event,this.c=y.None,this.f=new Map,this.g=this.B(new D.$4g(L.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(p=>this.u(p)))}u(p){this.b.pause();try{p.changed?.forEach((S,h)=>this.w(h,S)),p.deleted?.forEach(S=>this.w(S,void 0))}finally{this.b.resume()}}w(p,S){if(this.c===y.Closed)return;let h=!1;(0,A.$Rf)(S)?h=this.f.delete(p):this.f.get(p)!==S&&(this.f.set(p,S),h=!0),h&&this.b.fire({key:p,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===y.None&&(this.c=y.Initialized,this.s.hint!==b.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(p,S){const h=this.f.get(p);return(0,A.$Rf)(h)?S:h}getBoolean(p,S){const h=this.get(p);return(0,A.$Rf)(h)?S:h==="true"}getNumber(p,S){const h=this.get(p);return(0,A.$Rf)(h)?S:parseInt(h,10)}getObject(p,S){const h=this.get(p);return(0,A.$Rf)(h)?S:(0,I.$Bh)(h)}async set(p,S,h=!1){if(this.c===y.Closed)return;if((0,A.$Rf)(S))return this.delete(p,h);const f=(0,A.$Kf)(S)||Array.isArray(S)?(0,I.$Ah)(S):String(S);if(this.f.get(p)!==f)return this.f.set(p,f),this.j.set(p,f),this.h.delete(p),this.b.fire({key:p,external:h}),this.D()}async delete(p,S=!1){if(!(this.c===y.Closed||!this.f.delete(p)))return this.h.has(p)||this.h.add(p),this.j.delete(p),this.b.fire({key:p,external:S}),this.D()}async optimize(){if(this.c!==y.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=y.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const p={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(p).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(p){if(this.z)return this.D(p)}async D(p){return this.s.hint===b.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),p)}async whenFlushed(){if(this.z)return new Promise(p=>this.n.push(p))}isInMemory(){return this.s.hint===b.STORAGE_IN_MEMORY}}e.$qp=L;class C{constructor(){this.onDidChangeItemsExternal=O.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(p){p.insert?.forEach((S,h)=>this.a.set(h,S)),p.delete?.forEach(S=>this.a.delete(S))}async optimize(){}async close(){}}e.$rp=C}),define(ke[189],Se([1,0,12,10,22]),function(me,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ct=e.$bt=e.$at=void 0;let I;function A(){return I||(I=new TextDecoder("UTF-16LE")),I}let b;function $(){return b||(b=new TextDecoder("UTF-16BE")),b}let y;function L(){return y||(y=O.$D()?A():$()),y}e.$at=L;function C(S,h,f){const o=new Uint16Array(S.buffer,h,f);return f>0&&(o[0]===65279||o[0]===65534)?m(S,h,f):A().decode(o)}e.$bt=C;function m(S,h,f){const o=[];let i=0;for(let r=0;r<f;r++){const n=g.$le(S,h);h+=2,o[i++]=String.fromCharCode(n)}return o.join("")}class p{constructor(h){this.a=h|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const h=new Uint16Array(this.b.buffer,0,this.d);return L().decode(h)}f(){const h=this.e();this.d=0,this.c===null?this.c=[h]:this.c[this.c.length]=h}appendCharCode(h){const f=this.a-this.d;f<=1&&(f===0||D.$df(h))&&this.f(),this.b[this.d++]=h}appendASCIICharCode(h){this.d===this.a&&this.f(),this.b[this.d++]=h}appendString(h){const f=h.length;if(this.d+f>=this.a){this.f(),this.c[this.c.length]=h;return}for(let o=0;o<f;o++)this.b[this.d++]=h.charCodeAt(o)}}e.$ct=p}),define(ke[190],Se([1,0,22,189]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$et=e.$dt=void 0;function g($){return $.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class I{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(y,L,C,m){this.oldPosition=y,this.oldText=L,this.newPosition=C,this.newText=m}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${g(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${g(this.oldText)}")`:`(replace@${this.oldPosition} "${g(this.oldText)}" with "${g(this.newText)}")`}static a(y){return 4+2*y.length}static c(y,L,C){const m=L.length;D.$oe(y,m,C),C+=4;for(let p=0;p<m;p++)D.$me(y,L.charCodeAt(p),C),C+=2;return C}static d(y,L){const C=D.$ne(y,L);return L+=4,(0,O.$bt)(y,L,C)}writeSize(){return 4+4+I.a(this.oldText)+I.a(this.newText)}write(y,L){return D.$oe(y,this.oldPosition,L),L+=4,D.$oe(y,this.newPosition,L),L+=4,L=I.c(y,this.oldText,L),L=I.c(y,this.newText,L),L}static read(y,L,C){const m=D.$ne(y,L);L+=4;const p=D.$ne(y,L);L+=4;const S=I.d(y,L);L+=I.a(S);const h=I.d(y,L);return L+=I.a(h),C.push(new I(m,S,p,h)),L}}e.$dt=I;function A($,y){return $===null||$.length===0?y:new b($,y).compress()}e.$et=A;class b{constructor(y,L){this.a=y,this.c=L,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let y=0,L=0,C=this.n(y),m=this.l(L);for(;y<this.f||L<this.h;){if(C===null){this.k(m),m=this.l(++L);continue}if(m===null){this.m(C),C=this.n(++y);continue}if(m.oldEnd<=C.newPosition){this.k(m),m=this.l(++L);continue}if(C.newEnd<=m.oldPosition){this.m(C),C=this.n(++y);continue}if(m.oldPosition<C.newPosition){const[o,i]=b.r(m,C.newPosition-m.oldPosition);this.k(o),m=i;continue}if(C.newPosition<m.oldPosition){const[o,i]=b.q(C,m.oldPosition-C.newPosition);this.m(o),C=i;continue}let h,f;if(m.oldEnd===C.newEnd)h=C,f=m,C=this.n(++y),m=this.l(++L);else if(m.oldEnd<C.newEnd){const[o,i]=b.q(C,m.oldLength);h=o,f=m,C=i,m=this.l(++L)}else{const[o,i]=b.r(m,C.newLength);h=C,f=o,C=this.n(++y),m=i}this.d[this.e++]=new I(h.oldPosition,h.oldText,f.newPosition,f.newText),this.g+=h.newLength-h.oldLength,this.j+=f.newLength-f.oldLength}const p=b.s(this.d);return b.t(p)}k(y){this.d[this.e++]=b.o(this.g,y),this.j+=y.newLength-y.oldLength}l(y){return y<this.h?this.c[y]:null}m(y){this.d[this.e++]=b.p(this.j,y),this.g+=y.newLength-y.oldLength}n(y){return y<this.f?this.a[y]:null}static o(y,L){return new I(L.oldPosition-y,L.oldText,L.newPosition,L.newText)}static p(y,L){return new I(L.oldPosition,L.oldText,L.newPosition+y,L.newText)}static q(y,L){const C=y.newText.substr(0,L),m=y.newText.substr(L);return[new I(y.oldPosition,y.oldText,y.newPosition,C),new I(y.oldEnd,"",y.newPosition+L,m)]}static r(y,L){const C=y.oldText.substr(0,L),m=y.oldText.substr(L);return[new I(y.oldPosition,C,y.newPosition,y.newText),new I(y.oldPosition+L,m,y.newEnd,"")]}static s(y){if(y.length===0)return y;const L=[];let C=0,m=y[0];for(let p=1;p<y.length;p++){const S=y[p];m.oldEnd===S.oldPosition?m=new I(m.oldPosition,m.oldText+S.oldText,m.newPosition,m.newText+S.newText):(L[C++]=m,m=S)}return L[C++]=m,L}static t(y){if(y.length===0)return y;const L=[];let C=0;for(let m=0;m<y.length;m++){const p=y[m];p.oldText!==p.newText&&(L[C++]=p)}return L}}}),define(ke[191],Se([1,0,34,16]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bt=void 0;function g(I,A,b,$,y,L){if(Array.isArray(I)){let C=0;for(const m of I){const p=g(m,A,b,$,y,L);if(p===10)return p;p>C&&(C=p)}return C}else{if(typeof I=="string")return $?I==="*"?5:I===b?10:0:0;if(I){const{language:C,pattern:m,scheme:p,hasAccessToAllModels:S,notebookType:h}=I;if(!$&&!S)return 0;h&&y&&(A=y);let f=0;if(p)if(p===A.scheme)f=10;else if(p==="*")f=5;else return 0;if(C)if(C===b)f=10;else if(C==="*")f=Math.max(f,5);else return 0;if(h)if(h===L)f=10;else if(h==="*"&&L!==void 0)f=Math.max(f,5);else return 0;if(m){let o;if(typeof m=="string"?o=m:o={...m,base:(0,O.$hc)(m.base)},o===A.fsPath||(0,D.$Lj)(o,A.fsPath))f=10;else return 0}return f}else return 0}}e.$Bt=g}),define(ke[192],Se([1,0,4,12,29,79,127,167,190,3]),function(me,e,D,O,g,I,A,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bC=void 0;class L extends y.$Tc{constructor(m,p,S,h,f,o,i){super(),this.m=this.B(new D.$Vd),this.onDidChangeContent=this.m.event,this.f=p,this.j=!o,this.g=h,this.h=f,this.c=new A.$aC(m,S,i)}equals(m){return!(m instanceof L)||this.f!==m.f||this.getEOL()!==m.getEOL()?!1:this.c.equal(m.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(m){return this.c.createSnapshot(m?this.f:"")}getOffsetAt(m,p){return this.c.getOffsetAt(m,p)}getPositionAt(m){return this.c.getPositionAt(m)}getRangeAt(m,p){const S=m+p,h=this.getPositionAt(m),f=this.getPositionAt(S);return new g.$Us(h.lineNumber,h.column,f.lineNumber,f.column)}getValueInRange(m,p=0){if(m.isEmpty())return"";const S=this.n(p);return this.c.getValueInRange(m,S)}getValueLengthInRange(m,p=0){if(m.isEmpty())return 0;if(m.startLineNumber===m.endLineNumber)return m.endColumn-m.startColumn;const S=this.getOffsetAt(m.startLineNumber,m.startColumn),h=this.getOffsetAt(m.endLineNumber,m.endColumn);let f=0;const o=this.n(p),i=this.getEOL();if(o.length!==i.length){const r=o.length-i.length,n=m.endLineNumber-m.startLineNumber;f=r*n}return h-S+f}getCharacterCountInRange(m,p=0){if(this.j){let S=0;const h=m.startLineNumber,f=m.endLineNumber;for(let o=h;o<=f;o++){const i=this.getLineContent(o),r=o===h?m.startColumn-1:0,n=o===f?m.endColumn-1:i.length;for(let c=r;c<n;c++)O.$df(i.charCodeAt(c))?(S=S+1,c=c+1):S=S+1}return S+=this.n(p).length*(f-h),S}return this.getValueLengthInRange(m,p)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(m){return this.c.getLineContent(m)}getLineCharCode(m,p){return this.c.getLineCharCode(m,p)}getCharCode(m){return this.c.getCharCode(m)}getLineLength(m){return this.c.getLineLength(m)}getLineMinColumn(m){return 1}getLineMaxColumn(m){return this.getLineLength(m)+1}getLineFirstNonWhitespaceColumn(m){const p=O.$1e(this.getLineContent(m));return p===-1?0:p+1}getLineLastNonWhitespaceColumn(m){const p=O.$3e(this.getLineContent(m));return p===-1?0:p+2}n(m){switch(m){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(m){this.c.setEOL(m)}applyEdits(m,p,S){let h=this.g,f=this.h,o=this.j,i=!0,r=[];for(let a=0;a<m.length;a++){const d=m[a];i&&d._isTracked&&(i=!1);const k=d.range;if(d.text){let P=!0;o||(P=!O.$of(d.text),o=P),!h&&P&&(h=O.$nf(d.text)),!f&&P&&(f=O.$qf(d.text))}let R="",v=0,w=0,E=0;if(d.text){let P;[v,w,E,P]=(0,b.$ut)(d.text);const N=this.getEOL();P===0||P===(N===`\r
`?2:1)?R=d.text:R=d.text.replace(/\r\n|\r|\n/g,N)}r[a]={sortIndex:a,identifier:d.identifier||null,range:k,rangeOffset:this.getOffsetAt(k.startLineNumber,k.startColumn),rangeLength:this.getValueLengthInRange(k),text:R,eolCount:v,firstLineLength:w,lastLineLength:E,forceMoveMarkers:!!d.forceMoveMarkers,isAutoWhitespaceEdit:d.isAutoWhitespaceEdit||!1}}r.sort(L.u);let n=!1;for(let a=0,d=r.length-1;a<d;a++){const k=r[a].range.getEndPosition(),R=r[a+1].range.getStartPosition();if(R.isBeforeOrEqual(k)){if(R.isBefore(k))throw new Error("Overlapping ranges are not allowed!");n=!0}}i&&(r=this.s(r));const c=S||p?L._getInverseEditRanges(r):[],t=[];if(p)for(let a=0;a<r.length;a++){const d=r[a],k=c[a];if(d.isAutoWhitespaceEdit&&d.range.isEmpty())for(let R=k.startLineNumber;R<=k.endLineNumber;R++){let v="";R===k.startLineNumber&&(v=this.getLineContent(d.range.startLineNumber),O.$1e(v)!==-1)||t.push({lineNumber:R,oldContent:v})}}let u=null;if(S){let a=0;u=[];for(let d=0;d<r.length;d++){const k=r[d],R=c[d],v=this.getValueInRange(k.range),w=k.rangeOffset+a;a+=k.text.length-v.length,u[d]={sortIndex:k.sortIndex,identifier:k.identifier,range:R,text:v,textChange:new $.$dt(k.rangeOffset,v,w,k.text)}}n||u.sort((d,k)=>d.sortIndex-k.sortIndex)}this.g=h,this.h=f,this.j=o;const s=this.t(r);let l=null;if(p&&t.length>0){t.sort((a,d)=>d.lineNumber-a.lineNumber),l=[];for(let a=0,d=t.length;a<d;a++){const k=t[a].lineNumber;if(a>0&&t[a-1].lineNumber===k)continue;const R=t[a].oldContent,v=this.getLineContent(k);v.length===0||v===R||O.$1e(v)!==-1||l.push(k)}}return this.m.fire(),new I.$ev(u,s,l)}s(m){return m.length<1e3?m:[this._toSingleEditOperation(m)]}_toSingleEditOperation(m){let p=!1;const S=m[0].range,h=m[m.length-1].range,f=new g.$Us(S.startLineNumber,S.startColumn,h.endLineNumber,h.endColumn);let o=S.startLineNumber,i=S.startColumn;const r=[];for(let s=0,l=m.length;s<l;s++){const a=m[s],d=a.range;p=p||a.forceMoveMarkers,r.push(this.getValueInRange(new g.$Us(o,i,d.startLineNumber,d.startColumn))),a.text.length>0&&r.push(a.text),o=d.endLineNumber,i=d.endColumn}const n=r.join(""),[c,t,u]=(0,b.$ut)(n);return{sortIndex:0,identifier:m[0].identifier,range:f,rangeOffset:this.getOffsetAt(f.startLineNumber,f.startColumn),rangeLength:this.getValueLengthInRange(f,0),text:n,eolCount:c,firstLineLength:t,lastLineLength:u,forceMoveMarkers:p,isAutoWhitespaceEdit:!1}}t(m){m.sort(L.w);const p=[];for(let S=0;S<m.length;S++){const h=m[S],f=h.range.startLineNumber,o=h.range.startColumn,i=h.range.endLineNumber,r=h.range.endColumn;if(f===i&&o===r&&h.text.length===0)continue;h.text?(this.c.delete(h.rangeOffset,h.rangeLength),this.c.insert(h.rangeOffset,h.text,!0)):this.c.delete(h.rangeOffset,h.rangeLength);const n=new g.$Us(f,o,i,r);p.push({range:n,rangeLength:h.rangeLength,text:h.text,rangeOffset:h.rangeOffset,forceMoveMarkers:h.forceMoveMarkers})}return p}findMatchesLineByLine(m,p,S,h){return this.c.findMatchesLineByLine(m,p,S,h)}getPieceTree(){return this.c}static _getInverseEditRange(m,p){const S=m.startLineNumber,h=m.startColumn,[f,o,i]=(0,b.$ut)(p);let r;if(p.length>0){const n=f+1;n===1?r=new g.$Us(S,h,S,h+o):r=new g.$Us(S,h,S+n-1,i+1)}else r=new g.$Us(S,h,S,h);return r}static _getInverseEditRanges(m){const p=[];let S=0,h=0,f=null;for(let o=0,i=m.length;o<i;o++){const r=m[o];let n,c;f?f.range.endLineNumber===r.range.startLineNumber?(n=S,c=h+(r.range.startColumn-f.range.endColumn)):(n=S+(r.range.startLineNumber-f.range.endLineNumber),c=r.range.startColumn):(n=r.range.startLineNumber,c=r.range.startColumn);let t;if(r.text.length>0){const u=r.eolCount+1;u===1?t=new g.$Us(n,c,n,c+r.firstLineLength):t=new g.$Us(n,c,n+u-1,r.lastLineLength+1)}else t=new g.$Us(n,c,n,c);S=t.endLineNumber,h=t.endColumn,p.push(t),f=r}return p}static u(m,p){const S=g.$Us.compareRangesUsingEnds(m.range,p.range);return S===0?m.sortIndex-p.sortIndex:S}static w(m,p){const S=g.$Us.compareRangesUsingEnds(m.range,p.range);return S===0?p.sortIndex-m.sortIndex:-S}}e.$bC=L}),define(ke[193],Se([1,0,12,127,192]),function(me,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cC=void 0;class I{constructor($,y,L,C,m,p,S,h,f){this.a=$,this.b=y,this.c=L,this.d=C,this.e=m,this.f=p,this.g=S,this.h=h,this.j=f}k($){const y=this.c+this.d+this.e,L=this.c+this.e;return y===0?$===1?`
`:`\r
`:L>y/2?`\r
`:`
`}create($){const y=this.k($),L=this.a;if(this.j&&(y===`\r
`&&(this.c>0||this.d>0)||y===`
`&&(this.c>0||this.e>0)))for(let m=0,p=L.length;m<p;m++){const S=L[m].buffer.replace(/\r\n|\r|\n/g,y),h=(0,O.$9B)(S);L[m]=new O.$_B(S,h)}const C=new g.$bC(L,this.b,y,this.f,this.g,this.h,this.j);return{textBuffer:C,disposable:C}}getFirstLineText($){return this.a[0].buffer.substr(0,$).split(/\r\n|\r|\n/)[0]}}class A{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk($){if($.length===0)return;this.a.length===0&&D.$wf($)&&(this.b=D.$vf,$=$.substr(1));const y=$.charCodeAt($.length-1);y===13||y>=55296&&y<=56319?(this.m($.substr(0,$.length-1),!1),this.c=!0,this.d=y):(this.m($,!1),this.c=!1,this.d=y)}m($,y){!y&&$.length===0||(this.c?this.n(String.fromCharCode(this.d)+$):this.n($))}n($){const y=(0,O.$0B)(this.e,$);this.a.push(new O.$_B($,y.lineStarts)),this.f+=y.cr,this.g+=y.lf,this.h+=y.crlf,y.isBasicASCII||(this.l=!1,this.j||(this.j=D.$nf($)),this.k||(this.k=D.$qf($)))}finish($=!0){return this.o(),new I(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,$)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const $=this.a[this.a.length-1];$.buffer+=String.fromCharCode(this.d);const y=(0,O.$9B)($.buffer);$.lineStarts=y,this.d===13&&this.f++}}}e.$cC=A}),define(ke[131],Se([1,0,22,10]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$t$=e.$s$=void 0;var g;(function(C){C[C.Full=1]="Full",C[C.Delta=2]="Delta"})(g||(g={}));function I(C){for(let m=0,p=C.length;m<p;m+=4){const S=C[m+0],h=C[m+1],f=C[m+2],o=C[m+3];C[m+0]=o,C[m+1]=f,C[m+2]=h,C[m+3]=S}}function A(C){const m=new Uint8Array(C.buffer,C.byteOffset,C.length*4);return O.$D()||I(m),D.$je.wrap(m)}function b(C){const m=C.buffer;if(O.$D()||I(m),m.byteOffset%4===0)return new Uint32Array(m.buffer,m.byteOffset,m.length/4);{const p=new Uint8Array(m.byteLength);return p.set(m),new Uint32Array(p.buffer,p.byteOffset,p.length/4)}}function $(C){const m=new Uint32Array(y(C));let p=0;if(m[p++]=C.id,C.type==="full")m[p++]=1,m[p++]=C.data.length,m.set(C.data,p),p+=C.data.length;else{m[p++]=2,m[p++]=C.deltas.length;for(const S of C.deltas)m[p++]=S.start,m[p++]=S.deleteCount,S.data?(m[p++]=S.data.length,m.set(S.data,p),p+=S.data.length):m[p++]=0}return A(m)}e.$s$=$;function y(C){let m=0;if(m+=1+1,C.type==="full")m+=1+C.data.length;else{m+=1,m+=(1+1+1)*C.deltas.length;for(const p of C.deltas)p.data&&(m+=p.data.length)}return m}function L(C){const m=b(C);let p=0;const S=m[p++];if(m[p++]===1){const i=m[p++],r=m.subarray(p,p+i);return p+=i,{id:S,type:"full",data:r}}const f=m[p++],o=[];for(let i=0;i<f;i++){const r=m[p++],n=m[p++],c=m[p++];let t;c>0&&(t=m.subarray(p,p+c),p+=c),o[i]={start:r,deleteCount:n,data:t}}return{id:S,type:"delta",deltas:o}}e.$t$=L}),define(ke[194],Se([8,9]),function(me,e){return me.create("vs/editor/common/config/editorOptions",e)}),define(ke[132],Se([1,0,19,24,10,170,126,194]),function(me,e,D,O,g,I,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var $;(function(ne){ne[ne.None=0]="None",ne[ne.Keep=1]="Keep",ne[ne.Brackets=2]="Brackets",ne[ne.Advanced=3]="Advanced",ne[ne.Full=4]="Full"})($||(e.EditorAutoIndentStrategy=$={})),e.MINIMAP_GUTTER_WIDTH=8;class y{constructor(ce){this.c=ce}hasChanged(ce){return this.c[ce]}}e.ConfigurationChangedEvent=y;class L{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=L;class C{constructor(ce,Ie,qe,Ye){this.id=ce,this.name=Ie,this.defaultValue=qe,this.schema=Ye}applyUpdate(ce,Ie){return p(ce,Ie)}compute(ce,Ie,qe){return qe}}class m{constructor(ce,Ie){this.newValue=ce,this.didChange=Ie}}e.ApplyUpdateResult=m;function p(ne,ce){if(typeof ne!="object"||typeof ce!="object"||!ne||!ce)return new m(ce,ne!==ce);if(Array.isArray(ne)||Array.isArray(ce)){const qe=Array.isArray(ne)&&Array.isArray(ce)&&D.$ub(ne,ce);return new m(ce,!qe)}let Ie=!1;for(const qe in ce)if(ce.hasOwnProperty(qe)){const Ye=p(ne[qe],ce[qe]);Ye.didChange&&(ne[qe]=Ye.newValue,Ie=!0)}return new m(ne,Ie)}class S{constructor(ce){this.schema=void 0,this.id=ce,this.name="_never_",this.defaultValue=void 0}applyUpdate(ce,Ie){return p(ce,Ie)}validate(ce){return this.defaultValue}}class h{constructor(ce,Ie,qe,Ye){this.id=ce,this.name=Ie,this.defaultValue=qe,this.schema=Ye}applyUpdate(ce,Ie){return p(ce,Ie)}validate(ce){return typeof ce>"u"?this.defaultValue:ce}compute(ce,Ie,qe){return qe}}function f(ne,ce){return typeof ne>"u"?ce:ne==="false"?!1:!!ne}e.boolean=f;class o extends h{constructor(ce,Ie,qe,Ye=void 0){typeof Ye<"u"&&(Ye.type="boolean",Ye.default=qe),super(ce,Ie,qe,Ye)}validate(ce){return f(ce,this.defaultValue)}}function i(ne,ce,Ie,qe){if(typeof ne>"u")return ce;let Ye=parseInt(ne,10);return isNaN(Ye)?ce:(Ye=Math.max(Ie,Ye),Ye=Math.min(qe,Ye),Ye|0)}e.clampedInt=i;class r extends h{static clampedInt(ce,Ie,qe,Ye){return i(ce,Ie,qe,Ye)}constructor(ce,Ie,qe,Ye,nt,it=void 0){typeof it<"u"&&(it.type="integer",it.default=qe,it.minimum=Ye,it.maximum=nt),super(ce,Ie,qe,it),this.minimum=Ye,this.maximum=nt}validate(ce){return r.clampedInt(ce,this.defaultValue,this.minimum,this.maximum)}}function n(ne,ce,Ie,qe){if(typeof ne>"u")return ce;const Ye=c.float(ne,ce);return c.clamp(Ye,Ie,qe)}e.clampedFloat=n;class c extends h{static clamp(ce,Ie,qe){return ce<Ie?Ie:ce>qe?qe:ce}static float(ce,Ie){if(typeof ce=="number")return ce;if(typeof ce>"u")return Ie;const qe=parseFloat(ce);return isNaN(qe)?Ie:qe}constructor(ce,Ie,qe,Ye,nt){typeof nt<"u"&&(nt.type="number",nt.default=qe),super(ce,Ie,qe,nt),this.validationFn=Ye}validate(ce){return this.validationFn(c.float(ce,this.defaultValue))}}class t extends h{static string(ce,Ie){return typeof ce!="string"?Ie:ce}constructor(ce,Ie,qe,Ye=void 0){typeof Ye<"u"&&(Ye.type="string",Ye.default=qe),super(ce,Ie,qe,Ye)}validate(ce){return t.string(ce,this.defaultValue)}}function u(ne,ce,Ie,qe){return typeof ne!="string"?ce:qe&&ne in qe?qe[ne]:Ie.indexOf(ne)===-1?ce:ne}e.stringSet=u;class s extends h{constructor(ce,Ie,qe,Ye,nt=void 0){typeof nt<"u"&&(nt.type="string",nt.enum=Ye,nt.default=qe),super(ce,Ie,qe,nt),this.c=Ye}validate(ce){return u(ce,this.defaultValue,this.c)}}class l extends C{constructor(ce,Ie,qe,Ye,nt,it,Oe=void 0){typeof Oe<"u"&&(Oe.type="string",Oe.enum=nt,Oe.default=Ye),super(ce,Ie,qe,Oe),this.c=nt,this.d=it}validate(ce){return typeof ce!="string"?this.defaultValue:this.c.indexOf(ce)===-1?this.defaultValue:this.d(ce)}}function a(ne){switch(ne){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class d extends C{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[b.localize(0,null),b.localize(1,null),b.localize(2,null)],default:"auto",tags:["accessibility"],description:b.localize(3,null)})}validate(ce){switch(ce){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ce,Ie,qe){return qe===0?ce.accessibilitySupport:qe}}class k extends C{constructor(){const ce={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",ce,{"editor.comments.insertSpace":{type:"boolean",default:ce.insertSpace,description:b.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ce.ignoreEmptyLines,description:b.localize(5,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{insertSpace:f(Ie.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:f(Ie.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var R;(function(ne){ne[ne.Hidden=0]="Hidden",ne[ne.Blink=1]="Blink",ne[ne.Smooth=2]="Smooth",ne[ne.Phase=3]="Phase",ne[ne.Expand=4]="Expand",ne[ne.Solid=5]="Solid"})(R||(e.TextEditorCursorBlinkingStyle=R={}));function v(ne){switch(ne){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var w;(function(ne){ne[ne.Line=1]="Line",ne[ne.Block=2]="Block",ne[ne.Underline=3]="Underline",ne[ne.LineThin=4]="LineThin",ne[ne.BlockOutline=5]="BlockOutline",ne[ne.UnderlineThin=6]="UnderlineThin"})(w||(e.TextEditorCursorStyle=w={}));function E(ne){switch(ne){case w.Line:return"line";case w.Block:return"block";case w.Underline:return"underline";case w.LineThin:return"line-thin";case w.BlockOutline:return"block-outline";case w.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=E;function P(ne){switch(ne){case"line":return w.Line;case"block":return w.Block;case"underline":return w.Underline;case"line-thin":return w.LineThin;case"block-outline":return w.BlockOutline;case"underline-thin":return w.UnderlineThin}}class N extends S{constructor(){super(140)}compute(ce,Ie,qe){const Ye=["monaco-editor"];return Ie.get(39)&&Ye.push(Ie.get(39)),ce.extraEditorClassName&&Ye.push(ce.extraEditorClassName),Ie.get(73)==="default"?Ye.push("mouse-default"):Ie.get(73)==="copy"&&Ye.push("mouse-copy"),Ie.get(110)&&Ye.push("showUnused"),Ie.get(138)&&Ye.push("showDeprecated"),Ye.join(" ")}}class U extends o{constructor(){super(37,"emptySelectionClipboard",!0,{description:b.localize(6,null)})}compute(ce,Ie,qe){return qe&&ce.emptySelectionClipboard}}class F extends C{constructor(){const ce={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",ce,{"editor.find.cursorMoveOnType":{type:"boolean",default:ce.cursorMoveOnType,description:b.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:ce.seedSearchStringFromSelection,enumDescriptions:[b.localize(8,null),b.localize(9,null),b.localize(10,null)],description:b.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ce.autoFindInSelection,enumDescriptions:[b.localize(12,null),b.localize(13,null),b.localize(14,null)],description:b.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ce.globalFindClipboard,description:b.localize(16,null),included:g.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ce.addExtraSpaceOnTop,description:b.localize(17,null)},"editor.find.loop":{type:"boolean",default:ce.loop,description:b.localize(18,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{cursorMoveOnType:f(Ie.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof ce.seedSearchStringFromSelection=="boolean"?ce.seedSearchStringFromSelection?"always":"never":u(Ie.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof ce.autoFindInSelection=="boolean"?ce.autoFindInSelection?"always":"never":u(Ie.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:f(Ie.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:f(Ie.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:f(Ie.loop,this.defaultValue.loop)}}}class j extends C{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",j.OFF,{anyOf:[{type:"boolean",description:b.localize(19,null)},{type:"string",description:b.localize(20,null)}],description:b.localize(21,null),default:!1})}validate(ce){return typeof ce>"u"?this.defaultValue:typeof ce=="string"?ce==="false"||ce.length===0?j.OFF:ce==="true"?j.ON:ce:ce?j.ON:j.OFF}}e.EditorFontLigatures=j;class T extends C{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",T.OFF,{anyOf:[{type:"boolean",description:b.localize(22,null)},{type:"string",description:b.localize(23,null)}],description:b.localize(24,null),default:!1})}validate(ce){return typeof ce>"u"?this.defaultValue:typeof ce=="string"?ce==="false"?T.OFF:ce==="true"?T.TRANSLATE:ce:ce?T.TRANSLATE:T.OFF}compute(ce,Ie,qe){return ce.fontInfo.fontVariationSettings}}e.EditorFontVariations=T;class M extends S{constructor(){super(50)}compute(ce,Ie,qe){return ce.fontInfo}}class B extends h{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:b.localize(25,null)})}validate(ce){const Ie=c.float(ce,this.defaultValue);return Ie===0?e.EDITOR_FONT_DEFAULTS.fontSize:c.clamp(Ie,6,100)}compute(ce,Ie,qe){return ce.fontInfo.fontSize}}class Y extends C{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:Y.d,maximum:Y.e,errorMessage:b.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:Y.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:b.localize(27,null)})}validate(ce){return ce==="normal"||ce==="bold"?ce:String(r.clampedInt(ce,e.EDITOR_FONT_DEFAULTS.fontWeight,Y.d,Y.e))}}class ue extends C{constructor(){const ce={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ie={type:"string",enum:["peek","gotoAndPeek","goto"],default:ce.multiple,enumDescriptions:[b.localize(28,null),b.localize(29,null),b.localize(30,null)]},qe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",ce,{"editor.gotoLocation.multiple":{deprecationMessage:b.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:b.localize(32,null),...Ie},"editor.gotoLocation.multipleTypeDefinitions":{description:b.localize(33,null),...Ie},"editor.gotoLocation.multipleDeclarations":{description:b.localize(34,null),...Ie},"editor.gotoLocation.multipleImplementations":{description:b.localize(35,null),...Ie},"editor.gotoLocation.multipleReferences":{description:b.localize(36,null),...Ie},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ce.alternativeDefinitionCommand,enum:qe,description:b.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ce.alternativeTypeDefinitionCommand,enum:qe,description:b.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ce.alternativeDeclarationCommand,enum:qe,description:b.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ce.alternativeImplementationCommand,enum:qe,description:b.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ce.alternativeReferenceCommand,enum:qe,description:b.localize(41,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{multiple:u(Ie.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ie.multipleDefinitions??u(Ie.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ie.multipleTypeDefinitions??u(Ie.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ie.multipleDeclarations??u(Ie.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ie.multipleImplementations??u(Ie.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ie.multipleReferences??u(Ie.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(Ie.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(Ie.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(Ie.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(Ie.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(Ie.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class Z extends C{constructor(){const ce={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",ce,{"editor.hover.enabled":{type:"boolean",default:ce.enabled,description:b.localize(42,null)},"editor.hover.delay":{type:"number",default:ce.delay,minimum:0,maximum:1e4,description:b.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:ce.sticky,description:b.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:ce.hidingDelay,description:b.localize(45,null)},"editor.hover.above":{type:"boolean",default:ce.above,description:b.localize(46,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{enabled:f(Ie.enabled,this.defaultValue.enabled),delay:r.clampedInt(Ie.delay,this.defaultValue.delay,0,1e4),sticky:f(Ie.sticky,this.defaultValue.sticky),hidingDelay:r.clampedInt(Ie.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:f(Ie.above,this.defaultValue.above)}}}var J;(function(ne){ne[ne.None=0]="None",ne[ne.Text=1]="Text",ne[ne.Blocks=2]="Blocks"})(J||(e.RenderMinimap=J={}));class X extends S{constructor(){super(143)}compute(ce,Ie,qe){return X.computeLayout(Ie,{memory:ce.memory,outerWidth:ce.outerWidth,outerHeight:ce.outerHeight,isDominatedByLongLines:ce.isDominatedByLongLines,lineHeight:ce.fontInfo.lineHeight,viewLineCount:ce.viewLineCount,lineNumbersDigitCount:ce.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ce.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ce.fontInfo.maxDigitWidth,pixelRatio:ce.pixelRatio,glyphMarginDecorationLaneCount:ce.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(ce){const Ie=ce.height/ce.lineHeight,qe=Math.floor(ce.paddingTop/ce.lineHeight);let Ye=Math.floor(ce.paddingBottom/ce.lineHeight);ce.scrollBeyondLastLine&&(Ye=Math.max(Ye,Ie-1));const nt=(qe+ce.viewLineCount+Ye)/(ce.pixelRatio*ce.height),it=Math.floor(ce.viewLineCount/nt);return{typicalViewportLineCount:Ie,extraLinesBeforeFirstLine:qe,extraLinesBeyondLastLine:Ye,desiredRatio:nt,minimapLineCount:it}}static c(ce,Ie){const qe=ce.outerWidth,Ye=ce.outerHeight,nt=ce.pixelRatio;if(!ce.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(nt*Ye),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ye};const it=Ie.stableMinimapLayoutInput,Oe=it&&ce.outerHeight===it.outerHeight&&ce.lineHeight===it.lineHeight&&ce.typicalHalfwidthCharacterWidth===it.typicalHalfwidthCharacterWidth&&ce.pixelRatio===it.pixelRatio&&ce.scrollBeyondLastLine===it.scrollBeyondLastLine&&ce.paddingTop===it.paddingTop&&ce.paddingBottom===it.paddingBottom&&ce.minimap.enabled===it.minimap.enabled&&ce.minimap.side===it.minimap.side&&ce.minimap.size===it.minimap.size&&ce.minimap.showSlider===it.minimap.showSlider&&ce.minimap.renderCharacters===it.minimap.renderCharacters&&ce.minimap.maxColumn===it.minimap.maxColumn&&ce.minimap.scale===it.minimap.scale&&ce.verticalScrollbarWidth===it.verticalScrollbarWidth&&ce.isViewportWrapping===it.isViewportWrapping,vt=ce.lineHeight,St=ce.typicalHalfwidthCharacterWidth,Nt=ce.scrollBeyondLastLine,Wt=ce.minimap.renderCharacters;let Et=nt>=2?Math.round(ce.minimap.scale*2):ce.minimap.scale;const Kt=ce.minimap.maxColumn,Ot=ce.minimap.size,Yt=ce.minimap.side,Ut=ce.verticalScrollbarWidth,At=ce.viewLineCount,et=ce.remainingWidth,Gt=ce.isViewportWrapping,Jt=Wt?2:3;let ht=Math.floor(nt*Ye);const bt=ht/nt;let zt=!1,Vt=!1,Dt=Jt*Et,ft=Et/nt,Rt=1;if(Ot==="fill"||Ot==="fit"){const{typicalViewportLineCount:gt,extraLinesBeforeFirstLine:Ft,extraLinesBeyondLastLine:Te,desiredRatio:Ne,minimapLineCount:Ce}=X.computeContainedMinimapLineCount({viewLineCount:At,scrollBeyondLastLine:Nt,paddingTop:ce.paddingTop,paddingBottom:ce.paddingBottom,height:Ye,lineHeight:vt,pixelRatio:nt});if(At/Ce>1)zt=!0,Vt=!0,Et=1,Dt=1,ft=Et/nt;else{let Fe=!1,Ve=Et+1;if(Ot==="fit"){const xe=Math.ceil((Ft+At+Te)*Dt);Gt&&Oe&&et<=Ie.stableFitRemainingWidth?(Fe=!0,Ve=Ie.stableFitMaxMinimapScale):Fe=xe>ht}if(Ot==="fill"||Fe){zt=!0;const xe=Et;Dt=Math.min(vt*nt,Math.max(1,Math.floor(1/Ne))),Gt&&Oe&&et<=Ie.stableFitRemainingWidth&&(Ve=Ie.stableFitMaxMinimapScale),Et=Math.min(Ve,Math.max(1,Math.floor(Dt/Jt))),Et>xe&&(Rt=Math.min(2,Et/xe)),ft=Et/nt/Rt,ht=Math.ceil(Math.max(gt,Ft+At+Te)*Dt),Gt?(Ie.stableMinimapLayoutInput=ce,Ie.stableFitRemainingWidth=et,Ie.stableFitMaxMinimapScale=Et):(Ie.stableMinimapLayoutInput=null,Ie.stableFitRemainingWidth=0)}}}const xt=Math.floor(Kt*ft),Ct=Math.min(xt,Math.max(0,Math.floor((et-Ut-2)*ft/(St+ft)))+e.MINIMAP_GUTTER_WIDTH);let Qe=Math.floor(nt*Ct);const Tt=Qe/nt;Qe=Math.floor(Qe*Rt);const qt=Wt?1:2,Qt=Yt==="left"?0:qe-Ct-Ut;return{renderMinimap:qt,minimapLeft:Qt,minimapWidth:Ct,minimapHeightIsEditorHeight:zt,minimapIsSampling:Vt,minimapScale:Et,minimapLineHeight:Dt,minimapCanvasInnerWidth:Qe,minimapCanvasInnerHeight:ht,minimapCanvasOuterWidth:Tt,minimapCanvasOuterHeight:bt}}static computeLayout(ce,Ie){const qe=Ie.outerWidth|0,Ye=Ie.outerHeight|0,nt=Ie.lineHeight|0,it=Ie.lineNumbersDigitCount|0,Oe=Ie.typicalHalfwidthCharacterWidth,vt=Ie.maxDigitWidth,St=Ie.pixelRatio,Nt=Ie.viewLineCount,Wt=ce.get(135),Et=Wt==="inherit"?ce.get(134):Wt,Kt=Et==="inherit"?ce.get(130):Et,Ot=ce.get(133),Yt=Ie.isDominatedByLongLines,Ut=ce.get(57),At=ce.get(67).renderType!==0,et=ce.get(68),Gt=ce.get(104),Jt=ce.get(83),ht=ce.get(72),bt=ce.get(102),zt=bt.verticalScrollbarSize,Vt=bt.verticalHasArrows,Dt=bt.arrowSize,ft=bt.horizontalScrollbarSize,Rt=ce.get(43),xt=ce.get(109)!=="never";let Ct=ce.get(65);Rt&&xt&&(Ct+=16);let Qe=0;if(At){const st=Math.max(it,et);Qe=Math.round(st*vt)}let Tt=0;Ut&&(Tt=nt*Ie.glyphMarginDecorationLaneCount);let qt=0,Qt=qt+Tt,gt=Qt+Qe,Ft=gt+Ct;const Te=qe-Tt-Qe-Ct;let Ne=!1,Ce=!1,se=-1;Et==="inherit"&&Yt?(Ne=!0,Ce=!0):Kt==="on"||Kt==="bounded"?Ce=!0:Kt==="wordWrapColumn"&&(se=Ot);const Fe=X.c({outerWidth:qe,outerHeight:Ye,lineHeight:nt,typicalHalfwidthCharacterWidth:Oe,pixelRatio:St,scrollBeyondLastLine:Gt,paddingTop:Jt.top,paddingBottom:Jt.bottom,minimap:ht,verticalScrollbarWidth:zt,viewLineCount:Nt,remainingWidth:Te,isViewportWrapping:Ce},Ie.memory||new L);Fe.renderMinimap!==0&&Fe.minimapLeft===0&&(qt+=Fe.minimapWidth,Qt+=Fe.minimapWidth,gt+=Fe.minimapWidth,Ft+=Fe.minimapWidth);const Ve=Te-Fe.minimapWidth,xe=Math.max(1,Math.floor((Ve-zt-2)/Oe)),Ke=Vt?Dt:0;return Ce&&(se=Math.max(1,xe),Kt==="bounded"&&(se=Math.min(se,Ot))),{width:qe,height:Ye,glyphMarginLeft:qt,glyphMarginWidth:Tt,glyphMarginDecorationLaneCount:Ie.glyphMarginDecorationLaneCount,lineNumbersLeft:Qt,lineNumbersWidth:Qe,decorationsLeft:gt,decorationsWidth:Ct,contentLeft:Ft,contentWidth:Ve,minimap:Fe,viewportColumn:xe,isWordWrapMinified:Ne,isViewportWrapping:Ce,wrappingColumn:se,verticalScrollbarWidth:zt,horizontalScrollbarHeight:ft,overviewRuler:{top:Ke,width:zt,height:Ye-2*Ke,right:0}}}}e.EditorLayoutInfoComputer=X;class he extends C{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[b.localize(47,null),b.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:b.localize(49,null)}})}validate(ce){return u(ce,"simple",["simple","advanced"])}compute(ce,Ie,qe){return Ie.get(2)===2?"advanced":qe}}var _;(function(ne){ne.Off="off",ne.OnCode="onCode",ne.On="on"})(_||(e.ShowLightbulbIconMode=_={}));class we extends C{constructor(){const ce={enabled:_.On};super(64,"lightbulb",ce,{"editor.lightbulb.enabled":{type:"string",enum:[_.Off,_.OnCode,_.On],default:ce.enabled,enumDescriptions:[b.localize(50,null),b.localize(51,null),b.localize(52,null)],description:b.localize(53,null)}})}validate(ce){return!ce||typeof ce!="object"?this.defaultValue:{enabled:u(ce.enabled,this.defaultValue.enabled,[_.Off,_.OnCode,_.On])}}}class oe extends C{constructor(){const ce={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",ce,{"editor.stickyScroll.enabled":{type:"boolean",default:ce.enabled,description:b.localize(54,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:ce.maxLineCount,minimum:1,maximum:10,description:b.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:ce.defaultModel,description:b.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:ce.scrollWithEditor,description:b.localize(57,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{enabled:f(Ie.enabled,this.defaultValue.enabled),maxLineCount:r.clampedInt(Ie.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:u(Ie.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:f(Ie.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class K extends C{constructor(){const ce={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",ce,{"editor.inlayHints.enabled":{type:"string",default:ce.enabled,description:b.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[b.localize(59,null),b.localize(60,null,g.$j?"Ctrl+Option":"Ctrl+Alt"),b.localize(61,null,g.$j?"Ctrl+Option":"Ctrl+Alt"),b.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:ce.fontSize,markdownDescription:b.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:ce.fontFamily,markdownDescription:b.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:ce.padding,description:b.localize(65,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return typeof Ie.enabled=="boolean"&&(Ie.enabled=Ie.enabled?"on":"off"),{enabled:u(Ie.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:r.clampedInt(Ie.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(Ie.fontFamily,this.defaultValue.fontFamily),padding:f(Ie.padding,this.defaultValue.padding)}}}class W extends C{constructor(){super(65,"lineDecorationsWidth",10)}validate(ce){return typeof ce=="string"&&/^\d+(\.\d+)?ch$/.test(ce)?-parseFloat(ce.substring(0,ce.length-2)):r.clampedInt(ce,this.defaultValue,0,1e3)}compute(ce,Ie,qe){return qe<0?r.clampedInt(-qe*ce.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):qe}}class re extends c{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,ce=>c.clamp(ce,0,150),{markdownDescription:b.localize(66,null)})}compute(ce,Ie,qe){return ce.fontInfo.lineHeight}}class ye extends C{constructor(){const ce={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",ce,{"editor.minimap.enabled":{type:"boolean",default:ce.enabled,description:b.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:ce.autohide,description:b.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[b.localize(69,null),b.localize(70,null),b.localize(71,null)],default:ce.size,description:b.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ce.side,description:b.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ce.showSlider,description:b.localize(74,null)},"editor.minimap.scale":{type:"number",default:ce.scale,minimum:1,maximum:3,enum:[1,2,3],description:b.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ce.renderCharacters,description:b.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:ce.maxColumn,description:b.localize(77,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{enabled:f(Ie.enabled,this.defaultValue.enabled),autohide:f(Ie.autohide,this.defaultValue.autohide),size:u(Ie.size,this.defaultValue.size,["proportional","fill","fit"]),side:u(Ie.side,this.defaultValue.side,["right","left"]),showSlider:u(Ie.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:f(Ie.renderCharacters,this.defaultValue.renderCharacters),scale:r.clampedInt(Ie.scale,1,1,3),maxColumn:r.clampedInt(Ie.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function de(ne){return ne==="ctrlCmd"?g.$j?"metaKey":"ctrlKey":"altKey"}class ge extends C{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(78,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(79,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{top:r.clampedInt(Ie.top,0,0,1e3),bottom:r.clampedInt(Ie.bottom,0,0,1e3)}}}class x extends C{constructor(){const ce={enabled:!0,cycle:!0};super(85,"parameterHints",ce,{"editor.parameterHints.enabled":{type:"boolean",default:ce.enabled,description:b.localize(80,null)},"editor.parameterHints.cycle":{type:"boolean",default:ce.cycle,description:b.localize(81,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{enabled:f(Ie.enabled,this.defaultValue.enabled),cycle:f(Ie.cycle,this.defaultValue.cycle)}}}class te extends S{constructor(){super(141)}compute(ce,Ie,qe){return ce.pixelRatio}}class G extends C{constructor(){const ce={other:"on",comments:"off",strings:"off"},Ie=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[b.localize(82,null),b.localize(83,null),b.localize(84,null)]}];super(88,"quickSuggestions",ce,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ie,default:ce.strings,description:b.localize(85,null)},comments:{anyOf:Ie,default:ce.comments,description:b.localize(86,null)},other:{anyOf:Ie,default:ce.other,description:b.localize(87,null)}},default:ce,markdownDescription:b.localize(88,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=ce}validate(ce){if(typeof ce=="boolean"){const St=ce?"on":"off";return{comments:St,strings:St,other:St}}if(!ce||typeof ce!="object")return this.defaultValue;const{other:Ie,comments:qe,strings:Ye}=ce,nt=["on","inline","off"];let it,Oe,vt;return typeof Ie=="boolean"?it=Ie?"on":"off":it=u(Ie,this.defaultValue.other,nt),typeof qe=="boolean"?Oe=qe?"on":"off":Oe=u(qe,this.defaultValue.comments,nt),typeof Ye=="boolean"?vt=Ye?"on":"off":vt=u(Ye,this.defaultValue.strings,nt),{other:it,comments:Oe,strings:vt}}}var ie;(function(ne){ne[ne.Off=0]="Off",ne[ne.On=1]="On",ne[ne.Relative=2]="Relative",ne[ne.Interval=3]="Interval",ne[ne.Custom=4]="Custom"})(ie||(e.RenderLineNumbersType=ie={}));class fe extends C{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[b.localize(89,null),b.localize(90,null),b.localize(91,null),b.localize(92,null)],default:"on",description:b.localize(93,null)})}validate(ce){let Ie=this.defaultValue.renderType,qe=this.defaultValue.renderFn;return typeof ce<"u"&&(typeof ce=="function"?(Ie=4,qe=ce):ce==="interval"?Ie=3:ce==="relative"?Ie=2:ce==="on"?Ie=1:Ie=0),{renderType:Ie,renderFn:qe}}}function pe(ne){const ce=ne.get(97);return ce==="editable"?ne.get(90):ce!=="on"}e.filterValidationDecorations=pe;class Pe extends C{constructor(){const ce=[],Ie={type:"number",description:b.localize(94,null)};super(101,"rulers",ce,{type:"array",items:{anyOf:[Ie,{type:["object"],properties:{column:Ie,color:{type:"string",description:b.localize(95,null),format:"color-hex"}}}]},default:ce,description:b.localize(96,null)})}validate(ce){if(Array.isArray(ce)){const Ie=[];for(const qe of ce)if(typeof qe=="number")Ie.push({column:r.clampedInt(qe,0,0,1e4),color:null});else if(qe&&typeof qe=="object"){const Ye=qe;Ie.push({column:r.clampedInt(Ye.column,0,0,1e4),color:Ye.color})}return Ie.sort((qe,Ye)=>qe.column-Ye.column),Ie}return this.defaultValue}}class be extends C{constructor(){super(91,"readOnlyMessage",void 0)}validate(ce){return!ce||typeof ce!="object"?this.defaultValue:ce}}function De(ne,ce){if(typeof ne!="string")return ce;switch(ne){case"hidden":return 2;case"visible":return 3;default:return 1}}class z extends C{constructor(){const ce={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(102,"scrollbar",ce,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[b.localize(97,null),b.localize(98,null),b.localize(99,null)],default:"auto",description:b.localize(100,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[b.localize(101,null),b.localize(102,null),b.localize(103,null)],default:"auto",description:b.localize(104,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:ce.verticalScrollbarSize,description:b.localize(105,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:ce.horizontalScrollbarSize,description:b.localize(106,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:ce.scrollByPage,description:b.localize(107,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:ce.ignoreHorizontalScrollbarInContentHeight,description:b.localize(108,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce,qe=r.clampedInt(Ie.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ye=r.clampedInt(Ie.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:r.clampedInt(Ie.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:De(Ie.vertical,this.defaultValue.vertical),horizontal:De(Ie.horizontal,this.defaultValue.horizontal),useShadows:f(Ie.useShadows,this.defaultValue.useShadows),verticalHasArrows:f(Ie.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:f(Ie.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:f(Ie.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:f(Ie.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:qe,horizontalSliderSize:r.clampedInt(Ie.horizontalSliderSize,qe,0,1e3),verticalScrollbarSize:Ye,verticalSliderSize:r.clampedInt(Ie.verticalSliderSize,Ye,0,1e3),scrollByPage:f(Ie.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:f(Ie.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class Q extends C{constructor(){const ce={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",ce,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ce.nonBasicASCII,description:b.localize(109,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:ce.invisibleCharacters,description:b.localize(110,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:ce.ambiguousCharacters,description:b.localize(111,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ce.includeComments,description:b.localize(112,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ce.includeStrings,description:b.localize(113,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:ce.allowedCharacters,description:b.localize(114,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:ce.allowedLocales,description:b.localize(115,null)}})}applyUpdate(ce,Ie){let qe=!1;Ie.allowedCharacters&&ce&&(O.$zn(ce.allowedCharacters,Ie.allowedCharacters)||(ce={...ce,allowedCharacters:Ie.allowedCharacters},qe=!0)),Ie.allowedLocales&&ce&&(O.$zn(ce.allowedLocales,Ie.allowedLocales)||(ce={...ce,allowedLocales:Ie.allowedLocales},qe=!0));const Ye=super.applyUpdate(ce,Ie);return qe?new m(Ye.newValue,!0):Ye}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{nonBasicASCII:le(Ie.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:f(Ie.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:f(Ie.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:le(Ie.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:le(Ie.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(ce.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(ce.allowedLocales,this.defaultValue.allowedLocales)}}c(ce,Ie){if(typeof ce!="object"||!ce)return Ie;const qe={};for(const[Ye,nt]of Object.entries(ce))nt===!0&&(qe[Ye]=!0);return qe}}class ee extends C{constructor(){const ce={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(62,"inlineSuggest",ce,{"editor.inlineSuggest.enabled":{type:"boolean",default:ce.enabled,description:b.localize(116,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:ce.showToolbar,enum:["always","onHover","never"],enumDescriptions:[b.localize(117,null),b.localize(118,null),b.localize(119,null)],description:b.localize(120,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:ce.suppressSuggestions,description:b.localize(121,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{enabled:f(Ie.enabled,this.defaultValue.enabled),mode:u(Ie.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:u(Ie.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:f(Ie.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:f(Ie.keepOnBlur,this.defaultValue.keepOnBlur)}}}class q extends C{constructor(){const ce={enabled:I.$ss.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:I.$ss.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",ce,{"editor.bracketPairColorization.enabled":{type:"boolean",default:ce.enabled,markdownDescription:b.localize(122,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:ce.independentColorPoolPerBracketType,description:b.localize(123,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{enabled:f(Ie.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:f(Ie.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class ae extends C{constructor(){const ce={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",ce,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[b.localize(124,null),b.localize(125,null),b.localize(126,null)],default:ce.bracketPairs,description:b.localize(127,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[b.localize(128,null),b.localize(129,null),b.localize(130,null)],default:ce.bracketPairsHorizontal,description:b.localize(131,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:ce.highlightActiveBracketPair,description:b.localize(132,null)},"editor.guides.indentation":{type:"boolean",default:ce.indentation,description:b.localize(133,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[b.localize(134,null),b.localize(135,null),b.localize(136,null)],default:ce.highlightActiveIndentation,description:b.localize(137,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{bracketPairs:le(Ie.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:le(Ie.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:f(Ie.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:f(Ie.indentation,this.defaultValue.indentation),highlightActiveIndentation:le(Ie.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function le(ne,ce,Ie){const qe=Ie.indexOf(ne);return qe===-1?ce:Ie[qe]}class Le extends C{constructor(){const ce={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",ce,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[b.localize(138,null),b.localize(139,null)],default:ce.insertMode,description:b.localize(140,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ce.filterGraceful,description:b.localize(141,null)},"editor.suggest.localityBonus":{type:"boolean",default:ce.localityBonus,description:b.localize(142,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ce.shareSuggestSelections,markdownDescription:b.localize(143,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[b.localize(144,null),b.localize(145,null),b.localize(146,null),b.localize(147,null)],default:ce.selectionMode,markdownDescription:b.localize(148,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ce.snippetsPreventQuickSuggestions,description:b.localize(149,null)},"editor.suggest.showIcons":{type:"boolean",default:ce.showIcons,description:b.localize(150,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ce.showStatusBar,description:b.localize(151,null)},"editor.suggest.preview":{type:"boolean",default:ce.preview,description:b.localize(152,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ce.showInlineDetails,description:b.localize(153,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:b.localize(154,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:b.localize(155,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:b.localize(156,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:b.localize(157,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:b.localize(158,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:b.localize(159,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:b.localize(160,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:b.localize(161,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:b.localize(162,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:b.localize(163,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:b.localize(164,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:b.localize(165,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:b.localize(166,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:b.localize(167,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:b.localize(168,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:b.localize(169,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:b.localize(170,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:b.localize(171,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:b.localize(172,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:b.localize(173,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:b.localize(174,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:b.localize(175,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:b.localize(176,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:b.localize(177,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:b.localize(178,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:b.localize(179,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:b.localize(180,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:b.localize(181,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:b.localize(182,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:b.localize(183,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:b.localize(184,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:b.localize(185,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{insertMode:u(Ie.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:f(Ie.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:f(Ie.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:f(Ie.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:f(Ie.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:u(Ie.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:f(Ie.showIcons,this.defaultValue.showIcons),showStatusBar:f(Ie.showStatusBar,this.defaultValue.showStatusBar),preview:f(Ie.preview,this.defaultValue.preview),previewMode:u(Ie.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:f(Ie.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:f(Ie.showMethods,this.defaultValue.showMethods),showFunctions:f(Ie.showFunctions,this.defaultValue.showFunctions),showConstructors:f(Ie.showConstructors,this.defaultValue.showConstructors),showDeprecated:f(Ie.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:f(Ie.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:f(Ie.showFields,this.defaultValue.showFields),showVariables:f(Ie.showVariables,this.defaultValue.showVariables),showClasses:f(Ie.showClasses,this.defaultValue.showClasses),showStructs:f(Ie.showStructs,this.defaultValue.showStructs),showInterfaces:f(Ie.showInterfaces,this.defaultValue.showInterfaces),showModules:f(Ie.showModules,this.defaultValue.showModules),showProperties:f(Ie.showProperties,this.defaultValue.showProperties),showEvents:f(Ie.showEvents,this.defaultValue.showEvents),showOperators:f(Ie.showOperators,this.defaultValue.showOperators),showUnits:f(Ie.showUnits,this.defaultValue.showUnits),showValues:f(Ie.showValues,this.defaultValue.showValues),showConstants:f(Ie.showConstants,this.defaultValue.showConstants),showEnums:f(Ie.showEnums,this.defaultValue.showEnums),showEnumMembers:f(Ie.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:f(Ie.showKeywords,this.defaultValue.showKeywords),showWords:f(Ie.showWords,this.defaultValue.showWords),showColors:f(Ie.showColors,this.defaultValue.showColors),showFiles:f(Ie.showFiles,this.defaultValue.showFiles),showReferences:f(Ie.showReferences,this.defaultValue.showReferences),showFolders:f(Ie.showFolders,this.defaultValue.showFolders),showTypeParameters:f(Ie.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:f(Ie.showSnippets,this.defaultValue.showSnippets),showUsers:f(Ie.showUsers,this.defaultValue.showUsers),showIssues:f(Ie.showIssues,this.defaultValue.showIssues)}}}class je extends C{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:b.localize(186,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:b.localize(187,null),default:!0,type:"boolean"}})}validate(ce){return!ce||typeof ce!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:f(ce.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:f(ce.selectSubwords,this.defaultValue.selectSubwords)}}}var He;(function(ne){ne[ne.None=0]="None",ne[ne.Same=1]="Same",ne[ne.Indent=2]="Indent",ne[ne.DeepIndent=3]="DeepIndent"})(He||(e.WrappingIndent=He={}));class Je extends C{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[b.localize(188,null),b.localize(189,null),b.localize(190,null),b.localize(191,null)],description:b.localize(192,null),default:"same"}})}validate(ce){switch(ce){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(ce,Ie,qe){return Ie.get(2)===2?0:qe}}class _e extends S{constructor(){super(144)}compute(ce,Ie,qe){const Ye=Ie.get(143);return{isDominatedByLongLines:ce.isDominatedByLongLines,isWordWrapMinified:Ye.isWordWrapMinified,isViewportWrapping:Ye.isViewportWrapping,wrappingColumn:Ye.wrappingColumn}}}class ct extends C{constructor(){const ce={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",ce,{"editor.dropIntoEditor.enabled":{type:"boolean",default:ce.enabled,markdownDescription:b.localize(193,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:b.localize(194,null),enum:["afterDrop","never"],enumDescriptions:[b.localize(195,null),b.localize(196,null)],default:"afterDrop"}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{enabled:f(Ie.enabled,this.defaultValue.enabled),showDropSelector:u(Ie.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class ot extends C{constructor(){const ce={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",ce,{"editor.pasteAs.enabled":{type:"boolean",default:ce.enabled,markdownDescription:b.localize(197,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:b.localize(198,null),enum:["afterPaste","never"],enumDescriptions:[b.localize(199,null),b.localize(200,null)],default:"afterPaste"}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{enabled:f(Ie.enabled,this.defaultValue.enabled),showPasteSelector:u(Ie.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const rt="Consolas, 'Courier New', monospace",Re="Menlo, Monaco, 'Courier New', monospace",Ue="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:g.$j?Re:g.$k?Ue:rt,fontWeight:"normal",fontSize:g.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Ae(ne){return e.editorOptionsRegistry[ne.id]=ne,ne}var Xe;(function(ne){ne[ne.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ne[ne.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ne[ne.accessibilitySupport=2]="accessibilitySupport",ne[ne.accessibilityPageSize=3]="accessibilityPageSize",ne[ne.ariaLabel=4]="ariaLabel",ne[ne.ariaRequired=5]="ariaRequired",ne[ne.autoClosingBrackets=6]="autoClosingBrackets",ne[ne.autoClosingComments=7]="autoClosingComments",ne[ne.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",ne[ne.autoClosingDelete=9]="autoClosingDelete",ne[ne.autoClosingOvertype=10]="autoClosingOvertype",ne[ne.autoClosingQuotes=11]="autoClosingQuotes",ne[ne.autoIndent=12]="autoIndent",ne[ne.automaticLayout=13]="automaticLayout",ne[ne.autoSurround=14]="autoSurround",ne[ne.bracketPairColorization=15]="bracketPairColorization",ne[ne.guides=16]="guides",ne[ne.codeLens=17]="codeLens",ne[ne.codeLensFontFamily=18]="codeLensFontFamily",ne[ne.codeLensFontSize=19]="codeLensFontSize",ne[ne.colorDecorators=20]="colorDecorators",ne[ne.colorDecoratorsLimit=21]="colorDecoratorsLimit",ne[ne.columnSelection=22]="columnSelection",ne[ne.comments=23]="comments",ne[ne.contextmenu=24]="contextmenu",ne[ne.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",ne[ne.cursorBlinking=26]="cursorBlinking",ne[ne.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",ne[ne.cursorStyle=28]="cursorStyle",ne[ne.cursorSurroundingLines=29]="cursorSurroundingLines",ne[ne.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",ne[ne.cursorWidth=31]="cursorWidth",ne[ne.disableLayerHinting=32]="disableLayerHinting",ne[ne.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",ne[ne.domReadOnly=34]="domReadOnly",ne[ne.dragAndDrop=35]="dragAndDrop",ne[ne.dropIntoEditor=36]="dropIntoEditor",ne[ne.emptySelectionClipboard=37]="emptySelectionClipboard",ne[ne.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",ne[ne.extraEditorClassName=39]="extraEditorClassName",ne[ne.fastScrollSensitivity=40]="fastScrollSensitivity",ne[ne.find=41]="find",ne[ne.fixedOverflowWidgets=42]="fixedOverflowWidgets",ne[ne.folding=43]="folding",ne[ne.foldingStrategy=44]="foldingStrategy",ne[ne.foldingHighlight=45]="foldingHighlight",ne[ne.foldingImportsByDefault=46]="foldingImportsByDefault",ne[ne.foldingMaximumRegions=47]="foldingMaximumRegions",ne[ne.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",ne[ne.fontFamily=49]="fontFamily",ne[ne.fontInfo=50]="fontInfo",ne[ne.fontLigatures=51]="fontLigatures",ne[ne.fontSize=52]="fontSize",ne[ne.fontWeight=53]="fontWeight",ne[ne.fontVariations=54]="fontVariations",ne[ne.formatOnPaste=55]="formatOnPaste",ne[ne.formatOnType=56]="formatOnType",ne[ne.glyphMargin=57]="glyphMargin",ne[ne.gotoLocation=58]="gotoLocation",ne[ne.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",ne[ne.hover=60]="hover",ne[ne.inDiffEditor=61]="inDiffEditor",ne[ne.inlineSuggest=62]="inlineSuggest",ne[ne.letterSpacing=63]="letterSpacing",ne[ne.lightbulb=64]="lightbulb",ne[ne.lineDecorationsWidth=65]="lineDecorationsWidth",ne[ne.lineHeight=66]="lineHeight",ne[ne.lineNumbers=67]="lineNumbers",ne[ne.lineNumbersMinChars=68]="lineNumbersMinChars",ne[ne.linkedEditing=69]="linkedEditing",ne[ne.links=70]="links",ne[ne.matchBrackets=71]="matchBrackets",ne[ne.minimap=72]="minimap",ne[ne.mouseStyle=73]="mouseStyle",ne[ne.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",ne[ne.mouseWheelZoom=75]="mouseWheelZoom",ne[ne.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",ne[ne.multiCursorModifier=77]="multiCursorModifier",ne[ne.multiCursorPaste=78]="multiCursorPaste",ne[ne.multiCursorLimit=79]="multiCursorLimit",ne[ne.occurrencesHighlight=80]="occurrencesHighlight",ne[ne.overviewRulerBorder=81]="overviewRulerBorder",ne[ne.overviewRulerLanes=82]="overviewRulerLanes",ne[ne.padding=83]="padding",ne[ne.pasteAs=84]="pasteAs",ne[ne.parameterHints=85]="parameterHints",ne[ne.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",ne[ne.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",ne[ne.quickSuggestions=88]="quickSuggestions",ne[ne.quickSuggestionsDelay=89]="quickSuggestionsDelay",ne[ne.readOnly=90]="readOnly",ne[ne.readOnlyMessage=91]="readOnlyMessage",ne[ne.renameOnType=92]="renameOnType",ne[ne.renderControlCharacters=93]="renderControlCharacters",ne[ne.renderFinalNewline=94]="renderFinalNewline",ne[ne.renderLineHighlight=95]="renderLineHighlight",ne[ne.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",ne[ne.renderValidationDecorations=97]="renderValidationDecorations",ne[ne.renderWhitespace=98]="renderWhitespace",ne[ne.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",ne[ne.roundedSelection=100]="roundedSelection",ne[ne.rulers=101]="rulers",ne[ne.scrollbar=102]="scrollbar",ne[ne.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",ne[ne.scrollBeyondLastLine=104]="scrollBeyondLastLine",ne[ne.scrollPredominantAxis=105]="scrollPredominantAxis",ne[ne.selectionClipboard=106]="selectionClipboard",ne[ne.selectionHighlight=107]="selectionHighlight",ne[ne.selectOnLineNumbers=108]="selectOnLineNumbers",ne[ne.showFoldingControls=109]="showFoldingControls",ne[ne.showUnused=110]="showUnused",ne[ne.snippetSuggestions=111]="snippetSuggestions",ne[ne.smartSelect=112]="smartSelect",ne[ne.smoothScrolling=113]="smoothScrolling",ne[ne.stickyScroll=114]="stickyScroll",ne[ne.stickyTabStops=115]="stickyTabStops",ne[ne.stopRenderingLineAfter=116]="stopRenderingLineAfter",ne[ne.suggest=117]="suggest",ne[ne.suggestFontSize=118]="suggestFontSize",ne[ne.suggestLineHeight=119]="suggestLineHeight",ne[ne.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",ne[ne.suggestSelection=121]="suggestSelection",ne[ne.tabCompletion=122]="tabCompletion",ne[ne.tabIndex=123]="tabIndex",ne[ne.unicodeHighlighting=124]="unicodeHighlighting",ne[ne.unusualLineTerminators=125]="unusualLineTerminators",ne[ne.useShadowDOM=126]="useShadowDOM",ne[ne.useTabStops=127]="useTabStops",ne[ne.wordBreak=128]="wordBreak",ne[ne.wordSeparators=129]="wordSeparators",ne[ne.wordWrap=130]="wordWrap",ne[ne.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",ne[ne.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",ne[ne.wordWrapColumn=133]="wordWrapColumn",ne[ne.wordWrapOverride1=134]="wordWrapOverride1",ne[ne.wordWrapOverride2=135]="wordWrapOverride2",ne[ne.wrappingIndent=136]="wrappingIndent",ne[ne.wrappingStrategy=137]="wrappingStrategy",ne[ne.showDeprecated=138]="showDeprecated",ne[ne.inlayHints=139]="inlayHints",ne[ne.editorClassName=140]="editorClassName",ne[ne.pixelRatio=141]="pixelRatio",ne[ne.tabFocusMode=142]="tabFocusMode",ne[ne.layoutInfo=143]="layoutInfo",ne[ne.wrappingInfo=144]="wrappingInfo",ne[ne.defaultColorDecorators=145]="defaultColorDecorators",ne[ne.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",ne[ne.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(Xe||(e.EditorOption=Xe={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ae(new o(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:b.localize(201,null)})),acceptSuggestionOnEnter:Ae(new s(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",b.localize(202,null),""],markdownDescription:b.localize(203,null)})),accessibilitySupport:Ae(new d),accessibilityPageSize:Ae(new r(3,"accessibilityPageSize",10,1,1073741824,{description:b.localize(204,null),tags:["accessibility"]})),ariaLabel:Ae(new t(4,"ariaLabel",b.localize(205,null))),ariaRequired:Ae(new o(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Ae(new o(8,"screenReaderAnnounceInlineSuggestion",!0,{description:b.localize(206,null),tags:["accessibility"]})),autoClosingBrackets:Ae(new s(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(207,null),b.localize(208,null),""],description:b.localize(209,null)})),autoClosingComments:Ae(new s(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(210,null),b.localize(211,null),""],description:b.localize(212,null)})),autoClosingDelete:Ae(new s(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",b.localize(213,null),""],description:b.localize(214,null)})),autoClosingOvertype:Ae(new s(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",b.localize(215,null),""],description:b.localize(216,null)})),autoClosingQuotes:Ae(new s(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(217,null),b.localize(218,null),""],description:b.localize(219,null)})),autoIndent:Ae(new l(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],a,{enumDescriptions:[b.localize(220,null),b.localize(221,null),b.localize(222,null),b.localize(223,null),b.localize(224,null)],description:b.localize(225,null)})),automaticLayout:Ae(new o(13,"automaticLayout",!1)),autoSurround:Ae(new s(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[b.localize(226,null),b.localize(227,null),b.localize(228,null),""],description:b.localize(229,null)})),bracketPairColorization:Ae(new q),bracketPairGuides:Ae(new ae),stickyTabStops:Ae(new o(115,"stickyTabStops",!1,{description:b.localize(230,null)})),codeLens:Ae(new o(17,"codeLens",!0,{description:b.localize(231,null)})),codeLensFontFamily:Ae(new t(18,"codeLensFontFamily","",{description:b.localize(232,null)})),codeLensFontSize:Ae(new r(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:b.localize(233,null)})),colorDecorators:Ae(new o(20,"colorDecorators",!0,{description:b.localize(234,null)})),colorDecoratorActivatedOn:Ae(new s(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[b.localize(235,null),b.localize(236,null),b.localize(237,null)],description:b.localize(238,null)})),colorDecoratorsLimit:Ae(new r(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:b.localize(239,null)})),columnSelection:Ae(new o(22,"columnSelection",!1,{description:b.localize(240,null)})),comments:Ae(new k),contextmenu:Ae(new o(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Ae(new o(25,"copyWithSyntaxHighlighting",!0,{description:b.localize(241,null)})),cursorBlinking:Ae(new l(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],v,{description:b.localize(242,null)})),cursorSmoothCaretAnimation:Ae(new s(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[b.localize(243,null),b.localize(244,null),b.localize(245,null)],description:b.localize(246,null)})),cursorStyle:Ae(new l(28,"cursorStyle",w.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],P,{description:b.localize(247,null)})),cursorSurroundingLines:Ae(new r(29,"cursorSurroundingLines",0,0,1073741824,{description:b.localize(248,null)})),cursorSurroundingLinesStyle:Ae(new s(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[b.localize(249,null),b.localize(250,null)],markdownDescription:b.localize(251,null)})),cursorWidth:Ae(new r(31,"cursorWidth",0,0,1073741824,{markdownDescription:b.localize(252,null)})),disableLayerHinting:Ae(new o(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ae(new o(33,"disableMonospaceOptimizations",!1)),domReadOnly:Ae(new o(34,"domReadOnly",!1)),dragAndDrop:Ae(new o(35,"dragAndDrop",!0,{description:b.localize(253,null)})),emptySelectionClipboard:Ae(new U),dropIntoEditor:Ae(new ct),stickyScroll:Ae(new oe),experimentalWhitespaceRendering:Ae(new s(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[b.localize(254,null),b.localize(255,null),b.localize(256,null)],description:b.localize(257,null)})),extraEditorClassName:Ae(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Ae(new c(40,"fastScrollSensitivity",5,ne=>ne<=0?5:ne,{markdownDescription:b.localize(258,null)})),find:Ae(new F),fixedOverflowWidgets:Ae(new o(42,"fixedOverflowWidgets",!1)),folding:Ae(new o(43,"folding",!0,{description:b.localize(259,null)})),foldingStrategy:Ae(new s(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[b.localize(260,null),b.localize(261,null)],description:b.localize(262,null)})),foldingHighlight:Ae(new o(45,"foldingHighlight",!0,{description:b.localize(263,null)})),foldingImportsByDefault:Ae(new o(46,"foldingImportsByDefault",!1,{description:b.localize(264,null)})),foldingMaximumRegions:Ae(new r(47,"foldingMaximumRegions",5e3,10,65e3,{description:b.localize(265,null)})),unfoldOnClickAfterEndOfLine:Ae(new o(48,"unfoldOnClickAfterEndOfLine",!1,{description:b.localize(266,null)})),fontFamily:Ae(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:b.localize(267,null)})),fontInfo:Ae(new M),fontLigatures2:Ae(new j),fontSize:Ae(new B),fontWeight:Ae(new Y),fontVariations:Ae(new T),formatOnPaste:Ae(new o(55,"formatOnPaste",!1,{description:b.localize(268,null)})),formatOnType:Ae(new o(56,"formatOnType",!1,{description:b.localize(269,null)})),glyphMargin:Ae(new o(57,"glyphMargin",!0,{description:b.localize(270,null)})),gotoLocation:Ae(new ue),hideCursorInOverviewRuler:Ae(new o(59,"hideCursorInOverviewRuler",!1,{description:b.localize(271,null)})),hover:Ae(new Z),inDiffEditor:Ae(new o(61,"inDiffEditor",!1)),letterSpacing:Ae(new c(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ne=>c.clamp(ne,-5,20),{description:b.localize(272,null)})),lightbulb:Ae(new we),lineDecorationsWidth:Ae(new W),lineHeight:Ae(new re),lineNumbers:Ae(new fe),lineNumbersMinChars:Ae(new r(68,"lineNumbersMinChars",5,1,300)),linkedEditing:Ae(new o(69,"linkedEditing",!1,{description:b.localize(273,null)})),links:Ae(new o(70,"links",!0,{description:b.localize(274,null)})),matchBrackets:Ae(new s(71,"matchBrackets","always",["always","near","never"],{description:b.localize(275,null)})),minimap:Ae(new ye),mouseStyle:Ae(new s(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ae(new c(74,"mouseWheelScrollSensitivity",1,ne=>ne===0?1:ne,{markdownDescription:b.localize(276,null)})),mouseWheelZoom:Ae(new o(75,"mouseWheelZoom",!1,{markdownDescription:g.$j?b.localize(277,null):b.localize(278,null)})),multiCursorMergeOverlapping:Ae(new o(76,"multiCursorMergeOverlapping",!0,{description:b.localize(279,null)})),multiCursorModifier:Ae(new l(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],de,{markdownEnumDescriptions:[b.localize(280,null),b.localize(281,null)],markdownDescription:b.localize(282,null)})),multiCursorPaste:Ae(new s(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[b.localize(283,null),b.localize(284,null)],markdownDescription:b.localize(285,null)})),multiCursorLimit:Ae(new r(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:b.localize(286,null)})),occurrencesHighlight:Ae(new s(80,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[b.localize(287,null),b.localize(288,null),b.localize(289,null)],markdownDescription:b.localize(290,null)})),overviewRulerBorder:Ae(new o(81,"overviewRulerBorder",!0,{description:b.localize(291,null)})),overviewRulerLanes:Ae(new r(82,"overviewRulerLanes",3,0,3)),padding:Ae(new ge),pasteAs:Ae(new ot),parameterHints:Ae(new x),peekWidgetDefaultFocus:Ae(new s(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[b.localize(292,null),b.localize(293,null)],description:b.localize(294,null)})),definitionLinkOpensInPeek:Ae(new o(87,"definitionLinkOpensInPeek",!1,{description:b.localize(295,null)})),quickSuggestions:Ae(new G),quickSuggestionsDelay:Ae(new r(89,"quickSuggestionsDelay",10,0,1073741824,{description:b.localize(296,null)})),readOnly:Ae(new o(90,"readOnly",!1)),readOnlyMessage:Ae(new be),renameOnType:Ae(new o(92,"renameOnType",!1,{description:b.localize(297,null),markdownDeprecationMessage:b.localize(298,null)})),renderControlCharacters:Ae(new o(93,"renderControlCharacters",!0,{description:b.localize(299,null),restricted:!0})),renderFinalNewline:Ae(new s(94,"renderFinalNewline",g.$k?"dimmed":"on",["off","on","dimmed"],{description:b.localize(300,null)})),renderLineHighlight:Ae(new s(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",b.localize(301,null)],description:b.localize(302,null)})),renderLineHighlightOnlyWhenFocus:Ae(new o(96,"renderLineHighlightOnlyWhenFocus",!1,{description:b.localize(303,null)})),renderValidationDecorations:Ae(new s(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ae(new s(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",b.localize(304,null),b.localize(305,null),b.localize(306,null),""],description:b.localize(307,null)})),revealHorizontalRightPadding:Ae(new r(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Ae(new o(100,"roundedSelection",!0,{description:b.localize(308,null)})),rulers:Ae(new Pe),scrollbar:Ae(new z),scrollBeyondLastColumn:Ae(new r(103,"scrollBeyondLastColumn",4,0,1073741824,{description:b.localize(309,null)})),scrollBeyondLastLine:Ae(new o(104,"scrollBeyondLastLine",!0,{description:b.localize(310,null)})),scrollPredominantAxis:Ae(new o(105,"scrollPredominantAxis",!0,{description:b.localize(311,null)})),selectionClipboard:Ae(new o(106,"selectionClipboard",!0,{description:b.localize(312,null),included:g.$k})),selectionHighlight:Ae(new o(107,"selectionHighlight",!0,{description:b.localize(313,null)})),selectOnLineNumbers:Ae(new o(108,"selectOnLineNumbers",!0)),showFoldingControls:Ae(new s(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[b.localize(314,null),b.localize(315,null),b.localize(316,null)],description:b.localize(317,null)})),showUnused:Ae(new o(110,"showUnused",!0,{description:b.localize(318,null)})),showDeprecated:Ae(new o(138,"showDeprecated",!0,{description:b.localize(319,null)})),inlayHints:Ae(new K),snippetSuggestions:Ae(new s(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[b.localize(320,null),b.localize(321,null),b.localize(322,null),b.localize(323,null)],description:b.localize(324,null)})),smartSelect:Ae(new je),smoothScrolling:Ae(new o(113,"smoothScrolling",!1,{description:b.localize(325,null)})),stopRenderingLineAfter:Ae(new r(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ae(new Le),inlineSuggest:Ae(new ee),inlineCompletionsAccessibilityVerbose:Ae(new o(147,"inlineCompletionsAccessibilityVerbose",!1,{description:b.localize(326,null)})),suggestFontSize:Ae(new r(118,"suggestFontSize",0,0,1e3,{markdownDescription:b.localize(327,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Ae(new r(119,"suggestLineHeight",0,0,1e3,{markdownDescription:b.localize(328,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Ae(new o(120,"suggestOnTriggerCharacters",!0,{description:b.localize(329,null)})),suggestSelection:Ae(new s(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[b.localize(330,null),b.localize(331,null),b.localize(332,null)],description:b.localize(333,null)})),tabCompletion:Ae(new s(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[b.localize(334,null),b.localize(335,null),b.localize(336,null)],description:b.localize(337,null)})),tabIndex:Ae(new r(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:Ae(new Q),unusualLineTerminators:Ae(new s(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[b.localize(338,null),b.localize(339,null),b.localize(340,null)],description:b.localize(341,null)})),useShadowDOM:Ae(new o(126,"useShadowDOM",!0)),useTabStops:Ae(new o(127,"useTabStops",!0,{description:b.localize(342,null)})),wordBreak:Ae(new s(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[b.localize(343,null),b.localize(344,null)],description:b.localize(345,null)})),wordSeparators:Ae(new t(129,"wordSeparators",A.$ts,{description:b.localize(346,null)})),wordWrap:Ae(new s(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[b.localize(347,null),b.localize(348,null),b.localize(349,null),b.localize(350,null)],description:b.localize(351,null)})),wordWrapBreakAfterCharacters:Ae(new t(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ae(new t(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ae(new r(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:b.localize(352,null)})),wordWrapOverride1:Ae(new s(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ae(new s(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Ae(new N),defaultColorDecorators:Ae(new o(145,"defaultColorDecorators",!1,{markdownDescription:b.localize(353,null)})),pixelRatio:Ae(new te),tabFocusMode:Ae(new o(142,"tabFocusMode",!1,{markdownDescription:b.localize(354,null)})),layoutInfo:Ae(new X),wrappingInfo:Ae(new _e),wrappingIndent:Ae(new Je),wrappingStrategy:Ae(new he)}}),define(ke[195],Se([8,9]),function(me,e){return me.create("vs/editor/common/languages",e)}),define(ke[83],Se([1,0,78,2,168,29,178,195]),function(me,e,D,O,g,I,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.$Mt=e.$Lt=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.$Kt=e.$Jt=e.SymbolKinds=e.SymbolTag=e.$It=e.$Ht=e.SymbolKind=e.$Gt=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.$Ft=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.$Et=e.$Dt=e.$Ct=void 0;class ${constructor(j,T,M){this.offset=j,this.type=T,this.language=M,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$Ct=$;class y{constructor(j,T){this.tokens=j,this.endState=T,this._tokenizationResultBrand=void 0}}e.$Dt=y;class L{constructor(j,T){this.tokens=j,this.endState=T,this._encodedTokenizationResultBrand=void 0}}e.$Et=L;var C;(function(F){F[F.Method=0]="Method",F[F.Function=1]="Function",F[F.Constructor=2]="Constructor",F[F.Field=3]="Field",F[F.Variable=4]="Variable",F[F.Class=5]="Class",F[F.Struct=6]="Struct",F[F.Interface=7]="Interface",F[F.Module=8]="Module",F[F.Property=9]="Property",F[F.Event=10]="Event",F[F.Operator=11]="Operator",F[F.Unit=12]="Unit",F[F.Value=13]="Value",F[F.Constant=14]="Constant",F[F.Enum=15]="Enum",F[F.EnumMember=16]="EnumMember",F[F.Keyword=17]="Keyword",F[F.Text=18]="Text",F[F.Color=19]="Color",F[F.File=20]="File",F[F.Reference=21]="Reference",F[F.Customcolor=22]="Customcolor",F[F.Folder=23]="Folder",F[F.TypeParameter=24]="TypeParameter",F[F.User=25]="User",F[F.Issue=26]="Issue",F[F.Snippet=27]="Snippet"})(C||(e.CompletionItemKind=C={}));var m;(function(F){const j=new Map;j.set(0,D.$_j.symbolMethod),j.set(1,D.$_j.symbolFunction),j.set(2,D.$_j.symbolConstructor),j.set(3,D.$_j.symbolField),j.set(4,D.$_j.symbolVariable),j.set(5,D.$_j.symbolClass),j.set(6,D.$_j.symbolStruct),j.set(7,D.$_j.symbolInterface),j.set(8,D.$_j.symbolModule),j.set(9,D.$_j.symbolProperty),j.set(10,D.$_j.symbolEvent),j.set(11,D.$_j.symbolOperator),j.set(12,D.$_j.symbolUnit),j.set(13,D.$_j.symbolValue),j.set(15,D.$_j.symbolEnum),j.set(14,D.$_j.symbolConstant),j.set(15,D.$_j.symbolEnum),j.set(16,D.$_j.symbolEnumMember),j.set(17,D.$_j.symbolKeyword),j.set(27,D.$_j.symbolSnippet),j.set(18,D.$_j.symbolText),j.set(19,D.$_j.symbolColor),j.set(20,D.$_j.symbolFile),j.set(21,D.$_j.symbolReference),j.set(22,D.$_j.symbolCustomColor),j.set(23,D.$_j.symbolFolder),j.set(24,D.$_j.symbolTypeParameter),j.set(25,D.$_j.account),j.set(26,D.$_j.issues);function T(Y){let ue=j.get(Y);return ue||(console.info("No codicon found for CompletionItemKind "+Y),ue=D.$_j.symbolProperty),ue}F.toIcon=T;const M=new Map;M.set("method",0),M.set("function",1),M.set("constructor",2),M.set("field",3),M.set("variable",4),M.set("class",5),M.set("struct",6),M.set("interface",7),M.set("module",8),M.set("property",9),M.set("event",10),M.set("operator",11),M.set("unit",12),M.set("value",13),M.set("constant",14),M.set("enum",15),M.set("enum-member",16),M.set("enumMember",16),M.set("keyword",17),M.set("snippet",27),M.set("text",18),M.set("color",19),M.set("file",20),M.set("reference",21),M.set("customcolor",22),M.set("folder",23),M.set("type-parameter",24),M.set("typeParameter",24),M.set("account",25),M.set("issue",26);function B(Y,ue){let Z=M.get(Y);return typeof Z>"u"&&!ue&&(Z=9),Z}F.fromString=B})(m||(e.CompletionItemKinds=m={}));var p;(function(F){F[F.Deprecated=1]="Deprecated"})(p||(e.CompletionItemTag=p={}));var S;(function(F){F[F.None=0]="None",F[F.KeepWhitespace=1]="KeepWhitespace",F[F.InsertAsSnippet=4]="InsertAsSnippet"})(S||(e.CompletionItemInsertTextRule=S={}));var h;(function(F){F[F.Invoke=0]="Invoke",F[F.TriggerCharacter=1]="TriggerCharacter",F[F.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(h||(e.CompletionTriggerKind=h={}));var f;(function(F){F[F.Automatic=0]="Automatic",F[F.Explicit=1]="Explicit"})(f||(e.InlineCompletionTriggerKind=f={}));class o{constructor(j,T,M,B){this.range=j,this.text=T,this.completionKind=M,this.isSnippetText=B}equals(j){return I.$Us.lift(this.range).equalsRange(j.range)&&this.text===j.text&&this.completionKind===j.completionKind&&this.isSnippetText===j.isSnippetText}}e.$Ft=o;var i;(function(F){F[F.Invoke=1]="Invoke",F[F.Auto=2]="Auto"})(i||(e.CodeActionTriggerType=i={}));var r;(function(F){F[F.Invoke=1]="Invoke",F[F.TriggerCharacter=2]="TriggerCharacter",F[F.ContentChange=3]="ContentChange"})(r||(e.SignatureHelpTriggerKind=r={}));var n;(function(F){F[F.Text=0]="Text",F[F.Read=1]="Read",F[F.Write=2]="Write"})(n||(e.DocumentHighlightKind=n={}));function c(F){return F&&O.URI.isUri(F.uri)&&I.$Us.isIRange(F.range)&&(I.$Us.isIRange(F.originSelectionRange)||I.$Us.isIRange(F.targetSelectionRange))}e.$Gt=c;var t;(function(F){F[F.File=0]="File",F[F.Module=1]="Module",F[F.Namespace=2]="Namespace",F[F.Package=3]="Package",F[F.Class=4]="Class",F[F.Method=5]="Method",F[F.Property=6]="Property",F[F.Field=7]="Field",F[F.Constructor=8]="Constructor",F[F.Enum=9]="Enum",F[F.Interface=10]="Interface",F[F.Function=11]="Function",F[F.Variable=12]="Variable",F[F.Constant=13]="Constant",F[F.String=14]="String",F[F.Number=15]="Number",F[F.Boolean=16]="Boolean",F[F.Array=17]="Array",F[F.Object=18]="Object",F[F.Key=19]="Key",F[F.Null=20]="Null",F[F.EnumMember=21]="EnumMember",F[F.Struct=22]="Struct",F[F.Event=23]="Event",F[F.Operator=24]="Operator",F[F.TypeParameter=25]="TypeParameter"})(t||(e.SymbolKind=t={})),e.$Ht={[17]:(0,b.localize)(0,null),[16]:(0,b.localize)(1,null),[4]:(0,b.localize)(2,null),[13]:(0,b.localize)(3,null),[8]:(0,b.localize)(4,null),[9]:(0,b.localize)(5,null),[21]:(0,b.localize)(6,null),[23]:(0,b.localize)(7,null),[7]:(0,b.localize)(8,null),[0]:(0,b.localize)(9,null),[11]:(0,b.localize)(10,null),[10]:(0,b.localize)(11,null),[19]:(0,b.localize)(12,null),[5]:(0,b.localize)(13,null),[1]:(0,b.localize)(14,null),[2]:(0,b.localize)(15,null),[20]:(0,b.localize)(16,null),[15]:(0,b.localize)(17,null),[18]:(0,b.localize)(18,null),[24]:(0,b.localize)(19,null),[3]:(0,b.localize)(20,null),[6]:(0,b.localize)(21,null),[14]:(0,b.localize)(22,null),[22]:(0,b.localize)(23,null),[25]:(0,b.localize)(24,null),[12]:(0,b.localize)(25,null)};function u(F,j){return(0,b.localize)(26,null,F,e.$Ht[j])}e.$It=u;var s;(function(F){F[F.Deprecated=1]="Deprecated"})(s||(e.SymbolTag=s={}));var l;(function(F){const j=new Map;j.set(0,D.$_j.symbolFile),j.set(1,D.$_j.symbolModule),j.set(2,D.$_j.symbolNamespace),j.set(3,D.$_j.symbolPackage),j.set(4,D.$_j.symbolClass),j.set(5,D.$_j.symbolMethod),j.set(6,D.$_j.symbolProperty),j.set(7,D.$_j.symbolField),j.set(8,D.$_j.symbolConstructor),j.set(9,D.$_j.symbolEnum),j.set(10,D.$_j.symbolInterface),j.set(11,D.$_j.symbolFunction),j.set(12,D.$_j.symbolVariable),j.set(13,D.$_j.symbolConstant),j.set(14,D.$_j.symbolString),j.set(15,D.$_j.symbolNumber),j.set(16,D.$_j.symbolBoolean),j.set(17,D.$_j.symbolArray),j.set(18,D.$_j.symbolObject),j.set(19,D.$_j.symbolKey),j.set(20,D.$_j.symbolNull),j.set(21,D.$_j.symbolEnumMember),j.set(22,D.$_j.symbolStruct),j.set(23,D.$_j.symbolEvent),j.set(24,D.$_j.symbolOperator),j.set(25,D.$_j.symbolTypeParameter);function T(M){let B=j.get(M);return B||(console.info("No codicon found for SymbolKind "+M),B=D.$_j.symbolProperty),B}F.toIcon=T})(l||(e.SymbolKinds=l={}));class a{static asEditOperation(j){return g.$Vs.replace(I.$Us.lift(j.range),j.text)}}e.$Jt=a;class d{static{this.Comment=new d("comment")}static{this.Imports=new d("imports")}static{this.Region=new d("region")}static fromValue(j){switch(j){case"comment":return d.Comment;case"imports":return d.Imports;case"region":return d.Region}return new d(j)}constructor(j){this.value=j}}e.$Kt=d;var k;(function(F){function j(T){return!T||typeof T!="object"?!1:typeof T.id=="string"&&typeof T.title=="string"}F.is=j})(k||(e.Command=k={}));var R;(function(F){F[F.Collapsed=0]="Collapsed",F[F.Expanded=1]="Expanded"})(R||(e.CommentThreadCollapsibleState=R={}));var v;(function(F){F[F.Unresolved=0]="Unresolved",F[F.Resolved=1]="Resolved"})(v||(e.CommentThreadState=v={}));var w;(function(F){F[F.Editing=0]="Editing",F[F.Preview=1]="Preview"})(w||(e.CommentMode=w={}));var E;(function(F){F[F.Published=0]="Published",F[F.Draft=1]="Draft"})(E||(e.CommentState=E={}));var P;(function(F){F[F.Type=1]="Type",F[F.Parameter=2]="Parameter"})(P||(e.InlayHintKind=P={}));class N{constructor(j){this.b=j,this.a=null}dispose(){this.a&&this.a.then(j=>{j&&j.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$Lt=N,e.$Mt=new A.$tt;var U;(function(F){F[F.None=0]="None",F[F.Option=1]="Option",F[F.Default=2]="Default",F[F.Preferred=3]="Preferred"})(U||(e.ExternalUriOpenerPriority=U={}))}),define(ke[196],Se([8,9]),function(me,e){return me.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ke[197],Se([8,9]),function(me,e){return me.create("vs/platform/contextkey/common/contextkey",e)}),define(ke[198],Se([8,9]),function(me,e){return me.create("vs/platform/contextkey/common/scanner",e)}),define(ke[199],Se([8,9]),function(me,e){return me.create("vs/platform/dialogs/common/dialogs",e)}),define(ke[200],Se([8,9]),function(me,e){return me.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ke[201],Se([8,9]),function(me,e){return me.create("vs/platform/extensions/common/extensionValidator",e)}),define(ke[202],Se([8,9]),function(me,e){return me.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ke[203],Se([8,9]),function(me,e){return me.create("vs/platform/files/common/files",e)}),define(ke[204],Se([8,9]),function(me,e){return me.create("vs/platform/files/common/io",e)}),define(ke[205],Se([8,9]),function(me,e){return me.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ke[206],Se([8,9]),function(me,e){return me.create("vs/platform/markers/common/markers",e)}),define(ke[207],Se([8,9]),function(me,e){return me.create("vs/platform/theme/common/iconRegistry",e)}),define(ke[208],Se([8,9]),function(me,e){return me.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ke[209],Se([8,9]),function(me,e){return me.create("vs/platform/workspace/common/workspace",e)}),define(ke[210],Se([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(ke[211],Se([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ke[212],Se([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ke[213],Se([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(ke[214],Se([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostLogService",e)}),define(ke[215],Se([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostNotebook",e)}),define(ke[216],Se([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ke[217],Se([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostTelemetry",e)}),define(ke[218],Se([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ke[219],Se([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ke[220],Se([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostTunnelService",e)}),define(ke[221],Se([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ke[222],Se([8,9]),function(me,e){return me.create("vs/workbench/api/node/extHostDebugService",e)}),define(ke[223],Se([8,9]),function(me,e){return me.create("vs/workbench/common/configuration",e)}),define(ke[224],Se([8,9]),function(me,e){return me.create("vs/workbench/common/editor",e)}),define(ke[225],Se([8,9]),function(me,e){return me.create("vs/workbench/common/views",e)}),define(ke[226],Se([8,9]),function(me,e){return me.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ke[227],Se([8,9]),function(me,e){return me.create("vs/workbench/contrib/debug/common/debug",e)}),define(ke[228],Se([8,9]),function(me,e){return me.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(ke[229],Se([8,9]),function(me,e){return me.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(ke[230],Se([8,9]),function(me,e){return me.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(ke[231],Se([8,9]),function(me,e){return me.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ke[232],Se([8,9]),function(me,e){return me.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(ke[233],Se([8,9]),function(me,e){return me.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(ke[234],Se([8,9]),function(me,e){return me.create("vs/workbench/services/remote/common/tunnelModel",e)}),define(ke[235],Se([8,9]),function(me,e){return me.create("vs/workbench/services/search/common/queryBuilder",e)}),define(ke[236],Se([1,0,14,198]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1i=e.TokenType=void 0;var g;(function(y){y[y.LParen=0]="LParen",y[y.RParen=1]="RParen",y[y.Neg=2]="Neg",y[y.Eq=3]="Eq",y[y.NotEq=4]="NotEq",y[y.Lt=5]="Lt",y[y.LtEq=6]="LtEq",y[y.Gt=7]="Gt",y[y.GtEq=8]="GtEq",y[y.RegexOp=9]="RegexOp",y[y.RegexStr=10]="RegexStr",y[y.True=11]="True",y[y.False=12]="False",y[y.In=13]="In",y[y.Not=14]="Not",y[y.And=15]="And",y[y.Or=16]="Or",y[y.Str=17]="Str",y[y.QuotedStr=18]="QuotedStr",y[y.Error=19]="Error",y[y.EOF=20]="EOF"})(g||(e.TokenType=g={}));function I(...y){switch(y.length){case 1:return(0,O.localize)(0,null,y[0]);case 2:return(0,O.localize)(1,null,y[0],y[1]);case 3:return(0,O.localize)(2,null,y[0],y[1],y[2]);default:return}}const A=(0,O.localize)(3,null),b=(0,O.localize)(4,null);class ${constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(L){switch(L.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return L.isTripleEq?"===":"==";case 4:return L.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return L.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return L.lexeme;case 18:return L.lexeme;case 19:return L.lexeme;case 20:return"EOF";default:throw(0,D.$8)(`unhandled token type: ${JSON.stringify(L)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(L=>L.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(L){return this.c=L,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const C=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:C})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const C=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:C})}else this.h(126)?this.k(9):this.l(I("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(I("&&"));break;case 124:this.h(124)?this.k(16):this.l(I("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(L){return this.r()||this.c.charCodeAt(this.e)!==L?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(L){this.f.push({type:L,offset:this.d})}l(L){const C=this.d,m=this.c.substring(this.d,this.e),p={type:19,offset:this.d,lexeme:m};this.g.push({offset:C,lexeme:m,additionalInfo:L}),this.f.push(p)}n(){this.m.lastIndex=this.d;const L=this.m.exec(this.c);if(L){this.e=this.d+L[0].length;const C=this.c.substring(this.d,this.e),m=$.b.get(C);m?this.k(m):this.f.push({type:17,lexeme:C,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let L=this.e,C=!1,m=!1;for(;;){if(L>=this.c.length){this.e=L,this.l(b);return}const S=this.c.charCodeAt(L);if(C)C=!1;else if(S===47&&!m){L++;break}else S===91?m=!0:S===92?C=!0:S===93&&(m=!1);L++}for(;L<this.c.length&&$.a.has(this.c.charCodeAt(L));)L++;this.e=L;const p=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:p,offset:this.d})}r(){return this.e>=this.c.length}}e.$1i=$}),define(ke[237],Se([1,0,23,39,201,385]),function(me,e,D,O,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gp=e.$fp=e.$ep=e.$dp=e.$cp=e.$bp=e.$ap=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,b=/^-(\d{4})(\d{2})(\d{2})$/;function $(o){return o=o.trim(),o==="*"||A.test(o)}e.$ap=$;function y(o){if(!$(o))return null;if(o=o.trim(),o==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const i=o.match(A);return i?{hasCaret:i[1]==="^",hasGreaterEquals:i[1]===">=",majorBase:i[2]==="x"?0:parseInt(i[2],10),majorMustEqual:i[2]!=="x",minorBase:i[4]==="x"?0:parseInt(i[4],10),minorMustEqual:i[4]!=="x",patchBase:i[6]==="x"?0:parseInt(i[6],10),patchMustEqual:i[6]!=="x",preRelease:i[8]||null}:null}e.$bp=y;function L(o){if(!o)return null;const i=o.majorBase,r=o.majorMustEqual,n=o.minorBase;let c=o.minorMustEqual;const t=o.patchBase;let u=o.patchMustEqual;o.hasCaret&&(i===0||(c=!1),u=!1);let s=0;if(o.preRelease){const l=b.exec(o.preRelease);if(l){const[,a,d,k]=l;s=Date.UTC(Number(a),Number(d)-1,Number(k))}}return{majorBase:i,majorMustEqual:r,minorBase:n,minorMustEqual:c,patchBase:t,patchMustEqual:u,isMinimum:o.hasGreaterEquals,notBefore:s}}e.$cp=L;function C(o,i,r){let n;typeof o=="string"?n=L(y(o)):n=o;let c;i instanceof Date?c=i.getTime():typeof i=="string"&&(c=new Date(i).getTime());let t;if(typeof r=="string"?t=L(y(r)):t=r,!n||!t)return!1;const u=n.majorBase,s=n.minorBase,l=n.patchBase;let a=t.majorBase,d=t.minorBase,k=t.patchBase;const R=t.notBefore;let v=t.majorMustEqual,w=t.minorMustEqual,E=t.patchMustEqual;return t.isMinimum?u>a?!0:u<a?!1:s>d?!0:s<d||c&&c<R?!1:l>=k:(u===1&&a===0&&(!v||!w||!E)&&(a=1,d=0,k=0,v=!0,w=!1,E=!1),u<a?!1:u>a?!v:s<d?!1:s>d?!w:l<k?!1:l>k?!E:!(c&&c<R))}e.$dp=C;function m(o,i,r,n,c){const t=[];if(typeof n.publisher<"u"&&typeof n.publisher!="string")return t.push([O.default.Error,g.localize(0,null)]),t;if(typeof n.name!="string")return t.push([O.default.Error,g.localize(1,null,"name")]),t;if(typeof n.version!="string")return t.push([O.default.Error,g.localize(2,null,"version")]),t;if(!n.engines)return t.push([O.default.Error,g.localize(3,null,"engines")]),t;if(typeof n.engines.vscode!="string")return t.push([O.default.Error,g.localize(4,null,"engines.vscode")]),t;if(typeof n.extensionDependencies<"u"&&!f(n.extensionDependencies))return t.push([O.default.Error,g.localize(5,null,"extensionDependencies")]),t;if(typeof n.activationEvents<"u"){if(!f(n.activationEvents))return t.push([O.default.Error,g.localize(6,null,"activationEvents")]),t;if(typeof n.main>"u"&&typeof n.browser>"u")return t.push([O.default.Error,g.localize(7,null,"activationEvents","main","browser")]),t}if(typeof n.extensionKind<"u"&&typeof n.main>"u"&&t.push([O.default.Warning,g.localize(8,null,"extensionKind")]),typeof n.main<"u"){if(typeof n.main!="string")return t.push([O.default.Error,g.localize(9,null,"main")]),t;{const l=(0,D.$Hg)(r,n.main);(0,D.$Bg)(l,r)||t.push([O.default.Warning,g.localize(10,null,l.path,r.path)])}}if(typeof n.browser<"u"){if(typeof n.browser!="string")return t.push([O.default.Error,g.localize(11,null,"browser")]),t;{const l=(0,D.$Hg)(r,n.browser);(0,D.$Bg)(l,r)||t.push([O.default.Warning,g.localize(12,null,l.path,r.path)])}}if(!I.valid(n.version))return t.push([O.default.Error,g.localize(13,null)]),t;const u=[];if(!p(o,i,n,c,u))for(const l of u)t.push([O.default.Error,l]);return t}e.$ep=m;function p(o,i,r,n,c){return n||typeof r.main>"u"&&typeof r.browser>"u"?!0:h(o,i,r.engines.vscode,c)}e.$fp=p;function S(o,i,r){return o==="*"||h(i,r,o)}e.$gp=S;function h(o,i,r,n=[]){const c=L(y(r));if(!c)return n.push(g.localize(14,null,r)),!1;if(c.majorBase===0){if(!c.majorMustEqual||!c.minorMustEqual)return n.push(g.localize(15,null,r)),!1}else if(!c.majorMustEqual)return n.push(g.localize(16,null,r)),!1;return C(o,i,c)?!0:(n.push(g.localize(17,null,o,r)),!1)}function f(o){if(!Array.isArray(o))return!1;for(let i=0,r=o.length;i<r;i++)if(typeof o[i]!="string")return!1;return!0}}),define(ke[105],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3h=void 0;class D{constructor(g,I=[],A=!1){this.ctor=g,this.staticArguments=I,this.supportsDelayedInstantiation=A}}e.$3h=D}),define(ke[106],Se([1,0,105]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zr=e.$Yr=e.InstantiationType=void 0;const O=[];var g;(function(b){b[b.Eager=0]="Eager",b[b.Delayed=1]="Delayed"})(g||(e.InstantiationType=g={}));function I(b,$,y){$ instanceof D.$3h||($=new D.$3h($,[],!!y)),O.push([b,$])}e.$Yr=I;function A(){return O}e.$Zr=A}),define(ke[238],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dq=e.$Cq=void 0;class D{constructor(I,A){this.key=I,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$Cq=D;class O{constructor(I){this.b=I,this.a=new Map}roots(){const I=[];for(const A of this.a.values())A.outgoing.size===0&&I.push(A);return I}insertEdge(I,A){const b=this.lookupOrInsertNode(I),$=this.lookupOrInsertNode(A);b.outgoing.set($.key,$),$.incoming.set(b.key,b)}removeNode(I){const A=this.b(I);this.a.delete(A);for(const b of this.a.values())b.outgoing.delete(A),b.incoming.delete(A)}lookupOrInsertNode(I){const A=this.b(I);let b=this.a.get(A);return b||(b=new D(A,I),this.a.set(A,b)),b}lookup(I){return this.a.get(this.b(I))}isEmpty(){return this.a.size===0}toString(){const I=[];for(const[A,b]of this.a)I.push(`${A}
	(-> incoming)[${[...b.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...b.outgoing.keys()].join(",")}]
`);return I.join(`
`)}findCycleSlow(){for(const[I,A]of this.a){const b=new Set([I]),$=this.c(A,b);if($)return $}}c(I,A){for(const[b,$]of I.outgoing){if(A.has(b))return[...A,b].join(" -> ");A.add(b);const y=this.c($,A);if(y)return y;A.delete(b)}}}e.$Dq=O}),define(ke[5],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7h=e.$6h=e.$5h=e._util=void 0;var D;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function b($){return $[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=b})(D||(e._util=D={})),e.$5h=g("instantiationService");function O(A,b,$){b[D.DI_TARGET]===b?b[D.DI_DEPENDENCIES].push({id:A,index:$}):(b[D.DI_DEPENDENCIES]=[{id:A,index:$}],b[D.DI_TARGET]=b)}function g(A){if(D.serviceIds.has(A))return D.serviceIds.get(A);const b=function($,y,L){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");O(b,$,L)};return b.toString=()=>A,D.serviceIds.set(A,b),b}e.$6h=g;function I(A){return A}e.$7h=I}),define(ke[51],Se([1,0,18,2,5]),function(me,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=e.ConfigurationTarget=e.$Bi=e.$Ai=e.$zi=void 0,e.$zi=(0,g.$6h)("configurationService");function I(o){return o&&typeof o=="object"&&(!o.overrideIdentifier||typeof o.overrideIdentifier=="string")&&(!o.resource||o.resource instanceof O.URI)}e.$Ai=I;function A(o){return o&&typeof o=="object"&&(!o.overrideIdentifiers||Array.isArray(o.overrideIdentifiers))&&!o.overrideIdentifier&&(!o.resource||o.resource instanceof O.URI)}e.$Bi=A;var b;(function(o){o[o.APPLICATION=1]="APPLICATION",o[o.USER=2]="USER",o[o.USER_LOCAL=3]="USER_LOCAL",o[o.USER_REMOTE=4]="USER_REMOTE",o[o.WORKSPACE=5]="WORKSPACE",o[o.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",o[o.DEFAULT=7]="DEFAULT",o[o.MEMORY=8]="MEMORY"})(b||(e.ConfigurationTarget=b={}));function $(o){switch(o){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$Ci=$;function y(o){return o.applicationValue!==void 0||o.userValue!==void 0||o.userLocalValue!==void 0||o.userRemoteValue!==void 0||o.workspaceValue!==void 0||o.workspaceFolderValue!==void 0}e.$Di=y;function L(o,i){const r=Object.create(null);for(const n in o)C(r,n,o[n],i);return r}e.$Ei=L;function C(o,i,r,n){const c=i.split("."),t=c.pop();let u=o;for(let s=0;s<c.length;s++){const l=c[s];let a=u[l];switch(typeof a){case"undefined":a=u[l]=Object.create(null);break;case"object":break;default:n(`Ignoring ${i} as ${c.slice(0,s+1).join(".")} is ${JSON.stringify(a)}`);return}u=a}if(typeof u=="object"&&u!==null)try{u[t]=r}catch{n(`Ignoring ${i} as ${c.join(".")} is ${JSON.stringify(u)}`)}else n(`Ignoring ${i} as ${c.join(".")} is ${JSON.stringify(u)}`)}e.$Fi=C;function m(o,i){const r=i.split(".");p(o,r)}e.$Gi=m;function p(o,i){const r=i.shift();if(i.length===0){delete o[r];return}if(Object.keys(o).indexOf(r)!==-1){const n=o[r];typeof n=="object"&&!Array.isArray(n)&&(p(n,i),Object.keys(n).length===0&&delete o[r])}}function S(o,i,r){function n(u,s){let l=u;for(const a of s){if(typeof l!="object"||l===null)return;l=l[a]}return l}const c=i.split("."),t=n(o,c);return typeof t>"u"?r:t}e.$Hi=S;function h(o,i,r){Object.keys(i).forEach(n=>{n!=="__proto__"&&(n in o?D.$Kf(o[n])&&D.$Kf(i[n])?h(o[n],i[n],r):r&&(o[n]=i[n]):o[n]=i[n])})}e.$Ii=h;function f(o){return o.replace(/[\[\]]/g,"")}e.$Ji=f}),define(ke[45],Se([1,0,10,12,236,5,197,14]),function(me,e,D,O,g,I,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.ContextKeyExprType=e.$2i=void 0;const $=new Map;$.set("false",!1),$.set("true",!0),$.set("isMac",D.$j),$.set("isLinux",D.$k),$.set("isWindows",D.$i),$.set("isWeb",D.$o),$.set("isMacNative",D.$j&&!D.$o),$.set("isEdge",D.$H),$.set("isFirefox",D.$F),$.set("isChrome",D.$E),$.set("isSafari",D.$G);function y(K,W){if($.get(K)!==void 0)throw(0,b.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");$.set(K,W)}e.$2i=y;const L=Object.prototype.hasOwnProperty;var C;(function(K){K[K.False=0]="False",K[K.True=1]="True",K[K.Defined=2]="Defined",K[K.Not=3]="Not",K[K.Equals=4]="Equals",K[K.NotEquals=5]="NotEquals",K[K.And=6]="And",K[K.Regex=7]="Regex",K[K.NotRegex=8]="NotRegex",K[K.Or=9]="Or",K[K.In=10]="In",K[K.NotIn=11]="NotIn",K[K.Greater=12]="Greater",K[K.GreaterEquals=13]="GreaterEquals",K[K.Smaller=14]="Smaller",K[K.SmallerEquals=15]="SmallerEquals"})(C||(e.ContextKeyExprType=C={}));const m={regexParsingWithErrorRecovery:!0},p=(0,A.localize)(0,null),S=(0,A.localize)(1,null),h=(0,A.localize)(2,null),f=(0,A.localize)(3,null),o=(0,A.localize)(4,null),i=(0,A.localize)(5,null),r=(0,A.localize)(6,null),n=(0,A.localize)(7,null);class c{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(W=m){this.k=W,this.d=new g.$1i,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(W){if(W===""){this.h.push({message:p,offset:0,lexeme:"",additionalInfo:S});return}this.f=this.d.reset(W).scan(),this.g=0,this.h=[];try{const re=this.l();if(!this.E()){const ye=this.D(),de=ye.type===17?i:void 0;throw this.h.push({message:o,offset:ye.offset,lexeme:g.$1i.getLexeme(ye),additionalInfo:de}),c.c}return re}catch(re){if(re!==c.c)throw re;return}}l(){return this.m()}m(){const W=[this.o()];for(;this.y(16);){const re=this.o();W.push(re)}return W.length===1?W[0]:t.or(...W)}o(){const W=[this.s()];for(;this.y(15);){const re=this.s();W.push(re)}return W.length===1?W[0]:t.and(...W)}s(){if(this.y(2)){const W=this.D();switch(W.type){case 11:return this.z(),a.INSTANCE;case 12:return this.z(),d.INSTANCE;case 0:{this.z();const re=this.l();return this.A(1,f),re?.negate()}case 17:return this.z(),P.create(W.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",W)}}return this.t()}t(){const W=this.D();switch(W.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const re=this.l();return this.A(1,f),re}case 17:{const re=W.lexeme;if(this.z(),this.y(9)){const de=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),de.type!==10)throw this.B("REGEX",de);const ge=de.lexeme,x=ge.lastIndexOf("/"),te=x===ge.length-1?void 0:this.w(ge.substring(x+1));let G;try{G=new RegExp(ge.substring(1,x),te)}catch{throw this.B("REGEX",de)}return M.create(re,G)}switch(de.type){case 10:case 19:{const ge=[de.lexeme];this.z();let x=this.D(),te=0;for(let Pe=0;Pe<de.lexeme.length;Pe++)de.lexeme.charCodeAt(Pe)===40?te++:de.lexeme.charCodeAt(Pe)===41&&te--;for(;!this.E()&&x.type!==15&&x.type!==16;){switch(x.type){case 0:te++;break;case 1:te--;break;case 10:case 18:for(let Pe=0;Pe<x.lexeme.length;Pe++)x.lexeme.charCodeAt(Pe)===40?te++:de.lexeme.charCodeAt(Pe)===41&&te--}if(te<0)break;ge.push(g.$1i.getLexeme(x)),this.z(),x=this.D()}const G=ge.join(""),ie=G.lastIndexOf("/"),fe=ie===G.length-1?void 0:this.w(G.substring(ie+1));let pe;try{pe=new RegExp(G.substring(1,ie),fe)}catch{throw this.B("REGEX",de)}return t.regex(re,pe)}case 18:{const ge=de.lexeme;this.z();let x=null;if(!(0,O.$Je)(ge)){const te=ge.indexOf("/"),G=ge.lastIndexOf("/");if(te!==G&&te>=0){const ie=ge.slice(te+1,G),fe=ge[G+1]==="i"?"i":"";try{x=new RegExp(ie,fe)}catch{throw this.B("REGEX",de)}}}if(x===null)throw this.B("REGEX",de);return M.create(re,x)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,h);const de=this.u();return t.notIn(re,de)}switch(this.D().type){case 3:{this.z();const de=this.u();if(this.x().type===18)return t.equals(re,de);switch(de){case"true":return t.has(re);case"false":return t.not(re);default:return t.equals(re,de)}}case 4:{this.z();const de=this.u();if(this.x().type===18)return t.notEquals(re,de);switch(de){case"true":return t.not(re);case"false":return t.has(re);default:return t.notEquals(re,de)}}case 5:return this.z(),j.create(re,this.u());case 6:return this.z(),T.create(re,this.u());case 7:return this.z(),U.create(re,this.u());case 8:return this.z(),F.create(re,this.u());case 13:return this.z(),t.in(re,this.u());default:return t.has(re)}}case 20:throw this.h.push({message:r,offset:W.offset,lexeme:"",additionalInfo:n}),c.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const W=this.D();switch(W.type){case 17:case 18:return this.z(),W.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(W){return W.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(W){return this.C(W)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(W,re){if(this.C(W))return this.z();throw this.B(re,this.D())}B(W,re,ye){const de=(0,A.localize)(8,null,W,g.$1i.getLexeme(re)),ge=re.offset,x=g.$1i.getLexeme(re);return this.h.push({message:de,offset:ge,lexeme:x,additionalInfo:ye}),c.c}C(W){return this.D().type===W}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$3i=c;class t{static false(){return a.INSTANCE}static true(){return d.INSTANCE}static has(W){return k.create(W)}static equals(W,re){return R.create(W,re)}static notEquals(W,re){return E.create(W,re)}static regex(W,re){return M.create(W,re)}static in(W,re){return v.create(W,re)}static notIn(W,re){return w.create(W,re)}static not(W){return P.create(W)}static and(...W){return ue.create(W,null,!0)}static or(...W){return Z.create(W,null,!0)}static greater(W,re){return U.create(W,re)}static greaterEquals(W,re){return F.create(W,re)}static smaller(W,re){return j.create(W,re)}static smallerEquals(W,re){return T.create(W,re)}static{this.c=new c({regexParsingWithErrorRecovery:!1})}static deserialize(W){return W==null?void 0:this.c.parse(W)}}e.$4i=t;function u(K){const W=new c({regexParsingWithErrorRecovery:!1});return K.map(re=>(W.parse(re),W.lexingErrors.length>0?W.lexingErrors.map(ye=>({errorMessage:ye.additionalInfo?(0,A.localize)(9,null,ye.additionalInfo):(0,A.localize)(10,null),offset:ye.offset,length:ye.lexeme.length})):W.parsingErrors.length>0?W.parsingErrors.map(ye=>({errorMessage:ye.additionalInfo?`${ye.message}. ${ye.additionalInfo}`:ye.message,offset:ye.offset,length:ye.lexeme.length})):[]))}e.$5i=u;function s(K,W){const re=K?K.substituteConstants():void 0,ye=W?W.substituteConstants():void 0;return!re&&!ye?!0:!re||!ye?!1:re.equals(ye)}e.$6i=s;function l(K,W){return K.cmp(W)}class a{static{this.INSTANCE=new a}constructor(){this.type=0}cmp(W){return this.type-W.type}equals(W){return W.type===this.type}substituteConstants(){return this}evaluate(W){return!1}serialize(){return"false"}keys(){return[]}map(W){return this}negate(){return d.INSTANCE}}e.$7i=a;class d{static{this.INSTANCE=new d}constructor(){this.type=1}cmp(W){return this.type-W.type}equals(W){return W.type===this.type}substituteConstants(){return this}evaluate(W){return!0}serialize(){return"true"}keys(){return[]}map(W){return this}negate(){return a.INSTANCE}}e.$8i=d;class k{static create(W,re=null){const ye=$.get(W);return typeof ye=="boolean"?ye?d.INSTANCE:a.INSTANCE:new k(W,re)}constructor(W,re){this.key=W,this.c=re,this.type=2}cmp(W){return W.type!==this.type?this.type-W.type:X(this.key,W.key)}equals(W){return W.type===this.type?this.key===W.key:!1}substituteConstants(){const W=$.get(this.key);return typeof W=="boolean"?W?d.INSTANCE:a.INSTANCE:this}evaluate(W){return!!W.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(W){return W.mapDefined(this.key)}negate(){return this.c||(this.c=P.create(this.key,this)),this.c}}e.$9i=k;class R{static create(W,re,ye=null){if(typeof re=="boolean")return re?k.create(W,ye):P.create(W,ye);const de=$.get(W);return typeof de=="boolean"?re===(de?"true":"false")?d.INSTANCE:a.INSTANCE:new R(W,re,ye)}constructor(W,re,ye){this.c=W,this.d=re,this.f=ye,this.type=4}cmp(W){return W.type!==this.type?this.type-W.type:he(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){const W=$.get(this.c);if(typeof W=="boolean"){const re=W?"true":"false";return this.d===re?d.INSTANCE:a.INSTANCE}return this}evaluate(W){return W.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(W){return W.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=E.create(this.c,this.d,this)),this.f}}e.$0i=R;class v{static create(W,re){return new v(W,re)}constructor(W,re){this.d=W,this.f=re,this.type=10,this.c=null}cmp(W){return W.type!==this.type?this.type-W.type:he(this.d,this.f,W.d,W.f)}equals(W){return W.type===this.type?this.d===W.d&&this.f===W.f:!1}substituteConstants(){return this}evaluate(W){const re=W.getValue(this.f),ye=W.getValue(this.d);return Array.isArray(re)?re.includes(ye):typeof ye=="string"&&typeof re=="object"&&re!==null?L.call(re,ye):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(W){return W.mapIn(this.d,this.f)}negate(){return this.c||(this.c=w.create(this.d,this.f)),this.c}}e.$$i=v;class w{static create(W,re){return new w(W,re)}constructor(W,re){this.d=W,this.f=re,this.type=11,this.c=v.create(W,re)}cmp(W){return W.type!==this.type?this.type-W.type:this.c.cmp(W.c)}equals(W){return W.type===this.type?this.c.equals(W.c):!1}substituteConstants(){return this}evaluate(W){return!this.c.evaluate(W)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(W){return W.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$_i=w;class E{static create(W,re,ye=null){if(typeof re=="boolean")return re?P.create(W,ye):k.create(W,ye);const de=$.get(W);return typeof de=="boolean"?re===(de?"true":"false")?a.INSTANCE:d.INSTANCE:new E(W,re,ye)}constructor(W,re,ye){this.c=W,this.d=re,this.f=ye,this.type=5}cmp(W){return W.type!==this.type?this.type-W.type:he(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){const W=$.get(this.c);if(typeof W=="boolean"){const re=W?"true":"false";return this.d===re?a.INSTANCE:d.INSTANCE}return this}evaluate(W){return W.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(W){return W.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=R.create(this.c,this.d,this)),this.f}}e.$aj=E;class P{static create(W,re=null){const ye=$.get(W);return typeof ye=="boolean"?ye?a.INSTANCE:d.INSTANCE:new P(W,re)}constructor(W,re){this.c=W,this.d=re,this.type=3}cmp(W){return W.type!==this.type?this.type-W.type:X(this.c,W.c)}equals(W){return W.type===this.type?this.c===W.c:!1}substituteConstants(){const W=$.get(this.c);return typeof W=="boolean"?W?a.INSTANCE:d.INSTANCE:this}evaluate(W){return!W.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(W){return W.mapNot(this.c)}negate(){return this.d||(this.d=k.create(this.c,this)),this.d}}e.$bj=P;function N(K,W){if(typeof K=="string"){const re=parseFloat(K);isNaN(re)||(K=re)}return typeof K=="string"||typeof K=="number"?W(K):a.INSTANCE}class U{static create(W,re,ye=null){return N(re,de=>new U(W,de,ye))}constructor(W,re,ye){this.c=W,this.d=re,this.f=ye,this.type=12}cmp(W){return W.type!==this.type?this.type-W.type:he(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(W){return W.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=T.create(this.c,this.d,this)),this.f}}e.$cj=U;class F{static create(W,re,ye=null){return N(re,de=>new F(W,de,ye))}constructor(W,re,ye){this.c=W,this.d=re,this.f=ye,this.type=13}cmp(W){return W.type!==this.type?this.type-W.type:he(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(W){return W.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$dj=F;class j{static create(W,re,ye=null){return N(re,de=>new j(W,de,ye))}constructor(W,re,ye){this.c=W,this.d=re,this.f=ye,this.type=14}cmp(W){return W.type!==this.type?this.type-W.type:he(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(W){return W.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$ej=j;class T{static create(W,re,ye=null){return N(re,de=>new T(W,de,ye))}constructor(W,re,ye){this.c=W,this.d=re,this.f=ye,this.type=15}cmp(W){return W.type!==this.type?this.type-W.type:he(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(W){return W.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$fj=T;class M{static create(W,re){return new M(W,re)}constructor(W,re){this.d=W,this.f=re,this.type=7,this.c=null}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.d<W.d)return-1;if(this.d>W.d)return 1;const re=this.f?this.f.source:"",ye=W.f?W.f.source:"";return re<ye?-1:re>ye?1:0}equals(W){if(W.type===this.type){const re=this.f?this.f.source:"",ye=W.f?W.f.source:"";return this.d===W.d&&re===ye}return!1}substituteConstants(){return this}evaluate(W){const re=W.getValue(this.d);return this.f?this.f.test(re):!1}serialize(){const W=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${W}`}keys(){return[this.d]}map(W){return W.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=B.create(this)),this.c}}e.$gj=M;class B{static create(W){return new B(W)}constructor(W){this.c=W,this.type=8}cmp(W){return W.type!==this.type?this.type-W.type:this.c.cmp(W.c)}equals(W){return W.type===this.type?this.c.equals(W.c):!1}substituteConstants(){return this}evaluate(W){return!this.c.evaluate(W)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(W){return new B(this.c.map(W))}negate(){return this.c}}e.$hj=B;function Y(K){let W=null;for(let re=0,ye=K.length;re<ye;re++){const de=K[re].substituteConstants();if(K[re]!==de&&W===null){W=[];for(let ge=0;ge<re;ge++)W[ge]=K[ge]}W!==null&&(W[re]=de)}return W===null?K:W}class ue{static create(W,re,ye){return ue.d(W,re,ye)}constructor(W,re){this.expr=W,this.c=re,this.type=6}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.expr.length<W.expr.length)return-1;if(this.expr.length>W.expr.length)return 1;for(let re=0,ye=this.expr.length;re<ye;re++){const de=l(this.expr[re],W.expr[re]);if(de!==0)return de}return 0}equals(W){if(W.type===this.type){if(this.expr.length!==W.expr.length)return!1;for(let re=0,ye=this.expr.length;re<ye;re++)if(!this.expr[re].equals(W.expr[re]))return!1;return!0}return!1}substituteConstants(){const W=Y(this.expr);return W===this.expr?this:ue.create(W,this.c,!1)}evaluate(W){for(let re=0,ye=this.expr.length;re<ye;re++)if(!this.expr[re].evaluate(W))return!1;return!0}static d(W,re,ye){const de=[];let ge=!1;for(const x of W)if(x){if(x.type===1){ge=!0;continue}if(x.type===0)return a.INSTANCE;if(x.type===6){de.push(...x.expr);continue}de.push(x)}if(de.length===0&&ge)return d.INSTANCE;if(de.length!==0){if(de.length===1)return de[0];de.sort(l);for(let x=1;x<de.length;x++)de[x-1].equals(de[x])&&(de.splice(x,1),x--);if(de.length===1)return de[0];for(;de.length>1;){const x=de[de.length-1];if(x.type!==9)break;de.pop();const te=de.pop(),G=de.length===0,ie=Z.create(x.expr.map(fe=>ue.create([fe,te],null,ye)),null,G);ie&&(de.push(ie),de.sort(l))}if(de.length===1)return de[0];if(ye){for(let x=0;x<de.length;x++)for(let te=x+1;te<de.length;te++)if(de[x].negate().equals(de[te]))return a.INSTANCE;if(de.length===1)return de[0]}return new ue(de,re)}}serialize(){return this.expr.map(W=>W.serialize()).join(" && ")}keys(){const W=[];for(const re of this.expr)W.push(...re.keys());return W}map(W){return new ue(this.expr.map(re=>re.map(W)),null)}negate(){if(!this.c){const W=[];for(const re of this.expr)W.push(re.negate());this.c=Z.create(W,this,!0)}return this.c}}e.$ij=ue;class Z{static create(W,re,ye){return Z.d(W,re,ye)}constructor(W,re){this.expr=W,this.c=re,this.type=9}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.expr.length<W.expr.length)return-1;if(this.expr.length>W.expr.length)return 1;for(let re=0,ye=this.expr.length;re<ye;re++){const de=l(this.expr[re],W.expr[re]);if(de!==0)return de}return 0}equals(W){if(W.type===this.type){if(this.expr.length!==W.expr.length)return!1;for(let re=0,ye=this.expr.length;re<ye;re++)if(!this.expr[re].equals(W.expr[re]))return!1;return!0}return!1}substituteConstants(){const W=Y(this.expr);return W===this.expr?this:Z.create(W,this.c,!1)}evaluate(W){for(let re=0,ye=this.expr.length;re<ye;re++)if(this.expr[re].evaluate(W))return!0;return!1}static d(W,re,ye){let de=[],ge=!1;if(W){for(let x=0,te=W.length;x<te;x++){const G=W[x];if(G){if(G.type===0){ge=!0;continue}if(G.type===1)return d.INSTANCE;if(G.type===9){de=de.concat(G.expr);continue}de.push(G)}}if(de.length===0&&ge)return a.INSTANCE;de.sort(l)}if(de.length!==0){if(de.length===1)return de[0];for(let x=1;x<de.length;x++)de[x-1].equals(de[x])&&(de.splice(x,1),x--);if(de.length===1)return de[0];if(ye){for(let x=0;x<de.length;x++)for(let te=x+1;te<de.length;te++)if(de[x].negate().equals(de[te]))return d.INSTANCE;if(de.length===1)return de[0]}return new Z(de,re)}}serialize(){return this.expr.map(W=>W.serialize()).join(" || ")}keys(){const W=[];for(const re of this.expr)W.push(...re.keys());return W}map(W){return new Z(this.expr.map(re=>re.map(W)),null)}negate(){if(!this.c){const W=[];for(const re of this.expr)W.push(re.negate());for(;W.length>1;){const re=W.shift(),ye=W.shift(),de=[];for(const ge of oe(re))for(const x of oe(ye))de.push(ue.create([ge,x],null,!1));W.unshift(Z.create(de,null,!1))}this.c=Z.create(W,this,!0)}return this.c}}e.$jj=Z;class J extends k{static{this.d=[]}static all(){return J.d.values()}constructor(W,re,ye){super(W,null),this.f=re,typeof ye=="object"?J.d.push({...ye,key:W}):ye!==!0&&J.d.push({key:W,description:ye,type:re!=null?typeof re:void 0})}bindTo(W){return W.createKey(this.key,this.f)}getValue(W){return W.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(W){return R.create(this.key,W)}notEqualsTo(W){return E.create(this.key,W)}}e.$kj=J,e.$lj=(0,I.$6h)("contextKeyService");function X(K,W){return K<W?-1:K>W?1:0}function he(K,W,re,ye){return K<re?-1:K>re?1:W<ye?-1:W>ye?1:0}function _(K,W){if(K.type===0||W.type===1)return!0;if(K.type===9)return W.type===9?we(K.expr,W.expr):!1;if(W.type===9){for(const re of W.expr)if(_(K,re))return!0;return!1}if(K.type===6){if(W.type===6)return we(W.expr,K.expr);for(const re of K.expr)if(_(re,W))return!0;return!1}return K.equals(W)}e.$mj=_;function we(K,W){let re=0,ye=0;for(;re<K.length&&ye<W.length;){const de=K[re].cmp(W[ye]);if(de<0)return!1;de===0&&re++,ye++}return re===K.length}function oe(K){return K.type===9?K.expr:[K]}}),define(ke[239],Se([1,0,23,39,199,5,102,10,24]),function(me,e,D,O,g,I,A,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0v=e.$9v=e.ConfirmResult=e.$8v=e.$7v=e.$6v=void 0,e.$6v=(0,I.$6h)("dialogService");var y;(function(h){h[h.Confirmation=1]="Confirmation",h[h.Prompt=2]="Prompt",h[h.Input=3]="Input"})(y||(y={}));class L{a(f){return this.d(f,y.Confirmation)}b(f){return this.d(f,y.Prompt)}c(f){return this.d(f,y.Input)}d(f,o){const i=[];switch(o){case y.Confirmation:{const r=f;r.primaryButton?i.push(r.primaryButton):i.push((0,g.localize)(0,null)),r.cancelButton?i.push(r.cancelButton):i.push((0,g.localize)(1,null));break}case y.Prompt:{const r=f;Array.isArray(r.buttons)&&r.buttons.length>0&&i.push(...r.buttons.map(n=>n.label)),r.cancelButton&&(r.cancelButton===!0?i.push((0,g.localize)(2,null)):typeof r.cancelButton=="string"?i.push(r.cancelButton):r.cancelButton.label?i.push(r.cancelButton.label):i.push((0,g.localize)(3,null))),i.length===0&&i.push((0,g.localize)(4,null));break}case y.Input:{const r=f;r.primaryButton?i.push(r.primaryButton):i.push((0,g.localize)(5,null)),r.cancelButton?i.push(r.cancelButton):i.push((0,g.localize)(6,null));break}}return i}e(f){if(typeof f=="string")return f;if(typeof f=="number")return f===O.default.Info?"info":f===O.default.Error?"error":f===O.default.Warning?"warning":"none"}f(f,o,i){const r=[...f.buttons??[]];f.cancelButton&&typeof f.cancelButton!="string"&&typeof f.cancelButton!="boolean"&&r.push(f.cancelButton);let n=r[o]?.run({checkboxChecked:i});return n instanceof Promise||(n=Promise.resolve(n)),{result:n,checkboxChecked:i}}}e.$7v=L,e.$8v=(0,I.$6h)("fileDialogService");var C;(function(h){h[h.SAVE=0]="SAVE",h[h.DONT_SAVE=1]="DONT_SAVE",h[h.CANCEL=2]="CANCEL"})(C||(e.ConfirmResult=C={}));const m=10;function p(h){const f=[];return f.push(...h.slice(0,m).map(o=>typeof o=="string"?o:(0,D.$Eg)(o))),h.length>m&&(h.length-m===1?f.push((0,g.localize)(7,null)):f.push((0,g.localize)(8,null,h.length-m))),f.push(""),f.join(`
`)}e.$9v=p;function S(h,f){const o=(0,$.$vn)(h);let i=(o.buttons??[]).map(t=>(0,A.$3v)(t)),r=(h.buttons||[]).map((t,u)=>u),n=0,c=o.cancelId??i.length-1;if(i.length>1){const t=typeof c=="number"?i[c]:void 0;if(b.$k||b.$j){if(typeof t=="string"&&i.length>1&&c!==1){i.splice(c,1),i.splice(1,0,t);const u=r[c];r.splice(c,1),r.splice(1,0,u),c=1}b.$k&&i.length>1&&(i=i.reverse(),r=r.reverse(),n=i.length-1,typeof t=="string"&&(c=n-1))}else if(b.$i&&typeof t=="string"&&i.length>1&&c!==i.length-1){i.splice(c,1),i.push(t);const u=r[c];r.splice(c,1),r.push(u),c=i.length-1}}return o.buttons=i,o.defaultId=n,o.cancelId=c,o.noLink=!0,o.title=o.title||f.nameLong,{options:o,buttonIndeces:r}}e.$0v=S}),define(ke[133],Se([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bi=e.$ai=void 0,e.$ai=(0,D.$6h)("environmentService"),e.$bi=(0,D.$7h)(e.$ai)}),define(ke[134],Se([1,0,200,5]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.ExtensionGalleryErrorCode=e.$zo=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$yo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=void 0,e.$mo="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$no=new RegExp(e.$mo),e.$oo="__web_extension",e.$po="skipWalkthrough",e.$qo="extensionsSync",e.$ro="dependecyOrPackExtensionInstall";function g(r){switch(r){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$so=g;function I(r){switch(r){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$to=I;function A(r,n){switch(r){case 3:return n==="x64"?"win32-x64":n==="arm64"?"win32-arm64":"unknown";case 2:return n==="x64"?"linux-x64":n==="arm64"?"linux-arm64":n==="arm"?"linux-armhf":"unknown";case"alpine":return n==="x64"?"alpine-x64":n==="arm64"?"alpine-arm64":"unknown";case 1:return n==="x64"?"darwin-x64":n==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$uo=A;function b(r,n){return n==="web"&&!r.includes("web")}e.$vo=b;function $(r,n,c){return b(n,c)?!1:r==="undefined"||r==="universal"?!0:r==="unknown"?!1:r===c}e.$wo=$;function y(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(!r.uuid||typeof r.uuid=="string")}e.$xo=y;var L;(function(r){r[r.NoneOrRelevance=0]="NoneOrRelevance",r[r.LastUpdatedDate=1]="LastUpdatedDate",r[r.Title=2]="Title",r[r.PublisherName=3]="PublisherName",r[r.InstallCount=4]="InstallCount",r[r.PublishedDate=10]="PublishedDate",r[r.AverageRating=6]="AverageRating",r[r.WeightedRating=12]="WeightedRating"})(L||(e.SortBy=L={}));var C;(function(r){r[r.Default=0]="Default",r[r.Ascending=1]="Ascending",r[r.Descending=2]="Descending"})(C||(e.SortOrder=C={}));var m;(function(r){r.Install="install",r.Uninstall="uninstall"})(m||(e.StatisticType=m={}));var p;(function(r){r[r.None=1]="None",r[r.Install=2]="Install",r[r.Update=3]="Update",r[r.Migrate=4]="Migrate"})(p||(e.InstallOperation=p={})),e.$yo=(0,O.$6h)("extensionGalleryService");var S;(function(r){r.Unsupported="Unsupported",r.Deprecated="Deprecated",r.Malicious="Malicious",r.Incompatible="Incompatible",r.IncompatibleTargetPlatform="IncompatibleTargetPlatform",r.ReleaseVersionNotFound="ReleaseVersionNotFound",r.Invalid="Invalid",r.Download="Download",r.DownloadSignature="DownloadSignature",r.UpdateMetadata="UpdateMetadata",r.Extract="Extract",r.Scanning="Scanning",r.Delete="Delete",r.Rename="Rename",r.CorruptZip="CorruptZip",r.IncompleteZip="IncompleteZip",r.Signature="Signature",r.NotAllowed="NotAllowed",r.Gallery="Gallery",r.Unknown="Unknown",r.Internal="Internal"})(S||(e.ExtensionManagementErrorCode=S={}));var h;(function(r){r.UnknownError="UnknownError",r.PackageIsInvalidZip="PackageIsInvalidZip",r.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(h||(e.ExtensionSignaturetErrorCode=h={}));class f extends Error{constructor(n,c){super(n),this.code=c,this.name=c}}e.$zo=f;var o;(function(r){r.Timeout="Timeout",r.Cancelled="Cancelled",r.Failed="Failed"})(o||(e.ExtensionGalleryErrorCode=o={}));class i extends Error{constructor(n,c){super(n),this.code=c,this.name=c}}e.$Ao=i,e.$Bo=(0,O.$6h)("extensionManagementService"),e.$Co="extensionsIdentifiers/disabled",e.$Do="extensionsIdentifiers/enabled",e.$Eo=(0,O.$6h)("IGlobalExtensionEnablementService"),e.$Fo=(0,O.$6h)("IExtensionTipsService"),e.$Go=(0,D.localize)(0,null),e.$Ho={value:e.$Go,original:"Extensions"},e.$Io=(0,D.localize2)(1,"Preferences")}),define(ke[240],Se([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$42b=e.$32b=void 0,e.$32b=(0,D.$6h)("externalTerminal"),e.$42b="Terminal.app"}),define(ke[241],Se([1,0,50,52,17,16,10,101,31,104,202,240]),function(me,e,D,O,g,I,A,b,$,y,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$30b=e.$20b=e.$10b=void 0;const m=L.localize(0,null);class p{async getDefaultTerminalForPlatforms(){return{windows:S.getDefaultTerminalWindows(),linux:await f.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class S extends p{static{this.b="cmd.exe"}openTerminal(c,t){return this.spawnTerminal(D,c,y.$Tl(),t)}spawnTerminal(c,t,u,s){const l=t.windowsExec||S.getDefaultTerminalWindows();s&&s[1]===":"&&(s=s[0].toUpperCase()+s.substr(1));const a=I.$nc(l,".exe").toLowerCase();if(a==="cmder")return c.spawn(l,s?[s]:void 0),Promise.resolve(void 0);const d=["/c","start","/wait"];return l.indexOf(" ")>=0&&d.push('""'),d.push(l),a==="wt"&&d.push("-d ."),new Promise((k,R)=>{const v=o(process),w=c.spawn(u,d,{cwd:s,env:v,detached:!0});w.on("error",R),w.on("exit",()=>k())})}async runInTerminal(c,t,u,s,l){const a="windowsExec"in l&&l.windowsExec?l.windowsExec:S.getDefaultTerminalWindows(),d=await S.f();return new Promise((k,R)=>{const v=`"${t} - ${m}"`,w=`""${u.join('" "')}" & pause"`,E=Object.assign({},o(process),s);Object.keys(E).filter(j=>E[j]===null).forEach(j=>delete E[j]);const P={cwd:t,env:E,windowsVerbatimArguments:!0};let N,U;I.$nc(a,".exe")==="wt"?(N=a,U=["-d",".",S.b,"/c",w]):d?(N=d,U=["-d",t,a,"/c",w]):(N=S.b,U=["/c","start",v,"/wait",a,"/c",w]),D.spawn(N,U,P).on("error",j=>{R(i(j))}),k(void 0)})}static getDefaultTerminalWindows(){if(!S.d){const c=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");S.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${c?"Sysnative":"System32"}\\cmd.exe`}return S.d}static async f(){try{const c=await y.win32.findExecutable("wt");return await $.Promises.exists(c)?c:void 0}catch{return}}}e.$10b=S,Ge([O.$xh],S,"f",null);class h extends p{static{this.b="/usr/bin/osascript"}openTerminal(c,t){return this.spawnTerminal(D,c,t)}runInTerminal(c,t,u,s,l){const a=l.osxExec||C.$42b;return new Promise((d,k)=>{if(a===C.$42b||a==="iTerm.app"){const R=a===C.$42b?"TerminalHelper":"iTermHelper",w=[g.$og.asFileUri(`vs/workbench/contrib/externalTerminal/node/${R}.scpt`).fsPath,"-t",c||m,"-w",t];for(const N of u)w.push("-a"),w.push(N);if(s){const N=Object.assign({},o(process),s);for(const U in N){const F=N[U];F===null?(w.push("-u"),w.push(U)):(w.push("-e"),w.push(`${U}=${F}`))}}let E="";const P=D.spawn(h.b,w);P.on("error",N=>{k(i(N))}),P.stderr.on("data",N=>{E+=N.toString()}),P.on("exit",N=>{if(N===0)d(void 0);else if(E){const U=E.split(`
`,1);k(new Error(U[0]))}else k(new Error(L.localize(1,null,R,N)))})}else k(new Error(L.localize(2,null,a)))})}spawnTerminal(c,t,u){const s=t.osxExec||C.$42b;return new Promise((l,a)=>{const d=["-a",s];u&&d.push(u);const k=o(process),R=c.spawn("/usr/bin/open",d,{cwd:u,env:k});R.on("error",a),R.on("exit",()=>l())})}}e.$20b=h;class f extends p{static{this.b=L.localize(3,null)}openTerminal(c,t){return this.spawnTerminal(D,c,t)}runInTerminal(c,t,u,s,l){const a=l.linuxExec?Promise.resolve(l.linuxExec):f.getDefaultTerminalLinuxReady();return new Promise((d,k)=>{const R=[];a.then(v=>{v.indexOf("gnome-terminal")>=0?R.push("-x"):R.push("-e"),R.push("bash"),R.push("-c");const w=`${r(u)}; echo; read -p "${f.b}" -n1;`;R.push(`''${w}''`);const E=Object.assign({},o(process),s);Object.keys(E).filter(F=>E[F]===null).forEach(F=>delete E[F]);const P={cwd:t,env:E};let N="";const U=D.spawn(v,R,P);U.on("error",F=>{k(i(F))}),U.stderr.on("data",F=>{N+=F.toString()}),U.on("exit",F=>{if(F===0)d(void 0);else if(N){const j=N.split(`
`,1);k(new Error(j[0]))}else k(new Error(L.localize(4,null,v,F)))})})})}static async getDefaultTerminalLinuxReady(){if(!f.d)if(!A.$k)f.d=Promise.resolve("xterm");else{const c=await $.Promises.exists("/etc/debian_version");f.d=new Promise(t=>{c?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm")})}return f.d}spawnTerminal(c,t,u){const s=t.linuxExec?Promise.resolve(t.linuxExec):f.getDefaultTerminalLinuxReady();return new Promise((l,a)=>{s.then(d=>{const k=o(process),R=c.spawn(d,[],{cwd:u,env:k});R.on("error",a),R.on("exit",()=>l())})})}}e.$30b=f;function o(n){const c={...n.env};return(0,b.$Rl)(c),c}function i(n){return"errno"in n&&n.errno==="ENOENT"&&"path"in n&&typeof n.path=="string"?new Error(L.localize(5,null,n.path)):n}function r(n){let c="";for(const t of n)t.indexOf(" ")>=0?c+='"'+t+'"':c+=t,c+=" ";return c}}),define(ke[32],Se([1,0,77,16,12,18,2,203,5,10,17,43]),function(me,e,D,O,g,I,A,b,$,y,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zk=e.$Yk=e.$Xk=e.$Wk=e.$Vk=e.FileKind=e.$Uk=e.$Tk=e.$Sk=e.$Rk=e.$Qk=e.$Pk=e.$Ok=e.FileOperationResult=e.$Nk=e.$Mk=e.$Lk=e.$Kk=e.$Jk=e.FileChangeType=e.$Ik=e.FileOperation=e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.$Dk=e.$Ck=e.FileSystemProviderErrorCode=e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=e.$wk=e.$vk=e.$uk=e.$tk=e.FileSystemProviderCapabilities=e.$sk=e.FilePermission=e.FileType=e.$rk=e.$qk=void 0,e.$qk=(0,$.$6h)("fileService");function m(_){return _.create===!0}e.$rk=m;var p;(function(_){_[_.Unknown=0]="Unknown",_[_.File=1]="File",_[_.Directory=2]="Directory",_[_.SymbolicLink=64]="SymbolicLink"})(p||(e.FileType=p={}));var S;(function(_){_[_.Readonly=1]="Readonly",_[_.Locked=2]="Locked"})(S||(e.FilePermission=S={}));function h(_){const we=_;return!!we&&typeof we.onDidChange=="function"}e.$sk=h;var f;(function(_){_[_.None=0]="None",_[_.FileReadWrite=2]="FileReadWrite",_[_.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",_[_.FileReadStream=16]="FileReadStream",_[_.FileFolderCopy=8]="FileFolderCopy",_[_.PathCaseSensitive=1024]="PathCaseSensitive",_[_.Readonly=2048]="Readonly",_[_.Trash=4096]="Trash",_[_.FileWriteUnlock=8192]="FileWriteUnlock",_[_.FileAtomicRead=16384]="FileAtomicRead",_[_.FileAtomicWrite=32768]="FileAtomicWrite",_[_.FileAtomicDelete=65536]="FileAtomicDelete",_[_.FileClone=131072]="FileClone"})(f||(e.FileSystemProviderCapabilities=f={}));function o(_){return!!(_.capabilities&2)}e.$tk=o;function i(_){return!!(_.capabilities&8)}e.$uk=i;function r(_){return!!(_.capabilities&131072)}e.$vk=r;function n(_){return!!(_.capabilities&4)}e.$wk=n;function c(_){return!!(_.capabilities&16)}e.$xk=c;function t(_){return o(_)?!!(_.capabilities&16384):!1}e.$yk=t;function u(_){return o(_)?!!(_.capabilities&32768):!1}e.$zk=u;function s(_){return!!(_.capabilities&65536)}e.$Ak=s;function l(_){return!!(_.capabilities&2048)}e.$Bk=l;var a;(function(_){_.FileExists="EntryExists",_.FileNotFound="EntryNotFound",_.FileNotADirectory="EntryNotADirectory",_.FileIsADirectory="EntryIsADirectory",_.FileExceedsStorageQuota="EntryExceedsStorageQuota",_.FileTooLarge="EntryTooLarge",_.FileWriteLocked="EntryWriteLocked",_.NoPermissions="NoPermissions",_.Unavailable="Unavailable",_.Unknown="Unknown"})(a||(e.FileSystemProviderErrorCode=a={}));class d extends Error{static create(we,oe){const K=new d(we.toString(),oe);return v(K,oe),K}constructor(we,oe){super(we),this.code=oe}}e.$Ck=d;function k(_,we){return d.create(_,we)}e.$Dk=k;function R(_){return _||k((0,b.localize)(0,null),a.Unknown)}e.$Ek=R;function v(_,we){return _.name=we?`${we} (FileSystemError)`:"FileSystemError",_}e.$Fk=v;function w(_){if(!_)return a.Unknown;if(_ instanceof d)return _.code;const we=/^(.+) \(FileSystemError\)$/.exec(_.name);if(!we)return a.Unknown;switch(we[1]){case a.FileExists:return a.FileExists;case a.FileIsADirectory:return a.FileIsADirectory;case a.FileNotADirectory:return a.FileNotADirectory;case a.FileNotFound:return a.FileNotFound;case a.FileTooLarge:return a.FileTooLarge;case a.FileWriteLocked:return a.FileWriteLocked;case a.NoPermissions:return a.NoPermissions;case a.Unavailable:return a.Unavailable}return a.Unknown}e.$Gk=w;function E(_){if(_ instanceof T)return _.fileOperationResult;switch(w(_)){case a.FileNotFound:return 1;case a.FileIsADirectory:return 0;case a.FileNotADirectory:return 9;case a.FileWriteLocked:return 5;case a.NoPermissions:return 6;case a.FileExists:return 4;case a.FileTooLarge:return 7;default:return 10}}e.$Hk=E;var P;(function(_){_[_.CREATE=0]="CREATE",_[_.DELETE=1]="DELETE",_[_.MOVE=2]="MOVE",_[_.COPY=3]="COPY",_[_.WRITE=4]="WRITE"})(P||(e.FileOperation=P={}));class N{constructor(we,oe,K){this.resource=we,this.operation=oe,this.target=K}isOperation(we){return this.operation===we}}e.$Ik=N;var U;(function(_){_[_.UPDATED=0]="UPDATED",_[_.ADDED=1]="ADDED",_[_.DELETED=2]="DELETED"})(U||(e.FileChangeType=U={}));class F{static{this.a=null}constructor(we,oe){this.c=oe,this.b=void 0,this.d=new C.$V(()=>{const K=D.$_h.forUris(()=>this.c);return K.fill(this.rawAdded.map(W=>[W,!0])),K}),this.f=new C.$V(()=>{const K=D.$_h.forUris(()=>this.c);return K.fill(this.rawUpdated.map(W=>[W,!0])),K}),this.g=new C.$V(()=>{const K=D.$_h.forUris(()=>this.c);return K.fill(this.rawDeleted.map(W=>[W,!0])),K}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const K of we){switch(K.type){case 1:this.rawAdded.push(K.resource);break;case 0:this.rawUpdated.push(K.resource);break;case 2:this.rawDeleted.push(K.resource);break}this.b!==F.a&&(typeof K.cId=="number"?this.b===void 0?this.b=K.cId:this.b!==K.cId&&(this.b=F.a):this.b!==void 0&&(this.b=F.a))}}contains(we,...oe){return this.h(we,{includeChildren:!1},...oe)}affects(we,...oe){return this.h(we,{includeChildren:!0},...oe)}h(we,oe,...K){if(!we)return!1;const W=K.length>0;return!!((!W||K.includes(1))&&(this.d.value.get(we)||oe.includeChildren&&this.d.value.findSuperstr(we))||(!W||K.includes(0))&&(this.f.value.get(we)||oe.includeChildren&&this.f.value.findSuperstr(we))||(!W||K.includes(2))&&(this.g.value.findSubstr(we)||oe.includeChildren&&this.g.value.findSuperstr(we)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(we){return this.b===we}hasCorrelation(){return typeof this.b=="number"}}e.$Jk=F;function j(_,we,oe){return!_||!we||_===we||we.length>_.length?!1:(we.charAt(we.length-1)!==O.sep&&(we+=O.sep),oe?(0,g.$af)(_,we):_.indexOf(we)===0)}e.$Kk=j;class T extends Error{constructor(we,oe,K){super(we),this.fileOperationResult=oe,this.options=K}}e.$Lk=T;class M extends T{constructor(we,oe,K,W){super(we,oe,W),this.fileOperationResult=oe,this.size=K}}e.$Mk=M;class B extends T{constructor(we,oe,K){super(we,2,K),this.stat=oe}}e.$Nk=B;var Y;(function(_){_[_.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",_[_.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",_[_.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",_[_.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",_[_.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",_[_.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",_[_.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",_[_.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",_[_.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",_[_.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",_[_.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Y||(e.FileOperationResult=Y={})),e.$Ok={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Pk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Qk="files.associations",e.$Rk="files.exclude",e.$Sk="files.readonlyInclude",e.$Tk="files.readonlyExclude",e.$Uk="files.readonlyFromPermissions";var ue;(function(_){_[_.FILE=0]="FILE",_[_.FOLDER=1]="FOLDER",_[_.ROOT_FOLDER=2]="ROOT_FOLDER"})(ue||(e.FileKind=ue={})),e.$Vk="";function Z(_){if(!(typeof _.size!="number"||typeof _.mtime!="number"))return _.mtime.toString(29)+_.size.toString(31)}e.$Wk=Z;async function J(_,we){if(!we.hasProvider(A.URI.from({scheme:_.scheme})))return new Promise(oe=>{const K=we.onDidChangeFileSystemProviderRegistrations(W=>{W.scheme===_.scheme&&W.added&&(K.dispose(),oe())})})}e.$Xk=J;class X{static{this.KB=1024}static{this.MB=X.KB*X.KB}static{this.GB=X.MB*X.KB}static{this.TB=X.GB*X.KB}static formatSize(we){return(0,I.$Mf)(we)||(we=0),we<X.KB?(0,b.localize)(1,null,we.toFixed(0)):we<X.MB?(0,b.localize)(2,null,(we/X.KB).toFixed(2)):we<X.GB?(0,b.localize)(3,null,(we/X.MB).toFixed(2)):we<X.TB?(0,b.localize)(4,null,(we/X.GB).toFixed(2)):(0,b.localize)(5,null,(we/X.TB).toFixed(2))}}e.$Yk=X;function he(_){const we=typeof _=="string"||_?.scheme===L.Schemas.vscodeRemote;return typeof _!="string"&&_?.scheme===L.Schemas.file?1024*X.MB:we?10*X.MB:y.$o?50*X.MB:1024*X.MB}e.$Zk=he}),define(ke[242],Se([1,0,22,14,204,32]),function(me,e,D,O,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bq=void 0;async function A(L,C,m,p,S,h){let f;try{await b(L,C,m,p,S,h)}catch(o){f=o}finally{f&&S.errorTransformer&&(f=S.errorTransformer(f)),typeof f<"u"&&m.error(f),m.end()}}e.$bq=A;async function b(L,C,m,p,S,h){$(h);const f=await L.open(C,{create:!1});try{$(h);let o=0,i=0,r=S&&typeof S.length=="number"?S.length:void 0,n=D.$je.alloc(Math.min(S.bufferSize,typeof r=="number"?r:S.bufferSize)),c=S&&typeof S.position=="number"?S.position:0,t=0;do i=await L.read(f,c,n.buffer,t,n.byteLength-t),c+=i,t+=i,o+=i,typeof r=="number"&&(r-=i),t===n.byteLength&&(await m.write(p(n)),n=D.$je.alloc(Math.min(S.bufferSize,typeof r=="number"?r:S.bufferSize)),t=0);while(i>0&&(typeof r!="number"||r>0)&&$(h)&&y(o,S));if(t>0){let u=t;typeof r=="number"&&(u=Math.min(t,r)),m.write(p(n.slice(0,u)))}}catch(o){throw(0,I.$Ek)(o)}finally{await L.close(f)}}function $(L){if(L.isCancellationRequested)throw(0,O.$6)();return!0}function y(L,C){if(typeof C?.limits?.size=="number"&&L>C.limits.size)throw(0,I.$Dk)((0,g.localize)(0,null),I.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ke[84],Se([1,0,34,3,16,10,2,32]),function(me,e,D,O,g,I,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kq=e.$jq=e.$iq=e.$hq=e.$gq=e.$fq=e.$eq=e.$dq=void 0;function $(o){return o.recursive===!0}e.$dq=$;class y extends O.$Tc{static{this.a=5}constructor(i,r,n,c){super(),this.h=i,this.j=r,this.m=n,this.n=c,this.c=this.B(new O.$Uc),this.f=void 0,this.g=0}s(){const i=new O.$Sc;this.c.value=i,this.b=this.r(i),this.b.setVerboseLogging(this.m),i.add(this.b.onDidChangeFile(r=>this.h(r))),i.add(this.b.onDidLogMessage(r=>this.j(r))),i.add(this.b.onDidError(r=>this.t(r)))}t(i){this.n.restartOnError?this.g<y.a&&this.f?(this.w(`restarting watcher after error: ${i}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${i}`):this.w(i)}u(i){this.g++,this.s(),this.watch(i)}async watch(i){this.f=i,await this.b?.watch(i)}async setVerboseLogging(i){this.m=i,await this.b?.setVerboseLogging(i)}w(i){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${i}`})}y(i){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${i}`})}dispose(){return this.b=void 0,super.dispose()}}e.$eq=y;class L extends y{constructor(i,r,n){super(i,r,n,{type:"node.js",restartOnError:!1})}}e.$fq=L;class C extends y{constructor(i,r,n){super(i,r,n,{type:"universal",restartOnError:!0})}}e.$gq=C;function m(o){return o.map(i=>({type:i.type,resource:A.URI.revive(i.resource),cId:i.cId}))}e.$hq=m;function p(o){const i=new f;for(const r of o)i.processEvent(r);return i.coalesce()}e.$iq=p;function S(o,i){return typeof i=="string"&&!i.startsWith(D.$Ij)&&!(0,g.$ic)(i)?{base:o,pattern:i}:i}e.$jq=S;function h(o,i){const r=[];for(const n of i)r.push((0,D.$Mj)(S(o,n)));return r}e.$kq=h;class f{constructor(){this.a=new Set,this.b=new Map}c(i){return I.$k?i.resource.fsPath:i.resource.fsPath.toLowerCase()}processEvent(i){const r=this.b.get(this.c(i));let n=!1;if(r){const c=r.type,t=i.type;r.resource.fsPath!==i.resource.fsPath&&(i.type===2||i.type===1)?n=!0:c===1&&t===2?(this.b.delete(this.c(i)),this.a.delete(r)):c===2&&t===1?r.type=0:c===1&&t===0||(r.type=t)}else n=!0;n&&(this.a.add(i),this.b.set(this.c(i),i))}coalesce(){const i=[],r=[];return Array.from(this.a).filter(n=>n.type!==2?(i.push(n),!1):!0).sort((n,c)=>n.resource.fsPath.length-c.resource.fsPath.length).filter(n=>r.some(c=>(0,b.$Kk)(n.resource.fsPath,c,!I.$k))?!1:(r.push(n.resource.fsPath),!0)).concat(i)}}}),define(ke[243],Se([1,0,56,11,21,33,3,76,16,10,23,2,103,31,84]),function(me,e,D,O,g,I,A,b,$,y,L,C,m,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yq=e.$xq=void 0;class h extends A.$Tc{static{this.a=100}static{this.b=75}constructor(i,r,n,c){super(),this.m=i,this.n=r,this.r=n,this.s=c,this.c=this.B(new O.$ih({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},t=>this.n(t))),this.f=this.B(new O.$hh(t=>this.z(t),h.b)),this.g=(0,S.$kq)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,S.$kq)(this.m.path,this.m.includes):void 0,this.j=new g.$6d,this.ready=this.t()}async t(){try{const i=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const r=await p.Promises.stat(i);this.B(await this.w(i,r.isDirectory()))}catch(i){i.code!=="ENOENT"?this.D(i):this.G(i)}}async u(i){let r=i.path;try{r=await p.Promises.realpath(i.path),i.path===r&&(r=await(0,m.$uq)(i.path)??i.path),i.path!==r&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${i.path}, real: ${r})`)}catch{}return r}async w(i,r){if(y.$j&&(0,I.$8f)(i,"/Volumes/",!0))return this.D(`Refusing to watch ${i} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),A.$Tc.None;const n=new g.$6d(this.j.token),c=new A.$Sc;try{const t=C.URI.file(this.m.path),u=(0,$.$nc)(i),s=(0,D.watch)(i);c.add((0,A.$Rc)(()=>{s.removeAllListeners(),s.close()})),this.G(`Started watching: '${i}'`);const l=new Set;if(r)try{for(const d of await p.Promises.readdir(i))l.add(d)}catch(d){this.D(d)}const a=new Map;c.add((0,A.$Rc)(()=>{for(const[,d]of a)d.dispose();a.clear()})),s.on("error",(d,k)=>{this.D(`Failed to watch ${i} for changes using fs.watch() (${d}, ${k})`),this.dispose()}),s.on("change",(d,k)=>{if(n.token.isCancellationRequested)return;this.G(`[raw] ["${d}"] ${k}`);let R="";if(k&&(R=k.toString(),y.$j&&(R=(0,b.$Gl)(R))),!(!R||d!=="change"&&d!=="rename"))if(r)if(d==="rename"){a.get(R)?.dispose();const v=setTimeout(async()=>{if(a.delete(R),R===u&&!await p.Promises.exists(i)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const w=await this.C((0,$.$jc)(i,R));if(n.token.isCancellationRequested)return;let E;w?l.has(R)?E=0:(E=1,l.add(R)):(l.delete(R),E=2),this.y({resource:(0,L.$Hg)(t,R),type:E,cId:this.m.correlationId})},h.a);a.set(R,(0,A.$Rc)(()=>clearTimeout(v)))}else{let v;l.has(R)?v=0:(v=1,l.add(R)),this.y({resource:(0,L.$Hg)(t,R),type:v,cId:this.m.correlationId})}else if(d==="rename"||R!==u){const v=setTimeout(async()=>{const w=await p.Promises.exists(i);n.token.isCancellationRequested||(w?(this.y({resource:t,type:0,cId:this.m.correlationId},!0),c.add(await this.w(i,!1))):(this.y({resource:t,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.dispose()))},h.a);c.clear(),c.add((0,A.$Rc)(()=>clearTimeout(v)))}else this.y({resource:t,type:0,cId:this.m.correlationId},!0)})}catch(t){await p.Promises.exists(i)&&!n.token.isCancellationRequested&&this.D(`Failed to watch ${i} for changes using fs.watch() (${t.toString()})`)}return(0,A.$Rc)(()=>{n.dispose(!0),c.dispose()})}y(i,r=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${i.type===1?"[ADDED]":i.type===2?"[DELETED]":"[CHANGED]"} ${i.resource.fsPath}`),!r&&this.g.some(n=>n(i.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${i.resource.fsPath}`):!r&&this.h&&this.h.length>0&&!this.h.some(n=>n(i.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${i.resource.fsPath}`):this.f.work(i))}z(i){const r=(0,S.$iq)(i);if(r.length>0){if(this.s)for(const c of r)this.G(` >> normalized ${c.type===1?"[ADDED]":c.type===2?"[DELETED]":"[CHANGED]"} ${c.resource.fsPath}`);this.c.work(r)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${r[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${r.length}, most recent change: ${r[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(i){if(y.$k)return p.Promises.exists(i);try{const r=(0,$.$nc)(i);return(await p.Promises.readdir((0,$.$mc)(i))).some(c=>c===r)}catch(r){return this.G(r),!1}}setVerboseLogging(i){this.s=i}D(i){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${i}`})}F(i){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${i}`})}G(i){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${i}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$xq=h;async function f(o,i,r,n,c=512){const t=await p.Promises.open(o,"r"),u=Buffer.allocUnsafe(c),s=new g.$6d(n);let l,a=!1;const d={path:o,excludes:[],recursive:!1},k=new h(d,R=>{(async()=>{for(const{type:v}of R)if(v===0){if(a)return;a=!0;try{for(;!s.token.isCancellationRequested;){const{bytesRead:w}=await p.Promises.read(t,u,0,c,null);if(!w||s.token.isCancellationRequested)break;i(u.slice(0,w))}}catch(w){l=new Error(w),s.dispose(!0)}finally{a=!1}}})()});return await k.ready,r(),new Promise((R,v)=>{s.token.onCancellationRequested(async()=>{k.dispose();try{await p.Promises.close(t)}catch(w){l=new Error(w)}l?v(l):R()})})}e.$yq=f}),define(ke[244],Se([1,0,4,34,3,10,243]),function(me,e,D,O,g,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zq=void 0;class b extends g.$Tc{constructor(){super(...arguments),this.a=this.B(new D.$Vd),this.onDidChangeFile=this.a.event,this.b=this.B(new D.$Vd),this.onDidLogMessage=this.b.event,this.onDidError=D.Event.None,this.c=new Map,this.f=!1}async watch(y){const L=this.j(y),C=L.filter(p=>{const S=this.c.get(p.path);return S?!(0,O.$Qj)(S.request.excludes,p.excludes)||!(0,O.$Qj)(S.request.includes,p.includes):!0}),m=Array.from(this.c.values()).filter(({request:p})=>!L.find(S=>S.path===p.path&&(0,O.$Qj)(S.excludes,p.excludes)&&(0,O.$Qj)(S.includes,p.includes))).map(({request:p})=>p.path);C.length&&this.m(`Request to start watching: ${C.map(p=>`${p.path} (excludes: ${p.excludes.length>0?p.excludes:"<none>"}, includes: ${p.includes&&p.includes.length>0?JSON.stringify(p.includes):"<all>"}, correlationId: ${typeof p.correlationId=="number"?p.correlationId:"<none>"})`).join(",")}`),m.length&&this.m(`Request to stop watching: ${m.join(",")}`);for(const p of m)this.h(p);for(const p of C)this.g(p)}g(y){const L=new A.$xq(y,m=>this.a.fire(m),m=>this.b.fire(m),this.f),C={request:y,instance:L};this.c.set(y.path,C)}async stop(){for(const[y]of this.c)this.h(y);this.c.clear()}h(y){const L=this.c.get(y);L&&(this.c.delete(y),L.instance.dispose())}j(y){const L=new Map;for(const C of y){const m=I.$k?C.path:C.path.toLowerCase();let p=L.get(C.correlationId);p||(p=new Map,L.set(C.correlationId,p)),p.set(m,C)}return Array.from(L.values()).map(C=>Array.from(C.values())).flat()}async setVerboseLogging(y){this.f=y;for(const[,L]of this.c)L.instance.setVerboseLogging(y)}m(y){this.f&&this.b.fire({type:"trace",message:this.n(y)})}n(y,L){return L?`[File Watcher (node.js)] ${y} (path: ${L.request.path})`:`[File Watcher (node.js)] ${y}`}}e.$zq=b}),define(ke[245],Se([1,0,84,244]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aq=void 0;class g extends D.$fq{constructor(A,b,$){super(A,b,$),this.s()}r(A){return A.add(new O.$zq)}}e.$Aq=g}),define(ke[246],Se([1,0,17,81,187,84]),function(me,e,D,O,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sq=void 0;class A extends I.$gq{constructor($,y,L){super($,y,L),this.s()}r($){const y=$.add(new g.$rq(D.$og.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return $.add(y.onDidProcessExit(({code:L,signal:C})=>this.t(`terminated by itself with code ${L}, signal: ${C}`))),O.ProxyChannel.toService((0,O.$Mh)(y.getChannel("watcher")))}}e.$sq=A}),define(ke[107],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=void 0;class D{constructor(...g){this.a=new Map;for(const[I,A]of g)this.set(I,A)}set(g,I){const A=this.a.get(g);return this.a.set(g,I),A}has(g){return this.a.has(g)}get(g){return this.a.get(g)}}e.$4h=D}),define(ke[247],Se([1,0,11,14,3,105,238,5,107,75]),function(me,e,D,O,g,I,A,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fq=e.$Eq=void 0;const L=!1;class C extends Error{constructor(f){super("cyclic dependency between services"),this.message=f.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${f.toString()}`}}class m{constructor(f=new $.$4h,o=!1,i,r=L){this.f=f,this.g=o,this.h=i,this.i=r,this.o=new Set,this.f.set(b.$5h,this),this._globalGraph=r?i?._globalGraph??new A.$Dq(n=>n):void 0}createChild(f){return new m(f,this.g,this,this.i)}invokeFunction(f,...o){const i=S.traceInvocation(this.i,f);let r=!1;try{return f({get:c=>{if(r)throw(0,O.$8)("service accessor is only valid during the invocation of its target method");const t=this.m(c,i);if(!t)throw new Error(`[invokeFunction] unknown service '${c}'`);return t}},...o)}finally{r=!0,i.stop()}}createInstance(f,...o){let i,r;return f instanceof I.$3h?(i=S.traceCreation(this.i,f.ctor),r=this.j(f.ctor,f.staticArguments.concat(o),i)):(i=S.traceCreation(this.i,f),r=this.j(f,o,i)),i.stop(),r}j(f,o=[],i){const r=b._util.getServiceDependencies(f).sort((t,u)=>t.index-u.index),n=[];for(const t of r){const u=this.m(t.id,i);u||this.u(`[createInstance] ${f.name} depends on UNKNOWN service ${t.id}.`,!1),n.push(u)}const c=r.length>0?r[0].index:o.length;if(o.length!==c){console.trace(`[createInstance] First service dependency of ${f.name} at position ${c+1} conflicts with ${o.length} static arguments`);const t=c-o.length;t>0?o=o.concat(new Array(t)):o=o.slice(0,c)}return Reflect.construct(f,o.concat(n))}k(f,o){if(this.f.get(f)instanceof I.$3h)this.f.set(f,o);else if(this.h)this.h.k(f,o);else throw new Error("illegalState - setting UNKNOWN service instance")}l(f){const o=this.f.get(f);return!o&&this.h?this.h.l(f):o}m(f,o){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(f));const i=this.l(f);return i instanceof I.$3h?this.q(f,i,o.branch(f,!0)):(o.branch(f,!1),i)}q(f,o,i){if(this.o.has(f))throw new Error(`illegal state - RECURSIVELY instantiating service '${f}'`);this.o.add(f);try{return this.r(f,o,i)}finally{this.o.delete(f)}}r(f,o,i){const r=new A.$Dq(t=>t.id.toString());let n=0;const c=[{id:f,desc:o,_trace:i}];for(;c.length;){const t=c.pop();if(r.lookupOrInsertNode(t),n++>1e3)throw new C(r);for(const u of b._util.getServiceDependencies(t.desc.ctor)){const s=this.l(u.id);if(s||this.u(`[createInstance] ${f} depends on ${u.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(u.id)),s instanceof I.$3h){const l={id:u.id,desc:s,_trace:t._trace.branch(u.id,!0)};r.insertEdge(t,l),c.push(l)}}}for(;;){const t=r.roots();if(t.length===0){if(!r.isEmpty())throw new C(r);break}for(const{data:u}of t){if(this.l(u.id)instanceof I.$3h){const l=this.s(u.id,u.desc.ctor,u.desc.staticArguments,u.desc.supportsDelayedInstantiation,u._trace);this.k(u.id,l)}r.removeNode(u)}}return this.l(f)}s(f,o,i=[],r,n){if(this.f.get(f)instanceof I.$3h)return this.t(f,o,i,r,n);if(this.h)return this.h.s(f,o,i,r,n);throw new Error(`illegalState - creating UNKNOWN service instance ${o.name}`)}t(f,o,i=[],r,n){if(r){const c=new m(void 0,this.g,this,this.i);c.c=String(f);const t=new Map,u=new D.$mh(()=>{const s=c.j(o,i,n);for(const[l,a]of t){const d=s[l];if(typeof d=="function")for(const k of a)k.disposable=d.apply(s,k.listener)}return t.clear(),s});return new Proxy(Object.create(null),{get(s,l){if(!u.isInitialized&&typeof l=="string"&&(l.startsWith("onDid")||l.startsWith("onWill"))){let k=t.get(l);return k||(k=new y.$4c,t.set(l,k)),(v,w,E)=>{if(u.isInitialized)return u.value[l](v,w,E);{const P={listener:[v,w,E],disposable:void 0},N=k.push(P);return(0,g.$Rc)(()=>{N(),P.disposable?.dispose()})}}}if(l in s)return s[l];const a=u.value;let d=a[l];return typeof d!="function"||(d=d.bind(a),s[l]=d),d},set(s,l,a){return u.value[l]=a,!0},getPrototypeOf(s){return o.prototype}})}else return this.j(o,i,n)}u(f,o){if(o&&console.warn(f),this.g)throw new Error(f)}}e.$Eq=m;var p;(function(h){h[h.None=0]="None",h[h.Creation=1]="Creation",h[h.Invocation=2]="Invocation",h[h.Branch=3]="Branch"})(p||(p={}));class S{static{this.all=new Set}static{this.c=new class extends S{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(f,o){return f?new S(2,o.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):S.c}static traceCreation(f,o){return f?new S(1,o.name):S.c}static{this.f=0}constructor(f,o){this.type=f,this.name=o,this.g=Date.now(),this.h=[]}branch(f,o){const i=new S(3,f.toString());return this.h.push([f,o,i]),i}stop(){const f=Date.now()-this.g;S.f+=f;let o=!1;function i(n,c){const t=[],u=new Array(n+1).join("	");for(const[s,l,a]of c.h)if(l&&a){o=!0,t.push(`${u}CREATES -> ${s}`);const d=i(n+1,a);d&&t.push(d)}else t.push(`${u}uses -> ${s}`);return t.join(`
`)}const r=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${i(1,this)}`,`DONE, took ${f.toFixed(2)}ms (grand total ${S.f.toFixed(2)}ms)`];(f>2||o)&&S.all.add(r.join(`
`))}}e.$Fq=S}),define(ke[13],Se([1,0,44,4,54,3,28,10,23,18,2,45,5]),function(me,e,D,O,g,I,A,b,$,y,L,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.log=e.$qj=e.LogLevel=e.$pj=e.$oj=e.$nj=void 0,e.$nj=(0,m.$6h)("logService"),e.$oj=(0,m.$6h)("loggerService");function p(){return new Date().toISOString()}function S(v){return(0,y.$Mf)(v)}e.$pj=S;var h;(function(v){v[v.Off=0]="Off",v[v.Trace=1]="Trace",v[v.Debug=2]="Debug",v[v.Info=3]="Info",v[v.Warning=4]="Warning",v[v.Error=5]="Error"})(h||(e.LogLevel=h={})),e.$qj=h.Info;function f(v,w,E){switch(w){case h.Trace:v.trace(E);break;case h.Debug:v.debug(E);break;case h.Info:v.info(E);break;case h.Warning:v.warn(E);break;case h.Error:v.error(E);break;case h.Off:break;default:throw new Error(`Invalid log level ${w}`)}}e.log=f;function o(v,w=!1){let E="";for(let P=0;P<v.length;P++){let N=v[P];if(N instanceof Error&&(N=(0,D.$Qi)(N,w)),typeof N=="object")try{N=JSON.stringify(N)}catch{}E+=(P>0?" ":"")+N}return E}class i extends I.$Tc{constructor(){super(...arguments),this.b=e.$qj,this.c=this.B(new O.$Vd),this.onDidChangeLogLevel=this.c.event}setLevel(w){this.b!==w&&(this.b=w,this.c.fire(this.b))}getLevel(){return this.b}f(w){return this.b!==h.Off&&this.b<=w}}e.$sj=i;class r extends i{constructor(w){super(),this.h=w}f(w){return this.h||super.f(w)}trace(w,...E){this.f(h.Trace)&&this.g(h.Trace,o([w,...E],!0))}debug(w,...E){this.f(h.Debug)&&this.g(h.Debug,o([w,...E]))}info(w,...E){this.f(h.Info)&&this.g(h.Info,o([w,...E]))}warn(w,...E){this.f(h.Warning)&&this.g(h.Warning,o([w,...E]))}error(w,...E){if(this.f(h.Error))if(w instanceof Error){const P=Array.prototype.slice.call(arguments);P[0]=w.stack,this.g(h.Error,o(P))}else this.g(h.Error,o([w,...E]))}flush(){}}e.$tj=r;class n extends i{constructor(w=e.$qj){super(),this.setLevel(w),this.g=!b.$i}trace(w,...E){this.f(h.Trace)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,w,...E):console.log(`[main ${p()}]`,w,...E))}debug(w,...E){this.f(h.Debug)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,w,...E):console.log(`[main ${p()}]`,w,...E))}info(w,...E){this.f(h.Info)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,w,...E):console.log(`[main ${p()}]`,w,...E))}warn(w,...E){this.f(h.Warning)&&(this.g?console.warn(`\x1B[93m[main ${p()}]\x1B[0m`,w,...E):console.warn(`[main ${p()}]`,w,...E))}error(w,...E){this.f(h.Error)&&(this.g?console.error(`\x1B[91m[main ${p()}]\x1B[0m`,w,...E):console.error(`[main ${p()}]`,w,...E))}flush(){}}e.$uj=n;class c extends i{constructor(w=e.$qj,E=!0){super(),this.g=E,this.setLevel(w)}trace(w,...E){this.f(h.Trace)&&(this.g?console.log("%cTRACE","color: #888",w,...E):console.log(w,...E))}debug(w,...E){this.f(h.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",w,...E):console.log(w,...E))}info(w,...E){this.f(h.Info)&&(this.g?console.log("%c INFO","color: #33f",w,...E):console.log(w,...E))}warn(w,...E){this.f(h.Warning)&&(this.g?console.log("%c WARN","color: #993",w,...E):console.log(w,...E))}error(w,...E){this.f(h.Error)&&(this.g?console.log("%c  ERR","color: #f33",w,...E):console.error(w,...E))}flush(){}}e.$vj=c;class t extends i{constructor(w,E=e.$qj){super(),this.g=w,this.setLevel(E)}trace(w,...E){this.f(h.Trace)&&this.g.log(h.Trace,[this.h(w),...E])}debug(w,...E){this.f(h.Debug)&&this.g.log(h.Debug,[this.h(w),...E])}info(w,...E){this.f(h.Info)&&this.g.log(h.Info,[this.h(w),...E])}warn(w,...E){this.f(h.Warning)&&this.g.log(h.Warning,[this.h(w),...E])}error(w,...E){this.f(h.Error)&&this.g.log(h.Error,[this.h(w),...E])}h(w){return typeof w=="string"?w:(0,D.$Qi)(w,this.f(h.Trace))}flush(){}}e.$wj=t;class u extends i{constructor(w){super(),this.g=w,w.length&&this.setLevel(w[0].getLevel())}setLevel(w){for(const E of this.g)E.setLevel(w);super.setLevel(w)}trace(w,...E){for(const P of this.g)P.trace(w,...E)}debug(w,...E){for(const P of this.g)P.debug(w,...E)}info(w,...E){for(const P of this.g)P.info(w,...E)}warn(w,...E){for(const P of this.g)P.warn(w,...E)}error(w,...E){for(const P of this.g)P.error(w,...E)}flush(){for(const w of this.g)w.flush()}dispose(){for(const w of this.g)w.dispose();super.dispose()}}e.$xj=u;class s extends I.$Tc{constructor(w,E,P){if(super(),this.h=w,this.j=E,this.b=new A.$Ac,this.c=this.B(new O.$Vd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new O.$Vd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new O.$Vd),this.onDidChangeVisibility=this.g.event,P)for(const N of P)this.b.set(N.resource,{logger:void 0,info:N})}m(w){return(0,y.$If)(w)?[...this.b.values()].find(E=>E.info.id===w):this.b.get(w)}getLogger(w){return this.m(w)?.logger}createLogger(w,E){const P=this.n(w),N=(0,y.$If)(w)?w:E?.id??(0,g.$Ti)(P.toString()).toString(16);let U=this.b.get(P)?.logger;const F=E?.logLevel==="always"?h.Trace:E?.logLevel;U||(U=this.s(P,F??this.getLogLevel(P)??this.h,{...E,id:N}));const j={logger:U,info:{resource:P,id:N,logLevel:F,name:E?.name,hidden:E?.hidden,extensionId:E?.extensionId,when:E?.when}};return this.registerLogger(j.info),this.b.set(P,j),U}n(w){return(0,y.$If)(w)?(0,$.$Hg)(this.j,`${w}.log`):w}setLogLevel(w,E){if(L.URI.isUri(w)){const P=w,N=E,U=this.b.get(P);U&&N!==U.info.logLevel&&(U.info.logLevel=N===this.h?void 0:N,U.logger?.setLevel(N),this.b.set(U.info.resource,U),this.f.fire([P,N]))}else{this.h=w;for(const[P,N]of this.b.entries())this.b.get(P)?.info.logLevel===void 0&&N.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(w,E){const P=this.m(w);P&&E!==!P.info.hidden&&(P.info.hidden=!E,this.b.set(P.info.resource,P),this.g.fire([P.info.resource,E]))}getLogLevel(w){let E;return w&&(E=this.b.get(w)?.info.logLevel),E??this.h}registerLogger(w){const E=this.b.get(w.resource);E?E.info.hidden!==w.hidden&&this.setVisibility(w.resource,!w.hidden):(this.b.set(w.resource,{info:w,logger:void 0}),this.c.fire({added:[w],removed:[]}))}deregisterLogger(w){const E=this.b.get(w);E&&(E.logger&&E.logger.dispose(),this.b.delete(w),this.c.fire({added:[],removed:[E.info]}))}*getRegisteredLoggers(){for(const w of this.b.values())yield w.info}getRegisteredLogger(w){return this.b.get(w)?.info}dispose(){this.b.forEach(w=>w.logger?.dispose()),this.b.clear(),super.dispose()}}e.$yj=s;class l{constructor(){this.onDidChangeLogLevel=new O.$Vd().event}setLevel(w){}getLevel(){return h.Info}trace(w,...E){}debug(w,...E){}info(w,...E){}warn(w,...E){}error(w,...E){}critical(w,...E){}dispose(){}flush(){}}e.$zj=l;class a extends l{}e.$Aj=a;function d(v){if(v.verbose)return h.Trace;if(typeof v.logLevel=="string"){const w=R(v.logLevel.toLowerCase());if(w!==void 0)return w}return e.$qj}e.$Bj=d;function k(v){switch(v){case h.Trace:return"trace";case h.Debug:return"debug";case h.Info:return"info";case h.Warning:return"warn";case h.Error:return"error";case h.Off:return"off"}}e.$Cj=k;function R(v){switch(v){case"trace":return h.Trace;case"debug":return h.Debug;case"info":return h.Info;case"warn":return h.Warning;case"error":return h.Error;case"critical":return h.Error;case"off":return h.Off}}e.$Dj=R,e.$Ej=new C.$kj("logLevel",k(h.Info))}),define(ke[248],Se([1,0,19,11,14,4,3,16,84,13]),function(me,e,D,O,g,I,A,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lq=void 0;class L extends A.$Tc{constructor(m,p){super(),this.a=m,this.b=p,this.c=this.B(new I.$Vd),this.onDidChangeFile=this.c.event,this.g=this.B(new I.$Vd),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new O.$4g(0)),this.w=[],this.y=this.B(new O.$4g(0))}watch(m,p){return p.recursive||this.b?.watcher?.forceUniversal?this.n(m,p):this.z(m,p)}n(m,p){const S={path:this.H(m),excludes:p.excludes,includes:p.includes,recursive:p.recursive,correlationId:p.correlationId},h=(0,D.$Ub)(this.j,S);return this.r(),(0,A.$Rc)(()=>{h(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(m=>(0,g.$1)(m))}s(){this.h||(this.h=this.B(this.t(p=>this.c.fire((0,$.$hq)(p)),p=>this.G(p),this.a.getLevel()===y.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===y.LogLevel.Trace)})));const m=this.b?.watcher?.recursive?.usePolling;if(m===!0)for(const p of this.j)(0,$.$dq)(p)&&(p.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(m))for(const p of this.j)(0,$.$dq)(p)&&m.includes(p.path)&&(p.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(m,p){const S={path:this.H(m),excludes:p.excludes,includes:p.includes,recursive:!1,correlationId:p.correlationId},h=(0,D.$Ub)(this.w,S);return this.C(),(0,A.$Rc)(()=>{h(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(m=>(0,g.$1)(m))}D(){return this.u||(this.u=this.B(this.F(m=>this.c.fire((0,$.$hq)(m)),m=>this.G(m),this.a.getLevel()===y.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===y.LogLevel.Trace)}))),this.u.watch(this.w)}G(m){m.type==="error"&&this.g.fire(m.message),this.a[m.type](m.message)}H(m){return(0,b.$hc)(m.fsPath)}}e.$lq=L}),define(ke[249],Se([1,0,56,386,11,28,22,4,33,3,16,10,23,98,31,205,32,242,248,44,246,245]),function(me,e,D,O,g,I,A,b,$,y,L,C,m,p,S,h,f,o,i,r,n,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bq=void 0,(()=>{try{(0,O.gracefulify)(D)}catch(u){console.error(`Error enabling graceful-fs: ${(0,r.$Qi)(u)}`)}})();class t extends i.$lq{static{this.I=!1}constructor(s,l){super(s,l),this.onDidChangeCapabilities=b.Event.None,this.N=new I.$Ac(a=>m.$yg.getComparisonKey(a)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,C.$k&&(this.J|=1024)),this.J}async stat(s){try{const{stat:l,symbolicLink:a}=await S.SymlinkSupport.stat(this.H(s));return{type:this.M(l,a),ctime:l.birthtime.getTime(),mtime:l.mtime.getTime(),size:l.size,permissions:l.mode&128?void 0:f.FilePermission.Locked}}catch(l){throw this.fb(l)}}async L(s){try{return await this.stat(s)}catch{return}}async readdir(s){try{const l=await S.Promises.readdir(this.H(s),{withFileTypes:!0}),a=[];return await Promise.all(l.map(async d=>{try{let k;d.isSymbolicLink()?k=(await this.stat((0,m.$Hg)(s,d.name))).type:k=this.M(d),a.push([d.name,k])}catch(k){this.a.trace(k)}})),a}catch(l){throw this.fb(l)}}M(s,l){let a;return l?.dangling?a=f.FileType.Unknown:s.isFile()?a=f.FileType.File:s.isDirectory()?a=f.FileType.Directory:a=f.FileType.Unknown,l&&(a|=f.FileType.SymbolicLink),a}async O(s){const l=this.H(s);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${l})`);let a;for(;a=this.N.get(s);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${l})`),await a.wait();const d=new g.$5g;return this.N.set(s,d),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${l})`),(0,y.$Rc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${l})`),this.N.get(s)===d&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${l})`),this.N.delete(s)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${l})`),d.open()})}async readFile(s,l){let a;try{l?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(s)})`),a=await this.O(s));const d=this.H(s);return await S.Promises.readFile(d)}catch(d){throw this.fb(d)}finally{a?.dispose()}}P(s){t.I&&this.a.trace(s)}readFileStream(s,l,a){const d=(0,p.$0d)(k=>A.$je.concat(k.map(R=>A.$je.wrap(R))).buffer);return(0,o.$bq)(this,s,d,k=>k.buffer,{...l,bufferSize:256*1024},a),d}async writeFile(s,l,a){return a?.atomic!==!1&&a?.atomic?.postfix&&await this.Q(s)?this.R(s,(0,m.$Hg)((0,m.$Gg)(s),`${(0,m.$Eg)(s)}${a.atomic.postfix}`),l,a):this.S(s,l,a)}async Q(s){try{const l=this.H(s),{symbolicLink:a}=await S.SymlinkSupport.stat(l);if(a)return!1}catch{}return!0}async R(s,l,a,d){const k=new y.$Sc;try{k.add(await this.O(s)),k.add(await this.O(l)),await this.S(l,a,d,!0);try{await this.rename(l,s,{overwrite:!0})}catch(R){try{await this.delete(l,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw R}}finally{k.dispose()}}async S(s,l,a,d){let k;try{const R=this.H(s);if(!a.create||!a.overwrite){if(await S.Promises.exists(R)){if(!a.overwrite)throw(0,f.$Dk)((0,h.localize)(0,null),f.FileSystemProviderErrorCode.FileExists)}else if(!a.create)throw(0,f.$Dk)((0,h.localize)(1,null),f.FileSystemProviderErrorCode.FileNotFound)}k=await this.open(s,{create:!0,unlock:a.unlock},d),await this.write(k,0,l,0,l.byteLength)}catch(R){throw await this.gb(s,R)}finally{typeof k=="number"&&await this.close(k)}}static{this.Y=!0}static configureFlushOnWrite(s){t.Y=s}async open(s,l,a){const d=this.H(s);let k;(0,f.$rk)(l)&&!a&&(k=await this.O(s));let R;try{if((0,f.$rk)(l)&&l.unlock)try{const{stat:w}=await S.SymlinkSupport.stat(d);w.mode&128||await S.Promises.chmod(d,w.mode|128)}catch(w){w.code!=="ENOENT"&&this.a.trace(w)}let v;if((0,f.$rk)(l)){if(C.$i)try{await S.Promises.truncate(d,0),v="r+"}catch(w){w.code!=="ENOENT"&&this.a.trace(w)}v||(v="w")}else v="r";R=await S.Promises.open(d,v)}catch(v){throw k?.dispose(),(0,f.$rk)(l)?await this.gb(s,v):this.fb(v)}if(this.U.set(R,0),(0,f.$rk)(l)&&this.X.set(R,s),k){const v=this.W.get(R);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${R} (${d})`),this.W.set(R,k),v&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${R} (${d})`),v.dispose())}return R}async close(s){const l=this.W.get(s);try{if(this.U.delete(s),this.X.delete(s)&&t.Y)try{await S.Promises.fdatasync(s)}catch(a){t.configureFlushOnWrite(!1),this.a.error(a)}return await S.Promises.close(s)}catch(a){throw this.fb(a)}finally{l&&(this.W.get(s)===l&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${s}`),this.W.delete(s)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${s}`),l.dispose())}}async read(s,l,a,d,k){const R=this.Z(s,l);let v=null;try{v=(await S.Promises.read(s,a,d,k,R)).bytesRead}catch(w){throw this.fb(w)}finally{this.$(s,R,v)}return v}Z(s,l){return l===this.U.get(s)?null:l}$(s,l,a){const d=this.U.get(s);typeof d=="number"&&(typeof l=="number"||(typeof a=="number"?this.U.set(s,d+a):this.U.delete(s)))}async write(s,l,a,d,k){return(0,g.$nh)(()=>this.ab(s,l,a,d,k),100,3)}async ab(s,l,a,d,k){const R=this.Z(s,l);let v=null;try{v=(await S.Promises.write(s,a,d,k,R)).bytesWritten}catch(w){throw await this.gb(this.X.get(s),w)}finally{this.$(s,R,v)}return v}async mkdir(s){try{await S.Promises.mkdir(this.H(s))}catch(l){throw this.fb(l)}}async delete(s,l){try{const a=this.H(s);if(l.recursive){let d;l?.atomic!==!1&&l.atomic.postfix&&(d=(0,L.$jc)((0,L.$mc)(a),`${(0,L.$nc)(a)}${l.atomic.postfix}`)),await S.Promises.rm(a,S.RimRafMode.MOVE,d)}else try{await S.Promises.unlink(a)}catch(d){if(d.code==="EPERM"||d.code==="EISDIR"){let k=!1;try{const{stat:R,symbolicLink:v}=await S.SymlinkSupport.stat(a);k=R.isDirectory()&&!v}catch{}if(k)await S.Promises.rmdir(a);else throw d}else throw d}}catch(a){throw this.fb(a)}}async rename(s,l,a){const d=this.H(s),k=this.H(l);if(d!==k)try{await this.bb(s,l,"move",a.overwrite),await S.Promises.rename(d,k)}catch(R){throw(R.code==="EINVAL"||R.code==="EBUSY"||R.code==="ENAMETOOLONG")&&(R=new Error((0,h.localize)(2,null,(0,L.$nc)(d),(0,L.$nc)((0,L.$mc)(k)),R.toString()))),this.fb(R)}}async copy(s,l,a){const d=this.H(s),k=this.H(l);if(d!==k)try{await this.bb(s,l,"copy",a.overwrite),await S.Promises.copy(d,k,{preserveSymlinks:!0})}catch(R){throw(R.code==="EINVAL"||R.code==="EBUSY"||R.code==="ENAMETOOLONG")&&(R=new Error((0,h.localize)(3,null,(0,L.$nc)(d),(0,L.$nc)((0,L.$mc)(k)),R.toString()))),this.fb(R)}}async bb(s,l,a,d){const k=this.H(s),R=this.H(l);let v=!1;if(!!(this.capabilities&1024)||(v=(0,$.$7f)(k,R,!0)),v){if(a==="copy")throw(0,f.$Dk)((0,h.localize)(4,null),f.FileSystemProviderErrorCode.FileExists);if(a==="move")return}const E=await this.L(s);if(!E)throw(0,f.$Dk)((0,h.localize)(5,null),f.FileSystemProviderErrorCode.FileNotFound);const P=await this.L(l);if(P){if(!d)throw(0,f.$Dk)((0,h.localize)(6,null),f.FileSystemProviderErrorCode.FileExists);E.type&f.FileType.File&&P.type&f.FileType.File||await this.delete(l,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(s,l){return this.cb(s,l,!1)}async cb(s,l,a){const d=this.H(s),k=this.H(l),R=!!(this.capabilities&1024);if((0,$.$7f)(d,k,!R))return;const v=new y.$Sc;try{v.add(await this.O(s)),v.add(await this.O(l)),a&&await S.Promises.mkdir((0,L.$mc)(k),{recursive:!0}),await S.Promises.copyFile(d,k)}catch(w){if(w.code==="ENOENT"&&!a)return this.cb(s,l,!0);throw this.fb(w)}finally{v.dispose()}}t(s,l,a){return new n.$sq(d=>s(d),d=>l(d),a)}F(s,l,a){return new c.$Aq(d=>s(d),d=>l(d),a)}fb(s){if(s instanceof f.$Ck)return s;let l=s,a;switch(s.code){case"ENOENT":a=f.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":a=f.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":a=f.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":a=f.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":a=f.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":l=`${s.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,a=f.FileSystemProviderErrorCode.Unknown;break;default:a=f.FileSystemProviderErrorCode.Unknown}return(0,f.$Dk)(l,a)}async gb(s,l){let a=this.fb(l);if(s&&a.code===f.FileSystemProviderErrorCode.NoPermissions)try{const{stat:d}=await S.SymlinkSupport.stat(this.H(s));d.mode&128||(a=(0,f.$Dk)(l,f.FileSystemProviderErrorCode.FileWriteLocked))}catch(d){this.a.trace(d)}return a}}e.$Bq=t}),define(ke[250],Se([1,0,3,13]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uO=void 0;class g extends D.$Tc{constructor(A,b=[]){super(),this.a=new O.$xj([A,...b]),this.B(A.onDidChangeLogLevel($=>this.setLevel($)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...b){this.a.trace(A,...b)}debug(A,...b){this.a.debug(A,...b)}info(A,...b){this.a.info(A,...b)}warn(A,...b){this.a.warn(A,...b)}error(A,...b){this.a.error(A,...b)}flush(){this.a.flush()}}e.$uO=g}),define(ke[251],Se([1,0,32,13]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jO=void 0;var g;(function(y){y[y.Trace=0]="Trace",y[y.Debug=1]="Debug",y[y.Info=2]="Info",y[y.Warning=3]="Warning",y[y.Error=4]="Error",y[y.Critical=5]="Critical",y[y.Off=6]="Off"})(g||(g={}));async function I(y,L,C,m,p){try{const S=await new Promise((f,o)=>{me(["@vscode/spdlog"],f,o)});S.setFlushOn(g.Trace);const h=await S.createAsyncRotatingLogger(y,L,C,m);return p?h.clearFormatters():h.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),h}catch(S){console.error(S)}return null}function A(y,L,C){switch(L){case O.LogLevel.Trace:y.trace(C);break;case O.LogLevel.Debug:y.debug(C);break;case O.LogLevel.Info:y.info(C);break;case O.LogLevel.Warning:y.warn(C);break;case O.LogLevel.Error:y.error(C);break;case O.LogLevel.Off:break;default:throw new Error(`Invalid log level ${L}`)}}function b(y,L){switch(L){case O.LogLevel.Trace:y.setLevel(g.Trace);break;case O.LogLevel.Debug:y.setLevel(g.Debug);break;case O.LogLevel.Info:y.setLevel(g.Info);break;case O.LogLevel.Warning:y.setLevel(g.Warning);break;case O.LogLevel.Error:y.setLevel(g.Error);break;case O.LogLevel.Off:y.setLevel(g.Off);break;default:throw new Error(`Invalid log level ${L}`)}}class $ extends O.$tj{constructor(L,C,m,p,S){super(),this.m=[],this.setLevel(S),this.n=this.s(L,C,m,p),this.B(this.onDidChangeLogLevel(h=>{this.r&&b(this.r,h)}))}async s(L,C,m,p){const S=m?6:1,h=30/S*D.$Yk.MB,f=await I(L,C,h,S,p);if(f){this.r=f,b(this.r,this.getLevel());for(const{level:o,message:i}of this.m)A(this.r,o,i);this.m=[]}}g(L,C){this.r?A(this.r,L,C):this.getLevel()<=L&&this.m.push({level:L,message:C})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$jO=$}),define(ke[135],Se([1,0,39,206,5]),function(me,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$At=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var I;(function($){$[$.Unnecessary=1]="Unnecessary",$[$.Deprecated=2]="Deprecated"})(I||(e.MarkerTag=I={}));var A;(function($){$[$.Hint=1]="Hint",$[$.Info=2]="Info",$[$.Warning=4]="Warning",$[$.Error=8]="Error"})(A||(e.MarkerSeverity=A={})),function($){function y(S,h){return h-S}$.compare=y;const L=Object.create(null);L[$.Error]=(0,O.localize)(0,null),L[$.Warning]=(0,O.localize)(1,null),L[$.Info]=(0,O.localize)(2,null);function C(S){return L[S]||""}$.toString=C;function m(S){switch(S){case D.default.Error:return $.Error;case D.default.Warning:return $.Warning;case D.default.Info:return $.Info;case D.default.Ignore:return $.Hint}}$.fromSeverity=m;function p(S){switch(S){case $.Error:return D.default.Error;case $.Warning:return D.default.Warning;case $.Info:return D.default.Info;case $.Hint:return D.default.Ignore}}$.toSeverity=p}(A||(e.MarkerSeverity=A={}));var b;(function($){const y="";function L(m){return C(m,!0)}$.makeKey=L;function C(m,p){const S=[y];return m.source?S.push(m.source.replace("\xA6","\\\xA6")):S.push(y),m.code?typeof m.code=="string"?S.push(m.code.replace("\xA6","\\\xA6")):S.push(m.code.value.replace("\xA6","\\\xA6")):S.push(y),m.severity!==void 0&&m.severity!==null?S.push(A.toString(m.severity)):S.push(y),m.message&&p?S.push(m.message.replace("\xA6","\\\xA6")):S.push(y),m.startLineNumber!==void 0&&m.startLineNumber!==null?S.push(m.startLineNumber.toString()):S.push(y),m.startColumn!==void 0&&m.startColumn!==null?S.push(m.startColumn.toString()):S.push(y),m.endLineNumber!==void 0&&m.endLineNumber!==null?S.push(m.endLineNumber.toString()):S.push(y),m.endColumn!==void 0&&m.endColumn!==null?S.push(m.endColumn.toString()):S.push(y),S.push(y),S.join("\xA6")}$.makeKeyOptionalMessage=C})(b||(e.IMarkerData=b={})),e.$At=(0,g.$6h)("markerService")}),define(ke[252],Se([1,0,4,39,5]),function(me,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sv=e.$rv=e.NotificationsFilter=e.$qv=e.NeverShowAgainScope=e.NotificationPriority=e.$pv=e.Severity=void 0,e.Severity=O.default,e.$pv=(0,g.$6h)("notificationService");var I;(function(C){C[C.DEFAULT=0]="DEFAULT",C[C.SILENT=1]="SILENT",C[C.URGENT=2]="URGENT"})(I||(e.NotificationPriority=I={}));var A;(function(C){C[C.WORKSPACE=0]="WORKSPACE",C[C.PROFILE=1]="PROFILE",C[C.APPLICATION=2]="APPLICATION"})(A||(e.NeverShowAgainScope=A={}));function b(C){if(C){const m=C;return typeof m.id=="string"&&typeof m.label=="string"}return!1}e.$qv=b;var $;(function(C){C[C.OFF=0]="OFF",C[C.ERROR=1]="ERROR"})($||(e.NotificationsFilter=$={}));class y{constructor(){this.progress=new L,this.onDidClose=D.Event.None,this.onDidChangeVisibility=D.Event.None}updateSeverity(m){}updateMessage(m){}updateActions(m){}close(){}}e.$rv=y;class L{infinite(){}done(){}total(m){}worked(m){}}e.$sv=L}),define(ke[253],Se([1,0,49]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let O;const g=globalThis.vscode;if(typeof g<"u"&&typeof g.context<"u"){const I=g.context.configuration();if(I)O=I.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(O=globalThis._VSCODE_PRODUCT_JSON,D.env.VSCODE_DEV&&Object.assign(O,{nameShort:`${O.nameShort} Dev`,nameLong:`${O.nameLong} Dev`,dataFolderName:`${O.dataFolderName}-dev`,serverDataFolderName:O.serverDataFolderName?`${O.serverDataFolderName}-dev`:void 0}),!O.version){const I=globalThis._VSCODE_PACKAGE_JSON;Object.assign(O,{version:I.version})}}else O={},Object.keys(O).length===0&&Object.assign(O,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=O}),define(ke[136],Se([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gj=e.$Fj=void 0,e.$Fj=(0,D.$6h)("productService"),e.$Gj="vscode://schemas/vscode-product"});var We=this&&this.__param||function(me,e){return function(D,O){e(D,O,me)}};define(ke[85],Se([1,0,11,21,3,5]),function(me,e,D,O,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zv=e.$yv=e.$xv=e.$wv=e.$vv=e.$uv=e.ProgressLocation=e.$tv=void 0,e.$tv=(0,I.$6h)("progressService");var A;(function(C){C[C.Explorer=1]="Explorer",C[C.Scm=3]="Scm",C[C.Extensions=5]="Extensions",C[C.Window=10]="Window",C[C.Notification=15]="Notification",C[C.Dialog=20]="Dialog"})(A||(e.ProgressLocation=A={})),e.$uv=Object.freeze({total(){},worked(){},done(){}});class b{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(m){this.b=m}report(m){this.a=m,this.b(this.a)}}e.$vv=b;class ${get value(){return this.a}constructor(m){this.e=m}report(m){this.b?this.b.push(m):this.b=[m],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const m=this.b.shift();this.a=m,await this.e(this.a)}}finally{this.c=!1;const m=this.d;this.d=void 0,m?.()}}drain(){return this.c?new Promise(m=>{const p=this.d;this.d=()=>{p?.(),m()}}):Promise.resolve()}}e.$wv=$;let y=class extends g.$Tc{constructor(m,p){super(),this.a=new D.$qh,p.withProgress(m,S=>(this.b=S,this.c&&S.report(this.c),this.a.p)),this.B((0,g.$Rc)(()=>this.a.complete()))}report(m){this.b?this.b.report(m):this.c=m}};e.$xv=y,e.$xv=y=Ge([We(1,e.$tv)],y);class L extends g.$Tc{constructor(m){super(),this.g=m,this.a=0,this.b=this.B(new g.$Sc)}start(m){this.stop();const p=++this.a,S=new O.$6d;return this.f=setTimeout(()=>{p===this.a&&(this.c=this.g.show(!0))},m),this.b.add((0,g.$Rc)(()=>clearTimeout(this.f))),this.b.add((0,g.$Rc)(()=>S.cancel())),this.b.add((0,g.$Rc)(()=>this.c?this.c.done():void 0)),{id:p,token:S.token,stop:()=>this.h(p),isCurrent:()=>this.a===p}}stop(){this.h(this.a)}h(m){this.a===m&&this.b.clear()}}e.$yv=L,e.$zv=(0,I.$6h)("editorProgressService")}),define(ke[37],Se([1,0,60,18]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hn=void 0;class g{constructor(){this.a=new Map}add(A,b){D.ok(O.$If(A)),D.ok(O.$Kf(b)),D.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,b)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$Hn=new g}),define(ke[108],Se([1,0,4,37]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$In=void 0,e.$In={JSONContribution:"base.contributions.json"};function g(b){return b.length>0&&b.charAt(b.length-1)==="#"?b.substring(0,b.length-1):b}class I{constructor(){this.b=new D.$Vd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema($,y){this.a[g($)]=y,this.b.fire($)}notifySchemaChanged($){this.b.fire($)}getSchemaContributions(){return{schemas:this.a}}}const A=new I;O.$Hn.add(e.$In.JSONContribution,A)}),define(ke[86],Se([1,0,19,4,18,196,51,108,37]),function(me,e,D,O,g,I,A,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2n=e.$1n=e.$Zn=e.$Yn=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.$On=e.$Nn=e.ConfigurationScope=e.$Mn=e.EditPresentationTypes=void 0;var y;(function(c){c.Multiline="multilineText",c.Singleline="singlelineText"})(y||(e.EditPresentationTypes=y={})),e.$Mn={Configuration:"base.contributions.configuration"};var L;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.MACHINE=2]="MACHINE",c[c.WINDOW=3]="WINDOW",c[c.RESOURCE=4]="RESOURCE",c[c.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",c[c.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(L||(e.ConfigurationScope=L={})),e.$Nn={properties:{},patternProperties:{}},e.$On={properties:{},patternProperties:{}},e.$Pn={properties:{},patternProperties:{}},e.$Qn={properties:{},patternProperties:{}},e.$Rn={properties:{},patternProperties:{}},e.$Sn={properties:{},patternProperties:{}},e.$Tn="vscode://schemas/settings/resourceLanguage",e.$Un="vscode://schemas/settings/configurationDefaults";const C=$.$Hn.as(b.$In.JSONContribution);class m{constructor(){this.h=new Set,this.i=new O.$Vd,this.onDidSchemaChange=this.i.event,this.j=new O.$Vd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:I.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},C.registerSchema(e.$Tn,this.g),this.v()}registerConfiguration(t,u=!0){this.registerConfigurations([t],u)}registerConfigurations(t,u=!0){const s=new Set;this.n(t,u,s),C.registerSchema(e.$Tn,this.g),this.i.fire(),this.j.fire({properties:s})}deregisterConfigurations(t){const u=new Set;this.o(t,u),C.registerSchema(e.$Tn,this.g),this.i.fire(),this.j.fire({properties:u})}updateConfigurations({add:t,remove:u}){const s=new Set;this.o(u,s),this.n(t,!1,s),C.registerSchema(e.$Tn,this.g),this.i.fire(),this.j.fire({properties:s})}registerDefaultConfigurations(t){const u=new Set;this.k(t,u),this.i.fire(),this.j.fire({properties:u,defaultsOverrides:!0})}k(t,u){const s=[];for(const{overrides:l,source:a}of t)for(const d in l)if(u.add(d),e.$Wn.test(d)){const k=this.a.get(d),R=k?.valuesSources??new Map;if(a)for(const P of Object.keys(l[d]))R.set(P,a);const v={...k?.value||{},...l[d]};this.a.set(d,{source:a,value:v,valuesSources:R});const w=(0,A.$Ji)(d),E={type:"object",default:v,description:I.localize(1,null,w),$ref:e.$Tn,defaultDefaultValue:v,source:g.$If(a)?void 0:a,defaultValueSource:a};s.push(...h(d)),this.d[d]=E,this.b.properties[d]=E}else{this.a.set(d,{value:l[d],source:a});const k=this.d[d];k&&(this.w(d,k),this.r(d,k))}this.m(s)}deregisterDefaultConfigurations(t){const u=new Set;this.l(t,u),this.i.fire(),this.j.fire({properties:u,defaultsOverrides:!0})}l(t,u){for(const{overrides:s,source:l}of t)for(const a in s){const d=this.a.get(a),k=g.$If(l)?l:l?.id,R=g.$If(d?.source)?d?.source:d?.source?.id;if(k===R)if(u.add(a),this.a.delete(a),e.$Wn.test(a))delete this.d[a],delete this.b.properties[a];else{const v=this.d[a];v&&(this.w(a,v),this.r(a,v))}}this.u()}deltaConfiguration(t){let u=!1;const s=new Set;t.removedDefaults&&(this.l(t.removedDefaults,s),u=!0),t.addedDefaults&&(this.k(t.addedDefaults,s),u=!0),t.removedConfigurations&&this.o(t.removedConfigurations,s),t.addedConfigurations&&this.n(t.addedConfigurations,!1,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:u})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const u of t)this.h.add(u);this.u()}n(t,u,s){t.forEach(l=>{this.p(l,u,l.extensionInfo,l.restrictedProperties,void 0,s),this.c.push(l),this.q(l)})}o(t,u){const s=l=>{if(l.properties)for(const a in l.properties){u.add(a);const d=this.d[a];d?.policy?.name&&this.e.delete(d.policy.name),delete this.d[a],this.s(a,l.properties[a])}l.allOf?.forEach(a=>s(a))};for(const l of t){s(l);const a=this.c.indexOf(l);a!==-1&&this.c.splice(a,1)}}p(t,u=!0,s,l,a=3,d){a=g.$Rf(t.scope)?a:t.scope;const k=t.properties;if(k)for(const v in k){const w=k[v];if(u&&r(v,w)){delete k[v];continue}if(w.source=s,w.defaultDefaultValue=k[v].default,this.w(v,w),e.$Wn.test(v)?w.scope=void 0:(w.scope=g.$Rf(w.scope)?a:w.scope,w.restricted=g.$Rf(w.restricted)?!!l?.includes(v):w.restricted),k[v].hasOwnProperty("included")&&!k[v].included){this.f[v]=k[v],delete k[v];continue}else this.d[v]=k[v],k[v].policy?.name&&this.e.set(k[v].policy.name,v);!k[v].deprecationMessage&&k[v].markdownDeprecationMessage&&(k[v].deprecationMessage=k[v].markdownDeprecationMessage),d.add(v)}const R=t.allOf;if(R)for(const v of R)this.p(v,u,s,l,a,d)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const u=s=>{const l=s.properties;if(l)for(const d in l)this.r(d,l[d]);s.allOf?.forEach(u)};u(t)}r(t,u){switch(e.$Nn.properties[t]=u,u.scope){case 1:e.$On.properties[t]=u;break;case 2:e.$Pn.properties[t]=u;break;case 6:e.$Qn.properties[t]=u;break;case 3:e.$Rn.properties[t]=u;break;case 4:e.$Sn.properties[t]=u;break;case 5:e.$Sn.properties[t]=u,this.g.properties[t]=u;break}}s(t,u){switch(delete e.$Nn.properties[t],u.scope){case 1:delete e.$On.properties[t];break;case 2:delete e.$Pn.properties[t];break;case 6:delete e.$Qn.properties[t];break;case 3:delete e.$Rn.properties[t];break;case 4:case 5:delete e.$Sn.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const u=`[${t}]`,s={type:"object",description:I.localize(2,null),errorMessage:I.localize(3,null),$ref:e.$Tn};this.w(u,s),e.$Nn.properties[u]=s,e.$On.properties[u]=s,e.$Pn.properties[u]=s,e.$Qn.properties[u]=s,e.$Rn.properties[u]=s,e.$Sn.properties[u]=s}}v(){const t={type:"object",description:I.localize(4,null),errorMessage:I.localize(5,null),$ref:e.$Tn};e.$Nn.patternProperties[e.$Vn]=t,e.$On.patternProperties[e.$Vn]=t,e.$Pn.patternProperties[e.$Vn]=t,e.$Qn.patternProperties[e.$Vn]=t,e.$Rn.patternProperties[e.$Vn]=t,e.$Sn.patternProperties[e.$Vn]=t,this.i.fire()}w(t,u){const s=this.a.get(t);let l=s?.value,a=s?.source;g.$Pf(l)&&(l=u.defaultDefaultValue,a=void 0),g.$Pf(l)&&(l=o(u.type)),u.default=l,u.defaultValueSource=a}}const p="\\[([^\\]]+)\\]",S=new RegExp(p,"g");e.$Vn=`^(${p})+$`,e.$Wn=new RegExp(e.$Vn);function h(c){const t=[];if(e.$Wn.test(c)){let u=S.exec(c);for(;u?.length;){const s=u[1].trim();s&&t.push(s),u=S.exec(c)}}return(0,D.$Mb)(t)}e.$Xn=h;function f(c){return c.reduce((t,u)=>`${t}[${u}]`,"")}e.$Yn=f;function o(c){switch(Array.isArray(c)?c[0]:c){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$Zn=o;const i=new m;$.$Hn.add(e.$Mn.Configuration,i);function r(c,t){return c.trim()?e.$Wn.test(c)?I.localize(7,null,c):i.getConfigurationProperties()[c]!==void 0?I.localize(8,null,c):t.policy?.name&&i.getPolicyConfigurations().get(t.policy?.name)!==void 0?I.localize(9,null,c,t.policy?.name,i.getPolicyConfigurations().get(t.policy?.name)):null:I.localize(6,null)}e.$1n=r;function n(){const c=[],t=i.getConfigurationProperties();for(const u of Object.keys(t))c.push([u,t[u].scope]);return c.push(["launch",4]),c.push(["task",4]),c}e.$2n=n}),define(ke[254],Se([1,0,19,4,159,3,28,24,18,2,51,86,37]),function(me,e,D,O,g,I,A,b,$,y,L,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=void 0;function p(u){return Object.isFrozen(u)?u:b.$wn(u)}class S{constructor(s={},l=[],a=[],d){this.b=s,this.c=l,this.d=a,this.raw=d,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const s=this.raw.map(l=>{if(l instanceof S)return l;const a=new h("");return a.parseRaw(l),a.configurationModel});this.f=s.reduce((l,a)=>a===l?a:l.merge(a),s[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(s){return s?(0,L.$Hi)(this.contents,s):this.contents}inspect(s,l){const a=this.rawConfiguration.getValue(s),d=l?this.rawConfiguration.getOverrideValue(s,l):void 0,k=l?this.rawConfiguration.override(l).getValue(s):a;return{value:a,override:d,merged:k}}getOverrideValue(s,l){const a=this.i(l);return a?s?(0,L.$Hi)(a,s):a:void 0}getKeysForOverrideIdentifier(s){const l=[];for(const a of this.overrides)a.identifiers.includes(s)&&l.push(...a.keys);return D.$Mb(l)}getAllOverrideIdentifiers(){const s=[];for(const l of this.overrides)s.push(...l.identifiers);return D.$Mb(s)}override(s){let l=this.a.get(s);return l||(l=this.g(s),this.a.set(s,l)),l}merge(...s){const l=b.$vn(this.contents),a=b.$vn(this.overrides),d=[...this.keys],k=this.raw?.length?[...this.raw]:[this];for(const R of s)if(k.push(...R.raw?.length?R.raw:[R]),!R.isEmpty()){this.h(l,R.contents);for(const v of R.overrides){const[w]=a.filter(E=>D.$ub(E.identifiers,v.identifiers));w?(this.h(w.contents,v.contents),w.keys.push(...v.keys),w.keys=D.$Mb(w.keys)):a.push(b.$vn(v))}for(const v of R.keys)d.indexOf(v)===-1&&d.push(v)}return new S(l,d,a,k.every(R=>R instanceof S)?void 0:k)}g(s){const l=this.i(s);if(!l||typeof l!="object"||!Object.keys(l).length)return this;const a={};for(const d of D.$Mb([...Object.keys(this.contents),...Object.keys(l)])){let k=this.contents[d];const R=l[d];R&&(typeof k=="object"&&typeof R=="object"?(k=b.$vn(k),this.h(k,R)):k=R),a[d]=k}return new S(a,this.keys,this.overrides)}h(s,l){for(const a of Object.keys(l)){if(a in s&&$.$Kf(s[a])&&$.$Kf(l[a])){this.h(s[a],l[a]);continue}s[a]=b.$vn(l[a])}}i(s){let l=null,a=null;const d=k=>{k&&(a?this.h(a,k):a=b.$vn(k))};for(const k of this.overrides)k.identifiers.length===1&&k.identifiers[0]===s?l=k.contents:k.identifiers.includes(s)&&d(k.contents);return d(l),a}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(s,l){this.j(s,l,!0)}setValue(s,l){this.j(s,l,!1)}removeValue(s){const l=this.keys.indexOf(s);l!==-1&&(this.keys.splice(l,1),(0,L.$Gi)(this.contents,s),C.$Wn.test(s)&&this.overrides.splice(this.overrides.findIndex(a=>D.$ub(a.identifiers,(0,C.$Xn)(s))),1))}j(s,l,a){(0,L.$Fi)(this.contents,s,l,d=>console.error(d)),a=a||this.keys.indexOf(s)===-1,a&&this.keys.push(s),C.$Wn.test(s)&&this.overrides.push({identifiers:(0,C.$Xn)(s),keys:Object.keys(this.contents[s]),contents:(0,L.$Ei)(this.contents[s],d=>console.error(d))})}}e.$3n=S;class h{constructor(s){this.f=s,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new S}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(s,l){if(!$.$Rf(s)){const a=this.g(s);this.parseRaw(a,l)}}reparse(s){this.a&&this.parseRaw(this.a,s)}parseRaw(s,l){this.a=s;const{contents:a,keys:d,overrides:k,restricted:R,hasExcludedProperties:v}=this.h(s,l);this.b=new S(a,d,k,v?[s]:void 0),this.c=R||[]}g(s){let l={},a=null,d=[];const k=[],R=[];function v(E){Array.isArray(d)?d.push(E):a!==null&&(d[a]=E)}const w={onObjectBegin:()=>{const E={};v(E),k.push(d),d=E,a=null},onObjectProperty:E=>{a=E},onObjectEnd:()=>{d=k.pop()},onArrayBegin:()=>{const E=[];v(E),k.push(d),d=E,a=null},onArrayEnd:()=>{d=k.pop()},onLiteralValue:v,onError:(E,P,N)=>{R.push({error:E,offset:P,length:N})}};if(s)try{g.$jn(s,w),l=d[0]||{}}catch(E){console.error(`Error while parsing settings file ${this.f}: ${E}`),this.d=[E]}return l}h(s,l){const a=m.$Hn.as(C.$Mn.Configuration).getConfigurationProperties(),d=this.i(s,a,!0,l);s=d.raw;const k=(0,L.$Ei)(s,w=>console.error(`Conflict in settings file ${this.f}: ${w}`)),R=Object.keys(s),v=this.j(s,w=>console.error(`Conflict in settings file ${this.f}: ${w}`));return{contents:k,keys:R,overrides:v,restricted:d.restricted,hasExcludedProperties:d.hasExcludedProperties}}i(s,l,a,d){let k=!1;if(!d?.scopes&&!d?.skipRestricted&&!d?.exclude?.length)return{raw:s,restricted:[],hasExcludedProperties:k};const R={},v=[];for(const w in s)if(C.$Wn.test(w)&&a){const E=this.i(s[w],l,!1,d);R[w]=E.raw,k=k||E.hasExcludedProperties,v.push(...E.restricted)}else{const E=l[w],P=E?typeof E.scope<"u"?E.scope:3:void 0;E?.restricted&&v.push(w),!d.exclude?.includes(w)&&(d.include?.includes(w)||(P===void 0||d.scopes===void 0||d.scopes.includes(P))&&!(d.skipRestricted&&E?.restricted))?R[w]=s[w]:k=!0}return{raw:R,restricted:v,hasExcludedProperties:k}}j(s,l){const a=[];for(const d of Object.keys(s))if(C.$Wn.test(d)){const k={};for(const R in s[d])k[R]=s[d][R];a.push({identifiers:(0,C.$Xn)(d),keys:Object.keys(k),contents:(0,L.$Ei)(k,l)})}return a}}e.$4n=h;class f extends I.$Tc{constructor(s,l,a,d){super(),this.c=s,this.f=l,this.g=d,this.b=this.B(new O.$Vd),this.onDidChange=this.b.event,this.a=new h(this.c.toString()),this.B(this.g.watch(a.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(O.Event.any(O.Event.filter(this.g.onDidFilesChange,k=>k.contains(this.c)),O.Event.filter(this.g.onDidRunOperation,k=>(k.isOperation(0)||k.isOperation(3)||k.isOperation(1)||k.isOperation(4))&&a.isEqual(k.resource,s)))(()=>this.b.fire()))}async loadConfiguration(){try{const s=await this.g.readFile(this.c);return this.a.parse(s.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new S}}reparse(s){return s&&(this.f=s),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$5n=f;class o{constructor(s,l,a,d,k,R,v,w,E,P,N,U,F){this.a=s,this.b=l,this.c=a,this.overrideIdentifiers=d,this.d=k,this.f=R,this.g=v,this.h=w,this.i=E,this.j=P,this.k=N,this.l=U,this.m=F}get value(){return p(this.c)}n(s,l,a){const d=s.inspect(l,a);return{get value(){return p(d.value)},get override(){return p(d.override)},get merged(){return p(d.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class i{constructor(s,l,a,d,k=new S,R=new S,v=new A.$Ac,w=new S,E=new A.$Ac){this.c=s,this.d=l,this.f=a,this.g=d,this.h=k,this.i=R,this.j=v,this.l=w,this.m=E,this.a=null,this.b=new A.$Ac,this.n=null}getValue(s,l,a){return this.p(s,l,a).getValue(s)}updateValue(s,l,a={}){let d;a.resource?(d=this.m.get(a.resource),d||(d=new S,this.m.set(a.resource,d))):d=this.l,l===void 0?d.removeValue(s):d.setValue(s,l),a.resource||(this.a=null)}inspect(s,l,a){const d=this.p(s,l,a),k=this.t(l.resource,a),R=l.resource?this.m.get(l.resource)||this.l:this.l,v=new Set;for(const w of d.overrides)for(const E of w.identifiers)d.getOverrideValue(s,E)!==void 0&&v.add(E);return new o(s,l,d.getValue(s),v.size?[...v]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,a?this.i:void 0,k||void 0,R)}keys(s){const l=this.t(void 0,s);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:l?l.keys.slice(0):[]}}updateDefaultConfiguration(s){this.c=s,this.a=null,this.b.clear()}updatePolicyConfiguration(s){this.d=s}updateApplicationConfiguration(s){this.f=s,this.a=null,this.b.clear()}updateLocalUserConfiguration(s){this.g=s,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(s){this.h=s,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(s){this.i=s,this.a=null,this.b.clear()}updateFolderConfiguration(s,l){this.j.set(s,l),this.b.delete(s)}deleteFolderConfiguration(s){this.folderConfigurations.delete(s),this.b.delete(s)}compareAndUpdateDefaultConfiguration(s,l){const a=[];if(!l){const{added:d,updated:k,removed:R}=c(this.c,s);l=[...d,...k,...R]}for(const d of l)for(const k of(0,C.$Xn)(d)){const R=this.c.getKeysForOverrideIdentifier(k),v=s.getKeysForOverrideIdentifier(k),w=[...v.filter(E=>R.indexOf(E)===-1),...R.filter(E=>v.indexOf(E)===-1),...R.filter(E=>!b.$zn(this.c.override(k).getValue(E),s.override(k).getValue(E)))];a.push([k,w])}return this.updateDefaultConfiguration(s),{keys:l,overrides:a}}compareAndUpdatePolicyConfiguration(s){const{added:l,updated:a,removed:d}=c(this.d,s),k=[...l,...a,...d];return k.length&&this.updatePolicyConfiguration(s),{keys:k,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:l,updated:a,removed:d,overrides:k}=c(this.applicationConfiguration,s),R=[...l,...a,...d];return R.length&&this.updateApplicationConfiguration(s),{keys:R,overrides:k}}compareAndUpdateLocalUserConfiguration(s){const{added:l,updated:a,removed:d,overrides:k}=c(this.localUserConfiguration,s),R=[...l,...a,...d];return R.length&&this.updateLocalUserConfiguration(s),{keys:R,overrides:k}}compareAndUpdateRemoteUserConfiguration(s){const{added:l,updated:a,removed:d,overrides:k}=c(this.remoteUserConfiguration,s),R=[...l,...a,...d];return R.length&&this.updateRemoteUserConfiguration(s),{keys:R,overrides:k}}compareAndUpdateWorkspaceConfiguration(s){const{added:l,updated:a,removed:d,overrides:k}=c(this.workspaceConfiguration,s),R=[...l,...a,...d];return R.length&&this.updateWorkspaceConfiguration(s),{keys:R,overrides:k}}compareAndUpdateFolderConfiguration(s,l){const a=this.folderConfigurations.get(s),{added:d,updated:k,removed:R,overrides:v}=c(a,l),w=[...d,...k,...R];return(w.length||!a)&&this.updateFolderConfiguration(s,l),{keys:w,overrides:v}}compareAndDeleteFolderConfiguration(s){const l=this.folderConfigurations.get(s);if(!l)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:a,updated:d,removed:k,overrides:R}=c(l,void 0);return{keys:[...a,...d,...k],overrides:R}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(s,l,a){let d=this.q(l,a);return l.overrideIdentifier&&(d=d.override(l.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(s)!==void 0&&(d=d.merge(this.d)),d}q({resource:s},l){let a=this.r();if(l&&s){const d=l.getFolder(s);d&&(a=this.s(d.uri)||a);const k=this.m.get(s);k&&(a=a.merge(k))}return a}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(s){let l=this.b.get(s);if(!l){const a=this.r(),d=this.j.get(s);d?(l=a.merge(d),this.b.set(s,l)):l=a}return l}t(s,l){if(l&&s){const a=l.getFolder(s);if(a)return this.j.get(a.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((s,l)=>{const{contents:a,overrides:d,keys:k}=this.j.get(l);return s.push([l,{contents:a,overrides:d,keys:k}]),s},[])}}allKeys(){const s=new Set;return this.c.keys.forEach(l=>s.add(l)),this.userConfiguration.keys.forEach(l=>s.add(l)),this.i.keys.forEach(l=>s.add(l)),this.j.forEach(l=>l.keys.forEach(a=>s.add(a))),[...s.values()]}u(){const s=new Set;return this.c.getAllOverrideIdentifiers().forEach(l=>s.add(l)),this.userConfiguration.getAllOverrideIdentifiers().forEach(l=>s.add(l)),this.i.getAllOverrideIdentifiers().forEach(l=>s.add(l)),this.j.forEach(l=>l.getAllOverrideIdentifiers().forEach(a=>s.add(a))),[...s.values()]}v(s){const l=new Set;return this.c.getKeysForOverrideIdentifier(s).forEach(a=>l.add(a)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(a=>l.add(a)),this.i.getKeysForOverrideIdentifier(s).forEach(a=>l.add(a)),this.j.forEach(a=>a.getKeysForOverrideIdentifier(s).forEach(d=>l.add(d))),[...l.values()]}static parse(s){const l=this.w(s.defaults),a=this.w(s.policy),d=this.w(s.application),k=this.w(s.user),R=this.w(s.workspace),v=s.folders.reduce((w,E)=>(w.set(y.URI.revive(E[0]),this.w(E[1])),w),new A.$Ac);return new i(l,a,d,k,new S,R,v,new S,new A.$Ac)}static w(s){return new S(s.contents,s.keys,s.overrides)}}e.$6n=i;function r(...u){if(u.length===0)return{keys:[],overrides:[]};if(u.length===1)return u[0];const s=new Set,l=new Map;for(const d of u)d.keys.forEach(k=>s.add(k)),d.overrides.forEach(([k,R])=>{const v=(0,A.$xc)(l,k,new Set);R.forEach(w=>v.add(w))});const a=[];return l.forEach((d,k)=>a.push([k,[...d.values()]])),{keys:[...s.values()],overrides:a}}e.$7n=r;class n{constructor(s,l,a,d){this.change=s,this.f=l,this.g=a,this.h=d,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const k of s.keys)this.affectedKeys.add(k);for(const[,k]of s.overrides)for(const R of k)this.affectedKeys.add(R);this.d=this.a;for(const k of this.affectedKeys)this.d+=k+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=i.parse(this.f.data)),this.i}affectsConfiguration(s,l){const a=this.a+s,d=this.d.indexOf(a);if(d<0)return!1;const k=d+a.length;if(k>=this.d.length)return!1;const R=this.d.charCodeAt(k);if(R!==this.b&&R!==this.c)return!1;if(l){const v=this.previousConfiguration?this.previousConfiguration.getValue(s,l,this.f?.workspace):void 0,w=this.g.getValue(s,l,this.h);return!b.$zn(v,w)}return!0}}e.$8n=n;function c(u,s){const{added:l,removed:a,updated:d}=t(s?.rawConfiguration,u?.rawConfiguration),k=[],R=u?.getAllOverrideIdentifiers()||[],v=s?.getAllOverrideIdentifiers()||[];if(s){const w=v.filter(E=>!R.includes(E));for(const E of w)k.push([E,s.getKeysForOverrideIdentifier(E)])}if(u){const w=R.filter(E=>!v.includes(E));for(const E of w)k.push([E,u.getKeysForOverrideIdentifier(E)])}if(s&&u){for(const w of R)if(v.includes(w)){const E=t({contents:u.getOverrideValue(void 0,w)||{},keys:u.getKeysForOverrideIdentifier(w)},{contents:s.getOverrideValue(void 0,w)||{},keys:s.getKeysForOverrideIdentifier(w)});k.push([w,[...E.added,...E.removed,...E.updated]])}}return{added:l,removed:a,updated:d,overrides:k}}function t(u,s){const l=u?s?u.keys.filter(k=>s.keys.indexOf(k)===-1):[...u.keys]:[],a=s?u?s.keys.filter(k=>u.keys.indexOf(k)===-1):[...s.keys]:[],d=[];if(u&&s){for(const k of s.keys)if(u.keys.indexOf(k)!==-1){const R=(0,L.$Hi)(s.contents,k),v=(0,L.$Hi)(u.contents,k);b.$zn(R,v)||d.push(k)}}return{added:l,removed:a,updated:d}}}),define(ke[255],Se([1,0,22,4,3,82]),function(me,e,D,O,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$trb=e.$srb=e.$rrb=e.$qrb=void 0;const A=(y,L,C)=>{const m=new Uint8Array(16);for(let h=0;h<16;h++)m[h]=Math.round(Math.random()*256);const p=(0,D.$De)(D.$je.wrap(m));return[`GET ws://localhost${y}?${L}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${p}`].join(`\r
`)+`\r
\r
`};e.$qrb=A,e.$rrb=D.$je.fromString(`\r
\r
`);async function b(y,L,C,m,p){y.write(D.$je.fromString((0,e.$qrb)(L,C,m)));const S=new g.$Sc;try{return await new Promise((h,f)=>{let o;S.add(y.onData(i=>{o?o=D.$je.concat([o,i],o.byteLength+i.byteLength):o=i;const r=o.indexOf(e.$rrb);if(r===-1)return;h(y),y.pauseData();const n=o.slice(r+e.$rrb.byteLength);n.byteLength&&p.onData.fire(n)})),S.add(y.onClose(i=>f(i??new Error("socket closed")))),S.add(y.onEnd(()=>f(new Error("socket ended"))))})}catch(h){throw y.dispose(),h}finally{S.dispose()}}e.$srb=b;class $ extends g.$Tc{constructor(L,C){super(),this.g=L,this.a=this.B(new O.$Yd),this.onData=(...m)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...m)),this.b=this.B(new O.$Vd),this.onDidDispose=this.b.event,this.f=!1,this.B(C.onData),this.B(C.onData.event(m=>this.a.fire(m))),this.onClose=this.B(C.onClose).event,this.onEnd=this.B(C.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(L,C){I.SocketDiagnostics.traceSocketEvent(this,this.g,L,C)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$trb=$}),define(ke[64],Se([1,0,14,5]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_k=e.$$k=e.RemoteAuthorityResolverErrorCode=e.$0k=e.$9k=e.RemoteConnectionType=e.$8k=void 0,e.$8k=(0,O.$6h)("remoteAuthorityResolverService");var g;(function(L){L[L.WebSocket=0]="WebSocket",L[L.Managed=1]="Managed"})(g||(e.RemoteConnectionType=g={}));class I{constructor(C){this.id=C,this.type=1}toString(){return`Managed(${this.id})`}}e.$9k=I;class A{constructor(C,m){this.host=C,this.port=m,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$0k=A;var b;(function(L){L.Unknown="Unknown",L.NotAvailable="NotAvailable",L.TemporarilyNotAvailable="TemporarilyNotAvailable",L.NoResolverFound="NoResolverFound",L.InvalidAuthority="InvalidAuthority"})(b||(e.RemoteAuthorityResolverErrorCode=b={}));class $ extends D.$bb{static isNotAvailable(C){return C instanceof $&&C._code===b.NotAvailable}static isTemporarilyNotAvailable(C){return C instanceof $&&C._code===b.TemporarilyNotAvailable}static isNoResolverFound(C){return C instanceof $&&C._code===b.NoResolverFound}static isInvalidAuthority(C){return C instanceof $&&C._code===b.InvalidAuthority}static isHandled(C){return C instanceof $&&C.isHandled}constructor(C,m=b.Unknown,p){super(C),this._message=C,this._code=m,this._detail=p,this.isHandled=m===b.NotAvailable&&p===!0,Object.setPrototypeOf(this,$.prototype)}}e.$$k=$;function y(L){const C=L.indexOf("+");return C===-1?L:L.substring(0,C)}e.$_k=y}),define(ke[65],Se([1,0,17]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$el=e.$dl=e.$cl=e.$bl=e.$al=void 0;function O(y){return y.scheme===D.Schemas.vscodeRemote?y.authority:void 0}e.$al=O;function g(y){if(!y)return;const L=y.indexOf("+");return L<0?y:y.substr(0,L)}e.$bl=g;function I(y){return`/${y.quality??"oss"}-${y.commit??"dev"}`}e.$cl=I;function A(y){const{host:L,port:C}=$(y);if(typeof C>"u")throw new Error(`Invalid remote authority: ${y}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:L,port:C}}e.$dl=A;function b(y,L){let{host:C,port:m}=$(y);return typeof m>"u"&&(m=L),{host:C,port:m}}e.$el=b;function $(y){const L=y.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(L)return{host:L[1],port:parseInt(L[2],10)};const C=y.match(/^(\[[0-9a-z:]+\])$/);if(C)return{host:C[1],port:void 0};const m=y.match(/(.*):(\d+)$/);return m?{host:m[1],port:parseInt(m[2],10)}:{host:y,port:void 0}}}),define(ke[26],Se([1,0,12,5,65]),function(me,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sm=e.$rm=e.$qm=e.$pm=e.$om=e.$nm=e.$mm=e.$lm=e.TargetPlatform=e.ExtensionType=e.$km=e.$jm=e.$im=e.$hm=e.$gm=e.$fm=void 0,e.$fm="extensions.user.cache",e.$gm="extensions.builtin.cache",e.$hm="undefined_publisher",e.$im=["ui","workspace","web"];function I(h){if(typeof h=="object"&&h!==null&&h.supported!==!0)return h.description}e.$jm=I,e.$km=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(h){h[h.System=0]="System",h[h.User=1]="User"})(A||(e.ExtensionType=A={}));var b;(function(h){h.WIN32_X64="win32-x64",h.WIN32_ARM64="win32-arm64",h.LINUX_X64="linux-x64",h.LINUX_ARM64="linux-arm64",h.LINUX_ARMHF="linux-armhf",h.ALPINE_X64="alpine-x64",h.ALPINE_ARM64="alpine-arm64",h.DARWIN_X64="darwin-x64",h.DARWIN_ARM64="darwin-arm64",h.WEB="web",h.UNIVERSAL="universal",h.UNKNOWN="unknown",h.UNDEFINED="undefined"})(b||(e.TargetPlatform=b={}));class ${constructor(f){this.value=f,this._lower=f.toLowerCase()}static equals(f,o){if(typeof f>"u"||f===null)return typeof o>"u"||o===null;if(typeof o>"u"||o===null)return!1;if(typeof f=="string"||typeof o=="string"){const i=typeof f=="string"?f:f.value,r=typeof o=="string"?o:o.value;return D.$_e(i,r)}return f._lower===o._lower}static toKey(f){return typeof f=="string"?f.toLowerCase():f._lower}}e.$lm=$;class y{get size(){return this.c.size}constructor(f){if(this.c=new Set,f)for(const o of f)this.add(o)}add(f){this.c.add($.toKey(f))}delete(f){return this.c.delete($.toKey(f))}has(f){return this.c.has($.toKey(f))}}e.$mm=y;class L{constructor(){this.c=new Map}clear(){this.c.clear()}delete(f){this.c.delete($.toKey(f))}get(f){return this.c.get($.toKey(f))}has(f){return this.c.has($.toKey(f))}set(f,o){this.c.set($.toKey(f),o)}values(){return this.c.values()}forEach(f){this.c.forEach(f)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$nm=L;function C(h){return m(h)}e.$om=C;function m(h){return h.contributes&&h.contributes.localizations?h.contributes.localizations.length>0:!1}e.$pm=m;function p(h){return h.contributes&&h.contributes.authentication?h.contributes.authentication.length>0:!1}e.$qm=p;function S(h,f){if(f){const o=`onResolveRemoteAuthority:${(0,g.$bl)(f)}`;return!!h.activationEvents?.includes(o)}return!1}e.$rm=S,e.$sm=(0,O.$6h)("IBuiltinExtensionsScannerService")}),define(ke[137],Se([1,0,14,26]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hF=e.$gF=void 0;class g{constructor(){this.a=new Map,this.b=new WeakMap}register(A,b){this.a.set(A,b)}readActivationEvents(A){return this.b.has(A)||this.b.set(A,this.c(A)),this.b.get(A)}createActivationEventsMap(A){const b=Object.create(null);for(const $ of A){const y=this.readActivationEvents($);y.length>0&&(b[O.$lm.toKey($.identifier)]=y)}return b}c(A){if(typeof A.main>"u"&&typeof A.browser>"u")return[];const b=Array.isArray(A.activationEvents)?A.activationEvents.slice(0):[];for(let $=0;$<b.length;$++)b[$]==="onUri"&&(b[$]=`onUri:${O.$lm.toKey(A.identifier)}`);if(!A.contributes)return b;for(const $ in A.contributes){const y=this.a.get($);if(!y)continue;const L=A.contributes[$],C=Array.isArray(L)?L:[L];try{y(C,b)}catch(m){(0,D.$1)(m)}}return b}}e.$gF=g,e.$hF=new g}),define(ke[256],Se([1,0,11,22,21,14,4,3,57,38,30,82,64,65]),function(me,e,D,O,g,I,A,b,$,y,L,C,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tl=e.$sl=e.$rl=e.$ql=e.$pl=e.$ol=e.$nl=e.$ml=e.PersistentConnectionEventType=e.$ll=e.$kl=e.$jl=e.ConnectionType=void 0;const S=30*1e3;var h;(function(K){K[K.Management=1]="Management",K[K.ExtensionHost=2]="ExtensionHost",K[K.Tunnel=3]="Tunnel"})(h||(e.ConnectionType=h={}));function f(K){switch(K){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function o(K){const W=new g.$6d;return setTimeout(()=>W.cancel(),K),W.token}function i(K,W){if(K.isCancellationRequested||W.isCancellationRequested)return g.CancellationToken.Cancelled;const re=new g.$6d;return K.onCancellationRequested(()=>re.cancel()),W.onCancellationRequested(()=>re.cancel()),re.token}class r{get didTimeout(){return this.c==="timedout"}constructor(W){this.c="pending",this.d=new b.$Sc,this.promise=new Promise((re,ye)=>{this.f=re,this.g=ye}),W.isCancellationRequested?this.h():this.d.add(W.onCancellationRequested(()=>this.h()))}registerDisposable(W){this.c==="pending"?this.d.add(W):W.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const W=new Error("Time limit reached");return W.code="ETIMEDOUT",W.syscall="connect",W}resolve(W){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(W))}reject(W){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(W))}}function n(K,W){const re=new r(W);return re.registerDisposable(K.onControlMessage(ye=>{const de=JSON.parse(ye.toString()),ge=J(de);ge?re.reject(ge):re.resolve(de)})),re.promise}function c(K,W,re,ye,de,ge,x,te){const G=new r(te),ie=y.$Rd.create(!1);return K.info(`Creating a socket (${x})...`),$.mark(`code/willCreateSocket/${ge}`),W.connect(re,ye,de,x).then(fe=>{G.didTimeout?($.mark(`code/didCreateSocketError/${ge}`),K.info(`Creating a socket (${x}) finished after ${ie.elapsed()} ms, but this is too late and has timed out already.`),fe?.dispose()):($.mark(`code/didCreateSocketOK/${ge}`),K.info(`Creating a socket (${x}) was successful after ${ie.elapsed()} ms.`),G.resolve(fe))},fe=>{$.mark(`code/didCreateSocketError/${ge}`),K.info(`Creating a socket (${x}) returned an error after ${ie.elapsed()} ms.`),K.error(fe),G.reject(fe)}),G.promise}function t(K,W){const re=new r(W);return K.then(ye=>{re.didTimeout||re.resolve(ye)},ye=>{re.didTimeout||re.reject(ye)}),re.promise}async function u(K,W,re,ye){const de=we(K,W);K.logService.trace(`${de} 1/6. invoking socketFactory.connect().`);let ge;try{ge=await c(K.logService,K.remoteSocketFactoryService,K.connectTo,(0,p.$cl)(K),`reconnectionToken=${K.reconnectionToken}&reconnection=${K.reconnectionProtocol?"true":"false"}`,f(W),`renderer-${f(W)}-${K.reconnectionToken}`,ye)}catch(fe){throw K.logService.error(`${de} socketFactory.connect() failed or timed out. Error:`),K.logService.error(fe),fe}K.logService.trace(`${de} 2/6. socketFactory.connect() was successful.`);let x,te;K.reconnectionProtocol?(K.reconnectionProtocol.beginAcceptReconnection(ge,null),x=K.reconnectionProtocol,te=!1):(x=new C.$Th({socket:ge}),te=!0),K.logService.trace(`${de} 3/6. sending AuthRequest control message.`);const G=await t(K.signService.createNewMessage((0,L.$qg)()),ye),ie={type:"auth",auth:K.connectionToken||"00000000000000000000",data:G.data};x.sendControl(O.$je.fromString(JSON.stringify(ie)));try{const fe=await n(x,i(ye,o(1e4)));if(fe.type!=="sign"||typeof fe.data!="string"){const De=new Error("Unexpected handshake message");throw De.code="VSCODE_CONNECTION_ERROR",De}if(K.logService.trace(`${de} 4/6. received SignRequest control message.`),!await t(K.signService.validate(G,fe.signedData),ye)){const De=new Error("Refused to connect to unsupported server");throw De.code="VSCODE_CONNECTION_ERROR",De}const Pe=await t(K.signService.sign(fe.data),ye),be={type:"connectionType",commit:K.commit,signedData:Pe,desiredConnectionType:W};return re&&(be.args=re),K.logService.trace(`${de} 5/6. sending ConnectionTypeRequest control message.`),x.sendControl(O.$je.fromString(JSON.stringify(be))),{protocol:x,ownsProtocol:te}}catch(fe){throw fe&&fe.code==="ETIMEDOUT"&&(K.logService.error(`${de} the handshake timed out. Error:`),K.logService.error(fe)),fe&&fe.code==="VSCODE_CONNECTION_ERROR"&&(K.logService.error(`${de} received error control message when negotiating connection. Error:`),K.logService.error(fe)),te&&Z(x),fe}}async function s(K,W,re,ye){const de=Date.now(),ge=we(K,W),{protocol:x,ownsProtocol:te}=await u(K,W,re,ye),G=new r(ye);return G.registerDisposable(x.onControlMessage(ie=>{const fe=JSON.parse(ie.toString()),pe=J(fe);pe?(K.logService.error(`${ge} received error control message when negotiating connection. Error:`),K.logService.error(pe),te&&Z(x),G.reject(pe)):(K.reconnectionProtocol?.endAcceptReconnection(),K.logService.trace(`${ge} 6/6. handshake finished, connection is up and running after ${oe(de)}!`),G.resolve({protocol:x,firstMessage:fe}))})),G.promise}async function l(K,W){const{protocol:re}=await s(K,1,void 0,W);return{protocol:re}}async function a(K,W,re){const{protocol:ye,firstMessage:de}=await s(K,2,W,re),ge=de&&de.debugPort;return{protocol:ye,debugPort:ge}}async function d(K,W,re){const ye=Date.now(),de=we(K,3),{protocol:ge}=await u(K,3,W,re);return K.logService.trace(`${de} 6/6. handshake finished, connection is up and running after ${oe(ye)}!`),ge}async function k(K,W,re){const{connectTo:ye,connectionToken:de}=await K.addressProvider.getAddress();return{commit:K.commit,quality:K.quality,connectTo:ye,connectionToken:de,reconnectionToken:W,reconnectionProtocol:re,remoteSocketFactoryService:K.remoteSocketFactoryService,signService:K.signService,logService:K.logService}}async function R(K,W,re){return w(K,async ye=>{const{protocol:de}=await l(ye,g.CancellationToken.None);return new Y(K,W,re,ye.reconnectionToken,de)})}e.$jl=R;async function v(K,W){return w(K,async re=>{const{protocol:ye,debugPort:de}=await a(re,W,g.CancellationToken.None);return new ue(K,W,re.reconnectionToken,ye,de)})}e.$kl=v;async function w(K,W){for(let ye=1;;ye++)try{const de=(0,L.$qg)(),ge=await k(K,de,null);return await W(ge)}catch(de){if(ye<5)K.logService.error(`[remote-connection][attempt ${ye}] An error occurred in initial connection! Will retry... Error:`),K.logService.error(de);else throw K.logService.error(`[remote-connection][attempt ${ye}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),K.logService.error(de),B.triggerPermanentFailure(0,0,m.$$k.isHandled(de)),de}}async function E(K,W,re){const ye=await k(K,(0,L.$qg)(),null);return await d(ye,{host:W,port:re},g.CancellationToken.None)}e.$ll=E;function P(K){return(0,D.$Tg)(W=>new Promise((re,ye)=>{const de=setTimeout(re,K*1e3);W.onCancellationRequested(()=>{clearTimeout(de),re()})}))}var N;(function(K){K[K.ConnectionLost=0]="ConnectionLost",K[K.ReconnectionWait=1]="ReconnectionWait",K[K.ReconnectionRunning=2]="ReconnectionRunning",K[K.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",K[K.ConnectionGain=4]="ConnectionGain"})(N||(e.PersistentConnectionEventType=N={}));class U{constructor(W,re){this.reconnectionToken=W,this.millisSinceLastIncomingData=re,this.type=0}}e.$ml=U;class F{constructor(W,re,ye,de){this.reconnectionToken=W,this.millisSinceLastIncomingData=re,this.durationSeconds=ye,this.c=de,this.type=1}skipWait(){this.c.cancel()}}e.$nl=F;class j{constructor(W,re,ye){this.reconnectionToken=W,this.millisSinceLastIncomingData=re,this.attempt=ye,this.type=2}}e.$ol=j;class T{constructor(W,re,ye){this.reconnectionToken=W,this.millisSinceLastIncomingData=re,this.attempt=ye,this.type=4}}e.$pl=T;class M{constructor(W,re,ye,de){this.reconnectionToken=W,this.millisSinceLastIncomingData=re,this.attempt=ye,this.handled=de,this.type=3}}e.$ql=M;class B extends b.$Tc{static triggerPermanentFailure(W,re,ye){this._permanentFailure=!0,this.f=W,this.g=re,this.h=ye,this.j.forEach(de=>de.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(W=>W.y())}static debugPauseSocketWriting(){this.j.forEach(W=>W.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||B._permanentFailure}constructor(W,re,ye,de,ge){super(),this.t=W,this.u=re,this.reconnectionToken=ye,this.protocol=de,this.w=ge,this.m=this.B(new A.$Vd),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new T(this.reconnectionToken,0,0)),this.B(de.onSocketClose(x=>{const te=_(this.t,this.reconnectionToken,!0);x?x.type===0?(this.u.logService.info(`${te} received socket close event (hadError: ${x.hadError}).`),x.error&&this.u.logService.error(x.error)):(this.u.logService.info(`${te} received socket close event (wasClean: ${x.wasClean}, code: ${x.code}, reason: ${x.reason}).`),x.event&&this.u.logService.error(x.event)):this.u.logService.info(`${te} received socket close event.`),this.y()})),this.B(de.onSocketTimeout(x=>{const te=_(this.t,this.reconnectionToken,!0);this.u.logService.info(`${te} received socket timeout event (unacknowledgedMsgCount: ${x.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${x.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${x.timeSinceLastReceivedSomeData}).`),this.y()})),B.j.push(this),this.B((0,b.$Rc)(()=>{const x=B.j.indexOf(this);x>=0&&B.j.splice(x,1)})),this.n&&this.D(B.f,B.g,B.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const W=_(this.t,this.reconnectionToken,!0);this.u.logService.info(`${W} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const re=[0,5,5,10,10,10,10,10,30];let ye=-1;do{ye++;const de=ye<re.length?re[ye]:re[re.length-1];try{if(de>0){const x=P(de);this.m.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),de,x)),this.u.logService.info(`${W} waiting for ${de} seconds before reconnecting...`);try{await x}catch{}}if(this.n){this.u.logService.error(`${W} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ye+1)),this.u.logService.info(`${W} resolving connection...`);const ge=await k(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${W} connecting to ${ge.connectTo}...`),await this.G(ge,o(S)),this.u.logService.info(`${W} reconnected!`),this.m.fire(new T(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ye+1));break}catch(ge){if(ge.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${W} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(ge),this.C(this.protocol.getMillisSinceLastIncomingData(),ye+1,!1);break}if(ye>360){this.u.logService.error(`${W} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(ge),this.C(this.protocol.getMillisSinceLastIncomingData(),ye+1,!1);break}if(m.$$k.isTemporarilyNotAvailable(ge)){this.u.logService.info(`${W} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ge);continue}if((ge.code==="ETIMEDOUT"||ge.code==="ENETUNREACH"||ge.code==="ECONNREFUSED"||ge.code==="ECONNRESET")&&ge.syscall==="connect"){this.u.logService.info(`${W} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ge);continue}if((0,I.$4)(ge)){this.u.logService.info(`${W} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ge);continue}if(ge instanceof m.$$k){this.u.logService.error(`${W} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(ge),this.C(this.protocol.getMillisSinceLastIncomingData(),ye+1,m.$$k.isHandled(ge));break}this.u.logService.error(`${W} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(ge),this.C(this.protocol.getMillisSinceLastIncomingData(),ye+1,!1);break}}while(!this.n&&!this.s)}C(W,re,ye){this.w?B.triggerPermanentFailure(W,re,ye):this.D(W,re,ye)}D(W,re,ye){this.m.fire(new M(this.reconnectionToken,W,re,ye)),Z(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$rl=B;class Y extends B{constructor(W,re,ye,de,ge){super(1,W,de,ge,!0),this.client=this.B(new C.$Rh(ge,{remoteAuthority:re,clientId:ye},W.ipcLogger))}async G(W,re){await l(W,re)}}e.$sl=Y;class ue extends B{constructor(W,re,ye,de,ge){super(2,W,ye,de,!1),this.H=re,this.debugPort=ge}async G(W,re){await a(W,this.H,re)}}e.$tl=ue;function Z(K){try{K.acceptDisconnect();const W=K.getSocket();K.dispose(),W.dispose()}catch(W){(0,I.$1)(W)}}function J(K){if(K&&K.type==="error"){const W=new Error(`Connection error: ${K.reason}`);return W.code="VSCODE_CONNECTION_ERROR",W}return null}function X(K,W){for(;K.length<W;)K+=" ";return K}function he(K,W){return`[remote-connection][${X(f(K),13)}][${W.substr(0,5)}\u2026]`}function _(K,W,re){return`${he(K,W)}[${re?"reconnect":"initial"}]`}function we(K,W){return`${_(W,K.reconnectionToken,!!K.reconnectionProtocol)}[${K.connectTo}]`}function oe(K){return`${Date.now()-K} ms`}}),define(ke[257],Se([1,0,3,5]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gl=e.$fl=void 0,e.$fl=(0,O.$6h)("remoteSocketFactoryService");class g{constructor(){this.a={}}register(A,b){return this.a[A]??=[],this.a[A].push(b),(0,D.$Rc)(()=>{const $=this.a[A]?.indexOf(b);typeof $=="number"&&$>=0&&this.a[A]?.splice($,1)})}b(A){return(this.a[A.type]||[]).find($=>$.supports(A))}connect(A,b,$,y){const L=this.b(A);if(!L)throw new Error(`No socket factory found for ${A}`);return L.connect(A,b,$,y)}}e.$gl=g}),define(ke[258],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$h7b=void 0;class D{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(g){try{const I=await this.c();if(I){const A=String(D.a++);return this.b.set(A,I),{id:A,data:I.createNewMessage(g)}}}catch{}return{id:"",data:g}}async validate(g,I){if(!g.id)return!0;const A=this.b.get(g.id);if(!A)return!1;this.b.delete(g.id);try{return A.validate(I)==="ok"}catch{return!1}finally{A.dispose?.()}}async sign(g){try{return await this.d(g)}catch{}return g}}e.$h7b=D}),define(ke[109],Se([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$il=e.$hl=void 0,e.$hl="signService",e.$il=(0,D.$6h)(e.$hl)}),define(ke[138],Se([1,0,258]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$c_b=void 0;class O extends D.$h7b{c(){return this.h().then(I=>new I.validator)}d(I){return this.h().then(A=>new A.signer().sign(I))}h(){return new Promise((I,A)=>me(["vsda"],I,A))}}e.$c_b=O}),define(ke[259],Se([1,0,10,49,30]),function(me,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ko=e.$Jo=void 0;function I($){if(D.$u===2&&/^penguin(\.|$)/i.test($))return"chromebook"}function A($,y,L,C,m,p,S,h,f){const o=Object.create(null);o["common.machineId"]=p,o["common.sqmId"]=S,o.sessionID=(0,g.$qg)()+Date.now(),o.commitHash=C,o.version=m,o["common.platformVersion"]=($||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),o["common.platform"]=(0,D.$h)(D.$u),o["common.nodePlatform"]=O.$dc,o["common.nodeArch"]=L,o["common.product"]=f||"desktop",h&&(o["common.msftInternal"]=h);let i=0;const r=Date.now();Object.defineProperties(o,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-r,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),D.$l&&(o["common.snap"]="true");const n=I(y);return n&&(o["common.platformDetail"]=n),o}e.$Jo=A;function b($){const y=O.env.USERDNSDOMAIN;if(!y)return!1;const L=y.toLowerCase();return $.some(C=>L===C)}e.$Ko=b}),define(ke[260],Se([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$El=e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=e.$wl=e.$vl=e.$ul=void 0,e.$ul=(0,D.$6h)("telemetryService"),e.$vl=(0,D.$6h)("customEndpointTelemetryService"),e.$wl="telemetry.currentSessionDate",e.$xl="telemetry.firstSessionDate",e.$yl="telemetry.lastSessionDate",e.$zl="telemetry.machineId",e.$Al="telemetry.sqmId",e.$Bl="telemetry",e.$Cl="telemetry.telemetryLevel",e.$Dl="telemetry.enableCrashReporter",e.$El="telemetry.enableTelemetry";var O;(function(I){I[I.NONE=0]="NONE",I[I.CRASH=1]="CRASH",I[I.ERROR=2]="ERROR",I[I.USAGE=3]="USAGE"})(O||(e.TelemetryLevel=O={}));var g;(function(I){I.OFF="off",I.CRASH="crash",I.ERROR="error",I.ON="all"})(g||(e.TelemetryConfiguration=g={}))}),define(ke[87],Se([1,0,24,18,65,259,260]),function(me,e,D,O,g,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=e.$Mo=e.$Lo=void 0;class b{constructor(u){this.value=u,this.isTrustedTelemetryValue=!0}}e.$Lo=b;class ${constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$Mo=$,e.$No=new $;class y{async publicLog(u,s,l){}async publicLogError(u,s,l){}}e.$Oo=y,e.$Po="telemetry",e.$Qo="extensionTelemetryLog",e.$Ro={log:()=>null,flush:()=>Promise.resolve(null)};function L(t,u){return!u.isBuilt&&!u.disableTelemetry?!0:!(u.disableTelemetry||!t.enableTelemetry)}e.$So=L;function C(t,u){return u.extensionTestsLocationURI?!0:!(u.isBuilt||u.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}e.$To=C;function m(t){const u=t.getValue(A.$Cl),s=t.getValue(A.$Dl);if(t.getValue(A.$El)===!1||s===!1)return 0;switch(u??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$Uo=m;function p(t){const u={},s={},l={};f(t,l);for(let a in l){a=a.length>150?a.substr(a.length-149):a;const d=l[a];typeof d=="number"?s[a]=d:typeof d=="boolean"?s[a]=d?1:0:typeof d=="string"?(d.length>8192&&console.warn(`Telemetry property: ${a} has been trimmed to 8192, the original length is ${d.length}`),u[a]=d.substring(0,8191)):typeof d<"u"&&d!==null&&(u[a]=d)}return{properties:u,measurements:s}}e.$Vo=p;const S=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function h(t){if(!t)return"none";const u=(0,g.$bl)(t);return S.has(u)?u:"other"}e.$Wo=h;function f(t,u,s=0,l){if(t)for(const a of Object.getOwnPropertyNames(t)){const d=t[a],k=l?l+a:a;Array.isArray(d)?u[k]=(0,D.$An)(d):d instanceof Date?u[k]=d.toISOString():(0,O.$Kf)(d)?s<2?f(d,u,s+1,k+"."):u[k]=(0,D.$An)(d):u[k]=d}}function o(t,u){const s=t.msftInternalDomains||[],l=u.getValue("telemetry.internalTesting");return(0,I.$Ko)(s)||l}e.$Xo=o;function i(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}e.$Yo=i;function r(t,u){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let s=t;const l=[];for(const R of u)for(;;){const v=R.exec(t);if(!v)break;l.push([v.index,R.lastIndex])}const a=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,d=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let k=0;for(s="";;){const R=d.exec(t);if(!R)break;const v=l.some(([w,E])=>R.index<E&&w<d.lastIndex);!a.test(R[0])&&!v&&(s+=t.substring(k,R.index)+"<REDACTED: user-file-path>",k=d.lastIndex)}return k<t.length&&(s+=t.substr(k)),s}function n(t){if(!t)return t;const u=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const s of u)if(s.regex.test(t))return`<REDACTED: ${s.label}>`;return t}function c(t,u){return(0,D.$xn)(t,s=>{if(s instanceof b||Object.hasOwnProperty.call(s,"isTrustedTelemetryValue"))return s.value;if(typeof s=="string"){let l=s.replaceAll("%20"," ");l=r(l,u);for(const a of u)l=l.replace(a,"");return l=n(l),l}})}e.$Zo=c}),define(ke[261],Se([1,0,12,134,26,10,2,14,49,87]),function(me,e,D,O,g,I,A,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=e.$2o=e.$1o=void 0;function L(s,l){return s.uuid&&l.uuid?s.uuid===l.uuid:s.id===l.id?!0:(0,D.$7e)(s.id,l.id)===0}e.$1o=L;const C=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class m{static create(l){const a=l.manifest?l.manifest.version:l.version,d=l.manifest?l.targetPlatform:l.properties.targetPlatform;return new m(l.identifier,a,d)}static parse(l){const a=C.exec(l);return a&&a[1]&&a[2]?new m({id:a[1]},a[2],a[4]||void 0):null}constructor(l,a,d="undefined"){this.version=a,this.targetPlatform=d,this.id=l.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(l){return l instanceof m?L(this,l)&&this.version===l.version&&this.targetPlatform===l.targetPlatform:!1}}e.$2o=m;const p=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function S(s){const l=p.exec(s);return l&&l[1]?[f(l[1]),l[2]]:[f(s),void 0]}e.$3o=S;function h(s,l){return`${s}.${l}`}e.$4o=h;function f(s){return s.toLowerCase()}e.$5o=f;function o(s,l){return f(h(s??g.$hm,l))}e.$6o=o;function i(s,l){const a=[],d=k=>{for(const R of a)if(R.some(v=>L(l(v),l(k))))return R;return null};for(const k of s){const R=d(k);R?R.push(k):a.push([k])}return a}e.$7o=i;function r(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}e.$8o=r;function n(s){return{id:new y.$Lo(s.identifier.id),name:new y.$Lo(s.name),galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),isSigned:s.isSigned,...s.telemetryData}}e.$9o=n,e.$0o=new g.$lm("pprice.better-merge");function c(s,l){const a=[],d=l.manifest.extensionDependencies?.slice(0)??[];for(;d.length;){const k=d.shift();if(k&&a.every(R=>!L(R.identifier,{id:k}))){const R=s.filter(v=>L(v.identifier,{id:k}));R.length===1&&(a.push(R[0]),d.push(...R[0].manifest.extensionDependencies?.slice(0)??[]))}}return a}e.$$o=c;async function t(s,l){if(!I.$k)return!1;let a;try{a=(await s.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{a=(await s.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(k){l.debug("Error while getting the os-release file.",(0,b.$0)(k))}}return!!a&&(a.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function u(s,l){const a=await t(s,l),d=(0,O.$uo)(a?"alpine":I.$u,$.$ec);return l.debug("ComputeTargetPlatform:",d),d}e.$_o=u}),define(ke[262],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rr=e.$Qr=e.$Pr=e.$Or=e.$Nr=e.$Mr=void 0;function D($){return[...$.entries()]}e.$Mr=D;function O($){return $?[...$.entries()]:[]}e.$Nr=O;function g($){return new Map($)}e.$Or=g;function I($){return new Map($??[])}e.$Pr=I;function A($){return Array.from($.entries()).map(y=>[y[0],D(y[1].map),O(y[1].descriptionMap)])}e.$Qr=A;function b($){return new Map($.map(y=>[y[0],{map:g(y[1]),descriptionMap:I(y[2])}]))}e.$Rr=b}),define(ke[263],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Krb=void 0;class D{constructor(g){this.b=g,this.a=new Map}dispose(){for(const g of this.a.values())g.dispose()}startBuffering(g,I,A=5){const b=I($=>{const y=typeof $=="string"?$:$.data;let L=this.a.get(g);if(L){L.data.push(y);return}const C=setTimeout(()=>this.flushBuffer(g),A);L={data:[y],timeoutId:C,dispose:()=>{clearTimeout(C),this.flushBuffer(g),b.dispose()}},this.a.set(g,L)});return b}stopBuffering(g){this.a.get(g)?.dispose()}flushBuffer(g){const I=this.a.get(g);I&&(this.a.delete(g),this.b(g,I.data.join("")))}}e.$Krb=D}),define(ke[264],Se([1,0,11,78,61,4,18,2,207,108,37]),function(me,e,D,O,g,I,A,b,$,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ew=e.$Dw=e.$Cw=e.$Bw=e.$Aw=e.$zw=e.$yw=e.$xw=e.IconFontDefinition=e.IconContribution=e.$ww=void 0,e.$ww={IconContribution:"base.contributions.icons"};var C;(function(n){function c(t,u){let s=t.defaults;for(;g.ThemeIcon.isThemeIcon(s);){const l=S.getIcon(s.id);if(!l)return;s=l.defaults}return s}n.getDefinition=c})(C||(e.IconContribution=C={}));var m;(function(n){function c(u){return{weight:u.weight,style:u.style,src:u.src.map(s=>({format:s.format,location:s.location.toString()}))}}n.toJSONObject=c;function t(u){const s=l=>(0,A.$If)(l)?l:void 0;if(u&&Array.isArray(u.src)&&u.src.every(l=>(0,A.$If)(l.format)&&(0,A.$If)(l.location)))return{weight:s(u.weight),style:s(u.style),src:u.src.map(l=>({format:l.format,location:b.URI.parse(l.location)}))}}n.fromJSONObject=t})(m||(e.IconFontDefinition=m={}));class p{constructor(){this.a=new I.$Vd,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,$.localize)(0,null)},fontCharacter:{type:"string",description:(0,$.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${g.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(c,t,u,s){const l=this.b[c];if(l){if(u&&!l.description){l.description=u,this.d.properties[c].markdownDescription=`${u} $(${c})`;const k=this.e.enum.indexOf(c);k!==-1&&(this.e.enumDescriptions[k]=u),this.a.fire()}return l}const a={id:c,description:u,defaults:t,deprecationMessage:s};this.b[c]=a;const d={$ref:"#/definitions/icons"};return s&&(d.deprecationMessage=s),u&&(d.markdownDescription=`${u}: $(${c})`),this.d.properties[c]=d,this.e.enum.push(c),this.e.enumDescriptions.push(u||""),this.a.fire(),{id:c}}deregisterIcon(c){delete this.b[c],delete this.d.properties[c];const t=this.e.enum.indexOf(c);t!==-1&&(this.e.enum.splice(t,1),this.e.enumDescriptions.splice(t,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(c=>this.b[c])}getIcon(c){return this.b[c]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(c,t){const u=this.f[c];return u||(this.f[c]=t,this.a.fire(),t)}deregisterIconFont(c){delete this.f[c]}getIconFont(c){return this.f[c]}toString(){const c=(l,a)=>l.id.localeCompare(a.id),t=l=>{for(;g.ThemeIcon.isThemeIcon(l.defaults);)l=this.b[l.defaults.id];return`codicon codicon-${l?l.id:""}`},u=[];u.push("| preview     | identifier                        | default codicon ID                | description"),u.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const s=Object.keys(this.b).map(l=>this.b[l]);for(const l of s.filter(a=>!!a.description).sort(c))u.push(`|<i class="${t(l)}"></i>|${l.id}|${g.ThemeIcon.isThemeIcon(l.defaults)?l.defaults.id:l.id}|${l.description||""}|`);u.push("| preview     | identifier                        "),u.push("| ----------- | --------------------------------- |");for(const l of s.filter(a=>!g.ThemeIcon.isThemeIcon(a.defaults)).sort(c))u.push(`|<i class="${t(l)}"></i>|${l.id}|`);return u.join(`
`)}}const S=new p;L.$Hn.add(e.$ww.IconContribution,S);function h(n,c,t,u){return S.registerIcon(n,c,t,u)}e.$xw=h;function f(){return S}e.$yw=f;function o(){const n=(0,O.$0j)();for(const c in n){const t="\\"+n[c].toString(16);S.registerIcon(c,{fontCharacter:t})}}o(),e.$zw="vscode://schemas/icons";const i=L.$Hn.as(y.$In.JSONContribution);i.registerSchema(e.$zw,S.getIconSchema());const r=new D.$fh(()=>i.notifySchemaChanged(e.$zw),200);S.onDidChange(()=>{r.isScheduled()||r.schedule()}),e.$Aw=h("widget-close",O.$_j.close,(0,$.localize)(2,null)),e.$Bw=h("goto-previous-location",O.$_j.arrowUp,(0,$.localize)(3,null)),e.$Cw=h("goto-next-location",O.$_j.arrowDown,(0,$.localize)(4,null)),e.$Dw=g.ThemeIcon.modify(O.$_j.sync,"spin"),e.$Ew=g.ThemeIcon.modify(O.$_j.loading,"spin")}),define(ke[88],Se([1,0,4,51,5,13]),function(me,e,D,O,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kv=e.$Jv=e.$Iv=e.$Hv=e.$Gv=e.$Fv=e.$Ev=e.$Dv=e.ProvidedOnAutoForward=e.$Cv=e.TunnelPrivacyId=e.TunnelProtocol=e.$Bv=e.$Av=void 0,e.$Av=(0,g.$6h)("tunnelService"),e.$Bv=(0,g.$6h)("sharedTunnelsService");var A;(function(f){f.Http="http",f.Https="https"})(A||(e.TunnelProtocol=A={}));var b;(function(f){f.ConstantPrivate="constantPrivate",f.Private="private",f.Public="public"})(b||(e.TunnelPrivacyId=b={}));function $(f){return!!f.forwardPort}e.$Cv=$;var y;(function(f){f[f.Notify=1]="Notify",f[f.OpenBrowser=2]="OpenBrowser",f[f.OpenPreview=3]="OpenPreview",f[f.Silent=4]="Silent",f[f.Ignore=5]="Ignore",f[f.OpenBrowserOnce=6]="OpenBrowserOnce"})(y||(e.ProvidedOnAutoForward=y={}));function L(f){if(f.scheme!=="http"&&f.scheme!=="https")return;const o=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(f.authority);if(o)return{address:o[1],port:+o[2]}}e.$Dv=L,e.$Ev=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function C(f){return e.$Ev.indexOf(f)>=0}e.$Fv=C,e.$Gv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function m(f){return e.$Gv.indexOf(f)>=0}e.$Hv=m;function p(f,o,i,r){if(i===1)return!1;if(i===2&&m(o)){const n=/(\d+)\.(\d+)\.(\d+)/g.exec(r);if(n?.length===4&&parseInt(n[1])>=18)return!1}return f<1024}e.$Iv=p;class S{constructor(o,i,r){this.remoteAddress=o,this.localAddress=i,this.b=r,this.a=new D.$Vd,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Jv=S;let h=class{constructor(o,i){this.k=o,this.l=i,this.a=new D.$Vd,this.onTunnelOpened=this.a.event,this.b=new D.$Vd,this.onTunnelClosed=this.b.event,this.c=new D.$Vd,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const o=this.l.getValue("remote.localPortHost");return!o||o==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(o){return this.f=o,o?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(o){this.g=o.elevation,this.i=o.privacyOptions,this.h=o.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const o=[],i=Array.from(this.e.values());for(const r of i){const n=Array.from(r.values());for(const c of n){const t=await c.value;t&&typeof t!="string"&&o.push(t)}}return o}async dispose(){for(const o of this.e.values()){for(const{value:i}of o.values())await i.then(r=>typeof r!="string"?r?.dispose():void 0);o.clear()}this.e.clear()}setEnvironmentTunnel(o,i,r,n,c){this.q(o,i,Promise.resolve({tunnelRemoteHost:o,tunnelRemotePort:i,localAddress:r,privacy:n,protocol:c,dispose:()=>Promise.resolve()}))}async getExistingTunnel(o,i){(m(o)||C(o))&&(o=e.$Ev[0]);const r=this.s(o,i);if(r)return++r.refcount,r.value}openTunnel(o,i,r,n,c,t=!1,u,s){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${i}:${r} on local port ${c}.`);const l=this.f??o;if(!l)return;if(i||(i="localhost"),n||(n=this.m),this.f&&this.j.has(r)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const a=this.t(l,i,r,n,c,t,u,s);return a?a.then(d=>{if(d){if(typeof d=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(i,r),d}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(i,r);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const k=this.o(d);return(d.tunnelRemoteHost!==i||d.tunnelRemotePort!==r)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),u&&d.privacy!==u&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(k),k}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),a)}o(o){return{tunnelRemotePort:o.tunnelRemotePort,tunnelRemoteHost:o.tunnelRemoteHost,tunnelLocalPort:o.tunnelLocalPort,localAddress:o.localAddress,privacy:o.privacy,protocol:o.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${o.tunnelRemoteHost}:${o.tunnelRemotePort} `);const i=this.e.get(o.tunnelRemoteHost);if(i){const r=i.get(o.tunnelRemotePort);r&&(r.refcount--,await this.p(o.tunnelRemoteHost,o.tunnelRemotePort,r))}}}}async p(o,i,r){if(r.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${o}:${i}.`);const n=r.value.then(async c=>{c&&typeof c!="string"&&(await c.dispose(!0),this.b.fire({host:c.tunnelRemoteHost,port:c.tunnelRemotePort}))});return this.e.has(o)&&this.e.get(o).delete(i),n}}async closeTunnel(o,i){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${o}:${i} `);const r=this.e.get(o);if(r&&r.has(i)){const n=r.get(i);n.refcount=0,await this.p(o,i,n)}}q(o,i,r){this.e.has(o)||this.e.set(o,new Map),this.e.get(o).set(i,{refcount:1,value:r})}async r(o,i){const r=this.e.get(o);if(r){const n=r.get(i),c=n?await n.value:void 0;(!c||typeof c=="string")&&r.delete(i),r.size===0&&this.e.delete(o)}}s(o,i){const r=[o];C(o)?(r.push(...e.$Ev),r.push(...e.$Gv)):m(o)&&r.push(...e.$Gv);const n=r.map(c=>this.e.get(c));for(const c of n){const t=c?.get(i);if(t)return t}}canTunnel(o){return!!L(o)}u(o,i,r,n,c,t,u){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${i}:${r} on local port ${n}.`);const s=r;this.j.add(s);const l=n===void 0?r:n,a={elevationRequired:c?this.isPortPrivileged(l):!1},d={remoteAddress:{host:i,port:r},localAddressPort:n,privacy:t,public:t?t!==b.Private:void 0,protocol:u},k=o.forwardPort(d,a);return k?(this.q(i,r,k),k.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(s)})):this.j.delete(s),k}};e.$Kv=h,e.$Kv=h=Ge([We(0,I.$nj),We(1,O.$zi)],h)}),define(ke[265],Se([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1k=void 0,e.$1k=(0,D.$6h)("IUriIdentityService")}),define(ke[266],Se([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$Lv=void 0,e.$Lv=(0,D.$6h)("editSessionIdentityService");var O;(function(g){g[g.Complete=100]="Complete",g[g.Partial=50]="Partial",g[g.None=0]="None"})(O||(e.EditSessionIdentityMatch=O={}))}),define(ke[267],Se([1,0,17]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GK=e.$FK=e.$EK=e.$DK=e.$CK=void 0;function O($){return $.scheme!==D.Schemas.file&&$.scheme!==D.Schemas.vscodeRemote}e.$CK=O;function g($){if($.folders.length)return $.folders.every(y=>O(y.uri))?$.folders[0].uri:void 0;if($.configuration&&O($.configuration))return $.configuration}e.$DK=g;function I($){return g($)?.scheme}e.$EK=I;function A($){return g($)?.authority}e.$FK=A;function b($){return g($)!==void 0}e.$GK=b}),define(ke[40],Se([1,0,209,16,77,23,2,5,17]),function(me,e,D,O,g,I,A,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.$li=e.$ki=e.WorkbenchState=e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=e.$di=e.$ci=void 0,e.$ci=(0,b.$6h)("contextService");function y(l){const a=l;return typeof a?.id=="string"&&A.URI.isUri(a.uri)}e.$di=y;function L(l){return typeof l?.id=="string"&&!y(l)&&!m(l)}e.$ei=L,e.$fi={id:"ext-dev"},e.$gi={id:"empty-window"};function C(l,a){if(typeof l=="string"||typeof l>"u")return typeof l=="string"?{id:(0,O.$nc)(l)}:a?e.$fi:e.$gi;const d=l;return d.configuration?{id:d.id,configPath:d.configuration}:d.folders.length===1?{id:d.id,uri:d.folders[0].uri}:{id:d.id}}e.$hi=C;function m(l){const a=l;return typeof a?.id=="string"&&A.URI.isUri(a.configPath)}e.$ii=m;function p(l){const a=l;if(a?.uri)return{id:a.id,uri:A.URI.revive(a.uri)};const d=l;if(d?.configPath)return{id:d.id,configPath:A.URI.revive(d.configPath)};if(l?.id)return{id:l.id}}e.$ji=p;var S;(function(l){l[l.EMPTY=1]="EMPTY",l[l.FOLDER=2]="FOLDER",l[l.WORKSPACE=3]="WORKSPACE"})(S||(e.WorkbenchState=S={}));function h(l){const a=l;return!!(a&&typeof a=="object"&&typeof a.id=="string"&&Array.isArray(a.folders))}e.$ki=h;function f(l){const a=l;return!!(a&&typeof a=="object"&&A.URI.isUri(a.uri)&&typeof a.name=="string"&&typeof a.toResource=="function")}e.$li=f;class o{constructor(a,d,k,R,v){this.h=a,this.j=k,this.k=R,this.l=v,this.c=g.$_h.forUris(this.l,()=>!0),this.folders=d}update(a){this.h=a.id,this.k=a.configuration,this.j=a.transient,this.l=a.l,this.folders=a.folders}get folders(){return this.g}set folders(a){this.g=a,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(a){this.k=a}getFolder(a){return a&&this.c.findSubstr(a)||null}n(){this.c=g.$_h.forUris(this.l,()=>!0);for(const a of this.folders)this.c.set(a.uri,a)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$mi=o;class i{constructor(a,d){this.raw=d,this.uri=a.uri,this.index=a.index,this.name=a.name}toResource(a){return(0,I.$Hg)(this.uri,a)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$ni=i;function r(l){return new i({uri:l,index:0,name:(0,I.$Dg)(l)},{uri:l.toString()})}e.$oi=r,e.$pi="code-workspace",e.$qi=`.${e.$pi}`,e.$ri=[{name:(0,D.localize)(0,null),extensions:[e.$pi]}],e.$si="workspace.json";function n(l,a){return I.$yg.isEqualOrParent(l,a.untitledWorkspacesHome)}e.$ti=n;function c(l){let a;return A.URI.isUri(l)?a=l:a=l.configuration,a?.scheme===$.Schemas.tmp}e.$ui=c,e.$vi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(l){return l.id===e.$vi}e.$wi=t;function u(l,a){return!n(l,a)&&!c(l)}e.$xi=u;function s(l){return(typeof l=="string"?(0,O.$oc)(l):(0,I.$Fg)(l))===e.$qi}e.$yi=s}),define(ke[268],Se([1,0,54,4,3,23,2,208,133,32,5,13,40,28,265,11,30,12,18]),function(me,e,D,O,g,I,A,b,$,y,L,C,m,p,S,h,f,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7k=e.$6k=e.$5k=e.$4k=e.$3k=e.$2k=e.ProfileResourceType=void 0;var r;(function(l){l.Settings="settings",l.Keybindings="keybindings",l.Snippets="snippets",l.Tasks="tasks",l.Extensions="extensions",l.GlobalState="globalState"})(r||(e.ProfileResourceType=r={}));function n(l){const a=l;return!!(a&&typeof a=="object"&&typeof a.id=="string"&&typeof a.isDefault=="boolean"&&typeof a.name=="string"&&A.URI.isUri(a.location)&&A.URI.isUri(a.globalStorageHome)&&A.URI.isUri(a.settingsResource)&&A.URI.isUri(a.keybindingsResource)&&A.URI.isUri(a.tasksResource)&&A.URI.isUri(a.snippetsHome)&&A.URI.isUri(a.extensionsResource))}e.$2k=n,e.$3k=(0,L.$6h)("IUserDataProfilesService");function c(l,a){return{id:l.id,isDefault:l.isDefault,name:l.name,shortName:l.shortName,icon:l.icon,location:A.URI.revive(l.location).with({scheme:a}),globalStorageHome:A.URI.revive(l.globalStorageHome).with({scheme:a}),settingsResource:A.URI.revive(l.settingsResource).with({scheme:a}),keybindingsResource:A.URI.revive(l.keybindingsResource).with({scheme:a}),tasksResource:A.URI.revive(l.tasksResource).with({scheme:a}),snippetsHome:A.URI.revive(l.snippetsHome).with({scheme:a}),extensionsResource:A.URI.revive(l.extensionsResource).with({scheme:a}),cacheHome:A.URI.revive(l.cacheHome).with({scheme:a}),useDefaultFlags:l.useDefaultFlags,isTransient:l.isTransient}}e.$4k=c;function t(l,a,d,k,R,v){return{id:l,name:a,location:d,isDefault:!1,shortName:R?.shortName,icon:R?.icon,globalStorageHome:v&&R?.useDefaultFlags?.globalState?v.globalStorageHome:(0,I.$Hg)(d,"globalStorage"),settingsResource:v&&R?.useDefaultFlags?.settings?v.settingsResource:(0,I.$Hg)(d,"settings.json"),keybindingsResource:v&&R?.useDefaultFlags?.keybindings?v.keybindingsResource:(0,I.$Hg)(d,"keybindings.json"),tasksResource:v&&R?.useDefaultFlags?.tasks?v.tasksResource:(0,I.$Hg)(d,"tasks.json"),snippetsHome:v&&R?.useDefaultFlags?.snippets?v.snippetsHome:(0,I.$Hg)(d,"snippets"),extensionsResource:v&&R?.useDefaultFlags?.extensions?v.extensionsResource:(0,I.$Hg)(d,"extensions.json"),cacheHome:(0,I.$Hg)(k,l),useDefaultFlags:R?.useDefaultFlags,isTransient:R?.transient}}e.$5k=t;let u=class extends g.$Tc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(a,d,k,R){super(),this.t=a,this.u=d,this.w=k,this.y=R,this.f=!0,this.h=this.B(new O.$Vd),this.onDidChangeProfiles=this.h.event,this.j=this.B(new O.$Vd),this.onWillCreateProfile=this.j.event,this.m=this.B(new O.$Vd),this.onWillRemoveProfile=this.m.event,this.n=this.B(new O.$Vd),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new p.$Ac,emptyWindows:new Map},this.profilesHome=(0,I.$Hg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,I.$Hg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(a){this.f!==a&&(this.z=void 0,this.f=a)}isEnabled(){return this.f}get C(){if(!this.z){const a=this.D(),d=[a];if(this.f)try{for(const v of this.O()){if(!v.name||!(0,i.$If)(v.name)||!v.location){this.y.warn("Skipping the invalid stored profile",v.location||v.name);continue}d.push(t((0,I.$Eg)(v.location),v.name,v.location,this.g,{shortName:v.shortName,icon:v.icon,useDefaultFlags:v.useDefaultFlags},a))}}catch(v){this.y.error(v)}const k=new p.$Ac,R=new Map;if(d.length)try{const v=this.Q();if(v.workspaces)for(const[w,E]of Object.entries(v.workspaces)){const P=A.URI.parse(w),N=d.find(U=>U.id===E);N&&k.set(P,N)}if(v.emptyWindows)for(const[w,E]of Object.entries(v.emptyWindows)){const P=d.find(N=>N.id===E);P&&R.set(w,P)}}catch(v){this.y.error(v)}this.z={profiles:d,workspaces:k,emptyWindows:R}}return this.z}D(){const a=t("__default__profile__",(0,b.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...a,extensionsResource:this.S()??a.extensionsResource,isDefault:!0}}async createTransientProfile(a){const d="Temp",k=new RegExp(`${(0,o.$Oe)(d)}\\s(\\d+)`);let R=0;for(const w of this.profiles){const E=k.exec(w.name),P=E?parseInt(E[1]):0;R=P>R?P:R}const v=`${d} ${R+1}`;return this.createProfile((0,D.$Ti)((0,f.$qg)()).toString(16),v,{transient:!0},a)}async createNamedProfile(a,d,k){return this.createProfile((0,D.$Ti)((0,f.$qg)()).toString(16),a,d,k)}async createProfile(a,d,k,R){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const v=await this.F(a,d,k);return R&&await this.setProfileForWorkspace(R,v),v}async F(a,d,k){if(!(0,i.$If)(d)||!d)throw new Error("Name of the profile is mandatory and must be of type `string`");let R=this.r.get(d);return R||(R=(async()=>{try{const v=this.profiles.find(P=>P.name===d||P.id===a);if(v)return v;const w=t(a,d,(0,I.$Hg)(this.profilesHome,a),this.g,k,this.defaultProfile);await this.u.createFolder(w.location);const E=[];return this.j.fire({profile:w,join(P){E.push(P)}}),await h.Promises.settled(E),this.I([w],[],[]),w}finally{this.r.delete(d)}})(),this.r.set(d,R)),R}async updateProfile(a,d){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let k=this.profiles.find(R=>R.id===a.id);if(!k)throw new Error(`Profile '${a.name}' does not exist`);return k=t(k.id,d.name??k.name,k.location,this.g,{shortName:d.shortName??k.shortName,icon:d.icon===null?void 0:d.icon??k.icon,transient:d.transient??k.isTransient,useDefaultFlags:d.useDefaultFlags??k.useDefaultFlags},this.defaultProfile),this.I([],[],[k]),k}async removeProfile(a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(a.isDefault)throw new Error("Cannot remove default profile");const d=this.profiles.find(R=>R.id===a.id);if(!d)throw new Error(`Profile '${a.name}' does not exist`);const k=[];this.m.fire({profile:d,join(R){k.push(R)}});try{await Promise.allSettled(k)}catch(R){this.y.error(R)}for(const R of[...this.C.emptyWindows.keys()])d.id===this.C.emptyWindows.get(R)?.id&&this.C.emptyWindows.delete(R);for(const R of[...this.C.workspaces.keys()])d.id===this.C.workspaces.get(R)?.id&&this.C.workspaces.delete(R);this.M(),this.I([],[d],[]);try{await this.u.del(d.cacheHome,{recursive:!0})}catch(R){(0,y.$Hk)(R)!==1&&this.y.error(R)}}async setProfileForWorkspace(a,d){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const k=this.profiles.find(R=>R.id===d.id);if(!k)throw new Error(`Profile '${d.name}' does not exist`);this.L(a,k)}unsetWorkspace(a,d){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(a,void 0,d)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const a=await this.u.resolve(this.profilesHome);await Promise.all((a.children||[]).filter(d=>d.isDirectory&&this.profiles.every(k=>!this.w.extUri.isEqual(k.location,d.resource))).map(d=>this.u.del(d.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const a=this.s.profiles.filter(d=>!this.H(d));await Promise.allSettled(a.map(d=>this.removeProfile(d)))}getProfileForWorkspace(a){const d=this.G(a);return A.URI.isUri(d)?this.s.workspaces.get(d)??this.C.workspaces.get(d):this.s.emptyWindows.get(d)??this.C.emptyWindows.get(d)}G(a){return(0,m.$di)(a)?a.uri:(0,m.$ii)(a)?a.configPath:a.id}H(a){return!!([...this.s.emptyWindows.values()].some(d=>this.w.extUri.isEqual(d.location,a.location))||[...this.s.workspaces.values()].some(d=>this.w.extUri.isEqual(d.location,a.location))||[...this.C.emptyWindows.values()].some(d=>this.w.extUri.isEqual(d.location,a.location))||[...this.C.workspaces.values()].some(d=>this.w.extUri.isEqual(d.location,a.location)))}I(a,d,k){const R=[...this.profiles,...a],v=[];this.s.profiles=[];for(let w of R)w.isDefault||d.some(E=>w.id===E.id)||(w=k.find(E=>w.id===E.id)??w,w.isTransient?this.s.profiles.push(w):v.push({location:w.location,name:w.name,shortName:w.shortName,icon:w.icon,useDefaultFlags:w.useDefaultFlags}));this.P(v),this.z=void 0,this.J(a,d,k)}J(a,d,k){this.h.fire({added:a,removed:d,updated:k,all:this.profiles})}L(a,d,k){k=d?.isTransient?!0:k,k||this.L(a,void 0,!0);const R=this.G(a),v=k?this.s:this.C;A.URI.isUri(R)?(v.workspaces.delete(R),d&&v.workspaces.set(R,d)):(v.emptyWindows.delete(R),d&&v.emptyWindows.set(R,d)),k||this.M()}M(){const a={};for(const[k,R]of this.C.workspaces.entries())a[k.toString()]=R.id;const d={};for(const[k,R]of this.C.emptyWindows.entries())d[k.toString()]=R.id;this.R({workspaces:a,emptyWindows:d}),this.z=void 0}N(a){const d={},k=this.D();if(a.workspaces)for(const[v,w]of Object.entries(a.workspaces)){const E=A.URI.parse(w);d[v]=this.w.extUri.isEqual(E,k.location)?k.id:this.w.extUri.basename(E)}const R={};if(a.emptyWindows)for(const[v,w]of Object.entries(a.emptyWindows)){const E=A.URI.parse(w);R[v]=this.w.extUri.isEqual(E,k.location)?k.id:this.w.extUri.basename(E)}return{workspaces:d,emptyWindows:R}}O(){return[]}P(a){throw new Error("not implemented")}Q(){return{}}R(a){throw new Error("not implemented")}S(){}};e.$6k=u,e.$6k=u=Ge([We(0,$.$ai),We(1,y.$qk),We(2,S.$1k),We(3,C.$nj)],u);class s extends u{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(a){this.a=a}Q(){return this.X}R(a){this.X=a}}e.$7k=s}),define(ke[269],Se([1,0,11,4,3,57,18,188,5,268]),function(me,e,D,O,g,I,A,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zp=e.$yp=e.$xp=e.$wp=e.$vp=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$up=e.$tp=e.$sp=void 0,e.$sp="__$__isNewStorageMarker",e.$tp="__$__targetStorageMarker",e.$up=(0,$.$6h)("storageService");var L;(function(i){i[i.NONE=0]="NONE",i[i.SHUTDOWN=1]="SHUTDOWN"})(L||(e.WillSaveStateReason=L={}));var C;(function(i){i[i.APPLICATION=-1]="APPLICATION",i[i.PROFILE=0]="PROFILE",i[i.WORKSPACE=1]="WORKSPACE"})(C||(e.StorageScope=C={}));var m;(function(i){i[i.USER=0]="USER",i[i.MACHINE=1]="MACHINE"})(m||(e.StorageTarget=m={}));function p(i){const r=i.get(e.$tp);if(r)try{return JSON.parse(r)}catch{}return Object.create(null)}e.$vp=p;class S extends g.$Tc{static{this.a=60*1e3}constructor(r={flushInterval:S.a}){super(),this.m=r,this.b=this.B(new O.$Yd),this.c=this.B(new O.$Yd),this.onDidChangeTarget=this.c.event,this.f=this.B(new O.$Vd),this.onWillSaveState=this.f.event,this.h=this.B(new D.$fh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new g.$Uc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(r,n,c){return O.Event.filter(this.b.event,t=>t.scope===r&&(n===void 0||t.key===n),c)}n(){this.j.value=(0,D.$jh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,g.$Oc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,I.mark)("code/willInitStorage");try{await this.O()}finally{(0,I.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(r,n){const{key:c,external:t}=n;if(c===e.$tp){switch(r){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:r})}else this.b.fire({scope:r,key:c,target:this.J(r)[c],external:t})}w(r){this.f.fire({reason:r})}get(r,n,c){return this.P(n)?.get(r,c)}getBoolean(r,n,c){return this.P(n)?.getBoolean(r,c)}getNumber(r,n,c){return this.P(n)?.getNumber(r,c)}getObject(r,n,c){return this.P(n)?.getObject(r,c)}storeAll(r,n){this.y(()=>{for(const c of r)this.store(c.key,c.value,c.scope,c.target,n)})}store(r,n,c,t,u=!1){if((0,A.$Rf)(n)){this.remove(r,c,u);return}this.y(()=>{this.z(r,c,t),this.P(c)?.set(r,n,u)})}remove(r,n,c=!1){this.y(()=>{this.z(r,n,void 0),this.P(n)?.delete(r,c)})}y(r){this.b.pause(),this.c.pause();try{r()}finally{this.b.resume(),this.c.resume()}}keys(r,n){const c=[],t=this.J(r);for(const u of Object.keys(t))t[u]===n&&c.push(u);return c}z(r,n,c,t=!1){const u=this.J(n);typeof c=="number"?u[r]!==c&&(u[r]=c,this.P(n)?.set(e.$tp,JSON.stringify(u),t)):typeof u[r]=="number"&&(delete u[r],this.P(n)?.set(e.$tp,JSON.stringify(u),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(r){switch(r){case-1:return this.I;case 0:return this.G;default:return this.D}}L(r){const n=this.P(r);return n?p(n):Object.create(null)}isNew(r){return this.getBoolean(e.$sp,r)===!0}async flush(r=L.NONE){this.f.fire({reason:r});const n=this.P(-1),c=this.P(0),t=this.P(1);switch(r){case L.NONE:await D.Promises.settled([n?.whenFlushed()??Promise.resolve(),c?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case L.SHUTDOWN:await D.Promises.settled([n?.flush(0)??Promise.resolve(),c?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const r=this.P(-1)?.items??new Map,n=this.P(0)?.items??new Map,c=this.P(1)?.items??new Map;return o(r,n,c,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(r){return await this.flush(),this.P(r)?.optimize()}async switch(r,n){return this.w(L.NONE),(0,y.$2k)(r)?this.R(r,n):this.S(r,n)}M(r,n){return!(r.id===n.id||h(n)&&h(r))}N(r,n,c){this.y(()=>{const t=new Set;for(const[u,s]of r)t.add(u),n.get(u)!==s&&this.u(c,{key:u,external:!0});for(const[u]of n.items)t.has(u)||this.u(c,{key:u,external:!0})})}}e.$wp=S;function h(i){return i.isDefault||!!i.useDefaultFlags?.globalState}e.$xp=h;class f extends S{constructor(){super(),this.U=this.B(new b.$qp(new b.$rp,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new b.$qp(new b.$rp,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new b.$qp(new b.$rp,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(r=>this.u(1,r))),this.B(this.W.onDidChangeStorage(r=>this.u(0,r))),this.B(this.U.onDidChangeStorage(r=>this.u(-1,r)))}P(r){switch(r){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(r){switch(r){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(r){return!1}}e.$yp=f;async function o(i,r,n,c,t,u){const s=P=>{try{return JSON.parse(P)}catch{return P}},l=new Map,a=new Map;i.forEach((P,N)=>{l.set(N,P),a.set(N,s(P))});const d=new Map,k=new Map;r.forEach((P,N)=>{d.set(N,P),k.set(N,s(P))});const R=new Map,v=new Map;n.forEach((P,N)=>{R.set(N,P),v.set(N,s(P))}),console.group(c!==t?`Storage: Application (path: ${c})`:`Storage: Application & Profile (path: ${c}, default profile)`);const w=[];if(l.forEach((P,N)=>{w.push({key:N,value:P})}),console.table(w),console.groupEnd(),console.log(a),c!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const P=[];d.forEach((N,U)=>{P.push({key:U,value:N})}),console.table(P),console.groupEnd(),console.log(k)}console.group(`Storage: Workspace (path: ${u})`);const E=[];R.forEach((P,N)=>{E.push({key:N,value:P})}),console.table(E),console.groupEnd(),console.log(v)}e.$zp=o}),define(ke[110],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4fc=void 0;class D{static{this.a=!1}constructor(g){this.d=g,this.b=new Map,this.c=1}add(g){const I=this.c++;return this.b.set(I,g),this.e(),I}get(g,I){return this.b.has(g)?this.b.get(g)[I]:void 0}delete(g){this.b.delete(g),this.e()}e(){D.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$4fc=D}),define(ke[58],Se([1,0,17,23,5]),function(me,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8fc=e.$7fc=void 0;class I{constructor(){this.a=new Set(Object.keys(D.Schemas)),this.b=new Map,this.extUri=new O.$wg(b=>{const $=this.b.get(b.scheme);return!($===void 0||$&1024)})}$acceptProviderInfos(b,$){$===null?this.b.delete(b.scheme):this.b.set(b.scheme,$)}isFreeScheme(b){return!this.b.has(b)&&!this.a.has(b)}getCapabilities(b){return this.b.get(b)}}e.$7fc=I,e.$8fc=(0,g.$6h)("IExtHostFileSystemInfo")}),define(ke[27],Se([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nN=void 0,e.$nN=(0,D.$6h)("IExtHostInitDataService")}),define(ke[270],Se([1,0,214,13,250,27]),function(me,e,D,O,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bic=void 0;let A=class extends g.$uO{constructor($,y,L){const C=L.remote.isRemote?"remoteexthost":$?"workerexthost":"exthost",m=L.remote.isRemote?(0,D.localize)(0,null):$?(0,D.localize)(1,null):(0,D.localize)(2,null);super(y.createLogger(C,{name:m}))}};e.$bic=A,e.$bic=A=Ge([We(1,O.$oj),We(2,I.$nN)],A)}),define(ke[271],Se([1,0,11]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qgc=e.$Pgc=void 0;class O{constructor(A,b,$){this.h=new Map,this.a=A,this.b=b,this.c=$,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(y=>(this.f=y,this)),this.g=this.c.onDidChangeStorage(y=>{y.shared===this.b&&y.key===this.a&&(this.f=y.value)}),this.i=new D.$fh(()=>{const y=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const L of y.values())L.complete()}catch(L){for(const C of y.values())C.error(L)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this.d}get(A,b){let $=this.f[A];return typeof $>"u"&&($=b),$}update(A,b){this.f[A]=b;const $=this.h.get(A);if($!==void 0)return $.p;const y=new D.$qh;return this.h.set(A,y),this.i.isScheduled()||this.i.schedule(),y.p}dispose(){this.g.dispose()}}e.$Pgc=O;class g extends O{setKeysForSync(A){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},A)}constructor(A,b){super(A.identifier.value,!0,b),this.j=A}}e.$Qgc=g}),define(ke[272],Se([1,0,4,2]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dhc=void 0;class g{constructor(A){this.c=A,this.a=new D.$Vd,this.onDidSaveNotebookDocument=this.a.event,this.b=new D.$Vd,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(A,b,$,y){const C=this.c.getNotebookDocument(O.URI.revive(A)).acceptModelChanged(b.value,$,y);this.b.fire(C)}$acceptDirtyStateChanged(A,b){this.c.getNotebookDocument(O.URI.revive(A)).acceptDirty(b)}$acceptModelSaved(A){const b=this.c.getNotebookDocument(O.URI.revive(A));this.a.fire(b.apiNotebook)}}e.$Dhc=g}),define(ke[20],Se([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$M=e.$0M=void 0,e.$0M=(0,D.$6h)("IExtHostRpcService");class O{constructor(I){this.getProxy=I.getProxy.bind(I),this.set=I.set.bind(I),this.dispose=I.dispose.bind(I),this.assertRegistered=I.assertRegistered.bind(I),this.drain=I.drain.bind(I)}}e.$$M=O}),define(ke[273],Se([1,0,26,4]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xgc=void 0;class g{#e;constructor(A,b){this.b=new O.$Vd,this.onDidChange=this.b.event,this.a=D.$lm.toKey(A.identifier),this.#e=b,this.#e.onDidChangePassword($=>{$.extensionId===this.a&&this.b.fire({key:$.key})})}get(A){return this.#e.get(this.a,A)}store(A,b){return this.#e.store(this.a,A,b)}delete(A){return this.#e.delete(this.a,A)}}e.$Xgc=g}),define(ke[66],Se([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ogc=e.$ngc=void 0,e.$ngc=(0,D.$6h)("IURITransformerService");class O{constructor(I){I?(this.transformIncoming=I.transformIncoming.bind(I),this.transformOutgoing=I.transformOutgoing.bind(I),this.transformOutgoingURI=I.transformOutgoingURI.bind(I),this.transformOutgoingScheme=I.transformOutgoingScheme.bind(I)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.$ogc=O}),define(ke[274],Se([1,0,22]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dlb=e.$clb=void 0;class O{constructor(){this.buffers=[]}add($){let y=this.buffers.indexOf($);return y<0&&(y=this.buffers.length,this.buffers.push($)),y}}function g(b,$){if($.serializeBuffersForPostMessage){const y=new O,C=JSON.stringify(b,(p,S)=>{if(S instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:y.add(S)};if(ArrayBuffer.isView(S)){const h=I(S);if(h)return{$$vscode_array_buffer_reference$$:!0,index:y.add(S.buffer),view:{type:h,byteLength:S.byteLength,byteOffset:S.byteOffset}}}return S}),m=y.buffers.map(p=>{const S=new Uint8Array(p);return D.$je.wrap(S)});return{message:C,buffers:m}}else return{message:JSON.stringify(b),buffers:[]}}e.$clb=g;function I(b){switch(b.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function A(b,$){const y=$.map(m=>{const p=new ArrayBuffer(m.byteLength);return new Uint8Array(p).set(m.buffer),p}),L=$.length?(m,p)=>{if(p&&typeof p=="object"&&p.$$vscode_array_buffer_reference$$){const S=p,{index:h}=S,f=y[h];if(S.view)switch(S.view.type){case 1:return new Int8Array(f,S.view.byteOffset,S.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(f,S.view.byteOffset,S.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(f,S.view.byteOffset,S.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(f,S.view.byteOffset,S.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(f,S.view.byteOffset,S.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(f,S.view.byteOffset,S.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(f,S.view.byteOffset,S.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(f,S.view.byteOffset,S.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(f,S.view.byteOffset,S.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(f,S.view.byteOffset,S.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(f,S.view.byteOffset,S.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return f}return p}:void 0;return{message:JSON.parse(b,L),arrayBuffers:y}}e.$dlb=A}),define(ke[275],Se([1,0,276,387,388,62,2,13,389]),function(me,e,D,O,g,I,A,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jic=void 0;const y=!1;function L(r,n,c,t,u,s){const l=s.environment.useHostProxy,a=typeof l=="boolean"?l:!s.remote.isRemote,d={resolveProxy:v=>r.resolveProxy(v),lookupProxyAuthorization:f.bind(void 0,t,u,n,{},s.remote.isRemote),getProxyURL:()=>n.getConfiguration("http").get("proxy"),getProxySupport:()=>n.getConfiguration("http").get("proxySupport")||"off",addCertificatesV1:()=>m(n),addCertificatesV2:()=>p(n),log:t,getLogLevel:()=>{const v=t.getLevel();switch(v){case b.LogLevel.Trace:return $.LogLevel.Trace;case b.LogLevel.Debug:return $.LogLevel.Debug;case b.LogLevel.Info:return $.LogLevel.Info;case b.LogLevel.Warning:return $.LogLevel.Warning;case b.LogLevel.Error:return $.LogLevel.Error;case b.LogLevel.Off:return $.LogLevel.Off;default:return w(v)}function w(E){return t.error("Unknown log level",E),$.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:a,loadAdditionalCertificates:async()=>{const v=[];if(s.remote.isRemote&&v.push((0,$.loadSystemCertificates)({log:t})),a){t.trace("ProxyResolver#loadAdditionalCertificates: Loading certificates from main process");const w=r.loadCertificates();w.then(E=>t.trace("ProxyResolver#loadAdditionalCertificates: Loaded certificates from main process",E.length)),v.push(w)}return(await Promise.all(v)).flat()},env:process.env},k=(0,$.createProxyResolver)(d),R=C(d,k);return h(c,R)}e.$Jic=L;function C(r,n){return{http:Object.assign(D,(0,$.createHttpPatch)(r,D,n)),https:Object.assign(O,(0,$.createHttpPatch)(r,O,n)),net:Object.assign(I,(0,$.createNetPatch)(r,I)),tls:Object.assign(g,(0,$.createTlsPatch)(r,g))}}function m(r){const n=r.getConfiguration("http");return!n.get("experimental.systemCertificatesV2",y)&&!!n.get("systemCertificates")}function p(r){const n=r.getConfiguration("http");return!!n.get("experimental.systemCertificatesV2",y)&&!!n.get("systemCertificates")}const S=new Map;function h(r,n){return r.getExtensionPathIndex().then(c=>{const t=globalThis._VSCODE_NODE_MODULES.module,u=t._load;t._load=function(l,a,d){if(l==="net")return n.net;if(l==="tls")return n.tls;if(l!=="http"&&l!=="https")return u.apply(this,arguments);const k=c.findSubstr(A.URI.file(a.filename));let R=S.get(k);if(R||S.set(k,R={}),!R[l]){const v=n[l];R[l]={...v}}return R[l]}})}async function f(r,n,c,t,u,s,l,a){const d=t[s];l&&(t[s]=l),r.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${s}`,`proxyAuthenticate:${l}`,`proxyAuthenticateCache:${d}`);const k=l||d,R=Array.isArray(k)?k:typeof k=="string"?[k]:[];if(i(n,R,u),R.some(v=>/^(Negotiate|Kerberos)( |$)/i.test(v))&&!a.kerberosRequested)try{a.kerberosRequested=!0;const v=await new Promise((U,F)=>{me(["kerberos"],U,F)}),w=new URL(s),E=c.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${w.hostname}`:`HTTP@${w.hostname}`);return r.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${s}`,`spn:${E}`),"Negotiate "+await(await v.initializeClient(E)).step("")}catch(v){r.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",v)}}let o=!1;function i(r,n,c){o||!n.length||(o=!0,r.$publicLog2("proxyAuthenticationRequest",{authenticationType:n.map(t=>t.split(" ")[0]).join(","),extensionHostType:c?"remote":"local"}))}}),define(ke[277],Se([1,0,130]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3r=void 0;function O(I){return{transformIncoming:A=>A.scheme==="vscode-remote"?{scheme:"file",path:A.path,query:A.query,fragment:A.fragment}:A.scheme==="file"?{scheme:"vscode-local",path:A.path,query:A.query,fragment:A.fragment}:A,transformOutgoing:A=>A.scheme==="file"?{scheme:"vscode-remote",authority:I,path:A.path,query:A.query,fragment:A.fragment}:A.scheme==="vscode-local"?{scheme:"file",path:A.path,query:A.query,fragment:A.fragment}:A,transformOutgoingScheme:A=>A==="file"?"vscode-remote":A==="vscode-local"?"file":A}}function g(I){return new D.$4m(O(I))}e.$3r=g}),define(ke[139],Se([1,0,224,18,2,3,5,37,32,17,44,180,39]),function(me,e,D,O,g,I,A,b,$,y,L,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5E=e.$4E=e.$3E=e.EditorsOrder=e.$2E=e.CloseDirection=e.$1E=e.$ZE=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$YE=e.$XE=e.$WE=e.$VE=e.$UE=e.$TE=e.$SE=e.$RE=e.EditorInputCapabilities=e.$QE=e.SaveReason=e.Verbosity=e.$PE=e.$OE=e.$NE=e.$ME=e.$LE=e.$KE=e.$JE=e.$IE=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$HE=e.$GE=e.$FE=e.$EE=e.$DE=void 0,e.$DE={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$EE={id:"default",displayName:(0,D.localize)(0,null),providerDisplayName:(0,D.localize)(1,null)},e.$FE="workbench.editor.sidebysideEditor",e.$GE="workbench.editors.textDiffEditor",e.$HE="workbench.editors.binaryResourceDiffEditor";var p;(function(oe){oe[oe.PROGRAMMATIC=1]="PROGRAMMATIC",oe[oe.USER=2]="USER",oe[oe.EDIT=3]="EDIT",oe[oe.NAVIGATION=4]="NAVIGATION",oe[oe.JUMP=5]="JUMP"})(p||(e.EditorPaneSelectionChangeReason=p={}));var S;(function(oe){oe[oe.IDENTICAL=1]="IDENTICAL",oe[oe.SIMILAR=2]="SIMILAR",oe[oe.DIFFERENT=3]="DIFFERENT"})(S||(e.EditorPaneSelectionCompareResult=S={}));function h(oe){const K=oe;return!!K&&typeof K.getSelection=="function"&&!!K.onDidChangeSelection}e.$IE=h;function f(oe,K,W){for(const re of W.visibleEditorPanes)if(re.group.id===K&&oe.matches(re.input))return re.getViewState()}e.$JE=f;function o(oe){if(k(oe))return!1;const K=oe;return g.URI.isUri(K?.resource)}e.$KE=o;function i(oe){if(k(oe))return!1;const K=oe;return K?.original!==void 0&&K.modified!==void 0}e.$LE=i;function r(oe){if(k(oe))return!1;const K=oe;return!K||K.resources&&!Array.isArray(K.resources)?!1:!!K.resources||!!K.multiDiffSource}e.$ME=r;function n(oe){if(k(oe)||i(oe))return!1;const K=oe;return K?.primary!==void 0&&K.secondary!==void 0}e.$NE=n;function c(oe){if(k(oe))return!1;const K=oe;return K?K.resource===void 0||K.resource.scheme===y.Schemas.untitled||K.forceUntitled===!0:!1}e.$OE=c;function t(oe){if(k(oe))return!1;const K=oe;return g.URI.isUri(K?.base?.resource)&&g.URI.isUri(K?.input1?.resource)&&g.URI.isUri(K?.input2?.resource)&&g.URI.isUri(K?.result?.resource)}e.$PE=t;var u;(function(oe){oe[oe.SHORT=0]="SHORT",oe[oe.MEDIUM=1]="MEDIUM",oe[oe.LONG=2]="LONG"})(u||(e.Verbosity=u={}));var s;(function(oe){oe[oe.EXPLICIT=1]="EXPLICIT",oe[oe.AUTO=2]="AUTO",oe[oe.FOCUS_CHANGE=3]="FOCUS_CHANGE",oe[oe.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(s||(e.SaveReason=s={}));class l{constructor(){this.a=new Map}registerSource(K,W){let re=this.a.get(K);return re||(re={source:K,label:W},this.a.set(K,re)),re.source}getSourceLabel(K){return this.a.get(K)?.label??K}}e.$QE=new l;var a;(function(oe){oe[oe.None=0]="None",oe[oe.Readonly=2]="Readonly",oe[oe.Untitled=4]="Untitled",oe[oe.Singleton=8]="Singleton",oe[oe.RequiresTrust=16]="RequiresTrust",oe[oe.CanSplitInGroup=32]="CanSplitInGroup",oe[oe.ForceDescription=64]="ForceDescription",oe[oe.CanDropIntoEditor=128]="CanDropIntoEditor",oe[oe.MultipleEditors=256]="MultipleEditors",oe[oe.Scratchpad=512]="Scratchpad",oe[oe.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(a||(e.EditorInputCapabilities=a={}));class d extends I.$Tc{}e.$RE=d;function k(oe){return oe instanceof d}e.$SE=k;function R(oe){const K=oe;return g.URI.isUri(K?.preferredResource)}function v(oe){const K=oe;return k(K?.primary)&&k(K?.secondary)}e.$TE=v;function w(oe){const K=oe;return k(K?.modified)&&k(K?.original)}e.$UE=w;function E(oe,K,W,re,ye){return we(re,[(0,C.$Pi)({id:"workbench.action.openLargeFile",label:(0,D.localize)(2,null),run:()=>{const de={...W,limits:{size:Number.MAX_VALUE}};oe.openEditor(K,de)}}),(0,C.$Pi)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,D.localize)(3,null),run:()=>ye.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:m.default.Warning})}e.$VE=E;function P(oe){return k(oe?.editor)}e.$WE=P;function N(oe){const K=oe;return P(oe)&&K?.group!==void 0}e.$XE=N;function U(oe){const K=oe;return typeof K?.groupId=="number"&&k(K.editor)}e.$YE=U;var F;(function(oe){oe[oe.UNKNOWN=0]="UNKNOWN",oe[oe.REPLACE=1]="REPLACE",oe[oe.MOVE=2]="MOVE",oe[oe.UNPIN=3]="UNPIN"})(F||(e.EditorCloseContext=F={}));var j;(function(oe){oe[oe.GROUP_ACTIVE=0]="GROUP_ACTIVE",oe[oe.GROUP_INDEX=1]="GROUP_INDEX",oe[oe.GROUP_LABEL=2]="GROUP_LABEL",oe[oe.GROUP_LOCKED=3]="GROUP_LOCKED",oe[oe.EDITOR_OPEN=4]="EDITOR_OPEN",oe[oe.EDITOR_CLOSE=5]="EDITOR_CLOSE",oe[oe.EDITOR_MOVE=6]="EDITOR_MOVE",oe[oe.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",oe[oe.EDITOR_LABEL=8]="EDITOR_LABEL",oe[oe.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",oe[oe.EDITOR_PIN=10]="EDITOR_PIN",oe[oe.EDITOR_STICKY=11]="EDITOR_STICKY",oe[oe.EDITOR_DIRTY=12]="EDITOR_DIRTY",oe[oe.EDITOR_WILL_DISPOSE=13]="EDITOR_WILL_DISPOSE"})(j||(e.GroupModelChangeKind=j={}));var T;(function(oe){oe[oe.PRIMARY=1]="PRIMARY",oe[oe.SECONDARY=2]="SECONDARY",oe[oe.BOTH=3]="BOTH",oe[oe.ANY=4]="ANY"})(T||(e.SideBySideEditor=T={}));class M{getOriginalUri(K,W){if(!K)return;if(t(K))return e.$1E.getOriginalUri(K.result,W);if(W?.supportSideBySide){const{primary:ye,secondary:de}=this.a(K);if(ye&&de){if(W?.supportSideBySide===T.BOTH)return{primary:this.getOriginalUri(ye,{filterByScheme:W.filterByScheme}),secondary:this.getOriginalUri(de,{filterByScheme:W.filterByScheme})};if(W?.supportSideBySide===T.ANY)return this.getOriginalUri(ye,{filterByScheme:W.filterByScheme})??this.getOriginalUri(de,{filterByScheme:W.filterByScheme});K=W.supportSideBySide===T.PRIMARY?ye:de}}if(i(K)||r(K)||n(K)||t(K))return;const re=R(K)?K.preferredResource:K.resource;return!re||!W||!W.filterByScheme?re:this.b(re,W.filterByScheme)}a(K){return v(K)||n(K)?{primary:K.primary,secondary:K.secondary}:w(K)||i(K)?{primary:K.modified,secondary:K.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(K,W){if(!K)return;if(t(K))return e.$1E.getCanonicalUri(K.result,W);if(W?.supportSideBySide){const{primary:ye,secondary:de}=this.a(K);if(ye&&de){if(W?.supportSideBySide===T.BOTH)return{primary:this.getCanonicalUri(ye,{filterByScheme:W.filterByScheme}),secondary:this.getCanonicalUri(de,{filterByScheme:W.filterByScheme})};if(W?.supportSideBySide===T.ANY)return this.getCanonicalUri(ye,{filterByScheme:W.filterByScheme})??this.getCanonicalUri(de,{filterByScheme:W.filterByScheme});K=W.supportSideBySide===T.PRIMARY?ye:de}}if(i(K)||r(K)||n(K)||t(K))return;const re=K.resource;return!re||!W||!W.filterByScheme?re:this.b(re,W.filterByScheme)}b(K,W){if(Array.isArray(W)){if(W.some(re=>K.scheme===re))return K}else if(W===K.scheme)return K}}var B;(function(oe){oe[oe.UNKNOWN=0]="UNKNOWN",oe[oe.KEYBOARD=1]="KEYBOARD",oe[oe.MOUSE=2]="MOUSE"})(B||(e.EditorCloseMethod=B={}));function Y(oe,K,W,re){if(!oe.isSticky(K))return!1;switch(re.preventPinnedEditorClose){case"keyboardAndMouse":return W===B.MOUSE||W===B.KEYBOARD;case"mouse":return W===B.MOUSE;case"keyboard":return W===B.KEYBOARD}return!1}e.$ZE=Y,e.$1E=new M;var ue;(function(oe){oe[oe.LEFT=0]="LEFT",oe[oe.RIGHT=1]="RIGHT"})(ue||(e.CloseDirection=ue={}));class Z{constructor(){this.c=new Map,this.d=new Map}start(K){const W=this.a=K.get(A.$5h);for(const[re,ye]of this.c)this.e(re,ye,W);this.c.clear()}e(K,W,re){const ye=re.createInstance(W);this.d.set(K,ye)}registerFileEditorFactory(K){if(this.b)throw new Error("Can only register one file editor factory.");this.b=K}getFileEditorFactory(){return(0,O.$Tf)(this.b)}registerEditorSerializer(K,W){if(this.c.has(K)||this.d.has(K))throw new Error(`A editor serializer with type ID '${K}' was already registered.`);return this.a?this.e(K,W,this.a):this.c.set(K,W),(0,I.$Rc)(()=>{this.c.delete(K),this.d.delete(K)})}getEditorSerializer(K){return this.d.get(typeof K=="string"?K:K.typeId)}}b.$Hn.add(e.$DE.EditorFactory,new Z);async function J(oe,K,W){return!oe||!oe.length?[]:await Promise.all(oe.map(async re=>{const ye=g.URI.revive(re.fileUri);if(!ye){W.info("Cannot resolve the path because it is not valid.",re);return}if(!await K.canHandleResource(ye)){W.info("Cannot resolve the path because it cannot be handled",re);return}let ge=re.exists,x=re.type;if(typeof ge!="boolean"||typeof x!="number")try{x=(await K.stat(ye)).isDirectory?$.FileType.Directory:$.FileType.Unknown,ge=!0}catch(G){W.error(G),ge=!1}if(!ge&&re.openOnlyIfExists){W.info("Cannot resolve the path because it does not exist",re);return}if(x===$.FileType.Directory){W.info("Cannot resolve the path because it is a directory",re);return}const te={...re.options,pinned:!0};return ge?{resource:ye,options:te}:{resource:ye,options:te,forceUntitled:!0}}))}e.$2E=J;var X;(function(oe){oe[oe.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",oe[oe.SEQUENTIAL=1]="SEQUENTIAL"})(X||(e.EditorsOrder=X={}));function he(oe){const K=oe;if(!K)return!1;const W=K;if(W.modified)return he(W.modified);const re=K;return!!(re.contributionsState&&re.viewState&&Array.isArray(re.cursorState))}e.$3E=he;function _(oe){return(0,L.$Ri)(oe)}e.$4E=_;function we(oe,K,W){const re=(0,L.$Si)(oe,K);return re.forceMessage=W?.forceMessage,re.forceSeverity=W?.forceSeverity,re.allowDialog=W?.allowDialog,re}e.$5E=we}),define(ke[278],Se([1,0,4,225,5,3,28,37,19,24,78,264]),function(me,e,D,O,g,I,A,b,$,y,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aF=e.$_E=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$$E=e.ViewContentGroups=e.$0E=e.$9E=e.ViewContainerLocation=e.Extensions=e.$8E=e.$7E=e.$6E=void 0,e.$6E="views",e.$7E=(0,O.localize)(0,null),e.$8E=(0,C.$xw)("default-view-icon",L.$_j.window,(0,O.localize)(1,null));var m;(function(u){u.ViewContainersRegistry="workbench.registry.view.containers",u.ViewsRegistry="workbench.registry.view"})(m||(e.Extensions=m={}));var p;(function(u){u[u.Sidebar=0]="Sidebar",u[u.Panel=1]="Panel",u[u.AuxiliaryBar=2]="AuxiliaryBar"})(p||(e.ViewContainerLocation=p={})),e.$9E=[0,1,2];function S(u){switch(u){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$0E=S;class h extends I.$Tc{constructor(){super(...arguments),this.c=this.B(new D.$Vd),this.onDidRegister=this.c.event,this.f=this.B(new D.$Vd),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,$.$Rb)([...this.g.values()])}registerViewContainer(s,l,a){const d=this.get(s.id);if(d)return d;const k=s;return k.openCommandActionDescriptor=a?.doNotRegisterOpenCommand?void 0:k.openCommandActionDescriptor??{id:k.id},(0,A.$xc)(this.g,l,[]).push(k),a?.isDefault&&this.h.push(k),this.c.fire({viewContainer:k,viewContainerLocation:l}),k}deregisterViewContainer(s){for(const l of this.g.keys()){const a=this.g.get(l),d=a?.indexOf(s);if(d!==-1){a?.splice(d,1),a.length===0&&this.g.delete(l),this.f.fire({viewContainer:s,viewContainerLocation:l});return}}}get(s){return this.all.filter(l=>l.id===s)[0]}getViewContainers(s){return[...this.g.get(s)||[]]}getViewContainerLocation(s){return[...this.g.keys()].filter(l=>this.getViewContainers(l).filter(a=>a?.id===s.id).length>0)[0]}getDefaultViewContainer(s){return this.h.find(l=>this.getViewContainerLocation(l)===s)}}b.$Hn.add(m.ViewContainersRegistry,new h);var f;(function(u){u.Open="2_open",u.Debug="4_debug",u.SCM="5_scm",u.More="9_more"})(f||(e.ViewContentGroups=f={}));function o(u,s){const l=u.group??f.More,a=s.group??f.More;return l!==a?l.localeCompare(a):(u.order??5)-(s.order??5)}class i extends I.$Tc{constructor(){super(...arguments),this.c=this.B(new D.$Vd),this.onViewsRegistered=this.c.event,this.f=this.B(new D.$Vd),this.onViewsDeregistered=this.f.event,this.g=this.B(new D.$Vd),this.onDidChangeContainer=this.g.event,this.h=this.B(new D.$Vd),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new A.$Gc}registerViews(s,l){this.registerViews2([{views:s,viewContainer:l}])}registerViews2(s){s.forEach(({views:l,viewContainer:a})=>this.r(l,a)),this.c.fire(s)}deregisterViews(s,l){const a=this.s(s,l);a.length&&this.f.fire({views:a,viewContainer:l})}moveViews(s,l){for(const a of this.m.keys())if(a!==l){const d=this.s(s,a);d.length&&(this.r(d,l),this.g.fire({views:d,from:a,to:l}))}}getViews(s){return this.m.get(s)||[]}getView(s){for(const l of this.j){const a=(this.m.get(l)||[]).filter(d=>d.id===s)[0];if(a)return a}return null}getViewContainer(s){for(const l of this.j)if((this.m.get(l)||[]).filter(d=>d.id===s)[0])return l;return null}registerViewWelcomeContent(s,l){return this.n.add(s,l),this.h.fire(s),(0,I.$Rc)(()=>{this.n.delete(s,l),this.h.fire(s)})}registerViewWelcomeContent2(s,l){const a=new Map;for(const[d,k]of l)this.n.add(s,k),a.set(d,(0,I.$Rc)(()=>{this.n.delete(s,k),this.h.fire(s)}));return this.h.fire(s),a}getViewWelcomeContent(s){const l=[];return this.n.forEach(s,a=>l.push(a)),l.sort(o)}r(s,l){let a=this.m.get(l);a||(a=[],this.m.set(l,a),this.j.push(l));for(const d of s){if(this.getView(d.id)!==null)throw new Error((0,O.localize)(2,null,d.id));a.push(d)}}s(s,l){const a=this.m.get(l);if(!a)return[];const d=[],k=[];for(const R of a)s.includes(R)?d.push(R):k.push(R);return d.length&&(k.length?this.m.set(l,k):(this.m.delete(l),this.j.splice(this.j.indexOf(l),1))),d}}b.$Hn.add(m.ViewsRegistry,new i),e.$$E=(0,g.$6h)("viewDescriptorService");var r;(function(u){u[u.Default=0]="Default",u[u.Expand=1]="Expand"})(r||(e.ViewVisibilityState=r={}));var n;(function(u){u[u.None=0]="None",u[u.Collapsed=1]="Collapsed",u[u.Expanded=2]="Expanded"})(n||(e.TreeItemCollapsibleState=n={}));class c{constructor(s,l){this.c=!1,this.d=!1,(0,y.$yn)(this,s),this.d=!!l,this.resolve=async a=>{if(l&&!this.c){const d=await l(a);d&&(this.tooltip=this.tooltip??d.tooltip,this.command=this.command??d.command)}a.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$_E=c;class t extends Error{constructor(s){super((0,O.localize)(3,null,s)),this.name="NoTreeViewError"}static is(s){return s.name==="NoTreeViewError"}}e.$aF=t}),define(ke[279],Se([1,0,2,29,5]),function(me,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5F=e.ChatAgentCopyKind=e.InteractiveSessionVoteDirection=e.$4F=e.$3F=void 0;function I(y){return!!y&&typeof y=="object"&&"uri"in y&&y.uri instanceof D.URI&&"version"in y&&typeof y.version=="number"&&"ranges"in y&&Array.isArray(y.ranges)&&y.ranges.every(O.$Us.isIRange)}e.$3F=I;function A(y){return!!y&&typeof y=="object"&&"documents"in y&&Array.isArray(y.documents)&&y.documents.every(I)}e.$4F=A;var b;(function(y){y[y.Down=0]="Down",y[y.Up=1]="Up"})(b||(e.InteractiveSessionVoteDirection=b={}));var $;(function(y){y[y.Action=1]="Action",y[y.Toolbar=2]="Toolbar"})($||(e.ChatAgentCopyKind=$={})),e.$5F=(0,g.$6h)("IChatService")}),define(ke[140],Se([1,0,4,11,226]),function(me,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ilb=void 0;class I{constructor(){this.f=new Map,this.k=[],this.m=new D.$Vd,this.n=new D.$Vd,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(b){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=b}onEvent(b){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=b}onRequest(b){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=b}sendResponse(b){b.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${b.command}`)):this.s("response",b)}sendRequest(b,$,y,L){const C={command:b};if($&&Object.keys($).length>0&&(C.arguments=$),this.s("request",C),typeof L=="number"){const m=setTimeout(()=>{clearTimeout(m);const p=this.f.get(C.seq);if(p){this.f.delete(C.seq);const S={type:"response",seq:0,request_seq:C.seq,success:!1,command:b,message:(0,g.localize)(0,null,L,b)};p(S)}},L)}return y&&this.f.set(C.seq,y),C.seq}acceptMessage(b){this.j?this.j(b):(this.k.push(b),this.k.length===1&&this.q())}o(b,$){return b.type!=="event"||$.type!=="event"}async q(){let b;for(;this.k.length;){if((!b||this.o(this.k[0],b))&&await(0,O.$7g)(0),b=this.k.shift(),!b)return;switch(b.type){case"event":this.i?.(b);break;case"request":this.g?.(b);break;case"response":{const $=b,y=this.f.get($.request_seq);y&&(this.f.delete($.request_seq),y($));break}}}}s(b,$){$.type=b,$.seq=this.d++,this.sendMessage($)}async u(){if(this.f.size===0)return Promise.resolve();const b=new Map;this.f.forEach(($,y)=>b.set(y,$)),await(0,O.$7g)(500),b.forEach(($,y)=>{$({type:"response",seq:0,request_seq:y,success:!1,command:"canceled",message:"canceled"}),this.f.delete(y)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$Ilb=I}),define(ke[280],Se([1,0,227,45,5]),function(me,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.$NH=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$MH=e.MemoryRangeType=e.$LH=e.State=e.$KH=e.$JH=e.$IH=e.$HH=e.$GH=e.$FH=e.$EH=e.$DH=e.$CH=e.$BH=e.$AH=e.$zH=e.$yH=e.$xH=e.$wH=e.$vH=e.$uH=e.$tH=e.$sH=e.$rH=e.$qH=e.$pH=e.$oH=e.$nH=e.$mH=e.$lH=e.$kH=e.$jH=e.$iH=e.$hH=e.$gH=e.$fH=e.$eH=e.$dH=e.$cH=e.$bH=e.$aH=e.$_G=e.$$G=e.$0G=e.$9G=e.$8G=e.$7G=e.$6G=e.$5G=e.$4G=e.$3G=e.$2G=e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=void 0,e.$IG="workbench.view.debug",e.$JG="workbench.debug.variablesView",e.$KG="workbench.debug.watchExpressionsView",e.$LG="workbench.debug.callStackView",e.$MG="workbench.debug.loadedScriptsView",e.$NG="workbench.debug.breakPointsView",e.$OG="workbench.debug.disassemblyView",e.$PG="workbench.panel.repl",e.$QG="workbench.panel.repl.view",e.$RG=new O.$kj("debugType",void 0,{type:"string",description:D.localize(0,null)}),e.$SG=new O.$kj("debugConfigurationType",void 0,{type:"string",description:D.localize(1,null)}),e.$TG=new O.$kj("debugState","inactive",{type:"string",description:D.localize(2,null)}),e.$UG="debugUx",e.$VG=new O.$kj(e.$UG,"default",{type:"string",description:D.localize(3,null)}),e.$WG=new O.$kj("hasDebugged",!1,{type:"boolean",description:D.localize(4,null)}),e.$XG=new O.$kj("inDebugMode",!1,{type:"boolean",description:D.localize(5,null)}),e.$YG=new O.$kj("inDebugRepl",!1,{type:"boolean",description:D.localize(6,null)}),e.$ZG=new O.$kj("breakpointWidgetVisible",!1,{type:"boolean",description:D.localize(7,null)}),e.$1G=new O.$kj("inBreakpointWidget",!1,{type:"boolean",description:D.localize(8,null)}),e.$2G=new O.$kj("breakpointsFocused",!0,{type:"boolean",description:D.localize(9,null)}),e.$3G=new O.$kj("watchExpressionsFocused",!0,{type:"boolean",description:D.localize(10,null)}),e.$4G=new O.$kj("watchExpressionsExist",!1,{type:"boolean",description:D.localize(11,null)}),e.$5G=new O.$kj("variablesFocused",!0,{type:"boolean",description:D.localize(12,null)}),e.$6G=new O.$kj("expressionSelected",!1,{type:"boolean",description:D.localize(13,null)}),e.$7G=new O.$kj("breakpointInputFocused",!1,{type:"boolean",description:D.localize(14,null)}),e.$8G=new O.$kj("callStackItemType",void 0,{type:"string",description:D.localize(15,null)}),e.$9G=new O.$kj("callStackSessionIsAttach",!1,{type:"boolean",description:D.localize(16,null)}),e.$0G=new O.$kj("callStackItemStopped",!1,{type:"boolean",description:D.localize(17,null)}),e.$$G=new O.$kj("callStackSessionHasOneThread",!1,{type:"boolean",description:D.localize(18,null)}),e.$_G=new O.$kj("watchItemType",void 0,{type:"string",description:D.localize(19,null)}),e.$aH=new O.$kj("canViewMemory",void 0,{type:"boolean",description:D.localize(20,null)}),e.$bH=new O.$kj("breakpointItemType",void 0,{type:"string",description:D.localize(21,null)}),e.$cH=new O.$kj("breakpointSupportsCondition",!1,{type:"boolean",description:D.localize(22,null)}),e.$dH=new O.$kj("loadedScriptsSupported",!1,{type:"boolean",description:D.localize(23,null)}),e.$eH=new O.$kj("loadedScriptsItemType",void 0,{type:"string",description:D.localize(24,null)}),e.$fH=new O.$kj("focusedSessionIsAttach",!1,{type:"boolean",description:D.localize(25,null)}),e.$gH=new O.$kj("focusedSessionIsNoDebug",!1,{type:"boolean",description:D.localize(26,null)}),e.$hH=new O.$kj("stepBackSupported",!1,{type:"boolean",description:D.localize(27,null)}),e.$iH=new O.$kj("restartFrameSupported",!1,{type:"boolean",description:D.localize(28,null)}),e.$jH=new O.$kj("stackFrameSupportsRestart",!1,{type:"boolean",description:D.localize(29,null)}),e.$kH=new O.$kj("jumpToCursorSupported",!1,{type:"boolean",description:D.localize(30,null)}),e.$lH=new O.$kj("stepIntoTargetsSupported",!1,{type:"boolean",description:D.localize(31,null)}),e.$mH=new O.$kj("breakpointsExist",!1,{type:"boolean",description:D.localize(32,null)}),e.$nH=new O.$kj("debuggersAvailable",!1,{type:"boolean",description:D.localize(33,null)}),e.$oH=new O.$kj("debugExtensionAvailable",!0,{type:"boolean",description:D.localize(34,null)}),e.$pH=new O.$kj("debugProtocolVariableMenuContext",void 0,{type:"string",description:D.localize(35,null)}),e.$qH=new O.$kj("debugSetVariableSupported",!1,{type:"boolean",description:D.localize(36,null)}),e.$rH=new O.$kj("debugSetExpressionSupported",!1,{type:"boolean",description:D.localize(37,null)}),e.$sH=new O.$kj("breakWhenValueChangesSupported",!1,{type:"boolean",description:D.localize(38,null)}),e.$tH=new O.$kj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:D.localize(39,null)}),e.$uH=new O.$kj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:D.localize(40,null)}),e.$vH=new O.$kj("terminateDebuggeeSupported",!1,{type:"boolean",description:D.localize(41,null)}),e.$wH=new O.$kj("suspendDebuggeeSupported",!1,{type:"boolean",description:D.localize(42,null)}),e.$xH=new O.$kj("variableEvaluateNamePresent",!1,{type:"boolean",description:D.localize(43,null)}),e.$yH=new O.$kj("variableIsReadonly",!1,{type:"boolean",description:D.localize(44,null)}),e.$zH=new O.$kj("exceptionWidgetVisible",!1,{type:"boolean",description:D.localize(45,null)}),e.$AH=new O.$kj("multiSessionRepl",!1,{type:"boolean",description:D.localize(46,null)}),e.$BH=new O.$kj("multiSessionDebug",!1,{type:"boolean",description:D.localize(47,null)}),e.$CH=new O.$kj("disassembleRequestSupported",!1,{type:"boolean",description:D.localize(48,null)}),e.$DH=new O.$kj("disassemblyViewFocus",!1,{type:"boolean",description:D.localize(49,null)}),e.$EH=new O.$kj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:D.localize(50,null)}),e.$FH=new O.$kj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:D.localize(51,null)});const I=m=>D.localize(52,null,m);e.$GH=I,e.$HH="editor.contrib.debug",e.$IH="editor.contrib.breakpoint",e.$JH="debug",e.$KH={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:D.localize(53,null)};var A;(function(m){m[m.Inactive=0]="Inactive",m[m.Initializing=1]="Initializing",m[m.Stopped=2]="Stopped",m[m.Running=3]="Running"})(A||(e.State=A={}));function b(m){switch(m){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$LH=b;var $;(function(m){m[m.Valid=0]="Valid",m[m.Unreadable=1]="Unreadable",m[m.Error=2]="Error"})($||(e.MemoryRangeType=$={})),e.$MH="vscode-debug-memory";var y;(function(m){m[m.Initial=1]="Initial",m[m.Dynamic=2]="Dynamic"})(y||(e.DebugConfigurationProviderTriggerKind=y={}));var L;(function(m){m.UnverifiedBreakpoints="unverifiedBreakpoints"})(L||(e.DebuggerString=L={})),e.$NH=(0,g.$6h)("debugService");var C;(function(m){m[m.CONDITION=0]="CONDITION",m[m.HIT_COUNT=1]="HIT_COUNT",m[m.LOG_MESSAGE=2]="LOG_MESSAGE",m[m.TRIGGER_POINT=3]="TRIGGER_POINT"})(C||(e.BreakpointWidgetContext=C={}))}),define(ke[281],Se([1,0,12,2,16,24,17,29,21,19]),function(me,e,D,O,g,I,A,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=e.$eG=e.$dG=e.$cG=e.$bG=e.$aG=e.$_F=e.$$F=e.$0F=void 0;const L=/{([^}]+)}/g;function C(R,v,w){return R.replace(L,function(E,P){return v&&P.length>0&&P[0]!=="_"?E:w&&w.hasOwnProperty(P)?w[P]:E})}e.$0F=C;function m(R){const v={};for(const w of Object.keys(R))w.startsWith("!")||(v[w]=R[w]);return v}e.$$F=m;function p(R){return R.configuration.request==="attach"&&!S(R)&&(!R.parentSession||p(R.parentSession))}e.$_F=p;function S(R){let v=R.configuration.type;if(v)return v==="vslsShare"&&(v=R.configuration.adapterProxy.configuration.type),(0,D.$_e)(v,"extensionhost")||(0,D.$_e)(v,"pwa-extensionhost")?R:R.parentSession?S(R.parentSession):void 0}e.$aG=S;function h(R){return R.type&&(R.label||R.program||R.runtime)}e.$bG=h;function f(R,v,w){let E,P=0;const N=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let U=null;for(;U=N.exec(R);){const F=U.index+1,j=F+U[0].length;if(F<=v&&j>=w){E=U[0],P=F;break}}if(E){const F=/\w+/g;let j=null;for(;(j=F.exec(E))&&!(j.index+1+P+j[0].length>=w););j&&(E=E.substring(0,F.lastIndex))}return E?{start:P,end:P+E.length-1}:{start:0,end:0}}e.$cG=f;async function o(R,v,w,E){if(R.evaluatableExpressionProvider.has(v)){const P=R.evaluatableExpressionProvider.ordered(v),N=(0,y.$Hb)(await Promise.all(P.map(async U=>{try{return await U.provideEvaluatableExpression(v,w,E??$.CancellationToken.None)}catch{return}})));if(N.length>0){let U=N[0].expression;const F=N[0].range;return U||(U=v.getLineContent(w.lineNumber).substring(F.startColumn-1,F.endColumn-1)),{range:F,matchingExpression:U}}}else{const P=v.getLineContent(w.lineNumber),{start:N,end:U}=f(P,w.column,w.column),F=P.substring(N-1,U);return{matchingExpression:F,range:new b.$Us(w.lineNumber,N,w.lineNumber,N+F.length)}}return null}e.$dG=o;const i=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function r(R){return!!(R&&R.match(i))}e.$eG=r;function n(R){if(typeof R.path=="string"&&!(typeof R.sourceReference=="number"&&R.sourceReference>0)){if(r(R.path))return O.URI.parse(R.path);if((0,g.$ic)(R.path))return O.URI.file(R.path)}return R.path}function c(R){if(typeof R.path=="object"){const v=O.URI.revive(R.path);if(v)return v.scheme===A.Schemas.file?v.fsPath:v.toString()}return R.path}function t(R,v){const w=v?n:c,E=(0,I.$vn)(R);return s(E,(P,N)=>{P&&N&&(N.path=w(N))}),E}e.$fG=t;function u(R,v){const w=v?n:c,E=(0,I.$vn)(R);return s(E,(P,N)=>{!P&&N&&(N.path=w(N))}),E}e.$gG=u;function s(R,v){switch(R.type){case"event":{const w=R;switch(w.event){case"output":v(!1,w.body.source);break;case"loadedSource":v(!1,w.body.source);break;case"breakpoint":v(!1,w.body.breakpoint.source);break;default:break}break}case"request":{const w=R;switch(w.command){case"setBreakpoints":v(!0,w.arguments.source);break;case"breakpointLocations":v(!0,w.arguments.source);break;case"source":v(!0,w.arguments.source);break;case"gotoTargets":v(!0,w.arguments.source);break;case"launchVSCode":w.arguments.args.forEach(E=>v(!1,E));break;default:break}break}case"response":{const w=R;if(w.success&&w.body)switch(w.command){case"stackTrace":w.body.stackFrames.forEach(E=>v(!1,E.source));break;case"loadedSources":w.body.sources.forEach(E=>v(!1,E));break;case"scopes":w.body.scopes.forEach(E=>v(!1,E.source));break;case"setFunctionBreakpoints":w.body.breakpoints.forEach(E=>v(!1,E.source));break;case"setBreakpoints":w.body.breakpoints.forEach(E=>v(!1,E.source));break;case"disassemble":w.body?.instructions.forEach(P=>v(!1,P.location));break;default:break}break}}}function l(R){return R.filter(v=>!v.presentation?.hidden).sort((v,w)=>v.presentation?w.presentation?v.presentation.group?w.presentation.group?v.presentation.group!==w.presentation.group?v.presentation.group.localeCompare(w.presentation.group):a(v.presentation.order,w.presentation.order):-1:w.presentation.group?1:a(v.presentation.order,w.presentation.order):-1:w.presentation?1:0)}e.$hG=l;function a(R,v){return typeof R!="number"?typeof v!="number"?0:1:typeof v!="number"?-1:R-v}async function d(R,v){const w=R.getValue("debug.saveBeforeStart",{overrideIdentifier:v.activeTextEditorLanguageId});if(w!=="none"&&(await v.saveAll(),w==="allEditorsInActiveGroup")){const E=v.activeEditorPane;E&&E.input.resource?.scheme===A.Schemas.untitled&&await v.save({editor:E.input,groupId:E.group.id})}await R.reloadConfiguration()}e.$iG=d;const k=(R,v)=>!R||!v?R===v:R.name===v.name&&R.path===v.path&&R.sourceReference===v.sourceReference;e.$jG=k}),define(ke[282],Se([1,0,50,62,24,16,10,12,31,228,140]),function(me,e,D,O,g,I,A,b,$,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lic=e.$kic=e.$jic=e.$iic=e.$hic=void 0;class C extends L.$Ilb{static{this.a=`\r
\r
`}static{this.b=/\r?\n/}static{this.l=/: */}constructor(){super(),this.r=Buffer.allocUnsafe(0),this.t=-1}v(o,i){this.p=i,this.r=Buffer.allocUnsafe(0),this.t=-1,o.on("data",r=>this.w(r))}sendMessage(o){if(this.p){const i=JSON.stringify(o);this.p.write(`Content-Length: ${Buffer.byteLength(i,"utf8")}${C.a}${i}`,"utf8")}}w(o){for(this.r=Buffer.concat([this.r,o]);;){if(this.t>=0){if(this.r.length>=this.t){const i=this.r.toString("utf8",0,this.t);if(this.r=this.r.slice(this.t),this.t=-1,i.length>0)try{this.acceptMessage(JSON.parse(i))}catch(r){this.m.fire(new Error((r.message||r)+`
`+i))}continue}}else{const i=this.r.indexOf(C.a);if(i!==-1){const n=this.r.toString("utf8",0,i).split(C.b);for(const c of n){const t=c.split(C.l);t[0]==="Content-Length"&&(this.t=Number(t[1]))}this.r=this.r.slice(i+C.a.length);continue}}break}}}e.$hic=C;class m extends C{startSession(){return new Promise((o,i)=>{let r=!1;this.x=this.y(()=>{this.v(this.x,this.x),o(),r=!0}),this.x.on("close",()=>{r?this.m.fire(new Error("connection closed")):i(new Error("connection closed"))}),this.x.on("error",n=>{r?this.m.fire(n):i(n)})})}async stopSession(){await this.u(),this.x&&(this.x.end(),this.x=void 0)}}e.$iic=m;class p extends m{constructor(o){super(),this.z=o}y(o){return O.createConnection(this.z.port,this.z.host||"127.0.0.1",o)}}e.$jic=p;class S extends m{constructor(o){super(),this.z=o}y(o){return O.createConnection(this.z.path,o)}}e.$kic=S;class h extends C{constructor(o,i){super(),this.y=o,this.z=i}async startSession(){const o=this.y.command,i=this.y.args,r=this.y.options||{};try{if(o)if(I.$ic(o)){if(!await $.Promises.exists(o))throw new Error(y.localize(0,null,o))}else o.indexOf("/")<0&&o.indexOf("\\")<0;else throw new Error(y.localize(1,null,this.z));let n=process.env;if(r.env&&Object.keys(r.env).length>0&&(n=g.$yn(g.$vn(process.env),r.env)),o==="node")if(Array.isArray(i)&&i.length>0){const c=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:n,execArgv:c?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};r.cwd&&(t.cwd=r.cwd);const u=D.fork(i[0],i.slice(1),t);if(!u.pid)throw new Error(y.localize(2,null,i[0]));this.x=u}else throw new Error(y.localize(3,null));else{const c={env:n};r.cwd&&(c.cwd=r.cwd),this.x=D.spawn(o,i,c)}this.x.on("error",c=>{this.m.fire(c)}),this.x.on("exit",(c,t)=>{this.n.fire(c)}),this.x.stdout.on("close",()=>{this.m.fire(new Error("read error"))}),this.x.stdout.on("error",c=>{this.m.fire(c)}),this.x.stdin.on("error",c=>{this.m.fire(c)}),this.x.stderr.resume(),this.v(this.x.stdout,this.x.stdin)}catch(n){this.m.fire(n)}}async stopSession(){return this.x?(await this.u(),A.$i?new Promise((o,i)=>{const r=D.exec(`taskkill /F /T /PID ${this.x.pid}`,function(n,c,t){if(n)return i(n)});r.on("exit",o),r.on("error",i)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(o,i){if(!o)return;const r=Object.create(null);o.runtime&&(o.runtime.indexOf("./")===0?r.runtime=I.$jc(i,o.runtime):r.runtime=o.runtime),o.runtimeArgs&&(r.runtimeArgs=o.runtimeArgs),o.program&&(I.$ic(o.program)?r.program=o.program:r.program=I.$jc(i,o.program)),o.args&&(r.args=o.args);const n=o;return n.win&&(r.win=h.A(n.win,i)),n.winx86&&(r.winx86=h.A(n.winx86,i)),n.windows&&(r.windows=h.A(n.windows,i)),n.osx&&(r.osx=h.A(n.osx,i)),n.linux&&(r.linux=h.A(n.linux,i)),r}static platformAdapterExecutable(o,i){let r=Object.create(null);i=i.toLowerCase();for(const l of o)if(l.contributes){const a=l.contributes.debuggers;a&&a.length>0&&a.filter(d=>typeof d.type=="string"&&b.$_e(d.type,i)).forEach(d=>{const k=h.A(d,l.extensionLocation.fsPath);r=g.$yn(r,k,l.isBuiltin)})}let n;A.$i&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?n=r.winx86||r.win||r.windows:A.$i?n=r.win||r.windows:A.$j?n=r.osx:A.$k&&(n=r.linux),n=n||r;const c=n.program||r.program,t=n.args||r.args,u=n.runtime||r.runtime,s=n.runtimeArgs||r.runtimeArgs;if(u)return{type:"executable",command:u,args:(s||[]).concat(typeof c=="string"?[c]:[]).concat(t||[])};if(c)return{type:"executable",command:c,args:t||[]}}}e.$lic=h}),define(ke[283],Se([1,0,50,33,10]),function(me,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nic=e.$mic=void 0;function I(y,L){return new Promise((C,m)=>{let p="";const S=D.spawn(y,L);S.pid&&S.stdout.on("data",h=>{p+=h.toString()}),S.on("error",h=>{m(h)}),S.on("close",h=>{C(p)})})}async function A(y){if(y)if(g.$i){const L=await new Promise((C,m)=>{me(["@vscode/windows-process-tree"],C,m)});return new Promise(C=>{L.getProcessTree(y,m=>{C(!!m&&m.children.length>0)})})}else return I("/usr/bin/pgrep",["-lP",String(y)]).then(L=>{const C=L.trim();return!(C.length===0||C.indexOf(" tmux")>=0)},L=>!0);return Promise.resolve(!0)}e.$mic=A;var b;(function(y){y[y.cmd=0]="cmd",y[y.powershell=1]="powershell",y[y.bash=2]="bash"})(b||(b={}));function $(y,L,C,m,p){y=y.trim().toLowerCase();let S;y.indexOf("powershell")>=0||y.indexOf("pwsh")>=0?S=1:y.indexOf("cmd.exe")>=0?S=0:y.indexOf("bash")>=0?S=2:g.$i?S=0:S=2;let h,f=" ";switch(S){case 1:if(h=o=>(o=o.replace(/\'/g,"''"),o.length>0&&o.charAt(o.length-1)==="\\"?`'${o}\\'`:`'${o}'`),m){const o=(0,O.$ag)(m);o&&(f+=`${o}:; `),f+=`cd ${h(m)}; `}if(p)for(const o in p){const i=p[o];i===null?f+=`Remove-Item env:${o}; `:f+=`\${env:${o}}='${i}'; `}if(L.length>0){const o=L.shift(),i=C?o:h(o);f+=i[0]==="'"?`& ${i} `:`${i} `;for(const r of L)f+=r==="<"||r===">"||C?r:h(r),f+=" "}break;case 0:if(h=o=>(o=o.replace(/\"/g,'""'),o=o.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(i=>o.includes(i))||o.length===0?`"${o}"`:o),m){const o=(0,O.$ag)(m);o&&(f+=`${o}: && `),f+=`cd ${h(m)} && `}if(p){f+='cmd /C "';for(const o in p){let i=p[o];i===null?f+=`set "${o}=" && `:(i=i.replace(/[&^|<>]/g,r=>`^${r}`),f+=`set "${o}=${i}" && `)}}for(const o of L)f+=o==="<"||o===">"||C?o:h(o),f+=" ";p&&(f+='"');break;case 2:{h=i=>(i=i.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),i.length===0?'""':i);const o=i=>/[^\w@%\/+=,.:^-]/.test(i)?`'${i.replace(/'/g,"'\\''")}'`:i;if(m&&(f+=`cd ${h(m)} ; `),p){f+="/usr/bin/env";for(const i in p){const r=p[i];r===null?f+=` -u ${o(i)}`:f+=` ${o(`${i}=${r}`)}`}f+=" "}for(const i of L)f+=i==="<"||i===">"||C?i:h(i),f+=" ";break}}return f}e.$nic=$}),define(ke[111],Se([1,0,22,34,53,100,17,16,10,45]),function(me,e,D,O,g,I,A,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_I=e.$$I=e.$0I=e.$9I=e.CellStatusbarAlignment=e.$8I=e.$7I=e.$6I=e.NotebookEditorPriority=e.$5I=e.$4I=e.$3I=e.$2I=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$1I=e.$ZI=e.$YI=e.$XI=e.CellKind=e.$WI=e.$VI=e.$UI=void 0,e.$UI="workbench.editor.notebook",e.$VI="workbench.editor.notebookTextDiffEditor",e.$WI="workbench.editor.interactive";var L;(function(M){M[M.Markup=1]="Markup",M[M.Code=2]="Code"})(L||(e.CellKind=L={})),e.$XI=["application/json","application/javascript","text/html","image/svg+xml",I.$fs.latex,I.$fs.markdown,"image/png","image/jpeg",I.$fs.text],e.$YI=[I.$fs.latex,I.$fs.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",I.$fs.text],e.$ZI=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$1I="_notAvailable";var C;(function(M){M[M.Running=1]="Running",M[M.Idle=2]="Idle"})(C||(e.NotebookRunState=C={}));var m;(function(M){M[M.Unconfirmed=1]="Unconfirmed",M[M.Pending=2]="Pending",M[M.Executing=3]="Executing"})(m||(e.NotebookCellExecutionState=m={}));var p;(function(M){M[M.Unconfirmed=1]="Unconfirmed",M[M.Pending=2]="Pending",M[M.Executing=3]="Executing"})(p||(e.NotebookExecutionState=p={}));var S;(function(M){M[M.WithHardKernelDependency=0]="WithHardKernelDependency",M[M.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",M[M.Pure=2]="Pure",M[M.Never=3]="Never"})(S||(e.NotebookRendererMatch=S={}));var h;(function(M){M.Always="always",M.Never="never",M.Optional="optional"})(h||(e.RendererMessagingSpec=h={}));var f;(function(M){M[M.ModelChange=1]="ModelChange",M[M.Move=2]="Move",M[M.ChangeCellLanguage=5]="ChangeCellLanguage",M[M.Initialize=6]="Initialize",M[M.ChangeCellMetadata=7]="ChangeCellMetadata",M[M.Output=8]="Output",M[M.OutputItem=9]="OutputItem",M[M.ChangeCellContent=10]="ChangeCellContent",M[M.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",M[M.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",M[M.ChangeCellMime=13]="ChangeCellMime",M[M.Unknown=100]="Unknown"})(f||(e.NotebookCellsChangeType=f={}));var o;(function(M){M[M.Handle=0]="Handle",M[M.Index=1]="Index"})(o||(e.SelectionStateType=o={}));var i;(function(M){M[M.Replace=1]="Replace",M[M.Output=2]="Output",M[M.Metadata=3]="Metadata",M[M.CellLanguage=4]="CellLanguage",M[M.DocumentMetadata=5]="DocumentMetadata",M[M.Move=6]="Move",M[M.OutputItems=7]="OutputItems",M[M.PartialMetadata=8]="PartialMetadata",M[M.PartialInternalMetadata=9]="PartialInternalMetadata"})(i||(e.CellEditType=i={}));var r;(function(M){M.scheme=A.Schemas.vscodeNotebookCell;const B=["W","X","Y","Z","a","b","c","d","e","f"],Y=new RegExp(`^[${B.join("")}]+`),ue=7;function Z(oe,K){const W=K.toString(ue),ye=`${W.length<B.length?B[W.length-1]:"z"}${W}s${(0,D.$De)(D.$je.fromString(oe.scheme),!0,!0)}`;return oe.with({scheme:M.scheme,fragment:ye})}M.generate=Z;function J(oe){if(oe.scheme!==M.scheme)return;const K=oe.fragment.indexOf("s");if(K<0)return;const W=parseInt(oe.fragment.substring(0,K).replace(Y,""),ue),re=(0,D.$Ce)(oe.fragment.substring(K+1)).toString();if(!isNaN(W))return{handle:W,notebook:oe.with({scheme:re,fragment:null})}}M.parse=J;function X(oe,K){return oe.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`op${K??""},${oe.scheme!==A.Schemas.file?oe.scheme:""}`})}M.generateCellOutputUri=X;function he(oe){if(oe.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const K=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(oe.fragment);if(!K)return;const W=K[1]&&K[1]!==""?K[1]:void 0,re=K[2];return{outputId:W,notebook:oe.with({scheme:re||A.Schemas.file,fragment:null})}}M.parseCellOutputUri=he;function _(oe,K,W){return M.generate(oe,K).with({scheme:W})}M.generateCellPropertyUri=_;function we(oe,K){if(oe.scheme===K)return M.parse(oe.with({scheme:M.scheme}))}M.parseCellPropertyUri=we})(r||(e.CellUri=r={}));const n=M=>$.$i?M.replace(/\//g,"\\"):M;class c{constructor(B=[],Y=e.$XI){this.e=Y,this.d=[...new Set(B)].map(ue=>({pattern:ue,matches:O.$Mj(n(ue))}))}sort(B){const Y=new Map(g.Iterable.map(B,Z=>[Z,n(Z)]));let ue=[];for(const{matches:Z}of this.d)for(const[J,X]of Y)if(Z(X)){ue.push(J),Y.delete(J);break}return Y.size&&(ue=ue.concat([...Y.keys()].sort((Z,J)=>this.e.indexOf(Z)-this.e.indexOf(J)))),ue}prioritize(B,Y){const ue=this.f(B);if(ue===-1){this.d.unshift({pattern:B,matches:O.$Mj(n(B))});return}const Z=new Set(Y.map(X=>this.f(X,ue)));Z.delete(-1);const J=Array.from(Z).sort();this.d.splice(ue+1,0,...J.map(X=>this.d[X]));for(let X=J.length-1;X>=0;X--)this.d.splice(J[X],1)}toArray(){return this.d.map(B=>B.pattern)}f(B,Y=this.d.length){const ue=n(B);for(let Z=0;Z<Y;Z++)if(this.d[Z].matches(ue))return Z;return-1}}e.$2I=c;function t(M,B,Y,ue=(Z,J)=>Z===J){const Z=[];function J(_,we,oe){if(we===0&&oe.length===0)return;const K=Z[Z.length-1];K&&K.start+K.deleteCount===_?(K.deleteCount+=we,K.toInsert.push(...oe)):Z.push({start:_,deleteCount:we,toInsert:oe})}let X=0,he=0;for(;;){if(X===M.length){J(X,0,B.slice(he));break}if(he===B.length){J(X,M.length-X,[]);break}const _=M[X],we=B[he];if(ue(_,we)){X+=1,he+=1;continue}Y(we)?(J(X,1,[]),X+=1):(J(X,0,[we]),he+=1)}return Z}e.$3I=t,e.$4I=new y.$kj("notebookEditorCursorAtBoundary","none"),e.$5I=new y.$kj("notebookEditorCursorAtLineBoundary","none");var u;(function(M){M.default="default",M.option="option"})(u||(e.NotebookEditorPriority=u={}));function s(M){const B=M;return!!((typeof B.include=="string"||O.$Nj(B.include))&&(typeof B.exclude=="string"||O.$Nj(B.exclude)))}e.$6I=s;function l(M,B,Y){if(Array.isArray(M.viewType)&&M.viewType.indexOf(B)>=0||M.viewType===B)return!0;if(M.filenamePattern){const ue=s(M.filenamePattern)?M.filenamePattern.include:M.filenamePattern,Z=s(M.filenamePattern)?M.filenamePattern.exclude:void 0;if(O.$Lj(ue,(0,b.$nc)(Y.fsPath).toLowerCase()))return!(Z&&O.$Lj(Z,(0,b.$nc)(Y.fsPath).toLowerCase()))}return!1}e.$7I=l,e.$8I={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell",cellChat:"notebook.experimental.cellChat"};var a;(function(M){M[M.Left=1]="Left",M[M.Right=2]="Right"})(a||(e.CellStatusbarAlignment=a={}));class d{static{this.d="notebook/"}static create(B){return`${d.d}${B}`}static parse(B){if(B.startsWith(d.d))return B.substring(d.d.length)}}e.$9I=d;function k(M){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(M)}e.$0I=k;const R=new TextDecoder;function v(M){const B=[];let Y=!1;for(const X of M)(B.length===0||Y)&&(B.push(X),Y=!0);let ue=P(B);const Z=D.$je.concat(B.map(X=>D.$je.wrap(X))),J=T(Z);return ue=ue||J.byteLength!==Z.byteLength,{data:J,didCompression:ue}}e.$$I=v,e.$_I=`${String.fromCharCode(27)}[A`;const w=e.$_I.split("").map(M=>M.charCodeAt(0)),E=10;function P(M){let B=!1;return M.forEach((Y,ue)=>{if(ue===0||Y.length<e.$_I.length)return;const Z=M[ue-1],J=Y.subarray(0,e.$_I.length);if(J[0]===w[0]&&J[1]===w[1]&&J[2]===w[2]){const X=Z.lastIndexOf(E);if(X===-1)return;B=!0,M[ue-1]=Z.subarray(0,X),M[ue]=Y.subarray(e.$_I.length)}}),B}function N(M){let B=M;do M=B,B=M.replace(/[^\n]\x08/gm,"");while(B.length<M.length);return M}function U(M){for(M=M.replace(/\r+\n/gm,`
`);M.search(/\r[^$]/g)>-1;){const B=M.match(/^(.*)\r+/m)[1];let Y=M.match(/\r+(.*)$/m)[1];Y=Y+B.slice(Y.length,B.length),M=M.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,Y)}return M}const F="\b".charCodeAt(0),j="\r".charCodeAt(0);function T(M){return!M.buffer.includes(F)&&!M.buffer.includes(j)?M:D.$je.fromString(U(N(R.decode(M.buffer))))}}),define(ke[7],Se([1,0,19,14,80,28,100,12,18,2,30,26,32,64,111]),function(me,e,D,O,g,I,A,b,$,y,L,C,m,p,S){"use strict";var h,f,o,i,r,n,c,t,u,s,l,a,d,k,R,v,w;Object.defineProperty(e,"__esModule",{value:!0}),e.SpeechToTextStatus=e.RelatedInformationType=e.ChatAgentResultFeedbackKind=e.$YM=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.$XM=e.ChatVariableLevel=e.ChatAgentCopyKind=e.InteractiveSessionVoteDirection=e.$WM=e.$VM=e.$UM=e.$TM=e.$SM=e.$RM=e.$QM=e.$PM=e.$OM=e.$NM=e.$MM=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$LM=e.$KM=e.$JM=e.$IM=e.$HM=e.$GM=e.$FM=e.$EM=e.TestRunProfileKind=e.TestResultState=e.$DM=e.$CM=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$BM=e.NotebookVariablesRequestKind=e.$AM=e.$zM=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$yM=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$xM=e.$wM=e.$vM=e.$uM=e.$tM=e.ColorThemeKind=e.$sM=e.$rM=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$qM=e.DebugConsoleMode=e.$pM=e.$oM=e.$nM=e.$mM=e.$lM=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$kM=e.$jM=e.FileChangeType=e.$iM=e.$hM=e.$gM=e.$fM=e.InlineCompletionTriggerKind=e.$eM=e.$dM=e.$cM=e.$bM=e.$aM=e.$_L=e.$$L=e.$0L=e.$9L=e.$8L=e.$7L=e.$6L=e.$5L=e.ConfigurationTarget=e.$4L=e.$3L=e.$2L=e.$1L=e.$ZL=e.$YL=e.$XL=e.$WL=e.$VL=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$UL=e.ViewBadge=e.ProgressLocation=e.$TL=e.$SL=e.TaskScope=e.ShellQuoting=e.$RL=e.$QL=e.$PL=e.TaskPanelKind=e.TaskRevealKind=e.$OL=e.TerminalLocation=e.$NL=e.$ML=e.$LL=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$KL=e.$JL=e.$IL=e.$HL=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$GL=e.StatusBarAlignment=e.ViewColumn=e.$FL=e.$EL=e.$DL=e.$CL=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$BL=e.$AL=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$zL=e.$yL=e.$xL=e.$wL=e.$vL=e.LanguageStatusSeverity=e.$uL=e.$tL=e.$sL=e.$rL=e.$qL=e.$pL=e.CodeActionTriggerKind=e.$oL=e.$nL=e.SymbolTag=e.SymbolKind=e.$mL=e.$lL=e.DocumentHighlightKind=e.$kL=e.$jL=e.$iL=e.$hL=e.DiagnosticSeverity=e.DiagnosticTag=e.$gL=e.$fL=e.FileEditType=e.$eL=e.$dL=e.$cL=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$bL=e.$aL=e.$_K=e.$$K=e.$0K=e.$9K=e.$8K=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function E(H){return Object.assign(H,{apply:function(...ve){if(ve.length===0)return Reflect.construct(H,[]);{const Me=ve.length===1?[]:ve[1];return Reflect.construct(H,Me,ve[0].constructor)}},call:function(...ve){if(ve.length===0)return Reflect.construct(H,[]);{const[Me,...Ze]=ve;return Reflect.construct(H,Ze,Me.constructor)}}})}var P;(function(H){H[H.Top=0]="Top",H[H.Bottom=1]="Bottom"})(P||(e.TerminalOutputAnchor=P={}));var N;(function(H){H[H.TerminalCommand=0]="TerminalCommand",H[H.Opener=1]="Opener",H[H.Command=3]="Command"})(N||(e.TerminalQuickFixType=N={}));let U=h=class{static from(...V){let ve=V;return new h(function(){if(ve){for(const Me of ve)Me&&typeof Me.dispose=="function"&&Me.dispose();ve=void 0}})}#e;constructor(V){this.#e=V}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$8K=U,e.$8K=U=h=Ge([E],U);let F=f=class{static Min(...V){if(V.length===0)throw new TypeError;let ve=V[0];for(let Me=1;Me<V.length;Me++){const Ze=V[Me];Ze.isBefore(ve)&&(ve=Ze)}return ve}static Max(...V){if(V.length===0)throw new TypeError;let ve=V[0];for(let Me=1;Me<V.length;Me++){const Ze=V[Me];Ze.isAfter(ve)&&(ve=Ze)}return ve}static isPosition(V){if(!V)return!1;if(V instanceof f)return!0;const{line:ve,character:Me}=V;return typeof ve=="number"&&typeof Me=="number"}static of(V){if(V instanceof f)return V;if(this.isPosition(V))return new f(V.line,V.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(V,ve){if(V<0)throw(0,O.$7)("line must be non-negative");if(ve<0)throw(0,O.$7)("character must be non-negative");this.c=V,this.e=ve}isBefore(V){return this.c<V.c?!0:V.c<this.c?!1:this.e<V.e}isBeforeOrEqual(V){return this.c<V.c?!0:V.c<this.c?!1:this.e<=V.e}isAfter(V){return!this.isBeforeOrEqual(V)}isAfterOrEqual(V){return!this.isBefore(V)}isEqual(V){return this.c===V.c&&this.e===V.e}compareTo(V){return this.c<V.c?-1:this.c>V.line?1:this.e<V.e?-1:this.e>V.e?1:0}translate(V,ve=0){if(V===null||ve===null)throw(0,O.$7)();let Me;return typeof V>"u"?Me=0:typeof V=="number"?Me=V:(Me=typeof V.lineDelta=="number"?V.lineDelta:0,ve=typeof V.characterDelta=="number"?V.characterDelta:0),Me===0&&ve===0?this:new f(this.line+Me,this.character+ve)}with(V,ve=this.character){if(V===null||ve===null)throw(0,O.$7)();let Me;return typeof V>"u"?Me=this.line:typeof V=="number"?Me=V:(Me=typeof V.line=="number"?V.line:this.line,ve=typeof V.character=="number"?V.character:this.character),Me===this.line&&ve===this.character?this:new f(Me,ve)}toJSON(){return{line:this.line,character:this.character}}};e.$9K=F,e.$9K=F=f=Ge([E],F);let j=o=class{static isRange(V){return V instanceof o?!0:V?F.isPosition(V.start)&&F.isPosition(V.end):!1}static of(V){if(V instanceof o)return V;if(this.isRange(V))return new o(V.start,V.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(V,ve,Me,Ze){let tt,lt;if(typeof V=="number"&&typeof ve=="number"&&typeof Me=="number"&&typeof Ze=="number"?(tt=new F(V,ve),lt=new F(Me,Ze)):F.isPosition(V)&&F.isPosition(ve)&&(tt=F.of(V),lt=F.of(ve)),!tt||!lt)throw new Error("Invalid arguments");tt.isBefore(lt)?(this.c=tt,this.e=lt):(this.c=lt,this.e=tt)}contains(V){return o.isRange(V)?this.contains(V.start)&&this.contains(V.end):F.isPosition(V)?!(F.of(V).isBefore(this.c)||this.e.isBefore(V)):!1}isEqual(V){return this.c.isEqual(V.c)&&this.e.isEqual(V.e)}intersection(V){const ve=F.Max(V.start,this.c),Me=F.Min(V.end,this.e);if(!ve.isAfter(Me))return new o(ve,Me)}union(V){if(this.contains(V))return this;if(V.contains(this))return V;const ve=F.Min(V.start,this.c),Me=F.Max(V.end,this.end);return new o(ve,Me)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(V,ve=this.end){if(V===null||ve===null)throw(0,O.$7)();let Me;return V?F.isPosition(V)?Me=V:(Me=V.start||this.start,ve=V.end||this.end):Me=this.start,Me.isEqual(this.c)&&ve.isEqual(this.end)?this:new o(Me,ve)}toJSON(){return[this.start,this.end]}};e.$0K=j,e.$0K=j=o=Ge([E],j);let T=i=class extends j{static isSelection(V){return V instanceof i?!0:V?j.isRange(V)&&F.isPosition(V.anchor)&&F.isPosition(V.active)&&typeof V.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(V,ve,Me,Ze){let tt,lt;if(typeof V=="number"&&typeof ve=="number"&&typeof Me=="number"&&typeof Ze=="number"?(tt=new F(V,ve),lt=new F(Me,Ze)):F.isPosition(V)&&F.isPosition(ve)&&(tt=F.of(V),lt=F.of(ve)),!tt||!lt)throw new Error("Invalid arguments");super(tt,lt),this.f=tt,this.g=lt}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$$K=T,e.$$K=T=i=Ge([E],T);const M=H=>{if(typeof H!="string"||H.length===0||!/^[0-9A-Za-z_\-]+$/.test(H))throw(0,O.$7)("connectionToken")};class B{static isResolvedAuthority(V){return V&&typeof V=="object"&&typeof V.host=="string"&&typeof V.port=="number"&&(V.connectionToken===void 0||typeof V.connectionToken=="string")}constructor(V,ve,Me){if(typeof V!="string"||V.length===0)throw(0,O.$7)("host");if(typeof ve!="number"||ve===0||Math.round(ve)!==ve)throw(0,O.$7)("port");typeof Me<"u"&&M(Me),this.host=V,this.port=Math.round(ve),this.connectionToken=Me}}e.$_K=B;class Y{static isManagedResolvedAuthority(V){return V&&typeof V=="object"&&typeof V.makeConnection=="function"&&(V.connectionToken===void 0||typeof V.connectionToken=="string")}constructor(V,ve){this.makeConnection=V,this.connectionToken=ve,typeof ve<"u"&&M(ve)}}e.$aL=Y;class ue extends Error{static NotAvailable(V,ve){return new ue(V,p.RemoteAuthorityResolverErrorCode.NotAvailable,ve)}static TemporarilyNotAvailable(V){return new ue(V,p.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(V,ve=p.RemoteAuthorityResolverErrorCode.Unknown,Me){super(V),this._message=V,this._code=ve,this._detail=Me,Object.setPrototypeOf(this,ue.prototype)}}e.$bL=ue;var Z;(function(H){H[H.LF=1]="LF",H[H.CRLF=2]="CRLF"})(Z||(e.EndOfLine=Z={}));var J;(function(H){H[H.Replace=1]="Replace",H[H.Append=2]="Append",H[H.Prepend=3]="Prepend"})(J||(e.EnvironmentVariableMutatorType=J={}));let X=r=class{static isTextEdit(V){return V instanceof r?!0:V?j.isRange(V)&&typeof V.newText=="string":!1}static replace(V,ve){return new r(V,ve)}static insert(V,ve){return r.replace(new j(V,V),ve)}static delete(V){return r.replace(V,"")}static setEndOfLine(V){const ve=new r(new j(new F(0,0),new F(0,0)),"");return ve.newEol=V,ve}get range(){return this.c}set range(V){if(V&&!j.isRange(V))throw(0,O.$7)("range");this.c=V}get newText(){return this.e||""}set newText(V){if(V&&typeof V!="string")throw(0,O.$7)("newText");this.e=V}get newEol(){return this.f}set newEol(V){if(V&&typeof V!="number")throw(0,O.$7)("newEol");this.f=V}constructor(V,ve){this.c=V,this.e=ve}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$cL=X,e.$cL=X=r=Ge([E],X);let he=n=class{static isNotebookCellEdit(V){return V instanceof n?!0:V?ei.isNotebookRange(V)&&Array.isArray(V.newCells):!1}static replaceCells(V,ve){return new n(V,ve)}static insertCells(V,ve){return new n(new ei(V,V),ve)}static deleteCells(V){return new n(V,[])}static updateCellMetadata(V,ve){const Me=new n(new ei(V,V),[]);return Me.newCellMetadata=ve,Me}static updateNotebookMetadata(V){const ve=new n(new ei(0,0),[]);return ve.newNotebookMetadata=V,ve}constructor(V,ve){this.range=V,this.newCells=ve}};e.$dL=he,e.$dL=he=n=Ge([E],he);class _{static isSnippetTextEdit(V){return V instanceof _?!0:V?j.isRange(V.range)&&K.isSnippetString(V.snippet):!1}static replace(V,ve){return new _(V,ve)}static insert(V,ve){return _.replace(new j(V,V),ve)}constructor(V,ve){this.range=V,this.snippet=ve}}e.$eL=_;var we;(function(H){H[H.File=1]="File",H[H.Text=2]="Text",H[H.Cell=3]="Cell",H[H.CellReplace=5]="CellReplace",H[H.Snippet=6]="Snippet"})(we||(e.FileEditType=we={}));let oe=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(V,ve,Me,Ze){this.c.push({_type:1,from:V,to:ve,options:Me,metadata:Ze})}createFile(V,ve,Me){this.c.push({_type:1,from:void 0,to:V,options:ve,metadata:Me})}deleteFile(V,ve,Me){this.c.push({_type:1,from:V,to:void 0,options:ve,metadata:Me})}e(V,ve,Me){this.c.push({_type:3,metadata:Me,uri:V,edit:{editType:5,metadata:ve},notebookMetadata:ve})}f(V,ve,Me,Ze){const tt=ve.start,lt=ve.end;(tt!==lt||Me.length>0)&&this.c.push({_type:5,uri:V,index:tt,count:lt-tt,cells:Me,metadata:Ze})}g(V,ve,Me,Ze){this.c.push({_type:3,metadata:Ze,uri:V,edit:{editType:3,index:ve,metadata:Me}})}replace(V,ve,Me,Ze){this.c.push({_type:2,uri:V,edit:new X(ve,Me),metadata:Ze})}insert(V,ve,Me,Ze){this.replace(V,new j(ve,ve),Me,Ze)}delete(V,ve,Me){this.replace(V,ve,"",Me)}has(V){return this.c.some(ve=>ve._type===2&&ve.uri.toString()===V.toString())}set(V,ve){if(ve)for(const Me of ve){if(!Me)continue;let Ze,tt;Array.isArray(Me)?(Ze=Me[0],tt=Me[1]):Ze=Me,he.isNotebookCellEdit(Ze)?Ze.newCellMetadata?this.g(V,Ze.range.start,Ze.newCellMetadata,tt):Ze.newNotebookMetadata?this.e(V,Ze.newNotebookMetadata,tt):this.f(V,Ze.range,Ze.newCells,tt):_.isSnippetTextEdit(Ze)?this.c.push({_type:6,uri:V,range:Ze.range,edit:Ze.snippet,metadata:tt}):this.c.push({_type:2,uri:V,edit:Ze,metadata:tt})}else{for(let Me=0;Me<this.c.length;Me++){const Ze=this.c[Me];switch(Ze._type){case 2:case 6:case 3:case 5:Ze.uri.toString()===V.toString()&&(this.c[Me]=void 0);break}}(0,D.$Ib)(this.c)}}get(V){const ve=[];for(const Me of this.c)Me._type===2&&Me.uri.toString()===V.toString()&&ve.push(Me.edit);return ve}entries(){const V=new I.$Ac;for(const ve of this.c)if(ve._type===2){let Me=V.get(ve.uri);Me||(Me=[ve.uri,[]],V.set(ve.uri,Me)),Me[1].push(ve.edit)}return[...V.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$fL=oe,e.$fL=oe=Ge([E],oe);let K=c=class{static isSnippetString(V){return V instanceof c?!0:V?typeof V.value=="string":!1}static c(V){return V.replace(/\$|}|\\/g,"\\$&")}constructor(V){this.e=1,this.value=V||""}appendText(V){return this.value+=c.c(V),this}appendTabstop(V=this.e++){return this.value+="$",this.value+=V,this}appendPlaceholder(V,ve=this.e++){if(typeof V=="function"){const Me=new c;Me.e=this.e,V(Me),this.e=Me.e,V=Me.value}else V=c.c(V);return this.value+="${",this.value+=ve,this.value+=":",this.value+=V,this.value+="}",this}appendChoice(V,ve=this.e++){const Me=V.map(Ze=>Ze.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=ve,this.value+="|",this.value+=Me,this.value+="|}",this}appendVariable(V,ve){if(typeof ve=="function"){const Me=new c;Me.e=this.e,ve(Me),this.e=Me.e,ve=Me.value}else typeof ve=="string"&&(ve=ve.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=V,ve&&(this.value+=":",this.value+=ve),this.value+="}",this}};e.$gL=K,e.$gL=K=c=Ge([E],K);var W;(function(H){H[H.Unnecessary=1]="Unnecessary",H[H.Deprecated=2]="Deprecated"})(W||(e.DiagnosticTag=W={}));var re;(function(H){H[H.Hint=3]="Hint",H[H.Information=2]="Information",H[H.Warning=1]="Warning",H[H.Error=0]="Error"})(re||(e.DiagnosticSeverity=re={}));let ye=t=class{static isLocation(V){return V instanceof t?!0:V?j.isRange(V.range)&&y.URI.isUri(V.uri):!1}constructor(V,ve){if(this.uri=V,ve)if(j.isRange(ve))this.range=j.of(ve);else if(F.isPosition(ve))this.range=new j(ve,ve);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$hL=ye,e.$hL=ye=t=Ge([E],ye);let de=class{static is(V){return V?typeof V.message=="string"&&V.location&&j.isRange(V.location.range)&&y.URI.isUri(V.location.uri):!1}constructor(V,ve){this.location=V,this.message=ve}static isEqual(V,ve){return V===ve?!0:!V||!ve?!1:V.message===ve.message&&V.location.range.isEqual(ve.location.range)&&V.location.uri.toString()===ve.location.uri.toString()}};e.$iL=de,e.$iL=de=Ge([E],de);let ge=class{constructor(V,ve,Me=re.Error){if(!j.isRange(V))throw new TypeError("range must be set");if(!ve)throw new TypeError("message must be set");this.range=V,this.message=ve,this.severity=Me}toJSON(){return{severity:re[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(V,ve){return V===ve?!0:!V||!ve?!1:V.message===ve.message&&V.severity===ve.severity&&V.code===ve.code&&V.severity===ve.severity&&V.source===ve.source&&V.range.isEqual(ve.range)&&(0,D.$ub)(V.tags,ve.tags)&&(0,D.$ub)(V.relatedInformation,ve.relatedInformation,de.isEqual)}};e.$jL=ge,e.$jL=ge=Ge([E],ge);let x=class{constructor(V,ve){if(!V)throw new Error("Illegal argument, contents must be defined");Array.isArray(V)?this.contents=V:this.contents=[V],this.range=ve}};e.$kL=x,e.$kL=x=Ge([E],x);var te;(function(H){H[H.Text=0]="Text",H[H.Read=1]="Read",H[H.Write=2]="Write"})(te||(e.DocumentHighlightKind=te={}));let G=class{constructor(V,ve=te.Text){this.range=V,this.kind=ve}toJSON(){return{range:this.range,kind:te[this.kind]}}};e.$lL=G,e.$lL=G=Ge([E],G);let ie=class{constructor(V,ve){this.uri=V,this.highlights=ve}toJSON(){return{uri:this.uri,highlights:this.highlights.map(V=>V.toJSON())}}};e.$mL=ie,e.$mL=ie=Ge([E],ie);var fe;(function(H){H[H.File=0]="File",H[H.Module=1]="Module",H[H.Namespace=2]="Namespace",H[H.Package=3]="Package",H[H.Class=4]="Class",H[H.Method=5]="Method",H[H.Property=6]="Property",H[H.Field=7]="Field",H[H.Constructor=8]="Constructor",H[H.Enum=9]="Enum",H[H.Interface=10]="Interface",H[H.Function=11]="Function",H[H.Variable=12]="Variable",H[H.Constant=13]="Constant",H[H.String=14]="String",H[H.Number=15]="Number",H[H.Boolean=16]="Boolean",H[H.Array=17]="Array",H[H.Object=18]="Object",H[H.Key=19]="Key",H[H.Null=20]="Null",H[H.EnumMember=21]="EnumMember",H[H.Struct=22]="Struct",H[H.Event=23]="Event",H[H.Operator=24]="Operator",H[H.TypeParameter=25]="TypeParameter"})(fe||(e.SymbolKind=fe={}));var pe;(function(H){H[H.Deprecated=1]="Deprecated"})(pe||(e.SymbolTag=pe={}));let Pe=u=class{static validate(V){if(!V.name)throw new Error("name must not be falsy")}constructor(V,ve,Me,Ze,tt){this.name=V,this.kind=ve,this.containerName=tt,typeof Me=="string"&&(this.containerName=Me),Ze instanceof ye?this.location=Ze:Me instanceof j&&(this.location=new ye(Ze,Me)),u.validate(this)}toJSON(){return{name:this.name,kind:fe[this.kind],location:this.location,containerName:this.containerName}}};e.$nL=Pe,e.$nL=Pe=u=Ge([E],Pe);let be=s=class{static validate(V){if(!V.name)throw new Error("name must not be falsy");if(!V.range.contains(V.selectionRange))throw new Error("selectionRange must be contained in fullRange");V.children?.forEach(s.validate)}constructor(V,ve,Me,Ze,tt){this.name=V,this.detail=ve,this.kind=Me,this.range=Ze,this.selectionRange=tt,this.children=[],s.validate(this)}};e.$oL=be,e.$oL=be=s=Ge([E],be);var De;(function(H){H[H.Invoke=1]="Invoke",H[H.Automatic=2]="Automatic"})(De||(e.CodeActionTriggerKind=De={}));let z=class{constructor(V,ve){this.title=V,this.kind=ve}};e.$pL=z,e.$pL=z=Ge([E],z);let Q=class{static{l=this}static{this.c="."}constructor(V){this.value=V}append(V){return new l(this.value?this.value+l.c+V:V)}intersects(V){return this.contains(V)||V.contains(this)}contains(V){return this.value===V.value||V.value.startsWith(this.value+l.c)}};e.$qL=Q,e.$qL=Q=l=Ge([E],Q),Q.Empty=new Q(""),Q.QuickFix=Q.Empty.append("quickfix"),Q.Refactor=Q.Empty.append("refactor"),Q.RefactorExtract=Q.Refactor.append("extract"),Q.RefactorInline=Q.Refactor.append("inline"),Q.RefactorMove=Q.Refactor.append("move"),Q.RefactorRewrite=Q.Refactor.append("rewrite"),Q.Source=Q.Empty.append("source"),Q.SourceOrganizeImports=Q.Source.append("organizeImports"),Q.SourceFixAll=Q.Source.append("fixAll"),Q.Notebook=Q.Empty.append("notebook");let ee=class{constructor(V,ve){if(this.range=V,this.parent=ve,ve&&!ve.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$rL=ee,e.$rL=ee=Ge([E],ee);class q{constructor(V,ve,Me,Ze,tt,lt){this.kind=V,this.name=ve,this.detail=Me,this.uri=Ze,this.range=tt,this.selectionRange=lt}}e.$sL=q;class ae{constructor(V,ve){this.fromRanges=ve,this.from=V}}e.$tL=ae;class le{constructor(V,ve){this.fromRanges=ve,this.to=V}}e.$uL=le;var Le;(function(H){H[H.Information=0]="Information",H[H.Warning=1]="Warning",H[H.Error=2]="Error"})(Le||(e.LanguageStatusSeverity=Le={}));let je=class{constructor(V,ve){this.range=V,this.command=ve}get isResolved(){return!!this.command}};e.$vL=je,e.$vL=je=Ge([E],je);let He=a=class{#e;static isMarkdownString(V){return V instanceof a?!0:V&&V.appendCodeblock&&V.appendMarkdown&&V.appendText&&V.value!==void 0}constructor(V,ve=!1){this.#e=new g.$hk(V,{supportThemeIcons:ve})}get value(){return this.#e.value}set value(V){this.#e.value=V}get isTrusted(){return this.#e.isTrusted}set isTrusted(V){this.#e.isTrusted=V}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(V){this.#e.supportThemeIcons=V}get supportHtml(){return this.#e.supportHtml}set supportHtml(V){this.#e.supportHtml=V}get baseUri(){return this.#e.baseUri}set baseUri(V){this.#e.baseUri=V}appendText(V){return this.#e.appendText(V),this}appendMarkdown(V){return this.#e.appendMarkdown(V),this}appendCodeblock(V,ve){return this.#e.appendCodeblock(ve??"",V),this}};e.$wL=He,e.$wL=He=a=Ge([E],He);let Je=class{constructor(V,ve){this.label=V,this.documentation=ve}};e.$xL=Je,e.$xL=Je=Ge([E],Je);let _e=class{constructor(V,ve){this.label=V,this.documentation=ve,this.parameters=[]}};e.$yL=_e,e.$yL=_e=Ge([E],_e);let ct=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$zL=ct,e.$zL=ct=Ge([E],ct);var ot;(function(H){H[H.Invoke=1]="Invoke",H[H.TriggerCharacter=2]="TriggerCharacter",H[H.ContentChange=3]="ContentChange"})(ot||(e.SignatureHelpTriggerKind=ot={}));var rt;(function(H){H[H.Type=1]="Type",H[H.Parameter=2]="Parameter"})(rt||(e.InlayHintKind=rt={}));let Re=class{constructor(V){this.value=V}};e.$AL=Re,e.$AL=Re=Ge([E],Re);let Ue=class{constructor(V,ve,Me){this.position=V,this.label=ve,this.kind=Me}};e.$BL=Ue,e.$BL=Ue=Ge([E],Ue);var Ae;(function(H){H[H.Invoke=0]="Invoke",H[H.TriggerCharacter=1]="TriggerCharacter",H[H.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ae||(e.CompletionTriggerKind=Ae={}));var Xe;(function(H){H[H.Text=0]="Text",H[H.Method=1]="Method",H[H.Function=2]="Function",H[H.Constructor=3]="Constructor",H[H.Field=4]="Field",H[H.Variable=5]="Variable",H[H.Class=6]="Class",H[H.Interface=7]="Interface",H[H.Module=8]="Module",H[H.Property=9]="Property",H[H.Unit=10]="Unit",H[H.Value=11]="Value",H[H.Enum=12]="Enum",H[H.Keyword=13]="Keyword",H[H.Snippet=14]="Snippet",H[H.Color=15]="Color",H[H.File=16]="File",H[H.Reference=17]="Reference",H[H.Folder=18]="Folder",H[H.EnumMember=19]="EnumMember",H[H.Constant=20]="Constant",H[H.Struct=21]="Struct",H[H.Event=22]="Event",H[H.Operator=23]="Operator",H[H.TypeParameter=24]="TypeParameter",H[H.User=25]="User",H[H.Issue=26]="Issue"})(Xe||(e.CompletionItemKind=Xe={}));var ne;(function(H){H[H.Deprecated=1]="Deprecated"})(ne||(e.CompletionItemTag=ne={}));let ce=class{constructor(V,ve){this.label=V,this.kind=ve}toJSON(){return{label:this.label,kind:this.kind&&Xe[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$CL=ce,e.$CL=ce=Ge([E],ce);let Ie=class{constructor(V=[],ve=!1){this.items=V,this.isIncomplete=ve}};e.$DL=Ie,e.$DL=Ie=Ge([E],Ie);let qe=class{constructor(V,ve,Me){this.insertText=V,this.range=ve,this.command=Me}};e.$EL=qe,e.$EL=qe=Ge([E],qe);let Ye=class{constructor(V){this.commands=void 0,this.suppressSuggestions=void 0,this.items=V}};e.$FL=Ye,e.$FL=Ye=Ge([E],Ye);var nt;(function(H){H[H.Active=-1]="Active",H[H.Beside=-2]="Beside",H[H.One=1]="One",H[H.Two=2]="Two",H[H.Three=3]="Three",H[H.Four=4]="Four",H[H.Five=5]="Five",H[H.Six=6]="Six",H[H.Seven=7]="Seven",H[H.Eight=8]="Eight",H[H.Nine=9]="Nine"})(nt||(e.ViewColumn=nt={}));var it;(function(H){H[H.Left=1]="Left",H[H.Right=2]="Right"})(it||(e.StatusBarAlignment=it={}));function Oe(H,V){return`${C.$lm.toKey(H)}.${V}`}e.$GL=Oe;var vt;(function(H){H[H.Off=0]="Off",H[H.On=1]="On",H[H.Relative=2]="Relative"})(vt||(e.TextEditorLineNumbersStyle=vt={}));var St;(function(H){H[H.Manual=1]="Manual",H[H.AfterDelay=2]="AfterDelay",H[H.FocusOut=3]="FocusOut"})(St||(e.TextDocumentSaveReason=St={}));var Nt;(function(H){H[H.Default=0]="Default",H[H.InCenter=1]="InCenter",H[H.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",H[H.AtTop=3]="AtTop"})(Nt||(e.TextEditorRevealType=Nt={}));var Wt;(function(H){H[H.Keyboard=1]="Keyboard",H[H.Mouse=2]="Mouse",H[H.Command=3]="Command"})(Wt||(e.TextEditorSelectionChangeKind=Wt={}));var Et;(function(H){H[H.Undo=1]="Undo",H[H.Redo=2]="Redo"})(Et||(e.TextDocumentChangeReason=Et={}));var Kt;(function(H){H[H.OpenOpen=0]="OpenOpen",H[H.ClosedClosed=1]="ClosedClosed",H[H.OpenClosed=2]="OpenClosed",H[H.ClosedOpen=3]="ClosedOpen"})(Kt||(e.DecorationRangeBehavior=Kt={})),function(H){function V(ve){switch(ve){case"keyboard":return H.Keyboard;case"mouse":return H.Mouse;case"api":return H.Command}}H.fromValue=V}(Wt||(e.TextEditorSelectionChangeKind=Wt={}));var Ot;(function(H){H[H.Other=0]="Other",H[H.Comment=1]="Comment",H[H.String=2]="String",H[H.RegEx=3]="RegEx"})(Ot||(e.SyntaxTokenType=Ot={})),function(H){function V(ve){switch(ve){case H.Other:return"other";case H.Comment:return"comment";case H.String:return"string";case H.RegEx:return"regex"}return"other"}H.toString=V}(Ot||(e.SyntaxTokenType=Ot={}));let Yt=class{constructor(V,ve){if(ve&&!y.URI.isUri(ve))throw(0,O.$7)("target");if(!j.isRange(V)||V.isEmpty)throw(0,O.$7)("range");this.range=V,this.target=ve}};e.$HL=Yt,e.$HL=Yt=Ge([E],Yt);let Ut=class{constructor(V,ve,Me,Ze){this.red=V,this.green=ve,this.blue=Me,this.alpha=Ze}};e.$IL=Ut,e.$IL=Ut=Ge([E],Ut);let At=class{constructor(V,ve){if(ve&&!(ve instanceof Ut))throw(0,O.$7)("color");if(!j.isRange(V)||V.isEmpty)throw(0,O.$7)("range");this.range=V,this.color=ve}};e.$JL=At,e.$JL=At=Ge([E],At);let et=class{constructor(V){if(!V||typeof V!="string")throw(0,O.$7)("label");this.label=V}};e.$KL=et,e.$KL=et=Ge([E],et);var Gt;(function(H){H[H.RGB=0]="RGB",H[H.HEX=1]="HEX",H[H.HSL=2]="HSL"})(Gt||(e.ColorFormat=Gt={}));var Jt;(function(H){H[H.Error=0]="Error",H[H.Warning=1]="Warning",H[H.Information=2]="Information"})(Jt||(e.SourceControlInputBoxValidationType=Jt={}));var ht;(function(H){H[H.Unknown=0]="Unknown",H[H.Shutdown=1]="Shutdown",H[H.Process=2]="Process",H[H.User=3]="User",H[H.Extension=4]="Extension"})(ht||(e.TerminalExitReason=ht={}));class bt{constructor(V,ve,Me){if(this.startIndex=V,this.length=ve,this.tooltip=Me,typeof V!="number"||V<0)throw(0,O.$7)("startIndex");if(typeof ve!="number"||ve<1)throw(0,O.$7)("length");if(Me!==void 0&&typeof Me!="string")throw(0,O.$7)("tooltip")}}e.$LL=bt;class zt{constructor(V){this.uri=V}}e.$ML=zt;class Vt{constructor(V){this.terminalCommand=V}}e.$NL=Vt;var Dt;(function(H){H[H.Panel=1]="Panel",H[H.Editor=2]="Editor"})(Dt||(e.TerminalLocation=Dt={}));class ft{constructor(V){if(this.options=V,typeof V!="object")throw(0,O.$7)("options")}}e.$OL=ft;var Rt;(function(H){H[H.Always=1]="Always",H[H.Silent=2]="Silent",H[H.Never=3]="Never"})(Rt||(e.TaskRevealKind=Rt={}));var xt;(function(H){H[H.Shared=1]="Shared",H[H.Dedicated=2]="Dedicated",H[H.New=3]="New"})(xt||(e.TaskPanelKind=xt={}));let Ct=class{static{d=this}static{this.Clean=new d("clean","Clean")}static{this.Build=new d("build","Build")}static{this.Rebuild=new d("rebuild","Rebuild")}static{this.Test=new d("test","Test")}static from(V){switch(V){case"clean":return d.Clean;case"build":return d.Build;case"rebuild":return d.Rebuild;case"test":return d.Test;default:return}}constructor(V,ve){if(this.label=ve,typeof V!="string"||typeof ve!="string")throw(0,O.$7)("name");this.c=V}get id(){return this.c}};e.$PL=Ct,e.$PL=Ct=d=Ge([E],Ct);function Qe(H){let V="";for(let ve=0;ve<H.length;ve++)V+=H[ve].replace(/,/g,",,")+",";return V}let Tt=class{constructor(V,ve,Me){if(typeof V!="string")throw(0,O.$7)("process");this.e=[],this.c=V,ve!==void 0&&(Array.isArray(ve)?(this.e=ve,this.f=Me):this.f=ve)}get process(){return this.c}set process(V){if(typeof V!="string")throw(0,O.$7)("process");this.c=V}get args(){return this.e}set args(V){Array.isArray(V)||(V=[]),this.e=V}get options(){return this.f}set options(V){this.f=V}computeId(){const V=[];if(V.push("process"),this.c!==void 0&&V.push(this.c),this.e&&this.e.length>0)for(const ve of this.e)V.push(ve);return Qe(V)}};e.$QL=Tt,e.$QL=Tt=Ge([E],Tt);let qt=class{constructor(V,ve,Me){if(this.f=[],Array.isArray(ve)){if(!V)throw(0,O.$7)("command can't be undefined or null");if(typeof V!="string"&&typeof V.value!="string")throw(0,O.$7)("command");this.e=V,this.f=ve,this.g=Me}else{if(typeof V!="string")throw(0,O.$7)("commandLine");this.c=V,this.g=ve}}get commandLine(){return this.c}set commandLine(V){if(typeof V!="string")throw(0,O.$7)("commandLine");this.c=V}get command(){return this.e?this.e:""}set command(V){if(typeof V!="string"&&typeof V.value!="string")throw(0,O.$7)("command");this.e=V}get args(){return this.f}set args(V){this.f=V||[]}get options(){return this.g}set options(V){this.g=V}computeId(){const V=[];if(V.push("shell"),this.c!==void 0&&V.push(this.c),this.e!==void 0&&V.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ve of this.f)V.push(typeof ve=="string"?ve:ve.value);return Qe(V)}};e.$RL=qt,e.$RL=qt=Ge([E],qt);var Qt;(function(H){H[H.Escape=1]="Escape",H[H.Strong=2]="Strong",H[H.Weak=3]="Weak"})(Qt||(e.ShellQuoting=Qt={}));var gt;(function(H){H[H.Global=1]="Global",H[H.Workspace=2]="Workspace"})(gt||(e.TaskScope=gt={}));class Ft{constructor(V){this.c=V}computeId(){return"customExecution"+(0,L.$qg)()}set callback(V){this.c=V}get callback(){return this.c}}e.$SL=Ft;let Te=class{static{k=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(V,ve,Me,Ze,tt,lt){this.k=!1,this.l=this.definition=V;let mt;typeof ve=="string"?(this.n=this.name=ve,this.u=this.source=Me,this.execution=Ze,mt=tt,this.k=!0):ve===gt.Global||ve===gt.Workspace?(this.target=ve,this.n=this.name=Me,this.u=this.source=Ze,this.execution=tt,mt=lt):(this.target=ve,this.n=this.name=Me,this.u=this.source=Ze,this.execution=tt,mt=lt),typeof mt=="string"?(this.q=[mt],this.r=!0):Array.isArray(mt)?(this.q=mt,this.r=!0):(this.q=[],this.r=!1),this.t=!1,this.x=Object.create(null),this.y=Object.create(null)}get _id(){return this.j}set _id(V){this.j=V}get _deprecated(){return this.k}A(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.B())}B(){this.o instanceof Tt?this.l={type:k.e,id:this.o.computeId()}:this.o instanceof qt?this.l={type:k.f,id:this.o.computeId()}:this.o instanceof Ft?this.l={type:k.c,id:this.o.computeId()}:this.l={type:k.g,id:(0,L.$qg)()}}get definition(){return this.l}set definition(V){if(V==null)throw(0,O.$7)("Kind can't be undefined or null");this.A(),this.l=V}get scope(){return this.m}set target(V){this.A(),this.m=V}get name(){return this.n}set name(V){if(typeof V!="string")throw(0,O.$7)("name");this.A(),this.n=V}get execution(){return this.o}set execution(V){V===null&&(V=void 0),this.A(),this.o=V;const ve=this.l.type;(k.g===ve||k.e===ve||k.f===ve||k.c===ve)&&this.B()}get problemMatchers(){return this.q}set problemMatchers(V){if(Array.isArray(V))this.A(),this.q=V,this.r=!0;else{this.A(),this.q=[],this.r=!1;return}}get hasDefinedMatchers(){return this.r}get isBackground(){return this.t}set isBackground(V){V!==!0&&V!==!1&&(V=!1),this.A(),this.t=V}get source(){return this.u}set source(V){if(typeof V!="string"||V.length===0)throw(0,O.$7)("source must be a string of length > 0");this.A(),this.u=V}get group(){return this.w}set group(V){V===null&&(V=void 0),this.A(),this.w=V}get detail(){return this.z}set detail(V){V===null&&(V=void 0),this.z=V}get presentationOptions(){return this.x}set presentationOptions(V){V==null&&(V=Object.create(null)),this.A(),this.x=V}get runOptions(){return this.y}set runOptions(V){V==null&&(V=Object.create(null)),this.A(),this.y=V}};e.$TL=Te,e.$TL=Te=k=Ge([E],Te);var Ne;(function(H){H[H.SourceControl=1]="SourceControl",H[H.Window=10]="Window",H[H.Notification=15]="Notification"})(Ne||(e.ProgressLocation=Ne={}));var Ce;(function(H){function V(ve){const Me=ve;return(0,$.$Mf)(Me.value)?Me.tooltip&&!(0,$.$If)(Me.tooltip)?(console.log("INVALID view badge, invalid tooltip",Me.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Me.value),!1)}H.isViewBadge=V})(Ce||(e.ViewBadge=Ce={}));let se=R=class{static isTreeItem(V,ve){const Me=V;if(Me.checkboxState!==void 0){const Ze=(0,$.$Mf)(Me.checkboxState)?Me.checkboxState:(0,$.$Kf)(Me.checkboxState)&&(0,$.$Mf)(Me.checkboxState.state)?Me.checkboxState.state:void 0,tt=!(0,$.$Mf)(Me.checkboxState)&&(0,$.$Kf)(Me.checkboxState)?Me.checkboxState.tooltip:void 0;if(Ze===void 0||Ze!==Ve.Checked&&Ze!==Ve.Unchecked||tt!==void 0&&!(0,$.$If)(tt))return console.log("INVALID tree item, invalid checkboxState",Me.checkboxState),!1}if(V instanceof R)return!0;if(Me.label!==void 0&&!(0,$.$If)(Me.label)&&!Me.label?.label)return console.log("INVALID tree item, invalid label",Me.label),!1;if(Me.id!==void 0&&!(0,$.$If)(Me.id))return console.log("INVALID tree item, invalid id",Me.id),!1;if(Me.iconPath!==void 0&&!(0,$.$If)(Me.iconPath)&&!y.URI.isUri(Me.iconPath)&&(!Me.iconPath||!(0,$.$If)(Me.iconPath.id))){const Ze=Me.iconPath;if(!Ze||!(0,$.$If)(Ze.light)&&!y.URI.isUri(Ze.light)&&!(0,$.$If)(Ze.dark)&&!y.URI.isUri(Ze.dark))return console.log("INVALID tree item, invalid iconPath",Me.iconPath),!1}return Me.description!==void 0&&!(0,$.$If)(Me.description)&&typeof Me.description!="boolean"?(console.log("INVALID tree item, invalid description",Me.description),!1):Me.resourceUri!==void 0&&!y.URI.isUri(Me.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Me.resourceUri),!1):Me.tooltip!==void 0&&!(0,$.$If)(Me.tooltip)&&!(Me.tooltip instanceof He)?(console.log("INVALID tree item, invalid tooltip",Me.tooltip),!1):Me.command!==void 0&&!Me.command.command?(console.log("INVALID tree item, invalid command",Me.command),!1):Me.collapsibleState!==void 0&&Me.collapsibleState<Fe.None&&Me.collapsibleState>Fe.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Me.collapsibleState),!1):Me.contextValue!==void 0&&!(0,$.$If)(Me.contextValue)?(console.log("INVALID tree item, invalid contextValue",Me.contextValue),!1):Me.accessibilityInformation!==void 0&&!Me.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Me.accessibilityInformation),!1):!0}constructor(V,ve=Fe.None){this.collapsibleState=ve,y.URI.isUri(V)?this.resourceUri=V:this.label=V}};e.$UL=se,e.$UL=se=R=Ge([E],se);var Fe;(function(H){H[H.None=0]="None",H[H.Collapsed=1]="Collapsed",H[H.Expanded=2]="Expanded"})(Fe||(e.TreeItemCollapsibleState=Fe={}));var Ve;(function(H){H[H.Unchecked=0]="Unchecked",H[H.Checked=1]="Checked"})(Ve||(e.TreeItemCheckboxState=Ve={}));let xe=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(V){this.value=V}};e.$VL=xe,e.$VL=xe=Ge([E],xe);class Ke extends xe{}e.$WL=Ke;class st extends Ke{#e;constructor(V){super(""),this.#e=V}asFile(){return this.#e}}e.$XL=st;class $t{constructor(V,ve,Me,Ze){this.name=V,this.uri=ve,this._itemId=Me,this.c=Ze}data(){return this.c()}}e.$YL=$t;let Bt=class{#e=new Map;constructor(V){for(const[ve,Me]of V??[]){const Ze=this.#e.get(this.#t(ve));Ze?Ze.push(Me):this.#e.set(this.#t(ve),[Me])}}get(V){return this.#e.get(this.#t(V))?.[0]}set(V,ve){this.#e.set(this.#t(V),[ve])}forEach(V,ve){for(const[Me,Ze]of this.#e)for(const tt of Ze)V.call(ve,tt,Me,this)}*[Symbol.iterator](){for(const[V,ve]of this.#e)for(const Me of ve)yield[V,Me]}#t(V){return V.toLowerCase()}};e.$ZL=Bt,e.$ZL=Bt=Ge([E],Bt);let kt=class{constructor(V){this.insertText=V}};e.$1L=kt,e.$1L=kt=Ge([E],kt);let It=class{constructor(V,ve){this.label=ve,this.insertText=V}};e.$2L=It,e.$2L=It=Ge([E],It);let yt=class{constructor(V,ve){this.id=V,this.color=ve}static isThemeIcon(V){return typeof V.id!="string"?(console.log("INVALID ThemeIcon, invalid id",V.id),!1):!0}};e.$3L=yt,e.$3L=yt=Ge([E],yt),yt.File=new yt("file"),yt.Folder=new yt("folder");let gi=class{constructor(V){this.id=V}};e.$4L=gi,e.$4L=gi=Ge([E],gi);var Lt;(function(H){H[H.Global=1]="Global",H[H.Workspace=2]="Workspace",H[H.WorkspaceFolder=3]="WorkspaceFolder"})(Lt||(e.ConfigurationTarget=Lt={}));let Di=class{get base(){return this.c}set base(V){this.c=V,this.e=y.URI.file(V)}get baseUri(){return this.e}set baseUri(V){this.e=V,this.c=V.fsPath}constructor(V,ve){if(typeof V!="string"&&(!V||!y.URI.isUri(V)&&!y.URI.isUri(V.uri)))throw(0,O.$7)("base");if(typeof ve!="string")throw(0,O.$7)("pattern");typeof V=="string"?this.baseUri=y.URI.file(V):y.URI.isUri(V)?this.baseUri=V:this.baseUri=V.uri,this.pattern=ve}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$5L=Di,e.$5L=Di=Ge([E],Di);const Gi=new WeakMap;function Pt(H,V){Gi.set(H,V)}e.$6L=Pt;let ri=class{constructor(V,ve,Me,Ze){this.enabled=typeof V=="boolean"?V:!0,typeof ve=="string"&&(this.condition=ve),typeof Me=="string"&&(this.hitCondition=Me),typeof Ze=="string"&&(this.logMessage=Ze)}get id(){return this.c||(this.c=Gi.get(this)??(0,L.$qg)()),this.c}};e.$7L=ri,e.$7L=ri=Ge([E],ri);let mi=class extends ri{constructor(V,ve,Me,Ze,tt){if(super(ve,Me,Ze,tt),V===null)throw(0,O.$7)("location");this.location=V}};e.$8L=mi,e.$8L=mi=Ge([E],mi);let ci=class extends ri{constructor(V,ve,Me,Ze,tt){super(ve,Me,Ze,tt),this.functionName=V}};e.$9L=ci,e.$9L=ci=Ge([E],ci);let Ci=class extends ri{constructor(V,ve,Me,Ze,tt,lt,mt){if(super(Ze,tt,lt,mt),!ve)throw(0,O.$7)("dataId");this.label=V,this.dataId=ve,this.canPersist=Me}};e.$0L=Ci,e.$0L=Ci=Ge([E],Ci);let Ii=class{constructor(V,ve,Me){this.command=V,this.args=ve||[],this.options=Me}};e.$$L=Ii,e.$$L=Ii=Ge([E],Ii);let jt=class{constructor(V,ve){this.port=V,this.host=ve}};e.$_L=jt,e.$_L=jt=Ge([E],jt);let $i=class{constructor(V){this.path=V}};e.$aM=$i,e.$aM=$i=Ge([E],$i);let Pi=class{constructor(V){this.implementation=V}};e.$bM=Pi,e.$bM=Pi=Ge([E],Pi);let ui=class{constructor(V,ve,Me){this.session=V,this.threadId=ve,this.frameId=Me}};e.$cM=ui,e.$cM=ui=Ge([E],ui);let li=class{constructor(V,ve){this.session=V,this.threadId=ve}};e.$dM=li,e.$dM=li=Ge([E],li);let dt=class{constructor(V,ve){this.range=V,this.expression=ve}};e.$eM=dt,e.$eM=dt=Ge([E],dt);var Ji;(function(H){H[H.Invoke=0]="Invoke",H[H.Automatic=1]="Automatic"})(Ji||(e.InlineCompletionTriggerKind=Ji={}));let _t=class{constructor(V,ve){this.range=V,this.text=ve}};e.$fM=_t,e.$fM=_t=Ge([E],_t);let si=class{constructor(V,ve,Me=!0){this.range=V,this.variableName=ve,this.caseSensitiveLookup=Me}};e.$gM=si,e.$gM=si=Ge([E],si);let bi=class{constructor(V,ve){this.range=V,this.expression=ve}};e.$hM=bi,e.$hM=bi=Ge([E],bi);let Ri=class{constructor(V,ve){this.frameId=V,this.stoppedLocation=ve}};e.$iM=Ri,e.$iM=Ri=Ge([E],Ri);var Qi;(function(H){H[H.Changed=1]="Changed",H[H.Created=2]="Created",H[H.Deleted=3]="Deleted"})(Qi||(e.FileChangeType=Qi={}));let Ai=v=class extends Error{static FileExists(V){return new v(V,m.FileSystemProviderErrorCode.FileExists,v.FileExists)}static FileNotFound(V){return new v(V,m.FileSystemProviderErrorCode.FileNotFound,v.FileNotFound)}static FileNotADirectory(V){return new v(V,m.FileSystemProviderErrorCode.FileNotADirectory,v.FileNotADirectory)}static FileIsADirectory(V){return new v(V,m.FileSystemProviderErrorCode.FileIsADirectory,v.FileIsADirectory)}static NoPermissions(V){return new v(V,m.FileSystemProviderErrorCode.NoPermissions,v.NoPermissions)}static Unavailable(V){return new v(V,m.FileSystemProviderErrorCode.Unavailable,v.Unavailable)}constructor(V,ve=m.FileSystemProviderErrorCode.Unknown,Me){super(y.URI.isUri(V)?V.toString(!0):V),this.code=Me?.name??"Unknown",(0,m.$Fk)(this,ve),Object.setPrototypeOf(this,v.prototype),typeof Error.captureStackTrace=="function"&&typeof Me=="function"&&Error.captureStackTrace(this,Me)}};e.$jM=Ai,e.$jM=Ai=v=Ge([E],Ai);let wi=class{constructor(V,ve,Me){this.start=V,this.end=ve,this.kind=Me}};e.$kM=wi,e.$kM=wi=Ge([E],wi);var Yi;(function(H){H[H.Comment=1]="Comment",H[H.Imports=2]="Imports",H[H.Region=3]="Region"})(Yi||(e.FoldingRangeKind=Yi={}));var Li;(function(H){H[H.Collapsed=0]="Collapsed",H[H.Expanded=1]="Expanded"})(Li||(e.CommentThreadCollapsibleState=Li={}));var hi;(function(H){H[H.Editing=0]="Editing",H[H.Preview=1]="Preview"})(hi||(e.CommentMode=hi={}));var Xi;(function(H){H[H.Published=0]="Published",H[H.Draft=1]="Draft"})(Xi||(e.CommentState=Xi={}));var vi;(function(H){H[H.Unresolved=0]="Unresolved",H[H.Resolved=1]="Resolved"})(vi||(e.CommentThreadState=vi={}));class Mi{constructor(V,ve=[]){this.tokenTypes=V,this.tokenModifiers=ve}}e.$lM=Mi;function un(H){return typeof H>"u"||(0,$.$Jf)(H)}class Ti{constructor(V){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,V){this.m=!0;for(let ve=0,Me=V.tokenTypes.length;ve<Me;ve++)this.k.set(V.tokenTypes[ve],ve);for(let ve=0,Me=V.tokenModifiers.length;ve<Me;ve++)this.l.set(V.tokenModifiers[ve],ve)}}push(V,ve,Me,Ze,tt){if(typeof V=="number"&&typeof ve=="number"&&typeof Me=="number"&&typeof Ze=="number"&&(typeof tt=="number"||typeof tt>"u"))return typeof tt>"u"&&(tt=0),this.o(V,ve,Me,Ze,tt);if(j.isRange(V)&&typeof ve=="string"&&un(Me))return this.n(V,ve,Me);throw(0,O.$7)()}n(V,ve,Me){if(!this.m)throw new Error("Legend must be provided in constructor");if(V.start.line!==V.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(ve))throw new Error("`tokenType` is not in the provided legend");const Ze=V.start.line,tt=V.start.character,lt=V.end.character-V.start.character,mt=this.k.get(ve);let Ht=0;if(Me)for(const Zt of Me){if(!this.l.has(Zt))throw new Error("`tokenModifier` is not in the provided legend");const ii=this.l.get(Zt);Ht|=1<<ii>>>0}this.o(Ze,tt,lt,mt,Ht)}o(V,ve,Me,Ze,tt){if(this.f&&(V<this.c||V===this.c&&ve<this.e)){this.f=!1;const Ht=this.g.length/5|0;let Zt=0,ii=0;for(let ni=0;ni<Ht;ni++){let ai=this.g[5*ni],Hi=this.g[5*ni+1];ai===0?(ai=Zt,Hi+=ii):ai+=Zt,this.g[5*ni]=ai,this.g[5*ni+1]=Hi,Zt=ai,ii=Hi}}let lt=V,mt=ve;this.f&&this.j>0&&(lt-=this.c,lt===0&&(mt-=this.e)),this.g[this.j++]=lt,this.g[this.j++]=mt,this.g[this.j++]=Me,this.g[this.j++]=Ze,this.g[this.j++]=tt,this.c=V,this.e=ve}static q(V){const ve=[],Me=V.length/5|0;for(let mt=0;mt<Me;mt++)ve[mt]=mt;ve.sort((mt,Ht)=>{const Zt=V[5*mt],ii=V[5*Ht];if(Zt===ii){const ni=V[5*mt+1],ai=V[5*Ht+1];return ni-ai}return Zt-ii});const Ze=new Uint32Array(V.length);let tt=0,lt=0;for(let mt=0;mt<Me;mt++){const Ht=5*ve[mt],Zt=V[Ht+0],ii=V[Ht+1],ni=V[Ht+2],ai=V[Ht+3],Hi=V[Ht+4],Cn=Zt-tt,jn=Cn===0?ii-lt:ii,Ki=5*mt;Ze[Ki+0]=Cn,Ze[Ki+1]=jn,Ze[Ki+2]=ni,Ze[Ki+3]=ai,Ze[Ki+4]=Hi,tt=Zt,lt=ii}return Ze}build(V){return this.f?new oi(new Uint32Array(this.g),V):new oi(Ti.q(this.g),V)}}e.$mM=Ti;class oi{constructor(V,ve){this.resultId=ve,this.data=V}}e.$nM=oi;class ln{constructor(V,ve,Me){this.start=V,this.deleteCount=ve,this.data=Me}}e.$oM=ln;class hn{constructor(V,ve){this.resultId=ve,this.edits=V}}e.$pM=hn;var Zi;(function(H){H[H.Separate=0]="Separate",H[H.MergeWithParent=1]="MergeWithParent"})(Zi||(e.DebugConsoleMode=Zi={}));let di=class{static{this.Back={iconPath:new yt("arrow-left")}}constructor(){}};e.$qM=di,e.$qM=di=Ge([E],di);var xi;(function(H){H[H.Separator=-1]="Separator",H[H.Default=0]="Default"})(xi||(e.QuickPickItemKind=xi={}));var _i;(function(H){H[H.Info=1]="Info",H[H.Warning=2]="Warning",H[H.Error=3]="Error"})(_i||(e.InputBoxValidationSeverity=_i={}));var pi;(function(H){H[H.UI=1]="UI",H[H.Workspace=2]="Workspace"})(pi||(e.ExtensionKind=pi={}));class en{static validate(V){if(typeof V.badge=="string"){let ve=(0,b.$jf)(V.badge,0);if(ve<V.badge.length&&(ve+=(0,b.$jf)(V.badge,ve)),V.badge.length>ve)throw new Error("The 'badge'-property must be undefined or a short character")}else if(V.badge&&!yt.isThemeIcon(V.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!V.color&&!V.badge&&!V.tooltip)throw new Error("The decoration is empty");return!0}constructor(V,ve,Me){this.badge=V,this.tooltip=ve,this.color=Me}}e.$rM=en;let Fi=class{constructor(V){this.kind=V}};e.$sM=Fi,e.$sM=Fi=Ge([E],Fi);var Ni;(function(H){H[H.Light=1]="Light",H[H.Dark=2]="Dark",H[H.HighContrast=3]="HighContrast",H[H.HighContrastLight=4]="HighContrastLight"})(Ni||(e.ColorThemeKind=Ni={}));class ei{static isNotebookRange(V){return V instanceof ei?!0:V?typeof V.start=="number"&&typeof V.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(V,ve){if(V<0)throw(0,O.$7)("start must be positive");if(ve<0)throw(0,O.$7)("end must be positive");V<=ve?(this.c=V,this.e=ve):(this.c=ve,this.e=V)}with(V){let ve=this.c,Me=this.e;return V.start!==void 0&&(ve=V.start),V.end!==void 0&&(Me=V.end),ve===this.c&&Me===this.e?this:new ei(ve,Me)}}e.$tM=ei;class yi{static validate(V){if(typeof V.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof V.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof V.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(V){return Array.isArray(V)&&V.every(ve=>yi.isNotebookCellData(ve))}static isNotebookCellData(V){return!0}constructor(V,ve,Me,Ze,tt,lt,mt){this.kind=V,this.value=ve,this.languageId=Me,this.mime=Ze,this.outputs=tt??[],this.metadata=lt,this.executionSummary=mt,yi.validate(this)}}e.$uM=yi;class dn{constructor(V){this.cells=V}}e.$vM=dn;class Xt{static isNotebookCellOutputItem(V){return V instanceof Xt?!0:V?typeof V.mime=="string"&&V.data instanceof Uint8Array:!1}static error(V){const ve={name:V.name,message:V.message,stack:V.stack};return Xt.json(ve,"application/vnd.code.notebook.error")}static stdout(V){return Xt.text(V,"application/vnd.code.notebook.stdout")}static stderr(V){return Xt.text(V,"application/vnd.code.notebook.stderr")}static bytes(V,ve="application/octet-stream"){return new Xt(V,ve)}static#e=new TextEncoder;static text(V,ve=A.$fs.text){const Me=Xt.#e.encode(String(V));return new Xt(Me,ve)}static json(V,ve="text/x-json"){const Me=JSON.stringify(V,void 0,"	");return Xt.text(Me,ve)}constructor(V,ve){this.data=V,this.mime=ve;const Me=(0,A.$js)(ve,!0);if(!Me)throw new Error(`INVALID mime type: ${ve}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Me}}e.$wM=Xt;class Ei{static isNotebookCellOutput(V){return V instanceof Ei?!0:!V||typeof V!="object"?!1:typeof V.id=="string"&&Array.isArray(V.items)}static ensureUniqueMimeTypes(V,ve=!1){const Me=new Set,Ze=new Set;for(let tt=0;tt<V.length;tt++){const lt=V[tt],mt=(0,A.$js)(lt.mime);if(!Me.has(mt)||(0,S.$0I)(mt)){Me.add(mt);continue}Ze.add(tt),ve&&console.warn(`DUPLICATED mime type '${lt.mime}' will be dropped`)}return Ze.size===0?V:V.filter((tt,lt)=>!Ze.has(lt))}constructor(V,ve,Me){this.items=Ei.ensureUniqueMimeTypes(V,!0),typeof ve=="string"?(this.id=ve,this.metadata=Me):(this.id=(0,L.$qg)(),this.metadata=ve??Me)}}e.$xM=Ei;var ki;(function(H){H[H.Markup=1]="Markup",H[H.Code=2]="Code"})(ki||(e.NotebookCellKind=ki={}));var Oi;(function(H){H[H.Idle=1]="Idle",H[H.Pending=2]="Pending",H[H.Executing=3]="Executing"})(Oi||(e.NotebookCellExecutionState=Oi={}));var Be;(function(H){H[H.Left=1]="Left",H[H.Right=2]="Right"})(Be||(e.NotebookCellStatusBarAlignment=Be={}));var ti;(function(H){H[H.Default=0]="Default",H[H.InCenter=1]="InCenter",H[H.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",H[H.AtTop=3]="AtTop"})(ti||(e.NotebookEditorRevealType=ti={}));class tn{constructor(V,ve){this.text=V,this.alignment=ve}}e.$yM=tn;var at;(function(H){H[H.Default=1]="Default",H[H.Preferred=2]="Preferred"})(at||(e.NotebookControllerAffinity=at={}));var wt;(function(H){H[H.Default=1]="Default",H[H.Preferred=2]="Preferred",H[H.Hidden=-1]="Hidden"})(wt||(e.NotebookControllerAffinity2=wt={}));class fn{constructor(V,ve=[]){this.uri=V,this.provides=(0,D.$3b)(ve)}}e.$zM=fn;class gn{constructor(V){this.label=V}}e.$AM=gn;var ji;(function(H){H[H.Named=1]="Named",H[H.Indexed=2]="Indexed"})(ji||(e.NotebookVariablesRequestKind=ji={}));let Ui=class{constructor(V,ve){this.label=V,this.timestamp=ve}};e.$BM=Ui,e.$BM=Ui=Ge([E],Ui);var fi;(function(H){H[H.Production=1]="Production",H[H.Development=2]="Development",H[H.Test=3]="Test"})(fi||(e.ExtensionMode=fi={}));var nn;(function(H){H[H.Node=1]="Node",H[H.Webworker=2]="Webworker"})(nn||(e.ExtensionRuntime=nn={}));var rn;(function(H){H[H.Other=0]="Other",H[H.Comment=1]="Comment",H[H.String=2]="String",H[H.RegEx=3]="RegEx"})(rn||(e.StandardTokenType=rn={}));class mn{constructor(V,ve){this.ranges=V,this.wordPattern=ve}}e.$CM=mn;class sn{constructor(V){this.c=V}get autoForwardAction(){return this.c}}e.$DM=sn;var on;(function(H){H[H.Queued=1]="Queued",H[H.Running=2]="Running",H[H.Passed=3]="Passed",H[H.Failed=4]="Failed",H[H.Skipped=5]="Skipped",H[H.Errored=6]="Errored"})(on||(e.TestResultState=on={}));var an;(function(H){H[H.Run=1]="Run",H[H.Debug=2]="Debug",H[H.Coverage=3]="Coverage"})(an||(e.TestRunProfileKind=an={}));let zi=class{constructor(V=void 0,ve=void 0,Me=void 0,Ze=!1){this.include=V,this.exclude=ve,this.profile=Me,this.continuous=Ze}};e.$EM=zi,e.$EM=zi=Ge([E],zi);let Bi=w=class{static diff(V,ve,Me){const Ze=new w(V);return Ze.expectedOutput=ve,Ze.actualOutput=Me,Ze}constructor(V){this.message=V}};e.$FM=Bi,e.$FM=Bi=w=Ge([E],Bi);let Wi=class{constructor(V){this.id=V}};e.$GM=Wi,e.$GM=Wi=Ge([E],Wi);class Si{constructor(V,ve){this.covered=V,this.total=ve}}e.$HM=Si;const Vi=H=>{if(H&&H.covered>H.total)throw new Error(`The total number of covered items (${H.covered}) cannot be greater than the total (${H.total})`)};class qi{static fromDetails(V,ve){const Me=new Si(0,0),Ze=new Si(0,0),tt=new Si(0,0);for(const mt of ve)if("branches"in mt){Me.total+=1,Me.covered+=mt.executionCount>0?1:0;for(const Ht of mt.branches)Ze.total+=1,Ze.covered+=Ht.executionCount>0?1:0}else tt.total+=1,tt.covered+=mt.executionCount>0?1:0;const lt=new qi(V,Me,Ze.total>0?Ze:void 0,tt.total>0?tt:void 0);return lt.detailedCoverage=ve,lt}constructor(V,ve,Me,Ze){this.uri=V,this.statementCoverage=ve,this.branchCoverage=Me,this.functionCoverage=Ze,Vi(ve),Vi(Me),Vi(Ze)}}e.$IM=qi;class $n{constructor(V,ve,Me=[]){this.executionCount=V,this.location=ve,this.branches=Me}}e.$JM=$n;class bn{constructor(V,ve,Me){this.executionCount=V,this.location=ve,this.label=Me}}e.$KM=bn;class $e{constructor(V,ve,Me){this.name=V,this.executionCount=ve,this.location=Me}}e.$LM=$e;var Ee;(function(H){H[H.None=0]="None",H[H.Option=1]="Option",H[H.Default=2]="Default",H[H.Preferred=3]="Preferred"})(Ee||(e.ExternalUriOpenerPriority=Ee={}));var ze;(function(H){H[H.Untrusted=0]="Untrusted",H[H.Trusted=1]="Trusted",H[H.Unspecified=2]="Unspecified"})(ze||(e.WorkspaceTrustState=ze={}));var ut;(function(H){H[H.Notify=1]="Notify",H[H.OpenBrowser=2]="OpenBrowser",H[H.OpenPreview=3]="OpenPreview",H[H.Silent=4]="Silent",H[H.Ignore=5]="Ignore",H[H.OpenBrowserOnce=6]="OpenBrowserOnce"})(ut||(e.PortAutoForwardAction=ut={}));class pt{constructor(V,ve,Me,Ze,tt,lt){this.kind=V,this.name=ve,this.detail=Me,this.uri=Ze,this.range=tt,this.selectionRange=lt}}e.$MM=pt;class Mt{constructor(V){this.uri=V}}e.$NM=Mt;class cn{constructor(V,ve){this.original=V,this.modified=ve}}e.$OM=cn;class In{constructor(V,ve,Me,Ze){this.base=V,this.input1=ve,this.input2=Me,this.result=Ze}}e.$PM=In;class Pn{constructor(V,ve){this.uri=V,this.viewType=ve}}e.$QM=Pn;class Rn{constructor(V){this.viewType=V}}e.$RM=Rn;class An{constructor(V,ve){this.uri=V,this.notebookType=ve}}e.$SM=An;class Ln{constructor(V,ve,Me){this.original=V,this.modified=ve,this.notebookType=Me}}e.$TM=Ln;class Mn{constructor(){}}e.$UM=Mn;class Tn{constructor(V,ve){this.uri=V,this.inputBoxUri=ve}}e.$VM=Tn;class Fn{constructor(V){this.providerId=V}}e.$WM=Fn;var wn;(function(H){H[H.Down=0]="Down",H[H.Up=1]="Up"})(wn||(e.InteractiveSessionVoteDirection=wn={}));var vn;(function(H){H[H.Action=1]="Action",H[H.Toolbar=2]="Toolbar"})(vn||(e.ChatAgentCopyKind=vn={}));var pn;(function(H){H[H.Short=1]="Short",H[H.Medium=2]="Medium",H[H.Full=3]="Full"})(pn||(e.ChatVariableLevel=pn={}));class Nn{constructor(V,ve){this.label=V,this.values=ve}}e.$XM=Nn;var yn;(function(H){H[H.Unhelpful=0]="Unhelpful",H[H.Helpful=1]="Helpful",H[H.Undone=2]="Undone",H[H.Accepted=3]="Accepted",H[H.Bug=4]="Bug"})(yn||(e.InteractiveEditorResponseFeedbackKind=yn={}));var En;(function(H){H[H.System=0]="System",H[H.User=1]="User",H[H.Assistant=2]="Assistant",H[H.Function=3]="Function"})(En||(e.ChatMessageRole=En={}));class On{constructor(V,ve){this.role=V,this.content=ve}}e.$YM=On;var kn;(function(H){H[H.Unhelpful=0]="Unhelpful",H[H.Helpful=1]="Helpful"})(kn||(e.ChatAgentResultFeedbackKind=kn={}));var Sn;(function(H){H[H.SymbolInformation=1]="SymbolInformation",H[H.CommandInformation=2]="CommandInformation",H[H.SearchInformation=3]="SearchInformation",H[H.SettingInformation=4]="SettingInformation"})(Sn||(e.RelatedInformationType=Sn={}));var Dn;(function(H){H[H.Started=1]="Started",H[H.Recognizing=2]="Recognizing",H[H.Recognized=3]="Recognized",H[H.Stopped=4]="Stopped"})(Dn||(e.SpeechToTextStatus=Dn={}))}),define(ke[141],Se([1,0,60,17,12,176,126,7,19]),function(me,e,D,O,g,I,A,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bN=e.$aN=e.$_M=void 0;const y=new Map;function L(S,h){h?y.set(S,h):y.delete(S)}e.$_M=L;function C(S){return y.get(S)}class m extends I.$lv{constructor(h,f,o,i,r,n,c,t){super(f,o,i,r),this.c=h,this.m=n,this.q=c,this.notebook=t,this.b=!1}dispose(){(0,D.ok)(!this.b),this.b=!0,this.q=!1}equalLines(h){return(0,$.$ub)(this.f,h)}get document(){if(!this.a){const h=this;this.a={get uri(){return h.d},get fileName(){return h.d.fsPath},get isUntitled(){return h.d.scheme===O.Schemas.untitled},get languageId(){return h.m},get version(){return h.h},get isClosed(){return h.b},get isDirty(){return h.q},save(){return h.r()},getText(f){return f?h.s(f):h.getText()},get eol(){return h.g===`
`?b.EndOfLine.LF:b.EndOfLine.CRLF},get lineCount(){return h.f.length},lineAt(f){return h.t(f)},offsetAt(f){return h.u(f)},positionAt(f){return h.v(f)},validateRange(f){return h.w(f)},validatePosition(f){return h.x(f)},getWordRangeAtPosition(f,o){return h.y(f,o)}}}return Object.freeze(this.a)}_acceptLanguageId(h){(0,D.ok)(!this.b),this.m=h}_acceptIsDirty(h){(0,D.ok)(!this.b),this.q=h}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(h){const f=this.w(h);if(f.isEmpty)return"";if(f.isSingleLine)return this.f[f.start.line].substring(f.start.character,f.end.character);const o=this.g,i=f.start.line,r=f.end.line,n=[];n.push(this.f[i].substring(f.start.character));for(let c=i+1;c<r;c++)n.push(this.f[c]);return n.push(this.f[r].substring(0,f.end.character)),n.join(o)}t(h){let f;if(h instanceof b.$9K?f=h.line:typeof h=="number"&&(f=h),typeof f!="number"||f<0||f>=this.f.length||Math.floor(f)!==f)throw new Error("Illegal value for `line`");return new p(f,this.f[f],f===this.f.length-1)}u(h){return h=this.x(h),this.l(),this.j.getPrefixSum(h.line-1)+h.character}v(h){h=Math.floor(h),h=Math.max(0,h),this.l();const f=this.j.getIndexOf(h),o=this.f[f.index].length;return new b.$9K(f.index,Math.min(f.remainder,o))}w(h){if(!(h instanceof b.$0K))throw new Error("Invalid argument");const f=this.x(h.start),o=this.x(h.end);return f===h.start&&o===h.end?h:new b.$0K(f.line,f.character,o.line,o.character)}x(h){if(!(h instanceof b.$9K))throw new Error("Invalid argument");if(this.f.length===0)return h.with(0,0);let{line:f,character:o}=h,i=!1;if(f<0)f=0,o=0,i=!0;else if(f>=this.f.length)f=this.f.length-1,o=this.f[f].length,i=!0;else{const r=this.f[f].length;o<0?(o=0,i=!0):o>r&&(o=r,i=!0)}return i?new b.$9K(f,o):h}y(h,f){const o=this.x(h);if(!f)f=C(this.m);else if((0,g.$Ye)(f))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${f.source}' because it matches the empty string.`);const i=(0,A.$xs)(o.character+1,(0,A.$vs)(f),this.f[o.line],0);if(i)return new b.$0K(o.line,i.startColumn-1,o.line,i.endColumn-1)}}e.$aN=m;class p{constructor(h,f,o){this.a=h,this.b=f,this.c=o}get lineNumber(){return this.a}get text(){return this.b}get range(){return new b.$0K(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new b.$0K(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$bN=p}),define(ke[284],Se([1,0,7,20,4]),function(me,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2hc=void 0;let I=class{constructor(b){this.a=new D.$sM(D.ColorThemeKind.Dark),this.b=new g.$Vd}get activeColorTheme(){return this.a}$onColorThemeChange(b){let $;switch(b){case"light":$=D.ColorThemeKind.Light;break;case"hcDark":$=D.ColorThemeKind.HighContrast;break;case"hcLight":$=D.ColorThemeKind.HighContrastLight;break;default:$=D.ColorThemeKind.Dark}this.a=new D.$sM($),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$2hc=I,e.$2hc=I=Ge([We(0,O.$0M)],I)}),define(ke[285],Se([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bJ=e.CellExecutionUpdateType=void 0;var O;(function(g){g[g.Output=1]="Output",g[g.OutputItems=2]="OutputItems",g[g.ExecutionState=3]="ExecutionState"})(O||(e.CellExecutionUpdateType=O={})),e.$bJ=(0,D.$6h)("INotebookExecutionService")}),define(ke[286],Se([1,0,3,29,193,99]),function(me,e,D,O,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KQb=void 0;class A extends D.$Tc{constructor($,y,L){super(),this._source=$,this.b=y,this.c=L,this.a=void 0}f($){const y=$.getLineCount();return new O.$Us(1,1,y,this.g($,y))}g($,y){if(y<1||y>$.getLineCount())throw new Error("Illegal value for lineNumber");return $.getLineLength(y)+1}get inputTextBuffer(){if(!this.b){const $=new g.$cC;$.acceptChunk(this._source);const y=$.finish(!0),{textBuffer:L,disposable:C}=y.create(1);this.b=L,this.B(C)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map($=>{const y=new g.$cC;y.acceptChunk($);const L=y.finish(!0),{textBuffer:C,disposable:m}=L.create(1);return this.B(m),C})),this.a}findInInputs($){const L=new I.$3B($,!1,!1,null).parseSearchRequest();if(!L)return[];const C=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(C,L,!0,5e3)}findInOutputs($){const L=new I.$3B($,!1,!1,null).parseSearchRequest();return L?this.outputTextBuffers.map(C=>{const m=C.findMatchesLineByLine(this.f(C),L,!0,5e3);if(m.length!==0)return{textBuffer:C,matches:m}}).filter(C=>!!C):[]}}e.$KQb=A}),define(ke[67],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XJ=e.TestPosition=e.TestIdPathParts=void 0;var D;(function(I){I.Delimiter="\0"})(D||(e.TestIdPathParts=D={}));var O;(function(I){I[I.IsSame=0]="IsSame",I[I.Disconnected=1]="Disconnected",I[I.IsChild=2]="IsChild",I[I.IsParent=3]="IsParent"})(O||(e.TestPosition=O={}));class g{static fromExtHostTestItem(A,b,$=A.parent){if(A._isRoot)return new g([b]);const y=[A.id];for(let L=$;L&&L.id!==b;L=L.parent)y.push(L.id);return y.push(b),new g(y.reverse())}static isRoot(A){return!A.includes("\0")}static root(A){const b=A.indexOf("\0");return b===-1?A:A.slice(0,b)}static fromString(A){return new g(A.split("\0"))}static join(A,b){return new g([...A.path,b])}static joinToString(A,b){return A.toString()+"\0"+b}static parentId(A){const b=A.lastIndexOf("\0");return b===-1?void 0:A.slice(0,b)}static localId(A){const b=A.lastIndexOf("\0");return b===-1?A:A.slice(b+1)}static isChild(A,b){return b.startsWith(A)&&b[A.length]==="\0"}static compare(A,b){return A===b?0:g.isChild(A,b)?2:g.isChild(b,A)?3:1}constructor(A,b=A.length){if(this.path=A,this.d=b,A.length===0||b<1)throw new Error("cannot create test with empty path")}get rootId(){return new g(this.path,1)}get parentId(){return this.d>1?new g(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let A=1;A<=this.d;A++)yield new g(this.path,A)}*idsToRoot(){for(let A=this.d;A>0;A--)yield new g(this.path,A)}compare(A){if(typeof A=="string")return g.compare(this.toString(),A);for(let b=0;b<A.d&&b<this.d;b++)if(A.path[b]!==this.path[b])return 1;return A.d>this.d?2:A.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let A=1;A<this.d;A++)this.c+="\0",this.c+=this.path[A]}return this.c}}e.$XJ=g}),define(ke[89],Se([1,0,2,48,29,67]),function(me,e,D,O,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6J=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IFunctionCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$5J=e.IFileCoverage=e.ICoveredCount=e.TestResultItem=e.$4J=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$3J=e.$2J=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$1J=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$ZJ=e.$YJ=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var A;(function(T){T[T.Unset=0]="Unset",T[T.Queued=1]="Queued",T[T.Running=2]="Running",T[T.Passed=3]="Passed",T[T.Failed=4]="Failed",T[T.Skipped=5]="Skipped",T[T.Errored=6]="Errored"})(A||(e.TestResultState=A={}));var b;(function(T){T[T.Run=1]="Run",T[T.Debug=2]="Debug",T[T.Coverage=3]="Coverage"})(b||(e.ExtTestRunProfileKind=b={}));var $;(function(T){T[T.Run=2]="Run",T[T.Debug=4]="Debug",T[T.Coverage=8]="Coverage",T[T.HasNonDefaultProfile=16]="HasNonDefaultProfile",T[T.HasConfigurable=32]="HasConfigurable",T[T.SupportsContinuousRun=64]="SupportsContinuousRun"})($||(e.TestRunProfileBitset=$={})),e.$YJ=[2,4,8,16,32,64];const y=T=>"runId"in T;e.$ZJ=y;var L;(function(T){T.serialize=M=>({range:M.range.toJSON(),uri:M.uri.toJSON()}),T.deserialize=(M,B)=>({range:g.$Us.lift(B.range),uri:M.asCanonicalUri(D.URI.revive(B.uri))})})(L||(e.IRichLocation=L={}));var C;(function(T){T[T.Error=0]="Error",T[T.Output=1]="Output"})(C||(e.TestMessageType=C={}));var m;(function(T){T.serialize=M=>({message:M.message,type:0,expected:M.expected,actual:M.actual,contextValue:M.contextValue,location:M.location&&L.serialize(M.location)}),T.deserialize=(M,B)=>({message:B.message,type:0,expected:B.expected,actual:B.actual,contextValue:B.contextValue,location:B.location&&L.deserialize(M,B.location)})})(m||(e.ITestErrorMessage=m={}));const p=(T,M)=>`${M?"s":"e"}${T}`;e.$1J=p;var S;(function(T){T.serialize=M=>({message:M.message,type:1,offset:M.offset,length:M.length,location:M.location&&L.serialize(M.location)}),T.deserialize=(M,B)=>({message:B.message,type:1,offset:B.offset,length:B.length,location:B.location&&L.deserialize(M,B.location)})})(S||(e.ITestOutputMessage=S={}));var h;(function(T){T.serialize=M=>M.type===0?m.serialize(M):S.serialize(M),T.deserialize=(M,B)=>B.type===0?m.deserialize(M,B):S.deserialize(M,B)})(h||(e.ITestMessage=h={}));var f;(function(T){T.serializeWithoutMessages=M=>({state:M.state,duration:M.duration,messages:[]}),T.serialize=M=>({state:M.state,duration:M.duration,messages:M.messages.map(h.serialize)}),T.deserialize=(M,B)=>({state:B.state,duration:B.duration,messages:B.messages.map(Y=>h.deserialize(M,Y))})})(f||(e.ITestTaskState=f={}));const o="\0",i=(T,M)=>T+o+M;e.$2J=i;const r=T=>{const M=T.indexOf(o);return{ctrlId:T.slice(0,M),tagId:T.slice(M+1)}};e.$3J=r;var n;(function(T){T.serialize=M=>({extId:M.extId,label:M.label,tags:M.tags,busy:M.busy,children:void 0,uri:M.uri?.toJSON(),range:M.range?.toJSON()||null,description:M.description,error:M.error,sortText:M.sortText}),T.deserialize=(M,B)=>({extId:B.extId,label:B.label,tags:B.tags,busy:B.busy,children:void 0,uri:B.uri?M.asCanonicalUri(D.URI.revive(B.uri)):void 0,range:B.range?g.$Us.lift(B.range):null,description:B.description,error:B.error,sortText:B.sortText})})(n||(e.ITestItem=n={}));var c;(function(T){T[T.NotExpandable=0]="NotExpandable",T[T.Expandable=1]="Expandable",T[T.BusyExpanding=2]="BusyExpanding",T[T.Expanded=3]="Expanded"})(c||(e.TestItemExpandState=c={}));var t;(function(T){T.serialize=M=>({expand:M.expand,item:n.serialize(M.item)}),T.deserialize=(M,B)=>({controllerId:I.$XJ.root(B.item.extId),expand:B.expand,item:n.deserialize(M,B.item)})})(t||(e.InternalTestItem=t={}));var u;(function(T){T.serialize=M=>{let B;return M.item&&(B={},M.item.label!==void 0&&(B.label=M.item.label),M.item.tags!==void 0&&(B.tags=M.item.tags),M.item.busy!==void 0&&(B.busy=M.item.busy),M.item.uri!==void 0&&(B.uri=M.item.uri?.toJSON()),M.item.range!==void 0&&(B.range=M.item.range?.toJSON()),M.item.description!==void 0&&(B.description=M.item.description),M.item.error!==void 0&&(B.error=M.item.error),M.item.sortText!==void 0&&(B.sortText=M.item.sortText)),{extId:M.extId,expand:M.expand,item:B}},T.deserialize=M=>{let B;return M.item&&(B={},M.item.label!==void 0&&(B.label=M.item.label),M.item.tags!==void 0&&(B.tags=M.item.tags),M.item.busy!==void 0&&(B.busy=M.item.busy),M.item.range!==void 0&&(B.range=M.item.range?g.$Us.lift(M.item.range):null),M.item.description!==void 0&&(B.description=M.item.description),M.item.error!==void 0&&(B.error=M.item.error),M.item.sortText!==void 0&&(B.sortText=M.item.sortText)),{extId:M.extId,expand:M.expand,item:B}}})(u||(e.ITestItemUpdate=u={}));const s=(T,M)=>{M.expand!==void 0&&(T.expand=M.expand),M.item!==void 0&&(T.item=T.item?Object.assign(T.item,M.item):M.item)};e.$4J=s;var l;(function(T){T.serializeWithoutMessages=M=>({...t.serialize(M),ownComputedState:M.ownComputedState,computedState:M.computedState,tasks:M.tasks.map(f.serializeWithoutMessages)}),T.serialize=M=>({...t.serialize(M),ownComputedState:M.ownComputedState,computedState:M.computedState,tasks:M.tasks.map(f.serialize)}),T.deserialize=(M,B)=>({...t.deserialize(M,B),ownComputedState:B.ownComputedState,computedState:B.computedState,tasks:B.tasks.map(Y=>f.deserialize(M,Y)),retired:!0})})(l||(e.TestResultItem=l={}));var a;(function(T){T.empty=()=>({covered:0,total:0}),T.sum=(M,B)=>{M.covered+=B.covered,M.total+=B.total}})(a||(e.ICoveredCount=a={}));var d;(function(T){T.serialize=M=>({statement:M.statement,branch:M.branch,function:M.function,details:M.details?.map(w.serialize),uri:M.uri.toJSON()}),T.deserialize=(M,B)=>({statement:B.statement,branch:B.branch,function:B.function,details:B.details?.map(w.deserialize),uri:M.asCanonicalUri(D.URI.revive(B.uri))})})(d||(e.IFileCoverage=d={}));function k(T){return{...T,location:T.location?.toJSON()}}function R(T){return T.location=T.location?O.$Ts.isIPosition(T.location)?O.$Ts.lift(T.location):g.$Us.lift(T.location):void 0,T}e.$5J=3;var v;(function(T){T[T.Function=0]="Function",T[T.Statement=1]="Statement",T[T.Branch=2]="Branch"})(v||(e.DetailType=v={}));var w;(function(T){T.serialize=M=>M.type===0?P.serialize(M):N.serialize(M),T.deserialize=M=>M.type===0?P.deserialize(M):N.deserialize(M)})(w||(e.CoverageDetails=w={}));var E;(function(T){T.serialize=k,T.deserialize=R})(E||(e.IBranchCoverage=E={}));var P;(function(T){T.serialize=k,T.deserialize=R})(P||(e.IFunctionCoverage=P={}));var N;(function(T){T.serialize=M=>({...k(M),branches:M.branches?.map(E.serialize)}),T.deserialize=M=>({...R(M),branches:M.branches?.map(E.deserialize)})})(N||(e.IStatementCoverage=N={}));var U;(function(T){T[T.Add=0]="Add",T[T.Update=1]="Update",T[T.DocumentSynced=2]="DocumentSynced",T[T.Remove=3]="Remove",T[T.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",T[T.Retire=5]="Retire",T[T.AddTag=6]="AddTag",T[T.RemoveTag=7]="RemoveTag"})(U||(e.TestDiffOpType=U={}));var F;(function(T){T.deserialize=(M,B)=>B.op===0?{op:B.op,item:t.deserialize(M,B.item)}:B.op===1?{op:B.op,item:u.deserialize(B.item)}:B.op===2?{op:B.op,uri:M.asCanonicalUri(D.URI.revive(B.uri)),docv:B.docv}:B,T.serialize=M=>M.op===0?{op:M.op,item:t.serialize(M.item)}:M.op===1?{op:M.op,item:u.serialize(M.item)}:M})(F||(e.TestsDiffOp=F={}));class j{constructor(M){this.k=M,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(M){const B=this.v();for(const Y of M)switch(Y.op){case 0:this.l(t.deserialize(this.k,Y.item),B);break;case 1:this.o(u.deserialize(Y.item),B);break;case 3:this.p(Y.itemId,B);break;case 5:this.q(Y.itemId);break;case 4:this.updatePendingRoots(Y.amount);break;case 6:this.c.set(Y.tag.id,Y.tag);break;case 7:this.c.delete(Y.id);break}B.complete?.()}l(M,B){const Y=I.$XJ.parentId(M.item.extId)?.toString();let ue;if(!Y)ue=this.w(M),this.g.add(ue),this.f.set(M.item.extId,ue);else if(this.f.has(Y)){const Z=this.f.get(Y);Z.children.add(M.item.extId),ue=this.w(M,Z),this.f.set(M.item.extId,ue)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(M)}`);return}return B.add?.(ue),M.expand===2&&this.h++,ue}o(M,B){const Y=this.f.get(M.extId);if(Y)return M.expand!==void 0&&(Y.expand===2&&this.h--,M.expand===2&&this.h++),(0,e.$4J)(Y,M),B.update?.(Y),Y}p(M,B){const Y=this.f.get(M);if(!Y)return;const ue=I.$XJ.parentId(Y.item.extId)?.toString();ue?this.f.get(ue).children.delete(Y.item.extId):this.g.delete(Y);const Z=[[M]];for(;Z.length;)for(const J of Z.pop()){const X=this.f.get(J);X&&(Z.push(X.children),this.f.delete(J),B.remove?.(X,X!==Y),X.expand===2&&this.h--)}}q(M){}updatePendingRoots(M){this.j+=M}v(){return{}}}e.$6J=j}),define(ke[112],Se([1,0,11,4,3,60,89,67]),function(me,e,D,O,g,I,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4M=e.$3M=e.$2M=e.$1M=e.$ZM=e.TestItemEventOp=void 0;var $;(function(i){i[i.Upsert=0]="Upsert",i[i.SetTags=1]="SetTags",i[i.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",i[i.RemoveChild=3]="RemoveChild",i[i.SetProp=4]="SetProp",i[i.Bulk=5]="Bulk",i[i.DocumentSynced=6]="DocumentSynced"})($||(e.TestItemEventOp=$={}));const y=(i,r)=>i===r,C=Object.entries({range:(i,r)=>i===r?!0:!i||!r?!1:i.equalsRange(r),busy:y,label:y,description:y,error:y,sortText:y,tags:(i,r)=>!(i.length!==r.length||i.some(n=>!r.includes(n)))}),m=(i,r)=>{let n;for(const[c,t]of C)t(i[c],r[c])||(n?n[c]=r[c]:n={[c]:r[c]});return n};class p extends g.$Tc{get root(){return this.s.root}constructor(r){super(),this.s=r,this.f=this.B(new D.$fh(()=>this.flushDiff(),200)),this.g=this.B(new O.$Vd),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(r){this.h=r;for(const n of this.tree.values())this.J(n)}get resolveHandler(){return this.h}collectDiff(){const r=this.m;return this.m=[],r}pushDiff(r){switch(r.op){case 2:{for(const n of this.m)if(n.op===2&&n.uri===r.uri){n.docv=r.docv;return}break}case 1:{const n=this.m[this.m.length-1];if(n){if(n.op===1&&n.item.extId===r.item.extId){(0,A.$4J)(n.item,r.item);return}if(n.op===0&&n.item.item.extId===r.item.extId){(0,A.$4J)(n.item,r.item);return}}break}}this.m.push(r),this.f.isScheduled()||this.f.schedule()}expand(r,n){const c=this.tree.get(r);if(c){if((c.expandLevels===void 0||n>c.expandLevels)&&(c.expandLevels=n),c.expand===1){const t=this.M(c);return t.isOpen()?this.L(c,n-1):t.wait().then(()=>this.L(c,n-1))}else if(c.expand===3)return c.resolveBarrier?.isOpen()===!1?c.resolveBarrier.wait().then(()=>this.L(c,n-1)):this.L(c,n-1)}}dispose(){for(const r of this.tree.values())this.s.getApiFor(r.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(r,n){switch(n.op){case 3:this.O(b.$XJ.joinToString(r.fullId,n.id));break;case 0:this.z(n.item,r);break;case 5:for(const c of n.ops)this.w(r,c);break;case 1:this.C(n.new,n.old,r.fullId.toString());break;case 2:this.J(r);break;case 4:this.pushDiff({op:1,item:{extId:r.fullId.toString(),item:n.update}});break;case 6:this.y(r.actual.uri);break;default:(0,I.$6c)(n)}}y(r){r&&this.pushDiff({op:2,uri:r,docv:this.s.getDocumentVersion(r)})}z(r,n){const c=b.$XJ.fromExtHostTestItem(r,this.root.id,n?.actual),t=this.s.getApiFor(r);t.parent&&t.parent!==n?.actual&&this.s.getChildren(t.parent).delete(r.id);let u=this.tree.get(c.toString());if(!u){u={fullId:c,actual:r,expandLevels:n?.expandLevels?n.expandLevels-1:void 0,expand:0},r.tags.forEach(this.D,this),this.tree.set(u.fullId.toString(),u),this.G(r,n),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:u.expand,item:this.s.toITestItem(r)}}),this.I(r,u,n);return}if(u.actual===r){this.H(r,u,n);return}if(u.actual.uri?.toString()!==r.uri?.toString())return this.O(c.toString()),this.z(r,n);const s=this.s.getChildren(u.actual),l=u.actual,a=m(this.s.toITestItem(l),this.s.toITestItem(r));this.s.getApiFor(l).listener=void 0,u.actual=r,u.expand=0,a&&(a.hasOwnProperty("tags")&&(this.C(r.tags,l.tags,c.toString()),delete a.tags),this.w(u,{op:4,update:a})),this.I(r,u,n);for(const[d,k]of s)this.s.getChildren(r).get(k.id)||this.O(b.$XJ.joinToString(c,k.id));this.y(u.actual.uri)}C(r,n,c){const t=new Set(n.map(u=>u.id));for(const u of r)t.delete(u.id)||this.D(u);this.pushDiff({op:1,item:{extId:c,item:{tags:r.map(u=>(0,A.$2J)(this.s.controllerId,u.id))}}}),t.forEach(this.F,this)}D(r){const n=this.j.get(r.id);n?n.refCount++:(this.j.set(r.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,A.$2J)(this.s.controllerId,r.id)}}))}F(r){const n=this.j.get(r);n&&!--n.refCount&&(this.j.delete(r),this.pushDiff({op:7,id:(0,A.$2J)(this.s.controllerId,r)}))}G(r,n){this.s.getApiFor(r).parent=n&&n.actual!==this.root?n.actual:void 0}H(r,n,c){this.G(r,c);const t=this.s.getApiFor(r);t.parent=c?.actual,t.listener=u=>this.w(n,u),this.J(n)}I(r,n,c){this.H(r,n,c);for(const[t,u]of this.s.getChildren(r))this.z(u,n)}J(r){let n;this.h?r.resolveBarrier?n=r.resolveBarrier.isOpen()?3:2:n=r.actual.canResolveChildren?1:0:n=0,n!==r.expand&&(r.expand=n,this.pushDiff({op:1,item:{extId:r.fullId.toString(),expand:n}}),n===1&&r.expandLevels!==void 0&&this.M(r))}L(r,n){if(n<0)return;const c=[];for(const[t,u]of this.s.getChildren(r.actual)){const s=this.expand(b.$XJ.joinToString(r.fullId,u.id),n);(0,D.$Sg)(s)&&c.push(s)}if(c.length)return Promise.all(c).then(()=>{})}M(r){if(r.resolveBarrier)return r.resolveBarrier;if(!this.h){const u=new D.$5g;return u.open(),u}r.expand=2,this.N(r);const n=r.resolveBarrier=new D.$5g,c=u=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,u)};let t;try{t=this.h(r.actual===this.root?void 0:r.actual)}catch(u){c(u)}return(0,D.$Sg)(t)?t.catch(c).then(()=>{n.open(),this.J(r)}):(n.open(),this.J(r)),r.resolveBarrier}N(r){this.pushDiff({op:1,item:{extId:r.fullId.toString(),expand:r.expand}})}O(r){const n=this.tree.get(r);if(!n)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:r});const c=[n];for(;c.length;){const t=c.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const u of t.actual.tags)this.F(u.id);this.tree.delete(t.fullId.toString());for(const[u,s]of this.s.getChildren(t.actual))c.push(this.tree.get(b.$XJ.joinToString(t.fullId,s.id)))}}}flushDiff(){const r=this.collectDiff();r.length&&this.g.fire(r)}}e.$ZM=p;class S extends Error{constructor(r){super(`Attempted to insert a duplicate test item ID ${r}`)}}e.$1M=S;class h extends Error{constructor(r){super(`TestItem with ID "${r}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$2M=h;class f extends Error{constructor(r,n,c){super(`TestItem with ID "${r}" is from controller "${n}" and cannot be added as a child of an item from controller "${c}".`)}}e.$3M=f;const o=(i,r,n)=>{let c=new Map;return{get size(){return c.size},forEach(t,u){for(const s of c.values())t.call(u,s,this)},[Symbol.iterator](){return c.entries()},replace(t){const u=new Map,s=new Set(c.keys()),l={op:5,ops:[]};for(const a of t){if(!(a instanceof n))throw new h(a.id);const d=r(a).controllerId;if(d!==i.controllerId)throw new f(a.id,d,i.controllerId);if(u.has(a.id))throw new S(a.id);u.set(a.id,a),s.delete(a.id),l.ops.push({op:0,item:a})}for(const a of s.keys())l.ops.push({op:3,id:a});i.listener?.(l),c=u},add(t){if(!(t instanceof n))throw new h(t.id);c.set(t.id,t),i.listener?.({op:0,item:t})},delete(t){c.delete(t)&&i.listener?.({op:3,id:t})},get(t){return c.get(t)},toJSON(){return Array.from(c.values())}}};e.$4M=o}),define(ke[142],Se([1,0,112]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6M=e.$5M=void 0;const O=new WeakMap,g=(A,b)=>{const $={controllerId:b};return O.set(A,$),$};e.$5M=g;const I=A=>{const b=O.get(A);if(!b)throw new D.$2M(A?.id||"<unknown>");return b};e.$6M=I}),define(ke[113],Se([1,0,17,2]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xvb=e.$wvb=e.$vvb=e.$uvb=e.$tvb=void 0,e.$tvb="vscode-cdn.net",e.$uvb=`vscode-resource.${e.$tvb}`,e.$vvb=`'self' https://*.${e.$tvb}`;function g(b,$){return b.scheme===D.Schemas.http||b.scheme===D.Schemas.https?b:($&&$.authority&&$.isRemote&&b.scheme===D.Schemas.file&&(b=O.URI.from({scheme:D.Schemas.vscodeRemote,authority:$.authority,path:b.path})),O.URI.from({scheme:D.Schemas.https,authority:`${b.scheme}+${I(b.authority)}.${e.$uvb}`,path:b.path,fragment:b.fragment,query:b.query}))}e.$wvb=g;function I(b){return b.replace(/./g,$=>{const y=$.charCodeAt(0);return y>=97&&y<=122||y>=65&&y<=90||y>=48&&y<=57?$:"-"+y.toString(16).padStart(4,"0")})}function A(b){return b.replace(/-([0-9a-f]{4})/g,($,y)=>String.fromCharCode(parseInt(y,16)))}e.$xvb=A}),define(ke[287],Se([1,0,4,3,113]),function(me,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lgc=void 0;class I{constructor(b,$,y){this.d=b,this.e=$,this.f=y,this.a=0,this.b=new O.$Sc,this.c=new Map,this.b.add($.onDidChangeVisibleTextEditors(()=>{const L=$.getVisibleTextEditors();for(const C of this.c.values())L.indexOf(C.editor)<0&&C.inset.dispose()}))}dispose(){this.c.forEach(b=>b.inset.dispose()),this.b.dispose()}createWebviewEditorInset(b,$,y,L,C){let m;for(const r of this.e.getVisibleTextEditors(!0))if(r.value===b){m=r;break}if(!m)throw new Error("not a visible editor");const p=this,S=this.a++,h=new D.$Vd,f=new D.$Vd,o=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(r){return(0,g.$wvb)(r,p.f)}get cspSource(){return g.$vvb}set options(r){this.b=r,p.d.$setOptions(S,r)}get options(){return this.b}set html(r){this.a=r,p.d.$setHtml(S,r)}get html(){return this.a}get onDidReceiveMessage(){return h.event}postMessage(r){return p.d.$postMessage(S,r)}},i=new class{constructor(){this.editor=b,this.line=$,this.height=y,this.webview=o,this.onDidDispose=f.event}dispose(){p.c.has(S)&&(p.c.delete(S),p.d.$disposeEditorInset(S),f.fire(),f.dispose(),h.dispose())}};return this.d.$createEditorInset(S,m.id,m.value.document.uri,$+1,y,L||{},C.identifier,C.extensionLocation),this.c.set(S,{editor:b,inset:i,onDidReceiveMessage:h}),i}$onDidDispose(b){const $=this.c.get(b);$&&$.inset.dispose()}$onDidReceiveMessage(b,$){this.c.get(b)?.onDidReceiveMessage.fire($)}}e.$lgc=I}),define(ke[288],Se([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WN=e.VariableKind=e.$VN=void 0,e.$VN=(0,D.$6h)("configurationResolverService");var O;(function(I){I.Unknown="unknown",I.Env="env",I.Config="config",I.Command="command",I.Input="input",I.ExtensionInstallFolder="extensionInstallFolder",I.WorkspaceFolder="workspaceFolder",I.Cwd="cwd",I.WorkspaceFolderBasename="workspaceFolderBasename",I.UserHome="userHome",I.LineNumber="lineNumber",I.SelectedText="selectedText",I.File="file",I.FileWorkspaceFolder="fileWorkspaceFolder",I.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",I.RelativeFile="relativeFile",I.RelativeFileDirname="relativeFileDirname",I.FileDirname="fileDirname",I.FileExtname="fileExtname",I.FileBasename="fileBasename",I.FileBasenameNoExtension="fileBasenameNoExtension",I.FileDirnameBasename="fileDirnameBasename",I.ExecPath="execPath",I.ExecInstallFolder="execInstallFolder",I.PathSeparator="pathSeparator",I.PathSeparatorAlias="/"})(O||(e.VariableKind=O={}));class g extends Error{constructor(A,b){super(b),this.variable=A}}e.$WN=g}),define(ke[289],Se([1,0,16,49,18,24,10,102,231,288,12]),function(me,e,D,O,g,I,A,b,$,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$N=void 0;class C{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(p,S,h,f){this.h=new Map,this.a=p,this.b=S,this.g=h,f&&(this.c=f.then(o=>this.i(o)))}i(p){if(A.$i){const S=Object.create(null);return Object.keys(p).forEach(h=>{S[h.toLowerCase()]=p[h]}),S}return p}resolveWithEnvironment(p,S,h){return this.l({env:this.i(p),userHome:void 0},S?S.uri:void 0,h)}async resolveAsync(p,S){const h={env:await this.c,userHome:await this.g};return this.l(h,p?p.uri:void 0,S)}async j(p,S,h,f){const o=I.$vn(S);A.$i&&o.windows?Object.keys(o.windows).forEach(r=>o[r]=o.windows[r]):A.$j&&o.osx?Object.keys(o.osx).forEach(r=>o[r]=o.osx[r]):A.$k&&o.linux&&Object.keys(o.linux).forEach(r=>o[r]=o.linux[r]),delete o.windows,delete o.osx,delete o.linux;const i={env:await this.c,userHome:await this.g};return this.l(i,p?p.uri:void 0,o,h,f)}async resolveAnyAsync(p,S,h){return this.j(p,S,h)}async resolveAnyMap(p,S,h){const f=new Map;return{newConfig:await this.j(p,S,h,f),resolvedVariables:f}}resolveWithInteractionReplace(p,S,h,f){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(p,S,h,f){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(p,S){if(this.h.has(p))throw new Error("Variable "+p+" is contributed twice.");this.h.set(p,S)}async l(p,S,h,f,o){if(g.$If(h))return this.m(p,S,h,f,o);if(Array.isArray(h))return Promise.all(h.map(i=>this.l(p,S,i,f,o)));if(g.$Kf(h)){const i=Object.create(null),r=await Promise.all(Object.keys(h).map(async n=>[await this.m(p,S,n,f,o),await this.l(p,S,h[n],f,o)]));for(const[n,c]of r)i[n]=c;return i}return h}m(p,S,h,f,o){return(0,L.$4e)(h,C.VARIABLE_REGEXP,async(i,r)=>{if(r.includes(C.VARIABLE_LHS))return i;let n=await this.o(p,i,r,S,f);return o?.set(r,n),n!==i&&g.$If(n)&&n.match(C.VARIABLE_REGEXP)&&(n=await this.m(p,S,n,f,o)),n})}n(p){return this.b?this.b.getUriLabel(p,{noPrefix:!0}):p.fsPath}async o(p,S,h,f,o){let i;const r=h.split(":");r.length>1&&(h=r[0],i=r[1]);const n=u=>{const s=this.a.getFilePath();if(s)return(0,b.$Wv)(s);throw new y.$WN(u,(0,$.localize)(0,null,S))},c=u=>{const s=n(u);if(this.a.getWorkspaceFolderPathForFile){const l=this.a.getWorkspaceFolderPathForFile();if(l)return(0,b.$Wv)(l)}throw new y.$WN(u,(0,$.localize)(1,null,S,D.$nc(s)))},t=u=>{if(i){const s=this.a.getFolderUri(i);if(s)return s;throw new y.$WN(u,(0,$.localize)(2,null,S,i))}if(f)return f;throw this.a.getWorkspaceFolderCount()>1?new y.$WN(u,(0,$.localize)(3,null,S)):new y.$WN(u,(0,$.localize)(4,null,S))};switch(h){case"env":if(i){if(p.env){const u=p.env[A.$i?i.toLowerCase():i];if(g.$If(u))return u}return""}throw new y.$WN(y.VariableKind.Env,(0,$.localize)(5,null,S));case"config":if(i){const u=this.a.getConfigurationValue(f,i);if(g.$Rf(u))throw new y.$WN(y.VariableKind.Config,(0,$.localize)(6,null,S,i));if(g.$Kf(u))throw new y.$WN(y.VariableKind.Config,(0,$.localize)(7,null,S,i));return u}throw new y.$WN(y.VariableKind.Config,(0,$.localize)(8,null,S));case"command":return this.p(y.VariableKind.Command,S,i,o,"command");case"input":return this.p(y.VariableKind.Input,S,i,o,"input");case"extensionInstallFolder":if(i){const u=await this.a.getExtension(i);if(!u)throw new y.$WN(y.VariableKind.ExtensionInstallFolder,(0,$.localize)(9,null,S,i));return this.n(u.extensionLocation)}throw new y.$WN(y.VariableKind.ExtensionInstallFolder,(0,$.localize)(10,null,S));default:switch(h){case"workspaceRoot":case"workspaceFolder":return(0,b.$Wv)(this.n(t(y.VariableKind.WorkspaceFolder)));case"cwd":return f||i?(0,b.$Wv)(this.n(t(y.VariableKind.Cwd))):O.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,b.$Wv)(D.$nc(this.n(t(y.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(p.userHome)return p.userHome;throw new y.$WN(y.VariableKind.UserHome,(0,$.localize)(11,null,S))}case"lineNumber":{const u=this.a.getLineNumber();if(u)return u;throw new y.$WN(y.VariableKind.LineNumber,(0,$.localize)(12,null,S))}case"selectedText":{const u=this.a.getSelectedText();if(u)return u;throw new y.$WN(y.VariableKind.SelectedText,(0,$.localize)(13,null,S))}case"file":return n(y.VariableKind.File);case"fileWorkspaceFolder":return c(y.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return D.$nc(c(y.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return f||i?D.$lc(this.n(t(y.VariableKind.RelativeFile)),n(y.VariableKind.RelativeFile)):n(y.VariableKind.RelativeFile);case"relativeFileDirname":{const u=D.$mc(n(y.VariableKind.RelativeFileDirname));if(f||i){const s=D.$lc(this.n(t(y.VariableKind.RelativeFileDirname)),u);return s.length===0?".":s}return u}case"fileDirname":return D.$mc(n(y.VariableKind.FileDirname));case"fileExtname":return D.$oc(n(y.VariableKind.FileExtname));case"fileBasename":return D.$nc(n(y.VariableKind.FileBasename));case"fileBasenameNoExtension":{const u=D.$nc(n(y.VariableKind.FileBasenameNoExtension));return u.slice(0,u.length-D.$oc(u).length)}case"fileDirnameBasename":return D.$nc(D.$mc(n(y.VariableKind.FileDirnameBasename)));case"execPath":{const u=this.a.getExecPath();return u||S}case"execInstallFolder":{const u=this.a.getAppRoot();return u||S}case"pathSeparator":case"/":return D.sep;default:try{const u=i?`${h}:${i}`:h;return this.p(y.VariableKind.Unknown,S,u,o,void 0)}catch{return S}}}}p(p,S,h,f,o){if(h&&f){const i=o===void 0?f[h]:f[o+":"+h];if(typeof i=="string")return i;throw new y.$WN(p,(0,$.localize)(14,null,S))}return S}}e.$$N=C}),define(ke[143],Se([1,0,5,139]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_C=e.$$C=e.OpenEditorContext=e.GroupsOrder=e.$0C=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$9C=void 0,e.$9C=(0,D.$6h)("editorGroupsService");var g;(function(S){S[S.UP=0]="UP",S[S.DOWN=1]="DOWN",S[S.LEFT=2]="LEFT",S[S.RIGHT=3]="RIGHT"})(g||(e.GroupDirection=g={}));var I;(function(S){S[S.HORIZONTAL=0]="HORIZONTAL",S[S.VERTICAL=1]="VERTICAL"})(I||(e.GroupOrientation=I={}));var A;(function(S){S[S.FIRST=0]="FIRST",S[S.LAST=1]="LAST",S[S.NEXT=2]="NEXT",S[S.PREVIOUS=3]="PREVIOUS"})(A||(e.GroupLocation=A={}));var b;(function(S){S[S.MAXIMIZE=0]="MAXIMIZE",S[S.EXPAND=1]="EXPAND",S[S.EVEN=2]="EVEN"})(b||(e.GroupsArrangement=b={}));var $;(function(S){S[S.COPY_EDITORS=0]="COPY_EDITORS",S[S.MOVE_EDITORS=1]="MOVE_EDITORS"})($||(e.MergeGroupMode=$={}));function y(S){const h=S;return(0,O.$SE)(h?.editor)&&(0,O.$SE)(h?.replacement)}e.$0C=y;var L;(function(S){S[S.CREATION_TIME=0]="CREATION_TIME",S[S.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",S[S.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(L||(e.GroupsOrder=L={}));var C;(function(S){S[S.NEW_EDITOR=1]="NEW_EDITOR",S[S.MOVE_EDITOR=2]="MOVE_EDITOR",S[S.COPY_EDITOR=3]="COPY_EDITOR"})(C||(e.OpenEditorContext=C={}));function m(S){const h=S;return!!h&&typeof h.id=="number"&&Array.isArray(h.editors)}e.$$C=m;function p(S){return S.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$_C=p}),define(ke[290],Se([1,0,5,143]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eD=e.$dD=e.$cD=e.$bD=e.$aD=void 0,e.$aD=(0,D.$6h)("editorService"),e.$bD=-1,e.$cD=-2,e.$dD=-3;function g(I){const A=I;return typeof I=="number"||(0,O.$$C)(A)}e.$eD=g}),define(ke[144],Se([1,0,5,133]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qK=void 0,e.$qK=(0,D.$7h)(O.$ai)}),define(ke[145],Se([1,0,26,4,16,3]),function(me,e,D,O,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$k8b=e.$j8b=e.$i8b=e.$h8b=e.$g8b=void 0;class A{constructor(o,i){this.versionId=o,this.removedDueToLooping=i}}e.$g8b=A;class b{static isHostExtension(o,i,r){if(i.getExtensionDescription(o))return!1;const n=r.getExtensionDescription(o);return n?!!((n.main||n.browser)&&n.api==="none"):!1}constructor(o,i){this.j=o,this.c=new O.$Vd,this.onDidChange=this.c.event,this.d=0,this.e=i,this.k()}k(){this.e.sort(S),this.f=new D.$nm,this.g=[],this.h=new Map;for(const o of this.e){if(this.f.has(o.identifier)){console.error("Extension `"+o.identifier.value+"` is already registered");continue}this.f.set(o.identifier,o),this.g.push(o);const i=this.j.readActivationEvents(o);for(const r of i)this.h.has(r)||this.h.set(r,[]),this.h.get(r).push(o)}}set(o){return this.e=o,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(o,i){this.e=h(this.e,i),this.e=this.e.concat(o);const r=b.l(this.e);return this.e=h(this.e,r.map(n=>n.identifier)),this.k(),this.d++,this.c.fire(void 0),new A(this.d,r)}static l(o){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(u){this.d.has(u)||(this.d.add(u),this.e.push(u))}addArc(u,s){this.addNode(u),this.addNode(s),this.c.has(u)?this.c.get(u).push(s):this.c.set(u,[s])}getArcs(u){return this.c.has(u)?this.c.get(u):[]}hasOnlyGoodArcs(u,s){const l=i.getArcs(u);for(let a=0;a<l.length;a++)if(!s.has(l[a]))return!1;return!0}getNodes(){return this.e}},r=new D.$nm;for(const u of o)if(r.set(u.identifier,u),u.extensionDependencies)for(const s of u.extensionDependencies)i.addArc(D.$lm.toKey(u.identifier),D.$lm.toKey(s));const n=new Set;i.getNodes().filter(u=>i.getArcs(u).length===0).forEach(u=>n.add(u));const c=i.getNodes().filter(u=>!n.has(u));let t;do{t=!1;for(let u=0;u<c.length;u++){const s=c[u];i.hasOnlyGoodArcs(s,n)&&(c.splice(u,1),u--,n.add(s),t=!0)}}while(t);return c.map(u=>r.get(u))}containsActivationEvent(o){return this.h.has(o)}containsExtension(o){return this.f.has(o)}getExtensionDescriptionsForActivationEvent(o){const i=this.h.get(o);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new $(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(o){const i=this.f.get(o);return i||void 0}getExtensionDescriptionByUUID(o){for(const i of this.g)if(i.uuid===o)return i}getExtensionDescriptionByIdOrUUID(o,i){return this.getExtensionDescription(o)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$h8b=b;class ${constructor(o,i){this.versionId=o,this.extensions=i}}e.$i8b=$;class y{constructor(o){this.d=new m,this.c=new b(o,[])}async acquireLock(o){const i=await this.d.acquire(o);return new L(this,i)}deltaExtensions(o,i,r){if(!o.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,r)}containsActivationEvent(o){return this.c.containsActivationEvent(o)}containsExtension(o){return this.c.containsExtension(o)}getExtensionDescriptionsForActivationEvent(o){return this.c.getExtensionDescriptionsForActivationEvent(o)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(o){return this.c.getExtensionDescription(o)}getExtensionDescriptionByUUID(o){return this.c.getExtensionDescriptionByUUID(o)}getExtensionDescriptionByIdOrUUID(o,i){return this.c.getExtensionDescriptionByIdOrUUID(o,i)}}e.$j8b=y;class L extends I.$Tc{constructor(o,i){super(),this.f=o,this.c=!1,this.B(i)}isAcquiredFor(o){return!this.c&&this.f===o}}e.$k8b=L;class C{constructor(o){this.name=o,this.promise=new Promise((i,r)=>{this.c=i})}resolve(o){this.c(o)}}class m{constructor(){this.c=[],this.d=!1}async acquire(o){const i=new C(o);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const o=this.c.shift();this.d=!0;let i=!0;const r=setTimeout(()=>{i&&console.warn(`The customer named ${o.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),n=()=>{i&&(clearTimeout(r),i=!1,this.d=!1,this.e())};o.resolve((0,I.$Rc)(n))}}var p;(function(f){f[f.Builtin=0]="Builtin",f[f.User=1]="User",f[f.Dev=2]="Dev"})(p||(p={}));function S(f,o){const i=f.isBuiltin?0:f.isUnderDevelopment?2:1,r=o.isBuiltin?0:o.isUnderDevelopment?2:1;if(i!==r)return i-r;const n=g.$gc.basename(f.extensionLocation.path),c=g.$gc.basename(o.extensionLocation.path);return n<c?-1:n>c?1:0}function h(f,o){const i=new D.$mm(o);return f.filter(r=>!i.has(r.identifier))}}),define(ke[291],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tm=e.$Sm=e.$Rm=e.$Qm=e.$Pm=e.ExtHostConnectionType=void 0;var D;(function(L){L[L.IPC=1]="IPC",L[L.Socket=2]="Socket",L[L.MessagePort=3]="MessagePort"})(D||(e.ExtHostConnectionType=D={}));class O{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(C){this.pipeName=C,this.type=1}serialize(C){C[O.ENV_KEY]=this.pipeName}}e.$Pm=O;class g{constructor(){this.type=2}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(C){C[g.ENV_KEY]="1"}}e.$Qm=g;class I{constructor(){this.type=3}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(C){C[I.ENV_KEY]="1"}}e.$Rm=I;function A(L){delete L[O.ENV_KEY],delete L[g.ENV_KEY],delete L[I.ENV_KEY]}function b(L,C){A(C),L.serialize(C)}e.$Sm=b;function $(L){if(L[O.ENV_KEY])return y(L,new O(L[O.ENV_KEY]));if(L[g.ENV_KEY])return y(L,new g);if(L[I.ENV_KEY])return y(L,new I);throw new Error("No connection information defined in environment!")}e.$Tm=$;function y(L,C){return A(L),C}}),define(ke[114],Se([1,0,22]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$um=e.$tm=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var O;(function(y){y[y.Desktop=1]="Desktop",y[y.Web=2]="Web"})(O||(e.UIKind=O={}));var g;(function(y){y[y.VersionMismatch=55]="VersionMismatch",y[y.UnexpectedError=81]="UnexpectedError"})(g||(e.ExtensionHostExitCode=g={}));var I;(function(y){y[y.Initialized=0]="Initialized",y[y.Ready=1]="Ready",y[y.Terminate=2]="Terminate"})(I||(e.MessageType=I={}));function A(y){const L=D.$je.alloc(1);switch(y){case 0:L.writeUInt8(1,0);break;case 1:L.writeUInt8(2,0);break;case 2:L.writeUInt8(3,0);break}return L}e.$tm=A;function b(y,L){if(y.byteLength!==1)return!1;switch(y.readUInt8(0)){case 1:return L===0;case 2:return L===1;case 3:return L===2;default:return!1}}e.$um=b;var $;(function(y){y.Start="START_NATIVE_LOG",y.End="END_NATIVE_LOG"})($||(e.NativeLogMarkers=$={}))}),define(ke[90],Se([1,0,5,4,13,27,114,65,87,24,2,3,217]),function(me,e,D,O,g,I,A,b,$,y,L,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rN=e.$qN=e.$pN=e.$oN=void 0;let p=class extends C.$Tc{constructor(o,i){super(),this.s=o,this.t=i,this.a=this.B(new O.$Vd),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new O.$Vd),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=L.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=i.createLogger(this.m,{id:$.$Qo,name:(0,m.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(i.onDidChangeLogLevel(r=>{(0,g.$pj)(r)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===g.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(o,i,r){const n=this.getTelemetryDetails(),c=new S(i,r,o,this.n,this.j,this.getBuiltInCommonProperties(o),{isUsageEnabled:n.isUsageEnabled,isErrorsEnabled:n.isErrorsEnabled}),t=this.r.get(o.identifier.value)??[];return this.r.set(o.identifier.value,[...t,c]),c.apiTelemetryLogger}$initializeTelemetryLevel(o,i,r){this.f=o,this.g=i,this.c=r??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(o){const i=Object.create(null);switch(i["common.extname"]=`${o.publisher}.${o.name}`,i["common.extversion"]=o.version,i["common.vscodemachineid"]=this.s.telemetryInfo.machineId,i["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,i["common.sqmid"]=this.s.telemetryInfo.sqmId,i["common.vscodeversion"]=this.s.version,i["common.isnewappinstall"]=h(this.s.telemetryInfo.firstSessionDate),i["common.product"]=this.s.environment.appHost,this.s.uiKind){case A.UIKind.Web:i["common.uikind"]="web";break;case A.UIKind.Desktop:i["common.uikind"]="desktop";break;default:i["common.uikind"]="unknown"}return i["common.remotename"]=(0,b.$bl)((0,$.$Wo)(this.s.remote.authority)),i}$onDidChangeTelemetryLevel(o){this.h=this.getTelemetryConfiguration(),this.f=o;const i=this.getTelemetryDetails();this.r.forEach((r,n)=>{const c=r.filter(t=>!t.isDisposed);c.length===0?this.r.delete(n):this.r.set(n,c)}),this.r.forEach(r=>{for(const n of r)n.updateTelemetryEnablements(i.isUsageEnabled,i.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(o,i){const n=this.r.get(o.value)?.filter(t=>!t.isDisposed);if(!n)return this.r.delete(o.value),!1;let c=!1;for(const t of n)t.ignoreUnhandledExtHostErrors||(t.logError(i),c=!0);return c}};e.$oN=p,e.$oN=p=Ge([We(0,I.$nN),We(1,g.$oj)],p);class S{static validateSender(o){if(typeof o!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof o.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof o.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof o.flush<"u"&&typeof o.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(o,i,r,n,c,t,u){this.g=r,this.h=n,this.i=c,this.j=t,this.a=new O.$Vd,this.ignoreUnhandledExtHostErrors=i?.ignoreUnhandledErrors??!1,this.b=i?.ignoreBuiltInCommonProperties??!1,this.c=i?.additionalCommonProperties,this.f=o,this.d={isUsageEnabled:u.isUsageEnabled,isErrorsEnabled:u.isErrorsEnabled}}updateTelemetryEnablements(o,i){this.e&&(this.d={isUsageEnabled:o,isErrorsEnabled:i},this.a.fire(this.e))}mixInCommonPropsAndCleanData(o){let i="properties"in o?o.properties??{}:o;return i=(0,$.$Zo)(i,[]),this.c&&(i=(0,y.$yn)(i,this.c)),this.b||(i=(0,y.$yn)(i,this.j)),"properties"in o?o.properties=i:o=i,o}k(o,i){this.f&&(this.g.publisher==="vscode"?o=this.g.name+"/"+o:o=this.g.identifier.value+"/"+o,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f?.sendEventData(o,i),this.h.trace(o,i))}logUsage(o,i){this.d.isUsageEnabled&&this.k(o,i)}logError(o,i){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof o=="string")this.k(o,i);else{const r={name:o.name,message:o.message,stack:o.stack,cause:o.cause},n=(0,$.$Zo)(r,[]),c=new Error(n.message,{cause:n.cause});c.stack=n.stack,c.name=n.name,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f.sendErrorData(c,i),this.h.trace("exception",i)}}get apiTelemetryLogger(){if(!this.e){const o=this,i={logUsage:o.logUsage.bind(o),get isUsageEnabled(){return o.d.isUsageEnabled},get isErrorsEnabled(){return o.d.isErrorsEnabled},logError:o.logError.bind(o),dispose:o.dispose.bind(o),onDidChangeEnableStates:o.a.event.bind(o)};this.e=Object.freeze(i)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let o=this.f;this.f=void 0,Promise.resolve(o.flush()).then(o=void 0),this.e=void 0}else this.f=void 0}}e.$pN=S;function h(f){const o=Date.now()-new Date(f).getTime();return isNaN(o)?!1:o<1e3*60*60*24}e.$qN=h,e.$rN=(0,D.$6h)("IExtHostTelemetry")}),define(ke[25],Se([1,0,4,2,261,137,26,5]),function(me,e,D,O,g,I,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HF=e.$GF=e.$FF=e.ActivationKind=e.$EF=e.$DF=e.$CF=e.$BF=e.$AF=e.ExtensionHostStartup=e.$zF=e.$yF=e.$xF=e.$wF=void 0,e.$wF=Object.freeze({identifier:new A.$lm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:O.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$xF="extensions.webWorker",e.$yF=(0,b.$6h)("extensionService");class ${constructor(c){this.dependency=c}}e.$zF=$;var y;(function(n){n[n.EagerAutoStart=1]="EagerAutoStart",n[n.EagerManualStart=2]="EagerManualStart",n[n.Lazy=3]="Lazy"})(y||(e.ExtensionHostStartup=y={}));class L{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(c,t,u){this.c=c,this.d=t.slice(0),this.e=u.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:I.$hF.createActivationEventsMap(this.d)}}set(c,t,u){if(this.c>c)throw new Error(`ExtensionHostExtensions: invalid versionId ${c} (current: ${this.c})`);const s=[],l=[],a=[],d=[],k=C(this.d),R=C(t),v=(U,F)=>U.extensionLocation.toString()===F.extensionLocation.toString()||U.isBuiltin===F.isBuiltin||U.isUserBuiltin===F.isUserBuiltin||U.isUnderDevelopment===F.isUnderDevelopment;for(const U of this.d){const F=R.get(U.identifier);if(!F){s.push(U.identifier),k.delete(U.identifier);continue}if(!v(U,F)){s.push(U.identifier),k.delete(U.identifier);continue}}for(const U of t){const F=k.get(U.identifier);if(!F){l.push(U);continue}if(!v(F,U)){s.push(F.identifier),k.delete(F.identifier);continue}}const w=new A.$mm(this.e),E=new A.$mm(u);for(const U of this.e)E.has(U)||a.push(U);for(const U of u)w.has(U)||d.push(U);const P=I.$hF.createActivationEventsMap(l),N={versionId:c,toRemove:s,toAdd:l,addActivationEvents:P,myToRemove:a,myToAdd:d};return this.delta(N),N}delta(c){if(this.c>=c.versionId)return null;const{toRemove:t,toAdd:u,myToRemove:s,myToAdd:l}=c,a=new A.$mm(t),d=new A.$mm(s);for(let k=0;k<this.d.length;k++)a.has(this.d[k].identifier)&&(this.d.splice(k,1),k--);for(let k=0;k<this.e.length;k++)d.has(this.e[k])&&(this.e.splice(k,1),k--);for(const k of u)this.d.push(k);for(const k of l)this.e.push(k);return this.f=null,c}containsExtension(c){for(const t of this.e)if(A.$lm.equals(t,c))return!0;return!1}containsActivationEvent(c){return this.f||(this.f=this.g()),this.f.has(c)}g(){const c=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const u=I.$hF.readActivationEvents(t);for(const s of u)c.add(s)}return c}}e.$AF=L;function C(n){const c=new A.$nm;for(const t of n)c.set(t.identifier,t);return c}function m(n,c){return n.enabledApiProposals?n.enabledApiProposals.includes(c):!1}e.$BF=m;function p(n,c){if(!m(n,c))throw new Error(`Extension '${n.identifier.value}' CANNOT use API proposal: ${c}.
Its package.json#enabledApiProposals-property declares: ${n.enabledApiProposals?.join(", ")??"[]"} but NOT ${c}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${n.identifier.value}`)}e.$CF=p;class S{constructor(c,t,u,s){this.codeLoadingTime=c,this.activateCallTime=t,this.activateResolvedTime=u,this.activationReason=s}}e.$DF=S;class h{constructor(c,t){this.description=c,this.value=t}}e.$EF=h;var f;(function(n){n[n.Normal=0]="Normal",n[n.Immediate=1]="Immediate"})(f||(e.ActivationKind=f={}));function o(n){return{type:n.isBuiltin?0:1,isBuiltin:n.isBuiltin||n.isUserBuiltin,identifier:{id:(0,g.$6o)(n.publisher,n.name),uuid:n.uuid},manifest:n,location:n.extensionLocation,targetPlatform:n.targetPlatform,validations:[],isValid:!0}}e.$FF=o;function i(n,c){return{identifier:new A.$lm((0,g.$4o)(n.manifest.publisher,n.manifest.name)),isBuiltin:n.type===0,isUserBuiltin:n.type===1&&n.isBuiltin,isUnderDevelopment:!!c,extensionLocation:n.location,...n.manifest,uuid:n.identifier.uuid,targetPlatform:n.targetPlatform}}e.$GF=i;class r{constructor(){this.onDidRegisterExtensions=D.Event.None,this.onDidChangeExtensionsStatus=D.Event.None,this.onDidChangeExtensions=D.Event.None,this.onWillActivateByEvent=D.Event.None,this.onDidChangeResponsiveChange=D.Event.None,this.onWillStop=D.Event.None,this.extensions=[]}activateByEvent(c){return Promise.resolve(void 0)}activateById(c,t){return Promise.resolve(void 0)}activationEventIsDone(c){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(c){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(c,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(c){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$HF=r}),define(ke[292],Se([1,0,14,145,26,25,13,11]),function(me,e,D,O,g,I,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mgc=e.$Lgc=e.$Kgc=e.$Jgc=e.$Igc=e.$Hgc=void 0;class ${static{this.NONE=new $(!1,-1,-1,-1)}constructor(o,i,r,n){this.startup=o,this.codeLoadingTime=i,this.activateCallTime=r,this.activateResolvedTime=n}}e.$Hgc=$;class y{constructor(o){this.a=o,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(o,i){return o===-1||i===-1?-1:i-o}build(){return new $(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$Igc=y;class L{constructor(o,i,r,n,c,t){this.activationFailed=o,this.activationFailedError=i,this.activationTimes=r,this.module=n,this.exports=c,this.subscriptions=t}}e.$Jgc=L;class C extends L{constructor(o){super(!1,null,o,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Kgc=C;class m extends L{constructor(){super(!1,null,$.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Lgc=m;class p extends L{constructor(o){super(!0,o,$.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let S=class{constructor(o,i,r,n){this.g=n,this.a=o,this.b=i,this.c=r,this.d=new g.$nm,this.f=Object.create(null)}dispose(){for(const[o,i]of this.d)i.dispose()}async waitForActivatingExtensions(){const o=[];for(const[i,r]of this.d)o.push(r.wait());await Promise.all(o)}isActivated(o){const i=this.d.get(o);return!!(i&&i.value)}getActivatedExtension(o){const i=this.d.get(o);if(!i||!i.value)throw new Error(`Extension '${o.value}' is not known or not activated`);return i.value}async activateByEvent(o,i){if(this.f[o])return;const r=this.a.getExtensionDescriptionsForActivationEvent(o);await this.h(r.map(n=>({id:n.identifier,reason:{startup:i,extensionId:n.identifier,activationEvent:o}}))),this.f[o]=!0}activateById(o,i){const r=this.a.getExtensionDescription(o);if(!r)throw new Error(`Extension '${o}' is not known`);return this.h([{id:r.identifier,reason:i}])}async h(o){const i=o.filter(r=>!this.isActivated(r.id)).map(r=>this.j(r));await Promise.all(i.map(r=>r.wait()))}j(o){if(this.d.has(o.id))return this.d.get(o.id);if(this.l(o.id))return this.k(o,null,[],null);const i=this.a.getExtensionDescription(o.id);if(!i){const c=new Error(`Cannot activate unknown extension '${o.id.value}'`),t=this.k(o,null,[],new p(c));return this.c.onExtensionActivationError(o.id,c,new I.$zF(o.id.value)),t}const r=[],n=typeof i.extensionDependencies>"u"?[]:i.extensionDependencies;for(const c of n){if(this.m(c))continue;const t=this.d.get(c);if(t){r.push(t);continue}if(this.l(c)){r.push(this.j({id:this.b.getExtensionDescription(c).identifier,reason:o.reason}));continue}const u=this.a.getExtensionDescription(c);if(u){if(!u.main&&!u.browser)continue;r.push(this.j({id:u.identifier,reason:o.reason}));continue}const s=i.displayName||i.identifier.value,l=new Error(`Cannot activate the '${s}' extension because it depends on unknown extension '${c}'`),a=this.k(o,i.displayName,[],new p(l));return this.c.onExtensionActivationError(i.identifier,l,new I.$zF(c)),a}return this.k(o,i.displayName,r,null)}k(o,i,r,n){const c=new h(o.id,i,o.reason,r,n,this.c,this.g);return this.d.set(o.id,c),c}l(o){return O.$h8b.isHostExtension(o,this.a,this.b)}m(o){const i=this.b.getExtensionDescription(o);return i?!i.main&&!i.browser:!1}};e.$Mgc=S,e.$Mgc=S=Ge([We(3,A.$nj)],S);let h=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(o,i,r,n,c,t,u){this.c=o,this.d=i,this.f=r,this.g=n,this.h=c,this.j=t,this.k=u,this.a=new b.$5g,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let o=0;o<this.g.length;o++){const i=this.g[o];if(i.value&&!i.value.activationFailed){this.g.splice(o,1),o--;continue}if(i.value&&i.value.activationFailed){const r=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${i.friendlyName}' failed to activate`);r.detail=i.value.activationFailedError,this.h=new p(r),this.j.onExtensionActivationError(this.c,r,null);return}}this.g.length>0&&await Promise.race(this.g.map(o=>o.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(o){const i=new Error;if(o&&o.name&&(i.name=o.name),o&&o.message?i.message=`Activating extension '${this.c.value}' failed: ${o.message}.`:i.message=`Activating extension '${this.c.value}' failed: ${o}.`,o&&o.stack&&(i.stack=o.stack),this.h=new p(i),this.b&&D.$4(o))return;this.j.onExtensionActivationError(this.c,i,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(o)}}};h=Ge([We(6,A.$nj)],h)}),define(ke[15],Se([1,0,19,22,165,74,80,28,160,55,100,24,18,2,29,83,135,142,139,111,67,89,290,25,7]),function(me,e,D,O,g,I,A,b,$,y,L,C,m,p,S,h,f,o,i,r,n,c,t,u,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatAgentCompletionItem=e.ChatResponseProgress=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$9M=e.$8M=e.MarkdownString=e.$7M=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var l;(function(Te){function Ne(se){const{selectionStartLineNumber:Fe,selectionStartColumn:Ve,positionLineNumber:xe,positionColumn:Ke}=se,st=new s.$9K(Fe-1,Ve-1),$t=new s.$9K(xe-1,Ke-1);return new s.$$K(st,$t)}Te.to=Ne;function Ce(se){const{anchor:Fe,active:Ve}=se;return{selectionStartLineNumber:Fe.line+1,selectionStartColumn:Fe.character+1,positionLineNumber:Ve.line+1,positionColumn:Ve.character+1}}Te.from=Ce})(l||(e.Selection=l={}));var a;(function(Te){function Ne(se){if(!se)return;const{start:Fe,end:Ve}=se;return{startLineNumber:Fe.line+1,startColumn:Fe.character+1,endLineNumber:Ve.line+1,endColumn:Ve.character+1}}Te.from=Ne;function Ce(se){if(!se)return;const{startLineNumber:Fe,startColumn:Ve,endLineNumber:xe,endColumn:Ke}=se;return new s.$0K(Fe-1,Ve-1,xe-1,Ke-1)}Te.to=Ce})(a||(e.Range=a={}));var d;(function(Te){function Ne(Ce){switch(Ce){case 1:return s.StandardTokenType.Comment;case 0:return s.StandardTokenType.Other;case 3:return s.StandardTokenType.RegEx;case 2:return s.StandardTokenType.String}}Te.to=Ne})(d||(e.TokenType=d={}));var k;(function(Te){function Ne(se){return new s.$9K(se.lineNumber-1,se.column-1)}Te.to=Ne;function Ce(se){return{lineNumber:se.line+1,column:se.character+1}}Te.from=Ce})(k||(e.Position=k={}));var R;(function(Te){function Ne(Fe,Ve,xe){return(0,D.$Hb)((0,D.$3b)(Fe).map(Ke=>Ce(Ke,Ve,xe)))}Te.from=Ne;function Ce(Fe,Ve,xe){if(typeof Fe=="string")return{$serialized:!0,language:Fe,isBuiltin:xe?.isBuiltin};if(Fe)return{$serialized:!0,language:Fe.language,scheme:se(Fe.scheme,Ve),pattern:ne.from(Fe.pattern)??void 0,exclusive:Fe.exclusive,notebookType:Fe.notebookType,isBuiltin:xe?.isBuiltin}}function se(Fe,Ve){return Ve&&typeof Fe=="string"?Ve.transformOutgoingScheme(Fe):Fe}})(R||(e.DocumentSelector=R={}));var v;(function(Te){function Ne(se){switch(se){case s.DiagnosticTag.Unnecessary:return 1;case s.DiagnosticTag.Deprecated:return 2}}Te.from=Ne;function Ce(se){switch(se){case 1:return s.DiagnosticTag.Unnecessary;case 2:return s.DiagnosticTag.Deprecated;default:return}}Te.to=Ce})(v||(e.DiagnosticTag=v={}));var w;(function(Te){function Ne(se){let Fe;return se.code&&((0,m.$If)(se.code)||(0,m.$Mf)(se.code)?Fe=String(se.code):Fe={value:String(se.code.value),target:se.code.target}),{...a.from(se.range),message:se.message,source:se.source,code:Fe,severity:P.from(se.severity),relatedInformation:se.relatedInformation&&se.relatedInformation.map(E.from),tags:Array.isArray(se.tags)?(0,D.$Hb)(se.tags.map(v.from)):void 0}}Te.from=Ne;function Ce(se){const Fe=new s.$jL(a.to(se),se.message,P.to(se.severity));return Fe.source=se.source,Fe.code=(0,m.$If)(se.code)?se.code:se.code?.value,Fe.relatedInformation=se.relatedInformation&&se.relatedInformation.map(E.to),Fe.tags=se.tags&&(0,D.$Hb)(se.tags.map(v.to)),Fe}Te.to=Ce})(w||(e.Diagnostic=w={}));var E;(function(Te){function Ne(se){return{...a.from(se.location.range),message:se.message,resource:se.location.uri}}Te.from=Ne;function Ce(se){return new s.$iL(new s.$hL(se.resource,a.to(se)),se.message)}Te.to=Ce})(E||(e.DiagnosticRelatedInformation=E={}));var P;(function(Te){function Ne(se){switch(se){case s.DiagnosticSeverity.Error:return f.MarkerSeverity.Error;case s.DiagnosticSeverity.Warning:return f.MarkerSeverity.Warning;case s.DiagnosticSeverity.Information:return f.MarkerSeverity.Info;case s.DiagnosticSeverity.Hint:return f.MarkerSeverity.Hint}return f.MarkerSeverity.Error}Te.from=Ne;function Ce(se){switch(se){case f.MarkerSeverity.Info:return s.DiagnosticSeverity.Information;case f.MarkerSeverity.Warning:return s.DiagnosticSeverity.Warning;case f.MarkerSeverity.Error:return s.DiagnosticSeverity.Error;case f.MarkerSeverity.Hint:return s.DiagnosticSeverity.Hint;default:return s.DiagnosticSeverity.Error}}Te.to=Ce})(P||(e.DiagnosticSeverity=P={}));var N;(function(Te){function Ne(se){return typeof se=="number"&&se>=s.ViewColumn.One?se-1:se===s.ViewColumn.Beside?t.$cD:t.$bD}Te.from=Ne;function Ce(se){if(typeof se=="number"&&se>=0)return se+1;throw new Error("invalid 'EditorGroupColumn'")}Te.to=Ce})(N||(e.ViewColumn=N={}));function U(Te){return typeof Te.range<"u"}function F(Te){return Te.length===0?!0:!!U(Te[0])}e.$7M=F;var j;(function(Te){function Ne(Ke){return Ke.map(Te.from)}Te.fromMany=Ne;function Ce(Ke){return Ke&&typeof Ke=="object"&&typeof Ke.language=="string"&&typeof Ke.value=="string"}function se(Ke){let st;if(Ce(Ke)){const{language:It,value:yt}=Ke;st={value:"```"+It+`
`+yt+"\n```\n"}}else s.$wL.isMarkdownString(Ke)?st={value:Ke.value,isTrusted:Ke.isTrusted,supportThemeIcons:Ke.supportThemeIcons,supportHtml:Ke.supportHtml,baseUri:Ke.baseUri}:typeof Ke=="string"?st={value:Ke}:st={value:""};const $t=Object.create(null);st.uris=$t;const Bt=It=>{try{let yt=p.URI.parse(It,!0);yt=yt.with({query:Fe(yt.query,$t)}),$t[It]=yt}catch{}return""},kt=new $.marked.Renderer;return kt.link=Bt,kt.image=It=>typeof It=="string"?Bt(A.$pk(It).href):"",(0,$.marked)(st.value,{renderer:kt}),st}Te.from=se;function Fe(Ke,st){if(!Ke)return Ke;let $t;try{$t=(0,y.$Bh)(Ke)}catch{}if(!$t)return Ke;let Bt=!1;return $t=(0,C.$xn)($t,kt=>{if(p.URI.isUri(kt)){const It=`__uri_${Math.random().toString(16).slice(2,8)}`;return st[It]=kt,Bt=!0,It}else return}),Bt?JSON.stringify($t):Ke}function Ve(Ke){const st=new s.$wL(Ke.value,Ke.supportThemeIcons);return st.isTrusted=Ke.isTrusted,st.supportHtml=Ke.supportHtml,st.baseUri=Ke.baseUri?p.URI.from(Ke.baseUri):void 0,st}Te.to=Ve;function xe(Ke){if(Ke)return typeof Ke=="string"?Ke:Te.from(Ke)}Te.fromStrict=xe})(j||(e.MarkdownString=j={}));function T(Te){return F(Te)?Te.map(Ne=>({range:a.from(Ne.range),hoverMessage:Array.isArray(Ne.hoverMessage)?j.fromMany(Ne.hoverMessage):Ne.hoverMessage?j.from(Ne.hoverMessage):void 0,renderOptions:Ne.renderOptions})):Te.map(Ne=>({range:a.from(Ne)}))}e.$8M=T;function M(Te){return typeof Te>"u"?Te:typeof Te=="string"?p.URI.file(Te):Te}e.$9M=M;var B;(function(Te){function Ne(Ce){return typeof Ce>"u"?Ce:{contentText:Ce.contentText,contentIconPath:Ce.contentIconPath?M(Ce.contentIconPath):void 0,border:Ce.border,borderColor:Ce.borderColor,fontStyle:Ce.fontStyle,fontWeight:Ce.fontWeight,textDecoration:Ce.textDecoration,color:Ce.color,backgroundColor:Ce.backgroundColor,margin:Ce.margin,width:Ce.width,height:Ce.height}}Te.from=Ne})(B||(e.ThemableDecorationAttachmentRenderOptions=B={}));var Y;(function(Te){function Ne(Ce){return typeof Ce>"u"?Ce:{backgroundColor:Ce.backgroundColor,outline:Ce.outline,outlineColor:Ce.outlineColor,outlineStyle:Ce.outlineStyle,outlineWidth:Ce.outlineWidth,border:Ce.border,borderColor:Ce.borderColor,borderRadius:Ce.borderRadius,borderSpacing:Ce.borderSpacing,borderStyle:Ce.borderStyle,borderWidth:Ce.borderWidth,fontStyle:Ce.fontStyle,fontWeight:Ce.fontWeight,textDecoration:Ce.textDecoration,cursor:Ce.cursor,color:Ce.color,opacity:Ce.opacity,letterSpacing:Ce.letterSpacing,gutterIconPath:Ce.gutterIconPath?M(Ce.gutterIconPath):void 0,gutterIconSize:Ce.gutterIconSize,overviewRulerColor:Ce.overviewRulerColor,before:Ce.before?B.from(Ce.before):void 0,after:Ce.after?B.from(Ce.after):void 0}}Te.from=Ne})(Y||(e.ThemableDecorationRenderOptions=Y={}));var ue;(function(Te){function Ne(Ce){if(typeof Ce>"u")return Ce;switch(Ce){case s.DecorationRangeBehavior.OpenOpen:return 0;case s.DecorationRangeBehavior.ClosedClosed:return 1;case s.DecorationRangeBehavior.OpenClosed:return 2;case s.DecorationRangeBehavior.ClosedOpen:return 3}}Te.from=Ne})(ue||(e.DecorationRangeBehavior=ue={}));var Z;(function(Te){function Ne(Ce){return{isWholeLine:Ce.isWholeLine,rangeBehavior:Ce.rangeBehavior?ue.from(Ce.rangeBehavior):void 0,overviewRulerLane:Ce.overviewRulerLane,light:Ce.light?Y.from(Ce.light):void 0,dark:Ce.dark?Y.from(Ce.dark):void 0,backgroundColor:Ce.backgroundColor,outline:Ce.outline,outlineColor:Ce.outlineColor,outlineStyle:Ce.outlineStyle,outlineWidth:Ce.outlineWidth,border:Ce.border,borderColor:Ce.borderColor,borderRadius:Ce.borderRadius,borderSpacing:Ce.borderSpacing,borderStyle:Ce.borderStyle,borderWidth:Ce.borderWidth,fontStyle:Ce.fontStyle,fontWeight:Ce.fontWeight,textDecoration:Ce.textDecoration,cursor:Ce.cursor,color:Ce.color,opacity:Ce.opacity,letterSpacing:Ce.letterSpacing,gutterIconPath:Ce.gutterIconPath?M(Ce.gutterIconPath):void 0,gutterIconSize:Ce.gutterIconSize,overviewRulerColor:Ce.overviewRulerColor,before:Ce.before?B.from(Ce.before):void 0,after:Ce.after?B.from(Ce.after):void 0}}Te.from=Ne})(Z||(e.DecorationRenderOptions=Z={}));var J;(function(Te){function Ne(se){return{text:se.newText,eol:se.newEol&&rt.from(se.newEol),range:a.from(se.range)}}Te.from=Ne;function Ce(se){const Fe=new s.$cL(a.to(se.range),se.text);return Fe.newEol=typeof se.eol>"u"?void 0:rt.to(se.eol),Fe}Te.to=Ce})(J||(e.TextEdit=J={}));var X;(function(Te){function Ne(se,Fe){const Ve={edits:[]};if(se instanceof s.$fL){const xe=new b.$Bc;for(const Ke of se._allEntries())Ke._type===1&&p.URI.isUri(Ke.to)&&Ke.from===void 0&&xe.add(Ke.to);for(const Ke of se._allEntries())if(Ke._type===1){let st;Ke.options?.contents&&(ArrayBuffer.isView(Ke.options.contents)?st={type:"base64",value:(0,O.$De)(O.$je.wrap(Ke.options.contents))}:st={type:"dataTransferItem",id:Ke.options.contents._itemId}),Ve.edits.push({oldResource:Ke.from,newResource:Ke.to,options:{...Ke.options,contents:st},metadata:Ke.metadata})}else Ke._type===2?Ve.edits.push({resource:Ke.uri,textEdit:J.from(Ke.edit),versionId:xe.has(Ke.uri)?void 0:Fe?.getTextDocumentVersion(Ke.uri),metadata:Ke.metadata}):Ke._type===6?Ve.edits.push({resource:Ke.uri,textEdit:{range:a.from(Ke.range),text:Ke.edit.value,insertAsSnippet:!0},versionId:xe.has(Ke.uri)?void 0:Fe?.getTextDocumentVersion(Ke.uri),metadata:Ke.metadata}):Ke._type===3?Ve.edits.push({metadata:Ke.metadata,resource:Ke.uri,cellEdit:Ke.edit,notebookMetadata:Ke.notebookMetadata,notebookVersionId:Fe?.getNotebookDocumentVersion(Ke.uri)}):Ke._type===5&&Ve.edits.push({metadata:Ke.metadata,resource:Ke.uri,notebookVersionId:Fe?.getNotebookDocumentVersion(Ke.uri),cellEdit:{editType:1,index:Ke.index,count:Ke.count,cells:Ke.cells.map(vt.from)}})}return Ve}Te.from=Ne;function Ce(se){const Fe=new s.$fL,Ve=new b.$Ac;for(const xe of se.edits)if(xe.textEdit){const Ke=xe,st=p.URI.revive(Ke.resource),$t=a.to(Ke.textEdit.range),Bt=Ke.textEdit.text,kt=Ke.textEdit.insertAsSnippet;let It;kt?It=s.$eL.replace($t,new s.$gL(Bt)):It=s.$cL.replace($t,Bt);const yt=Ve.get(st);yt?yt.push(It):Ve.set(st,[It])}else Fe.renameFile(p.URI.revive(xe.oldResource),p.URI.revive(xe.newResource),xe.options);for(const[xe,Ke]of Ve)Fe.set(xe,Ke);return Fe}Te.to=Ce})(X||(e.WorkspaceEdit=X={}));var he;(function(Te){const Ne=Object.create(null);Ne[s.SymbolKind.File]=0,Ne[s.SymbolKind.Module]=1,Ne[s.SymbolKind.Namespace]=2,Ne[s.SymbolKind.Package]=3,Ne[s.SymbolKind.Class]=4,Ne[s.SymbolKind.Method]=5,Ne[s.SymbolKind.Property]=6,Ne[s.SymbolKind.Field]=7,Ne[s.SymbolKind.Constructor]=8,Ne[s.SymbolKind.Enum]=9,Ne[s.SymbolKind.Interface]=10,Ne[s.SymbolKind.Function]=11,Ne[s.SymbolKind.Variable]=12,Ne[s.SymbolKind.Constant]=13,Ne[s.SymbolKind.String]=14,Ne[s.SymbolKind.Number]=15,Ne[s.SymbolKind.Boolean]=16,Ne[s.SymbolKind.Array]=17,Ne[s.SymbolKind.Object]=18,Ne[s.SymbolKind.Key]=19,Ne[s.SymbolKind.Null]=20,Ne[s.SymbolKind.EnumMember]=21,Ne[s.SymbolKind.Struct]=22,Ne[s.SymbolKind.Event]=23,Ne[s.SymbolKind.Operator]=24,Ne[s.SymbolKind.TypeParameter]=25;function Ce(Fe){return typeof Ne[Fe]=="number"?Ne[Fe]:6}Te.from=Ce;function se(Fe){for(const Ve in Ne)if(Ne[Ve]===Fe)return Number(Ve);return s.SymbolKind.Property}Te.to=se})(he||(e.SymbolKind=he={}));var _;(function(Te){function Ne(se){switch(se){case s.SymbolTag.Deprecated:return 1}}Te.from=Ne;function Ce(se){switch(se){case 1:return s.SymbolTag.Deprecated}}Te.to=Ce})(_||(e.SymbolTag=_={}));var we;(function(Te){function Ne(se){return{name:se.name,kind:he.from(se.kind),tags:se.tags&&se.tags.map(_.from),containerName:se.containerName,location:ye.from(se.location)}}Te.from=Ne;function Ce(se){const Fe=new s.$nL(se.name,he.to(se.kind),se.containerName,ye.to(se.location));return Fe.tags=se.tags&&se.tags.map(_.to),Fe}Te.to=Ce})(we||(e.WorkspaceSymbol=we={}));var oe;(function(Te){function Ne(se){const Fe={name:se.name||"!!MISSING: name!!",detail:se.detail,range:a.from(se.range),selectionRange:a.from(se.selectionRange),kind:he.from(se.kind),tags:se.tags?.map(_.from)??[]};return se.children&&(Fe.children=se.children.map(Ne)),Fe}Te.from=Ne;function Ce(se){const Fe=new s.$oL(se.name,se.detail,he.to(se.kind),a.to(se.range),a.to(se.selectionRange));return(0,D.$Lb)(se.tags)&&(Fe.tags=se.tags.map(_.to)),se.children&&(Fe.children=se.children.map(Ce)),Fe}Te.to=Ce})(oe||(e.DocumentSymbol=oe={}));var K;(function(Te){function Ne(se){const Fe=new s.$sL(he.to(se.kind),se.name,se.detail||"",p.URI.revive(se.uri),a.to(se.range),a.to(se.selectionRange));return Fe._sessionId=se._sessionId,Fe._itemId=se._itemId,Fe}Te.to=Ne;function Ce(se,Fe,Ve){if(Fe=Fe??se._sessionId,Ve=Ve??se._itemId,Fe===void 0||Ve===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:Ve,name:se.name,detail:se.detail,kind:he.from(se.kind),uri:se.uri,range:a.from(se.range),selectionRange:a.from(se.selectionRange),tags:se.tags?.map(_.from)}}Te.from=Ce})(K||(e.CallHierarchyItem=K={}));var W;(function(Te){function Ne(Ce){return new s.$tL(K.to(Ce.from),Ce.fromRanges.map(se=>a.to(se)))}Te.to=Ne})(W||(e.CallHierarchyIncomingCall=W={}));var re;(function(Te){function Ne(Ce){return new s.$uL(K.to(Ce.to),Ce.fromRanges.map(se=>a.to(se)))}Te.to=Ne})(re||(e.CallHierarchyOutgoingCall=re={}));var ye;(function(Te){function Ne(se){return{range:se.range&&a.from(se.range),uri:se.uri}}Te.from=Ne;function Ce(se){return new s.$hL(p.URI.revive(se.uri),a.to(se.range))}Te.to=Ce})(ye||(e.location=ye={}));var de;(function(Te){function Ne(se){const Fe=se,Ve=se;return{originSelectionRange:Fe.originSelectionRange?a.from(Fe.originSelectionRange):void 0,uri:Fe.targetUri?Fe.targetUri:Ve.uri,range:a.from(Fe.targetRange?Fe.targetRange:Ve.range),targetSelectionRange:Fe.targetSelectionRange?a.from(Fe.targetSelectionRange):void 0}}Te.from=Ne;function Ce(se){return{targetUri:p.URI.revive(se.uri),targetRange:a.to(se.range),targetSelectionRange:se.targetSelectionRange?a.to(se.targetSelectionRange):void 0,originSelectionRange:se.originSelectionRange?a.to(se.originSelectionRange):void 0}}Te.to=Ce})(de||(e.DefinitionLink=de={}));var ge;(function(Te){function Ne(se){return{range:a.from(se.range),contents:j.fromMany(se.contents)}}Te.from=Ne;function Ce(se){return new s.$kL(se.contents.map(j.to),a.to(se.range))}Te.to=Ce})(ge||(e.Hover=ge={}));var x;(function(Te){function Ne(se){return{range:a.from(se.range),expression:se.expression}}Te.from=Ne;function Ce(se){return new s.$eM(a.to(se.range),se.expression)}Te.to=Ce})(x||(e.EvaluatableExpression=x={}));var te;(function(Te){function Ne(se){if(se instanceof s.$fM)return{type:"text",range:a.from(se.range),text:se.text};if(se instanceof s.$gM)return{type:"variable",range:a.from(se.range),variableName:se.variableName,caseSensitiveLookup:se.caseSensitiveLookup};if(se instanceof s.$hM)return{type:"expression",range:a.from(se.range),expression:se.expression};throw new Error("Unknown 'InlineValue' type")}Te.from=Ne;function Ce(se){switch(se.type){case"text":return{range:a.to(se.range),text:se.text};case"variable":return{range:a.to(se.range),variableName:se.variableName,caseSensitiveLookup:se.caseSensitiveLookup};case"expression":return{range:a.to(se.range),expression:se.expression}}}Te.to=Ce})(te||(e.InlineValue=te={}));var G;(function(Te){function Ne(se){return{frameId:se.frameId,stoppedLocation:a.from(se.stoppedLocation)}}Te.from=Ne;function Ce(se){return new s.$iM(se.frameId,a.to(se.stoppedLocation))}Te.to=Ce})(G||(e.InlineValueContext=G={}));var ie;(function(Te){function Ne(se){return{range:a.from(se.range),kind:se.kind}}Te.from=Ne;function Ce(se){return new s.$lL(a.to(se.range),se.kind)}Te.to=Ce})(ie||(e.DocumentHighlight=ie={}));var fe;(function(Te){function Ne(se){return{uri:se.uri,highlights:se.highlights.map(ie.from)}}Te.from=Ne;function Ce(se){return new s.$mL(p.URI.revive(se.uri),se.highlights.map(ie.to))}Te.to=Ce})(fe||(e.MultiDocumentHighlight=fe={}));var pe;(function(Te){function Ne(Ce){switch(Ce){case 1:return s.CompletionTriggerKind.TriggerCharacter;case 2:return s.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return s.CompletionTriggerKind.Invoke}}Te.to=Ne})(pe||(e.CompletionTriggerKind=pe={}));var Pe;(function(Te){function Ne(Ce){return{triggerKind:pe.to(Ce.triggerKind),triggerCharacter:Ce.triggerCharacter}}Te.to=Ne})(Pe||(e.CompletionContext=Pe={}));var be;(function(Te){function Ne(se){switch(se){case s.CompletionItemTag.Deprecated:return 1}}Te.from=Ne;function Ce(se){switch(se){case 1:return s.CompletionItemTag.Deprecated}}Te.to=Ce})(be||(e.CompletionItemTag=be={}));var De;(function(Te){const Ne=new Map([[s.CompletionItemKind.Method,0],[s.CompletionItemKind.Function,1],[s.CompletionItemKind.Constructor,2],[s.CompletionItemKind.Field,3],[s.CompletionItemKind.Variable,4],[s.CompletionItemKind.Class,5],[s.CompletionItemKind.Interface,7],[s.CompletionItemKind.Struct,6],[s.CompletionItemKind.Module,8],[s.CompletionItemKind.Property,9],[s.CompletionItemKind.Unit,12],[s.CompletionItemKind.Value,13],[s.CompletionItemKind.Constant,14],[s.CompletionItemKind.Enum,15],[s.CompletionItemKind.EnumMember,16],[s.CompletionItemKind.Keyword,17],[s.CompletionItemKind.Snippet,27],[s.CompletionItemKind.Text,18],[s.CompletionItemKind.Color,19],[s.CompletionItemKind.File,20],[s.CompletionItemKind.Reference,21],[s.CompletionItemKind.Folder,23],[s.CompletionItemKind.Event,10],[s.CompletionItemKind.Operator,11],[s.CompletionItemKind.TypeParameter,24],[s.CompletionItemKind.Issue,26],[s.CompletionItemKind.User,25]]);function Ce(Ve){return Ne.get(Ve)??9}Te.from=Ce;const se=new Map([[0,s.CompletionItemKind.Method],[1,s.CompletionItemKind.Function],[2,s.CompletionItemKind.Constructor],[3,s.CompletionItemKind.Field],[4,s.CompletionItemKind.Variable],[5,s.CompletionItemKind.Class],[7,s.CompletionItemKind.Interface],[6,s.CompletionItemKind.Struct],[8,s.CompletionItemKind.Module],[9,s.CompletionItemKind.Property],[12,s.CompletionItemKind.Unit],[13,s.CompletionItemKind.Value],[14,s.CompletionItemKind.Constant],[15,s.CompletionItemKind.Enum],[16,s.CompletionItemKind.EnumMember],[17,s.CompletionItemKind.Keyword],[27,s.CompletionItemKind.Snippet],[18,s.CompletionItemKind.Text],[19,s.CompletionItemKind.Color],[20,s.CompletionItemKind.File],[21,s.CompletionItemKind.Reference],[23,s.CompletionItemKind.Folder],[10,s.CompletionItemKind.Event],[11,s.CompletionItemKind.Operator],[24,s.CompletionItemKind.TypeParameter],[25,s.CompletionItemKind.User],[26,s.CompletionItemKind.Issue]]);function Fe(Ve){return se.get(Ve)??s.CompletionItemKind.Property}Te.to=Fe})(De||(e.CompletionItemKind=De={}));var z;(function(Te){function Ne(Ce,se){const Fe=new s.$CL(Ce.label);return Fe.insertText=Ce.insertText,Fe.kind=De.to(Ce.kind),Fe.tags=Ce.tags?.map(be.to),Fe.detail=Ce.detail,Fe.documentation=A.$jk(Ce.documentation)?j.to(Ce.documentation):Ce.documentation,Fe.sortText=Ce.sortText,Fe.filterText=Ce.filterText,Fe.preselect=Ce.preselect,Fe.commitCharacters=Ce.commitCharacters,S.$Us.isIRange(Ce.range)?Fe.range=a.to(Ce.range):typeof Ce.range=="object"&&(Fe.range={inserting:a.to(Ce.range.insert),replacing:a.to(Ce.range.replace)}),Fe.keepWhitespace=typeof Ce.insertTextRules>"u"?!1:!!(Ce.insertTextRules&1),typeof Ce.insertTextRules<"u"&&Ce.insertTextRules&4?Fe.insertText=new s.$gL(Ce.insertText):(Fe.insertText=Ce.insertText,Fe.textEdit=Fe.range instanceof s.$0K?new s.$cL(Fe.range,Fe.insertText):void 0),Ce.additionalTextEdits&&Ce.additionalTextEdits.length>0&&(Fe.additionalTextEdits=Ce.additionalTextEdits.map(Ve=>J.to(Ve))),Fe.command=se&&Ce.command?se.fromInternal(Ce.command):void 0,Fe}Te.to=Ne})(z||(e.CompletionItem=z={}));var Q;(function(Te){function Ne(se){if(typeof se.label!="string"&&!Array.isArray(se.label))throw new TypeError("Invalid label");return{label:se.label,documentation:j.fromStrict(se.documentation)}}Te.from=Ne;function Ce(se){return{label:se.label,documentation:A.$jk(se.documentation)?j.to(se.documentation):se.documentation}}Te.to=Ce})(Q||(e.ParameterInformation=Q={}));var ee;(function(Te){function Ne(se){return{label:se.label,documentation:j.fromStrict(se.documentation),parameters:Array.isArray(se.parameters)?se.parameters.map(Q.from):[],activeParameter:se.activeParameter}}Te.from=Ne;function Ce(se){return{label:se.label,documentation:A.$jk(se.documentation)?j.to(se.documentation):se.documentation,parameters:Array.isArray(se.parameters)?se.parameters.map(Q.to):[],activeParameter:se.activeParameter}}Te.to=Ce})(ee||(e.SignatureInformation=ee={}));var q;(function(Te){function Ne(se){return{activeSignature:se.activeSignature,activeParameter:se.activeParameter,signatures:Array.isArray(se.signatures)?se.signatures.map(ee.from):[]}}Te.from=Ne;function Ce(se){return{activeSignature:se.activeSignature,activeParameter:se.activeParameter,signatures:Array.isArray(se.signatures)?se.signatures.map(ee.to):[]}}Te.to=Ce})(q||(e.SignatureHelp=q={}));var ae;(function(Te){function Ne(Ce,se){const Fe=new s.$BL(k.to(se.position),typeof se.label=="string"?se.label:se.label.map(le.to.bind(void 0,Ce)),se.kind&&Le.to(se.kind));return Fe.textEdits=se.textEdits&&se.textEdits.map(J.to),Fe.tooltip=A.$jk(se.tooltip)?j.to(se.tooltip):se.tooltip,Fe.paddingLeft=se.paddingLeft,Fe.paddingRight=se.paddingRight,Fe}Te.to=Ne})(ae||(e.InlayHint=ae={}));var le;(function(Te){function Ne(Ce,se){const Fe=new s.$AL(se.label);return Fe.tooltip=A.$jk(se.tooltip)?j.to(se.tooltip):se.tooltip,h.Command.is(se.command)&&(Fe.command=Ce.fromInternal(se.command)),se.location&&(Fe.location=ye.to(se.location)),Fe}Te.to=Ne})(le||(e.InlayHintLabelPart=le={}));var Le;(function(Te){function Ne(se){return se}Te.from=Ne;function Ce(se){return se}Te.to=Ce})(Le||(e.InlayHintKind=Le={}));var je;(function(Te){function Ne(se){return{range:a.from(se.range),url:se.target,tooltip:se.tooltip}}Te.from=Ne;function Ce(se){let Fe;if(se.url)try{Fe=typeof se.url=="string"?p.URI.parse(se.url,!0):p.URI.revive(se.url)}catch{}return new s.$HL(a.to(se.range),Fe)}Te.to=Ce})(je||(e.DocumentLink=je={}));var He;(function(Te){function Ne(se){const Fe=new s.$KL(se.label);return se.textEdit&&(Fe.textEdit=J.to(se.textEdit)),se.additionalTextEdits&&(Fe.additionalTextEdits=se.additionalTextEdits.map(Ve=>J.to(Ve))),Fe}Te.to=Ne;function Ce(se){return{label:se.label,textEdit:se.textEdit?J.from(se.textEdit):void 0,additionalTextEdits:se.additionalTextEdits?se.additionalTextEdits.map(Fe=>J.from(Fe)):void 0}}Te.from=Ce})(He||(e.ColorPresentation=He={}));var Je;(function(Te){function Ne(se){return new s.$IL(se[0],se[1],se[2],se[3])}Te.to=Ne;function Ce(se){return[se.red,se.green,se.blue,se.alpha]}Te.from=Ce})(Je||(e.Color=Je={}));var _e;(function(Te){function Ne(se){return{range:a.from(se.range)}}Te.from=Ne;function Ce(se){return new s.$rL(a.to(se.range))}Te.to=Ce})(_e||(e.SelectionRange=_e={}));var ct;(function(Te){function Ne(Ce){switch(Ce){case 2:return s.TextDocumentSaveReason.AfterDelay;case 1:return s.TextDocumentSaveReason.Manual;case 3:case 4:return s.TextDocumentSaveReason.FocusOut}}Te.to=Ne})(ct||(e.TextDocumentSaveReason=ct={}));var ot;(function(Te){function Ne(se){switch(se){case s.TextEditorLineNumbersStyle.Off:return 0;case s.TextEditorLineNumbersStyle.Relative:return 2;case s.TextEditorLineNumbersStyle.On:default:return 1}}Te.from=Ne;function Ce(se){switch(se){case 0:return s.TextEditorLineNumbersStyle.Off;case 2:return s.TextEditorLineNumbersStyle.Relative;case 1:default:return s.TextEditorLineNumbersStyle.On}}Te.to=Ce})(ot||(e.TextEditorLineNumbersStyle=ot={}));var rt;(function(Te){function Ne(se){if(se===s.EndOfLine.CRLF)return 1;if(se===s.EndOfLine.LF)return 0}Te.from=Ne;function Ce(se){if(se===1)return s.EndOfLine.CRLF;if(se===0)return s.EndOfLine.LF}Te.to=Ce})(rt||(e.EndOfLine=rt={}));var Re;(function(Te){function Ne(Ce){if(typeof Ce=="object")return Ce.viewId;switch(Ce){case s.ProgressLocation.SourceControl:return 3;case s.ProgressLocation.Window:return 10;case s.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Te.from=Ne})(Re||(e.ProgressLocation=Re={}));var Ue;(function(Te){function Ne(se){const Fe={start:se.start+1,end:se.end+1};return se.kind&&(Fe.kind=Ae.from(se.kind)),Fe}Te.from=Ne;function Ce(se){const Fe={start:se.start-1,end:se.end-1};return se.kind&&(Fe.kind=Ae.to(se.kind)),Fe}Te.to=Ce})(Ue||(e.FoldingRange=Ue={}));var Ae;(function(Te){function Ne(se){if(se)switch(se){case s.FoldingRangeKind.Comment:return h.$Kt.Comment;case s.FoldingRangeKind.Imports:return h.$Kt.Imports;case s.FoldingRangeKind.Region:return h.$Kt.Region}}Te.from=Ne;function Ce(se){if(se)switch(se.value){case h.$Kt.Comment.value:return s.FoldingRangeKind.Comment;case h.$Kt.Imports.value:return s.FoldingRangeKind.Imports;case h.$Kt.Region.value:return s.FoldingRangeKind.Region}}Te.to=Ce})(Ae||(e.FoldingRangeKind=Ae={}));var Xe;(function(Te){function Ne(Ce){if(Ce)return{pinned:typeof Ce.preview=="boolean"?!Ce.preview:void 0,inactive:Ce.background,preserveFocus:Ce.preserveFocus,selection:typeof Ce.selection=="object"?a.from(Ce.selection):void 0,override:typeof Ce.override=="boolean"?i.$EE.id:void 0}}Te.from=Ne})(Xe||(e.TextEditorOpenOptions=Xe={}));var ne;(function(Te){function Ne(Ve){return Ve instanceof s.$5L?Ve.toJSON():typeof Ve=="string"?Ve:Ce(Ve)||se(Ve)?new s.$5L(Ve.baseUri??Ve.base,Ve.pattern).toJSON():Ve}Te.from=Ne;function Ce(Ve){const xe=Ve;return xe?p.URI.isUri(xe.baseUri)&&typeof xe.pattern=="string":!1}function se(Ve){const xe=Ve;return xe?typeof xe.base=="string"&&typeof xe.pattern=="string":!1}function Fe(Ve){return typeof Ve=="string"?Ve:new s.$5L(p.URI.revive(Ve.baseUri),Ve.pattern)}Te.to=Fe})(ne||(e.GlobPattern=ne={}));var ce;(function(Te){function Ne(Ce){if(Ce){if(Array.isArray(Ce))return Ce.map(Ne);if(typeof Ce=="string")return Ce;{const se=Ce;return{language:se.language,scheme:se.scheme,pattern:ne.from(se.pattern),exclusive:se.exclusive,notebookType:se.notebookType}}}else return}Te.from=Ne})(ce||(e.LanguageSelector=ce={}));var Ie;(function(Te){function Ne(se){return!!se&&typeof se=="object"&&"documents"in se&&Array.isArray(se.documents)&&se.documents.every(Fe=>Array.isArray(Fe)&&Fe.every(Ve=>Ve&&typeof Ve=="object"&&"uri"in Ve&&p.URI.isUri(Ve.uri)&&"version"in Ve&&typeof Ve.version=="number"&&"ranges"in Ve&&Array.isArray(Ve.ranges)&&Ve.ranges.every(xe=>xe instanceof s.$0K)))}Te.is=Ne;function Ce(se){return{documents:se.documents.map(Fe=>Fe.map(Ve=>({uri:p.URI.from(Ve.uri),version:Ve.version,ranges:Ve.ranges.map(xe=>a.from(xe))})))}}Te.from=Ce})(Ie||(e.MappedEditsContext=Ie={}));var qe;(function(Te){function Ne(se){return{start:se.start,end:se.end}}Te.from=Ne;function Ce(se){return new s.$tM(se.start,se.end)}Te.to=Ce})(qe||(e.NotebookRange=qe={}));var Ye;(function(Te){function Ne(se){return{timing:typeof se.runStartTime=="number"&&typeof se.runEndTime=="number"?{startTime:se.runStartTime,endTime:se.runEndTime}:void 0,executionOrder:se.executionOrder,success:se.lastRunSuccess}}Te.to=Ne;function Ce(se){return{lastRunSuccess:se.success,runStartTime:se.timing?.startTime,runEndTime:se.timing?.endTime,executionOrder:se.executionOrder}}Te.from=Ce})(Ye||(e.NotebookCellExecutionSummary=Ye={}));var nt;(function(Te){function Ne(Ce){if(Ce===r.NotebookCellExecutionState.Unconfirmed)return s.NotebookCellExecutionState.Pending;if(Ce===r.NotebookCellExecutionState.Pending)return;if(Ce===r.NotebookCellExecutionState.Executing)return s.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Ce}`)}Te.to=Ne})(nt||(e.NotebookCellExecutionState=nt={}));var it;(function(Te){function Ne(se){switch(se){case s.NotebookCellKind.Markup:return r.CellKind.Markup;case s.NotebookCellKind.Code:default:return r.CellKind.Code}}Te.from=Ne;function Ce(se){switch(se){case r.CellKind.Markup:return s.NotebookCellKind.Markup;case r.CellKind.Code:default:return s.NotebookCellKind.Code}}Te.to=Ce})(it||(e.NotebookCellKind=it={}));var Oe;(function(Te){function Ne(se){const Fe={metadata:se.metadata??Object.create(null),cells:[]};for(const Ve of se.cells)s.$uM.validate(Ve),Fe.cells.push(vt.from(Ve));return Fe}Te.from=Ne;function Ce(se){const Fe=new s.$vM(se.cells.map(vt.to));return(0,m.$Vf)(se.metadata)||(Fe.metadata=se.metadata),Fe}Te.to=Ce})(Oe||(e.NotebookData=Oe={}));var vt;(function(Te){function Ne(se){return{cellKind:it.from(se.kind),language:se.languageId,mime:se.mime,source:se.value,metadata:se.metadata,internalMetadata:Ye.from(se.executionSummary??{}),outputs:se.outputs?se.outputs.map(Nt.from):[]}}Te.from=Ne;function Ce(se){return new s.$uM(it.to(se.cellKind),se.source,se.language,se.mime,se.outputs?se.outputs.map(Nt.to):void 0,se.metadata,se.internalMetadata?Ye.to(se.internalMetadata):void 0)}Te.to=Ce})(vt||(e.NotebookCellData=vt={}));var St;(function(Te){function Ne(se){return{mime:se.mime,valueBytes:O.$je.wrap(se.data)}}Te.from=Ne;function Ce(se){return new s.$wM(se.valueBytes.buffer,se.mime)}Te.to=Ce})(St||(e.NotebookCellOutputItem=St={}));var Nt;(function(Te){function Ne(se){return{outputId:se.id,items:se.items.map(St.from),metadata:se.metadata}}Te.from=Ne;function Ce(se){const Fe=se.items.map(St.to);return new s.$xM(Fe,se.outputId,se.metadata)}Te.to=Ce})(Nt||(e.NotebookCellOutput=Nt={}));var Wt;(function(Te){function Ne(Fe){return se(Fe)?{include:ne.from(Fe.include)??void 0,exclude:ne.from(Fe.exclude)??void 0}:ne.from(Fe)??void 0}Te.from=Ne;function Ce(Fe){return se(Fe)?{include:ne.to(Fe.include),exclude:ne.to(Fe.exclude)}:ne.to(Fe)}Te.to=Ce;function se(Fe){const Ve=Fe;return Ve?!(0,m.$Rf)(Ve.include)&&!(0,m.$Rf)(Ve.exclude):!1}})(Wt||(e.NotebookExclusiveDocumentPattern=Wt={}));var Et;(function(Te){function Ne(Ce,se,Fe){const Ve=typeof Ce.command=="string"?{title:"",command:Ce.command}:Ce.command;return{alignment:Ce.alignment===s.NotebookCellStatusBarAlignment.Left?1:2,command:se.toInternal(Ve,Fe),text:Ce.text,tooltip:Ce.tooltip,accessibilityInformation:Ce.accessibilityInformation,priority:Ce.priority}}Te.from=Ne})(Et||(e.NotebookStatusBarItem=Et={}));var Kt;(function(Te){function Ne(Ce,se,Fe){const Ve=typeof Ce.command=="string"?{title:"",command:Ce.command}:Ce.command;return{command:se.toInternal(Ve,Fe),label:Ce.label,description:Ce.description,detail:Ce.detail,documentation:Ce.documentation}}Te.from=Ne})(Kt||(e.NotebookKernelSourceAction=Kt={}));var Ot;(function(Te){function Ne(Ce){return{transientOutputs:Ce?.transientOutputs??!1,transientCellMetadata:Ce?.transientCellMetadata??{},transientDocumentMetadata:Ce?.transientDocumentMetadata??{},cellContentMetadata:Ce?.cellContentMetadata??{}}}Te.from=Ne})(Ot||(e.NotebookDocumentContentOptions=Ot={}));var Yt;(function(Te){function Ne(se){return{uri:se.uri,provides:se.provides}}Te.from=Ne;function Ce(se){return new s.$zM(p.URI.revive(se.uri),se.provides)}Te.to=Ce})(Yt||(e.NotebookRendererScript=Yt={}));var Ut;(function(Te){function Ne(se){return{message:j.fromStrict(se.message)||"",type:0,expected:se.expectedOutput,actual:se.actualOutput,contextValue:se.contextValue,location:se.location&&{range:a.from(se.location.range),uri:se.location.uri}}}Te.from=Ne;function Ce(se){const Fe=new s.$FM(typeof se.message=="string"?se.message:j.to(se.message));return Fe.actualOutput=se.actual,Fe.expectedOutput=se.expected,Fe.contextValue=se.contextValue,Fe.location=se.location?ye.to(se.location):void 0,Fe}Te.to=Ce})(Ut||(e.TestMessage=Ut={}));var At;(function(Te){Te.namespace=c.$2J,Te.denamespace=c.$3J})(At||(e.TestTag=At={}));var et;(function(Te){function Ne(se){const Fe=(0,o.$6M)(se).controllerId;return{extId:n.$XJ.fromExtHostTestItem(se,Fe).toString(),label:se.label,uri:p.URI.revive(se.uri),busy:se.busy,tags:se.tags.map(Ve=>At.namespace(Fe,Ve.id)),range:S.$Us.lift(a.from(se.range)),description:se.description||null,sortText:se.sortText||null,error:se.error&&j.fromStrict(se.error)||null}}Te.from=Ne;function Ce(se){return{parent:void 0,error:void 0,id:n.$XJ.fromString(se.extId).localId,label:se.label,uri:p.URI.revive(se.uri),tags:(se.tags||[]).map(Fe=>{const{tagId:Ve}=At.denamespace(Fe);return new s.$GM(Ve)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:a.to(se.range||void 0),canResolveChildren:!1,busy:se.busy,description:se.description||void 0,sortText:se.sortText||void 0}}Te.toPlain=Ce})(et||(e.TestItem=et={})),function(Te){function Ne(se){return{id:se.id}}Te.from=Ne;function Ce(se){return new s.$GM(se.id)}Te.to=Ce}(At||(e.TestTag=At={}));var Gt;(function(Te){const Ne=(se,Fe)=>{const Ve=[];for(const[Ke,st]of Fe)n.$XJ.compare(st.item.extId,Ke)===2&&(Fe.delete(Ke),Ve.push(st));const xe={...et.toPlain(se.item),parent:void 0,taskStates:se.tasks.map(Ke=>({state:Ke.state,duration:Ke.duration,messages:Ke.messages.filter(st=>st.type===0).map(Ut.to)})),children:Ve.map(Ke=>Ne(Ke,Fe))};for(const Ke of xe.children)Ke.parent=xe;return xe};function Ce(se){const Fe=[],Ve=new Map;for(const xe of se.items){Ve.set(xe.item.extId,xe);const Ke=n.$XJ.root(xe.item.extId);se.request.targets.some(st=>st.controllerId===Ke&&st.testIds.includes(xe.item.extId))&&Fe.push(xe)}return{completedAt:se.completedAt,results:Fe.map(xe=>Ne(xe,Ve))}}Te.to=Ce})(Gt||(e.TestResults=Gt={}));var Jt;(function(Te){function Ne(Ve){return{covered:Ve.covered,total:Ve.total}}function Ce(Ve){return"line"in Ve?k.from(Ve):a.from(Ve)}function se(Ve){return"branches"in Ve?{count:Ve.executionCount,location:Ce(Ve.location),type:1,branches:Ve.branches.length?Ve.branches.map(xe=>({count:xe.executionCount,location:xe.location&&Ce(xe.location),label:xe.label})):void 0}:{type:0,name:Ve.name,count:Ve.executionCount,location:Ce(Ve.location)}}Te.fromDetailed=se;function Fe(Ve){return{uri:Ve.uri,statement:Ne(Ve.statementCoverage),branch:Ve.branchCoverage&&Ne(Ve.branchCoverage),function:Ve.functionCoverage&&Ne(Ve.functionCoverage),details:Ve.detailedCoverage?.map(se)}}Te.fromFile=Fe})(Jt||(e.TestCoverage=Jt={}));var ht;(function(Te){function Ne(Ce){switch(Ce){case 1:return s.CodeActionTriggerKind.Invoke;case 2:return s.CodeActionTriggerKind.Automatic}}Te.to=Ne})(ht||(e.CodeActionTriggerKind=ht={}));var bt;(function(Te){function Ne(se){const Fe=new s.$MM(he.to(se.kind),se.name,se.detail||"",p.URI.revive(se.uri),a.to(se.range),a.to(se.selectionRange));return Fe._sessionId=se._sessionId,Fe._itemId=se._itemId,Fe}Te.to=Ne;function Ce(se,Fe,Ve){if(Fe=Fe??se._sessionId,Ve=Ve??se._itemId,Fe===void 0||Ve===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:Ve,kind:he.from(se.kind),name:se.name,detail:se.detail??"",uri:se.uri,range:a.from(se.range),selectionRange:a.from(se.selectionRange),tags:se.tags?.map(_.from)}}Te.from=Ce})(bt||(e.TypeHierarchyItem=bt={}));var zt;(function(Te){function Ne(Ce){if(Ce)return{value:Ce.value,tooltip:Ce.tooltip}}Te.from=Ne})(zt||(e.ViewBadge=zt={}));var Vt;(function(Te){function Ne(Ve,xe,Ke){const st=xe.fileData;return st?new s.$XL(new s.$YL(st.name,p.URI.revive(st.uri),st.id,(0,I.$db)(()=>Ke(st.id)))):Ve===L.$fs.uriList&&xe.uriListData?new s.$WL(Fe(xe.uriListData)):new s.$WL(xe.asString)}Te.to=Ne;async function Ce(Ve,xe){const Ke=await xe.asString();if(Ve===L.$fs.uriList)return{asString:Ke,fileData:void 0,uriListData:se(Ke)};const st=xe.asFile();return{asString:Ke,fileData:st?{name:st.name,uri:st.uri,id:st._itemId??st.id}:void 0}}Te.from=Ce;function se(Ve){return g.$rt.split(Ve).map(xe=>{if(xe.startsWith("#"))return xe;try{return p.URI.parse(xe)}catch{}return xe})}function Fe(Ve){return g.$rt.create(Ve.map(xe=>typeof xe=="string"?xe:p.URI.revive(xe)))}})(Vt||(e.DataTransferItem=Vt={}));var Dt;(function(Te){function Ne(se,Fe){const Ve=se.items.map(([xe,Ke])=>[xe,Vt.to(xe,Ke,Fe)]);return new s.$ZL(Ve)}Te.toDataTransfer=Ne;async function Ce(se){const Fe={items:[]},Ve=[];for(const[xe,Ke]of se)Ve.push((async()=>{Fe.items.push([xe,await Vt.from(xe,Ke)])})());return await Promise.all(Ve),Fe}Te.from=Ce})(Dt||(e.DataTransfer=Dt={}));var ft;(function(Te){function Ne(Ce){return{kind:"reply",message:Ce.message,title:Ce.title,tooltip:Ce.tooltip}}Te.from=Ne})(ft||(e.ChatReplyFollowup=ft={}));var Rt;(function(Te){function Ne(Ce){return typeof Ce=="string"?{title:Ce,message:Ce,kind:"reply"}:"commandId"in Ce?{kind:"command",title:Ce.title??"",commandId:Ce.commandId??"",when:Ce.when??"",args:Ce.args}:ft.from(Ce)}Te.from=Ne})(Rt||(e.ChatFollowup=Rt={}));var xt;(function(Te){function Ne(se){const Fe=new s.$YM(Ct.to(se.role),se.content);return Fe.name=se.name,Fe}Te.to=Ne;function Ce(se){return{role:Ct.from(se.role),content:se.content,name:se.name}}Te.from=Ce})(xt||(e.ChatMessage=xt={}));var Ct;(function(Te){function Ne(se){switch(se){case 0:return s.ChatMessageRole.System;case 1:return s.ChatMessageRole.User;case 2:return s.ChatMessageRole.Assistant;case 3:return s.ChatMessageRole.Function}}Te.to=Ne;function Ce(se){switch(se){case s.ChatMessageRole.System:return 0;case s.ChatMessageRole.Assistant:return 2;case s.ChatMessageRole.Function:return 3;case s.ChatMessageRole.User:default:return 1}}Te.from=Ce})(Ct||(e.ChatMessageRole=Ct={}));var Qe;(function(Te){function Ne(Fe){const Ve={};for(const xe of Object.keys(Fe))Ve[xe]=Fe[xe].map(Te.to);return Ve}Te.objectTo=Ne;function Ce(Fe){return{level:Tt.to(Fe.level),kind:Fe.kind,value:(0,p.$vc)(Fe.value)?p.URI.revive(Fe.value):Fe.value,description:Fe.description}}Te.to=Ce;function se(Fe){return{level:Tt.from(Fe.level),kind:Fe.kind,value:Fe.value,description:Fe.description}}Te.from=se})(Qe||(e.ChatVariable=Qe={}));var Tt;(function(Te){function Ne(se){switch(se){case"short":return s.ChatVariableLevel.Short;case"medium":return s.ChatVariableLevel.Medium;case"full":default:return s.ChatVariableLevel.Full}}Te.to=Ne;function Ce(se){switch(se){case s.ChatVariableLevel.Short:return"short";case s.ChatVariableLevel.Medium:return"medium";case s.ChatVariableLevel.Full:default:return"full"}}Te.from=Ce})(Tt||(e.ChatVariableLevel=Tt={}));var qt;(function(Te){function Ne(Ce){switch(Ce){case 1:return s.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return s.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return s.InteractiveEditorResponseFeedbackKind.Undone;case 3:return s.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return s.InteractiveEditorResponseFeedbackKind.Bug}}Te.to=Ne})(qt||(e.InteractiveEditorResponseFeedbackKind=qt={}));var Qt;(function(Te){function Ne(Ce,se){return"placeholder"in se&&"resolvedContent"in se?{content:se.placeholder,kind:"asyncContent"}:"markdownContent"in se?((0,u.$CF)(Ce,"chatAgents2Additions"),{content:j.from(se.markdownContent),kind:"markdownContent"}):"content"in se?"vulnerabilities"in se&&se.vulnerabilities?((0,u.$CF)(Ce,"chatAgents2Additions"),{content:se.content,vulnerabilities:se.vulnerabilities,kind:"vulnerability"}):typeof se.content=="string"?{content:se.content,kind:"content"}:((0,u.$CF)(Ce,"chatAgents2Additions"),{content:j.from(se.content),kind:"markdownContent"}):"documents"in se?{documents:se.documents.map(Fe=>({uri:Fe.uri,version:Fe.version,ranges:Fe.ranges.map(Ve=>a.from(Ve))})),kind:"usedContext"}:"reference"in se?{reference:"uri"in se.reference?{uri:se.reference.uri,range:a.from(se.reference.range)}:se.reference,kind:"reference"}:"inlineReference"in se?{inlineReference:"uri"in se.inlineReference?{uri:se.inlineReference.uri,range:a.from(se.inlineReference.range)}:se.inlineReference,name:se.title,kind:"inlineReference"}:"agentName"in se?((0,u.$CF)(Ce,"chatAgents2Additions"),{agentName:se.agentName,command:se.command,kind:"agentDetection"}):"treeData"in se?{treeData:se.treeData,kind:"treeData"}:"message"in se?{content:j.from(se.message),kind:"progressMessage"}:void 0}Te.from=Ne})(Qt||(e.ChatResponseProgress=Qt={}));var gt;(function(Te){function Ne(Ce){return{label:Ce.label,values:Ce.values.map(Qe.from),insertText:Ce.insertText,detail:Ce.detail,documentation:Ce.documentation}}Te.from=Ne})(gt||(e.ChatAgentCompletionItem=gt={}));var Ft;(function(Te){function Ne(Ce,se,Fe){return"terminalCommand"in Ce?{terminalCommand:Ce.terminalCommand,shouldExecute:Ce.shouldExecute}:"uri"in Ce?{uri:Ce.uri}:se.toInternal(Ce,Fe)}Te.from=Ne})(Ft||(e.TerminalQuickFix=Ft={}))}),define(ke[293],Se([1,0,2,14,7,15,75]),function(me,e,D,O,g,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ghc=void 0;class b{constructor(y,L,C,m={timeout:1500,errors:3}){this.c=y,this.d=L,this.f=C,this.g=m,this.a=new A.$4c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(y){return(L,C,m)=>{const S={dispose:this.a.push([L,C,y])};return Array.isArray(m)&&m.push(S),S}}async $participateInSave(y,L){const C=D.URI.revive(y);let m=!1;const p=setTimeout(()=>m=!0,this.g.timeout),S=[];try{for(const h of[...this.a]){if(m)break;const f=this.d.getDocument(C),o=await this.h(h,{document:f,reason:I.TextDocumentSaveReason.to(L)});S.push(o)}}finally{clearTimeout(p)}return S}h([y,L,C],m){const p=this.b.get(y);return typeof p=="number"&&p>this.g.errors?Promise.resolve(!1):this.i(C,y,L,m).then(()=>!0,S=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' threw ERROR`),this.c.error(S),!(S instanceof Error)||S.message!=="concurrent_edits"){const h=this.b.get(y);this.b.set(y,h?h+1:1),typeof h=="number"&&h>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(y,L,C,m){const p=[],S=Date.now(),{document:h,reason:f}=m,{version:o}=h,i=Object.freeze({document:h,reason:f,waitUntil(r){if(Object.isFrozen(p))throw(0,O.$8)("waitUntil can not be called async");p.push(Promise.resolve(r))}});try{L.apply(C,[i])}catch(r){return Promise.reject(r)}return Object.freeze(p),new Promise((r,n)=>{const c=setTimeout(()=>n(new Error("timeout")),this.g.timeout);return Promise.all(p).then(t=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${y.identifier.value}' finished after ${Date.now()-S}ms`),clearTimeout(c),r(t)}).catch(t=>{clearTimeout(c),n(t)})}).then(r=>{const n={edits:[]};for(const c of r)if(Array.isArray(c)&&c.every(t=>t instanceof g.$cL))for(const{newText:t,newEol:u,range:s}of c)n.edits.push({resource:h.uri,versionId:void 0,textEdit:{range:s&&I.Range.from(s),text:t,eol:u&&I.EndOfLine.from(u)}});if(n.edits.length!==0)return o===h.version?this.f.$tryApplyWorkspaceEdit(n):Promise.reject(new Error("concurrent_edits"))})}}e.$ghc=b}),define(ke[294],Se([1,0,17,2,15,7,111]),function(me,e,D,O,g,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mhc=e.$lhc=void 0;class b{constructor(C,m,p,S){this.start=C,this.deletedCount=m,this.deletedItems=p,this.items=S}asApiEvent(){return{range:new I.$tM(this.start,this.start+this.deletedCount),addedCells:this.items.map(C=>C.apiCell),removedCells:this.deletedItems}}}class ${static asModelAddData(C,m){return{EOL:m.eol,lines:m.source,languageId:m.language,uri:m.uri,isDirty:!1,versionId:1,notebook:C}}constructor(C,m,p){this.notebook=C,this.h=m,this.j=p,this.handle=p.handle,this.uri=O.URI.revive(p.uri),this.cellKind=p.cellKind,this.a=p.outputs.map(g.NotebookCellOutput.to),this.e=p.internalMetadata??{},this.b=Object.freeze(p.metadata??{}),this.d=Object.freeze(g.NotebookCellExecutionSummary.to(p.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const C=this,m=this.h.getDocument(this.uri);if(!m)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const p={get index(){return C.notebook.getCellIndex(C)},notebook:C.notebook.apiNotebook,kind:g.NotebookCellKind.to(this.j.cellKind),document:m.document,get mime(){return C.g},set mime(S){C.g=S},get outputs(){return C.a.slice(0)},get metadata(){return C.b},get executionSummary(){return C.d}};this.f=Object.freeze(p)}return this.f}setOutputs(C){this.a=C.map(g.NotebookCellOutput.to)}setOutputItems(C,m,p){const S=p.map(g.NotebookCellOutputItem.to),h=this.a.find(f=>f.id===C);if(h&&(m||(h.items.length=0),h.items.push(...S),h.items.length>1&&h.items.every(f=>A.$0I(f.mime)))){const f=new Map,o=[];h.items.forEach(i=>{let r;f.has(i.mime)?r=f.get(i.mime):(r=[],f.set(i.mime,r),o.push(i.mime)),r.push(i.data)}),h.items.length=0,o.forEach(i=>{const r=A.$$I(f.get(i));h.items.push({mime:i,data:r.data.buffer})})}}setMetadata(C){this.b=Object.freeze(C)}setInternalMetadata(C){this.e=C,this.d=Object.freeze(g.NotebookCellExecutionSummary.to(C))}setMime(C){}}e.$lhc=$;class y{static{this.a=0}constructor(C,m,p,S,h){this.k=C,this.l=m,this.m=p,this.uri=S,this.handle=y.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=h.viewType,this.f=Object.freeze(h.metadata??Object.create(null)),this.r([[0,0,h.cells]],!0,void 0),this.g=h.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const C=this,m={get uri(){return C.uri},get version(){return C.g},get notebookType(){return C.d},get isDirty(){return C.h},get isUntitled(){return C.uri.scheme===D.Schemas.untitled},get isClosed(){return C.j},get metadata(){return C.f},get cellCount(){return C.b.length},cellAt(p){return p=C.n(p),C.b[p].apiCell},getCells(p){return(p?C.p(p):C.b).map(h=>h.apiCell)},save(){return C.q()}};this.e=Object.freeze(m)}return this.e}acceptDocumentPropertiesChanged(C){C.metadata&&(this.f=Object.freeze({...this.f,...C.metadata}))}acceptDirty(C){this.h=C}acceptModelChanged(C,m,p){this.g=C.versionId,this.h=m,this.acceptDocumentPropertiesChanged({metadata:p});const S={notebook:this.apiNotebook,metadata:p,cellChanges:[],contentChanges:[]},h=[];for(const o of C.rawEvents)o.kind===A.NotebookCellsChangeType.ModelChange?this.r(o.changes,!1,S.contentChanges):o.kind===A.NotebookCellsChangeType.Move?this.s(o.index,o.length,o.newIdx,S.contentChanges):o.kind===A.NotebookCellsChangeType.Output?(this.t(o.index,o.outputs),h.push({cell:this.b[o.index].apiCell,outputs:this.b[o.index].apiCell.outputs})):o.kind===A.NotebookCellsChangeType.OutputItem?(this.u(o.index,o.outputId,o.append,o.outputItems),h.push({cell:this.b[o.index].apiCell,outputs:this.b[o.index].apiCell.outputs})):o.kind===A.NotebookCellsChangeType.ChangeCellLanguage?(this.v(o.index,o.language),h.push({cell:this.b[o.index].apiCell,document:this.b[o.index].apiCell.document})):o.kind===A.NotebookCellsChangeType.ChangeCellContent?h.push({cell:this.b[o.index].apiCell,document:this.b[o.index].apiCell.document}):o.kind===A.NotebookCellsChangeType.ChangeCellMime?this.w(o.index,o.mime):o.kind===A.NotebookCellsChangeType.ChangeCellMetadata?(this.x(o.index,o.metadata),h.push({cell:this.b[o.index].apiCell,metadata:this.b[o.index].apiCell.metadata})):o.kind===A.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(o.index,o.internalMetadata),h.push({cell:this.b[o.index].apiCell,executionSummary:this.b[o.index].apiCell.executionSummary}));const f=new Map;for(let o=0;o<h.length;o++){const i=h[o],r=f.get(i.cell);if(r===void 0){const n=S.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...i});f.set(i.cell,n-1)}else S.cellChanges[r]={...S.cellChanges[r],...i}}return Object.freeze(S),Object.freeze(S.cellChanges),Object.freeze(S.contentChanges),S}n(C){return C=C|0,C<0?0:C>=this.b.length?this.b.length-1:C}o(C){let m=C.start|0,p=C.end|0;return m<0&&(m=0),p>this.b.length&&(p=this.b.length),C.with({start:m,end:p})}p(C){C=this.o(C);const m=[];for(let p=C.start;p<C.end;p++)m.push(this.b[p]);return m}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(C,m,p){if(this.j)return;const S=[],h=[],f=[];if(C.reverse().forEach(o=>{const r=o[2].map(t=>{const u=new $(this,this.l,t);return m||h.push($.asModelAddData(this.apiNotebook,t)),u}),n=new b(o[0],o[1],[],r),c=this.b.splice(o[0],o[1],...r);for(const t of c)f.push(t.uri),n.deletedItems.push(t.apiCell);S.push(n)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:h,removedDocuments:f}),p)for(const o of S)p.push(o.asApiEvent())}s(C,m,p,S){const h=this.b.splice(C,m);this.b.splice(p,0,...h);const f=[new b(C,m,h.map(o=>o.apiCell),[]),new b(p,0,[],h)];for(const o of f)S.push(o.asApiEvent())}t(C,m){this.b[C].setOutputs(m)}u(C,m,p,S){this.b[C].setOutputItems(m,p,S)}v(C,m){const p=this.b[C];p.apiCell.document.languageId!==m&&this.m.$acceptModelLanguageChanged(p.uri,m)}w(C,m){const p=this.b[C];p.apiCell.mime=m}x(C,m){this.b[C].setMetadata(m)}y(C,m){this.b[C].setInternalMetadata(m)}getCellFromApiCell(C){return this.b.find(m=>m.apiCell===C)}getCellFromIndex(C){return this.b[C]}getCell(C){return this.b.find(m=>m.handle===C)}getCellIndex(C){return this.b.indexOf(C)}}e.$mhc=y}),define(ke[295],Se([1,0,4,2,15,7]),function(me,e,D,O,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Chc=void 0;class A{constructor($,y,L,C={timeout:1500,errors:3}){this.b=$,this.c=y,this.d=L,this.f=C,this.a=new D.$Xd}dispose(){}getOnWillSaveNotebookDocumentEvent($){return(y,L,C)=>{const m=function(S){y.call(L,S)};return m.extension=$,this.a.event(m,void 0,C)}}async $participateInSave($,y,L){const C=O.URI.revive($),m=this.c.getNotebookDocument(C);if(!m)throw new Error("Unable to resolve notebook document");const p=[];if(await this.a.fireAsync({notebook:m.apiNotebook,reason:g.TextDocumentSaveReason.to(y)},L,async(h,f)=>{const o=Date.now(),i=await await Promise.resolve(h);Date.now()-o>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",f.extension.identifier),!L.isCancellationRequested&&i&&(i instanceof I.$fL?p.push(i):this.b.warn("onWillSaveNotebookDocument-listener from extension",f.extension.identifier,"ignored due to invalid data"))}),L.isCancellationRequested)return!1;if(p.length===0)return!0;const S={edits:[]};for(const h of p){const{edits:f}=g.WorkspaceEdit.from(h);S.edits=S.edits.concat(f)}return this.d.$tryApplyWorkspaceEdit(S)}}e.$Chc=A}),define(ke[146],Se([1,0,14,15,7]),function(me,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nhc=void 0;class I{static{this.apiEditorsToExtHost=new WeakMap}constructor(b,$,y,L,C,m){this.id=b,this.f=$,this.notebookData=y,this.a=[],this.b=[],this.d=!1,this.a=C,this.b=L,this.c=m}get apiEditor(){if(!this.e){const b=this;this.e={get notebook(){return b.notebookData.apiNotebook},get selection(){return b.a[0]},set selection($){this.selections=[$]},get selections(){return b.a},set selections($){if(!Array.isArray($)||!$.every(g.$tM.isNotebookRange))throw(0,D.$7)("selections");b.a=$,b.g($)},get visibleRanges(){return b.b},revealRange($,y){b.f.$tryRevealRange(b.id,O.NotebookRange.from($),y??g.NotebookEditorRevealType.Default)},get viewColumn(){return b.c}},I.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(b){this.d=b}_acceptVisibleRanges(b){this.b=b}_acceptSelections(b){this.a=b}g(b){this.f.$trySetSelections(this.id,b.map(O.NotebookRange.from))}_acceptViewColumn(b){this.c=b}}e.$nhc=I}),define(ke[296],Se([1,0,4,13,15]),function(me,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ehc=void 0;let I=class{constructor(b,$){this.c=b,this.d=$,this.a=new D.$Vd,this.b=new D.$Vd,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(b,$){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",b,$);const y=this.d.getEditorById(b);$.visibleRanges&&y._acceptVisibleRanges($.visibleRanges.ranges.map(g.NotebookRange.to)),$.selections&&y._acceptSelections($.selections.selections.map(g.NotebookRange.to)),$.visibleRanges&&this.b.fire({notebookEditor:y.apiEditor,visibleRanges:y.apiEditor.visibleRanges}),$.selections&&this.a.fire(Object.freeze({notebookEditor:y.apiEditor,selections:y.apiEditor.selections}))}$acceptEditorViewColumns(b){for(const $ in b)this.d.getEditorById($)._acceptViewColumn(g.ViewColumn.to(b[$]))}};e.$Ehc=I,e.$Ehc=I=Ge([We(0,O.$nj)],I)}),define(ke[297],Se([1,0,15,85,21,52,14]),function(me,e,D,O,g,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lhc=void 0;class b{constructor(C){this.b=0,this.c=new Map,this.a=C}async withProgress(C,m,p){const S=this.b++,{title:h,location:f,cancellable:o}=m,i={label:C.displayName||C.name,id:C.identifier.value};return this.a.$startProgress(S,{location:D.ProgressLocation.from(f),title:h,source:i,cancellable:o},C.isUnderDevelopment?void 0:C.identifier.value).catch(A.$2),this.d(S,p,!!o)}d(C,m,p){let S;p&&(S=new g.$6d,this.c.set(C,S));const h=o=>{this.a.$progressEnd(o),this.c.delete(o),S?.dispose()};let f;try{f=m(new y(this.a,C),p&&S?S.token:g.CancellationToken.None)}catch(o){throw h(C),o}return f.then(o=>h(C),o=>h(C)),f}$acceptProgressCanceled(C){const m=this.c.get(C);m&&(m.cancel(),this.c.delete(C))}}e.$Lhc=b;function $(L,C){return L.message=C.message,typeof C.increment=="number"&&(typeof L.increment=="number"?L.increment+=C.increment:L.increment=C.increment),L}class y extends O.$vv{constructor(C,m){super(p=>this.throttledReport(p)),this.c=C,this.d=m}throttledReport(C){this.c.$progressReport(this.d,C)}}Ge([(0,I.$zh)(100,(L,C)=>$(L,C),()=>Object.create(null))],y.prototype,"throttledReport",null)}),define(ke[147],Se([1,0,29,142,67,112,89,15,2]),function(me,e,D,O,g,I,A,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mN=e.$lN=e.$kN=e.$jN=void 0;const y=(r,n,c,t)=>{let u=n;return{enumerable:!0,configurable:!1,get(){return u},set(s){if(!c(u,s)){const l=u;u=s,r.listener?.(t(s,l))}}}},L=(r,n)=>r===n,C={range:(r,n)=>r===n?!0:!r||!n?!1:r.isEqual(n),label:L,description:L,sortText:L,busy:L,error:L,canResolveChildren:L,tags:(r,n)=>!(r.length!==n.length||r.some(c=>!n.find(t=>c.id===t.id)))},m=r=>n=>({op:4,update:r(n)}),p=(r,n)=>({range:(()=>{let c;const t=m(u=>({range:D.$Us.lift(b.Range.from(u))}));return{enumerable:!0,configurable:!1,get(){return c},set(u){r.listener?.({op:6}),C.range(c,u)||(c=u,r.listener?.(t(u)))}}})(),label:y(r,n,C.label,m(c=>({label:c}))),description:y(r,void 0,C.description,m(c=>({description:c}))),sortText:y(r,void 0,C.sortText,m(c=>({sortText:c}))),canResolveChildren:y(r,!1,C.canResolveChildren,c=>({op:2,state:c})),busy:y(r,!1,C.busy,m(c=>({busy:c}))),error:y(r,void 0,C.error,m(c=>({error:b.MarkdownString.fromStrict(c)||null}))),tags:y(r,[],C.tags,(c,t)=>({op:1,new:c.map(b.TestTag.from),old:t.map(b.TestTag.from)}))}),S=r=>{const n=g.$XJ.fromString(r.extId),c=new f(n.controllerId,n.localId,r.label,$.URI.revive(r.uri)||void 0);return c.range=b.Range.to(r.range||void 0),c.description=r.description||void 0,c.sortText=r.sortText||void 0,c.tags=r.tags.map(t=>b.TestTag.to({id:(0,A.$3J)(t).tagId})),c},h=r=>{let n;for(const c of r.tests){const t=S(c.item);(0,O.$6M)(t).parent=n,n=t}return n};e.$jN=h;class f{constructor(n,c,t,u){if(c.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(c)} symbol`);const s=(0,O.$5M)(this,n);Object.defineProperties(this,{id:{value:c,enumerable:!0,writable:!1},uri:{value:u,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return s.parent instanceof o?void 0:s.parent}},children:{value:(0,I.$4M)(s,O.$6M,f),enumerable:!0,writable:!1},...p(s,t)})}}e.$kN=f;class o extends f{constructor(n,c){super(n,n,c,void 0),this._isRoot=!0}}e.$lN=o;class i extends I.$ZM{constructor(n,c,t){super({controllerId:n,getDocumentVersion:u=>u&&t.getDocument(u)?.version,getApiFor:O.$6M,getChildren:u=>u.children,root:new o(n,c),toITestItem:b.TestItem.from})}}e.$mN=i}),define(ke[148],Se([1,0,60,14,121,15,7]),function(me,e,D,O,g,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gN=e.$fN=e.$eN=void 0;class b{static{this.c=new g.$cN("TextEditorDecorationType")}constructor(m,p,S){const h=b.c.nextId();m.$registerTextEditorDecorationType(p.identifier,h,I.DecorationRenderOptions.from(S)),this.value=Object.freeze({key:h,dispose(){m.$removeTextEditorDecorationType(h)}})}}e.$eN=b;class ${constructor(m,p){this.g=[],this.h=void 0,this.j=!1,this.c=m,this.d=m.version,this.e=p.undoStopBefore,this.f=p.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(m,p){this.k();let S=null;if(m instanceof A.$9K)S=new A.$0K(m,m);else if(m instanceof A.$0K)S=m;else throw new Error("Unrecognized location");this.l(S,p,!1)}insert(m,p){this.k(),this.l(new A.$0K(m,m),p,!0)}delete(m){this.k();let p=null;if(m instanceof A.$0K)p=m;else throw new Error("Unrecognized location");this.l(p,null,!0)}l(m,p,S){const h=this.c.validateRange(m);this.g.push({range:h,text:p,forceMoveMarkers:S})}setEndOfLine(m){if(this.k(),m!==A.EndOfLine.LF&&m!==A.EndOfLine.CRLF)throw(0,O.$7)("endOfLine");this.h=m}}class y{constructor(m,p,S,h){this.c=m,this.d=p,this._accept(S),this.e=h;const f=this;this.value={get tabSize(){return f.f},set tabSize(o){f.n(o)},get indentSize(){return f.g},set indentSize(o){f.p(o)},get insertSpaces(){return f.j},set insertSpaces(o){f.s(o)},get cursorStyle(){return f.k},set cursorStyle(o){f.t(o)},get lineNumbers(){return f.l},set lineNumbers(o){f.u(o)}}}_accept(m){this.f=m.tabSize,this.g=m.indentSize,this.h=m.originalIndentSize,this.j=m.insertSpaces,this.k=m.cursorStyle,this.l=I.TextEditorLineNumbersStyle.to(m.lineNumbers)}m(m){if(m==="auto")return"auto";if(typeof m=="number"){const p=Math.floor(m);return p>0?p:null}if(typeof m=="string"){const p=parseInt(m,10);return isNaN(p)?null:p>0?p:null}return null}n(m){const p=this.m(m);if(p!==null){if(typeof p=="number"){if(this.f===p)return;this.f=p}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:p}))}}o(m){if(m==="tabSize")return"tabSize";if(typeof m=="number"){const p=Math.floor(m);return p>0?p:null}if(typeof m=="string"){const p=parseInt(m,10);return isNaN(p)?null:p>0?p:null}return null}p(m){const p=this.o(m);if(p!==null){if(typeof p=="number"){if(this.h===p)return;this.g=p,this.h=p}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:p}))}}q(m){return m==="auto"?"auto":m==="false"?!1:!!m}s(m){const p=this.q(m);if(typeof p=="boolean"){if(this.j===p)return;this.j=p}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:p}))}t(m){this.k!==m&&(this.k=m,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:m})))}u(m){this.l!==m&&(this.l=m,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:I.TextEditorLineNumbersStyle.from(m)})))}assign(m){const p={};let S=!1;if(typeof m.tabSize<"u"){const h=this.m(m.tabSize);h==="auto"?(S=!0,p.tabSize=h):typeof h=="number"&&this.f!==h&&(this.f=h,S=!0,p.tabSize=h)}if(typeof m.indentSize<"u"){const h=this.o(m.indentSize);h==="tabSize"?(S=!0,p.indentSize=h):typeof h=="number"&&this.h!==h&&(this.g=h,this.h=h,S=!0,p.indentSize=h)}if(typeof m.insertSpaces<"u"){const h=this.q(m.insertSpaces);h==="auto"?(S=!0,p.insertSpaces=h):this.j!==h&&(this.j=h,S=!0,p.insertSpaces=h)}typeof m.cursorStyle<"u"&&this.k!==m.cursorStyle&&(this.k=m.cursorStyle,S=!0,p.cursorStyle=m.cursorStyle),typeof m.lineNumbers<"u"&&this.l!==m.lineNumbers&&(this.l=m.lineNumbers,S=!0,p.lineNumbers=I.TextEditorLineNumbersStyle.from(m.lineNumbers)),S&&this.v("setOptions",this.c.$trySetOptions(this.d,p))}v(m,p){p.catch(S=>{this.e.warn(`ExtHostTextEditorOptions '${m}' failed:'`),this.e.warn(S)})}}e.$fN=y;class L{constructor(m,p,S,h,f,o,i,r){this.id=m,this.j=p,this.k=S,this.g=!1,this.h=new Set,this.c=f,this.d=new y(this.j,this.id,o,S),this.e=i,this.f=r;const n=this;this.value=Object.freeze({get document(){return h.value},set document(c){throw new O.$9("document")},get selection(){return n.c&&n.c[0]},set selection(c){if(!(c instanceof A.$$K))throw(0,O.$7)("selection");n.c=[c],n.l()},get selections(){return n.c},set selections(c){if(!Array.isArray(c)||c.some(t=>!(t instanceof A.$$K)))throw(0,O.$7)("selections");n.c=c,n.l()},get visibleRanges(){return n.e},set visibleRanges(c){throw new O.$9("visibleRanges")},get options(){return n.d.value},set options(c){n.g||n.d.assign(c)},get viewColumn(){return n.f},set viewColumn(c){throw new O.$9("viewColumn")},edit(c,t={undoStopBefore:!0,undoStopAfter:!0}){if(n.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const u=new $(h.value,t);return c(u),n.m(u)},insertSnippet(c,t,u={undoStopBefore:!0,undoStopAfter:!0}){if(n.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let s;if(!t||Array.isArray(t)&&t.length===0)s=n.c.map(l=>I.Range.from(l));else if(t instanceof A.$9K){const{lineNumber:l,column:a}=I.Position.from(t);s=[{startLineNumber:l,startColumn:a,endLineNumber:l,endColumn:a}]}else if(t instanceof A.$0K)s=[I.Range.from(t)];else{s=[];for(const l of t)if(l instanceof A.$0K)s.push(I.Range.from(l));else{const{lineNumber:a,column:d}=I.Position.from(l);s.push({startLineNumber:a,startColumn:d,endLineNumber:a,endColumn:d})}}return p.$tryInsertSnippet(m,h.value.version,c.value,s,u)},setDecorations(c,t){const u=t.length===0;u&&!n.h.has(c.key)||(u?n.h.delete(c.key):n.h.add(c.key),n.n(()=>{if(I.$7M(t))return p.$trySetDecorations(m,c.key,I.$8M(t));{const s=new Array(4*t.length);for(let l=0,a=t.length;l<a;l++){const d=t[l];s[4*l]=d.start.line+1,s[4*l+1]=d.start.character+1,s[4*l+2]=d.end.line+1,s[4*l+3]=d.end.character+1}return p.$trySetDecorationsFast(m,c.key,s)}}))},revealRange(c,t){n.n(()=>p.$tryRevealRange(m,I.Range.from(c),t||A.TextEditorRevealType.Default))},show(c){p.$tryShowEditor(m,I.ViewColumn.from(c))},hide(){p.$tryHideEditor(m)}})}dispose(){(0,D.ok)(!this.g),this.g=!0}_acceptOptions(m){(0,D.ok)(!this.g),this.d._accept(m)}_acceptVisibleRanges(m){(0,D.ok)(!this.g),this.e=m}_acceptViewColumn(m){(0,D.ok)(!this.g),this.f=m}_acceptSelections(m){(0,D.ok)(!this.g),this.c=m}async l(){const m=this.c.map(I.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,m)),this.value}m(m){const p=m.finalize();if(p.edits.length===0&&!p.setEndOfLine)return Promise.resolve(!0);const S=p.edits.map(f=>f.range);S.sort((f,o)=>f.end.line===o.end.line?f.end.character===o.end.character?f.start.line===o.start.line?f.start.character-o.start.character:f.start.line-o.start.line:f.end.character-o.end.character:f.end.line-o.end.line);for(let f=0,o=S.length-1;f<o;f++){const i=S[f].end;if(S[f+1].start.isBefore(i))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const h=p.edits.map(f=>({range:I.Range.from(f.range),text:f.text,forceMoveMarkers:f.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,p.documentVersionId,h,{setEndOfLine:typeof p.setEndOfLine=="number"?I.EndOfLine.from(p.setEndOfLine):void 0,undoStopBefore:p.undoStopBefore,undoStopAfter:p.undoStopAfter})}n(m){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):m().then(()=>this,p=>(p instanceof Error&&p.name==="DISPOSED"||this.k.warn(p),null))}}e.$gN=L}),define(ke[298],Se([1,0,219,23,2,4,3,278,11,7,18,19,15,80,21,177,25]),function(me,e,D,O,g,I,A,b,$,y,L,C,m,p,S,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5hc=void 0;function o(n,c){if((0,L.$If)(n))return{label:n};if(n&&typeof n=="object"&&typeof n.label=="string"){let t;return Array.isArray(n.highlights)&&(t=n.highlights.filter(u=>u.length===2&&typeof u[0]=="number"&&typeof u[1]=="number"),t=t.length?t:void 0),{label:n.label,highlights:t}}}class i extends A.$Tc{constructor(c,t,u){super(),this.f=c,this.g=t,this.h=u,this.a=new Map,this.b=new h.$j8;function s(l){return l&&l.$treeViewId&&(l.$treeItemHandle||l.$selectedTreeItems||l.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:l=>s(l)?this.r(l):Array.isArray(l)&&l.length>0?l.map(a=>s(a)?this.r(a):a):l})}registerTreeDataProvider(c,t,u){const s=this.createTreeView(c,{treeDataProvider:t},u);return{dispose:()=>s.dispose()}}createTreeView(c,t,u){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const s=t.dragAndDropController?.dropMimeTypes??[],l=t.dragAndDropController?.dragMimeTypes??[],a=!!t.dragAndDropController?.handleDrag,d=!!t.dragAndDropController?.handleDrop,k=this.m(c,t,u),R={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:s,dragMimeTypes:l,hasHandleDrag:a,hasHandleDrop:d,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},v=this.f.$registerTreeViewDataProvider(c,R),w={get onDidCollapseElement(){return k.onDidCollapseElement},get onDidExpandElement(){return k.onDidExpandElement},get selection(){return k.selectedElements},get onDidChangeSelection(){return k.onDidChangeSelection},get activeItem(){return(0,f.$CF)(u,"treeViewActiveItem"),k.focusedElement},get onDidChangeActiveItem(){return(0,f.$CF)(u,"treeViewActiveItem"),k.onDidChangeActiveItem},get visible(){return k.visible},get onDidChangeVisibility(){return k.onDidChangeVisibility},get onDidChangeCheckboxState(){return k.onDidChangeCheckboxState},get message(){return k.message},set message(E){(0,p.$jk)(E)&&(0,f.$CF)(u,"treeViewMarkdownMessage"),k.message=E},get title(){return k.title},set title(E){k.title=E},get description(){return k.description},set description(E){k.description=E},get badge(){return k.badge},set badge(E){E!==void 0&&y.ViewBadge.isViewBadge(E)?k.badge={value:Math.floor(Math.abs(E.value)),tooltip:E.tooltip}:E===void 0&&(k.badge=void 0)},reveal:(E,P)=>k.reveal(E,P),dispose:async()=>{await v,this.a.delete(c),k.dispose()}};return this.B(w),w}$getChildren(c,t){const u=this.a.get(c);return u?u.getChildren(t):Promise.reject(new b.$aF(c))}async $handleDrop(c,t,u,s,l,a,d,k){const R=this.a.get(c);if(!R)return Promise.reject(new b.$aF(c));const v=m.DataTransfer.toDataTransfer(u,async w=>(await this.f.$resolveDropFileData(c,t,w)).buffer);return d===c&&k&&await this.j(v,R,k,l,a),R.onDrop(v,s,l)}async j(c,t,u,s,l){const a=this.b.removeDragOperationTransfer(l);if(a)(await a)?.forEach((d,k)=>{d&&c.set(k,d)});else if(l&&t.handleDrag){const d=t.handleDrag(u,c,s);this.b.addDragOperationTransfer(l,d),await d}return c}async $handleDrag(c,t,u,s){const l=this.a.get(c);if(!l)return Promise.reject(new b.$aF(c));const a=await this.j(new y.$ZL,l,t,s,u);if(!(!a||s.isCancellationRequested))return m.DataTransfer.from(a)}async $hasResolve(c){const t=this.a.get(c);if(!t)throw new b.$aF(c);return t.hasResolve}$resolve(c,t,u){const s=this.a.get(c);if(!s)throw new b.$aF(c);return s.resolveTreeItem(t,u)}$setExpanded(c,t,u){const s=this.a.get(c);if(!s)throw new b.$aF(c);s.setExpanded(t,u)}$setSelectionAndFocus(c,t,u){const s=this.a.get(c);if(!s)throw new b.$aF(c);s.setSelectionAndFocus(t,u)}$setVisible(c,t){const u=this.a.get(c);if(!u){if(!t)return;throw new b.$aF(c)}u.setVisible(t)}$changeCheckboxState(c,t){const u=this.a.get(c);if(!u)throw new b.$aF(c);u.setCheckboxState(t)}m(c,t,u){const s=this.B(new r(c,t,this.f,this.g.converter,this.h,u));return this.a.set(c,s),s}r(c){const t=this.a.get(c.$treeViewId);return t&&"$treeItemHandle"in c?t.getExtensionElement(c.$treeItemHandle):t&&"$focusedTreeItem"in c&&c.$focusedTreeItem?t.focusedElement:null}}e.$5hc=i;class r extends A.$Tc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(c=>this.getExtensionElement(c)).filter(c=>!(0,L.$Rf)(c))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(c,t,u,s,l,a){if(super(),this.I=c,this.J=u,this.L=s,this.M=l,this.N=a,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new I.$Vd),this.onDidExpandElement=this.u.event,this.w=this.B(new I.$Vd),this.onDidCollapseElement=this.w.event,this.y=this.B(new I.$Vd),this.onDidChangeSelection=this.y.event,this.z=this.B(new I.$Vd),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new I.$Vd),this.onDidChangeVisibility=this.C.event,this.D=this.B(new I.$Vd),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new I.$Vd),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new S.$6d,a.contributes&&a.contributes.views)for(const v in a.contributes.views)for(const w of a.contributes.views[v])w.id===c&&(this.P=w.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(v=>this.F.fire({message:!1,element:v})));let d,k;const R=I.Event.debounce(this.F.event,(v,w)=>(v||(v={message:!1,elements:[]}),w.element!==!1&&(d||(d=new Promise(E=>k=E),this.G=this.G.then(()=>d)),Array.isArray(w.element)?v.elements.push(...w.element):v.elements.push(w.element)),w.message&&(v.message=!0),v),200,!0);this.B(R(({message:v,elements:w})=>{w.length&&(this.H=this.H.then(()=>{const E=k;return d=null,this.$(w).then(()=>E())})),v&&this.J.$setMessage(this.I,m.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(c){const t=c?this.getExtensionElement(c):void 0;if(c&&!t)return this.M.error(`No tree item with id '${c}' found.`),Promise.resolve([]);let u=this.X(c);return u||(u=await this.Y(t)),u?u.map(s=>s.item):void 0}getExtensionElement(c){return this.j.get(c)}reveal(c,t){t=t||{select:!0,focus:!1};const u=(0,L.$Rf)(t.select)?!0:t.select,s=(0,L.$Rf)(t.focus)?!1:t.focus,l=(0,L.$Rf)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):c?this.G.then(()=>this.S(c)).then(a=>this.W(c,a[a.length-1]).then(d=>this.J.$reveal(this.I,{item:d.item,parentChain:a.map(k=>k.item)},{select:u,focus:s,expand:l})),a=>this.M.error(a)):this.J.$reveal(this.I,void 0,{select:u,focus:s,expand:l})}get message(){return this.O}set message(c){this.O=c,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(c){this.P=c,this.J.$setTitle(this.I,c,this.Q)}get description(){return this.Q}set description(c){this.Q=c,this.J.$setTitle(this.I,this.P,c)}get badge(){return this.R}set badge(c){this.R?.value===c?.value&&this.R?.tooltip===c?.tooltip||(this.R=m.ViewBadge.from(c),this.J.$setBadge(this.I,c))}setExpanded(c,t){const u=this.getExtensionElement(c);u&&(t?this.u.fire(Object.freeze({element:u})):this.w.fire(Object.freeze({element:u})))}setSelectionAndFocus(c,t){const u=!(0,C.$ub)(this.s,c);this.s=c;const s=this.t!==t;this.t=t,u&&this.y.fire(Object.freeze({selection:this.selectedElements})),s&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(c){c!==this.r&&(this.r=c,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(c){const t=(await Promise.all(c.map(async u=>{const s=this.getExtensionElement(u.treeItemHandle);return s?{extensionItem:s,treeItem:await this.f.getTreeItem(s),newState:u.newState?y.TreeItemCheckboxState.Checked:y.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(u=>u!==void 0);t.forEach(u=>{u.treeItem.checkboxState=u.newState?y.TreeItemCheckboxState.Checked:y.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(u=>[u.extensionItem,u.newState])})}async handleDrag(c,t,u){const s=[];for(const l of c){const a=this.getExtensionElement(l);a&&s.push(a)}if(!(!this.g?.handleDrag||s.length===0))return await this.g.handleDrag(s,t,u),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(c,t,u){const s=t?this.getExtensionElement(t):void 0;if(!(!s&&t||!this.g?.handleDrop))return(0,$.$Yg)(()=>this.g?.handleDrop?this.g.handleDrop(s,c,u):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(c,t){if(!this.f.resolveTreeItem)return;const u=this.j.get(c);if(u){const s=this.m.get(u);if(s){const l=await this.f.resolveTreeItem(s.extensionItem,u,t)??s.extensionItem;return this.hb(l),s.item.tooltip=this.eb(l.tooltip),s.item.command=this.fb(s.disposableStore,l.command),s.item}}}S(c){return this.U(c).then(t=>t?this.S(t).then(u=>this.W(t,u[u.length-1]).then(s=>(u.push(s),u))):Promise.resolve([]))}U(c){const t=this.m.get(c);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,$.$Yg)(()=>this.f.getParent(c))}W(c,t){const u=this.m.get(c);return u?Promise.resolve(u):(0,$.$Yg)(()=>this.f.getTreeItem(c)).then(s=>this.kb(c,s,t,!0)).then(s=>this.getChildren(t?t.item.handle:void 0).then(()=>{const l=this.getExtensionElement(s);if(l){const a=this.m.get(l);if(a)return Promise.resolve(a)}throw new Error(`Cannot resolve tree item for element ${s} from extension ${this.N.identifier.value}`)}))}X(c){if(c){let t;if(typeof c=="string"){const u=this.getExtensionElement(c);t=u?this.m.get(u):void 0}else t=c;return t&&t.children||void 0}return this.h}async Y(c){this.rb(c);const t=new S.$6d(this.Z.token);try{const u=c?this.m.get(c):void 0,s=await this.f.getChildren(c);if(t.token.isCancellationRequested)return;const l=(0,C.$Hb)(s||[]),a=await Promise.all((0,C.$Hb)(l).map(k=>this.f.getTreeItem(k)));if(t.token.isCancellationRequested)return;const d=a.map((k,R)=>k?this.db(l[R],k,u):null);return(0,C.$Hb)(d)}finally{t.dispose()}}$(c){if(c.some(u=>!u))return this.Z.dispose(!0),this.Z=new S.$6d,this.tb(),this.J.$refresh(this.I);{const u=this.ab(c);if(u.length)return this.bb(u)}return Promise.resolve(void 0)}ab(c){const t=new Set,u=c.map(l=>this.m.get(l));for(const l of u)if(l&&!t.has(l.item.handle)){let a=l;for(;a&&a.parent&&u.findIndex(d=>a&&a.parent&&d&&d.item.handle===a.parent.item.handle)===-1;){const d=this.j.get(a.parent.item.handle);a=d?this.m.get(d):void 0}a&&!a.parent&&t.add(l.item.handle)}const s=[];return t.forEach(l=>{const a=this.j.get(l);if(a){const d=this.m.get(a);d&&(!d.parent||!t.has(d.parent.item.handle))&&s.push(l)}}),s}bb(c){const t={};return Promise.all(c.map(u=>this.cb(u).then(s=>{s&&(t[u]=s.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(c){const t=this.getExtensionElement(c);if(t){const u=this.m.get(t);if(u)return this.rb(t),(0,$.$Yg)(()=>this.f.getTreeItem(t)).then(s=>{if(s){const l=this.ib(t,s,u.parent);return this.pb(t,l,u,u.parent),u.dispose(),l}return null})}return Promise.resolve(null)}db(c,t,u){const s=this.ib(c,t,u);if(t.id&&this.j.has(s.item.handle))throw new Error((0,D.localize)(0,null,t.id));return this.ob(c,s),this.qb(s,u),s}eb(c){return y.$wL.isMarkdownString(c)?m.MarkdownString.from(c):c}fb(c,t){return t?{...this.L.toInternal(t,c),originalId:t.command}:void 0}gb(c){if(c.checkboxState===void 0)return;let t,u,s;return typeof c.checkboxState=="number"?t=c.checkboxState:(t=c.checkboxState.state,u=c.checkboxState.tooltip,s=c.checkboxState.accessibilityInformation),{isChecked:t===y.TreeItemCheckboxState.Checked,tooltip:u,accessibilityInformation:s}}hb(c){if(!y.$UL.isTreeItem(c,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(c,t,u){this.hb(t);const s=this.B(new A.$Sc),l=this.kb(c,t,u),a=this.lb(t);return{item:{handle:l,parentHandle:u?u.item.handle:void 0,label:o(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(s,t.command),contextValue:t.contextValue,icon:a,iconDark:this.mb(t)||a,themeIcon:this.jb(t),collapsibleState:(0,L.$Rf)(t.collapsibleState)?y.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:u,children:void 0,disposableStore:s,dispose(){s.dispose()}}}jb(c){return c.iconPath instanceof y.$3L?c.iconPath:void 0}kb(c,{id:t,label:u,resourceUri:s},l,a){if(t)return`${r.b}/${t}`;const d=o(u,this.N),k=l?l.item.handle:r.a;let R=d?d.label:s?(0,O.$Eg)(s):"";R=R.indexOf("/")!==-1?R.replace("/","//"):R;const v=this.m.has(c)?this.m.get(c).item.handle:void 0,w=this.X(l)||[];let E,P=0;do{if(E=`${k}/${P}:${R}`,a||!this.j.has(E)||v===E)break;P++}while(P<=w.length);return E}lb(c){if(c.iconPath&&!(c.iconPath instanceof y.$3L))return typeof c.iconPath=="string"||g.URI.isUri(c.iconPath)?this.nb(c.iconPath):this.nb(c.iconPath.light)}mb(c){if(c.iconPath&&!(c.iconPath instanceof y.$3L)&&c.iconPath.dark)return this.nb(c.iconPath.dark)}nb(c){return g.URI.isUri(c)?c:g.URI.file(c)}ob(c,t){this.j.set(t.item.handle,c),this.m.set(c,t)}pb(c,t,u,s){this.j.delete(t.item.handle),this.m.delete(c),t.item.handle!==u.item.handle&&this.j.delete(u.item.handle),this.ob(c,t);const l=this.X(s)||[],a=l.filter(d=>d.item.handle===u.item.handle)[0];a&&l.splice(l.indexOf(a),1,t)}qb(c,t){t?(t.children||(t.children=[]),t.children.push(c)):(this.h||(this.h=[]),this.h.push(c))}rb(c){if(c){const t=this.m.get(c);if(t){if(t.children)for(const u of t.children){const s=this.j.get(u.item.handle);s&&this.sb(s)}t.children=void 0}}else this.tb()}sb(c){const t=this.m.get(c);if(t){if(t.children)for(const u of t.children){const s=this.j.get(u.item.handle);s&&this.sb(s)}this.m.delete(c),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(c=>c.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(ke[299],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2.d.ts",chatAgents2Additions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2Additions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",defaultChatAgent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatAgent.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",testingActiveProfile:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testingActiveProfile.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(ke[300],Se([1,0,233,14,39,134,108,37,26,299,136,137]),function(me,e,D,O,g,I,A,b,$,y,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vF=e.$uF=e.$tF=e.$sF=e.$rF=e.$qF=void 0;const m=b.$Hn.as(A.$In.JSONContribution);class p{constructor(c,t,u){this.a=c,this.b=t,this.c=u}d(c,t){this.a({type:c,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(c){this.d(g.default.Error,c)}warn(c){this.d(g.default.Warning,c)}info(c){this.d(g.default.Info,c)}}e.$qF=p;class S{static a(c){const t=new $.$mm;for(let u=0,s=c.length;u<s;u++)t.add(c[u].description.identifier);return t}static compute(c,t){if(!c||!c.length)return new S(t,[]);if(!t||!t.length)return new S([],c);const u=this.a(c),s=this.a(t),l=t.filter(d=>!u.has(d.description.identifier)),a=c.filter(d=>!s.has(d.description.identifier));return new S(l,a)}constructor(c,t){this.added=c,this.removed=t}}e.$rF=S;class h{constructor(c,t){this.name=c,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(c){if(this.a!==null)throw new Error("Handler already set!");this.a=c,this.d()}acceptUsers(c){this.c=S.compute(this.b,c),this.b=c,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(c){(0,O.$1)(c)}}}e.$sF=h;const f={type:"string",enum:["ui","workspace"],enumDescriptions:[D.localize(0,null),D.localize(1,null)]},o="vscode://schemas/vscode-extensions";e.$tF={properties:{engines:{type:"object",description:D.localize(2,null),properties:{vscode:{type:"string",description:D.localize(3,null),default:"^1.22.0"}}},publisher:{description:D.localize(4,null),type:"string"},displayName:{description:D.localize(5,null),type:"string"},categories:{description:D.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:$.$km},{type:"string",const:"Languages",deprecationMessage:D.localize(7,null)}]}},galleryBanner:{type:"object",description:D.localize(8,null),properties:{color:{description:D.localize(9,null),type:"string"},theme:{description:D.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:D.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:D.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:D.localize(13,null)},enabledApiProposals:{markdownDescription:D.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(y.allApiProposals),markdownEnumDescriptions:Object.values(y.allApiProposals)}},api:{markdownDescription:D.localize(15,null),type:"string",enum:["none"],enumDescriptions:[D.localize(16,null)]},activationEvents:{description:D.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:D.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:D.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:D.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:D.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:D.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:D.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:D.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:D.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:D.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:D.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:D.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:D.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:D.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:D.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:D.localize(32,null)},{label:"onUri",body:"onUri",description:D.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:D.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:D.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:D.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:D.localize(37,null)},{label:"onRenderer",description:D.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:D.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:D.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:D.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:D.localize(42,null)},{label:"*",description:D.localize(43,null),body:"*"}]}},badges:{type:"array",description:D.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:D.localize(45,null)},href:{type:"string",description:D.localize(46,null)},description:{type:"string",description:D.localize(47,null)}}}},markdown:{type:"string",description:D.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:D.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:D.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:I.$mo}},extensionPack:{description:D.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:I.$mo}},extensionKind:{description:D.localize(52,null),type:"array",items:f,default:["workspace"],defaultSnippets:[{body:["ui"],description:D.localize(53,null)},{body:["workspace"],description:D.localize(54,null)},{body:["ui","workspace"],description:D.localize(55,null)},{body:["workspace","ui"],description:D.localize(56,null)},{body:[],description:D.localize(57,null)}]},capabilities:{description:D.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:D.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:D.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[D.localize(61,null),D.localize(62,null),D.localize(63,null)]},description:{type:"string",markdownDescription:D.localize(64,null)}}},untrustedWorkspaces:{description:D.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:D.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[D.localize(67,null),D.localize(68,null),D.localize(69,null)]},restrictedConfigurations:{description:D.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:D.localize(71,null)}}}}},sponsor:{description:D.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:D.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:D.localize(74,null),type:"string"},"vscode:uninstall":{description:D.localize(75,null),type:"string"}}},icon:{type:"string",description:D.localize(76,null)},l10n:{type:"string",description:D.localize(77,null)},pricing:{type:"string",markdownDescription:D.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class i{constructor(){this.a=new Map}registerExtensionPoint(c){if(this.a.has(c.extensionPoint))throw new Error("Duplicate extension point: "+c.extensionPoint);const t=new h(c.extensionPoint,c.defaultExtensionKind);return this.a.set(c.extensionPoint,t),c.activationEventsGenerator&&C.$hF.register(c.extensionPoint,c.activationEventsGenerator),e.$tF.properties.contributes.properties[c.extensionPoint]=c.jsonSchema,m.registerSchema(o,e.$tF),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$uF=i;const r={ExtensionsRegistry:"ExtensionsRegistry"};b.$Hn.add(r.ExtensionsRegistry,new i),e.$vF=b.$Hn.as(r.ExtensionsRegistry),m.registerSchema(o,e.$tF),m.registerSchema(L.$Gj,{properties:{extensionEnabledApiProposals:{description:D.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(y.allApiProposals),markdownEnumDescriptions:Object.values(y.allApiProposals)}}]}}}})}),define(ke[301],Se([1,0,229,18,24,300,45,4]),function(me,e,D,O,g,I,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xG=void 0;const $={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:D.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:D.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:D.localize(2,null),default:""}}};var y;(function(m){function p(S,h,f){if(!S)return;const o=O.$If(S.type)?S.type:void 0;if(!o||o.length===0){f.error(D.localize(3,null));return}const i=[];if(Array.isArray(S.required))for(const r of S.required)O.$If(r)&&i.push(r);return{extensionId:h.value,taskType:o,required:i,properties:S.properties?g.$vn(S.properties):{},when:S.when?A.$4i.deserialize(S.when):void 0}}m.from=p})(y||(y={}));const L=I.$vF.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(m,p)=>{for(const S of m)S.type&&p.push(`onTaskType:${S.type}`)},jsonSchema:{description:D.localize(4,null),type:"array",items:$}});class C{constructor(){this.d=new b.$Vd,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((p,S)=>{L.setHandler((h,f)=>{this.c=void 0;try{for(const o of f.removed){const i=o.value;for(const r of i)this.a&&r.type&&this.a[r.type]&&delete this.a[r.type]}for(const o of f.added){const i=o.value;for(const r of i){const n=y.from(r,o.description.identifier,o.collector);n&&(this.a[n.taskType]=n)}}(f.removed.length>0||f.added.length>0)&&this.d.fire()}catch{}p(void 0)})})}onReady(){return this.b}get(p){return this.a[p]}all(){return Object.keys(this.a).map(p=>this.a[p])}getJsonSchema(){if(this.c===void 0){const p=[];for(const S of this.all()){const h={type:"object",additionalProperties:!1};S.required.length>0&&(h.required=S.required.slice(0)),S.properties!==void 0?h.properties=g.$vn(S.properties):h.properties=Object.create(null),h.properties.type={type:"string",enum:[S.taskType]},p.push(h)}this.c={oneOf:p}}return this.c}}e.$xG=new C}),define(ke[302],Se([1,0,230,18,23,24,45,301]),function(me,e,D,O,g,I,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$HG=e.JsonSchemaVersion=e.ExecutionEngine=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$BG=e.ShellQuoting=e.$AG=e.$zG=e.$yG=void 0,e.$yG="settings",e.$zG=new A.$kj("taskRunning",!1,D.localize(0,null)),e.$AG={value:D.localize(1,null),original:"Tasks"};var $;(function(T){T[T.Escape=1]="Escape",T[T.Strong=2]="Strong",T[T.Weak=3]="Weak"})($||(e.ShellQuoting=$={})),e.$BG="$customized",function(T){function M(B){if(!B)return T.Strong;switch(B.toLowerCase()){case"escape":return T.Escape;case"strong":return T.Strong;case"weak":return T.Weak;default:return T.Strong}}T.from=M}($||(e.ShellQuoting=$={}));var y;(function(T){T.defaults={cwd:"${workspaceFolder}"}})(y||(e.CommandOptions=y={}));var L;(function(T){T[T.Always=1]="Always",T[T.Silent=2]="Silent",T[T.Never=3]="Never"})(L||(e.RevealKind=L={})),function(T){function M(B){switch(B.toLowerCase()){case"always":return T.Always;case"silent":return T.Silent;case"never":return T.Never;default:return T.Always}}T.fromString=M}(L||(e.RevealKind=L={}));var C;(function(T){T[T.Never=1]="Never",T[T.OnProblem=2]="OnProblem",T[T.Always=3]="Always"})(C||(e.RevealProblemKind=C={})),function(T){function M(B){switch(B.toLowerCase()){case"always":return T.Always;case"never":return T.Never;case"onproblem":return T.OnProblem;default:return T.OnProblem}}T.fromString=M}(C||(e.RevealProblemKind=C={}));var m;(function(T){T[T.Shared=1]="Shared",T[T.Dedicated=2]="Dedicated",T[T.New=3]="New"})(m||(e.PanelKind=m={})),function(T){function M(B){switch(B.toLowerCase()){case"shared":return T.Shared;case"dedicated":return T.Dedicated;case"new":return T.New;default:return T.Shared}}T.fromString=M}(m||(e.PanelKind=m={}));var p;(function(T){T.defaults={echo:!0,reveal:L.Always,revealProblems:C.Never,focus:!1,panel:m.Shared,showReuseMessage:!0,clear:!1}})(p||(e.PresentationOptions=p={}));var S;(function(T){T[T.Shell=1]="Shell",T[T.Process=2]="Process",T[T.CustomExecution=3]="CustomExecution"})(S||(e.RuntimeType=S={})),function(T){function M(Y){switch(Y.toLowerCase()){case"shell":return T.Shell;case"process":return T.Process;case"customExecution":return T.CustomExecution;default:return T.Process}}T.fromString=M;function B(Y){switch(Y){case T.Shell:return"shell";case T.Process:return"process";case T.CustomExecution:return"customExecution";default:return"process"}}T.toString=B}(S||(e.RuntimeType=S={}));var h;(function(T){function M(B){return O.$If(B)?B:B.value}T.value=M})(h||(e.CommandString=h={}));var f;(function(T){T.Clean={_id:"clean",isDefault:!1},T.Build={_id:"build",isDefault:!1},T.Rebuild={_id:"rebuild",isDefault:!1},T.Test={_id:"test",isDefault:!1};function M(Y){return Y===T.Clean._id||Y===T.Build._id||Y===T.Rebuild._id||Y===T.Test._id}T.is=M;function B(Y){if(Y!==void 0)return O.$If(Y)?M(Y)?{_id:Y,isDefault:!1}:void 0:Y}T.from=B})(f||(e.TaskGroup=f={}));var o;(function(T){T[T.Global=1]="Global",T[T.Workspace=2]="Workspace",T[T.Folder=3]="Folder"})(o||(e.TaskScope=o={}));var i;(function(T){T.Workspace="workspace",T.Extension="extension",T.InMemory="inMemory",T.WorkspaceFile="workspaceFile",T.User="user";function M(B){switch(B){case T.User:return 2;case T.WorkspaceFile:return 5;default:return 6}}T.toConfigurationTarget=M})(i||(e.TaskSourceKind=i={}));var r;(function(T){T.parallel="parallel",T.sequence="sequence"})(r||(e.DependsOrder=r={}));var n;(function(T){T[T.default=1]="default",T[T.folderOpen=2]="folderOpen"})(n||(e.RunOnOptions=n={}));var c;(function(T){T.defaults={reevaluateOnRerun:!0,runOn:n.default,instanceLimit:1}})(c||(e.RunOptions=c={}));class t{constructor(M,B,Y,ue,Z,J){this._label="",this._id=M,B&&(this._label=B),Y&&(this.type=Y),this.runOptions=ue,this.configurationProperties=Z,this._source=J}getDefinition(M){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const M={folder:this.d(),id:this._id};return JSON.stringify(M)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(M,B=!1){if(M===void 0)return!1;if(O.$If(M))return M===this._label||M===this.configurationProperties.identifier||B&&M===this._id;const Y=this.getDefinition(!0);return Y!==void 0&&Y._key===M._key}getQualifiedLabel(){const M=this.getWorkspaceFolder();return M?`${this._label} (${M.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(M){this.c===void 0&&(this.c=[]),M&&(this.c=this.c.concat(M))}get taskLoadMessages(){return this.c}}e.$CG=t;class u extends t{constructor(M,B,Y,ue,Z,J,X,he){super(M,Y,void 0,X,he,B),this.command={},this._source=B,this.hasDefinedMatchers=J,Z&&(this.command=Z)}clone(){return new u(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(M=!1){if(M&&this._source.customizes!==void 0)return this._source.customizes;{let B;switch(this.command?this.command.runtime:void 0){case S.Shell:B="shell";break;case S.Process:B="process";break;case S.CustomExecution:B="customExecution";break;case void 0:B="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:B,_key:this._id,id:this._id}}}static is(M){return M instanceof u}getMapKey(){const M=this._source.config.workspaceFolder;return M?`${M.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===i.User?e.$yG:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const M=this.d();if(!M)return;let B=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(B+=this._source.kind);const Y={type:e.$BG,folder:M,id:B};return JSON.stringify(Y)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?g.$Eg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(M){return new u(M._id,M._source,M._label,M.type,M.command,M.hasDefinedMatchers,M.runOptions,M.configurationProperties)}}e.$DG=u;class s extends t{constructor(M,B,Y,ue,Z,J,X){super(M,Y,ue,J,X,B),this._source=B,this.configures=Z}static is(M){return M instanceof s}f(M){return M}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?g.$Eg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===i.User?e.$yG:this._source.config.workspaceFolder?.uri.toString()}getKey(){const M=this.d();if(!M)return;let B=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(B+=this._source.kind);const Y={type:e.$BG,folder:M,id:B};return JSON.stringify(Y)}}e.$EG=s;class l extends t{constructor(M,B,Y,ue,Z,J,X,he,_){super(M,Y,ue,he,_,B),this.defines=Z,this.hasDefinedMatchers=X,this.command=J,this.icon=_.icon,this.hide=_.hide}clone(){return new l(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(M){return M instanceof l}getMapKey(){const M=this._source.workspaceFolder;return M?`${this._source.scope.toString()}|${M.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const M={type:"contributed",scope:this._source.scope,id:this._id};return M.folder=this.d(),JSON.stringify(M)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(M){return new l(M._id,M._source,M._label,M.type,M.defines,M.command,M.hasDefinedMatchers,M.runOptions,M.configurationProperties)}}e.$FG=l;class a extends t{constructor(M,B,Y,ue,Z,J){super(M,Y,ue,Z,J,B),this._source=B}clone(){return new a(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(M){return M instanceof a}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(M){return new a(M._id,M._source,M._label,M.type,M.runOptions,M.configurationProperties)}}e.$GG=a;var d;(function(T){T[T.Process=1]="Process",T[T.Terminal=2]="Terminal"})(d||(e.ExecutionEngine=d={})),function(T){T._default=T.Terminal}(d||(e.ExecutionEngine=d={}));var k;(function(T){T[T.V0_1_0=1]="V0_1_0",T[T.V2_0_0=2]="V2_0_0"})(k||(e.JsonSchemaVersion=k={}));class R{constructor(M){this.c=new Map;for(let B=0;B<M.length;B++)this.c.set(M[B].uri.toString(),B)}compare(M,B){const Y=M.getWorkspaceFolder(),ue=B.getWorkspaceFolder();if(Y&&ue){let Z=this.c.get(Y.uri.toString());Z=Z===void 0?0:Z+1;let J=this.c.get(ue.uri.toString());return J=J===void 0?0:J+1,Z===J?M._label.localeCompare(B._label):Z-J}else return!Y&&ue?-1:Y&&!ue?1:0}}e.$HG=R;var v;(function(T){T.DependsOnStarted="dependsOnStarted",T.AcquiredInput="acquiredInput",T.Start="start",T.ProcessStarted="processStarted",T.Active="active",T.Inactive="inactive",T.Changed="changed",T.Terminated="terminated",T.ProcessEnded="processEnded",T.End="end"})(v||(e.TaskEventKind=v={}));var w;(function(T){T.SingleRun="singleRun",T.Background="background"})(w||(e.TaskRunType=w={}));var E;(function(T){T[T.System=0]="System",T[T.User=1]="User",T[T.FolderOpen=2]="FolderOpen",T[T.ConfigurationChange=3]="ConfigurationChange",T[T.Reconnect=4]="Reconnect"})(E||(e.TaskRunSource=E={}));var P;(function(T){function M(he){return{taskId:he._id,taskName:he.configurationProperties.name,runType:he.configurationProperties.isBackground?"background":"singleRun",group:he.configurationProperties.group,__task:he}}function B(he,_,we){return{...M(he),kind:"start",terminalId:_,resolvedVariables:we}}T.start=B;function Y(he,_,we){return{...M(he),kind:"processStarted",terminalId:_,processId:we}}T.processStarted=Y;function ue(he,_,we){return{...M(he),kind:"processEnded",terminalId:_,exitCode:we}}T.processEnded=ue;function Z(he,_,we){return{...M(he),kind:"terminated",exitReason:we,terminalId:_}}T.terminated=Z;function J(he,_,we){return{...M(_),kind:he,terminalId:we}}T.general=J;function X(){return{kind:"changed"}}T.changed=X})(P||(e.TaskEvent=P={}));var N;(function(T){function M(Y){const ue=Object.keys(Y).sort();let Z="";for(const J of ue){let X=Y[J];X instanceof Object?X=M(X):typeof X=="string"&&(X=X.replace(/,/g,",,")),Z+=J+","+X+","}return Z}function B(Y){const Z={_key:M(Y),type:Y.taskType};return Object.assign(Z,Y),Z}T.create=B})(N||(e.KeyedTaskIdentifier=N={}));var U;(function(T){T.AutoDetect="task.autoDetect",T.SaveBeforeRun="task.saveBeforeRun",T.ShowDecorations="task.showDecorations",T.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",T.SlowProviderWarning="task.slowProviderWarning",T.QuickOpenHistory="task.quickOpen.history",T.QuickOpenDetail="task.quickOpen.detail",T.QuickOpenSkip="task.quickOpen.skip",T.QuickOpenShowAll="task.quickOpen.showAll",T.AllowAutomaticTasks="task.allowAutomaticTasks",T.Reconnection="task.reconnection",T.VerboseLogging="task.verboseLogging"})(U||(e.TaskSettingId=U={}));var F;(function(T){T.Tasks="tasks",T.SuppressTaskName="tasks.suppressTaskName",T.Windows="tasks.windows",T.Osx="tasks.osx",T.Linux="tasks.linux",T.ShowOutput="tasks.showOutput",T.IsShellCommand="tasks.isShellCommand",T.ServiceTestSetting="tasks.service.testSetting"})(F||(e.TasksSchemaProperties=F={}));var j;(function(T){function M(B,Y){const ue=b.$xG.get(B.type);if(ue===void 0){const he=I.$vn(B);return delete he._key,N.create(he)}const Z=Object.create(null);Z.type=ue.taskType;const J=new Set;ue.required.forEach(he=>J.add(he));const X=ue.properties;for(const he of Object.keys(X)){const _=B[he];if(_!=null)Z[he]=_;else if(J.has(he)){const we=X[he];if(we.default!==void 0)Z[he]=I.$vn(we.default);else switch(we.type){case"boolean":Z[he]=!1;break;case"number":case"integer":Z[he]=0;break;case"string":Z[he]="";break;default:Y.error(D.localize(2,null,JSON.stringify(B,void 0,0),he));return}}}return N.create(Z)}T.createTaskIdentifier=M})(j||(e.TaskDefinition=j={}))}),define(ke[303],Se([1,0,14]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$m8b=e.$l8b=void 0;class O{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((A,b)=>{this.b=A,this.d=b,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(A){this.f||this.h||(this.f=!0,this.g=A,this.a&&this.b(A))}resolveErr(A){this.f||this.h||(this.h=!0,this.i=A,this.a?this.d(A):(0,D.$1)(A))}then(A,b){return this.j().then(A,b)}catch(A){return this.j().then(void 0,A)}finally(A){return this.j().finally(A)}}e.$l8b=O;class g extends O{constructor(){super(),this.h=!0,this.i=new D.$5}}e.$m8b=g}),define(ke[68],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tv=e.$Sv=e.$Rv=e.$Qv=void 0;class D{static{this.count=0}constructor($){this._proxyIdentifierBrand=void 0,this.sid=$,this.nid=++D.count}}e.$Qv=D;const O=[];function g(b){const $=new D(b);return O[$.nid]=$,$}e.$Rv=g;function I(b){return O[b].sid}e.$Sv=I;class A{constructor($){this.value=$}}e.$Tv=A}),define(ke[6],Se([1,0,68]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7K=e.$6K=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$5K=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var O;(function(h){h[h.Default=0]="Default",h[h.InCenter=1]="InCenter",h[h.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",h[h.AtTop=3]="AtTop"})(O||(e.TextEditorRevealType=O={}));var g;(function(h){h[h.UnknownInput=0]="UnknownInput",h[h.TextInput=1]="TextInput",h[h.TextDiffInput=2]="TextDiffInput",h[h.TextMergeInput=3]="TextMergeInput",h[h.NotebookInput=4]="NotebookInput",h[h.NotebookDiffInput=5]="NotebookDiffInput",h[h.CustomEditorInput=6]="CustomEditorInput",h[h.WebviewEditorInput=7]="WebviewEditorInput",h[h.TerminalEditorInput=8]="TerminalEditorInput",h[h.InteractiveEditorInput=9]="InteractiveEditorInput",h[h.ChatEditorInput=10]="ChatEditorInput"})(g||(e.TabInputKind=g={}));var I;(function(h){h[h.TAB_OPEN=0]="TAB_OPEN",h[h.TAB_CLOSE=1]="TAB_CLOSE",h[h.TAB_UPDATE=2]="TAB_UPDATE",h[h.TAB_MOVE=3]="TAB_MOVE"})(I||(e.TabModelOperationKind=I={}));var A;(function(h){h[h.Editable=0]="Editable",h[h.SupportsHotExit=1]="SupportsHotExit"})(A||(e.WebviewEditorCapabilities=A={}));var b;(function(h){h[h.Int8Array=1]="Int8Array",h[h.Uint8Array=2]="Uint8Array",h[h.Uint8ClampedArray=3]="Uint8ClampedArray",h[h.Int16Array=4]="Int16Array",h[h.Uint16Array=5]="Uint16Array",h[h.Int32Array=6]="Int32Array",h[h.Uint32Array=7]="Uint32Array",h[h.Float32Array=8]="Float32Array",h[h.Float64Array=9]="Float64Array",h[h.BigInt64Array=10]="BigInt64Array",h[h.BigUint64Array=11]="BigUint64Array"})(b||(e.WebviewMessageArrayBufferViewType=b={}));var $;(function(h){h[h.Text=1]="Text",h[h.Error=2]="Error",h[h.Rich=3]="Rich"})($||(e.CellOutputKind=$={}));var y;(function(h){h[h.Default=0]="Default",h[h.InCenter=1]="InCenter",h[h.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",h[h.AtTop=3]="AtTop"})(y||(e.NotebookEditorRevealType=y={}));var L;(function(h){h[h.None=0]="None",h[h.Process=1]="Process",h[h.Output=2]="Output"})(L||(e.CandidatePortSource=L={}));class C{static{this.a=0}static mixin(f){return f._id=C.a++,f}}e.$5K=C;var m;(function(h){h.label="a",h.kind="b",h.detail="c",h.documentation="d",h.sortText="e",h.filterText="f",h.preselect="g",h.insertText="h",h.insertTextRules="i",h.range="j",h.commitCharacters="k",h.additionalTextEdits="l",h.kindModifier="m",h.commandIdent="n",h.commandId="o",h.commandArguments="p"})(m||(e.ISuggestDataDtoField=m={}));var p;(function(h){h.defaultRanges="a",h.completions="b",h.isIncomplete="c",h.duration="d"})(p||(e.ISuggestResultDtoField=p={}));var S;(function(h){h[h.Workspace=0]="Workspace",h[h.TextDocument=1]="TextDocument"})(S||(e.ExtHostTestingResource=S={})),e.$6K={MainThreadAuthentication:(0,D.$Rv)("MainThreadAuthentication"),MainThreadBulkEdits:(0,D.$Rv)("MainThreadBulkEdits"),MainThreadChatProvider:(0,D.$Rv)("MainThreadChatProvider"),MainThreadChatAgents2:(0,D.$Rv)("MainThreadChatAgents2"),MainThreadChatVariables:(0,D.$Rv)("MainThreadChatVariables"),MainThreadClipboard:(0,D.$Rv)("MainThreadClipboard"),MainThreadCommands:(0,D.$Rv)("MainThreadCommands"),MainThreadComments:(0,D.$Rv)("MainThreadComments"),MainThreadConfiguration:(0,D.$Rv)("MainThreadConfiguration"),MainThreadConsole:(0,D.$Rv)("MainThreadConsole"),MainThreadDebugService:(0,D.$Rv)("MainThreadDebugService"),MainThreadDecorations:(0,D.$Rv)("MainThreadDecorations"),MainThreadDiagnostics:(0,D.$Rv)("MainThreadDiagnostics"),MainThreadDialogs:(0,D.$Rv)("MainThreadDiaglogs"),MainThreadDocuments:(0,D.$Rv)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,D.$Rv)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,D.$Rv)("MainThreadTextEditors"),MainThreadEditorInsets:(0,D.$Rv)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,D.$Rv)("MainThreadEditorTabs"),MainThreadErrors:(0,D.$Rv)("MainThreadErrors"),MainThreadTreeViews:(0,D.$Rv)("MainThreadTreeViews"),MainThreadDownloadService:(0,D.$Rv)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,D.$Rv)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,D.$Rv)("MainThreadLanguages"),MainThreadLogger:(0,D.$Rv)("MainThreadLogger"),MainThreadMessageService:(0,D.$Rv)("MainThreadMessageService"),MainThreadOutputService:(0,D.$Rv)("MainThreadOutputService"),MainThreadProgress:(0,D.$Rv)("MainThreadProgress"),MainThreadQuickDiff:(0,D.$Rv)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,D.$Rv)("MainThreadQuickOpen"),MainThreadStatusBar:(0,D.$Rv)("MainThreadStatusBar"),MainThreadSecretState:(0,D.$Rv)("MainThreadSecretState"),MainThreadStorage:(0,D.$Rv)("MainThreadStorage"),MainThreadSpeech:(0,D.$Rv)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,D.$Rv)("MainThreadTelemetry"),MainThreadTerminalService:(0,D.$Rv)("MainThreadTerminalService"),MainThreadWebviews:(0,D.$Rv)("MainThreadWebviews"),MainThreadWebviewPanels:(0,D.$Rv)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,D.$Rv)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,D.$Rv)("MainThreadCustomEditors"),MainThreadUrls:(0,D.$Rv)("MainThreadUrls"),MainThreadUriOpeners:(0,D.$Rv)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,D.$Rv)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,D.$Rv)("MainThreadWorkspace"),MainThreadFileSystem:(0,D.$Rv)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,D.$Rv)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,D.$Rv)("MainThreadExtensionService"),MainThreadSCM:(0,D.$Rv)("MainThreadSCM"),MainThreadSearch:(0,D.$Rv)("MainThreadSearch"),MainThreadShare:(0,D.$Rv)("MainThreadShare"),MainThreadTask:(0,D.$Rv)("MainThreadTask"),MainThreadWindow:(0,D.$Rv)("MainThreadWindow"),MainThreadLabelService:(0,D.$Rv)("MainThreadLabelService"),MainThreadNotebook:(0,D.$Rv)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,D.$Rv)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,D.$Rv)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,D.$Rv)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,D.$Rv)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,D.$Rv)("MainThreadInteractive"),MainThreadChat:(0,D.$Rv)("MainThreadChat"),MainThreadInlineChat:(0,D.$Rv)("MainThreadInlineChatShape"),MainThreadTheming:(0,D.$Rv)("MainThreadTheming"),MainThreadTunnelService:(0,D.$Rv)("MainThreadTunnelService"),MainThreadManagedSockets:(0,D.$Rv)("MainThreadManagedSockets"),MainThreadTimeline:(0,D.$Rv)("MainThreadTimeline"),MainThreadTesting:(0,D.$Rv)("MainThreadTesting"),MainThreadLocalization:(0,D.$Rv)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,D.$Rv)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,D.$Rv)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,D.$Rv)("MainThreadIssueReporter")},e.$7K={ExtHostCommands:(0,D.$Rv)("ExtHostCommands"),ExtHostConfiguration:(0,D.$Rv)("ExtHostConfiguration"),ExtHostDiagnostics:(0,D.$Rv)("ExtHostDiagnostics"),ExtHostDebugService:(0,D.$Rv)("ExtHostDebugService"),ExtHostDecorations:(0,D.$Rv)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,D.$Rv)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,D.$Rv)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,D.$Rv)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,D.$Rv)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,D.$Rv)("ExtHostEditors"),ExtHostTreeViews:(0,D.$Rv)("ExtHostTreeViews"),ExtHostFileSystem:(0,D.$Rv)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,D.$Rv)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,D.$Rv)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,D.$Rv)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,D.$Rv)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,D.$Rv)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,D.$Rv)("ExtHostQuickDiff"),ExtHostStatusBar:(0,D.$Rv)("ExtHostStatusBar"),ExtHostShare:(0,D.$Rv)("ExtHostShare"),ExtHostExtensionService:(0,D.$Rv)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,D.$Rv)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,D.$Rv)("ExtHostTerminalService"),ExtHostSCM:(0,D.$Rv)("ExtHostSCM"),ExtHostSearch:(0,D.$Rv)("ExtHostSearch"),ExtHostTask:(0,D.$Rv)("ExtHostTask"),ExtHostWorkspace:(0,D.$Rv)("ExtHostWorkspace"),ExtHostWindow:(0,D.$Rv)("ExtHostWindow"),ExtHostWebviews:(0,D.$Rv)("ExtHostWebviews"),ExtHostWebviewPanels:(0,D.$Rv)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,D.$Rv)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,D.$Rv)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,D.$Rv)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,D.$Rv)("ExtHostEditorTabs"),ExtHostProgress:(0,D.$Rv)("ExtHostProgress"),ExtHostComments:(0,D.$Rv)("ExtHostComments"),ExtHostSecretState:(0,D.$Rv)("ExtHostSecretState"),ExtHostStorage:(0,D.$Rv)("ExtHostStorage"),ExtHostUrls:(0,D.$Rv)("ExtHostUrls"),ExtHostUriOpeners:(0,D.$Rv)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,D.$Rv)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,D.$Rv)("ExtHostOutputService"),ExtHostLabelService:(0,D.$Rv)("ExtHostLabelService"),ExtHostNotebook:(0,D.$Rv)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,D.$Rv)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,D.$Rv)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,D.$Rv)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,D.$Rv)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,D.$Rv)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,D.$Rv)("ExtHostInteractive"),ExtHostInlineChat:(0,D.$Rv)("ExtHostInlineChatShape"),ExtHostChat:(0,D.$Rv)("ExtHostChat"),ExtHostChatAgents2:(0,D.$Rv)("ExtHostChatAgents"),ExtHostChatVariables:(0,D.$Rv)("ExtHostChatVariables"),ExtHostChatProvider:(0,D.$Rv)("ExtHostChatProvider"),ExtHostSpeech:(0,D.$Rv)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,D.$Rv)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,D.$Rv)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,D.$Rv)("ExtHostTheming"),ExtHostTunnelService:(0,D.$Rv)("ExtHostTunnelService"),ExtHostManagedSockets:(0,D.$Rv)("ExtHostManagedSockets"),ExtHostAuthentication:(0,D.$Rv)("ExtHostAuthentication"),ExtHostTimeline:(0,D.$Rv)("ExtHostTimeline"),ExtHostTesting:(0,D.$Rv)("ExtHostTesting"),ExtHostTelemetry:(0,D.$Rv)("ExtHostTelemetry"),ExtHostLocalization:(0,D.$Rv)("ExtHostLocalization"),ExtHostIssueReporter:(0,D.$Rv)("ExtHostIssueReporter")}}),define(ke[304],Se([1,0,6,7]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5fc=void 0;class g{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(D.$6K.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(A,b,$){if(this.a.size===0)throw new Error("No related information providers registered");const y=this.a.get(A);if(!y)throw new Error("related information provider not found");return await y.provideRelatedInformation(b,$)??[]}getRelatedInformation(A,b,$){return this.c.$getAiRelatedInformation(b,$)}registerRelatedInformationProvider(A,b,$){const y=this.b;return this.b++,this.a.set(y,$),this.c.$registerAiRelatedInformationProvider(y,b),new O.$8K(()=>{this.c.$unregisterAiRelatedInformationProvider(y),this.a.delete(y)})}}e.$5fc=g}),define(ke[91],Se([1,0,5,13,6,20]),function(me,e,D,O,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$agc=e.$_fc=e.$$fc=void 0,e.$$fc=(0,D.$6h)("IExtHostApiDeprecationService");let A=class{constructor($,y){this.c=y,this.a=new Set,this.b=$.getProxy(g.$6K.MainThreadTelemetry)}report($,y,L){const C=this.d($,y);this.a.has(C)||(this.a.add(C),y.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${$}' is deprecated. ${L}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:y.identifier.value,apiId:$}))}d($,y){return`${$}-${y.identifier.value}`}};e.$_fc=A,e.$_fc=A=Ge([We(0,I.$0M),We(1,O.$nj)],A),e.$agc=Object.freeze(new class{report(b,$,y){}})}),define(ke[305],Se([1,0,4,6,7,26]),function(me,e,D,O,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dgc=void 0;class A{constructor(y){this.b=new Map,this.c=new D.$Vd,this.onDidChangeSessions=this.c.event,this.d=new b,this.f=new b,this.a=y.getProxy(O.$6K.MainThreadAuthentication)}async getSession(y,L,C,m={}){const p=I.$lm.toKey(y.identifier),S=[...C].sort().join(" ");return await this.d.getOrCreate(`${p} ${L} ${S}`,async()=>{await this.a.$ensureProvider(L);const h=y.displayName||y.name;return this.a.$getSession(L,C,p,h,m)})}async getSessions(y,L,C){const m=I.$lm.toKey(y.identifier),p=[...C].sort().join(" ");return await this.f.getOrCreate(`${m} ${p}`,async()=>{await this.a.$ensureProvider(L);const S=y.displayName||y.name;return this.a.$getSessions(L,C,m,S)})}async removeSession(y,L){const C=this.b.get(y);return C?C.provider.removeSession(L):this.a.$removeSession(y,L)}registerAuthenticationProvider(y,L,C,m){if(this.b.get(y))throw new Error(`An authentication provider with id '${y}' is already registered.`);this.b.set(y,{label:L,provider:C,options:m??{supportsMultipleAccounts:!1}});const p=C.onDidChangeSessions(S=>this.a.$sendDidChangeSessions(y,S));return this.a.$registerAuthenticationProvider(y,L,m?.supportsMultipleAccounts??!1),new g.$8K(()=>{p.dispose(),this.b.delete(y),this.a.$unregisterAuthenticationProvider(y)})}$createSession(y,L,C){const m=this.b.get(y);if(m)return Promise.resolve(m.provider.createSession(L,C));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$removeSession(y,L){const C=this.b.get(y);if(C)return Promise.resolve(C.provider.removeSession(L));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$getSessions(y,L){const C=this.b.get(y);if(C)return Promise.resolve(C.provider.getSessions(L));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$onDidChangeAuthenticationSessions(y,L){return this.c.fire({provider:{id:y,label:L}}),Promise.resolve()}}e.$dgc=A;class b{constructor(){this.a=new Map}getOrCreate(y,L){const C=this.a.get(y);if(C)return C;const m=L().finally(()=>this.a.delete(y));return this.a.set(y,m),m}}}),define(ke[306],Se([1,0,6,20,15]),function(me,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$egc=void 0;let I=class{constructor(b,$){this.a=b.getProxy(D.$6K.MainThreadBulkEdits),this.b={getTextDocumentVersion:y=>$.getDocument(y)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(b,$,y){const L=g.WorkspaceEdit.from(b,this.b);return this.a.$tryApplyWorkspaceEdit(L,void 0,y?.isRefactoring??!1)}};e.$egc=I,e.$egc=I=Ge([We(0,O.$0M)],I)}),define(ke[307],Se([1,0,53,3,6,15]),function(me,e,D,O,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fgc=void 0;class A{static{this.a=0}constructor(y,L){this.extension=y,this.provider=L,this.handle=A.a++}}class b{static{this.a=0}constructor(y){this.b=new Map,this.c=new Map,this.d=y.getProxy(g.$6K.MainThreadChat)}registerChatProvider(y,L,C){const m=new A(y,C);return this.b.set(m.handle,m),this.d.$registerChatProvider(m.handle,L),(0,O.$Rc)(()=>{this.d.$unregisterChatProvider(m.handle),this.b.delete(m.handle)})}transferChatSession(y,L){const C=D.Iterable.find(this.c.keys(),m=>this.c.get(m)===y)??0;typeof C=="number"&&this.d.$transferChatSession(C,L)}sendInteractiveRequestToProvider(y,L){this.d.$sendRequestToProvider(y,L)}async $prepareChat(y,L){const C=this.b.get(y);if(!C)return;const m=await C.provider.prepareSession(L);if(!m)return;const p=b.a++;return this.c.set(p,m),{id:p,requesterUsername:m.requester?.name,requesterAvatarIconUri:m.requester?.icon,responderUsername:m.responder?.name,responderAvatarIconUri:m.responder?.icon,inputPlaceholder:m.inputPlaceholder}}async $provideWelcomeMessage(y,L){const C=this.b.get(y);if(!C||!C.provider.provideWelcomeMessage)return;const m=await C.provider.provideWelcomeMessage(L);if(m)return m.map(p=>typeof p=="string"?p:Array.isArray(p)?p.map(S=>I.ChatReplyFollowup.from(S)):I.MarkdownString.from(p))}async $provideSampleQuestions(y,L){const C=this.b.get(y);if(!C||!C.provider.provideSampleQuestions)return;const m=await C.provider.provideSampleQuestions(L);if(m)return m?.map(p=>I.ChatReplyFollowup.from(p))}$releaseSession(y){this.c.delete(y)}}e.$fgc=b}),define(ke[308],Se([1,0,11,21,44,4,38,18,2,210,85,6,15,7,279,25]),function(me,e,D,O,g,I,A,b,$,y,L,C,m,p,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hgc=void 0;class f{static{this.a=0}constructor(r,n,c){this.i=n,this.j=c,this.b=new Map,this.g=new Map,this.h=new Map,this.d=r.getProxy(C.$6K.MainThreadChatAgents2)}createChatAgent(r,n,c){const t=f.a++,u=new o(r,n,this.d,t,c);return this.b.set(t,u),this.d.$registerAgent(t,n,{}),u.apiAgent}async $invokeAgent(r,n,c,t,u,s){this.g.delete(n);const l=this.b.get(r);if(!l)throw new Error(`[CHAT](${r}) CANNOT invoke agent because the agent is not registered`);let a=!1;function d(){if(a)throw new Error("Only valid while executing the command")}const k=new D.$qh;s.onCancellationRequested(()=>k.complete()),this.i.allowListExtensionWhile(l.extension.identifier,k.p);const R=t.command?await l.validateSlashCommand(t.command):void 0,v=A.$Rd.create(!1);let w;try{const E=l.invoke({prompt:t.message,variables:m.ChatVariable.objectTo(t.variables),slashCommand:R},{history:u.history.map(m.ChatMessage.to)},new L.$vv(P=>{d(),typeof w>"u"&&"content"in P&&(w=v.elapsed());const N=m.ChatResponseProgress.from(l.extension,P);if(!N){this.j.error("Unknown progress type: "+JSON.stringify(P));return}if("placeholder"in P&&"resolvedContent"in P){const U=Promise.all([this.d.$handleProgressChunk(c,N),P.resolvedContent]);(0,D.$Ug)(U,s).then(F=>{if(!F)return;const[j,T]=F,M=m.ChatResponseProgress.from(l.extension,T);if(!M){this.j.error("Unknown progress type: "+JSON.stringify(T));return}this.d.$handleProgressChunk(c,M,j??void 0)})}else this.d.$handleProgressChunk(c,N)}),s);return await(0,D.$Ug)(Promise.resolve(E).then(P=>{if(P){this.g.set(n,P);let N=this.h.get(n);N||(N=new Map,this.h.set(n,N)),N.set(c,P);const U={firstProgress:w,totalElapsed:v.elapsed()};return{errorDetails:P.errorDetails,timings:U}}else this.g.delete(n)}),s)}catch(E){return this.j.error(E,l.extension),{errorDetails:{message:(0,y.localize)(0,null,(0,g.$Qi)(E)),responseIsIncomplete:!0}}}finally{a=!0,k.complete()}}$releaseSession(r){this.g.delete(r),this.h.delete(r)}async $provideSlashCommands(r,n){const c=this.b.get(r);return c?c.provideSlashCommand(n):[]}$provideFollowups(r,n,c){const t=this.b.get(r);if(!t)return Promise.resolve([]);const u=this.g.get(n);return u?t.provideFollowups(u,c):Promise.resolve([])}$acceptFeedback(r,n,c,t,u){const s=this.b.get(r);if(!s)return;const l=this.h.get(n)?.get(c);if(!l)return;let a;switch(t){case S.InteractiveSessionVoteDirection.Down:a=p.ChatAgentResultFeedbackKind.Unhelpful;break;case S.InteractiveSessionVoteDirection.Up:a=p.ChatAgentResultFeedbackKind.Helpful;break}s.acceptFeedback(Object.freeze(u?{result:l,kind:a,reportIssue:u}:{result:l,kind:a}))}$acceptAction(r,n,c,t){const u=this.b.get(r);if(!u)return;const s=this.h.get(n)?.get(c);s&&t.action.kind!=="vote"&&u.acceptAction(Object.freeze({action:t.action,result:s}))}async $invokeCompletionProvider(r,n,c){const t=this.b.get(r);return t?(await t.invokeCompletionProvider(n,c)).map(m.ChatAgentCompletionItem.from):[]}}e.$hgc=f;class o{constructor(r,n,c,t,u){this.extension=r,this.t=n,this.u=c,this.w=t,this.x=u,this.o=new I.$Vd,this.q=new I.$Vd}acceptFeedback(r){this.o.fire(r)}acceptAction(r){this.q.fire(r)}async invokeCompletionProvider(r,n){return this.s?await this.s.provider.provideCompletionItems(r,n)??[]:[]}async validateSlashCommand(r){this.b||(await this.provideSlashCommand(O.CancellationToken.None),(0,b.$Sf)(this.b));const n=this.b.find(c=>c.name===r);if(!n)throw new Error(`Unknown slashCommand: ${r}`);return n}async provideSlashCommand(r){if(!this.a)return[];const n=await this.a.provideSlashCommands(r);return n?(this.b=n,n.map(c=>({name:c.name,description:c.description,followupPlaceholder:c.followupPlaceholder,shouldRepopulate:c.shouldRepopulate,sampleRequest:c.sampleRequest}))):[]}async provideFollowups(r,n){if(!this.d)return[];const c=await this.d.provideFollowups(r,n);return c?c.map(t=>m.ChatFollowup.from(t)):[]}get apiAgent(){let r=!1,n=!1;const c=()=>{r||n||(n=!0,queueMicrotask(()=>{this.u.$updateAgent(this.w,{description:this.g??"",fullName:this.h,icon:this.i?this.i instanceof $.URI?this.i:"light"in this.i?this.i.light:void 0:void 0,iconDark:this.i&&"dark"in this.i?this.i.dark:void 0,themeIcon:this.i instanceof p.$3L?this.i:void 0,hasSlashCommands:this.a!==void 0,hasFollowups:this.d!==void 0,isDefault:this.j,isSecondary:this.n,helpTextPrefix:!this.k||typeof this.k=="string"?this.k:m.MarkdownString.from(this.k),helpTextPostfix:!this.l||typeof this.l=="string"?this.l:m.MarkdownString.from(this.l),sampleRequest:this.m,supportIssueReporting:this.r}),n=!1}))},t=this;return{get name(){return t.t},get description(){return t.g??""},set description(u){t.g=u,c()},get fullName(){return t.h??t.extension.displayName??t.extension.name},set fullName(u){t.h=u,c()},get iconPath(){return t.i},set iconPath(u){t.i=u,c()},get slashCommandProvider(){return t.a},set slashCommandProvider(u){t.a=u,c()},get followupProvider(){return t.d},set followupProvider(u){t.d=u,c()},get isDefault(){return(0,h.$CF)(t.extension,"defaultChatAgent"),t.j},set isDefault(u){(0,h.$CF)(t.extension,"defaultChatAgent"),t.j=u,c()},get helpTextPrefix(){return(0,h.$CF)(t.extension,"defaultChatAgent"),t.k},set helpTextPrefix(u){if((0,h.$CF)(t.extension,"defaultChatAgent"),!t.j)throw new Error("helpTextPrefix is only available on the default chat agent");t.k=u,c()},get helpTextPostfix(){return(0,h.$CF)(t.extension,"defaultChatAgent"),t.l},set helpTextPostfix(u){if((0,h.$CF)(t.extension,"defaultChatAgent"),!t.j)throw new Error("helpTextPostfix is only available on the default chat agent");t.l=u,c()},get isSecondary(){return(0,h.$CF)(t.extension,"defaultChatAgent"),t.n},set isSecondary(u){(0,h.$CF)(t.extension,"defaultChatAgent"),t.n=u,c()},get sampleRequest(){return t.m},set sampleRequest(u){t.m=u,c()},get supportIssueReporting(){return(0,h.$CF)(t.extension,"chatAgents2Additions"),t.r},set supportIssueReporting(u){(0,h.$CF)(t.extension,"chatAgents2Additions"),t.r=u,c()},get onDidReceiveFeedback(){return t.o.event},set agentVariableProvider(u){if(t.s=u,u){if(!u.triggerCharacters.length)throw new Error("triggerCharacters are required");t.u.$registerAgentCompletionsProvider(t.w,u.triggerCharacters)}else t.u.$unregisterAgentCompletionsProvider(t.w)},get agentVariableProvider(){return t.s},onDidPerformAction:(0,h.$BF)(this.extension,"chatAgents2Additions")?this.q.event:void 0,dispose(){r=!0,t.a=void 0,t.d=void 0,t.o.dispose(),t.u.$unregisterAgent(t.w)}}}invoke(r,n,c,t){return this.x(r,n,c,t)}}}),define(ke[309],Se([1,0,21,3,6,15,85,26,11,4]),function(me,e,D,O,g,I,A,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ggc=void 0;class L{constructor(S,h){this.stream=new $.$wh,this.stream=h??new $.$wh;const f=this;this.apiObj={option:S,response:f.stream.asyncIterable}}}class C{constructor(S,h){this.a=new y.$Vd,this.b=new Map,this.c=new $.$wh,this.d=!1;const f=this;this.apiObject={result:S,response:f.c.asyncIterable,onDidStartResponseStream:f.a.event,cancel(){h.cancel()}},S.finally(()=>{if(this.d=!0,this.b.size>0)for(const[,o]of this.b)o.stream.resolve();else this.c.resolve()})}handleFragment(S){if(this.d)return;let h=this.b.get(S.index);h||(this.b.size===0?h=new L(S.index,this.c):h=new L(S.index),this.b.set(S.index,h),this.a.fire(h.apiObj)),h.stream.emitOne(S.part)}}class m{static{this.a=1}constructor(S,h){this.d=h,this.c=new Map,this.e=new Map,this.f=new b.$nm,this.b=S.getProxy(g.$6K.MainThreadChatProvider)}registerProvider(S,h,f,o){const i=m.a++;return this.c.set(i,{extension:S,provider:f}),this.b.$registerProvider(i,h,{extension:S,model:o.name??""}),(0,O.$Rc)(()=>{this.b.$unregisterProvider(i),this.c.delete(i)})}async $provideChatResponse(S,h,f,o,i){const r=this.c.get(S);if(!r)return;const n=new A.$vv(async c=>{if(i.isCancellationRequested){this.d.warn(`[CHAT](${r.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(h,{index:c.index,part:c.part})});return r.provider.provideChatResponse(f.map(I.ChatMessage.to),o,n,i)}allowListExtensionWhile(S,h){this.f.set(S,h),h.finally(()=>this.f.delete(S))}async requestChatResponseProvider(S,h){if(!this.f.has(S))throw new Error("Extension is NOT allowed to make chat requests");const f=await this.b.$prepareChatAccess(h);if(!f)throw new Error(`ChatAccess '${h}' NOT found`);const o=this;return{get model(){return f.model},get isRevoked(){return!o.f.has(S)},makeRequest(i,r,n){if(!o.f.has(S))throw new Error("Access to chat has been revoked");const c=new D.$6d(n),t=Math.random()*1e6|0,u=o.b.$fetchResponse(S,h,t,i.map(I.ChatMessage.from),r??{},c.token),s=new C(u,c);return o.e.set(t,{res:s}),u.finally(()=>{o.e.delete(t)}),s.apiObject}}}async $handleResponseFragment(S,h){const f=this.e.get(S);f&&f.res.handleFragment(h)}}e.$ggc=m}),define(ke[310],Se([1,0,3,6,14,15]),function(me,e,D,O,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$igc=void 0;class A{static{this.a=0}constructor($){this.b=new Map,this.c=$.getProxy(O.$6K.MainThreadChatVariables)}async $resolveVariable($,y,L){const C=this.b.get($);if(C)try{const m=await C.resolver.resolve(C.data.name,{prompt:y},L);if(m)return m.map(I.ChatVariable.from)}catch(m){(0,g.$2)(m)}}registerVariableResolver($,y,L,C){const m=A.a++;return this.b.set(m,{extension:$.identifier,data:{name:y,description:L},resolver:C}),this.c.$registerVariable(m,{name:y,description:L}),(0,D.$Rc)(()=>{this.b.delete(m),this.c.$unregisterVariable(m)})}}e.$igc=A}),define(ke[311],Se([1,0,6]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jgc=void 0;class O{constructor(I){const A=I.getProxy(D.$6K.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(b){return A.$writeText(b)}})}}e.$jgc=O}),define(ke[35],Se([1,0,18,7,15,24,6,19,13,55,29,48,2,3,5,20,147,22,68,44,38,87,90,30]),function(me,e,D,O,g,I,A,b,$,y,L,C,m,p,S,h,f,o,i,r,n,c,t,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xN=e.$wN=e.$vN=e.$uN=e.$tN=e.$sN=void 0;let s=class{#e;#t;#i;constructor(v,w,E){this.b=new Map,this.c=new Map,this.#e=v.getProxy(A.$6K.MainThreadCommands),this.d=w,this.#i=E,this.#t=v.getProxy(A.$6K.MainThreadTelemetry),this.converter=new l(this,P=>{const N=this.c.get(P);return N?.result===d.Void?N:void 0},w),this.f=[{processArgument(P){return(0,y.$Ch)(P)}},{processArgument(P){return(0,I.$xn)(P,function(N){if(L.$Us.isIRange(N))return g.Range.to(N);if(C.$Ts.isIPosition(N))return g.Position.to(N);if(L.$Us.isIRange(N.range)&&m.URI.isUri(N.uri))return g.location.to(N);if(N instanceof o.$je)return N.buffer.buffer;if(!Array.isArray(N))return N})}}]}registerArgumentProcessor(v){this.f.push(v)}registerApiCommand(v){const w=this.registerCommand(!1,v.id,async(...E)=>{const P=v.args.map((U,F)=>{if(!U.validate(E[F]))throw new Error(`Invalid argument '${U.name}' when running '${v.id}', received: ${typeof E[F]=="object"?JSON.stringify(E[F],null,"	"):E[F]} `);return U.convert(E[F])}),N=await this.executeCommand(v.internalId,...P);return v.result.convert(N,E,this.converter)},void 0,{description:v.description,args:v.args,returns:v.result.description});return this.c.set(v.id,v),new O.$8K(()=>{w.dispose(),this.c.delete(v.id)})}registerCommand(v,w,E,P,N,U){if(this.d.trace("ExtHostCommands#registerCommand",w),!w.trim().length)throw new Error("invalid id");if(this.b.has(w))throw new Error(`command '${w}' already exists`);return this.b.set(w,{callback:E,thisArg:P,metadata:N,extension:U}),v&&this.#e.$registerCommand(w),new O.$8K(()=>{this.b.delete(w)&&v&&this.#e.$unregisterCommand(w)})}executeCommand(v,...w){return this.d.trace("ExtHostCommands#executeCommand",v),this.g(v,w,!0)}async g(v,w,E){if(this.b.has(v))return this.#e.$fireCommandActivationEvent(v),this.h(v,w,!1);{let P=!1;const N=(0,I.$xn)(w,function(U){if(U instanceof O.$9K)return g.Position.from(U);if(U instanceof O.$0K)return g.Range.from(U);if(U instanceof O.$hL)return g.location.from(U);if(O.$tM.isNotebookRange(U))return g.NotebookRange.from(U);if(U instanceof ArrayBuffer)return P=!0,o.$je.wrap(new Uint8Array(U));if(U instanceof Uint8Array)return P=!0,o.$je.wrap(U);if(U instanceof o.$je)return P=!0,U;if(!Array.isArray(U))return U});try{const U=await this.#e.$executeCommand(v,P?new i.$Tv(N):N,E);return(0,y.$Ch)(U)}catch(U){if(U instanceof Error&&U.message==="$executeCommand:retry")return this.g(v,w,!1);throw U}}}async h(v,w,E){const P=this.b.get(v);if(!P)throw new Error("Unknown command");const{callback:N,thisArg:U,metadata:F}=P;if(F?.args)for(let T=0;T<F.args.length;T++)try{(0,D.$Zf)(w[T],F.args[T].constraint)}catch{throw new Error(`Running the contributed command: '${v}' failed. Illegal argument '${F.args[T].name}' - ${F.args[T].description}`)}const j=n.$Rd.create();try{return await N.apply(U,w)}catch(T){if(v===this.converter.delegatingCommandId){const M=this.converter.getActualCommand(...w);M&&(v=M.command)}if(this.d.error(T,v,P.extension?.identifier),!E)throw T;if(P.extension?.identifier){const M=this.#i.onExtensionError(P.extension.identifier,T);this.d.trace("forwarded error to extension?",M,P.extension?.identifier)}throw new class extends Error{constructor(){super((0,r.$Qi)(T)),this.id=v,this.source=P.extension?.displayName??P.extension?.name}}}finally{this.j(P,v,j.elapsed())}}j(v,w,E){v.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:v.extension.identifier.value,id:new c.$Lo(w),duration:E})}$executeContributedCommand(v,...w){this.d.trace("ExtHostCommands#$executeContributedCommand",v);const E=this.b.get(v);return E?(w=w.map(P=>this.f.reduce((N,U)=>U.processArgument(N,E.extension?.identifier),P)),this.h(v,w,!0)):Promise.reject(new Error(`Contributed command '${v}' does not exist.`))}getCommands(v=!1){return this.d.trace("ExtHostCommands#getCommands",v),this.#e.$getCommands().then(w=>(v&&(w=w.filter(E=>E[0]!=="_")),w))}$getContributedCommandMetadata(){const v=Object.create(null);for(const[w,E]of this.b){const{metadata:P}=E;P&&(v[w]=P)}return Promise.resolve(v)}};e.$sN=s,e.$sN=s=Ge([We(0,h.$0M),We(1,$.$nj),We(2,t.$rN)],s),e.$tN=(0,S.$6h)("IExtHostCommands");class l{constructor(v,w,E){this.d=v,this.f=w,this.g=E,this.delegatingCommandId=`__vsc${(0,u.$qg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(v,w){if(!v)return;const E={$ident:void 0,id:v.command,title:v.title,tooltip:v.tooltip};if(!v.command)return E;const P=this.f(v.command);if(P)E.id=P.internalId,E.arguments=P.args.map((N,U)=>N.convert(v.arguments&&v.arguments[U]));else if((0,b.$Lb)(v.arguments)){const N=`${v.command} /${++this.c}`;this.b.set(N,v),w.add((0,p.$Rc)(()=>{this.b.delete(N),this.g.trace("CommandsConverter#DISPOSE",N)})),E.$ident=N,E.id=this.delegatingCommandId,E.arguments=[N],this.g.trace("CommandsConverter#CREATE",v.command,N)}return E}fromInternal(v){return typeof v.$ident=="string"?this.b.get(v.$ident):{command:v.id,title:v.title,arguments:v.arguments}}getActualCommand(...v){return this.b.get(v[0])}h(...v){const w=this.getActualCommand(...v);return this.g.trace("CommandsConverter#EXECUTE",v[0],w?w.command:"MISSING"),w?this.d.executeCommand(w.command,...w.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${v[0]}`)}}e.$uN=l;class a{static{this.Uri=new a("uri","Uri of a text document",v=>m.URI.isUri(v),v=>v)}static{this.Position=new a("position","A position in a text document",v=>O.$9K.isPosition(v),g.Position.from)}static{this.Range=new a("range","A range in a text document",v=>O.$0K.isRange(v),g.Range.from)}static{this.Selection=new a("selection","A selection in a text document",v=>O.$$K.isSelection(v),g.Selection.from)}static{this.Number=new a("number","",v=>typeof v=="number",v=>v)}static{this.String=new a("string","",v=>typeof v=="string",v=>v)}static{this.StringArray=a.Arr(a.String)}static Arr(v){return new a(`${v.name}_array`,`Array of ${v.name}, ${v.description}`,w=>Array.isArray(w)&&w.every(E=>v.validate(E)),w=>w.map(E=>v.convert(E)))}static{this.CallHierarchyItem=new a("item","A call hierarchy item",v=>v instanceof O.$sL,g.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new a("item","A type hierarchy item",v=>v instanceof O.$MM,g.TypeHierarchyItem.from)}static{this.TestItem=new a("testItem","A VS Code TestItem",v=>v instanceof f.$kN,g.TestItem.from)}constructor(v,w,E,P){this.name=v,this.description=w,this.validate=E,this.convert=P}optional(){return new a(this.name,`(optional) ${this.description}`,v=>v==null||this.validate(v),v=>v===void 0?void 0:v===null?null:this.convert(v))}with(v,w){return new a(v??this.name,w??this.description,this.validate,this.convert)}}e.$vN=a;class d{static{this.Void=new d("no result",v=>v)}constructor(v,w){this.description=v,this.convert=w}}e.$wN=d;class k{constructor(v,w,E,P,N){this.id=v,this.internalId=w,this.description=E,this.args=P,this.result=N}}e.$xN=k}),define(ke[312],Se([1,0,19,17,2,83,131,45,35,15,7]),function(me,e,D,O,g,I,A,b,$,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cgc=void 0;const C=[new $.$xN("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[$.$vN.Uri,$.$vN.Position],new $.$wN("A promise that resolves to an array of DocumentHighlight-instances.",p(y.DocumentHighlight.to))),new $.$xN("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[$.$vN.Uri],new $.$wN("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(h,f)=>{if((0,D.$Kb)(h))return;class o extends L.$nL{static to(r){const n=new o(r.name,y.SymbolKind.to(r.kind),r.containerName||"",new L.$hL(f[0],y.Range.to(r.range)));return n.detail=r.detail,n.range=n.location.range,n.selectionRange=y.Range.to(r.selectionRange),n.children=r.children?r.children.map(o.to):[],n}}return h.map(o.to)})),new $.$xN("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[$.$vN.Uri,new $.$vN("options","Formatting options",h=>!0,h=>h)],new $.$wN("A promise that resolves to an array of TextEdits.",p(y.TextEdit.to))),new $.$xN("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[$.$vN.Uri,$.$vN.Range,new $.$vN("options","Formatting options",h=>!0,h=>h)],new $.$wN("A promise that resolves to an array of TextEdits.",p(y.TextEdit.to))),new $.$xN("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[$.$vN.Uri,$.$vN.Position,new $.$vN("ch","Trigger character",h=>typeof h=="string",h=>h),new $.$vN("options","Formatting options",h=>!0,h=>h)],new $.$wN("A promise that resolves to an array of TextEdits.",p(y.TextEdit.to))),new $.$xN("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[$.$vN.Uri,$.$vN.Position],new $.$wN("A promise that resolves to an array of Location or LocationLink instances.",S)),new $.$xN("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[$.$vN.Uri,$.$vN.Position],new $.$wN("A promise that resolves to an array of Location or LocationLink instances.",S)),new $.$xN("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[$.$vN.Uri,$.$vN.Position],new $.$wN("A promise that resolves to an array of Location or LocationLink instances.",S)),new $.$xN("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[$.$vN.Uri,$.$vN.Position],new $.$wN("A promise that resolves to an array of Location or LocationLink instances.",S)),new $.$xN("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[$.$vN.Uri,$.$vN.Position],new $.$wN("A promise that resolves to an array of Location-instances.",p(y.location.to))),new $.$xN("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[$.$vN.Uri,$.$vN.Position],new $.$wN("A promise that resolves to an array of Hover-instances.",p(y.Hover.to))),new $.$xN("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[$.$vN.Uri,new $.$vN("position","A position in a text document",h=>Array.isArray(h)&&h.every(f=>L.$9K.isPosition(f)),h=>h.map(y.Position.from))],new $.$wN("A promise that resolves to an array of ranges.",h=>h.map(f=>{let o;for(const i of f.reverse())o=new L.$rL(y.Range.to(i),o);return o}))),new $.$xN("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[$.$vN.String.with("query","Search string")],new $.$wN("A promise that resolves to an array of SymbolInformation-instances.",h=>h.map(y.WorkspaceSymbol.to))),new $.$xN("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[$.$vN.Uri,$.$vN.Position],new $.$wN("A promise that resolves to an array of CallHierarchyItem-instances",h=>h.map(y.CallHierarchyItem.to))),new $.$xN("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[$.$vN.CallHierarchyItem],new $.$wN("A promise that resolves to an array of CallHierarchyIncomingCall-instances",h=>h.map(y.CallHierarchyIncomingCall.to))),new $.$xN("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[$.$vN.CallHierarchyItem],new $.$wN("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",h=>h.map(y.CallHierarchyOutgoingCall.to))),new $.$xN("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[$.$vN.Uri,$.$vN.Position],new $.$wN("A promise that resolves to a range and placeholder text.",h=>{if(h)return{range:y.Range.to(h.range),placeholder:h.text}})),new $.$xN("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[$.$vN.Uri,$.$vN.Position,$.$vN.String.with("newName","The new symbol name")],new $.$wN("A promise that resolves to a WorkspaceEdit.",h=>{if(h){if(h.rejectReason)throw new Error(h.rejectReason);return y.WorkspaceEdit.to(h)}})),new $.$xN("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[$.$vN.Uri,$.$vN.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new $.$wN("A promise that resolves to an array of DocumentLink-instances.",h=>h.map(y.DocumentLink.to))),new $.$xN("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[$.$vN.Uri],new $.$wN("A promise that resolves to SemanticTokensLegend.",h=>{if(h)return new L.$lM(h.tokenTypes,h.tokenModifiers)})),new $.$xN("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[$.$vN.Uri],new $.$wN("A promise that resolves to SemanticTokens.",h=>{if(!h)return;const f=(0,A.$t$)(h);if(f.type==="full")return new L.$nM(f.data,void 0)})),new $.$xN("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[$.$vN.Uri,$.$vN.Range.optional()],new $.$wN("A promise that resolves to SemanticTokensLegend.",h=>{if(h)return new L.$lM(h.tokenTypes,h.tokenModifiers)})),new $.$xN("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[$.$vN.Uri,$.$vN.Range],new $.$wN("A promise that resolves to SemanticTokens.",h=>{if(!h)return;const f=(0,A.$t$)(h);if(f.type==="full")return new L.$nM(f.data,void 0)})),new $.$xN("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[$.$vN.Uri,$.$vN.Position,$.$vN.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),$.$vN.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new $.$wN("A promise that resolves to a CompletionList-instance.",(h,f,o)=>{if(!h)return new L.$DL([]);const i=h.suggestions.map(r=>y.CompletionItem.to(r,o));return new L.$DL(i,h.incomplete)})),new $.$xN("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[$.$vN.Uri,$.$vN.Position,$.$vN.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new $.$wN("A promise that resolves to SignatureHelp.",h=>{if(h)return y.SignatureHelp.to(h)})),new $.$xN("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[$.$vN.Uri,$.$vN.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new $.$wN("A promise that resolves to an array of CodeLens-instances.",(h,f,o)=>p(i=>new L.$vL(y.Range.to(i.range),i.command&&o.fromInternal(i.command)))(h))),new $.$xN("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[$.$vN.Uri,new $.$vN("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",h=>L.$0K.isRange(h),h=>L.$$K.isSelection(h)?y.Selection.from(h):y.Range.from(h)),$.$vN.String.with("kind","Code action kind to return code actions for").optional(),$.$vN.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new $.$wN("A promise that resolves to an array of Command-instances.",(h,f,o)=>p(i=>{if(i._isSynthetic){if(!i.command)throw new Error("Synthetic code actions must have a command");return o.fromInternal(i.command)}else{const r=new L.$pL(i.title,i.kind?new L.$qL(i.kind):void 0);return i.edit&&(r.edit=y.WorkspaceEdit.to(i.edit)),i.command&&(r.command=o.fromInternal(i.command)),r.isPreferred=i.isPreferred,r}})(h))),new $.$xN("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[$.$vN.Uri],new $.$wN("A promise that resolves to an array of ColorInformation objects.",h=>h?h.map(f=>new L.$JL(y.Range.to(f.range),y.Color.to(f.color))):[])),new $.$xN("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new $.$vN("color","The color to show and insert",h=>h instanceof L.$IL,y.Color.from),new $.$vN("context","Context object with uri and range",h=>!0,h=>({uri:h.uri,range:y.Range.from(h.range)}))],new $.$wN("A promise that resolves to an array of ColorPresentation objects.",h=>h?h.map(y.ColorPresentation.to):[])),new $.$xN("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[$.$vN.Uri,$.$vN.Range],new $.$wN("A promise that resolves to an array of Inlay objects",(h,f,o)=>h.map(y.InlayHint.to.bind(void 0,o)))),new $.$xN("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[$.$vN.Uri],new $.$wN("A promise that resolves to an array of FoldingRange objects",(h,f)=>{if(h)return h.map(y.FoldingRange.to)})),new $.$xN("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new $.$wN("A promise that resolves to an array of NotebookContentProvider static info objects.",p(h=>({viewType:h.viewType,displayName:h.displayName,options:{transientOutputs:h.options.transientOutputs,transientCellMetadata:h.options.transientCellMetadata,transientDocumentMetadata:h.options.transientDocumentMetadata},filenamePattern:h.filenamePattern.map(f=>y.NotebookExclusiveDocumentPattern.to(f))})))),new $.$xN("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[$.$vN.Uri,$.$vN.Range,new $.$vN("context","An InlineValueContext",h=>h&&typeof h.frameId=="number"&&h.stoppedLocation instanceof L.$0K,h=>y.InlineValueContext.from(h))],new $.$wN("A promise that resolves to an array of InlineValue objects",h=>h.map(y.InlineValue.to))),new $.$xN("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new $.$vN("uriOrString","Uri-instance or string (only http/https)",h=>g.URI.isUri(h)||typeof h=="string"&&(0,O.$fg)(h,O.Schemas.http,O.Schemas.https),h=>h),new $.$vN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",h=>h===void 0||typeof h=="number"||typeof h=="object",h=>h&&(typeof h=="number"?[y.ViewColumn.from(h),void 0]:[y.ViewColumn.from(h.viewColumn),y.TextEditorOpenOptions.from(h)])).optional(),$.$vN.String.with("label","").optional()],$.$wN.Void),new $.$xN("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[$.$vN.Uri.with("resource","Resource to open"),$.$vN.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new $.$vN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",h=>h===void 0||typeof h=="number"||typeof h=="object",h=>h&&(typeof h=="number"?[y.ViewColumn.from(h),void 0]:[y.ViewColumn.from(h.viewColumn),y.TextEditorOpenOptions.from(h)])).optional()],$.$wN.Void),new $.$xN("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[$.$vN.Uri.with("left","Left-hand side resource of the diff editor"),$.$vN.Uri.with("right","Right-hand side resource of the diff editor"),$.$vN.String.with("title","Human readable title for the diff editor").optional(),new $.$vN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",h=>h===void 0||typeof h=="object",h=>h&&[y.ViewColumn.from(h.viewColumn),y.TextEditorOpenOptions.from(h)]).optional()],$.$wN.Void),new $.$xN("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[$.$vN.String.with("title","Human readable title for the changes editor"),new $.$vN("resourceList","List of resources to compare",h=>{for(const f of h){if(f.length!==3)return!1;const[o,i,r]=f;if(!g.URI.isUri(o)||!g.URI.isUri(i)&&i!==void 0&&i!==null||!g.URI.isUri(r)&&r!==void 0&&r!==null)return!1}return!0},h=>h)],$.$wN.Void),new $.$xN("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[$.$vN.Uri,$.$vN.Position],new $.$wN("A promise that resolves to an array of TypeHierarchyItem-instances",h=>h.map(y.TypeHierarchyItem.to))),new $.$xN("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[$.$vN.TypeHierarchyItem],new $.$wN("A promise that resolves to an array of TypeHierarchyItem-instances",h=>h.map(y.TypeHierarchyItem.to))),new $.$xN("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[$.$vN.TypeHierarchyItem],new $.$wN("A promise that resolves to an array of TypeHierarchyItem-instances",h=>h.map(y.TypeHierarchyItem.to))),new $.$xN("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[$.$vN.TestItem],$.$wN.Void),new $.$xN("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[$.$vN.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],$.$wN.Void),new $.$xN("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[$.$vN.String.with("name","The context key name"),new $.$vN("value","The context key value",()=>!0,h=>h)],$.$wN.Void),new $.$xN("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[$.$vN.Uri,$.$vN.StringArray,new $.$vN("MappedEditsContext","Mapped Edits Context",h=>y.MappedEditsContext.is(h),h=>y.MappedEditsContext.from(h))],new $.$wN("A promise that resolves to a workspace edit or null",h=>h?y.WorkspaceEdit.to(h):null))];class m{static register(f){C.forEach(f.registerApiCommand,f),this.a(f)}static a(f){f.registerCommand(!1,"_validateWhenClauses",b.$5i)}}e.$cgc=m;function p(h){return f=>{if(Array.isArray(f))return f.map(h)}}function S(h){if(!Array.isArray(h))return;const f=[];for(const o of h)I.$Gt(o)?f.push(y.DefinitionLink.to(o)):f.push(y.location.to(o));return f}}),define(ke[313],Se([1,0,11,52,4,3,2,83,26,15,7,6,25]),function(me,e,D,O,g,I,A,b,$,y,L,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mgc=void 0;function p(S,h,f){const o=S.getProxy(C.$6K.MainThreadComments);class i{static{this.a=0}constructor(){this.b=new Map,this.c=new $.$nm,h.registerArgumentProcessor({processArgument:d=>{if(d&&d.$mid===6){const k=this.b.get(d.handle);return k?k.value:d}else if(d&&d.$mid===7){const k=this.b.get(d.commentControlHandle);if(!k)return d;const R=k.getCommentThread(d.commentThreadHandle);return R?R.value:d}else if(d&&(d.$mid===9||d.$mid===8)){const k=this.b.get(d.thread.commentControlHandle);if(!k)return d;const R=k.getCommentThread(d.thread.commentThreadHandle);return R?d.$mid===8?R.value:{thread:R.value,text:d.text}:d}else if(d&&d.$mid===10){const k=this.b.get(d.thread.commentControlHandle);if(!k)return d;const R=k.getCommentThread(d.thread.commentThreadHandle);if(!R)return d;const v=d.commentUniqueId,w=R.getCommentByUniqueId(v);return w||d}else if(d&&d.$mid===11){const k=this.b.get(d.thread.commentControlHandle);if(!k)return d;const R=k.getCommentThread(d.thread.commentThreadHandle);if(!R)return d;const v=d.text,w=d.commentUniqueId,E=R.getCommentByUniqueId(w);return E?(typeof E.body=="string"?E.body=v:E.body=new L.$wL(v),E):d}return d}})}createCommentController(d,k,R){const v=i.a++,w=new n(d,v,k,R);this.b.set(w.handle,w);const E=this.c.get(d.identifier)||[];return E.push(w),this.c.set(d.identifier,E),w.value}async $createCommentThreadTemplate(d,k,R){const v=this.b.get(d);v&&v.$createCommentThreadTemplate(k,R)}async $updateCommentThreadTemplate(d,k,R){const v=this.b.get(d);v&&v.$updateCommentThreadTemplate(k,R)}$deleteCommentThread(d,k){this.b.get(d)?.$deleteCommentThread(k)}$provideCommentingRanges(d,k,R){const v=this.b.get(d);if(!v||!v.commentingRangeProvider)return Promise.resolve(void 0);const w=f.getDocument(A.URI.revive(k));return(0,D.$Yg)(async()=>{const E=await v.commentingRangeProvider.provideCommentingRanges(w,R);let P;return Array.isArray(E)?P={ranges:E,fileComments:!1}:E?P={ranges:E.ranges||[],fileComments:E.fileComments||!1}:P=E??void 0,P}).then(E=>{let P;return E&&(P={ranges:E.ranges.map(N=>y.Range.from(N)),fileComments:E.fileComments}),P})}$toggleReaction(d,k,R,v,w){const E=this.b.get(d);return!E||!E.reactionHandler?Promise.resolve(void 0):(0,D.$Yg)(()=>{const P=E.getCommentThread(k);if(P){const N=P.getCommentByUniqueId(v.uniqueIdInThread);if(E!==void 0&&N&&E.reactionHandler)return E.reactionHandler(N,u(w))}return Promise.resolve(void 0)})}}class r{static{this.a=0}set threadId(d){this.n=d}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(d){(d===void 0!=(this.p===void 0)||!d||!this.p||!d.isEqual(this.p))&&(this.p=d,this.b.range=d,this.c.fire())}get range(){return this.p}set canReply(d){this.d!==d&&(this.d=d,this.b.canReply=d,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(d){this.e=d,this.b.label=d,this.c.fire()}get contextValue(){return this.f}set contextValue(d){this.f=d,this.b.contextValue=d,this.c.fire()}get comments(){return this.q}set comments(d){this.q=d,this.b.comments=d,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(d){this.g=d,this.b.collapsibleState=d,this.c.fire()}get state(){return this.h}set state(d){this.h=d,this.b.state=d,this.c.fire()}get isDisposed(){return this.j}constructor(d,k,R,v,w,E,P,N){this.m=k,this.n=R,this.o=v,this.p=w,this.q=E,this.extensionDescription=P,this.r=N,this.handle=r.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new g.$Vd,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new I.$Uc,this.l.value=new I.$Sc,this.n===void 0&&(this.n=`${d}.${this.handle}`),o.$createCommentThread(k,this.handle,this.n,this.o,y.Range.from(this.p),P.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=E,this.i.push({dispose:()=>{o.$deleteCommentThread(k,this.handle)}});const U=this;this.value={get uri(){return U.uri},get range(){return U.range},set range(F){U.range=F},get comments(){return U.comments},set comments(F){U.comments=F},get collapsibleState(){return U.collapsibleState},set collapsibleState(F){U.collapsibleState=F},get canReply(){return U.canReply},set canReply(F){U.canReply=F},get contextValue(){return U.contextValue},set contextValue(F){U.contextValue=F},get label(){return U.label},set label(F){U.label=F},get state(){return U.state},set state(F){U.state=F},dispose:()=>{U.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new I.$Sc);const d=R=>Object.prototype.hasOwnProperty.call(this.b,R),k={};d("range")&&(k.range=y.Range.from(this.p)),d("label")&&(k.label=this.label),d("contextValue")&&(k.contextValue=this.contextValue??null),d("comments")&&(k.comments=this.q.map(R=>c(this,R,this.k,this.extensionDescription))),d("collapsibleState")&&(k.collapseState=s(this.g)),d("canReply")&&(k.canReply=this.canReply),d("state")&&(k.state=l(this.h)),d("isTemplate")&&(k.isTemplate=this.r),this.b={},o.$updateCommentThread(this.m,this.handle,this.n,this.o,k)}getCommentByUniqueId(d){for(const k of this.k){const R=k[0],v=k[1];if(d===v)return R}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(d=>d.dispose())}}Ge([(0,O.$yh)(100)],r.prototype,"eventuallyUpdateCommentThread",null);class n{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(d){this.b=d,o.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(d){this.c=d,o.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!d})}get options(){return this.d}set options(d){this.d=d,o.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(d,k,R,v){this.f=d,this.g=k,this.h=R,this.i=v,this.a=new Map,o.$registerCommentController(this.handle,R,v,this.f.identifier.value);const w=this;this.value=Object.freeze({id:w.id,label:w.label,get options(){return w.options},set options(E){w.options=E},get commentingRangeProvider(){return w.commentingRangeProvider},set commentingRangeProvider(E){w.commentingRangeProvider=E},get reactionHandler(){return w.reactionHandler},set reactionHandler(E){w.reactionHandler=E},createCommentThread(E,P,N){return w.createCommentThread(E,P,N).value},dispose:()=>{w.dispose()}}),this.e=[],this.e.push({dispose:()=>{o.$unregisterCommentController(this.handle)}})}createCommentThread(d,k,R){k===void 0&&(0,m.$CF)(this.f,"fileComments");const v=new r(this.id,this.handle,void 0,d,k,R,this.f,!1);return this.a.set(v.handle,v),v}$createCommentThreadTemplate(d,k){const R=new r(this.id,this.handle,void 0,A.URI.revive(d),y.Range.to(k),[],this.f,!0);return R.collapsibleState=b.CommentThreadCollapsibleState.Expanded,this.a.set(R.handle,R),R}$updateCommentThreadTemplate(d,k){const R=this.a.get(d);R&&(R.range=y.Range.to(k))}$deleteCommentThread(d){this.a.get(d)?.dispose(),this.a.delete(d)}getCommentThread(d){return this.a.get(d)}dispose(){this.a.forEach(d=>{d.dispose()}),this.e.forEach(d=>d.dispose())}}function c(a,d,k,R){let v=k.get(d);return v||(v=++a.commentHandle,k.set(d,v)),d.state!==void 0&&(0,m.$CF)(R,"commentsDraftState"),d.reactions?.some(w=>w.reactors!==void 0)&&(0,m.$CF)(R,"commentReactor"),{mode:d.mode,contextValue:d.contextValue,uniqueIdInThread:v,body:typeof d.body=="string"?d.body:y.MarkdownString.from(d.body),userName:d.author.name,userIconPath:d.author.iconPath,label:d.label,commentReactions:d.reactions?d.reactions.map(w=>t(w)):void 0,state:d.state,timestamp:d.timestamp?.toJSON()}}function t(a){return{label:a.label,iconPath:a.iconPath?y.$9M(a.iconPath):void 0,count:a.count,hasReacted:a.authorHasReacted,reactors:a.reactors&&a.reactors.length>0&&typeof a.reactors[0]!="string"?a.reactors.map(d=>d.name):a.reactors}}function u(a){return{label:a.label||"",count:a.count||0,iconPath:a.iconPath?A.URI.revive(a.iconPath):"",authorHasReacted:a.hasReacted||!1,reactors:a.reactors?.map(d=>({name:d}))}}function s(a){if(a!==void 0)switch(a){case L.CommentThreadCollapsibleState.Expanded:return b.CommentThreadCollapsibleState.Expanded;case L.CommentThreadCollapsibleState.Collapsed:return b.CommentThreadCollapsibleState.Collapsed}return b.CommentThreadCollapsibleState.Collapsed}function l(a){if(a!==void 0)switch(a){case L.CommentThreadState.Unresolved:return b.CommentThreadState.Unresolved;case L.CommentThreadState.Resolved:return b.CommentThreadState.Resolved}return b.CommentThreadState.Unresolved}return new i}e.$mgc=p}),define(ke[314],Se([1,0,24,6,27,20]),function(me,e,D,O,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aic=void 0;let A=class{constructor(L,C){this.a=L.getProxy(O.$6K.MainThreadConsole),this.b=C.consoleForward.includeStack,this.c=C.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(L,C){const m=this,p=console[L];Object.defineProperty(console,L,{set:()=>{},get:()=>function(){m.e(L,C,p,arguments)}})}e(L,C,m,p){this.a.$logExtensionHostMessage({type:"__$console",severity:C,arguments:$(p,this.b)}),this.c&&this.f(L,m,p)}};e.$aic=A,e.$aic=A=Ge([We(0,I.$0M),We(1,g.$nN)],A);const b=1e5;function $(y,L){const C=[];if(y.length)for(let m=0;m<y.length;m++){let p=y[m];if(typeof p>"u")p="undefined";else if(p instanceof Error){const S=p;S.stack?p=S.stack:p=S.toString()}C.push(p)}if(L){const m=new Error().stack;m&&C.push({__$stack:m.split(`
`).slice(3).join(`
`)})}try{const m=(0,D.$An)(C);return m.length>b?"Output omitted for a large object that exceeds the limits":m}catch(m){return`Output omitted for an object that cannot be inspected ('${m.toString()}')`}}}),define(ke[149],Se([1,0,2,6,7,5,20,13,19,12,16,25]),function(me,e,D,O,g,I,A,b,$,y,L,C){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$dhc=e.$chc=void 0;let p=class{static{m=this}static{this.c=0}static{this.d=250}constructor(h,f){this.h=f,this.f=new Map,this.g=h.getProxy(O.$6K.MainThreadDecorations)}registerFileDecorationProvider(h,f){const o=m.c++;this.f.set(o,{provider:h,extensionDescription:f}),this.g.$registerDecorationProvider(o,f.identifier.value);const i=h.onDidChangeFileDecorations&&h.onDidChangeFileDecorations(r=>{if(!r){this.g.$onDidChange(o,null);return}const n=(0,$.$3b)(r);if(n.length<=m.d){this.g.$onDidChange(o,n);return}this.h.warn("[Decorations] CAPPING events from decorations provider",f.identifier.value,n.length);const c=n.map(s=>({uri:s,rank:(0,y.$Pe)(s.path,"/")})),t=(0,$.$zb)(c,(s,l)=>s.rank-l.rank||(0,y.$5e)(s.uri.path,l.uri.path)),u=[];e:for(const s of t){let l;for(const a of s){const d=(0,L.$mc)(a.uri.path);if(l!==d&&(l=d,u.push(a.uri)>=m.d))break e}}this.g.$onDidChange(o,u)});return new g.$8K(()=>{i?.dispose(),this.g.$unregisterDecorationProvider(o),this.f.delete(o)})}async $provideDecorations(h,f,o){if(!this.f.has(h))return Object.create(null);const i=Object.create(null),{provider:r,extensionDescription:n}=this.f.get(h);return await Promise.all(f.map(async c=>{try{const{uri:t,id:u}=c,s=await Promise.resolve(r.provideFileDecoration(D.URI.revive(t),o));if(!s)return;try{g.$rM.validate(s),s.badge&&typeof s.badge!="string"&&(0,C.$CF)(n,"codiconDecoration"),i[u]=[s.propagate,s.tooltip,s.badge,s.color]}catch(l){this.h.warn(`INVALID decoration from extension '${n.identifier.value}': ${l}`)}}catch(t){this.h.error(t)}})),i}};e.$chc=p,e.$chc=p=m=Ge([We(0,A.$0M),We(1,b.$nj)],p),e.$dhc=(0,I.$6h)("IExtHostDecorations")}),define(ke[315],Se([1,0,211,135,2,6,7,15,4,13,28,58]),function(me,e,D,O,g,I,A,b,$,y,L,C){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$0fc=e.$9fc=void 0;class p{#e;#t;#i;constructor(f,o,i,r,n,c,t,u){this.d=f,this.e=o,this.f=i,this.g=r,this.h=n,this.c=!1,this.f=Math.max(r,i),this.#i=new L.$Ac(s=>c.getComparisonKey(s)),this.#e=t,this.#t=u}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(f,o){if(!f){this.clear();return}this.j();let i=[];if(g.URI.isUri(f)){if(!o){this.delete(f);return}this.#i.set(f,o.slice()),i=[f]}else if(Array.isArray(f)){i=[];let c;f=[...f].sort(p.k);for(const t of f){const[u,s]=t;if((!c||u.toString()!==c.toString())&&(c&&this.#i.get(c).length===0&&this.#i.delete(c),c=u,i.push(u),this.#i.set(u,[])),s)this.#i.get(u)?.push(...s);else{const l=this.#i.get(u);l&&(l.length=0)}}}if(this.#t.fire(i),!this.#e)return;const r=[];let n=0;for(const c of i){let t=[];const u=this.#i.get(c);if(u)if(u.length>this.g){t=[];const s=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let l=0;l<4;l++)for(const a of u)if(a.severity===s[l]&&t.push({...b.Diagnostic.from(a),modelVersionId:this.h(c)})===this.g)break e;t.push({severity:O.MarkerSeverity.Info,message:(0,D.localize)(0,null,u.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=u.map(s=>({...b.Diagnostic.from(s),modelVersionId:this.h(c)}));if(r.push([c,t]),n+=t.length,n>this.f)break}this.#e.$changeMany(this.e,r)}delete(f){this.j(),this.#t.fire([f]),this.#i.delete(f),this.#e?.$changeMany(this.e,[[f,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(f,o){this.j();for(const[i,r]of this)f.call(o,i,r,this)}*[Symbol.iterator](){this.j();for(const f of this.#i.keys())yield[f,this.get(f)]}get(f){this.j();const o=this.#i.get(f);return Array.isArray(o)?Object.freeze(o.slice(0)):[]}has(f){return this.j(),Array.isArray(this.#i.get(f))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(f,o){return f[0].toString()<o[0].toString()?-1:f[0].toString()>o[0].toString()?1:0}}e.$9fc=p;let S=class{static{m=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*m.d}static _mapper(f){const o=new L.$Ac;for(const i of f)o.set(i,i);return{uris:Object.freeze(Array.from(o.values()))}}constructor(f,o,i,r){this.j=o,this.k=i,this.l=r,this.g=new Map,this.h=new $.$Zd({merge:n=>n.flat(),delay:50}),this.onDidChangeDiagnostics=$.Event.map(this.h.event,m._mapper),this.f=f.getProxy(I.$6K.MainThreadDiagnostics)}createDiagnosticCollection(f,o){const{g:i,f:r,h:n,j:c,k:t,l:u}=this,s=new class{$changeMany(d,k){r.$changeMany(d,k),c.trace("[DiagnosticCollection] change many (extension, owner, uris)",f.value,d,k.length===0?"CLEARING":k)}$clear(d){r.$clear(d),c.trace("[DiagnosticCollection] remove all (extension, owner)",f.value,d)}dispose(){r.dispose()}};let l;if(!o)o="_generated_diagnostic_collection_name_#"+m.c++,l=o;else if(!i.has(o))l=o;else{this.j.warn(`DiagnosticCollection with name '${o}' does already exist.`);do l=o+m.c++;while(i.has(l))}return new class extends p{constructor(){super(o,l,m.e,m.d,d=>u.getDocument(d)?.version,t.extUri,s,n),i.set(l,this)}dispose(){super.dispose(),i.delete(l)}}}getDiagnostics(f){if(f)return this.m(f);{const o=new Map,i=[];for(const r of this.g.values())r.forEach((n,c)=>{let t=o.get(n.toString());typeof t>"u"&&(t=i.length,o.set(n.toString(),t),i.push([n,[]])),i[t][1]=i[t][1].concat(...c)});return i}}m(f){let o=[];for(const i of this.g.values())i.has(f)&&(o=o.concat(i.get(f)));return o}$acceptMarkersChange(f){if(!this.n){const o="_generated_mirror",i=new p(o,o,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,r=>{},this.k.extUri,void 0,this.h);this.g.set(o,i),this.n=i}for(const[o,i]of f)this.n.set(g.URI.revive(o),i.map(b.Diagnostic.to))}};e.$0fc=S,e.$0fc=S=m=Ge([We(1,y.$nj),We(2,C.$8fc)],S)}),define(ke[316],Se([1,0,2,6,25]),function(me,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ehc=void 0;class I{constructor(b){this.a=b.getProxy(O.$6K.MainThreadDialogs)}showOpenDialog(b,$){return $?.allowUIResources&&(0,g.$CF)(b,"showLocal"),this.a.$showOpenDialog($).then(y=>y?y.map(L=>D.URI.revive(L)):void 0)}showSaveDialog(b){return this.a.$showSaveDialog(b).then($=>$?D.URI.revive($):void 0)}}e.$ehc=I}),define(ke[317],Se([1,0,14,2,7,6,17,21,12]),function(me,e,D,O,g,I,A,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fhc=void 0;class y{static{this.a=0}constructor(C,m,p){this.d=m,this.e=p,this.b=new Map,this.c=C.getProxy(I.$6K.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(C,m){if(Object.keys(A.Schemas).indexOf(C)>=0)throw new Error(`scheme '${C}' already registered`);const p=y.a++;this.b.set(p,m),this.c.$registerTextContentProvider(p,C);let S;if(typeof m.onDidChange=="function"){let h;S=m.onDidChange(async f=>{if(f.scheme!==C){this.e.warn(`Provider for scheme '${C}' is firing event for schema '${f.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(f))return;h&&await h;const o=this.$provideTextDocumentContent(p,f).then(async i=>{if(!i&&typeof i!="string")return;const r=this.d.getDocument(f);if(!r)return;const n=(0,$.$Ze)(i);if(!r.equalLines(n))return this.c.$onVirtualDocumentChange(f,i)}).catch(D.$1).finally(()=>{h===o&&(h=void 0)});h=o})}return new g.$8K(()=>{this.b.delete(p)&&this.c.$unregisterTextContentProvider(p),S&&(S.dispose(),S=void 0)})}$provideTextDocumentContent(C,m){const p=this.b.get(C);return p?Promise.resolve(p.provideTextDocumentContent(O.URI.revive(m),b.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${m.scheme}`))}}e.$fhc=y}),define(ke[318],Se([1,0,4,3,2,6,141,15,18,24,7]),function(me,e,D,O,g,I,A,b,$,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6fc=void 0;class C{constructor(p,S){this.a=new D.$Vd,this.b=new D.$Vd,this.c=new D.$Vd,this.d=new D.$Vd,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new O.$Sc,this.h=new Map,this.f=p.getProxy(I.$6K.MainThreadDocuments),this.g=S,this.g.onDidRemoveDocuments(h=>{for(const f of h)this.b.fire(f.document)},void 0,this.e),this.g.onDidAddDocuments(h=>{for(const f of h)this.a.fire(f.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(p){if(!p)return;const S=this.g.getDocument(p);if(S)return S}getDocument(p){const S=this.getDocumentData(p);if(!S?.document)throw new Error(`Unable to retrieve document from URI '${p}'`);return S.document}ensureDocumentData(p){const S=this.g.getDocument(p);if(S)return Promise.resolve(S);let h=this.h.get(p.toString());return h||(h=this.f.$tryOpenDocument(p).then(f=>{this.h.delete(p.toString());const o=g.URI.revive(f);return(0,$.$Tf)(this.g.getDocument(o))},f=>(this.h.delete(p.toString()),Promise.reject(f))),this.h.set(p.toString(),h)),h}createDocumentData(p){return this.f.$tryCreateDocument(p).then(S=>g.URI.revive(S))}$acceptModelLanguageChanged(p,S){const h=g.URI.revive(p),f=this.g.getDocument(h);if(!f)throw new Error("unknown document");this.b.fire(f.document),f._acceptLanguageId(S),this.a.fire(f.document)}$acceptModelSaved(p){const S=g.URI.revive(p),h=this.g.getDocument(S);if(!h)throw new Error("unknown document");this.$acceptDirtyStateChanged(p,!1),this.d.fire(h.document)}$acceptDirtyStateChanged(p,S){const h=g.URI.revive(p),f=this.g.getDocument(h);if(!f)throw new Error("unknown document");f._acceptIsDirty(S),this.c.fire({document:f.document,contentChanges:[],reason:void 0})}$acceptModelChanged(p,S,h){const f=g.URI.revive(p),o=this.g.getDocument(f);if(!o)throw new Error("unknown document");o._acceptIsDirty(h),o.onEvents(S);let i;S.isUndoing?i=L.TextDocumentChangeReason.Undo:S.isRedoing&&(i=L.TextDocumentChangeReason.Redo),this.c.fire((0,y.$wn)({document:o.document,contentChanges:S.changes.map(r=>({range:b.Range.to(r.range),rangeOffset:r.rangeOffset,rangeLength:r.rangeLength,text:r.text})),reason:i}))}setWordDefinitionFor(p,S){(0,A.$_M)(p,S)}}e.$6fc=C}),define(ke[69],Se([1,0,60,4,3,2,5,6,141,20,148,15,13,28,17,53,43]),function(me,e,D,O,g,I,A,b,$,y,L,C,m,p,S,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iN=e.$hN=void 0;class o{constructor(n){this.value=n,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let i=class{constructor(n,c){this.h=n,this.i=c,this.a=null,this.b=new Map,this.c=new p.$Ac,this.d=new O.$Vd,this.e=new O.$Vd,this.f=new O.$Vd,this.g=new O.$Vd,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(n){this.acceptDocumentsAndEditorsDelta(n)}acceptDocumentsAndEditorsDelta(n){const c=[],t=[],u=[];if(n.removedDocuments)for(const s of n.removedDocuments){const l=I.URI.revive(s),a=this.c.get(l);a?.unref()&&(this.c.delete(l),c.push(a.value))}if(n.addedDocuments)for(const s of n.addedDocuments){const l=I.URI.revive(s.uri);let a=this.c.get(l);if(a&&l.scheme!==S.Schemas.vscodeNotebookCell&&l.scheme!==S.Schemas.vscodeInteractiveInput)throw new Error(`document '${l} already exists!'`);a||(a=new o(new $.$aN(this.h.getProxy(b.$6K.MainThreadDocuments),l,s.lines,s.EOL,s.versionId,s.languageId,s.isDirty,s.notebook)),this.c.set(l,a),t.push(a.value)),a.ref()}if(n.removedEditors)for(const s of n.removedEditors){const l=this.b.get(s);this.b.delete(s),l&&u.push(l)}if(n.addedEditors)for(const s of n.addedEditors){const l=I.URI.revive(s.documentUri);D.ok(this.c.has(l),`document '${l}' does not exist`),D.ok(!this.b.has(s.id),`editor '${s.id}' already exists!`);const a=this.c.get(l).value,d=new L.$gN(s.id,this.h.getProxy(b.$6K.MainThreadTextEditors),this.i,new f.$V(()=>a.document),s.selections.map(C.Selection.to),s.options,s.visibleRanges.map(k=>C.Range.to(k)),typeof s.editorPosition=="number"?C.ViewColumn.to(s.editorPosition):void 0);this.b.set(s.id,d)}n.newActiveEditor!==void 0&&(D.ok(n.newActiveEditor===null||this.b.has(n.newActiveEditor),`active editor '${n.newActiveEditor}' does not exist`),this.a=n.newActiveEditor),(0,g.$Oc)(c),(0,g.$Oc)(u),n.removedDocuments&&this.e.fire(c),n.addedDocuments&&this.d.fire(t),(n.removedEditors||n.addedEditors)&&this.f.fire(this.allEditors().map(s=>s.value)),n.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(n){return this.c.get(n)?.value}allDocuments(){return h.Iterable.map(this.c.values(),n=>n.value)}getEditor(n){return this.b.get(n)}activeEditor(n){if(!this.a)return;const c=this.b.get(this.a);return n?c:c?.value}allEditors(){return[...this.b.values()]}};e.$hN=i,e.$hN=i=Ge([We(0,y.$0M),We(1,m.$nj)],i),e.$iN=(0,A.$6h)("IExtHostDocumentsAndEditors")}),define(ke[70],Se([1,0,73,4,18,2,5,6,20,15,7]),function(me,e,D,O,g,I,A,b,$,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ggc=e.$Fgc=void 0,e.$Fgc=(0,A.$6h)("IExtHostEditorTabs");class C{constructor(f,o,i){this.e=i,this.d=o,this.acceptDtoUpdate(f)}get apiObject(){if(!this.a){const f=this,o={get isActive(){return f.b.id===f.e()},get label(){return f.b.label},get input(){return f.c},get isDirty(){return f.b.isDirty},get isPinned(){return f.b.isPinned},get isPreview(){return f.b.isPreview},get group(){return f.d.apiObject}};this.a=Object.freeze(o)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(f){this.b=f,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new L.$NM(I.URI.revive(this.b.input.uri));case 2:return new L.$OM(I.URI.revive(this.b.input.original),I.URI.revive(this.b.input.modified));case 3:return new L.$PM(I.URI.revive(this.b.input.base),I.URI.revive(this.b.input.input1),I.URI.revive(this.b.input.input2),I.URI.revive(this.b.input.result));case 6:return new L.$QM(I.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new L.$RM(this.b.input.viewType);case 4:return new L.$SM(I.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new L.$TM(I.URI.revive(this.b.input.original),I.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new L.$UM;case 9:return new L.$VM(I.URI.revive(this.b.input.uri),I.URI.revive(this.b.input.inputBoxUri));case 10:return new L.$WM(this.b.input.providerId);default:return}}}class m{constructor(f,o){this.c=[],this.d="",this.b=f,this.e=o;for(const i of f.tabs)i.isActive&&(this.d=i.id),this.c.push(new C(i,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const f=this,o={get isActive(){return f.b.groupId===f.e()},get viewColumn(){return y.ViewColumn.to(f.b.viewColumn)},get activeTab(){return f.c.find(i=>i.tabId===f.d)?.apiObject},get tabs(){return Object.freeze(f.c.map(i=>i.apiObject))}};this.a=Object.freeze(o)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(f){this.b=f}acceptTabOperation(f){if(f.kind===0){const i=new C(f.tabDto,this,()=>this.activeTabId());return this.c.splice(f.index,0,i),f.tabDto.isActive&&(this.d=i.tabId),i}else if(f.kind===1){const i=this.c.splice(f.index,1)[0];if(!i)throw new Error(`Tab close updated received for index ${f.index} which does not exist`);return i.tabId===this.d&&(this.d=""),i}else if(f.kind===3){if(f.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const i=this.c.splice(f.oldIndex,1)[0];if(!i)throw new Error(`Tab move updated received for index ${f.oldIndex} which does not exist`);return this.c.splice(f.index,0,i),i}const o=this.c.find(i=>i.tabId===f.tabDto.id);if(!o)throw new Error("INVALID tab");return f.tabDto.isActive?this.d=f.tabDto.id:this.d===f.tabDto.id&&!f.tabDto.isActive&&(this.d=""),o.acceptDtoUpdate(f.tabDto),o}activeTabId(){return this.d}}let p=class{constructor(f){this.b=new O.$Vd,this.c=new O.$Vd,this.e=[],this.a=f.getProxy(b.$6K.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const f=this,o={onDidChangeTabGroups:f.c.event,onDidChangeTabs:f.b.event,get all(){return Object.freeze(f.e.map(i=>i.apiObject))},get activeTabGroup(){const i=f.d;return(0,g.$Tf)(f.e.find(n=>n.groupId===i)?.apiObject)},close:async(i,r)=>{const n=Array.isArray(i)?i:[i];return n.length?S(n[0])?this.j(n,r):this.i(n,r):!0}};this.f=Object.freeze(o)}return this.f}$acceptEditorTabModel(f){const o=new Set(this.e.map(s=>s.groupId)),i=new Set(f.map(s=>s.groupId)),r=(0,D.$L)(o,i),n=this.e.filter(s=>r.removed.includes(s.groupId)).map(s=>s.apiObject),c=[],t=[];this.e=f.map(s=>{const l=new m(s,()=>this.d);return r.added.includes(l.groupId)?c.push(l.apiObject):t.push(l.apiObject),l});const u=(0,g.$Tf)(f.find(s=>s.isActive===!0)?.groupId);u!==void 0&&this.d!==u&&(this.d=u),this.c.fire(Object.freeze({opened:c,closed:n,changed:t}))}$acceptTabGroupUpdate(f){const o=this.e.find(i=>i.groupId===f.groupId);if(!o)throw new Error("Update Group IPC call received before group creation.");o.acceptGroupDtoUpdate(f),f.isActive&&(this.d=f.groupId),this.c.fire(Object.freeze({changed:[o.apiObject],opened:[],closed:[]}))}$acceptTabOperation(f){const o=this.e.find(r=>r.groupId===f.groupId);if(!o)throw new Error("Update Tabs IPC call received before group creation.");const i=o.acceptTabOperation(f);switch(f.kind){case 0:this.b.fire(Object.freeze({opened:[i.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[i.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[i.apiObject]}));return}}g(f){for(const o of this.e)for(const i of o.tabs)if(i.apiObject===f)return i}h(f){return this.e.find(o=>o.apiObject===f)}async i(f,o){const i=[];for(const r of f){const n=this.g(r);if(!n)throw new Error("Tab close: Invalid tab not found!");i.push(n.tabId)}return this.a.$closeTab(i,o)}async j(f,o){const i=[];for(const r of f){const n=this.h(r);if(!n)throw new Error("Group close: Invalid group not found!");i.push(n.groupId)}return this.a.$closeGroup(i,o)}};e.$Ggc=p,e.$Ggc=p=Ge([We(0,$.$0M)],p);function S(h){return h.tabs!==void 0}}),define(ke[319],Se([1,0,6,7]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hhc=void 0;class g{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(D.$6K.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(A,b,$){if(this.a.size===0)throw new Error("No embedding vector providers registered");const y=this.a.get(A);if(!y)throw new Error("Embedding vector provider not found");const L=await y.provideEmbeddingVector(b,$);if(!L)throw new Error("Embedding vector provider returned undefined");return L}registerEmbeddingVectorProvider(A,b,$){const y=this.b;return this.b++,this.a.set(y,$),this.c.$registerAiEmbeddingVectorProvider(b,y),new O.$8K(()=>{this.c.$unregisterAiEmbeddingVectorProvider(y),this.a.delete(y)})}}e.$hhc=g}),define(ke[320],Se([1,0,2,6,3,7,15,173,12,22,25,80]),function(me,e,D,O,g,I,A,b,$,y,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ihc=void 0;class m{constructor(){this.a=[]}add(h){this.b=void 0,this.a.push(h)}delete(h){const f=this.a.indexOf(h);f>=0&&(this.a.splice(f,1),this.b=void 0)}c(){if(!this.b){const h=this.a.sort(),f=[];let o,i,r=14,n=14;for(const c of h){let t=o?(0,$.$bf)(o,c):0;for(t===0?i=1:i=n;t<c.length;t++)t+1===c.length?(r=n,n=9):n+=1,f.push([i,c.toUpperCase().charCodeAt(t),n]),f.push([i,c.toLowerCase().charCodeAt(t),n]),i=n;o=c,n=r}f.push([9,58,10]),f.push([10,47,12]),this.b=new b.$uZ(f)}}provideDocumentLinks(h){this.c();const f=[],o=b.$vZ.computeLinks({getLineContent(i){return h.lineAt(i-1).text},getLineCount(){return h.lineCount}},this.b);for(const i of o){const r=A.DocumentLink.to(i);r.target&&f.push(r)}return f}}class p{constructor(h,f){this.i=f,this.b=new m,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=h.getProxy(O.$6K.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(h,f,o,i={}){if(p.j(o),this.d.has(f))throw new Error(`a provider for the scheme '${f}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(h,"*",this.b));const r=this.h++;this.b.add(f),this.d.add(f),this.c.set(r,o);let n=2;i.isCaseSensitive&&(n+=1024),i.isReadonly&&(n+=2048),typeof o.copy=="function"&&(n+=8),typeof o.open=="function"&&typeof o.close=="function"&&typeof o.read=="function"&&typeof o.write=="function"&&((0,L.$CF)(h,"fsChunks"),n+=4);let c;i.isReadonly&&(0,C.$jk)(i.isReadonly)&&(c={value:i.isReadonly.value,isTrusted:i.isReadonly.isTrusted,supportThemeIcons:i.isReadonly.supportThemeIcons,supportHtml:i.isReadonly.supportHtml,baseUri:i.isReadonly.baseUri,uris:i.isReadonly.uris}),this.a.$registerFileSystemProvider(r,f,n,c).catch(u=>{console.error(`FAILED to register filesystem provider of ${h.identifier.value}-extension for the scheme ${f}`),console.error(u)});const t=o.onDidChangeFile(u=>{const s=[];for(const l of u){const{uri:a,type:d}=l;if(a.scheme!==f)continue;let k;switch(d){case I.FileChangeType.Changed:k=0;break;case I.FileChangeType.Created:k=1;break;case I.FileChangeType.Deleted:k=2;break;default:throw new Error("Unknown FileChangeType")}s.push({resource:a,type:k})}this.a.$onFileSystemChange(r,s)});return(0,g.$Rc)(()=>{t.dispose(),this.b.delete(f),this.d.delete(f),this.c.delete(r),this.a.$unregisterProvider(r)})}static j(h){if(!h)throw new Error("MISSING provider");if(typeof h.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof h.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof h.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof h.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof h.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof h.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof h.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof h.rename!="function")throw new Error("Provider does NOT implement rename")}static k(h){const{type:f,ctime:o,mtime:i,size:r,permissions:n}=h;return{type:f,ctime:o,mtime:i,size:r,permissions:n}}$stat(h,f){return Promise.resolve(this.l(h).stat(D.URI.revive(f))).then(o=>p.k(o))}$readdir(h,f){return Promise.resolve(this.l(h).readDirectory(D.URI.revive(f)))}$readFile(h,f){return Promise.resolve(this.l(h).readFile(D.URI.revive(f))).then(o=>y.$je.wrap(o))}$writeFile(h,f,o,i){return Promise.resolve(this.l(h).writeFile(D.URI.revive(f),o.buffer,i))}$delete(h,f,o){return Promise.resolve(this.l(h).delete(D.URI.revive(f),o))}$rename(h,f,o,i){return Promise.resolve(this.l(h).rename(D.URI.revive(f),D.URI.revive(o),i))}$copy(h,f,o,i){const r=this.l(h);if(!r.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(r.copy(D.URI.revive(f),D.URI.revive(o),i))}$mkdir(h,f){return Promise.resolve(this.l(h).createDirectory(D.URI.revive(f)))}$watch(h,f,o,i){const r=this.l(h).watch(D.URI.revive(o),i);this.f.set(f,r)}$unwatch(h,f){const o=this.f.get(f);o&&(o.dispose(),this.f.delete(f))}$open(h,f,o){const i=this.l(h);if(!i.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(i.open(D.URI.revive(f),o))}$close(h,f){const o=this.l(h);if(!o.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(o.close(f))}$read(h,f,o,i){const r=this.l(h);if(!r.read)throw new Error('FileSystemProvider does not implement "read"');const n=y.$je.alloc(i);return Promise.resolve(r.read(f,o,n.buffer,0,i)).then(c=>n.slice(0,c))}$write(h,f,o,i){const r=this.l(h);if(!r.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(r.write(f,o,i.buffer,0,i.byteLength))}l(h){const f=this.c.get(h);if(!f){const o=new Error;throw o.name="ENOPRO",o.message="no provider",o}return f}}e.$ihc=p}),define(ke[71],Se([1,0,6,32,7,22,5,20,58,3,11,23,17]),function(me,e,D,O,g,I,A,b,$,y,L,C,m){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$vgc=e.$ugc=void 0;let S=p=class{constructor(f,o){this.b=new Map,this.c=new L.$ch,this.a=f.getProxy(D.$6K.MainThreadFileSystem);const i=this;this.value=Object.freeze({async stat(r){try{let n;const c=i.b.get(r.scheme);return c?(await i.a.$ensureActivation(r.scheme),n=await c.impl.stat(r)):n=await i.a.$stat(r),{type:n.type,ctime:n.ctime,mtime:n.mtime,size:n.size,permissions:n.permissions===O.FilePermission.Readonly?1:void 0}}catch(n){p.e(n)}},async readDirectory(r){try{const n=i.b.get(r.scheme);return n?(await i.a.$ensureActivation(r.scheme),(await n.impl.readDirectory(r)).slice()):await i.a.$readdir(r)}catch(n){return p.e(n)}},async createDirectory(r){try{const n=i.b.get(r.scheme);return n&&!n.isReadonly?(await i.a.$ensureActivation(r.scheme),await i.d(n.impl,n.extUri,r)):await i.a.$mkdir(r)}catch(n){return p.e(n)}},async readFile(r){try{const n=i.b.get(r.scheme);return n?(await i.a.$ensureActivation(r.scheme),(await n.impl.readFile(r)).slice()):(await i.a.$readFile(r)).buffer}catch(n){return p.e(n)}},async writeFile(r,n){try{const c=i.b.get(r.scheme);return c&&!c.isReadonly?(await i.a.$ensureActivation(r.scheme),await i.d(c.impl,c.extUri,c.extUri.dirname(r)),await i.c.queueFor(r,()=>Promise.resolve(c.impl.writeFile(r,n,{create:!0,overwrite:!0})))):await i.a.$writeFile(r,I.$je.wrap(n))}catch(c){return p.e(c)}},async delete(r,n){try{const c=i.b.get(r.scheme);return c&&!c.isReadonly&&!n?.useTrash?(await i.a.$ensureActivation(r.scheme),await c.impl.delete(r,{recursive:!1,...n})):await i.a.$delete(r,{recursive:!1,useTrash:!1,atomic:!1,...n})}catch(c){return p.e(c)}},async rename(r,n,c){try{return await i.a.$rename(r,n,{overwrite:!1,...c})}catch(t){return p.e(t)}},async copy(r,n,c){try{return await i.a.$copy(r,n,{overwrite:!1,...c})}catch(t){return p.e(t)}},isWritableFileSystem(r){const n=o.getCapabilities(r);if(typeof n=="number")return!(n&2048)}})}async d(f,o,i){const r=[];for(;!o.isEqual(i,o.dirname(i));)try{if(!((await f.stat(i)).type&O.FileType.Directory))throw g.$jM.FileExists(`Unable to create folder '${i.scheme===m.Schemas.file?i.fsPath:i.toString(!0)}' that already exists but is not a directory`);break}catch(n){if(O.$Gk(n)!==O.FileSystemProviderErrorCode.FileNotFound)throw n;r.push(o.basename(i)),i=o.dirname(i)}for(let n=r.length-1;n>=0;n--){i=o.joinPath(i,r[n]);try{await f.createDirectory(i)}catch(c){if(O.$Gk(c)!==O.FileSystemProviderErrorCode.FileExists)throw c}}}static e(f){if(f instanceof g.$jM)throw f;if(f instanceof O.$Ck)switch(f.code){case O.FileSystemProviderErrorCode.FileExists:throw g.$jM.FileExists(f.message);case O.FileSystemProviderErrorCode.FileNotFound:throw g.$jM.FileNotFound(f.message);case O.FileSystemProviderErrorCode.FileNotADirectory:throw g.$jM.FileNotADirectory(f.message);case O.FileSystemProviderErrorCode.FileIsADirectory:throw g.$jM.FileIsADirectory(f.message);case O.FileSystemProviderErrorCode.NoPermissions:throw g.$jM.NoPermissions(f.message);case O.FileSystemProviderErrorCode.Unavailable:throw g.$jM.Unavailable(f.message);default:throw new g.$jM(f.message,f.name)}if(!(f instanceof Error))throw new g.$jM(String(f));if(f.name==="ENOPRO"||f.message.includes("ENOPRO"))throw g.$jM.Unavailable(f.message);switch(f.name){case O.FileSystemProviderErrorCode.FileExists:throw g.$jM.FileExists(f.message);case O.FileSystemProviderErrorCode.FileNotFound:throw g.$jM.FileNotFound(f.message);case O.FileSystemProviderErrorCode.FileNotADirectory:throw g.$jM.FileNotADirectory(f.message);case O.FileSystemProviderErrorCode.FileIsADirectory:throw g.$jM.FileIsADirectory(f.message);case O.FileSystemProviderErrorCode.NoPermissions:throw g.$jM.NoPermissions(f.message);case O.FileSystemProviderErrorCode.Unavailable:throw g.$jM.Unavailable(f.message);default:throw new g.$jM(f.message,f.name)}}addFileSystemProvider(f,o,i){return this.b.set(f,{impl:o,extUri:i?.isCaseSensitive?C.$xg:C.$zg,isReadonly:!!i?.isReadonly}),(0,y.$Rc)(()=>this.b.delete(f))}getFileSystemProviderExtUri(f){return this.b.get(f)?.extUri??C.$xg}};e.$ugc=S,e.$ugc=S=p=Ge([We(0,b.$0M),We(1,$.$8fc)],S),e.$vgc=(0,A.$6h)("IExtHostConsumerFileSystem")}),define(ke[321],Se([1,0,4,34,2,6,15,7,43]),function(me,e,D,O,g,I,A,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jhc=void 0;class y{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(p,S,h,f,o,i){this.a=Math.random(),this.b=new D.$Vd,this.c=new D.$Vd,this.d=new D.$Vd,this.h=0,i?.ignoreCreateEvents&&(this.h+=1),i?.ignoreChangeEvents&&(this.h+=2),i?.ignoreDeleteEvents&&(this.h+=4);const r=(0,O.$Mj)(o),n=typeof o=="string",c=i?.correlate,t=f(u=>{if(!(typeof u.session=="number"&&u.session!==this.a)&&!(c&&typeof u.session>"u")){if(!i?.ignoreCreateEvents)for(const s of u.created){const l=g.URI.revive(s);r(l.fsPath)&&(!n||S.getWorkspaceFolder(l))&&this.b.fire(l)}if(!i?.ignoreChangeEvents)for(const s of u.changed){const l=g.URI.revive(s);r(l.fsPath)&&(!n||S.getWorkspaceFolder(l))&&this.c.fire(l)}if(!i?.ignoreDeleteEvents)for(const s of u.deleted){const l=g.URI.revive(s);r(l.fsPath)&&(!n||S.getWorkspaceFolder(l))&&this.d.fire(l)}}});this.g=b.$8K.from(this.i(p,h,o,i,i?.correlate),this.b,this.c,this.d,t)}i(p,S,h,f,o){const i=b.$8K.from();if(typeof h=="string")return i;const r=p.getProxy(I.$6K.MainThreadFileSystemEventService);let n=!1;return(h.pattern.includes(O.$Ij)||h.pattern.includes(O.$Jj))&&(n=!0),r.$watch(S.identifier.value,this.a,h.baseUri,{recursive:n,excludes:f?.excludes??[]},!!o),b.$8K.from({dispose:()=>r.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class L{constructor(p){this.a=p,this.session=this.a.session,this.b=new $.$V(()=>this.a.created.map(g.URI.revive)),this.c=new $.$V(()=>this.a.changed.map(g.URI.revive)),this.d=new $.$V(()=>this.a.deleted.map(g.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class C{constructor(p,S,h){this.j=p,this.k=S,this.l=h,this.a=new D.$Vd,this.b=new D.$Vd,this.c=new D.$Vd,this.d=new D.$Vd,this.g=new D.$Xd,this.h=new D.$Xd,this.i=new D.$Xd,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(p,S,h,f){return new y(this.j,p,S,this.a.event,A.GlobPattern.from(h),f)}$onFileEvent(p){this.a.fire(new L(p))}$onDidRunFileOperation(p,S){switch(p){case 2:this.b.fire(Object.freeze({files:S.map(h=>({oldUri:g.URI.revive(h.source),newUri:g.URI.revive(h.target)}))}));break;case 1:this.d.fire(Object.freeze({files:S.map(h=>g.URI.revive(h.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:S.map(h=>g.URI.revive(h.target))}));break;default:}}getOnWillRenameFileEvent(p){return this.m(p,this.g)}getOnWillCreateFileEvent(p){return this.m(p,this.h)}getOnWillDeleteFileEvent(p){return this.m(p,this.i)}m(p,S){return(h,f,o)=>{const i=function(n){h.call(f,n)};return i.extension=p,S.event(i,void 0,o)}}async $onWillRunFileOperation(p,S,h,f){switch(p){case 2:return await this.n(this.g,{files:S.map(o=>({oldUri:g.URI.revive(o.source),newUri:g.URI.revive(o.target)}))},h,f);case 1:return await this.n(this.i,{files:S.map(o=>g.URI.revive(o.target))},h,f);case 0:case 3:return await this.n(this.h,{files:S.map(o=>g.URI.revive(o.target))},h,f)}}async n(p,S,h,f){const o=new Set,i=[];if(await p.fireAsync(S,f,async(n,c)=>{const t=Date.now(),u=await Promise.resolve(n);u instanceof b.$fL&&(i.push([c.extension,u]),o.add(c.extension.displayName??c.extension.identifier.value)),Date.now()-t>h&&this.k.warn("SLOW file-participant",c.extension.identifier)}),f.isCancellationRequested||i.length===0)return;const r={edits:[]};for(const[,n]of i){const{edits:c}=A.WorkspaceEdit.from(n,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});r.edits=r.edits.concat(c)}return{edit:r,extensionNames:Array.from(o)}}}e.$jhc=C}),define(ke[322],Se([1,0,3,2,6,15,7,35,11]),function(me,e,D,O,g,I,A,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$khc=void 0;class y{static{this.a=0}constructor(p,S){this.extension=p,this.provider=S,this.handle=y.a++}}class L{constructor(p){this.session=p,this.responses=[]}}class C{static{this.a=0}constructor(p,S,h,f){this.f=h,this.g=f,this.b=new Map,this.d=new Map,this.e=p.getProxy(g.$6K.MainThreadInlineChat),S.registerApiCommand(new b.$xN("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new b.$vN("Run arguments","",o=>!0,o=>{if(o)return{initialRange:o.initialRange?I.Range.from(o.initialRange):void 0,initialSelection:o.initialSelection?I.Selection.from(o.initialSelection):void 0,message:o.message,autoSend:o.autoSend,position:o.position?I.Position.from(o.position):void 0}})],b.$wN.Void))}registerProvider(p,S,h){const f=new y(p,S);return this.b.set(f.handle,f),this.e.$registerInteractiveEditorProvider(f.handle,h?.label??p.displayName??p.name,p.identifier.value,typeof S.handleInteractiveEditorResponseFeedback=="function",typeof S.provideFollowups=="function",h?.supportReportIssue??!1),(0,D.$Rc)(()=>{this.e.$unregisterInteractiveEditorProvider(f.handle),this.b.delete(f.handle)})}async $prepareSession(p,S,h,f){const o=this.b.get(p);if(!o){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const i=this.f.getDocument(O.URI.revive(S)),r=I.Selection.to(h),n=await o.provider.prepareInteractiveEditorSession({document:i,selection:r},f);if(!n)return;if(n.wholeRange&&!n.wholeRange.contains(r))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const c=C.a++;return this.d.set(c,new L(n)),{id:c,placeholder:n.placeholder,input:n.input,slashCommands:n.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:I.Range.from(n.wholeRange),message:n.message}}async $provideResponse(p,S,h,f){const o=this.b.get(p);if(!o)return;const i=this.d.get(S.id);if(!i)return;const r={prompt:h.prompt,selection:I.Selection.to(h.selection),wholeRange:I.Range.to(h.wholeRange),attempt:h.attempt,live:h.live,withIntentDetection:h.withIntentDetection};let n=!1;const c={report:async R=>{if(!h.live&&R.edits?.length)throw new Error("Progress reporting is only supported for live sessions");n||f.isCancellationRequested||await this.e.$handleProgressChunk(h.requestId,{message:R.message,edits:R.edits?.map(I.TextEdit.from),editsShouldBeInstant:R.editsShouldBeInstant,slashCommand:R.slashCommand?.command,markdownFragment:A.$wL.isMarkdownString(R.content)?R.content.value:R.content})}},t=Promise.resolve(o.provider.provideInteractiveEditorResponse(i.session,r,c,f));let u;try{u=await(0,$.$Ug)(t,f)}finally{n=!0}if(!u)return;const s=i.responses.push(u)-1,l={wholeRange:I.Range.from(u.wholeRange),placeholder:u.placeholder};if(!C.h(u))return{...l,id:s,type:"editorEdit",message:I.MarkdownString.from(u.contents),edits:[]};const{edits:a,contents:d}=u,k=d!==void 0?I.MarkdownString.from(d):void 0;return a instanceof A.$fL?{...l,id:s,type:"bulkEdit",edits:I.WorkspaceEdit.from(a),message:k}:{...l,id:s,type:"editorEdit",edits:a.map(I.TextEdit.from),message:k}}async $provideFollowups(p,S,h,f){const o=this.b.get(p),i=this.d.get(S),r=i?.responses[h];if(o&&r&&o.provider.provideFollowups){const n=Promise.resolve(o.provider.provideFollowups(i.session,r,f));return(await(0,$.$Ug)(n,f))?.map(I.ChatReplyFollowup.from)}}$handleFeedback(p,S,h,f){const o=this.b.get(p),i=this.d.get(S),r=i?.responses[h];if(o&&r){const n=I.InteractiveEditorResponseFeedbackKind.to(f);o.provider.handleInteractiveEditorResponseFeedback?.(i.session,r,n)}}$releaseSession(p,S){}static h(p){return typeof p=="object"&&typeof p.edits=="object"}}e.$khc=C}),define(ke[323],Se([1,0,2,35]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xhc=void 0;class g{constructor(A,b,$,y,L){this.a=b,this.b=$,this.c=y;const C=new O.$xN("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new O.$vN("showOptions","Show Options",m=>!0,m=>m),new O.$vN("resource","Interactive resource Uri",m=>!0,m=>m),new O.$vN("controllerId","Notebook controller Id",m=>!0,m=>m),new O.$vN("title","Interactive editor title",m=>!0,m=>m)],new O.$wN("Notebook and input URI",m=>{if(L.debug("[ExtHostInteractive] open iw with notebook editor id",m.notebookEditorId),m.notebookEditorId!==void 0){const p=this.a.getEditorById(m.notebookEditorId);return L.debug("[ExtHostInteractive] notebook editor found",p.id),{notebookUri:D.URI.revive(m.notebookUri),inputUri:D.URI.revive(m.inputUri),notebookEditor:p.apiEditor}}return L.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",m.notebookUri,m.inputUri),{notebookUri:D.URI.revive(m.notebookUri),inputUri:D.URI.revive(m.inputUri)}}));this.c.registerApiCommand(C)}$willAddInteractiveDocument(A,b,$,y){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:b,lines:[""],languageId:$,uri:A,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(D.URI.revive(y))?.apiNotebook}]})}$willRemoveInteractiveDocument(A,b){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.$xhc=g}),define(ke[324],Se([1,0,6,7]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yhc=void 0;class g{constructor(A){this.a=new Map,this.b=new Map,this.c=A.getProxy(D.$6K.MainThreadIssueReporter)}async $getIssueReporterUri(A,b){if(this.a.size===0)throw new Error("No issue request handlers registered");const $=this.a.get(A);if(!$)throw new Error("Issue request handler not found");const y=await $.handleIssueUrlRequest();if(!y)throw new Error("Issue request handler returned no result");return y}async $getIssueReporterData(A,b){if(this.b.size===0)throw new Error("No issue request handlers registered");const $=this.b.get(A);if(!$)throw new Error("Issue data provider not found");const y=await $.provideIssueData(b);if(!y)throw new Error("Issue data provider returned no result");return y}async $getIssueReporterTemplate(A,b){if(this.b.size===0)throw new Error("No issue request handlers registered");const $=this.b.get(A);if(!$)throw new Error("Issue data provider not found");const y=await $.provideIssueTemplate(b);if(!y)throw new Error("Issue template provider returned no result");return y}registerIssueUriRequestHandler(A,b){const $=A.identifier.value;return this.a.set($,b),this.c.$registerIssueUriRequestHandler($),new O.$8K(()=>{this.c.$unregisterIssueUriRequestHandler($),this.a.delete($)})}registerIssueDataProvider(A,b){const $=A.identifier.value;return this.b.set($,b),this.c.$registerIssueDataProvider($),new O.$8K(()=>{this.c.$unregisterIssueDataProvider($),this.b.delete($)})}}e.$yhc=g}),define(ke[325],Se([1,0,3,6]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zhc=void 0;class g{constructor(A){this.b=0,this.a=A.getProxy(O.$6K.MainThreadLabelService)}$registerResourceLabelFormatter(A){const b=this.b++;return this.a.$registerResourceLabelFormatter(b,A),(0,D.$Rc)(()=>{this.a.$unregisterResourceLabelFormatter(b)})}}e.$zhc=g}),define(ke[326],Se([1,0,2,24,15,7,83,6,12,29,19,18,169,21,26,3,131,121,110,38,14,11,25,213]),function(me,e,D,O,g,I,A,b,$,y,L,C,m,p,S,h,f,o,i,r,n,c,t,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bgc=void 0;class s{constructor(z,Q){this.d=z,this.e=Q}async provideDocumentSymbols(z,Q){const ee=this.d.getDocument(z),q=await this.e.provideDocumentSymbols(ee,Q);if(!(0,L.$Kb)(q))return q[0]instanceof I.$oL?q.map(g.DocumentSymbol.from):s.f(q)}static f(z){z=z.slice(0).sort((q,ae)=>{let le=q.location.range.start.compareTo(ae.location.range.start);return le===0&&(le=ae.location.range.end.compareTo(q.location.range.end)),le});const Q=[],ee=[];for(const q of z){const ae={name:q.name||"!!MISSING: name!!",kind:g.SymbolKind.from(q.kind),tags:q.tags?.map(g.SymbolTag.from)||[],detail:"",containerName:q.containerName,range:g.Range.from(q.location.range),selectionRange:g.Range.from(q.location.range),children:[]};for(;;){if(ee.length===0){ee.push(ae),Q.push(ae);break}const le=ee[ee.length-1];if(y.$Us.containsRange(le.range,ae.range)&&!y.$Us.equalsRange(le.range,ae.range)){le.children?.push(ae),ee.push(ae);break}ee.pop()}}return Q}}class l{constructor(z,Q,ee,q,ae,le){this.f=z,this.g=Q,this.h=ee,this.j=q,this.k=ae,this.l=le,this.d=new i.$4fc("CodeLens"),this.e=new Map}async provideCodeLenses(z,Q){const ee=this.f.getDocument(z),q=await this.h.provideCodeLenses(ee,Q);if(!q||Q.isCancellationRequested)return;const ae=this.d.add(q),le=new h.$Sc;this.e.set(ae,le);const Le={cacheId:ae,lenses:[]};for(let je=0;je<q.length;je++)Le.lenses.push({cacheId:[ae,je],range:g.Range.from(q[je].range),command:this.g.toInternal(q[je].command,le)});return Le}async resolveCodeLens(z,Q){const ee=z.cacheId&&this.d.get(...z.cacheId);if(!ee)return;let q;if(typeof this.h.resolveCodeLens!="function"||ee.isResolved?q=ee:q=await this.h.resolveCodeLens(ee,Q),q||(q=ee),Q.isCancellationRequested)return;const ae=z.cacheId&&this.e.get(z.cacheId[0]);if(ae){if(!q.command){const le=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,le),this.l.error(le);return}return z.command=this.g.toInternal(q.command,ae),z}}releaseCodeLenses(z){this.e.get(z)?.dispose(),this.e.delete(z),this.d.delete(z)}}function a(De){return Array.isArray(De)?De.map(g.DefinitionLink.from):De?[g.DefinitionLink.from(De)]:[]}class d{constructor(z,Q){this.d=z,this.e=Q}async provideDefinition(z,Q,ee){const q=this.d.getDocument(z),ae=g.Position.to(Q),le=await this.e.provideDefinition(q,ae,ee);return a(le)}}class k{constructor(z,Q){this.d=z,this.e=Q}async provideDeclaration(z,Q,ee){const q=this.d.getDocument(z),ae=g.Position.to(Q),le=await this.e.provideDeclaration(q,ae,ee);return a(le)}}class R{constructor(z,Q){this.d=z,this.e=Q}async provideImplementation(z,Q,ee){const q=this.d.getDocument(z),ae=g.Position.to(Q),le=await this.e.provideImplementation(q,ae,ee);return a(le)}}class v{constructor(z,Q){this.d=z,this.e=Q}async provideTypeDefinition(z,Q,ee){const q=this.d.getDocument(z),ae=g.Position.to(Q),le=await this.e.provideTypeDefinition(q,ae,ee);return a(le)}}class w{constructor(z,Q){this.d=z,this.e=Q}async provideHover(z,Q,ee){const q=this.d.getDocument(z),ae=g.Position.to(Q),le=await this.e.provideHover(q,ae,ee);if(!(!le||(0,L.$Kb)(le.contents)))return le.range||(le.range=q.getWordRangeAtPosition(ae)),le.range||(le.range=new I.$0K(ae,ae)),g.Hover.from(le)}}class E{constructor(z,Q){this.d=z,this.e=Q}async provideEvaluatableExpression(z,Q,ee){const q=this.d.getDocument(z),ae=g.Position.to(Q),le=await this.e.provideEvaluatableExpression(q,ae,ee);if(le)return g.EvaluatableExpression.from(le)}}class P{constructor(z,Q){this.d=z,this.e=Q}async provideInlineValues(z,Q,ee,q){const ae=this.d.getDocument(z),le=await this.e.provideInlineValues(ae,g.Range.to(Q),g.InlineValueContext.to(ee),q);if(Array.isArray(le))return le.map(Le=>g.InlineValue.from(Le))}}class N{constructor(z,Q){this.d=z,this.e=Q}async provideDocumentHighlights(z,Q,ee){const q=this.d.getDocument(z),ae=g.Position.to(Q),le=await this.e.provideDocumentHighlights(q,ae,ee);if(Array.isArray(le))return le.map(g.DocumentHighlight.from)}}class U{constructor(z,Q){this.d=z,this.e=Q}async provideMultiDocumentHighlights(z,Q,ee,q){const ae=this.d.getDocument(z),le=ee.map(He=>this.d.getDocument(He)),Le=g.Position.to(Q),je=await this.e.provideMultiDocumentHighlights(ae,Le,le,q);if(Array.isArray(je))return je.map(g.MultiDocumentHighlight.from)}}class F{constructor(z,Q){this.d=z,this.e=Q}async provideLinkedEditingRanges(z,Q,ee){const q=this.d.getDocument(z),ae=g.Position.to(Q),le=await this.e.provideLinkedEditingRanges(q,ae,ee);if(le&&Array.isArray(le.ranges))return{ranges:(0,L.$Hb)(le.ranges.map(g.Range.from)),wordPattern:le.wordPattern}}}class j{constructor(z,Q){this.d=z,this.e=Q}async provideReferences(z,Q,ee,q){const ae=this.d.getDocument(z),le=g.Position.to(Q),Le=await this.e.provideReferences(ae,le,ee,q);if(Array.isArray(Le))return Le.map(g.location.from)}}class T{static{this.d=1e3}constructor(z,Q,ee,q,ae,le,Le){this.g=z,this.h=Q,this.j=ee,this.k=q,this.l=ae,this.m=le,this.n=Le,this.e=new i.$4fc("CodeAction"),this.f=new Map}async provideCodeActions(z,Q,ee,q){const ae=this.g.getDocument(z),le=m.$Ws.isISelection(Q)?g.Selection.to(Q):g.Range.to(Q),Le=[];for(const ot of this.j.getDiagnostics(z))if(le.intersection(ot.range)&&Le.push(ot)>T.d)break;const je={diagnostics:Le,only:ee.only?new I.$qL(ee.only):void 0,triggerKind:g.CodeActionTriggerKind.to(ee.trigger)},He=await this.k.provideCodeActions(ae,le,je,q);if(!(0,L.$Lb)(He)||q.isCancellationRequested)return;const Je=this.e.add(He),_e=new h.$Sc;this.f.set(Je,_e);const ct=[];for(let ot=0;ot<He.length;ot++){const rt=He[ot];rt&&(T.o(rt)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),ct.push({_isSynthetic:!0,title:rt.title,command:this.h.toInternal(rt,_e)})):(je.only&&(rt.kind?je.only.contains(rt.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${je.only.value} 'requested but returned code action is of kind '${rt.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${je.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),ct.push({cacheId:[Je,ot],title:rt.title,command:rt.command&&this.h.toInternal(rt.command,_e),diagnostics:rt.diagnostics&&rt.diagnostics.map(g.Diagnostic.from),edit:rt.edit&&g.WorkspaceEdit.from(rt.edit,void 0),kind:rt.kind&&rt.kind.value,isPreferred:rt.isPreferred,isAI:(0,t.$BF)(this.m,"codeActionAI")?rt.isAI:!1,disabled:rt.disabled?.reason})))}return{cacheId:Je,actions:ct}}async resolveCodeAction(z,Q){const[ee,q]=z,ae=this.e.get(ee,q);if(!ae||T.o(ae))return{};if(!this.k.resolveCodeAction)return{};const le=await this.k.resolveCodeAction(ae,Q)??ae;let Le;le.edit&&(Le=g.WorkspaceEdit.from(le.edit,void 0));let je;if(le.command){const He=this.f.get(ee);He&&(je=this.h.toInternal(le.command,He))}return{edit:Le,command:je}}releaseCodeActions(z){this.f.get(z)?.dispose(),this.f.delete(z),this.e.delete(z)}static o(z){return typeof z.command=="string"&&typeof z.title=="string"}}class M{static toInternalProviderId(z,Q){return z+"."+Q}constructor(z,Q,ee,q,ae){this.d=z,this.e=Q,this.f=ee,this.g=q,this.h=ae}async prepareDocumentPaste(z,Q,ee,q){if(!this.f.prepareDocumentPaste)return;const ae=this.e.getDocument(z),le=Q.map(He=>g.Range.to(He)),Le=g.DataTransfer.toDataTransfer(ee,()=>{throw new n.$$});if(await this.f.prepareDocumentPaste(ae,le,Le,q),q.isCancellationRequested)return;const je=Array.from(Le).filter(([,He])=>!(He instanceof I.$WL));return g.DataTransfer.from(je)}async providePasteEdits(z,Q,ee,q,ae){if(!this.f.provideDocumentPasteEdits)return;const le=this.e.getDocument(Q),Le=ee.map(Je=>g.Range.to(Je)),je=g.DataTransfer.toDataTransfer(q,async Je=>(await this.d.$resolvePasteFileData(this.g,z,Je)).buffer),He=await this.f.provideDocumentPasteEdits(le,Le,je,ae);if(He)return{label:He.label??(0,u.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:He.yieldTo?.map(Je=>"mimeType"in Je?Je:{providerId:M.toInternalProviderId(Je.extensionId,Je.providerId)}),insertText:typeof He.insertText=="string"?He.insertText:{snippet:He.insertText.value},additionalEdit:He.additionalEdit?g.WorkspaceEdit.from(He.additionalEdit,void 0):void 0}}}class B{constructor(z,Q){this.d=z,this.e=Q}async provideDocumentFormattingEdits(z,Q,ee){const q=this.d.getDocument(z),ae=await this.e.provideDocumentFormattingEdits(q,Q,ee);if(Array.isArray(ae))return ae.map(g.TextEdit.from)}}class Y{constructor(z,Q){this.d=z,this.e=Q}async provideDocumentRangeFormattingEdits(z,Q,ee,q){const ae=this.d.getDocument(z),le=g.Range.to(Q),Le=await this.e.provideDocumentRangeFormattingEdits(ae,le,ee,q);if(Array.isArray(Le))return Le.map(g.TextEdit.from)}async provideDocumentRangesFormattingEdits(z,Q,ee,q){(0,C.$Sf)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const ae=this.d.getDocument(z),le=Q.map(g.Range.to),Le=await this.e.provideDocumentRangesFormattingEdits(ae,le,ee,q);if(Array.isArray(Le))return Le.map(g.TextEdit.from)}}class ue{constructor(z,Q){this.d=z,this.e=Q,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(z,Q,ee,q,ae){const le=this.d.getDocument(z),Le=g.Position.to(Q),je=await this.e.provideOnTypeFormattingEdits(le,Le,ee,q,ae);if(Array.isArray(je))return je.map(g.TextEdit.from)}}class Z{constructor(z,Q){this.e=z,this.f=Q,this.d=new i.$4fc("WorkspaceSymbols")}async provideWorkspaceSymbols(z,Q){const ee=await this.e.provideWorkspaceSymbols(z,Q);if(!(0,L.$Lb)(ee))return{symbols:[]};const q=this.d.add(ee),ae={cacheId:q,symbols:[]};for(let le=0;le<ee.length;le++){const Le=ee[le];if(!Le||!Le.name){this.f.warn("INVALID SymbolInformation",Le);continue}ae.symbols.push({...g.WorkspaceSymbol.from(Le),cacheId:[q,le]})}return ae}async resolveWorkspaceSymbol(z,Q){if(typeof this.e.resolveWorkspaceSymbol!="function"||!z.cacheId)return z;const ee=this.d.get(...z.cacheId);if(ee){const q=await this.e.resolveWorkspaceSymbol(ee,Q);return q&&(0,O.$yn)(z,g.WorkspaceSymbol.from(q),!0)}}releaseWorkspaceSymbols(z){this.d.delete(z)}}class J{static supportsResolving(z){return typeof z.prepareRename=="function"}constructor(z,Q,ee){this.d=z,this.e=Q,this.f=ee}async provideRenameEdits(z,Q,ee,q){const ae=this.d.getDocument(z),le=g.Position.to(Q);try{const Le=await this.e.provideRenameEdits(ae,le,ee,q);return Le?g.WorkspaceEdit.from(Le):void 0}catch(Le){const je=J.g(Le);return je?{rejectReason:je,edits:void 0}:Promise.reject(Le)}}async resolveRenameLocation(z,Q,ee){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const q=this.d.getDocument(z),ae=g.Position.to(Q);try{const le=await this.e.prepareRename(q,ae,ee);let Le,je;if(I.$0K.isRange(le)?(Le=le,je=q.getText(le)):(0,C.$Kf)(le)&&(Le=le.range,je=le.placeholder),!Le||!je)return;if(Le.start.line>ae.line||Le.end.line<ae.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:g.Range.from(Le),text:je}}catch(le){const Le=J.g(le);return Le?{rejectReason:Le,range:void 0,text:void 0}:Promise.reject(le)}}static g(z){return typeof z=="string"?z:z instanceof Error&&typeof z.message=="string"?z.message:void 0}}class X{constructor(z,Q){this.resultId=z,this.tokens=Q}}class he{constructor(z,Q){this.f=z,this.g=Q,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(z,Q,ee){const q=this.f.getDocument(z),ae=Q!==0?this.d.get(Q):null;let le=typeof ae?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(q,ae.resultId,ee):await this.g.provideDocumentSemanticTokens(q,ee);return ae&&this.d.delete(Q),le?(le=he.h(le),this.o(he.n(ae,le),le)):null}async releaseDocumentSemanticColoring(z){this.d.delete(z)}static h(z){return he.j(z)?he.k(z)?z:new I.$nM(new Uint32Array(z.data),z.resultId):he.l(z)?he.m(z)?z:new I.$pM(z.edits.map(Q=>new I.$oM(Q.start,Q.deleteCount,Q.data?new Uint32Array(Q.data):Q.data)),z.resultId):z}static j(z){return z&&!!z.data}static k(z){return z.data instanceof Uint32Array}static l(z){return z&&Array.isArray(z.edits)}static m(z){for(const Q of z.edits)if(!(Q.data instanceof Uint32Array))return!1;return!0}static n(z,Q){if(!he.j(Q)||!z||!z.tokens)return Q;const ee=z.tokens,q=ee.length,ae=Q.data,le=ae.length;let Le=0;const je=Math.min(q,le);for(;Le<je&&ee[Le]===ae[Le];)Le++;if(Le===q&&Le===le)return new I.$pM([],Q.resultId);let He=0;const Je=je-Le;for(;He<Je&&ee[q-He-1]===ae[le-He-1];)He++;return new I.$pM([{start:Le,deleteCount:q-Le-He,data:ae.subarray(Le,le-He)}],Q.resultId)}o(z,Q){if(he.j(z)){const ee=this.e++;return this.d.set(ee,new X(z.resultId,z.data)),(0,f.$s$)({id:ee,type:"full",data:z.data})}if(he.l(z)){const ee=this.e++;return he.j(Q)?this.d.set(ee,new X(Q.resultId,Q.data)):this.d.set(ee,new X(z.resultId)),(0,f.$s$)({id:ee,type:"delta",deltas:(z.edits||[]).map(q=>({start:q.start,deleteCount:q.deleteCount,data:q.data}))})}return null}}class _{constructor(z,Q){this.d=z,this.e=Q}async provideDocumentRangeSemanticTokens(z,Q,ee){const q=this.d.getDocument(z),ae=await this.e.provideDocumentRangeSemanticTokens(q,g.Range.to(Q),ee);return ae?this.f(ae):null}f(z){return(0,f.$s$)({id:0,type:"full",data:z.data})}}class we{static supportsResolving(z){return typeof z.resolveCompletionItem=="function"}constructor(z,Q,ee,q,ae){this.f=z,this.g=Q,this.h=ee,this.j=q,this.k=ae,this.d=new i.$4fc("CompletionItem"),this.e=new Map}async provideCompletionItems(z,Q,ee,q){const ae=this.f.getDocument(z),le=g.Position.to(Q),Le=ae.getWordRangeAtPosition(le)||new I.$0K(le,le),je=Le.with({end:le}),He=new r.$Rd,Je=await this.h.provideCompletionItems(ae,le,q,g.CompletionContext.to(ee));if(!Je||q.isCancellationRequested)return;const _e=Array.isArray(Je)?new I.$DL(Je):Je,ct=we.supportsResolving(this.h)?this.d.add(_e.items):this.d.add([]),ot=new h.$Sc;this.e.set(ct,ot);const rt=[],Re={x:ct,b:rt,a:{replace:g.Range.from(Le),insert:g.Range.from(je)},c:_e.isIncomplete||void 0,d:He.elapsed()};for(let Ue=0;Ue<_e.items.length;Ue++){const Ae=_e.items[Ue],Xe=this.l(Ae,[ct,Ue],je,Le);rt.push(Xe)}return Re}async resolveCompletionItem(z,Q){if(typeof this.h.resolveCompletionItem!="function")return;const ee=this.d.get(...z);if(!ee)return;const q=this.l(ee,z),ae=await this.h.resolveCompletionItem(ee,Q);if(!ae)return;const le=this.l(ae,z);return(q.h!==le.h||q.i!==le.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(q.n!==le.n||q.o!==le.o||!(0,O.$zn)(q.p,le.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...q,d:le.d,c:le.c,l:le.l,h:le.h,i:le.i,n:le.n,o:le.o,p:le.p}}releaseCompletionItems(z){this.e.get(z)?.dispose(),this.e.delete(z),this.d.delete(z)}l(z,Q,ee,q){const ae=this.e.get(Q[0]);if(!ae)throw Error("DisposableStore is missing...");const le=this.g.toInternal(z.command,ae),Le={x:Q,a:z.label,b:z.kind!==void 0?g.CompletionItemKind.from(z.kind):void 0,m:z.tags&&z.tags.map(g.CompletionItemTag.from),c:z.detail,d:typeof z.documentation>"u"?void 0:g.MarkdownString.fromStrict(z.documentation),e:z.sortText!==z.label?z.sortText:void 0,f:z.filterText!==z.label?z.filterText:void 0,g:z.preselect||void 0,i:z.keepWhitespace?1:0,k:z.commitCharacters?.join(""),l:z.additionalTextEdits&&z.additionalTextEdits.map(g.TextEdit.from),n:le?.$ident,o:le?.id,p:le?.$ident?void 0:le?.arguments};z.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Le.h=z.textEdit.newText):typeof z.insertText=="string"?Le.h=z.insertText:z.insertText instanceof I.$gL&&(Le.h=z.insertText.value,Le.i|=4);let je;return z.textEdit?je=z.textEdit.range:z.range&&(je=z.range),I.$0K.isRange(je)?Le.j=g.Range.from(je):je&&(!ee?.isEqual(je.inserting)||!q?.isEqual(je.replacing))&&(Le.j={insert:g.Range.from(je.inserting),replace:g.Range.from(je.replacing)}),Le}}class oe{async provideInlineCompletions(z,Q,ee,q){}disposeCompletions(z){}handleDidShowCompletionItem(z,Q,ee){}handlePartialAccept(z,Q,ee){}}class K extends oe{constructor(z,Q,ee,q){super(),this.f=z,this.g=Q,this.h=ee,this.j=q,this.d=new W,this.e=(0,t.$BF)(this.f,"inlineCompletionsAdditions"),this.k={[A.InlineCompletionTriggerKind.Automatic]:I.InlineCompletionTriggerKind.Automatic,[A.InlineCompletionTriggerKind.Explicit]:I.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.$BF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(z,Q,ee,q){const ae=this.g.getDocument(z),le=g.Position.to(Q),Le=await this.h.provideInlineCompletionItems(ae,le,{selectedCompletionInfo:ee.selectedSuggestionInfo?{range:g.Range.to(ee.selectedSuggestionInfo.range),text:ee.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[ee.triggerKind]},q);if(!Le||q.isCancellationRequested)return;const je=Array.isArray(Le)?Le:Le.items,He=this.e?Array.isArray(Le)?[]:Le.commands||[]:[],Je=this.e&&!Array.isArray(Le)?Le.enableForwardStability:void 0;let _e;return{pid:this.d.createReferenceId({dispose(){_e?.dispose()},items:je}),items:je.map((ot,rt)=>{let Re;ot.command&&(_e||(_e=new h.$Sc),Re=this.j.toInternal(ot.command,_e));const Ue=ot.insertText;return{insertText:typeof Ue=="string"?Ue:{snippet:Ue.value},filterText:ot.filterText,range:ot.range?g.Range.from(ot.range):void 0,command:Re,idx:rt,completeBracketPairs:this.e?ot.completeBracketPairs:!1}}),commands:He.map(ot=>(_e||(_e=new h.$Sc),this.j.toInternal(ot,_e))),suppressSuggestions:!1,enableForwardStability:Je}}disposeCompletions(z){this.d.disposeReferenceId(z)?.dispose()}handleDidShowCompletionItem(z,Q,ee){const q=this.d.get(z)?.items[Q];q&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(q,ee)}handlePartialAccept(z,Q,ee){const q=this.d.get(z)?.items[Q];q&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(q,ee)}}class W{constructor(){this.d=new Map,this.e=1}createReferenceId(z){const Q=this.e++;return this.d.set(Q,z),Q}disposeReferenceId(z){const Q=this.d.get(z);return this.d.delete(z),Q}get(z){return this.d.get(z)}}class re{constructor(z,Q){this.e=z,this.f=Q,this.d=new i.$4fc("SignatureHelp")}async provideSignatureHelp(z,Q,ee,q){const ae=this.e.getDocument(z),le=g.Position.to(Q),Le=this.g(ee),je=await this.f.provideSignatureHelp(ae,le,q,Le);if(je){const He=this.d.add([je]);return{...g.SignatureHelp.from(je),id:He}}}g(z){let Q;if(z.activeSignatureHelp){const ee=g.SignatureHelp.to(z.activeSignatureHelp),q=this.d.get(z.activeSignatureHelp.id,0);q?(Q=q,Q.activeSignature=ee.activeSignature,Q.activeParameter=ee.activeParameter):Q=ee}return{...z,activeSignatureHelp:Q}}releaseSignatureHelp(z){this.d.delete(z)}}class ye{constructor(z,Q,ee,q,ae){this.f=z,this.g=Q,this.h=ee,this.j=q,this.k=ae,this.d=new i.$4fc("InlayHints"),this.e=new Map}async provideInlayHints(z,Q,ee){const q=this.f.getDocument(z),ae=g.Range.to(Q),le=await this.h.provideInlayHints(q,ae,ee);if(!Array.isArray(le)||le.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(Q)}`);return}if(ee.isCancellationRequested)return;const Le=this.d.add(le);this.e.set(Le,new h.$Sc);const je={hints:[],cacheId:Le};for(let He=0;He<le.length;He++)this.l(le[He],ae)&&je.hints.push(this.m(le[He],[Le,He]));return this.j.trace(`[InlayHints] ${je.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(Q)}`),je}async resolveInlayHint(z,Q){if(typeof this.h.resolveInlayHint!="function")return;const ee=this.d.get(...z);if(!ee)return;const q=await this.h.resolveInlayHint(ee,Q);if(q&&this.l(q))return this.m(q,z)}releaseHints(z){this.e.get(z)?.dispose(),this.e.delete(z),this.d.delete(z)}l(z,Q){return z.label.length===0||Array.isArray(z.label)&&z.label.every(ee=>ee.value.length===0)?(console.log("INVALID inlay hint, empty label",z),!1):!(Q&&!Q.contains(z.position))}m(z,Q){const ee=this.e.get(Q[0]);if(!ee)throw Error("DisposableStore is missing...");const q={label:"",cacheId:Q,tooltip:g.MarkdownString.fromStrict(z.tooltip),position:g.Position.from(z.position),textEdits:z.textEdits&&z.textEdits.map(g.TextEdit.from),kind:z.kind&&g.InlayHintKind.from(z.kind),paddingLeft:z.paddingLeft,paddingRight:z.paddingRight};if(typeof z.label=="string")q.label=z.label;else{const ae=[];q.label=ae;for(const le of z.label){if(!le.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Le={label:le.value,tooltip:g.MarkdownString.fromStrict(le.tooltip)};I.$hL.isLocation(le.location)&&(Le.location=g.location.from(le.location)),le.command&&(Le.command=this.g.toInternal(le.command,ee)),ae.push(Le)}}return q}}class de{constructor(z,Q){this.e=z,this.f=Q,this.d=new i.$4fc("DocumentLink")}async provideLinks(z,Q){const ee=this.e.getDocument(z),q=await this.f.provideDocumentLinks(ee,Q);if(!(!Array.isArray(q)||q.length===0)&&!Q.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:q.filter(de.g).map(g.DocumentLink.from)};{const ae=this.d.add(q),le={links:[],cacheId:ae};for(let Le=0;Le<q.length;Le++){if(!de.g(q[Le]))continue;const je=g.DocumentLink.from(q[Le]);je.cacheId=[ae,Le],le.links.push(je)}return le}}}static g(z){return z.target&&z.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(z,Q){if(typeof this.f.resolveDocumentLink!="function")return;const ee=this.d.get(...z);if(!ee)return;const q=await this.f.resolveDocumentLink(ee,Q);if(!(!q||!de.g(q)))return g.DocumentLink.from(q)}releaseLinks(z){this.d.delete(z)}}class ge{constructor(z,Q){this.d=z,this.e=Q}async provideColors(z,Q){const ee=this.d.getDocument(z),q=await this.e.provideDocumentColors(ee,Q);return Array.isArray(q)?q.map(le=>({color:g.Color.from(le.color),range:g.Range.from(le.range)})):[]}async provideColorPresentations(z,Q,ee){const q=this.d.getDocument(z),ae=g.Range.to(Q.range),le=g.Color.to(Q.color),Le=await this.e.provideColorPresentations(le,{document:q,range:ae},ee);if(Array.isArray(Le))return Le.map(g.ColorPresentation.from)}}class x{constructor(z,Q){this.d=z,this.e=Q}async provideFoldingRanges(z,Q,ee){const q=this.d.getDocument(z),ae=await this.e.provideFoldingRanges(q,Q,ee);if(Array.isArray(ae))return ae.map(g.FoldingRange.from)}}class te{constructor(z,Q,ee){this.d=z,this.e=Q,this.f=ee}async provideSelectionRanges(z,Q,ee){const q=this.d.getDocument(z),ae=Q.map(g.Position.to),le=await this.e.provideSelectionRanges(q,ae,ee);if(!(0,L.$Lb)(le))return[];if(le.length!==ae.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Le=[];for(let je=0;je<ae.length;je++){const He=[];Le.push(He);let Je=ae[je],_e=le[je];for(;;){if(!_e.range.contains(Je))throw new Error("INVALID selection range, must contain the previous range");if(He.push(g.SelectionRange.from(_e)),!_e.parent)break;Je=_e.range,_e=_e.parent}}return Le}}class G{constructor(z,Q){this.f=z,this.g=Q,this.d=new o.$cN(""),this.e=new Map}async prepareSession(z,Q,ee){const q=this.f.getDocument(z),ae=g.Position.to(Q),le=await this.g.prepareCallHierarchy(q,ae,ee);if(!le)return;const Le=this.d.nextId();return this.e.set(Le,new Map),Array.isArray(le)?le.map(je=>this.h(Le,je)):[this.h(Le,le)]}async provideCallsTo(z,Q,ee){const q=this.j(z,Q);if(!q)throw new Error("missing call hierarchy item");const ae=await this.g.provideCallHierarchyIncomingCalls(q,ee);if(ae)return ae.map(le=>({from:this.h(z,le.from),fromRanges:le.fromRanges.map(Le=>g.Range.from(Le))}))}async provideCallsFrom(z,Q,ee){const q=this.j(z,Q);if(!q)throw new Error("missing call hierarchy item");const ae=await this.g.provideCallHierarchyOutgoingCalls(q,ee);if(ae)return ae.map(le=>({to:this.h(z,le.to),fromRanges:le.fromRanges.map(Le=>g.Range.from(Le))}))}releaseSession(z){this.e.delete(z)}h(z,Q){const ee=this.e.get(z),q=g.CallHierarchyItem.from(Q,z,ee.size.toString(36));return ee.set(q._itemId,Q),q}j(z,Q){return this.e.get(z)?.get(Q)}}class ie{constructor(z,Q){this.f=z,this.g=Q,this.d=new o.$cN(""),this.e=new Map}async prepareSession(z,Q,ee){const q=this.f.getDocument(z),ae=g.Position.to(Q),le=await this.g.prepareTypeHierarchy(q,ae,ee);if(!le)return;const Le=this.d.nextId();return this.e.set(Le,new Map),Array.isArray(le)?le.map(je=>this.h(Le,je)):[this.h(Le,le)]}async provideSupertypes(z,Q,ee){const q=this.j(z,Q);if(!q)throw new Error("missing type hierarchy item");const ae=await this.g.provideTypeHierarchySupertypes(q,ee);if(ae)return ae.map(le=>this.h(z,le))}async provideSubtypes(z,Q,ee){const q=this.j(z,Q);if(!q)throw new Error("missing type hierarchy item");const ae=await this.g.provideTypeHierarchySubtypes(q,ee);if(ae)return ae.map(le=>this.h(z,le))}releaseSession(z){this.e.delete(z)}h(z,Q){const ee=this.e.get(z),q=g.TypeHierarchyItem.from(Q,z,ee.size.toString(36));return ee.set(q._itemId,Q),q}j(z,Q){return this.e.get(z)?.get(Q)}}class fe{static toInternalProviderId(z,Q){return z+"."+Q}constructor(z,Q,ee,q,ae){this.d=z,this.e=Q,this.f=ee,this.g=q,this.h=ae}async provideDocumentOnDropEdits(z,Q,ee,q,ae){const le=this.e.getDocument(Q),Le=g.Position.to(ee),je=g.DataTransfer.toDataTransfer(q,async Je=>(await this.d.$resolveDocumentOnDropFileData(this.g,z,Je)).buffer),He=await this.f.provideDocumentDropEdits(le,Le,je,ae);if(He)return{label:He.label??(0,u.localize)(1,null,this.h.displayName||this.h.name),yieldTo:He.yieldTo?.map(Je=>"mimeType"in Je?Je:{providerId:fe.toInternalProviderId(Je.extensionId,Je.providerId)}),insertText:typeof He.insertText=="string"?He.insertText:{snippet:He.insertText.value},additionalEdit:He.additionalEdit?g.WorkspaceEdit.from(He.additionalEdit,void 0):void 0}}}class pe{constructor(z,Q){this.d=z,this.e=Q}async provideMappedEdits(z,Q,ee,q){const ae=D.URI.revive(z),le=this.d.getDocument(ae),Le=ee.documents.map(Je=>Je.map(_e=>({uri:D.URI.revive(_e.uri),version:_e.version,ranges:_e.ranges.map(ct=>g.Range.to(ct))}))),je={documents:Le,selections:Le[0]?.[0]?.ranges??[]},He=await this.e.provideMappedEdits(le,Q,je,q);return He?g.WorkspaceEdit.from(He):null}}class Pe{constructor(z,Q){this.adapter=z,this.extension=Q}}class be{static{this.d=0}constructor(z,Q,ee,q,ae,le,Le,je){this.g=Q,this.h=ee,this.j=q,this.k=ae,this.l=le,this.m=Le,this.n=je,this.f=new Map,this.e=z.getProxy(b.$6K.MainThreadLanguageFeatures)}o(z,Q){return g.DocumentSelector.from(z,this.g,Q)}p(z){return new I.$8K(()=>{this.f.delete(z),this.e.$unregister(z)})}q(){return be.d++}async s(z,Q,ee,q,ae,le=!1){const Le=this.f.get(z);if(!Le||!(Le.adapter instanceof Q))return q;const je=Date.now();le||this.l.trace(`[${Le.extension.identifier.value}] INVOKE provider '${ee.toString().replace(/[\r\n]/g,"")}'`);const He=ee(Le.adapter,Le.extension);return Promise.resolve(He).catch(Je=>{(0,n.$4)(Je)||(this.l.error(`[${Le.extension.identifier.value}] provider FAILED`),this.l.error(Je),this.n.onExtensionError(Le.extension.identifier,Je))}).finally(()=>{le||this.l.trace(`[${Le.extension.identifier.value}] provider DONE after ${Date.now()-je}ms`)}),p.CancellationToken.isCancellationToken(ae)?(0,c.$Vg)(He,ae):He}t(z,Q){const ee=this.q();return this.f.set(ee,new Pe(z,Q)),ee}static u(z){return z.displayName||z.name}registerDocumentSymbolProvider(z,Q,ee,q){const ae=this.t(new s(this.h,ee),z),le=q&&q.label||be.u(z);return this.e.$registerDocumentSymbolProvider(ae,this.o(Q,z),le),this.p(ae)}$provideDocumentSymbols(z,Q,ee){return this.s(z,s,q=>q.provideDocumentSymbols(D.URI.revive(Q),ee),void 0,ee)}registerCodeLensProvider(z,Q,ee){const q=this.q(),ae=typeof ee.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(q,new Pe(new l(this.h,this.j.converter,ee,z,this.n,this.l),z)),this.e.$registerCodeLensSupport(q,this.o(Q,z),ae);let le=this.p(q);if(ae!==void 0){const Le=ee.onDidChangeCodeLenses(je=>this.e.$emitCodeLensEvent(ae));le=I.$8K.from(le,Le)}return le}$provideCodeLenses(z,Q,ee){return this.s(z,l,q=>q.provideCodeLenses(D.URI.revive(Q),ee),void 0,ee)}$resolveCodeLens(z,Q,ee){return this.s(z,l,q=>q.resolveCodeLens(Q,ee),void 0,void 0)}$releaseCodeLenses(z,Q){this.s(z,l,ee=>Promise.resolve(ee.releaseCodeLenses(Q)),void 0,void 0)}registerDefinitionProvider(z,Q,ee){const q=this.t(new d(this.h,ee),z);return this.e.$registerDefinitionSupport(q,this.o(Q,z)),this.p(q)}$provideDefinition(z,Q,ee,q){return this.s(z,d,ae=>ae.provideDefinition(D.URI.revive(Q),ee,q),[],q)}registerDeclarationProvider(z,Q,ee){const q=this.t(new k(this.h,ee),z);return this.e.$registerDeclarationSupport(q,this.o(Q,z)),this.p(q)}$provideDeclaration(z,Q,ee,q){return this.s(z,k,ae=>ae.provideDeclaration(D.URI.revive(Q),ee,q),[],q)}registerImplementationProvider(z,Q,ee){const q=this.t(new R(this.h,ee),z);return this.e.$registerImplementationSupport(q,this.o(Q,z)),this.p(q)}$provideImplementation(z,Q,ee,q){return this.s(z,R,ae=>ae.provideImplementation(D.URI.revive(Q),ee,q),[],q)}registerTypeDefinitionProvider(z,Q,ee){const q=this.t(new v(this.h,ee),z);return this.e.$registerTypeDefinitionSupport(q,this.o(Q,z)),this.p(q)}$provideTypeDefinition(z,Q,ee,q){return this.s(z,v,ae=>ae.provideTypeDefinition(D.URI.revive(Q),ee,q),[],q)}registerHoverProvider(z,Q,ee,q){const ae=this.t(new w(this.h,ee),z);return this.e.$registerHoverProvider(ae,this.o(Q,z)),this.p(ae)}$provideHover(z,Q,ee,q){return this.s(z,w,ae=>ae.provideHover(D.URI.revive(Q),ee,q),void 0,q)}registerEvaluatableExpressionProvider(z,Q,ee,q){const ae=this.t(new E(this.h,ee),z);return this.e.$registerEvaluatableExpressionProvider(ae,this.o(Q,z)),this.p(ae)}$provideEvaluatableExpression(z,Q,ee,q){return this.s(z,E,ae=>ae.provideEvaluatableExpression(D.URI.revive(Q),ee,q),void 0,q)}registerInlineValuesProvider(z,Q,ee,q){const ae=typeof ee.onDidChangeInlineValues=="function"?this.q():void 0,le=this.t(new P(this.h,ee),z);this.e.$registerInlineValuesProvider(le,this.o(Q,z),ae);let Le=this.p(le);if(ae!==void 0){const je=ee.onDidChangeInlineValues(He=>this.e.$emitInlineValuesEvent(ae));Le=I.$8K.from(Le,je)}return Le}$provideInlineValues(z,Q,ee,q,ae){return this.s(z,P,le=>le.provideInlineValues(D.URI.revive(Q),ee,q,ae),void 0,ae)}registerDocumentHighlightProvider(z,Q,ee){const q=this.t(new N(this.h,ee),z);return this.e.$registerDocumentHighlightProvider(q,this.o(Q,z)),this.p(q)}registerMultiDocumentHighlightProvider(z,Q,ee){const q=this.t(new U(this.h,ee),z);return this.e.$registerMultiDocumentHighlightProvider(q,this.o(Q,z)),this.p(q)}$provideDocumentHighlights(z,Q,ee,q){return this.s(z,N,ae=>ae.provideDocumentHighlights(D.URI.revive(Q),ee,q),void 0,q)}$provideMultiDocumentHighlights(z,Q,ee,q,ae){return this.s(z,U,le=>le.provideMultiDocumentHighlights(D.URI.revive(Q),ee,q.map(Le=>D.URI.revive(Le)),ae),void 0,ae)}registerLinkedEditingRangeProvider(z,Q,ee){const q=this.t(new F(this.h,ee),z);return this.e.$registerLinkedEditingRangeProvider(q,this.o(Q,z)),this.p(q)}$provideLinkedEditingRanges(z,Q,ee,q){return this.s(z,F,async ae=>{const le=await ae.provideLinkedEditingRanges(D.URI.revive(Q),ee,q);if(le)return{ranges:le.ranges,wordPattern:le.wordPattern?be.w(le.wordPattern):void 0}},void 0,q)}registerReferenceProvider(z,Q,ee){const q=this.t(new j(this.h,ee),z);return this.e.$registerReferenceSupport(q,this.o(Q,z)),this.p(q)}$provideReferences(z,Q,ee,q,ae){return this.s(z,j,le=>le.provideReferences(D.URI.revive(Q),ee,q,ae),void 0,ae)}registerCodeActionProvider(z,Q,ee,q){const ae=new h.$Sc,le=this.t(new T(this.h,this.j.converter,this.k,ee,this.l,z,this.m),z);return this.e.$registerQuickFixSupport(le,this.o(Q,z),{providedKinds:q?.providedCodeActionKinds?.map(Le=>Le.value),documentation:q?.documentation?.map(Le=>({kind:Le.kind.value,command:this.j.converter.toInternal(Le.command,ae)}))},be.u(z),!!ee.resolveCodeAction),ae.add(this.p(le)),ae}$provideCodeActions(z,Q,ee,q,ae){return this.s(z,T,le=>le.provideCodeActions(D.URI.revive(Q),ee,q,ae),void 0,ae)}$resolveCodeAction(z,Q,ee){return this.s(z,T,q=>q.resolveCodeAction(Q,ee),{},void 0)}$releaseCodeActions(z,Q){this.s(z,T,ee=>Promise.resolve(ee.releaseCodeActions(Q)),void 0,void 0)}registerDocumentFormattingEditProvider(z,Q,ee){const q=this.t(new B(this.h,ee),z);return this.e.$registerDocumentFormattingSupport(q,this.o(Q,z),z.identifier,z.displayName||z.name),this.p(q)}$provideDocumentFormattingEdits(z,Q,ee,q){return this.s(z,B,ae=>ae.provideDocumentFormattingEdits(D.URI.revive(Q),ee,q),void 0,q)}registerDocumentRangeFormattingEditProvider(z,Q,ee){const q=typeof ee.provideDocumentRangesFormattingEdits=="function",ae=this.t(new Y(this.h,ee),z);return this.e.$registerRangeFormattingSupport(ae,this.o(Q,z),z.identifier,z.displayName||z.name,q),this.p(ae)}$provideDocumentRangeFormattingEdits(z,Q,ee,q,ae){return this.s(z,Y,le=>le.provideDocumentRangeFormattingEdits(D.URI.revive(Q),ee,q,ae),void 0,ae)}$provideDocumentRangesFormattingEdits(z,Q,ee,q,ae){return this.s(z,Y,le=>le.provideDocumentRangesFormattingEdits(D.URI.revive(Q),ee,q,ae),void 0,ae)}registerOnTypeFormattingEditProvider(z,Q,ee,q){const ae=this.t(new ue(this.h,ee),z);return this.e.$registerOnTypeFormattingSupport(ae,this.o(Q,z),q,z.identifier),this.p(ae)}$provideOnTypeFormattingEdits(z,Q,ee,q,ae,le){return this.s(z,ue,Le=>Le.provideOnTypeFormattingEdits(D.URI.revive(Q),ee,q,ae,le),void 0,le)}registerWorkspaceSymbolProvider(z,Q){const ee=this.t(new Z(Q,this.l),z);return this.e.$registerNavigateTypeSupport(ee,typeof Q.resolveWorkspaceSymbol=="function"),this.p(ee)}$provideWorkspaceSymbols(z,Q,ee){return this.s(z,Z,q=>q.provideWorkspaceSymbols(Q,ee),{symbols:[]},ee)}$resolveWorkspaceSymbol(z,Q,ee){return this.s(z,Z,q=>q.resolveWorkspaceSymbol(Q,ee),void 0,void 0)}$releaseWorkspaceSymbols(z,Q){this.s(z,Z,ee=>ee.releaseWorkspaceSymbols(Q),void 0,void 0)}registerRenameProvider(z,Q,ee){const q=this.t(new J(this.h,ee,this.l),z);return this.e.$registerRenameSupport(q,this.o(Q,z),J.supportsResolving(ee)),this.p(q)}$provideRenameEdits(z,Q,ee,q,ae){return this.s(z,J,le=>le.provideRenameEdits(D.URI.revive(Q),ee,q,ae),void 0,ae)}$resolveRenameLocation(z,Q,ee,q){return this.s(z,J,ae=>ae.resolveRenameLocation(D.URI.revive(Q),ee,q),void 0,q)}registerDocumentSemanticTokensProvider(z,Q,ee,q){const ae=this.t(new he(this.h,ee),z),le=typeof ee.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(ae,this.o(Q,z),q,le);let Le=this.p(ae);if(le){const je=ee.onDidChangeSemanticTokens(He=>this.e.$emitDocumentSemanticTokensEvent(le));Le=I.$8K.from(Le,je)}return Le}$provideDocumentSemanticTokens(z,Q,ee,q){return this.s(z,he,ae=>ae.provideDocumentSemanticTokens(D.URI.revive(Q),ee,q),null,q)}$releaseDocumentSemanticTokens(z,Q){this.s(z,he,ee=>ee.releaseDocumentSemanticColoring(Q),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(z,Q,ee,q){const ae=this.t(new _(this.h,ee),z);return this.e.$registerDocumentRangeSemanticTokensProvider(ae,this.o(Q,z),q),this.p(ae)}$provideDocumentRangeSemanticTokens(z,Q,ee,q){return this.s(z,_,ae=>ae.provideDocumentRangeSemanticTokens(D.URI.revive(Q),ee,q),null,q)}registerCompletionItemProvider(z,Q,ee,q){const ae=this.t(new we(this.h,this.j.converter,ee,this.m,z),z);return this.e.$registerCompletionsProvider(ae,this.o(Q,z),q,we.supportsResolving(ee),z.identifier),this.p(ae)}$provideCompletionItems(z,Q,ee,q,ae){return this.s(z,we,le=>le.provideCompletionItems(D.URI.revive(Q),ee,q,ae),void 0,ae)}$resolveCompletionItem(z,Q,ee){return this.s(z,we,q=>q.resolveCompletionItem(Q,ee),void 0,ee)}$releaseCompletionItems(z,Q){this.s(z,we,ee=>ee.releaseCompletionItems(Q),void 0,void 0)}registerInlineCompletionsProvider(z,Q,ee,q){const ae=new K(z,this.h,ee,this.j.converter),le=this.t(ae,z);return this.e.$registerInlineCompletionsSupport(le,this.o(Q,z),ae.supportsHandleEvents,S.$lm.toKey(z.identifier.value),q?.yieldTo?.map(Le=>S.$lm.toKey(Le))||[]),this.p(le)}$provideInlineCompletions(z,Q,ee,q,ae){return this.s(z,oe,le=>le.provideInlineCompletions(D.URI.revive(Q),ee,q,ae),void 0,ae)}$handleInlineCompletionDidShow(z,Q,ee,q){this.s(z,oe,async ae=>{ae.handleDidShowCompletionItem(Q,ee,q)},void 0,void 0)}$handleInlineCompletionPartialAccept(z,Q,ee,q){this.s(z,oe,async ae=>{ae.handlePartialAccept(Q,ee,q)},void 0,void 0)}$freeInlineCompletionsList(z,Q){this.s(z,oe,async ee=>{ee.disposeCompletions(Q)},void 0,void 0)}registerSignatureHelpProvider(z,Q,ee,q){const ae=Array.isArray(q)?{triggerCharacters:q,retriggerCharacters:[]}:q,le=this.t(new re(this.h,ee),z);return this.e.$registerSignatureHelpProvider(le,this.o(Q,z),ae),this.p(le)}$provideSignatureHelp(z,Q,ee,q,ae){return this.s(z,re,le=>le.provideSignatureHelp(D.URI.revive(Q),ee,q,ae),void 0,ae)}$releaseSignatureHelp(z,Q){this.s(z,re,ee=>ee.releaseSignatureHelp(Q),void 0,void 0)}registerInlayHintsProvider(z,Q,ee){const q=typeof ee.onDidChangeInlayHints=="function"?this.q():void 0,ae=this.t(new ye(this.h,this.j.converter,ee,this.l,z),z);this.e.$registerInlayHintsProvider(ae,this.o(Q,z),typeof ee.resolveInlayHint=="function",q,be.u(z));let le=this.p(ae);if(q!==void 0){const Le=ee.onDidChangeInlayHints(je=>this.e.$emitInlayHintsEvent(q));le=I.$8K.from(le,Le)}return le}$provideInlayHints(z,Q,ee,q){return this.s(z,ye,ae=>ae.provideInlayHints(D.URI.revive(Q),ee,q),void 0,q)}$resolveInlayHint(z,Q,ee){return this.s(z,ye,q=>q.resolveInlayHint(Q,ee),void 0,ee)}$releaseInlayHints(z,Q){this.s(z,ye,ee=>ee.releaseHints(Q),void 0,void 0)}registerDocumentLinkProvider(z,Q,ee){const q=this.t(new de(this.h,ee),z);return this.e.$registerDocumentLinkProvider(q,this.o(Q,z),typeof ee.resolveDocumentLink=="function"),this.p(q)}$provideDocumentLinks(z,Q,ee){return this.s(z,de,q=>q.provideLinks(D.URI.revive(Q),ee),void 0,ee,Q.scheme==="output")}$resolveDocumentLink(z,Q,ee){return this.s(z,de,q=>q.resolveLink(Q,ee),void 0,void 0,!0)}$releaseDocumentLinks(z,Q){this.s(z,de,ee=>ee.releaseLinks(Q),void 0,void 0,!0)}registerColorProvider(z,Q,ee){const q=this.t(new ge(this.h,ee),z);return this.e.$registerDocumentColorProvider(q,this.o(Q,z)),this.p(q)}$provideDocumentColors(z,Q,ee){return this.s(z,ge,q=>q.provideColors(D.URI.revive(Q),ee),[],ee)}$provideColorPresentations(z,Q,ee,q){return this.s(z,ge,ae=>ae.provideColorPresentations(D.URI.revive(Q),ee,q),void 0,q)}registerFoldingRangeProvider(z,Q,ee){const q=this.q(),ae=typeof ee.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(q,new Pe(new x(this.h,ee),z)),this.e.$registerFoldingRangeProvider(q,this.o(Q,z),z.identifier,ae);let le=this.p(q);if(ae!==void 0){const Le=ee.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(ae));le=I.$8K.from(le,Le)}return le}$provideFoldingRanges(z,Q,ee,q){return this.s(z,x,ae=>ae.provideFoldingRanges(D.URI.revive(Q),ee,q),void 0,q)}registerSelectionRangeProvider(z,Q,ee){const q=this.t(new te(this.h,ee,this.l),z);return this.e.$registerSelectionRangeProvider(q,this.o(Q,z)),this.p(q)}$provideSelectionRanges(z,Q,ee,q){return this.s(z,te,ae=>ae.provideSelectionRanges(D.URI.revive(Q),ee,q),[],q)}registerCallHierarchyProvider(z,Q,ee){const q=this.t(new G(this.h,ee),z);return this.e.$registerCallHierarchyProvider(q,this.o(Q,z)),this.p(q)}$prepareCallHierarchy(z,Q,ee,q){return this.s(z,G,ae=>Promise.resolve(ae.prepareSession(D.URI.revive(Q),ee,q)),void 0,q)}$provideCallHierarchyIncomingCalls(z,Q,ee,q){return this.s(z,G,ae=>ae.provideCallsTo(Q,ee,q),void 0,q)}$provideCallHierarchyOutgoingCalls(z,Q,ee,q){return this.s(z,G,ae=>ae.provideCallsFrom(Q,ee,q),void 0,q)}$releaseCallHierarchy(z,Q){this.s(z,G,ee=>Promise.resolve(ee.releaseSession(Q)),void 0,void 0)}registerTypeHierarchyProvider(z,Q,ee){const q=this.t(new ie(this.h,ee),z);return this.e.$registerTypeHierarchyProvider(q,this.o(Q,z)),this.p(q)}$prepareTypeHierarchy(z,Q,ee,q){return this.s(z,ie,ae=>Promise.resolve(ae.prepareSession(D.URI.revive(Q),ee,q)),void 0,q)}$provideTypeHierarchySupertypes(z,Q,ee,q){return this.s(z,ie,ae=>ae.provideSupertypes(Q,ee,q),void 0,q)}$provideTypeHierarchySubtypes(z,Q,ee,q){return this.s(z,ie,ae=>ae.provideSubtypes(Q,ee,q),void 0,q)}$releaseTypeHierarchy(z,Q){this.s(z,ie,ee=>Promise.resolve(ee.releaseSession(Q)),void 0,void 0)}registerDocumentOnDropEditProvider(z,Q,ee,q){const ae=this.q();this.f.set(ae,new Pe(new fe(this.e,this.h,ee,ae,z),z));const le=(0,t.$BF)(z,"dropMetadata")&&q?fe.toInternalProviderId(z.identifier.value,q.id):void 0;return this.e.$registerDocumentOnDropEditProvider(ae,this.o(Q,z),le,(0,t.$BF)(z,"dropMetadata")?q:void 0),this.p(ae)}$provideDocumentOnDropEdits(z,Q,ee,q,ae,le){return this.s(z,fe,Le=>Promise.resolve(Le.provideDocumentOnDropEdits(Q,D.URI.revive(ee),q,ae,le)),void 0,void 0)}registerMappedEditsProvider(z,Q,ee){const q=this.t(new pe(this.h,ee),z);return this.e.$registerMappedEditsProvider(q,this.o(Q,z)),this.p(q)}$provideMappedEdits(z,Q,ee,q,ae){return this.s(z,pe,le=>Promise.resolve(le.provideMappedEdits(Q,ee,q,ae)),null,ae)}registerDocumentPasteEditProvider(z,Q,ee,q){const ae=this.q();this.f.set(ae,new Pe(new M(this.e,this.h,ee,ae,z),z));const le=M.toInternalProviderId(z.identifier.value,q.id);return this.e.$registerPasteEditProvider(ae,this.o(Q,z),le,{supportsCopy:!!ee.prepareDocumentPaste,supportsPaste:!!ee.provideDocumentPasteEdits,copyMimeTypes:q.copyMimeTypes,pasteMimeTypes:q.pasteMimeTypes}),this.p(ae)}$prepareDocumentPaste(z,Q,ee,q,ae){return this.s(z,M,le=>le.prepareDocumentPaste(D.URI.revive(Q),ee,q,ae),void 0,ae)}$providePasteEdits(z,Q,ee,q,ae,le){return this.s(z,M,Le=>Le.providePasteEdits(Q,D.URI.revive(ee),q,ae,le),void 0,le)}static w(z){return{pattern:z.source,flags:z.flags}}static y(z){return{decreaseIndentPattern:be.w(z.decreaseIndentPattern),increaseIndentPattern:be.w(z.increaseIndentPattern),indentNextLinePattern:z.indentNextLinePattern?be.w(z.indentNextLinePattern):void 0,unIndentedLinePattern:z.unIndentedLinePattern?be.w(z.unIndentedLinePattern):void 0}}static z(z){return{beforeText:be.w(z.beforeText),afterText:z.afterText?be.w(z.afterText):void 0,previousLineText:z.previousLineText?be.w(z.previousLineText):void 0,action:z.action}}static B(z){return z.map(be.z)}static C(z){return{open:z.open,close:z.close,notIn:z.notIn?z.notIn.map(Q=>I.SyntaxTokenType.toString(Q)):void 0}}static D(z){return z.map(be.C)}setLanguageConfiguration(z,Q,ee){const{wordPattern:q}=ee;if(q&&(0,$.$Ye)(q))throw new Error(`Invalid language configuration: wordPattern '${q}' is not allowed to match the empty string.`);q?this.h.setWordDefinitionFor(Q,q):this.h.setWordDefinitionFor(Q,void 0),ee.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",z,"Do not use."),ee.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",z,"Do not use.");const ae=this.q(),le={comments:ee.comments,brackets:ee.brackets,wordPattern:ee.wordPattern?be.w(ee.wordPattern):void 0,indentationRules:ee.indentationRules?be.y(ee.indentationRules):void 0,onEnterRules:ee.onEnterRules?be.B(ee.onEnterRules):void 0,__electricCharacterSupport:ee.__electricCharacterSupport,__characterPairSupport:ee.__characterPairSupport,autoClosingPairs:ee.autoClosingPairs?be.D(ee.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(ae,Q,le),this.p(ae)}$setWordDefinitions(z){for(const Q of z)this.h.setWordDefinitionFor(Q.languageId,new RegExp(Q.regexSource,Q.regexFlags))}}e.$bgc=be}),define(ke[327],Se([1,0,6,15,7,39,11,3,25]),function(me,e,D,O,g,I,A,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ahc=void 0;class y{constructor(C,m,p,S){this.c=m,this.d=p,this.e=S,this.b=[],this.f=0,this.g=new Set,this.a=C.getProxy(D.$6K.MainThreadLanguages)}$acceptLanguageIds(C){this.b=C}async getLanguages(){return this.b.slice(0)}async changeLanguage(C,m){await this.a.$changeLanguage(C,m);const p=this.c.getDocumentData(C);if(!p)throw new Error(`document '${C.toString()}' NOT found`);return p.document}async tokenAtPosition(C,m){const p=C.version,S=O.Position.from(m),h=await this.a.$tokensAtPosition(C.uri,S),f={type:g.StandardTokenType.Other,range:C.getWordRangeAtPosition(m)??new g.$0K(m.line,m.character,m.line,m.character)};if(!h)return f;const o={range:O.Range.to(h.range),type:O.TokenType.to(h.type)};return!o.range.contains(m)||p!==C.version?f:o}createLanguageStatusItem(C,m,p){const S=this.f++,h=this.a,f=this.g,o=`${C.identifier.value}/${m}`;if(f.has(o))throw new Error(`LanguageStatusItem with id '${m}' ALREADY exists`);f.add(o);const i={selector:p,id:m,name:C.displayName??C.name,severity:g.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let r;const n=new b.$Sc,c=()=>{if(r?.dispose(),!f.has(o)){console.warn(`LanguageStatusItem (${m}) from ${C.identifier.value} has been disposed and CANNOT be updated anymore`);return}r=(0,A.$8g)(()=>{n.clear(),this.a.$setLanguageStatus(S,{id:o,name:i.name??C.displayName??C.name,source:C.displayName??C.name,selector:O.DocumentSelector.from(i.selector,this.e),label:i.text,detail:i.detail??"",severity:i.severity===g.LanguageStatusSeverity.Error?I.default.Error:i.severity===g.LanguageStatusSeverity.Warning?I.default.Warning:I.default.Info,command:i.command&&this.d.toInternal(i.command,n),accessibilityInfo:i.accessibilityInformation,busy:i.busy})},0)},t={dispose(){n.dispose(),r?.dispose(),h.$removeLanguageStatus(S),f.delete(o)},get id(){return i.id},get name(){return i.name},set name(u){i.name=u,c()},get selector(){return i.selector},set selector(u){i.selector=u,c()},get text(){return i.text},set text(u){i.text=u,c()},set text2(u){(0,$.$CF)(C,"languageStatusText"),i.text=u,c()},get text2(){return(0,$.$CF)(C,"languageStatusText"),i.text},get detail(){return i.detail},set detail(u){i.detail=u,c()},get severity(){return i.severity},set severity(u){i.severity=u,c()},get accessibilityInformation(){return i.accessibilityInformation},set accessibilityInformation(u){i.accessibilityInformation=u,c()},get command(){return i.command},set command(u){i.command=u,c()},get busy(){return i.busy},set busy(u){i.busy=u,c()}};return c(),t}}e.$Ahc=y}),define(ke[115],Se([1,0,10,12,2,5,13,6,27,20]),function(me,e,D,O,g,I,A,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zgc=e.$Ygc=void 0;let L=class{constructor(m,p,S){this.f=S,this.d=new Map,this.a=p.getProxy(b.$6K.MainThreadLocalization),this.b=m.environment.appLanguage,this.c=this.b===D.$g}getMessage(m,p){const{message:S,args:h,comment:f}=p;if(this.c)return(0,O.$Le)(S,h??{});let o=S;f&&f.length>0&&(o+=`/${Array.isArray(f)?f.join(""):f}`);const i=this.d.get(m)?.contents[o];return i||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${o}`),(0,O.$Le)(i??S,h??{})}getBundle(m){return this.d.get(m)?.contents}getBundleUri(m){return this.d.get(m)?.uri}async initializeLocalizedMessages(m){if(this.c||!m.l10n&&!m.isBuiltin||this.d.has(m.identifier.value))return;let p;const S=await this.g(m);if(!S){this.f.error(`No bundle location found for extension ${m.identifier.value}`);return}try{const h=await this.a.$fetchBundleContents(S),f=JSON.parse(h);p=m.isBuiltin?f.contents?.bundle:f}catch(h){this.f.error(`Failed to load translations for ${m.identifier.value} from ${S}: ${h.message}`);return}p&&this.d.set(m.identifier.value,{contents:p,uri:S})}async g(m){if(m.isBuiltin){const p=await this.a.$fetchBuiltInBundleUri(m.identifier.value,this.b);return g.URI.revive(p)}return m.l10n?g.URI.joinPath(m.extensionLocation,m.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$Ygc=L,e.$Ygc=L=Ge([We(0,$.$nN),We(1,y.$0M),We(2,A.$nj)],L),e.$Zgc=(0,I.$6h)("IExtHostLocalizationService")}),define(ke[150],Se([1,0,13,6,27,20,2,55]),function(me,e,D,O,g,I,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_hc=void 0;let $=class extends D.$yj{constructor(C,m){super(m.logLevel,m.logsLocation,m.loggers.map(p=>(0,b.$Ch)(p))),this.r=C.getProxy(O.$6K.MainThreadLogger)}$setLogLevel(C,m){m?this.setLogLevel(A.URI.revive(m),C):this.setLogLevel(C)}setVisibility(C,m){super.setVisibility(C,m),this.r.$setVisibility(C,m)}s(C,m,p){return new y(this.r,C,m,p)}};e.$_hc=$,e.$_hc=$=Ge([We(0,I.$0M),We(1,g.$nN)],$);class y extends D.$tj{constructor(C,m,p,S){super(S?.logLevel==="always"),this.r=C,this.s=m,this.m=!1,this.n=[],this.setLevel(p),this.r.$createLogger(m,S).then(()=>{this.u(this.n),this.m=!0})}g(C,m){const p=[[C,m]];this.m?this.u(p):this.n.push(...p)}u(C){this.r.$log(this.s,C)}flush(){this.r.$flush(this.s)}}}),define(ke[116],Se([1,0,6,5,3,20,22]),function(me,e,D,O,g,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2gc=e.$1gc=void 0,e.$1gc=(0,O.$6h)("IExtHostManagedSockets");let b=class{constructor(C){this.b=0,this.c=null,this.d=new Map,this.a=C.getProxy(D.$6K.MainThreadManagedSockets)}setFactory(C,m){for(const p of this.d.values())p.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new $(C,m),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(C){if(!this.c||this.c.socketFactoryId!==C)throw new Error(`No socket factory with id ${C}`);const m=++this.b,p=await this.c.makeConnection(),S=new g.$Sc;return this.d.set(m,new y(m,p,S)),S.add((0,g.$Rc)(()=>this.d.delete(m))),S.add(p.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(m),S.dispose()})),S.add(p.onDidClose(h=>{this.a.$onDidManagedSocketClose(m,h?.stack??h?.message),S.dispose()})),S.add(p.onDidReceiveMessage(h=>this.a.$onDidManagedSocketHaveData(m,A.$je.wrap(h)))),m}$remoteSocketWrite(C,m){this.d.get(C)?.actual.send(m.buffer)}$remoteSocketEnd(C){const m=this.d.get(C);m&&(m.actual.end(),m.dispose())}async $remoteSocketDrain(C){await this.d.get(C)?.actual.drain?.()}};e.$2gc=b,e.$2gc=b=Ge([We(0,I.$0M)],b);class ${constructor(C,m){this.socketFactoryId=C,this.makeConnection=m}}class y extends g.$Tc{constructor(C,m,p){super(),this.socketId=C,this.actual=m,this.B(p)}}}),define(ke[328],Se([1,0,6,13,25]),function(me,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bhc=void 0;function I(b){return b&&b.title}let A=class{constructor($,y){this.b=y,this.a=$.getProxy(D.$6K.MainThreadMessageService)}showMessage($,y,L,C,m){const p={source:{identifier:$.identifier,label:$.displayName||$.name}};let S;typeof C=="string"||I(C)?S=[C,...m]:(p.modal=C?.modal,p.useCustom=C?.useCustom,p.detail=C?.detail,S=m),p.useCustom&&(0,g.$CF)($,"resolvers");const h=[];let f=!1;for(let o=0;o<S.length;o++){const i=S[o];if(typeof i=="string")h.push({title:i,handle:o,isCloseAffordance:!1});else if(typeof i=="object"){const{title:r,isCloseAffordance:n}=i;h.push({title:r,isCloseAffordance:!!n,handle:o}),n&&(f?this.b.warn(`[${$.identifier}] Only one message item can have 'isCloseAffordance':`,i):f=!0)}else this.b.warn(`[${$.identifier}] Invalid message item:`,i)}return this.a.$showMessage(y,L,p,h).then(o=>{if(typeof o=="number")return S[o]})}};e.$Bhc=A,e.$Bhc=A=Ge([We(1,O.$nj)],A)}),define(ke[329],Se([1,0,19,11,21,4,3,28,2,26,13,6,35,15,7,113,285,25,68]),function(me,e,D,O,g,I,A,b,$,y,L,C,m,p,S,h,f,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ghc=e.$Fhc=void 0;let r=class{constructor(d,k,R,v,w){this.m=k,this.n=R,this.o=v,this.q=w,this.b=new b.$Ac,this.c=new b.$Ac,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new I.$Vd,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=d.getProxy(C.$6K.MainThreadNotebookKernels);const E=new m.$xN("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new m.$vN("options","Select kernel options",P=>!0,P=>{if(P&&"notebookEditor"in P&&"id"in P){const N=this.n.getIdByEditor(P.notebookEditor);return{id:P.id,extension:P.extension,notebookEditorId:N}}else if(P&&"notebookEditor"in P){const N=this.n.getIdByEditor(P.notebookEditor);if(N===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${P.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:N}}return P})],m.$wN.Void);this.o.registerApiCommand(E)}createNotebookController(d,k,R,v,w,E){for(const _ of this.j.values())if(_.controller.id===k&&y.$lm.equals(d.identifier,_.extensionId))throw new Error(`notebook controller with id '${k}' ALREADY exist`);const P=this.k++,N=this;this.q.trace(`NotebookController[${P}], CREATED by ${d.identifier.value}, ${k}`);const U=()=>console.warn(`NO execute handler from notebook controller '${M.id}' of extension: '${d.identifier}'`);let F=!1;const j=new I.$Vd,T=new I.$Vd,M={id:l(d.identifier,k),notebookType:R,extensionId:d.identifier,extensionLocation:d.extensionLocation,label:v||d.identifier.value,preloads:E?E.map(p.NotebookRendererScript.from):[]};let B=w??U,Y,ue;this.a.$addKernel(P,M).catch(_=>{console.log(_),F=!0});let Z=0;const J=()=>{if(F)return;const _=++Z;Promise.resolve().then(()=>{_===Z&&this.a.$updateKernel(P,M)})},X=new b.$Ac,he={get id(){return k},get notebookType(){return M.notebookType},onDidChangeSelectedNotebooks:j.event,get label(){return M.label},set label(_){M.label=_??d.displayName??d.name,J()},get detail(){return M.detail??""},set detail(_){M.detail=_,J()},get description(){return M.description??""},set description(_){M.description=_,J()},get supportedLanguages(){return M.supportedLanguages},set supportedLanguages(_){M.supportedLanguages=_,J()},get supportsExecutionOrder(){return M.supportsExecutionOrder??!1},set supportsExecutionOrder(_){M.supportsExecutionOrder=_,J()},get rendererScripts(){return M.preloads?M.preloads.map(p.NotebookRendererScript.to):[]},get executeHandler(){return B},set executeHandler(_){B=_??U},get interruptHandler(){return Y},set interruptHandler(_){Y=_,M.supportsInterrupt=!!_,J()},set variableProvider(_){(0,o.$CF)(d,"notebookVariableProvider"),ue=_,M.hasVariableProvider=!!_,_?.onDidChangeVariables(we=>N.a.$variablesUpdated(we.uri)),J()},get variableProvider(){return ue},createNotebookCellExecution(_){if(F)throw new Error("notebook controller is DISPOSED");if(!X.has(_.notebook.uri))throw N.q.trace(`NotebookController[${P}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(X.keys()).map(we=>we.toString())),new Error(`notebook controller is NOT associated to notebook: ${_.notebook.uri.toString()}`);return N._createNotebookCellExecution(_,l(d.identifier,this.id))},createNotebookExecution(_){if((0,o.$CF)(d,"notebookExecution"),F)throw new Error("notebook controller is DISPOSED");if(!X.has(_.uri))throw N.q.trace(`NotebookController[${P}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(X.keys()).map(we=>we.toString())),new Error(`notebook controller is NOT associated to notebook: ${_.uri.toString()}`);return N._createNotebookExecution(_,l(d.identifier,this.id))},dispose:()=>{F||(this.q.trace(`NotebookController[${P}], DISPOSED`),F=!0,this.j.delete(P),j.dispose(),T.dispose(),this.a.$removeKernel(P))},updateNotebookAffinity(_,we){we===S.NotebookControllerAffinity2.Hidden&&(0,o.$CF)(d,"notebookControllerAffinityHidden"),N.a.$updateNotebookPriority(P,_.uri,we)},onDidReceiveMessage:T.event,postMessage(_,we){return(0,o.$CF)(d,"notebookMessaging"),N.a.$postMessage(P,we&&N.n.getIdByEditor(we),_)},asWebviewUri(_){return(0,o.$CF)(d,"notebookMessaging"),(0,h.$wvb)(_,N.m.remote)}};return this.j.set(P,{extensionId:d.identifier,controller:he,onDidReceiveMessage:T,onDidChangeSelection:j,associatedNotebooks:X}),he}getIdByController(d){for(const[k,R]of this.j)if(R.controller===d)return l(R.extensionId,d.id);return null}createNotebookControllerDetectionTask(d,k){const R=this.g++,v=this;this.q.trace(`NotebookControllerDetectionTask[${R}], CREATED by ${d.identifier.value}`),this.a.$addKernelDetectionTask(R,k);const w={dispose:()=>{this.f.delete(R),v.a.$removeKernelDetectionTask(R)}};return this.f.set(R,w),w}registerKernelSourceActionProvider(d,k,R){const v=this.i++,w=typeof R.onDidChangeNotebookKernelSourceActions=="function"?v:void 0,E=this;this.h.set(v,R),this.q.trace(`NotebookKernelSourceActionProvider[${v}], CREATED by ${d.identifier.value}`),this.a.$addKernelSourceActionProvider(v,v,k);let P;return w!==void 0&&(P=R.onDidChangeNotebookKernelSourceActions(N=>this.a.$emitNotebookKernelSourceActionsChangeEvent(w))),{dispose:()=>{this.h.delete(v),E.a.$removeKernelSourceActionProvider(v,v),P?.dispose()}}}async $provideKernelSourceActions(d,k){const R=this.h.get(d);if(R){const v=new A.$Sc;return(await R.provideNotebookKernelSourceActions(k)??[]).map(E=>p.NotebookKernelSourceAction.from(E,this.o.converter,v))}return[]}$acceptNotebookAssociation(d,k,R){const v=this.j.get(d);if(v){const w=this.n.getNotebookDocument($.URI.revive(k));R?v.associatedNotebooks.set(w.uri,!0):v.associatedNotebooks.delete(w.uri),this.q.trace(`NotebookController[${d}] ASSOCIATE notebook`,w.uri.toString(),R),v.onDidChangeSelection.fire({selected:R,notebook:w.apiNotebook})}}async $executeCells(d,k,R){const v=this.j.get(d);if(!v)return;const w=this.n.getNotebookDocument($.URI.revive(k)),E=[];for(const P of R){const N=w.getCell(P);N&&E.push(N.apiCell)}try{this.q.trace(`NotebookController[${d}] EXECUTE cells`,w.uri.toString(),E.length),await v.controller.executeHandler.call(v.controller,E,w.apiNotebook,v.controller)}catch(P){this.q.error(`NotebookController[${d}] execute cells FAILED`,P),console.error(P)}}async $cancelCells(d,k,R){const v=this.j.get(d);if(!v)return;const w=this.n.getNotebookDocument($.URI.revive(k));if(v.controller.interruptHandler)await v.controller.interruptHandler.call(v.controller,w.apiNotebook);else for(const E of R){const P=w.getCell(E);P&&this.b.get(P.uri)?.cancel()}if(v.controller.interruptHandler){const E=this.c.get(w.uri);R.length&&Array.isArray(E)&&E.length&&E.forEach(P=>P.dispose())}}async $provideVariables(d,k,R,v,w,E,P){const N=this.j.get(d);if(!N)return;const U=this.n.getNotebookDocument($.URI.revive(R)),F=N.controller.variableProvider;if(!F)return;let j;if(v){if(j=this.s[v],!j)return}else this.s={};const T=w==="named"?S.NotebookVariablesRequestKind.Named:S.NotebookVariablesRequestKind.Indexed,M=F.provideVariables(U.apiNotebook,j,T,E,P);for await(const B of M){if(P.isCancellationRequested)return;const Y={id:this.r++,name:B.variable.name,value:B.variable.value,hasNamedChildren:B.hasNamedChildren,indexedChildrenCount:B.indexedChildrenCount};this.s[Y.id]=B.variable,this.a.$receiveVariable(k,Y)}}$acceptKernelMessageFromRenderer(d,k,R){const v=this.j.get(d);if(!v)return;const w=this.n.getEditorById(k);v.onDidReceiveMessage.fire(Object.freeze({editor:w.apiEditor,message:R}))}$cellExecutionChanged(d,k,R){const w=this.n.getNotebookDocument($.URI.revive(d)).getCell(k);if(w){const E=R?p.NotebookCellExecutionState.to(R):S.NotebookCellExecutionState.Idle;E!==void 0&&this.l.fire({cell:w.apiCell,state:E})}}_createNotebookCellExecution(d,k){if(d.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const v=this.n.getNotebookDocument(d.notebook.uri).getCellFromApiCell(d);if(!v)throw new Error("invalid cell");if(this.b.has(v.uri))throw new Error(`duplicate execution for ${v.uri}`);const w=new c(k,v,this.a);this.b.set(v.uri,w);const E=w.onDidChangeState(()=>{w.state===n.Resolved&&(w.dispose(),E.dispose(),this.b.delete(v.uri))});return w.asApiObject()}_createNotebookExecution(d,k){const R=this.n.getNotebookDocument(d.uri),v=d.getCells().find(P=>{const N=R.getCellFromApiCell(P);return N&&this.b.has(N.uri)});if(v)throw new Error(`duplicate cell execution for ${v.document.uri}`);if(this.c.has(R.uri))throw new Error(`duplicate notebook execution for ${R.uri}`);const w=new u(k,R,this.a),E=w.onDidChangeState(()=>{w.state===t.Resolved&&(w.dispose(),E.dispose(),this.c.delete(R.uri))});return this.c.set(R.uri,[w,E]),w.asApiObject()}};e.$Fhc=r,e.$Fhc=r=Ge([We(4,L.$nj)],r);var n;(function(a){a[a.Init=0]="Init",a[a.Started=1]="Started",a[a.Resolved=2]="Resolved"})(n||(n={}));class c extends A.$Tc{static{this.a=0}get state(){return this.f}constructor(d,k,R){super(),this.m=k,this.n=R,this.b=c.a++,this.c=new I.$Vd,this.onDidChangeState=this.c.event,this.f=n.Init,this.g=this.B(new g.$6d),this.h=new s(10,v=>this.s(v)),this.j=k.internalMetadata.executionOrder,this.n.$createExecution(this.b,d,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(d){await this.h.addItem(d)}async s(d){const k=Array.isArray(d)?d:[d];return this.n.$updateExecution(this.b,new i.$Tv(k))}t(){if(this.f===n.Init)throw new Error("Must call start before modifying cell output");if(this.f===n.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(d){let k=this.m;if(d&&(k=this.m.notebook.getCellFromApiCell(d)),!k)throw new Error("INVALID cell");return k.handle}y(d){return d.map(k=>{const R=S.$xM.ensureUniqueMimeTypes(k.items,!0);return R===k.items?p.NotebookCellOutput.from(k):p.NotebookCellOutput.from({items:R,id:k.id,metadata:k.metadata})})}async z(d,k,R){const v=this.w(k),w=this.y((0,D.$3b)(d));return this.r({editType:f.CellExecutionUpdateType.Output,cellHandle:v,append:R,outputs:w})}async C(d,k,R){return d=S.$xM.ensureUniqueMimeTypes((0,D.$3b)(d),!0),this.r({editType:f.CellExecutionUpdateType.OutputItems,items:d.map(p.NotebookCellOutputItem.from),outputId:k.id,append:R})}asApiObject(){const d=this;return Object.freeze({get token(){return d.g.token},get cell(){return d.m.apiCell},get executionOrder(){return d.j},set executionOrder(R){d.j=R,d.s([{editType:f.CellExecutionUpdateType.ExecutionState,executionOrder:d.j}])},start(R){if(d.f===n.Resolved||d.f===n.Started)throw new Error("Cannot call start again");d.f=n.Started,d.c.fire(),d.s({editType:f.CellExecutionUpdateType.ExecutionState,runStartTime:R})},end(R,v){if(d.f===n.Resolved)throw new Error("Cannot call resolve twice");d.f=n.Resolved,d.c.fire(),d.h.flush(),d.n.$completeExecution(d.b,new i.$Tv({runEndTime:v,lastRunSuccess:R}))},clearOutput(R){return d.t(),d.z([],R,!1)},appendOutput(R,v){return d.t(),d.z(R,v,!0)},replaceOutput(R,v){return d.t(),d.z(R,v,!1)},appendOutputItems(R,v){return d.t(),d.C(R,v,!0)},replaceOutputItems(R,v){return d.t(),d.C(R,v,!1)}})}}var t;(function(a){a[a.Init=0]="Init",a[a.Started=1]="Started",a[a.Resolved=2]="Resolved"})(t||(t={}));class u extends A.$Tc{static{this.a=0}get state(){return this.f}constructor(d,k,R){super(),this.h=k,this.j=R,this.b=u.a++,this.c=new I.$Vd,this.onDidChangeState=this.c.event,this.f=t.Init,this.g=this.B(new g.$6d),this.j.$createNotebookExecution(this.b,d,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===t.Resolved||this.f===t.Started)throw new Error("Cannot call start again");this.f=t.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===t.Resolved)throw new Error("Cannot call resolve twice");this.f=t.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class s{constructor(d,k){this.f=d,this.g=k,this.a=[],this.b=Date.now()}addItem(d){return this.a.push(d),this.c||(this.c=new O.$qh,this.b=Date.now(),(0,O.$7g)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const d=this.c;this.c=void 0;const k=this.a;return this.a=[],this.g(k).finally(()=>d.complete())}}function l(a,d){return`${a.value}/${d}`}e.$Ghc=l}),define(ke[330],Se([1,0,4,6,146]),function(me,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hhc=void 0;class I{constructor(b,$){this.c=$,this.a=new Map,this.b=b.getProxy(O.$6K.MainThreadNotebookRenderers)}$postRendererMessage(b,$,y){const L=this.c.getEditorById(b);this.a.get($)?.fire({editor:L.apiEditor,message:y})}createRendererMessaging(b,$){if(!b.contributes?.notebookRenderer?.some(L=>L.id===$))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${$})`);return{onDidReceiveMessage:(L,C,m)=>this.d($).event(L,C,m),postMessage:(L,C)=>{g.$nhc.apiEditorsToExtHost.has(L)&&([L,C]=[C,L]);const m=C&&g.$nhc.apiEditorsToExtHost.get(C);return this.b.$postMessage(m?.id,$,L)}}}d(b){let $=this.a.get(b);return $||($=new D.$Vd({onDidRemoveLastListener:()=>{$?.dispose(),this.a.delete(b)}}),this.a.set(b,$),$)}}e.$Hhc=I}),define(ke[331],Se([1,0,3,18,2,25,6]),function(me,e,D,O,g,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Khc=void 0;class b{constructor(y){this.b=new Map,this.a=y.getProxy(A.$6K.MainThreadProfileContentHandlers)}registerProfileContentHandler(y,L,C){if((0,I.$CF)(y,"profileContentHandlers"),this.b.has(L))throw new Error(`Handler with id '${L}' already registered`);return this.b.set(L,C),this.a.$registerProfileContentHandler(L,C.name,C.description,y.identifier.value),(0,D.$Rc)(()=>{this.b.delete(L),this.a.$unregisterProfileContentHandler(L)})}async $saveProfile(y,L,C,m){const p=this.b.get(y);if(!p)throw new Error(`Unknown handler with id: ${y}`);return p.saveProfile(L,C,m)}async $readProfile(y,L,C){const m=this.b.get(y);if(!m)throw new Error(`Unknown handler with id: ${y}`);return m.readProfile((0,O.$If)(L)?L:g.URI.revive(L),C)}}e.$Khc=b}),define(ke[332],Se([1,0,2,6,11,15]),function(me,e,D,O,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mhc=void 0;class A{static{this.a=0}constructor($,y){this.d=y,this.c=new Map,this.b=$.getProxy(O.$6K.MainThreadQuickDiff)}$provideOriginalResource($,y,L){const C=D.URI.revive(y),m=this.c.get($);return m?(0,g.$Yg)(()=>m.provideOriginalResource(C,L)).then(p=>p||null):Promise.resolve(null)}registerQuickDiffProvider($,y,L,C){const m=A.a++;return this.c.set(m,y),this.b.$registerQuickDiffProvider(m,I.DocumentSelector.from($,this.d),L,C),{dispose:()=>{this.b.$unregisterQuickDiffProvider(m),this.c.delete(m)}}}}e.$Mhc=A}),define(ke[333],Se([1,0,21,4,3,6,2,7,14,19,39,61,25,15]),function(me,e,D,O,g,I,A,b,$,y,L,C,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nhc=void 0;function S(h,f,o){const i=h.getProxy(I.$6K.MainThreadQuickOpen);class r{constructor(k,R){this.e=new Map,this.f=0,this.a=k,this.b=R}showQuickPick(k,R,v,w=D.CancellationToken.None){this.c=void 0;const E=Promise.resolve(R),P=++this.f,N=i.$show(P,{title:v?.title,placeHolder:v?.placeHolder,matchOnDescription:v?.matchOnDescription,matchOnDetail:v?.matchOnDetail,ignoreFocusLost:v?.ignoreFocusOut,canPickMany:v?.canPickMany},w),U={},F=N.then(()=>U);return Promise.race([F,E]).then(j=>{if(j===U)return;const T=(0,m.$BF)(k,"quickPickItemTooltip");return E.then(M=>{const B=[];for(let Y=0;Y<M.length;Y++){const ue=M[Y];if(typeof ue=="string")B.push({label:ue,handle:Y});else if(ue.kind===b.QuickPickItemKind.Separator)B.push({type:"separator",label:ue.label});else{ue.tooltip&&!T&&console.warn(`Extension '${k.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${k.identifier.value}`);const Z=ue.iconPath?s(ue.iconPath):void 0;B.push({label:ue.label,iconPath:Z?.iconPath,iconClass:Z?.iconClass,description:ue.description,detail:ue.detail,picked:ue.picked,alwaysShow:ue.alwaysShow,tooltip:T?p.MarkdownString.fromStrict(ue.tooltip):void 0,handle:Y})}}return v&&typeof v.onDidSelectItem=="function"&&(this.c=Y=>{v.onDidSelectItem(M[Y])}),i.$setItems(P,B),N.then(Y=>{if(typeof Y=="number")return M[Y];if(Array.isArray(Y))return Y.map(ue=>M[ue])})})}).then(void 0,j=>{if(!(0,$.$4)(j))return i.$setError(P,j),Promise.reject(j)})}$onItemSelected(k){this.c?.(k)}showInput(k,R=D.CancellationToken.None){return this.d=k?.validateInput,i.$input(k,typeof this.d=="function",R).then(void 0,v=>{if(!(0,$.$4)(v))return Promise.reject(v)})}async $validateInput(k){if(!this.d)return;const R=await this.d(k);if(!R||typeof R=="string")return R;let v;switch(R.severity){case b.InputBoxValidationSeverity.Info:v=L.default.Info;break;case b.InputBoxValidationSeverity.Warning:v=L.default.Warning;break;case b.InputBoxValidationSeverity.Error:v=L.default.Error;break;default:v=R.message?L.default.Error:L.default.Ignore;break}return{content:R.message,severity:v}}async showWorkspaceFolderPick(k,R=D.CancellationToken.None){const v=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[k]);if(!v)return;const w=await this.a.getWorkspaceFolders2();if(w)return w.find(E=>E.uri.toString()===v.uri.toString())}createQuickPick(k){const R=new l(k,()=>this.e.delete(R._id));return this.e.set(R._id,R),R}createInputBox(k){const R=new a(k,()=>this.e.delete(R._id));return this.e.set(R._id,R),R}$onDidChangeValue(k,R){this.e.get(k)?._fireDidChangeValue(R)}$onDidAccept(k){this.e.get(k)?._fireDidAccept()}$onDidChangeActive(k,R){const v=this.e.get(k);v instanceof l&&v._fireDidChangeActive(R)}$onDidChangeSelection(k,R){const v=this.e.get(k);v instanceof l&&v._fireDidChangeSelection(R)}$onDidTriggerButton(k,R){this.e.get(k)?._fireDidTriggerButton(R)}$onDidTriggerItemButton(k,R,v){const w=this.e.get(k);w instanceof l&&w._fireDidTriggerItemButton(R,v)}$onDidHide(k){this.e.get(k)?._fireDidHide()}}class n{static{this.a=1}constructor(k,R){this.x=k,this.y=R,this._id=l.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new O.$Vd,this.q=new O.$Vd,this.r=new O.$Vd,this.s=new O.$Vd,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(k){this.b=k,this.z({title:k})}get step(){return this.c}set step(k){this.c=k,this.z({step:k})}get totalSteps(){return this.d}set totalSteps(k){this.d=k,this.z({totalSteps:k})}get enabled(){return this.g}set enabled(k){this.g=k,this.z({enabled:k})}get busy(){return this.j}set busy(k){this.j=k,this.z({busy:k})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(k){this.k=k,this.z({ignoreFocusOut:k})}get value(){return this.l}set value(k){this.l=k,this.z({value:k})}get placeholder(){return this.m}set placeholder(k){this.m=k,this.z({placeholder:k})}get buttons(){return this.n}set buttons(k){this.n=k.slice(),this.o.clear(),k.forEach((R,v)=>{const w=R===b.$qM.Back?-1:v;this.o.set(w,R)}),this.z({buttons:k.map((R,v)=>({...s(R.iconPath),tooltip:R.tooltip,handle:R===b.$qM.Back?-1:v}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(k){this.l=k,this.q.fire(k)}_fireDidTriggerButton(k){const R=this.o.get(k);R&&this.r.fire(R)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,g.$Oc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),i.$dispose(this._id))}z(k){if(!this.v){for(const R of Object.keys(k)){const v=k[R];this.u[R]=v===void 0?null:v}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){i.$createOrUpdate(this.u),this.u={id:this._id}}}function c(d){if(d instanceof b.$3L)return{id:d.id};const k=u(d),R=t(d);return{dark:typeof k=="string"?A.URI.file(k):k,light:typeof R=="string"?A.URI.file(R):R}}function t(d){return typeof d=="object"&&"light"in d?d.light:d}function u(d){return typeof d=="object"&&"dark"in d?d.dark:d}function s(d){const k=c(d);let R,v;return"id"in k?v=C.ThemeIcon.asClassName(k):R=k,{iconPath:R,iconClass:v}}class l extends n{constructor(k,R){super(k.identifier,R),this.O=k,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new O.$Vd,this.L=[],this.M=new O.$Vd,this.N=new O.$Vd,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(k){this.B=k.slice(),this.C.clear(),this.D.clear(),k.forEach((w,E)=>{this.C.set(E,w),this.D.set(w,E)});const R=(0,m.$BF)(this.O,"quickPickItemTooltip"),v=[];for(let w=0;w<k.length;w++){const E=k[w];if(E.kind===b.QuickPickItemKind.Separator)v.push({type:"separator",label:E.label});else{E.tooltip&&!R&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const P=E.iconPath?s(E.iconPath):void 0;v.push({handle:w,label:E.label,iconPath:P?.iconPath,iconClass:P?.iconClass,description:E.description,detail:E.detail,picked:E.picked,alwaysShow:E.alwaysShow,tooltip:R?p.MarkdownString.fromStrict(E.tooltip):void 0,buttons:E.buttons?.map((N,U)=>({...s(N.iconPath),tooltip:N.tooltip,handle:U}))})}}this.z({items:v})}get canSelectMany(){return this.E}set canSelectMany(k){this.E=k,this.z({canSelectMany:k})}get matchOnDescription(){return this.F}set matchOnDescription(k){this.F=k,this.z({matchOnDescription:k})}get matchOnDetail(){return this.G}set matchOnDetail(k){this.G=k,this.z({matchOnDetail:k})}get sortByLabel(){return this.H}set sortByLabel(k){this.H=k,this.z({sortByLabel:k})}get keepScrollPosition(){return this.I}set keepScrollPosition(k){this.I=k,this.z({keepScrollPosition:k})}get activeItems(){return this.J}set activeItems(k){this.J=k.filter(R=>this.D.has(R)),this.z({activeItems:this.J.map(R=>this.D.get(R))})}get selectedItems(){return this.L}set selectedItems(k){this.L=k.filter(R=>this.D.has(R)),this.z({selectedItems:this.L.map(R=>this.D.get(R))})}_fireDidChangeActive(k){const R=(0,y.$Hb)(k.map(v=>this.C.get(v)));this.J=R,this.K.fire(R)}_fireDidChangeSelection(k){const R=(0,y.$Hb)(k.map(v=>this.C.get(v)));this.L=R,this.M.fire(R)}_fireDidTriggerItemButton(k,R){const v=this.C.get(k);if(!v||!v.buttons||!v.buttons.length)return;const w=v.buttons[R];w&&this.N.fire({button:w,item:v})}}class a extends n{constructor(k,R){super(k.identifier,R),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(k){this.B=k,this.z({password:k})}get prompt(){return this.C}set prompt(k){this.C=k,this.z({prompt:k})}get valueSelection(){return this.D}set valueSelection(k){this.D=k,this.z({valueSelection:k})}get validationMessage(){return this.E}set validationMessage(k){this.E=k,k?typeof k=="string"?this.z({validationMessage:k,severity:L.default.Error}):this.z({validationMessage:k.message,severity:k.severity??L.default.Error}):this.z({validationMessage:void 0,severity:L.default.Ignore})}}return new r(f,o)}e.$Nhc=S}),define(ke[334],Se([1,0,2,4,52,3,11,6,19,128,13,26,61,15,25,17,10]),function(me,e,D,O,g,I,A,b,$,y,L,C,m,p,S,h,f){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$Phc=e.$Ohc=void 0;function i(P){return P instanceof D.URI}function r(P,N){return P.scheme===h.Schemas.file&&N.scheme===h.Schemas.file&&f.$k?P.toString()===N.toString():P.toString().toLowerCase()===N.toString().toLowerCase()}function n(P){if(P)return typeof P.iconPath=="string"?D.URI.file(P.iconPath):D.URI.isUri(P.iconPath)||m.ThemeIcon.isThemeIcon(P.iconPath)?P.iconPath:void 0}function c(P){if(P.icon){if(D.URI.isUri(P.icon))return P.icon;if(m.ThemeIcon.isThemeIcon(P.icon))return P.icon;{const N=P.icon;return{light:N.light,dark:N.dark}}}else return}function t(P,N){if(!P.iconPath&&!N.iconPath)return 0;if(P.iconPath){if(!N.iconPath)return 1}else return-1;const U=typeof P.iconPath=="string"?P.iconPath:D.URI.isUri(P.iconPath)?P.iconPath.fsPath:P.iconPath.id,F=typeof N.iconPath=="string"?N.iconPath:D.URI.isUri(N.iconPath)?N.iconPath.fsPath:N.iconPath.id;return(0,y.$Sq)(U,F)}function u(P,N){let U=0;if(P.strikeThrough!==N.strikeThrough)return P.strikeThrough?1:-1;if(P.faded!==N.faded)return P.faded?1:-1;if(P.tooltip!==N.tooltip)return(P.tooltip||"").localeCompare(N.tooltip||"");if(U=t(P,N),U!==0)return U;if(P.light&&N.light)U=t(P.light,N.light);else{if(P.light)return 1;if(N.light)return-1}if(U!==0)return U;if(P.dark&&N.dark)U=t(P.dark,N.dark);else{if(P.dark)return 1;if(N.dark)return-1}return U}function s(P,N){if(P.command!==N.command)return P.command<N.command?-1:1;if(P.title!==N.title)return P.title<N.title?-1:1;if(P.tooltip!==N.tooltip){if(P.tooltip!==void 0&&N.tooltip!==void 0)return P.tooltip<N.tooltip?-1:1;if(P.tooltip!==void 0)return 1;if(N.tooltip!==void 0)return-1}if(P.arguments===N.arguments)return 0;if(P.arguments)if(N.arguments){if(P.arguments.length!==N.arguments.length)return P.arguments.length-N.arguments.length}else return 1;else return-1;for(let U=0;U<P.arguments.length;U++){const F=P.arguments[U],j=N.arguments[U];if(F!==j&&!(i(F)&&i(j)&&r(F,j)))return F<j?-1:1}return 0}function l(P,N){let U=(0,y.$Sq)(P.resourceUri.fsPath,N.resourceUri.fsPath,!0);if(U!==0)return U;if(P.command&&N.command)U=s(P.command,N.command);else{if(P.command)return 1;if(N.command)return-1}if(U!==0)return U;if(P.decorations&&N.decorations)U=u(P.decorations,N.decorations);else{if(P.decorations)return 1;if(N.decorations)return-1}if(P.multiFileDiffEditorModifiedUri&&N.multiFileDiffEditorModifiedUri)U=(0,y.$Sq)(P.multiFileDiffEditorModifiedUri.fsPath,N.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(P.multiFileDiffEditorModifiedUri)return 1;if(N.multiFileDiffEditorModifiedUri)return-1}if(P.multiDiffEditorOriginalUri&&N.multiDiffEditorOriginalUri)U=(0,y.$Sq)(P.multiDiffEditorOriginalUri.fsPath,N.multiDiffEditorOriginalUri.fsPath,!0);else{if(P.multiDiffEditorOriginalUri)return 1;if(N.multiDiffEditorOriginalUri)return-1}return U}function a(P,N){for(let U=0;U<P.length;U++)if(P[U]!==N[U])return!1;return!0}function d(P,N){return P.command===N.command&&P.title===N.title&&P.tooltip===N.tooltip&&(P.arguments&&N.arguments?a(P.arguments,N.arguments):P.arguments===N.arguments)}function k(P,N){return(0,$.$ub)(P,N,d)}class R{#e;#t;get value(){return this.d}set value(N){N=N??"",this.#e.$setInputBoxValue(this.l,N),this.n(N)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(N){this.#e.$setInputBoxPlaceholder(this.l,N),this.f=N}get validateInput(){return(0,S.$CF)(this.k,"scmValidation"),this.g}set validateInput(N){if((0,S.$CF)(this.k,"scmValidation"),N&&typeof N!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=N,this.#e.$setValidationProviderIsEnabled(this.l,!!N)}get enabled(){return this.h}set enabled(N){N=!!N,this.h!==N&&(this.h=N,this.#e.$setInputBoxEnablement(this.l,N))}get visible(){return this.j}set visible(N){N=!!N,this.j!==N&&(this.j=N,this.#e.$setInputBoxVisibility(this.l,N))}get document(){return(0,S.$CF)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(N,U,F,j,T){this.k=N,this.l=j,this.m=T,this.d="",this.e=new O.$Vd,this.f="",this.h=!0,this.j=!0,this.#t=U,this.#e=F}showValidationMessage(N,U){(0,S.$CF)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,N,U)}$onInputBoxValueChange(N){this.n(N)}n(N){this.d=N,this.e.fire(N)}}e.$Ohc=R;class v{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(N){this.v=N,this.q.$updateGroupLabel(this.t,this.handle,N)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(N){this.p=N,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(N){this.f=[...N],this.k.fire()}constructor(N,U,F,j,T,M,B){this.q=N,this.s=U,this.t=F,this.u=j,this.v=T,this.multiDiffEditorEnableViewChanges=M,this.w=B,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new O.$Vd,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new O.$Vd,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=v.d++}getResourceState(N){return this.g.get(N)}$executeResourceCommand(N,U){const F=this.h.get(N);return F?(0,A.$Yg)(()=>this.s.executeCommand(F.command,...F.arguments||[],U)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const N=[...this.f].sort(l),F=(0,$.$Db)(this.o,N,l).map(M=>{const B=M.toInsert.map(Y=>{const ue=this.e++;this.g.set(ue,Y);const Z=Y.resourceUri;let J;if(Y.command)if(Y.command.command==="vscode.open"||Y.command.command==="vscode.diff"||Y.command.command==="vscode.changes"){const te=new I.$Sc;J=this.s.converter.toInternal(Y.command,te),this.j.set(ue,te)}else this.h.set(ue,Y.command);const X=(0,S.$BF)(this.w,"scmMultiDiffEditor"),he=X?Y.multiDiffEditorOriginalUri:void 0,_=X?Y.multiFileDiffEditorModifiedUri:void 0,we=n(Y.decorations),oe=Y.decorations&&n(Y.decorations.light)||we,K=Y.decorations&&n(Y.decorations.dark)||we,W=[oe,K],re=Y.decorations&&Y.decorations.tooltip||"",ye=Y.decorations&&!!Y.decorations.strikeThrough,de=Y.decorations&&!!Y.decorations.faded,ge=Y.contextValue||"";return{rawResource:[ue,Z,W,re,ye,de,ge,J,he,_],handle:ue}});return{start:M.start,deleteCount:M.deleteCount,toInsert:B}}),j=F.map(({start:M,deleteCount:B,toInsert:Y})=>[M,B,Y.map(ue=>ue.rawResource)]),T=F.reverse();for(const{start:M,deleteCount:B,toInsert:Y}of T){const ue=Y.map(J=>J.handle),Z=this.n.splice(M,B,...ue);for(const J of Z)this.g.delete(J),this.h.delete(J),this.j.get(J)?.dispose(),this.j.delete(J)}return this.o=N,j}dispose(){this.l=!0,this.m.fire()}}class w{static{this.d=0}#e;get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(N){this.g!==N&&(this.g=N,this.#e.$updateSourceControl(this.w,{count:N}))}get quickDiffProvider(){return this.h}set quickDiffProvider(N){this.h=N;let U;(0,S.$BF)(this.x,"quickDiffProvider")&&(U=N?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!N,quickDiffLabel:U})}get historyProvider(){return(0,S.$CF)(this.x,"scmHistoryProvider"),this.j}set historyProvider(N){(0,S.$CF)(this.x,"scmHistoryProvider"),this.j=N,this.k.value=new I.$Sc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!N}),N&&this.k.value.add(N.onDidChangeCurrentHistoryItemGroup(()=>{this.l=N?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(N){N!==this.m&&(this.m=N,this.#e.$updateSourceControl(this.w,{commitTemplate:N}))}get acceptInputCommand(){return this.o}set acceptInputCommand(N){this.n.value=new I.$Sc,this.o=N;const U=this.y.converter.toInternal(N,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:U})}get actionButton(){return(0,S.$CF)(this.x,"scmActionButton"),this.q}set actionButton(N){(0,S.$CF)(this.x,"scmActionButton"),this.p.value=new I.$Sc,this.q=N;const U=N!==void 0?{command:this.y.converter.toInternal(N.command,this.p.value),secondaryCommands:N.secondaryCommands?.map(F=>F.map(j=>this.y.converter.toInternal(j,this.p.value))),description:N.description,enabled:N.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:U??null})}get statusBarCommands(){return this.t}set statusBarCommands(N){if(this.t&&N&&k(this.t,N))return;this.s.value=new I.$Sc,this.t=N;const U=(N||[]).map(F=>this.y.converter.toInternal(F,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:U})}get selected(){return this.u}constructor(N,U,F,j,T,M,B){this.x=N,this.y=j,this.z=T,this.A=M,this.B=B,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new I.$Uc,this.m=void 0,this.n=new I.$Uc,this.o=void 0,this.p=new I.$Uc,this.s=new I.$Uc,this.t=void 0,this.u=!1,this.v=new O.$Vd,this.onDidChangeSelection=this.v.event,this.w=w.d++,this.C=new Map,this.D=new Set,this.#e=F;const Y=D.URI.from({scheme:h.Schemas.vscodeSourceControl,path:`${T}/scm${this.w}/input`,query:B?`rootUri=${encodeURIComponent(B.toString())}`:void 0});this.f=new R(N,U,this.#e,this.w,Y),this.#e.$registerSourceControl(this.w,T,M,B,Y)}createResourceGroup(N,U,F){const j=(0,S.$BF)(this.x,"scmMultiDiffEditor")&&F?.multiDiffEditorEnableViewChanges===!0,T=new v(this.#e,this.y,this.w,N,U,j,this.x),M=O.Event.once(T.onDidDispose)(()=>this.C.delete(T));return this.C.set(T,M),this.eventuallyAddResourceGroups(),T}eventuallyAddResourceGroups(){const N=[],U=[];for(const[F,j]of this.C){j.dispose();const T=F.onDidUpdateResourceStates(()=>{this.D.add(F),this.eventuallyUpdateResourceStates()});O.Event.once(F.onDidDispose)(()=>{this.D.delete(F),T.dispose(),this.e.delete(F.handle),this.#e.$unregisterGroup(this.w,F.handle)}),N.push([F.handle,F.id,F.label,F.features,F.multiDiffEditorEnableViewChanges]);const M=F._takeResourceStateSnapshot();M.length>0&&U.push([F.handle,M]),this.e.set(F.handle,F)}this.#e.$registerGroups(this.w,N,U),this.C.clear()}eventuallyUpdateResourceStates(){const N=[];this.D.forEach(U=>{const F=U._takeResourceStateSnapshot();F.length!==0&&N.push([U.handle,F])}),N.length>0&&this.#e.$spliceResourceStates(this.w,N),this.D.clear()}getResourceGroup(N){return this.e.get(N)}setSelectionState(N){this.u=N,this.v.fire(N)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(N=>N.dispose()),this.#e.$unregisterSourceControl(this.w)}}Ge([(0,g.$yh)(100)],w.prototype,"eventuallyAddResourceGroups",null),Ge([(0,g.$yh)(100)],w.prototype,"eventuallyUpdateResourceStates",null);let E=class{static{o=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(N,U,F,j){this.l=U,this.m=F,this.n=j,this.g=new Map,this.h=new C.$nm,this.j=new O.$Vd,this.e=N.getProxy(b.$6K.MainThreadSCM),this.f=N.getProxy(b.$6K.MainThreadTelemetry),U.registerArgumentProcessor({processArgument:T=>{if(T&&T.$mid===3){const M=this.g.get(T.sourceControlHandle);if(!M)return T;const B=M.getResourceGroup(T.groupHandle);return B?B.getResourceState(T.handle):T}else if(T&&T.$mid===4){const M=this.g.get(T.sourceControlHandle);return M?M.getResourceGroup(T.groupHandle):T}else if(T&&T.$mid===5){const M=this.g.get(T.handle);return M||T}return T}})}createSourceControl(N,U,F,j){this.n.trace("ExtHostSCM#createSourceControl",N.identifier.value,U,F,j),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:N.identifier.value});const T=o.d++,M=new w(N,this.m,this.e,this.l,U,F,j);this.g.set(T,M);const B=this.h.get(N.identifier)||[];return B.push(M),this.h.set(N.identifier,B),M}getLastInputBox(N){this.n.trace("ExtHostSCM#getLastInputBox",N.identifier.value);const U=this.h.get(N.identifier),F=U&&U[U.length-1];return F&&F.inputBox}$provideOriginalResource(N,U,F){const j=D.URI.revive(U);this.n.trace("ExtHostSCM#$provideOriginalResource",N,j.toString());const T=this.g.get(N);return!T||!T.quickDiffProvider||!T.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.$Yg)(()=>T.quickDiffProvider.provideOriginalResource(j,F)).then(M=>M||null)}$onInputBoxValueChange(N,U){this.n.trace("ExtHostSCM#$onInputBoxValueChange",N);const F=this.g.get(N);return F&&F.inputBox.$onInputBoxValueChange(U),Promise.resolve(void 0)}$executeResourceCommand(N,U,F,j){this.n.trace("ExtHostSCM#$executeResourceCommand",N,U,F);const T=this.g.get(N);if(!T)return Promise.resolve(void 0);const M=T.getResourceGroup(U);return M?M.$executeResourceCommand(F,j):Promise.resolve(void 0)}$validateInput(N,U,F){this.n.trace("ExtHostSCM#$validateInput",N);const j=this.g.get(N);return!j||!j.inputBox.validateInput?Promise.resolve(void 0):(0,A.$Yg)(()=>j.inputBox.validateInput(U,F)).then(T=>{if(!T)return Promise.resolve(void 0);const M=p.MarkdownString.fromStrict(T.message);return M?Promise.resolve([M,T.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(N){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",N),N!==void 0&&this.g.get(N)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=N,Promise.resolve(void 0)}async $resolveHistoryItemGroupBase(N,U,F){return await this.g.get(N)?.historyProvider?.resolveHistoryItemGroupBase(U,F)??void 0}async $resolveHistoryItemGroupCommonAncestor(N,U,F,j){return await this.g.get(N)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(U,F,j)??void 0}async $provideHistoryItems(N,U,F,j){return(await this.g.get(N)?.historyProvider?.provideHistoryItems(U,F,j))?.map(B=>({...B,icon:c(B)}))??void 0}async $provideHistoryItemSummary(N,U,F,j){const T=this.g.get(N)?.historyProvider;if(typeof T?.provideHistoryItemSummary!="function")return;const M=await T.provideHistoryItemSummary(U,F,j);return M?{...M,icon:c(M)}:void 0}async $provideHistoryItemChanges(N,U,F,j){return await this.g.get(N)?.historyProvider?.provideHistoryItemChanges(U,F,j)??void 0}};e.$Phc=E,e.$Phc=E=o=Ge([We(3,L.$nj)],E)}),define(ke[117],Se([1,0,6,4,5]),function(me,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wgc=e.$Vgc=void 0;class I{constructor(b){this.b=new O.$Vd,this.onDidChangePassword=this.b.event,this.a=b.getProxy(D.$6K.MainThreadSecretState)}async $onDidChangePassword(b){this.b.fire(b)}get(b,$){return this.a.$getPassword(b,$)}store(b,$,y){return this.a.$setPassword(b,$,y)}delete(b,$){return this.a.$deletePassword(b,$)}}e.$Vgc=I,e.$Wgc=(0,g.$6h)("IExtHostSecretState")}),define(ke[335],Se([1,0,6,15,2]),function(me,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qhc=void 0;class I{static{this.a=0}constructor(b,$){this.d=$,this.c=new Map,this.b=b.getProxy(D.$6K.MainThreadShare)}async $provideShare(b,$,y){return await this.c.get(b)?.provideShare({selection:O.Range.to($.selection),resourceUri:g.URI.revive($.resourceUri)},y)??void 0}registerShareProvider(b,$){const y=I.a++;return this.c.set(y,$),this.b.$registerShareProvider(y,O.DocumentSelector.from(b,this.d),$.id,$.label,$.priority),{dispose:()=>{this.b.$unregisterShareProvider(y),this.c.delete(y)}}}}e.$Qhc=I}),define(ke[336],Se([1,0,21,3,6]),function(me,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rhc=void 0;class I{static{this.a=1}constructor(b){this.c=new Map,this.d=new Map,this.b=b.getProxy(g.$6K.MainThreadSpeech)}async $createSpeechToTextSession(b,$){const y=this.c.get(b);if(!y)return;const L=new O.$Sc,C=new D.$6d;this.d.set($,C);const m=L.add(y.provideSpeechToTextSession(C.token));L.add(m.onDidChange(p=>{C.token.isCancellationRequested||this.b.$emitSpeechToTextEvent($,p)})),L.add(C.token.onCancellationRequested(()=>L.dispose()))}async $cancelSpeechToTextSession(b){this.d.get(b)?.dispose(!0),this.d.delete(b)}registerProvider(b,$,y){const L=I.a++;return this.c.set(L,y),this.b.$registerProvider(L,$,{extension:b,displayName:b.value}),(0,O.$Rc)(()=>{this.b.$unregisterProvider(L),this.c.delete(L)})}}e.$Rhc=I}),define(ke[337],Se([1,0,7,6,216,3,15,18]),function(me,e,D,O,g,I,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Thc=e.$Shc=void 0;class ${static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new D.$4L("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new D.$4L("statusBarItem.warningForeground")]])}#e;#t;constructor(m,p,S,h,f,o=D.StatusBarAlignment.Left,i){if(this.i=!1,this.k="",this.q=new I.$Sc,this.#e=m,this.#t=p,f&&h){this.c=(0,D.$GL)(h.identifier,f);const r=S.get(this.c);r&&(o=r.alignLeft?D.StatusBarAlignment.Left:D.StatusBarAlignment.Right,i=r.priority,this.j=!0,this.name=r.name,this.text=r.text,this.tooltip=r.tooltip,this.command=r.command,this.accessibilityInformation=r.accessibilityInformation)}else this.c=String($.a++);this.e=h,this.f=f,this.g=o,this.h=this.u(i)}u(m){if((0,b.$Mf)(m))return m===Number.POSITIVE_INFINITY?Number.MAX_VALUE:m===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:m}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(m){this.k=m,this.v()}set name(m){this.m=m,this.v()}set tooltip(m){this.l=m,this.v()}set color(m){this.n=m,this.v()}set backgroundColor(m){m&&!$.b.has(m.id)&&(m=void 0),this.o=m,this.v()}set command(m){this.r?.fromApi!==m&&(this.p&&this.q.add(this.p),this.p=new I.$Sc,typeof m=="string"?this.r={fromApi:m,internal:this.#t.toInternal({title:"",command:m},this.p)}:m?this.r={fromApi:m,internal:this.#t.toInternal(m,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(m){this.t=m,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let m;this.e?this.f?m=`${this.e.identifier.value}.${this.f}`:m=this.e.identifier.value:m=this.f;let p;this.m?p=this.m:p=(0,g.localize)(0,null,this.e.displayName||this.e.name);let S=this.n;this.o&&(S=$.b.get(this.o.id));const h=A.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,m,this.e?.identifier.value,p,this.k,h,this.r?.internal,S,this.o,this.g===D.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$Shc=$;class y{constructor(m){this.b=[],this.a=m.createStatusBarEntry(void 0,"status.extensionMessage",D.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,g.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(m){const p={message:m};return this.b.unshift(p),this.c(),new D.$8K(()=>{const S=this.b.indexOf(p);S>=0&&(this.b.splice(S,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class L{constructor(m,p){this.e=new Map,this.a=m.getProxy(O.$6K.MainThreadStatusBar),this.b=p,this.c=new y(this)}$acceptStaticEntries(m){for(const p of m)this.e.set(p.entryId,p)}createStatusBarEntry(m,p,S,h){return new $(this.a,this.b,this.e,m,p,S,h)}setStatusBarMessage(m,p){const S=this.c.setMessage(m);let h;return typeof p=="number"?h=setTimeout(()=>S.dispose(),p):typeof p<"u"&&p.then(()=>S.dispose(),()=>S.dispose()),new D.$8K(()=>{S.dispose(),clearTimeout(h)})}}e.$Thc=L}),define(ke[118],Se([1,0,6,4,5]),function(me,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ogc=e.$Ngc=void 0;class I{constructor(b,$){this.c=$,this.b=new O.$Vd,this.onDidChangeStorage=this.b.event,this.a=b.getProxy(D.$6K.MainThreadStorage)}registerExtensionStorageKeysToSync(b,$){this.a.$registerExtensionStorageKeysToSync(b,$)}async initializeExtensionStorage(b,$,y){const L=await this.a.$initializeExtensionStorage(b,$);let C;return L&&(C=this.d(b,$,L)),C||y}setValue(b,$,y){return this.a.$setValue(b,$,y)}$acceptValue(b,$,y){const L=this.d(b,$,y);L&&this.b.fire({shared:b,key:$,value:L})}d(b,$,y){try{return JSON.parse(y)}catch(L){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${$}, global: ${b}): ${L}`)}}}e.$Ngc=I,e.$Ogc=(0,g.$6h)("IExtHostStorage")}),define(ke[92],Se([1,0,5,27,13,71,2]),function(me,e,D,O,g,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xgc=e.$wgc=void 0,e.$wgc=(0,D.$6h)("IExtensionStoragePaths");let b=class{constructor(y,L,C){this.d=L,this.f=C,this.a=y.workspace??void 0,this.b=y.environment,this.whenReady=this.h().then(m=>this.c=m)}async g(y){return A.URI.joinPath(this.b.workspaceStorageHome,y)}async h(){if(!this.a)return Promise.resolve(void 0);const y=this.a.id,L=await this.g(y);try{return await this.f.value.stat(L),this.d.trace("[ExtHostStorage] storage dir already exists",L),L}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",L),await this.f.value.createDirectory(L),await this.f.value.writeFile(A.URI.joinPath(L,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:A.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),L}catch(C){this.d.error("[ExtHostStorage]",C);return}}workspaceValue(y){if(this.c)return A.URI.joinPath(this.c,y.identifier.value)}globalValue(y){return A.URI.joinPath(this.b.globalStorageHome,y.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$xgc=b,e.$xgc=b=Ge([We(0,O.$nN),We(1,g.$nj),We(2,I.$vgc)],b)}),define(ke[46],Se([1,0,4,6,5,2,20,3,7,218,14,262,21,30,263,61,11,15,35]),function(me,e,D,O,g,I,A,b,$,y,L,C,m,p,S,h,f,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ugc=e.$Tgc=e.$Sgc=e.$Rgc=void 0,e.$Rgc=(0,g.$6h)("IExtHostTerminalService");class r{constructor(v,w,E,P){this.l=v,this._id=w,this.m=E,this.n=P,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(U=>this.f=U);const N=this;this.value={get name(){return N.n||""},get processId(){return N.b},get creationOptions(){return N.m},get exitStatus(){return N.h},get state(){return N.j},get selection(){return N.k},sendText(U,F=!0){N.q(),N.l.$sendText(N._id,U,F)},show(U){N.q(),N.l.$show(N._id,U)},hide(){N.q(),N.l.$hide(N._id)},dispose(){N.a||(N.a=!0,N.l.$dispose(N._id))},get dimensions(){if(!(N.d===void 0||N.g===void 0))return{columns:N.d,rows:N.g}}}}async create(v,w){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:v.name,shellPath:v.shellPath??void 0,shellArgs:v.shellArgs??void 0,cwd:v.cwd??w?.cwd??void 0,env:v.env??void 0,icon:a(v.iconPath)??void 0,color:h.ThemeColor.isThemeColor(v.color)?v.color.id:void 0,initialText:v.message??void 0,strictEnv:v.strictEnv??void 0,hideFromUser:v.hideFromUser??void 0,isFeatureTerminal:w?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:w?.useShellEnvironment??void 0,location:w?.location||this.o(v.location,w?.resolvedExtHostIdentifier),isTransient:v.isTransient??void 0})}async createExtensionTerminal(v,w,E,P,N){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:P,color:h.ThemeColor.isThemeColor(N)?N.id:void 0,location:w?.location||this.o(v,E),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(v,w){return typeof v=="object"?"parentTerminal"in v&&v.parentTerminal&&w?{parentTerminal:w}:"viewColumn"in v?{viewColumn:o.ViewColumn.from(v.viewColumn),preserveFocus:v.preserveFocus}:void 0:v}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(v){this.n=v}setExitStatus(v,w){this.h=Object.freeze({code:v,reason:w})}setDimensions(v,w){return v===this.d&&w===this.g||v===0||w===0?!1:(this.d=v,this.g=w,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(v){this.k=v}_setProcessId(v){this.f?(this.f(v),this.f=void 0):this.b.then(w=>{w!==v&&(this.b=Promise.resolve(v))})}}e.$Sgc=r;class n{get onProcessReady(){return this.b.event}constructor(v){this.g=v,this.id=0,this.shouldPersist=!1,this.a=new D.$Vd,this.onProcessData=this.a.event,this.b=new D.$Vd,this.d=new D.$Vd,this.onDidChangeProperty=this.d.event,this.f=new D.$Vd,this.onProcessExit=this.f.event}refreshProperty(v){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${v}`)}updateProperty(v,w){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${v}, value: ${w}`)}async start(){}shutdown(){this.g.close()}input(v){this.g.handleInput?.(v)}resize(v,w){this.g.setDimensions?.({columns:v,rows:w})}clearBuffer(){}async processBinary(v){}acknowledgeDataEvent(v){}async setUnicodeVersion(v){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(v){this.g.onDidWrite(w=>this.a.fire(w)),this.g.onDidClose?.((w=void 0)=>{this.f.fire(w===void 0?void 0:w)}),this.g.onDidOverrideDimensions?.(w=>{w&&this.d.fire({type:"overrideDimensions",value:{cols:w.columns,rows:w.rows}})}),this.g.onDidChangeName?.(w=>{this.d.fire({type:"title",value:w})}),this.g.open(v||void 0),v&&this.g.setDimensions?.(v),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let c=1,t=class extends b.$Tc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(v=>v.value)}constructor(v,w,E){super(),this.Q=w,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new b.$Uc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new D.$Vd,this.onDidCloseTerminal=this.H.event,this.I=new D.$Vd,this.onDidOpenTerminal=this.I.event,this.J=new D.$Vd,this.onDidChangeActiveTerminal=this.J.event,this.L=new D.$Vd,this.onDidChangeTerminalDimensions=this.L.event,this.M=new D.$Vd,this.onDidChangeTerminalState=this.M.event,this.N=new D.$Vd,this.onDidChangeShell=this.N.event,this.O=new D.$Vd({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new D.$Vd({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=E.getProxy(O.$6K.MainThreadTerminalService),this.y=new S.$Krb(this.a.$sendProcessData),this.a.$registerProcessSupport(v),this.Q.registerArgumentProcessor({processArgument:P=>{const N=U=>{const F=U;return this.W(F.instanceId)?.value};switch(P?.$mid){case 15:return N(P);default:{if(Array.isArray(P))for(let U=0;U<P.length&&P[U].$mid===15;U++)P[U]=N(P[U]);return P}}}}),this.B({dispose:()=>{for(const[P,N]of this.g)N.shutdown(!0)}})}getDefaultShell(v){return(v?this.u:this.s)?.path||""}getDefaultShellArgs(v){return(v?this.u:this.s)?.args||[]}createExtensionTerminal(v,w){const E=new r(this.a,(0,p.$qg)(),v,v.name),P=new n(v.pty);return E.createExtensionTerminal(v.location,w,this.R(v,w).resolvedExtHostIdentifier,a(v.iconPath),d(v.color)).then(N=>{const U=this.S(N,P);this.h[N]=U}),this.f.push(E),E.value}R(v,w){if(w=w||{},v.location&&typeof v.location=="object"&&"parentTerminal"in v.location){const E=v.location.parentTerminal;if(E){const P=this.f.find(N=>N.value===E);P&&(w.resolvedExtHostIdentifier=P._id)}}else v.location&&typeof v.location!="object"?w.location=v.location:w.location&&typeof w.location=="object"&&"splitActiveTerminal"in w.location&&(w.location={splitActiveTerminal:!0});return w}attachPtyToTerminal(v,w){if(!this.W(v))throw new Error(`Cannot resolve terminal with id ${v} for virtual process`);const P=new n(w),N=this.S(v,P);this.h[v]=N}async $acceptActiveTerminalChanged(v){const w=this.b;if(v===null){this.b=void 0,w!==this.b&&this.J.fire(this.b);return}const E=this.W(v);E&&(this.b=E,w!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(v,w){const E=this.W(v);E&&this.O.fire({terminal:E.value,data:w})}async $acceptTerminalDimensions(v,w,E){const P=this.W(v);P&&P.setDimensions(w,E)&&this.L.fire({terminal:P.value,dimensions:P.value.dimensions})}async $acceptDidExecuteCommand(v,w){const E=this.W(v);E&&this.P.fire({terminal:E.value,...w})}async $acceptTerminalMaximumDimensions(v,w,E){this.g.get(v)?.resize(w,E)}async $acceptTerminalTitleChange(v,w){const E=this.W(v);E&&(E.name=w)}async $acceptTerminalClosed(v,w,E){const P=this.Y(this.f,v);if(P!==null){const N=this.f.splice(P,1)[0];N.setExitStatus(w,E),this.H.fire(N.value)}}$acceptTerminalOpened(v,w,E,P){if(w){const F=this.Y(this.f,w);if(F!==null){this.f[F]._id=v,this.I.fire(this.terminals[F]),this.f[F].isOpen=!0;return}}const N={name:P.name,shellPath:P.executable,shellArgs:P.args,cwd:typeof P.cwd=="string"?P.cwd:I.URI.revive(P.cwd),env:P.env,hideFromUser:P.hideFromUser},U=new r(this.a,v,N,E);this.f.push(U),this.I.fire(U.value),U.isOpen=!0}async $acceptTerminalProcessId(v,w){this.W(v)?._setProcessId(w)}async $startExtensionTerminal(v,w){const E=this.W(v);if(!E)return{message:(0,y.localize)(0,null,v)};E.isOpen||await new Promise(N=>{const U=this.onDidOpenTerminal(async F=>{F===E.value&&(U.dispose(),N())})});const P=this.g.get(v);P?P.startSendingEvents(w):this.j[v]={initialDimensions:w}}S(v,w){const E=new b.$Sc;E.add(w.onProcessReady(N=>this.a.$sendProcessReady(v,N.pid,N.cwd,N.windowsPty))),E.add(w.onDidChangeProperty(N=>this.a.$sendProcessProperty(v,N))),this.y.startBuffering(v,w.onProcessData),E.add(w.onProcessExit(N=>this.U(v,N))),this.g.set(v,w);const P=this.j[v];return P&&w instanceof n&&(w.startSendingEvents(P.initialDimensions),delete this.j[v]),E}$acceptProcessAckDataEvent(v,w){this.g.get(v)?.acknowledgeDataEvent(w)}$acceptProcessInput(v,w){this.g.get(v)?.input(w)}$acceptTerminalInteraction(v){const w=this.W(v);w?.setInteractedWith()&&this.M.fire(w.value)}$acceptTerminalSelection(v,w){this.W(v)?.setSelection(w)}$acceptProcessResize(v,w,E){try{this.g.get(v)?.resize(w,E)}catch(P){if(P.code!=="EPIPE"&&P.code!=="ERR_IPC_CHANNEL_CLOSED")throw P}}$acceptProcessShutdown(v,w){this.g.get(v)?.shutdown(w)}$acceptProcessRequestInitialCwd(v){this.g.get(v)?.getInitialCwd().then(w=>this.a.$sendProcessProperty(v,{type:"initialCwd",value:w}))}$acceptProcessRequestCwd(v){this.g.get(v)?.getCwd().then(w=>this.a.$sendProcessProperty(v,{type:"cwd",value:w}))}$acceptProcessRequestLatency(v){return Promise.resolve(v)}registerLinkProvider(v){return this.z.add(v),this.z.size===1&&this.a.$startLinkProvider(),new $.$8K(()=>{this.z.delete(v),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(v,w,E){if(this.C.has(w))throw new Error(`Terminal profile provider "${w}" already registered`);return this.C.set(w,E),this.a.$registerProfileProvider(w,v.identifier.value),new $.$8K(()=>{this.C.delete(w),this.a.$unregisterProfileProvider(w)})}registerTerminalQuickFixProvider(v,w,E){if(this.D.has(v))throw new Error(`Terminal quick fix provider "${v}" is already registered`);return this.D.set(v,E),this.a.$registerQuickFixProvider(v,w),new $.$8K(()=>{this.D.delete(v),this.a.$unregisterQuickFixProvider(v)})}async $provideTerminalQuickFixes(v,w){const E=new m.$6d().token;if(E.isCancellationRequested)return;const P=this.D.get(v);if(!P)return;const N=await P.provideTerminalQuickFixes(w,E);if(N===null||Array.isArray(N)&&N.length===0)return;const U=new b.$Sc;if(this.w.value=U,!Array.isArray(N))return N?o.TerminalQuickFix.from(N,this.Q.converter,U):void 0;const F=[];for(const j of N){const T=o.TerminalQuickFix.from(j,this.Q.converter,U);T&&F.push(T)}return F}async $createContributedProfileTerminal(v,w){const E=new m.$6d().token;let P=await this.C.get(v)?.provideTerminalProfile(E);if(!E.isCancellationRequested){if(P&&!("options"in P)&&(P={options:P}),!P||!("options"in P))throw new Error(`No terminal profile options provided for id "${v}"`);if("pty"in P.options){this.createExtensionTerminal(P.options,w);return}this.createTerminalFromOptions(P.options,w)}}async $provideLinks(v,w){const E=this.W(v);if(!E)return[];this.F.delete(v),this.G.get(v)?.dispose(!0);const N=new m.$6d;this.G.set(v,N);const U=[],F={terminal:E.value,line:w},j=[];for(const B of this.z)j.push(f.Promises.withAsyncBody(async Y=>{N.token.onCancellationRequested(()=>Y({provider:B,links:[]}));const ue=await B.provideTerminalLinks(F,N.token)||[];N.token.isCancellationRequested||Y({provider:B,links:ue})}));const T=await Promise.all(j);if(N.token.isCancellationRequested)return[];const M=new Map;for(const B of T)B&&B.links.length>0&&U.push(...B.links.map(Y=>{const ue={id:c++,startIndex:Y.startIndex,length:Y.length,label:Y.tooltip};return M.set(ue.id,{provider:B.provider,link:Y}),ue}));return this.F.set(v,M),U}$activateLink(v,w){const E=this.F.get(v)?.get(w);E&&E.provider.handleTerminalLink(E.link)}U(v,w){this.y.stopBuffering(v),this.g.delete(v),delete this.j[v];const E=this.h[v];E&&(E.dispose(),delete this.h[v]),this.a.$sendProcessExit(v,w)}W(v){return this.X(this.f,v)}X(v,w){const E=this.Y(v,w);return E!==null?v[E]:null}Y(v,w){const E=v.findIndex(P=>P._id===w);return E===-1?null:E}getEnvironmentVariableCollection(v){let w=this.n.get(v.identifier.value);return w||(w=new u,this.$(v.identifier.value,w)),w.getScopedEnvironmentVariableCollection(void 0)}Z(v,w){const E=(0,C.$Mr)(w.map),P=(0,C.$Nr)(w.descriptionMap);this.a.$setEnvironmentVariableCollection(v,w.persistent,E.length===0?void 0:E,P)}$initEnvironmentVariableCollections(v){v.forEach(w=>{const E=w[0],P=new u(w[1]);this.$(E,P)})}$acceptDefaultProfile(v,w){const E=this.s;this.s=v,this.u=w,E?.path!==v.path&&this.N.fire(v.path)}$(v,w){this.n.set(v,w),w.onDidChangeCollection(()=>{this.Z(v,w)})}};e.$Tgc=t,e.$Tgc=t=Ge([We(1,i.$tN),We(2,A.$0M)],t);class u{get persistent(){return this.b}set persistent(v){this.b=v,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(v){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new D.$Vd,this.map=new Map(v)}getScopedEnvironmentVariableCollection(v){const w=this.h(v);let E=this.a.get(w);return E||(E=new s(this,v),this.a.set(w,E),E.onDidChangeCollection(()=>this.d.fire())),E}replace(v,w,E,P){this.f(v,{value:w,type:$.EnvironmentVariableMutatorType.Replace,options:E??{applyAtProcessCreation:!0},scope:P})}append(v,w,E,P){this.f(v,{value:w,type:$.EnvironmentVariableMutatorType.Append,options:E??{applyAtProcessCreation:!0},scope:P})}prepend(v,w,E,P){this.f(v,{value:w,type:$.EnvironmentVariableMutatorType.Prepend,options:E??{applyAtProcessCreation:!0},scope:P})}f(v,w){if(w.options&&w.options.applyAtProcessCreation===!1&&!w.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const E=this.g(v,w.scope),P=this.map.get(E),N=w.options?{applyAtProcessCreation:w.options.applyAtProcessCreation??!1,applyAtShellIntegration:w.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!P||P.value!==w.value||P.type!==w.type||P.options?.applyAtProcessCreation!==N.applyAtProcessCreation||P.options?.applyAtShellIntegration!==N.applyAtShellIntegration||P.scope?.workspaceFolder?.index!==w.scope?.workspaceFolder?.index){const U=this.g(v,w.scope),F={variable:v,...w,options:N};this.map.set(U,F),this.d.fire()}}get(v,w){const E=this.g(v,w),P=this.map.get(E);return P?k(P):void 0}g(v,w){const E=this.h(w);return E.length?`${v}:::${E}`:v}h(v){return this.j(v?.workspaceFolder)??""}j(v){return v?v.uri.toString():void 0}getVariableMap(v){const w=new Map;for(const[E,P]of this.map)this.h(P.scope)===this.h(v)&&w.set(P.variable,k(P));return w}delete(v,w){const E=this.g(v,w);this.map.delete(E),this.d.fire()}clear(v){if(v?.workspaceFolder){for(const[w,E]of this.map)E.scope?.workspaceFolder?.index===v.workspaceFolder.index&&this.map.delete(w);this.k(v)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(v,w){const E=this.h(w),P=this.descriptionMap.get(E);if(!P||P.description!==v){let N;typeof v=="string"?N=v:N=v?.value.split(`

`)[0];const U={description:N,scope:w};this.descriptionMap.set(E,U),this.d.fire()}}getDescription(v){const w=this.h(v);return this.descriptionMap.get(w)?.description}k(v){const w=this.h(v);this.descriptionMap.delete(w)}}class s{get persistent(){return this.b.persistent}set persistent(v){this.b.persistent=v}get onDidChangeCollection(){return this.a&&this.a.event}constructor(v,w){this.b=v,this.d=w,this.a=new D.$Vd}getScoped(v){return this.b.getScopedEnvironmentVariableCollection(v)}replace(v,w,E){this.b.replace(v,w,E,this.d)}append(v,w,E){this.b.append(v,w,E,this.d)}prepend(v,w,E){this.b.prepend(v,w,E,this.d)}get(v){return this.b.get(v,this.d)}forEach(v,w){this.b.getVariableMap(this.d).forEach((E,P)=>v.call(w,P,E,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(v){this.b.delete(v,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(v){this.b.setDescription(v,this.d)}get description(){return this.b.getDescription(this.d)}}let l=class extends t{constructor(v,w){super(!1,v,w)}createTerminal(v,w,E){throw new L.$_}createTerminalFromOptions(v,w){throw new L.$_}};e.$Ugc=l,e.$Ugc=l=Ge([We(0,i.$tN),We(1,A.$0M)],l);function a(R){if(!(!R||typeof R=="string"))return"id"in R?{id:R.id,color:R.color}:R}function d(R){return h.ThemeColor.isThemeColor(R)?R:void 0}function k(R){const v={...R};return delete v.scope,v.options=v.options??void 0,delete v.variable,v}}),define(ke[338],Se([1,0,11,22,21,4,74,54,3,24,18,30,13,6,20,147,15,7,67,112,89,25]),function(me,e,D,O,g,I,A,b,$,y,L,C,m,p,S,h,f,o,i,r,n,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1hc=e.$Zhc=e.$Yhc=e.$Xhc=void 0;let t=class extends $.$Tc{constructor(j,T,M,B){super(),this.w=B,this.f=this.B(new I.$Vd),this.g=new Map,this.s=this.B(new I.$Vd),this.onResultsChanged=this.f.event,this.results=[],this.h=j.getProxy(p.$6K.MainThreadTesting),this.m=new E(this.h),this.j=new a(this.h,T),M.registerArgumentProcessor({processArgument:Y=>{switch(Y?.$mid){case 16:{const ue=Y,Z=ue.tests[ue.tests.length-1].item.extId;return this.g.get(i.$XJ.root(Z))?.collection.tree.get(Z)?.actual??(0,h.$jN)(Y)}case 18:{const{extId:ue,message:Z}=Y;return{test:this.g.get(i.$XJ.root(ue))?.collection.tree.get(ue)?.actual,message:f.TestMessage.to(Z)}}default:return Y}}}),M.registerCommand(!1,"testing.getExplorerSelection",async()=>{const Y=await M.executeCommand("_testing.getExplorerSelection"),ue=Z=>{const J=this.g.get(i.$XJ.root(Z));if(J)return i.$XJ.isRoot(Z)?J.controller:J.collection.tree.get(Z)?.actual};return{include:Y?.include.map(ue).filter(L.$Qf)||[],exclude:Y?.exclude.map(ue).filter(L.$Qf)||[]}})}createTestController(j,T,M,B){if(this.g.has(T))throw new Error(`Attempt to insert a duplicate controller with ID "${T}"`);const Y=new $.$Sc,ue=Y.add(new h.$mN(T,M,this.w));ue.root.label=M;const Z=new Map,J=new Set,X=this.h,he={items:ue.root.children,get label(){return M},set label(we){M=we,ue.root.label=we,X.$updateController(T,{label:M})},get refreshHandler(){return B},set refreshHandler(we){B=we,X.$updateController(T,{canRefresh:!!we})},get id(){return T},createRunProfile:(we,oe,K,W,re,ye)=>{let de=(0,b.$Ti)(we);for(;Z.has(de);)de++;return new N(this.h,Z,j,J,this.s.event,T,de,we,oe,K,W,re,ye)},createTestItem(we,oe,K){return new h.$kN(T,we,oe,K)},createTestRun:(we,oe,K=!0)=>this.j.createTestRun(j,T,ue,we,oe,K),invalidateTestResults:we=>{if(we===void 0)this.h.$markTestRetired(void 0);else{const oe=we instanceof Array?we:[we];this.h.$markTestRetired(oe.map(K=>i.$XJ.fromExtHostTestItem(K,T).toString()))}},set resolveHandler(we){ue.resolveHandler=we},get resolveHandler(){return ue.resolveHandler},dispose:()=>{Y.dispose()}};X.$registerTestController(T,M,!!B),Y.add((0,$.$Rc)(()=>X.$unregisterTestController(T)));const _={controller:he,collection:ue,profiles:Z,extension:j,activeProfiles:J};return this.g.set(T,_),Y.add((0,$.$Rc)(()=>this.g.delete(T))),Y.add(ue.onDidGenerateDiff(we=>X.$publishDiff(T,we.map(n.TestsDiffOp.serialize)))),he}createTestObserver(){return this.m.checkout()}async runTests(j,T=g.CancellationToken.None){const M=d(j);if(!M)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const B=this.g.get(M.controllerId);if(!B)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:j.include?.map(Y=>i.$XJ.fromExtHostTestItem(Y,B.collection.root.id).toString())??[B.collection.root.id],profileGroup:U[M.kind],profileId:M.profileId,controllerId:M.controllerId}],exclude:j.exclude?.map(Y=>Y.id)},T)}$syncTests(){for(const{collection:j}of this.g.values())j.flushDiff();return Promise.resolve()}async $provideFileCoverage(j,T,M){return await this.j.getCoverageReport(j,T)?.provideFileCoverage(M)??[]}async $resolveFileCoverage(j,T,M,B){return await this.j.getCoverageReport(j,T)?.resolveFileCoverage(M,B)??[]}$configureRunProfile(j,T){this.g.get(j)?.profiles.get(T)?.configureHandler?.()}$setDefaultRunProfiles(j){const T=new Map;for(const[M,B]of Object.entries(j)){const Y=this.g.get(M);if(!Y)continue;const ue=new Map,Z=B.filter(X=>!Y.activeProfiles.has(X)),J=[...Y.activeProfiles].filter(X=>!B.includes(X));for(const X of Z)ue.set(X,!0),Y.activeProfiles.add(X);for(const X of J)ue.set(X,!1),Y.activeProfiles.delete(X);ue.size&&T.set(M,ue)}this.s.fire(T)}async $refreshTests(j,T){await this.g.get(j)?.controller.refreshHandler?.(T)}$publishTestResults(j){this.results=Object.freeze(j.map(T=>(0,y.$wn)(f.TestResults.to(T))).concat(this.results).sort((T,M)=>M.completedAt-T.completedAt).slice(0,32)),this.f.fire()}async $expandTest(j,T){const M=this.g.get(i.$XJ.fromString(j).controllerId)?.collection;M&&(await M.expand(j,T<0?1/0:T),M.flushDiff())}$acceptDiff(j){this.m.applyDiff(j.map(T=>n.TestsDiffOp.deserialize({asCanonicalUri:M=>M},T)))}async $runControllerTests(j,T){return Promise.all(j.map(M=>this.y(M,!1,T)))}async $startContinuousRun(j,T){const M=new g.$6d(T),B=await Promise.all(j.map(Y=>this.y(Y,!0,M.token)));return!T.isCancellationRequested&&!B.some(Y=>Y.error)&&await new Promise(Y=>T.onCancellationRequested(Y)),M.dispose(!0),B}async y(j,T,M){const B=this.g.get(j.controllerId);if(!B)return{};const{collection:Y,profiles:ue,extension:Z}=B,J=ue.get(j.profileId);if(!J)return{};const X=j.testIds.map(oe=>Y.tree.get(oe)).filter(L.$Qf),he=j.excludeExtIds.map(oe=>B.collection.tree.get(oe)).filter(L.$Qf).filter(oe=>X.some(K=>K.fullId.compare(oe.fullId)===2));if(!X.length)return{};const _=new o.$EM(X.some(oe=>oe.actual instanceof h.$lN)?void 0:X.map(oe=>oe.actual),he.map(oe=>oe.actual),J,T),we=(0,n.$ZJ)(j)&&this.j.prepareForMainThreadTestRun(_,k.fromInternal(j,B.collection),Z,M);try{return await J.runHandler(_,M),{}}catch(oe){return{error:String(oe)}}finally{we&&(we.hasRunningTasks&&!M.isCancellationRequested&&await I.Event.toPromise(we.onEnd),we.dispose())}}$cancelExtensionTestRun(j){j===void 0?this.j.cancelAllRuns():this.j.cancelRunById(j)}};e.$Xhc=t,e.$Xhc=t=Ge([We(0,S.$0M),We(1,m.$nj)],t);const u=1e4;var s;(function(F){F[F.Running=0]="Running",F[F.Cancelling=1]="Cancelling",F[F.Ended=2]="Ended"})(s||(s={}));class l extends $.$Tc{get hasRunningTasks(){return this.f.size>0}get id(){return this.s.id}constructor(j,T,M,B,Y){super(),this.s=j,this.w=T,this.y=M,this.z=B,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new I.$Vd),this.m=this.B(new I.$Vd),this.onDidCoverage=this.m.event,this.onEnd=this.j.event,this.h=this.B(new g.$6d(Y));const ue=this.B(new D.$fh(()=>this.C(),u));this.B(this.h.token.onCancellationRequested(()=>ue.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.C()}createRun(j){const T=this.s.id,M=this.s.controllerId,B=(0,C.$qg)(),Y=this.y,ue=this.m;let Z;const J=we=>(oe,...K)=>{if(he){this.z.warn(`Setting the state of test "${oe.id}" is a no-op after the run ends.`);return}this.s.isIncluded(oe)&&(this.F(oe),we(oe,...K))},X=(we,oe)=>{const K=oe instanceof Array?oe.map(f.TestMessage.from):[f.TestMessage.from(oe)];if(we.uri&&we.range){const W={range:f.Range.from(we.range),uri:we.uri};for(const re of K)re.location=re.location||W}this.w.$appendTestMessagesInRun(T,B,i.$XJ.fromExtHostTestItem(we,M).toString(),K)};let he=!1;const _={isPersisted:this.s.isPersisted,token:this.h.token,name:j,get coverageProvider(){return Z?.provider},set coverageProvider(we){(0,c.$CF)(Y,"testCoverage"),Z=we&&new R(we),ue.fire({taskId:B,runId:T,coverage:Z})},enqueued:J(we=>{this.w.$updateTestStateInRun(T,B,i.$XJ.fromExtHostTestItem(we,M).toString(),1)}),skipped:J(we=>{this.w.$updateTestStateInRun(T,B,i.$XJ.fromExtHostTestItem(we,M).toString(),5)}),started:J(we=>{this.w.$updateTestStateInRun(T,B,i.$XJ.fromExtHostTestItem(we,M).toString(),2)}),errored:J((we,oe,K)=>{X(we,oe),this.w.$updateTestStateInRun(T,B,i.$XJ.fromExtHostTestItem(we,M).toString(),6,K)}),failed:J((we,oe,K)=>{X(we,oe),this.w.$updateTestStateInRun(T,B,i.$XJ.fromExtHostTestItem(we,M).toString(),4,K)}),passed:J((we,oe)=>{this.w.$updateTestStateInRun(T,B,i.$XJ.fromExtHostTestItem(we,this.s.controllerId).toString(),3,oe)}),appendOutput:(we,oe,K)=>{he||(K&&(this.s.isIncluded(K)?this.F(K):K=void 0),this.w.$appendOutputToRun(T,B,O.$je.fromString(we),oe&&f.location.from(oe),K&&i.$XJ.fromExtHostTestItem(K,M).toString()))},end:()=>{he||(he=!0,this.w.$finishedTestRunTask(T,B),this.f.delete(B),this.f.size||this.D())}};return this.f.set(B,{run:_}),this.w.$startedTestRunTask(T,{id:B,name:j,running:!0}),_}C(){for(const{run:j}of this.f.values())j.end()}D(){this.c!==2&&(this.c=2,this.j.fire())}F(j){if(!(j instanceof h.$kN))throw new r.$2M(j.id);if(this.g.has(i.$XJ.fromExtHostTestItem(j,this.s.controllerId).toString()))return;const T=[],M=this.s.colllection.root;for(;;){const B=f.TestItem.from(j);if(T.unshift(B),this.g.has(B.extId)||(this.g.add(B.extId),j===M))break;j=j.parent||M}this.w.$addTestsToRun(this.s.controllerId,this.s.id,T)}dispose(){this.D(),super.dispose()}}class a{get trackers(){return this.c.values()}constructor(j,T){this.g=j,this.h=T,this.c=new Map,this.f=[]}getCoverageReport(j,T){return this.f.find(M=>M.runId===j)?.coverage.get(T)}prepareForMainThreadTestRun(j,T,M,B){return this.j(j,T,M,B)}cancelRunById(j){for(const T of this.c.values())if(T.id===j){T.cancel();return}}cancelAllRuns(){for(const j of this.c.values())j.cancel()}createTestRun(j,T,M,B,Y,ue){const Z=this.c.get(B);if(Z)return Z.createRun(Y);const J=k.fromPublic(T,M,B,ue),X=d(B);this.g.$startedExtensionTestRun({controllerId:T,continuous:!!B.continuous,profile:X&&{group:U[X.kind],id:X.profileId},exclude:B.exclude?.map(_=>i.$XJ.fromExtHostTestItem(_,M.root.id).toString())??[],id:J.id,include:B.include?.map(_=>i.$XJ.fromExtHostTestItem(_,M.root.id).toString())??[M.root.id],persist:ue});const he=this.j(B,J,j);return I.Event.once(he.onEnd)(()=>{this.g.$finishedExtensionTestRun(J.id),he.dispose()}),he.createRun(Y)}j(j,T,M,B){const Y=new l(T,this.g,M,this.h,B);this.c.set(j,Y);let ue;const Z=Y.onDidCoverage(({runId:J,taskId:X,coverage:he})=>{ue||(ue={runId:J,coverage:new Map},this.f.unshift(ue),this.f.length>n.$5J&&this.f.pop()),ue.coverage.set(X,he),this.g.$signalCoverageAvailable(J,X,!!he)});return I.Event.once(Y.onEnd)(()=>{this.c.delete(j),Z.dispose()}),Y}}e.$Yhc=a;const d=F=>{if(F.profile){if(!(F.profile instanceof N))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return F.profile}};class k{static fromPublic(j,T,M,B){return new k(j,(0,C.$qg)(),M.include?.map(Y=>i.$XJ.fromExtHostTestItem(Y,j).toString())??[j],M.exclude?.map(Y=>i.$XJ.fromExtHostTestItem(Y,j).toString())??[],B,T)}static fromInternal(j,T){return new k(j.controllerId,j.runId,j.testIds,j.excludeExtIds,!0,T)}constructor(j,T,M,B,Y,ue){this.controllerId=j,this.id=T,this.isPersisted=Y,this.colllection=ue,this.c=M.map(Z=>Z+"\0"),this.f=B.map(Z=>Z+"\0")}isIncluded(j){const T=i.$XJ.fromExtHostTestItem(j,this.controllerId).toString()+"\0";for(const M of this.f)if(T===M||T.startsWith(M))return!1;for(const M of this.c)if(T===M||T.startsWith(M))return!0;return!1}}e.$Zhc=k;class R{constructor(j){this.provider=j}async provideFileCoverage(j){this.c||(this.c=(async()=>this.provider.provideFileCoverage(j))());try{return(await this.c)?.map(f.TestCoverage.fromFile)??[]}catch(T){throw this.c=void 0,T}}async resolveFileCoverage(j,T){const M=await this.c;let B=M?.[j];return!this.provider||!M||!B?[]:(B.detailedCoverage||(B=M[j]=await this.provider.resolveFileCoverage?.(B,T)??B),B.detailedCoverage?.map(f.TestCoverage.fromDetailed)??[])}}class v{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(j){this.j=j,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(j){this.c.add(j)}update(j){Object.assign(j.revived,f.TestItem.toPlain(j.item)),this.c.has(j)||this.f.add(j)}remove(j){if(this.c.has(j)){this.c.delete(j);return}this.f.delete(j);const T=i.$XJ.parentId(j.item.extId);if(T&&this.h.has(T.toString())){this.h.add(j.item.extId);return}this.g.add(j)}getChangeEvent(){const{c:j,f:T,g:M}=this;return{get added(){return[...j].map(B=>B.revived)},get updated(){return[...T].map(B=>B.revived)},get removed(){return[...M].map(B=>B.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class w extends n.$6J{constructor(){super(...arguments),this.s=new I.$Vd,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(j){return this.f.get(j)}getMirroredTestDataByReference(j){return this.f.get(j.id)}w(j,T){return{...j,revived:f.TestItem.toPlain(j.item),depth:T?T.depth+1:0,children:new Set}}v(){return new v(this.s)}}class E{constructor(j){this.f=j}checkout(){this.c||(this.c=this.g());const j=this.c;return j.observers++,{onDidChangeTest:j.tests.onDidChangeTests,get tests(){return[...j.tests.rootTests].map(T=>T.revived)},dispose:(0,A.$db)(()=>{--j.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(j){return this.c?.tests.getMirroredTestDataByReference(j)}applyDiff(j){this.c?.tests.apply(j)}g(){const j=new w({asCanonicalUri:T=>T});return this.f.$subscribeToDiffs(),{observers:0,tests:j}}}const P=(F,j,T,M)=>{T?Object.assign(T,M):j.$updateTestRunConfig(F.controllerId,F.profileId,M)};class N{#e;#t;#i;#o;#n;#r;get label(){return this.f}set label(j){j!==this.f&&(this.f=j,P(this,this.#e,this.#n,{label:j}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(j){j!==this.g&&(this.g=j,P(this,this.#e,this.#n,{supportsContinuousRun:j}))}get isDefault(){return this.#i.has(this.profileId)}set isDefault(j){j!==this.isDefault&&(j?this.#i.add(this.profileId):this.#i.delete(this.profileId),P(this,this.#e,this.#n,{isDefault:j}))}get tag(){return this._tag}set tag(j){j?.id!==this._tag?.id&&(this._tag=j,P(this,this.#e,this.#n,{tag:j?f.TestTag.namespace(this.controllerId,j.id):null}))}get configureHandler(){return this.c}set configureHandler(j){j!==this.c&&(this.c=j,P(this,this.#e,this.#n,{hasConfigurationHandler:!!j}))}get onDidChangeDefault(){return(0,c.$CF)(this.#t,"testingActiveProfile"),I.Event.chain(this.#o,j=>j.map(T=>T.get(this.controllerId)?.get(this.profileId)).filter(L.$Qf))}constructor(j,T,M,B,Y,ue,Z,J,X,he,_=!1,we=void 0,oe=!1){this.controllerId=ue,this.profileId=Z,this.f=J,this.kind=X,this.runHandler=he,this._tag=we,this.g=oe,this.#e=j,this.#r=T,this.#t=M,this.#i=B,this.#o=Y,T.set(Z,this);const K=U[X];if(typeof K!="number")throw new Error(`Unknown TestRunProfile.group ${X}`);_&&B.add(Z),this.#n={profileId:Z,controllerId:ue,tag:we?f.TestTag.namespace(this.controllerId,we.id):null,label:J,group:K,isDefault:_,hasConfigurationHandler:!1,supportsContinuousRun:oe},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#r?.delete(this.profileId)&&(this.#r=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$1hc=N;const U={[o.TestRunProfileKind.Coverage]:8,[o.TestRunProfileKind.Debug]:4,[o.TestRunProfileKind.Run]:2}}),define(ke[339],Se([1,0,19,4,6,148,15,7]),function(me,e,D,O,g,I,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kgc=void 0;class ${constructor(L,C){this.i=C,this.a=new O.$Vd,this.b=new O.$Vd,this.c=new O.$Vd,this.d=new O.$Vd,this.f=new O.$Vd,this.g=new O.$Vd,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=L.getProxy(g.$6K.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(m=>this.g.fire(m)),this.i.onDidChangeActiveTextEditor(m=>this.f.fire(m))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(L){const C=this.i.allEditors();return L?C:C.map(m=>m.value)}async showTextDocument(L,C,m){let p;typeof C=="number"?p={position:A.ViewColumn.from(C),preserveFocus:m}:typeof C=="object"?p={position:A.ViewColumn.from(C.viewColumn),preserveFocus:C.preserveFocus,selection:typeof C.selection=="object"?A.Range.from(C.selection):void 0,pinned:typeof C.preview=="boolean"?!C.preview:void 0}:p={preserveFocus:!1};const S=await this.h.$tryShowTextDocument(L.uri,p),h=S&&this.i.getEditor(S);if(h)return h.value;throw S?new Error(`Could NOT open editor for "${L.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${L.uri.toString()}".`)}createTextEditorDecorationType(L,C){return new I.$eN(this.h,L,C).value}$acceptEditorPropertiesChanged(L,C){const m=this.i.getEditor(L);if(!m)throw new Error("unknown text editor");if(C.options&&m._acceptOptions(C.options),C.selections){const p=C.selections.selections.map(A.Selection.to);m._acceptSelections(p)}if(C.visibleRanges){const p=D.$Hb(C.visibleRanges.map(A.Range.to));m._acceptVisibleRanges(p)}if(C.options&&this.b.fire({textEditor:m.value,options:{...C.options,lineNumbers:A.TextEditorLineNumbersStyle.to(C.options.lineNumbers)}}),C.selections){const p=b.TextEditorSelectionChangeKind.fromValue(C.selections.source),S=C.selections.selections.map(A.Selection.to);this.a.fire({textEditor:m.value,selections:S,kind:p})}if(C.visibleRanges){const p=D.$Hb(C.visibleRanges.map(A.Range.to));this.c.fire({textEditor:m.value,visibleRanges:p})}}$acceptEditorPositionData(L){for(const C in L){const m=this.i.getEditor(C);if(!m)throw new Error("Unknown text editor");const p=A.ViewColumn.to(L[C]);m.value.viewColumn!==p&&(m._acceptViewColumn(p),this.d.fire({textEditor:m.value,viewColumn:p}))}}getDiffInformation(L){return Promise.resolve(this.h.$getDiffInformation(L))}}e.$kgc=$}),define(ke[340],Se([1,0,2,5,6,3,7,15,26,18]),function(me,e,D,O,g,I,A,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4hc=e.$3hc=void 0,e.$3hc=(0,O.$6h)("IExtHostTimeline");class L{constructor(p,S){this.b=new Map,this.c=new Map,this.a=p.getProxy(g.$6K.MainThreadTimeline),S.registerArgumentProcessor({processArgument:(h,f)=>{if(h&&h.$mid===12)if(this.b.get(h.source)&&$.$lm.equals(f,this.b.get(h.source)?.extension)){const o=h.uri===void 0?void 0:D.URI.revive(h.uri);return this.c.get(h.source)?.get(C(o))?.get(h.handle)}else return;return h}})}async $getTimeline(p,S,h,f){return this.b.get(p)?.provider.provideTimeline(D.URI.revive(S),h,f)}registerTimelineProvider(p,S,h,f){const o=new I.$Sc,i=this.d(S.id,f,o).bind(this);let r;S.onDidChange&&(r=S.onDidChange(c=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...c,id:S.id}),this));const n=this.c;return this.f({...S,scheme:p,onDidChange:void 0,async provideTimeline(c,t,u){t?.resetCache&&(o.clear(),n.get(S.id)?.clear());const s=await S.provideTimeline(c,t,u);if(s==null)return;const l=i(c,t);return{...s,source:S.id,items:s.items.map(l)}},dispose(){for(const c of n.values())c.get(S.id)?.clear();r?.dispose(),o.dispose()}},h)}d(p,S,h){return(f,o)=>{let i;if(o?.cacheResults){let r=this.c.get(p);r===void 0&&(r=new Map,this.c.set(p,r));const n=C(f);i=r.get(n),i===void 0&&(i=new Map,r.set(n,i))}return r=>{const{iconPath:n,...c}=r,t=`${p}|${r.id??r.timestamp}`;i?.set(t,r);let u,s,l;r.iconPath&&(n instanceof A.$3L?l={id:n.id,color:n.color}:D.URI.isUri(n)?(u=n,s=n):{light:u,dark:s}=n);let a;return A.$wL.isMarkdownString(c.tooltip)?a=b.MarkdownString.from(c.tooltip):(0,y.$If)(c.tooltip)?a=c.tooltip:A.$wL.isMarkdownString(c.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),a=b.MarkdownString.from(c.detail)):(0,y.$If)(c.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),a=c.detail),{...c,id:c.id??void 0,handle:t,source:p,command:r.command?S.toInternal(r.command,h):void 0,icon:u,iconDark:s,themeIcon:l,tooltip:a,accessibilityInformation:r.accessibilityInformation}}}}f(p,S){if(this.b.get(p.id))throw new Error(`Timeline Provider ${p.id} already exists.`);return this.a.$registerTimelineProvider({id:p.id,label:p.label,scheme:p.scheme}),this.b.set(p.id,{provider:p,extension:S}),(0,I.$Rc)(()=>{for(const f of this.c.values())f.get(p.id)?.clear();this.b.delete(p.id),this.a.$unregisterTimelineProvider(p.id),p.dispose()})}}e.$4hc=L;function C(m){return m?.toString()}}),define(ke[72],Se([1,0,21,4,3,220,5,13,88,6,27,20,7]),function(me,e,D,O,g,I,A,b,$,y,L,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pyb=e.$oyb=e.TunnelDtoConverter=void 0;class p extends $.$Jv{}var S;(function(f){function o(r){return{remoteAddress:r.remoteAddress,localAddress:r.localAddress,public:!!r.public,privacy:r.privacy??(r.public?$.TunnelPrivacyId.Public:$.TunnelPrivacyId.Private),protocol:r.protocol}}f.fromApiTunnel=o;function i(r){return{remoteAddress:{host:r.tunnelRemoteHost,port:r.tunnelRemotePort},localAddress:r.localAddress,public:r.privacy!==$.TunnelPrivacyId.ConstantPrivate&&r.privacy!==$.TunnelPrivacyId.ConstantPrivate,privacy:r.privacy,protocol:r.protocol}}f.fromServiceTunnel=i})(S||(e.TunnelDtoConverter=S={})),e.$oyb=(0,A.$6h)("IExtHostTunnelService");let h=class extends g.$Tc{constructor(o,i,r){super(),this.s=r,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new O.$Vd,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=o.getProxy(y.$6K.MainThreadTunnelService)}async openTunnel(o,i){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${o.identifier.value} called openTunnel API for ${i.remoteAddress.host}:${i.remoteAddress.port}.`);const r=await this.a.$openTunnel(i,o.displayName);if(r){const n=new p(r.remoteAddress,r.localAddress,()=>this.a.$closeTunnel(r.remoteAddress));return this.B(n),n}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(o,i){const r=this.u();return this.r.set(r,{selector:o,provider:i}),this.a.$registerPortsAttributesProvider(o,r),new m.$8K(()=>{this.r.delete(r),this.a.$unregisterPortsAttributesProvider(r)})}async $providePortAttributes(o,i,r,n,c){const t=[];for(const s of o){const l=this.r.get(s);if(!l)return[];t.push(...await Promise.all(i.map(async a=>{let d;try{d=await l.provider.providePortAttributes({port:a,pid:r,commandLine:n},c)}catch{d=await l.provider.providePortAttributes(a,r,n,c)}return{providedAttributes:d,port:a}})))}const u=t.filter(s=>!!s.providedAttributes);return u.length>0?u.map(s=>({autoForwardAction:s.providedAttributes.autoForwardAction,port:s.port})):[]}async $registerCandidateFinder(o){}registerTunnelProvider(o,i){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(n,c)=>await o.provideTunnel(n,c,new D.$6d().token)??void 0;const r=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,privacyOptions:i.tunnelFeatures?.privacyOptions,protocol:i.tunnelFeatures.protocol===void 0?!0:i.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(r),Promise.resolve((0,g.$Rc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(o,i){if(o){o.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(o.candidatePortSource),o.showCandidatePort&&(this.f=o.showCandidatePort,this.a.$setCandidateFilter());const r=o.tunnelFactory??(i?this.w(i):void 0);if(r){this.b=r;let n=o.tunnelFeatures?.privacyOptions??[];o.tunnelFeatures?.public&&n.length===0&&(n=[{id:"private",label:I.localize(0,null),themeIcon:"lock"},{id:"public",label:I.localize(1,null),themeIcon:"eye"}]);const c=o.tunnelFeatures?{elevation:!!o.tunnelFeatures?.elevation,public:!!o.tunnelFeatures?.public,privacyOptions:n,protocol:!0}:void 0;this.a.$setTunnelProvider(c)}}else this.b=void 0;return(0,g.$Rc)(()=>{this.b=void 0})}w(o){}async $closeTunnel(o,i){if(this.g.has(o.host)){const r=this.g.get(o.host);r.has(o.port)&&(i&&r.get(o.port).disposeListener.dispose(),await r.get(o.port).tunnel.dispose(),r.delete(o.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(o,i){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const r=this.b(o,i);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),r!==void 0){const n=await r;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),n===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(o.remoteAddress.host)||this.g.set(o.remoteAddress.host,new Map);const c=this.B(n.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(n.remoteAddress))));return this.g.get(o.remoteAddress.host).set(o.remoteAddress.port,{tunnel:n,disposeListener:c}),S.fromApiTunnel(n)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(r){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),r instanceof Error)return r.message}}async $applyCandidateFilter(o){const i=await Promise.all(o.map(n=>this.f(n.host,n.port,n.detail??""))),r=o.filter((n,c)=>i[c]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${o.map(n=>n.port).join(", ")} to ${r.map(n=>n.port).join(", ")}`),r}};e.$pyb=h,e.$pyb=h=Ge([We(0,C.$0M),We(1,L.$nN),We(2,b.$nj)],h)}),define(ke[341],Se([1,0,3,17,2,6]),function(me,e,D,O,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6hc=void 0;class A{static{this.a=new Set([O.Schemas.http,O.Schemas.https])}constructor($){this.c=new Map,this.b=$.getProxy(I.$6K.MainThreadUriOpeners)}registerExternalUriOpener($,y,L,C){if(this.c.has(y))throw new Error(`Opener with id '${y}' already registered`);const m=C.schemes.find(p=>!A.a.has(p));if(m)throw new Error(`Scheme '${m}' is not supported. Only http and https are currently supported.`);return this.c.set(y,L),this.b.$registerUriOpener(y,C.schemes,$,C.label),(0,D.$Rc)(()=>{this.c.delete(y),this.b.$unregisterUriOpener(y)})}async $canOpenUri($,y,L){const C=this.c.get($);if(!C)throw new Error(`Unknown opener with id: ${$}`);const m=g.URI.revive(y);return C.canOpenExternalUri(m,L)}async $openUri($,y,L){const C=this.c.get($);if(!C)throw new Error(`Unknown opener id: '${$}'`);return C.openExternalUri(g.URI.revive(y.resolvedUri),{sourceUri:g.URI.revive(y.sourceUri)},L)}}e.$6hc=A}),define(ke[342],Se([1,0,6,2,3,14,26]),function(me,e,D,O,g,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7hc=void 0;class b{static{this.a=0}constructor(y){this.c=new A.$mm,this.d=new Map,this.b=y.getProxy(D.$6K.MainThreadUrls)}registerUriHandler(y,L){const C=y.identifier;if(this.c.has(C))throw new Error(`Protocol handler already registered for extension ${C}`);const m=b.a++;return this.c.add(C),this.d.set(m,L),this.b.$registerUriHandler(m,C,y.displayName||y.name),(0,g.$Rc)(()=>{this.c.delete(C),this.d.delete(m),this.b.$unregisterUriHandler(m)})}$handleExternalUri(y,L){const C=this.d.get(y);if(!C)return Promise.resolve(void 0);try{C.handleUri(O.URI.revive(L))}catch(m){(0,I.$1)(m)}return Promise.resolve(void 0)}async createAppUri(y){return O.URI.revive(await this.b.$createAppUri(y))}}e.$7hc=b}),define(ke[93],Se([1,0,4,3,17,24,2,237,274,113,6]),function(me,e,D,O,g,I,A,b,$,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cgc=e.$Bgc=e.$Agc=e.$zgc=e.$ygc=void 0;class C{#e;#t;#i;#o;#n;#r;#a;#s;#c;#u;#l;#d;constructor(n,c,t,u,s,l,a){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new D.$Vd,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new D.$Vd,this._onDidDispose=this.#h.event,this.#e=n,this.#t=c,this.#s=t,this.#o=u,this.#n=s,this.#r=l,this.#l=m(l),this.#d=p(l),this.#i=a}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(n){return this.#u=!0,(0,y.$wvb)(n,this.#o)}get cspSource(){const n=this.#r.extensionLocation;if(n.scheme===g.Schemas.https||n.scheme===g.Schemas.http){let c=n.toString();return c.endsWith("/")||(c+="/"),c+" "+y.$vvb}return y.$vvb}get html(){return this.a(),this.#a}set html(n){this.a(),this.#a!==n&&(this.#a=n,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(n)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(n)))}get options(){return this.a(),this.#s}set options(n){this.a(),I.$zn(this.#s,n)||this.#t.$setOptions(this.#e,f(this.#r,this.#n,n)),this.#s=n}async postMessage(n){if(this.#c)return!1;const c=(0,$.$clb)(n,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,c.message,...c.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(n){if(!this.#d)return n;const c=this.#r.extensionLocation?.scheme===g.Schemas.vscodeRemote,t=this.#r.extensionLocation.scheme===g.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return n.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(u,s,l,a,d,k)=>{const R=A.URI.from({scheme:a||"file",path:decodeURIComponent(d)}),v=(0,y.$wvb)(R,{isRemote:c,authority:t}).toString();return`${s}${v}${k}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(u,s,l,a,d,k)=>{const R=A.URI.from({scheme:a||"file",path:decodeURIComponent(d)}),v=(0,y.$wvb)(R,{isRemote:c,authority:t}).toString();return`${s}${v}${k}`})}}e.$ygc=C;function m(r){try{const n=(0,b.$cp)((0,b.$bp)(r.engines.vscode));return!!n&&n.majorBase>=1&&n.minorBase>=57}catch{return!1}}e.$zgc=m;function p(r){try{const n=(0,b.$cp)((0,b.$bp)(r.engines.vscode));return n?n.majorBase<1||n.majorBase===1&&n.minorBase<60:!1}catch{return!1}}class S extends O.$Tc{constructor(n,c,t,u,s){super(),this.c=c,this.f=t,this.g=u,this.h=s,this.b=new Map,this.a=n.getProxy(L.$6K.MainThreadWebviews)}dispose(){super.dispose();for(const n of this.b.values())n.dispose();this.b.clear()}$onMessage(n,c,t){const u=this.j(n);if(u){const{message:s}=(0,$.$dlb)(c,t.value);u._onMessageEmitter.fire(s)}}$onMissingCsp(n,c){this.g.warn(`${c} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(n,c,t){const u=new C(n,this.a,o(c),this.c,this.f,t,this.h);this.b.set(n,u);const s=u._onDidDispose(()=>{s.dispose(),this.deleteWebview(n)});return u}deleteWebview(n){this.b.delete(n)}j(n){return this.b.get(n)}}e.$Agc=S;function h(r){return{id:r.identifier,location:r.extensionLocation}}e.$Bgc=h;function f(r,n,c){return{enableCommandUris:c.enableCommandUris,enableScripts:c.enableScripts,enableForms:c.enableForms,portMapping:c.portMapping,localResourceRoots:c.localResourceRoots||i(r,n)}}e.$Cgc=f;function o(r){return{enableCommandUris:r.enableCommandUris,enableScripts:r.enableScripts,enableForms:r.enableForms,portMapping:r.portMapping,localResourceRoots:r.localResourceRoots?.map(n=>A.URI.from(n))}}function i(r,n){return[...(n?.getWorkspaceFolders()||[]).map(c=>c.uri),r.extensionLocation]}}),define(ke[343],Se([1,0,21,54,3,17,23,2,15,93,110,6,7]),function(me,e,D,O,g,I,A,b,$,y,L,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Egc=void 0;class p{constructor(u,s){this.document=u,this.b=s,this.a=1,this.c=new L.$4fc("custom documents")}addEdit(u){return this.c.add([u])}async undo(u,s){await this.f(u).undo(),s||this.disposeBackup()}async redo(u,s){await this.f(u).redo(),s||this.disposeBackup()}disposeEdits(u){for(const s of u)this.c.delete(s)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const u=c(this.document.uri)+this.a++;return(0,A.$Hg)(this.b,u)}updateBackup(u){this.d?.delete(),this.d=u}disposeBackup(){this.d?.delete(),this.d=void 0}f(u){const s=this.c.get(u,0);if(!s)throw new Error("No edit found");return s}}class S{constructor(){this.a=new Map}get(u,s){return this.a.get(this.b(u,s))}add(u,s,l){const a=this.b(u,s.uri);if(this.a.has(a))throw new Error(`Document already exists for viewType:${u} resource:${s.uri}`);const d=new p(s,l);return this.a.set(a,d),d}delete(u,s){const l=this.b(u,s.uri);this.a.delete(l)}b(u,s){return`${u}@@@${s}`}}var h;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(h||(h={}));class f{constructor(){this.a=new Map}addTextProvider(u,s,l){return this.b(0,u,s,l)}addCustomProvider(u,s,l){return this.b(1,u,s,l)}get(u){return this.a.get(u)}b(u,s,l,a){if(this.a.has(s))throw new Error(`Provider for viewType:${s} already registered`);return this.a.set(s,{type:u,extension:l,provider:a}),new m.$8K(()=>this.a.delete(s))}}class o{constructor(u,s,l,a,d){this.d=s,this.f=l,this.g=a,this.h=d,this.b=new f,this.c=new S,this.a=u.getProxy(C.$6K.MainThreadCustomEditors)}registerCustomEditorProvider(u,s,l,a){const d=new g.$Sc;return r(l)?(d.add(this.b.addTextProvider(s,u,l)),this.a.$registerTextEditorProvider((0,y.$Bgc)(u),s,a.webviewOptions||{},{supportsMove:!!l.moveCustomTextEditor},(0,y.$zgc)(u))):(d.add(this.b.addCustomProvider(s,u,l)),i(l)&&d.add(l.onDidChangeCustomDocument(k=>{const R=this.i(s,k.document.uri);if(n(k)){const v=R.addEdit(k);this.a.$onDidEdit(k.document.uri,s,v,k.label)}else this.a.$onContentChange(k.document.uri,s)})),this.a.$registerCustomEditorProvider((0,y.$Bgc)(u),s,a.webviewOptions||{},!!a.supportsMultipleEditorsPerDocument,(0,y.$zgc)(u))),m.$8K.from(d,new m.$8K(()=>{this.a.$unregisterEditorProvider(s)}))}async $createCustomDocument(u,s,l,a,d){const k=this.b.get(s);if(!k)throw new Error(`No provider found for '${s}'`);if(k.type!==1)throw new Error(`Invalid provide type for '${s}'`);const R=b.URI.revive(u),v=await k.provider.openCustomDocument(R,{backupId:l,untitledDocumentData:a?.buffer},d);let w;return i(k.provider)&&this.f&&(w=this.f.workspaceValue(k.extension)??this.f.globalValue(k.extension)),this.c.add(s,v,w),{editable:i(k.provider)}}async $disposeCustomDocument(u,s){const l=this.b.get(s);if(!l)throw new Error(`No provider found for '${s}'`);if(l.type!==1)throw new Error(`Invalid provider type for '${s}'`);const a=b.URI.revive(u),{document:d}=this.i(s,a);this.c.delete(s,d),d.dispose()}async $resolveCustomEditor(u,s,l,a,d,k){const R=this.b.get(l);if(!R)throw new Error(`No provider found for '${l}'`);const v=$.ViewColumn.to(d),w=this.g.createNewWebview(s,a.contentOptions,R.extension),E=this.h.createNewWebviewPanel(s,l,a.title,v,a.options,w,a.active),P=b.URI.revive(u);switch(R.type){case 1:{const{document:N}=this.i(l,P);return R.provider.resolveCustomEditor(N,E,k)}case 0:{const N=this.d.getDocument(P);return R.provider.resolveCustomTextEditor(N,E,k)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(u,s,l){this.i(s,u).disposeEdits(l)}async $onMoveCustomEditor(u,s,l){const a=this.b.get(l);if(!a)throw new Error(`No provider found for '${l}'`);if(!a.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${l}'`);const d=this.h.getWebviewPanel(u);if(!d)throw new Error("No webview found");const k=b.URI.revive(s),R=this.d.getDocument(k);await a.provider.moveCustomTextEditor(R,d,D.CancellationToken.None)}async $undo(u,s,l,a){return this.i(s,u).undo(l,a)}async $redo(u,s,l,a){return this.i(s,u).redo(l,a)}async $revert(u,s,l){const a=this.i(s,u);await this.j(s).revertCustomDocument(a.document,l),a.disposeBackup()}async $onSave(u,s,l){const a=this.i(s,u);await this.j(s).saveCustomDocument(a.document,l),a.disposeBackup()}async $onSaveAs(u,s,l,a){const d=this.i(s,u);return this.j(s).saveCustomDocumentAs(d.document,b.URI.revive(l),a)}async $backup(u,s,l){const a=this.i(s,u),k=await this.j(s).backupCustomDocument(a.document,{destination:a.getNewBackupUri()},l);return a.updateBackup(k),k.id}i(u,s){const l=this.c.get(u,b.URI.revive(s));if(!l)throw new Error("No custom document found");return l}j(u){const l=this.b.get(u)?.provider;if(!l||!i(l))throw new Error("Custom document is not editable");return l}}e.$Egc=o;function i(t){return!!t.onDidChangeCustomDocument}function r(t){return typeof t.resolveCustomTextEditor=="function"}function n(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function c(t){const u=t.scheme===I.Schemas.file||t.scheme===I.Schemas.untitled?t.fsPath:t.toString();return(0,O.$Ti)(u)+""}}),define(ke[344],Se([1,0,4,3,2,30,15,93,6,7]),function(me,e,D,O,g,I,A,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dgc=void 0;class L extends O.$Tc{#e;#t;#i;#o;#n;#r;#a;#s;#c;#u;#l;#d;#h;constructor(S,h,f,o){super(),this.#s=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new D.$Vd),this.onDidDispose=this.#d.event,this.#h=this.B(new D.$Vd),this.onDidChangeViewState=this.#h.event,this.#e=S,this.#t=h,this.#o=f,this.#i=o.viewType,this.#n=o.panelOptions,this.#s=o.viewColumn,this.#r=o.title,this.#u=o.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#o.dispose(),super.dispose())}get webview(){return this.c(),this.#o}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(S){this.c(),this.#r!==S&&(this.#r=S,this.#t.$setTitle(this.#e,S))}get iconPath(){return this.c(),this.#a}set iconPath(S){this.c(),this.#a!==S&&(this.#a=S,this.#t.$setIconPath(this.#e,g.URI.isUri(S)?{light:S,dark:S}:S))}get options(){return this.#n}get viewColumn(){if(this.c(),!(typeof this.#s=="number"&&this.#s<0))return this.#s}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(S){this.#l||(this.active!==S.active||this.visible!==S.visible||this.viewColumn!==S.viewColumn)&&(this.#u=S.active,this.#c=S.visible,this.#s=S.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(S,h){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof S>"u"?void 0:A.ViewColumn.from(S),preserveFocus:!!h})}c(){if(this.#l)throw new Error("Webview is disposed")}}class C extends O.$Tc{static c(){return(0,I.$qg)()}constructor(S,h,f){super(),this.j=h,this.m=f,this.g=new Map,this.h=new Map,this.f=S.getProxy($.$6K.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(S=>S.dispose()),this.g.clear()}createWebviewPanel(S,h,f,o,i={}){const r=typeof o=="object"?o.viewColumn:o,n={viewColumn:A.ViewColumn.from(r),preserveFocus:typeof o=="object"&&!!o.preserveFocus},c=(0,b.$zgc)(S),t=C.c();this.f.$createWebviewPanel((0,b.$Bgc)(S),t,h,{title:f,panelOptions:m(i),webviewOptions:(0,b.$Cgc)(S,this.m,i),serializeBuffersForPostMessage:c},n);const u=this.j.createNewWebview(t,i,S);return this.createNewWebviewPanel(t,h,f,r,i,u,!0)}$onDidChangeWebviewPanelViewStates(S){const h=Object.keys(S);h.sort((f,o)=>{const i=S[f],r=S[o];return i.active?1:r.active?-1:+i.visible-+r.visible});for(const f of h){const o=this.getWebviewPanel(f);if(!o)continue;const i=S[f];o._updateViewState({active:i.active,visible:i.visible,viewColumn:A.ViewColumn.to(i.position)})}}async $onDidDisposeWebviewPanel(S){this.getWebviewPanel(S)?.dispose(),this.g.delete(S),this.j.deleteWebview(S)}registerWebviewPanelSerializer(S,h,f){if(this.h.has(h))throw new Error(`Serializer for '${h}' already registered`);return this.h.set(h,{serializer:f,extension:S}),this.f.$registerSerializer(h,{serializeBuffersForPostMessage:(0,b.$zgc)(S)}),new y.$8K(()=>{this.h.delete(h),this.f.$unregisterSerializer(h)})}async $deserializeWebviewPanel(S,h,f,o){const i=this.h.get(h);if(!i)throw new Error(`No serializer found for '${h}'`);const{serializer:r,extension:n}=i,c=this.j.createNewWebview(S,f.webviewOptions,n),t=this.createNewWebviewPanel(S,h,f.title,o,f.panelOptions,c,f.active);await r.deserializeWebviewPanel(t,f.state)}createNewWebviewPanel(S,h,f,o,i,r,n){const c=new L(S,this.f,r,{viewType:h,title:f,viewColumn:o,panelOptions:i,active:n});return this.g.set(S,c),c}getWebviewPanel(S){return this.g.get(S)}}e.$Dgc=C;function m(p){return{enableFindWidget:p.enableFindWidget,retainContextWhenHidden:p.retainContextWhenHidden}}}),define(ke[345],Se([1,0,4,3,93,15,6,7]),function(me,e,D,O,g,I,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8hc=void 0;class $ extends O.$Tc{#e;#t;#i;#o;#n;#r;#a;#s;#c;constructor(C,m,p,S,h,f){super(),this.#n=!1,this.#u=this.B(new D.$Vd),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new D.$Vd),this.onDidDispose=this.#l.event,this.#i=p,this.#a=S,this.#e=C,this.#t=m,this.#o=h,this.#r=f}dispose(){this.#n||(this.#n=!0,this.#l.fire(),this.#o.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(C){this.a(),this.#a!==C&&(this.#a=C,this.#t.$setWebviewViewTitle(this.#e,C))}get description(){return this.a(),this.#s}set description(C){this.a(),this.#s!==C&&(this.#s=C,this.#t.$setWebviewViewDescription(this.#e,C))}get visible(){return this.#r}get webview(){return this.#o}get viewType(){return this.#i}_setVisible(C){C===this.#r||this.#n||(this.#r=C,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(C){this.a(),!(C?.value===this.#c?.value&&C?.tooltip===this.#c?.tooltip)&&(this.#c=I.ViewBadge.from(C),this.#t.$setWebviewViewBadge(this.#e,C))}show(C){this.a(),this.#t.$show(this.#e,!!C)}a(){if(this.#n)throw new Error("Webview is disposed")}}class y{constructor(C,m){this.d=m,this.b=new Map,this.c=new Map,this.a=C.getProxy(A.$6K.MainThreadWebviewViews)}registerWebviewViewProvider(C,m,p,S){if(this.b.has(m))throw new Error(`View provider for '${m}' already registered`);return this.b.set(m,{provider:p,extension:C}),this.a.$registerWebviewViewProvider((0,g.$Bgc)(C),m,{retainContextWhenHidden:S?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,g.$zgc)(C)}),new b.$8K(()=>{this.b.delete(m),this.a.$unregisterWebviewViewProvider(m)})}async $resolveWebviewView(C,m,p,S,h){const f=this.b.get(m);if(!f)throw new Error(`No view provider found for '${m}'`);const{provider:o,extension:i}=f,r=this.d.createNewWebview(C,{},i),n=new $(C,this.a,m,p,r,!0);this.c.set(C,n),await o.resolveWebviewView(n,{state:S},h)}async $onDidChangeWebviewViewVisibility(C,m){this.e(C)._setVisible(m)}async $disposeWebviewView(C){const m=this.e(C);this.c.delete(C),m.dispose(),this.d.deleteWebview(C)}e(C){const m=this.c.get(C);if(!m)throw new Error("No webview found");return m}}e.$8hc=y}),define(ke[151],Se([1,0,4,6,2,17,12,5,20,25]),function(me,e,D,O,g,I,A,b,$,y){"use strict";var L;Object.defineProperty(e,"__esModule",{value:!0}),e.$0hc=e.$9hc=void 0;let C=class{static{L=this}static{this.a={focused:!0,active:!0}}getState(p){const S=this.d;return{get focused(){return S.focused},get active(){return(0,y.$CF)(p,"windowActivity"),S.active}}}constructor(p){this.c=new D.$Vd,this.onDidChangeWindowState=this.c.event,this.d=L.a,this.b=p.getProxy(O.$6K.MainThreadWindow),this.b.$getInitialState().then(({isFocused:S,isActive:h})=>{this.onDidChangeWindowProperty("focused",S),this.onDidChangeWindowProperty("active",h)})}$onDidChangeWindowFocus(p){this.onDidChangeWindowProperty("focused",p)}$onDidChangeWindowActive(p){this.onDidChangeWindowProperty("active",p)}onDidChangeWindowProperty(p,S){S!==this.d[p]&&(this.d={...this.d,[p]:S},this.c.fire(this.d))}openUri(p,S){let h;if(typeof p=="string"){h=p;try{p=g.URI.parse(p)}catch{return Promise.reject(`Invalid uri - '${p}'`)}}return(0,A.$Je)(p.scheme)?Promise.reject("Invalid scheme - cannot be empty"):p.scheme===I.Schemas.command?Promise.reject(`Invalid scheme '${p.scheme}'`):this.b.$openUri(p,h,S)}async asExternalUri(p,S){if((0,A.$Je)(p.scheme))return Promise.reject("Invalid scheme - cannot be empty");const h=await this.b.$asExternalUri(p,S);return g.URI.from(h)}};e.$9hc=C,e.$9hc=C=L=Ge([We(0,$.$0M)],C),e.$0hc=(0,b.$6h)("IExtHostWindow")}),define(ke[346],Se([1,0,314,27,20]),function(me,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lic=void 0;const I=1024*1024;let A=class extends D.$aic{constructor($,y){super($,y),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f($,y,L){const C=$==="error"||$==="warn"?process.stderr:process.stdout;this.g=!0,C.write(`
START_NATIVE_LOG
`),y.apply(console,L),C.write(`
END_NATIVE_LOG
`),this.g=!1}j($,y){const L=process[$],C=L.write;let m="";Object.defineProperty(L,"write",{set:()=>{},get:()=>(p,S,h)=>{if(!this.g){m+=p.toString(S);const f=m.length>I?m.length:m.lastIndexOf(`
`);f!==-1&&(console[y](m.slice(0,f)),m=m.slice(f+1))}C.call(L,p,S,h)}})}};e.$Lic=A,e.$Lic=A=Ge([We(0,g.$0M),We(1,O.$nN)],A)}),define(ke[347],Se([1,0,71,17,13,249,32,10]),function(me,e,D,O,g,I,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mic=void 0;let $=class{constructor(C,m){C.addFileSystemProvider(O.Schemas.file,new y(m),{isCaseSensitive:b.$k})}};e.$Mic=$,e.$Mic=$=Ge([We(0,D.$vgc),We(1,g.$nj)],$);class y{constructor(C){this.b=C,this.a=new I.$Bq(this.b)}async stat(C){const m=await this.a.stat(C);return{type:m.type,ctime:m.ctime,mtime:m.mtime,size:m.size,permissions:m.permissions===A.FilePermission.Readonly?1:void 0}}readDirectory(C){return this.a.readdir(C)}createDirectory(C){return this.a.mkdir(C)}readFile(C){return this.a.readFile(C)}writeFile(C,m,p){return this.a.writeFile(C,m,{...p,unlock:!1,atomic:!1})}delete(C,m){return this.a.delete(C,{...m,useTrash:!1,atomic:!1})}rename(C,m,p){return this.a.rename(C,m,p)}copy(C,m,p){return this.a.copy(C,m,p)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(C,m){throw new Error("Method not implemented.")}}}),define(ke[348],Se([1,0,16,63,30,35,3,6,2,20]),function(me,e,D,O,g,I,A,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kic=void 0;let L=class extends A.$Tc{constructor(m,p){super();const S=m.getProxy(b.$6K.MainThreadDownloadService);p.registerCommand(!1,"_workbench.downloadResource",async h=>{const f=$.URI.file((0,D.$jc)((0,O.tmpdir)(),(0,g.$qg)()));return await S.$download(h,f),f})}};e.$Kic=L,e.$Kic=L=Ge([We(0,y.$0M),We(1,I.$tN)],L)}),define(ke[349],Se([1,0,150,17,251,30]),function(me,e,D,O,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xic=void 0;class A extends D.$_hc{s($,y,L){return $.scheme===O.Schemas.file?new g.$jO(L?.name||(0,I.$qg)(),$.fsPath,!L?.donotRotate,!!L?.donotUseFormatters,y):super.s($,y,L)}registerLogger($){super.registerLogger($),this.r.$registerLogger($)}deregisterLogger($){super.deregisterLogger($),this.r.$deregisterLogger($)}}e.$Xic=A}),define(ke[350],Se([1,0,56,16,2,92,3,17,11,31]),function(me,e,D,O,g,I,A,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wic=void 0;class L extends I.$xgc{constructor(){super(...arguments),this.i=null}async g(t){const u=await super.g(t);if(u.scheme!==b.Schemas.file)return u;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${u.fsPath}.`),u;const s=u.fsPath;let l=0;do{let a;l===0?a=s:a=/[/\\]$/.test(s)?`${s.substr(0,s.length-1)}-${l}`:`${s}-${l}`,await C(a);const d=O.$jc(a,"vscode.lock"),k=await h(this.d,d,!1);if(k)return this.i=k,process.on("exit",()=>{k.dispose()}),g.URI.file(a);l++}while(l<10);return u}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$Wic=L;async function C(c){try{await y.Promises.stat(c);return}catch{}try{await y.Promises.mkdir(c,{recursive:!0})}catch{}}const m=1e3,p=10*60*1e3;class S extends A.$Tc{constructor(t,u){super(),this.b=t,this.c=u,this.a=this.B(new $.$eh),this.a.cancelAndSet(async()=>{const s=await f(t,u);(!s||s.pid!==process.pid)&&(t.info(`Lock '${u}': The lock was lost unexpectedly.`),this.a.cancel());try{await y.Promises.utimes(u,new Date,new Date)}catch(l){t.error(l),t.info(`Lock '${u}': Could not update mtime.`)}},m)}dispose(){super.dispose();try{D.unlinkSync(this.c)}catch{}}async setWillRelease(t){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const u={pid:process.pid,willReleaseAt:Date.now()+t};await y.Promises.writeFile(this.c,JSON.stringify(u),{flag:"w"})}catch(u){this.b.error(u)}}}async function h(c,t,u){try{const l={pid:process.pid,willReleaseAt:0};await y.Promises.writeFile(t,JSON.stringify(l),{flag:"wx"})}catch(l){c.error(l)}const s=await f(c,t);return!s||s.pid!==process.pid?u?(c.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(c.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),r(c,t)):(c.info(`Lock '${t}': Lock acquired.`),new S(c,t))}async function f(c,t){let u;try{u=await y.Promises.readFile(t)}catch(s){return c.error(s),null}try{return JSON.parse(String(u))}catch(s){return c.error(s),null}}async function o(c,t){let u;try{u=await y.Promises.stat(t)}catch(s){return c.error(s),0}return u.mtime.getTime()}function i(c){try{return process.kill(c,0),!0}catch{return!1}}async function r(c,t){const u=await f(c,t);if(!u)return c.info(`Lock '${t}': Could not read pid of lock holder.`),n(c,t);if(u.willReleaseAt){let k=u.willReleaseAt-Date.now();if(k<5e3){for(k>0?c.info(`Lock '${t}': The lockfile is scheduled to be released in ${k} ms.`):c.info(`Lock '${t}': The lockfile is scheduled to have been released.`);k>0;){if(await(0,$.$7g)(Math.min(100,k)),await o(c,t)===0)return n(c,t);k=u.willReleaseAt-Date.now()}return n(c,t)}}if(!i(u.pid))return c.info(`Lock '${t}': The pid ${u.pid} appears to be gone.`),n(c,t);const s=await o(c,t),l=Date.now()-s;if(l<=p)return c.info(`Lock '${t}': The lock does not look stale, elapsed: ${l} ms, giving up.`),null;c.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,$.$7g)(2e3);const a=await o(c,t),d=Date.now()-a;return d<=p?(c.info(`Lock '${t}': The lock does not look stale, elapsed: ${d} ms, giving up.`),null):(c.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),n(c,t))}async function n(c,t){c.info(`Lock '${t}': Deleting a stale lock.`);try{await y.Promises.unlink(t)}catch{}return h(c,t,!0)}}),define(ke[351],Se([1,0,30,20,46,35]),function(me,e,D,O,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fic=void 0;let A=class extends g.$Tgc{constructor($,y){super(!0,$,y)}createTerminal($,y,L){return this.createTerminalFromOptions({name:$,shellPath:y,shellArgs:L})}createTerminalFromOptions($,y){const L=new g.$Sgc(this.a,(0,D.$qg)(),$,$.name);return this.f.push(L),L.create($,this.R($,y)),L.value}};e.$fic=A,e.$fic=A=Ge([We(0,I.$tN),We(1,O.$0M)],A)}),define(ke[352],Se([1,0,11,22,21,14,4,3,130,303,68]),function(me,e,D,O,g,I,A,b,$,y,L){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.$p8b=e.ResponsiveState=e.RequestInitiator=e.$o8b=e.$n8b=void 0;function m(E,P){try{return JSON.stringify(E,P)}catch{return"null"}}const p="$$ref$$",S={[p]:-1};class h{constructor(P,N){this.jsonString=P,this.referencedBuffers=N}}function f(E,P=null,N=!1){const U=[];return{jsonString:(N?m:JSON.stringify)(E,(j,T)=>{if(typeof T>"u")return S;if(typeof T=="object"){if(T instanceof O.$je){const M=U.push(T)-1;return{[p]:M}}if(P)return P(j,T)}return T}),referencedBuffers:U}}e.$n8b=f;function o(E,P,N){return JSON.parse(E,(U,F)=>{if(F){const j=F[p];if(typeof j=="number")return P[j];if(N&&F.$mid===1)return N.transformIncoming(F)}return F})}e.$o8b=o;function i(E,P){return JSON.stringify(E,P)}function r(E){return E?(P,N)=>N&&N.$mid===1?E.transformOutgoing(N):N:null}var n;(function(E){E[E.LocalSide=0]="LocalSide",E[E.OtherSide=1]="OtherSide"})(n||(e.RequestInitiator=n={}));var c;(function(E){E[E.Responsive=0]="Responsive",E[E.Unresponsive=1]="Unresponsive"})(c||(e.ResponsiveState=c={}));const t=()=>{},u=Symbol.for("rpcProtocol"),s=Symbol.for("rpcProxy");class l extends b.$Tc{static{C=u}static{this.a=3*1e3}constructor(P,N=null,U=null){super(),this[C]=!0,this.b=this.B(new A.$Vd),this.onDidChangeResponsiveState=this.b.event,this.c=P,this.f=N,this.g=U,this.h=r(this.g),this.j=!1,this.m=[],this.s=[];for(let F=0,j=L.$Qv.count;F<j;F++)this.m[F]=null,this.s[F]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new D.$fh(()=>this.H(),1e3)),this.c.onMessage(F=>this.L(F))}dispose(){this.j=!0,Object.keys(this.w).forEach(P=>{const N=this.w[P];delete this.w[P],N.resolveErr(I.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(P){this.z===0&&(this.C=Date.now()+l.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(P){this.C=Date.now()+l.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(P){this.y!==P&&(this.y=P,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(P){return this.g?(0,$.$7m)(P,this.g):P}getProxy(P){const{nid:N,sid:U}=P;return this.s[N]||(this.s[N]=this.J(N,U)),this.s[N]}J(P,N){const U={get:(F,j)=>(typeof j=="string"&&!F[j]&&j.charCodeAt(0)===36&&(F[j]=(...T)=>this.U(P,j,T)),j===s?N:F[j])};return new Proxy(Object.create(null),U)}set(P,N){return this.m[P.nid]=N,N}assertRegistered(P){for(let N=0,U=P.length;N<U;N++){const F=P[N];if(!this.m[F.nid])throw new Error(`Missing proxy instance ${F.sid}`)}}L(P){if(this.j)return;const N=P.byteLength,U=d.read(P,0),F=U.readUInt8(),j=U.readUInt32();switch(F){case 1:case 2:{let{rpcId:T,method:M,args:B}=R.deserializeRequestJSONArgs(U);this.g&&(B=(0,$.$7m)(B,this.g)),this.M(N,j,T,M,B,F===2);break}case 3:case 4:{let{rpcId:T,method:M,args:B}=R.deserializeRequestMixedArgs(U);this.g&&(B=(0,$.$7m)(B,this.g)),this.M(N,j,T,M,B,F===4);break}case 5:{this.f?.logIncoming(N,j,0,"ack"),this.G(j);break}case 6:{this.N(N,j);break}case 7:{this.O(N,j,void 0);break}case 9:{let T=R.deserializeReplyOKJSON(U);this.g&&(T=(0,$.$7m)(T,this.g)),this.O(N,j,T);break}case 10:{const T=R.deserializeReplyOKJSONWithBuffers(U,this.g);this.O(N,j,T);break}case 8:{const T=R.deserializeReplyOKVSBuffer(U);this.O(N,j,T);break}case 11:{let T=R.deserializeReplyErrError(U);this.g&&(T=(0,$.$7m)(T,this.g)),this.P(N,j,T);break}case 12:{this.P(N,j,void 0);break}default:console.error("received unexpected message"),console.error(P)}}M(P,N,U,F,j,T){this.f?.logIncoming(P,N,1,`receiveRequest ${(0,L.$Sv)(U)}.${F}(`,j);const M=String(N);let B,Y;if(T){const Z=new g.$6d;j.push(Z.token),B=this.Q(U,F,j),Y=()=>Z.cancel()}else B=this.Q(U,F,j),Y=t;this.u[M]=Y;const ue=R.serializeAcknowledged(N);this.f?.logOutgoing(ue.byteLength,N,1,"ack"),this.c.send(ue),B.then(Z=>{delete this.u[M];const J=R.serializeReplyOK(N,Z,this.h);this.f?.logOutgoing(J.byteLength,N,1,"reply:",Z),this.c.send(J)},Z=>{delete this.u[M];const J=R.serializeReplyErr(N,Z);this.f?.logOutgoing(J.byteLength,N,1,"replyErr:",Z),this.c.send(J)})}N(P,N){this.f?.logIncoming(P,N,1,"receiveCancel");const U=String(N);this.u[U]?.()}O(P,N,U){this.f?.logIncoming(P,N,0,"receiveReply:",U);const F=String(N);if(!this.w.hasOwnProperty(F))return;const j=this.w[F];delete this.w[F],j.resolveOk(U)}P(P,N,U){this.f?.logIncoming(P,N,0,"receiveReplyErr:",U);const F=String(N);if(!this.w.hasOwnProperty(F))return;const j=this.w[F];delete this.w[F];let T;U&&(U.$isError?(T=new Error,T.name=U.name,T.message=U.message,T.stack=U.stack):T=U),j.resolveErr(T)}Q(P,N,U){try{return Promise.resolve(this.S(P,N,U))}catch(F){return Promise.reject(F)}}S(P,N,U){const F=this.m[P];if(!F)throw new Error("Unknown actor "+(0,L.$Sv)(P));const j=F[N];if(typeof j!="function")throw new Error("Unknown method "+N+" on actor "+(0,L.$Sv)(P));return j.apply(F,U)}U(P,N,U){if(this.j)return new y.$m8b;let F=null;if(U.length>0&&g.CancellationToken.isCancellationToken(U[U.length-1])&&(F=U.pop()),F&&F.isCancellationRequested)return Promise.reject(I.$6());const j=R.serializeRequestArguments(U,this.h),T=++this.t,M=String(T),B=new y.$l8b,Y=new b.$Sc;F&&Y.add(F.onCancellationRequested(()=>{const Z=R.serializeCancel(T);this.f?.logOutgoing(Z.byteLength,T,0,"cancel"),this.c.send(R.serializeCancel(T))})),this.w[M]=new a(B,Y),this.F(T);const ue=R.serializeRequest(T,P,N,j,!!F);return this.f?.logOutgoing(ue.byteLength,T,0,`request: ${(0,L.$Sv)(P)}.${N}(`,U),this.c.send(ue),B}}e.$p8b=l;class a{constructor(P,N){this.a=P,this.b=N}resolveOk(P){this.a.resolveOk(P),this.b.dispose()}resolveErr(P){this.a.resolveErr(P),this.b.dispose()}}class d{static alloc(P,N,U){const F=new d(O.$je.alloc(U+1+4),0);return F.writeUInt8(P),F.writeUInt32(N),F}static read(P,N){return new d(P,N)}get buffer(){return this.a}constructor(P,N){this.a=P,this.b=N}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(P){this.a.writeUInt8(P,this.b),this.b+=1}readUInt8(){const P=this.a.readUInt8(this.b);return this.b+=1,P}writeUInt32(P){this.a.writeUInt32BE(P,this.b),this.b+=4}readUInt32(){const P=this.a.readUInt32BE(this.b);return this.b+=4,P}static sizeShortString(P){return 1+P.byteLength}writeShortString(P){this.a.writeUInt8(P.byteLength,this.b),this.b+=1,this.a.set(P,this.b),this.b+=P.byteLength}readShortString(){const P=this.a.readUInt8(this.b);this.b+=1;const U=this.a.slice(this.b,this.b+P).toString();return this.b+=P,U}static sizeLongString(P){return 4+P.byteLength}writeLongString(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}readLongString(){const P=this.a.readUInt32BE(this.b);this.b+=4;const U=this.a.slice(this.b,this.b+P).toString();return this.b+=P,U}writeBuffer(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}static sizeVSBuffer(P){return 4+P.byteLength}writeVSBuffer(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}readVSBuffer(){const P=this.a.readUInt32BE(this.b);this.b+=4;const N=this.a.slice(this.b,this.b+P);return this.b+=P,N}static sizeMixedArray(P){let N=0;N+=1;for(let U=0,F=P.length;U<F;U++){const j=P[U];switch(N+=1,j.type){case 1:N+=this.sizeLongString(j.value);break;case 2:N+=this.sizeVSBuffer(j.value);break;case 3:N+=this.sizeUInt32,N+=this.sizeLongString(j.value);for(let T=0;T<j.buffers.length;++T)N+=this.sizeVSBuffer(j.buffers[T]);break;case 4:break}}return N}writeMixedArray(P){this.a.writeUInt8(P.length,this.b),this.b+=1;for(let N=0,U=P.length;N<U;N++){const F=P[N];switch(F.type){case 1:this.writeUInt8(1),this.writeLongString(F.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(F.value);break;case 3:this.writeUInt8(3),this.writeUInt32(F.buffers.length),this.writeLongString(F.value);for(let j=0;j<F.buffers.length;++j)this.writeBuffer(F.buffers[j]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const P=this.a.readUInt8(this.b);this.b+=1;const N=new Array(P);for(let U=0;U<P;U++)switch(this.readUInt8()){case 1:N[U]=this.readLongString();break;case 2:N[U]=this.readVSBuffer();break;case 3:{const j=this.readUInt32(),T=this.readLongString(),M=[];for(let B=0;B<j;++B)M.push(this.readVSBuffer());N[U]=new L.$Tv(o(T,M,null));break}case 4:N[U]=void 0;break}return N}}var k;(function(E){E[E.Simple=0]="Simple",E[E.Mixed=1]="Mixed"})(k||(k={}));class R{static a(P){for(let N=0,U=P.length;N<U;N++)if(P[N]instanceof O.$je||P[N]instanceof L.$Tv||typeof P[N]>"u")return!0;return!1}static serializeRequestArguments(P,N){if(this.a(P)){const U=[];for(let F=0,j=P.length;F<j;F++){const T=P[F];if(T instanceof O.$je)U[F]={type:2,value:T};else if(typeof T>"u")U[F]={type:4};else if(T instanceof L.$Tv){const{jsonString:M,referencedBuffers:B}=f(T.value,N);U[F]={type:3,value:O.$je.fromString(M),buffers:B}}else U[F]={type:1,value:O.$je.fromString(i(T,N))}}return{type:1,args:U}}return{type:0,args:i(P,N)}}static serializeRequest(P,N,U,F,j){switch(F.type){case 0:return this.b(P,N,U,F.args,j);case 1:return this.c(P,N,U,F.args,j)}}static b(P,N,U,F,j){const T=O.$je.fromString(U),M=O.$je.fromString(F);let B=0;B+=d.sizeUInt8(),B+=d.sizeShortString(T),B+=d.sizeLongString(M);const Y=d.alloc(j?2:1,P,B);return Y.writeUInt8(N),Y.writeShortString(T),Y.writeLongString(M),Y.buffer}static deserializeRequestJSONArgs(P){const N=P.readUInt8(),U=P.readShortString(),F=P.readLongString();return{rpcId:N,method:U,args:JSON.parse(F)}}static c(P,N,U,F,j){const T=O.$je.fromString(U);let M=0;M+=d.sizeUInt8(),M+=d.sizeShortString(T),M+=d.sizeMixedArray(F);const B=d.alloc(j?4:3,P,M);return B.writeUInt8(N),B.writeShortString(T),B.writeMixedArray(F),B.buffer}static deserializeRequestMixedArgs(P){const N=P.readUInt8(),U=P.readShortString(),F=P.readMixedArray(),j=new Array(F.length);for(let T=0,M=F.length;T<M;T++){const B=F[T];typeof B=="string"?j[T]=JSON.parse(B):j[T]=B}return{rpcId:N,method:U,args:j}}static serializeAcknowledged(P){return d.alloc(5,P,0).buffer}static serializeCancel(P){return d.alloc(6,P,0).buffer}static serializeReplyOK(P,N,U){if(typeof N>"u")return this.d(P);if(N instanceof O.$je)return this.e(P,N);if(N instanceof L.$Tv){const{jsonString:F,referencedBuffers:j}=f(N.value,U,!0);return this.g(P,F,j)}else return this.f(P,m(N,U))}static d(P){return d.alloc(7,P,0).buffer}static e(P,N){let U=0;U+=d.sizeVSBuffer(N);const F=d.alloc(8,P,U);return F.writeVSBuffer(N),F.buffer}static deserializeReplyOKVSBuffer(P){return P.readVSBuffer()}static f(P,N){const U=O.$je.fromString(N);let F=0;F+=d.sizeLongString(U);const j=d.alloc(9,P,F);return j.writeLongString(U),j.buffer}static g(P,N,U){const F=O.$je.fromString(N);let j=0;j+=d.sizeUInt32,j+=d.sizeLongString(F);for(const M of U)j+=d.sizeVSBuffer(M);const T=d.alloc(10,P,j);T.writeUInt32(U.length),T.writeLongString(F);for(const M of U)T.writeBuffer(M);return T.buffer}static deserializeReplyOKJSON(P){const N=P.readLongString();return JSON.parse(N)}static deserializeReplyOKJSONWithBuffers(P,N){const U=P.readUInt32(),F=P.readLongString(),j=[];for(let T=0;T<U;++T)j.push(P.readVSBuffer());return new L.$Tv(o(F,j,N))}static serializeReplyErr(P,N){const U=N?m(I.$3(N),null):void 0;if(typeof U!="string")return this.h(P);const F=O.$je.fromString(U);let j=0;j+=d.sizeLongString(F);const T=d.alloc(11,P,j);return T.writeLongString(F),T.buffer}static deserializeReplyErrError(P){const N=P.readLongString();return JSON.parse(N)}static h(P){return d.alloc(12,P,0).buffer}}var v;(function(E){E[E.RequestJSONArgs=1]="RequestJSONArgs",E[E.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",E[E.RequestMixedArgs=3]="RequestMixedArgs",E[E.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",E[E.Acknowledged=5]="Acknowledged",E[E.Cancel=6]="Cancel",E[E.ReplyOKEmpty=7]="ReplyOKEmpty",E[E.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",E[E.ReplyOKJSON=9]="ReplyOKJSON",E[E.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",E[E.ReplyErrError=11]="ReplyErrError",E[E.ReplyErrEmpty=12]="ReplyErrEmpty"})(v||(v={}));var w;(function(E){E[E.String=1]="String",E[E.VSBuffer=2]="VSBuffer",E[E.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",E[E.Undefined=4]="Undefined"})(w||(w={}))}),define(ke[353],Se([1,0,4,37,45,5]),function(me,e,D,O,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pK=e.$oK=e.OutputChannelUpdateMode=e.$nK=e.$mK=e.$lK=e.$kK=e.$jK=e.$iK=e.$hK=e.$gK=e.$fK=e.$eK=void 0,e.$eK="text/x-code-output",e.$fK="output",e.$gK="Log",e.$hK="text/x-code-log-output",e.$iK="log",e.$jK="workbench.panel.output",e.$kK=new g.$kj("inOutput",!1),e.$lK=new g.$kj("activeLogOutput",!1),e.$mK=new g.$kj("outputView.scrollLock",!1),e.$nK=(0,I.$6h)("outputService");var A;(function($){$[$.Append=1]="Append",$[$.Replace=2]="Replace",$[$.Clear=3]="Clear"})(A||(e.OutputChannelUpdateMode=A={})),e.$oK={OutputChannels:"workbench.contributions.outputChannels"};class b{constructor(){this.a=new Map,this.b=new D.$Vd,this.onDidRegisterChannel=this.b.event,this.c=new D.$Vd,this.onDidRemoveChannel=this.c.event}registerChannel(y){this.a.has(y.id)||(this.a.set(y.id,y),this.b.fire(y.id))}getChannels(){const y=[];return this.a.forEach(L=>y.push(L)),y}getChannel(y){return this.a.get(y)}removeChannel(y){this.a.delete(y),this.c.fire(y)}}O.$Hn.add(e.$oK.OutputChannels,new b),e.$pK=new g.$kj("activeOutputChannel","")}),define(ke[152],Se([1,0,6,5,20,26,13,353,71,27,58,182,22,18,32,4,3]),function(me,e,D,O,g,I,A,b,$,y,L,C,m,p,S,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jhc=e.$Ihc=void 0;class o extends A.$tj{get disposed(){return this.n}constructor(c,t,u,s,l){super(),this.id=c,this.name=t,this.r=u,this.s=s,this.extension=l,this.m=0,this.n=!1,this.visible=!1,this.setLevel(u.getLevel()),this.B(u.onDidChangeLogLevel(a=>this.setLevel(a)))}get logLevel(){return this.getLevel()}appendLine(c){this.append(c+`
`)}append(c){this.info(c)}clear(){const c=this.m;this.r.flush(),this.s.$update(this.id,b.OutputChannelUpdateMode.Clear,c)}replace(c){const t=this.m;this.info(c),this.s.$update(this.id,b.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(c,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof c=="boolean"?c:t))}hide(){this.s.$close(this.id)}g(c,t){this.m+=m.$je.fromString(t).byteLength,(0,A.log)(this.r,c,t),this.visible&&(this.r.flush(),this.s.$update(this.id,b.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class i extends o{appendLine(c){this.append(c)}}let r=class{constructor(c,t,u,s,l,a){this.i=t,this.j=u,this.k=s,this.l=l,this.m=a,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=c.getProxy(D.$6K.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,C.$wm)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(c){this.h=c;for(const[t,u]of this.g)u.visible=t===this.h}createOutputChannel(c,t,u){if(c=c.trim(),!c)throw new Error("illegal argument `name`. must not be falsy");const s=typeof t=="object"&&t.log,l=(0,p.$If)(t)?t:void 0;if((0,p.$If)(l)&&!l.trim())throw new Error("illegal argument `languageId`. must not be empty");let a;const d=this.i.environment.extensionLogLevel?.find(([R])=>I.$lm.equals(u.identifier,R))?.[1];d&&(a=(0,A.$Dj)(d));const k=s?this.o(c,a,u):this.n(c,l,u);return k.then(R=>{this.g.set(R.id,R),R.visible=R.id===this.h}),s?this.r(c,a??this.m.getLevel(),k):this.q(c,k)}async n(c,t,u){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const s=await this.c,l=this.k.extUri.joinPath(s,`${this.f++}-${c.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),a=this.l.createLogger(l,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),d=await this.a.$register(c,l,t,u.identifier.value);return new o(d,c,a,this.a,u)}async o(c,t,u){const s=await this.p(u),l=c.replace(/[\\/:\*\?"<>\|]/g,""),a=this.k.extUri.joinPath(s,`${l}.log`),d=`${u.identifier.value}.${l}`,k=this.l.createLogger(a,{id:d,name:c,logLevel:t,extensionId:u.identifier.value});return new i(d,c,k,this.a,u)}p(c){let t=this.d.get(c.identifier.value);if(!t){const u=this.k.extUri.joinPath(this.i.logsLocation,c.identifier.value);this.d.set(c.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(u)}catch(s){if((0,S.$Gk)(s)!==S.FileSystemProviderErrorCode.FileExists)throw s}return u})())}return t}q(c,t){let u=!1;const s=()=>{if(u)throw new Error("Channel has been closed")};return{get name(){return c},append(l){s(),t.then(a=>a.append(l))},appendLine(l){s(),t.then(a=>a.appendLine(l))},clear(){s(),t.then(l=>l.clear())},replace(l){s(),t.then(a=>a.replace(l))},show(l,a){s(),t.then(d=>d.show(l,a))},hide(){s(),t.then(l=>l.hide())},dispose(){u=!0,t.then(l=>l.dispose())}}}r(c,t,u){const s=new f.$Sc,l=()=>{if(s.isDisposed)throw new Error("Channel has been closed")},a=s.add(new h.$Vd);function d(k){t=k,a.fire(k)}return u.then(k=>{s.add(k),k.logLevel!==t&&d(k.logLevel),s.add(k.onDidChangeLogLevel(R=>d(R)))}),{...this.q(c,u),get logLevel(){return t},onDidChangeLogLevel:a.event,trace(k,...R){l(),u.then(v=>v.trace(k,...R))},debug(k,...R){l(),u.then(v=>v.debug(k,...R))},info(k,...R){l(),u.then(v=>v.info(k,...R))},warn(k,...R){l(),u.then(v=>v.warn(k,...R))},error(k,...R){l(),u.then(v=>v.error(k,...R))},dispose(){s.dispose()}}}};e.$Ihc=r,e.$Ihc=r=Ge([We(0,g.$0M),We(1,y.$nN),We(2,$.$vgc),We(3,L.$8fc),We(4,A.$oj),We(5,A.$nj)],r),e.$Jhc=(0,O.$6h)("IExtHostOutputService")}),define(ke[153],Se([1,0,5,11]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mm=e.$Lm=void 0,e.$Lm=(0,D.$6h)("remoteAgentService"),e.$Mm=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(g){let I=1/0;for(let b=0;b<this.maxSampleCount;b++){const $=await g.getRoundTripTime();if($===void 0)return;I=Math.min(I,$/2),await(0,O.$7g)(this.sampleDelay)}this.average.push(I),this.average.length>this.maxAverageCount&&this.average.shift();let A;return this.initial.length<this.maxInitialCount?this.initial.push(I):A=this.initial.reduce((b,$)=>b+$,0)/this.initial.length,this.lastMeasurement={initial:A,current:I,average:this.average.reduce((b,$)=>b+$,0)/this.average.length,high:(()=>typeof A>"u"?!1:I>this.highLatencyMaxThreshold||I>this.highLatencyMinThreshold&&I>A*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(ke[354],Se([1,0,223,86,37,40,51,3,4,153,10,24]),function(me,e,D,O,g,I,A,b,$,y,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XH=e.$WH=e.$VH=e.$UH=e.$TH=e.$SH=e.$RH=void 0,e.$RH=Object.freeze({id:"application",order:100,title:(0,D.localize)(0,null),type:"object"}),e.$SH=Object.freeze({id:"workbench",order:7,title:(0,D.localize)(1,null),type:"object"}),e.$TH=Object.freeze({id:"security",scope:1,title:(0,D.localize)(2,null),type:"object",order:7}),e.$UH=Object.freeze({id:"problems",title:(0,D.localize)(3,null),type:"object",order:101}),e.$VH={ConfigurationMigration:"base.contributions.configuration.migration"};class m{constructor(){this.migrations=[],this.a=new $.$Vd,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(o){this.migrations.push(...o)}}const p=new m;g.$Hn.add(e.$VH.ConfigurationMigration,p);let S=class extends b.$Tc{constructor(o,i){super(),this.a=o,this.b=i,this.B(this.b.onDidChangeWorkspaceFolders(async r=>{for(const n of r.added)await this.f(n,p.migrations)})),this.c(p.migrations),this.B(p.onDidRegisterConfigurationMigration(r=>this.c(r)))}async c(o){await this.f(void 0,o);for(const i of this.b.getWorkspace().folders)await this.f(i,o)}async f(o,i){await Promise.all([i.map(r=>this.g(r,o?.uri))])}async g(o,i){const r=this.a.inspect(o.key,{resource:i}),n=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[c,t]of n){const u=[];for(const l of r.overrideIdentifiers??[]){const a=await this.h(o,{resource:i,overrideIdentifier:l},c);for(const d of a??[]){let k=u.find(([[R,v]])=>R===d[0]&&(0,C.$zn)(v.value,d[1].value));k||u.push(k=[d,[]]),k[1].push(l)}}const s=await this.h(o,{resource:i},c,r);for(const l of s??[])u.push([l,[]]);u.length&&await Promise.allSettled(u.map(async([[l,a],d])=>this.a.updateValue(l,a.value,{resource:i,overrideIdentifiers:d},t)))}}async h(o,i,r,n){const c=l=>t(this.a.inspect(l,i)),t=l=>{const a=l[r];return i.overrideIdentifier?a?.override:a?.value},u=n?t(n):c(o.key);if(u===void 0)return;const s=await o.migrateFn(u,c);return Array.isArray(s)?s:[[o.key,s]]}};e.$WH=S,e.$WH=S=Ge([We(0,A.$zi),We(1,I.$ci)],S);let h=class extends b.$Tc{constructor(o){super(),(async()=>{if(!L.$i&&(await o.getEnvironment())?.os!==1)return;g.$Hn.as(O.$Mn.Configuration).registerConfiguration({...e.$TH,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,D.localize)(4,null)},default:[],markdownDescription:(0,D.localize)(5,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,D.localize)(6,null),scope:2}}})})()}};e.$XH=h,e.$XH=h=Ge([We(0,y.$Lm)],h)}),define(ke[355],Se([1,0,34,17,16,23,232,354,86,5,37]),function(me,e,D,O,g,I,A,b,$,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fdb=e.$edb=e.ResolvedStatus=e.RegisteredEditorPriority=e.$ddb=e.$cdb=void 0,e.$cdb=(0,y.$6h)("editorResolverService"),e.$ddb="workbench.editorAssociations";const C=L.$Hn.as($.$Mn.Configuration),m={...b.$SH,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,A.localize)(0,null),additionalProperties:{type:"string"}}}};C.registerConfiguration(m);var p;(function(o){o.builtin="builtin",o.option="option",o.exclusive="exclusive",o.default="default"})(p||(e.RegisteredEditorPriority=p={}));var S;(function(o){o[o.ABORT=1]="ABORT",o[o.NONE=2]="NONE"})(S||(e.ResolvedStatus=S={}));function h(o){switch(o){case p.exclusive:return 5;case p.default:return 4;case p.builtin:return 3;case p.option:default:return 1}}e.$edb=h;function f(o,i){if(new Set([O.Schemas.extension,O.Schemas.webviewPanel,O.Schemas.vscodeWorkspaceTrust,O.Schemas.vscodeSettings]).has(i.scheme))return!1;const c=typeof o=="string"&&o.indexOf(g.$gc.sep)>=0?`${i.scheme}:${i.path}`:(0,I.$Eg)(i);return D.$Lj(typeof o=="string"?o.toLowerCase():o,c.toLowerCase())}e.$fdb=f}),define(ke[356],Se([1,0,33,17,16,10,23,2,5,267,40,144,153]),function(me,e,D,O,g,I,A,b,$,y,L,C,m){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$IK=e.$HK=void 0,e.$HK=(0,$.$6h)("pathService");let S=p=class{constructor(f,o,i,r){this.d=f,this.e=o,this.f=i,this.g=r,this.a=(async()=>(await this.e.getEnvironment())?.os||I.OS)(),this.b=(async()=>{const n=await this.e.getEnvironment();return this.c=n?.userHome??f})()}hasValidBasename(f,o,i){return typeof o=="string"||typeof o>"u"?this.a.then(r=>this.h(f,r,o)):this.h(f,o,i)}h(f,o,i){return f.scheme===O.Schemas.file||f.scheme===O.Schemas.vscodeRemote?(0,D.$6f)(i??(0,A.$Eg)(f),o===1):!0}get defaultUriScheme(){return p.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(f,o){if(f.remoteAuthority)return O.Schemas.vscodeRemote;const i=(0,y.$EK)(o.getWorkspace());if(i)return i;const r=o.getWorkspace().folders[0];if(r)return r.uri.scheme;const n=o.getWorkspace().configuration;return n?n.scheme:O.Schemas.file}userHome(f){return f?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(f=>f===1?g.$fc:g.$gc)}async fileURI(f){let o="";if(await this.a===1&&(f=f.replace(/\\/g,"/")),f[0]==="/"&&f[1]==="/"){const r=f.indexOf("/",2);r===-1?(o=f.substring(2),f="/"):(o=f.substring(2,r),f=f.substring(r)||"/")}return b.URI.from({scheme:O.Schemas.file,authority:o,path:f,query:"",fragment:""})}};e.$IK=S,e.$IK=S=p=Ge([We(1,m.$Lm),We(2,C.$qK),We(3,L.$ci)],S)}),define(ke[357],Se([1,0,234,19,52,4,54,3,2,51,239,13,64,269,88,40,144,25,21,18,24,45]),function(me,e,D,O,g,I,A,b,$,y,L,C,m,p,S,h,f,o,i,r,n,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BK=e.$AK=e.$zK=e.OnPortForward=e.$yK=e.$xK=e.$wK=e.$vK=e.$uK=e.TunnelSource=e.TunnelCloseReason=e.$tK=e.$sK=e.$rK=void 0;const t=10*1e3,u="remote.tunnels.toRestore";e.$rK="onTunnel",e.$sK=new c.$kj("forwardedPortsViewEnabled",!1,D.localize(0,null));function s(N){const U=N.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(U)return{host:U[1]?.substring(0,U[1].length-1)||"localhost",port:Number(U[2])}}e.$tK=s;var l;(function(N){N.Other="Other",N.User="User",N.AutoForwardEnd="AutoForwardEnd"})(l||(e.TunnelCloseReason=l={}));var a;(function(N){N[N.User=0]="User",N[N.Auto=1]="Auto",N[N.Extension=2]="Extension"})(a||(e.TunnelSource=a={})),e.$uK={source:a.User,description:D.localize(1,null)},e.$vK={source:a.Auto,description:D.localize(2,null)};function d(N,U,F){const j=N.get(R(U,F));if(j)return j;if((0,S.$Fv)(U))for(const T of S.$Ev){const M=R(T,F);if(N.has(M))return N.get(M)}else if((0,S.$Hv)(U))for(const T of S.$Gv){const M=R(T,F);if(N.has(M))return N.get(M)}}e.$wK=d;function k(N,U,F){const j=d(N,U,F);if(j)return j;const T=(0,S.$Hv)(U)?"localhost":(0,S.$Fv)(U)?"0.0.0.0":void 0;if(T)return d(N,T,F)}e.$xK=k;function R(N,U){return N+":"+U}e.$yK=R;var v;(function(N){N.Notify="notify",N.OpenBrowser="openBrowser",N.OpenBrowserOnce="openBrowserOnce",N.OpenPreview="openPreview",N.Silent="silent",N.Ignore="ignore"})(v||(e.OnPortForward=v={}));function w(N){return N&&"host"in N&&typeof N.host=="string"&&"port"in N&&typeof N.port=="number"&&(!("detail"in N)||typeof N.detail=="string")&&(!("pid"in N)||typeof N.pid=="string")}e.$zK=w;class E extends b.$Tc{static{this.c="remote.portsAttributes"}static{this.f="remote.otherPortsAttributes"}static{this.g=/^(\d+)\-(\d+)$/}static{this.h=/^([a-z0-9\-]+):(\d{1,5})$/}constructor(U){super(),this.r=U,this.j=[],this.n=new I.$Vd,this.onDidChangeAttributes=this.n.event,this.B(U.onDidChangeConfiguration(F=>{(F.affectsConfiguration(E.c)||F.affectsConfiguration(E.f))&&this.s()})),this.s()}s(){this.j=this.y(),this.n.fire()}getAttributes(U,F,j){let T=this.w(U,F,j,this.j,0);const M={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;T>=0;){const B=this.j[T];B.key===U?(M.onAutoForward=B.onAutoForward??M.onAutoForward,M.elevateIfNeeded=B.elevateIfNeeded!==void 0?B.elevateIfNeeded:M.elevateIfNeeded,M.label=B.label??M.label,M.requireLocalPort=B.requireLocalPort,M.protocol=B.protocol):(M.onAutoForward=M.onAutoForward??B.onAutoForward,M.elevateIfNeeded=M.elevateIfNeeded!==void 0?M.elevateIfNeeded:B.elevateIfNeeded,M.label=M.label??B.label,M.requireLocalPort=M.requireLocalPort!==void 0?M.requireLocalPort:void 0,M.protocol=M.protocol??B.protocol),T=this.w(U,F,j,this.j,T+1)}return M.onAutoForward!==void 0||M.elevateIfNeeded!==void 0||M.label!==void 0||M.requireLocalPort!==void 0||M.protocol!==void 0?M:this.C()}t(U){return U.start!==void 0&&U.end!==void 0}u(U){return U.host!==void 0&&U.port!==void 0&&(0,r.$If)(U.host)&&(0,r.$Mf)(U.port)}w(U,F,j,T,M){if(M>=T.length)return-1;const B=!(0,S.$Fv)(F)&&!(0,S.$Hv)(F),ue=T.slice(M).findIndex(Z=>(0,r.$Mf)(Z.key)?B?!1:Z.key===U:this.t(Z.key)?B?!1:U>=Z.key.start&&U<=Z.key.end:this.u(Z.key)?U===Z.key.port&&F===Z.key.host:j?Z.key.test(j):!1);return ue>=0?ue+M:-1}y(){const U=this.r.getValue(E.c);if(!U||!(0,r.$Kf)(U))return[];const F=[];for(const T in U){if(T===void 0)continue;const M=U[T];let B;if(Number(T))B=Number(T);else if((0,r.$If)(T))if(E.g.test(T)){const Y=T.match(E.g);B={start:Number(Y[1]),end:Number(Y[2])}}else if(E.h.test(T)){const Y=T.match(E.h);B={host:Y[1],port:Number(Y[2])}}else{let Y;try{Y=RegExp(T)}catch{}Y&&(B=Y)}B&&F.push({key:B,elevateIfNeeded:M.elevateIfNeeded,onAutoForward:M.onAutoForward,label:M.label,requireLocalPort:M.requireLocalPort,protocol:M.protocol})}const j=this.r.getValue(E.f);return j&&(this.m={elevateIfNeeded:j.elevateIfNeeded,label:j.label,onAutoForward:j.onAutoForward,requireLocalPort:j.requireLocalPort,protocol:j.protocol}),this.z(F)}z(U){function F(j,T){return(0,r.$Mf)(j.key)?j.key:T.t(j.key)?j.key.start:T.u(j.key)?j.key.port:Number.MAX_VALUE}return U.sort((j,T)=>F(j,this)-F(T,this))}C(){return this.m}static providedActionToAction(U){switch(U){case S.ProvidedOnAutoForward.Notify:return v.Notify;case S.ProvidedOnAutoForward.OpenBrowser:return v.OpenBrowser;case S.ProvidedOnAutoForward.OpenBrowserOnce:return v.OpenBrowserOnce;case S.ProvidedOnAutoForward.OpenPreview:return v.OpenPreview;case S.ProvidedOnAutoForward.Silent:return v.Silent;case S.ProvidedOnAutoForward.Ignore:return v.Ignore;default:return}}async addAttributes(U,F,j){const M=this.r.inspect(E.c).userRemoteValue;let B;!M||!(0,r.$Kf)(M)?B={}:B=(0,n.$vn)(M),B[`${U}`]||(B[`${U}`]={});for(const Y in F)B[`${U}`][Y]=F[Y];return this.r.updateValue(E.c,B,j)}}e.$AK=E;let P=class extends b.$Tc{constructor(U,F,j,T,M,B,Y,ue,Z,J){super(),this.H=U,this.I=F,this.J=j,this.L=T,this.M=M,this.N=B,this.O=Y,this.P=ue,this.Q=Z,this.R=J,this.c=new Map,this.g=new I.$Vd,this.onForwardPort=this.g.event,this.h=new I.$Vd,this.onClosePort=this.h.event,this.j=new I.$Vd,this.onPortName=this.j.event,this.n=new I.$Vd,this.onCandidatesChanged=this.n.event,this.t=new I.$Vd,this.onEnvironmentTunnelsSet=this.t.event,this.u=!1,this.w=void 0,this.z=!1,this.C=new I.$Vd,this.D=new Map,this.F=new Map,this.G=[],this.ab=new Date,this.configPortsAttributes=new E(j),this.s=this.Z(),this.B(this.configPortsAttributes.onDidChangeAttributes(this.gb,this)),this.forwarded=new Map,this.f=new Map,this.H.tunnels.then(async X=>{const he=await this.getAttributes(X.map(_=>({port:_.tunnelRemotePort,host:_.tunnelRemoteHost})));for(const _ of X)if(_.localAddress){const we=R(_.tunnelRemoteHost,_.tunnelRemotePort),oe=k(this.m??new Map,_.tunnelRemoteHost,_.tunnelRemotePort);this.forwarded.set(we,{remotePort:_.tunnelRemotePort,remoteHost:_.tunnelRemoteHost,localAddress:_.localAddress,protocol:he?.get(_.tunnelRemotePort)?.protocol??S.TunnelProtocol.Http,localUri:await this.X(_.localAddress,he?.get(_.tunnelRemotePort)),localPort:_.tunnelLocalPort,runningProcess:oe?.detail,hasRunningProcess:!!oe,pid:oe?.pid,privacy:_.privacy,source:e.$uK}),this.f.set(we,_)}}),this.detected=new Map,this.B(this.H.onTunnelOpened(async X=>{const he=R(X.tunnelRemoteHost,X.tunnelRemotePort);if(!k(this.forwarded,X.tunnelRemoteHost,X.tunnelRemotePort)&&!k(this.detected,X.tunnelRemoteHost,X.tunnelRemotePort)&&!k(this.c,X.tunnelRemoteHost,X.tunnelRemotePort)&&X.localAddress){const _=k(this.m??new Map,X.tunnelRemoteHost,X.tunnelRemotePort),we=(await this.getAttributes([{port:X.tunnelRemotePort,host:X.tunnelRemoteHost}]))?.get(X.tunnelRemotePort);this.forwarded.set(he,{remoteHost:X.tunnelRemoteHost,remotePort:X.tunnelRemotePort,localAddress:X.localAddress,protocol:we?.protocol??S.TunnelProtocol.Http,localUri:await this.X(X.localAddress,we),localPort:X.tunnelLocalPort,closeable:!0,runningProcess:_?.detail,hasRunningProcess:!!_,pid:_?.pid,privacy:X.privacy,source:e.$uK})}await this.$(),this.f.set(he,X),this.g.fire(this.forwarded.get(he))})),this.B(this.H.onTunnelClosed(X=>this.W(X,l.Other))),this.U()}S(){return this.Q.extensions.find(U=>U.activationEvents?.includes(e.$rK))?(this.R.createKey(e.$sK.key,!0),!0):!1}U(){if(this.S())return;const U=this.B(this.Q.onDidRegisterExtensions(()=>{this.S()&&U.dispose()}))}async W(U,F){const j=R(U.host,U.port);this.forwarded.has(j)&&(this.forwarded.delete(j),await this.$(),this.h.fire(U))}X(U,F){if(U.startsWith("http"))return $.URI.parse(U);const j=F?.protocol??"http";return $.URI.parse(`${j}://${U}`)}async Y(){const U=this.N.getWorkspace(),F=U.configuration?(0,A.$Ti)(U.configuration.path):U.folders.length>0?(0,A.$Ti)(U.folders[0].uri.path):void 0;if(F===void 0){this.O.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${u}.${this.L.remoteAuthority}.${F}`}async Z(){const U=this.I.get(u,1);if(U)return this.I.remove(u,1),await this.$(),U;const F=await this.Y();if(F)return this.I.get(F,0)}async restoreForwarded(){if(this.J.getValue("remote.restoreForwardedPorts")){const U=await this.s;if(U&&U!==this.y){const F=JSON.parse(U)??[];this.O.trace(`ForwardedPorts: (TunnelModel) restoring ports ${F.map(j=>j.remotePort).join(", ")}`);for(const j of F){const T=k(this.detected,j.remoteHost,j.remotePort);j.source.source!==a.Extension&&!T||j.source.source===a.Extension&&T?await this.cb({remote:{host:j.remoteHost,port:j.remotePort},local:j.localPort,name:j.name,privacy:j.privacy,elevateIfNeeded:!0,source:j.source}):j.source.source===a.Extension&&!T&&this.D.set(R(j.remoteHost,j.remotePort),j)}}}if(this.z=!0,this.C.fire(),!this.w){const U=await this.Y();this.w=this.B(new b.$Sc),this.w.add(this.I.onDidChangeValue(0,void 0,this.w)(async F=>{F.key===U&&(this.s=Promise.resolve(this.I.get(U,0)),await this.restoreForwarded())}))}}async $(){if(this.J.getValue("remote.restoreForwardedPorts")){const U=JSON.stringify(Array.from(this.forwarded.values()));if(U!==this.y){this.y=U;const F=await this.Y();F&&this.I.store(F,this.y,0,0)}}}async bb(U,F,j){if(!U.tunnelLocalPort||!j?.requireLocalPort||U.tunnelLocalPort===F)return;const T=new Date;if(this.ab.getTime()+t>T.getTime())return;this.ab=T;const M=D.localize(3,null,F,U.tunnelRemotePort,U.tunnelLocalPort);return this.P.info(M)}async forward(U,F){return!this.z&&this.L.remoteAuthority&&await I.Event.toPromise(this.C.event),this.cb(U,F)}async cb(U,F){await this.Q.activateByEvent(e.$rK);const j=k(this.forwarded,U.remote.host,U.remote.port);F=F??(F!==null?(await this.getAttributes([U.remote]))?.get(U.remote.port):void 0);const T=U.local!==void 0?U.local:U.remote.port;let M;if(j)return this.eb(j,U,F);{const B=this.L.remoteAuthority,Y=B?{getAddress:async()=>(await this.M.resolveAuthority(B)).authority}:void 0,ue=R(U.remote.host,U.remote.port);this.c.set(ue,!0),U=this.db(ue,U);const Z=await this.H.openTunnel(Y,U.remote.host,U.remote.port,void 0,T,U.elevateIfNeeded?U.elevateIfNeeded:F?.elevateIfNeeded,U.privacy,F?.protocol);if(typeof Z=="string")M=Z;else if(Z&&Z.localAddress){const J=k(this.m??new Map,U.remote.host,U.remote.port),X=Z.protocol?Z.protocol===S.TunnelProtocol.Https?S.TunnelProtocol.Https:S.TunnelProtocol.Http:F?.protocol??S.TunnelProtocol.Http,he={remoteHost:Z.tunnelRemoteHost,remotePort:Z.tunnelRemotePort,localPort:Z.tunnelLocalPort,name:F?.label??U.name,closeable:!0,localAddress:Z.localAddress,protocol:X,localUri:await this.X(Z.localAddress,F),runningProcess:J?.detail,hasRunningProcess:!!J,pid:J?.pid,source:U.source??e.$uK,privacy:Z.privacy};return this.forwarded.set(ue,he),this.f.set(ue,Z),this.c.delete(ue),await this.$(),await this.bb(Z,T,F),this.g.fire(he),Z}this.c.delete(ue)}return M}db(U,F){const j=this.D.has(U)?this.D:this.F.has(U)?this.F:void 0;if(j){const T=j.get(U);j.delete(U),T&&(F.name=T.name??F.name,F.local=("local"in T?T.local:"localPort"in T?T.localPort:void 0)??F.local,F.privacy=T.privacy??F.privacy)}return F}async eb(U,F,j){const T=j?.label??F.name;let M;(function(Y){Y[Y.None=0]="None",Y[Y.Fire=1]="Fire",Y[Y.Reopen=2]="Reopen"})(M||(M={}));let B=M.None;switch(T!==U.name&&(U.name=T,B=M.Fire),(j?.protocol||U.protocol!==S.TunnelProtocol.Http)&&j?.protocol!==U.protocol&&(F.source=U.source,B=M.Reopen),F.privacy&&U.privacy!==F.privacy&&(B=M.Reopen),B){case M.Fire:{this.g.fire();break}case M.Reopen:await this.close(U.remoteHost,U.remotePort,l.User),await this.cb(F,j)}return k(this.f,F.remote.host,F.remote.port)}async name(U,F,j){const T=k(this.forwarded,U,F),M=R(U,F);if(T){T.name=j,await this.$(),this.j.fire({host:U,port:F});return}else this.detected.has(M)&&(this.detected.get(M).name=j,this.j.fire({host:U,port:F}))}async close(U,F,j){const T=R(U,F),M=this.forwarded.get(T);return j===l.AutoForwardEnd&&M&&M.source.source===a.Auto&&this.F.set(T,{local:M.localPort,name:M.name,privacy:M.privacy}),await this.H.closeTunnel(U,F),this.W({host:U,port:F},j)}address(U,F){const j=R(U,F);return(this.forwarded.get(j)||this.detected.get(j))?.localAddress}get environmentTunnelsSet(){return this.u}addEnvironmentTunnels(U){if(U)for(const F of U){const j=k(this.m??new Map,F.remoteAddress.host,F.remoteAddress.port),T=typeof F.localAddress=="string"?F.localAddress:R(F.localAddress.host,F.localAddress.port);this.detected.set(R(F.remoteAddress.host,F.remoteAddress.port),{remoteHost:F.remoteAddress.host,remotePort:F.remoteAddress.port,localAddress:T,protocol:S.TunnelProtocol.Http,localUri:this.X(T),closeable:!1,runningProcess:j?.detail,hasRunningProcess:!!j,pid:j?.pid,privacy:S.TunnelPrivacyId.ConstantPrivate,source:{source:a.Extension,description:D.localize(4,null)}}),this.H.setEnvironmentTunnel(F.remoteAddress.host,F.remoteAddress.port,T,S.TunnelPrivacyId.ConstantPrivate,S.TunnelProtocol.Http)}this.u=!0,this.t.fire(),this.g.fire()}setCandidateFilter(U){this.r=U}async setCandidates(U){let F=U;this.r&&(F=await this.r(U));const j=this.fb(F);this.O.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(j.values()).map(T=>T.port).join(", ")}`),this.n.fire(j)}fb(U){const F=this.m??new Map,j=new Map;return this.m=j,U.forEach(T=>{const M=R(T.host,T.port);j.set(M,{host:T.host,port:T.port,detail:T.detail,pid:T.pid}),F.has(M)&&F.delete(M);const B=k(this.forwarded,T.host,T.port);B&&(B.runningProcess=T.detail,B.hasRunningProcess=!0,B.pid=T.pid)}),F.forEach((T,M)=>{const B=s(M);if(!B)return;const Y=k(this.forwarded,B.host,B.port);Y&&(Y.runningProcess=void 0,Y.hasRunningProcess=!1,Y.pid=void 0);const ue=k(this.detected,B.host,B.port);ue&&(ue.runningProcess=void 0,ue.hasRunningProcess=!1,ue.pid=void 0)}),F}get candidates(){return this.m?Array.from(this.m.values()):[]}get candidatesOrUndefined(){return this.m?this.candidates:void 0}async gb(){const U=Array.from(this.forwarded.values()),F=await this.getAttributes(U.map(j=>({port:j.remotePort,host:j.remoteHost})),!1);if(F)for(const j of U){const T=F.get(j.remotePort);(T?.protocol||j.protocol!==S.TunnelProtocol.Http)&&T?.protocol!==j.protocol&&await this.cb({remote:{host:j.remoteHost,port:j.remotePort},local:j.localPort,name:j.name,source:j.source},T),T&&T.label&&T.label!==j.name&&await this.name(j.remoteHost,j.remotePort,T.label)}}async getAttributes(U,F=!0){const j=new Map,T=new Map;U.forEach(Z=>{const J=k(this.m??new Map,S.$Ev[0],Z.port)??Z;if(J){j.set(Z.port,J);const X=w(J)?J.pid:void 0;T.has(X)||T.set(X,[]),T.get(X)?.push(Z.port)}});const M=new Map;if(U.forEach(Z=>{const J=this.configPortsAttributes.getAttributes(Z.port,Z.host,j.get(Z.port)?.detail);J&&M.set(Z.port,J)}),this.G.length===0||!F)return M.size>0?M:void 0;const B=await Promise.all((0,O.$Rb)(this.G.map(Z=>Array.from(T.entries()).map(J=>{const X=J[1],he=j.get(X[0]);return Z.providePortAttributes(X,he?.pid,he?.detail,new i.$6d().token)})))),Y=new Map;if(B.forEach(Z=>Z.forEach(J=>{J&&Y.set(J.port,J)})),!M&&!Y)return;const ue=new Map;return U.forEach(Z=>{const J=M.get(Z.port),X=Y.get(Z.port);ue.set(Z.port,{elevateIfNeeded:J?.elevateIfNeeded,label:J?.label,onAutoForward:J?.onAutoForward??E.providedActionToAction(X?.autoForwardAction),requireLocalPort:J?.requireLocalPort,protocol:J?.protocol})}),ue}addAttributesProvider(U){this.G.push(U)}};e.$BK=P,Ge([(0,g.$yh)(1e3)],P.prototype,"$",null),e.$BK=P=Ge([We(0,S.$Av),We(1,p.$up),We(2,y.$zi),We(3,f.$qK),We(4,m.$8k),We(5,h.$ci),We(6,C.$nj),We(7,L.$6v),We(8,o.$yF),We(9,c.$lj)],P)}),define(ke[94],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$kJ=e.$jJ=void 0;class D{constructor(A,b){this.line=A,this.character=b}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,b){return new D(0,0)}with(A){return new D(0,0)}}e.$jJ=D;class O{constructor(A,b,$,y){this.isEmpty=!1,this.isSingleLine=!1,this.start=new D(A,b),this.end=new D($,y)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new O(0,0,0,0)}with(A){return new O(0,0,0,0)}}e.$kJ=O;var g;(function(I){I[I.Information=1]="Information",I[I.Warning=2]="Warning"})(g||(e.TextSearchCompleteMessageType=g={}))}),define(ke[36],Se([1,0,19,34,24,33,12,5,16,14,94,11]),function(me,e,D,O,g,I,A,b,$,y,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LJ=e.$KJ=e.$JJ=e.$IJ=e.$HJ=e.$GJ=e.$FJ=e.$EJ=e.$DJ=e.$CJ=e.$BJ=e.$AJ=e.SearchErrorCode=e.$zJ=e.$yJ=e.SearchSortOrder=e.ViewMode=e.$xJ=e.$wJ=e.$vJ=e.$uJ=e.SearchCompletionExitCode=e.$tJ=e.$sJ=e.$rJ=e.QueryType=e.SearchProviderType=e.$qJ=e.$pJ=e.$oJ=e.$nJ=e.$mJ=e.$lJ=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return L.TextSearchCompleteMessageType}}),e.$lJ="workbench.view.search",e.$mJ="workbench.panel.search",e.$nJ="workbench.view.search",e.$oJ="search-result",e.$pJ="search.exclude";const m="\u27EA ",p=" characters skipped \u27EB",S=(m.length+p.length+5)*2;e.$qJ=(0,b.$6h)("searchService");var h;(function(X){X[X.file=0]="file",X[X.text=1]="text"})(h||(e.SearchProviderType=h={}));var f;(function(X){X[X.File=1]="File",X[X.Text=2]="Text"})(f||(e.QueryType=f={}));function o(X){return!!X.preview}e.$rJ=o;function i(X){return!!X.resource}e.$sJ=i;function r(X){return!!X.message}e.$tJ=r;var n;(function(X){X[X.Normal=0]="Normal",X[X.NewSearchStarted=1]="NewSearchStarted"})(n||(e.SearchCompletionExitCode=n={}));class c{constructor(he){this.resource=he,this.results=[]}}e.$uJ=c;class t{constructor(he,_,we,oe){this.ranges=_,this.webviewIndex=oe;const K=Array.isArray(_)?_:[_];if(we&&we.matchLines===1&&u(K)){he=(0,A.$Bf)(he,we.matchLines);let W="",re=0,ye=0;const de=Math.floor(we.charsPerLine/5),ge=[];for(const x of K){const te=Math.max(x.startColumn-de,0),G=x.startColumn+we.charsPerLine;if(te>ye+de+S){const ie=m+(te-ye)+p;W+=ie+he.slice(te,G),re+=te-(ye+ie.length)}else W+=he.slice(ye,G);ge.push(new l(0,x.startColumn-re,x.endColumn-re)),ye=G}this.preview={text:W,matches:Array.isArray(this.ranges)?ge:ge[0]}}else{const W=Array.isArray(_)?_[0].startLineNumber:_.startLineNumber;this.preview={text:he,matches:(0,D.$2b)(_,re=>new s(re.startLineNumber-W,re.startColumn,re.endLineNumber-W,re.endColumn))}}}}e.$vJ=t;function u(X){const he=X[0].startLineNumber;for(const _ of X)if(_.startLineNumber!==he||_.endLineNumber!==he)return!1;return!0}class s{constructor(he,_,we,oe){this.startLineNumber=he,this.startColumn=_,this.endLineNumber=we,this.endColumn=oe}}e.$wJ=s;class l extends s{constructor(he,_,we){super(he,_,he,we)}}e.$xJ=l;var a;(function(X){X.List="list",X.Tree="tree"})(a||(e.ViewMode=a={}));var d;(function(X){X.Default="default",X.FileNames="fileNames",X.Type="type",X.Modified="modified",X.CountDescending="countDescending",X.CountAscending="countAscending"})(d||(e.SearchSortOrder=d={}));function k(X,he=!0){const _=X&&X.files&&X.files.exclude,we=he&&X&&X.search&&X.search.exclude;if(!_&&!we)return;if(!_||!we)return _||we;let oe=Object.create(null);return oe=g.$yn(oe,g.$vn(_)),oe=g.$yn(oe,g.$vn(we),!0),oe}e.$yJ=k;function R(X,he){return X.excludePattern&&O.$Lj(X.excludePattern,he)?!1:X.includePattern||X.usingSearchPaths?X.includePattern&&O.$Lj(X.includePattern,he)?!0:X.usingSearchPaths?!!X.folderQueries&&X.folderQueries.some(_=>{const we=_.folder.fsPath;if(I.$8f(he,we)){const oe=$.$lc(we,he);return!_.includePattern||!!O.$Lj(_.includePattern,oe)}else return!1}):!1:!0}e.$zJ=R;var v;(function(X){X[X.unknownEncoding=1]="unknownEncoding",X[X.regexParseError=2]="regexParseError",X[X.globParseError=3]="globParseError",X[X.invalidLiteral=4]="invalidLiteral",X[X.rgProcessError=5]="rgProcessError",X[X.other=6]="other",X[X.canceled=7]="canceled"})(v||(e.SearchErrorCode=v={}));class w extends Error{constructor(he,_){super(he),this.code=_}}e.$AJ=w;function E(X){const he=X.message;if((0,y.$4)(X))return new w(he,v.canceled);try{const _=JSON.parse(he);return new w(_.message,_.code)}catch{return new w(he,v.other)}}e.$BJ=E;function P(X){const he={message:X.message,code:X.code};return new Error(JSON.stringify(he))}e.$CJ=P;function N(X){return X.type==="error"?!0:X.type==="success"}e.$DJ=N;function U(X){return X.type==="success"}e.$EJ=U;function F(X){return!!X.path}e.$FJ=F;function j(X,he){const _=X.searchPath?X.searchPath:X.relativePath;return(0,A.$yf)(_,he)}e.$GJ=j;class T{constructor(he){this.path=he,this.results=[]}addMatch(he){this.results.push(he)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$HJ=T;function M(X,he){const _={...X||{},...he||{}};return Object.keys(_).filter(we=>{const oe=_[we];return typeof oe=="boolean"&&oe})}e.$IJ=M;class B{constructor(he,_){this.c=null,this.a={...he.excludePattern||{},..._.excludePattern||{}},this.b=O.$Mj(this.a);let we=he.includePattern;_.includePattern&&(we?we={...we,..._.includePattern}:we=_.includePattern),we&&(this.c=O.$Mj(we))}matchesExcludesSync(he,_,we){return!!(this.b&&this.b(he,_,we))}includedInQuerySync(he,_,we){return!(this.b&&this.b(he,_,we)||this.c&&!this.c(he,_,we))}includedInQuery(he,_,we){const oe=this.b(he,_,we),K=()=>this.c?!!this.c(he,_,we):!0;return(0,C.$Sg)(oe)?oe.then(W=>W?!1:K()):K()}hasSiblingExcludeClauses(){return Y(this.a)}}e.$JJ=B;function Y(X){for(const he in X)if(typeof X[he]!="boolean")return!0;return!1}function ue(X){if(!X)return;let he;return _=>(he||(he=(X()||Promise.resolve([])).then(we=>we?J(we):{})),he.then(we=>!!we[_]))}e.$KJ=ue;function Z(X){if(!X)return;let he;return _=>{if(!he){const we=X();he=we?J(we):{}}return!!he[_]}}e.$LJ=Z;function J(X){const he={};for(const _ of X)he[_]=!0;return he}}),define(ke[41],Se([1,0,19,11,21,4,3,77,17,122,23,12,2,221,5,13,252,40,58,27,20,15,7,66,36,6,55]),function(me,e,D,O,g,I,A,b,$,y,L,C,m,p,S,h,f,o,i,r,n,c,t,u,s,l,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qgc=e.$pgc=void 0;function d(U,F,j){return new L.$wg(T=>w(T,j)).isEqual(U,F)}function k(U,F,j){return d(U.uri,F.uri,j)?0:(0,C.$5e)(U.uri.toString(),F.uri.toString())}function R(U,F,j){return U.index!==F.index?U.index<F.index?-1:1:d(U.uri,F.uri,j)?(0,C.$5e)(U.name,F.name):(0,C.$5e)(U.uri.toString(),F.uri.toString())}function v(U,F,j,T){const M=U.slice(0).sort((Y,ue)=>j(Y,ue,T)),B=F.slice(0).sort((Y,ue)=>j(Y,ue,T));return(0,D.$Eb)(M,B,(Y,ue)=>j(Y,ue,T))}function w(U,F){const j=F.getCapabilities(U.scheme);return!(j&&j&1024)}class E extends o.$mi{static toExtHostWorkspace(F,j,T,M){if(!F)return{workspace:null,added:[],removed:[]};const{id:B,name:Y,folders:ue,configuration:Z,transient:J,isUntitled:X}=F,he=[],_=j;j?ue.forEach((W,re)=>{const ye=m.URI.revive(W.uri),de=E.o(T||j,ye,M);de?(de.name=W.name,de.index=W.index,he.push(de)):he.push({uri:ye,name:W.name,index:re})}):he.push(...ue.map(({uri:W,name:re,index:ye})=>({uri:m.URI.revive(W),name:re,index:ye}))),he.sort((W,re)=>W.index<re.index?-1:1);const we=new E(B,Y,he,!!J,Z?m.URI.revive(Z):null,!!X,W=>w(W,M)),{added:oe,removed:K}=v(_?_.workspaceFolders:[],we.workspaceFolders,k,M);return{workspace:we,added:oe,removed:K}}static o(F,j,T){for(let M=0;M<F.folders.length;M++){const B=F.workspaceFolders[M];if(d(B.uri,j,T))return B}}constructor(F,j,T,M,B,Y,ue){super(F,T.map(Z=>new o.$ni(Z)),M,B,ue),this.t=j,this.u=Y,this.q=[],this.s=b.$_h.forUris(ue),T.forEach(Z=>{this.q.push(Z),this.s.set(Z.uri,Z)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(F,j){return j&&this.s.get(F)&&(F=(0,L.$Gg)(F)),this.s.findSubstr(F)}resolveWorkspaceFolder(F){return this.s.get(F)}}let P=class{constructor(F,j,T,M,B){this.c=new I.$Vd,this.onDidChangeWorkspace=this.c.event,this.g=new I.$Vd,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new I.$Xd,this.B=new Map,this.h=M,this.s=T,this.t=B,this.j=new y.$9l,this.k=new O.$5g,this.o=F.getProxy(l.$6K.MainThreadWorkspace),this.q=F.getProxy(l.$6K.MainThreadMessageService);const Y=j.workspace;this.l=Y?new E(Y.id,Y.name,[],!!Y.transient,Y.configuration?m.URI.revive(Y.configuration):null,!!Y.isUntitled,ue=>w(ue,T)):void 0}$initializeWorkspace(F,j){this.v=j,this.$acceptWorkspaceData(F),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?m.URI.from({scheme:$.Schemas.untitled,path:(0,L.$Eg)((0,L.$Gg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(F,j,T,...M){const B=[];if(Array.isArray(M)&&M.forEach(X=>{m.URI.isUri(X.uri)&&!B.some(he=>d(he.uri,X.uri,this.s))&&B.push({uri:X.uri,name:X.name||(0,L.$Dg)(X.uri)})}),this.n||[j,T].some(X=>typeof X!="number"||X<0)||T===0&&B.length===0)return!1;const Y=this.x?this.x.workspaceFolders:[];if(j+T>Y.length)return!1;const ue=Y.slice(0);ue.splice(j,T,...B.map(X=>({uri:X.uri,name:X.name||(0,L.$Dg)(X.uri),index:void 0})));for(let X=0;X<ue.length;X++){const he=ue[X];if(ue.some((_,we)=>we!==X&&d(he.uri,_.uri,this.s)))return!1}ue.forEach((X,he)=>X.index=he);const{added:Z,removed:J}=v(Y,ue,R,this.s);if(Z.length===0&&J.length===0)return!1;if(this.o){const X=F.displayName||F.name;this.o.$updateWorkspaceFolders(X,j,T,B).then(void 0,he=>{this.n=void 0;const _={source:{identifier:F.identifier,label:F.displayName||F.name}};this.q.$showMessage(f.Severity.Error,(0,p.localize)(0,null,X,he.toString()),_,[])})}return this.y(ue),!0}getWorkspaceFolder(F,j){if(this.x)return this.x.getWorkspaceFolder(F,j)}async getWorkspaceFolder2(F,j){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(F,j)}async resolveWorkspaceFolder(F){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(F)}getPath(){if(!this.x)return;const{folders:F}=this.x;if(F.length!==0)return F[0].uri.fsPath}getRelativePath(F,j){let T,M="";if(typeof F=="string"?(T=m.URI.file(F),M=F):typeof F<"u"&&(T=F,M=F.fsPath),!T)return M;const B=this.getWorkspaceFolder(T,!0);if(!B)return M;typeof j>"u"&&this.x&&(j=this.x.folders.length>1);let Y=(0,L.$Jg)(B.uri,T);return j&&B.name&&(Y=`${B.name}/${Y}`),Y}y(F){this.x&&(this.n=E.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:F,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(F){const{workspace:j,added:T,removed:M}=E.toExtHostWorkspace(F,this.l,this.n,this.s);this.l=j||void 0,this.n=void 0,this.c.fire(Object.freeze({added:T,removed:M}))}findFiles(F,j,T,M,B=g.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${M.value}, entryPoint: findFiles`);let Y;if(j===null?Y=!1:j&&(typeof j=="string"?Y=j:Y=j.pattern),B&&B.isCancellationRequested)return Promise.resolve([]);const{includePattern:ue,folder:Z}=N(c.GlobPattern.from(F));return this.o.$startFileSearch(ue??null,Z??null,Y??null,T??null,B).then(J=>Array.isArray(J)?J.map(X=>m.URI.revive(X)):[])}async findTextInFiles(F,j,T,M,B=g.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${M.value}, entryPoint: findTextInFiles`);const Y=this.j.getNext(),ue=typeof j.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:j.previewOptions,{includePattern:Z,folder:J}=N(c.GlobPattern.from(j.include)),X=typeof j.exclude=="string"?j.exclude:j.exclude?j.exclude.pattern:void 0,he={ignoreSymlinks:typeof j.followSymlinks=="boolean"?!j.followSymlinks:void 0,disregardIgnoreFiles:typeof j.useIgnoreFiles=="boolean"?!j.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof j.useGlobalIgnoreFiles=="boolean"?!j.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof j.useParentIgnoreFiles=="boolean"?!j.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof j.useDefaultExcludes=="boolean"?!j.useDefaultExcludes:!0,fileEncoding:j.encoding,maxResults:j.maxResults,previewOptions:ue,afterContext:j.afterContext,beforeContext:j.beforeContext,includePattern:Z,excludePattern:X},_=!1;if(this.u[Y]=we=>{if(_)return;const oe=m.URI.revive(we.resource);we.results.forEach(K=>{const W=(0,a.$Ch)(K);(0,s.$rJ)(W)?T({uri:oe,preview:{text:W.preview.text,matches:(0,D.$2b)(W.preview.matches,re=>new t.$0K(re.startLineNumber,re.startColumn,re.endLineNumber,re.endColumn))},ranges:(0,D.$2b)(W.ranges,re=>new t.$0K(re.startLineNumber,re.startColumn,re.endLineNumber,re.endColumn))}):T({uri:oe,text:W.text,lineNumber:W.lineNumber})})},B.isCancellationRequested)return{};try{const we=await this.o.$startTextSearch(F,J??null,he,Y,B);return delete this.u[Y],we||{}}catch(we){throw delete this.u[Y],we}}$handleTextSearchResult(F,j){this.u[j]?.(F)}async save(F){const j=await this.o.$save(F,{saveAs:!1});return m.URI.revive(j)}async saveAs(F){const j=await this.o.$save(F,{saveAs:!0});return m.URI.revive(j)}saveAll(F){return this.o.$saveAll(F)}resolveProxy(F){return this.o.$resolveProxy(F)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(F){return this.o.$requestWorkspaceTrust(F)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(F,j){if(this.w.has(F))throw new Error(`A provider has already been registered for scheme ${F}`);this.w.set(F,j);const T=this.t.transformOutgoingScheme(F),M=this.z++;return this.o.$registerEditSessionIdentityProvider(M,T),(0,A.$Rc)(()=>{this.w.delete(F),this.o.$unregisterEditSessionIdentityProvider(M)})}async $getEditSessionIdentifier(F,j){this.h.info("Getting edit session identifier for workspaceFolder",F);const T=await this.resolveWorkspaceFolder(m.URI.revive(F));if(!T){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",T);const M=this.w.get(T.uri.scheme);if(this.h.info(`Provider for scheme ${T.uri.scheme} is defined: `,!!M),!M)return;const B=await M.provideEditSessionIdentity(T,j);if(this.h.info("Provider returned edit session identifier: ",B),!!B)return B}async $provideEditSessionIdentityMatch(F,j,T,M){this.h.info("Getting edit session identifier for workspaceFolder",F);const B=await this.resolveWorkspaceFolder(m.URI.revive(F));if(!B){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",B);const Y=this.w.get(B.uri.scheme);if(this.h.info(`Provider for scheme ${B.uri.scheme} is defined: `,!!Y),!Y)return;const ue=await Y.provideEditSessionIdentityMatch?.(j,T,M);if(this.h.info("Provider returned edit session identifier match result: ",ue),!!ue)return ue}getOnWillCreateEditSessionIdentityEvent(F){return(j,T,M)=>{const B=function(ue){j.call(T,ue)};return B.extension=F,this.A.event(B,void 0,M)}}async $onWillCreateEditSessionIdentity(F,j,T){const M=await this.resolveWorkspaceFolder(m.URI.revive(F));if(M===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:M},j,async(B,Y)=>{const ue=Date.now();await Promise.resolve(B),Date.now()-ue>T&&this.h.warn("SLOW edit session create-participant",Y.extension.identifier)}),j.isCancellationRequested}registerCanonicalUriProvider(F,j){if(this.B.has(F))throw new Error(`A provider has already been registered for scheme ${F}`);this.B.set(F,j);const T=this.t.transformOutgoingScheme(F),M=this.z++;return this.o.$registerCanonicalUriProvider(M,T),(0,A.$Rc)(()=>{this.B.delete(F),this.o.$unregisterCanonicalUriProvider(M)})}async provideCanonicalUri(F,j,T){const M=this.B.get(F.scheme);if(!M)return;const B=await M.provideCanonicalUri?.(m.URI.revive(F),j,T);if(B)return B}async $provideCanonicalUri(F,j,T){return this.provideCanonicalUri(m.URI.revive(F),{targetScheme:j},T)}};e.$pgc=P,e.$pgc=P=Ge([We(0,n.$0M),We(1,r.$nN),We(2,i.$8fc),We(3,h.$nj),We(4,u.$ngc)],P),e.$qgc=(0,S.$6h)("IExtHostWorkspace");function N(U){let F,j;return U&&(typeof U=="string"?F=U:(F=U.pattern,j=m.URI.revive(U.baseUri))),{includePattern:F,folder:j}}}),define(ke[42],Se([1,0,24,4,41,6,7,254,86,18,11,5,20,13,2]),function(me,e,D,O,g,I,A,b,$,y,L,C,m,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tgc=e.$sgc=e.$rgc=void 0;function h(u,s){if(s){const l=s.split(".");let a=u;for(let d=0;a&&d<l.length;d++)a=a[l[d]];return a}}function f(u){return u instanceof S.URI}function o(u){return u&&u.uri instanceof S.URI&&u.languageId&&typeof u.languageId=="string"}function i(u){return u&&!u.uri&&u.languageId&&typeof u.languageId=="string"}function r(u){return u&&u.uri instanceof S.URI&&(!u.name||typeof u.name=="string")&&(!u.index||typeof u.index=="number")}function n(u){if(f(u))return{resource:u};if(o(u))return{resource:u.uri,overrideIdentifier:u.languageId};if(i(u))return{overrideIdentifier:u.languageId};if(r(u))return{resource:u.uri};if(u===null)return{resource:null}}let c=class{constructor(s,l,a){this.a=s.getProxy(I.$6K.MainThreadConfiguration),this.c=l,this.b=a,this.d=new L.$5g,this.e=null}getConfigProvider(){return this.d.wait().then(s=>this.e)}$initializeConfiguration(s){this.e=new t(this.a,this.c,s,this.b),this.d.open()}$acceptConfigurationChanged(s,l){this.getConfigProvider().then(a=>a.$acceptConfigurationChanged(s,l))}};e.$rgc=c,e.$rgc=c=Ge([We(0,m.$0M),We(1,g.$qgc),We(2,p.$nj)],c);class t{constructor(s,l,a,d){this.a=new O.$Vd,this.b=s,this.f=d,this.c=l,this.e=b.$6n.parse(a),this.d=this.k(a.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(s,l){const a={data:this.e.toData(),workspace:this.c.workspace};this.e=b.$6n.parse(s),this.d=this.k(s.configurationScopes),this.a.fire(this.j(l,a))}getConfiguration(s,l,a){const d=n(l)||{},k=this.g(s?h(this.e.getValue(void 0,d,this.c.workspace),s):this.e.getValue(void 0,d,this.c.workspace));s&&this.h(s,d,a?.identifier);function R(w){if(w==null)return null;if(typeof w=="boolean")return w?2:5;switch(w){case A.ConfigurationTarget.Global:return 2;case A.ConfigurationTarget.Workspace:return 5;case A.ConfigurationTarget.WorkspaceFolder:return 6}}const v={has(w){return typeof h(k,w)<"u"},get:(w,E)=>{this.h(s?`${s}.${w}`:w,d,a?.identifier);let P=h(k,w);if(typeof P>"u")P=E;else{let N;const U=(F,j)=>{if((0,y.$Kf)(F)){let T;const M=()=>{N=N||(0,D.$vn)(k),T=T||h(N,j)};return new Proxy(F,{get:(B,Y)=>{if(typeof Y=="string"&&Y.toLowerCase()==="tojson")return M(),()=>T;if(N)return T=T||h(N,j),T[Y];const ue=B[Y];return typeof Y=="string"?U(ue,`${j}.${Y}`):ue},set:(B,Y,ue)=>(M(),T&&(T[Y]=ue),!0),deleteProperty:(B,Y)=>(M(),T&&delete T[Y],!0),defineProperty:(B,Y,ue)=>(M(),T&&Object.defineProperty(T,Y,ue),!0)})}return Array.isArray(F)?(0,D.$vn)(F):F};P=U(P,w)}return P},update:(w,E,P,N)=>{w=s?`${s}.${w}`:w;const U=R(P);return E!==void 0?this.b.$updateConfigurationOption(U,w,E,d,N):this.b.$removeConfigurationOption(U,w,d,N)},inspect:w=>{w=s?`${s}.${w}`:w;const E=this.e.inspect(w,d,this.c.workspace);if(E)return{key:w,defaultValue:(0,D.$vn)(E.policy?.value??E.default?.value),globalValue:(0,D.$vn)(E.user?.value??E.application?.value),workspaceValue:(0,D.$vn)(E.workspace?.value),workspaceFolderValue:(0,D.$vn)(E.workspaceFolder?.value),defaultLanguageValue:(0,D.$vn)(E.default?.override),globalLanguageValue:(0,D.$vn)(E.user?.override??E.application?.override),workspaceLanguageValue:(0,D.$vn)(E.workspace?.override),workspaceFolderLanguageValue:(0,D.$vn)(E.workspaceFolder?.override),languageIds:(0,D.$vn)(E.overrideIdentifiers)}}};return typeof k=="object"&&(0,D.$yn)(v,k,!1),Object.freeze(v)}g(s){const l=a=>(0,y.$Kf)(a)?new Proxy(a,{get:(d,k)=>l(d[k]),set:(d,k,R)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(k)}' of object`)},deleteProperty:(d,k)=>{throw new Error(`TypeError: Cannot delete read only property '${String(k)}' of object`)},defineProperty:(d,k)=>{throw new Error(`TypeError: Cannot define property '${String(k)}' for a readonly object`)},setPrototypeOf:d=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):a;return l(s)}h(s,l,a){const d=$.$Wn.test(s)?4:this.d.get(s),k=a?`[${a.value}] `:"";if(d===4){typeof l?.resource>"u"&&this.f.warn(`${k}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if(d===3){l?.resource&&this.f.warn(`${k}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(s,l){const a=new b.$8n(s,l,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(d,k)=>a.affectsConfiguration(d,n(k))})}k(s){return s.reduce((l,a)=>(l.set(a[0],a[1]),l),new Map)}}e.$sgc=t,e.$tgc=(0,C.$6h)("IExtHostConfiguration")}),define(ke[95],Se([1,0,2,11,4,6,7,41,69,42,21,46,20,27,5,17,10,13,91,302,14]),function(me,e,D,O,g,I,A,b,$,y,L,C,m,p,S,h,f,o,i,r,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Whc=e.$Vhc=e.$Uhc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var c;(function(U){function F(T){if(T!=null)return T}U.from=F;function j(T){if(T!=null)return T}U.to=j})(c||(c={}));var t;(function(U){function F(T){if(T!=null)return T}U.from=F;function j(T){if(T!=null)return T}U.to=j})(t||(t={}));var u;(function(U){function F(T){if(T!=null)return T}U.from=F;function j(T){if(T!=null)return T}U.to=j})(u||(u={}));var s;(function(U){function F(M){if(M){const B=M;return B&&!!B.process}else return!1}U.is=F;function j(M){if(M==null)return;const B={process:M.process,args:M.args};return M.options&&(B.options=u.from(M.options)),B}U.from=j;function T(M){if(M!=null)return new A.$QL(M.process,M.args,M.options)}U.to=T})(s||(s={}));var l;(function(U){function F(T){if(T!=null)return T}U.from=F;function j(T){if(T!=null)return T}U.to=j})(l||(l={}));var a;(function(U){function F(M){if(M){const B=M;return B&&(!!B.commandLine||!!B.command)}else return!1}U.is=F;function j(M){if(M==null)return;const B={};return M.commandLine!==void 0?B.commandLine=M.commandLine:(B.command=M.command,B.args=M.args),M.options&&(B.options=l.from(M.options)),B}U.from=j;function T(M){if(!(M==null||M.command===void 0&&M.commandLine===void 0))return M.commandLine?new A.$RL(M.commandLine,M.options):new A.$RL(M.command,M.args?M.args:[],M.options)}U.to=T})(a||(a={}));var d;(function(U){function F(M){if(M){const B=M;return B&&B.customExecution==="customExecution"}else return!1}U.is=F;function j(M){return{customExecution:"customExecution"}}U.from=j;function T(M,B){return B.get(M)}U.to=T})(d||(e.CustomExecutionDTO=d={}));var k;(function(U){function F(j,T){let M;return j.scope!==void 0&&typeof j.scope!="number"?M=j.scope.uri:j.scope!==void 0&&typeof j.scope=="number"&&(j.scope===A.TaskScope.Workspace&&T&&T.workspaceFile?M=T.workspaceFile:M=r.$yG),{id:j._id,workspaceFolder:M}}U.from=F})(k||(e.TaskHandleDTO=k={}));var R;(function(U){function F(j){if(j!=null)return{_id:j.id,isDefault:j.isDefault}}U.from=F})(R||(R={}));var v;(function(U){function F(M,B){if(M==null)return[];const Y=[];for(const ue of M){const Z=j(ue,B);Z&&Y.push(Z)}return Y}U.fromMany=F;function j(M,B){if(M==null)return;let Y;M.execution instanceof A.$QL?Y=s.from(M.execution):M.execution instanceof A.$RL?Y=a.from(M.execution):M.execution&&M.execution instanceof A.$SL&&(Y=d.from(M.execution));const ue=c.from(M.definition);let Z;return M.scope?typeof M.scope=="number"?Z=M.scope:Z=M.scope.uri:Z=A.TaskScope.Workspace,!ue||!Z?void 0:{_id:M._id,definition:ue,name:M.name,source:{extensionId:B.identifier.value,label:M.source,scope:Z},execution:Y,isBackground:M.isBackground,group:R.from(M.group),presentationOptions:t.from(M.presentationOptions),problemMatchers:M.problemMatchers,hasDefinedMatchers:M.hasDefinedMatchers,runOptions:M.runOptions?M.runOptions:{reevaluateOnRerun:!0},detail:M.detail}}U.from=j;async function T(M,B,Y){if(M==null)return;let ue;s.is(M.execution)?ue=s.to(M.execution):a.is(M.execution)?ue=a.to(M.execution):d.is(M.execution)&&(ue=d.to(M._id,Y));const Z=c.to(M.definition);let J;if(M.source&&(M.source.scope!==void 0?typeof M.source.scope=="number"?J=M.source.scope:J=await B.resolveWorkspaceFolder(D.URI.revive(M.source.scope)):J=A.TaskScope.Workspace),!Z||!J)return;const X=new A.$TL(Z,J,M.name,M.source.label,ue,M.problemMatchers);return M.isBackground!==void 0&&(X.isBackground=M.isBackground),M.group!==void 0&&(X.group=A.$PL.from(M.group._id),X.group&&M.group.isDefault&&(X.group=new A.$PL(X.group.id,X.group.label),M.group.isDefault===!0&&(X.group.isDefault=M.group.isDefault))),M.presentationOptions&&(X.presentationOptions=t.to(M.presentationOptions)),M._id&&(X._id=M._id),M.detail&&(X.detail=M.detail),X}U.to=T})(v||(e.TaskDTO=v={}));var w;(function(U){function F(T){return T}U.from=F;function j(T){if(T)return Object.assign(Object.create(null),T)}U.to=j})(w||(w={}));class E{#e;constructor(F,j,T){this._id=j,this.a=T,this.#e=F}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(F){}fireDidEndProcess(F){}}let P=class{constructor(F,j,T,M,B,Y,ue,Z){this.q=new g.$Vd,this.r=new g.$Vd,this.s=new g.$Vd,this.u=new g.$Vd,this.a=F.getProxy(I.$6K.MainThreadTask),this.b=T,this.c=M,this.d=B,this.e=Y,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ue,this.g=Z,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(F,j,T){if(!T)return new A.$8K(()=>{});const M=this.x();return this.j.set(M,{type:j,provider:T,extension:F}),this.a.$registerTaskProvider(M,j),new A.$8K(()=>{this.j.delete(M),this.a.$unregisterTaskProvider(M)})}registerTaskSystem(F,j){this.a.$registerTaskSystem(F,j)}fetchTasks(F){return this.a.$fetchTasks(w.from(F)).then(async j=>{const T=[];for(const M of j){const B=await v.to(M,this.b,this.m);B&&T.push(B)}return T})}get taskExecutions(){const F=[];return this.k.forEach(j=>F.push(j)),F}terminateTask(F){if(!(F instanceof E))throw new Error("No valid task execution provided");return this.a.$terminateTask(F._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(F,j,T){const M=this.m.get(F.id);M&&(this.o.set(F.id,M),this.e.attachPtyToTerminal(j,await M.callback(T))),this.p=F.id,this.q.fire({execution:await this.z(F)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(F){if(!this.l.has(F.id))return;const j=await this.z(F);this.l.delete(F.id),this.k.delete(F.id),this.B(F),this.r.fire({execution:j})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(F){const j=await this.z(F.id);this.s.fire({execution:j,processId:F.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(F){const j=await this.z(F.id);this.u.fire({execution:j,exitCode:F.exitCode})}$provideTasks(F,j){const T=this.j.get(F);if(!T)return Promise.reject(new Error("no handler found"));const M=[],B=(0,O.$Yg)(()=>T.provider.provideTasks(L.CancellationToken.None)).then(Y=>this.v(j,M,T,Y));return new Promise(Y=>{B.then(ue=>{Promise.all(M).then(()=>{Y(ue)})})})}async $resolveTask(F,j){const T=this.j.get(F);if(!T)return Promise.reject(new Error("no handler found"));if(j.definition.type!==T.type)throw new Error(`Unexpected: Task of type [${j.definition.type}] cannot be resolved by provider of type [${T.type}].`);const M=await v.to(j,this.b,this.m);if(!M)throw new Error("Unexpected: Task cannot be resolved.");const B=await T.provider.resolveTask(M,L.CancellationToken.None);if(!B)return;this.A(B,T);const Y=v.from(B,T.extension);if(!Y)throw new Error("Unexpected: Task cannot be resolved.");if(B.definition!==M.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return d.is(Y.execution)&&await this.y(Y,B,!0),await this.w(Y)}x(){return this.h++}async y(F,j,T){const M=await this.a.$createTaskId(F);!T&&!this.m.has(M)&&(this.n.add(M),this.o.set(M,j.execution)),this.m.set(M,j.execution)}async z(F,j){if(typeof F=="string"){const B=this.l.get(F);if(!B)throw new n.$bb("Unexpected: The specified task is missing an execution");return B}const T=this.l.get(F.id);if(T)return T;let M;return j?M=Promise.resolve(new E(this,F.id,j)):M=v.to(F.task,this.b,this.m).then(B=>{if(!B)throw new n.$bb("Unexpected: Task does not exist.");return new E(this,F.id,B)}),this.l.set(F.id,M),M.then(B=>(this.k.set(F.id,B),B))}A(F,j){F._deprecated&&this.g.report("Task.constructor",j.extension,"Use the Task constructor that takes a `scope` instead.")}B(F){this.o.get(F.id)&&this.o.delete(F.id),this.n.has(F.id)&&this.p!==F.id&&(this.m.delete(F.id),this.n.delete(F.id));const T=this.n.values();let M=T.next();for(;!M.done;)!this.o.has(M.value)&&this.p!==M.value&&(this.m.delete(M.value),this.n.delete(M.value)),M=T.next()}};e.$Uhc=P,e.$Uhc=P=Ge([We(0,m.$0M),We(1,p.$nN),We(2,b.$qgc),We(3,$.$iN),We(4,y.$tgc),We(5,C.$Rgc),We(6,o.$nj),We(7,i.$$fc)],P);let N=class extends P{constructor(F,j,T,M,B,Y,ue,Z){super(F,j,T,M,B,Y,ue,Z),this.registerTaskSystem(h.Schemas.vscodeRemote,{scheme:h.Schemas.vscodeRemote,authority:"",platform:f.$h(0)})}async executeTask(F,j){if(!j.execution)throw new Error("Tasks to execute must include an execution");const T=v.from(j,F);if(T===void 0)throw new Error("Task is not valid");if(d.is(T.execution))await this.y(T,j,!1);else throw new n.$_;const M=await this.z(await this.a.$getTaskExecution(T),j);return this.a.$executeTask(T).catch(B=>{throw new Error(B)}),M}v(F,j,T,M){const B=[];if(M)for(const Y of M){if(this.A(Y,T),!Y.definition||!F[Y.definition.type]){const Z=Y.source?Y.source:"No task source";this.f.warn(`The task [${Z}, ${Y.name}] uses an undefined task type. The task will be ignored in the future.`)}const ue=v.from(Y,T.extension);ue&&d.is(ue.execution)?(B.push(ue),j.push(this.y(ue,Y,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:B,extension:T.extension}}async w(F){if(d.is(F.execution))return F;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(F,j){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(F,j,T){}};e.$Vhc=N,e.$Vhc=N=Ge([We(0,m.$0M),We(1,p.$nN),We(2,b.$qgc),We(3,$.$iN),We(4,y.$tgc),We(5,C.$Rgc),We(6,o.$nj),We(7,i.$$fc)],N),e.$Whc=(0,S.$6h)("IExtHostTask")}),define(ke[358],Se([1,0,36,29]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TJ=e.$SJ=e.$RJ=void 0;function g(A){return"cellResults"in A}e.$RJ=g,e.$SJ="rawCell#";function I(A,b){let $=-1;const y=[];let L=[];return A.forEach(m=>{m.range.startLineNumber!==$&&L.length>0&&(y.push([...L]),L=[]),L.push(m),$=m.range.endLineNumber}),L.length>0&&y.push([...L]),y.map(m=>{const p=[],S=m[0].range.startLineNumber,h=m[m.length-1].range.endLineNumber;for(let f=S;f<=h;f++)p.push(b.getLineContent(f));return new D.$vJ(p.join(`
`)+`
`,m.map(f=>new O.$Us(f.range.startLineNumber-1,f.range.startColumn-1,f.range.endLineNumber-1,f.range.endColumn-1)))})}e.$TJ=I}),define(ke[359],Se([1,0,215,22,4,3,28,12,18,2,32,110,6,35,15,7,68,294,146,24,17,286,358,355]),function(me,e,D,O,g,I,A,b,$,y,L,C,m,p,S,h,f,o,i,r,n,c,t,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$whc=void 0;class s{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(a=>a.apiEditor)}constructor(a,d,k,R,v,w){this.q=k,this.r=R,this.s=v,this.t=w,this.f=new Map,this.g=new A.$Ac,this.h=new Map,this.j=new g.$Vd,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new g.$Vd,this.onDidOpenNotebookDocument=this.m.event,this.n=new g.$Vd,this.onDidCloseNotebookDocument=this.n.event,this.o=new g.$Vd,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new C.$4fc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=a.getProxy(m.$6K.MainThreadNotebook),this.c=a.getProxy(m.$6K.MainThreadNotebookDocuments),this.d=a.getProxy(m.$6K.MainThreadNotebookEditors),this.i=d.converter,d.registerArgumentProcessor({processArgument:E=>{if(E&&E.$mid===13){const P=E.notebookEditor?.notebookUri,N=E.cell.handle,F=this.g.get(P)?.getCell(N);if(F)return F.apiCell}if(E&&E.$mid===14){const P=E.uri,N=this.g.get(P);if(N)return N.apiNotebook}return E}}),s.B(d)}getEditorById(a){const d=this.h.get(a);if(!d)throw new Error(`unknown text editor: ${a}. known editors: ${[...this.h.keys()]} `);return d}getIdByEditor(a){for(const[d,k]of this.h)if(k.apiEditor===a)return d}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(a,d){const k=this.g.get(a);if(!k&&!d)throw new Error(`NO notebook document for '${a}'`);return k}static u(a,d){if(!d)return;const k=d.filenamePattern.map(R=>S.NotebookExclusiveDocumentPattern.from(R)).filter(R=>R!==void 0);if(d.filenamePattern&&!k){console.warn(`Notebook content provider view options file name pattern is invalid ${d.filenamePattern}`);return}return{extension:a.identifier,providerDisplayName:a.displayName||a.name,displayName:d.displayName,filenamePattern:k,exclusive:d.exclusive||!1}}registerNotebookCellStatusBarItemProvider(a,d,k){const R=s.a++,v=typeof k.onDidChangeCellStatusBarItems=="function"?s.a++:void 0;this.f.set(R,k),this.b.$registerNotebookCellStatusBarItemProvider(R,v,d);let w;return v!==void 0&&(w=k.onDidChangeCellStatusBarItems(E=>this.b.$emitCellStatusBarEvent(v))),new h.$8K(()=>{this.f.delete(R),this.b.$unregisterNotebookCellStatusBarItemProvider(R,v),w?.dispose()})}async createNotebookDocument(a){const d=await this.c.$tryCreateNotebook({viewType:a.viewType,content:a.content&&S.NotebookData.from(a.content)});return y.URI.revive(d)}async openNotebookDocument(a){const d=this.g.get(a);if(d)return d.apiNotebook;const k=await this.c.$tryOpenNotebook(a),R=this.g.get(y.URI.revive(k));return(0,$.$Tf)(R?.apiNotebook)}async showNotebookDocument(a,d){y.URI.isUri(a)&&(a=await this.openNotebookDocument(a));let k;typeof d=="object"?k={position:S.ViewColumn.from(d.viewColumn),preserveFocus:d.preserveFocus,selections:d.selections&&d.selections.map(S.NotebookRange.from),pinned:typeof d.preview=="boolean"?!d.preview:void 0}:k={preserveFocus:!1};const R=await this.d.$tryShowNotebookDocument(a.uri,a.notebookType,k),v=R&&this.h.get(R)?.apiEditor;if(v)return v;throw R?new Error(`Could NOT open editor for "${a.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${a.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(a,d,k,R){const v=this.f.get(a),w=y.URI.revive(d),E=this.g.get(w);if(!E||!v)return;const P=E.getCellFromIndex(k);if(!P)return;const N=await v.provideCellStatusBarItems(P.apiCell,R);if(!N)return;const U=new I.$Sc,F=this.p.add([U]),T=(Array.isArray(N)?N:[N]).map(M=>S.NotebookStatusBarItem.from(M,this.i,U));return{cacheId:F,items:T}}$releaseNotebookCellStatusBarItems(a){this.p.delete(a)}registerNotebookSerializer(a,d,k,R,v){if((0,b.$Je)(d))throw new Error("viewType cannot be empty or just whitespace");const w=this.w++;return this.x.set(w,{viewType:d,serializer:k,options:R}),this.b.$registerNotebookSerializer(w,{id:a.identifier,location:a.extensionLocation},d,S.NotebookDocumentContentOptions.from(R),s.u(a,v)),(0,I.$Rc)(()=>{this.b.$unregisterNotebookSerializer(w)})}async $dataToNotebook(a,d,k){const R=this.x.get(a);if(!R)throw new Error("NO serializer found");const v=await R.serializer.deserializeNotebook(d.buffer,k);return new f.$Tv(S.NotebookData.from(v))}async $notebookToData(a,d,k){const R=this.x.get(a);if(!R)throw new Error("NO serializer found");const v=await R.serializer.serializeNotebook(S.NotebookData.to(d.value),k);return O.$je.wrap(v)}async $saveNotebook(a,d,k,R,v){const w=y.URI.revive(d),E=this.x.get(a);if(!E)throw new Error("NO serializer found");const P=this.g.get(w);if(!P)throw new Error("Document NOT found");if(P.versionId!==k)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(w.scheme))throw new L.$Lk((0,D.localize)(0,null,this.z(w)),6);await this.y(w,R);const N={metadata:(0,r.$Dn)(P.apiNotebook.metadata,M=>!(E.options?.transientDocumentMetadata??{})[M]),cells:[]};for(const M of P.apiNotebook.getCells()){const B=new h.$uM(M.kind,M.document.getText(),M.document.languageId,M.mime,E.options?.transientOutputs?[]:[...M.outputs],M.metadata,M.executionSummary);B.metadata=(0,r.$Dn)(M.metadata,Y=>!(E.options?.transientCellMetadata??{})[Y]),N.cells.push(B)}const U=await E.serializer.serializeNotebook(N,v);await this.s.value.writeFile(w,U);const F=this.s.getFileSystemProviderExtUri(w.scheme),j=await this.s.value.stat(w);return{name:F.basename(w),isFile:(j.type&L.FileType.File)!==0,isDirectory:(j.type&L.FileType.Directory)!==0,isSymbolicLink:(j.type&L.FileType.SymbolicLink)!==0,mtime:j.mtime,ctime:j.ctime,size:j.size,readonly:!!((j.permissions??0)&L.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(w.scheme),locked:!!((j.permissions??0)&L.FilePermission.Locked),etag:L.$Wk({mtime:j.mtime,size:j.size}),children:void 0}}async $searchInNotebooks(a,d,k,R,v){const w=this.x.get(a)?.serializer;if(!w)return{limitHit:!1,results:[]};const E=new A.$Bc;await(async(j,T,M)=>{await Promise.all(j.map(async B=>await Promise.all(B.filenamePatterns.map(Y=>{const ue={_reason:M._reason,folderQueries:M.folderQueries,includePattern:M.includePattern,excludePattern:M.excludePattern,maxResults:M.maxResults,type:1,filePattern:Y};return this.t.doInternalFileSearchWithCustomCallback(ue,T,Z=>{Z.forEach(J=>{E.has(J)||R.some(he=>B.isFromSettings&&!he.isFromSettings?!1:he.filenamePatterns.some(_=>(0,u.$fdb)(_,J)))||E.add(J)})})}))))})(k,v,d);const N=new A.$Ac;let U=!1;const F=Array.from(E).map(async j=>{const T=[];try{if(v.isCancellationRequested)return;if(d.maxResults&&[...N.values()].reduce((ue,Z)=>ue+Z.cellResults.length,0)>d.maxResults){U=!0;return}const M=[],B=this.g.get(j);if(B)B.apiNotebook.getCells().forEach(Z=>M.push({input:Z.document.getText(),outputs:Z.outputs.flatMap(J=>J.items.map(X=>X.data.toString()))}));else{const ue=await this.s.value.readFile(j),Z=O.$je.fromString(ue.toString()),J=await w.deserializeNotebook(Z.buffer,v);if(v.isCancellationRequested)return;S.NotebookData.from(J).cells.forEach(he=>M.push({input:he.source,outputs:he.outputs.flatMap(_=>_.items.map(we=>we.valueBytes.toString()))}))}if(v.isCancellationRequested)return;M.forEach((ue,Z)=>{const J=d.contentPattern.pattern,X=new c.$KQb(ue.input,void 0,ue.outputs),he=X.findInInputs(J),_=X.findInOutputs(J),we=_.flatMap(oe=>(0,t.$TJ)(oe.matches,oe.textBuffer)).map((oe,K)=>(oe.webviewIndex=K,oe));if(he.length>0||_.length>0){const oe={index:Z,contentResults:(0,t.$TJ)(he,X.inputTextBuffer),webviewResults:we};T.push(oe)}});const Y={resource:j,cellResults:T};N.set(j,Y);return}catch{return}});return await Promise.all(F),{limitHit:U,results:[...N.values()]}}async y(a,d){const k=await this.s.value.stat(a);if(typeof d?.mtime=="number"&&typeof d.etag=="string"&&d.etag!==L.$Vk&&typeof k.mtime=="number"&&typeof k.size=="number"&&d.mtime<k.mtime&&d.etag!==L.$Wk({mtime:d.mtime,size:k.size}))throw new L.$Lk((0,D.localize)(1,null),3,d)}z(a){return a.scheme===n.Schemas.file?a.fsPath:a.toString()}A(a,d,k){if(this.h.has(d))throw new Error(`editor with id ALREADY EXSIST: ${d}`);const R=new i.$nhc(d,this.d,a,k.visibleRanges.map(S.NotebookRange.to),k.selections.map(S.NotebookRange.to),typeof k.viewColumn=="number"?S.ViewColumn.to(k.viewColumn):void 0);this.h.set(d,R)}$acceptDocumentAndEditorsDelta(a){if(a.value.removedDocuments)for(const k of a.value.removedDocuments){const R=y.URI.revive(k),v=this.g.get(R);v&&(v.dispose(),this.g.delete(R),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:v.apiNotebook.getCells().map(w=>w.document.uri)}),this.n.fire(v.apiNotebook));for(const w of this.h.values())w.notebookData.uri.toString()===R.toString()&&this.h.delete(w.id)}if(a.value.addedDocuments){const k=[];for(const R of a.value.addedDocuments){const v=y.URI.revive(R.uri);if(this.g.has(v))throw new Error(`adding EXISTING notebook ${v} `);const w=new o.$mhc(this.c,this.q,this.r,v,R);k.push(...R.cells.map(E=>o.$lhc.asModelAddData(w.apiNotebook,E))),this.g.get(v)?.dispose(),this.g.set(v,w),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:k}),this.m.fire(w.apiNotebook)}}if(a.value.addedEditors)for(const k of a.value.addedEditors){if(this.h.has(k.id))return;const R=y.URI.revive(k.documentUri),v=this.g.get(R);v&&this.A(v,k.id,k)}const d=[];if(a.value.removedEditors)for(const k of a.value.removedEditors){const R=this.h.get(k);R&&(this.h.delete(k),this.k?.id===R.id&&(this.k=void 0),d.push(R))}if(a.value.visibleEditors){this.l=a.value.visibleEditors.map(R=>this.h.get(R)).filter(R=>!!R);const k=new Set;this.l.forEach(R=>k.add(R.id));for(const R of this.h.values()){const v=k.has(R.id);R._acceptVisibility(v)}this.l=[...this.h.values()].map(R=>R).filter(R=>R.visible),this.o.fire(this.visibleNotebookEditors)}a.value.newActiveEditor===null?this.k=void 0:a.value.newActiveEditor&&(this.h.get(a.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${a.value.newActiveEditor}`),this.k=this.h.get(a.value.newActiveEditor)),a.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(a){const d=p.$vN.String.with("notebookType","A notebook type"),k=new p.$xN("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[d,new p.$vN("data","Bytes to convert to data",v=>v instanceof Uint8Array,v=>O.$je.wrap(v))],new p.$wN("Notebook Data",v=>S.NotebookData.to(v.value))),R=new p.$xN("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[d,new p.$vN("NotebookData","Notebook data to convert to bytes",v=>!0,v=>new f.$Tv(S.NotebookData.from(v)))],new p.$wN("Bytes",v=>v.buffer));a.registerApiCommand(k),a.registerApiCommand(R)}}e.$whc=s}),define(ke[360],Se([1,0,16,21,44,34,23,38,36]),function(me,e,D,O,g,I,A,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ohc=void 0;class y{constructor(m,p,S){this.k=m,this.l=p,this.o=S,this.e=!1,this.f=0,this.g=!1,this.a=m.filePattern,this.b=m.includePattern&&I.$Mj(m.includePattern),this.c=m.maxResults||void 0,this.d=m.exists,this.h=new Set,this.j=m.excludePattern&&I.$Mj(m.excludePattern)}cancel(){this.g=!0,this.h.forEach(m=>m.cancel()),this.h=new Set}search(m){const p=this.k.folderQueries||[];return new Promise((S,h)=>{const f=o=>{this.f++,m(o)};if(this.g)return S({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(o=>{const i=o.toString(),r=D.$nc(i);this.j&&this.j(i,r)||this.v(f,{base:o,basename:r})}),Promise.all(p.map(o=>this.p(o,f))).then(o=>{S({limitHit:this.e,stats:o[0]||void 0})},o=>{h(new Error((0,g.$Qi)(o)))})})}async p(m,p){const S=new O.$6d,h=this.q(m),f=this.r(),o=new $.$JJ(this.k,m),i=!o.hasSiblingExcludeClauses();let r;try{this.h.add(S),r=b.$Rd.create();const n=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},h,S.token),c=r.elapsed(),t=b.$Rd.create();return this.g&&!this.e||(n&&n.forEach(u=>{const s=D.$gc.relative(m.folder.path,u.path);if(i){const l=D.$nc(u.path);this.v(p,{base:m.folder,relativePath:s,basename:l});return}this.s(f,m.folder,s,p)}),this.g&&!this.e)?null:(this.u(f,o,p),{providerTime:c,postProcessTime:t.elapsed()})}finally{S.dispose(),this.h.delete(S)}}q(m){const p=(0,$.$IJ)(this.k.includePattern,m.includePattern),S=(0,$.$IJ)(this.k.excludePattern,m.excludePattern);return{folder:m.folder,excludes:S,includes:p,useIgnoreFiles:!m.disregardIgnoreFiles,useGlobalIgnoreFiles:!m.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!m.disregardParentIgnoreFiles,followSymlinks:!m.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const m={rootEntries:[],pathToEntries:Object.create(null)};return m.pathToEntries["."]=m.rootEntries,m}s({pathToEntries:m},p,S,h){if(S===this.a){const o=D.$nc(this.a);this.v(h,{base:p,relativePath:this.a,basename:o})}function f(o){const i=D.$nc(o),r=D.$mc(o);let n=m[r];n||(n=m[r]=[],f(r)),n.push({base:p,relativePath:o,basename:i})}f(S)}u({rootEntries:m,pathToEntries:p},S,h){const f=this,o=this.a;function i(r){const n=(0,$.$LJ)(()=>r.map(c=>c.basename));for(let c=0,t=r.length;c<t;c++){const u=r[c],{relativePath:s,basename:l}=u;if(S.matchesExcludesSync(s,l,o!==l?n:void 0))continue;const a=p[s];if(a)i(a);else{if(s===o)continue;f.v(h,u)}if(f.e)break}}i(m)}v(m,p){(!this.b||p.relativePath&&this.b(p.relativePath,p.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||m(p))}}class L{constructor(){this.b=new Map}static{this.a=512}fileSearch(m,p,S,h){const f=this.c(m.cacheKey),o=new y(m,p,f&&f.token);let i=0;const r=n=>{i+=n.length,S(n.map(c=>this.d(c)))};return this.e(o,L.a,r,h).then(n=>({limitHit:n.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:i,detailStats:n.stats}}))}clearCache(m){this.c(m)?.cancel()}c(m){if(m)return this.b.has(m)||this.b.set(m,new O.$6d),this.b.get(m)}d(m){return m.relativePath?{resource:A.$Hg(m.base,m.relativePath)}:{resource:m.base}}e(m,p,S,h){const f=h.onCancellationRequested(()=>{m.cancel()}),o=r=>{r&&(i.push(r),p>0&&i.length>=p&&(S(i),i=[]))};let i=[];return m.search(o).then(r=>(i.length&&S(i),f.dispose(),r),r=>(i.length&&S(i),f.dispose(),Promise.reject(r)))}}e.$ohc=L}),define(ke[361],Se([1,0,19,73,34,102,28,17,16,23,12,18,2,99,235,51,13,40,143,356,36]),function(me,e,D,O,g,I,A,b,$,y,L,C,m,p,S,h,f,o,i,r,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KK=e.$JK=void 0;let c=class{constructor(w,E,P,N,U){this.a=w,this.b=E,this.c=P,this.d=N,this.e=U}text(w,E,P={}){w=this.f(w,P);const N=this.a.getValue(),U=E&&E.some(j=>!this.a.getValue({resource:j}).search.useRipgrep);return{...this.h(E?.map(o.$oi),P),type:2,contentPattern:w,previewOptions:P.previewOptions,maxFileSize:P.maxFileSize,usePCRE2:N.search.usePCRE2||U||!1,beforeContext:P.beforeContext,afterContext:P.afterContext,userDisabledExcludesAndIgnoreFiles:P.disregardExcludeSettings&&P.disregardIgnoreFiles}}f(w,E){const P=this.a.getValue();w.isRegExp&&(w.pattern=w.pattern.replace(/\r?\n/g,"\\n"));const N={...w,wordSeparators:P.editor.wordSeparators};return this.j(w,E)&&(N.isCaseSensitive=!0),this.k(w)&&(N.isMultiline=!0),E.notebookSearchConfig?.includeMarkupInput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookMarkdownInput=E.notebookSearchConfig.includeMarkupInput),E.notebookSearchConfig?.includeMarkupPreview&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookMarkdownPreview=E.notebookSearchConfig.includeMarkupPreview),E.notebookSearchConfig?.includeCodeInput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookCellInput=E.notebookSearchConfig.includeCodeInput),E.notebookSearchConfig?.includeOutput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookCellOutput=E.notebookSearchConfig.includeOutput),N}file(w,E={}){return{...this.h(w,E),type:1,filePattern:E.filePattern?E.filePattern.trim():E.filePattern,exists:E.exists,sortByScore:E.sortByScore,cacheKey:E.cacheKey}}g(w,E){return w?(w=Array.isArray(w)?w.map(a):a(w),E?this.parseSearchPaths(w):{pattern:u(...Array.isArray(w)?w:[w])}):{}}h(w=[],E={}){const P=this.g(E.includePattern,E.expandPatterns),N=this.g(E.excludePattern,E.expandPatterns),U=w.length>1,F=(P.searchPaths&&P.searchPaths.length?P.searchPaths.map(M=>this.q(M,E,N)):w.map(M=>this.r(M,E,N,U))).filter(M=>!!M),j={_reason:E._reason,folderQueries:F,usingSearchPaths:!!(P.searchPaths&&P.searchPaths.length),extraFileResources:E.extraFileResources,excludePattern:N.pattern,includePattern:P.pattern,onlyOpenEditors:E.onlyOpenEditors,maxResults:E.maxResults};if(E.onlyOpenEditors){const M=D.$Hb(D.$Rb(this.c.groups.map(ue=>ue.editors.map(Z=>Z.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(M));const B=M.filter(ue=>(0,n.$zJ)(j,ue.fsPath)),Y=this.i(B);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(Y)),{...j,...Y}}const T=E.extraFileResources&&E.extraFileResources.filter(M=>(0,n.$zJ)(j,M.fsPath));return j.extraFileResources=T&&T.length?T:void 0,j}i(w){const E=[],P=new A.$Ac,N={};let U=!1;return w.forEach(F=>{if(F.scheme===b.Schemas.walkThrough)return;if((0,y.$Lg)(F)){const T=this.b.getWorkspaceFolder(F)?.uri??F.with({path:$.$mc(F.fsPath)});let M=P.get(T);M||(U=!0,M={folder:T,includePattern:{}},E.push(M),P.set(T,M));const B=$.$lc(T.fsPath,F.fsPath);(0,C.$Tf)(M.includePattern)[B.replace(/\\/g,"/")]=!0}else F.fsPath&&(U=!0,N[F.fsPath]=!0)}),{folderQueries:E,includePattern:N,usingSearchPaths:!0,excludePattern:U?void 0:{"**/*":!0}}}j(w,E){if(E.isSmartCase){if(w.isRegExp){if(L.$zf(w.pattern,!0))return!0}else if(L.$zf(w.pattern))return!0}return!!w.isCaseSensitive}k(w){return w.isMultiline||w.isRegExp&&(0,p.$4B)(w.pattern)||w.pattern.indexOf(`
`)>=0?!0:!!w.isMultiline}parseSearchPaths(w){const E=Y=>$.$ic(Y)||/^\.\.?([\/\\]|$)/.test(Y),N=(Array.isArray(w)?w:s(w)).map(Y=>{const ue=this.e.resolvedUserHome;return ue?(0,I.$Yv)(Y,ue.scheme===b.Schemas.file?ue.fsPath:ue.path):Y}),U=O.$K(N,Y=>E(Y)?"searchPaths":"exprSegments"),F=(U.exprSegments||[]).map(Y=>L.$Ue(Y,"/")).map(Y=>L.$Ue(Y,"\\")).map(Y=>(Y[0]==="."&&(Y="*"+Y),l(Y))),j={},T=this.m(U.searchPaths||[]);T&&T.length&&(j.searchPaths=T);const M=D.$Rb(F),B=u(...M);return B&&(j.pattern=B),j}l(w,E){return E.disregardExcludeSettings?void 0:(0,n.$yJ)(w,!E.disregardSearchExcludeSettings)}m(w){if(!w||!w.length)return[];const E=w.flatMap(N=>{let{pathPortion:U,globPortion:F}=t(N);return F&&(F=d(F)),this.n(U).flatMap(T=>this.o(T,F))}),P=new Map;return E.forEach(N=>{const U=N.searchPath.toString(),F=P.get(U);F?N.pattern&&(F.pattern=F.pattern||{},F.pattern[N.pattern]=!0):P.set(U,{searchPath:N.searchPath,pattern:N.pattern?u(N.pattern):void 0})}),Array.from(P.values())}n(w){if($.$ic(w)){const E=this.b.getWorkspace().folders;return E[0]&&E[0].uri.scheme!==b.Schemas.file?[{searchPath:E[0].uri.with({path:w})}]:[{searchPath:m.URI.file($.$hc(w))}]}if(this.b.getWorkbenchState()===2){const E=this.b.getWorkspace().folders[0].uri;if(w=a(w),w.startsWith("../")||w===".."){const N=$.$gc.resolve(E.path,w);return[{searchPath:E.with({path:N})}]}const P=d(w);return[{searchPath:E,pattern:P}]}else{if(w==="./"||w===".\\")return[];{const E=w.replace(/^\.[\/\\]/,""),N=this.b.getWorkspace().folders.map(U=>{const F=E.match(new RegExp(`^${L.$Oe(U.name)}(?:/(.*)|$)`));return F?{match:F,folder:U}:null}).filter(C.$Qf);if(N.length)return N.map(U=>{const F=U.match[1];return{searchPath:U.folder.uri,pattern:F&&d(F)}});{const U=w.match(/\.[\/\\](.+)[\/\\]?/),F=U?U[1]:w,j=S.localize(0,null,F);throw new Error(j)}}}}o(w,E){const P=w.pattern&&E?`${w.pattern}/${E}`:w.pattern||E,N=[{searchPath:w.searchPath,pattern:P}];return P&&!P.endsWith("**")&&N.push({searchPath:w.searchPath,pattern:P+"/**"}),N}q(w,E,P){const N=this.r((0,o.$oi)(w.searchPath),E,P,!1);return N?{...N,includePattern:w.pattern}:null}r(w,E,P,N){let U;const F=m.URI.isUri(w)?w:w.uri;if(P.searchPaths){const Y=P.searchPaths.filter(ue=>(0,y.$Ag)(ue.searchPath,F))[0];if(Y&&!Y.pattern)return null;Y&&(U=Y.pattern)}const j=this.a.getValue({resource:F}),M={...this.l(j,E)||{},...U||{}},B=m.URI.isUri(w)?(0,y.$Eg)(w):w.name;return{folder:F,folderName:N?B:void 0,excludePattern:Object.keys(M).length>0?M:void 0,fileEncoding:j.files&&j.files.encoding,disregardIgnoreFiles:typeof E.disregardIgnoreFiles=="boolean"?E.disregardIgnoreFiles:!j.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof E.disregardGlobalIgnoreFiles=="boolean"?E.disregardGlobalIgnoreFiles:!j.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof E.disregardParentIgnoreFiles=="boolean"?E.disregardParentIgnoreFiles:!j.search.useParentIgnoreFiles,ignoreSymlinks:typeof E.ignoreSymlinks=="boolean"?E.ignoreSymlinks:!j.search.followSymlinks}}};e.$JK=c,e.$JK=c=Ge([We(0,h.$zi),We(1,o.$ci),We(2,i.$9C),We(3,f.$nj),We(4,r.$HK)],c);function t(v){const w=v.match(/[\*\{\}\(\)\[\]\?]/);if(w){const E=w.index,P=v.substr(0,E).match(/[/|\\][^/\\]*$/);if(P){let N=v.substr(0,P.index);return N.match(/[/\\]/)||(N+="/"),{pathPortion:N,globPortion:v.substr((P.index||0)+1)}}}return{pathPortion:v}}function u(...v){return v.length?v.reduce((w,E)=>(w[E]=!0,w),Object.create(null)):void 0}function s(v){return g.$Kj(v,",").map(w=>w.trim()).filter(w=>!!w.length)}function l(v){return[`**/${v}/**`,`**/${v}`].map(E=>E.replace(/\*\*\/\*\*/g,"**"))}function a(v){return v.replace(/\\/g,"/")}function d(v){return a(v).replace(/^\.\//,"").replace(/\/+$/g,"")}function k(v){return v.replace(/([?*[\]])/g,"[$1]")}function R(v,w){v=D.$Mb(v,N=>N.toString());const E=[],P=w.getWorkspace();return v&&v.forEach(N=>{let U;if(w.getWorkbenchState()===2)U=(0,y.$Jg)(P.folders[0].uri,N),U&&U!=="."&&(U="./"+U);else{const F=w.getWorkspaceFolder(N);if(F){const j=F.name;if(P.folders.filter(M=>M.name===j).length===1){const M=(0,y.$Jg)(F.uri,N);M===""?U=`./${F.name}`:U=`./${F.name}/${M}`}else U=N.fsPath}}U&&E.push(k(U))}),E}e.$KK=R}),define(ke[362],Se([1,0,23,2,21,14,5,361,36,40]),function(me,e,D,O,g,I,A,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rsb=e.$qsb=void 0;const L=7e3;function C(h,f){const o=f.activationEvents;if(!o)return Promise.resolve(void 0);const i=[],r=[];for(const l of o)if(/^workspaceContains:/.test(l)){const a=l.substr(18);a.indexOf("*")>=0||a.indexOf("?")>=0||h.forceUsingSearch?r.push(a):i.push(a)}if(i.length===0&&r.length===0)return Promise.resolve(void 0);let n;const c=new Promise((l,a)=>{n=l}),t=l=>n({activationEvent:l}),u=Promise.all(i.map(l=>m(h,l,t))).then(()=>{}),s=p(h,f.identifier,r,t);return Promise.all([u,s]).then(()=>{n(void 0)}),c}e.$qsb=C;async function m(h,f,o){for(const i of h.folders)if(await h.exists(D.$Hg(O.URI.revive(i),f))){o(`workspaceContains:${f}`);return}}async function p(h,f,o,i){if(o.length===0)return Promise.resolve(void 0);const r=new g.$6d,n=h.checkExists(h.folders,o,r.token),c=setTimeout(async()=>{r.cancel(),h.logService.info(`Not activating extension '${f.value}': Timed out while searching for 'workspaceContains' pattern ${o.join(",")}`)},L);let t=!1;try{t=await n}catch(u){I.$4(u)||I.$1(u)}r.dispose(),clearTimeout(c),t&&i(`workspaceContains:${o.join(",")}`)}function S(h,f,o,i){const r=h.get(A.$5h),n=h.get($.$qJ),t=r.createInstance(b.$JK).file(f.map(u=>(0,y.$oi)(O.URI.revive(u))),{_reason:"checkExists",includePattern:o,exists:!0});return n.fileSearch(t,i).then(u=>!!u.limitHit,u=>I.$4(u)?!1:Promise.reject(u))}e.$rsb=S}),define(ke[47],Se([1,0,212,16,57,23,11,3,77,2,13,6,42,292,118,41,25,145,14,26,22,271,7,64,5,27,92,20,107,72,46,4,362,117,273,17,115,38,10,116]),function(me,e,D,O,g,I,A,b,$,y,L,C,m,p,S,h,f,o,i,r,n,c,t,u,s,l,a,d,k,R,v,w,E,P,N,U,F,j,T,M){"use strict";var B;Object.defineProperty(e,"__esModule",{value:!0}),e.$7gc=e.$6gc=e.$5gc=e.$4gc=e.$3gc=void 0,e.$3gc=(0,s.$6h)("IHostUtils");let Y=B=class extends b.$Tc{constructor(K,W,re,ye,de,ge,x,te,G,ie,fe,pe){super(),this.X=pe,this.a=this.B(new w.$Vd),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=W,this.g=re,this.f=x,this.j=ye,this.m=de,this.s=ge,this.t=G,this.u=ie,this.w=fe,this.y=this.g.getProxy(C.$6K.MainThreadWorkspace),this.z=this.g.getProxy(C.$6K.MainThreadTelemetry),this.C=this.g.getProxy(C.$6K.MainThreadExtensionService),this.D=new A.$5g,this.F=new A.$5g,this.G=new A.$5g,this.H=new A.$5g,this.I=new we(this.f.extensions.activationEvents),this.L=new o.$h8b(this.I,this.f.extensions.allExtensions);const Pe=new r.$mm(this.f.extensions.myExtensions);this.J=new o.$h8b(this.I,he(this.L,Pe)),T.$t&&(this.s.info(`Creating extension host with the following global extensions: ${J(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${J(this.J)}`)),this.M=new S.$Ngc(this.g,this.s),this.N=new P.$Vgc(this.g),this.O=te,this.h=K.createChild(new k.$4h([S.$Ogc,this.M],[P.$Wgc,this.N])),this.P=this.B(new p.$Mgc(this.J,this.L,{onExtensionActivationError:(be,De,z)=>{this.C.$onExtensionActivationError(be,i.$3(De),z)},actualActivateExtension:async(be,De)=>{if(o.$h8b.isHostExtension(be,this.J,this.L))return await this.C.$activateExtension(be,De),new p.$Lgc;const z=this.J.getExtensionDescription(be);return this.db(z,De)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),g.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(K){i.$1(K)}}async Y(){this.O.onWillDeactivateAll();let K=[];try{K=this.J.getAllExtensionDescriptions().map(de=>de.identifier).filter(de=>this.isActivated(de)).map(de=>this.cb(de))}catch{}await Promise.all(K)}terminate(K,W=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${K}`),this.s.flush(),this.u.dispose(),this.P.dispose(),i.setUnexpectedErrorHandler(ye=>{this.s.error(ye)}),this.g.dispose();const re=this.Y();Promise.race([(0,A.$7g)(5e3),re]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${W}`):this.s.info(`Extension host exiting with code ${W}`),this.s.flush(),this.s.dispose(),this.c.exit(W)})}isActivated(K){return this.G.isOpen()?this.P.isActivated(K):!1}async getExtension(K){const W=await this.C.$getExtension(K);return W&&{...W,identifier:new r.$lm(W.identifier.value),extensionLocation:y.URI.revive(W.extensionLocation)}}Z(K,W){return this.P.activateByEvent(K,W)}$(K,W){return this.P.activateById(K,W)}activateByIdWithErrors(K,W){return this.$(K,W).then(()=>{const re=this.P.getActivatedExtension(K);if(re.activationFailed)return Promise.reject(re.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(K=>this.J)}getExtensionExports(K){if(this.G.isOpen())return this.P.getActivatedExtension(K).exports;try{return this.P.getActivatedExtension(K).exports}catch{return null}}async ab(K){if(K.scheme===U.Schemas.file&&this.c.fsRealpath){const W=await this.c.fsRealpath(K.fsPath);return y.URI.file(W)}return K}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(K=>new _(K))),this.Q}async bb(K){const W=$.$_h.forUris(re=>I.$yg.ignorePathCasing(re));return await Promise.all(K.map(async re=>{if(this.ub(re)){const ye=await this.ab(re.extensionLocation);W.set(ye,re)}})),W}cb(K){let W=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(K))return W;const re=this.P.getActivatedExtension(K);if(!re)return W;try{typeof re.module.deactivate=="function"&&(W=Promise.resolve(re.module.deactivate()).then(void 0,ye=>(this.s.error(ye),Promise.resolve(void 0))))}catch(ye){this.s.error(`An error occurred when deactivating the extension '${K.value}':`),this.s.error(ye)}try{(0,b.$Oc)(re.subscriptions)}catch(ye){this.s.error(`An error occurred when deactivating the subscriptions for extension '${K.value}':`),this.s.error(ye)}return W}async db(K,W){return this.f.remote.isRemote?this.C.$onWillActivateExtension(K.identifier):await this.C.$onWillActivateExtension(K.identifier),this.fb(K,W).then(re=>{const ye=re.activationTimes;return this.C.$onDidActivateExtension(K.identifier,ye.codeLoadingTime,ye.activateCallTime,ye.activateResolvedTime,W),this.eb(K,W,"success",ye),re},re=>{throw this.eb(K,W,"failure"),re})}eb(K,W,re,ye){const de=Z(K,W);this.z.$publicLog2("extensionActivationTimes",{...de,...ye||{},outcome:re})}fb(K,W){const re=Z(K,W);this.z.$publicLog2("activatePlugin",re);const ye=this.ub(K);if(!ye)return Promise.resolve(new p.$Kgc(p.$Hgc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${K.identifier.value}, startup: ${W.startup}, activationEvent: '${W.activationEvent}'${K.identifier.value!==W.extensionId.value?`, root cause: ${W.extensionId.value}`:""}`),this.s.flush();const de=new p.$Igc(W.startup);return Promise.all([this.vb(K,(0,I.$Hg)(K.extensionLocation,ye),de),this.gb(K)]).then(ge=>(g.mark(`code/extHost/willActivateExtension/${K.identifier.value}`),B.hb(this.s,K.identifier,ge[0],ge[1],de))).then(ge=>(g.mark(`code/extHost/didActivateExtension/${K.identifier.value}`),ge))}gb(K){const W=new c.$Qgc(K,this.M),re=new c.$Pgc(K.identifier.value,!1,this.M),ye=new N.$Xgc(K,this.N),de=K.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,ge=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${K.identifier.value}`),Promise.all([W.whenReady,re.whenReady,this.O.whenReady]).then(()=>{const x=this;let te,G;const ie=(0,f.$BF)(K,"ipc")?this.f.messagePorts?.get(r.$lm.toKey(K.identifier)):void 0;return Object.freeze({globalState:W,workspaceState:re,secrets:ye,subscriptions:[],get extensionUri(){return K.extensionLocation},get extensionPath(){return K.extensionLocation.fsPath},asAbsolutePath(fe){return O.$jc(K.extensionLocation.fsPath,fe)},get storagePath(){return x.O.workspaceValue(K)?.fsPath},get globalStoragePath(){return x.O.globalValue(K).fsPath},get logPath(){return O.$jc(x.f.logsLocation.fsPath,K.identifier.value)},get logUri(){return y.URI.joinPath(x.f.logsLocation,K.identifier.value)},get storageUri(){return x.O.workspaceValue(K)},get globalStorageUri(){return x.O.globalValue(K)},get extensionMode(){return de},get extension(){return te===void 0&&(te=new X(x,K.identifier,K,ge,!1)),te},get extensionRuntime(){return(0,f.$CF)(K,"extensionRuntime"),x.extensionRuntime},get environmentVariableCollection(){return x.u.getEnvironmentVariableCollection(K)},get messagePassingProtocol(){if(!G){if(!ie)return;const fe=w.Event.buffer(w.Event.fromDOMEventEmitter(ie,"message",pe=>pe.data));ie.start(),G={onDidReceiveMessage:fe,postMessage:ie.postMessage.bind(ie)}}return G}})})}static hb(K,W,re,ye,de){return re=re||{activate:void 0,deactivate:void 0},this.ib(K,W,re,ye,de).then(ge=>new p.$Jgc(!1,null,de.build(),re,ge,ye.subscriptions))}static ib(K,W,re,ye,de){if(typeof re.activate=="function")try{de.activateCallStart(),K.trace(`ExtensionService#_callActivateOptional ${W.value}`);const ge=typeof global=="object"?global:self,x=re.activate.apply(ge,[ye]);return de.activateCallStop(),de.activateResolveStart(),Promise.resolve(x).then(te=>(de.activateResolveStop(),te))}catch(ge){return Promise.reject(ge)}else return Promise.resolve(re)}jb(K,W){this.$(K.identifier,{startup:!1,extensionId:K.identifier,activationEvent:W}).then(void 0,re=>{this.s.error(re)})}kb(K,W=0){const ye=Date.now();(0,T.$B)(()=>{for(let de=W;de<K.length;de+=1){const ge=K[de];for(const x of ge.activationEvents??[])if(x==="onStartupFinished")if(Date.now()-ye>50){this.kb(K,de);break}else this.jb(ge,x)}})}lb(){this.C.$setPerformanceMarks(g.getMarks()),this.m.getConfigProvider().then(K=>{const W=K.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),re=this.J.getAllExtensionDescriptions();if(W)this.kb(re);else for(const ye of re)if(ye.activationEvents)for(const de of ye.activationEvents)de==="onStartupFinished"&&this.jb(ye,de)})}mb(){const K=this.Z("*",!0).then(void 0,ge=>{this.s.error(ge)});this.B(this.j.onDidChangeWorkspace(ge=>this.nb(ge.added)));const W=this.j.workspace?this.j.workspace.folders:[],re=this.nb(W),ye=this.pb(),de=Promise.all([ye,K,re]).then(()=>{});return Promise.race([de,(0,A.$7g)(1e4)]).then(()=>{this.lb()}),de}nb(K){return K.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(W=>this.ob(K,W))).then(()=>{})}async ob(K,W){if(this.isActivated(W.identifier))return;const re=!this.f.remote.isRemote&&!!this.f.remote.authority,ye={logService:this.s,folders:K.map(ge=>ge.uri),forceUsingSearch:re||!this.c.fsExists,exists:ge=>this.c.fsExists(ge.fsPath),checkExists:(ge,x,te)=>this.y.$checkExists(ge,x,te)},de=await(0,E.$qsb)(ye,W);if(de)return this.$(W.identifier,{startup:!0,extensionId:W.identifier,activationEvent:de.activationEvent}).then(void 0,ge=>this.s.error(ge))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(K){throw console.error(K),K}}async qb(){const{extensionDevelopmentLocationURI:K,extensionTestsLocationURI:W}=this.f.environment;if(!K||!W)throw new Error(D.localize(0,null));const re=await this.vb(null,W,new p.$Igc(!1));if(!re||typeof re.run!="function")throw new Error(D.localize(1,null,W.toString()));return new Promise((ye,de)=>{const ge=(G,ie)=>{G?(T.$t&&this.s.error("Test runner called back with error",G),de(G)):(T.$t&&(ie?this.s.info(`Test runner called back with ${ie} failures.`):this.s.info("Test runner called back with successful outcome.")),ye(typeof ie=="number"&&ie>0?1:0))},x=(0,I.$vg)(W),te=re.run(x,ge);te&&te.then&&te.then(()=>{T.$t&&this.s.info("Test runner finished successfully."),ye(0)}).catch(G=>{T.$t&&this.s.error("Test runner finished with error",G),de(G instanceof Error&&G.stack?G.stack:String(G))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,A.$7g)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(K,W){return this.R[K]=W,(0,b.$Rc)(()=>{delete this.R[K]})}async getRemoteExecServer(K){const{resolver:W}=await this.sb(K);return W?.resolveExecServer?.(K,{resolveAttempt:0})}async sb(K){const W=K.indexOf("+");if(W===-1)throw new t.$bL("Not an authority that can be resolved!",u.RemoteAuthorityResolverErrorCode.InvalidAuthority);const re=K.substr(0,W);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${re}`,!1),{authorityPrefix:re,resolver:this.R[re]}}async $resolveAuthority(K,W){const re=j.$Rd.create(!1),ye=()=>`[resolveAuthority(${(0,u.$_k)(K)},${W})][${re.elapsed()}ms] `,de=ee=>this.s.info(`${ye()}${ee}`),ge=ee=>this.s.warn(`${ye()}${ee}`),x=(ee,q=void 0)=>this.s.error(`${ye()}${ee}`,q),te=ee=>{if(ee instanceof t.$bL)return{type:"error",error:{code:ee._code,message:ee._message,detail:ee._detail}};throw ee},G=async ee=>{de(`activating resolver for ${ee}...`);const{resolver:q,authorityPrefix:ae}=await this.sb(ee);if(!q)throw x(`no resolver for ${ae}`),new t.$bL(`No remote extension installed to resolve ${ae}.`,u.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:q,authorityPrefix:ae,remoteAuthority:ee}},ie=K.split(/@|%40/g).reverse();de(`activating remote resolvers ${ie.join(" -> ")}`);let fe;try{fe=await Promise.all(ie.map(G)).catch(async ee=>{if(!(ee instanceof t.$bL)||ee._code!==u.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw ee;return ge(`resolving nested authorities failed: ${ee.message}`),[await G(K)]})}catch(ee){return te(ee)}const pe=new A.$eh;pe.cancelAndSet(()=>de("waiting..."),1e3);let Pe,be;for(const[ee,{authorityPrefix:q,resolver:ae,remoteAuthority:le}]of fe.entries())try{if(ee===fe.length-1)de("invoking final resolve()..."),g.mark(`code/extHost/willResolveAuthority/${q}`),Pe=await ae.resolve(le,{resolveAttempt:W,execServer:be}),g.mark(`code/extHost/didResolveAuthorityOK/${q}`),de("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(ae,t.$aL.isManagedResolvedAuthority(Pe)?Pe:void 0));else{if(de(`invoking resolveExecServer() for ${le}`),g.mark(`code/extHost/willResolveExecServer/${q}`),be=await ae.resolveExecServer?.(le,{resolveAttempt:W,execServer:be}),!be)throw new t.$bL(`Exec server was not available for ${le}`,u.RemoteAuthorityResolverErrorCode.NoResolverFound);g.mark(`code/extHost/didResolveExecServerOK/${q}`)}}catch(Le){return g.mark(`code/extHost/didResolveAuthorityError/${q}`),x("returned an error",Le),pe.dispose(),te(Le)}pe.dispose();const De={environmentTunnels:Pe.environmentTunnels,features:Pe.tunnelFeatures?{elevation:Pe.tunnelFeatures.elevation,privacyOptions:Pe.tunnelFeatures.privacyOptions,protocol:Pe.tunnelFeatures.protocol===void 0?!0:Pe.tunnelFeatures.protocol}:void 0},z={extensionHostEnv:Pe.extensionHostEnv,isTrusted:Pe.isTrusted,authenticationSession:Pe.authenticationSessionForInitializingExtensions?{id:Pe.authenticationSessionForInitializingExtensions.id,providerId:Pe.authenticationSessionForInitializingExtensions.providerId}:void 0};de(`returned ${t.$aL.isManagedResolvedAuthority(Pe)?"managed authority":`${Pe.host}:${Pe.port}`}`);let Q;if(t.$aL.isManagedResolvedAuthority(Pe)){const ee=W;this.X.setFactory(ee,Pe.makeConnection),Q={authority:K,connectTo:new u.$9k(ee),connectionToken:Pe.connectionToken}}else Q={authority:K,connectTo:new u.$0k(Pe.host,Pe.port),connectionToken:Pe.connectionToken};return{type:"ok",value:{authority:Q,options:z,tunnelInformation:De}}}async $getCanonicalURI(K,W){this.s.info(`$getCanonicalURI invoked for authority (${(0,u.$_k)(K)})`);const{resolver:re}=await this.sb(K);if(!re)return null;const ye=y.URI.revive(W);if(typeof re.getCanonicalURI>"u")return ye;const de=await(0,A.$Yg)(()=>re.getCanonicalURI(ye));return de||ye}$startExtensionHost(K){K.toAdd.forEach(ye=>ye.extensionLocation=y.URI.revive(ye.extensionLocation));const{globalRegistry:W,myExtensions:re}=ue(this.I,this.L,this.J,K);return this.L.set(W.getAllExtensionDescriptions()),this.J.set(re),T.$t&&(this.s.info(`$startExtensionHost: global extensions: ${J(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${J(this.J)}`)),this.rb()}$activateByEvent(K,W){return W===1?this.D.wait().then(re=>this.Z(K,!1)):this.G.wait().then(re=>this.Z(K,!1))}async $activate(K,W){return await this.G.wait(),this.J.getExtensionDescription(K)?(await this.$(K,W),!0):!1}async $deltaExtensions(K){K.toAdd.forEach(ge=>ge.extensionLocation=y.URI.revive(ge.extensionLocation));const{globalRegistry:W,myExtensions:re}=ue(this.I,this.L,this.J,K),ye=await this.bb(re);return(await this.getExtensionPathIndex()).setSearchTree(ye),this.L.set(W.getAllExtensionDescriptions()),this.J.set(re),T.$t&&(this.s.info(`$deltaExtensions: global extensions: ${J(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${J(this.J)}`)),Promise.resolve(void 0)}async $test_latency(K){return K}async $test_up(K){return K.byteLength}async $test_down(K){const W=n.$je.alloc(K),re=Math.random()%256;for(let ye=0;ye<K;ye++)W.writeUInt8(re,ye);return W}async $updateRemoteConnectionData(K){this.W=K,this.a.fire()}};e.$4gc=Y,e.$4gc=Y=B=Ge([We(0,s.$5h),We(1,e.$3gc),We(2,d.$0M),We(3,h.$qgc),We(4,m.$tgc),We(5,L.$nj),We(6,l.$nN),We(7,a.$wgc),We(8,R.$oyb),We(9,v.$Rgc),We(10,F.$Zgc),We(11,M.$1gc)],Y);function ue(oe,K,W,re){oe.addActivationEvents(re.addActivationEvents);const ye=new o.$h8b(oe,K.getAllExtensionDescriptions());ye.deltaExtensions(re.toAdd,re.toRemove);const de=new r.$mm(W.getAllExtensionDescriptions().map(x=>x.identifier));for(const x of re.myToRemove)de.delete(x);for(const x of re.myToAdd)de.add(x);const ge=he(ye,de);return{globalRegistry:ye,myExtensions:ge}}function Z(oe,K){return{id:oe.identifier.value,name:oe.name,extensionVersion:oe.version,publisherDisplayName:oe.publisher,activationEvents:oe.activationEvents?oe.activationEvents.join(","):null,isBuiltin:oe.isBuiltin,reason:K.activationEvent,reasonId:K.extensionId.value}}function J(oe){return oe.getAllExtensionDescriptions().map(K=>K.identifier.value).join(",")}e.$5gc=(0,s.$6h)("IExtHostExtensionService");class X{#e;#t;#i;constructor(K,W,re,ye,de){this.#e=K,this.#t=W,this.#i=re.identifier,this.id=re.identifier.value,this.extensionUri=re.extensionLocation,this.extensionPath=O.$hc((0,I.$vg)(re.extensionLocation)),this.packageJSON=re,this.extensionKind=ye,this.isFromDifferentExtensionHost=de}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$6gc=X;function he(oe,K){return oe.getAllExtensionDescriptions().filter(W=>K.has(W.identifier))}class _{constructor(K){this.a=K}setSearchTree(K){this.a=K}findSubstr(K){return this.a.findSubstr(K)}forEach(K){return this.a.forEach(K)}}e.$7gc=_;class we{constructor(K){this.a=new r.$nm,this.addActivationEvents(K)}readActivationEvents(K){return this.a.get(K.identifier)??[]}addActivationEvents(K){for(const W of Object.keys(K))this.a.set(W,K[W])}}}),define(ke[363],Se([1,0,57,2,6,42,25,26,20,27,5,47,13,12]),function(me,e,D,O,g,I,A,b,$,y,L,C,m,p){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$cic=void 0;let h=class{constructor(n,c,t,u,s,l,a){this.c=n,this.d=c,this.e=t,this.f=u,this.g=s,this.h=l,this.i=a,this.a=new Map,this.b=[]}async install(){this.j(),D.mark("code/extHost/willWaitForConfig");const n=await this.f.getConfigProvider();D.mark("code/extHost/didWaitForConfig");const c=await this.g.getExtensionPathIndex();this.register(new o(this.c,c,this.d,n,this.i)),this.register(this.e.createInstance(f)),this.h.remote.isRemote&&this.register(this.e.createInstance(i,c,this.h.environment.appUriScheme))}register(n){if("nodeModuleName"in n)if(Array.isArray(n.nodeModuleName))for(const c of n.nodeModuleName)this.a.set(c,n);else this.a.set(n.nodeModuleName,n);typeof n.alternativeModuleName=="function"&&this.b.push(c=>n.alternativeModuleName(c))}};e.$cic=h,e.$cic=h=Ge([We(2,L.$5h),We(3,I.$tgc),We(4,C.$5gc),We(5,y.$nN),We(6,m.$nj)],h);let f=class{static{S=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(n){if(n.environment.appRoot&&S.a.size){const c=(0,p.$Oe)(this.c(n.environment.appRoot.fsPath)),t="[a-z0-9_.-]",u=`@${t}+\\/${t}+|${t}+`,s="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${c}/${s}\\/)(${u})(.*)$`,"i")}}alternativeModuleName(n){if(!this.b)return;const c=this.b.exec(this.c(n));if(!c)return;const[,t,u,s]=c,l=S.a.get(u);if(l!==void 0)return console.warn(`${u} as been renamed to ${l}, please update your imports`),t+l+s}c(n){return n.replace(/\\/g,"/")}};f=S=Ge([We(0,y.$nN)],f);class o{constructor(n,c,t,u,s){this.c=n,this.d=c,this.e=t,this.f=u,this.g=s,this.nodeModuleName="vscode",this.a=new b.$nm}load(n,c){const t=this.d.findSubstr(c);if(t){let u=this.a.get(t.identifier);return u||(u=this.c(t,this.e,this.f),this.a.set(t.identifier,u)),u}if(!this.b){let u="";this.d.forEach((s,l)=>u+=`	${l} -> ${s.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${c}. These are the extension path mappings: 
${u}`),this.b=this.c(A.$wF,this.e,this.f)}return this.b}}let i=class{constructor(n,c,t){this.e=n,this.f=c,this.nodeModuleName=["open","opn"],this.d=t.getProxy(g.$6K.MainThreadTelemetry);const u=t.getProxy(g.$6K.MainThreadWindow);this.c=(s,l)=>{const a=O.URI.parse(s);return l?this.g(s,l):a.scheme==="http"||a.scheme==="https"?u.$openUri(a,s,{allowTunneling:!0}):a.scheme==="mailto"||a.scheme===this.f?u.$openUri(a,s,{}):this.g(s,l)}}load(n,c,t){const u=this.e.findSubstr(c);return u&&(this.a=u.identifier.value,this.h()),this.b=t(n),this.c}g(n,c){return this.i(),this.b(n,c)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};i=Ge([We(2,$.$0M)],i)}),define(ke[59],Se([1,0,43,3,16,49,5,69,70,47,7,41,289,42]),function(me,e,D,O,g,I,A,b,$,y,L,C,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9gc=e.$8gc=void 0,e.$8gc=(0,A.$6h)("IExtHostVariableResolverProvider");class S extends m.$$N{constructor(o,i,r,n,c,t,u){function s(){if(r){const l=r.activeEditor();if(l)return l.document.uri;const a=n.tabGroups.all.find(d=>d.isActive)?.activeTab;if(a!==void 0){if(a.input instanceof L.$OM||a.input instanceof L.$TM)return a.input.modified;if(a.input instanceof L.$NM||a.input instanceof L.$SM||a.input instanceof L.$QM)return a.input.uri}}}super({getFolderUri:l=>{const a=t.folders.filter(d=>d.name===l);if(a&&a.length>0)return a[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(l,a)=>c.getConfiguration(void 0,l).get(a),getAppRoot:()=>I.cwd(),getExecPath:()=>I.env.VSCODE_EXEC_PATH,getFilePath:()=>{const l=s();if(l)return g.$hc(l.fsPath)},getWorkspaceFolderPathForFile:()=>{if(i){const l=s();if(l){const a=i.getWorkspaceFolder(l);if(a)return g.$hc(a.uri.fsPath)}}},getSelectedText:()=>{if(r){const l=r.activeEditor();if(l&&!l.selection.isEmpty)return l.document.getText(l.selection)}},getLineNumber:()=>{if(r){const l=r.activeEditor();if(l)return String(l.selection.end.line+1)}},getExtension:l=>o.getExtension(l)},void 0,u?Promise.resolve(u):void 0,Promise.resolve(I.env))}}let h=class extends O.$Tc{constructor(o,i,r,n,c){super(),this.b=o,this.c=i,this.g=r,this.h=n,this.j=c,this.a=new D.$V(async()=>{const t=await this.h.getConfigProvider(),s={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async l=>{s.folders=await this.c.getWorkspaceFolders2()||[]})),new S(this.b,this.c,this.g,this.j,t,s,this.m())})}getResolver(){return this.a.value}m(){}};e.$9gc=h,e.$9gc=h=Ge([We(0,y.$5gc),We(1,C.$qgc),We(2,b.$iN),We(3,p.$tgc),We(4,$.$Fgc)],h)}),define(ke[96],Se([1,0,11,4,2,5,6,70,47,20,7,41,140,281,42,59]),function(me,e,D,O,g,I,A,b,$,y,L,C,m,p,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bhc=e.$ahc=e.$_gc=e.$$gc=e.$0gc=void 0,e.$0gc=(0,I.$6h)("IExtHostDebugService");let f=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(u,s,l,a,d,k){this.E=s,this.F=l,this.G=a,this.H=d,this.I=k,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new O.$Vd,this.n=new O.$Vd,this.o=new O.$Vd,this.u=new O.$Vd,this.k=u.getProxy(A.$6K.MainThreadDebugService),this.y=new O.$Vd,this.A=new O.$Vd,this.v=new i(this.k),this.w=new Map,this.F.getExtensionRegistry().then(R=>{R.onDidChange(v=>{this.J(R)}),this.J(R)})}asDebugSourceUri(u,s){const l=u;if(typeof l.sourceReference=="number"&&l.sourceReference>0){let a=`debug:${encodeURIComponent(l.path||"")}`,d="?";return s&&(a+=`${d}session=${encodeURIComponent(s.id)}`,d="&"),a+=`${d}ref=${l.sourceReference}`,g.URI.parse(a)}else{if(l.path)return g.URI.file(l.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(u){const s=[];for(const l of u.getAllExtensionDescriptions())if(l.contributes){const a=l.contributes.debuggers;if(a&&a.length>0)for(const d of a)(0,p.$bG)(d)&&s.push(d.type)}this.k.$registerDebugTypes(s)}get stackFrameFocus(){return this.z}get onDidChangeStackFrameFocus(){return this.A.event}get onDidChangeBreakpoints(){return this.y.event}get breakpoints(){const u=[];return this.w.forEach(s=>u.push(s)),u}addBreakpoints(u){const s=u.filter(d=>{const k=d.id;return this.w.has(k)?!1:(this.w.set(k,d),!0)});this.U(s,[],[]);const l=[],a=new Map;for(const d of s)if(d instanceof L.$8L){let k=a.get(d.location.uri.toString());k||(k={type:"sourceMulti",uri:d.location.uri,lines:[]},a.set(d.location.uri.toString(),k),l.push(k)),k.lines.push({id:d.id,enabled:d.enabled,condition:d.condition,hitCondition:d.hitCondition,logMessage:d.logMessage,line:d.location.range.start.line,character:d.location.range.start.character})}else d instanceof L.$9L&&l.push({type:"function",id:d.id,enabled:d.enabled,hitCondition:d.hitCondition,logMessage:d.logMessage,condition:d.condition,functionName:d.functionName});return this.k.$registerBreakpoints(l)}removeBreakpoints(u){const s=u.filter(k=>this.w.delete(k.id));this.U([],s,[]);const l=s.filter(k=>k instanceof L.$8L).map(k=>k.id),a=s.filter(k=>k instanceof L.$9L).map(k=>k.id),d=s.filter(k=>k instanceof L.$0L).map(k=>k.id);return this.k.$unregisterBreakpoints(l,a,d)}startDebugging(u,s,l){return this.k.$startDebugging(u?u.uri:void 0,s,{parentSessionID:l.parentSession?l.parentSession.id:void 0,lifecycleManagedByParent:l.lifecycleManagedByParent,repl:l.consoleMode===L.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:l.noDebug,compact:l.compact,suppressSaveBeforeStart:l.suppressSaveBeforeStart,suppressDebugStatusbar:l.suppressDebugStatusbar??l.debugUI?.simple,suppressDebugToolbar:l.suppressDebugToolbar??l.debugUI?.simple,suppressDebugView:l.suppressDebugView??l.debugUI?.simple})}stopDebugging(u){return this.k.$stopDebugging(u?u.id:void 0)}registerDebugConfigurationProvider(u,s,l){if(!s)return new L.$8K(()=>{});const a=this.d++;return this.f.push({type:u,handle:a,provider:s}),this.k.$registerDebugConfigurationProvider(u,l,!!s.provideDebugConfigurations,!!s.resolveDebugConfiguration,!!s.resolveDebugConfigurationWithSubstitutedVariables,a),new L.$8K(()=>{this.f=this.f.filter(d=>d.provider!==s),this.k.$unregisterDebugConfigurationProvider(a)})}registerDebugAdapterDescriptorFactory(u,s,l){if(!l)return new L.$8K(()=>{});if(!this.Q(u,s))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${s}' debugger.`);if(this.N(s))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const a=this.g++;return this.h.push({type:s,handle:a,factory:l}),this.k.$registerDebugAdapterDescriptorFactory(s,a),new L.$8K(()=>{this.h=this.h.filter(d=>d.factory!==l),this.k.$unregisterDebugAdapterDescriptorFactory(a)})}registerDebugAdapterTrackerFactory(u,s){if(!s)return new L.$8K(()=>{});const l=this.i++;return this.j.push({type:u,handle:l,factory:s}),new L.$8K(()=>{this.j=this.j.filter(a=>a.factory!==s)})}async $runInTerminal(u,s){return Promise.resolve(void 0)}async $substituteVariables(u,s){let l;const a=await this.W(u);return a&&(l={uri:a.uri,name:a.name,index:a.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync(l,s)}K(u,s){if(u.type==="implementation")return new n(u.implementation)}L(){}async $startDASession(u,s){const l=this,a=await this.V(s);return this.S(this.N(a.type),a).then(d=>{if(!d)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${a.type}' (extension might have failed to activate)`);const k=this.M(d),R=this.K(k,a);if(!R)throw new Error(`Couldn't create a debug adapter for type '${a.type}'.`);const v=R;return this.B.set(u,v),this.R(a).then(w=>(w&&this.C.set(u,w),v.onMessage(async E=>{if(E.type==="request"&&E.command==="handshake"){const P=E,N={type:"response",seq:0,command:P.command,request_seq:P.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const U=await this.D.sign(P.arguments.value);N.body={signature:U},v.sendResponse(N)}else throw new Error("no signer")}catch(U){N.success=!1,N.message=U.message,v.sendResponse(N)}}else w&&w.onDidSendMessage&&w.onDidSendMessage(E),E=(0,p.$gG)(E,!0),l.k.$acceptDAMessage(u,E)}),v.onError(E=>{w&&w.onError&&w.onError(E),this.k.$acceptDAError(u,E.name,E.message,E.stack)}),v.onExit(E=>{w&&w.onExit&&w.onExit(E??void 0,void 0),this.k.$acceptDAExit(u,E??void 0,void 0)}),w&&w.onWillStartSession&&w.onWillStartSession(),v.startSession()))})}$sendDAMessage(u,s){s=(0,p.$fG)(s,!1);const l=this.C.get(u);l&&l.onWillReceiveMessage&&l.onWillReceiveMessage(s),this.B.get(u)?.sendMessage(s)}$stopDASession(u){const s=this.C.get(u);this.C.delete(u),s&&s.onWillStopSession&&s.onWillStopSession();const l=this.B.get(u);return this.B.delete(u),l?l.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(u){const s=[],l=[],a=[];if(u.added)for(const d of u.added){const k=d.id;if(k&&!this.w.has(k)){let R;if(d.type==="function")R=new L.$9L(d.functionName,d.enabled,d.condition,d.hitCondition,d.logMessage);else if(d.type==="data")R=new L.$0L(d.label,d.dataId,d.canPersist,d.enabled,d.hitCondition,d.condition,d.logMessage);else{const v=g.URI.revive(d.uri);R=new L.$8L(new L.$hL(v,new L.$9K(d.line,d.character)),d.enabled,d.condition,d.hitCondition,d.logMessage)}(0,L.$6L)(R,k),this.w.set(k,R),s.push(R)}}if(u.removed)for(const d of u.removed){const k=this.w.get(d);k&&(this.w.delete(d),l.push(k))}if(u.changed){for(const d of u.changed)if(d.id){const k=this.w.get(d.id);if(k){if(k instanceof L.$9L&&d.type==="function"){const R=k;R.enabled=d.enabled,R.condition=d.condition,R.hitCondition=d.hitCondition,R.logMessage=d.logMessage,R.functionName=d.functionName}else if(k instanceof L.$8L&&d.type==="source"){const R=k;R.enabled=d.enabled,R.condition=d.condition,R.hitCondition=d.hitCondition,R.logMessage=d.logMessage,R.location=new L.$hL(g.URI.revive(d.uri),new L.$9K(d.line,d.character))}a.push(k)}}}this.U(s,l,a)}async $acceptStackFrameFocus(u){let s;const l=u.sessionId?await this.V(u.sessionId):void 0;if(!l)throw new Error("no DebugSession found for debug focus context");u.kind==="thread"?s=new L.$dM(l,u.threadId):s=new L.$cM(l,u.threadId,u.frameId),this.z=s,this.A.fire(this.z)}$provideDebugConfigurations(u,s,l){return(0,D.$Yg)(async()=>{const a=this.P(u);if(!a)throw new Error("no DebugConfigurationProvider found");if(!a.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const d=await this.W(s);return a.provideDebugConfigurations(d,l)}).then(a=>{if(!a)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return a})}$resolveDebugConfiguration(u,s,l,a){return(0,D.$Yg)(async()=>{const d=this.P(u);if(!d)throw new Error("no DebugConfigurationProvider found");if(!d.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const k=await this.W(s);return d.resolveDebugConfiguration(k,l,a)})}$resolveDebugConfigurationWithSubstitutedVariables(u,s,l,a){return(0,D.$Yg)(async()=>{const d=this.P(u);if(!d)throw new Error("no DebugConfigurationProvider found");if(!d.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const k=await this.W(s);return d.resolveDebugConfigurationWithSubstitutedVariables(k,l,a)})}async $provideDebugAdapter(u,s){const l=this.O(u);if(!l)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const a=await this.V(s);return this.S(l,a).then(d=>{if(!d)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${a.type}'`);return this.M(d)})}async $acceptDebugSessionStarted(u){const s=await this.V(u);this.m.fire(s)}async $acceptDebugSessionTerminated(u){const s=await this.V(u);s&&(this.n.fire(s),this.l.delete(s.id))}async $acceptDebugSessionActiveChanged(u){this.q=u?await this.V(u):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(u,s){(await this.V(u))?._acceptNameChanged(s)}async $acceptDebugSessionCustomEvent(u,s){const a={session:await this.V(u),event:s.event,body:s.body};this.u.fire(a)}M(u){if(u instanceof L.$$L)return{type:"executable",command:u.command,args:u.args,options:u.options};if(u instanceof L.$_L)return{type:"server",port:u.port,host:u.host};if(u instanceof L.$aM)return{type:"pipeServer",path:u.path};if(u instanceof L.$bM)return{type:"implementation",implementation:u.implementation};throw new Error("convertToDto unexpected type")}N(u){const s=this.h.filter(l=>l.type===u);if(s.length>0)return s[0].factory}O(u){const s=this.h.filter(l=>l.handle===u);if(s.length>0)return s[0].factory}P(u){const s=this.f.filter(l=>l.handle===u);if(s.length>0)return s[0].provider}Q(u,s){if(u.contributes){const l=u.contributes.debuggers;if(l&&l.length>0){for(const a of l)if(a.label&&a.type&&a.type===s)return!0}}return!1}R(u){const l=u.configuration.type,a=this.j.filter(d=>d.type===l||d.type==="*").map(d=>(0,D.$Yg)(()=>d.factory.createDebugAdapterTracker(u)).then(k=>k,k=>null));return Promise.race([Promise.all(a).then(d=>{const k=d.filter(R=>!!R);if(k.length>0)return new r(k)}),new Promise(d=>setTimeout(()=>d(void 0),1e3))]).catch(d=>{})}async S(u,s){const l=s.configuration.debugServer;if(typeof l=="number")return Promise.resolve(new L.$_L(l));if(u){const d=await this.F.getExtensionRegistry();return(0,D.$Yg)(()=>u.createDebugAdapterDescriptor(s,this.T(s,d))).then(k=>{if(k)return k})}const a=await this.F.getExtensionRegistry();return Promise.resolve(this.T(s,a))}T(u,s){}U(u,s,l){(u.length>0||s.length>0||l.length>0)&&this.y.fire(Object.freeze({added:u,removed:s,changed:l}))}async V(u){if(u)if(typeof u=="string"){const s=this.l.get(u);if(s)return s}else{let s=this.l.get(u.id);if(!s){const l=await this.W(u.folderUri),a=u.parent?this.l.get(u.parent):void 0;s=new o(this.k,u.id,u.type,u.name,l,u.configuration,a),this.l.set(s.id,s),this.k.$sessionCached(s.id)}return s}throw new Error("cannot find session")}W(u){if(u){const s=g.URI.revive(u);return this.E.resolveWorkspaceFolder(s)}return Promise.resolve(void 0)}};e.$$gc=f,e.$$gc=f=Ge([We(0,y.$0M),We(1,C.$qgc),We(2,$.$5gc),We(3,S.$tgc),We(4,b.$Fgc),We(5,h.$8gc)],f);class o{constructor(u,s,l,a,d,k,R){this.d=u,this.f=s,this.g=l,this.h=a,this.i=d,this.j=k,this.k=R}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(u){this.h=u,this.d.$setDebugSessionName(this.f,u)}get parentSession(){return this.k}_acceptNameChanged(u){this.h=u}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(u,s){return this.d.$customDebugAdapterRequest(this.f,u,s)}getDebugProtocolBreakpoint(u){return this.d.$getDebugProtocolBreakpoint(this.f,u.id)}}e.$_gc=o;class i{constructor(u){this.value=Object.freeze({append(s){u.$appendDebugConsole(s)},appendLine(s){this.append(s+`
`)}})}}e.$ahc=i;class r{constructor(u){this.d=u}onWillStartSession(){this.d.forEach(u=>u.onWillStartSession?u.onWillStartSession():void 0)}onWillReceiveMessage(u){this.d.forEach(s=>s.onWillReceiveMessage?s.onWillReceiveMessage(u):void 0)}onDidSendMessage(u){this.d.forEach(s=>s.onDidSendMessage?s.onDidSendMessage(u):void 0)}onWillStopSession(){this.d.forEach(u=>u.onWillStopSession?u.onWillStopSession():void 0)}onError(u){this.d.forEach(s=>s.onError?s.onError(u):void 0)}onExit(u,s){this.d.forEach(l=>l.onExit?l.onExit(u,s):void 0)}}class n extends m.$Ilb{constructor(u){super(),this.h=u,u.onDidSendMessage(s=>{this.acceptMessage(s)})}startSession(){return Promise.resolve(void 0)}sendMessage(u){this.h.handleMessage(u)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let c=class extends f{constructor(u,s,l,a,d,k){super(u,s,l,a,d,k)}};e.$bhc=c,e.$bhc=c=Ge([We(0,y.$0M),We(1,C.$qgc),We(2,$.$5gc),We(3,S.$tgc),We(4,b.$Fgc),We(5,h.$8gc)],c)}),define(ke[364],Se([1,0,14,57,2,6,352,13,106,107,27,247,20,66,47,90]),function(me,e,D,O,g,I,A,b,$,y,L,C,m,p,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eic=e.$dic=void 0;class f{static async installEarlyHandler(r){Error.stackTraceLimit=100;const n=r.get(b.$nj),t=r.get(m.$0M).getProxy(I.$6K.MainThreadErrors);D.setUnexpectedErrorHandler(u=>{n.error(u);const s=D.$3(u);t.$onUnexpectedError(s)})}static async installFullHandler(r){const n=r.get(b.$nj),c=r.get(m.$0M),t=r.get(S.$5gc),u=r.get(h.$rN),s=c.getProxy(I.$6K.MainThreadExtensionService),l=c.getProxy(I.$6K.MainThreadErrors),a=await t.getExtensionPathIndex(),d=new WeakMap;function k(w,E){if(d.has(w))return d.get(w).stack;let P="",N,U;for(const j of E)P+=`
	at ${j.toString()}`,U=j.getFileName(),!N&&U&&(N=a.findSubstr(g.URI.file(U)));const F=`${w.name||"Error"}: ${w.message||""}${P}`;return d.set(w,{extensionIdentifier:N?.identifier,stack:F}),F}const R=Symbol("prepareStackTrace wrapped");let v=k;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return v},set(w){if(w===k||!w||w[R]){v=w||k;return}v=function(E,P){return k(E,P),w.call(Error,E,P)},Object.assign(v,{[R]:!0})}}),D.setUnexpectedErrorHandler(w=>{n.error(w);const E=D.$3(w),P=d.get(w);if(!P?.extensionIdentifier){l.$onUnexpectedError(E);return}s.$onExtensionRuntimeError(P.extensionIdentifier,E);const N=u.onExtensionError(P.extensionIdentifier,w);n.trace("forwarded error to extension?",N,P)})}}e.$dic=f;class o{constructor(r,n,c,t,u){this.a=c,this.b=new A.$p8b(r,null,t),n=o.e(n,this.b);const s=new y.$4h(...(0,$.$Zr)());s.set(L.$nN,{_serviceBrand:void 0,...n,messagePorts:u}),s.set(m.$0M,new m.$$M(this.b)),s.set(p.$ngc,new p.$ogc(t)),s.set(S.$3gc,c);const l=new C.$Eq(s,!0);l.invokeFunction(f.installEarlyHandler),this.d=l.invokeFunction(a=>a.get(b.$nj)),O.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",n),this.c=l.invokeFunction(a=>a.get(S.$5gc)),this.c.initialize(),l.invokeFunction(f.installFullHandler)}async asBrowserUri(r){const n=this.b.getProxy(I.$6K.MainThreadExtensionService);return g.URI.revive(await n.$asBrowserUri(r))}terminate(r){this.c.terminate(r)}static e(r,n){r.extensions.allExtensions.forEach(t=>{t.extensionLocation=g.URI.revive(n.transformIncomingURIs(t.extensionLocation))}),r.environment.appRoot=g.URI.revive(n.transformIncomingURIs(r.environment.appRoot));const c=r.environment.extensionDevelopmentLocationURI;return c&&(r.environment.extensionDevelopmentLocationURI=c.map(t=>g.URI.revive(n.transformIncomingURIs(t)))),r.environment.extensionTestsLocationURI=g.URI.revive(n.transformIncomingURIs(r.environment.extensionTestsLocationURI)),r.environment.globalStorageHome=g.URI.revive(n.transformIncomingURIs(r.environment.globalStorageHome)),r.environment.workspaceStorageHome=g.URI.revive(n.transformIncomingURIs(r.environment.workspaceStorageHome)),r.environment.extensionTelemetryLogResource=g.URI.revive(n.transformIncomingURIs(r.environment.extensionTelemetryLogResource)),r.nlsBaseUrl=g.URI.revive(n.transformIncomingURIs(r.nlsBaseUrl)),r.logsLocation=g.URI.revive(n.transformIncomingURIs(r.logsLocation)),r.workspace=n.transformIncomingURIs(r.workspace),r}}e.$eic=o}),define(ke[365],Se([1,0,11,10,222,241,138,96,70,47,20,46,7,59,41,282,283,42]),function(me,e,D,O,g,I,A,b,$,y,L,C,m,p,S,h,f,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oic=void 0;let i=class extends b.$$gc{constructor(u,s,l,a,d,k,R){super(u,s,l,a,k,R),this.Z=d,this.X=new c}K(u,s){switch(u.type){case"server":return new h.$jic(u);case"pipeServer":return new h.$kic(u);case"executable":return new h.$lic(u,s.type)}return super.K(u,s)}T(u,s){const l=h.$lic.platformAdapterExecutable(s.getAllExtensionDescriptions(),u.type);if(l)return new m.$$L(l.command,l.args,l.options)}L(){return new A.$c_b}async $runInTerminal(u,s){if(u.kind==="integrated"){this.Y||(this.Y=this.Z.onDidCloseTerminal(F=>{this.X.onTerminalClosed(F)}));const l=await this.G.getConfigProvider(),a=this.Z.getDefaultShell(!0),d=this.Z.getDefaultShellArgs(!0),k=u.title||g.localize(0,null),R=JSON.stringify({shell:a,shellArgs:d});let v=await this.X.checkout(R,k),w,E=!1;if(v)w=u.cwd;else{const F={shellPath:a,shellArgs:d,cwd:u.cwd,name:k,iconPath:new m.$3L("debug")};E=!0,v=this.Z.createTerminalFromOptions(F,{isFeatureTerminal:!0,useShellEnvironment:!0}),this.X.insert(v,R)}v.show(!0);const P=await v.processId;E?await new Promise(F=>setTimeout(F,1e3)):l.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(a.indexOf("powershell")>=0||a.indexOf("pwsh")>=0||a.indexOf("cmd.exe")>=0?v.sendText("cls"):a.indexOf("bash")>=0?v.sendText("clear"):O.$i?v.sendText("cls"):v.sendText("clear"));const N=(0,f.$nic)(a,u.args,!!u.argsCanBeInterpretedByShell,w,u.env);v.sendText(N);const U=this.onDidTerminateDebugSession(F=>{F.id===s&&(this.X.free(v),U.dispose())});return P}else if(u.kind==="external")return n(u,await this.G.getConfigProvider());return super.$runInTerminal(u,s)}};e.$oic=i,e.$oic=i=Ge([We(0,L.$0M),We(1,S.$qgc),We(2,y.$5gc),We(3,o.$tgc),We(4,C.$Rgc),We(5,$.$Fgc),We(6,p.$8gc)],i);let r;function n(t,u){if(!r)if(O.$i)r=new I.$10b;else if(O.$j)r=new I.$20b;else if(O.$k)r=new I.$30b;else throw new Error("external terminals not supported on this platform");const s=u.getConfiguration("terminal");return r.runInTerminal(t.title,t.cwd,t.args,t.env||{},s.external||{})}class c{constructor(){this.b=new Map}static{this.a=1e3}async checkout(u,s){const a=[...this.b.entries()].map(([d,k])=>(0,D.$Tg)(async R=>{if(d.name!==s||k.lastUsedAt!==-1&&await(0,f.$mic)(await d.processId))return null;const v=Date.now();return k.lastUsedAt+c.a>v||R.isCancellationRequested||k.config!==u?null:(k.lastUsedAt=v,d)}));return await(0,D.$$g)(a,d=>!!d)}insert(u,s){this.b.set(u,{lastUsedAt:Date.now(),config:s})}free(u){const s=this.b.get(u);s&&(s.lastUsedAt=-1)}onTerminalClosed(u){this.b.delete(u)}}}),define(ke[366],Se([1,0,16,2,104,41,69,42,40,46,20,27,95,17,13,91,23,63,59]),function(me,e,D,O,g,I,A,b,$,y,L,C,m,p,S,h,f,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gic=void 0;let r=class extends m.$Uhc{constructor(c,t,u,s,l,a,d,k,R){super(c,t,u,s,l,a,d,k),this.C=u,this.D=R,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(p.Schemas.vscodeRemote,{scheme:p.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(p.Schemas.file,{scheme:p.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(c,t){const u=t;if(!t.execution&&u._id===void 0)throw new Error("Tasks to execute must include an execution");if(u._id!==void 0){const s=m.TaskHandleDTO.from(u,this.C),l=await this.a.$getTaskExecution(s);if(l.task===void 0)throw new Error("Task from execution DTO is undefined");const a=await this.z(l,t);return this.a.$executeTask(s).catch(()=>{}),a}else{const s=m.TaskDTO.from(t,c);if(s===void 0)return Promise.reject(new Error("Task is not valid"));m.CustomExecutionDTO.is(s.execution)&&await this.y(s,t,!1);const l=await this.z(await this.a.$getTaskExecution(s),t);return this.a.$executeTask(s).catch(()=>{}),l}}v(c,t,u,s){const l=[];if(s)for(const a of s){this.A(a,u),(!a.definition||!c[a.definition.type])&&this.f.warn(`The task [${a.source}, ${a.name}] uses an undefined task type. The task will be ignored in the future.`);const d=m.TaskDTO.from(a,u.extension);d&&(l.push(d),m.CustomExecutionDTO.is(d.execution)&&t.push(this.y(d,a,!0)))}return{tasks:l,extension:u.extension}}async w(c){return c}async G(c){let t=c&&c.length>0?c[0]:void 0;if(!t){const u=O.URI.file((0,o.homedir)());t=new $.$ni({uri:u,name:f.$Eg(u),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(c,t){const u=O.URI.revive(c),s={process:void 0,variables:Object.create(null)},l=await this.b.resolveWorkspaceFolder(u),a=await this.b.getWorkspaceFolders2()??[],d=await this.D.getResolver(),k=l?{uri:l.uri,name:l.name,index:l.index,toResource:()=>{throw new Error("Not implemented")}}:await this.G(a);for(const R of t.variables)s.variables[R]=await d.resolveAsync(k,R);if(t.process!==void 0){let R;if(t.process.path!==void 0){R=t.process.path.split(D.$tc);for(let v=0;v<R.length;v++)R[v]=await d.resolveAsync(k,R[v])}s.process=await g.win32.findExecutable(await d.resolveAsync(k,t.process.name),t.process.cwd!==void 0?await d.resolveAsync(k,t.process.cwd):void 0,R)}return s}async $jsonTasksSupported(){return!0}async $findExecutable(c,t,u){return g.win32.findExecutable(c,t,u)}};e.$gic=r,e.$gic=r=Ge([We(0,L.$0M),We(1,C.$nN),We(2,I.$qgc),We(3,A.$iN),We(4,b.$tgc),We(5,y.$Rgc),We(6,S.$nj),We(7,h.$$fc),We(8,i.$8gc)],r)}),define(ke[367],Se([1,0,63,59]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yic=void 0;class g extends O.$9gc{m(){return(0,D.homedir)()}}e.$Yic=g}),define(ke[154],Se([1,0,19,11,21,44,17,16,23,2,36]),function(me,e,D,O,g,I,A,b,$,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$shc=e.$rhc=e.$qhc=e.$phc=void 0;class C{constructor(i,r,n,c){this.d=i,this.e=r,this.f=n,this.g=c,this.a=null,this.b=!1,this.c=0}search(i,r){const n=this.d.folderQueries||[],c=new g.$6d(r);return new Promise((t,u)=>{this.a=new p(i);let s=!1;const l=(a,d)=>{if(!s&&!this.b){const k=this.h(a);h(a)&&typeof this.d.maxResults=="number"&&this.c+k>this.d.maxResults&&(this.b=!0,s=!0,c.cancel(),a=this.j(a,this.d.maxResults-this.c));const R=this.h(a);this.c+=R,(R>0||!h(a))&&this.a.add(a,d)}};Promise.all(n.map((a,d)=>this.k(a,k=>l(k,d),c.token))).then(a=>{c.dispose(),this.a.flush();const d=a.some(k=>!!k&&!!k.limitHit);t({limitHit:this.b||d,messages:(0,D.$Rb)(a.map(k=>k?.message?Array.isArray(k.message)?k.message:[k.message]:[])),stats:{type:this.g}})},a=>{c.dispose();const d=(0,I.$Qi)(a);u(new Error(d))})})}h(i){return h(i)?Array.isArray(i.ranges)?i.ranges.length:1:0}j(i,r){const n=Array.isArray(i.ranges)?i.ranges:[i.ranges],c=Array.isArray(i.preview.matches)?i.preview.matches:[i.preview.matches];return{ranges:n.slice(0,r),preview:{matches:c.slice(0,r),text:i.preview.text},uri:i.uri}}async k(i,r,n){const c=new L.$JJ(this.d,i),t=[],u={report:a=>{if(!this.l(a))return;const d=i.folder.scheme===A.Schemas.file?(0,L.$KJ)(()=>this.f.readdir($.$Gg(a.uri))):void 0,k=$.$Jg(i.folder,a.uri);if(k){const R=c.includedInQuery(k,b.$nc(k),d);(0,O.$Sg)(R)?t.push(R.then(v=>{v&&r(a)})):R&&r(a)}}},s=this.n(i),l=await this.e.provideTextSearchResults(m(this.d.contentPattern),s,u,n);return t.length&&await Promise.all(t),l}l(i){if(h(i)){if(Array.isArray(i.ranges)){if(!Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(i.preview.matches.length!==i.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(i){const r=(0,L.$IJ)(this.d.includePattern,i.includePattern),n=(0,L.$IJ)(this.d.excludePattern,i.excludePattern),c={folder:y.URI.from(i.folder),excludes:n,includes:r,useIgnoreFiles:!i.disregardIgnoreFiles,useGlobalIgnoreFiles:!i.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!i.disregardParentIgnoreFiles,followSymlinks:!i.ignoreSymlinks,encoding:i.fileEncoding&&this.f.toCanonicalName(i.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return c.usePCRE2=this.d.usePCRE2,c}}e.$phc=C;function m(o){return{isCaseSensitive:o.isCaseSensitive||!1,isRegExp:o.isRegExp||!1,isWordMatch:o.isWordMatch||!1,isMultiline:o.isMultiline||!1,pattern:o.pattern}}class p{constructor(i){this.e=i,this.b=-1,this.d=null,this.a=new f(512,r=>this.g(r))}add(i,r){this.d&&(this.b!==r||!$.$Ag(this.c,i.uri))&&(this.f(),this.d=null),this.d||(this.b=r,this.d={resource:i.uri,results:[]}),this.d.results.push(S(i))}f(){const i=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,i)}flush(){this.f(),this.a.flush()}g(i){this.e(i)}}e.$qhc=p;function S(o){return h(o)?{preview:{matches:(0,D.$2b)(o.preview.matches,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character})),text:o.preview.text},ranges:(0,D.$2b)(o.ranges,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character}))}:{text:o.text,lineNumber:o.lineNumber}}function h(o){return!!o.preview}e.$rhc=h;class f{static{this.a=4e3}static{this.b=50}constructor(i,r){this.g=i,this.h=r,this.c=0,this.d=[],this.e=0}addItem(i,r){i&&this.j(i,r)}addItems(i,r){i&&this.k(i,r)}j(i,r){this.d.push(i),this.e+=r,this.l()}k(i,r){this.d=this.d.concat(i),this.e+=r,this.l()}l(){this.c<f.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},f.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$shc=f}),define(ke[97],Se([1,0,3,6,5,360,20,66,13,2,154]),function(me,e,D,O,g,I,A,b,$,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vhc=e.$uhc=e.$thc=void 0,e.$thc=(0,g.$6h)("IExtHostSearch");let C=class{constructor(h,f,o){this.k=h,this.l=f,this.n=o,this.c=this.k.getProxy(O.$6K.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new I.$ohc}o(h){return this.l.transformOutgoingScheme(h)}registerTextSearchProvider(h,f){if(this.g.has(h))throw new Error(`a text search provider for the scheme '${h}' is already registered`);this.g.add(h);const o=this.d++;return this.e.set(o,f),this.c.$registerTextSearchProvider(o,this.o(h)),(0,D.$Rc)(()=>{this.g.delete(h),this.e.delete(o),this.c.$unregisterProvider(o)})}registerFileSearchProvider(h,f){if(this.i.has(h))throw new Error(`a file search provider for the scheme '${h}' is already registered`);this.i.add(h);const o=this.d++;return this.h.set(o,f),this.c.$registerFileSearchProvider(o,this.o(h)),(0,D.$Rc)(()=>{this.i.delete(h),this.h.delete(o),this.c.$unregisterProvider(o)})}$provideFileSearchResults(h,f,o,i){const r=m(o),n=this.h.get(h);if(n)return this.j.fileSearch(r,n,c=>{this.c.$handleFileMatch(h,f,c.map(t=>t.resource))},i);throw new Error("unknown provider: "+h)}async doInternalFileSearchWithCustomCallback(h,f,o){return{messages:[]}}$clearCache(h){return this.j.clearCache(h),Promise.resolve(void 0)}$provideTextSearchResults(h,f,o,i){const r=this.e.get(h);if(!r||!r.provideTextSearchResults)throw new Error(`Unknown provider ${h}`);const n=m(o);return this.q(n,r).search(t=>this.c.$handleTextMatch(h,f,t),i)}$enableExtensionHostSearch(){}q(h,f){return new L.$phc(h,f,{readdir:o=>Promise.resolve([]),toCanonicalName:o=>o},"textSearchProvider")}};e.$uhc=C,e.$uhc=C=Ge([We(0,A.$0M),We(1,b.$ngc),We(2,$.$nj)],C);function m(S){return{...S,folderQueries:S.folderQueries&&S.folderQueries.map(p),extraFileResources:S.extraFileResources&&S.extraFileResources.map(h=>y.URI.revive(h))}}e.$vhc=m;function p(S){return{...S,folder:y.URI.revive(S.folder)}}}),define(ke[368],Se([1,0,21,14,4,3,17,39,2,132,191,172,79,26,32,13,65,87,266,6,304,312,91,305,306,307,308,309,310,311,287,35,313,42,343,96,149,315,316,317,293,318,69,70,319,47,320,71,321,58,27,322,323,324,325,326,327,115,116,328,359,295,272,296,329,330,152,331,297,332,333,20,334,97,117,335,336,337,118,92,95,90,46,338,339,284,340,298,72,15,7,341,66,342,93,344,345,151,41,280,114,25,94]),function(me,e,D,O,g,I,A,b,$,y,L,C,m,p,S,h,f,o,i,r,n,c,t,u,s,l,a,d,k,R,v,w,E,P,N,U,F,j,T,M,B,Y,ue,Z,J,X,he,_,we,oe,K,W,re,ye,de,ge,x,te,G,ie,fe,pe,Pe,be,De,z,Q,ee,q,ae,le,Le,je,He,Je,_e,ct,ot,rt,Re,Ue,Ae,Xe,ne,ce,Ie,qe,Ye,nt,it,Oe,vt,St,Nt,Wt,Et,Kt,Ot,Yt,Ut,At,et,Gt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$hc=void 0;function Jt(ht){const bt=ht.get(K.$nN),zt=ht.get(oe.$8fc),Vt=ht.get(_.$vgc),Dt=ht.get(X.$5gc),ft=ht.get(Yt.$qgc),Rt=ht.get(Ae.$rN),xt=ht.get(P.$tgc),Ct=ht.get(St.$ngc),Qe=ht.get(Le.$0M),Tt=ht.get(rt.$Ogc),qt=ht.get(Re.$wgc),Qt=ht.get(h.$oj),gt=ht.get(h.$nj),Ft=ht.get(nt.$oyb),Te=ht.get(t.$$fc),Ne=ht.get(Ot.$0hc),Ce=ht.get(Je.$Wgc),se=ht.get(Z.$Fgc),Fe=ht.get(G.$1gc);Qe.set(r.$7K.ExtHostFileSystemInfo,zt),Qe.set(r.$7K.ExtHostLogLevelServiceShape,Qt),Qe.set(r.$7K.ExtHostWorkspace,ft),Qe.set(r.$7K.ExtHostConfiguration,xt),Qe.set(r.$7K.ExtHostExtensionService,Dt),Qe.set(r.$7K.ExtHostStorage,Tt),Qe.set(r.$7K.ExtHostTunnelService,Ft),Qe.set(r.$7K.ExtHostWindow,Ne),Qe.set(r.$7K.ExtHostSecretState,Ce),Qe.set(r.$7K.ExtHostTelemetry,Rt),Qe.set(r.$7K.ExtHostEditorTabs,se),Qe.set(r.$7K.ExtHostManagedSockets,Fe);const Ve=Qe.set(r.$7K.ExtHostDecorations,ht.get(F.$dhc)),xe=Qe.set(r.$7K.ExtHostDocumentsAndEditors,ht.get(ue.$iN)),Ke=Qe.set(r.$7K.ExtHostCommands,ht.get(w.$tN)),st=Qe.set(r.$7K.ExtHostTerminalService,ht.get(Xe.$Rgc)),$t=Qe.set(r.$7K.ExtHostDebugService,ht.get(U.$0gc)),Bt=Qe.set(r.$7K.ExtHostSearch,ht.get(He.$thc)),kt=Qe.set(r.$7K.ExtHostTask,ht.get(Ue.$Whc)),It=Qe.set(r.$7K.ExtHostOutputService,ht.get(Q.$Jhc)),yt=Qe.set(r.$7K.ExtHostLocalization,ht.get(te.$Zgc)),gi=Qe.set(r.$7K.ExtHostUrls,new Nt.$7hc(Qe)),Lt=Qe.set(r.$7K.ExtHostDocuments,new Y.$6fc(Qe,xe)),Di=Qe.set(r.$7K.ExtHostDocumentContentProviders,new M.$fhc(Qe,xe,gt)),Gi=Qe.set(r.$7K.ExtHostDocumentSaveParticipant,new B.$ghc(gt,Lt,Qe.getProxy(r.$6K.MainThreadBulkEdits))),Pt=Qe.set(r.$7K.ExtHostNotebook,new fe.$whc(Qe,Ke,xe,Lt,Vt,Bt)),ri=Qe.set(r.$7K.ExtHostNotebookDocuments,new Pe.$Dhc(Pt)),mi=Qe.set(r.$7K.ExtHostNotebookEditors,new be.$Ehc(gt,Pt)),ci=Qe.set(r.$7K.ExtHostNotebookKernels,new De.$Fhc(Qe,bt,Pt,Ke,gt)),Ci=Qe.set(r.$7K.ExtHostNotebookRenderers,new z.$Hhc(Qe,Pt)),Ii=Qe.set(r.$7K.ExtHostNotebookDocumentSaveParticipant,new pe.$Chc(gt,Pt,Qe.getProxy(r.$6K.MainThreadBulkEdits))),jt=Qe.set(r.$7K.ExtHostEditors,new ce.$kgc(Qe,xe)),$i=Qe.set(r.$7K.ExtHostTreeViews,new Ye.$5hc(Qe.getProxy(r.$6K.MainThreadTreeViews),Ke,gt)),Pi=Qe.set(r.$7K.ExtHostEditorInsets,new v.$lgc(Qe.getProxy(r.$6K.MainThreadEditorInsets),jt,bt.remote)),ui=Qe.set(r.$7K.ExtHostDiagnostics,new j.$0fc(Qe,gt,zt,xe)),li=Qe.set(r.$7K.ExtHostLanguages,new x.$Ahc(Qe,Lt,Ke.converter,Ct)),dt=Qe.set(r.$7K.ExtHostLanguageFeatures,new ge.$bgc(Qe,Ct,Lt,Ke,ui,gt,Te,Rt)),Ji=Qe.set(r.$7K.ExtHostFileSystem,new he.$ihc(Qe,dt)),_t=Qe.set(r.$7K.ExtHostFileSystemEventService,new we.$jhc(Qe,gt,xe)),si=Qe.set(r.$7K.ExtHostQuickOpen,(0,le.$Nhc)(Qe,ft,Ke)),bi=Qe.set(r.$7K.ExtHostSCM,new je.$Phc(Qe,Ke,Lt,gt)),Ri=Qe.set(r.$7K.ExtHostQuickDiff,new ae.$Mhc(Qe,Ct)),Qi=Qe.set(r.$7K.ExtHostShare,new _e.$Qhc(Qe,Ct)),Ai=Qe.set(r.$7K.ExtHostComments,(0,E.$mgc)(Qe,Ke,Lt)),wi=Qe.set(r.$7K.ExtHostProgress,new q.$Lhc(Qe.getProxy(r.$6K.MainThreadProgress))),Yi=Qe.set(r.$7K.ExtHostLabelService,new de.$zhc(Qe)),Li=Qe.set(r.$7K.ExtHostTheming,new Ie.$2hc(Qe)),hi=Qe.set(r.$7K.ExtHostAuthentication,new u.$dgc(Qe)),Xi=Qe.set(r.$7K.ExtHostTimeline,new qe.$4hc(Qe,Ke)),vi=Qe.set(r.$7K.ExtHostWebviews,new Wt.$Agc(Qe,bt.remote,ft,gt,Te)),Mi=Qe.set(r.$7K.ExtHostWebviewPanels,new Et.$Dgc(Qe,vi,ft)),un=Qe.set(r.$7K.ExtHostCustomEditors,new N.$Egc(Qe,Lt,qt,vi,Mi)),Ti=Qe.set(r.$7K.ExtHostWebviewViews,new Kt.$8hc(Qe,vi)),oi=Qe.set(r.$7K.ExtHostTesting,new ne.$Xhc(Qe,gt,Ke,xe)),ln=Qe.set(r.$7K.ExtHostUriOpeners,new vt.$6hc(Qe)),hn=Qe.set(r.$7K.ExtHostProfileContentHandlers,new ee.$Khc(Qe));Qe.set(r.$7K.ExtHostInteractive,new re.$xhc(Qe,Pt,xe,Ke,gt));const Zi=Qe.set(r.$7K.ExtHostInlineChat,new W.$khc(Qe,Ke,Lt,gt)),di=Qe.set(r.$7K.ExtHostChatProvider,new d.$ggc(Qe,gt)),xi=Qe.set(r.$7K.ExtHostChatAgents2,new a.$hgc(Qe,di,gt)),_i=Qe.set(r.$7K.ExtHostChatVariables,new k.$igc(Qe)),pi=Qe.set(r.$7K.ExtHostChat,new l.$fgc(Qe)),en=Qe.set(r.$7K.ExtHostAiRelatedInformation,new n.$5fc(Qe)),Fi=Qe.set(r.$7K.ExtHostAiEmbeddingVector,new J.$hhc(Qe)),Ni=Qe.set(r.$7K.ExtHostIssueReporter,new ye.$yhc(Qe)),ei=Qe.set(r.$7K.ExtHostStatusBar,new ot.$Thc(Qe,Ke.converter)),yi=Qe.set(r.$7K.ExtHostSpeech,new ct.$Rhc(Qe)),dn=Object.values(r.$7K);Qe.assertRegistered(dn);const Xt=new s.$egc(Qe,xe),Ei=new R.$jgc(Qe),ki=new ie.$Bhc(Qe,gt),Oi=new T.$ehc(Qe);return c.$cgc.register(Ke),function(Be,ti,tn){function at($e){return(Ee,ze,ut)=>{const pt=$e(Mt=>{try{Ee.call(ze,Mt)}catch(cn){O.$2(new Error(`[ExtensionListenerError] Extension '${Be.identifier.value}' FAILED to handle event`,{cause:cn})),Rt.onExtensionError(Be.identifier,cn)}});return ut?.push(pt),pt}}const wt=function(){let $e=!Be.isUnderDevelopment;function Ee(){$e||(gt.info(`Extension '${Be.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),$e=!0)}return function ze(ut){if(Array.isArray(ut))ut.forEach(ze);else if(typeof ut=="string")Ee();else{const pt=ut;typeof pt.scheme>"u"&&Ee(),typeof pt.exclusive=="boolean"&&(0,et.$CF)(Be,"documentFiltersExclusive")}return ut}}(),fn={getSession($e,Ee,ze){return hi.getSession(Be,$e,Ee,ze)},getSessions($e,Ee){return(0,et.$CF)(Be,"authGetSessions"),hi.getSessions(Be,$e,Ee)},async hasSession($e,Ee){return(0,et.$CF)(Be,"authSession"),!!await hi.getSession(Be,$e,Ee,{silent:!0})},get onDidChangeSessions(){return at(hi.onDidChangeSessions)},registerAuthenticationProvider($e,Ee,ze,ut){return hi.registerAuthenticationProvider($e,Ee,ze,ut)}},gn={registerCommand($e,Ee,ze){return Ke.registerCommand(!0,$e,Ee,ze,void 0,Be)},registerTextEditorCommand($e,Ee,ze){return Ke.registerCommand(!0,$e,(...ut)=>{const pt=jt.getActiveTextEditor();if(!pt){gt.warn("Cannot execute "+$e+" because there is no active text editor.");return}return pt.edit(Mt=>{Ee.apply(ze,[pt,Mt,...ut])}).then(Mt=>{Mt||gt.warn("Edits from command "+$e+" were not applied.")},Mt=>{gt.warn("An error occurred while running command "+$e,Mt)})},void 0,void 0,Be)},registerDiffInformationCommand:($e,Ee,ze)=>((0,et.$CF)(Be,"diffCommand"),Ke.registerCommand(!0,$e,async(...ut)=>{const pt=xe.activeEditor(!0);if(!pt){gt.warn("Cannot execute "+$e+" because there is no active text editor.");return}const Mt=await jt.getDiffInformation(pt.id);Ee.apply(ze,[Mt,...ut])},void 0,void 0,Be)),executeCommand($e,...Ee){return Ke.executeCommand($e,...Ee)},getCommands($e=!1){return Ke.getCommands($e)}},ji={get machineId(){return bt.telemetryInfo.machineId},get sessionId(){return bt.telemetryInfo.sessionId},get language(){return bt.environment.appLanguage},get appName(){return bt.environment.appName},get appRoot(){return bt.environment.appRoot?.fsPath??""},get appHost(){return bt.environment.appHost},get uriScheme(){return bt.environment.appUriScheme},get clipboard(){return Ei.value},get shell(){return st.getDefaultShell(!1)},get onDidChangeShell(){return at(st.onDidChangeShell)},get isTelemetryEnabled(){return Rt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return at(Rt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,et.$CF)(Be,"telemetry"),Rt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,et.$CF)(Be,"telemetry"),at(Rt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,Ae.$qN)(bt.telemetryInfo.firstSessionDate)},createTelemetryLogger($e,Ee){return Ae.$pN.validateSender($e),Rt.instantiateLogger(Be,$e,Ee)},openExternal($e,Ee){return Ne.openUri($e,{allowTunneling:!!bt.remote.authority,allowContributedOpeners:Ee?.allowContributedOpeners})},async asExternalUri($e){if($e.scheme===bt.environment.appUriScheme)return gi.createAppUri($e);try{return await Ne.asExternalUri($e,{allowTunneling:!!bt.remote.authority})}catch(Ee){if((0,A.$eg)($e,A.Schemas.http)||(0,A.$eg)($e,A.Schemas.https))return $e;throw Ee}},get remoteName(){return(0,f.$bl)(bt.remote.authority)},get remoteAuthority(){return(0,et.$CF)(Be,"resolvers"),bt.remote.authority},get uiKind(){return bt.uiKind},get logLevel(){return gt.getLevel()},get onDidChangeLogLevel(){return at(gt.onDidChangeLogLevel)},registerIssueUriRequestHandler($e){return(0,et.$CF)(Be,"handleIssueUri"),Ni.registerIssueUriRequestHandler(Be,$e)},registerIssueDataProvider($e){return(0,et.$CF)(Be,"handleIssueUri"),Ni.registerIssueDataProvider(Be,$e)},get appQuality(){return(0,et.$CF)(Be,"resolvers"),bt.quality},get appCommit(){return(0,et.$CF)(Be,"resolvers"),bt.commit}};bt.environment.extensionTestsLocationURI||Object.freeze(ji);const Ui={createTestController($e,Ee,ze){return oi.createTestController(Be,$e,Ee,ze)},createTestObserver(){return(0,et.$CF)(Be,"testObserver"),oi.createTestObserver()},runTests($e){return(0,et.$CF)(Be,"testObserver"),oi.runTests($e)},get onDidChangeTestResults(){return(0,et.$CF)(Be,"testObserver"),at(oi.onResultsChanged)},get testResults(){return(0,et.$CF)(Be,"testObserver"),oi.results}},fi=bt.remote.isRemote?Oe.ExtensionKind.Workspace:Oe.ExtensionKind.UI,nn={getExtension($e,Ee){(0,et.$BF)(Be,"extensionsAny")||(Ee=!1);const ze=ti.mine.getExtensionDescription($e);if(ze)return new X.$6gc(Dt,Be.identifier,ze,fi,!1);if(Ee){const ut=ti.all.getExtensionDescription($e);if(ut)return new X.$6gc(Dt,Be.identifier,ut,fi,!0)}},get all(){const $e=[];for(const Ee of ti.mine.getAllExtensionDescriptions())$e.push(new X.$6gc(Dt,Be.identifier,Ee,fi,!1));return $e},get allAcrossExtensionHosts(){(0,et.$CF)(Be,"extensionsAny");const $e=new p.$mm(ti.mine.getAllExtensionDescriptions().map(ze=>ze.identifier)),Ee=[];for(const ze of ti.all.getAllExtensionDescriptions()){const ut=!$e.has(ze.identifier);Ee.push(new X.$6gc(Dt,Be.identifier,ze,fi,ut))}return Ee},get onDidChange(){return(0,et.$BF)(Be,"extensionsAny")?at(g.Event.any(ti.mine.onDidChange,ti.all.onDidChange)):at(ti.mine.onDidChange)}},rn={createDiagnosticCollection($e){return ui.createDiagnosticCollection(Be.identifier,$e)},get onDidChangeDiagnostics(){return at(ui.onDidChangeDiagnostics)},getDiagnostics:$e=>ui.getDiagnostics($e),getLanguages(){return li.getLanguages()},setTextDocumentLanguage($e,Ee){return li.changeLanguage($e.uri,Ee)},match($e,Ee){const ze=Lt.getDocumentData(Ee.uri)?.notebook;return(0,L.$Bt)(it.LanguageSelector.from($e),Ee.uri,Ee.languageId,!0,ze?.uri,ze?.notebookType)},registerCodeActionsProvider($e,Ee,ze){return dt.registerCodeActionProvider(Be,wt($e),Ee,ze)},registerDocumentPasteEditProvider($e,Ee,ze){return(0,et.$CF)(Be,"documentPaste"),dt.registerDocumentPasteEditProvider(Be,wt($e),Ee,ze)},registerCodeLensProvider($e,Ee){return dt.registerCodeLensProvider(Be,wt($e),Ee)},registerDefinitionProvider($e,Ee){return dt.registerDefinitionProvider(Be,wt($e),Ee)},registerDeclarationProvider($e,Ee){return dt.registerDeclarationProvider(Be,wt($e),Ee)},registerImplementationProvider($e,Ee){return dt.registerImplementationProvider(Be,wt($e),Ee)},registerTypeDefinitionProvider($e,Ee){return dt.registerTypeDefinitionProvider(Be,wt($e),Ee)},registerHoverProvider($e,Ee){return dt.registerHoverProvider(Be,wt($e),Ee,Be.identifier)},registerEvaluatableExpressionProvider($e,Ee){return dt.registerEvaluatableExpressionProvider(Be,wt($e),Ee,Be.identifier)},registerInlineValuesProvider($e,Ee){return dt.registerInlineValuesProvider(Be,wt($e),Ee,Be.identifier)},registerDocumentHighlightProvider($e,Ee){return dt.registerDocumentHighlightProvider(Be,wt($e),Ee)},registerMultiDocumentHighlightProvider($e,Ee){return dt.registerMultiDocumentHighlightProvider(Be,wt($e),Ee)},registerLinkedEditingRangeProvider($e,Ee){return dt.registerLinkedEditingRangeProvider(Be,wt($e),Ee)},registerReferenceProvider($e,Ee){return dt.registerReferenceProvider(Be,wt($e),Ee)},registerRenameProvider($e,Ee){return dt.registerRenameProvider(Be,wt($e),Ee)},registerDocumentSymbolProvider($e,Ee,ze){return dt.registerDocumentSymbolProvider(Be,wt($e),Ee,ze)},registerWorkspaceSymbolProvider($e){return dt.registerWorkspaceSymbolProvider(Be,$e)},registerDocumentFormattingEditProvider($e,Ee){return dt.registerDocumentFormattingEditProvider(Be,wt($e),Ee)},registerDocumentRangeFormattingEditProvider($e,Ee){return dt.registerDocumentRangeFormattingEditProvider(Be,wt($e),Ee)},registerOnTypeFormattingEditProvider($e,Ee,ze,...ut){return dt.registerOnTypeFormattingEditProvider(Be,wt($e),Ee,[ze].concat(ut))},registerDocumentSemanticTokensProvider($e,Ee,ze){return dt.registerDocumentSemanticTokensProvider(Be,wt($e),Ee,ze)},registerDocumentRangeSemanticTokensProvider($e,Ee,ze){return dt.registerDocumentRangeSemanticTokensProvider(Be,wt($e),Ee,ze)},registerSignatureHelpProvider($e,Ee,ze,...ut){return typeof ze=="object"?dt.registerSignatureHelpProvider(Be,wt($e),Ee,ze):dt.registerSignatureHelpProvider(Be,wt($e),Ee,typeof ze>"u"?[]:[ze,...ut])},registerCompletionItemProvider($e,Ee,...ze){return dt.registerCompletionItemProvider(Be,wt($e),Ee,ze)},registerInlineCompletionItemProvider($e,Ee,ze){return Ee.handleDidShowCompletionItem&&(0,et.$CF)(Be,"inlineCompletionsAdditions"),Ee.handleDidPartiallyAcceptCompletionItem&&(0,et.$CF)(Be,"inlineCompletionsAdditions"),ze&&(0,et.$CF)(Be,"inlineCompletionsAdditions"),dt.registerInlineCompletionsProvider(Be,wt($e),Ee,ze)},registerDocumentLinkProvider($e,Ee){return dt.registerDocumentLinkProvider(Be,wt($e),Ee)},registerColorProvider($e,Ee){return dt.registerColorProvider(Be,wt($e),Ee)},registerFoldingRangeProvider($e,Ee){return dt.registerFoldingRangeProvider(Be,wt($e),Ee)},registerSelectionRangeProvider($e,Ee){return dt.registerSelectionRangeProvider(Be,$e,Ee)},registerCallHierarchyProvider($e,Ee){return dt.registerCallHierarchyProvider(Be,$e,Ee)},registerTypeHierarchyProvider($e,Ee){return dt.registerTypeHierarchyProvider(Be,$e,Ee)},setLanguageConfiguration:($e,Ee)=>dt.setLanguageConfiguration(Be,$e,Ee),getTokenInformationAtPosition($e,Ee){return(0,et.$CF)(Be,"tokenInformation"),li.tokenAtPosition($e,Ee)},registerInlayHintsProvider($e,Ee){return dt.registerInlayHintsProvider(Be,$e,Ee)},createLanguageStatusItem($e,Ee){return li.createLanguageStatusItem(Be,$e,Ee)},registerDocumentDropEditProvider($e,Ee,ze){return dt.registerDocumentOnDropEditProvider(Be,$e,Ee,(0,et.$BF)(Be,"dropMetadata")?ze:void 0)}},mn={get activeTextEditor(){return jt.getActiveTextEditor()},get visibleTextEditors(){return jt.getVisibleTextEditors()},get activeTerminal(){return st.activeTerminal},get terminals(){return st.terminals},async showTextDocument($e,Ee,ze){const ut=await($.URI.isUri($e)?Promise.resolve(sn.openTextDocument($e)):Promise.resolve($e));return jt.showTextDocument(ut,Ee,ze)},createTextEditorDecorationType($e){return jt.createTextEditorDecorationType(Be,$e)},onDidChangeActiveTextEditor($e,Ee,ze){return at(jt.onDidChangeActiveTextEditor)($e,Ee,ze)},onDidChangeVisibleTextEditors($e,Ee,ze){return at(jt.onDidChangeVisibleTextEditors)($e,Ee,ze)},onDidChangeTextEditorSelection($e,Ee,ze){return at(jt.onDidChangeTextEditorSelection)($e,Ee,ze)},onDidChangeTextEditorOptions($e,Ee,ze){return at(jt.onDidChangeTextEditorOptions)($e,Ee,ze)},onDidChangeTextEditorVisibleRanges($e,Ee,ze){return at(jt.onDidChangeTextEditorVisibleRanges)($e,Ee,ze)},onDidChangeTextEditorViewColumn($e,Ee,ze){return at(jt.onDidChangeTextEditorViewColumn)($e,Ee,ze)},onDidCloseTerminal($e,Ee,ze){return at(st.onDidCloseTerminal)($e,Ee,ze)},onDidOpenTerminal($e,Ee,ze){return at(st.onDidOpenTerminal)($e,Ee,ze)},onDidChangeActiveTerminal($e,Ee,ze){return at(st.onDidChangeActiveTerminal)($e,Ee,ze)},onDidChangeTerminalDimensions($e,Ee,ze){return(0,et.$CF)(Be,"terminalDimensions"),at(st.onDidChangeTerminalDimensions)($e,Ee,ze)},onDidChangeTerminalState($e,Ee,ze){return at(st.onDidChangeTerminalState)($e,Ee,ze)},onDidWriteTerminalData($e,Ee,ze){return(0,et.$CF)(Be,"terminalDataWriteEvent"),at(st.onDidWriteTerminalData)($e,Ee,ze)},onDidExecuteTerminalCommand($e,Ee,ze){return(0,et.$CF)(Be,"terminalExecuteCommandEvent"),at(st.onDidExecuteTerminalCommand)($e,Ee,ze)},get state(){return Ne.getState(Be)},onDidChangeWindowState($e,Ee,ze){return at(Ne.onDidChangeWindowState)($e,Ee,ze)},showInformationMessage($e,...Ee){return ki.showMessage(Be,b.default.Info,$e,Ee[0],Ee.slice(1))},showWarningMessage($e,...Ee){return ki.showMessage(Be,b.default.Warning,$e,Ee[0],Ee.slice(1))},showErrorMessage($e,...Ee){return ki.showMessage(Be,b.default.Error,$e,Ee[0],Ee.slice(1))},showQuickPick($e,Ee,ze){return si.showQuickPick(Be,$e,Ee,ze)},showWorkspaceFolderPick($e){return si.showWorkspaceFolderPick($e)},showInputBox($e,Ee){return si.showInput($e,Ee)},showOpenDialog($e){return Oi.showOpenDialog(Be,$e)},showSaveDialog($e){return Oi.showSaveDialog($e)},createStatusBarItem($e,Ee,ze){let ut,pt,Mt;return typeof $e=="string"?(ut=$e,pt=Ee,Mt=ze):(pt=$e,Mt=Ee),ei.createStatusBarEntry(Be,ut,pt,Mt)},setStatusBarMessage($e,Ee){return ei.setStatusBarMessage($e,Ee)},withScmProgress($e){return Te.report("window.withScmProgress",Be,"Use 'withProgress' instead."),wi.withProgress(Be,{location:Oe.ProgressLocation.SourceControl},(Ee,ze)=>$e({report(ut){}}))},withProgress($e,Ee){return wi.withProgress(Be,$e,Ee)},createOutputChannel($e,Ee){return It.createOutputChannel($e,Ee,Be)},createWebviewPanel($e,Ee,ze,ut){return Mi.createWebviewPanel(Be,$e,Ee,ze,ut)},createWebviewTextEditorInset($e,Ee,ze,ut){return(0,et.$CF)(Be,"editorInsets"),Pi.createWebviewEditorInset($e,Ee,ze,ut,Be)},createTerminal($e,Ee,ze){return typeof $e=="object"?"pty"in $e?st.createExtensionTerminal($e):st.createTerminalFromOptions($e):st.createTerminal($e,Ee,ze)},registerTerminalLinkProvider($e){return st.registerLinkProvider($e)},registerTerminalProfileProvider($e,Ee){return st.registerProfileProvider(Be,$e,Ee)},registerTerminalQuickFixProvider($e,Ee){return(0,et.$CF)(Be,"terminalQuickFixProvider"),st.registerTerminalQuickFixProvider($e,Be.identifier.value,Ee)},registerTreeDataProvider($e,Ee){return $i.registerTreeDataProvider($e,Ee,Be)},createTreeView($e,Ee){return $i.createTreeView($e,Ee,Be)},registerWebviewPanelSerializer:($e,Ee)=>Mi.registerWebviewPanelSerializer(Be,$e,Ee),registerCustomEditorProvider:($e,Ee,ze={})=>un.registerCustomEditorProvider(Be,$e,Ee,ze),registerFileDecorationProvider($e){return Ve.registerFileDecorationProvider($e,Be)},registerUriHandler($e){return gi.registerUriHandler(Be,$e)},createQuickPick(){return si.createQuickPick(Be)},createInputBox(){return si.createInputBox(Be)},get activeColorTheme(){return Li.activeColorTheme},onDidChangeActiveColorTheme($e,Ee,ze){return at(Li.onDidChangeActiveColorTheme)($e,Ee,ze)},registerWebviewViewProvider($e,Ee,ze){return Ti.registerWebviewViewProvider(Be,$e,Ee,ze?.webviewOptions)},get activeNotebookEditor(){return Pt.activeNotebookEditor},onDidChangeActiveNotebookEditor($e,Ee,ze){return at(Pt.onDidChangeActiveNotebookEditor)($e,Ee,ze)},get visibleNotebookEditors(){return Pt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return at(Pt.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection($e,Ee,ze){return at(mi.onDidChangeNotebookEditorSelection)($e,Ee,ze)},onDidChangeNotebookEditorVisibleRanges($e,Ee,ze){return at(mi.onDidChangeNotebookEditorVisibleRanges)($e,Ee,ze)},showNotebookDocument($e,Ee){return Pt.showNotebookDocument($e,Ee)},registerExternalUriOpener($e,Ee,ze){return(0,et.$CF)(Be,"externalUriOpener"),ln.registerExternalUriOpener(Be.identifier,$e,Ee,ze)},registerProfileContentHandler($e,Ee){return(0,et.$CF)(Be,"profileContentHandlers"),hn.registerProfileContentHandler(Be,$e,Ee)},registerQuickDiffProvider($e,Ee,ze,ut){return(0,et.$CF)(Be,"quickDiffProvider"),Ri.registerQuickDiffProvider(wt($e),Ee,ze,ut)},get tabGroups(){return se.tabGroups},registerShareProvider($e,Ee){return(0,et.$CF)(Be,"shareProvider"),Qi.registerShareProvider(wt($e),Ee)}},sn={get rootPath(){return Te.report("workspace.rootPath",Be,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath($e){throw new O.$9("rootPath")},getWorkspaceFolder($e){return ft.getWorkspaceFolder($e)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name($e){throw new O.$9("name")},get workspaceFile(){return ft.workspaceFile},set workspaceFile($e){throw new O.$9("workspaceFile")},updateWorkspaceFolders:($e,Ee,...ze)=>ft.updateWorkspaceFolders(Be,$e,Ee||0,...ze),onDidChangeWorkspaceFolders:function($e,Ee,ze){return at(ft.onDidChangeWorkspace)($e,Ee,ze)},asRelativePath:($e,Ee)=>ft.getRelativePath($e,Ee),findFiles:($e,Ee,ze,ut)=>ft.findFiles($e,Ee,ze,Be.identifier,ut),findTextInFiles:($e,Ee,ze,ut)=>{(0,et.$CF)(Be,"findTextInFiles");let pt,Mt;return typeof Ee=="object"?(pt=Ee,Mt=ze):(pt={},Mt=Ee,ut=ze),ft.findTextInFiles($e,pt||{},Mt,Be.identifier,ut)},save:$e=>ft.save($e),saveAs:$e=>ft.saveAs($e),saveAll:$e=>ft.saveAll($e),applyEdit($e,Ee){return Xt.applyWorkspaceEdit($e,Be,Ee)},createFileSystemWatcher:($e,Ee,ze,ut)=>{let pt;return typeof Ee=="boolean"?pt={ignoreCreateEvents:!!Ee,ignoreChangeEvents:!!ze,ignoreDeleteEvents:!!ut,correlate:!1}:Ee&&((0,et.$CF)(Be,"createFileSystemWatcher"),pt={...Ee,correlate:!0}),_t.createFileSystemWatcher(ft,Be,$e,pt)},get textDocuments(){return Lt.getAllDocumentData().map($e=>$e.document)},set textDocuments($e){throw new O.$9("textDocuments")},openTextDocument($e){let Ee;const ze=$e;if(typeof $e=="string")Ee=Promise.resolve($.URI.file($e));else if($.URI.isUri($e))Ee=Promise.resolve($e);else if(!ze||typeof ze=="object")Ee=Lt.createDocumentData(ze);else throw new Error("illegal argument - uriOrFileNameOrOptions");return Ee.then(ut=>Lt.ensureDocumentData(ut).then(pt=>pt.document))},onDidOpenTextDocument:($e,Ee,ze)=>at(Lt.onDidAddDocument)($e,Ee,ze),onDidCloseTextDocument:($e,Ee,ze)=>at(Lt.onDidRemoveDocument)($e,Ee,ze),onDidChangeTextDocument:($e,Ee,ze)=>at(Lt.onDidChangeDocument)($e,Ee,ze),onDidSaveTextDocument:($e,Ee,ze)=>at(Lt.onDidSaveDocument)($e,Ee,ze),onWillSaveTextDocument:($e,Ee,ze)=>at(Gi.getOnWillSaveTextDocumentEvent(Be))($e,Ee,ze),get notebookDocuments(){return Pt.notebookDocuments.map($e=>$e.apiNotebook)},async openNotebookDocument($e,Ee){let ze;if($.URI.isUri($e))ze=$e,await Pt.openNotebookDocument($e);else if(typeof $e=="string")ze=$.URI.revive(await Pt.createNotebookDocument({viewType:$e,content:Ee}));else throw new Error("Invalid arguments");return Pt.getNotebookDocument(ze).apiNotebook},onDidSaveNotebookDocument($e,Ee,ze){return at(ri.onDidSaveNotebookDocument)($e,Ee,ze)},onDidChangeNotebookDocument($e,Ee,ze){return at(ri.onDidChangeNotebookDocument)($e,Ee,ze)},onWillSaveNotebookDocument($e,Ee,ze){return at(Ii.getOnWillSaveNotebookDocumentEvent(Be))($e,Ee,ze)},get onDidOpenNotebookDocument(){return at(Pt.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return at(Pt.onDidCloseNotebookDocument)},registerNotebookSerializer($e,Ee,ze,ut){return Pt.registerNotebookSerializer(Be,$e,Ee,ze,(0,et.$BF)(Be,"notebookLiveShare")?ut:void 0)},onDidChangeConfiguration:($e,Ee,ze)=>at(tn.onDidChangeConfiguration)($e,Ee,ze),getConfiguration($e,Ee){return Ee=arguments.length===1?void 0:Ee,tn.getConfiguration($e,Ee,Be)},registerTextDocumentContentProvider($e,Ee){return Di.registerTextDocumentContentProvider($e,Ee)},registerTaskProvider:($e,Ee)=>(Te.report("window.registerTaskProvider",Be,"Use the corresponding function on the 'tasks' namespace instead"),kt.registerTaskProvider(Be,$e,Ee)),registerFileSystemProvider($e,Ee,ze){return(0,I.$Qc)(Ji.registerFileSystemProvider(Be,$e,Ee,ze),Vt.addFileSystemProvider($e,Ee,ze))},get fs(){return Vt.value},registerFileSearchProvider:($e,Ee)=>((0,et.$CF)(Be,"fileSearchProvider"),Bt.registerFileSearchProvider($e,Ee)),registerTextSearchProvider:($e,Ee)=>((0,et.$CF)(Be,"textSearchProvider"),Bt.registerTextSearchProvider($e,Ee)),registerRemoteAuthorityResolver:($e,Ee)=>((0,et.$CF)(Be,"resolvers"),Dt.registerRemoteAuthorityResolver($e,Ee)),registerResourceLabelFormatter:$e=>((0,et.$CF)(Be,"resolvers"),Yi.$registerResourceLabelFormatter($e)),getRemoteExecServer:$e=>((0,et.$CF)(Be,"resolvers"),Dt.getRemoteExecServer($e)),onDidCreateFiles:($e,Ee,ze)=>at(_t.onDidCreateFile)($e,Ee,ze),onDidDeleteFiles:($e,Ee,ze)=>at(_t.onDidDeleteFile)($e,Ee,ze),onDidRenameFiles:($e,Ee,ze)=>at(_t.onDidRenameFile)($e,Ee,ze),onWillCreateFiles:($e,Ee,ze)=>at(_t.getOnWillCreateFileEvent(Be))($e,Ee,ze),onWillDeleteFiles:($e,Ee,ze)=>at(_t.getOnWillDeleteFileEvent(Be))($e,Ee,ze),onWillRenameFiles:($e,Ee,ze)=>at(_t.getOnWillRenameFileEvent(Be))($e,Ee,ze),openTunnel:$e=>((0,et.$CF)(Be,"tunnels"),Ft.openTunnel(Be,$e).then(Ee=>{if(!Ee)throw new Error("cannot open tunnel");return Ee})),get tunnels(){return(0,et.$CF)(Be,"tunnels"),Ft.getTunnels()},onDidChangeTunnels:($e,Ee,ze)=>((0,et.$CF)(Be,"tunnels"),at(Ft.onDidChangeTunnels)($e,Ee,ze)),registerPortAttributesProvider:($e,Ee)=>((0,et.$CF)(Be,"portsAttributes"),Ft.registerPortsAttributesProvider($e,Ee)),registerTunnelProvider:($e,Ee)=>((0,et.$CF)(Be,"tunnelFactory"),Ft.registerTunnelProvider($e,Ee)),registerTimelineProvider:($e,Ee)=>((0,et.$CF)(Be,"timeline"),Xi.registerTimelineProvider($e,Ee,Be.identifier,Ke.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:$e=>((0,et.$CF)(Be,"workspaceTrust"),ft.requestWorkspaceTrust($e)),onDidGrantWorkspaceTrust:($e,Ee,ze)=>at(ft.onDidGrantWorkspaceTrust)($e,Ee,ze),registerEditSessionIdentityProvider:($e,Ee)=>((0,et.$CF)(Be,"editSessionIdentityProvider"),ft.registerEditSessionIdentityProvider($e,Ee)),onWillCreateEditSessionIdentity:($e,Ee,ze)=>((0,et.$CF)(Be,"editSessionIdentityProvider"),at(ft.getOnWillCreateEditSessionIdentityEvent(Be))($e,Ee,ze)),registerCanonicalUriProvider:($e,Ee)=>((0,et.$CF)(Be,"canonicalUriProvider"),ft.registerCanonicalUriProvider($e,Ee)),getCanonicalUri:($e,Ee,ze)=>((0,et.$CF)(Be,"canonicalUriProvider"),ft.provideCanonicalUri($e,Ee,ze))},on={get inputBox(){return Te.report("scm.inputBox",Be,"Use 'SourceControl.inputBox' instead"),bi.getLastInputBox(Be)},createSourceControl($e,Ee,ze){return bi.createSourceControl(Be,$e,Ee,ze)}},an={createCommentController($e,Ee){return Ai.createCommentController(Be,$e,Ee)}},zi={get activeDebugSession(){return $t.activeDebugSession},get activeDebugConsole(){return $t.activeDebugConsole},get breakpoints(){return $t.breakpoints},get stackFrameFocus(){return $t.stackFrameFocus},onDidStartDebugSession($e,Ee,ze){return at($t.onDidStartDebugSession)($e,Ee,ze)},onDidTerminateDebugSession($e,Ee,ze){return at($t.onDidTerminateDebugSession)($e,Ee,ze)},onDidChangeActiveDebugSession($e,Ee,ze){return at($t.onDidChangeActiveDebugSession)($e,Ee,ze)},onDidReceiveDebugSessionCustomEvent($e,Ee,ze){return at($t.onDidReceiveDebugSessionCustomEvent)($e,Ee,ze)},onDidChangeBreakpoints($e,Ee,ze){return at($t.onDidChangeBreakpoints)($e,Ee,ze)},onDidChangeStackFrameFocus($e,Ee,ze){return(0,et.$CF)(Be,"debugFocus"),at($t.onDidChangeStackFrameFocus)($e,Ee,ze)},registerDebugConfigurationProvider($e,Ee,ze){return $t.registerDebugConfigurationProvider($e,Ee,ze||Ut.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory($e,Ee){return $t.registerDebugAdapterDescriptorFactory(Be,$e,Ee)},registerDebugAdapterTrackerFactory($e,Ee){return $t.registerDebugAdapterTrackerFactory($e,Ee)},startDebugging($e,Ee,ze){return!ze||typeof ze=="object"&&"configuration"in ze?$t.startDebugging($e,Ee,{parentSession:ze}):$t.startDebugging($e,Ee,ze||{})},stopDebugging($e){return $t.stopDebugging($e)},addBreakpoints($e){return $t.addBreakpoints($e)},removeBreakpoints($e){return $t.removeBreakpoints($e)},asDebugSourceUri($e,Ee){return $t.asDebugSourceUri($e,Ee)}},Bi={registerTaskProvider:($e,Ee)=>kt.registerTaskProvider(Be,$e,Ee),fetchTasks:$e=>kt.fetchTasks($e),executeTask:$e=>kt.executeTask(Be,$e),get taskExecutions(){return kt.taskExecutions},onDidStartTask:($e,Ee,ze)=>at(kt.onDidStartTask)($e,Ee,ze),onDidEndTask:($e,Ee,ze)=>at(kt.onDidEndTask)($e,Ee,ze),onDidStartTaskProcess:($e,Ee,ze)=>at(kt.onDidStartTaskProcess)($e,Ee,ze),onDidEndTaskProcess:($e,Ee,ze)=>at(kt.onDidEndTaskProcess)($e,Ee,ze)},Wi={createNotebookController($e,Ee,ze,ut,pt){return ci.createNotebookController(Be,$e,Ee,ze,ut,(0,et.$BF)(Be,"notebookMessaging")?pt:void 0)},registerNotebookCellStatusBarItemProvider:($e,Ee)=>Pt.registerNotebookCellStatusBarItemProvider(Be,$e,Ee),createRendererMessaging($e){return Ci.createRendererMessaging(Be,$e)},createNotebookControllerDetectionTask($e){return(0,et.$CF)(Be,"notebookKernelSource"),ci.createNotebookControllerDetectionTask(Be,$e)},registerKernelSourceActionProvider($e,Ee){return(0,et.$CF)(Be,"notebookKernelSource"),ci.registerKernelSourceActionProvider(Be,$e,Ee)},onDidChangeNotebookCellExecutionState($e,Ee,ze){return(0,et.$CF)(Be,"notebookCellExecutionState"),at(ci.onDidChangeNotebookCellExecutionState)($e,Ee,ze)}},Si={t(...$e){if(typeof $e[0]=="string"){const Ee=$e.shift(),ze=!$e||typeof $e[0]!="object"?$e:$e[0];return yt.getMessage(Be.identifier.value,{message:Ee,args:ze})}return yt.getMessage(Be.identifier.value,$e[0])},get bundle(){return yt.getBundle(Be.identifier.value)},get uri(){return yt.getBundleUri(Be.identifier.value)}},Vi={_version:1,registerInteractiveEditorSessionProvider($e,Ee){return(0,et.$CF)(Be,"interactive"),Zi.registerProvider(Be,$e,Ee)},registerInteractiveSessionProvider($e,Ee){return(0,et.$CF)(Be,"interactive"),pi.registerChatProvider(Be,$e,Ee)},sendInteractiveRequestToProvider($e,Ee){return(0,et.$CF)(Be,"interactive"),pi.sendInteractiveRequestToProvider($e,Ee)},transferChatSession($e,Ee){return(0,et.$CF)(Be,"interactive"),pi.transferChatSession($e,Ee)}},qi={getRelatedInformation($e,Ee){return(0,et.$CF)(Be,"aiRelatedInformation"),en.getRelatedInformation(Be,$e,Ee)},registerRelatedInformationProvider($e,Ee){return(0,et.$CF)(Be,"aiRelatedInformation"),en.registerRelatedInformationProvider(Be,$e,Ee)},registerEmbeddingVectorProvider($e,Ee){return(0,et.$CF)(Be,"aiRelatedInformation"),Fi.registerEmbeddingVectorProvider(Be,$e,Ee)}},$n={registerChatResponseProvider($e,Ee,ze){return(0,et.$CF)(Be,"chatProvider"),di.registerProvider(Be.identifier,$e,Ee,ze)},requestChatAccess($e){return(0,et.$CF)(Be,"chatRequestAccess"),di.requestChatResponseProvider(Be.identifier,$e)},registerVariable($e,Ee,ze){return(0,et.$CF)(Be,"chatAgents2"),_i.registerVariableResolver(Be,$e,Ee,ze)},registerMappedEditsProvider($e,Ee){return(0,et.$CF)(Be,"mappedEditsProvider"),dt.registerMappedEditsProvider(Be,$e,Ee)},createChatAgent($e,Ee){return(0,et.$CF)(Be,"chatAgents2"),xi.createChatAgent(Be,$e,Ee)}},bn={registerSpeechProvider($e,Ee){return(0,et.$CF)(Be,"speech"),yi.registerProvider(Be.identifier,$e,Ee)}};return{version:bt.version,ai:qi,authentication:fn,commands:gn,comments:an,chat:$n,debug:zi,env:ji,extensions:nn,interactive:Vi,l10n:Si,languages:rn,notebooks:Wi,scm:on,speech:bn,tasks:Bi,tests:Ui,window:mn,workspace:sn,Breakpoint:Oe.$7L,TerminalOutputAnchor:Oe.TerminalOutputAnchor,ChatAgentResultFeedbackKind:Oe.ChatAgentResultFeedbackKind,ChatMessage:Oe.$YM,ChatMessageRole:Oe.ChatMessageRole,ChatVariableLevel:Oe.ChatVariableLevel,ChatAgentCompletionItem:Oe.$XM,CallHierarchyIncomingCall:Oe.$tL,CallHierarchyItem:Oe.$sL,CallHierarchyOutgoingCall:Oe.$uL,CancellationError:O.$5,CancellationTokenSource:D.$6d,CandidatePortSource:r.CandidatePortSource,CodeAction:Oe.$pL,CodeActionKind:Oe.$qL,CodeActionTriggerKind:Oe.CodeActionTriggerKind,CodeLens:Oe.$vL,Color:Oe.$IL,ColorInformation:Oe.$JL,ColorPresentation:Oe.$KL,ColorThemeKind:Oe.ColorThemeKind,CommentMode:Oe.CommentMode,CommentState:Oe.CommentState,CommentThreadCollapsibleState:Oe.CommentThreadCollapsibleState,CommentThreadState:Oe.CommentThreadState,CompletionItem:Oe.$CL,CompletionItemKind:Oe.CompletionItemKind,CompletionItemTag:Oe.CompletionItemTag,CompletionList:Oe.$DL,CompletionTriggerKind:Oe.CompletionTriggerKind,ConfigurationTarget:Oe.ConfigurationTarget,CustomExecution:Oe.$SL,DebugAdapterExecutable:Oe.$$L,DebugAdapterInlineImplementation:Oe.$bM,DebugAdapterNamedPipeServer:Oe.$aM,DebugAdapterServer:Oe.$_L,DebugConfigurationProviderTriggerKind:Ut.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Oe.DebugConsoleMode,DecorationRangeBehavior:Oe.DecorationRangeBehavior,Diagnostic:Oe.$jL,DiagnosticRelatedInformation:Oe.$iL,DiagnosticSeverity:Oe.DiagnosticSeverity,DiagnosticTag:Oe.DiagnosticTag,Disposable:Oe.$8K,DocumentHighlight:Oe.$lL,DocumentHighlightKind:Oe.DocumentHighlightKind,MultiDocumentHighlight:Oe.$mL,DocumentLink:Oe.$HL,DocumentSymbol:Oe.$oL,EndOfLine:Oe.EndOfLine,EnvironmentVariableMutatorType:Oe.EnvironmentVariableMutatorType,EvaluatableExpression:Oe.$eM,InlineValueText:Oe.$fM,InlineValueVariableLookup:Oe.$gM,InlineValueEvaluatableExpression:Oe.$hM,InlineCompletionTriggerKind:Oe.InlineCompletionTriggerKind,EventEmitter:g.$Vd,ExtensionKind:Oe.ExtensionKind,ExtensionMode:Oe.ExtensionMode,ExternalUriOpenerPriority:Oe.ExternalUriOpenerPriority,FileChangeType:Oe.FileChangeType,FileDecoration:Oe.$rM,FileDecoration2:Oe.$rM,FileSystemError:Oe.$jM,FileType:S.FileType,FilePermission:S.FilePermission,FoldingRange:Oe.$kM,FoldingRangeKind:Oe.FoldingRangeKind,FunctionBreakpoint:Oe.$9L,InlineCompletionItem:Oe.$EL,InlineCompletionList:Oe.$FL,Hover:Oe.$kL,IndentAction:C.IndentAction,Location:Oe.$hL,MarkdownString:Oe.$wL,OverviewRulerLane:m.OverviewRulerLane,ParameterInformation:Oe.$xL,PortAutoForwardAction:Oe.PortAutoForwardAction,Position:Oe.$9K,ProcessExecution:Oe.$QL,ProgressLocation:Oe.ProgressLocation,QuickInputButtons:Oe.$qM,Range:Oe.$0K,RelativePattern:Oe.$5L,Selection:Oe.$$K,SelectionRange:Oe.$rL,SemanticTokens:Oe.$nM,SemanticTokensBuilder:Oe.$mM,SemanticTokensEdit:Oe.$oM,SemanticTokensEdits:Oe.$pM,SemanticTokensLegend:Oe.$lM,ShellExecution:Oe.$RL,ShellQuoting:Oe.ShellQuoting,SignatureHelp:Oe.$zL,SignatureHelpTriggerKind:Oe.SignatureHelpTriggerKind,SignatureInformation:Oe.$yL,SnippetString:Oe.$gL,SourceBreakpoint:Oe.$8L,StandardTokenType:Oe.StandardTokenType,StatusBarAlignment:Oe.StatusBarAlignment,SymbolInformation:Oe.$nL,SymbolKind:Oe.SymbolKind,SymbolTag:Oe.SymbolTag,Task:Oe.$TL,TaskGroup:Oe.$PL,TaskPanelKind:Oe.TaskPanelKind,TaskRevealKind:Oe.TaskRevealKind,TaskScope:Oe.TaskScope,TerminalLink:Oe.$LL,TerminalQuickFixTerminalCommand:Oe.$NL,TerminalQuickFixOpener:Oe.$ML,TerminalLocation:Oe.TerminalLocation,TerminalProfile:Oe.$OL,TerminalExitReason:Oe.TerminalExitReason,TextDocumentSaveReason:Oe.TextDocumentSaveReason,TextEdit:Oe.$cL,SnippetTextEdit:Oe.$eL,TextEditorCursorStyle:y.TextEditorCursorStyle,TextEditorLineNumbersStyle:Oe.TextEditorLineNumbersStyle,TextEditorRevealType:Oe.TextEditorRevealType,TextEditorSelectionChangeKind:Oe.TextEditorSelectionChangeKind,SyntaxTokenType:Oe.SyntaxTokenType,TextDocumentChangeReason:Oe.TextDocumentChangeReason,ThemeColor:Oe.$4L,ThemeIcon:Oe.$3L,TreeItem:Oe.$UL,TreeItemCheckboxState:Oe.TreeItemCheckboxState,TreeItemCollapsibleState:Oe.TreeItemCollapsibleState,TypeHierarchyItem:Oe.$MM,UIKind:At.UIKind,Uri:$.URI,ViewColumn:Oe.ViewColumn,WorkspaceEdit:Oe.$fL,DocumentDropEdit:Oe.$1L,DocumentPasteEdit:Oe.$2L,InlayHint:Oe.$BL,InlayHintLabelPart:Oe.$AL,InlayHintKind:Oe.InlayHintKind,RemoteAuthorityResolverError:Oe.$bL,ResolvedAuthority:Oe.$_K,ManagedResolvedAuthority:Oe.$aL,SourceControlInputBoxValidationType:Oe.SourceControlInputBoxValidationType,ExtensionRuntime:Oe.ExtensionRuntime,TimelineItem:Oe.$BM,NotebookRange:Oe.$tM,NotebookCellKind:Oe.NotebookCellKind,NotebookCellExecutionState:Oe.NotebookCellExecutionState,NotebookCellData:Oe.$uM,NotebookData:Oe.$vM,NotebookRendererScript:Oe.$zM,NotebookCellStatusBarAlignment:Oe.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Oe.NotebookEditorRevealType,NotebookCellOutput:Oe.$xM,NotebookCellOutputItem:Oe.$wM,NotebookCellStatusBarItem:Oe.$yM,NotebookControllerAffinity:Oe.NotebookControllerAffinity,NotebookControllerAffinity2:Oe.NotebookControllerAffinity2,NotebookEdit:Oe.$dL,NotebookKernelSourceAction:Oe.$AM,NotebookVariablesRequestKind:Oe.NotebookVariablesRequestKind,PortAttributes:Oe.$DM,LinkedEditingRanges:Oe.$CM,TestResultState:Oe.TestResultState,TestRunRequest:Oe.$EM,TestMessage:Oe.$FM,TestMessage2:Oe.$FM,TestTag:Oe.$GM,TestRunProfileKind:Oe.TestRunProfileKind,TextSearchCompleteMessageType:Gt.TextSearchCompleteMessageType,DataTransfer:Oe.$ZL,DataTransferItem:Oe.$VL,CoveredCount:Oe.$HM,FileCoverage:Oe.$IM,StatementCoverage:Oe.$JM,BranchCoverage:Oe.$KM,FunctionCoverage:Oe.$LM,WorkspaceTrustState:Oe.WorkspaceTrustState,LanguageStatusSeverity:Oe.LanguageStatusSeverity,QuickPickItemKind:Oe.QuickPickItemKind,InputBoxValidationSeverity:Oe.InputBoxValidationSeverity,TabInputText:Oe.$NM,TabInputTextDiff:Oe.$OM,TabInputTextMerge:Oe.$PM,TabInputCustom:Oe.$QM,TabInputNotebook:Oe.$SM,TabInputNotebookDiff:Oe.$TM,TabInputWebview:Oe.$RM,TabInputTerminal:Oe.$UM,TabInputInteractiveWindow:Oe.$VM,TabInputChat:Oe.$WM,TelemetryTrustedValue:o.$Lo,LogLevel:h.LogLevel,EditSessionIdentityMatch:i.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Oe.InteractiveSessionVoteDirection,ChatAgentCopyKind:Oe.ChatAgentCopyKind,InteractiveEditorResponseFeedbackKind:Oe.InteractiveEditorResponseFeedbackKind,StackFrameFocus:Oe.$cM,ThreadFocus:Oe.$dM,RelatedInformationType:Oe.RelatedInformationType,SpeechToTextStatus:Oe.SpeechToTextStatus}}}e.$$hc=Jt}),define(ke[369],Se([1,0,106,152,41,149,42,35,69,46,95,96,97,118,72,91,151,71,58,117,90,70,150,13,59,115,116]),function(me,e,D,O,g,I,A,b,$,y,L,C,m,p,S,h,f,o,i,r,n,c,t,u,s,l,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,D.$Yr)(l.$Zgc,l.$Ygc,1),(0,D.$Yr)(u.$oj,t.$_hc,1),(0,D.$Yr)(h.$$fc,h.$_fc,1),(0,D.$Yr)(b.$tN,b.$sN,0),(0,D.$Yr)(A.$tgc,A.$rgc,0),(0,D.$Yr)(o.$vgc,o.$ugc,0),(0,D.$Yr)(C.$0gc,C.$bhc,0),(0,D.$Yr)(I.$dhc,I.$chc,0),(0,D.$Yr)($.$iN,$.$hN,0),(0,D.$Yr)(a.$1gc,a.$2gc,0),(0,D.$Yr)(i.$8fc,i.$7fc,0),(0,D.$Yr)(O.$Jhc,O.$Ihc,1),(0,D.$Yr)(m.$thc,m.$uhc,0),(0,D.$Yr)(p.$Ogc,p.$Ngc,0),(0,D.$Yr)(L.$Whc,L.$Vhc,0),(0,D.$Yr)(y.$Rgc,y.$Ugc,0),(0,D.$Yr)(S.$oyb,S.$pyb,0),(0,D.$Yr)(f.$0hc,f.$9hc,0),(0,D.$Yr)(g.$qgc,g.$pgc,0),(0,D.$Yr)(r.$Wgc,r.$Vgc,0),(0,D.$Yr)(n.$rN,n.$oN,0),(0,D.$Yr)(c.$Fgc,c.$Ggc,0),(0,D.$Yr)(s.$8gc,s.$9gc,0)}),define(ke[119],Se([1,0,19,13,36,94]),function(me,e,D,O,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ric=e.$qic=e.$pic=void 0;function A(C){return C.startsWith("**")||C.startsWith("/")?C:`/${C}`}e.$pic=A;function b(C,m,p,S){const h=(0,D.$2b)(p,$),f=new g.$vJ(m,h,S),o=f.preview.matches;return{ranges:(0,D.$2b)(h,y),uri:C,preview:{text:f.preview.text,matches:(0,D.$2b)(o,y)}}}e.$qic=b;function $(C){return new g.$wJ(C.start.line,C.start.character,C.end.line,C.end.character)}function y(C){return new I.$kJ(C.startLineNumber,C.startColumn,C.endLineNumber,C.endColumn)}let L=class{constructor(m,p){this.a=m,this.b=p}appendLine(m){this.b.debug(`${this.a}#search`,m)}};e.$ric=L,e.$ric=L=Ge([We(1,O.$nj)],L)}),define(ke[370],Se([1,0,50,16,76,33,10,12,119,371]),function(me,e,D,O,g,I,A,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uic=e.$tic=e.$sic=void 0;const L=y.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function C(r,n,c,t){const u=m(r,n,c,t),s=n.folder.fsPath;return{cmd:D.spawn(L,u.args,{cwd:s}),rgDiskPath:L,siblingClauses:u.siblingClauses,rgArgs:u,cwd:s}}e.$sic=C;function m(r,n,c,t){const u=["--files","--hidden","--case-sensitive","--no-require-git"];S([n],c,!1).forEach(l=>{const a=(0,$.$pic)(l);if(u.push("-g",a),A.$j){const d=(0,g.$Hl)(a);d!==a&&u.push("-g",d)}});const s=p([n],t,void 0,!1);return s.globArgs.forEach(l=>{const a=`!${(0,$.$pic)(l)}`;if(u.push("-g",a),A.$j){const d=(0,g.$Hl)(a);d!==a&&u.push("-g",d)}}),n.disregardIgnoreFiles!==!1?u.push("--no-ignore"):n.disregardParentIgnoreFiles!==!1&&u.push("--no-ignore-parent"),n.ignoreSymlinks||u.push("--follow"),r.exists&&u.push("--quiet"),u.push("--no-config"),n.disregardGlobalIgnoreFiles&&u.push("--no-ignore-global"),{args:u,siblingClauses:s.siblingClauses}}function p(r,n,c,t=!0){const u=[];let s={};return r.forEach(l=>{const a=Object.assign({},l.excludePattern||{},n||{}),d=h(a,t?l.folder.fsPath:void 0,c);u.push(...d.globArgs),d.siblingClauses&&(s=Object.assign(s,d.siblingClauses))}),{globArgs:u,siblingClauses:s}}function S(r,n,c=!0){const t=[];return r.forEach(u=>{const s=Object.assign({},n||{},u.includePattern||{}),l=h(s,c?u.folder.fsPath:void 0);t.push(...l.globArgs)}),t}function h(r,n,c){const t=[],u={};return Object.keys(r).forEach(s=>{if(c&&c.has(s)||!s)return;const l=r[s];s=o(n?f(n,s):s),s.startsWith("\\\\")?s="\\\\"+s.substr(2).replace(/\\/g,"/"):s=s.replace(/\\/g,"/"),typeof l=="boolean"&&l?(s.startsWith("\\\\")&&(s+="**"),t.push(i(s))):l&&l.when&&(u[s]=l)}),{globArgs:t,siblingClauses:u}}function f(r,n){return O.$ic(n)?n:O.$jc(r,n)}e.$tic=f;function o(r){return r=b.$Ue(r,"\\"),b.$Ue(r,"/")}function i(r){return I.$4f(r).toLowerCase()==="c:/"?r.replace(/^c:[/\\]/i,"/"):r}e.$uic=i}),define(ke[372],Se([1,0,50,56,16,373,19,44,34,76,33,10,38,12,18,31,36,370,129]),function(me,e,D,O,g,I,A,b,$,y,L,C,m,p,S,h,f,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wic=e.$vic=void 0;const r=new Set;process.on("exit",()=>{r.forEach(s=>s())});class n{constructor(l){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=l,this.b=l.filePattern||"",this.d=l.includePattern&&$.$Mj(l.includePattern),this.f=l.maxResults||null,this.g=!!l.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=(0,i.$Zq)(this.b).normalizedLowercase),this.u=l.excludePattern&&$.$Mj(l.excludePattern),this.t=new Map,l.folderQueries.forEach(a=>{const d=Object.assign({},a.excludePattern||{},this.a.excludePattern||{}),k=a.folder.fsPath;l.folderQueries.map(R=>R.folder.fsPath).filter(R=>R!==k).forEach(R=>{(0,L.$8f)(R,k)&&(d[g.$lc(k,R)]=!0)}),this.t.set(k,new t(d,k))})}cancel(){this.l=!0,r.forEach(l=>l())}walk(l,a,d,k,R){if(this.m=m.$Rd.create(!1),this.l)return R(null,this.j);a.forEach(v=>{const w=g.$nc(v.fsPath);this.u&&this.u(v.fsPath,w)||this.J(d,{relativePath:v.fsPath,searchPath:void 0})}),this.r=m.$Rd.create(!1),this.w(l,(v,w)=>{this.x(this.y,this,v,d,k,E=>{if(E){const P=(0,b.$Qi)(E);console.error(P),this.q.push(P),w(E,void 0)}else w(null,void 0)})},(v,w)=>{this.m.stop();const E=v?A.$Hb(v)[0]:null;R(E,this.j)})}w(l,a,d){const k=new Array(l.length),R=new Array(l.length);let v=!1,w=0;if(l.length===0)return d(null,[]);l.forEach((E,P)=>{a(E,(N,U)=>{if(N?(v=!0,k[P]=null,R[P]=N):(k[P]=U,R[P]=null),++w===l.length)return d(v?R:null,k)})})}x(l,a,...d){try{l.apply(a,d)}catch(k){d[d.length-1](k)}}y(l,a,d,k){const R=l.folder.fsPath,v=C.$j,w=()=>F&&F.kill();r.add(w);let E=B=>{r.delete(w),E=()=>{},k(B)},P="";const N=this.D(),U=(0,o.$sic)(this.a,l,this.a.includePattern,this.t.get(l.folder.fsPath).expression),F=U.cmd,j=!Object.keys(U.siblingClauses).length,T=U.rgArgs.args.map(B=>B.match(/^-/)?B:`'${B}'`).join(" ");let M=`${U.rgDiskPath} ${T}
 - cwd: ${U.cwd}`;U.rgArgs.siblingClauses&&(M+=`
 - Sibling clauses: ${JSON.stringify(U.rgArgs.siblingClauses)}`),d({message:M}),this.s=0,this.z(F,"utf8",d,(B,Y,ue)=>{if(B){E(B);return}if(this.j){E();return}const J=(P+(v?y.$Gl(Y||""):Y)).split(`
`);if(ue){const X=J.length;J[X-1]=J[X-1].trim(),J[X-1]||J.pop()}else P=J.pop()||"";if(J.length&&J[0].indexOf(`
`)!==-1){E(new Error("Splitting up files failed"));return}if(this.s+=J.length,j){for(const X of J)if(this.J(a,{base:R,relativePath:X,searchPath:this.N(l,X)}),this.j){w();break}(ue||this.j)&&E();return}this.G(l,N,R,J,a),ue&&(this.H(N,R,a),E())})}spawnFindCmd(l){const a=this.t.get(l.folder.fsPath),d=a.getBasenameTerms(),k=a.getPathTerms(),R=["-L","."];if(d.length||k.length){R.push("-not","(","(");for(const v of d)R.push("-name",v),R.push("-o");for(const v of k)R.push("-path",v),R.push("-o");R.pop(),R.push(")","-prune",")")}return R.push("-type","f"),D.spawn("find",R,{cwd:l.folder.fsPath})}readStdout(l,a,d){let k="";this.z(l,a,()=>{},(R,v,w)=>{if(R){d(R);return}k+=v,w&&d(null,k)})}z(l,a,d,k){let R=(E,P,N)=>{(E||N)&&(R=()=>{},this.r?.stop()),k(E,P,N)},v=!1;l.stdout?(this.A(l.stdout,a,R),l.stdout.once("data",()=>v=!0)):d({message:"stdout is null"});let w;l.stderr?w=this.B(l.stderr):d({message:"stderr is null"}),l.on("error",E=>{R(E)}),l.on("close",E=>{let P;!v&&(P=this.C(w,a))&&u(P)?R(new Error(`command failed with error code ${E}: ${this.C(w,a)}`)):(this.g&&E===0&&(this.j=!0),R(null,"",!0))})}A(l,a,d){const k=new I.StringDecoder(a);return l.on("data",R=>{d(null,k.write(R))}),k}B(l){const a=[];return l.on("data",d=>{a.push(d)}),a}C(l,a){const d=new I.StringDecoder(a);return l.map(k=>d.write(k)).join("")}D(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}G(l,{pathToEntries:a},d,k,R){k.indexOf(this.b)!==-1&&this.J(R,{base:d,relativePath:this.b,searchPath:this.N(l,this.b)});const v=w=>{const E=g.$nc(w),P=g.$mc(w);let N=a[P];N||(N=a[P]=[],v(P)),N.push({base:d,relativePath:w,basename:E,searchPath:this.N(l,w)})};k.forEach(v)}H({rootEntries:l,pathToEntries:a},d,k){const R=this,v=this.t.get(d),w=this.b;function E(P){R.o++;const N=(0,f.$LJ)(()=>P.map(U=>U.basename));for(let U=0,F=P.length;U<F;U++){const j=P[U],{relativePath:T,basename:M}=j;if(v.test(T,M,w!==M?N:void 0))continue;const B=a[T];if(B)E(B);else{if(R.p++,T===w)continue;R.J(k,j)}if(R.j)break}}E(l)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(l,a,d,k,R){const v=l.folder,w=(0,f.$LJ)(()=>d);this.w(d,(E,P)=>{if(this.l||this.j)return P(null);const N=a?[a,E].join(g.sep):E;if(this.t.get(l.folder.fsPath).test(N,E,this.a.filePattern!==E?w:void 0))return P(null);const U=[v.fsPath,N].join(g.sep);O.lstat(U,(F,j)=>{if(F||this.l||this.j)return P(null);this.L(U,j,(T,M)=>T||this.l||this.j?P(null):M.isDirectory()?(this.o++,this.M(U,j,(B,Y)=>B||this.l||this.j||(Y=Y||"",this.v[Y])?P(null):(this.v[Y]=!0,h.Promises.readdir(U).then(ue=>{if(this.l||this.j)return P(null);this.I(l,N,ue,k,Z=>P(Z||null))},ue=>{P(null)})))):(this.p++,N===this.b||this.h&&S.$Mf(M.size)&&M.size>this.h||this.J(k,{base:v.fsPath,relativePath:N,searchPath:this.N(l,N)}),P(null,void 0)))})},E=>{const P=E&&A.$Hb(E);return R(P&&P.length>0?P[0]:void 0)})}J(l,a){this.K(a)&&(!this.d||this.d(a.relativePath,g.$nc(a.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||l(a))}K(l){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,f.$GJ)(l,this.c)}return!0}L(l,a,d){return a.isSymbolicLink()?O.stat(l,d):d(null,a)}M(l,a,d){return a.isSymbolicLink()?O.realpath(l,(k,R)=>k?d(k):d(null,R)):d(null,l)}N(l,a){return l.folderName?g.$jc(l.folderName,a):a}}e.$vic=n;class c{constructor(l){this.a=l.folderQueries,this.b=l.extraFileResources||[],this.c=new n(l)}search(l,a,d){this.c.walk(this.a,this.b,l,a,(k,R)=>{d(k,{limitHit:R,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$wic=c;class t{constructor(l,a){this.expression=l,this.c=a,this.d(l)}d(l){let a,d;Object.keys(l).filter(k=>l[k]).forEach(k=>{g.$ic(k)?(a=a||$.$Hj(),a[k]=l[k]):(d=d||$.$Hj(),d[k]=l[k])}),this.a=a&&$.$Mj(a,{trimForExclusions:!0}),this.b=d&&$.$Mj(d,{trimForExclusions:!0})}test(l,a,d){return this.b&&this.b(l,a,d)||this.a&&this.a(g.$jc(this.c,l),a,d)}getBasenameTerms(){const l=[];return this.a&&l.push(...$.$Oj(this.a)),this.b&&l.push(...$.$Oj(this.b)),l}getPathTerms(){const l=[];return this.a&&l.push(...$.$Pj(this.a)),this.b&&l.push(...$.$Pj(this.b)),l}}function u(s){const l=s.trim().split(`
`),a=l[0].trim();if(a.startsWith("Error parsing regex"))return a;if(a.startsWith("regex parse error"))return p.$Af(l[l.length-1].trim());if(a.startsWith("error parsing glob")||a.startsWith("unsupported encoding"))return a.charAt(0).toUpperCase()+a.substr(1);if(a==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(a.startsWith("Literal "))return a}}),define(ke[374],Se([1,0,98,22,186,21]),function(me,e,D,O,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wD=e.$vD=e.$uD=e.$tD=e.$sD=e.$rD=e.$qD=e.$pD=e.$oD=e.DecodeStreamErrorKind=e.$nD=e.$mD=e.$lD=e.$kD=e.$jD=e.$iD=e.$hD=e.$gD=void 0,e.$gD="utf8",e.$hD="utf8bom",e.$iD="utf16be",e.$jD="utf16le";function A(a){return[e.$gD,e.$hD,e.$iD,e.$jD].some(d=>d===a)}e.$kD=A,e.$lD=[254,255],e.$mD=[255,254],e.$nD=[239,187,191];const b=512,$=512,y=512*8,L=512*128;var C;(function(a){a[a.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(C||(e.DecodeStreamErrorKind=C={}));class m extends Error{constructor(d,k){super(d),this.decodeStreamErrorKind=k}}e.$oD=m;class p{static async create(d){let k;if(d!==e.$gD)k=(await(0,g.$fD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(o(d));else{const R=new TextDecoder;k={write(v){return R.decode(v,{stream:!0})},end(){return R.decode()}}}return new p(k)}constructor(d){this.a=d}write(d){return this.a.write(d)}end(){return this.a.end()}}function S(a,d){const k=d.minBytesRequiredForDetection??d.guessEncoding?y:$;return new Promise((R,v)=>{const w=(0,D.$0d)(j=>j.join("")),E=[];let P=0,N;const U=new I.$6d,F=async()=>{try{const j=await l({buffer:O.$je.concat(E),bytesRead:P},d.guessEncoding);if(j.seemsBinary&&d.acceptTextOnly)throw new m("Stream is binary but only text is accepted for decoding",1);j.encoding=await d.overwriteEncoding(j.encoding),N=await p.create(j.encoding);const T=N.write(O.$je.concat(E).buffer);w.write(T),E.length=0,P=0,R({stream:w,detected:j})}catch(j){U.cancel(),w.destroy(),v(j)}};(0,D.$be)(a,{onData:async j=>{N?w.write(N.write(j.buffer)):(E.push(j),P+=j.byteLength,P>=k&&(a.pause(),await F(),setTimeout(()=>a.resume())))},onError:j=>w.error(j),onEnd:async()=>{N||await F(),w.end(N?.end())}},U.token)})}e.$pD=S;async function h(a,d,k){const v=(await(0,g.$fD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(o(d),k);let w=!1,E=!1;return{read(){if(E)return null;const P=a.read();if(typeof P!="string"){if(E=!0,!w&&k?.addBOM)switch(d){case e.$gD:case e.$hD:return O.$je.wrap(Uint8Array.from(e.$nD));case e.$iD:return O.$je.wrap(Uint8Array.from(e.$lD));case e.$jD:return O.$je.wrap(Uint8Array.from(e.$mD))}const N=v.end();return N&&N.length>0?(w=!0,O.$je.wrap(N)):null}return w=!0,O.$je.wrap(v.write(P))}}}e.$qD=h;async function f(a){return(await(0,g.$fD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(o(a))}e.$rD=f;function o(a){return a===e.$hD||a===null?e.$gD:a}e.$sD=o;function i(a,d){if(!a||d<e.$lD.length)return null;const k=a.readUInt8(0),R=a.readUInt8(1);if(k===e.$lD[0]&&R===e.$lD[1])return e.$iD;if(k===e.$mD[0]&&R===e.$mD[1])return e.$jD;if(d<e.$nD.length)return null;const v=a.readUInt8(2);return k===e.$nD[0]&&R===e.$nD[1]&&v===e.$nD[2]?e.$hD:null}e.$tD=i;const r=["ascii","utf-16","utf-32"];async function n(a){const d=await(0,g.$fD)("jschardet","dist/jschardet.min.js"),k=a.slice(0,L),R=u(k.buffer),v=d.detect(R);if(!v||!v.encoding)return null;const w=v.encoding.toLowerCase();return 0<=r.indexOf(w)?null:t(v.encoding)}const c={ibm866:"cp866",big5:"cp950"};function t(a){const d=a.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return c[d]||d}function u(a){let d="";for(let k=0;k<a.length;k++)d+=String.fromCharCode(a[k]);return d}function s(a){switch(a){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const d=a.match(/windows(\d+)/);return d?"windows-"+d[1]:a}}}e.$uD=s;function l({buffer:a,bytesRead:d},k){let R=i(a,d),v=!1;if(R!==e.$iD&&R!==e.$jD&&a){let w=!0,E=!0,P=!1;for(let N=0;N<d&&N<b;N++){const U=N%2===1,F=a.readUInt8(N)===0;if(F&&(P=!0),w&&(U&&!F||!U&&F)&&(w=!1),E&&(U&&F||!U&&!F)&&(E=!1),F&&!w&&!E)break}P&&(w?R=e.$jD:E?R=e.$iD:v=!0)}return k&&!v&&!R&&a?n(a.slice(0,d)).then(w=>({seemsBinary:!1,encoding:w})):{seemsBinary:v,encoding:R}}e.$vD=l,e.$wD={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(ke[155],Se([1,0,374,31,154]),function(me,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eic=void 0;class I extends g.$phc{constructor(b,$,y=O,L="searchProcess"){super(b,$,{readdir:C=>y.Promises.readdir(C.fsPath),toCanonicalName:C=>(0,D.$uD)(C)},L)}}e.$Eic=I}),define(ke[156],Se([1,0,50,390,373,19,73,34,12,2,36,94,391,371,119]),function(me,e,D,O,g,I,A,b,$,y,L,C,m,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dic=e.$Cic=e.$Bic=e.$Aic=e.$zic=e.$yic=e.$xic=void 0;const h=p.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class f{constructor(w){this.a=w}provideTextSearchResults(w,E,P,N){return this.a.appendLine(`provideTextSearchResults ${w.pattern}, ${JSON.stringify({...E,folder:E.folder.toString()})}`),new Promise((U,F)=>{N.onCancellationRequested(()=>J());const j=t(w,E),T=E.folder.fsPath,M=j.map(oe=>oe.match(/^-/)?oe:`'${oe}'`).join(" ");this.a.appendLine(`${h} ${M}
 - cwd: ${T}`);let B=D.spawn(h,j,{cwd:T});B.on("error",oe=>{console.error(oe),this.a.appendLine("Error: "+(oe&&oe.message)),F((0,L.$CJ)(new L.$AJ(oe&&oe.message,L.SearchErrorCode.rgProcessError)))});let Y=!1;const ue=new r(E.maxResults,E.folder,E.previewOptions);ue.on("result",oe=>{Y=!0,he="",P.report(oe)});let Z=!1;const J=()=>{Z=!0,B?.kill(),ue?.cancel()};let X=!1;ue.on("hitLimit",()=>{X=!0,J()});let he="";B.stdout.on("data",oe=>{ue.handleData(oe),Y||(he+=oe)});let _=!1;B.stdout.once("data",()=>_=!0);let we="";B.stderr.on("data",oe=>{const K=oe.toString();this.a.appendLine(K),we.length+K.length<1e6&&(we+=K)}),B.on("close",()=>{if(this.a.appendLine(_?"Got data from stdout":"No data from stdout"),this.a.appendLine(Y?"Got result from parser":"No result from parser"),he&&this.a.appendLine(`Got data without result: ${he}`),this.a.appendLine(""),Z)U({limitHit:X});else{ue.flush(),B=null;let oe;we&&!_&&(oe=o(we))?F((0,L.$CJ)(new L.$AJ(oe.message,oe.code))):U({limitHit:X})}})})}}e.$xic=f;function o(v){const w=v.split(`
`),E=w[0].trim();if(w.some(N=>N.startsWith("regex parse error")))return new L.$AJ(i(w),L.SearchErrorCode.regexParseError);const P=E.match(/grep config error: unknown encoding: (.*)/);if(P)return new L.$AJ(`Unknown encoding: ${P[1]}`,L.SearchErrorCode.unknownEncoding);if(E.startsWith("error parsing glob"))return new L.$AJ(E.charAt(0).toUpperCase()+E.substr(1),L.SearchErrorCode.globParseError);if(E.startsWith("the literal"))return new L.$AJ(E.charAt(0).toUpperCase()+E.substr(1),L.SearchErrorCode.invalidLiteral);if(E.startsWith("PCRE2: error compiling pattern"))return new L.$AJ(E,L.SearchErrorCode.regexParseError)}function i(v){const w=["Regex parse error"],E=v.filter(P=>P.startsWith("PCRE2:"));if(E.length>=1){const P=E[0].replace("PCRE2:","");if(P.indexOf(":")!==-1&&P.split(":").length>=2){const N=P.split(":")[1];w.push(":"+N)}}return w.join("")}class r extends O.EventEmitter{constructor(w,E,P){super(),this.g=w,this.h=E,this.j=P,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new g.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(w,E){return super.on(w,E),this}handleData(w){if(this.b)return;const E=typeof w=="string"?w:this.d.write(w);this.k(E)}k(w){let E=w.indexOf(`
`);const P=this.a+w;if(E>=0)E+=this.a.length;else{this.a=P;return}let N=0;for(;E>=0;)this.m(P.substring(N,E).trim()),N=E+1,E=P.indexOf(`
`,N);this.a=P.substring(N)}m(w){if(this.b||!w)return;let E;try{E=JSON.parse(w)}catch{throw new Error(`malformed line from rg: ${w}`)}if(E.type==="match"){const P=n(E.data.path),N=y.URI.joinPath(this.h,P),U=this.n(E.data,N);this.p(U),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(E.type==="context"){const P=n(E.data.path),N=y.URI.joinPath(this.h,P);this.o(E.data,N).forEach(F=>this.p(F))}}n(w,E){const P=w.line_number-1,N=n(w.lines),U=Buffer.from(N);let F=0,j=0,T=P;w.submatches.length===0&&w.submatches.push(N.length?{start:0,end:1,match:{text:N[0]}}:{start:0,end:0,match:{text:""}});const M=(0,I.$Hb)(w.submatches.map((B,Y)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const ue=n(B.match),Z=U.slice(F,B.start).toString(),J=c(Z),X=J.numLines>0?J.lastLineLength:J.lastLineLength+j,he=c(ue),_=J.numLines+T,we=he.numLines+_,oe=he.numLines>0?he.lastLineLength:he.lastLineLength+X;return F=B.end,j=oe,T=we,new C.$kJ(_,X,we,oe)}));return(0,S.$qic)(E,N,M,this.j)}o(w,E){const P=n(w.lines),N=w.line_number;return P.replace(/\r?\n$/,"").split(`
`).map((U,F)=>({text:U,uri:E,lineNumber:N+F}))}p(w){this.emit("result",w)}}e.$yic=r;function n(v){return v.bytes?Buffer.from(v.bytes,"base64").toString():v.text}function c(v){const w=/\n/g;let E=0,P=-1,N;for(;N=w.exec(v);)E++,P=N.index;const U=P>=0?v.length-P-1:v.length;return{numLines:E,lastLineLength:U}}function t(v,w){const E=["--hidden","--no-require-git"];E.push(v.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:P,otherIncludes:N}=(0,A.$K)(w.includes,F=>F.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(N&&N.length){const F=new Set;N.forEach(j=>{F.add(j)}),E.push("-g","!*"),F.forEach(j=>{u(j).map(S.$pic).forEach(T=>{E.push("-g",T)})})}P&&P.length&&P.forEach(F=>{E.push("-g",F)}),w.excludes.map(S.$pic).forEach(F=>E.push("-g",`!${F}`)),w.maxFileSize&&E.push("--max-filesize",w.maxFileSize+""),w.useIgnoreFiles?w.useParentIgnoreFiles||E.push("--no-ignore-parent"):E.push("--no-ignore"),w.followSymlinks&&E.push("--follow"),w.encoding&&w.encoding!=="utf8"&&E.push("--encoding",w.encoding),v.pattern==="--"&&(v.isRegExp=!0,v.pattern="\\-\\-"),v.isMultiline&&!v.isRegExp&&(v.pattern=(0,$.$Oe)(v.pattern),v.isRegExp=!0),w.usePCRE2&&E.push("--pcre2"),E.push("--crlf"),v.isRegExp&&(v.pattern=s(v.pattern),E.push("--engine","auto"));let U;if(v.isWordMatch){const j=(0,$.$Xe)(v.pattern,!!v.isRegExp,{wholeWord:v.isWordMatch}).source.replace(/\\\//g,"/");E.push("--regexp",j)}else if(v.isRegExp){let F=a(v.pattern);F=d(F),E.push("--regexp",F)}else U=v.pattern,E.push("--fixed-strings");return E.push("--no-config"),w.useGlobalIgnoreFiles||E.push("--no-ignore-global"),E.push("--json"),v.isMultiline&&E.push("--multiline"),w.beforeContext&&E.push("--before-context",w.beforeContext+""),w.afterContext&&E.push("--after-context",w.afterContext+""),E.push("--"),U&&E.push(U),E.push("."),E}e.$zic=t;function u(v){return R(v).flatMap(E=>{const P=(0,b.$Kj)(E,"/");return P.map((N,U)=>P.slice(0,U+1).join("/"))})}function s(v){const w=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;v.match(w);)v=v.replace(w,"$1\\x{$2}");const E=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;v.match(E);)v=v.replace(E,"$1\\x{$2}");return v}e.$Aic=s;const l=v=>v.type==="Assertion"&&v.kind==="lookbehind";function a(v){let w;try{w=new m.RegExpParser().parsePattern(v)}catch{return v}let E="",P=0;const N=(j,T,M)=>{E+=v.slice(P,j)+M,P=T},U=[];return new m.RegExpVisitor({onCharacterEnter(j){if(j.raw!=="\\n")return;const T=U[0];if(!T)N(j.start,j.end,"\\r?\\n");else if(!U.some(l))if(T.type==="CharacterClass")if(T.negate){const M=v.slice(T.start+2,j.start)+v.slice(j.end,T.end-1);T.parent?.type==="Quantifier"?N(T.start,T.end,M?`[^${M}]`:"."):N(T.start,T.end,"(?!\\r?\\n"+(M?`|[${M}]`:"")+")")}else{const M=v.slice(T.start+1,j.start)+v.slice(j.end,T.end-1);N(T.start,T.end,M===""?"\\r?\\n":`(?:[${M}]|\\r?\\n)`)}else T.type==="Quantifier"&&N(j.start,j.end,"(?:\\r?\\n)")},onQuantifierEnter(j){U.unshift(j)},onQuantifierLeave(){U.shift()},onCharacterClassRangeEnter(j){U.unshift(j)},onCharacterClassRangeLeave(){U.shift()},onCharacterClassEnter(j){U.unshift(j)},onCharacterClassLeave(){U.shift()},onAssertionEnter(j){l(j)&&U.push(j)},onAssertionLeave(j){U[0]===j&&U.shift()}}).visit(w),E+=v.slice(P),E}e.$Bic=a;function d(v){return v.replace(/\n/g,"\\r?\\n")}e.$Cic=d;function k(v){let w=!1,E=!1,P="",N="";for(let U=0;U<v.length;U++){const F=v[U];switch(F){case"\\":E?(w?N+="\\"+F:P+="\\"+F,E=!1):E=!0;break;case"{":if(E)w?N+=F:P+=F,E=!1;else{if(w)return{strInBraces:P+"{"+N+"{"+v.substring(U+1)};w=!0}break;case"}":if(E)w?N+=F:P+=F,E=!1;else{if(w)return{fixedStart:P,strInBraces:N,fixedEnd:v.substring(U+1)};P+=F}break;default:w?N+=(E?"\\":"")+F:P+=(E?"\\":"")+F,E=!1;break}}return{strInBraces:P+(w?"{"+N:"")}}function R(v){const{fixedStart:w,strInBraces:E,fixedEnd:P}=k(v);if(w===void 0||P===void 0)return[E];let N=(0,b.$Kj)(E,",");N.length||(N=[""]);const U=R(P);return N.flatMap(F=>{const j=w+F;return U.map(T=>j+T)})}e.$Dic=R}),define(ke[375],Se([1,0,21,156,85,17]),function(me,e,D,O,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hic=void 0;class A{constructor(y){this.b=y,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(y,L,C,m){const p=new O.$xic(this.b);if(L.folder.scheme===I.Schemas.vscodeUserData){const S={...L,folder:L.folder.with({scheme:I.Schemas.file})},h=new g.$vv(f=>C.report({...f,uri:f.uri.with({scheme:L.folder.scheme})}));return this.c(m,f=>p.provideTextSearchResults(y,S,h,f))}else return this.c(m,S=>p.provideTextSearchResults(y,L,C,S))}async c(y,L){const C=b(y);this.a.add(C);const m=await L(C.token);return this.a.delete(C),m}d(){this.a.forEach(y=>y.cancel())}}e.$Hic=A;function b($){const y=new D.$6d;return $.onCancellationRequested(()=>y.cancel()),y}}),define(ke[376],Se([1,0,31,156,155]),function(me,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fic=void 0;class I{constructor($){this.a=$}search($,y,L){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const C={appendLine(p){L({message:p})}},m=new g.$Eic(this.a,new O.$xic(C),D);return new Promise((p,S)=>m.search(h=>{y(h.map(A))},$).then(h=>p({limitHit:h.limitHit,type:"success",stats:h.stats}),S))}}e.$Fic=I;function A(b){return{path:b.resource&&b.resource.fsPath,results:b.results,numMatches:(b.results||[]).reduce(($,y)=>{if(y.ranges){const L=y;return $+(Array.isArray(L.ranges)?L.ranges.length:1)}else return $+1},0)}}}),define(ke[377],Se([1,0,19,11,14,4,129,16,38,2,32,36,372,376]),function(me,e,D,O,g,I,A,b,$,y,L,C,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gic=void 0;class S{static{this.a=512}constructor(n="searchProcess"){this.d=n,this.b=Object.create(null)}fileSearch(n){let c;const t=o(n),u=new I.$Vd({onDidAddFirstListener:()=>{c=(0,O.$Tg)(s=>this.doFileSearchWithEngine(m.$wic,t,l=>u.fire(l),s)),c.then(s=>u.fire(s),s=>u.fire({type:"error",error:{message:s.message,stack:s.stack}}))},onDidRemoveLastListener:()=>{c.cancel()}});return u.event}textSearch(n){let c;const t=o(n),u=new I.$Vd({onDidAddFirstListener:()=>{c=(0,O.$Tg)(s=>this.f(t,l=>u.fire(l),s)),c.then(s=>u.fire(s),s=>u.fire({type:"error",error:{message:s.message,stack:s.stack}}))},onDidRemoveLastListener:()=>{c.cancel()}});return u.event}f(n,c,t){return n.maxFileSize=this.g().maxFileSize,new p.$Fic(n).search(t,c,c)}g(){return{maxFileSize:16*L.$Yk.GB}}doFileSearch(n,c,t){return this.doFileSearchWithEngine(m.$wic,n,c,t)}doFileSearchWithEngine(n,c,t,u,s=S.a){let l=0;const a=k=>{Array.isArray(k)?(l+=k.length,t(k.map(R=>this.h(R)))):k.relativePath?(l++,t(this.h(k))):t(k)};if(c.sortByScore){let k=this.l(c,a,u);if(!k){const R=c.maxResults?Object.assign({},c,{maxResults:null}):c,v=new n(R);k=this.j(v,c,t,a,u)}return new Promise((R,v)=>{k.then(([w,E])=>{const P=E.map(N=>this.h(N));this.o(P,t,s),R(w)},v)})}const d=new n(c);return this.r(d,a,s,u).then(k=>({limitHit:k.limitHit,type:"success",stats:{detailStats:k.stats,type:this.d,fromCache:!1,resultCount:l,sortingTime:void 0}}))}h(n){return{path:n.base?(0,b.$jc)(n.base,n.relativePath):n.relativePath}}j(n,c,t,u,s){const l=new I.$Vd;let a=(0,O.$Tg)(k=>{let R=[];const v=w=>{Array.isArray(w)?R=w:(u(w),l.fire(w))};return this.r(n,v,-1,k).then(w=>[w,R])}),d;if(c.cacheKey){d=this.k(c.cacheKey);const k={promise:a,event:l.event,resolved:!1};d.resultsToSearchCache[c.filePattern||""]=k,a.then(()=>{k.resolved=!0},R=>{delete d.resultsToSearchCache[c.filePattern||""]}),a=this.s(a)}return a.then(([k,R])=>{const v=d?d.scorerCache:Object.create(null),w=(typeof c.maxResults!="number"||c.maxResults>0)&&$.$Rd.create(!1);return this.n(c,R,v,s).then(E=>{const P=w?w.elapsed():-1;return[{type:"success",stats:{detailStats:k.stats,sortingTime:P,fromCache:!1,type:this.d,workspaceFolderCount:c.folderQueries.length,resultCount:E.length},messages:k.messages,limitHit:k.limitHit||typeof c.maxResults=="number"&&R.length>c.maxResults},E]})})}k(n){const c=this.b[n];return c||(this.b[n]=new h)}l(n,c,t){const u=n.cacheKey&&this.b[n.cacheKey];if(!u)return;const s=this.q(u,n.filePattern||"",c,t);if(s)return s.then(([l,a,d])=>{const k=$.$Rd.create(!1);return this.n(n,a,u.scorerCache,t).then(R=>{const v=k.elapsed(),w={fromCache:!0,detailStats:d,type:this.d,resultCount:a.length,sortingTime:v};return[{type:"success",limitHit:l.limitHit||typeof n.maxResults=="number"&&a.length>n.maxResults,stats:w},R]})})}n(n,c,t,u){const s=(0,A.$Zq)(n.filePattern||""),l=(d,k)=>(0,A.$Yq)(d,k,s,!0,f,t),a=typeof n.maxResults=="number"?n.maxResults:Number.MAX_VALUE;return D.$Gb(c,l,a,1e4,u)}o(n,c,t){if(t&&t>0)for(let u=0;u<n.length;u+=t)c(n.slice(u,u+t));else c(n)}q(n,c,t,u){const s=$.$Rd.create(!1),l=c.indexOf(b.sep)>=0;let a;for(const v in n.resultsToSearchCache)if(c.startsWith(v)){if(l&&v.indexOf(b.sep)<0&&v!=="")continue;const w=n.resultsToSearchCache[v];a={promise:this.s(w.promise),event:w.event,resolved:w.resolved};break}if(!a)return null;const d=s.elapsed(),k=$.$Rd.create(!1),R=a.event(t);return u&&u.onCancellationRequested(()=>{R.dispose()}),a.promise.then(([v,w])=>{if(u&&u.isCancellationRequested)throw(0,g.$6)();const E=[],P=(0,A.$Zq)(c).normalizedLowercase;for(const N of w)(0,C.$GJ)(N,P)&&E.push(N);return[v,E,{cacheWasResolved:a.resolved,cacheLookupTime:d,cacheFilterTime:k.elapsed(),cacheEntryCount:w.length}]})}r(n,c,t,u){return new Promise((s,l)=>{let a=[];u?.onCancellationRequested(()=>n.cancel()),n.search(d=>{d&&(t?(a.push(d),t>0&&a.length>=t&&(c(a),a=[])):c(d))},d=>{c(d)},(d,k)=>{a.length&&c(a),d?(c({message:"Search finished. Error: "+d.message}),l(d)):(c({message:"Search finished. Stats: "+JSON.stringify(k.stats)}),s(k))})})}clearCache(n){return delete this.b[n],Promise.resolve(void 0)}s(n){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(c,t){return n.then(c,t)}catch(c){return this.then(void 0,c)}finally(c){return n.finally(c)}}}}e.$Gic=S;class h{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const f=new class{getItemLabel(r){return(0,b.$nc)(r.relativePath)}getItemDescription(r){return(0,b.$mc)(r.relativePath)}getItemPath(r){return r.relativePath}};function o(r){return{...r,folderQueries:r.folderQueries&&r.folderQueries.map(i),extraFileResources:r.extraFileResources&&r.extraFileResources.map(n=>y.URI.revive(n))}}function i(r){return{...r,folder:y.URI.revive(r.folder)}}}),define(ke[378],Se([1,0,3,17,2,31,13,27,20,97,66,36,377,375,119,155]),function(me,e,D,O,g,I,A,b,$,y,L,C,m,p,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iic=void 0;let f=class extends y.$uhc{constructor(i,r,n,c){super(i,n,c),this.s=I,this.t=-1,this.v=null,this.w=!1,this.x=new D.$Sc;const t=new S.$ric("RipgrepSearchUD",this.n);this.x.add(this.registerTextSearchProvider(O.Schemas.vscodeUserData,new p.$Hic(t))),r.remote.isRemote&&r.remote.authority&&this.y()}dispose(){this.x.dispose()}$enableExtensionHostSearch(){this.y()}y(){if(this.w)return;this.w=!0;const i=new S.$ric("RipgrepSearchEH",this.n);this.x.add(this.registerTextSearchProvider(O.Schemas.file,new p.$Hic(i))),this.x.add(this.z(O.Schemas.file,new m.$Gic("fileSearchProvider")))}z(i,r){const n=this.d++;return this.v=r,this.t=n,this.c.$registerFileSearchProvider(n,this.o(i)),(0,D.$Rc)(()=>{this.v=null,this.c.$unregisterProvider(n)})}$provideFileSearchResults(i,r,n,c){const t=(0,y.$vhc)(n);if(i===this.t){const u=Date.now();return this.A(i,r,t,c).then(s=>{const l=Date.now()-u;return this.n.debug(`Ext host file search time: ${l}ms`),s})}return super.$provideFileSearchResults(i,r,n,c)}doInternalFileSearchWithCustomCallback(i,r,n){const c=t=>{if((0,C.$FJ)(t)&&(t=[t]),Array.isArray(t)){n(t.map(u=>g.URI.file(u.path)));return}t.message&&this.n.debug("ExtHostSearch",t.message)};if(!this.v)throw new Error("No internal file search handler");return this.v.doFileSearch(i,c,r)}async A(i,r,n,c){return this.doInternalFileSearchWithCustomCallback(n,c,t=>{this.c.$handleFileMatch(i,r,t)})}$clearCache(i){return this.v?.clearCache(i),super.$clearCache(i)}q(i,r){return new h.$Eic(i,r,void 0,"textSearchProvider")}};e.$Iic=f,e.$Iic=f=Ge([We(0,$.$0M),We(1,b.$nN),We(2,L.$ngc),We(3,A.$nj)],f)}),define(ke[120],Se([1,0,392,62,63,393,22,14,4,3,16,10,30,81,82]),function(me,e,D,O,g,I,A,b,$,y,L,C,m,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=void 0;class h{traceSocketEvent(w,E){S.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,w,E)}constructor(w,E=""){this.f=!0,this.debugLabel=E,this.socket=w,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=P=>{if(this.traceSocketEvent("error",{code:P?.code,message:P?.message}),P){if(P.code==="EPIPE")return;(0,b.$1)(P)}},this.socket.on("error",this.a),this.b=P=>{this.traceSocketEvent("close",{hadError:P}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(w){const E=P=>{this.traceSocketEvent("read",P),w(A.$je.wrap(P))};return this.socket.on("data",E),{dispose:()=>this.socket.off("data",E)}}onClose(w){const E=P=>{w({type:0,hadError:P,error:void 0})};return this.socket.on("close",E),{dispose:()=>this.socket.off("close",E)}}onEnd(w){const E=()=>{w()};return this.socket.on("end",E),{dispose:()=>this.socket.off("end",E)}}write(w){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",w),this.socket.write(w.buffer,E=>{if(E){if(E.code==="EPIPE")return;(0,b.$1)(E)}})}catch(E){if(E.code==="EPIPE")return;(0,b.$1)(E)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((w,E)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),w();return}const P=()=>{this.socket.off("close",P),this.socket.off("end",P),this.socket.off("error",P),this.socket.off("timeout",P),this.socket.off("drain",P),this.traceSocketEvent("nodeDrainEnd"),w()};this.socket.on("close",P),this.socket.on("end",P),this.socket.on("error",P),this.socket.on("timeout",P),this.socket.on("drain",P)})}}e.$Uh=h;var f;(function(v){v[v.MinHeaderByteSize=2]="MinHeaderByteSize",v[v.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(f||(f={}));var o;(function(v){v[v.PeekHeader=1]="PeekHeader",v[v.ReadHeader=2]="ReadHeader",v[v.ReadBody=3]="ReadBody",v[v.Fin=4]="Fin"})(o||(o={}));class i extends y.$Tc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(w,E){this.socket.traceSocketEvent(w,E)}constructor(w,E,P,N){super(),this.f=this.B(new $.$Vd),this.g=this.B(new $.$Vd),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=w,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:E,inflateBytesLength:P?.byteLength||0,recordInflateBytes:N}),this.a=this.B(new r(this,E,P,N,this.f,(U,F)=>this.m(U,F))),this.B(this.a.onError(U=>{console.error(U),(0,b.$1)(U),this.g.fire({type:0,hadError:!0,error:U})})),this.b=new S.$Ph,this.B(this.socket.onData(U=>this.n(U))),this.B(this.socket.onClose(async U=>{this.a.isProcessingReadQueue()&&await $.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(U)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(w){return this.f.event(w)}onClose(w){return this.g.event(w)}onEnd(w){return this.socket.onEnd(w)}write(w){let E=0;for(;E<w.byteLength;)this.a.writeMessage(w.slice(E,Math.min(E+262144,w.byteLength)),{compressed:!0,opcode:2}),E+=262144}m(w,{compressed:E,opcode:P}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",w);let N=2;w.byteLength<126?N+=0:w.byteLength<2**16?N+=2:N+=8;const U=A.$je.alloc(N),F=E?64:0,j=P&15;if(U.writeUInt8(128|F|j,0),w.byteLength<126)U.writeUInt8(w.byteLength,1);else if(w.byteLength<2**16){U.writeUInt8(126,1);let T=1;U.writeUInt8(w.byteLength>>>8&255,++T),U.writeUInt8(w.byteLength>>>0&255,++T)}else{U.writeUInt8(127,1);let T=1;U.writeUInt8(0,++T),U.writeUInt8(0,++T),U.writeUInt8(0,++T),U.writeUInt8(0,++T),U.writeUInt8(w.byteLength>>>24&255,++T),U.writeUInt8(w.byteLength>>>16&255,++T),U.writeUInt8(w.byteLength>>>8&255,++T),U.writeUInt8(w.byteLength>>>0&255,++T)}this.socket.write(A.$je.concat([U,w]))}end(){this.h=!0,this.socket.end()}n(w){if(w.byteLength!==0){for(this.b.acceptChunk(w);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const E=this.b.peek(this.j.readLen),P=E.readUInt8(0),N=(P&128)>>>7,U=(P&64)>>>6,F=P&15,j=E.readUInt8(1),T=(j&128)>>>7,M=j&127;this.j.state=2,this.j.readLen=2+(T?4:0)+(M===126?2:0)+(M===127?8:0),this.j.fin=N,this.j.firstFrameOfMessage&&(this.j.compressed=!!U),this.j.firstFrameOfMessage=!!N,this.j.mask=0,this.j.opcode=F,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const E=this.b.read(this.j.readLen),P=E.readUInt8(1),N=(P&128)>>>7;let U=P&127,F=1;U===126?U=E.readUInt8(++F)*2**8+E.readUInt8(++F):U===127&&(U=E.readUInt8(++F)*0+E.readUInt8(++F)*0+E.readUInt8(++F)*0+E.readUInt8(++F)*0+E.readUInt8(++F)*2**24+E.readUInt8(++F)*2**16+E.readUInt8(++F)*2**8+E.readUInt8(++F));let j=0;N&&(j=E.readUInt8(++F)*2**24+E.readUInt8(++F)*2**16+E.readUInt8(++F)*2**8+E.readUInt8(++F)),this.j.state=3,this.j.readLen=U,this.j.mask=j,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const E=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",E),t(E,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",E),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(E,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(E,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await $.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$Vh=i;class r extends y.$Tc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:A.$je.alloc(0)}constructor(w,E,P,N,U,F){super(),this.n=w,this.r=U,this.s=F,this.a=this.B(new $.$Vd),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new $.$Vd),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new $.$Vd),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,E?(this.b=this.B(new n(this.n,N,P,{windowBits:15})),this.f=this.B(new c(this.n,{windowBits:15})),this.B(this.b.onError(j=>this.a.fire(j))),this.B(this.f.onError(j=>this.a.fire(j)))):(this.b=null,this.f=null)}writeMessage(w,E){this.g.push({data:w,options:E}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:w,options:E}=this.g.shift();if(this.f&&E.compressed){const P=await this.w(this.f,w);this.s(P,E)}else this.s(w,{...E,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(w,E){return new Promise((P,N)=>{w.write(E),w.flush(U=>P(U))})}acceptFrame(w,E,P){this.h.push({data:w,isCompressed:E,isLastFrameOfMessage:P}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const w=this.h.shift();if(this.b&&w.isCompressed){const E=await this.C(this.b,w.data,w.isLastFrameOfMessage);this.r.fire(E)}else this.r.fire(w.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(w,E,P){return new Promise((N,U)=>{w.write(E),P&&w.write(A.$je.fromByteArray([0,0,255,255])),w.flush(F=>N(F))})}}class n extends y.$Tc{get recordedInflateBytes(){return this.j?A.$je.concat(this.f):A.$je.alloc(0)}constructor(w,E,P,N){super(),this.h=w,this.j=E,this.a=this.B(new $.$Vd),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,I.createInflateRaw)(N),this.b.on("error",U=>{this.h.traceSocketEvent("zlibInflateError",{message:U?.message,code:U?.code}),this.a.fire(U)}),this.b.on("data",U=>{this.h.traceSocketEvent("zlibInflateData",U),this.g.push(A.$je.wrap(U))}),P&&(this.h.traceSocketEvent("zlibInflateInitialWrite",P.buffer),this.b.write(P.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(w){this.j&&this.f.push(w.clone()),this.h.traceSocketEvent("zlibInflateWrite",w),this.b.write(w.buffer)}flush(w){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const E=A.$je.concat(this.g);this.g.length=0,w(E)})}}class c extends y.$Tc{constructor(w,E){super(),this.g=w,this.a=this.B(new $.$Vd),this.onError=this.a.event,this.f=[],this.b=(0,I.createDeflateRaw)({windowBits:15}),this.b.on("error",P=>{this.g.traceSocketEvent("zlibDeflateError",{message:P?.message,code:P?.code}),this.a.fire(P)}),this.b.on("data",P=>{this.g.traceSocketEvent("zlibDeflateData",P),this.f.push(A.$je.wrap(P))})}write(w){this.g.traceSocketEvent("zlibDeflateWrite",w.buffer),this.b.write(w.buffer)}flush(w){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let E=A.$je.concat(this.f);this.f.length=0,E=E.slice(0,E.byteLength-4),w(E)})}}function t(v,w){if(w===0)return;const E=v.byteLength>>>2;for(let T=0;T<E;T++){const M=v.readUInt32BE(T*4);v.writeUInt32BE(M^w,T*4)}const P=E*4,N=v.byteLength-P,U=w>>>24&255,F=w>>>16&255,j=w>>>8&255;N>=1&&v.writeUInt8(v.readUInt8(P)^U,P),N>=2&&v.writeUInt8(v.readUInt8(P+1)^F,P+1),N>=3&&v.writeUInt8(v.readUInt8(P+2)^j,P+2)}e.$Wh=process.env.XDG_RUNTIME_DIR;const u={[2]:107,[1]:103};function s(){const v=(0,m.$qg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${v}-sock`;const w=process.platform!=="darwin"&&e.$Wh?e.$Wh:(0,g.tmpdir)(),E=(0,L.$jc)(w,`vscode-ipc-${v}.sock`);return a(E),E}e.$Xh=s;function l(v,w,E){const N=(0,D.createHash)("sha256").update(v).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${N}-${E}-${w}-sock`;const U=E.substr(0,4),F=w.substr(0,6);let j;return process.platform!=="darwin"&&e.$Wh&&!process.env.VSCODE_PORTABLE?j=(0,L.$jc)(e.$Wh,`vscode-${N}-${U}-${F}.sock`):j=(0,L.$jc)(v,`${U}-${F}.sock`),a(j),j}e.$Yh=l;function a(v){const w=u[C.$u];typeof w=="number"&&v.length>=w&&console.warn(`WARNING: IPC handle "${v}" is longer than ${w} chars, try a shorter --user-data-dir`)}class d extends p.$Jh{static b(w){const E=$.Event.fromNodeEventEmitter(w,"connection");return $.Event.map(E,P=>({protocol:new S.$Qh(new h(P,"ipc-server-connection")),onDidClientDisconnect:$.Event.once($.Event.fromNodeEventEmitter(P,"close"))}))}constructor(w){super(d.b(w)),this.d=w}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Zh=d;function k(v){return new Promise((w,E)=>{const P=(0,O.createServer)();P.on("error",E),P.listen(v,()=>{P.removeListener("error",E),w(new d(P))})})}e.$1h=k;function R(v,w){return new Promise((E,P)=>{const N=(0,O.createConnection)(v,()=>{N.removeListener("error",P),E(S.$Rh.fromSocket(new h(N,`ipc-client${w}`),w))});N.once("error",P)})}e.$2h=R}),define(ke[379],Se([1,0,62,63,166,120,11,3,10,51,13,136,256,257,109,88,22]),function(me,e,D,O,g,I,A,b,$,y,L,C,m,p,S,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$a_b=e.$_$b=e.$$$b=e.$0$b=void 0;async function o(t,u,s,l,a){let d;for(let k=3;k&&(d?.dispose(),d=await new i(t,u,s,l,a).waitForReady(),!(a&&g.$tg[a]||!g.$tg[d.tunnelLocalPort]));k--);return d}class i extends b.$Tc{constructor(u,s,l,a,d){super(),this.m=s,this.n=d,this.privacy=h.TunnelPrivacyId.Private,this.j=new Map,this.a=u,this.b=D.createServer(),this.c=new A.$5g,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=k=>this.r(k),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=a,this.tunnelRemoteHost=l}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(s=>{s()})}async waitForReady(){const u=this.n??this.tunnelRemotePort,s=(0,h.$Hv)(this.m)?"0.0.0.0":"127.0.0.1";let l=await(0,g.$ug)(u,2,1e3,s),a=null;return this.b.listen(l,this.m),await this.c.wait(),a=this.b.address(),a||(l=0,this.b.listen(l,this.m),await this.c.wait(),a=this.b.address()),this.tunnelLocalPort=a.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${a.port}`,this}async r(u){u.pause();const s=(0,h.$Fv)(this.tunnelRemoteHost)||(0,h.$Hv)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,l=await(0,m.$ll)(this.a,s,this.tunnelRemotePort),a=l.getSocket(),d=l.readEntireBuffer();l.dispose(),d.byteLength>0&&u.write(d.buffer),u.on("end",()=>{u.localAddress&&this.j.delete(u.localAddress),a.end()}),u.on("close",()=>a.end()),u.on("error",()=>{u.localAddress&&this.j.delete(u.localAddress),a instanceof I.$Uh?a.socket.destroy():a.end()}),a instanceof I.$Uh?this.t(u,a):this.s(u,a),u.localAddress&&this.j.set(u.localAddress,()=>{u.end(),a.end()})}s(u,s){s.onClose(()=>u.destroy()),s.onEnd(()=>u.end()),s.onData(l=>u.write(l.buffer)),u.on("data",l=>s.write(f.$je.wrap(l))),u.resume()}t(u,s){const l=s.socket;l.on("end",()=>u.end()),l.on("close",()=>u.end()),l.on("error",()=>{u.destroy()}),l.pipe(u),u.pipe(l)}}e.$0$b=i;let r=class extends h.$Kv{constructor(u,s,l,a,d){super(s,d),this.v=u,this.w=l,this.y=a}isPortPrivileged(u){return(0,h.$Iv)(u,this.m,$.OS,O.release())}t(u,s,l,a,d,k,R,v){const w=this.s(s,l);if(w)return++w.refcount,w.value;if((0,h.$Cv)(u))return this.u(u,s,l,d,k,R,v);{this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${s}:${l} on local port ${d}.`);const E={commit:this.y.commit,quality:this.y.quality,addressProvider:u,remoteSocketFactoryService:this.v,signService:this.w,logService:this.k,ipcLogger:null},P=o(E,a,s,l,d);return this.k.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.q(s,l,P),P}}};e.$$$b=r,e.$$$b=r=Ge([We(0,p.$fl),We(1,L.$nj),We(2,S.$il),We(3,C.$Fj),We(4,y.$zi)],r);let n=class extends r{constructor(u,s,l,a,d){super(u,s,l,a,d)}};e.$_$b=n,e.$_$b=n=Ge([We(0,p.$fl),We(1,L.$nj),We(2,S.$il),We(3,C.$Fj),We(4,y.$zi)],n);let c=class extends b.$Tc{constructor(u,s,l,a,d){super(),this.b=u,this.c=s,this.f=l,this.g=a,this.h=d,this.a=new Map}async openTunnel(u,s,l,a,d,k,R,v,w){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${l}:${a} on local port ${k}.`),!this.a.has(u)){const E=new n(this.b,this.c,this.g,this.f,this.h);this.B(E),this.a.set(u,E),E.onTunnelClosed(async()=>{(await E.tunnels).length===0&&(E.dispose(),this.a.delete(u))})}return this.a.get(u).openTunnel(s,l,a,d,k,R,v,w)}};e.$a_b=c,e.$a_b=c=Ge([We(0,p.$fl),We(1,L.$nj),We(2,C.$Fj),We(3,S.$il),We(4,y.$zi)],c)}),define(ke[380],Se([1,0,120,276,56,35,2,13,40]),function(me,e,D,O,g,I,A,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zN=e.$yN=void 0;class y{constructor(m,p,S){this.b=m,this.c=p,this.f=S,this.a=O.createServer((h,f)=>this.h(h,f)),this.g().catch(h=>(p.error(h),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",m=>this.c.error(m))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(m,p){const S=(f,o)=>{p.writeHead(f,{"content-type":"application/json"}),p.end(JSON.stringify(o||null),i=>i&&this.c.error(i))},h=[];m.setEncoding("utf8"),m.on("data",f=>h.push(f)),m.on("end",async()=>{try{const f=JSON.parse(h.join(""));let o;switch(f.type){case"open":o=await this.i(f);break;case"openExternal":o=await this.j(f);break;case"status":o=await this.l(f);break;case"extensionManagement":o=await this.k(f);break;default:S(404,`Unknown message type: ${f.type}`);break}S(200,o)}catch(f){const o=f instanceof Error?f.message:JSON.stringify(f);S(500,o),this.c.error("Error while processing pipe request",f)}})}async i(m){const{fileURIs:p,folderURIs:S,forceNewWindow:h,diffMode:f,mergeMode:o,addMode:i,forceReuseWindow:r,gotoLineMode:n,waitMarkerFilePath:c,remoteAuthority:t}=m,u=[];if(Array.isArray(S))for(const d of S)try{u.push({folderUri:A.URI.parse(d)})}catch{}if(Array.isArray(p))for(const d of p)try{(0,$.$yi)(d)?u.push({workspaceUri:A.URI.parse(d)}):u.push({fileUri:A.URI.parse(d)})}catch{}const s=c?A.URI.file(c):void 0,a={forceNewWindow:h,diffMode:f,mergeMode:o,addMode:i,gotoLineMode:n,forceReuseWindow:r,preferNewWindow:!r&&!s&&!i,waitMarkerFileURI:s,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",u,a)}async j(m){for(const p of m.uris){const S=A.URI.parse(p),h=S.scheme==="file"?S:p;await this.b.executeCommand("_remoteCLI.openExternal",h)}}async k(m){const p=h=>h?.map(f=>/\.vsix$/i.test(f)?A.URI.parse(f):f),S={list:m.list,install:p(m.install),uninstall:p(m.uninstall),force:m.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",S)}async l(m){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&g.existsSync(this.f)&&g.unlinkSync(this.f)}}e.$yN=y;let L=class extends y{constructor(m,p){super(m,p,(0,D.$Xh)())}};e.$zN=L,e.$zN=L=Ge([We(0,I.$tN),We(1,b.$nj)],L)}),define(ke[381],Se([1,0,57,368,363,275,47,348,2,17,7,380,103,346,347]),function(me,e,D,O,g,I,A,b,$,y,L,C,m,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nic=void 0;class h extends g.$cic{j(){const i=this,r=globalThis._VSCODE_NODE_MODULES.module,n=r._load;r._load=function(s,l,a){return s=t(s),i.a.has(s)?i.a.get(s).load(s,$.URI.file((0,m.$wq)(l.filename)),d=>n.apply(this,[d,l,a])):n.apply(this,arguments)};const c=r._resolveLookupPaths;r._resolveLookupPaths=(u,s)=>c.call(this,t(u),s);const t=u=>{for(const s of i.b){const l=s(u);if(l){u=l;break}}return u}}}class f extends A.$4gc{constructor(){super(...arguments),this.extensionRuntime=L.ExtensionRuntime.Node}async tb(){this.h.createInstance(p.$Lic);const i=this.h.invokeFunction(O.$$hc);if(this.h.createInstance(b.$Kic),this.f.remote.isRemote&&this.f.remote.authority){const c=this.h.createInstance(C.$zN);process.env.VSCODE_IPC_HOOK_CLI=c.ipcHandlePath}this.h.createInstance(S.$Mic),await this.h.createInstance(h,i,{mine:this.J,all:this.L}).install(),D.mark("code/extHost/didInitAPI");const n=await this.m.getConfigProvider();await(0,I.$Jic)(this.j,n,this,this.s,this.z,this.f),D.mark("code/extHost/didInitProxyResolver")}ub(i){return i.main}async vb(i,r,n){if(r.scheme!==y.Schemas.file)throw new Error(`Cannot load URI: '${r}', must be of file-scheme`);let c=null;n.codeLoadingStart(),this.s.trace(`ExtensionService#loadCommonJSModule ${r.toString(!0)}`),this.s.flush();const t=i?.identifier.value;i&&await this.w.initializeLocalizedMessages(i);try{t&&D.mark(`code/extHost/willLoadExtensionCode/${t}`),c=me.__$__nodeRequire(r.fsPath)}finally{t&&D.mark(`code/extHost/didLoadExtensionCode/${t}`),n.codeLoadingStop()}return c}async $setRemoteEnvironment(i){if(this.f.remote.isRemote)for(const r in i){const n=i[r];n===null?delete process.env[r]:process.env[r]=n}}}e.$Nic=f}),define(ke[382],Se([1,0,50,22,4,3,122,10,23,2,31,13,255,64,109,88,379,27,20,72,357]),function(me,e,D,O,g,I,A,b,$,y,L,C,m,p,S,h,f,o,i,r,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vic=e.$Uic=e.$Tic=e.$Sic=e.$Ric=e.$Qic=e.$Pic=e.$Oic=void 0;function c(w){const E=w.trim().split(`
`),P=[];return E.forEach(U=>{const F=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(U);F&&F.length>=3&&P.push({pid:parseInt(F[1],10),socket:parseInt(F[2],10)})}),P.reduce((U,F)=>(U[F.socket]=F,U),{})}e.$Oic=c;function t(...w){const E=[].concat(...w.map(s));return[...new Map(E.filter(P=>P.st==="0A").map(P=>{const N=P.local_address.split(":");return{socket:parseInt(P.inode,10),ip:u(N[0]),port:parseInt(N[1],16)}}).map(P=>[P.ip+":"+P.port,P])).values()]}e.$Pic=t;function u(w){let E="";if(w.length===8)for(let P=w.length-2;P>=0;P-=2)E+=parseInt(w.substr(P,2),16),P!==0&&(E+=".");else for(let P=0;P<w.length;P+=8){const N=w.substring(P,P+8);let U="";for(let F=8;F>=2;F-=2)U+=N.substring(F-2,F),(F===6||F===2)&&(U=parseInt(U,16).toString(16),E+=`${U}`,U="",P+F!==w.length-6&&(E+=":"))}return E}e.$Qic=u;function s(w){const E=w.trim().split(`
`),P=E.shift().trim().split(/\s+/).filter(U=>U!=="rx_queue"&&U!=="tm->when");return E.map(U=>U.trim().split(/\s+/).reduce((F,j,T)=>(F[P[T]||T]=j,F),{}))}e.$Ric=s;function l(w){return!!w.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||w.indexOf("out/server-main.js")!==-1||w.indexOf("_productName=VSCode")!==-1}function a(w){const E=w.trim().split(`
`),P=[];return E.forEach(N=>{const U=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(N);U&&U.length>=4&&P.push({pid:parseInt(U[1],10),ppid:parseInt(U[2]),cmd:U[3]})}),P}e.$Sic=a;async function d(w,E,P){const N=P.reduce((F,j)=>(F[j.pid]=j,F),{}),U=[];return w.forEach(({socket:F,ip:j,port:T})=>{const M=E[F]?E[F].pid:void 0,B=M?N[M]?.cmd:void 0;M&&B&&!l(B)&&U.push({host:j,port:T,detail:B,pid:M})}),U}e.$Tic=d;function k(w,E,P){const N=new Map,U=a(E);for(const F of w){const j=P.get(F.port);if(j){N.set(F.port,j);continue}const T=U.find(M=>M.cmd.includes(`${F.port}`));if(T){let M=T,B;do B=U.find(Y=>Y.ppid===M.pid),B&&(M=B);while(B);N.set(F.port,{host:F.ip,port:F.port,pid:M.pid,detail:M.cmd,ppid:M.ppid})}else N.set(F.port,{host:F.ip,port:F.port,ppid:Number.MAX_VALUE})}return N}e.$Uic=k;let R=class extends r.$pyb{constructor(E,P,N,U){super(E,P,N),this.D=P,this.F=U,this.y=void 0,this.z=new Map,this.C=!1,b.$k&&P.remote.isRemote&&P.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.H())}async $registerCandidateFinder(E){if(E&&this.C)return;this.C=E;let P;this.y&&(P=this.y,await this.a.$onFoundNewCandidates(this.y));const N=new A.$0l;let U=0;for(;this.C;){const F=new Date().getTime(),j=(await this.I()).filter(B=>(0,h.$Fv)(B.host)||(0,h.$Hv)(B.host));this.s.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${j.map(B=>B.port).join(", ")}`);const T=new Date().getTime()-F;this.s.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${T} ms.`),U++>3&&N.update(T),(!P||JSON.stringify(P)!==JSON.stringify(j))&&(P=j,await this.a.$onFoundNewCandidates(P));const M=this.G(N.value);this.s.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${M} ms.`),await new Promise(B=>setTimeout(()=>B(),M))}}G(E){return Math.max(E*20,2e3)}async H(){this.y=await this.I(),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.y.map(E=>E.port).join(", ")}`)}async I(){let E="",P="";try{E=await L.Promises.readFile("/proc/net/tcp","utf8"),P=await L.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const N=t(E,P),U=await new Promise(Z=>{(0,D.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(J,X,he)=>{Z(X)})}),F=c(U),j=await L.Promises.readdir("/proc"),T=[];for(const Z of j)try{const J=Number(Z),X=$.$Hg(y.URI.file("/proc"),Z);if((await L.Promises.stat(X.fsPath)).isDirectory()&&!isNaN(J)){const _=await L.Promises.readlink($.$Hg(X,"cwd").fsPath),we=await L.Promises.readFile($.$Hg(X,"cmdline").fsPath,"utf8");T.push({pid:J,cwd:_,cmd:we})}}catch{}const M=[],B=N.filter(Z=>{const J=F[Z.socket];return J||M.push(Z),J}),Y=d(B,F,T);let ue;if(this.s.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${M.length}`),M.length>0){const Z=await new Promise(J=>{(0,D.exec)("ps -F -A -l | grep root",(X,he,_)=>{J(he)})});this.z=k(M,Z,this.z),ue=Array.from(this.z.values()),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${ue.map(J=>J.port).join(", ")}`)}return Y.then(Z=>ue?Z.concat(ue):Z)}w(E){return async P=>{const N=new f.$0$b({commit:this.D.commit,quality:this.D.quality,logService:this.s,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(F,j,T,M){const B=await E.makeConnection();return v.connect(B,j,T,M)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new p.$9k(0),connectionToken:E.connectionToken})}},signService:this.F},"localhost",P.remoteAddress.host||"localhost",P.remoteAddress.port,P.localAddressPort);await N.waitForReady();const U=new g.$Vd;return{localAddress:(0,n.$tK)(N.localAddress)??N.localAddress,remoteAddress:{port:N.tunnelRemotePort,host:N.tunnelRemoteHost},onDidDispose:U.event,dispose:()=>{N.dispose(),U.fire(),U.dispose()}}}}};e.$Vic=R,e.$Vic=R=Ge([We(0,i.$0M),We(1,o.$nN),We(2,C.$nj),We(3,S.$il)],R);class v extends m.$trb{static connect(E,P,N,U){const F=new I.$Sc,j={onClose:F.add(new g.$Vd),onData:F.add(new g.$Vd),onEnd:F.add(new g.$Vd)};F.add(E.onDidReceiveMessage(M=>j.onData.fire(O.$je.wrap(M)))),F.add(E.onDidEnd(()=>j.onEnd.fire())),F.add(E.onDidClose(M=>j.onClose.fire({type:0,error:M,hadError:!!M})));const T=new v(E,U,j);return T.B(F),(0,m.$srb)(T,P,N,U,j)}constructor(E,P,N){super(P,N),this.n=E}write(E){this.n.send(E.buffer)}h(){this.n.end()}async drain(){await this.n.drain?.()}}}),define(ke[383],Se([1,0,106,351,366,365,378,381,382,96,47,97,95,46,72,92,350,349,13,367,59,270,105,109,138]),function(me,e,D,O,g,I,A,b,$,y,L,C,m,p,S,h,f,o,i,r,n,c,t,u,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,D.$Yr)(L.$5gc,b.$Nic,0),(0,D.$Yr)(i.$oj,o.$Xic,1),(0,D.$Yr)(i.$nj,new t.$3h(c.$bic,[!1],!0)),(0,D.$Yr)(u.$il,s.$c_b,1),(0,D.$Yr)(h.$wgc,f.$Wic,0),(0,D.$Yr)(y.$0gc,I.$oic,0),(0,D.$Yr)(C.$thc,A.$Iic,0),(0,D.$Yr)(m.$Whc,g.$gic,0),(0,D.$Yr)(p.$Rgc,O.$fic,0),(0,D.$Yr)(S.$oyb,$.$Vic,0),(0,D.$Yr)(n.$8gc,r.$Yic,0)}),define(ke[394],Se([1,0,62,395,57,14,82,120,253,114,364,22,31,103,11,132,277,291,369,383]),function(me,e,D,O,g,I,A,b,$,y,L,C,m,p,S,h,f,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let k=0;k<process.execArgv.length;k++)process.execArgv[k]==="--inspect-port=0"&&(process.execArgv.splice(k,1),k--)}();const i=O(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const d=globalThis._VSCODE_NODE_MODULES.module,k=d._load;d._load=function(R){if(R==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return k.apply(this,arguments)}})();const r=process.exit.bind(process),n=process.on.bind(process);function c(d){process.exit=function(k){if(d)r(k);else{const R=new Error("An extension called process.exit() and this was prevented.");console.warn(R.stack)}},process.crash=function(){const k=new Error("An extension called process.crash() and this was prevented.");console.warn(k.stack)},process.env.ELECTRON_RUN_AS_NODE="1",process.on=function(k,R){k==="uncaughtException"&&(R=function(){try{return R.call(void 0,arguments)}catch{}}),n(k,R)}}let t=function(d){r()};function u(){const d=(0,o.$Tm)(process.env);if(d.type===3)return new Promise((k,R)=>{const v=w=>{const E=w[0],P=new A.$Sh;E.on("message",N=>P.fire(C.$je.wrap(N.data))),E.on("close",()=>{t("renderer closed the MessagePort")}),E.start(),k({onMessage:P.event,send:N=>E.postMessage(N.buffer)})};process.parentPort.on("message",w=>v(w.ports))});if(d.type===2)return new Promise((k,R)=>{let v=null;const w=setTimeout(()=>{t("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),E=108e5,P=3e5,N=new S.$gh(()=>t("renderer disconnected for too long (1)"),E),U=new S.$gh(()=>t("renderer disconnected for too long (2)"),P);process.on("message",(j,T)=>{if(j&&j.type==="VSCODE_EXTHOST_IPC_SOCKET"){T.setNoDelay(!0);const M=C.$je.wrap(Buffer.from(j.initialDataChunk,"base64"));let B;if(j.skipWebSocketFrames)B=new b.$Uh(T,"extHost-socket");else{const Y=C.$je.wrap(Buffer.from(j.inflateBytes,"base64"));B=new b.$Vh(new b.$Uh(T,"extHost-socket"),j.permessageDeflate,Y,!1)}v?(N.cancel(),U.cancel(),v.beginAcceptReconnection(B,M),v.endAcceptReconnection(),v.sendResume()):(clearTimeout(w),v=new A.$Th({socket:B,initialChunk:M}),v.sendResume(),v.onDidDispose(()=>t("renderer disconnected")),k(v),v.onSocketClose(()=>{N.schedule()}))}if(j&&j.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(U.isScheduled())return;N.isScheduled()&&U.schedule()}});const F={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(F)});{const k=d.pipeName;return new Promise((R,v)=>{const w=D.createConnection(k,()=>{w.removeListener("error",v);const E=new A.$Th({socket:new b.$Uh(w,"extHost-renderer")});E.sendResume(),R(E)});w.once("error",v),w.on("close",()=>{t("renderer closed the socket")})})}}async function s(){const d=await u();return new class{constructor(){this.a=new A.$Sh,this.onMessage=this.a.event,this.b=!1,d.onMessage(k=>{(0,y.$um)(k,2)?(this.b=!0,t("received terminate message from renderer")):this.a.fire(k)})}send(k){this.b||d.send(k)}async drain(){if(d.drain)return d.drain()}}}function l(d){return new Promise(k=>{const R=d.onMessage(v=>{R.dispose();const w=JSON.parse(v.toString()),E=w.commit,P=$.default.commit;if(E&&P&&E!==P&&r(55),w.parentPid){let N=0;setInterval(function(){try{process.kill(w.parentPid,0),N=0}catch(F){F&&F.code==="EPERM"?(N++,N>=3&&t(`parent process ${w.parentPid} does not exist anymore (3 x EPERM): ${F.message} (code: ${F.code}) (errno: ${F.errno})`)):t(`parent process ${w.parentPid} does not exist anymore: ${F.message} (code: ${F.code}) (errno: ${F.errno})`)}},1e3);let U;try{U=globalThis._VSCODE_NODE_MODULES["native-watchdog"],U.start(w.parentPid)}catch(F){(0,I.$1)(F)}}d.send((0,y.$tm)(0)),k({protocol:d,initData:w})});d.send((0,y.$tm)(1))})}async function a(){const d=[];process.on("unhandledRejection",(N,U)=>{d.push(U),setTimeout(()=>{const F=d.indexOf(U);F>=0&&U.catch(j=>{d.splice(F,1),(0,I.$4)(j)||(console.warn(`rejected promise not handled within 1 second: ${j}`),j&&j.stack&&console.warn(`stack trace: ${j.stack}`),N&&(0,I.$1)(N))})},1e3)}),process.on("rejectionHandled",N=>{const U=d.indexOf(N);U>=0&&d.splice(U,1)}),process.on("uncaughtException",function(N){(0,I.$Z)(N)||(0,I.$1)(N)}),g.mark("code/extHost/willConnectToRenderer");const k=await s();g.mark("code/extHost/didConnectToRenderer");const R=await l(k);g.mark("code/extHost/didWaitForInitData");const{initData:v}=R;c(!!v.environment.extensionTestsLocationURI),v.environment.useHostProxy=i.useHostProxy!==void 0?i.useHostProxy!=="false":void 0,v.environment.skipWorkspaceStorageLock=(0,h.boolean)(i.skipWorkspaceStorageLock,!1);const w=new class{constructor(){this.pid=process.pid}exit(U){r(U)}fsExists(U){return m.Promises.exists(U)}fsRealpath(U){return(0,p.$vq)(U)}};let E=null;v.remote.authority&&i.transformURIs&&(E=(0,f.$3r)(v.remote.authority));const P=new L.$eic(R.protocol,v,w,E);t=N=>P.terminate(N)}a().catch(d=>console.log(d))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/2c8f29174a63b3ace3d00ad0028cdc7ed9853b8b/core/vs/workbench/api/node/extensionHostProcess.js.map
