/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Pe=["exports","require","vs/base/common/uri","vs/workbench/api/common/extHost.protocol","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/strings","vs/base/common/network","vs/base/common/async","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/path","vs/base/common/cancellation","vs/base/common/platform","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/base/common/buffer","vs/base/common/resources","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/platform/registry/common/platform","vs/base/common/severity","vs/workbench/api/common/extHostCommands","vs/base/common/uuid","vs/base/common/glob","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/lazy","vs/base/common/errorMessage","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/services/search/common/search","vs/base/common/themables","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/platform/workspace/common/workspace","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/base/common/ternarySearchTree","vs/base/common/marshalling","vs/base/common/htmlContent","vs/base/common/assert","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/base/common/stopwatch","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/editor/common/languages","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/core/position","vs/editor/common/model","vs/editor/common/model/textModelSearch","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/eolCounter","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/workbench/api/worker/extensionHostWorker"],Re=function(ge){for(var e=[],y=0,T=ge.length;y<T;y++)e[y]=Pe[ge[y]];return e};define(Pe[66],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zh=e.$yh=e.$xh=void 0;function y(R){return($,f,b)=>{let A=null,k=null;if(typeof b.value=="function"?(A="value",k=b.value):typeof b.get=="function"&&(A="get",k=b.get),!k)throw new Error("not supported");b[A]=R(k,f)}}function T(R,$,f){let b=null,A=null;if(typeof f.value=="function"?(b="value",A=f.value,A.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof f.get=="function"&&(b="get",A=f.get),!A)throw new Error("not supported");const k=`$memoize$${$}`;f[b]=function(...l){return this.hasOwnProperty(k)||Object.defineProperty(this,k,{configurable:!1,enumerable:!1,writable:!1,value:A.apply(this,l)}),this[k]}}e.$xh=T;function C(R,$,f){return y((b,A)=>{const k=`$debounce$${A}`,l=`$debounce$result$${A}`;return function(...p){this[l]||(this[l]=f?f():void 0),clearTimeout(this[k]),$&&(this[l]=$(this[l],...p),p=[this[l]]),this[k]=setTimeout(()=>{b.apply(this,p),this[l]=f?f():void 0},R)}})}e.$yh=C;function L(R,$,f){return y((b,A)=>{const k=`$throttle$timer$${A}`,l=`$throttle$result$${A}`,p=`$throttle$lastRun$${A}`,w=`$throttle$pending$${A}`;return function(...s){if(this[l]||(this[l]=f?f():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),$&&(this[l]=$(this[l],...s)),this[w])return;const a=this[p]+R;a<=Date.now()?(this[p]=Date.now(),b.apply(this,[this[l]]),this[l]=f?f():void 0):(this[w]=!0,this[k]=setTimeout(()=>{this[w]=!1,this[p]=Date.now(),b.apply(this,[this[l]]),this[l]=f?f():void 0},a-Date.now()))}})}e.$zh=L}),define(Pe[89],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dN=e.$cN=void 0;class y{constructor(C){this.a=C,this.b=0}nextId(){return this.a+ ++this.b}}e.$cN=y,e.$dN=new y("id#")}),define(Pe[119],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var y;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(y||(e.ScanError=y={}));var T;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(T||(e.SyntaxKind=T={}));var C;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(C||(e.ParseErrorCode=C={}));var L;(function(t){t.DEFAULT={allowTrailingComma:!0}})(L||(e.ParseOptions=L={}));function R(t,u=!1){let i=0;const g=t.length;let m="",d=0,S=16,M=0;function v(z){let P=0,I=0;for(;P<z;){const H=t.charCodeAt(i);if(H>=48&&H<=57)I=I*16+H-48;else if(H>=65&&H<=70)I=I*16+H-65+10;else if(H>=97&&H<=102)I=I*16+H-97+10;else break;i++,P++}return P<z&&(I=-1),I}function E(z){i=z,m="",d=0,S=16,M=0}function D(){const z=i;if(t.charCodeAt(i)===48)i++;else for(i++;i<t.length&&b(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===46)if(i++,i<t.length&&b(t.charCodeAt(i)))for(i++;i<t.length&&b(t.charCodeAt(i));)i++;else return M=3,t.substring(z,i);let P=i;if(i<t.length&&(t.charCodeAt(i)===69||t.charCodeAt(i)===101))if(i++,(i<t.length&&t.charCodeAt(i)===43||t.charCodeAt(i)===45)&&i++,i<t.length&&b(t.charCodeAt(i))){for(i++;i<t.length&&b(t.charCodeAt(i));)i++;P=i}else M=3;return t.substring(z,P)}function N(){let z="",P=i;for(;;){if(i>=g){z+=t.substring(P,i),M=2;break}const I=t.charCodeAt(i);if(I===34){z+=t.substring(P,i),i++;break}if(I===92){if(z+=t.substring(P,i),i++,i>=g){M=2;break}switch(t.charCodeAt(i++)){case 34:z+='"';break;case 92:z+="\\";break;case 47:z+="/";break;case 98:z+="\b";break;case 102:z+="\f";break;case 110:z+=`
`;break;case 114:z+="\r";break;case 116:z+="	";break;case 117:{const ae=v(4);ae>=0?z+=String.fromCharCode(ae):M=4;break}default:M=5}P=i;continue}if(I>=0&&I<=31)if(f(I)){z+=t.substring(P,i),M=2;break}else M=6;i++}return z}function O(){if(m="",M=0,d=i,i>=g)return d=g,S=17;let z=t.charCodeAt(i);if($(z)){do i++,m+=String.fromCharCode(z),z=t.charCodeAt(i);while($(z));return S=15}if(f(z))return i++,m+=String.fromCharCode(z),z===13&&t.charCodeAt(i)===10&&(i++,m+=`
`),S=14;switch(z){case 123:return i++,S=1;case 125:return i++,S=2;case 91:return i++,S=3;case 93:return i++,S=4;case 58:return i++,S=6;case 44:return i++,S=5;case 34:return i++,m=N(),S=10;case 47:{const P=i-1;if(t.charCodeAt(i+1)===47){for(i+=2;i<g&&!f(t.charCodeAt(i));)i++;return m=t.substring(P,i),S=12}if(t.charCodeAt(i+1)===42){i+=2;const I=g-1;let H=!1;for(;i<I;){if(t.charCodeAt(i)===42&&t.charCodeAt(i+1)===47){i+=2,H=!0;break}i++}return H||(i++,M=1),m=t.substring(P,i),S=13}return m+=String.fromCharCode(z),i++,S=16}case 45:if(m+=String.fromCharCode(z),i++,i===g||!b(t.charCodeAt(i)))return S=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return m+=D(),S=11;default:for(;i<g&&G(z);)i++,z=t.charCodeAt(i);if(d!==i){switch(m=t.substring(d,i),m){case"true":return S=8;case"false":return S=9;case"null":return S=7}return S=16}return m+=String.fromCharCode(z),i++,S=16}}function G(z){if($(z)||f(z))return!1;switch(z){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function W(){let z;do z=O();while(z>=12&&z<=15);return z}return{setPosition:E,getPosition:()=>i,scan:u?W:O,getToken:()=>S,getTokenValue:()=>m,getTokenOffset:()=>d,getTokenLength:()=>i-d,getTokenError:()=>M}}e.$an=R;function $(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function f(t){return t===10||t===13||t===8232||t===8233}function b(t){return t>=48&&t<=57}var A;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(A||(A={}));function k(t,u){const i=[],g=new Object;let m;const d={value:{},offset:0,length:0,type:"object",parent:void 0};let S=!1;function M(v,E,D,N){d.value=v,d.offset=E,d.length=D,d.type=N,d.colonOffset=void 0,m=d}try{o(t,{onObjectBegin:(v,E)=>{if(u<=v)throw g;m=void 0,S=u>v,i.push("")},onObjectProperty:(v,E,D)=>{if(u<E||(M(v,E,D,"property"),i[i.length-1]=v,u<=E+D))throw g},onObjectEnd:(v,E)=>{if(u<=v)throw g;m=void 0,i.pop()},onArrayBegin:(v,E)=>{if(u<=v)throw g;m=void 0,i.push(0)},onArrayEnd:(v,E)=>{if(u<=v)throw g;m=void 0,i.pop()},onLiteralValue:(v,E,D)=>{if(u<E||(M(v,E,D,h(v)),u<=E+D))throw g},onSeparator:(v,E,D)=>{if(u<=E)throw g;if(v===":"&&m&&m.type==="property")m.colonOffset=E,S=!1,m=void 0;else if(v===","){const N=i[i.length-1];typeof N=="number"?i[i.length-1]=N+1:(S=!0,i[i.length-1]=""),m=void 0}}})}catch(v){if(v!==g)throw v}return{path:i,previousNode:m,isAtPropertyKey:S,matches:v=>{let E=0;for(let D=0;E<v.length&&D<i.length;D++)if(v[E]===i[D]||v[E]==="*")E++;else if(v[E]!=="**")return!1;return E===v.length}}}e.$bn=k;function l(t,u=[],i=L.DEFAULT){let g=null,m=[];const d=[];function S(v){Array.isArray(m)?m.push(v):g!==null&&(m[g]=v)}return o(t,{onObjectBegin:()=>{const v={};S(v),d.push(m),m=v,g=null},onObjectProperty:v=>{g=v},onObjectEnd:()=>{m=d.pop()},onArrayBegin:()=>{const v=[];S(v),d.push(m),m=v,g=null},onArrayEnd:()=>{m=d.pop()},onLiteralValue:S,onError:(v,E,D)=>{u.push({error:v,offset:E,length:D})}},i),m[0]}e.$cn=l;function p(t,u=[],i=L.DEFAULT){let g={type:"array",offset:-1,length:-1,children:[],parent:void 0};function m(v){g.type==="property"&&(g.length=v-g.offset,g=g.parent)}function d(v){return g.children.push(v),v}o(t,{onObjectBegin:v=>{g=d({type:"object",offset:v,length:-1,parent:g,children:[]})},onObjectProperty:(v,E,D)=>{g=d({type:"property",offset:E,length:-1,parent:g,children:[]}),g.children.push({type:"string",value:v,offset:E,length:D,parent:g})},onObjectEnd:(v,E)=>{g.length=v+E-g.offset,g=g.parent,m(v+E)},onArrayBegin:(v,E)=>{g=d({type:"array",offset:v,length:-1,parent:g,children:[]})},onArrayEnd:(v,E)=>{g.length=v+E-g.offset,g=g.parent,m(v+E)},onLiteralValue:(v,E,D)=>{d({type:h(v),offset:E,length:D,parent:g,value:v}),m(E+D)},onSeparator:(v,E,D)=>{g.type==="property"&&(v===":"?g.colonOffset=E:v===","&&m(E))},onError:(v,E,D)=>{u.push({error:v,offset:E,length:D})}},i);const M=g.children[0];return M&&delete M.parent,M}e.$dn=p;function w(t,u){if(!t)return;let i=t;for(const g of u)if(typeof g=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let m=!1;for(const d of i.children)if(Array.isArray(d.children)&&d.children[0].value===g){i=d.children[1],m=!0;break}if(!m)return}else{const m=g;if(i.type!=="array"||m<0||!Array.isArray(i.children)||m>=i.children.length)return;i=i.children[m]}return i}e.$en=w;function s(t){if(!t.parent||!t.parent.children)return[];const u=s(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;u.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&u.push(i)}return u}e.$fn=s;function a(t){switch(t.type){case"array":return t.children.map(a);case"object":{const u=Object.create(null);for(const i of t.children){const g=i.children[1];g&&(u[i.children[0].value]=a(g))}return u}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$gn=a;function r(t,u,i=!1){return u>=t.offset&&u<t.offset+t.length||i&&u===t.offset+t.length}e.$hn=r;function n(t,u,i=!1){if(r(t,u,i)){const g=t.children;if(Array.isArray(g))for(let m=0;m<g.length&&g[m].offset<=u;m++){const d=n(g[m],u,i);if(d)return d}return t}}e.$in=n;function o(t,u,i=L.DEFAULT){const g=R(t,!1);function m(se){return se?()=>se(g.getTokenOffset(),g.getTokenLength()):()=>!0}function d(se){return se?be=>se(be,g.getTokenOffset(),g.getTokenLength()):()=>!0}const S=m(u.onObjectBegin),M=d(u.onObjectProperty),v=m(u.onObjectEnd),E=m(u.onArrayBegin),D=m(u.onArrayEnd),N=d(u.onLiteralValue),O=d(u.onSeparator),G=m(u.onComment),W=d(u.onError),z=i&&i.disallowComments,P=i&&i.allowTrailingComma;function I(){for(;;){const se=g.scan();switch(g.getTokenError()){case 4:H(14);break;case 5:H(15);break;case 3:H(13);break;case 1:z||H(11);break;case 2:H(12);break;case 6:H(16);break}switch(se){case 12:case 13:z?H(10):G();break;case 16:H(1);break;case 15:case 14:break;default:return se}}}function H(se,be=[],ne=[]){if(W(se),be.length+ne.length>0){let Y=g.getToken();for(;Y!==17;){if(be.indexOf(Y)!==-1){I();break}else if(ne.indexOf(Y)!==-1)break;Y=I()}}}function ae(se){const be=g.getTokenValue();return se?N(be):M(be),I(),!0}function de(){switch(g.getToken()){case 11:{let se=0;try{se=JSON.parse(g.getTokenValue()),typeof se!="number"&&(H(2),se=0)}catch{H(2)}N(se);break}case 7:N(null);break;case 8:N(!0);break;case 9:N(!1);break;default:return!1}return I(),!0}function we(){return g.getToken()!==10?(H(3,[],[2,5]),!1):(ae(!1),g.getToken()===6?(O(":"),I(),ve()||H(4,[],[2,5])):H(5,[],[2,5]),!0)}function ke(){S(),I();let se=!1;for(;g.getToken()!==2&&g.getToken()!==17;){if(g.getToken()===5){if(se||H(4,[],[]),O(","),I(),g.getToken()===2&&P)break}else se&&H(6,[],[]);we()||H(4,[],[2,5]),se=!0}return v(),g.getToken()!==2?H(7,[2],[]):I(),!0}function le(){E(),I();let se=!1;for(;g.getToken()!==4&&g.getToken()!==17;){if(g.getToken()===5){if(se||H(4,[],[]),O(","),I(),g.getToken()===4&&P)break}else se&&H(6,[],[]);ve()||H(4,[],[4,5]),se=!0}return D(),g.getToken()!==4?H(8,[4],[]):I(),!0}function ve(){switch(g.getToken()){case 3:return le();case 1:return ke();case 10:return ae(!0);default:return de()}}return I(),g.getToken()===17?i.allowEmptyContent?!0:(H(4,[],[]),!1):ve()?(g.getToken()!==17&&H(9,[],[]),!0):(H(4,[],[]),!1)}e.$jn=o;function c(t,u){const i=R(t),g=[];let m,d=0,S;do switch(S=i.getPosition(),m=i.scan(),m){case 12:case 13:case 17:d!==S&&g.push(t.substring(d,S)),u!==void 0&&g.push(i.getTokenValue().replace(/[^\r\n]/g,u)),d=i.getPosition();break}while(m!==17);return g.join("")}e.$kn=c;function h(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$ln=h}),function(ge,e){typeof define=="function"&&define.amd?define(Pe[120],Re([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(ge=typeof globalThis<"u"?globalThis:ge||self,e(ge.marked={}))}(this,function(ge){"use strict";function e(Ce,ce){for(var te=0;te<ce.length;te++){var Q=ce[te];Q.enumerable=Q.enumerable||!1,Q.configurable=!0,"value"in Q&&(Q.writable=!0),Object.defineProperty(Ce,Q.key,Q)}}function y(Ce,ce,te){return ce&&e(Ce.prototype,ce),te&&e(Ce,te),Object.defineProperty(Ce,"prototype",{writable:!1}),Ce}function T(Ce,ce){if(Ce){if(typeof Ce=="string")return C(Ce,ce);var te=Object.prototype.toString.call(Ce).slice(8,-1);if(te==="Object"&&Ce.constructor&&(te=Ce.constructor.name),te==="Map"||te==="Set")return Array.from(Ce);if(te==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(te))return C(Ce,ce)}}function C(Ce,ce){(ce==null||ce>Ce.length)&&(ce=Ce.length);for(var te=0,Q=new Array(ce);te<ce;te++)Q[te]=Ce[te];return Q}function L(Ce,ce){var te=typeof Symbol<"u"&&Ce[Symbol.iterator]||Ce["@@iterator"];if(te)return(te=te.call(Ce)).next.bind(te);if(Array.isArray(Ce)||(te=T(Ce))||ce&&Ce&&typeof Ce.length=="number"){te&&(Ce=te);var Q=0;return function(){return Q>=Ce.length?{done:!0}:{done:!1,value:Ce[Q++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function R(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ge.defaults=R();function $(Ce){ge.defaults=Ce}var f=/[&<>"']/,b=/[&<>"']/g,A=/[<>"']|&(?!#?\w+;)/,k=/[<>"']|&(?!#?\w+;)/g,l={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},p=function(ce){return l[ce]};function w(Ce,ce){if(ce){if(f.test(Ce))return Ce.replace(b,p)}else if(A.test(Ce))return Ce.replace(k,p);return Ce}var s=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function a(Ce){return Ce.replace(s,function(ce,te){return te=te.toLowerCase(),te==="colon"?":":te.charAt(0)==="#"?te.charAt(1)==="x"?String.fromCharCode(parseInt(te.substring(2),16)):String.fromCharCode(+te.substring(1)):""})}var r=/(^|[^\[])\^/g;function n(Ce,ce){Ce=typeof Ce=="string"?Ce:Ce.source,ce=ce||"";var te={replace:function(ee,me){return me=me.source||me,me=me.replace(r,"$1"),Ce=Ce.replace(ee,me),te},getRegex:function(){return new RegExp(Ce,ce)}};return te}var o=/[^\w:]/g,c=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function h(Ce,ce,te){if(Ce){var Q;try{Q=decodeURIComponent(a(te)).replace(o,"").toLowerCase()}catch{return null}if(Q.indexOf("javascript:")===0||Q.indexOf("vbscript:")===0||Q.indexOf("data:")===0)return null}ce&&!c.test(te)&&(te=m(ce,te));try{te=encodeURI(te).replace(/%25/g,"%")}catch{return null}return te}var t={},u=/^[^:]+:\/*[^/]*$/,i=/^([^:]+:)[\s\S]*$/,g=/^([^:]+:\/*[^/]*)[\s\S]*$/;function m(Ce,ce){t[" "+Ce]||(u.test(Ce)?t[" "+Ce]=Ce+"/":t[" "+Ce]=v(Ce,"/",!0)),Ce=t[" "+Ce];var te=Ce.indexOf(":")===-1;return ce.substring(0,2)==="//"?te?ce:Ce.replace(i,"$1")+ce:ce.charAt(0)==="/"?te?ce:Ce.replace(g,"$1")+ce:Ce+ce}var d={exec:function(){}};function S(Ce){for(var ce=1,te,Q;ce<arguments.length;ce++){te=arguments[ce];for(Q in te)Object.prototype.hasOwnProperty.call(te,Q)&&(Ce[Q]=te[Q])}return Ce}function M(Ce,ce){var te=Ce.replace(/\|/g,function(me,pe,Ae){for(var he=!1,ye=pe;--ye>=0&&Ae[ye]==="\\";)he=!he;return he?"|":" |"}),Q=te.split(/ \|/),ee=0;if(Q[0].trim()||Q.shift(),Q.length>0&&!Q[Q.length-1].trim()&&Q.pop(),Q.length>ce)Q.splice(ce);else for(;Q.length<ce;)Q.push("");for(;ee<Q.length;ee++)Q[ee]=Q[ee].trim().replace(/\\\|/g,"|");return Q}function v(Ce,ce,te){var Q=Ce.length;if(Q===0)return"";for(var ee=0;ee<Q;){var me=Ce.charAt(Q-ee-1);if(me===ce&&!te)ee++;else if(me!==ce&&te)ee++;else break}return Ce.slice(0,Q-ee)}function E(Ce,ce){if(Ce.indexOf(ce[1])===-1)return-1;for(var te=Ce.length,Q=0,ee=0;ee<te;ee++)if(Ce[ee]==="\\")ee++;else if(Ce[ee]===ce[0])Q++;else if(Ce[ee]===ce[1]&&(Q--,Q<0))return ee;return-1}function D(Ce){Ce&&Ce.sanitize&&!Ce.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function N(Ce,ce){if(ce<1)return"";for(var te="";ce>1;)ce&1&&(te+=Ce),ce>>=1,Ce+=Ce;return te+Ce}function O(Ce,ce,te,Q){var ee=ce.href,me=ce.title?w(ce.title):null,pe=Ce[1].replace(/\\([\[\]])/g,"$1");if(Ce[0].charAt(0)!=="!"){Q.state.inLink=!0;var Ae={type:"link",raw:te,href:ee,title:me,text:pe,tokens:Q.inlineTokens(pe)};return Q.state.inLink=!1,Ae}return{type:"image",raw:te,href:ee,title:me,text:w(pe)}}function G(Ce,ce){var te=Ce.match(/^(\s+)(?:```)/);if(te===null)return ce;var Q=te[1];return ce.split(`
`).map(function(ee){var me=ee.match(/^\s+/);if(me===null)return ee;var pe=me[0];return pe.length>=Q.length?ee.slice(Q.length):ee}).join(`
`)}var W=function(){function Ce(te){this.options=te||ge.defaults}var ce=Ce.prototype;return ce.space=function(Q){var ee=this.rules.block.newline.exec(Q);if(ee&&ee[0].length>0)return{type:"space",raw:ee[0]}},ce.code=function(Q){var ee=this.rules.block.code.exec(Q);if(ee){var me=ee[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ee[0],codeBlockStyle:"indented",text:this.options.pedantic?me:v(me,`
`)}}},ce.fences=function(Q){var ee=this.rules.block.fences.exec(Q);if(ee){var me=ee[0],pe=G(me,ee[3]||"");return{type:"code",raw:me,lang:ee[2]?ee[2].trim():ee[2],text:pe}}},ce.heading=function(Q){var ee=this.rules.block.heading.exec(Q);if(ee){var me=ee[2].trim();if(/#$/.test(me)){var pe=v(me,"#");(this.options.pedantic||!pe||/ $/.test(pe))&&(me=pe.trim())}return{type:"heading",raw:ee[0],depth:ee[1].length,text:me,tokens:this.lexer.inline(me)}}},ce.hr=function(Q){var ee=this.rules.block.hr.exec(Q);if(ee)return{type:"hr",raw:ee[0]}},ce.blockquote=function(Q){var ee=this.rules.block.blockquote.exec(Q);if(ee){var me=ee[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ee[0],tokens:this.lexer.blockTokens(me,[]),text:me}}},ce.list=function(Q){var ee=this.rules.block.list.exec(Q);if(ee){var me,pe,Ae,he,ye,F,q,K,U,X,x,Ee,Te=ee[1].trim(),Ve=Te.length>1,He={type:"list",raw:"",ordered:Ve,start:Ve?+Te.slice(0,-1):"",loose:!1,items:[]};Te=Ve?"\\d{1,9}\\"+Te.slice(-1):"\\"+Te,this.options.pedantic&&(Te=Ve?Te:"[*+-]");for(var Ye=new RegExp("^( {0,3}"+Te+")((?:[	 ][^\\n]*)?(?:\\n|$))");Q&&(Ee=!1,!(!(ee=Ye.exec(Q))||this.rules.block.hr.test(Q)));){if(me=ee[0],Q=Q.substring(me.length),K=ee[2].split(`
`,1)[0],U=Q.split(`
`,1)[0],this.options.pedantic?(he=2,x=K.trimLeft()):(he=ee[2].search(/[^ ]/),he=he>4?1:he,x=K.slice(he),he+=ee[1].length),F=!1,!K&&/^ *$/.test(U)&&(me+=U+`
`,Q=Q.substring(U.length+1),Ee=!0),!Ee)for(var st=new RegExp("^ {0,"+Math.min(3,he-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),nt=new RegExp("^ {0,"+Math.min(3,he-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),tt=new RegExp("^ {0,"+Math.min(3,he-1)+"}(?:```|~~~)"),at=new RegExp("^ {0,"+Math.min(3,he-1)+"}#");Q&&(X=Q.split(`
`,1)[0],K=X,this.options.pedantic&&(K=K.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(tt.test(K)||at.test(K)||st.test(K)||nt.test(Q)));){if(K.search(/[^ ]/)>=he||!K.trim())x+=`
`+K.slice(he);else if(!F)x+=`
`+K;else break;!F&&!K.trim()&&(F=!0),me+=X+`
`,Q=Q.substring(X.length+1)}He.loose||(q?He.loose=!0:/\n *\n *$/.test(me)&&(q=!0)),this.options.gfm&&(pe=/^\[[ xX]\] /.exec(x),pe&&(Ae=pe[0]!=="[ ] ",x=x.replace(/^\[[ xX]\] +/,""))),He.items.push({type:"list_item",raw:me,task:!!pe,checked:Ae,loose:!1,text:x}),He.raw+=me}He.items[He.items.length-1].raw=me.trimRight(),He.items[He.items.length-1].text=x.trimRight(),He.raw=He.raw.trimRight();var ct=He.items.length;for(ye=0;ye<ct;ye++){this.lexer.state.top=!1,He.items[ye].tokens=this.lexer.blockTokens(He.items[ye].text,[]);var je=He.items[ye].tokens.filter(function(Z){return Z.type==="space"}),vt=je.every(function(Z){for(var _=Z.raw.split(""),$e=0,Be=L(_),Qe;!(Qe=Be()).done;){var it=Qe.value;if(it===`
`&&($e+=1),$e>1)return!0}return!1});!He.loose&&je.length&&vt&&(He.loose=!0,He.items[ye].loose=!0)}return He}},ce.html=function(Q){var ee=this.rules.block.html.exec(Q);if(ee){var me={type:"html",raw:ee[0],pre:!this.options.sanitizer&&(ee[1]==="pre"||ee[1]==="script"||ee[1]==="style"),text:ee[0]};if(this.options.sanitize){var pe=this.options.sanitizer?this.options.sanitizer(ee[0]):w(ee[0]);me.type="paragraph",me.text=pe,me.tokens=this.lexer.inline(pe)}return me}},ce.def=function(Q){var ee=this.rules.block.def.exec(Q);if(ee){ee[3]&&(ee[3]=ee[3].substring(1,ee[3].length-1));var me=ee[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:me,raw:ee[0],href:ee[2],title:ee[3]}}},ce.table=function(Q){var ee=this.rules.block.table.exec(Q);if(ee){var me={type:"table",header:M(ee[1]).map(function(q){return{text:q}}),align:ee[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ee[3]&&ee[3].trim()?ee[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(me.header.length===me.align.length){me.raw=ee[0];var pe=me.align.length,Ae,he,ye,F;for(Ae=0;Ae<pe;Ae++)/^ *-+: *$/.test(me.align[Ae])?me.align[Ae]="right":/^ *:-+: *$/.test(me.align[Ae])?me.align[Ae]="center":/^ *:-+ *$/.test(me.align[Ae])?me.align[Ae]="left":me.align[Ae]=null;for(pe=me.rows.length,Ae=0;Ae<pe;Ae++)me.rows[Ae]=M(me.rows[Ae],me.header.length).map(function(q){return{text:q}});for(pe=me.header.length,he=0;he<pe;he++)me.header[he].tokens=this.lexer.inline(me.header[he].text);for(pe=me.rows.length,he=0;he<pe;he++)for(F=me.rows[he],ye=0;ye<F.length;ye++)F[ye].tokens=this.lexer.inline(F[ye].text);return me}}},ce.lheading=function(Q){var ee=this.rules.block.lheading.exec(Q);if(ee)return{type:"heading",raw:ee[0],depth:ee[2].charAt(0)==="="?1:2,text:ee[1],tokens:this.lexer.inline(ee[1])}},ce.paragraph=function(Q){var ee=this.rules.block.paragraph.exec(Q);if(ee){var me=ee[1].charAt(ee[1].length-1)===`
`?ee[1].slice(0,-1):ee[1];return{type:"paragraph",raw:ee[0],text:me,tokens:this.lexer.inline(me)}}},ce.text=function(Q){var ee=this.rules.block.text.exec(Q);if(ee)return{type:"text",raw:ee[0],text:ee[0],tokens:this.lexer.inline(ee[0])}},ce.escape=function(Q){var ee=this.rules.inline.escape.exec(Q);if(ee)return{type:"escape",raw:ee[0],text:w(ee[1])}},ce.tag=function(Q){var ee=this.rules.inline.tag.exec(Q);if(ee)return!this.lexer.state.inLink&&/^<a /i.test(ee[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ee[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ee[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ee[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ee[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ee[0]):w(ee[0]):ee[0]}},ce.link=function(Q){var ee=this.rules.inline.link.exec(Q);if(ee){var me=ee[2].trim();if(!this.options.pedantic&&/^</.test(me)){if(!/>$/.test(me))return;var pe=v(me.slice(0,-1),"\\");if((me.length-pe.length)%2===0)return}else{var Ae=E(ee[2],"()");if(Ae>-1){var he=ee[0].indexOf("!")===0?5:4,ye=he+ee[1].length+Ae;ee[2]=ee[2].substring(0,Ae),ee[0]=ee[0].substring(0,ye).trim(),ee[3]=""}}var F=ee[2],q="";if(this.options.pedantic){var K=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(F);K&&(F=K[1],q=K[3])}else q=ee[3]?ee[3].slice(1,-1):"";return F=F.trim(),/^</.test(F)&&(this.options.pedantic&&!/>$/.test(me)?F=F.slice(1):F=F.slice(1,-1)),O(ee,{href:F&&F.replace(this.rules.inline._escapes,"$1"),title:q&&q.replace(this.rules.inline._escapes,"$1")},ee[0],this.lexer)}},ce.reflink=function(Q,ee){var me;if((me=this.rules.inline.reflink.exec(Q))||(me=this.rules.inline.nolink.exec(Q))){var pe=(me[2]||me[1]).replace(/\s+/g," ");if(pe=ee[pe.toLowerCase()],!pe||!pe.href){var Ae=me[0].charAt(0);return{type:"text",raw:Ae,text:Ae}}return O(me,pe,me[0],this.lexer)}},ce.emStrong=function(Q,ee,me){me===void 0&&(me="");var pe=this.rules.inline.emStrong.lDelim.exec(Q);if(pe&&!(pe[3]&&me.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Ae=pe[1]||pe[2]||"";if(!Ae||Ae&&(me===""||this.rules.inline.punctuation.exec(me))){var he=pe[0].length-1,ye,F,q=he,K=0,U=pe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(U.lastIndex=0,ee=ee.slice(-1*Q.length+he);(pe=U.exec(ee))!=null;)if(ye=pe[1]||pe[2]||pe[3]||pe[4]||pe[5]||pe[6],!!ye){if(F=ye.length,pe[3]||pe[4]){q+=F;continue}else if((pe[5]||pe[6])&&he%3&&!((he+F)%3)){K+=F;continue}if(q-=F,!(q>0)){if(F=Math.min(F,F+q+K),Math.min(he,F)%2){var X=Q.slice(1,he+pe.index+F);return{type:"em",raw:Q.slice(0,he+pe.index+F+1),text:X,tokens:this.lexer.inlineTokens(X)}}var x=Q.slice(2,he+pe.index+F-1);return{type:"strong",raw:Q.slice(0,he+pe.index+F+1),text:x,tokens:this.lexer.inlineTokens(x)}}}}}},ce.codespan=function(Q){var ee=this.rules.inline.code.exec(Q);if(ee){var me=ee[2].replace(/\n/g," "),pe=/[^ ]/.test(me),Ae=/^ /.test(me)&&/ $/.test(me);return pe&&Ae&&(me=me.substring(1,me.length-1)),me=w(me,!0),{type:"codespan",raw:ee[0],text:me}}},ce.br=function(Q){var ee=this.rules.inline.br.exec(Q);if(ee)return{type:"br",raw:ee[0]}},ce.del=function(Q){var ee=this.rules.inline.del.exec(Q);if(ee)return{type:"del",raw:ee[0],text:ee[2],tokens:this.lexer.inlineTokens(ee[2])}},ce.autolink=function(Q,ee){var me=this.rules.inline.autolink.exec(Q);if(me){var pe,Ae;return me[2]==="@"?(pe=w(this.options.mangle?ee(me[1]):me[1]),Ae="mailto:"+pe):(pe=w(me[1]),Ae=pe),{type:"link",raw:me[0],text:pe,href:Ae,tokens:[{type:"text",raw:pe,text:pe}]}}},ce.url=function(Q,ee){var me;if(me=this.rules.inline.url.exec(Q)){var pe,Ae;if(me[2]==="@")pe=w(this.options.mangle?ee(me[0]):me[0]),Ae="mailto:"+pe;else{var he;do he=me[0],me[0]=this.rules.inline._backpedal.exec(me[0])[0];while(he!==me[0]);pe=w(me[0]),me[1]==="www."?Ae="http://"+pe:Ae=pe}return{type:"link",raw:me[0],text:pe,href:Ae,tokens:[{type:"text",raw:pe,text:pe}]}}},ce.inlineText=function(Q,ee){var me=this.rules.inline.text.exec(Q);if(me){var pe;return this.lexer.state.inRawBlock?pe=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(me[0]):w(me[0]):me[0]:pe=w(this.options.smartypants?ee(me[0]):me[0]),{type:"text",raw:me[0],text:pe}}},Ce}(),z={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:d,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};z._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,z._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,z.def=n(z.def).replace("label",z._label).replace("title",z._title).getRegex(),z.bullet=/(?:[*+-]|\d{1,9}[.)])/,z.listItemStart=n(/^( *)(bull) */).replace("bull",z.bullet).getRegex(),z.list=n(z.list).replace(/bull/g,z.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+z.def.source+")").getRegex(),z._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",z._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,z.html=n(z.html,"i").replace("comment",z._comment).replace("tag",z._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),z.paragraph=n(z._paragraph).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.blockquote=n(z.blockquote).replace("paragraph",z.paragraph).getRegex(),z.normal=S({},z),z.gfm=S({},z.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),z.gfm.table=n(z.gfm.table).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.gfm.paragraph=n(z._paragraph).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",z.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.pedantic=S({},z.normal,{html:n(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",z._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:d,paragraph:n(z.normal._paragraph).replace("hr",z.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",z.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var P={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:d,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:d,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};P._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",P.punctuation=n(P.punctuation).replace(/punctuation/g,P._punctuation).getRegex(),P.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,P.escapedEmSt=/\\\*|\\_/g,P._comment=n(z._comment).replace("(?:-->|$)","-->").getRegex(),P.emStrong.lDelim=n(P.emStrong.lDelim).replace(/punct/g,P._punctuation).getRegex(),P.emStrong.rDelimAst=n(P.emStrong.rDelimAst,"g").replace(/punct/g,P._punctuation).getRegex(),P.emStrong.rDelimUnd=n(P.emStrong.rDelimUnd,"g").replace(/punct/g,P._punctuation).getRegex(),P._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,P._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,P._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,P.autolink=n(P.autolink).replace("scheme",P._scheme).replace("email",P._email).getRegex(),P._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,P.tag=n(P.tag).replace("comment",P._comment).replace("attribute",P._attribute).getRegex(),P._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,P._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,P._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,P.link=n(P.link).replace("label",P._label).replace("href",P._href).replace("title",P._title).getRegex(),P.reflink=n(P.reflink).replace("label",P._label).replace("ref",z._label).getRegex(),P.nolink=n(P.nolink).replace("ref",z._label).getRegex(),P.reflinkSearch=n(P.reflinkSearch,"g").replace("reflink",P.reflink).replace("nolink",P.nolink).getRegex(),P.normal=S({},P),P.pedantic=S({},P.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:n(/^!?\[(label)\]\((.*?)\)/).replace("label",P._label).getRegex(),reflink:n(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",P._label).getRegex()}),P.gfm=S({},P.normal,{escape:n(P.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),P.gfm.url=n(P.gfm.url,"i").replace("email",P.gfm._extended_email).getRegex(),P.breaks=S({},P.gfm,{br:n(P.br).replace("{2,}","*").getRegex(),text:n(P.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function I(Ce){return Ce.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function H(Ce){var ce="",te,Q,ee=Ce.length;for(te=0;te<ee;te++)Q=Ce.charCodeAt(te),Math.random()>.5&&(Q="x"+Q.toString(16)),ce+="&#"+Q+";";return ce}var ae=function(){function Ce(te){this.tokens=[],this.tokens.links=Object.create(null),this.options=te||ge.defaults,this.options.tokenizer=this.options.tokenizer||new W,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var Q={block:z.normal,inline:P.normal};this.options.pedantic?(Q.block=z.pedantic,Q.inline=P.pedantic):this.options.gfm&&(Q.block=z.gfm,this.options.breaks?Q.inline=P.breaks:Q.inline=P.gfm),this.tokenizer.rules=Q}Ce.lex=function(Q,ee){var me=new Ce(ee);return me.lex(Q)},Ce.lexInline=function(Q,ee){var me=new Ce(ee);return me.inlineTokens(Q)};var ce=Ce.prototype;return ce.lex=function(Q){Q=Q.replace(/\r\n|\r/g,`
`),this.blockTokens(Q,this.tokens);for(var ee;ee=this.inlineQueue.shift();)this.inlineTokens(ee.src,ee.tokens);return this.tokens},ce.blockTokens=function(Q,ee){var me=this;ee===void 0&&(ee=[]),this.options.pedantic?Q=Q.replace(/\t/g,"    ").replace(/^ +$/gm,""):Q=Q.replace(/^( *)(\t+)/gm,function(q,K,U){return K+"    ".repeat(U.length)});for(var pe,Ae,he,ye;Q;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(q){return(pe=q.call({lexer:me},Q,ee))?(Q=Q.substring(pe.raw.length),ee.push(pe),!0):!1}))){if(pe=this.tokenizer.space(Q)){Q=Q.substring(pe.raw.length),pe.raw.length===1&&ee.length>0?ee[ee.length-1].raw+=`
`:ee.push(pe);continue}if(pe=this.tokenizer.code(Q)){Q=Q.substring(pe.raw.length),Ae=ee[ee.length-1],Ae&&(Ae.type==="paragraph"||Ae.type==="text")?(Ae.raw+=`
`+pe.raw,Ae.text+=`
`+pe.text,this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):ee.push(pe);continue}if(pe=this.tokenizer.fences(Q)){Q=Q.substring(pe.raw.length),ee.push(pe);continue}if(pe=this.tokenizer.heading(Q)){Q=Q.substring(pe.raw.length),ee.push(pe);continue}if(pe=this.tokenizer.hr(Q)){Q=Q.substring(pe.raw.length),ee.push(pe);continue}if(pe=this.tokenizer.blockquote(Q)){Q=Q.substring(pe.raw.length),ee.push(pe);continue}if(pe=this.tokenizer.list(Q)){Q=Q.substring(pe.raw.length),ee.push(pe);continue}if(pe=this.tokenizer.html(Q)){Q=Q.substring(pe.raw.length),ee.push(pe);continue}if(pe=this.tokenizer.def(Q)){Q=Q.substring(pe.raw.length),Ae=ee[ee.length-1],Ae&&(Ae.type==="paragraph"||Ae.type==="text")?(Ae.raw+=`
`+pe.raw,Ae.text+=`
`+pe.raw,this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):this.tokens.links[pe.tag]||(this.tokens.links[pe.tag]={href:pe.href,title:pe.title});continue}if(pe=this.tokenizer.table(Q)){Q=Q.substring(pe.raw.length),ee.push(pe);continue}if(pe=this.tokenizer.lheading(Q)){Q=Q.substring(pe.raw.length),ee.push(pe);continue}if(he=Q,this.options.extensions&&this.options.extensions.startBlock&&function(){var q=1/0,K=Q.slice(1),U=void 0;me.options.extensions.startBlock.forEach(function(X){U=X.call({lexer:this},K),typeof U=="number"&&U>=0&&(q=Math.min(q,U))}),q<1/0&&q>=0&&(he=Q.substring(0,q+1))}(),this.state.top&&(pe=this.tokenizer.paragraph(he))){Ae=ee[ee.length-1],ye&&Ae.type==="paragraph"?(Ae.raw+=`
`+pe.raw,Ae.text+=`
`+pe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):ee.push(pe),ye=he.length!==Q.length,Q=Q.substring(pe.raw.length);continue}if(pe=this.tokenizer.text(Q)){Q=Q.substring(pe.raw.length),Ae=ee[ee.length-1],Ae&&Ae.type==="text"?(Ae.raw+=`
`+pe.raw,Ae.text+=`
`+pe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):ee.push(pe);continue}if(Q){var F="Infinite loop on byte: "+Q.charCodeAt(0);if(this.options.silent){console.error(F);break}else throw new Error(F)}}return this.state.top=!0,ee},ce.inline=function(Q,ee){return ee===void 0&&(ee=[]),this.inlineQueue.push({src:Q,tokens:ee}),ee},ce.inlineTokens=function(Q,ee){var me=this;ee===void 0&&(ee=[]);var pe,Ae,he,ye=Q,F,q,K;if(this.tokens.links){var U=Object.keys(this.tokens.links);if(U.length>0)for(;(F=this.tokenizer.rules.inline.reflinkSearch.exec(ye))!=null;)U.includes(F[0].slice(F[0].lastIndexOf("[")+1,-1))&&(ye=ye.slice(0,F.index)+"["+N("a",F[0].length-2)+"]"+ye.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(F=this.tokenizer.rules.inline.blockSkip.exec(ye))!=null;)ye=ye.slice(0,F.index)+"["+N("a",F[0].length-2)+"]"+ye.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(F=this.tokenizer.rules.inline.escapedEmSt.exec(ye))!=null;)ye=ye.slice(0,F.index)+"++"+ye.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;Q;)if(q||(K=""),q=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(x){return(pe=x.call({lexer:me},Q,ee))?(Q=Q.substring(pe.raw.length),ee.push(pe),!0):!1}))){if(pe=this.tokenizer.escape(Q)){Q=Q.substring(pe.raw.length),ee.push(pe);continue}if(pe=this.tokenizer.tag(Q)){Q=Q.substring(pe.raw.length),Ae=ee[ee.length-1],Ae&&pe.type==="text"&&Ae.type==="text"?(Ae.raw+=pe.raw,Ae.text+=pe.text):ee.push(pe);continue}if(pe=this.tokenizer.link(Q)){Q=Q.substring(pe.raw.length),ee.push(pe);continue}if(pe=this.tokenizer.reflink(Q,this.tokens.links)){Q=Q.substring(pe.raw.length),Ae=ee[ee.length-1],Ae&&pe.type==="text"&&Ae.type==="text"?(Ae.raw+=pe.raw,Ae.text+=pe.text):ee.push(pe);continue}if(pe=this.tokenizer.emStrong(Q,ye,K)){Q=Q.substring(pe.raw.length),ee.push(pe);continue}if(pe=this.tokenizer.codespan(Q)){Q=Q.substring(pe.raw.length),ee.push(pe);continue}if(pe=this.tokenizer.br(Q)){Q=Q.substring(pe.raw.length),ee.push(pe);continue}if(pe=this.tokenizer.del(Q)){Q=Q.substring(pe.raw.length),ee.push(pe);continue}if(pe=this.tokenizer.autolink(Q,H)){Q=Q.substring(pe.raw.length),ee.push(pe);continue}if(!this.state.inLink&&(pe=this.tokenizer.url(Q,H))){Q=Q.substring(pe.raw.length),ee.push(pe);continue}if(he=Q,this.options.extensions&&this.options.extensions.startInline&&function(){var x=1/0,Ee=Q.slice(1),Te=void 0;me.options.extensions.startInline.forEach(function(Ve){Te=Ve.call({lexer:this},Ee),typeof Te=="number"&&Te>=0&&(x=Math.min(x,Te))}),x<1/0&&x>=0&&(he=Q.substring(0,x+1))}(),pe=this.tokenizer.inlineText(he,I)){Q=Q.substring(pe.raw.length),pe.raw.slice(-1)!=="_"&&(K=pe.raw.slice(-1)),q=!0,Ae=ee[ee.length-1],Ae&&Ae.type==="text"?(Ae.raw+=pe.raw,Ae.text+=pe.text):ee.push(pe);continue}if(Q){var X="Infinite loop on byte: "+Q.charCodeAt(0);if(this.options.silent){console.error(X);break}else throw new Error(X)}}return ee},y(Ce,null,[{key:"rules",get:function(){return{block:z,inline:P}}}]),Ce}(),de=function(){function Ce(te){this.options=te||ge.defaults}var ce=Ce.prototype;return ce.code=function(Q,ee,me){var pe=(ee||"").match(/\S*/)[0];if(this.options.highlight){var Ae=this.options.highlight(Q,pe);Ae!=null&&Ae!==Q&&(me=!0,Q=Ae)}return Q=Q.replace(/\n$/,"")+`
`,pe?'<pre><code class="'+this.options.langPrefix+w(pe,!0)+'">'+(me?Q:w(Q,!0))+`</code></pre>
`:"<pre><code>"+(me?Q:w(Q,!0))+`</code></pre>
`},ce.blockquote=function(Q){return`<blockquote>
`+Q+`</blockquote>
`},ce.html=function(Q){return Q},ce.heading=function(Q,ee,me,pe){if(this.options.headerIds){var Ae=this.options.headerPrefix+pe.slug(me);return"<h"+ee+' id="'+Ae+'">'+Q+"</h"+ee+`>
`}return"<h"+ee+">"+Q+"</h"+ee+`>
`},ce.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ce.list=function(Q,ee,me){var pe=ee?"ol":"ul",Ae=ee&&me!==1?' start="'+me+'"':"";return"<"+pe+Ae+`>
`+Q+"</"+pe+`>
`},ce.listitem=function(Q){return"<li>"+Q+`</li>
`},ce.checkbox=function(Q){return"<input "+(Q?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ce.paragraph=function(Q){return"<p>"+Q+`</p>
`},ce.table=function(Q,ee){return ee&&(ee="<tbody>"+ee+"</tbody>"),`<table>
<thead>
`+Q+`</thead>
`+ee+`</table>
`},ce.tablerow=function(Q){return`<tr>
`+Q+`</tr>
`},ce.tablecell=function(Q,ee){var me=ee.header?"th":"td",pe=ee.align?"<"+me+' align="'+ee.align+'">':"<"+me+">";return pe+Q+("</"+me+`>
`)},ce.strong=function(Q){return"<strong>"+Q+"</strong>"},ce.em=function(Q){return"<em>"+Q+"</em>"},ce.codespan=function(Q){return"<code>"+Q+"</code>"},ce.br=function(){return this.options.xhtml?"<br/>":"<br>"},ce.del=function(Q){return"<del>"+Q+"</del>"},ce.link=function(Q,ee,me){if(Q=h(this.options.sanitize,this.options.baseUrl,Q),Q===null)return me;var pe='<a href="'+w(Q)+'"';return ee&&(pe+=' title="'+ee+'"'),pe+=">"+me+"</a>",pe},ce.image=function(Q,ee,me){if(Q=h(this.options.sanitize,this.options.baseUrl,Q),Q===null)return me;var pe='<img src="'+Q+'" alt="'+me+'"';return ee&&(pe+=' title="'+ee+'"'),pe+=this.options.xhtml?"/>":">",pe},ce.text=function(Q){return Q},Ce}(),we=function(){function Ce(){}var ce=Ce.prototype;return ce.strong=function(Q){return Q},ce.em=function(Q){return Q},ce.codespan=function(Q){return Q},ce.del=function(Q){return Q},ce.html=function(Q){return Q},ce.text=function(Q){return Q},ce.link=function(Q,ee,me){return""+me},ce.image=function(Q,ee,me){return""+me},ce.br=function(){return""},Ce}(),ke=function(){function Ce(){this.seen={}}var ce=Ce.prototype;return ce.serialize=function(Q){return Q.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ce.getNextSafeSlug=function(Q,ee){var me=Q,pe=0;if(this.seen.hasOwnProperty(me)){pe=this.seen[Q];do pe++,me=Q+"-"+pe;while(this.seen.hasOwnProperty(me))}return ee||(this.seen[Q]=pe,this.seen[me]=0),me},ce.slug=function(Q,ee){ee===void 0&&(ee={});var me=this.serialize(Q);return this.getNextSafeSlug(me,ee.dryrun)},Ce}(),le=function(){function Ce(te){this.options=te||ge.defaults,this.options.renderer=this.options.renderer||new de,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new we,this.slugger=new ke}Ce.parse=function(Q,ee){var me=new Ce(ee);return me.parse(Q)},Ce.parseInline=function(Q,ee){var me=new Ce(ee);return me.parseInline(Q)};var ce=Ce.prototype;return ce.parse=function(Q,ee){ee===void 0&&(ee=!0);var me="",pe,Ae,he,ye,F,q,K,U,X,x,Ee,Te,Ve,He,Ye,st,nt,tt,at,ct=Q.length;for(pe=0;pe<ct;pe++){if(x=Q[pe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[x.type]&&(at=this.options.extensions.renderers[x.type].call({parser:this},x),at!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(x.type))){me+=at||"";continue}switch(x.type){case"space":continue;case"hr":{me+=this.renderer.hr();continue}case"heading":{me+=this.renderer.heading(this.parseInline(x.tokens),x.depth,a(this.parseInline(x.tokens,this.textRenderer)),this.slugger);continue}case"code":{me+=this.renderer.code(x.text,x.lang,x.escaped);continue}case"table":{for(U="",K="",ye=x.header.length,Ae=0;Ae<ye;Ae++)K+=this.renderer.tablecell(this.parseInline(x.header[Ae].tokens),{header:!0,align:x.align[Ae]});for(U+=this.renderer.tablerow(K),X="",ye=x.rows.length,Ae=0;Ae<ye;Ae++){for(q=x.rows[Ae],K="",F=q.length,he=0;he<F;he++)K+=this.renderer.tablecell(this.parseInline(q[he].tokens),{header:!1,align:x.align[he]});X+=this.renderer.tablerow(K)}me+=this.renderer.table(U,X);continue}case"blockquote":{X=this.parse(x.tokens),me+=this.renderer.blockquote(X);continue}case"list":{for(Ee=x.ordered,Te=x.start,Ve=x.loose,ye=x.items.length,X="",Ae=0;Ae<ye;Ae++)Ye=x.items[Ae],st=Ye.checked,nt=Ye.task,He="",Ye.task&&(tt=this.renderer.checkbox(st),Ve?Ye.tokens.length>0&&Ye.tokens[0].type==="paragraph"?(Ye.tokens[0].text=tt+" "+Ye.tokens[0].text,Ye.tokens[0].tokens&&Ye.tokens[0].tokens.length>0&&Ye.tokens[0].tokens[0].type==="text"&&(Ye.tokens[0].tokens[0].text=tt+" "+Ye.tokens[0].tokens[0].text)):Ye.tokens.unshift({type:"text",text:tt}):He+=tt),He+=this.parse(Ye.tokens,Ve),X+=this.renderer.listitem(He,nt,st);me+=this.renderer.list(X,Ee,Te);continue}case"html":{me+=this.renderer.html(x.text);continue}case"paragraph":{me+=this.renderer.paragraph(this.parseInline(x.tokens));continue}case"text":{for(X=x.tokens?this.parseInline(x.tokens):x.text;pe+1<ct&&Q[pe+1].type==="text";)x=Q[++pe],X+=`
`+(x.tokens?this.parseInline(x.tokens):x.text);me+=ee?this.renderer.paragraph(X):X;continue}default:{var je='Token with "'+x.type+'" type was not found.';if(this.options.silent){console.error(je);return}else throw new Error(je)}}}return me},ce.parseInline=function(Q,ee){ee=ee||this.renderer;var me="",pe,Ae,he,ye=Q.length;for(pe=0;pe<ye;pe++){if(Ae=Q[pe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ae.type]&&(he=this.options.extensions.renderers[Ae.type].call({parser:this},Ae),he!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Ae.type))){me+=he||"";continue}switch(Ae.type){case"escape":{me+=ee.text(Ae.text);break}case"html":{me+=ee.html(Ae.text);break}case"link":{me+=ee.link(Ae.href,Ae.title,this.parseInline(Ae.tokens,ee));break}case"image":{me+=ee.image(Ae.href,Ae.title,Ae.text);break}case"strong":{me+=ee.strong(this.parseInline(Ae.tokens,ee));break}case"em":{me+=ee.em(this.parseInline(Ae.tokens,ee));break}case"codespan":{me+=ee.codespan(Ae.text);break}case"br":{me+=ee.br();break}case"del":{me+=ee.del(this.parseInline(Ae.tokens,ee));break}case"text":{me+=ee.text(Ae.text);break}default:{var F='Token with "'+Ae.type+'" type was not found.';if(this.options.silent){console.error(F);return}else throw new Error(F)}}}return me},Ce}();function ve(Ce,ce,te){if(typeof Ce>"u"||Ce===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Ce!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Ce)+", string expected");if(typeof ce=="function"&&(te=ce,ce=null),ce=S({},ve.defaults,ce||{}),D(ce),te){var Q=ce.highlight,ee;try{ee=ae.lex(Ce,ce)}catch(ye){return te(ye)}var me=function(F){var q;if(!F)try{ce.walkTokens&&ve.walkTokens(ee,ce.walkTokens),q=le.parse(ee,ce)}catch(K){F=K}return ce.highlight=Q,F?te(F):te(null,q)};if(!Q||Q.length<3||(delete ce.highlight,!ee.length))return me();var pe=0;ve.walkTokens(ee,function(ye){ye.type==="code"&&(pe++,setTimeout(function(){Q(ye.text,ye.lang,function(F,q){if(F)return me(F);q!=null&&q!==ye.text&&(ye.text=q,ye.escaped=!0),pe--,pe===0&&me()})},0))}),pe===0&&me();return}function Ae(ye){if(ye.message+=`
Please report this to https://github.com/markedjs/marked.`,ce.silent)return"<p>An error occurred:</p><pre>"+w(ye.message+"",!0)+"</pre>";throw ye}try{var he=ae.lex(Ce,ce);if(ce.walkTokens){if(ce.async)return Promise.all(ve.walkTokens(he,ce.walkTokens)).then(function(){return le.parse(he,ce)}).catch(Ae);ve.walkTokens(he,ce.walkTokens)}return le.parse(he,ce)}catch(ye){Ae(ye)}}ve.options=ve.setOptions=function(Ce){return S(ve.defaults,Ce),$(ve.defaults),ve},ve.getDefaults=R,ve.defaults=ge.defaults,ve.use=function(){for(var Ce=arguments.length,ce=new Array(Ce),te=0;te<Ce;te++)ce[te]=arguments[te];var Q=S.apply(void 0,[{}].concat(ce)),ee=ve.defaults.extensions||{renderers:{},childTokens:{}},me;ce.forEach(function(pe){if(pe.extensions&&(me=!0,pe.extensions.forEach(function(he){if(!he.name)throw new Error("extension name required");if(he.renderer){var ye=ee.renderers?ee.renderers[he.name]:null;ye?ee.renderers[he.name]=function(){for(var F=arguments.length,q=new Array(F),K=0;K<F;K++)q[K]=arguments[K];var U=he.renderer.apply(this,q);return U===!1&&(U=ye.apply(this,q)),U}:ee.renderers[he.name]=he.renderer}if(he.tokenizer){if(!he.level||he.level!=="block"&&he.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ee[he.level]?ee[he.level].unshift(he.tokenizer):ee[he.level]=[he.tokenizer],he.start&&(he.level==="block"?ee.startBlock?ee.startBlock.push(he.start):ee.startBlock=[he.start]:he.level==="inline"&&(ee.startInline?ee.startInline.push(he.start):ee.startInline=[he.start]))}he.childTokens&&(ee.childTokens[he.name]=he.childTokens)})),pe.renderer&&function(){var he=ve.defaults.renderer||new de,ye=function(K){var U=he[K];he[K]=function(){for(var X=arguments.length,x=new Array(X),Ee=0;Ee<X;Ee++)x[Ee]=arguments[Ee];var Te=pe.renderer[K].apply(he,x);return Te===!1&&(Te=U.apply(he,x)),Te}};for(var F in pe.renderer)ye(F);Q.renderer=he}(),pe.tokenizer&&function(){var he=ve.defaults.tokenizer||new W,ye=function(K){var U=he[K];he[K]=function(){for(var X=arguments.length,x=new Array(X),Ee=0;Ee<X;Ee++)x[Ee]=arguments[Ee];var Te=pe.tokenizer[K].apply(he,x);return Te===!1&&(Te=U.apply(he,x)),Te}};for(var F in pe.tokenizer)ye(F);Q.tokenizer=he}(),pe.walkTokens){var Ae=ve.defaults.walkTokens;Q.walkTokens=function(he){var ye=[];return ye.push(pe.walkTokens.call(this,he)),Ae&&(ye=ye.concat(Ae.call(this,he))),ye}}me&&(Q.extensions=ee),ve.setOptions(Q)})},ve.walkTokens=function(Ce,ce){for(var te=[],Q=function(){var Ae=me.value;switch(te=te.concat(ce.call(ve,Ae)),Ae.type){case"table":{for(var he=L(Ae.header),ye;!(ye=he()).done;){var F=ye.value;te=te.concat(ve.walkTokens(F.tokens,ce))}for(var q=L(Ae.rows),K;!(K=q()).done;)for(var U=K.value,X=L(U),x;!(x=X()).done;){var Ee=x.value;te=te.concat(ve.walkTokens(Ee.tokens,ce))}break}case"list":{te=te.concat(ve.walkTokens(Ae.items,ce));break}default:ve.defaults.extensions&&ve.defaults.extensions.childTokens&&ve.defaults.extensions.childTokens[Ae.type]?ve.defaults.extensions.childTokens[Ae.type].forEach(function(Te){te=te.concat(ve.walkTokens(Ae[Te],ce))}):Ae.tokens&&(te=te.concat(ve.walkTokens(Ae.tokens,ce)))}},ee=L(Ce),me;!(me=ee()).done;)Q();return te},ve.parseInline=function(Ce,ce){if(typeof Ce>"u"||Ce===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Ce!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Ce)+", string expected");ce=S({},ve.defaults,ce||{}),D(ce);try{var te=ae.lexInline(Ce,ce);return ce.walkTokens&&ve.walkTokens(te,ce.walkTokens),le.parseInline(te,ce)}catch(Q){if(Q.message+=`
Please report this to https://github.com/markedjs/marked.`,ce.silent)return"<p>An error occurred:</p><pre>"+w(Q.message+"",!0)+"</pre>";throw Q}},ve.Parser=le,ve.parser=le.parse,ve.Renderer=de,ve.TextRenderer=we,ve.Lexer=ae,ve.lexer=ae.lex,ve.Tokenizer=W,ve.Slugger=ke,ve.parse=ve;var se=ve.options,be=ve.setOptions,ne=ve.use,Y=ve.walkTokens,V=ve.parseInline,ie=ve,Ie=le.parse,Le=ae.lex;ge.Lexer=ae,ge.Parser=le,ge.Renderer=de,ge.Slugger=ke,ge.TextRenderer=we,ge.Tokenizer=W,ge.getDefaults=R,ge.lexer=Le,ge.marked=ve,ge.options=se,ge.parse=ie,ge.parseInline=V,ge.parser=Ie,ge.setOptions=be,ge.use=ne,ge.walkTokens=Y,Object.defineProperty(ge,"__esModule",{value:!0})}),define(Pe[121],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rj=void 0;function y(s){const a=L(s);if(a&&a.length>0)return new Uint32Array(a)}e.$Rj=y;let T=0;const C=new Uint32Array(10);function L(s){if(T=0,R(s,k,4352),T>0||(R(s,l,4449),T>0)||(R(s,p,4520),T>0)||(R(s,w,12593),T))return C.subarray(0,T);if(s>=44032&&s<=55203){const a=s-44032,r=a%588,n=Math.floor(a/588),o=Math.floor(r/28),c=r%28-1;if(n<k.length?R(n,k,0):4352+n-12593<w.length&&R(4352+n,w,12593),o<l.length?R(o,l,0):4449+o-12593<w.length&&R(4449+o-12593,w,12593),c>=0&&(c<p.length?R(c,p,0):4520+c-12593<w.length&&R(4520+c-12593,w,12593)),T>0)return C.subarray(0,T)}}function R(s,a,r){s>=r&&s<r+a.length&&$(a[s-r])}function $(s){s!==0&&(C[T++]=s&255,s>>8&&(C[T++]=s>>8&255),s>>16&&(C[T++]=s>>16&255))}var f;(function(s){s[s.InitialConsonant=4352]="InitialConsonant",s[s.Vowel=4449]="Vowel",s[s.FinalConsonant=4520]="FinalConsonant",s[s.CompatibilityJamo=12593]="CompatibilityJamo"})(f||(f={}));var b;(function(s){s[s.NUL=0]="NUL",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z"})(b||(b={}));var A;(function(s){s[s.fa=24934]="fa",s[s.fg=26470]="fg",s[s.fq=29030]="fq",s[s.fr=29286]="fr",s[s.ft=29798]="ft",s[s.fv=30310]="fv",s[s.fx=30822]="fx",s[s.hk=27496]="hk",s[s.hl=27752]="hl",s[s.ho=28520]="ho",s[s.ml=27757]="ml",s[s.nj=27246]="nj",s[s.nl=27758]="nl",s[s.np=28782]="np",s[s.qt=29809]="qt",s[s.rt=29810]="rt",s[s.sg=26483]="sg",s[s.sw=30579]="sw"})(A||(A={}));const k=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),l=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),p=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),w=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(Pe[122],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$l=e.$0l=e.$9l=e.rot=e.$7l=void 0;function y($,f,b){return Math.min(Math.max($,f),b)}e.$7l=y;function T($,f){return(f+$%f)%f}e.rot=T;class C{constructor(){this.a=0}getNext(){return this.a++}}e.$9l=C;class L{constructor(){this.a=1,this.b=0}update(f){return this.b=this.b+(f-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$0l=L;class R{constructor(f){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(f),this.c.fill(0,0,f)}update(f){const b=this.c[this.d];return this.c[this.d]=f,this.d=(this.d+1)%this.c.length,this.e-=b,this.e+=f,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$$l=R}),function(){function ge(C){const L=[];typeof C=="number"&&L.push("code/timeOrigin",C);function R(f){L.push(f,Date.now())}function $(){const f=[];for(let b=0;b<L.length;b+=2)f.push({name:L[b],startTime:L[b+1]});return f}return{mark:R,getMarks:$}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ge():{mark(C){performance.mark(C)},getMarks(){let C=performance.timeOrigin;typeof C!="number"&&(C=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(C)}];for(const R of performance.getEntriesByType("mark"))L.push({name:R.name,startTime:Math.round(C+R.startTime)});return L}};if(typeof process=="object"){const C=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ge(C)}else return console.trace("perf-util loaded in UNKNOWN environment"),ge()}function y(C){return C.MonacoPerformanceMarks||(C.MonacoPerformanceMarks=e()),C.MonacoPerformanceMarks}var T;typeof global=="object"?T=global:typeof self=="object"?T=self:T={},typeof define=="function"?define("vs/base/common/performance",[],function(){return y(T)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=y(T):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),T.perf=y(T))}(),function(ge,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var y=e();for(var T in y)(typeof exports=="object"?exports:ge)[T]=y[T]}}(typeof self<"u"?self:this,function(){return function(ge){var e={};function y(T){if(e[T])return e[T].exports;var C=e[T]={i:T,l:!1,exports:{}};return ge[T].call(C.exports,C,C.exports,y),C.l=!0,C.exports}return y.m=ge,y.c=e,y.d=function(T,C,L){y.o(T,C)||Object.defineProperty(T,C,{enumerable:!0,get:L})},y.r=function(T){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(T,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(T,"__esModule",{value:!0})},y.t=function(T,C){if(1&C&&(T=y(T)),8&C||4&C&&typeof T=="object"&&T&&T.__esModule)return T;var L=Object.create(null);if(y.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:T}),2&C&&typeof T!="string")for(var R in T)y.d(L,R,function($){return T[$]}.bind(null,R));return L},y.n=function(T){var C=T&&T.__esModule?function(){return T.default}:function(){return T};return y.d(C,"a",C),C},y.o=function(T,C){return Object.prototype.hasOwnProperty.call(T,C)},y.p="",y(y.s=0)}([function(ge,e,y){(function(T){var C;e=ge.exports=ne,C=typeof T=="object"&&T.env&&T.env.NODE_DEBUG&&/\bsemver\b/i.test(T.env.NODE_DEBUG)?function(){var U=Array.prototype.slice.call(arguments,0);U.unshift("SEMVER"),console.log.apply(console,U)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,$=e.re=[],f=e.src=[],b=0,A=b++;f[A]="0|[1-9]\\d*";var k=b++;f[k]="[0-9]+";var l=b++;f[l]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var p=b++;f[p]="("+f[A]+")\\.("+f[A]+")\\.("+f[A]+")";var w=b++;f[w]="("+f[k]+")\\.("+f[k]+")\\.("+f[k]+")";var s=b++;f[s]="(?:"+f[A]+"|"+f[l]+")";var a=b++;f[a]="(?:"+f[k]+"|"+f[l]+")";var r=b++;f[r]="(?:-("+f[s]+"(?:\\."+f[s]+")*))";var n=b++;f[n]="(?:-?("+f[a]+"(?:\\."+f[a]+")*))";var o=b++;f[o]="[0-9A-Za-z-]+";var c=b++;f[c]="(?:\\+("+f[o]+"(?:\\."+f[o]+")*))";var h=b++,t="v?"+f[p]+f[r]+"?"+f[c]+"?";f[h]="^"+t+"$";var u="[v=\\s]*"+f[w]+f[n]+"?"+f[c]+"?",i=b++;f[i]="^"+u+"$";var g=b++;f[g]="((?:<|>)?=?)";var m=b++;f[m]=f[k]+"|x|X|\\*";var d=b++;f[d]=f[A]+"|x|X|\\*";var S=b++;f[S]="[v=\\s]*("+f[d]+")(?:\\.("+f[d]+")(?:\\.("+f[d]+")(?:"+f[r]+")?"+f[c]+"?)?)?";var M=b++;f[M]="[v=\\s]*("+f[m]+")(?:\\.("+f[m]+")(?:\\.("+f[m]+")(?:"+f[n]+")?"+f[c]+"?)?)?";var v=b++;f[v]="^"+f[g]+"\\s*"+f[S]+"$";var E=b++;f[E]="^"+f[g]+"\\s*"+f[M]+"$";var D=b++;f[D]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var N=b++;f[N]="(?:~>?)";var O=b++;f[O]="(\\s*)"+f[N]+"\\s+",$[O]=new RegExp(f[O],"g");var G=b++;f[G]="^"+f[N]+f[S]+"$";var W=b++;f[W]="^"+f[N]+f[M]+"$";var z=b++;f[z]="(?:\\^)";var P=b++;f[P]="(\\s*)"+f[z]+"\\s+",$[P]=new RegExp(f[P],"g");var I=b++;f[I]="^"+f[z]+f[S]+"$";var H=b++;f[H]="^"+f[z]+f[M]+"$";var ae=b++;f[ae]="^"+f[g]+"\\s*("+u+")$|^$";var de=b++;f[de]="^"+f[g]+"\\s*("+t+")$|^$";var we=b++;f[we]="(\\s*)"+f[g]+"\\s*("+u+"|"+f[S]+")",$[we]=new RegExp(f[we],"g");var ke=b++;f[ke]="^\\s*("+f[S]+")\\s+-\\s+("+f[S]+")\\s*$";var le=b++;f[le]="^\\s*("+f[M]+")\\s+-\\s+("+f[M]+")\\s*$";var ve=b++;f[ve]="(<|>)?=?\\s*\\*";for(var se=0;se<35;se++)C(se,f[se]),$[se]||($[se]=new RegExp(f[se]));function be(U,X){if(U instanceof ne)return U;if(typeof U!="string"||U.length>L||!(X?$[i]:$[h]).test(U))return null;try{return new ne(U,X)}catch{return null}}function ne(U,X){if(U instanceof ne){if(U.loose===X)return U;U=U.version}else if(typeof U!="string")throw new TypeError("Invalid Version: "+U);if(U.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof ne))return new ne(U,X);C("SemVer",U,X),this.loose=X;var x=U.trim().match(X?$[i]:$[h]);if(!x)throw new TypeError("Invalid Version: "+U);if(this.raw=U,this.major=+x[1],this.minor=+x[2],this.patch=+x[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");x[4]?this.prerelease=x[4].split(".").map(function(Ee){if(/^[0-9]+$/.test(Ee)){var Te=+Ee;if(Te>=0&&Te<R)return Te}return Ee}):this.prerelease=[],this.build=x[5]?x[5].split("."):[],this.format()}e.parse=be,e.valid=function(U,X){var x=be(U,X);return x?x.version:null},e.clean=function(U,X){var x=be(U.trim().replace(/^[=v]+/,""),X);return x?x.version:null},e.SemVer=ne,ne.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ne.prototype.toString=function(){return this.version},ne.prototype.compare=function(U){return C("SemVer.compare",this.version,this.loose,U),U instanceof ne||(U=new ne(U,this.loose)),this.compareMain(U)||this.comparePre(U)},ne.prototype.compareMain=function(U){return U instanceof ne||(U=new ne(U,this.loose)),V(this.major,U.major)||V(this.minor,U.minor)||V(this.patch,U.patch)},ne.prototype.comparePre=function(U){if(U instanceof ne||(U=new ne(U,this.loose)),this.prerelease.length&&!U.prerelease.length)return-1;if(!this.prerelease.length&&U.prerelease.length)return 1;if(!this.prerelease.length&&!U.prerelease.length)return 0;var X=0;do{var x=this.prerelease[X],Ee=U.prerelease[X];if(C("prerelease compare",X,x,Ee),x===void 0&&Ee===void 0)return 0;if(Ee===void 0)return 1;if(x===void 0)return-1;if(x!==Ee)return V(x,Ee)}while(++X)},ne.prototype.inc=function(U,X){switch(U){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",X);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",X);break;case"prepatch":this.prerelease.length=0,this.inc("patch",X),this.inc("pre",X);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",X),this.inc("pre",X);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var x=this.prerelease.length;--x>=0;)typeof this.prerelease[x]=="number"&&(this.prerelease[x]++,x=-2);x===-1&&this.prerelease.push(0)}X&&(this.prerelease[0]===X?isNaN(this.prerelease[1])&&(this.prerelease=[X,0]):this.prerelease=[X,0]);break;default:throw new Error("invalid increment argument: "+U)}return this.format(),this.raw=this.version,this},e.inc=function(U,X,x,Ee){typeof x=="string"&&(Ee=x,x=void 0);try{return new ne(U,x).inc(X,Ee).version}catch{return null}},e.diff=function(U,X){if(Ce(U,X))return null;var x=be(U),Ee=be(X);if(x.prerelease.length||Ee.prerelease.length){for(var Te in x)if((Te==="major"||Te==="minor"||Te==="patch")&&x[Te]!==Ee[Te])return"pre"+Te;return"prerelease"}for(var Te in x)if((Te==="major"||Te==="minor"||Te==="patch")&&x[Te]!==Ee[Te])return Te},e.compareIdentifiers=V;var Y=/^[0-9]+$/;function V(U,X){var x=Y.test(U),Ee=Y.test(X);return x&&Ee&&(U=+U,X=+X),x&&!Ee?-1:Ee&&!x?1:U<X?-1:U>X?1:0}function ie(U,X,x){return new ne(U,x).compare(new ne(X,x))}function Ie(U,X,x){return ie(U,X,x)>0}function Le(U,X,x){return ie(U,X,x)<0}function Ce(U,X,x){return ie(U,X,x)===0}function ce(U,X,x){return ie(U,X,x)!==0}function te(U,X,x){return ie(U,X,x)>=0}function Q(U,X,x){return ie(U,X,x)<=0}function ee(U,X,x,Ee){var Te;switch(X){case"===":typeof U=="object"&&(U=U.version),typeof x=="object"&&(x=x.version),Te=U===x;break;case"!==":typeof U=="object"&&(U=U.version),typeof x=="object"&&(x=x.version),Te=U!==x;break;case"":case"=":case"==":Te=Ce(U,x,Ee);break;case"!=":Te=ce(U,x,Ee);break;case">":Te=Ie(U,x,Ee);break;case">=":Te=te(U,x,Ee);break;case"<":Te=Le(U,x,Ee);break;case"<=":Te=Q(U,x,Ee);break;default:throw new TypeError("Invalid operator: "+X)}return Te}function me(U,X){if(U instanceof me){if(U.loose===X)return U;U=U.value}if(!(this instanceof me))return new me(U,X);C("comparator",U,X),this.loose=X,this.parse(U),this.semver===pe?this.value="":this.value=this.operator+this.semver.version,C("comp",this)}e.rcompareIdentifiers=function(U,X){return V(X,U)},e.major=function(U,X){return new ne(U,X).major},e.minor=function(U,X){return new ne(U,X).minor},e.patch=function(U,X){return new ne(U,X).patch},e.compare=ie,e.compareLoose=function(U,X){return ie(U,X,!0)},e.rcompare=function(U,X,x){return ie(X,U,x)},e.sort=function(U,X){return U.sort(function(x,Ee){return e.compare(x,Ee,X)})},e.rsort=function(U,X){return U.sort(function(x,Ee){return e.rcompare(x,Ee,X)})},e.gt=Ie,e.lt=Le,e.eq=Ce,e.neq=ce,e.gte=te,e.lte=Q,e.cmp=ee,e.Comparator=me;var pe={};function Ae(U,X){if(U instanceof Ae)return U.loose===X?U:new Ae(U.raw,X);if(U instanceof me)return new Ae(U.value,X);if(!(this instanceof Ae))return new Ae(U,X);if(this.loose=X,this.raw=U,this.set=U.split(/\s*\|\|\s*/).map(function(x){return this.parseRange(x.trim())},this).filter(function(x){return x.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+U);this.format()}function he(U){return!U||U.toLowerCase()==="x"||U==="*"}function ye(U,X,x,Ee,Te,Ve,He,Ye,st,nt,tt,at,ct){return((X=he(x)?"":he(Ee)?">="+x+".0.0":he(Te)?">="+x+"."+Ee+".0":">="+X)+" "+(Ye=he(st)?"":he(nt)?"<"+(+st+1)+".0.0":he(tt)?"<"+st+"."+(+nt+1)+".0":at?"<="+st+"."+nt+"."+tt+"-"+at:"<="+Ye)).trim()}function F(U,X){for(var x=0;x<U.length;x++)if(!U[x].test(X))return!1;if(X.prerelease.length){for(x=0;x<U.length;x++)if(C(U[x].semver),U[x].semver!==pe&&U[x].semver.prerelease.length>0){var Ee=U[x].semver;if(Ee.major===X.major&&Ee.minor===X.minor&&Ee.patch===X.patch)return!0}return!1}return!0}function q(U,X,x){try{X=new Ae(X,x)}catch{return!1}return X.test(U)}function K(U,X,x,Ee){var Te,Ve,He,Ye,st;switch(U=new ne(U,Ee),X=new Ae(X,Ee),x){case">":Te=Ie,Ve=Q,He=Le,Ye=">",st=">=";break;case"<":Te=Le,Ve=te,He=Ie,Ye="<",st="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(q(U,X,Ee))return!1;for(var nt=0;nt<X.set.length;++nt){var tt=X.set[nt],at=null,ct=null;if(tt.forEach(function(je){je.semver===pe&&(je=new me(">=0.0.0")),at=at||je,ct=ct||je,Te(je.semver,at.semver,Ee)?at=je:He(je.semver,ct.semver,Ee)&&(ct=je)}),at.operator===Ye||at.operator===st||(!ct.operator||ct.operator===Ye)&&Ve(U,ct.semver)||ct.operator===st&&He(U,ct.semver))return!1}return!0}me.prototype.parse=function(U){var X=this.loose?$[ae]:$[de],x=U.match(X);if(!x)throw new TypeError("Invalid comparator: "+U);this.operator=x[1],this.operator==="="&&(this.operator=""),x[2]?this.semver=new ne(x[2],this.loose):this.semver=pe},me.prototype.toString=function(){return this.value},me.prototype.test=function(U){return C("Comparator.test",U,this.loose),this.semver===pe||(typeof U=="string"&&(U=new ne(U,this.loose)),ee(U,this.operator,this.semver,this.loose))},me.prototype.intersects=function(U,X){if(!(U instanceof me))throw new TypeError("a Comparator is required");var x;if(this.operator==="")return x=new Ae(U.value,X),q(this.value,x,X);if(U.operator==="")return x=new Ae(this.value,X),q(U.semver,x,X);var Ee=!(this.operator!==">="&&this.operator!==">"||U.operator!==">="&&U.operator!==">"),Te=!(this.operator!=="<="&&this.operator!=="<"||U.operator!=="<="&&U.operator!=="<"),Ve=this.semver.version===U.semver.version,He=!(this.operator!==">="&&this.operator!=="<="||U.operator!==">="&&U.operator!=="<="),Ye=ee(this.semver,"<",U.semver,X)&&(this.operator===">="||this.operator===">")&&(U.operator==="<="||U.operator==="<"),st=ee(this.semver,">",U.semver,X)&&(this.operator==="<="||this.operator==="<")&&(U.operator===">="||U.operator===">");return Ee||Te||Ve&&He||Ye||st},e.Range=Ae,Ae.prototype.format=function(){return this.range=this.set.map(function(U){return U.join(" ").trim()}).join("||").trim(),this.range},Ae.prototype.toString=function(){return this.range},Ae.prototype.parseRange=function(U){var X=this.loose;U=U.trim(),C("range",U,X);var x=X?$[le]:$[ke];U=U.replace(x,ye),C("hyphen replace",U),U=U.replace($[we],"$1$2$3"),C("comparator trim",U,$[we]),U=(U=(U=U.replace($[O],"$1~")).replace($[P],"$1^")).split(/\s+/).join(" ");var Ee=X?$[ae]:$[de],Te=U.split(" ").map(function(Ve){return function(He,Ye){return C("comp",He),He=function(st,nt){return st.trim().split(/\s+/).map(function(tt){return function(at,ct){C("caret",at,ct);var je=ct?$[H]:$[I];return at.replace(je,function(vt,Z,_,$e,Be){var Qe;return C("caret",at,vt,Z,_,$e,Be),he(Z)?Qe="":he(_)?Qe=">="+Z+".0.0 <"+(+Z+1)+".0.0":he($e)?Qe=Z==="0"?">="+Z+"."+_+".0 <"+Z+"."+(+_+1)+".0":">="+Z+"."+_+".0 <"+(+Z+1)+".0.0":Be?(C("replaceCaret pr",Be),Be.charAt(0)!=="-"&&(Be="-"+Be),Qe=Z==="0"?_==="0"?">="+Z+"."+_+"."+$e+Be+" <"+Z+"."+_+"."+(+$e+1):">="+Z+"."+_+"."+$e+Be+" <"+Z+"."+(+_+1)+".0":">="+Z+"."+_+"."+$e+Be+" <"+(+Z+1)+".0.0"):(C("no pr"),Qe=Z==="0"?_==="0"?">="+Z+"."+_+"."+$e+" <"+Z+"."+_+"."+(+$e+1):">="+Z+"."+_+"."+$e+" <"+Z+"."+(+_+1)+".0":">="+Z+"."+_+"."+$e+" <"+(+Z+1)+".0.0"),C("caret return",Qe),Qe})}(tt,nt)}).join(" ")}(He,Ye),C("caret",He),He=function(st,nt){return st.trim().split(/\s+/).map(function(tt){return function(at,ct){var je=ct?$[W]:$[G];return at.replace(je,function(vt,Z,_,$e,Be){var Qe;return C("tilde",at,vt,Z,_,$e,Be),he(Z)?Qe="":he(_)?Qe=">="+Z+".0.0 <"+(+Z+1)+".0.0":he($e)?Qe=">="+Z+"."+_+".0 <"+Z+"."+(+_+1)+".0":Be?(C("replaceTilde pr",Be),Be.charAt(0)!=="-"&&(Be="-"+Be),Qe=">="+Z+"."+_+"."+$e+Be+" <"+Z+"."+(+_+1)+".0"):Qe=">="+Z+"."+_+"."+$e+" <"+Z+"."+(+_+1)+".0",C("tilde return",Qe),Qe})}(tt,nt)}).join(" ")}(He,Ye),C("tildes",He),He=function(st,nt){return C("replaceXRanges",st,nt),st.split(/\s+/).map(function(tt){return function(at,ct){at=at.trim();var je=ct?$[E]:$[v];return at.replace(je,function(vt,Z,_,$e,Be,Qe){C("xRange",at,vt,Z,_,$e,Be,Qe);var it=he(_),rt=it||he($e),Ne=rt||he(Be);return Z==="="&&Ne&&(Z=""),it?vt=Z===">"||Z==="<"?"<0.0.0":"*":Z&&Ne?(rt&&($e=0),Ne&&(Be=0),Z===">"?(Z=">=",rt?(_=+_+1,$e=0,Be=0):Ne&&($e=+$e+1,Be=0)):Z==="<="&&(Z="<",rt?_=+_+1:$e=+$e+1),vt=Z+_+"."+$e+"."+Be):rt?vt=">="+_+".0.0 <"+(+_+1)+".0.0":Ne&&(vt=">="+_+"."+$e+".0 <"+_+"."+(+$e+1)+".0"),C("xRange return",vt),vt})}(tt,nt)}).join(" ")}(He,Ye),C("xrange",He),He=function(st,nt){return C("replaceStars",st,nt),st.trim().replace($[ve],"")}(He,Ye),C("stars",He),He}(Ve,X)}).join(" ").split(/\s+/);return this.loose&&(Te=Te.filter(function(Ve){return!!Ve.match(Ee)})),Te=Te.map(function(Ve){return new me(Ve,X)})},Ae.prototype.intersects=function(U,X){if(!(U instanceof Ae))throw new TypeError("a Range is required");return this.set.some(function(x){return x.every(function(Ee){return U.set.some(function(Te){return Te.every(function(Ve){return Ee.intersects(Ve,X)})})})})},e.toComparators=function(U,X){return new Ae(U,X).set.map(function(x){return x.map(function(Ee){return Ee.value}).join(" ").trim().split(" ")})},Ae.prototype.test=function(U){if(!U)return!1;typeof U=="string"&&(U=new ne(U,this.loose));for(var X=0;X<this.set.length;X++)if(F(this.set[X],U))return!0;return!1},e.satisfies=q,e.maxSatisfying=function(U,X,x){var Ee=null,Te=null;try{var Ve=new Ae(X,x)}catch{return null}return U.forEach(function(He){Ve.test(He)&&(Ee&&Te.compare(He)!==-1||(Te=new ne(Ee=He,x)))}),Ee},e.minSatisfying=function(U,X,x){var Ee=null,Te=null;try{var Ve=new Ae(X,x)}catch{return null}return U.forEach(function(He){Ve.test(He)&&(Ee&&Te.compare(He)!==1||(Te=new ne(Ee=He,x)))}),Ee},e.validRange=function(U,X){try{return new Ae(U,X).range||"*"}catch{return null}},e.ltr=function(U,X,x){return K(U,X,"<",x)},e.gtr=function(U,X,x){return K(U,X,">",x)},e.outside=K,e.prerelease=function(U,X){var x=be(U,X);return x&&x.prerelease.length?x.prerelease:null},e.intersects=function(U,X,x){return U=new Ae(U,x),X=new Ae(X,x),U.intersects(X)},e.coerce=function(U){if(U instanceof ne)return U;if(typeof U!="string")return null;var X=U.match($[D]);return X==null?null:be((X[1]||"0")+"."+(X[2]||"0")+"."+(X[3]||"0"))}}).call(this,y(1))},function(ge,e){var y,T,C=ge.exports={};function L(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function $(a){if(y===setTimeout)return setTimeout(a,0);if((y===L||!y)&&setTimeout)return y=setTimeout,setTimeout(a,0);try{return y(a,0)}catch{try{return y.call(null,a,0)}catch{return y.call(this,a,0)}}}(function(){try{y=typeof setTimeout=="function"?setTimeout:L}catch{y=L}try{T=typeof clearTimeout=="function"?clearTimeout:R}catch{T=R}})();var f,b=[],A=!1,k=-1;function l(){A&&f&&(A=!1,f.length?b=f.concat(b):k=-1,b.length&&p())}function p(){if(!A){var a=$(l);A=!0;for(var r=b.length;r;){for(f=b,b=[];++k<r;)f&&f[k].run();k=-1,r=b.length}f=null,A=!1,function(n){if(T===clearTimeout)return clearTimeout(n);if((T===R||!T)&&clearTimeout)return T=clearTimeout,clearTimeout(n);try{T(n)}catch{try{return T.call(null,n)}catch{return T.call(this,n)}}}(a)}}function w(a,r){this.fun=a,this.array=r}function s(){}C.nextTick=function(a){var r=new Array(arguments.length-1);if(arguments.length>1)for(var n=1;n<arguments.length;n++)r[n-1]=arguments[n];b.push(new w(a,r)),b.length!==1||A||$(p)},w.prototype.run=function(){this.fun.apply(null,this.array)},C.title="browser",C.browser=!0,C.env={},C.argv=[],C.version="",C.versions={},C.on=s,C.addListener=s,C.once=s,C.off=s,C.removeListener=s,C.removeAllListeners=s,C.emit=s,C.prependListener=s,C.prependOnceListener=s,C.listeners=function(a){return[]},C.binding=function(a){throw new Error("process.binding is not supported")},C.cwd=function(){return"/"},C.chdir=function(a){throw new Error("process.chdir is not supported")},C.umask=function(){return 0}}])}),define(Pe[123],Re([1,0,15,6]),function(ge,e,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=void 0;function C(c){const h=c;return h?typeof h.read=="function":!1}e.$7d=C;function L(c){const h=c;return h?[h.on,h.pause,h.resume,h.destroy].every(t=>typeof t=="function"):!1}e.$8d=L;function R(c){const h=c;return h?L(h.stream)&&Array.isArray(h.buffer)&&typeof h.ended=="boolean":!1}e.$9d=R;function $(c,h){return new f(c,h)}e.$0d=$;class f{constructor(h,t){this.e=h,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(h){if(!this.a.destroyed){if(this.a.flowing)this.g(h);else if(this.b.data.push(h),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(h){this.a.destroyed||(this.a.flowing?this.h(h):this.b.error.push(h))}end(h){this.a.destroyed||(typeof h<"u"&&this.write(h),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(h){this.c.data.slice(0).forEach(t=>t(h))}h(h){this.c.error.length===0?(0,y.$1)(h):this.c.error.slice(0).forEach(t=>t(h))}i(){this.c.end.slice(0).forEach(h=>h())}on(h,t){if(!this.a.destroyed)switch(h){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(h,t){if(this.a.destroyed)return;let u;switch(h){case"data":u=this.c.data;break;case"end":u=this.c.end;break;case"error":u=this.c.error;break}if(u){const i=u.indexOf(t);i>=0&&u.splice(i,1)}}j(){if(this.b.data.length>0){const h=this.e(this.b.data);this.g(h),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(u=>u())}}k(){if(this.c.error.length>0){for(const h of this.b.error)this.h(h);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function b(c,h){const t=[];let u;for(;(u=c.read())!==null;)t.push(u);return h(t)}e.$$d=b;function A(c,h,t){const u=[];let i;for(;(i=c.read())!==null&&u.length<t;)u.push(i);return i===null&&u.length>0?h(u):{read:()=>{if(u.length>0)return u.shift();if(typeof i<"u"){const g=i;return i=void 0,g}return c.read()}}}e.$_d=A;function k(c,h){return new Promise((t,u)=>{const i=[];l(c,{onData:g=>{h&&i.push(g)},onError:g=>{h?u(g):t(void 0)},onEnd:()=>{t(h?h(i):void 0)}})})}e.$ae=k;function l(c,h,t){c.on("error",u=>{t?.isCancellationRequested||h.onError(u)}),c.on("end",()=>{t?.isCancellationRequested||h.onEnd()}),c.on("data",u=>{t?.isCancellationRequested||h.onData(u)})}e.$be=l;function p(c,h){return new Promise((t,u)=>{const i=new T.$Sc,g=[],m=M=>{if(g.push(M),g.length>h)return i.dispose(),c.pause(),t({stream:c,buffer:g,ended:!1})},d=M=>(i.dispose(),u(M)),S=()=>(i.dispose(),t({stream:c,buffer:g,ended:!0}));i.add((0,T.$Rc)(()=>c.removeListener("error",d))),c.on("error",d),i.add((0,T.$Rc)(()=>c.removeListener("end",S))),c.on("end",S),i.add((0,T.$Rc)(()=>c.removeListener("data",m))),c.on("data",m)})}e.$ce=p;function w(c,h){const t=$(h);return t.end(c),t}e.$de=w;function s(){const c=$(()=>{throw new Error("not supported")});return c.end(),c}e.$ee=s;function a(c){let h=!1;return{read:()=>h?null:(h=!0,c)}}e.$fe=a;function r(c,h,t){const u=$(t);return l(c,{onData:i=>u.write(h.data(i)),onError:i=>u.error(h.error?h.error(i):i),onEnd:()=>u.end()}),u}e.$ge=r;function n(c,h,t){let u=!1;return{read:()=>{const i=h.read();return u?i:(u=!0,i!==null?t([c,i]):c)}}}e.$he=n;function o(c,h,t){let u=!1;const i=$(t);return l(h,{onData:g=>u?i.write(g):(u=!0,i.write(t([c,g]))),onError:g=>i.error(g),onEnd:()=>{u||(u=!0,i.write(c)),i.end()}}),i}e.$ie=o}),define(Pe[24],Re([1,0,39,123]),function(ge,e,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$De=e.$Ce=e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=void 0;const C=typeof Buffer<"u",L=new y.$V(()=>new Uint8Array(256));let R,$;class f{static alloc(D){return C?new f(Buffer.allocUnsafe(D)):new f(new Uint8Array(D))}static wrap(D){return C&&!Buffer.isBuffer(D)&&(D=Buffer.from(D.buffer,D.byteOffset,D.byteLength)),new f(D)}static fromString(D,N){return!(N?.dontUseNodeBuffer||!1)&&C?new f(Buffer.from(D)):(R||(R=new TextEncoder),new f(R.encode(D)))}static fromByteArray(D){const N=f.alloc(D.length);for(let O=0,G=D.length;O<G;O++)N.buffer[O]=D[O];return N}static concat(D,N){if(typeof N>"u"){N=0;for(let W=0,z=D.length;W<z;W++)N+=D[W].byteLength}const O=f.alloc(N);let G=0;for(let W=0,z=D.length;W<z;W++){const P=D[W];O.set(P,G),G+=P.byteLength}return O}constructor(D){this.buffer=D,this.byteLength=this.buffer.byteLength}clone(){const D=f.alloc(this.byteLength);return D.set(this),D}toString(){return C?this.buffer.toString():($||($=new TextDecoder),$.decode(this.buffer))}slice(D,N){return new f(this.buffer.subarray(D,N))}set(D,N){if(D instanceof f)this.buffer.set(D.buffer,N);else if(D instanceof Uint8Array)this.buffer.set(D,N);else if(D instanceof ArrayBuffer)this.buffer.set(new Uint8Array(D),N);else if(ArrayBuffer.isView(D))this.buffer.set(new Uint8Array(D.buffer,D.byteOffset,D.byteLength),N);else throw new Error("Unknown argument 'array'")}readUInt32BE(D){return l(this.buffer,D)}writeUInt32BE(D,N){p(this.buffer,D,N)}readUInt32LE(D){return w(this.buffer,D)}writeUInt32LE(D,N){s(this.buffer,D,N)}readUInt8(D){return a(this.buffer,D)}writeUInt8(D,N){r(this.buffer,D,N)}indexOf(D,N=0){return b(this.buffer,D instanceof f?D.buffer:D,N)}}e.$je=f;function b(E,D,N=0){const O=D.byteLength,G=E.byteLength;if(O===0)return 0;if(O===1)return E.indexOf(D[0]);if(O>G-N)return-1;const W=L.value;W.fill(D.length);for(let H=0;H<D.length;H++)W[D[H]]=D.length-H-1;let z=N+D.length-1,P=z,I=-1;for(;z<G;)if(E[z]===D[P]){if(P===0){I=z;break}z--,P--}else z+=Math.max(D.length-P,W[E[z]]),P=D.length-1;return I}e.$ke=b;function A(E,D){return E[D+0]<<0>>>0|E[D+1]<<8>>>0}e.$le=A;function k(E,D,N){E[N+0]=D&255,D=D>>>8,E[N+1]=D&255}e.$me=k;function l(E,D){return E[D]*2**24+E[D+1]*2**16+E[D+2]*2**8+E[D+3]}e.$ne=l;function p(E,D,N){E[N+3]=D,D=D>>>8,E[N+2]=D,D=D>>>8,E[N+1]=D,D=D>>>8,E[N]=D}e.$oe=p;function w(E,D){return E[D+0]<<0>>>0|E[D+1]<<8>>>0|E[D+2]<<16>>>0|E[D+3]<<24>>>0}e.$pe=w;function s(E,D,N){E[N+0]=D&255,D=D>>>8,E[N+1]=D&255,D=D>>>8,E[N+2]=D&255,D=D>>>8,E[N+3]=D&255}e.$qe=s;function a(E,D){return E[D]}e.$re=a;function r(E,D,N){E[N]=D}e.$se=r;function n(E){return T.$$d(E,D=>f.concat(D))}e.$te=n;function o(E){return T.$fe(E)}e.$ue=o;function c(E){return T.$ae(E,D=>f.concat(D))}e.$ve=c;async function h(E){return E.ended?f.concat(E.buffer):f.concat([...E.buffer,await c(E.stream)])}e.$we=h;function t(E){return T.$de(E,D=>f.concat(D))}e.$xe=t;function u(E){return T.$ge(E,{data:D=>typeof D=="string"?f.fromString(D):f.wrap(D)},D=>f.concat(D))}e.$ye=u;function i(E){return T.$0d(D=>f.concat(D),E)}e.$ze=i;function g(E,D){return T.$he(E,D,N=>f.concat(N))}e.$Ae=g;function m(E,D){return T.$ie(E,D,N=>f.concat(N))}e.$Be=m;function d(E){let D=0,N=0,O=0;const G=new Uint8Array(Math.floor(E.length/4*3)),W=P=>{switch(N){case 3:G[O++]=D|P,N=0;break;case 2:G[O++]=D|P>>>2,D=P<<6,N=3;break;case 1:G[O++]=D|P>>>4,D=P<<4,N=2;break;default:D=P<<2,N=1}};for(let P=0;P<E.length;P++){const I=E.charCodeAt(P);if(I>=65&&I<=90)W(I-65);else if(I>=97&&I<=122)W(I-97+26);else if(I>=48&&I<=57)W(I-48+52);else if(I===43||I===45)W(62);else if(I===47||I===95)W(63);else{if(I===61)break;throw new SyntaxError(`Unexpected base64 character ${E[P]}`)}}const z=O;for(;N>0;)W(0);return f.wrap(G).slice(0,z)}e.$Ce=d;const S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",M="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function v({buffer:E},D=!0,N=!1){const O=N?M:S;let G="";const W=E.byteLength%3;let z=0;for(;z<E.byteLength-W;z+=3){const P=E[z+0],I=E[z+1],H=E[z+2];G+=O[P>>>2],G+=O[(P<<4|I>>>4)&63],G+=O[(I<<2|H>>>6)&63],G+=O[H&63]}if(W===1){const P=E[z+0];G+=O[P>>>2],G+=O[P<<4&63],D&&(G+="==")}else if(W===2){const P=E[z+0],I=E[z+1];G+=O[P>>>2],G+=O[(P<<4|I>>>4)&63],G+=O[I<<2&63],D&&(G+="=")}return G}e.$De=v}),define(Pe[124],Re([1,0,28,121,11]),function(ge,e,y,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9j=e.$8j=e.$7j=e.$6j=e.FuzzyScore=e.$5j=e.$4j=e.$3j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.or=void 0;function L(...he){return function(ye,F){for(let q=0,K=he.length;q<K;q++){const U=he[q](ye,F);if(U)return U}return null}}e.or=L,e.$Tj=R.bind(void 0,!1),e.$Uj=R.bind(void 0,!0);function R(he,ye,F){if(!F||F.length<ye.length)return null;let q;return he?q=C.$af(F,ye):q=F.indexOf(ye)===0,q?ye.length>0?[{start:0,end:ye.length}]:[]:null}function $(he,ye){const F=ye.toLowerCase().indexOf(he.toLowerCase());return F===-1?null:[{start:F,end:F+he.length}]}e.$Vj=$;function f(he,ye){return b(he.toLowerCase(),ye.toLowerCase(),0,0)}e.$Wj=f;function b(he,ye,F,q){if(F===he.length)return[];if(q===ye.length)return null;if(he[F]===ye[q]){let K=null;return(K=b(he,ye,F+1,q+1))?c({start:q,end:q+1},K):null}return b(he,ye,F,q+1)}function A(he){return 97<=he&&he<=122}function k(he){return 65<=he&&he<=90}e.$Xj=k;function l(he){return 48<=he&&he<=57}function p(he){return he===32||he===9||he===10||he===13}const w=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(he=>w.add(he.charCodeAt(0)));function s(he){return p(he)||w.has(he)}function a(he,ye){return he===ye||s(he)&&s(ye)}const r=new Map;function n(he){if(r.has(he))return r.get(he);let ye;const F=(0,T.$Rj)(he);return F&&(ye=F),r.set(he,ye),ye}function o(he){return A(he)||k(he)||l(he)}function c(he,ye){return ye.length===0?ye=[he]:he.end===ye[0].start?ye[0].start=he.start:ye.unshift(he),ye}function h(he,ye){for(let F=ye;F<he.length;F++){const q=he.charCodeAt(F);if(k(q)||l(q)||F>0&&!o(he.charCodeAt(F-1)))return F}return he.length}function t(he,ye,F,q){if(F===he.length)return[];if(q===ye.length)return null;if(he[F]!==ye[q].toLowerCase())return null;{let K=null,U=q+1;for(K=t(he,ye,F+1,q+1);!K&&(U=h(ye,U))<ye.length;)K=t(he,ye,F+1,U),U++;return K===null?null:c({start:q,end:q+1},K)}}function u(he){let ye=0,F=0,q=0,K=0,U=0;for(let Ve=0;Ve<he.length;Ve++)U=he.charCodeAt(Ve),k(U)&&ye++,A(U)&&F++,o(U)&&q++,l(U)&&K++;const X=ye/he.length,x=F/he.length,Ee=q/he.length,Te=K/he.length;return{upperPercent:X,lowerPercent:x,alphaPercent:Ee,numericPercent:Te}}function i(he){const{upperPercent:ye,lowerPercent:F}=he;return F===0&&ye>.6}function g(he){const{upperPercent:ye,lowerPercent:F,alphaPercent:q,numericPercent:K}=he;return F>.2&&ye<.8&&q>.6&&K<.2}function m(he){let ye=0,F=0,q=0,K=0;for(let U=0;U<he.length;U++)q=he.charCodeAt(U),k(q)&&ye++,A(q)&&F++,p(q)&&K++;return(ye===0||F===0)&&K===0?he.length<=30:ye<=5}function d(he,ye){if(!ye||(ye=ye.trim(),ye.length===0)||!m(he)||ye.length>60)return null;const F=u(ye);if(!g(F)){if(!i(F))return null;ye=ye.toLowerCase()}let q=null,K=0;for(he=he.toLowerCase();K<ye.length&&(q=t(he,ye,0,K))===null;)K=h(ye,K+1);return q}e.$Yj=d;function S(he,ye,F=!1){if(!ye||ye.length===0)return null;let q=null,K=0;for(he=he.toLowerCase(),ye=ye.toLowerCase();K<ye.length&&(q=M(he,ye,0,K,F),q===null);)K=v(ye,K+1);return q}e.$Zj=S;function M(he,ye,F,q,K){let U=0;if(F===he.length)return[];if(q===ye.length)return null;if(!a(he.charCodeAt(F),ye.charCodeAt(q))){const Ee=n(he.charCodeAt(F));if(!Ee)return null;for(let Te=0;Te<Ee.length;Te++)if(!a(Ee[Te],ye.charCodeAt(q+Te)))return null;U+=Ee.length-1}let X=null,x=q+U+1;if(X=M(he,ye,F+1,x,K),!K)for(;!X&&(x=v(ye,x))<ye.length;)X=M(he,ye,F+1,x,K),x++;if(!X)return null;if(he.charCodeAt(F)!==ye.charCodeAt(q)){const Ee=n(he.charCodeAt(F));if(!Ee)return X;for(let Te=0;Te<Ee.length;Te++)if(Ee[Te]!==ye.charCodeAt(q+Te))return X}return c({start:q,end:q+U+1},X)}function v(he,ye){for(let F=ye;F<he.length;F++)if(s(he.charCodeAt(F))||F>0&&s(he.charCodeAt(F-1)))return F;return he.length}const E=L(e.$Uj,d,$),D=L(e.$Uj,d,f),N=new y.$Dc(1e4);function O(he,ye,F=!1){if(typeof he!="string"||typeof ye!="string")return null;let q=N.get(he);q||(q=new RegExp(C.$Ve(he),"i"),N.set(he,q));const K=q.exec(ye);return K?[{start:K.index,end:K.index+K[0].length}]:F?D(he,ye):E(he,ye)}e.$1j=O;function G(he,ye){const F=ce(he,he.toLowerCase(),0,ye,ye.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return F?z(F):null}e.$2j=G;function W(he,ye,F,q,K,U){const X=Math.min(13,he.length);for(;F<X;F++){const x=ce(he,ye,F,q,K,U,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(x)return x}return[0,U]}e.$3j=W;function z(he){if(typeof he>"u")return[];const ye=[],F=he[1];for(let q=he.length-1;q>1;q--){const K=he[q]+F,U=ye[ye.length-1];U&&U.end===K?U.end=K+1:ye.push({start:K,end:K+1})}return ye}e.$4j=z;const P=128;function I(){const he=[],ye=[];for(let F=0;F<=P;F++)ye[F]=0;for(let F=0;F<=P;F++)he.push(ye.slice(0));return he}function H(he){const ye=[];for(let F=0;F<=he;F++)ye[F]=0;return ye}const ae=H(2*P),de=H(2*P),we=I(),ke=I(),le=I(),ve=!1;function se(he,ye,F,q,K){function U(x,Ee,Te=" "){for(;x.length<Ee;)x=Te+x;return x}let X=` |   |${q.split("").map(x=>U(x,3)).join("|")}
`;for(let x=0;x<=F;x++)x===0?X+=" |":X+=`${ye[x-1]}|`,X+=he[x].slice(0,K+1).map(Ee=>U(Ee.toString(),3)).join("|")+`
`;return X}function be(he,ye,F,q){he=he.substr(ye),F=F.substr(q),console.log(se(ke,he,he.length,F,F.length)),console.log(se(le,he,he.length,F,F.length)),console.log(se(we,he,he.length,F,F.length))}function ne(he,ye){if(ye<0||ye>=he.length)return!1;const F=he.codePointAt(ye);switch(F){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!C.$sf(F)}}function Y(he,ye){if(ye<0||ye>=he.length)return!1;switch(he.charCodeAt(ye)){case 32:case 9:return!0;default:return!1}}function V(he,ye,F){return ye[he]!==F[he]}function ie(he,ye,F,q,K,U,X=!1){for(;ye<F&&K<U;)he[ye]===q[K]&&(X&&(ae[ye]=K),ye+=1),K+=1;return ye===F}e.$5j=ie;var Ie;(function(he){he[he.Diag=1]="Diag",he[he.Left=2]="Left",he[he.LeftLeft=3]="LeftLeft"})(Ie||(Ie={}));var Le;(function(he){he.Default=[-100,0];function ye(F){return!F||F.length===2&&F[0]===-100&&F[1]===0}he.isDefault=ye})(Le||(e.FuzzyScore=Le={}));class Ce{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(ye,F){this.firstMatchCanBeWeak=ye,this.boostFullMatch=F}}e.$6j=Ce;function ce(he,ye,F,q,K,U,X=Ce.default){const x=he.length>P?P:he.length,Ee=q.length>P?P:q.length;if(F>=x||U>=Ee||x-F>Ee-U||!ie(ye,F,x,K,U,Ee,!0))return;te(x,Ee,F,U,ye,K);let Te=1,Ve=1,He=F,Ye=U;const st=[!1];for(Te=1,He=F;He<x;Te++,He++){const je=ae[He],vt=de[He],Z=He+1<x?de[He+1]:Ee;for(Ve=je-U+1,Ye=je;Ye<Z;Ve++,Ye++){let _=Number.MIN_SAFE_INTEGER,$e=!1;Ye<=vt&&(_=Q(he,ye,He,F,q,K,Ye,Ee,U,we[Te-1][Ve-1]===0,st));let Be=0;_!==Number.MAX_SAFE_INTEGER&&($e=!0,Be=_+ke[Te-1][Ve-1]);const Qe=Ye>je,it=Qe?ke[Te][Ve-1]+(we[Te][Ve-1]>0?-5:0):0,rt=Ye>je+1&&we[Te][Ve-1]>0,Ne=rt?ke[Te][Ve-2]+(we[Te][Ve-2]>0?-5:0):0;if(rt&&(!Qe||Ne>=it)&&(!$e||Ne>=Be))ke[Te][Ve]=Ne,le[Te][Ve]=3,we[Te][Ve]=0;else if(Qe&&(!$e||it>=Be))ke[Te][Ve]=it,le[Te][Ve]=2,we[Te][Ve]=0;else if($e)ke[Te][Ve]=Be,le[Te][Ve]=1,we[Te][Ve]=we[Te-1][Ve-1]+1;else throw new Error("not possible")}}if(ve&&be(he,F,q,U),!st[0]&&!X.firstMatchCanBeWeak)return;Te--,Ve--;const nt=[ke[Te][Ve],U];let tt=0,at=0;for(;Te>=1;){let je=Ve;do{const vt=le[Te][je];if(vt===3)je=je-2;else if(vt===2)je=je-1;else break}while(je>=1);tt>1&&ye[F+Te-1]===K[U+Ve-1]&&!V(je+U-1,q,K)&&tt+1>we[Te][je]&&(je=Ve),je===Ve?tt++:tt=1,at||(at=je),Te--,Ve=je-1,nt.push(Ve)}Ee===x&&X.boostFullMatch&&(nt[0]+=2);const ct=at-x;return nt[0]-=ct,nt}e.$7j=ce;function te(he,ye,F,q,K,U){let X=he-1,x=ye-1;for(;X>=F&&x>=q;)K[X]===U[x]&&(de[X]=x,X--),x--}function Q(he,ye,F,q,K,U,X,x,Ee,Te,Ve){if(ye[F]!==U[X])return Number.MIN_SAFE_INTEGER;let He=1,Ye=!1;return X===F-q?He=he[F]===K[X]?7:5:V(X,K,U)&&(X===0||!V(X-1,K,U))?(He=he[F]===K[X]?7:5,Ye=!0):ne(U,X)&&(X===0||!ne(U,X-1))?He=5:(ne(U,X-1)||Y(U,X-1))&&(He=5,Ye=!0),He>1&&F===q&&(Ve[0]=!0),Ye||(Ye=V(X,K,U)||ne(U,X-1)||Y(U,X-1)),F===q?X>Ee&&(He-=Ye?3:5):Te?He+=Ye?2:0:He+=Ye?0:1,X+1===x&&(He-=Ye?3:5),He}function ee(he,ye,F,q,K,U,X){return pe(he,ye,F,q,K,U,!0,X)}e.$8j=ee;function me(he,ye,F,q,K,U,X){return pe(he,ye,F,q,K,U,!1,X)}e.$9j=me;function pe(he,ye,F,q,K,U,X,x){let Ee=ce(he,ye,F,q,K,U,x);if(Ee&&!X)return Ee;if(he.length>=3){const Te=Math.min(7,he.length-1);for(let Ve=F+1;Ve<Te;Ve++){const He=Ae(he,Ve);if(He){const Ye=ce(He,He.toLowerCase(),F,q,K,U,x);Ye&&(Ye[0]-=3,(!Ee||Ye[0]>Ee[0])&&(Ee=Ye))}}}return Ee}function Ae(he,ye){if(ye+1>=he.length)return;const F=he[ye],q=he[ye+1];if(F!==q)return he.slice(0,ye)+q+F+he.slice(ye+2)}}),define(Pe[31],Re([1,0,11]),function(ge,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var T;(function(C){C[C.Ignore=0]="Ignore",C[C.Info=1]="Info",C[C.Warning=2]="Warning",C[C.Error=3]="Error"})(T||(T={})),function(C){const L="error",R="warning",$="warn",f="info",b="ignore";function A(l){return l?y.$_e(L,l)?C.Error:y.$_e(R,l)||y.$_e($,l)?C.Warning:y.$_e(f,l)?C.Info:C.Ignore:C.Ignore}C.fromValue=A;function k(l){switch(l){case C.Error:return L;case C.Warning:return R;case C.Info:return f;default:return b}}C.toString=k}(T||(T={})),e.default=T}),define(Pe[125],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sd=void 0,e.$Sd=Symbol("MicrotaskDelay")}),define(Pe[50],Re([1,0,18,11]),function(ge,e,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=void 0;class C{constructor(){this.b="",this.c=0}reset(p){return this.b=p,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(p){const w=p.charCodeAt(0),s=this.b.charCodeAt(this.c);return w-s}value(){return this.b[this.c]}}e.$8h=C;class L{constructor(p=!0){this.e=p}reset(p){return this.b=p,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let p=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(p)this.c++;else break;else p=!1;return this}cmp(p){return this.e?(0,T.$6e)(p,this.b,0,p.length,this.c,this.d):(0,T.$8e)(p,this.b,0,p.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$9h=L;class R{constructor(p=!0,w=!0){this.f=p,this.g=w}reset(p){this.d=0,this.e=0,this.b=p,this.c=p.length;for(let w=p.length-1;w>=0;w--,this.c--){const s=this.b.charCodeAt(w);if(!(s===47||this.f&&s===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let p=!0;for(;this.e<this.c;this.e++){const w=this.b.charCodeAt(this.e);if(w===47||this.f&&w===92)if(p)this.d++;else break;else p=!1}return this}cmp(p){return this.g?(0,T.$6e)(p,this.b,0,p.length,this.d,this.e):(0,T.$8e)(p,this.b,0,p.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$0h=R;var $;(function(l){l[l.Scheme=1]="Scheme",l[l.Authority=2]="Authority",l[l.Path=3]="Path",l[l.Query=4]="Query",l[l.Fragment=5]="Fragment"})($||($={}));class f{constructor(p,w){this.f=p,this.g=w,this.d=[],this.e=0}reset(p){return this.c=p,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new R(!1,!this.f(p)),this.b.reset(p.path),this.b.value()&&this.d.push(3)),this.g(p)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(p){if(this.d[this.e]===1)return(0,T.$7e)(p,this.c.scheme);if(this.d[this.e]===2)return(0,T.$7e)(p,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(p);if(this.d[this.e]===4)return(0,T.$5e)(p,this.c.query);if(this.d[this.e]===5)return(0,T.$5e)(p,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$$h=f;class b{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const p=this.right;return this.right=p.left,p.left=this,this.updateHeight(),p.updateHeight(),p}rotateRight(){const p=this.left;return this.left=p.right,p.right=this,this.updateHeight(),p.updateHeight(),p}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var A;(function(l){l[l.Left=-1]="Left",l[l.Mid=0]="Mid",l[l.Right=1]="Right"})(A||(A={}));class k{static forUris(p=()=>!1,w=()=>!1){return new k(new f(p,w))}static forPaths(p=!1){return new k(new R(void 0,!p))}static forStrings(){return new k(new C)}static forConfigKeys(){return new k(new L)}constructor(p){this.b=p}clear(){this.c=void 0}fill(p,w){if(w){const s=w.slice(0);(0,y.$Xb)(s);for(const a of s)this.set(a,p)}else{const s=p.slice(0);(0,y.$Xb)(s);for(const a of s)this.set(a[0],a[1])}}set(p,w){const s=this.b.reset(p);let a;this.c||(this.c=new b,this.c.segment=s.value());const r=[];for(a=this.c;;){const o=s.cmp(a.segment);if(o>0)a.left||(a.left=new b,a.left.segment=s.value()),r.push([-1,a]),a=a.left;else if(o<0)a.right||(a.right=new b,a.right.segment=s.value()),r.push([1,a]),a=a.right;else if(s.hasNext())s.next(),a.mid||(a.mid=new b,a.mid.segment=s.value()),r.push([0,a]),a=a.mid;else break}const n=a.value;a.value=w,a.key=p;for(let o=r.length-1;o>=0;o--){const c=r[o][1];c.updateHeight();const h=c.balanceFactor();if(h<-1||h>1){const t=r[o][0],u=r[o+1][0];if(t===1&&u===1)r[o][1]=c.rotateLeft();else if(t===-1&&u===-1)r[o][1]=c.rotateRight();else if(t===1&&u===-1)c.right=r[o+1][1]=r[o+1][1].rotateRight(),r[o][1]=c.rotateLeft();else if(t===-1&&u===1)c.left=r[o+1][1]=r[o+1][1].rotateLeft(),r[o][1]=c.rotateRight();else throw new Error;if(o>0)switch(r[o-1][0]){case-1:r[o-1][1].left=r[o][1];break;case 1:r[o-1][1].right=r[o][1];break;case 0:r[o-1][1].mid=r[o][1];break}else this.c=r[0][1]}}return n}get(p){return this.d(p)?.value}d(p){const w=this.b.reset(p);let s=this.c;for(;s;){const a=w.cmp(s.segment);if(a>0)s=s.left;else if(a<0)s=s.right;else if(w.hasNext())w.next(),s=s.mid;else break}return s}has(p){const w=this.d(p);return!(w?.value===void 0&&w?.mid===void 0)}delete(p){return this.e(p,!1)}deleteSuperstr(p){return this.e(p,!0)}e(p,w){const s=this.b.reset(p),a=[];let r=this.c;for(;r;){const n=s.cmp(r.segment);if(n>0)a.push([-1,r]),r=r.left;else if(n<0)a.push([1,r]),r=r.right;else if(s.hasNext())s.next(),a.push([0,r]),r=r.mid;else break}if(r){if(w?(r.left=void 0,r.mid=void 0,r.right=void 0,r.height=1):(r.key=void 0,r.value=void 0),!r.mid&&!r.value)if(r.left&&r.right){const n=this.f(r.right);if(n.key){const{key:o,value:c,segment:h}=n;this.e(n.key,!1),r.key=o,r.value=c,r.segment=h}}else{const n=r.left??r.right;if(a.length>0){const[o,c]=a[a.length-1];switch(o){case-1:c.left=n;break;case 0:c.mid=n;break;case 1:c.right=n;break}}else this.c=n}for(let n=a.length-1;n>=0;n--){const o=a[n][1];o.updateHeight();const c=o.balanceFactor();if(c>1?(o.right.balanceFactor()>=0||(o.right=o.right.rotateRight()),a[n][1]=o.rotateLeft()):c<-1&&(o.left.balanceFactor()<=0||(o.left=o.left.rotateLeft()),a[n][1]=o.rotateRight()),n>0)switch(a[n-1][0]){case-1:a[n-1][1].left=a[n][1];break;case 1:a[n-1][1].right=a[n][1];break;case 0:a[n-1][1].mid=a[n][1];break}else this.c=a[0][1]}}}f(p){for(;p.left;)p=p.left;return p}findSubstr(p){const w=this.b.reset(p);let s=this.c,a;for(;s;){const r=w.cmp(s.segment);if(r>0)s=s.left;else if(r<0)s=s.right;else if(w.hasNext())w.next(),a=s.value||a,s=s.mid;else break}return s&&s.value||a}findSuperstr(p){return this.g(p,!1)}g(p,w){const s=this.b.reset(p);let a=this.c;for(;a;){const r=s.cmp(a.segment);if(r>0)a=a.left;else if(r<0)a=a.right;else if(s.hasNext())s.next(),a=a.mid;else return a.mid?this.h(a.mid):w?a.value:void 0}}hasElementOrSubtree(p){return this.g(p,!0)!==void 0}forEach(p){for(const[w,s]of this)p(s,w)}*[Symbol.iterator](){yield*this.h(this.c)}h(p){const w=[];return this.j(p,w),w[Symbol.iterator]()}j(p,w){p&&(p.left&&this.j(p.left,w),p.value&&w.push([p.key,p.value]),p.mid&&this.j(p.mid,w),p.right&&this.j(p.right,w))}_isBalanced(){const p=w=>{if(!w)return!0;const s=w.balanceFactor();return s<-1||s>1?!1:p(w.left)&&p(w.right)};return p(this.c)}}e.$_h=k}),define(Pe[44],Re([1,0,90]),function(ge,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$ak=e.ThemeColor=void 0;var T;(function(R){function $(f){return f&&typeof f=="object"&&typeof f.id=="string"}R.isThemeColor=$})(T||(e.ThemeColor=T={}));function C(R){return{id:R}}e.$ak=C;var L;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const $=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function f(n){const o=$.exec(n.id);if(!o)return f(y.$_j.error);const[,c,h]=o,t=["codicon","codicon-"+c];return h&&t.push("codicon-modifier-"+h.substring(1)),t}R.asClassNameArray=f;function b(n){return f(n).join(" ")}R.asClassName=b;function A(n){return"."+f(n).join(".")}R.asCSSSelector=A;function k(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color>"u"||T.isThemeColor(n.color))}R.isThemeIcon=k;const l=new RegExp(`^\\$\\((${R.iconNameExpression}(?:${R.iconModifierExpression})?)\\)$`);function p(n){const o=l.exec(n);if(!o)return;const[,c]=o;return{id:c}}R.fromString=p;function w(n){return{id:n}}R.fromId=w;function s(n,o){let c=n.id;const h=c.lastIndexOf("~");return h!==-1&&(c=c.substring(0,h)),o&&(c=`${c}~${o}`),{id:c}}R.modify=s;function a(n){const o=n.id.lastIndexOf("~");if(o!==-1)return n.id.substring(o+1)}R.getModifier=a;function r(n,o){return n.id===o.id&&n.color?.id===o.color?.id}R.isEqual=r})(L||(e.ThemeIcon=L={}))}),define(Pe[126],Re([1,0,124,11,44]),function(ge,e,y,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=void 0;const L="$(",R=new RegExp(`\\$\\(${C.ThemeIcon.iconNameExpression}(?:${C.ThemeIcon.iconModifierExpression})?\\)`,"g"),$=new RegExp(`(\\\\)?${R.source}`,"g");function f(r){return r.replace($,(n,o)=>o?n:`\\${n}`)}e.$bk=f;const b=new RegExp(`\\\\${R.source}`,"g");function A(r){return r.replace(b,n=>`\\${n}`)}e.$ck=A;const k=new RegExp(`(\\s)?(\\\\)?${R.source}(\\s)?`,"g");function l(r){return r.indexOf(L)===-1?r:r.replace(k,(n,o,c,h)=>c?n:o||h||"")}e.$dk=l;function p(r){return r?r.replace(/\$\((.*?)\)/g,(n,o)=>` ${o} `).trim():""}e.$ek=p;const w=new RegExp(`\\$\\(${C.ThemeIcon.iconNameCharacter}+\\)`,"g");function s(r){w.lastIndex=0;let n="";const o=[];let c=0;for(;;){const h=w.lastIndex,t=w.exec(r),u=r.substring(h,t?.index);if(u.length>0){n+=u;for(let i=0;i<u.length;i++)o.push(c)}if(!t)break;c+=t[0].length}return{text:n,iconOffsets:o}}e.$fk=s;function a(r,n,o=!1){const{text:c,iconOffsets:h}=n;if(!h||h.length===0)return(0,y.$1j)(r,c,o);const t=(0,T.$Te)(c," "),u=c.length-t.length,i=(0,y.$1j)(r,t,o);if(i)for(const g of i){const m=h[g.start+u]+u;g.start+=m,g.end+=m}return i}e.$gk=a}),define(Pe[33],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qg=e.$pg=void 0;const y=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function T(C){return y.test(C)}e.$pg=T,e.$qg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let C;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?C=crypto.getRandomValues.bind(crypto):C=function($){for(let f=0;f<$.length;f++)$[f]=Math.floor(Math.random()*256);return $};const L=new Uint8Array(16),R=[];for(let $=0;$<256;$++)R.push($.toString(16).padStart(2,"0"));return function(){C(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let f=0,b="";return b+=R[L[f++]],b+=R[L[f++]],b+=R[L[f++]],b+=R[L[f++]],b+="-",b+=R[L[f++]],b+=R[L[f++]],b+="-",b+=R[L[f++]],b+=R[L[f++]],b+="-",b+=R[L[f++]],b+=R[L[f++]],b+="-",b+=R[L[f++]],b+=R[L[f++]],b+=R[L[f++]],b+=R[L[f++]],b+=R[L[f++]],b+=R[L[f++]],b}}()}),define(Pe[127],Re([1,0,18,67,33]),function(ge,e,y,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rt=e.$qt=e.$pt=e.$ot=e.$nt=void 0;function L(k){return{asString:async()=>k,asFile:()=>{},value:typeof k=="string"?k:void 0}}e.$nt=L;function R(k,l,p){const w={id:(0,C.$qg)(),name:k,uri:l,data:p};return{asString:async()=>"",asFile:()=>w,value:void 0}}e.$ot=R;class ${constructor(){this.a=new Map}get size(){let l=0;for(const p of this.a)l++;return l}has(l){return this.a.has(this.b(l))}matches(l){const p=[...this.a.keys()];return T.Iterable.some(this,([w,s])=>s.asFile())&&p.push("files"),A(f(l),p)}get(l){return this.a.get(this.b(l))?.[0]}append(l,p){const w=this.a.get(l);w?w.push(p):this.a.set(this.b(l),[p])}replace(l,p){this.a.set(this.b(l),[p])}delete(l){this.a.delete(this.b(l))}*[Symbol.iterator](){for(const[l,p]of this.a)for(const w of p)yield[l,w]}b(l){return f(l)}}e.$pt=$;function f(k){return k.toLowerCase()}function b(k,l){return A(f(k),l.map(f))}e.$qt=b;function A(k,l){if(k==="*/*")return l.length>0;if(l.includes(k))return!0;const p=k.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!p)return!1;const[w,s,a]=p;return a==="*"?l.some(r=>r.startsWith(s+"/")):!1}e.$rt=Object.freeze({create:k=>(0,y.$Mb)(k.map(l=>l.toString())).join(`\r
`),split:k=>k.split(`\r
`),parse:k=>e.$rt.split(k).filter(l=>!l.startsWith("#"))})}),define(Pe[128],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ut=e.StringEOL=void 0;var y;(function(C){C[C.Unknown=0]="Unknown",C[C.Invalid=3]="Invalid",C[C.LF=1]="LF",C[C.CRLF=2]="CRLF"})(y||(e.StringEOL=y={}));function T(C){let L=0,R=0,$=0,f=0;for(let b=0,A=C.length;b<A;b++){const k=C.charCodeAt(b);k===13?(L===0&&(R=b),L++,b+1<A&&C.charCodeAt(b+1)===10?(f|=2,b++):f|=3,$=b+1):k===10&&(f|=1,L===0&&(R=b),L++,$=b+1)}return L===0&&(R=C.length),[L,R,C.length-$,f]}e.$ut=T}),define(Pe[129],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ss=void 0,e.$ss={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Pe[130],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$St=e.$Rt=e.IndentAction=void 0;var y;(function(R){R[R.None=0]="None",R[R.Indent=1]="Indent",R[R.IndentOutdent=2]="IndentOutdent",R[R.Outdent=3]="Outdent"})(y||(e.IndentAction=y={}));class T{constructor($){if(this.e=null,this.f=!1,this.open=$.open,this.close=$.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray($.notIn))for(let f=0,b=$.notIn.length;f<b;f++)switch($.notIn[f]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK($){switch($){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose($,f){if($.getTokenCount()===0)return!0;const b=$.findTokenIndexAtOffset(f-2),A=$.getStandardTokenType(b);return this.isOK(A)}g($,f){for(let b=$;b<=f;b++){const A=String.fromCharCode(b);if(!this.open.includes(A)&&!this.close.includes(A))return A}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$Rt=T;class C{constructor($){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const f of $)L(this.autoClosingPairsOpenByStart,f.open.charAt(0),f),L(this.autoClosingPairsOpenByEnd,f.open.charAt(f.open.length-1),f),L(this.autoClosingPairsCloseByStart,f.close.charAt(0),f),L(this.autoClosingPairsCloseByEnd,f.close.charAt(f.close.length-1),f),f.close.length===1&&f.open.length===1&&L(this.autoClosingPairsCloseSingleChar,f.close,f)}}e.$St=C;function L(R,$,f){R.has($)?R.get($).push(f):R.set($,[f])}}),define(Pe[131],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2B=e.$1B=e.$ZB=e.$YB=e.$XB=e.$WB=e.$VB=e.$UB=e.$TB=e.NodeColor=e.$SB=void 0;class y{constructor(a,r){this.piece=a,this.color=r,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$TB)return C(this.right);let a=this;for(;a.parent!==e.$TB&&a.parent.left!==a;)a=a.parent;return a.parent===e.$TB?e.$TB:a.parent}prev(){if(this.left!==e.$TB)return L(this.left);let a=this;for(;a.parent!==e.$TB&&a.parent.right!==a;)a=a.parent;return a.parent===e.$TB?e.$TB:a.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$SB=y;var T;(function(s){s[s.Black=0]="Black",s[s.Red=1]="Red"})(T||(e.NodeColor=T={})),e.$TB=new y(null,0),e.$TB.parent=e.$TB,e.$TB.left=e.$TB,e.$TB.right=e.$TB,e.$TB.color=0;function C(s){for(;s.left!==e.$TB;)s=s.left;return s}e.$UB=C;function L(s){for(;s.right!==e.$TB;)s=s.right;return s}e.$VB=L;function R(s){return s===e.$TB?0:s.size_left+s.piece.length+R(s.right)}function $(s){return s===e.$TB?0:s.lf_left+s.piece.lineFeedCnt+$(s.right)}function f(){e.$TB.parent=e.$TB}function b(s,a){const r=a.right;r.size_left+=a.size_left+(a.piece?a.piece.length:0),r.lf_left+=a.lf_left+(a.piece?a.piece.lineFeedCnt:0),a.right=r.left,r.left!==e.$TB&&(r.left.parent=a),r.parent=a.parent,a.parent===e.$TB?s.root=r:a.parent.left===a?a.parent.left=r:a.parent.right=r,r.left=a,a.parent=r}e.$WB=b;function A(s,a){const r=a.left;a.left=r.right,r.right!==e.$TB&&(r.right.parent=a),r.parent=a.parent,a.size_left-=r.size_left+(r.piece?r.piece.length:0),a.lf_left-=r.lf_left+(r.piece?r.piece.lineFeedCnt:0),a.parent===e.$TB?s.root=r:a===a.parent.right?a.parent.right=r:a.parent.left=r,r.right=a,a.parent=r}e.$XB=A;function k(s,a){let r,n;if(a.left===e.$TB?(n=a,r=n.right):a.right===e.$TB?(n=a,r=n.left):(n=C(a.right),r=n.right),n===s.root){s.root=r,r.color=0,a.detach(),f(),s.root.parent=e.$TB;return}const o=n.color===1;if(n===n.parent.left?n.parent.left=r:n.parent.right=r,n===a?(r.parent=n.parent,w(s,r)):(n.parent===a?r.parent=n:r.parent=n.parent,w(s,r),n.left=a.left,n.right=a.right,n.parent=a.parent,n.color=a.color,a===s.root?s.root=n:a===a.parent.left?a.parent.left=n:a.parent.right=n,n.left!==e.$TB&&(n.left.parent=n),n.right!==e.$TB&&(n.right.parent=n),n.size_left=a.size_left,n.lf_left=a.lf_left,w(s,n)),a.detach(),r.parent.left===r){const h=R(r),t=$(r);if(h!==r.parent.size_left||t!==r.parent.lf_left){const u=h-r.parent.size_left,i=t-r.parent.lf_left;r.parent.size_left=h,r.parent.lf_left=t,p(s,r.parent,u,i)}}if(w(s,r.parent),o){f();return}let c;for(;r!==s.root&&r.color===0;)r===r.parent.left?(c=r.parent.right,c.color===1&&(c.color=0,r.parent.color=1,b(s,r.parent),c=r.parent.right),c.left.color===0&&c.right.color===0?(c.color=1,r=r.parent):(c.right.color===0&&(c.left.color=0,c.color=1,A(s,c),c=r.parent.right),c.color=r.parent.color,r.parent.color=0,c.right.color=0,b(s,r.parent),r=s.root)):(c=r.parent.left,c.color===1&&(c.color=0,r.parent.color=1,A(s,r.parent),c=r.parent.left),c.left.color===0&&c.right.color===0?(c.color=1,r=r.parent):(c.left.color===0&&(c.right.color=0,c.color=1,b(s,c),c=r.parent.left),c.color=r.parent.color,r.parent.color=0,c.left.color=0,A(s,r.parent),r=s.root));r.color=0,f()}e.$YB=k;function l(s,a){for(w(s,a);a!==s.root&&a.parent.color===1;)if(a.parent===a.parent.parent.left){const r=a.parent.parent.right;r.color===1?(a.parent.color=0,r.color=0,a.parent.parent.color=1,a=a.parent.parent):(a===a.parent.right&&(a=a.parent,b(s,a)),a.parent.color=0,a.parent.parent.color=1,A(s,a.parent.parent))}else{const r=a.parent.parent.left;r.color===1?(a.parent.color=0,r.color=0,a.parent.parent.color=1,a=a.parent.parent):(a===a.parent.left&&(a=a.parent,A(s,a)),a.parent.color=0,a.parent.parent.color=1,b(s,a.parent.parent))}s.root.color=0}e.$ZB=l;function p(s,a,r,n){for(;a!==s.root&&a!==e.$TB;)a.parent.left===a&&(a.parent.size_left+=r,a.parent.lf_left+=n),a=a.parent}e.$1B=p;function w(s,a){let r=0,n=0;if(a!==s.root){for(;a!==s.root&&a===a.parent.right;)a=a.parent;if(a!==s.root)for(a=a.parent,r=R(a.left)-a.size_left,n=$(a.left)-a.lf_left,a.size_left+=r,a.lf_left+=n;a!==s.root&&(r!==0||n!==0);)a.parent.left===a&&(a.parent.size_left+=r,a.parent.lf_left+=n),a=a.parent}}e.$2B=w}),define(Pe[91],Re([1,0,92,29,93,131,94]),function(ge,e,y,T,C,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aC=e.$_B=e.$$B=e.$0B=e.$9B=void 0;const $=65535;function f(r){let n;return r[r.length-1]<65536?n=new Uint16Array(r.length):n=new Uint32Array(r.length),n.set(r,0),n}class b{constructor(n,o,c,h,t){this.lineStarts=n,this.cr=o,this.lf=c,this.crlf=h,this.isBasicASCII=t}}function A(r,n=!0){const o=[0];let c=1;for(let h=0,t=r.length;h<t;h++){const u=r.charCodeAt(h);u===13?h+1<t&&r.charCodeAt(h+1)===10?(o[c++]=h+2,h++):o[c++]=h+1:u===10&&(o[c++]=h+1)}return n?f(o):o}e.$9B=A;function k(r,n){r.length=0,r[0]=0;let o=1,c=0,h=0,t=0,u=!0;for(let g=0,m=n.length;g<m;g++){const d=n.charCodeAt(g);d===13?g+1<m&&n.charCodeAt(g+1)===10?(t++,r[o++]=g+2,g++):(c++,r[o++]=g+1):d===10?(h++,r[o++]=g+1):u&&d!==9&&(d<32||d>126)&&(u=!1)}const i=new b(f(r),c,h,t,u);return r.length=0,i}e.$0B=k;class l{constructor(n,o,c,h,t){this.bufferIndex=n,this.start=o,this.end=c,this.lineFeedCnt=h,this.length=t}}e.$$B=l;class p{constructor(n,o){this.buffer=n,this.lineStarts=o}}e.$_B=p;class w{constructor(n,o){this.a=[],this.c=n,this.d=o,this.b=0,n.root!==L.$TB&&n.iterate(n.root,c=>(c!==L.$TB&&this.a.push(c.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class s{constructor(n){this.a=n,this.b=[]}get(n){for(let o=this.b.length-1;o>=0;o--){const c=this.b[o];if(c.nodeStartOffset<=n&&c.nodeStartOffset+c.node.piece.length>=n)return c}return null}get2(n){for(let o=this.b.length-1;o>=0;o--){const c=this.b[o];if(c.nodeStartLineNumber&&c.nodeStartLineNumber<n&&c.nodeStartLineNumber+c.node.piece.lineFeedCnt>=n)return c}return null}set(n){this.b.length>=this.a&&this.b.shift(),this.b.push(n)}validate(n){let o=!1;const c=this.b;for(let h=0;h<c.length;h++){const t=c[h];if(t.node.parent===null||t.nodeStartOffset>=n){c[h]=null,o=!0;continue}}if(o){const h=[];for(const t of c)t!==null&&h.push(t);this.b=h}}}class a{constructor(n,o,c){this.create(n,o,c)}create(n,o,c){this.a=[new p("",[0])],this.g={line:0,column:0},this.root=L.$TB,this.b=1,this.c=0,this.d=o,this.e=o.length,this.f=c;let h=null;for(let t=0,u=n.length;t<u;t++)if(n[t].buffer.length>0){n[t].lineStarts||(n[t].lineStarts=A(n[t].buffer));const i=new l(t+1,{line:0,column:0},{line:n[t].lineStarts.length-1,column:n[t].buffer.length-n[t].lineStarts[n[t].lineStarts.length-1]},n[t].lineStarts.length-1,n[t].buffer.length);this.a.push(n[t]),h=this.S(h,i)}this.h=new s(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(n){const o=$,c=o-Math.floor(o/3),h=c*2;let t="",u=0;const i=[];if(this.iterate(this.root,g=>{const m=this.R(g),d=m.length;if(u<=c||u+d<h)return t+=m,u+=d,!0;const S=t.replace(/\r\n|\r|\n/g,n);return i.push(new p(S,A(S))),t=m,u=d,!0}),u>0){const g=t.replace(/\r\n|\r|\n/g,n);i.push(new p(g,A(g)))}this.create(i,n,!0)}getEOL(){return this.d}setEOL(n){this.d=n,this.e=this.d.length,this.normalizeEOL(n)}createSnapshot(n){return new w(this,n)}equal(n){if(this.getLength()!==n.getLength()||this.getLineCount()!==n.getLineCount())return!1;let o=0;return this.iterate(this.root,h=>{if(h===L.$TB)return!0;const t=this.R(h),u=t.length,i=n.G(o),g=n.G(o+u),m=n.getValueInRange2(i,g);return o+=u,t===m})}getOffsetAt(n,o){let c=0,h=this.root;for(;h!==L.$TB;)if(h.left!==L.$TB&&h.lf_left+1>=n)h=h.left;else if(h.lf_left+h.piece.lineFeedCnt+1>=n){c+=h.size_left;const t=this.B(h,n-h.lf_left-2);return c+=t+o-1}else n-=h.lf_left+h.piece.lineFeedCnt,c+=h.size_left+h.piece.length,h=h.right;return c}getPositionAt(n){n=Math.floor(n),n=Math.max(0,n);let o=this.root,c=0;const h=n;for(;o!==L.$TB;)if(o.size_left!==0&&o.size_left>=n)o=o.left;else if(o.size_left+o.piece.length>=n){const t=this.A(o,n-o.size_left);if(c+=o.lf_left+t.index,t.index===0){const u=this.getOffsetAt(c+1,1),i=h-u;return new y.$Ts(c+1,i+1)}return new y.$Ts(c+1,t.remainder+1)}else if(n-=o.size_left+o.piece.length,c+=o.lf_left+o.piece.lineFeedCnt,o.right===L.$TB){const t=this.getOffsetAt(c+1,1),u=h-n-t;return new y.$Ts(c+1,u+1)}else o=o.right;return new y.$Ts(1,1)}getValueInRange(n,o){if(n.startLineNumber===n.endLineNumber&&n.startColumn===n.endColumn)return"";const c=this.H(n.startLineNumber,n.startColumn),h=this.H(n.endLineNumber,n.endColumn),t=this.getValueInRange2(c,h);return o?o!==this.d||!this.f?t.replace(/\r\n|\r|\n/g,o):o===this.getEOL()&&this.f?t:t.replace(/\r\n|\r|\n/g,o):t}getValueInRange2(n,o){if(n.node===o.node){const i=n.node,g=this.a[i.piece.bufferIndex].buffer,m=this.u(i.piece.bufferIndex,i.piece.start);return g.substring(m+n.remainder,m+o.remainder)}let c=n.node;const h=this.a[c.piece.bufferIndex].buffer,t=this.u(c.piece.bufferIndex,c.piece.start);let u=h.substring(t+n.remainder,t+c.piece.length);for(c=c.next();c!==L.$TB;){const i=this.a[c.piece.bufferIndex].buffer,g=this.u(c.piece.bufferIndex,c.piece.start);if(c===o.node){u+=i.substring(g,g+o.remainder);break}else u+=i.substr(g,c.piece.length);c=c.next()}return u}getLinesContent(){const n=[];let o=0,c="",h=!1;return this.iterate(this.root,t=>{if(t===L.$TB)return!0;const u=t.piece;let i=u.length;if(i===0)return!0;const g=this.a[u.bufferIndex].buffer,m=this.a[u.bufferIndex].lineStarts,d=u.start.line,S=u.end.line;let M=m[d]+u.start.column;if(h&&(g.charCodeAt(M)===10&&(M++,i--),n[o++]=c,c="",h=!1,i===0))return!0;if(d===S)return!this.f&&g.charCodeAt(M+i-1)===13?(h=!0,c+=g.substr(M,i-1)):c+=g.substr(M,i),!0;c+=this.f?g.substring(M,Math.max(M,m[d+1]-this.e)):g.substring(M,m[d+1]).replace(/(\r\n|\r|\n)$/,""),n[o++]=c;for(let v=d+1;v<S;v++)c=this.f?g.substring(m[v],m[v+1]-this.e):g.substring(m[v],m[v+1]).replace(/(\r\n|\r|\n)$/,""),n[o++]=c;return!this.f&&g.charCodeAt(m[S]+u.end.column-1)===13?(h=!0,u.end.column===0?o--:c=g.substr(m[S],u.end.column-1)):c=g.substr(m[S],u.end.column),!0}),h&&(n[o++]=c,c=""),n[o++]=c,n}getLength(){return this.c}getLineCount(){return this.b}getLineContent(n){return this.j.lineNumber===n?this.j.value:(this.j.lineNumber=n,n===this.b?this.j.value=this.getLineRawContent(n):this.f?this.j.value=this.getLineRawContent(n,this.e):this.j.value=this.getLineRawContent(n).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(n){if(n.remainder===n.node.piece.length){const o=n.node.next();if(!o)return 0;const c=this.a[o.piece.bufferIndex],h=this.u(o.piece.bufferIndex,o.piece.start);return c.buffer.charCodeAt(h)}else{const o=this.a[n.node.piece.bufferIndex],h=this.u(n.node.piece.bufferIndex,n.node.piece.start)+n.remainder;return o.buffer.charCodeAt(h)}}getLineCharCode(n,o){const c=this.H(n,o+1);return this.l(c)}getLineLength(n){if(n===this.getLineCount()){const o=this.getOffsetAt(n,1);return this.getLength()-o}return this.getOffsetAt(n+1,1)-this.getOffsetAt(n,1)-this.e}getCharCode(n){const o=this.G(n);return this.l(o)}findMatchesInNode(n,o,c,h,t,u,i,g,m,d,S){const M=this.a[n.piece.bufferIndex],v=this.u(n.piece.bufferIndex,n.piece.start),E=this.u(n.piece.bufferIndex,t),D=this.u(n.piece.bufferIndex,u);let N;const O={line:0,column:0};let G,W;o._wordSeparators?(G=M.buffer.substring(E,D),W=z=>z+E,o.reset(0)):(G=M.buffer,W=z=>z,o.reset(E));do if(N=o.next(G),N){if(W(N.index)>=D)return d;this.s(n,W(N.index)-v,O);const z=this.t(n.piece.bufferIndex,t,O),P=O.line===t.line?O.column-t.column+h:O.column+1,I=P+N[0].length;if(S[d++]=(0,R.$5B)(new T.$Us(c+z,P,c+z,I),N,g),W(N.index)+N[0].length>=D||d>=m)return d}while(N);return d}findMatchesLineByLine(n,o,c,h){const t=[];let u=0;const i=new R.$8B(o.wordSeparators,o.regex);let g=this.H(n.startLineNumber,n.startColumn);if(g===null)return[];const m=this.H(n.endLineNumber,n.endColumn);if(m===null)return[];let d=this.s(g.node,g.remainder);const S=this.s(m.node,m.remainder);if(g.node===m.node)return this.findMatchesInNode(g.node,i,n.startLineNumber,n.startColumn,d,S,o,c,h,u,t),t;let M=n.startLineNumber,v=g.node;for(;v!==m.node;){const D=this.t(v.piece.bufferIndex,d,v.piece.end);if(D>=1){const O=this.a[v.piece.bufferIndex].lineStarts,G=this.u(v.piece.bufferIndex,v.piece.start),W=O[d.line+D],z=M===n.startLineNumber?n.startColumn:1;if(u=this.findMatchesInNode(v,i,M,z,d,this.s(v,W-G),o,c,h,u,t),u>=h)return t;M+=D}const N=M===n.startLineNumber?n.startColumn-1:0;if(M===n.endLineNumber){const O=this.getLineContent(M).substring(N,n.endColumn-1);return u=this.n(o,i,O,n.endLineNumber,N,u,t,c,h),t}if(u=this.n(o,i,this.getLineContent(M).substr(N),M,N,u,t,c,h),u>=h)return t;M++,g=this.H(M,1),v=g.node,d=this.s(g.node,g.remainder)}if(M===n.endLineNumber){const D=M===n.startLineNumber?n.startColumn-1:0,N=this.getLineContent(M).substring(D,n.endColumn-1);return u=this.n(o,i,N,n.endLineNumber,D,u,t,c,h),t}const E=M===n.startLineNumber?n.startColumn:1;return u=this.findMatchesInNode(m.node,i,M,E,d,S,o,c,h,u,t),t}n(n,o,c,h,t,u,i,g,m){const d=n.wordSeparators;if(!g&&n.simpleSearch){const M=n.simpleSearch,v=M.length,E=c.length;let D=-v;for(;(D=c.indexOf(M,D+v))!==-1;)if((!d||(0,R.$7B)(d,c,E,D,v))&&(i[u++]=new C.$av(new T.$Us(h,D+1+t,h,D+1+v+t),null),u>=m))return u;return u}let S;o.reset(0);do if(S=o.next(c),S&&(i[u++]=(0,R.$5B)(new T.$Us(h,S.index+1+t,h,S.index+1+S[0].length+t),S,g),u>=m))return u;while(S);return u}insert(n,o,c=!1){if(this.f=this.f&&c,this.j.lineNumber=0,this.j.value="",this.root!==L.$TB){const{node:h,remainder:t,nodeStartOffset:u}=this.G(n),i=h.piece,g=i.bufferIndex,m=this.s(h,t);if(h.piece.bufferIndex===0&&i.end.line===this.g.line&&i.end.column===this.g.column&&u+i.length===n&&o.length<$){this.F(h,o),this.y();return}if(u===n)this.o(o,h),this.h.validate(n);else if(u+h.piece.length>n){const d=[];let S=new l(i.bufferIndex,m,i.end,this.t(i.bufferIndex,m,i.end),this.u(g,i.end)-this.u(g,m));if(this.K()&&this.M(o)&&this.I(h,t)===10){const D={line:S.start.line+1,column:0};S=new l(S.bufferIndex,D,S.end,this.t(S.bufferIndex,D,S.end),S.length-1),o+=`
`}if(this.K()&&this.L(o))if(this.I(h,t-1)===13){const D=this.s(h,t-1);this.C(h,D),o="\r"+o,h.piece.length===0&&d.push(h)}else this.C(h,m);else this.C(h,m);const M=this.w(o);S.length>0&&this.S(h,S);let v=h;for(let E=0;E<M.length;E++)v=this.S(v,M[E]);this.v(d)}else this.q(o,h)}else{const h=this.w(o);let t=this.T(null,h[0]);for(let u=1;u<h.length;u++)t=this.S(t,h[u])}this.y()}delete(n,o){if(this.j.lineNumber=0,this.j.value="",o<=0||this.root===L.$TB)return;const c=this.G(n),h=this.G(n+o),t=c.node,u=h.node;if(t===u){const M=this.s(t,c.remainder),v=this.s(t,h.remainder);if(c.nodeStartOffset===n){if(o===t.piece.length){const E=t.next();(0,L.$YB)(this,t),this.N(E),this.y();return}this.D(t,v),this.h.validate(n),this.N(t),this.y();return}if(c.nodeStartOffset+t.piece.length===n+o){this.C(t,M),this.O(t),this.y();return}this.E(t,M,v),this.y();return}const i=[],g=this.s(t,c.remainder);this.C(t,g),this.h.validate(n),t.piece.length===0&&i.push(t);const m=this.s(u,h.remainder);this.D(u,m),u.piece.length===0&&i.push(u);const d=t.next();for(let M=d;M!==L.$TB&&M!==u;M=M.next())i.push(M);const S=t.piece.length===0?t.prev():t;this.v(i),this.O(S),this.y()}o(n,o){const c=[];if(this.K()&&this.M(n)&&this.L(o)){const u=o.piece,i={line:u.start.line+1,column:0},g=new l(u.bufferIndex,i,u.end,this.t(u.bufferIndex,i,u.end),u.length-1);o.piece=g,n+=`
`,(0,L.$1B)(this,o,-1,-1),o.piece.length===0&&c.push(o)}const h=this.w(n);let t=this.T(o,h[h.length-1]);for(let u=h.length-2;u>=0;u--)t=this.T(t,h[u]);this.N(t),this.v(c)}q(n,o){this.Q(n,o)&&(n+=`
`);const c=this.w(n),h=this.S(o,c[0]);let t=h;for(let u=1;u<c.length;u++)t=this.S(t,c[u]);this.N(h)}s(n,o,c){const h=n.piece,t=n.piece.bufferIndex,u=this.a[t].lineStarts,g=u[h.start.line]+h.start.column+o;let m=h.start.line,d=h.end.line,S=0,M=0,v=0;for(;m<=d&&(S=m+(d-m)/2|0,v=u[S],S!==d);)if(M=u[S+1],g<v)d=S-1;else if(g>=M)m=S+1;else break;return c?(c.line=S,c.column=g-v,null):{line:S,column:g-v}}t(n,o,c){if(c.column===0)return c.line-o.line;const h=this.a[n].lineStarts;if(c.line===h.length-1)return c.line-o.line;const t=h[c.line+1],u=h[c.line]+c.column;if(t>u+1)return c.line-o.line;const i=u-1;return this.a[n].buffer.charCodeAt(i)===13?c.line-o.line+1:c.line-o.line}u(n,o){return this.a[n].lineStarts[o.line]+o.column}v(n){for(let o=0;o<n.length;o++)(0,L.$YB)(this,n[o])}w(n){if(n.length>$){const d=[];for(;n.length>$;){const M=n.charCodeAt($-1);let v;M===13||M>=55296&&M<=56319?(v=n.substring(0,$-1),n=n.substring($-1)):(v=n.substring(0,$),n=n.substring($));const E=A(v);d.push(new l(this.a.length,{line:0,column:0},{line:E.length-1,column:v.length-E[E.length-1]},E.length-1,v.length)),this.a.push(new p(v,E))}const S=A(n);return d.push(new l(this.a.length,{line:0,column:0},{line:S.length-1,column:n.length-S[S.length-1]},S.length-1,n.length)),this.a.push(new p(n,S)),d}let o=this.a[0].buffer.length;const c=A(n,!1);let h=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===o&&o!==0&&this.L(n)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},h=this.g;for(let d=0;d<c.length;d++)c[d]+=o+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(c.slice(1)),this.a[0].buffer+="_"+n,o+=1}else{if(o!==0)for(let d=0;d<c.length;d++)c[d]+=o;this.a[0].lineStarts=this.a[0].lineStarts.concat(c.slice(1)),this.a[0].buffer+=n}const t=this.a[0].buffer.length,u=this.a[0].lineStarts.length-1,i=t-this.a[0].lineStarts[u],g={line:u,column:i},m=new l(0,h,g,this.t(0,h,g),t-o);return this.g=g,[m]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(n,o=0){let c=this.root,h="";const t=this.h.get2(n);if(t){c=t.node;const u=this.B(c,n-t.nodeStartLineNumber-1),i=this.a[c.piece.bufferIndex].buffer,g=this.u(c.piece.bufferIndex,c.piece.start);if(t.nodeStartLineNumber+c.piece.lineFeedCnt===n)h=i.substring(g+u,g+c.piece.length);else{const m=this.B(c,n-t.nodeStartLineNumber);return i.substring(g+u,g+m-o)}}else{let u=0;const i=n;for(;c!==L.$TB;)if(c.left!==L.$TB&&c.lf_left>=n-1)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt>n-1){const g=this.B(c,n-c.lf_left-2),m=this.B(c,n-c.lf_left-1),d=this.a[c.piece.bufferIndex].buffer,S=this.u(c.piece.bufferIndex,c.piece.start);return u+=c.size_left,this.h.set({node:c,nodeStartOffset:u,nodeStartLineNumber:i-(n-1-c.lf_left)}),d.substring(S+g,S+m-o)}else if(c.lf_left+c.piece.lineFeedCnt===n-1){const g=this.B(c,n-c.lf_left-2),m=this.a[c.piece.bufferIndex].buffer,d=this.u(c.piece.bufferIndex,c.piece.start);h=m.substring(d+g,d+c.piece.length);break}else n-=c.lf_left+c.piece.lineFeedCnt,u+=c.size_left+c.piece.length,c=c.right}for(c=c.next();c!==L.$TB;){const u=this.a[c.piece.bufferIndex].buffer;if(c.piece.lineFeedCnt>0){const i=this.B(c,0),g=this.u(c.piece.bufferIndex,c.piece.start);return h+=u.substring(g,g+i-o),h}else{const i=this.u(c.piece.bufferIndex,c.piece.start);h+=u.substr(i,c.piece.length)}c=c.next()}return h}y(){let n=this.root,o=1,c=0;for(;n!==L.$TB;)o+=n.lf_left+n.piece.lineFeedCnt,c+=n.size_left+n.piece.length,n=n.right;this.b=o,this.c=c,this.h.validate(this.c)}A(n,o){const c=n.piece,h=this.s(n,o),t=h.line-c.start.line;if(this.u(c.bufferIndex,c.end)-this.u(c.bufferIndex,c.start)===o){const u=this.t(n.piece.bufferIndex,c.start,h);if(u!==t)return{index:u,remainder:0}}return{index:t,remainder:h.column}}B(n,o){if(o<0)return 0;const c=n.piece,h=this.a[c.bufferIndex].lineStarts,t=c.start.line+o+1;return t>c.end.line?h[c.end.line]+c.end.column-h[c.start.line]-c.start.column:h[t]-h[c.start.line]-c.start.column}C(n,o){const c=n.piece,h=c.lineFeedCnt,t=this.u(c.bufferIndex,c.end),u=o,i=this.u(c.bufferIndex,u),g=this.t(c.bufferIndex,c.start,u),m=g-h,d=i-t,S=c.length+d;n.piece=new l(c.bufferIndex,c.start,u,g,S),(0,L.$1B)(this,n,d,m)}D(n,o){const c=n.piece,h=c.lineFeedCnt,t=this.u(c.bufferIndex,c.start),u=o,i=this.t(c.bufferIndex,u,c.end),g=this.u(c.bufferIndex,u),m=i-h,d=t-g,S=c.length+d;n.piece=new l(c.bufferIndex,u,c.end,i,S),(0,L.$1B)(this,n,d,m)}E(n,o,c){const h=n.piece,t=h.start,u=h.end,i=h.length,g=h.lineFeedCnt,m=o,d=this.t(h.bufferIndex,h.start,m),S=this.u(h.bufferIndex,o)-this.u(h.bufferIndex,t);n.piece=new l(h.bufferIndex,h.start,m,d,S),(0,L.$1B)(this,n,S-i,d-g);const M=new l(h.bufferIndex,c,u,this.t(h.bufferIndex,c,u),this.u(h.bufferIndex,u)-this.u(h.bufferIndex,c)),v=this.S(n,M);this.N(v)}F(n,o){this.Q(o,n)&&(o+=`
`);const c=this.K()&&this.L(o)&&this.M(n),h=this.a[0].buffer.length;this.a[0].buffer+=o;const t=A(o,!1);for(let v=0;v<t.length;v++)t[v]+=h;if(c){const v=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:h-v}}this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1));const u=this.a[0].lineStarts.length-1,i=this.a[0].buffer.length-this.a[0].lineStarts[u],g={line:u,column:i},m=n.piece.length+o.length,d=n.piece.lineFeedCnt,S=this.t(0,n.piece.start,g),M=S-d;n.piece=new l(n.piece.bufferIndex,n.piece.start,g,S,m),this.g=g,(0,L.$1B)(this,n,o.length,M)}G(n){let o=this.root;const c=this.h.get(n);if(c)return{node:c.node,nodeStartOffset:c.nodeStartOffset,remainder:n-c.nodeStartOffset};let h=0;for(;o!==L.$TB;)if(o.size_left>n)o=o.left;else if(o.size_left+o.piece.length>=n){h+=o.size_left;const t={node:o,remainder:n-o.size_left,nodeStartOffset:h};return this.h.set(t),t}else n-=o.size_left+o.piece.length,h+=o.size_left+o.piece.length,o=o.right;return null}H(n,o){let c=this.root,h=0;for(;c!==L.$TB;)if(c.left!==L.$TB&&c.lf_left>=n-1)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt>n-1){const t=this.B(c,n-c.lf_left-2),u=this.B(c,n-c.lf_left-1);return h+=c.size_left,{node:c,remainder:Math.min(t+o-1,u),nodeStartOffset:h}}else if(c.lf_left+c.piece.lineFeedCnt===n-1){const t=this.B(c,n-c.lf_left-2);if(t+o-1<=c.piece.length)return{node:c,remainder:t+o-1,nodeStartOffset:h};o-=c.piece.length-t;break}else n-=c.lf_left+c.piece.lineFeedCnt,h+=c.size_left+c.piece.length,c=c.right;for(c=c.next();c!==L.$TB;){if(c.piece.lineFeedCnt>0){const t=this.B(c,0),u=this.J(c);return{node:c,remainder:Math.min(o-1,t),nodeStartOffset:u}}else if(c.piece.length>=o-1){const t=this.J(c);return{node:c,remainder:o-1,nodeStartOffset:t}}else o-=c.piece.length;c=c.next()}return null}I(n,o){if(n.piece.lineFeedCnt<1)return-1;const c=this.a[n.piece.bufferIndex],h=this.u(n.piece.bufferIndex,n.piece.start)+o;return c.buffer.charCodeAt(h)}J(n){if(!n)return 0;let o=n.size_left;for(;n!==this.root;)n.parent.right===n&&(o+=n.parent.size_left+n.parent.piece.length),n=n.parent;return o}K(){return!(this.f&&this.d===`
`)}L(n){if(typeof n=="string")return n.charCodeAt(0)===10;if(n===L.$TB||n.piece.lineFeedCnt===0)return!1;const o=n.piece,c=this.a[o.bufferIndex].lineStarts,h=o.start.line,t=c[h]+o.start.column;return h===c.length-1||c[h+1]>t+1?!1:this.a[o.bufferIndex].buffer.charCodeAt(t)===10}M(n){return typeof n=="string"?n.charCodeAt(n.length-1)===13:n===L.$TB||n.piece.lineFeedCnt===0?!1:this.I(n,n.piece.length-1)===13}N(n){if(this.K()&&this.L(n)){const o=n.prev();this.M(o)&&this.P(o,n)}}O(n){if(this.K()&&this.M(n)){const o=n.next();this.L(o)&&this.P(n,o)}}P(n,o){const c=[],h=this.a[n.piece.bufferIndex].lineStarts;let t;n.piece.end.column===0?t={line:n.piece.end.line-1,column:h[n.piece.end.line]-h[n.piece.end.line-1]-1}:t={line:n.piece.end.line,column:n.piece.end.column-1};const u=n.piece.length-1,i=n.piece.lineFeedCnt-1;n.piece=new l(n.piece.bufferIndex,n.piece.start,t,i,u),(0,L.$1B)(this,n,-1,-1),n.piece.length===0&&c.push(n);const g={line:o.piece.start.line+1,column:0},m=o.piece.length-1,d=this.t(o.piece.bufferIndex,g,o.piece.end);o.piece=new l(o.piece.bufferIndex,g,o.piece.end,d,m),(0,L.$1B)(this,o,-1,-1),o.piece.length===0&&c.push(o);const S=this.w(`\r
`);this.S(n,S[0]);for(let M=0;M<c.length;M++)(0,L.$YB)(this,c[M])}Q(n,o){if(this.K()&&this.M(n)){const c=o.next();if(this.L(c)){if(n+=`
`,c.piece.length===1)(0,L.$YB)(this,c);else{const h=c.piece,t={line:h.start.line+1,column:0},u=h.length-1,i=this.t(h.bufferIndex,t,h.end);c.piece=new l(h.bufferIndex,t,h.end,i,u),(0,L.$1B)(this,c,-1,-1)}return!0}}return!1}iterate(n,o){if(n===L.$TB)return o(L.$TB);const c=this.iterate(n.left,o);return c&&o(n)&&this.iterate(n.right,o)}R(n){if(n===L.$TB)return"";const o=this.a[n.piece.bufferIndex],c=n.piece,h=this.u(c.bufferIndex,c.start),t=this.u(c.bufferIndex,c.end);return o.buffer.substring(h,t)}getPieceContent(n){const o=this.a[n.bufferIndex],c=this.u(n.bufferIndex,n.start),h=this.u(n.bufferIndex,n.end);return o.buffer.substring(c,h)}S(n,o){const c=new L.$SB(o,1);if(c.left=L.$TB,c.right=L.$TB,c.parent=L.$TB,c.size_left=0,c.lf_left=0,this.root===L.$TB)this.root=c,c.color=0;else if(n.right===L.$TB)n.right=c,c.parent=n;else{const t=(0,L.$UB)(n.right);t.left=c,c.parent=t}return(0,L.$ZB)(this,c),c}T(n,o){const c=new L.$SB(o,1);if(c.left=L.$TB,c.right=L.$TB,c.parent=L.$TB,c.size_left=0,c.lf_left=0,this.root===L.$TB)this.root=c,c.color=0;else if(n.left===L.$TB)n.left=c,c.parent=n;else{const h=(0,L.$VB)(n.left);h.right=c,c.parent=h}return(0,L.$ZB)(this,c),c}U(n){let o="";return this.iterate(n,c=>(o+=this.R(c),!0)),o}}e.$aC=a}),define(Pe[132],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$k8=e.$j8=void 0;class y{constructor(){this.a=new Map}removeDragOperationTransfer(L){if(L&&this.a.has(L)){const R=this.a.get(L);return this.a.delete(L),R}}addDragOperationTransfer(L,R){this.a.set(L,R)}}e.$j8=y;class T{constructor(L){this.identifier=L}}e.$k8=T}),define(Pe[133],Re([9,10]),function(ge,e){return ge.create("vs/base/common/actions",e)}),define(Pe[134],Re([1,0,5,6,133]),function(ge,e,y,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=void 0;class L extends T.$Tc{constructor(l,p="",w="",s=!0,a){super(),this.h=this.B(new y.$Vd),this.onDidChange=this.h.event,this.w=!0,this.j=l,this.m=p,this.u=w,this.w=s,this.C=a}get id(){return this.j}get label(){return this.m}set label(l){this.D(l)}D(l){this.m!==l&&(this.m=l,this.h.fire({label:l}))}get tooltip(){return this.n||""}set tooltip(l){this.F(l)}F(l){this.n!==l&&(this.n=l,this.h.fire({tooltip:l}))}get class(){return this.u}set class(l){this.G(l)}G(l){this.u!==l&&(this.u=l,this.h.fire({class:l}))}get enabled(){return this.w}set enabled(l){this.H(l)}H(l){this.w!==l&&(this.w=l,this.h.fire({enabled:l}))}get checked(){return this.z}set checked(l){this.I(l)}I(l){this.z!==l&&(this.z=l,this.h.fire({checked:l}))}async run(l,p){this.C&&await this.C(l)}}e.$Ki=L;class R extends T.$Tc{constructor(){super(...arguments),this.f=this.B(new y.$Vd),this.onWillRun=this.f.event,this.m=this.B(new y.$Vd),this.onDidRun=this.m.event}async run(l,p){if(!l.enabled)return;this.f.fire({action:l});let w;try{await this.u(l,p)}catch(s){w=s}this.m.fire({action:l,error:w})}async u(l,p){await l.run(p)}}e.$Li=R;class ${constructor(){this.id=$.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...l){let p=[];for(const w of l)w.length&&(p.length?p=[...p,new $,...w]:p=w);return p}static{this.ID="vs.actions.separator"}async run(){}}e.$Mi=$;class f{get actions(){return this.a}constructor(l,p,w,s){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=l,this.label=p,this.class=s,this.a=w}async run(){}}e.$Ni=f;class b extends L{static{this.ID="vs.actions.empty"}constructor(){super(b.ID,C.localize(0,null),void 0,!1)}}e.$Oi=b;function A(k){return{id:k.id,label:k.label,class:k.class,enabled:k.enabled??!0,checked:k.checked??!1,run:async(...l)=>k.run(...l),tooltip:k.label}}e.$Pi=A}),define(Pe[135],Re([9,10]),function(ge,e){return ge.create("vs/base/common/date",e)}),define(Pe[136],Re([1,0,135]),function(ge,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wm=e.$vm=void 0;const T=60,C=T*60,L=C*24,R=L*7,$=L*30,f=L*365;function b(k,l,p,w){typeof k!="number"&&(k=k.getTime());const s=Math.round((new Date().getTime()-k)/1e3);if(s<-30)return(0,y.localize)(0,null,b(new Date().getTime()+s*1e3,!1));if(!w&&s<30)return(0,y.localize)(1,null);let a;return s<T?(a=s,l?a===1?p?(0,y.localize)(2,null,a):(0,y.localize)(3,null,a):p?(0,y.localize)(4,null,a):(0,y.localize)(5,null,a):a===1?p?(0,y.localize)(6,null,a):(0,y.localize)(7,null,a):p?(0,y.localize)(8,null,a):(0,y.localize)(9,null,a)):s<C?(a=Math.floor(s/T),l?a===1?p?(0,y.localize)(10,null,a):(0,y.localize)(11,null,a):p?(0,y.localize)(12,null,a):(0,y.localize)(13,null,a):a===1?p?(0,y.localize)(14,null,a):(0,y.localize)(15,null,a):p?(0,y.localize)(16,null,a):(0,y.localize)(17,null,a)):s<L?(a=Math.floor(s/C),l?a===1?p?(0,y.localize)(18,null,a):(0,y.localize)(19,null,a):p?(0,y.localize)(20,null,a):(0,y.localize)(21,null,a):a===1?p?(0,y.localize)(22,null,a):(0,y.localize)(23,null,a):p?(0,y.localize)(24,null,a):(0,y.localize)(25,null,a)):s<R?(a=Math.floor(s/L),l?a===1?(0,y.localize)(26,null,a):(0,y.localize)(27,null,a):a===1?(0,y.localize)(28,null,a):(0,y.localize)(29,null,a)):s<$?(a=Math.floor(s/R),l?a===1?p?(0,y.localize)(30,null,a):(0,y.localize)(31,null,a):p?(0,y.localize)(32,null,a):(0,y.localize)(33,null,a):a===1?p?(0,y.localize)(34,null,a):(0,y.localize)(35,null,a):p?(0,y.localize)(36,null,a):(0,y.localize)(37,null,a)):s<f?(a=Math.floor(s/$),l?a===1?p?(0,y.localize)(38,null,a):(0,y.localize)(39,null,a):p?(0,y.localize)(40,null,a):(0,y.localize)(41,null,a):a===1?p?(0,y.localize)(42,null,a):(0,y.localize)(43,null,a):p?(0,y.localize)(44,null,a):(0,y.localize)(45,null,a)):(a=Math.floor(s/f),l?a===1?p?(0,y.localize)(46,null,a):(0,y.localize)(47,null,a):p?(0,y.localize)(48,null,a):(0,y.localize)(49,null,a):a===1?p?(0,y.localize)(50,null,a):(0,y.localize)(51,null,a):p?(0,y.localize)(52,null,a):(0,y.localize)(53,null,a))}e.$vm=b;function A(k){return k.getFullYear()+"-"+String(k.getMonth()+1).padStart(2,"0")+"-"+String(k.getDate()).padStart(2,"0")+"T"+String(k.getHours()).padStart(2,"0")+":"+String(k.getMinutes()).padStart(2,"0")+":"+String(k.getSeconds()).padStart(2,"0")+"."+(k.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$wm=A}),define(Pe[137],Re([9,10]),function(ge,e){return ge.create("vs/base/common/errorMessage",e)}),define(Pe[40],Re([1,0,18,16,137]),function(ge,e,y,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Si=e.$Ri=e.$Qi=void 0;function L(k,l){return l&&(k.stack||k.stacktrace)?C.localize(0,null,$(k),R(k.stack)||R(k.stacktrace)):$(k)}function R(k){return Array.isArray(k)?k.join(`
`):k}function $(k){return k.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${k.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?C.localize(1,null,k.message):k.message||C.localize(2,null)}function f(k=null,l=!1){if(!k)return C.localize(3,null);if(Array.isArray(k)){const p=y.$Hb(k),w=f(p[0],l);return p.length>1?C.localize(4,null,w,p.length):w}if(T.$If(k))return k;if(k.detail){const p=k.detail;if(p.error)return L(p.error,l);if(p.exception)return L(p.exception,l)}return k.stack?L(k,l):k.message?k.message:C.localize(5,null)}e.$Qi=f;function b(k){const l=k;return l instanceof Error&&Array.isArray(l.actions)}e.$Ri=b;function A(k,l){let p;return typeof k=="string"?p=new Error(k):p=k,p.actions=l,p}e.$Si=A}),define(Pe[138],Re([1,0,39,19]),function(ge,e,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uq=e.$Tq=e.$Sq=e.$Rq=e.$Qq=e.$Pq=e.$Oq=e.$Nq=e.$Mq=e.$Lq=e.$Kq=e.$Jq=e.$Iq=void 0;const C=new y.$V(()=>{const M=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:M,collatorIsNumeric:M.resolvedOptions().numeric}}),L=new y.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),R=new y.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function $(M,v,E=!1){const D=M||"",N=v||"",O=C.value.collator.compare(D,N);return C.value.collatorIsNumeric&&O===0&&D!==N?D<N?-1:1:O}e.$Iq=$;function f(M,v){const E=L.value.collator;return M=M||"",v=v||"",c(E,M,v)}e.$Jq=f;function b(M,v){const E=L.value.collator;return M=M||"",v=v||"",i(M,v)||c(E,M,v)}e.$Kq=b;function A(M,v){const E=L.value.collator;return M=M||"",v=v||"",u(M,v)||c(E,M,v)}e.$Lq=A;function k(M,v){return M=M||"",v=v||"",M===v?0:M<v?-1:1}e.$Mq=k;function l(M,v){const[E,D]=n(M),[N,O]=n(v);let G=C.value.collator.compare(D,O);if(G===0){if(C.value.collatorIsNumeric&&D!==O)return D<O?-1:1;if(G=C.value.collator.compare(E,N),C.value.collatorIsNumeric&&G===0&&E!==N)return E<N?-1:1}return G}e.$Nq=l;function p(M,v){M=M||"",v=v||"";const E=o(M),D=o(v),N=L.value.collator,O=R.value.collator;return c(O,E,D)||c(N,M,v)}e.$Oq=p;function w(M,v){M=M||"",v=v||"";const E=o(M),D=o(v),N=L.value.collator,O=R.value.collator;return c(O,E,D)||i(M,v)||c(N,M,v)}e.$Pq=w;function s(M,v){M=M||"",v=v||"";const E=o(M),D=o(v),N=L.value.collator,O=R.value.collator;return c(O,E,D)||u(M,v)||c(N,M,v)}e.$Qq=s;function a(M,v){M=M||"",v=v||"";const E=o(M).toLowerCase(),D=o(v).toLowerCase();return E!==D?E<D?-1:1:M!==v?M<v?-1:1:0}e.$Rq=a;const r=/^(.*?)(\.([^.]*))?$/;function n(M,v=!1){const E=M?r.exec(M):[];let D=[E&&E[1]||"",E&&E[3]||""];return v&&(!D[0]&&D[1]||D[0]&&D[0].charAt(0)===".")&&(D=[D[0]+"."+D[1],""]),D}function o(M){const v=M?r.exec(M):[];return v&&v[1]&&v[1].charAt(0)!=="."&&v[3]||""}function c(M,v,E){const D=M.compare(v,E);return D!==0?D:v.length!==E.length?v.length<E.length?-1:1:0}function h(M){const v=M.charAt(0);return v.toLocaleUpperCase()!==v}function t(M){const v=M.charAt(0);return v.toLocaleLowerCase()!==v}function u(M,v){return h(M)&&t(v)?-1:t(M)&&h(v)?1:0}function i(M,v){return t(M)&&h(v)?-1:h(M)&&t(v)?1:0}function g(M,v,E=!1){return E||(M=M&&M.toLowerCase(),v=v&&v.toLowerCase()),M===v?0:M<v?-1:1}function m(M,v,E=!1){const D=M.split(T.sep),N=v.split(T.sep),O=D.length-1,G=N.length-1;let W,z;for(let P=0;;P++){if(W=O===P,z=G===P,W&&z)return $(D[P],N[P],E);if(W)return-1;if(z)return 1;const I=g(D[P],N[P],E);if(I!==0)return I}}e.$Sq=m;function d(M,v,E){const D=M.toLowerCase(),N=v.toLowerCase(),O=S(M,v,E);if(O)return O;const G=D.endsWith(E),W=N.endsWith(E);if(G!==W)return G?-1:1;const z=$(D,N);return z!==0?z:D.localeCompare(N)}e.$Tq=d;function S(M,v,E){const D=M.toLowerCase(),N=v.toLowerCase(),O=D.startsWith(E),G=N.startsWith(E);if(O!==G)return O?-1:1;if(O&&G){if(D.length<N.length)return-1;if(D.length>N.length)return 1}return 0}e.$Uq=S}),define(Pe[45],Re([1,0,19,21,11,16]),function(ge,e,y,T,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=void 0;function R(d){return d===47||d===92}e.$1f=R;function $(d){return d.replace(/[\\/]/g,y.$gc.sep)}e.$2f=$;function f(d){return d.indexOf("/")===-1&&(d=$(d)),/^[a-zA-Z]:(\/|$)/.test(d)&&(d="/"+d),d}e.$3f=f;function b(d,S=y.$gc.sep){if(!d)return"";const M=d.length,v=d.charCodeAt(0);if(R(v)){if(R(d.charCodeAt(1))&&!R(d.charCodeAt(2))){let D=3;const N=D;for(;D<M&&!R(d.charCodeAt(D));D++);if(N!==D&&!R(d.charCodeAt(D+1))){for(D+=1;D<M;D++)if(R(d.charCodeAt(D)))return d.slice(0,D+1).replace(/[\\/]/g,S)}}return S}else if(r(v)&&d.charCodeAt(1)===58)return R(d.charCodeAt(2))?d.slice(0,2)+S:d.slice(0,2);let E=d.indexOf("://");if(E!==-1){for(E+=3;E<M;E++)if(R(d.charCodeAt(E)))return d.slice(0,E+1)}return""}e.$4f=b;function A(d){if(!T.$i||!d||d.length<5)return!1;let S=d.charCodeAt(0);if(S!==92||(S=d.charCodeAt(1),S!==92))return!1;let M=2;const v=M;for(;M<d.length&&(S=d.charCodeAt(M),S!==92);M++);return!(v===M||(S=d.charCodeAt(M+1),isNaN(S)||S===92))}e.$5f=A;const k=/[\\/:\*\?"<>\|]/g,l=/[\\/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function w(d,S=T.$i){const M=S?k:l;return!(!d||d.length===0||/^\s+$/.test(d)||(M.lastIndex=0,M.test(d))||S&&p.test(d)||d==="."||d===".."||S&&d[d.length-1]==="."||S&&d.length!==d.trim().length||d.length>255)}e.$6f=w;function s(d,S,M){const v=d===S;return!M||v?v:!d||!S?!1:(0,C.$_e)(d,S)}e.$7f=s;function a(d,S,M,v=y.sep){if(d===S)return!0;if(!d||!S||S.length>d.length)return!1;if(M){if(!(0,C.$af)(d,S))return!1;if(S.length===d.length)return!0;let D=S.length;return S.charAt(S.length-1)===v&&D--,d.charAt(D)===v}return S.charAt(S.length-1)!==v&&(S+=v),d.indexOf(S)===0}e.$8f=a;function r(d){return d>=65&&d<=90||d>=97&&d<=122}e.$9f=r;function n(d,S){return T.$i&&d.endsWith(":")&&(d+=y.sep),(0,y.$ic)(d)||(d=(0,y.$jc)(S,d)),d=(0,y.$hc)(d),T.$i?(d=(0,C.$Ue)(d,y.sep),d.endsWith(":")&&(d+=y.sep)):(d=(0,C.$Ue)(d,y.sep),d||(d=y.sep)),d}e.$0f=n;function o(d){const S=(0,y.$hc)(d);return T.$i?d.length>3?!1:c(S)&&(d.length===2||S.charCodeAt(2)===92):S===y.$gc.sep}e.$$f=o;function c(d,S=T.$i){return S?r(d.charCodeAt(0))&&d.charCodeAt(1)===58:!1}e.$_f=c;function h(d,S=T.$i){return c(d,S)?d[0]:void 0}e.$ag=h;function t(d,S,M){return S.length>d.length?-1:d===S?0:(M&&(d=d.toLowerCase(),S=S.toLowerCase()),d.indexOf(S))}e.$bg=t;function u(d){const S=d.split(":");let M,v,E;for(const D of S){const N=Number(D);(0,L.$Mf)(N)?v===void 0?v=N:E===void 0&&(E=N):M=M?[M,D].join(":"):D}if(!M)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:M,line:v!==void 0?v:void 0,column:E!==void 0?E:v!==void 0?1:void 0}}e.$cg=u;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",g="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function m(d,S,M=8){let v="";for(let D=0;D<M;D++){let N;D===0&&T.$i&&!S&&(M===3||M===4)?N=g:N=i,v+=N.charAt(Math.floor(Math.random()*N.length))}let E;return S?E=`${S}-${v}`:E=v,d?(0,y.$jc)(d,E):E}e.$dg=m}),define(Pe[68],Re([1,0,19]),function(ge,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$js=e.$is=e.$hs=e.$gs=e.$fs=void 0,e.$fs=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const T={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},C={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function L(A){const k=(0,y.$oc)(A),l=T[k.toLowerCase()];return l!==void 0?l:R(A)}e.$gs=L;function R(A){const k=(0,y.$oc)(A);return C[k.toLowerCase()]}e.$hs=R;function $(A){for(const k in C)if(C[k]===A)return k}e.$is=$;const f=/^(.+)\/(.+?)(;.+)?$/;function b(A,k){const l=f.exec(A);return l?`${l[1].toLowerCase()}/${l[2].toLowerCase()}${l[3]??""}`:k?void 0:A}e.$js=b}),define(Pe[51],Re([1,0,24,2]),function(ge,e,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ch=e.$Bh=e.$Ah=void 0;function C(f){return JSON.stringify(f,R)}e.$Ah=C;function L(f){let b=JSON.parse(f);return b=$(b),b}e.$Bh=L;function R(f,b){return b instanceof RegExp?{$mid:2,source:b.source,flags:b.flags}:b}function $(f,b=0){if(!f||b>200)return f;if(typeof f=="object"){switch(f.$mid){case 1:return T.URI.revive(f);case 2:return new RegExp(f.source,f.flags);case 17:return new Date(f.source)}if(f instanceof y.$je||f instanceof Uint8Array)return f;if(Array.isArray(f))for(let A=0;A<f.length;++A)f[A]=$(f[A],b+1);else for(const A in f)Object.hasOwnProperty.call(f,A)&&(f[A]=$(f[A],b+1))}return f}e.$Ch=$}),define(Pe[12],Re([1,0,15,21,11,2]),function(ge,e,y,T,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.Schemas=void 0;var R;(function(l){l.inMemory="inmemory",l.vscode="vscode",l.internal="private",l.walkThrough="walkThrough",l.walkThroughSnippet="walkThroughSnippet",l.http="http",l.https="https",l.file="file",l.mailto="mailto",l.untitled="untitled",l.data="data",l.command="command",l.vscodeRemote="vscode-remote",l.vscodeRemoteResource="vscode-remote-resource",l.vscodeManagedRemoteResource="vscode-managed-remote-resource",l.vscodeUserData="vscode-userdata",l.vscodeCustomEditor="vscode-custom-editor",l.vscodeNotebookCell="vscode-notebook-cell",l.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",l.vscodeNotebookCellOutput="vscode-notebook-cell-output",l.vscodeInteractiveInput="vscode-interactive-input",l.vscodeSettings="vscode-settings",l.vscodeWorkspaceTrust="vscode-workspace-trust",l.vscodeTerminal="vscode-terminal",l.vscodeChatSesssion="vscode-chat-editor",l.webviewPanel="webview-panel",l.vscodeWebview="vscode-webview",l.extension="extension",l.vscodeFileResource="vscode-file",l.tmp="tmp",l.vsls="vsls",l.vscodeSourceControl="vscode-scm"})(R||(e.Schemas=R={}));function $(l,p){return L.URI.isUri(l)?(0,C.$_e)(l.scheme,p):(0,C.$af)(l,p+":")}e.$eg=$;function f(l,...p){return p.some(w=>$(l,w))}e.$fg=f,e.$gg="vscode-tkn",e.$hg="tkn";class b{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${R.vscodeRemoteResource}`}setPreferredWebSchema(p){this.d=p}setDelegate(p){this.e=p}setServerRootPath(p){this.f=`${p}/${R.vscodeRemoteResource}`}set(p,w,s){this.a[p]=w,this.b[p]=s}setConnectionToken(p,w){this.c[p]=w}getPreferredWebSchema(){return this.d}rewrite(p){if(this.e)try{return this.e(p)}catch(o){return y.$1(o),p}const w=p.authority;let s=this.a[w];s&&s.indexOf(":")!==-1&&s.indexOf("[")===-1&&(s=`[${s}]`);const a=this.b[w],r=this.c[w];let n=`path=${encodeURIComponent(p.path)}`;return typeof r=="string"&&(n+=`&${e.$hg}=${encodeURIComponent(r)}`),L.URI.from({scheme:T.$o?this.d:R.vscodeRemoteResource,authority:`${s}:${a}`,path:this.f,query:n})}}e.$ig=new b,e.$jg="vs/../../extensions",e.$kg="vs/../../node_modules",e.$lg="vs/../../node_modules.asar",e.$mg="vs/../../node_modules.asar.unpacked",e.$ng="vscode-app";class A{static{this.a=e.$ng}asBrowserUri(p){const w=this.b(p,ge);return this.uriToBrowserUri(w)}uriToBrowserUri(p){return p.scheme===R.vscodeRemote?e.$ig.rewrite(p):p.scheme===R.file&&(T.$m||T.$q===`${R.vscodeFileResource}://${A.a}`)?p.with({scheme:R.vscodeFileResource,authority:p.authority||A.a,query:null,fragment:null}):p}asFileUri(p){const w=this.b(p,ge);return this.uriToFileUri(w)}uriToFileUri(p){return p.scheme===R.vscodeFileResource?p.with({scheme:R.file,authority:p.authority!==A.a?p.authority:null,query:null,fragment:null}):p}b(p,w){return L.URI.isUri(p)?p:L.URI.parse(w.toUrl(p))}}e.$og=new A;var k;(function(l){const p=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);l.CoopAndCoep=Object.freeze(p.get("3"));const w="vscode-coi";function s(r){let n;typeof r=="string"?n=new URL(r).searchParams:r instanceof URL?n=r.searchParams:L.URI.isUri(r)&&(n=new URL(r.toString(!0)).searchParams);const o=n?.get(w);if(o)return p.get(o)}l.getHeadersFromQuery=s;function a(r,n,o){if(!globalThis.crossOriginIsolated)return;const c=n&&o?"3":o?"2":"1";r instanceof URLSearchParams?r.set(w,c):r[w]=c}l.addSearchParam=a})(k||(e.COI=k={}))}),define(Pe[25],Re([1,0,45,12,19,21,11,2]),function(ge,e,y,T,C,L,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rg=e.DataUri=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=void 0;function f(p){return(0,$.$wc)(p,!0)}e.$vg=f;class b{constructor(w){this.a=w}compare(w,s,a=!1){return w===s?0:(0,R.$5e)(this.getComparisonKey(w,a),this.getComparisonKey(s,a))}isEqual(w,s,a=!1){return w===s?!0:!w||!s?!1:this.getComparisonKey(w,a)===this.getComparisonKey(s,a)}getComparisonKey(w,s=!1){return w.with({path:this.a(w)?w.path.toLowerCase():void 0,fragment:s?null:void 0}).toString()}ignorePathCasing(w){return this.a(w)}isEqualOrParent(w,s,a=!1){if(w.scheme===s.scheme){if(w.scheme===T.Schemas.file)return y.$8f(f(w),f(s),this.a(w))&&w.query===s.query&&(a||w.fragment===s.fragment);if((0,e.$Mg)(w.authority,s.authority))return y.$8f(w.path,s.path,this.a(w),"/")&&w.query===s.query&&(a||w.fragment===s.fragment)}return!1}joinPath(w,...s){return $.URI.joinPath(w,...s)}basenameOrAuthority(w){return(0,e.$Eg)(w)||w.authority}basename(w){return C.$gc.basename(w.path)}extname(w){return C.$gc.extname(w.path)}dirname(w){if(w.path.length===0)return w;let s;return w.scheme===T.Schemas.file?s=$.URI.file(C.$mc(f(w))).path:(s=C.$gc.dirname(w.path),w.authority&&s.length&&s.charCodeAt(0)!==47&&(console.error(`dirname("${w.toString})) resulted in a relative path`),s="/")),w.with({path:s})}normalizePath(w){if(!w.path.length)return w;let s;return w.scheme===T.Schemas.file?s=$.URI.file(C.$hc(f(w))).path:s=C.$gc.normalize(w.path),w.with({path:s})}relativePath(w,s){if(w.scheme!==s.scheme||!(0,e.$Mg)(w.authority,s.authority))return;if(w.scheme===T.Schemas.file){const n=C.$lc(f(w),f(s));return L.$i?y.$2f(n):n}let a=w.path||"/";const r=s.path||"/";if(this.a(w)){let n=0;for(const o=Math.min(a.length,r.length);n<o&&!(a.charCodeAt(n)!==r.charCodeAt(n)&&a.charAt(n).toLowerCase()!==r.charAt(n).toLowerCase());n++);a=r.substr(0,n)+a.substr(n)}return C.$gc.relative(a,r)}resolvePath(w,s){if(w.scheme===T.Schemas.file){const a=$.URI.file(C.$kc(f(w),s));return w.with({authority:a.authority,path:a.path})}return s=y.$3f(s),w.with({path:C.$gc.resolve(w.path,s)})}isAbsolutePath(w){return!!w.path&&w.path[0]==="/"}isEqualAuthority(w,s){return w===s||w!==void 0&&s!==void 0&&(0,R.$_e)(w,s)}hasTrailingPathSeparator(w,s=C.sep){if(w.scheme===T.Schemas.file){const a=f(w);return a.length>y.$4f(a).length&&a[a.length-1]===s}else{const a=w.path;return a.length>1&&a.charCodeAt(a.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(w.fsPath)}}removeTrailingPathSeparator(w,s=C.sep){return(0,e.$Ng)(w,s)?w.with({path:w.path.substr(0,w.path.length-1)}):w}addTrailingPathSeparator(w,s=C.sep){let a=!1;if(w.scheme===T.Schemas.file){const r=f(w);a=r!==void 0&&r.length===y.$4f(r).length&&r[r.length-1]===s}else{s="/";const r=w.path;a=r.length===1&&r.charCodeAt(r.length-1)===47}return!a&&!(0,e.$Ng)(w,s)?w.with({path:w.path+"/"}):w}}e.$wg=b,e.$xg=new b(()=>!1),e.$yg=new b(p=>p.scheme===T.Schemas.file?!L.$k:!0),e.$zg=new b(p=>!0),e.$Ag=e.$xg.isEqual.bind(e.$xg),e.$Bg=e.$xg.isEqualOrParent.bind(e.$xg),e.$Cg=e.$xg.getComparisonKey.bind(e.$xg),e.$Dg=e.$xg.basenameOrAuthority.bind(e.$xg),e.$Eg=e.$xg.basename.bind(e.$xg),e.$Fg=e.$xg.extname.bind(e.$xg),e.$Gg=e.$xg.dirname.bind(e.$xg),e.$Hg=e.$xg.joinPath.bind(e.$xg),e.$Ig=e.$xg.normalizePath.bind(e.$xg),e.$Jg=e.$xg.relativePath.bind(e.$xg),e.$Kg=e.$xg.resolvePath.bind(e.$xg),e.$Lg=e.$xg.isAbsolutePath.bind(e.$xg),e.$Mg=e.$xg.isEqualAuthority.bind(e.$xg),e.$Ng=e.$xg.hasTrailingPathSeparator.bind(e.$xg),e.$Og=e.$xg.removeTrailingPathSeparator.bind(e.$xg),e.$Pg=e.$xg.addTrailingPathSeparator.bind(e.$xg);function A(p,w){const s=[];for(let a=0;a<p.length;a++){const r=w(p[a]);p.some((n,o)=>o===a?!1:(0,e.$Bg)(r,w(n)))||s.push(p[a])}return s}e.$Qg=A;var k;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function w(s){const a=new Map;s.path.substring(s.path.indexOf(";")+1,s.path.lastIndexOf(";")).split(";").forEach(o=>{const[c,h]=o.split(":");c&&h&&a.set(c,h)});const n=s.path.substring(0,s.path.indexOf(";"));return n&&a.set(p.META_DATA_MIME,n),a}p.parseMetaData=w})(k||(e.DataUri=k={}));function l(p,w,s){if(w){let a=p.path;return a&&a[0]!==C.$gc.sep&&(a=C.$gc.sep+a),p.with({scheme:s,authority:w,path:a})}return p.with({scheme:s})}e.$Rg=l}),define(Pe[13],Re([1,0,20,15,5,6,25,21,125,39]),function(ge,e,y,T,C,L,R,$,f,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.Promises=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=void 0;function A(ce){return!!ce&&typeof ce.then=="function"}e.$Sg=A;function k(ce){const te=new y.$6d,Q=ce(te.token),ee=new Promise((me,pe)=>{const Ae=te.token.onCancellationRequested(()=>{Ae.dispose(),pe(new T.$5)});Promise.resolve(Q).then(he=>{Ae.dispose(),te.dispose(),me(he)},he=>{Ae.dispose(),te.dispose(),pe(he)})});return new class{cancel(){te.cancel(),te.dispose()}then(me,pe){return ee.then(me,pe)}catch(me){return this.then(void 0,me)}finally(me){return ee.finally(me)}}}e.$Tg=k;function l(ce,te,Q){return new Promise((ee,me)=>{const pe=te.onCancellationRequested(()=>{pe.dispose(),ee(Q)});ce.then(ee,me).finally(()=>pe.dispose())})}e.$Ug=l;function p(ce,te){return new Promise((Q,ee)=>{const me=te.onCancellationRequested(()=>{me.dispose(),ee(new T.$5)});ce.then(Q,ee).finally(()=>me.dispose())})}e.$Vg=p;async function w(ce){let te=-1;const Q=ce.map((ee,me)=>ee.then(pe=>(te=me,pe)));try{return await Promise.race(Q)}finally{ce.forEach((ee,me)=>{me!==te&&ee.cancel()})}}e.$Wg=w;function s(ce,te,Q){let ee;const me=setTimeout(()=>{ee?.(void 0),Q?.()},te);return Promise.race([ce.finally(()=>clearTimeout(me)),new Promise(pe=>ee=pe)])}e.$Xg=s;function a(ce){return new Promise((te,Q)=>{const ee=ce();A(ee)?ee.then(te,Q):te(ee)})}e.$Yg=a;class r{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(te){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=te,!this.b){const Q=()=>{if(this.b=null,this.f)return;const ee=this.queue(this.d);return this.d=null,ee};this.b=new Promise(ee=>{this.a.then(Q,Q).then(ee)})}return new Promise((Q,ee)=>{this.b.then(Q,ee)})}return this.a=te(),new Promise((Q,ee)=>{this.a.then(me=>{this.a=null,Q(me)},me=>{this.a=null,ee(me)})})}dispose(){this.f=!0}}e.$Zg=r;class n{constructor(){this.a=Promise.resolve(null)}queue(te){return this.a=this.a.then(()=>te(),()=>te())}}e.$1g=n;class o{constructor(){this.a=new Map}queue(te,Q){const me=(this.a.get(te)??Promise.resolve()).catch(()=>{}).then(Q).finally(()=>{this.a.get(te)===me&&this.a.delete(te)});return this.a.set(te,me),me}}e.$2g=o;const c=(ce,te)=>{let Q=!0;const ee=setTimeout(()=>{Q=!1,te()},ce);return{isTriggered:()=>Q,dispose:()=>{clearTimeout(ee),Q=!1}}},h=ce=>{let te=!0;return queueMicrotask(()=>{te&&(te=!1,ce())}),{isTriggered:()=>te,dispose:()=>{te=!1}}};class t{constructor(te){this.defaultDelay=te,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(te,Q=this.defaultDelay){this.g=te,this.h(),this.b||(this.b=new Promise((me,pe)=>{this.d=me,this.f=pe}).then(()=>{if(this.b=null,this.d=null,this.g){const me=this.g;return this.g=null,me()}}));const ee=()=>{this.a=null,this.d?.(null)};return this.a=Q===f.$Sd?h(ee):c(Q,ee),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new T.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$3g=t;class u{constructor(te){this.a=new t(te),this.b=new r}trigger(te,Q){return this.a.trigger(()=>this.b.queue(te),Q)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$4g=u;class i{constructor(){this.a=!1,this.b=new Promise((te,Q)=>{this.d=te})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$5g=i;class g extends i{constructor(te){super(),this.f=setTimeout(()=>this.open(),te)}open(){clearTimeout(this.f),super.open()}}e.$6g=g;function m(ce,te){return te?new Promise((Q,ee)=>{const me=setTimeout(()=>{pe.dispose(),Q()},ce),pe=te.onCancellationRequested(()=>{clearTimeout(me),pe.dispose(),ee(new T.$5)})}):k(Q=>m(ce,Q))}e.$7g=m;function d(ce,te=0,Q){const ee=setTimeout(()=>{ce(),Q&&me.dispose()},te),me=(0,L.$Rc)(()=>{clearTimeout(ee),Q?.deleteAndLeak(me)});return Q?.add(me),me}e.$8g=d;function S(ce){const te=[];let Q=0;const ee=ce.length;function me(){return Q<ee?ce[Q++]():null}function pe(Ae){Ae!=null&&te.push(Ae);const he=me();return he?he.then(pe):Promise.resolve(te)}return Promise.resolve(null).then(pe)}e.$9g=S;function M(ce,te=ee=>!!ee,Q=null){let ee=0;const me=ce.length,pe=()=>{if(ee>=me)return Promise.resolve(Q);const Ae=ce[ee++];return Promise.resolve(Ae()).then(ye=>te(ye)?Promise.resolve(ye):pe())};return pe()}e.$0g=M;function v(ce,te=ee=>!!ee,Q=null){if(ce.length===0)return Promise.resolve(Q);let ee=ce.length;const me=()=>{ee=-1;for(const pe of ce)pe.cancel?.()};return new Promise((pe,Ae)=>{for(const he of ce)he.then(ye=>{--ee>=0&&te(ye)?(me(),pe(ye)):ee===0&&pe(Q)}).catch(ye=>{--ee>=0&&(me(),Ae(ye))})})}e.$$g=v;class E{constructor(te){this.a=0,this.b=!1,this.f=te,this.g=[],this.d=0,this.h=new C.$Vd}whenIdle(){return this.size>0?C.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(te){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((Q,ee)=>{this.g.push({factory:te,c:Q,e:ee}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const te=this.g.shift();this.d++;const Q=te.factory();Q.then(te.c,te.e),Q.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$_g=E;class D extends E{constructor(){super(1)}}e.$ah=D;class N{constructor(){this.a=new ke,this.b=0}queue(te){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,te())):this.a.run(this.b++,te())}}e.$bh=N;class O{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const te=new se;return this.b.add(te),te.p}g(){for(const[,te]of this.a)if(te.size>0)return!1;return!0}queueSize(te,Q=R.$xg){const ee=Q.getComparisonKey(te);return this.a.get(ee)?.size??0}queueFor(te,Q,ee=R.$xg){const me=ee.getComparisonKey(te);let pe=this.a.get(me);if(!pe){pe=new D;const Ae=this.f++,he=C.Event.once(pe.onDrained)(()=>{pe?.dispose(),this.a.delete(me),this.h(),this.d?.deleteAndDispose(Ae),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new L.$3c),this.d.set(Ae,he),this.a.set(me,pe)}return pe.queue(Q)}h(){this.g()&&this.j()}j(){for(const te of this.b)te.complete();this.b.clear()}dispose(){for(const[,te]of this.a)te.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$ch=O;class G{constructor(te,Q){this.a=-1,typeof te=="function"&&typeof Q=="number"&&this.setIfNotSet(te,Q)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(te,Q){this.cancel(),this.a=setTimeout(()=>{this.a=-1,te()},Q)}setIfNotSet(te,Q){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,te()},Q))}}e.$dh=G;class W{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(te,Q,ee=globalThis){this.cancel();const me=ee.setInterval(()=>{te()},Q);this.d=(0,L.$Rc)(()=>{ee.clearInterval(me),this.d=void 0})}dispose(){this.cancel()}}e.$eh=W;class z{constructor(te,Q){this.b=-1,this.a=te,this.d=Q,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(te=this.d){this.cancel(),this.b=setTimeout(this.f,te)}get delay(){return this.d}set delay(te){this.d=te}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$fh=z;class P{constructor(te,Q){Q%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Q}ms is not a multiple of 1000ms.`),this.a=te,this.b=Q,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(te=this.b){te%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${te}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(te/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$gh=P;class I extends z{constructor(te,Q){super(te,Q),this.j=[]}work(te){this.j.push(te),this.isScheduled()||this.schedule()}h(){const te=this.j;this.j=[],this.a?.(te)}dispose(){this.j=[],super.dispose()}}e.$hh=I;class H extends L.$Tc{constructor(te,Q){super(),this.g=te,this.h=Q,this.a=[],this.b=this.B(new L.$Uc),this.f=!1}get pending(){return this.a.length}work(te){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+te.length>this.g.maxBufferedWork)return!1}else if(this.pending+te.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const Q of te)this.a.push(Q);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new z(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$ih=H,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$kh=(ce,te)=>{(0,$.$B)(()=>{if(Q)return;const ee=Date.now()+15;te(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ee-Date.now())}}))});let Q=!1;return{dispose(){Q||(Q=!0)}}}:e.$kh=(ce,te,Q)=>{const ee=ce.requestIdleCallback(te,typeof Q=="number"?{timeout:Q}:void 0);let me=!1;return{dispose(){me||(me=!0,ce.cancelIdleCallback(ee))}}},e.$jh=ce=>(0,e.$kh)(globalThis,ce)}();class ae{constructor(te,Q){this.g=!1,this.d=()=>{try{this.j=Q()}catch(ee){this.l=ee}finally{this.g=!0}},this.f=(0,e.$kh)(te,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$lh=ae;class de extends ae{constructor(te){super(globalThis,te)}}e.$mh=de;async function we(ce,te,Q){let ee;for(let me=0;me<Q;me++)try{return await ce()}catch(pe){ee=pe,await m(te)}throw ee}e.$nh=we;class ke{isRunning(te){return typeof te=="number"?this.a?.taskId===te:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(te,Q,ee){return this.a={taskId:te,cancel:()=>ee?.(),promise:Q},Q.then(()=>this.d(te),()=>this.d(te)),Q}d(te){this.a&&te===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const te=this.b;this.b=void 0,te.run().then(te.promiseResolve,te.promiseReject)}}queue(te){if(this.b)this.b.run=te;else{let Q,ee;const me=new Promise((pe,Ae)=>{Q=pe,ee=Ae});this.b={run:te,promise:me,promiseResolve:Q,promiseReject:ee}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$oh=ke;class le{constructor(te,Q=()=>Date.now()){this.d=te,this.f=Q,this.a=0,this.b=0}increment(){const te=this.f();return te-this.a>this.d&&(this.a=te,this.b=0),this.b++,this.b}}e.$ph=le;var ve;(function(ce){ce[ce.Resolved=0]="Resolved",ce[ce.Rejected=1]="Rejected"})(ve||(ve={}));class se{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((te,Q)=>{this.a=te,this.b=Q})}complete(te){return new Promise(Q=>{this.a(te),this.d={outcome:0,value:te},Q()})}error(te){return new Promise(Q=>{this.b(te),this.d={outcome:1,value:te},Q()})}cancel(){return this.error(new T.$5)}}e.$qh=se;var be;(function(ce){async function te(ee){let me;const pe=await Promise.all(ee.map(Ae=>Ae.then(he=>he,he=>{me||(me=he)})));if(typeof me<"u")throw me;return pe}ce.settled=te;function Q(ee){return new Promise(async(me,pe)=>{try{await ee(me,pe)}catch(Ae){pe(Ae)}})}ce.withAsyncBody=Q})(be||(e.Promises=be={}));class ne{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(te){this.a=void 0,this.b=void 0,this.d=!1,this.promise=te.then(Q=>(this.a=Q,this.d=!0,Q),Q=>{throw this.b=Q,this.d=!0,Q})}requireValue(){if(!this.d)throw new T.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$rh=ne;class Y{constructor(te){this.b=te,this.a=new b.$V(()=>new ne(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$sh=Y;var V;(function(ce){ce[ce.Initial=0]="Initial",ce[ce.DoneOK=1]="DoneOK",ce[ce.DoneError=2]="DoneError"})(V||(V={}));class ie{static fromArray(te){return new ie(Q=>{Q.emitMany(te)})}static fromPromise(te){return new ie(async Q=>{Q.emitMany(await te)})}static fromPromises(te){return new ie(async Q=>{await Promise.all(te.map(async ee=>Q.emitOne(await ee)))})}static merge(te){return new ie(async Q=>{await Promise.all(te.map(async ee=>{for await(const me of ee)Q.emitOne(me)}))})}static{this.EMPTY=ie.fromArray([])}constructor(te){this.a=0,this.b=[],this.d=null,this.f=new C.$Vd,queueMicrotask(async()=>{const Q={emitOne:ee=>this.g(ee),emitMany:ee=>this.h(ee),reject:ee=>this.k(ee)};try{await Promise.resolve(te(Q)),this.j()}catch(ee){this.k(ee)}finally{Q.emitOne=void 0,Q.emitMany=void 0,Q.reject=void 0}})}[Symbol.asyncIterator](){let te=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(te<this.b.length)return{done:!1,value:this.b[te++]};if(this.a===1)return{done:!0,value:void 0};await C.Event.toPromise(this.f.event)}while(!0)}}}static map(te,Q){return new ie(async ee=>{for await(const me of te)ee.emitOne(Q(me))})}map(te){return ie.map(this,te)}static filter(te,Q){return new ie(async ee=>{for await(const me of te)Q(me)&&ee.emitOne(me)})}filter(te){return ie.filter(this,te)}static coalesce(te){return ie.filter(te,Q=>!!Q)}coalesce(){return ie.coalesce(this)}static async toPromise(te){const Q=[];for await(const ee of te)Q.push(ee);return Q}toPromise(){return ie.toPromise(this)}g(te){this.a===0&&(this.b.push(te),this.f.fire())}h(te){this.a===0&&(this.b=this.b.concat(te),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(te){this.a===0&&(this.a=2,this.d=te,this.f.fire())}}e.$th=ie;class Ie extends ie{constructor(te,Q){super(Q),this.l=te}cancel(){this.l.cancel()}}e.$uh=Ie;function Le(ce){const te=new y.$6d,Q=ce(te.token);return new Ie(te,async ee=>{const me=te.token.onCancellationRequested(()=>{me.dispose(),te.dispose(),ee.reject(new T.$5)});try{for await(const pe of Q){if(te.token.isCancellationRequested)return;ee.emitOne(pe)}me.dispose(),te.dispose()}catch(pe){me.dispose(),te.dispose(),ee.reject(pe)}})}e.$vh=Le;class Ce{constructor(){this.a=new se,this.b=new ie(ee=>{if(te){ee.reject(te);return}return Q&&ee.emitMany(Q),this.d=me=>ee.reject(me),this.f=me=>ee.emitOne(me),this.a.p});let te,Q;this.f=ee=>{Q||(Q=[]),Q.push(ee)},this.d=ee=>{te||(te=ee)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(te){this.d(te),this.a.complete()}emitOne(te){this.f(te)}}e.$wh=Ce}),define(Pe[34],Re([1,0,18,13,45,28,19,21,11]),function(ge,e,y,T,C,L,R,$,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=void 0;function b(){return Object.create(null)}e.$Hj=b,e.$Ij="**",e.$Jj="/";const A="[/\\\\]",k="[^/\\\\]",l=/\//g;function p(de,we){switch(de){case 0:return"";case 1:return`${k}*?`;default:return`(?:${A}|${k}+${A}${we?`|${A}${k}+`:""})*?`}}function w(de,we){if(!de)return[];const ke=[];let le=!1,ve=!1,se="";for(const be of de){switch(be){case we:if(!le&&!ve){ke.push(se),se="";continue}break;case"{":le=!0;break;case"}":le=!1;break;case"[":ve=!0;break;case"]":ve=!1;break}se+=be}return se&&ke.push(se),ke}e.$Kj=w;function s(de){if(!de)return"";let we="";const ke=w(de,e.$Jj);if(ke.every(le=>le===e.$Ij))we=".*";else{let le=!1;ke.forEach((ve,se)=>{if(ve===e.$Ij){if(le)return;we+=p(2,se===ke.length-1)}else{let be=!1,ne="",Y=!1,V="";for(const ie of ve){if(ie!=="}"&&be){ne+=ie;continue}if(Y&&(ie!=="]"||!V)){let Ie;ie==="-"?Ie=ie:(ie==="^"||ie==="!")&&!V?Ie="^":ie===e.$Jj?Ie="":Ie=(0,f.$Oe)(ie),V+=Ie;continue}switch(ie){case"{":be=!0;continue;case"[":Y=!0;continue;case"}":{const Le=`(?:${w(ne,",").map(Ce=>s(Ce)).join("|")})`;we+=Le,be=!1,ne="";break}case"]":{we+="["+V+"]",Y=!1,V="";break}case"?":we+=k;continue;case"*":we+=p(1);continue;default:we+=(0,f.$Oe)(ie)}}se<ke.length-1&&(ke[se+1]!==e.$Ij||se+2<ke.length)&&(we+=A)}le=ve===e.$Ij})}return we}const a=/^\*\*\/\*\.[\w\.-]+$/,r=/^\*\*\/([\w\.-]+)\/?$/,n=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,o=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,h=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new L.$Dc(1e4),u=function(){return!1},i=function(){return null};function g(de,we){if(!de)return i;let ke;typeof de!="string"?ke=de.pattern:ke=de,ke=ke.trim();const le=`${ke}_${!!we.trimForExclusions}`;let ve=t.get(le);if(ve)return m(ve,de);let se;return a.test(ke)?ve=S(ke.substr(4),ke):(se=r.exec(d(ke,we)))?ve=M(se[1],ke):(we.trimForExclusions?o:n).test(ke)?ve=v(ke,we):(se=c.exec(d(ke,we)))?ve=E(se[1].substr(1),ke,!0):(se=h.exec(d(ke,we)))?ve=E(se[1],ke,!1):ve=D(ke),t.set(le,ve),m(ve,de)}function m(de,we){if(typeof we=="string")return de;const ke=function(le,ve){return(0,C.$8f)(le,we.base,!$.$k)?de((0,f.$Te)(le.substr(we.base.length),R.sep),ve):null};return ke.allBasenames=de.allBasenames,ke.allPaths=de.allPaths,ke.basenames=de.basenames,ke.patterns=de.patterns,ke}function d(de,we){return we.trimForExclusions&&de.endsWith("/**")?de.substr(0,de.length-2):de}function S(de,we){return function(ke,le){return typeof ke=="string"&&ke.endsWith(de)?we:null}}function M(de,we){const ke=`/${de}`,le=`\\${de}`,ve=function(be,ne){return typeof be!="string"?null:ne?ne===de?we:null:be===de||be.endsWith(ke)||be.endsWith(le)?we:null},se=[de];return ve.basenames=se,ve.patterns=[we],ve.allBasenames=se,ve}function v(de,we){const ke=H(de.slice(1,-1).split(",").map(ne=>g(ne,we)).filter(ne=>ne!==i),de),le=ke.length;if(!le)return i;if(le===1)return ke[0];const ve=function(ne,Y){for(let V=0,ie=ke.length;V<ie;V++)if(ke[V](ne,Y))return de;return null},se=ke.find(ne=>!!ne.allBasenames);se&&(ve.allBasenames=se.allBasenames);const be=ke.reduce((ne,Y)=>Y.allPaths?ne.concat(Y.allPaths):ne,[]);return be.length&&(ve.allPaths=be),ve}function E(de,we,ke){const le=R.sep===R.$gc.sep,ve=le?de:de.replace(l,R.sep),se=R.sep+ve,be=R.$gc.sep+de;let ne;return ke?ne=function(Y,V){return typeof Y=="string"&&(Y===ve||Y.endsWith(se)||!le&&(Y===de||Y.endsWith(be)))?we:null}:ne=function(Y,V){return typeof Y=="string"&&(Y===ve||!le&&Y===de)?we:null},ne.allPaths=[(ke?"*/":"./")+de],ne}function D(de){try{const we=new RegExp(`^${s(de)}$`);return function(ke){return we.lastIndex=0,typeof ke=="string"&&we.test(ke)?de:null}}catch{return i}}function N(de,we,ke){return!de||typeof we!="string"?!1:O(de)(we,void 0,ke)}e.$Lj=N;function O(de,we={}){if(!de)return u;if(typeof de=="string"||G(de)){const ke=g(de,we);if(ke===i)return u;const le=function(ve,se){return!!ke(ve,se)};return ke.allBasenames&&(le.allBasenames=ke.allBasenames),ke.allPaths&&(le.allPaths=ke.allPaths),le}return P(de,we)}e.$Mj=O;function G(de){const we=de;return we?typeof we.base=="string"&&typeof we.pattern=="string":!1}e.$Nj=G;function W(de){return de.allBasenames||[]}e.$Oj=W;function z(de){return de.allPaths||[]}e.$Pj=z;function P(de,we){const ke=H(Object.getOwnPropertyNames(de).map(ne=>I(ne,de[ne],we)).filter(ne=>ne!==i)),le=ke.length;if(!le)return i;if(!ke.some(ne=>!!ne.requiresSiblings)){if(le===1)return ke[0];const ne=function(ie,Ie){let Le;for(let Ce=0,ce=ke.length;Ce<ce;Ce++){const te=ke[Ce](ie,Ie);if(typeof te=="string")return te;(0,T.$Sg)(te)&&(Le||(Le=[]),Le.push(te))}return Le?(async()=>{for(const Ce of Le){const ce=await Ce;if(typeof ce=="string")return ce}return null})():null},Y=ke.find(ie=>!!ie.allBasenames);Y&&(ne.allBasenames=Y.allBasenames);const V=ke.reduce((ie,Ie)=>Ie.allPaths?ie.concat(Ie.allPaths):ie,[]);return V.length&&(ne.allPaths=V),ne}const ve=function(ne,Y,V){let ie,Ie;for(let Le=0,Ce=ke.length;Le<Ce;Le++){const ce=ke[Le];ce.requiresSiblings&&V&&(Y||(Y=(0,R.$nc)(ne)),ie||(ie=Y.substr(0,Y.length-(0,R.$oc)(ne).length)));const te=ce(ne,Y,ie,V);if(typeof te=="string")return te;(0,T.$Sg)(te)&&(Ie||(Ie=[]),Ie.push(te))}return Ie?(async()=>{for(const Le of Ie){const Ce=await Le;if(typeof Ce=="string")return Ce}return null})():null},se=ke.find(ne=>!!ne.allBasenames);se&&(ve.allBasenames=se.allBasenames);const be=ke.reduce((ne,Y)=>Y.allPaths?ne.concat(Y.allPaths):ne,[]);return be.length&&(ve.allPaths=be),ve}function I(de,we,ke){if(we===!1)return i;const le=g(de,ke);if(le===i)return i;if(typeof we=="boolean")return le;if(we){const ve=we.when;if(typeof ve=="string"){const se=(be,ne,Y,V)=>{if(!V||!le(be,ne))return null;const ie=ve.replace("$(basename)",()=>Y),Ie=V(ie);return(0,T.$Sg)(Ie)?Ie.then(Le=>Le?de:null):Ie?de:null};return se.requiresSiblings=!0,se}}return le}function H(de,we){const ke=de.filter(ne=>!!ne.basenames);if(ke.length<2)return de;const le=ke.reduce((ne,Y)=>{const V=Y.basenames;return V?ne.concat(V):ne},[]);let ve;if(we){ve=[];for(let ne=0,Y=le.length;ne<Y;ne++)ve.push(we)}else ve=ke.reduce((ne,Y)=>{const V=Y.patterns;return V?ne.concat(V):ne},[]);const se=function(ne,Y){if(typeof ne!="string")return null;if(!Y){let ie;for(ie=ne.length;ie>0;ie--){const Ie=ne.charCodeAt(ie-1);if(Ie===47||Ie===92)break}Y=ne.substr(ie)}const V=le.indexOf(Y);return V!==-1?ve[V]:null};se.basenames=le,se.patterns=ve,se.allBasenames=le;const be=de.filter(ne=>!ne.basenames);return be.push(se),be}function ae(de,we){return(0,y.$ub)(de,we,(ke,le)=>typeof ke=="string"&&typeof le=="string"?ke===le:typeof ke!="string"&&typeof le!="string"?ke.base===le.base&&ke.pattern===le.pattern:!1)}e.$Qj=ae}),define(Pe[52],Re([1,0,15,126,25,11,2]),function(ge,e,y,T,C,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.MarkdownStringTextNewlineStyle=void 0;var $;(function(r){r[r.Paragraph=0]="Paragraph",r[r.Break=1]="Break"})($||(e.MarkdownStringTextNewlineStyle=$={}));class f{constructor(n="",o=!1){if(this.value=n,typeof this.value!="string")throw(0,y.$7)("value");typeof o=="boolean"?(this.isTrusted=o,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=o.isTrusted??void 0,this.supportThemeIcons=o.supportThemeIcons??!1,this.supportHtml=o.supportHtml??!1)}appendText(n,o=0){return this.value+=l(this.supportThemeIcons?(0,T.$bk)(n):n).replace(/([ \t]+)/g,(c,h)=>"&nbsp;".repeat(h.length)).replace(/\>/gm,"\\>").replace(/\n/g,o===1?`\\
`:`

`),this}appendMarkdown(n){return this.value+=n,this}appendCodeblock(n,o){return this.value+=`
${p(o,n)}
`,this}appendLink(n,o,c){return this.value+="[",this.value+=this.c(o,"]"),this.value+="](",this.value+=this.c(String(n),")"),c&&(this.value+=` "${this.c(this.c(c,'"'),")")}"`),this.value+=")",this}c(n,o){const c=new RegExp((0,L.$Oe)(o),"g");return n.replace(c,(h,t)=>n.charAt(t-1)!=="\\"?`\\${h}`:h)}}e.$hk=f;function b(r){return A(r)?!r.value:Array.isArray(r)?r.every(b):!0}e.$ik=b;function A(r){return r instanceof f?!0:r&&typeof r=="object"?typeof r.value=="string"&&(typeof r.isTrusted=="boolean"||typeof r.isTrusted=="object"||r.isTrusted===void 0)&&(typeof r.supportThemeIcons=="boolean"||r.supportThemeIcons===void 0):!1}e.$jk=A;function k(r,n){return r===n?!0:!r||!n?!1:r.value===n.value&&r.isTrusted===n.isTrusted&&r.supportThemeIcons===n.supportThemeIcons&&r.supportHtml===n.supportHtml&&(r.baseUri===n.baseUri||!!r.baseUri&&!!n.baseUri&&(0,C.$Ag)(R.URI.from(r.baseUri),R.URI.from(n.baseUri)))}e.$kk=k;function l(r){return r.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$lk=l;function p(r,n){const o=r.match(/^`+/gm)?.reduce((h,t)=>h.length>t.length?h:t).length??0,c=o>=3?o+1:3;return[`${"`".repeat(c)}${n}`,r,`${"`".repeat(c)}`].join(`
`)}e.$mk=p;function w(r){return r.replace(/"/g,"&quot;")}e.$nk=w;function s(r){return r&&r.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$ok=s;function a(r){const n=[],o=r.split("|").map(h=>h.trim());r=o[0];const c=o[1];if(c){const h=/height=(\d+)/.exec(c),t=/width=(\d+)/.exec(c),u=h?h[1]:"",i=t?t[1]:"",g=isFinite(parseInt(i)),m=isFinite(parseInt(u));g&&n.push(`width="${i}"`),m&&n.push(`height="${u}"`)}return{href:r,dimensions:n}}e.$pk=a}),define(Pe[95],Re([1,0,18,45,19,21,25,11]),function(ge,e,y,T,C,L,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5v=e.$4v=e.$3v=e.$2v=e.$1v=e.$Zv=e.$Yv=e.$Xv=e.$Wv=e.$Vv=void 0;function f(g,m){const{os:d,tildify:S,relative:M}=m;if(M){const D=b(g,M,d);if(typeof D=="string")return D}let v=g.fsPath;if(d===1&&!L.$i?v=v.replace(/\//g,"\\"):d!==1&&L.$i&&(v=v.replace(/\\/g,"/")),d!==1&&S?.userHome){const D=S.userHome.fsPath;let N;g.scheme!==S.userHome.scheme&&g.path[0]===C.$gc.sep&&g.path[1]!==C.$gc.sep?N=S.userHome.with({path:g.path}).fsPath:N=v,v=l(N,D,d)}return(d===1?C.$fc:C.$gc).normalize(A(v,d===1))}e.$Vv=f;function b(g,m,d){const S=d===1?C.$fc:C.$gc,M=d===3?R.$xg:R.$zg,v=m.getWorkspace(),E=(0,y.$Ob)(v.folders);if(!E)return;g.scheme!==E.uri.scheme&&g.path[0]===C.$gc.sep&&g.path[1]!==C.$gc.sep&&(g=E.uri.with({path:g.path}));const D=m.getWorkspaceFolder(g);if(!D)return;let N;if(M.isEqual(D.uri,g)?N="":N=M.relativePath(D.uri,g)??"",N&&(N=S.normalize(N)),v.folders.length>1&&!m.noPrefix){const O=D.name?D.name:M.basenameOrAuthority(D.uri);N=N?`${O} \u2022 ${N}`:O}return N}function A(g,m=L.$i){return(0,T.$_f)(g,m)?g.charAt(0).toUpperCase()+g.slice(1):g}e.$Wv=A;let k=Object.create(null);function l(g,m,d=L.OS){if(d===1||!g||!m)return g;let S=k.original===m?k.normalized:void 0;S||(S=m,L.$i&&(S=(0,T.$2f)(S)),S=`${(0,$.$Ue)(S,C.$gc.sep)}${C.$gc.sep}`,k={original:m,normalized:S});let M=g;return L.$i&&(M=(0,T.$2f)(M)),(d===3?M.startsWith(S):(0,$.$af)(M,S))?`~/${M.substr(S.length)}`:g}e.$Xv=l;function p(g,m){return g.replace(/^~($|\/|\\)/,`${m}$1`)}e.$Yv=p;const w="\u2026",s="\\\\",a="~";function r(g,m=C.sep){const d=new Array(g.length);let S=!1;for(let M=0;M<g.length;M++){const v=g[M];if(v===""){d[M]=`.${m}`;continue}if(!v){d[M]=v;continue}S=!0;let E="",D=v;D.indexOf(s)===0?(E=D.substr(0,D.indexOf(s)+s.length),D=D.substr(D.indexOf(s)+s.length)):D.indexOf(m)===0?(E=D.substr(0,D.indexOf(m)+m.length),D=D.substr(D.indexOf(m)+m.length)):D.indexOf(a)===0&&(E=D.substr(0,D.indexOf(a)+a.length),D=D.substr(D.indexOf(a)+a.length));const N=D.split(m);for(let O=1;S&&O<=N.length;O++)for(let G=N.length-O;S&&G>=0;G--){S=!1;let W=N.slice(G,G+O).join(m);for(let z=0;!S&&z<g.length;z++)if(z!==M&&g[z]&&g[z].indexOf(W)>-1){const P=G+O===N.length,I=G>0&&g[z].indexOf(m)>-1?m+W:W,H=g[z].endsWith(I);S=!P||H}if(!S){let z="";(N[0].endsWith(":")||E!=="")&&(G===1&&(G=0,O++,W=N[0]+m+W),G>0&&(z=N[0]+m),z=E+z),G>0&&(z=z+w+m),z=z+W,G+O<N.length&&(z=z+m+w),d[M]=z}}S&&(d[M]=v)}return d}e.$Zv=r;var n;(function(g){g[g.TEXT=0]="TEXT",g[g.VARIABLE=1]="VARIABLE",g[g.SEPARATOR=2]="SEPARATOR"})(n||(n={}));function o(g,m=Object.create(null)){const d=[];let S=!1,M="";for(const v of g)if(v==="$"||S&&v==="{")M&&d.push({value:M,type:n.TEXT}),M="",S=!0;else if(v==="}"&&S){const E=m[M];if(typeof E=="string")E.length&&d.push({value:E,type:n.VARIABLE});else if(E){const D=d[d.length-1];(!D||D.type!==n.SEPARATOR)&&d.push({value:E.label,type:n.SEPARATOR})}M="",S=!1}else M+=v;return M&&!S&&d.push({value:M,type:n.TEXT}),d.filter((v,E)=>{if(v.type===n.SEPARATOR){const D=d[E-1],N=d[E+1];return[D,N].every(O=>O&&(O.type===n.VARIABLE||O.type===n.TEXT)&&O.value.length>0)}return!0}).map(v=>v.value).join("")}e.$1v=o;function c(g,m){return L.$j||m?g.replace(/\(&&\w\)|&&/g,"").replace(/&/g,L.$j?"&":"&&"):g.replace(/&&|&/g,d=>d==="&"?"&&":"&")}e.$2v=c;function h(g,m){return L.$j||m?g.replace(/\(&&\w\)|&&/g,""):L.$i?g.replace(/&&|&/g,d=>d==="&"?"&&":"&"):g.replace(/&&/g,"_")}e.$3v=h;function t(g){return g.replace(/&/g,"&&")}e.$4v=t;function u(g){if(g.endsWith("]")){const m=g.lastIndexOf(" [",g.length-2);if(m!==-1){const d=i(g.substring(0,m)),S=g.substring(m);return{name:d.name+S,parentPath:d.parentPath}}}return i(g)}e.$5v=u;function i(g){const m=g.indexOf("/")!==-1?C.$gc:C.$fc,d=m.basename(g),S=m.dirname(g);return d.length?{name:d,parentPath:S}:{name:S,parentPath:""}}}),define(Pe[139],Re([1,0,24,2]),function(ge,e,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8m=e.$7m=e.$6m=e.$5m=e.$4m=void 0;function C(k){return k.toJSON()}class L{constructor(l){this.a=l}transformIncoming(l){const p=this.a.transformIncoming(l);return p===l?l:C(T.URI.from(p))}transformOutgoing(l){const p=this.a.transformOutgoing(l);return p===l?l:C(T.URI.from(p))}transformOutgoingURI(l){const p=this.a.transformOutgoing(l);return p===l?l:T.URI.from(p)}transformOutgoingScheme(l){return this.a.transformOutgoingScheme(l)}}e.$4m=L,e.$5m=new class{transformIncoming(k){return k}transformOutgoing(k){return k}transformOutgoingURI(k){return k}transformOutgoingScheme(k){return k}};function R(k,l,p){if(!k||p>200)return null;if(typeof k=="object"){if(k instanceof T.URI)return l.transformOutgoing(k);for(const w in k)if(Object.hasOwnProperty.call(k,w)){const s=R(k[w],l,p+1);s!==null&&(k[w]=s)}}return null}function $(k,l){const p=R(k,l,0);return p===null?k:p}e.$6m=$;function f(k,l,p,w){if(!k||w>200)return null;if(typeof k=="object"){if(k.$mid===1)return p?T.URI.revive(l.transformIncoming(k)):l.transformIncoming(k);if(k instanceof y.$je)return null;for(const s in k)if(Object.hasOwnProperty.call(k,s)){const a=f(k[s],l,p,w+1);a!==null&&(k[s]=a)}}return null}function b(k,l){const p=f(k,l,!1,0);return p===null?k:p}e.$7m=b;function A(k,l){const p=f(k,l,!0,0);return p===null?k:p}e.$8m=A}),define(Pe[140],Re([1,0,11,21,24]),function(ge,e,y,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ct=e.$bt=e.$at=void 0;let L;function R(){return L||(L=new TextDecoder("UTF-16LE")),L}let $;function f(){return $||($=new TextDecoder("UTF-16BE")),$}let b;function A(){return b||(b=T.$D()?R():f()),b}e.$at=A;function k(w,s,a){const r=new Uint16Array(w.buffer,s,a);return a>0&&(r[0]===65279||r[0]===65534)?l(w,s,a):R().decode(r)}e.$bt=k;function l(w,s,a){const r=[];let n=0;for(let o=0;o<a;o++){const c=C.$le(w,s);s+=2,r[n++]=String.fromCharCode(c)}return r.join("")}class p{constructor(s){this.a=s|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const s=new Uint16Array(this.b.buffer,0,this.d);return A().decode(s)}f(){const s=this.e();this.d=0,this.c===null?this.c=[s]:this.c[this.c.length]=s}appendCharCode(s){const a=this.a-this.d;a<=1&&(a===0||y.$df(s))&&this.f(),this.b[this.d++]=s}appendASCIICharCode(s){this.d===this.a&&this.f(),this.b[this.d++]=s}appendString(s){const a=s.length;if(this.d+a>=this.a){this.f(),this.c[this.c.length]=s;return}for(let r=0;r<a;r++)this.b[this.d++]=s.charCodeAt(r)}}e.$ct=p}),define(Pe[141],Re([1,0,24,140]),function(ge,e,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$et=e.$dt=void 0;function C(f){return f.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class L{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(b,A,k,l){this.oldPosition=b,this.oldText=A,this.newPosition=k,this.newText=l}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${C(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${C(this.oldText)}")`:`(replace@${this.oldPosition} "${C(this.oldText)}" with "${C(this.newText)}")`}static a(b){return 4+2*b.length}static c(b,A,k){const l=A.length;y.$oe(b,l,k),k+=4;for(let p=0;p<l;p++)y.$me(b,A.charCodeAt(p),k),k+=2;return k}static d(b,A){const k=y.$ne(b,A);return A+=4,(0,T.$bt)(b,A,k)}writeSize(){return 4+4+L.a(this.oldText)+L.a(this.newText)}write(b,A){return y.$oe(b,this.oldPosition,A),A+=4,y.$oe(b,this.newPosition,A),A+=4,A=L.c(b,this.oldText,A),A=L.c(b,this.newText,A),A}static read(b,A,k){const l=y.$ne(b,A);A+=4;const p=y.$ne(b,A);A+=4;const w=L.d(b,A);A+=L.a(w);const s=L.d(b,A);return A+=L.a(s),k.push(new L(l,w,p,s)),A}}e.$dt=L;function R(f,b){return f===null||f.length===0?b:new $(f,b).compress()}e.$et=R;class ${constructor(b,A){this.a=b,this.c=A,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let b=0,A=0,k=this.n(b),l=this.l(A);for(;b<this.f||A<this.h;){if(k===null){this.k(l),l=this.l(++A);continue}if(l===null){this.m(k),k=this.n(++b);continue}if(l.oldEnd<=k.newPosition){this.k(l),l=this.l(++A);continue}if(k.newEnd<=l.oldPosition){this.m(k),k=this.n(++b);continue}if(l.oldPosition<k.newPosition){const[r,n]=$.r(l,k.newPosition-l.oldPosition);this.k(r),l=n;continue}if(k.newPosition<l.oldPosition){const[r,n]=$.q(k,l.oldPosition-k.newPosition);this.m(r),k=n;continue}let s,a;if(l.oldEnd===k.newEnd)s=k,a=l,k=this.n(++b),l=this.l(++A);else if(l.oldEnd<k.newEnd){const[r,n]=$.q(k,l.oldLength);s=r,a=l,k=n,l=this.l(++A)}else{const[r,n]=$.r(l,k.newLength);s=k,a=r,k=this.n(++b),l=n}this.d[this.e++]=new L(s.oldPosition,s.oldText,a.newPosition,a.newText),this.g+=s.newLength-s.oldLength,this.j+=a.newLength-a.oldLength}const p=$.s(this.d);return $.t(p)}k(b){this.d[this.e++]=$.o(this.g,b),this.j+=b.newLength-b.oldLength}l(b){return b<this.h?this.c[b]:null}m(b){this.d[this.e++]=$.p(this.j,b),this.g+=b.newLength-b.oldLength}n(b){return b<this.f?this.a[b]:null}static o(b,A){return new L(A.oldPosition-b,A.oldText,A.newPosition,A.newText)}static p(b,A){return new L(A.oldPosition,A.oldText,A.newPosition+b,A.newText)}static q(b,A){const k=b.newText.substr(0,A),l=b.newText.substr(A);return[new L(b.oldPosition,b.oldText,b.newPosition,k),new L(b.oldEnd,"",b.newPosition+A,l)]}static r(b,A){const k=b.oldText.substr(0,A),l=b.oldText.substr(A);return[new L(b.oldPosition,k,b.newPosition,b.newText),new L(b.oldPosition+A,l,b.newEnd,"")]}static s(b){if(b.length===0)return b;const A=[];let k=0,l=b[0];for(let p=1;p<b.length;p++){const w=b[p];l.oldEnd===w.oldPosition?l=new L(l.oldPosition,l.oldText+w.oldText,l.newPosition,l.newText+w.newText):(A[k++]=l,l=w)}return A[k++]=l,A}static t(b){if(b.length===0)return b;const A=[];let k=0;for(let l=0;l<b.length;l++){const p=b[l];p.oldText!==p.newText&&(A[k++]=p)}return A}}}),define(Pe[142],Re([1,0,34,19]),function(ge,e,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bt=void 0;function C(L,R,$,f,b,A){if(Array.isArray(L)){let k=0;for(const l of L){const p=C(l,R,$,f,b,A);if(p===10)return p;p>k&&(k=p)}return k}else{if(typeof L=="string")return f?L==="*"?5:L===$?10:0:0;if(L){const{language:k,pattern:l,scheme:p,hasAccessToAllModels:w,notebookType:s}=L;if(!f&&!w)return 0;s&&b&&(R=b);let a=0;if(p)if(p===R.scheme)a=10;else if(p==="*")a=5;else return 0;if(k)if(k===$)a=10;else if(k==="*")a=Math.max(a,5);else return 0;if(s)if(s===A)a=10;else if(s==="*"&&A!==void 0)a=Math.max(a,5);else return 0;if(l){let r;if(typeof l=="string"?r=l:r={...l,base:(0,T.$hc)(l.base)},r===R.fsPath||(0,y.$Lj)(r,R.fsPath))a=10;else return 0}return a}else return 0}}e.$Bt=C}),define(Pe[143],Re([1,0,5,11,29,93,91,128,141,6]),function(ge,e,y,T,C,L,R,$,f,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bC=void 0;class A extends b.$Tc{constructor(l,p,w,s,a,r,n){super(),this.m=this.B(new y.$Vd),this.onDidChangeContent=this.m.event,this.f=p,this.j=!r,this.g=s,this.h=a,this.c=new R.$aC(l,w,n)}equals(l){return!(l instanceof A)||this.f!==l.f||this.getEOL()!==l.getEOL()?!1:this.c.equal(l.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(l){return this.c.createSnapshot(l?this.f:"")}getOffsetAt(l,p){return this.c.getOffsetAt(l,p)}getPositionAt(l){return this.c.getPositionAt(l)}getRangeAt(l,p){const w=l+p,s=this.getPositionAt(l),a=this.getPositionAt(w);return new C.$Us(s.lineNumber,s.column,a.lineNumber,a.column)}getValueInRange(l,p=0){if(l.isEmpty())return"";const w=this.n(p);return this.c.getValueInRange(l,w)}getValueLengthInRange(l,p=0){if(l.isEmpty())return 0;if(l.startLineNumber===l.endLineNumber)return l.endColumn-l.startColumn;const w=this.getOffsetAt(l.startLineNumber,l.startColumn),s=this.getOffsetAt(l.endLineNumber,l.endColumn);let a=0;const r=this.n(p),n=this.getEOL();if(r.length!==n.length){const o=r.length-n.length,c=l.endLineNumber-l.startLineNumber;a=o*c}return s-w+a}getCharacterCountInRange(l,p=0){if(this.j){let w=0;const s=l.startLineNumber,a=l.endLineNumber;for(let r=s;r<=a;r++){const n=this.getLineContent(r),o=r===s?l.startColumn-1:0,c=r===a?l.endColumn-1:n.length;for(let h=o;h<c;h++)T.$df(n.charCodeAt(h))?(w=w+1,h=h+1):w=w+1}return w+=this.n(p).length*(a-s),w}return this.getValueLengthInRange(l,p)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(l){return this.c.getLineContent(l)}getLineCharCode(l,p){return this.c.getLineCharCode(l,p)}getCharCode(l){return this.c.getCharCode(l)}getLineLength(l){return this.c.getLineLength(l)}getLineMinColumn(l){return 1}getLineMaxColumn(l){return this.getLineLength(l)+1}getLineFirstNonWhitespaceColumn(l){const p=T.$1e(this.getLineContent(l));return p===-1?0:p+1}getLineLastNonWhitespaceColumn(l){const p=T.$3e(this.getLineContent(l));return p===-1?0:p+2}n(l){switch(l){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(l){this.c.setEOL(l)}applyEdits(l,p,w){let s=this.g,a=this.h,r=this.j,n=!0,o=[];for(let m=0;m<l.length;m++){const d=l[m];n&&d._isTracked&&(n=!1);const S=d.range;if(d.text){let N=!0;r||(N=!T.$of(d.text),r=N),!s&&N&&(s=T.$nf(d.text)),!a&&N&&(a=T.$qf(d.text))}let M="",v=0,E=0,D=0;if(d.text){let N;[v,E,D,N]=(0,$.$ut)(d.text);const O=this.getEOL();N===0||N===(O===`\r
`?2:1)?M=d.text:M=d.text.replace(/\r\n|\r|\n/g,O)}o[m]={sortIndex:m,identifier:d.identifier||null,range:S,rangeOffset:this.getOffsetAt(S.startLineNumber,S.startColumn),rangeLength:this.getValueLengthInRange(S),text:M,eolCount:v,firstLineLength:E,lastLineLength:D,forceMoveMarkers:!!d.forceMoveMarkers,isAutoWhitespaceEdit:d.isAutoWhitespaceEdit||!1}}o.sort(A.u);let c=!1;for(let m=0,d=o.length-1;m<d;m++){const S=o[m].range.getEndPosition(),M=o[m+1].range.getStartPosition();if(M.isBeforeOrEqual(S)){if(M.isBefore(S))throw new Error("Overlapping ranges are not allowed!");c=!0}}n&&(o=this.s(o));const h=w||p?A._getInverseEditRanges(o):[],t=[];if(p)for(let m=0;m<o.length;m++){const d=o[m],S=h[m];if(d.isAutoWhitespaceEdit&&d.range.isEmpty())for(let M=S.startLineNumber;M<=S.endLineNumber;M++){let v="";M===S.startLineNumber&&(v=this.getLineContent(d.range.startLineNumber),T.$1e(v)!==-1)||t.push({lineNumber:M,oldContent:v})}}let u=null;if(w){let m=0;u=[];for(let d=0;d<o.length;d++){const S=o[d],M=h[d],v=this.getValueInRange(S.range),E=S.rangeOffset+m;m+=S.text.length-v.length,u[d]={sortIndex:S.sortIndex,identifier:S.identifier,range:M,text:v,textChange:new f.$dt(S.rangeOffset,v,E,S.text)}}c||u.sort((d,S)=>d.sortIndex-S.sortIndex)}this.g=s,this.h=a,this.j=r;const i=this.t(o);let g=null;if(p&&t.length>0){t.sort((m,d)=>d.lineNumber-m.lineNumber),g=[];for(let m=0,d=t.length;m<d;m++){const S=t[m].lineNumber;if(m>0&&t[m-1].lineNumber===S)continue;const M=t[m].oldContent,v=this.getLineContent(S);v.length===0||v===M||T.$1e(v)!==-1||g.push(S)}}return this.m.fire(),new L.$ev(u,i,g)}s(l){return l.length<1e3?l:[this._toSingleEditOperation(l)]}_toSingleEditOperation(l){let p=!1;const w=l[0].range,s=l[l.length-1].range,a=new C.$Us(w.startLineNumber,w.startColumn,s.endLineNumber,s.endColumn);let r=w.startLineNumber,n=w.startColumn;const o=[];for(let i=0,g=l.length;i<g;i++){const m=l[i],d=m.range;p=p||m.forceMoveMarkers,o.push(this.getValueInRange(new C.$Us(r,n,d.startLineNumber,d.startColumn))),m.text.length>0&&o.push(m.text),r=d.endLineNumber,n=d.endColumn}const c=o.join(""),[h,t,u]=(0,$.$ut)(c);return{sortIndex:0,identifier:l[0].identifier,range:a,rangeOffset:this.getOffsetAt(a.startLineNumber,a.startColumn),rangeLength:this.getValueLengthInRange(a,0),text:c,eolCount:h,firstLineLength:t,lastLineLength:u,forceMoveMarkers:p,isAutoWhitespaceEdit:!1}}t(l){l.sort(A.w);const p=[];for(let w=0;w<l.length;w++){const s=l[w],a=s.range.startLineNumber,r=s.range.startColumn,n=s.range.endLineNumber,o=s.range.endColumn;if(a===n&&r===o&&s.text.length===0)continue;s.text?(this.c.delete(s.rangeOffset,s.rangeLength),this.c.insert(s.rangeOffset,s.text,!0)):this.c.delete(s.rangeOffset,s.rangeLength);const c=new C.$Us(a,r,n,o);p.push({range:c,rangeLength:s.rangeLength,text:s.text,rangeOffset:s.rangeOffset,forceMoveMarkers:s.forceMoveMarkers})}return p}findMatchesLineByLine(l,p,w,s){return this.c.findMatchesLineByLine(l,p,w,s)}getPieceTree(){return this.c}static _getInverseEditRange(l,p){const w=l.startLineNumber,s=l.startColumn,[a,r,n]=(0,$.$ut)(p);let o;if(p.length>0){const c=a+1;c===1?o=new C.$Us(w,s,w,s+r):o=new C.$Us(w,s,w+c-1,n+1)}else o=new C.$Us(w,s,w,s);return o}static _getInverseEditRanges(l){const p=[];let w=0,s=0,a=null;for(let r=0,n=l.length;r<n;r++){const o=l[r];let c,h;a?a.range.endLineNumber===o.range.startLineNumber?(c=w,h=s+(o.range.startColumn-a.range.endColumn)):(c=w+(o.range.startLineNumber-a.range.endLineNumber),h=o.range.startColumn):(c=o.range.startLineNumber,h=o.range.startColumn);let t;if(o.text.length>0){const u=o.eolCount+1;u===1?t=new C.$Us(c,h,c,h+o.firstLineLength):t=new C.$Us(c,h,c+u-1,o.lastLineLength+1)}else t=new C.$Us(c,h,c,h);w=t.endLineNumber,s=t.endColumn,p.push(t),a=o}return p}static u(l,p){const w=C.$Us.compareRangesUsingEnds(l.range,p.range);return w===0?l.sortIndex-p.sortIndex:w}static w(l,p){const w=C.$Us.compareRangesUsingEnds(l.range,p.range);return w===0?p.sortIndex-l.sortIndex:-w}}e.$bC=A}),define(Pe[144],Re([1,0,11,91,143]),function(ge,e,y,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cC=void 0;class L{constructor(f,b,A,k,l,p,w,s,a){this.a=f,this.b=b,this.c=A,this.d=k,this.e=l,this.f=p,this.g=w,this.h=s,this.j=a}k(f){const b=this.c+this.d+this.e,A=this.c+this.e;return b===0?f===1?`
`:`\r
`:A>b/2?`\r
`:`
`}create(f){const b=this.k(f),A=this.a;if(this.j&&(b===`\r
`&&(this.c>0||this.d>0)||b===`
`&&(this.c>0||this.e>0)))for(let l=0,p=A.length;l<p;l++){const w=A[l].buffer.replace(/\r\n|\r|\n/g,b),s=(0,T.$9B)(w);A[l]=new T.$_B(w,s)}const k=new C.$bC(A,this.b,b,this.f,this.g,this.h,this.j);return{textBuffer:k,disposable:k}}getFirstLineText(f){return this.a[0].buffer.substr(0,f).split(/\r\n|\r|\n/)[0]}}class R{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(f){if(f.length===0)return;this.a.length===0&&y.$wf(f)&&(this.b=y.$vf,f=f.substr(1));const b=f.charCodeAt(f.length-1);b===13||b>=55296&&b<=56319?(this.m(f.substr(0,f.length-1),!1),this.c=!0,this.d=b):(this.m(f,!1),this.c=!1,this.d=b)}m(f,b){!b&&f.length===0||(this.c?this.n(String.fromCharCode(this.d)+f):this.n(f))}n(f){const b=(0,T.$0B)(this.e,f);this.a.push(new T.$_B(f,b.lineStarts)),this.f+=b.cr,this.g+=b.lf,this.h+=b.crlf,b.isBasicASCII||(this.l=!1,this.j||(this.j=y.$nf(f)),this.k||(this.k=y.$qf(f)))}finish(f=!0){return this.o(),new L(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,f)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const f=this.a[this.a.length-1];f.buffer+=String.fromCharCode(this.d);const b=(0,T.$9B)(f.buffer);f.lineStarts=b,this.d===13&&this.f++}}}e.$cC=R}),define(Pe[96],Re([1,0,24,21]),function(ge,e,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$t$=e.$s$=void 0;var C;(function(k){k[k.Full=1]="Full",k[k.Delta=2]="Delta"})(C||(C={}));function L(k){for(let l=0,p=k.length;l<p;l+=4){const w=k[l+0],s=k[l+1],a=k[l+2],r=k[l+3];k[l+0]=r,k[l+1]=a,k[l+2]=s,k[l+3]=w}}function R(k){const l=new Uint8Array(k.buffer,k.byteOffset,k.length*4);return T.$D()||L(l),y.$je.wrap(l)}function $(k){const l=k.buffer;if(T.$D()||L(l),l.byteOffset%4===0)return new Uint32Array(l.buffer,l.byteOffset,l.length/4);{const p=new Uint8Array(l.byteLength);return p.set(l),new Uint32Array(p.buffer,p.byteOffset,p.length/4)}}function f(k){const l=new Uint32Array(b(k));let p=0;if(l[p++]=k.id,k.type==="full")l[p++]=1,l[p++]=k.data.length,l.set(k.data,p),p+=k.data.length;else{l[p++]=2,l[p++]=k.deltas.length;for(const w of k.deltas)l[p++]=w.start,l[p++]=w.deleteCount,w.data?(l[p++]=w.data.length,l.set(w.data,p),p+=w.data.length):l[p++]=0}return R(l)}e.$s$=f;function b(k){let l=0;if(l+=1+1,k.type==="full")l+=1+k.data.length;else{l+=1,l+=(1+1+1)*k.deltas.length;for(const p of k.deltas)p.data&&(l+=p.data.length)}return l}function A(k){const l=$(k);let p=0;const w=l[p++];if(l[p++]===1){const n=l[p++],o=l.subarray(p,p+n);return p+=n,{id:w,type:"full",data:o}}const a=l[p++],r=[];for(let n=0;n<a;n++){const o=l[p++],c=l[p++],h=l[p++];let t;h>0&&(t=l.subarray(p,p+h),p+=h),r[n]={start:o,deleteCount:c,data:t}}return{id:w,type:"delta",deltas:r}}e.$t$=A}),define(Pe[145],Re([9,10]),function(ge,e){return ge.create("vs/editor/common/config/editorOptions",e)}),define(Pe[146],Re([1,0,18,26,21,129,147,145]),function(ge,e,y,T,C,L,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var f;(function(Z){Z[Z.None=0]="None",Z[Z.Keep=1]="Keep",Z[Z.Brackets=2]="Brackets",Z[Z.Advanced=3]="Advanced",Z[Z.Full=4]="Full"})(f||(e.EditorAutoIndentStrategy=f={})),e.MINIMAP_GUTTER_WIDTH=8;class b{constructor(_){this.c=_}hasChanged(_){return this.c[_]}}e.ConfigurationChangedEvent=b;class A{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=A;class k{constructor(_,$e,Be,Qe){this.id=_,this.name=$e,this.defaultValue=Be,this.schema=Qe}applyUpdate(_,$e){return p(_,$e)}compute(_,$e,Be){return Be}}class l{constructor(_,$e){this.newValue=_,this.didChange=$e}}e.ApplyUpdateResult=l;function p(Z,_){if(typeof Z!="object"||typeof _!="object"||!Z||!_)return new l(_,Z!==_);if(Array.isArray(Z)||Array.isArray(_)){const Be=Array.isArray(Z)&&Array.isArray(_)&&y.$ub(Z,_);return new l(_,!Be)}let $e=!1;for(const Be in _)if(_.hasOwnProperty(Be)){const Qe=p(Z[Be],_[Be]);Qe.didChange&&(Z[Be]=Qe.newValue,$e=!0)}return new l(Z,$e)}class w{constructor(_){this.schema=void 0,this.id=_,this.name="_never_",this.defaultValue=void 0}applyUpdate(_,$e){return p(_,$e)}validate(_){return this.defaultValue}}class s{constructor(_,$e,Be,Qe){this.id=_,this.name=$e,this.defaultValue=Be,this.schema=Qe}applyUpdate(_,$e){return p(_,$e)}validate(_){return typeof _>"u"?this.defaultValue:_}compute(_,$e,Be){return Be}}function a(Z,_){return typeof Z>"u"?_:Z==="false"?!1:!!Z}e.boolean=a;class r extends s{constructor(_,$e,Be,Qe=void 0){typeof Qe<"u"&&(Qe.type="boolean",Qe.default=Be),super(_,$e,Be,Qe)}validate(_){return a(_,this.defaultValue)}}function n(Z,_,$e,Be){if(typeof Z>"u")return _;let Qe=parseInt(Z,10);return isNaN(Qe)?_:(Qe=Math.max($e,Qe),Qe=Math.min(Be,Qe),Qe|0)}e.clampedInt=n;class o extends s{static clampedInt(_,$e,Be,Qe){return n(_,$e,Be,Qe)}constructor(_,$e,Be,Qe,it,rt=void 0){typeof rt<"u"&&(rt.type="integer",rt.default=Be,rt.minimum=Qe,rt.maximum=it),super(_,$e,Be,rt),this.minimum=Qe,this.maximum=it}validate(_){return o.clampedInt(_,this.defaultValue,this.minimum,this.maximum)}}function c(Z,_,$e,Be){if(typeof Z>"u")return _;const Qe=h.float(Z,_);return h.clamp(Qe,$e,Be)}e.clampedFloat=c;class h extends s{static clamp(_,$e,Be){return _<$e?$e:_>Be?Be:_}static float(_,$e){if(typeof _=="number")return _;if(typeof _>"u")return $e;const Be=parseFloat(_);return isNaN(Be)?$e:Be}constructor(_,$e,Be,Qe,it){typeof it<"u"&&(it.type="number",it.default=Be),super(_,$e,Be,it),this.validationFn=Qe}validate(_){return this.validationFn(h.float(_,this.defaultValue))}}class t extends s{static string(_,$e){return typeof _!="string"?$e:_}constructor(_,$e,Be,Qe=void 0){typeof Qe<"u"&&(Qe.type="string",Qe.default=Be),super(_,$e,Be,Qe)}validate(_){return t.string(_,this.defaultValue)}}function u(Z,_,$e,Be){return typeof Z!="string"?_:Be&&Z in Be?Be[Z]:$e.indexOf(Z)===-1?_:Z}e.stringSet=u;class i extends s{constructor(_,$e,Be,Qe,it=void 0){typeof it<"u"&&(it.type="string",it.enum=Qe,it.default=Be),super(_,$e,Be,it),this.c=Qe}validate(_){return u(_,this.defaultValue,this.c)}}class g extends k{constructor(_,$e,Be,Qe,it,rt,Ne=void 0){typeof Ne<"u"&&(Ne.type="string",Ne.enum=it,Ne.default=Qe),super(_,$e,Be,Ne),this.c=it,this.d=rt}validate(_){return typeof _!="string"?this.defaultValue:this.c.indexOf(_)===-1?this.defaultValue:this.d(_)}}function m(Z){switch(Z){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class d extends k{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[$.localize(0,null),$.localize(1,null),$.localize(2,null)],default:"auto",tags:["accessibility"],description:$.localize(3,null)})}validate(_){switch(_){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(_,$e,Be){return Be===0?_.accessibilitySupport:Be}}class S extends k{constructor(){const _={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",_,{"editor.comments.insertSpace":{type:"boolean",default:_.insertSpace,description:$.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:_.ignoreEmptyLines,description:$.localize(5,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const $e=_;return{insertSpace:a($e.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:a($e.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var M;(function(Z){Z[Z.Hidden=0]="Hidden",Z[Z.Blink=1]="Blink",Z[Z.Smooth=2]="Smooth",Z[Z.Phase=3]="Phase",Z[Z.Expand=4]="Expand",Z[Z.Solid=5]="Solid"})(M||(e.TextEditorCursorBlinkingStyle=M={}));function v(Z){switch(Z){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var E;(function(Z){Z[Z.Line=1]="Line",Z[Z.Block=2]="Block",Z[Z.Underline=3]="Underline",Z[Z.LineThin=4]="LineThin",Z[Z.BlockOutline=5]="BlockOutline",Z[Z.UnderlineThin=6]="UnderlineThin"})(E||(e.TextEditorCursorStyle=E={}));function D(Z){switch(Z){case E.Line:return"line";case E.Block:return"block";case E.Underline:return"underline";case E.LineThin:return"line-thin";case E.BlockOutline:return"block-outline";case E.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=D;function N(Z){switch(Z){case"line":return E.Line;case"block":return E.Block;case"underline":return E.Underline;case"line-thin":return E.LineThin;case"block-outline":return E.BlockOutline;case"underline-thin":return E.UnderlineThin}}class O extends w{constructor(){super(140)}compute(_,$e,Be){const Qe=["monaco-editor"];return $e.get(39)&&Qe.push($e.get(39)),_.extraEditorClassName&&Qe.push(_.extraEditorClassName),$e.get(73)==="default"?Qe.push("mouse-default"):$e.get(73)==="copy"&&Qe.push("mouse-copy"),$e.get(110)&&Qe.push("showUnused"),$e.get(138)&&Qe.push("showDeprecated"),Qe.join(" ")}}class G extends r{constructor(){super(37,"emptySelectionClipboard",!0,{description:$.localize(6,null)})}compute(_,$e,Be){return Be&&_.emptySelectionClipboard}}class W extends k{constructor(){const _={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",_,{"editor.find.cursorMoveOnType":{type:"boolean",default:_.cursorMoveOnType,description:$.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:_.seedSearchStringFromSelection,enumDescriptions:[$.localize(8,null),$.localize(9,null),$.localize(10,null)],description:$.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:_.autoFindInSelection,enumDescriptions:[$.localize(12,null),$.localize(13,null),$.localize(14,null)],description:$.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:_.globalFindClipboard,description:$.localize(16,null),included:C.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:_.addExtraSpaceOnTop,description:$.localize(17,null)},"editor.find.loop":{type:"boolean",default:_.loop,description:$.localize(18,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const $e=_;return{cursorMoveOnType:a($e.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof _.seedSearchStringFromSelection=="boolean"?_.seedSearchStringFromSelection?"always":"never":u($e.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof _.autoFindInSelection=="boolean"?_.autoFindInSelection?"always":"never":u($e.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:a($e.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:a($e.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:a($e.loop,this.defaultValue.loop)}}}class z extends k{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",z.OFF,{anyOf:[{type:"boolean",description:$.localize(19,null)},{type:"string",description:$.localize(20,null)}],description:$.localize(21,null),default:!1})}validate(_){return typeof _>"u"?this.defaultValue:typeof _=="string"?_==="false"||_.length===0?z.OFF:_==="true"?z.ON:_:_?z.ON:z.OFF}}e.EditorFontLigatures=z;class P extends k{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",P.OFF,{anyOf:[{type:"boolean",description:$.localize(22,null)},{type:"string",description:$.localize(23,null)}],description:$.localize(24,null),default:!1})}validate(_){return typeof _>"u"?this.defaultValue:typeof _=="string"?_==="false"?P.OFF:_==="true"?P.TRANSLATE:_:_?P.TRANSLATE:P.OFF}compute(_,$e,Be){return _.fontInfo.fontVariationSettings}}e.EditorFontVariations=P;class I extends w{constructor(){super(50)}compute(_,$e,Be){return _.fontInfo}}class H extends s{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:$.localize(25,null)})}validate(_){const $e=h.float(_,this.defaultValue);return $e===0?e.EDITOR_FONT_DEFAULTS.fontSize:h.clamp($e,6,100)}compute(_,$e,Be){return _.fontInfo.fontSize}}class ae extends k{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:ae.d,maximum:ae.e,errorMessage:$.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:ae.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:$.localize(27,null)})}validate(_){return _==="normal"||_==="bold"?_:String(o.clampedInt(_,e.EDITOR_FONT_DEFAULTS.fontWeight,ae.d,ae.e))}}class de extends k{constructor(){const _={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},$e={type:"string",enum:["peek","gotoAndPeek","goto"],default:_.multiple,enumDescriptions:[$.localize(28,null),$.localize(29,null),$.localize(30,null)]},Be=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",_,{"editor.gotoLocation.multiple":{deprecationMessage:$.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:$.localize(32,null),...$e},"editor.gotoLocation.multipleTypeDefinitions":{description:$.localize(33,null),...$e},"editor.gotoLocation.multipleDeclarations":{description:$.localize(34,null),...$e},"editor.gotoLocation.multipleImplementations":{description:$.localize(35,null),...$e},"editor.gotoLocation.multipleReferences":{description:$.localize(36,null),...$e},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:_.alternativeDefinitionCommand,enum:Be,description:$.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:_.alternativeTypeDefinitionCommand,enum:Be,description:$.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:_.alternativeDeclarationCommand,enum:Be,description:$.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:_.alternativeImplementationCommand,enum:Be,description:$.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:_.alternativeReferenceCommand,enum:Be,description:$.localize(41,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const $e=_;return{multiple:u($e.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:$e.multipleDefinitions??u($e.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:$e.multipleTypeDefinitions??u($e.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:$e.multipleDeclarations??u($e.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:$e.multipleImplementations??u($e.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:$e.multipleReferences??u($e.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string($e.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string($e.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string($e.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string($e.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string($e.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class we extends k{constructor(){const _={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",_,{"editor.hover.enabled":{type:"boolean",default:_.enabled,description:$.localize(42,null)},"editor.hover.delay":{type:"number",default:_.delay,minimum:0,maximum:1e4,description:$.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:_.sticky,description:$.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:_.hidingDelay,description:$.localize(45,null)},"editor.hover.above":{type:"boolean",default:_.above,description:$.localize(46,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const $e=_;return{enabled:a($e.enabled,this.defaultValue.enabled),delay:o.clampedInt($e.delay,this.defaultValue.delay,0,1e4),sticky:a($e.sticky,this.defaultValue.sticky),hidingDelay:o.clampedInt($e.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:a($e.above,this.defaultValue.above)}}}var ke;(function(Z){Z[Z.None=0]="None",Z[Z.Text=1]="Text",Z[Z.Blocks=2]="Blocks"})(ke||(e.RenderMinimap=ke={}));class le extends w{constructor(){super(143)}compute(_,$e,Be){return le.computeLayout($e,{memory:_.memory,outerWidth:_.outerWidth,outerHeight:_.outerHeight,isDominatedByLongLines:_.isDominatedByLongLines,lineHeight:_.fontInfo.lineHeight,viewLineCount:_.viewLineCount,lineNumbersDigitCount:_.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:_.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:_.fontInfo.maxDigitWidth,pixelRatio:_.pixelRatio,glyphMarginDecorationLaneCount:_.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(_){const $e=_.height/_.lineHeight,Be=Math.floor(_.paddingTop/_.lineHeight);let Qe=Math.floor(_.paddingBottom/_.lineHeight);_.scrollBeyondLastLine&&(Qe=Math.max(Qe,$e-1));const it=(Be+_.viewLineCount+Qe)/(_.pixelRatio*_.height),rt=Math.floor(_.viewLineCount/it);return{typicalViewportLineCount:$e,extraLinesBeforeFirstLine:Be,extraLinesBeyondLastLine:Qe,desiredRatio:it,minimapLineCount:rt}}static c(_,$e){const Be=_.outerWidth,Qe=_.outerHeight,it=_.pixelRatio;if(!_.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(it*Qe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Qe};const rt=$e.stableMinimapLayoutInput,Ne=rt&&_.outerHeight===rt.outerHeight&&_.lineHeight===rt.lineHeight&&_.typicalHalfwidthCharacterWidth===rt.typicalHalfwidthCharacterWidth&&_.pixelRatio===rt.pixelRatio&&_.scrollBeyondLastLine===rt.scrollBeyondLastLine&&_.paddingTop===rt.paddingTop&&_.paddingBottom===rt.paddingBottom&&_.minimap.enabled===rt.minimap.enabled&&_.minimap.side===rt.minimap.side&&_.minimap.size===rt.minimap.size&&_.minimap.showSlider===rt.minimap.showSlider&&_.minimap.renderCharacters===rt.minimap.renderCharacters&&_.minimap.maxColumn===rt.minimap.maxColumn&&_.minimap.scale===rt.minimap.scale&&_.verticalScrollbarWidth===rt.verticalScrollbarWidth&&_.isViewportWrapping===rt.isViewportWrapping,Pt=_.lineHeight,Tt=_.typicalHalfwidthCharacterWidth,Ht=_.scrollBeyondLastLine,Bt=_.minimap.renderCharacters;let yt=it>=2?Math.round(_.minimap.scale*2):_.minimap.scale;const Kt=_.minimap.maxColumn,Nt=_.minimap.size,Xt=_.minimap.side,zt=_.verticalScrollbarWidth,Rt=_.viewLineCount,Ze=_.remainingWidth,Gt=_.isViewportWrapping,Jt=Bt?2:3;let lt=Math.floor(it*Qe);const $t=lt/it;let jt=!1,Vt=!1,kt=Jt*yt,dt=yt/it,Ct=1;if(Nt==="fill"||Nt==="fit"){const{typicalViewportLineCount:ft,extraLinesBeforeFirstLine:Ft,extraLinesBeyondLastLine:Se,desiredRatio:Fe,minimapLineCount:fe}=le.computeContainedMinimapLineCount({viewLineCount:Rt,scrollBeyondLastLine:Ht,paddingTop:_.paddingTop,paddingBottom:_.paddingBottom,height:Qe,lineHeight:Pt,pixelRatio:it});if(Rt/fe>1)jt=!0,Vt=!0,yt=1,kt=1,dt=yt/it;else{let Me=!1,Ue=yt+1;if(Nt==="fit"){const Xe=Math.ceil((Ft+Rt+Se)*kt);Gt&&Ne&&Ze<=$e.stableFitRemainingWidth?(Me=!0,Ue=$e.stableFitMaxMinimapScale):Me=Xe>lt}if(Nt==="fill"||Me){jt=!0;const Xe=yt;kt=Math.min(Pt*it,Math.max(1,Math.floor(1/Fe))),Gt&&Ne&&Ze<=$e.stableFitRemainingWidth&&(Ue=$e.stableFitMaxMinimapScale),yt=Math.min(Ue,Math.max(1,Math.floor(kt/Jt))),yt>Xe&&(Ct=Math.min(2,yt/Xe)),dt=yt/it/Ct,lt=Math.ceil(Math.max(ft,Ft+Rt+Se)*kt),Gt?($e.stableMinimapLayoutInput=_,$e.stableFitRemainingWidth=Ze,$e.stableFitMaxMinimapScale=yt):($e.stableMinimapLayoutInput=null,$e.stableFitRemainingWidth=0)}}}const xt=Math.floor(Kt*dt),Dt=Math.min(xt,Math.max(0,Math.floor((Ze-zt-2)*dt/(Tt+dt)))+e.MINIMAP_GUTTER_WIDTH);let qe=Math.floor(it*Dt);const Mt=qe/it;qe=Math.floor(qe*Ct);const Wt=Bt?1:2,Qt=Xt==="left"?0:Be-Dt-zt;return{renderMinimap:Wt,minimapLeft:Qt,minimapWidth:Dt,minimapHeightIsEditorHeight:jt,minimapIsSampling:Vt,minimapScale:yt,minimapLineHeight:kt,minimapCanvasInnerWidth:qe,minimapCanvasInnerHeight:lt,minimapCanvasOuterWidth:Mt,minimapCanvasOuterHeight:$t}}static computeLayout(_,$e){const Be=$e.outerWidth|0,Qe=$e.outerHeight|0,it=$e.lineHeight|0,rt=$e.lineNumbersDigitCount|0,Ne=$e.typicalHalfwidthCharacterWidth,Pt=$e.maxDigitWidth,Tt=$e.pixelRatio,Ht=$e.viewLineCount,Bt=_.get(135),yt=Bt==="inherit"?_.get(134):Bt,Kt=yt==="inherit"?_.get(130):yt,Nt=_.get(133),Xt=$e.isDominatedByLongLines,zt=_.get(57),Rt=_.get(67).renderType!==0,Ze=_.get(68),Gt=_.get(104),Jt=_.get(83),lt=_.get(72),$t=_.get(102),jt=$t.verticalScrollbarSize,Vt=$t.verticalHasArrows,kt=$t.arrowSize,dt=$t.horizontalScrollbarSize,Ct=_.get(43),xt=_.get(109)!=="never";let Dt=_.get(65);Ct&&xt&&(Dt+=16);let qe=0;if(Rt){const _e=Math.max(rt,Ze);qe=Math.round(_e*Pt)}let Mt=0;zt&&(Mt=it*$e.glyphMarginDecorationLaneCount);let Wt=0,Qt=Wt+Mt,ft=Qt+qe,Ft=ft+Dt;const Se=Be-Mt-qe-Dt;let Fe=!1,fe=!1,J=-1;yt==="inherit"&&Xt?(Fe=!0,fe=!0):Kt==="on"||Kt==="bounded"?fe=!0:Kt==="wordWrapColumn"&&(J=Nt);const Me=le.c({outerWidth:Be,outerHeight:Qe,lineHeight:it,typicalHalfwidthCharacterWidth:Ne,pixelRatio:Tt,scrollBeyondLastLine:Gt,paddingTop:Jt.top,paddingBottom:Jt.bottom,minimap:lt,verticalScrollbarWidth:jt,viewLineCount:Ht,remainingWidth:Se,isViewportWrapping:fe},$e.memory||new A);Me.renderMinimap!==0&&Me.minimapLeft===0&&(Wt+=Me.minimapWidth,Qt+=Me.minimapWidth,ft+=Me.minimapWidth,Ft+=Me.minimapWidth);const Ue=Se-Me.minimapWidth,Xe=Math.max(1,Math.floor((Ue-jt-2)/Ne)),We=Vt?kt:0;return fe&&(J=Math.max(1,Xe),Kt==="bounded"&&(J=Math.min(J,Nt))),{width:Be,height:Qe,glyphMarginLeft:Wt,glyphMarginWidth:Mt,glyphMarginDecorationLaneCount:$e.glyphMarginDecorationLaneCount,lineNumbersLeft:Qt,lineNumbersWidth:qe,decorationsLeft:ft,decorationsWidth:Dt,contentLeft:Ft,contentWidth:Ue,minimap:Me,viewportColumn:Xe,isWordWrapMinified:Fe,isViewportWrapping:fe,wrappingColumn:J,verticalScrollbarWidth:jt,horizontalScrollbarHeight:dt,overviewRuler:{top:We,width:jt,height:Qe-2*We,right:0}}}}e.EditorLayoutInfoComputer=le;class ve extends k{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[$.localize(47,null),$.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:$.localize(49,null)}})}validate(_){return u(_,"simple",["simple","advanced"])}compute(_,$e,Be){return $e.get(2)===2?"advanced":Be}}var se;(function(Z){Z.Off="off",Z.OnCode="onCode",Z.On="on"})(se||(e.ShowLightbulbIconMode=se={}));class be extends k{constructor(){const _={enabled:se.On};super(64,"lightbulb",_,{"editor.lightbulb.enabled":{type:"string",enum:[se.Off,se.OnCode,se.On],default:_.enabled,enumDescriptions:[$.localize(50,null),$.localize(51,null),$.localize(52,null)],description:$.localize(53,null)}})}validate(_){return!_||typeof _!="object"?this.defaultValue:{enabled:u(_.enabled,this.defaultValue.enabled,[se.Off,se.OnCode,se.On])}}}class ne extends k{constructor(){const _={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",_,{"editor.stickyScroll.enabled":{type:"boolean",default:_.enabled,description:$.localize(54,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:_.maxLineCount,minimum:1,maximum:10,description:$.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:_.defaultModel,description:$.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:_.scrollWithEditor,description:$.localize(57,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const $e=_;return{enabled:a($e.enabled,this.defaultValue.enabled),maxLineCount:o.clampedInt($e.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:u($e.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:a($e.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class Y extends k{constructor(){const _={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",_,{"editor.inlayHints.enabled":{type:"string",default:_.enabled,description:$.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[$.localize(59,null),$.localize(60,null,C.$j?"Ctrl+Option":"Ctrl+Alt"),$.localize(61,null,C.$j?"Ctrl+Option":"Ctrl+Alt"),$.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:_.fontSize,markdownDescription:$.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:_.fontFamily,markdownDescription:$.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:_.padding,description:$.localize(65,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const $e=_;return typeof $e.enabled=="boolean"&&($e.enabled=$e.enabled?"on":"off"),{enabled:u($e.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:o.clampedInt($e.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string($e.fontFamily,this.defaultValue.fontFamily),padding:a($e.padding,this.defaultValue.padding)}}}class V extends k{constructor(){super(65,"lineDecorationsWidth",10)}validate(_){return typeof _=="string"&&/^\d+(\.\d+)?ch$/.test(_)?-parseFloat(_.substring(0,_.length-2)):o.clampedInt(_,this.defaultValue,0,1e3)}compute(_,$e,Be){return Be<0?o.clampedInt(-Be*_.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Be}}class ie extends h{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,_=>h.clamp(_,0,150),{markdownDescription:$.localize(66,null)})}compute(_,$e,Be){return _.fontInfo.lineHeight}}class Ie extends k{constructor(){const _={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",_,{"editor.minimap.enabled":{type:"boolean",default:_.enabled,description:$.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:_.autohide,description:$.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[$.localize(69,null),$.localize(70,null),$.localize(71,null)],default:_.size,description:$.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:_.side,description:$.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:_.showSlider,description:$.localize(74,null)},"editor.minimap.scale":{type:"number",default:_.scale,minimum:1,maximum:3,enum:[1,2,3],description:$.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:_.renderCharacters,description:$.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:_.maxColumn,description:$.localize(77,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const $e=_;return{enabled:a($e.enabled,this.defaultValue.enabled),autohide:a($e.autohide,this.defaultValue.autohide),size:u($e.size,this.defaultValue.size,["proportional","fill","fit"]),side:u($e.side,this.defaultValue.side,["right","left"]),showSlider:u($e.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:a($e.renderCharacters,this.defaultValue.renderCharacters),scale:o.clampedInt($e.scale,1,1,3),maxColumn:o.clampedInt($e.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Le(Z){return Z==="ctrlCmd"?C.$j?"metaKey":"ctrlKey":"altKey"}class Ce extends k{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:$.localize(78,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:$.localize(79,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const $e=_;return{top:o.clampedInt($e.top,0,0,1e3),bottom:o.clampedInt($e.bottom,0,0,1e3)}}}class ce extends k{constructor(){const _={enabled:!0,cycle:!0};super(85,"parameterHints",_,{"editor.parameterHints.enabled":{type:"boolean",default:_.enabled,description:$.localize(80,null)},"editor.parameterHints.cycle":{type:"boolean",default:_.cycle,description:$.localize(81,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const $e=_;return{enabled:a($e.enabled,this.defaultValue.enabled),cycle:a($e.cycle,this.defaultValue.cycle)}}}class te extends w{constructor(){super(141)}compute(_,$e,Be){return _.pixelRatio}}class Q extends k{constructor(){const _={other:"on",comments:"off",strings:"off"},$e=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[$.localize(82,null),$.localize(83,null),$.localize(84,null)]}];super(88,"quickSuggestions",_,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:$e,default:_.strings,description:$.localize(85,null)},comments:{anyOf:$e,default:_.comments,description:$.localize(86,null)},other:{anyOf:$e,default:_.other,description:$.localize(87,null)}},default:_,markdownDescription:$.localize(88,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=_}validate(_){if(typeof _=="boolean"){const Tt=_?"on":"off";return{comments:Tt,strings:Tt,other:Tt}}if(!_||typeof _!="object")return this.defaultValue;const{other:$e,comments:Be,strings:Qe}=_,it=["on","inline","off"];let rt,Ne,Pt;return typeof $e=="boolean"?rt=$e?"on":"off":rt=u($e,this.defaultValue.other,it),typeof Be=="boolean"?Ne=Be?"on":"off":Ne=u(Be,this.defaultValue.comments,it),typeof Qe=="boolean"?Pt=Qe?"on":"off":Pt=u(Qe,this.defaultValue.strings,it),{other:rt,comments:Ne,strings:Pt}}}var ee;(function(Z){Z[Z.Off=0]="Off",Z[Z.On=1]="On",Z[Z.Relative=2]="Relative",Z[Z.Interval=3]="Interval",Z[Z.Custom=4]="Custom"})(ee||(e.RenderLineNumbersType=ee={}));class me extends k{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[$.localize(89,null),$.localize(90,null),$.localize(91,null),$.localize(92,null)],default:"on",description:$.localize(93,null)})}validate(_){let $e=this.defaultValue.renderType,Be=this.defaultValue.renderFn;return typeof _<"u"&&(typeof _=="function"?($e=4,Be=_):_==="interval"?$e=3:_==="relative"?$e=2:_==="on"?$e=1:$e=0),{renderType:$e,renderFn:Be}}}function pe(Z){const _=Z.get(97);return _==="editable"?Z.get(90):_!=="on"}e.filterValidationDecorations=pe;class Ae extends k{constructor(){const _=[],$e={type:"number",description:$.localize(94,null)};super(101,"rulers",_,{type:"array",items:{anyOf:[$e,{type:["object"],properties:{column:$e,color:{type:"string",description:$.localize(95,null),format:"color-hex"}}}]},default:_,description:$.localize(96,null)})}validate(_){if(Array.isArray(_)){const $e=[];for(const Be of _)if(typeof Be=="number")$e.push({column:o.clampedInt(Be,0,0,1e4),color:null});else if(Be&&typeof Be=="object"){const Qe=Be;$e.push({column:o.clampedInt(Qe.column,0,0,1e4),color:Qe.color})}return $e.sort((Be,Qe)=>Be.column-Qe.column),$e}return this.defaultValue}}class he extends k{constructor(){super(91,"readOnlyMessage",void 0)}validate(_){return!_||typeof _!="object"?this.defaultValue:_}}function ye(Z,_){if(typeof Z!="string")return _;switch(Z){case"hidden":return 2;case"visible":return 3;default:return 1}}class F extends k{constructor(){const _={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(102,"scrollbar",_,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[$.localize(97,null),$.localize(98,null),$.localize(99,null)],default:"auto",description:$.localize(100,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[$.localize(101,null),$.localize(102,null),$.localize(103,null)],default:"auto",description:$.localize(104,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:_.verticalScrollbarSize,description:$.localize(105,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:_.horizontalScrollbarSize,description:$.localize(106,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:_.scrollByPage,description:$.localize(107,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:_.ignoreHorizontalScrollbarInContentHeight,description:$.localize(108,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const $e=_,Be=o.clampedInt($e.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Qe=o.clampedInt($e.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:o.clampedInt($e.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:ye($e.vertical,this.defaultValue.vertical),horizontal:ye($e.horizontal,this.defaultValue.horizontal),useShadows:a($e.useShadows,this.defaultValue.useShadows),verticalHasArrows:a($e.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:a($e.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:a($e.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:a($e.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Be,horizontalSliderSize:o.clampedInt($e.horizontalSliderSize,Be,0,1e3),verticalScrollbarSize:Qe,verticalSliderSize:o.clampedInt($e.verticalSliderSize,Qe,0,1e3),scrollByPage:a($e.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:a($e.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class q extends k{constructor(){const _={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",_,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:_.nonBasicASCII,description:$.localize(109,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:_.invisibleCharacters,description:$.localize(110,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:_.ambiguousCharacters,description:$.localize(111,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:_.includeComments,description:$.localize(112,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:_.includeStrings,description:$.localize(113,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:_.allowedCharacters,description:$.localize(114,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:_.allowedLocales,description:$.localize(115,null)}})}applyUpdate(_,$e){let Be=!1;$e.allowedCharacters&&_&&(T.$zn(_.allowedCharacters,$e.allowedCharacters)||(_={..._,allowedCharacters:$e.allowedCharacters},Be=!0)),$e.allowedLocales&&_&&(T.$zn(_.allowedLocales,$e.allowedLocales)||(_={..._,allowedLocales:$e.allowedLocales},Be=!0));const Qe=super.applyUpdate(_,$e);return Be?new l(Qe.newValue,!0):Qe}validate(_){if(!_||typeof _!="object")return this.defaultValue;const $e=_;return{nonBasicASCII:x($e.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:a($e.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:a($e.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:x($e.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:x($e.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(_.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(_.allowedLocales,this.defaultValue.allowedLocales)}}c(_,$e){if(typeof _!="object"||!_)return $e;const Be={};for(const[Qe,it]of Object.entries(_))it===!0&&(Be[Qe]=!0);return Be}}class K extends k{constructor(){const _={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(62,"inlineSuggest",_,{"editor.inlineSuggest.enabled":{type:"boolean",default:_.enabled,description:$.localize(116,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:_.showToolbar,enum:["always","onHover","never"],enumDescriptions:[$.localize(117,null),$.localize(118,null),$.localize(119,null)],description:$.localize(120,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:_.suppressSuggestions,description:$.localize(121,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const $e=_;return{enabled:a($e.enabled,this.defaultValue.enabled),mode:u($e.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:u($e.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:a($e.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:a($e.keepOnBlur,this.defaultValue.keepOnBlur)}}}class U extends k{constructor(){const _={enabled:L.$ss.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:L.$ss.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",_,{"editor.bracketPairColorization.enabled":{type:"boolean",default:_.enabled,markdownDescription:$.localize(122,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:_.independentColorPoolPerBracketType,description:$.localize(123,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const $e=_;return{enabled:a($e.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:a($e.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class X extends k{constructor(){const _={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",_,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[$.localize(124,null),$.localize(125,null),$.localize(126,null)],default:_.bracketPairs,description:$.localize(127,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[$.localize(128,null),$.localize(129,null),$.localize(130,null)],default:_.bracketPairsHorizontal,description:$.localize(131,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:_.highlightActiveBracketPair,description:$.localize(132,null)},"editor.guides.indentation":{type:"boolean",default:_.indentation,description:$.localize(133,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[$.localize(134,null),$.localize(135,null),$.localize(136,null)],default:_.highlightActiveIndentation,description:$.localize(137,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const $e=_;return{bracketPairs:x($e.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:x($e.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:a($e.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:a($e.indentation,this.defaultValue.indentation),highlightActiveIndentation:x($e.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function x(Z,_,$e){const Be=$e.indexOf(Z);return Be===-1?_:$e[Be]}class Ee extends k{constructor(){const _={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",_,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[$.localize(138,null),$.localize(139,null)],default:_.insertMode,description:$.localize(140,null)},"editor.suggest.filterGraceful":{type:"boolean",default:_.filterGraceful,description:$.localize(141,null)},"editor.suggest.localityBonus":{type:"boolean",default:_.localityBonus,description:$.localize(142,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:_.shareSuggestSelections,markdownDescription:$.localize(143,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[$.localize(144,null),$.localize(145,null),$.localize(146,null),$.localize(147,null)],default:_.selectionMode,markdownDescription:$.localize(148,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:_.snippetsPreventQuickSuggestions,description:$.localize(149,null)},"editor.suggest.showIcons":{type:"boolean",default:_.showIcons,description:$.localize(150,null)},"editor.suggest.showStatusBar":{type:"boolean",default:_.showStatusBar,description:$.localize(151,null)},"editor.suggest.preview":{type:"boolean",default:_.preview,description:$.localize(152,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:_.showInlineDetails,description:$.localize(153,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:$.localize(154,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:$.localize(155,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:$.localize(156,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:$.localize(157,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:$.localize(158,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:$.localize(159,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:$.localize(160,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:$.localize(161,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:$.localize(162,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:$.localize(163,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:$.localize(164,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:$.localize(165,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:$.localize(166,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:$.localize(167,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:$.localize(168,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:$.localize(169,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:$.localize(170,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:$.localize(171,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:$.localize(172,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:$.localize(173,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:$.localize(174,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:$.localize(175,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:$.localize(176,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:$.localize(177,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:$.localize(178,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:$.localize(179,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:$.localize(180,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:$.localize(181,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:$.localize(182,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:$.localize(183,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:$.localize(184,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:$.localize(185,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const $e=_;return{insertMode:u($e.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:a($e.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:a($e.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:a($e.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:a($e.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:u($e.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:a($e.showIcons,this.defaultValue.showIcons),showStatusBar:a($e.showStatusBar,this.defaultValue.showStatusBar),preview:a($e.preview,this.defaultValue.preview),previewMode:u($e.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:a($e.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:a($e.showMethods,this.defaultValue.showMethods),showFunctions:a($e.showFunctions,this.defaultValue.showFunctions),showConstructors:a($e.showConstructors,this.defaultValue.showConstructors),showDeprecated:a($e.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:a($e.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:a($e.showFields,this.defaultValue.showFields),showVariables:a($e.showVariables,this.defaultValue.showVariables),showClasses:a($e.showClasses,this.defaultValue.showClasses),showStructs:a($e.showStructs,this.defaultValue.showStructs),showInterfaces:a($e.showInterfaces,this.defaultValue.showInterfaces),showModules:a($e.showModules,this.defaultValue.showModules),showProperties:a($e.showProperties,this.defaultValue.showProperties),showEvents:a($e.showEvents,this.defaultValue.showEvents),showOperators:a($e.showOperators,this.defaultValue.showOperators),showUnits:a($e.showUnits,this.defaultValue.showUnits),showValues:a($e.showValues,this.defaultValue.showValues),showConstants:a($e.showConstants,this.defaultValue.showConstants),showEnums:a($e.showEnums,this.defaultValue.showEnums),showEnumMembers:a($e.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:a($e.showKeywords,this.defaultValue.showKeywords),showWords:a($e.showWords,this.defaultValue.showWords),showColors:a($e.showColors,this.defaultValue.showColors),showFiles:a($e.showFiles,this.defaultValue.showFiles),showReferences:a($e.showReferences,this.defaultValue.showReferences),showFolders:a($e.showFolders,this.defaultValue.showFolders),showTypeParameters:a($e.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:a($e.showSnippets,this.defaultValue.showSnippets),showUsers:a($e.showUsers,this.defaultValue.showUsers),showIssues:a($e.showIssues,this.defaultValue.showIssues)}}}class Te extends k{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:$.localize(186,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:$.localize(187,null),default:!0,type:"boolean"}})}validate(_){return!_||typeof _!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:a(_.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:a(_.selectSubwords,this.defaultValue.selectSubwords)}}}var Ve;(function(Z){Z[Z.None=0]="None",Z[Z.Same=1]="Same",Z[Z.Indent=2]="Indent",Z[Z.DeepIndent=3]="DeepIndent"})(Ve||(e.WrappingIndent=Ve={}));class He extends k{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[$.localize(188,null),$.localize(189,null),$.localize(190,null),$.localize(191,null)],description:$.localize(192,null),default:"same"}})}validate(_){switch(_){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(_,$e,Be){return $e.get(2)===2?0:Be}}class Ye extends w{constructor(){super(144)}compute(_,$e,Be){const Qe=$e.get(143);return{isDominatedByLongLines:_.isDominatedByLongLines,isWordWrapMinified:Qe.isWordWrapMinified,isViewportWrapping:Qe.isViewportWrapping,wrappingColumn:Qe.wrappingColumn}}}class st extends k{constructor(){const _={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",_,{"editor.dropIntoEditor.enabled":{type:"boolean",default:_.enabled,markdownDescription:$.localize(193,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:$.localize(194,null),enum:["afterDrop","never"],enumDescriptions:[$.localize(195,null),$.localize(196,null)],default:"afterDrop"}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const $e=_;return{enabled:a($e.enabled,this.defaultValue.enabled),showDropSelector:u($e.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class nt extends k{constructor(){const _={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",_,{"editor.pasteAs.enabled":{type:"boolean",default:_.enabled,markdownDescription:$.localize(197,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:$.localize(198,null),enum:["afterPaste","never"],enumDescriptions:[$.localize(199,null),$.localize(200,null)],default:"afterPaste"}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const $e=_;return{enabled:a($e.enabled,this.defaultValue.enabled),showPasteSelector:u($e.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const tt="Consolas, 'Courier New', monospace",at="Menlo, Monaco, 'Courier New', monospace",ct="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:C.$j?at:C.$k?ct:tt,fontWeight:"normal",fontSize:C.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function je(Z){return e.editorOptionsRegistry[Z.id]=Z,Z}var vt;(function(Z){Z[Z.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Z[Z.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Z[Z.accessibilitySupport=2]="accessibilitySupport",Z[Z.accessibilityPageSize=3]="accessibilityPageSize",Z[Z.ariaLabel=4]="ariaLabel",Z[Z.ariaRequired=5]="ariaRequired",Z[Z.autoClosingBrackets=6]="autoClosingBrackets",Z[Z.autoClosingComments=7]="autoClosingComments",Z[Z.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",Z[Z.autoClosingDelete=9]="autoClosingDelete",Z[Z.autoClosingOvertype=10]="autoClosingOvertype",Z[Z.autoClosingQuotes=11]="autoClosingQuotes",Z[Z.autoIndent=12]="autoIndent",Z[Z.automaticLayout=13]="automaticLayout",Z[Z.autoSurround=14]="autoSurround",Z[Z.bracketPairColorization=15]="bracketPairColorization",Z[Z.guides=16]="guides",Z[Z.codeLens=17]="codeLens",Z[Z.codeLensFontFamily=18]="codeLensFontFamily",Z[Z.codeLensFontSize=19]="codeLensFontSize",Z[Z.colorDecorators=20]="colorDecorators",Z[Z.colorDecoratorsLimit=21]="colorDecoratorsLimit",Z[Z.columnSelection=22]="columnSelection",Z[Z.comments=23]="comments",Z[Z.contextmenu=24]="contextmenu",Z[Z.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",Z[Z.cursorBlinking=26]="cursorBlinking",Z[Z.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",Z[Z.cursorStyle=28]="cursorStyle",Z[Z.cursorSurroundingLines=29]="cursorSurroundingLines",Z[Z.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",Z[Z.cursorWidth=31]="cursorWidth",Z[Z.disableLayerHinting=32]="disableLayerHinting",Z[Z.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",Z[Z.domReadOnly=34]="domReadOnly",Z[Z.dragAndDrop=35]="dragAndDrop",Z[Z.dropIntoEditor=36]="dropIntoEditor",Z[Z.emptySelectionClipboard=37]="emptySelectionClipboard",Z[Z.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",Z[Z.extraEditorClassName=39]="extraEditorClassName",Z[Z.fastScrollSensitivity=40]="fastScrollSensitivity",Z[Z.find=41]="find",Z[Z.fixedOverflowWidgets=42]="fixedOverflowWidgets",Z[Z.folding=43]="folding",Z[Z.foldingStrategy=44]="foldingStrategy",Z[Z.foldingHighlight=45]="foldingHighlight",Z[Z.foldingImportsByDefault=46]="foldingImportsByDefault",Z[Z.foldingMaximumRegions=47]="foldingMaximumRegions",Z[Z.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",Z[Z.fontFamily=49]="fontFamily",Z[Z.fontInfo=50]="fontInfo",Z[Z.fontLigatures=51]="fontLigatures",Z[Z.fontSize=52]="fontSize",Z[Z.fontWeight=53]="fontWeight",Z[Z.fontVariations=54]="fontVariations",Z[Z.formatOnPaste=55]="formatOnPaste",Z[Z.formatOnType=56]="formatOnType",Z[Z.glyphMargin=57]="glyphMargin",Z[Z.gotoLocation=58]="gotoLocation",Z[Z.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",Z[Z.hover=60]="hover",Z[Z.inDiffEditor=61]="inDiffEditor",Z[Z.inlineSuggest=62]="inlineSuggest",Z[Z.letterSpacing=63]="letterSpacing",Z[Z.lightbulb=64]="lightbulb",Z[Z.lineDecorationsWidth=65]="lineDecorationsWidth",Z[Z.lineHeight=66]="lineHeight",Z[Z.lineNumbers=67]="lineNumbers",Z[Z.lineNumbersMinChars=68]="lineNumbersMinChars",Z[Z.linkedEditing=69]="linkedEditing",Z[Z.links=70]="links",Z[Z.matchBrackets=71]="matchBrackets",Z[Z.minimap=72]="minimap",Z[Z.mouseStyle=73]="mouseStyle",Z[Z.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",Z[Z.mouseWheelZoom=75]="mouseWheelZoom",Z[Z.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",Z[Z.multiCursorModifier=77]="multiCursorModifier",Z[Z.multiCursorPaste=78]="multiCursorPaste",Z[Z.multiCursorLimit=79]="multiCursorLimit",Z[Z.occurrencesHighlight=80]="occurrencesHighlight",Z[Z.overviewRulerBorder=81]="overviewRulerBorder",Z[Z.overviewRulerLanes=82]="overviewRulerLanes",Z[Z.padding=83]="padding",Z[Z.pasteAs=84]="pasteAs",Z[Z.parameterHints=85]="parameterHints",Z[Z.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",Z[Z.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",Z[Z.quickSuggestions=88]="quickSuggestions",Z[Z.quickSuggestionsDelay=89]="quickSuggestionsDelay",Z[Z.readOnly=90]="readOnly",Z[Z.readOnlyMessage=91]="readOnlyMessage",Z[Z.renameOnType=92]="renameOnType",Z[Z.renderControlCharacters=93]="renderControlCharacters",Z[Z.renderFinalNewline=94]="renderFinalNewline",Z[Z.renderLineHighlight=95]="renderLineHighlight",Z[Z.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",Z[Z.renderValidationDecorations=97]="renderValidationDecorations",Z[Z.renderWhitespace=98]="renderWhitespace",Z[Z.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",Z[Z.roundedSelection=100]="roundedSelection",Z[Z.rulers=101]="rulers",Z[Z.scrollbar=102]="scrollbar",Z[Z.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",Z[Z.scrollBeyondLastLine=104]="scrollBeyondLastLine",Z[Z.scrollPredominantAxis=105]="scrollPredominantAxis",Z[Z.selectionClipboard=106]="selectionClipboard",Z[Z.selectionHighlight=107]="selectionHighlight",Z[Z.selectOnLineNumbers=108]="selectOnLineNumbers",Z[Z.showFoldingControls=109]="showFoldingControls",Z[Z.showUnused=110]="showUnused",Z[Z.snippetSuggestions=111]="snippetSuggestions",Z[Z.smartSelect=112]="smartSelect",Z[Z.smoothScrolling=113]="smoothScrolling",Z[Z.stickyScroll=114]="stickyScroll",Z[Z.stickyTabStops=115]="stickyTabStops",Z[Z.stopRenderingLineAfter=116]="stopRenderingLineAfter",Z[Z.suggest=117]="suggest",Z[Z.suggestFontSize=118]="suggestFontSize",Z[Z.suggestLineHeight=119]="suggestLineHeight",Z[Z.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",Z[Z.suggestSelection=121]="suggestSelection",Z[Z.tabCompletion=122]="tabCompletion",Z[Z.tabIndex=123]="tabIndex",Z[Z.unicodeHighlighting=124]="unicodeHighlighting",Z[Z.unusualLineTerminators=125]="unusualLineTerminators",Z[Z.useShadowDOM=126]="useShadowDOM",Z[Z.useTabStops=127]="useTabStops",Z[Z.wordBreak=128]="wordBreak",Z[Z.wordSeparators=129]="wordSeparators",Z[Z.wordWrap=130]="wordWrap",Z[Z.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",Z[Z.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",Z[Z.wordWrapColumn=133]="wordWrapColumn",Z[Z.wordWrapOverride1=134]="wordWrapOverride1",Z[Z.wordWrapOverride2=135]="wordWrapOverride2",Z[Z.wrappingIndent=136]="wrappingIndent",Z[Z.wrappingStrategy=137]="wrappingStrategy",Z[Z.showDeprecated=138]="showDeprecated",Z[Z.inlayHints=139]="inlayHints",Z[Z.editorClassName=140]="editorClassName",Z[Z.pixelRatio=141]="pixelRatio",Z[Z.tabFocusMode=142]="tabFocusMode",Z[Z.layoutInfo=143]="layoutInfo",Z[Z.wrappingInfo=144]="wrappingInfo",Z[Z.defaultColorDecorators=145]="defaultColorDecorators",Z[Z.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",Z[Z.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(vt||(e.EditorOption=vt={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:je(new r(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:$.localize(201,null)})),acceptSuggestionOnEnter:je(new i(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",$.localize(202,null),""],markdownDescription:$.localize(203,null)})),accessibilitySupport:je(new d),accessibilityPageSize:je(new o(3,"accessibilityPageSize",10,1,1073741824,{description:$.localize(204,null),tags:["accessibility"]})),ariaLabel:je(new t(4,"ariaLabel",$.localize(205,null))),ariaRequired:je(new r(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:je(new r(8,"screenReaderAnnounceInlineSuggestion",!0,{description:$.localize(206,null),tags:["accessibility"]})),autoClosingBrackets:je(new i(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",$.localize(207,null),$.localize(208,null),""],description:$.localize(209,null)})),autoClosingComments:je(new i(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",$.localize(210,null),$.localize(211,null),""],description:$.localize(212,null)})),autoClosingDelete:je(new i(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",$.localize(213,null),""],description:$.localize(214,null)})),autoClosingOvertype:je(new i(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",$.localize(215,null),""],description:$.localize(216,null)})),autoClosingQuotes:je(new i(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",$.localize(217,null),$.localize(218,null),""],description:$.localize(219,null)})),autoIndent:je(new g(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],m,{enumDescriptions:[$.localize(220,null),$.localize(221,null),$.localize(222,null),$.localize(223,null),$.localize(224,null)],description:$.localize(225,null)})),automaticLayout:je(new r(13,"automaticLayout",!1)),autoSurround:je(new i(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[$.localize(226,null),$.localize(227,null),$.localize(228,null),""],description:$.localize(229,null)})),bracketPairColorization:je(new U),bracketPairGuides:je(new X),stickyTabStops:je(new r(115,"stickyTabStops",!1,{description:$.localize(230,null)})),codeLens:je(new r(17,"codeLens",!0,{description:$.localize(231,null)})),codeLensFontFamily:je(new t(18,"codeLensFontFamily","",{description:$.localize(232,null)})),codeLensFontSize:je(new o(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:$.localize(233,null)})),colorDecorators:je(new r(20,"colorDecorators",!0,{description:$.localize(234,null)})),colorDecoratorActivatedOn:je(new i(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[$.localize(235,null),$.localize(236,null),$.localize(237,null)],description:$.localize(238,null)})),colorDecoratorsLimit:je(new o(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:$.localize(239,null)})),columnSelection:je(new r(22,"columnSelection",!1,{description:$.localize(240,null)})),comments:je(new S),contextmenu:je(new r(24,"contextmenu",!0)),copyWithSyntaxHighlighting:je(new r(25,"copyWithSyntaxHighlighting",!0,{description:$.localize(241,null)})),cursorBlinking:je(new g(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],v,{description:$.localize(242,null)})),cursorSmoothCaretAnimation:je(new i(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[$.localize(243,null),$.localize(244,null),$.localize(245,null)],description:$.localize(246,null)})),cursorStyle:je(new g(28,"cursorStyle",E.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],N,{description:$.localize(247,null)})),cursorSurroundingLines:je(new o(29,"cursorSurroundingLines",0,0,1073741824,{description:$.localize(248,null)})),cursorSurroundingLinesStyle:je(new i(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[$.localize(249,null),$.localize(250,null)],markdownDescription:$.localize(251,null)})),cursorWidth:je(new o(31,"cursorWidth",0,0,1073741824,{markdownDescription:$.localize(252,null)})),disableLayerHinting:je(new r(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:je(new r(33,"disableMonospaceOptimizations",!1)),domReadOnly:je(new r(34,"domReadOnly",!1)),dragAndDrop:je(new r(35,"dragAndDrop",!0,{description:$.localize(253,null)})),emptySelectionClipboard:je(new G),dropIntoEditor:je(new st),stickyScroll:je(new ne),experimentalWhitespaceRendering:je(new i(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[$.localize(254,null),$.localize(255,null),$.localize(256,null)],description:$.localize(257,null)})),extraEditorClassName:je(new t(39,"extraEditorClassName","")),fastScrollSensitivity:je(new h(40,"fastScrollSensitivity",5,Z=>Z<=0?5:Z,{markdownDescription:$.localize(258,null)})),find:je(new W),fixedOverflowWidgets:je(new r(42,"fixedOverflowWidgets",!1)),folding:je(new r(43,"folding",!0,{description:$.localize(259,null)})),foldingStrategy:je(new i(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[$.localize(260,null),$.localize(261,null)],description:$.localize(262,null)})),foldingHighlight:je(new r(45,"foldingHighlight",!0,{description:$.localize(263,null)})),foldingImportsByDefault:je(new r(46,"foldingImportsByDefault",!1,{description:$.localize(264,null)})),foldingMaximumRegions:je(new o(47,"foldingMaximumRegions",5e3,10,65e3,{description:$.localize(265,null)})),unfoldOnClickAfterEndOfLine:je(new r(48,"unfoldOnClickAfterEndOfLine",!1,{description:$.localize(266,null)})),fontFamily:je(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:$.localize(267,null)})),fontInfo:je(new I),fontLigatures2:je(new z),fontSize:je(new H),fontWeight:je(new ae),fontVariations:je(new P),formatOnPaste:je(new r(55,"formatOnPaste",!1,{description:$.localize(268,null)})),formatOnType:je(new r(56,"formatOnType",!1,{description:$.localize(269,null)})),glyphMargin:je(new r(57,"glyphMargin",!0,{description:$.localize(270,null)})),gotoLocation:je(new de),hideCursorInOverviewRuler:je(new r(59,"hideCursorInOverviewRuler",!1,{description:$.localize(271,null)})),hover:je(new we),inDiffEditor:je(new r(61,"inDiffEditor",!1)),letterSpacing:je(new h(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Z=>h.clamp(Z,-5,20),{description:$.localize(272,null)})),lightbulb:je(new be),lineDecorationsWidth:je(new V),lineHeight:je(new ie),lineNumbers:je(new me),lineNumbersMinChars:je(new o(68,"lineNumbersMinChars",5,1,300)),linkedEditing:je(new r(69,"linkedEditing",!1,{description:$.localize(273,null)})),links:je(new r(70,"links",!0,{description:$.localize(274,null)})),matchBrackets:je(new i(71,"matchBrackets","always",["always","near","never"],{description:$.localize(275,null)})),minimap:je(new Ie),mouseStyle:je(new i(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:je(new h(74,"mouseWheelScrollSensitivity",1,Z=>Z===0?1:Z,{markdownDescription:$.localize(276,null)})),mouseWheelZoom:je(new r(75,"mouseWheelZoom",!1,{markdownDescription:C.$j?$.localize(277,null):$.localize(278,null)})),multiCursorMergeOverlapping:je(new r(76,"multiCursorMergeOverlapping",!0,{description:$.localize(279,null)})),multiCursorModifier:je(new g(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Le,{markdownEnumDescriptions:[$.localize(280,null),$.localize(281,null)],markdownDescription:$.localize(282,null)})),multiCursorPaste:je(new i(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[$.localize(283,null),$.localize(284,null)],markdownDescription:$.localize(285,null)})),multiCursorLimit:je(new o(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:$.localize(286,null)})),occurrencesHighlight:je(new i(80,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[$.localize(287,null),$.localize(288,null),$.localize(289,null)],markdownDescription:$.localize(290,null)})),overviewRulerBorder:je(new r(81,"overviewRulerBorder",!0,{description:$.localize(291,null)})),overviewRulerLanes:je(new o(82,"overviewRulerLanes",3,0,3)),padding:je(new Ce),pasteAs:je(new nt),parameterHints:je(new ce),peekWidgetDefaultFocus:je(new i(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[$.localize(292,null),$.localize(293,null)],description:$.localize(294,null)})),definitionLinkOpensInPeek:je(new r(87,"definitionLinkOpensInPeek",!1,{description:$.localize(295,null)})),quickSuggestions:je(new Q),quickSuggestionsDelay:je(new o(89,"quickSuggestionsDelay",10,0,1073741824,{description:$.localize(296,null)})),readOnly:je(new r(90,"readOnly",!1)),readOnlyMessage:je(new he),renameOnType:je(new r(92,"renameOnType",!1,{description:$.localize(297,null),markdownDeprecationMessage:$.localize(298,null)})),renderControlCharacters:je(new r(93,"renderControlCharacters",!0,{description:$.localize(299,null),restricted:!0})),renderFinalNewline:je(new i(94,"renderFinalNewline",C.$k?"dimmed":"on",["off","on","dimmed"],{description:$.localize(300,null)})),renderLineHighlight:je(new i(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",$.localize(301,null)],description:$.localize(302,null)})),renderLineHighlightOnlyWhenFocus:je(new r(96,"renderLineHighlightOnlyWhenFocus",!1,{description:$.localize(303,null)})),renderValidationDecorations:je(new i(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:je(new i(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",$.localize(304,null),$.localize(305,null),$.localize(306,null),""],description:$.localize(307,null)})),revealHorizontalRightPadding:je(new o(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:je(new r(100,"roundedSelection",!0,{description:$.localize(308,null)})),rulers:je(new Ae),scrollbar:je(new F),scrollBeyondLastColumn:je(new o(103,"scrollBeyondLastColumn",4,0,1073741824,{description:$.localize(309,null)})),scrollBeyondLastLine:je(new r(104,"scrollBeyondLastLine",!0,{description:$.localize(310,null)})),scrollPredominantAxis:je(new r(105,"scrollPredominantAxis",!0,{description:$.localize(311,null)})),selectionClipboard:je(new r(106,"selectionClipboard",!0,{description:$.localize(312,null),included:C.$k})),selectionHighlight:je(new r(107,"selectionHighlight",!0,{description:$.localize(313,null)})),selectOnLineNumbers:je(new r(108,"selectOnLineNumbers",!0)),showFoldingControls:je(new i(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[$.localize(314,null),$.localize(315,null),$.localize(316,null)],description:$.localize(317,null)})),showUnused:je(new r(110,"showUnused",!0,{description:$.localize(318,null)})),showDeprecated:je(new r(138,"showDeprecated",!0,{description:$.localize(319,null)})),inlayHints:je(new Y),snippetSuggestions:je(new i(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[$.localize(320,null),$.localize(321,null),$.localize(322,null),$.localize(323,null)],description:$.localize(324,null)})),smartSelect:je(new Te),smoothScrolling:je(new r(113,"smoothScrolling",!1,{description:$.localize(325,null)})),stopRenderingLineAfter:je(new o(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:je(new Ee),inlineSuggest:je(new K),inlineCompletionsAccessibilityVerbose:je(new r(147,"inlineCompletionsAccessibilityVerbose",!1,{description:$.localize(326,null)})),suggestFontSize:je(new o(118,"suggestFontSize",0,0,1e3,{markdownDescription:$.localize(327,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:je(new o(119,"suggestLineHeight",0,0,1e3,{markdownDescription:$.localize(328,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:je(new r(120,"suggestOnTriggerCharacters",!0,{description:$.localize(329,null)})),suggestSelection:je(new i(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[$.localize(330,null),$.localize(331,null),$.localize(332,null)],description:$.localize(333,null)})),tabCompletion:je(new i(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[$.localize(334,null),$.localize(335,null),$.localize(336,null)],description:$.localize(337,null)})),tabIndex:je(new o(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:je(new q),unusualLineTerminators:je(new i(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[$.localize(338,null),$.localize(339,null),$.localize(340,null)],description:$.localize(341,null)})),useShadowDOM:je(new r(126,"useShadowDOM",!0)),useTabStops:je(new r(127,"useTabStops",!0,{description:$.localize(342,null)})),wordBreak:je(new i(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[$.localize(343,null),$.localize(344,null)],description:$.localize(345,null)})),wordSeparators:je(new t(129,"wordSeparators",R.$ts,{description:$.localize(346,null)})),wordWrap:je(new i(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[$.localize(347,null),$.localize(348,null),$.localize(349,null),$.localize(350,null)],description:$.localize(351,null)})),wordWrapBreakAfterCharacters:je(new t(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:je(new t(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:je(new o(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:$.localize(352,null)})),wordWrapOverride1:je(new i(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:je(new i(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:je(new O),defaultColorDecorators:je(new r(145,"defaultColorDecorators",!1,{markdownDescription:$.localize(353,null)})),pixelRatio:je(new te),tabFocusMode:je(new r(142,"tabFocusMode",!1,{markdownDescription:$.localize(354,null)})),layoutInfo:je(new le),wrappingInfo:je(new Ye),wrappingIndent:je(new He),wrappingStrategy:je(new ve)}}),define(Pe[148],Re([9,10]),function(ge,e){return ge.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Pe[149],Re([9,10]),function(ge,e){return ge.create("vs/platform/contextkey/common/contextkey",e)}),define(Pe[150],Re([9,10]),function(ge,e){return ge.create("vs/platform/contextkey/common/scanner",e)}),define(Pe[151],Re([9,10]),function(ge,e){return ge.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Pe[152],Re([9,10]),function(ge,e){return ge.create("vs/platform/extensions/common/extensionValidator",e)}),define(Pe[153],Re([9,10]),function(ge,e){return ge.create("vs/platform/files/common/files",e)}),define(Pe[154],Re([9,10]),function(ge,e){return ge.create("vs/platform/markers/common/markers",e)}),define(Pe[155],Re([9,10]),function(ge,e){return ge.create("vs/platform/theme/common/iconRegistry",e)}),define(Pe[156],Re([9,10]),function(ge,e){return ge.create("vs/platform/workspace/common/workspace",e)}),define(Pe[157],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(Pe[158],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Pe[159],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Pe[160],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Pe[161],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostLogService",e)}),define(Pe[162],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostNotebook",e)}),define(Pe[163],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Pe[164],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Pe[165],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Pe[166],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Pe[167],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Pe[168],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Pe[169],Re([9,10]),function(ge,e){return ge.create("vs/workbench/common/configuration",e)}),define(Pe[170],Re([9,10]),function(ge,e){return ge.create("vs/workbench/common/editor",e)}),define(Pe[171],Re([9,10]),function(ge,e){return ge.create("vs/workbench/common/views",e)}),define(Pe[172],Re([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Pe[173],Re([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/debug/common/debug",e)}),define(Pe[174],Re([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Pe[175],Re([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Pe[176],Re([9,10]),function(ge,e){return ge.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Pe[177],Re([9,10]),function(ge,e){return ge.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Pe[178],Re([9,10]),function(ge,e){return ge.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Pe[179],Re([9,10]),function(ge,e){return ge.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Pe[180],Re([1,0,15,150]),function(ge,e,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1i=e.TokenType=void 0;var C;(function(b){b[b.LParen=0]="LParen",b[b.RParen=1]="RParen",b[b.Neg=2]="Neg",b[b.Eq=3]="Eq",b[b.NotEq=4]="NotEq",b[b.Lt=5]="Lt",b[b.LtEq=6]="LtEq",b[b.Gt=7]="Gt",b[b.GtEq=8]="GtEq",b[b.RegexOp=9]="RegexOp",b[b.RegexStr=10]="RegexStr",b[b.True=11]="True",b[b.False=12]="False",b[b.In=13]="In",b[b.Not=14]="Not",b[b.And=15]="And",b[b.Or=16]="Or",b[b.Str=17]="Str",b[b.QuotedStr=18]="QuotedStr",b[b.Error=19]="Error",b[b.EOF=20]="EOF"})(C||(e.TokenType=C={}));function L(...b){switch(b.length){case 1:return(0,T.localize)(0,null,b[0]);case 2:return(0,T.localize)(1,null,b[0],b[1]);case 3:return(0,T.localize)(2,null,b[0],b[1],b[2]);default:return}}const R=(0,T.localize)(3,null),$=(0,T.localize)(4,null);class f{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(A){switch(A.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return A.isTripleEq?"===":"==";case 4:return A.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return A.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return A.lexeme;case 18:return A.lexeme;case 19:return A.lexeme;case 20:return"EOF";default:throw(0,y.$8)(`unhandled token type: ${JSON.stringify(A)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(A=>A.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(A){return this.c=A,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const k=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:k})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const k=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:k})}else this.h(126)?this.k(9):this.l(L("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(L("&&"));break;case 124:this.h(124)?this.k(16):this.l(L("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(A){return this.r()||this.c.charCodeAt(this.e)!==A?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(A){this.f.push({type:A,offset:this.d})}l(A){const k=this.d,l=this.c.substring(this.d,this.e),p={type:19,offset:this.d,lexeme:l};this.g.push({offset:k,lexeme:l,additionalInfo:A}),this.f.push(p)}n(){this.m.lastIndex=this.d;const A=this.m.exec(this.c);if(A){this.e=this.d+A[0].length;const k=this.c.substring(this.d,this.e),l=f.b.get(k);l?this.k(l):this.f.push({type:17,lexeme:k,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(R);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let A=this.e,k=!1,l=!1;for(;;){if(A>=this.c.length){this.e=A,this.l($);return}const w=this.c.charCodeAt(A);if(k)k=!1;else if(w===47&&!l){A++;break}else w===91?l=!0:w===92?k=!0:w===93&&(l=!1);A++}for(;A<this.c.length&&f.a.has(this.c.charCodeAt(A));)A++;this.e=A;const p=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:p,offset:this.d})}r(){return this.e>=this.c.length}}e.$1i=f}),define(Pe[181],Re([1,0,25,31,152,293]),function(ge,e,y,T,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gp=e.$fp=e.$ep=e.$dp=e.$cp=e.$bp=e.$ap=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,$=/^-(\d{4})(\d{2})(\d{2})$/;function f(r){return r=r.trim(),r==="*"||R.test(r)}e.$ap=f;function b(r){if(!f(r))return null;if(r=r.trim(),r==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const n=r.match(R);return n?{hasCaret:n[1]==="^",hasGreaterEquals:n[1]===">=",majorBase:n[2]==="x"?0:parseInt(n[2],10),majorMustEqual:n[2]!=="x",minorBase:n[4]==="x"?0:parseInt(n[4],10),minorMustEqual:n[4]!=="x",patchBase:n[6]==="x"?0:parseInt(n[6],10),patchMustEqual:n[6]!=="x",preRelease:n[8]||null}:null}e.$bp=b;function A(r){if(!r)return null;const n=r.majorBase,o=r.majorMustEqual,c=r.minorBase;let h=r.minorMustEqual;const t=r.patchBase;let u=r.patchMustEqual;r.hasCaret&&(n===0||(h=!1),u=!1);let i=0;if(r.preRelease){const g=$.exec(r.preRelease);if(g){const[,m,d,S]=g;i=Date.UTC(Number(m),Number(d)-1,Number(S))}}return{majorBase:n,majorMustEqual:o,minorBase:c,minorMustEqual:h,patchBase:t,patchMustEqual:u,isMinimum:r.hasGreaterEquals,notBefore:i}}e.$cp=A;function k(r,n,o){let c;typeof r=="string"?c=A(b(r)):c=r;let h;n instanceof Date?h=n.getTime():typeof n=="string"&&(h=new Date(n).getTime());let t;if(typeof o=="string"?t=A(b(o)):t=o,!c||!t)return!1;const u=c.majorBase,i=c.minorBase,g=c.patchBase;let m=t.majorBase,d=t.minorBase,S=t.patchBase;const M=t.notBefore;let v=t.majorMustEqual,E=t.minorMustEqual,D=t.patchMustEqual;return t.isMinimum?u>m?!0:u<m?!1:i>d?!0:i<d||h&&h<M?!1:g>=S:(u===1&&m===0&&(!v||!E||!D)&&(m=1,d=0,S=0,v=!0,E=!1,D=!1),u<m?!1:u>m?!v:i<d?!1:i>d?!E:g<S?!1:g>S?!D:!(h&&h<M))}e.$dp=k;function l(r,n,o,c,h){const t=[];if(typeof c.publisher<"u"&&typeof c.publisher!="string")return t.push([T.default.Error,C.localize(0,null)]),t;if(typeof c.name!="string")return t.push([T.default.Error,C.localize(1,null,"name")]),t;if(typeof c.version!="string")return t.push([T.default.Error,C.localize(2,null,"version")]),t;if(!c.engines)return t.push([T.default.Error,C.localize(3,null,"engines")]),t;if(typeof c.engines.vscode!="string")return t.push([T.default.Error,C.localize(4,null,"engines.vscode")]),t;if(typeof c.extensionDependencies<"u"&&!a(c.extensionDependencies))return t.push([T.default.Error,C.localize(5,null,"extensionDependencies")]),t;if(typeof c.activationEvents<"u"){if(!a(c.activationEvents))return t.push([T.default.Error,C.localize(6,null,"activationEvents")]),t;if(typeof c.main>"u"&&typeof c.browser>"u")return t.push([T.default.Error,C.localize(7,null,"activationEvents","main","browser")]),t}if(typeof c.extensionKind<"u"&&typeof c.main>"u"&&t.push([T.default.Warning,C.localize(8,null,"extensionKind")]),typeof c.main<"u"){if(typeof c.main!="string")return t.push([T.default.Error,C.localize(9,null,"main")]),t;{const g=(0,y.$Hg)(o,c.main);(0,y.$Bg)(g,o)||t.push([T.default.Warning,C.localize(10,null,g.path,o.path)])}}if(typeof c.browser<"u"){if(typeof c.browser!="string")return t.push([T.default.Error,C.localize(11,null,"browser")]),t;{const g=(0,y.$Hg)(o,c.browser);(0,y.$Bg)(g,o)||t.push([T.default.Warning,C.localize(12,null,g.path,o.path)])}}if(!L.valid(c.version))return t.push([T.default.Error,C.localize(13,null)]),t;const u=[];if(!p(r,n,c,h,u))for(const g of u)t.push([T.default.Error,g]);return t}e.$ep=l;function p(r,n,o,c,h){return c||typeof o.main>"u"&&typeof o.browser>"u"?!0:s(r,n,o.engines.vscode,h)}e.$fp=p;function w(r,n,o){return r==="*"||s(n,o,r)}e.$gp=w;function s(r,n,o,c=[]){const h=A(b(o));if(!h)return c.push(C.localize(14,null,o)),!1;if(h.majorBase===0){if(!h.majorMustEqual||!h.minorMustEqual)return c.push(C.localize(15,null,o)),!1}else if(!h.majorMustEqual)return c.push(C.localize(16,null,o)),!1;return k(r,n,h)?!0:(c.push(C.localize(17,null,r,o)),!1)}function a(r){if(!Array.isArray(r))return!1;for(let n=0,o=r.length;n<o;n++)if(typeof r[n]!="string")return!1;return!0}}),define(Pe[69],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3h=void 0;class y{constructor(C,L=[],R=!1){this.ctor=C,this.staticArguments=L,this.supportsDelayedInstantiation=R}}e.$3h=y}),define(Pe[70],Re([1,0,69]),function(ge,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zr=e.$Yr=e.InstantiationType=void 0;const T=[];var C;(function($){$[$.Eager=0]="Eager",$[$.Delayed=1]="Delayed"})(C||(e.InstantiationType=C={}));function L($,f,b){f instanceof y.$3h||(f=new y.$3h(f,[],!!b)),T.push([$,f])}e.$Yr=L;function R(){return T}e.$Zr=R}),define(Pe[182],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dq=e.$Cq=void 0;class y{constructor(L,R){this.key=L,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.$Cq=y;class T{constructor(L){this.b=L,this.a=new Map}roots(){const L=[];for(const R of this.a.values())R.outgoing.size===0&&L.push(R);return L}insertEdge(L,R){const $=this.lookupOrInsertNode(L),f=this.lookupOrInsertNode(R);$.outgoing.set(f.key,f),f.incoming.set($.key,$)}removeNode(L){const R=this.b(L);this.a.delete(R);for(const $ of this.a.values())$.outgoing.delete(R),$.incoming.delete(R)}lookupOrInsertNode(L){const R=this.b(L);let $=this.a.get(R);return $||($=new y(R,L),this.a.set(R,$)),$}lookup(L){return this.a.get(this.b(L))}isEmpty(){return this.a.size===0}toString(){const L=[];for(const[R,$]of this.a)L.push(`${R}
	(-> incoming)[${[...$.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...$.outgoing.keys()].join(",")}]
`);return L.join(`
`)}findCycleSlow(){for(const[L,R]of this.a){const $=new Set([L]),f=this.c(R,$);if(f)return f}}c(L,R){for(const[$,f]of L.outgoing){if(R.has($))return[...R,$].join(" -> ");R.add($);const b=this.c(f,R);if(b)return b;R.delete($)}}}e.$Dq=T}),define(Pe[4],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7h=e.$6h=e.$5h=e._util=void 0;var y;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function $(f){return f[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=$})(y||(e._util=y={})),e.$5h=C("instantiationService");function T(R,$,f){$[y.DI_TARGET]===$?$[y.DI_DEPENDENCIES].push({id:R,index:f}):($[y.DI_DEPENDENCIES]=[{id:R,index:f}],$[y.DI_TARGET]=$)}function C(R){if(y.serviceIds.has(R))return y.serviceIds.get(R);const $=function(f,b,A){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");T($,f,A)};return $.toString=()=>R,y.serviceIds.set(R,$),$}e.$6h=C;function L(R){return R}e.$7h=L}),define(Pe[46],Re([1,0,16,2,4]),function(ge,e,y,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=e.ConfigurationTarget=e.$Bi=e.$Ai=e.$zi=void 0,e.$zi=(0,C.$6h)("configurationService");function L(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof T.URI)}e.$Ai=L;function R(r){return r&&typeof r=="object"&&(!r.overrideIdentifiers||Array.isArray(r.overrideIdentifiers))&&!r.overrideIdentifier&&(!r.resource||r.resource instanceof T.URI)}e.$Bi=R;var $;(function(r){r[r.APPLICATION=1]="APPLICATION",r[r.USER=2]="USER",r[r.USER_LOCAL=3]="USER_LOCAL",r[r.USER_REMOTE=4]="USER_REMOTE",r[r.WORKSPACE=5]="WORKSPACE",r[r.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",r[r.DEFAULT=7]="DEFAULT",r[r.MEMORY=8]="MEMORY"})($||(e.ConfigurationTarget=$={}));function f(r){switch(r){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$Ci=f;function b(r){return r.applicationValue!==void 0||r.userValue!==void 0||r.userLocalValue!==void 0||r.userRemoteValue!==void 0||r.workspaceValue!==void 0||r.workspaceFolderValue!==void 0}e.$Di=b;function A(r,n){const o=Object.create(null);for(const c in r)k(o,c,r[c],n);return o}e.$Ei=A;function k(r,n,o,c){const h=n.split("."),t=h.pop();let u=r;for(let i=0;i<h.length;i++){const g=h[i];let m=u[g];switch(typeof m){case"undefined":m=u[g]=Object.create(null);break;case"object":break;default:c(`Ignoring ${n} as ${h.slice(0,i+1).join(".")} is ${JSON.stringify(m)}`);return}u=m}if(typeof u=="object"&&u!==null)try{u[t]=o}catch{c(`Ignoring ${n} as ${h.join(".")} is ${JSON.stringify(u)}`)}else c(`Ignoring ${n} as ${h.join(".")} is ${JSON.stringify(u)}`)}e.$Fi=k;function l(r,n){const o=n.split(".");p(r,o)}e.$Gi=l;function p(r,n){const o=n.shift();if(n.length===0){delete r[o];return}if(Object.keys(r).indexOf(o)!==-1){const c=r[o];typeof c=="object"&&!Array.isArray(c)&&(p(c,n),Object.keys(c).length===0&&delete r[o])}}function w(r,n,o){function c(u,i){let g=u;for(const m of i){if(typeof g!="object"||g===null)return;g=g[m]}return g}const h=n.split("."),t=c(r,h);return typeof t>"u"?o:t}e.$Hi=w;function s(r,n,o){Object.keys(n).forEach(c=>{c!=="__proto__"&&(c in r?y.$Kf(r[c])&&y.$Kf(n[c])?s(r[c],n[c],o):o&&(r[c]=n[c]):r[c]=n[c])})}e.$Ii=s;function a(r){return r.replace(/[\[\]]/g,"")}e.$Ji=a}),define(Pe[35],Re([1,0,21,11,180,4,149,15]),function(ge,e,y,T,C,L,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.ContextKeyExprType=e.$2i=void 0;const f=new Map;f.set("false",!1),f.set("true",!0),f.set("isMac",y.$j),f.set("isLinux",y.$k),f.set("isWindows",y.$i),f.set("isWeb",y.$o),f.set("isMacNative",y.$j&&!y.$o),f.set("isEdge",y.$H),f.set("isFirefox",y.$F),f.set("isChrome",y.$E),f.set("isSafari",y.$G);function b(Y,V){if(f.get(Y)!==void 0)throw(0,$.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");f.set(Y,V)}e.$2i=b;const A=Object.prototype.hasOwnProperty;var k;(function(Y){Y[Y.False=0]="False",Y[Y.True=1]="True",Y[Y.Defined=2]="Defined",Y[Y.Not=3]="Not",Y[Y.Equals=4]="Equals",Y[Y.NotEquals=5]="NotEquals",Y[Y.And=6]="And",Y[Y.Regex=7]="Regex",Y[Y.NotRegex=8]="NotRegex",Y[Y.Or=9]="Or",Y[Y.In=10]="In",Y[Y.NotIn=11]="NotIn",Y[Y.Greater=12]="Greater",Y[Y.GreaterEquals=13]="GreaterEquals",Y[Y.Smaller=14]="Smaller",Y[Y.SmallerEquals=15]="SmallerEquals"})(k||(e.ContextKeyExprType=k={}));const l={regexParsingWithErrorRecovery:!0},p=(0,R.localize)(0,null),w=(0,R.localize)(1,null),s=(0,R.localize)(2,null),a=(0,R.localize)(3,null),r=(0,R.localize)(4,null),n=(0,R.localize)(5,null),o=(0,R.localize)(6,null),c=(0,R.localize)(7,null);class h{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(V=l){this.k=V,this.d=new C.$1i,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(V){if(V===""){this.h.push({message:p,offset:0,lexeme:"",additionalInfo:w});return}this.f=this.d.reset(V).scan(),this.g=0,this.h=[];try{const ie=this.l();if(!this.E()){const Ie=this.D(),Le=Ie.type===17?n:void 0;throw this.h.push({message:r,offset:Ie.offset,lexeme:C.$1i.getLexeme(Ie),additionalInfo:Le}),h.c}return ie}catch(ie){if(ie!==h.c)throw ie;return}}l(){return this.m()}m(){const V=[this.o()];for(;this.y(16);){const ie=this.o();V.push(ie)}return V.length===1?V[0]:t.or(...V)}o(){const V=[this.s()];for(;this.y(15);){const ie=this.s();V.push(ie)}return V.length===1?V[0]:t.and(...V)}s(){if(this.y(2)){const V=this.D();switch(V.type){case 11:return this.z(),m.INSTANCE;case 12:return this.z(),d.INSTANCE;case 0:{this.z();const ie=this.l();return this.A(1,a),ie?.negate()}case 17:return this.z(),N.create(V.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",V)}}return this.t()}t(){const V=this.D();switch(V.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const ie=this.l();return this.A(1,a),ie}case 17:{const ie=V.lexeme;if(this.z(),this.y(9)){const Le=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Le.type!==10)throw this.B("REGEX",Le);const Ce=Le.lexeme,ce=Ce.lastIndexOf("/"),te=ce===Ce.length-1?void 0:this.w(Ce.substring(ce+1));let Q;try{Q=new RegExp(Ce.substring(1,ce),te)}catch{throw this.B("REGEX",Le)}return I.create(ie,Q)}switch(Le.type){case 10:case 19:{const Ce=[Le.lexeme];this.z();let ce=this.D(),te=0;for(let Ae=0;Ae<Le.lexeme.length;Ae++)Le.lexeme.charCodeAt(Ae)===40?te++:Le.lexeme.charCodeAt(Ae)===41&&te--;for(;!this.E()&&ce.type!==15&&ce.type!==16;){switch(ce.type){case 0:te++;break;case 1:te--;break;case 10:case 18:for(let Ae=0;Ae<ce.lexeme.length;Ae++)ce.lexeme.charCodeAt(Ae)===40?te++:Le.lexeme.charCodeAt(Ae)===41&&te--}if(te<0)break;Ce.push(C.$1i.getLexeme(ce)),this.z(),ce=this.D()}const Q=Ce.join(""),ee=Q.lastIndexOf("/"),me=ee===Q.length-1?void 0:this.w(Q.substring(ee+1));let pe;try{pe=new RegExp(Q.substring(1,ee),me)}catch{throw this.B("REGEX",Le)}return t.regex(ie,pe)}case 18:{const Ce=Le.lexeme;this.z();let ce=null;if(!(0,T.$Je)(Ce)){const te=Ce.indexOf("/"),Q=Ce.lastIndexOf("/");if(te!==Q&&te>=0){const ee=Ce.slice(te+1,Q),me=Ce[Q+1]==="i"?"i":"";try{ce=new RegExp(ee,me)}catch{throw this.B("REGEX",Le)}}}if(ce===null)throw this.B("REGEX",Le);return I.create(ie,ce)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,s);const Le=this.u();return t.notIn(ie,Le)}switch(this.D().type){case 3:{this.z();const Le=this.u();if(this.x().type===18)return t.equals(ie,Le);switch(Le){case"true":return t.has(ie);case"false":return t.not(ie);default:return t.equals(ie,Le)}}case 4:{this.z();const Le=this.u();if(this.x().type===18)return t.notEquals(ie,Le);switch(Le){case"true":return t.not(ie);case"false":return t.has(ie);default:return t.notEquals(ie,Le)}}case 5:return this.z(),z.create(ie,this.u());case 6:return this.z(),P.create(ie,this.u());case 7:return this.z(),G.create(ie,this.u());case 8:return this.z(),W.create(ie,this.u());case 13:return this.z(),t.in(ie,this.u());default:return t.has(ie)}}case 20:throw this.h.push({message:o,offset:V.offset,lexeme:"",additionalInfo:c}),h.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const V=this.D();switch(V.type){case 17:case 18:return this.z(),V.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(V){return V.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(V){return this.C(V)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(V,ie){if(this.C(V))return this.z();throw this.B(ie,this.D())}B(V,ie,Ie){const Le=(0,R.localize)(8,null,V,C.$1i.getLexeme(ie)),Ce=ie.offset,ce=C.$1i.getLexeme(ie);return this.h.push({message:Le,offset:Ce,lexeme:ce,additionalInfo:Ie}),h.c}C(V){return this.D().type===V}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$3i=h;class t{static false(){return m.INSTANCE}static true(){return d.INSTANCE}static has(V){return S.create(V)}static equals(V,ie){return M.create(V,ie)}static notEquals(V,ie){return D.create(V,ie)}static regex(V,ie){return I.create(V,ie)}static in(V,ie){return v.create(V,ie)}static notIn(V,ie){return E.create(V,ie)}static not(V){return N.create(V)}static and(...V){return de.create(V,null,!0)}static or(...V){return we.create(V,null,!0)}static greater(V,ie){return G.create(V,ie)}static greaterEquals(V,ie){return W.create(V,ie)}static smaller(V,ie){return z.create(V,ie)}static smallerEquals(V,ie){return P.create(V,ie)}static{this.c=new h({regexParsingWithErrorRecovery:!1})}static deserialize(V){return V==null?void 0:this.c.parse(V)}}e.$4i=t;function u(Y){const V=new h({regexParsingWithErrorRecovery:!1});return Y.map(ie=>(V.parse(ie),V.lexingErrors.length>0?V.lexingErrors.map(Ie=>({errorMessage:Ie.additionalInfo?(0,R.localize)(9,null,Ie.additionalInfo):(0,R.localize)(10,null),offset:Ie.offset,length:Ie.lexeme.length})):V.parsingErrors.length>0?V.parsingErrors.map(Ie=>({errorMessage:Ie.additionalInfo?`${Ie.message}. ${Ie.additionalInfo}`:Ie.message,offset:Ie.offset,length:Ie.lexeme.length})):[]))}e.$5i=u;function i(Y,V){const ie=Y?Y.substituteConstants():void 0,Ie=V?V.substituteConstants():void 0;return!ie&&!Ie?!0:!ie||!Ie?!1:ie.equals(Ie)}e.$6i=i;function g(Y,V){return Y.cmp(V)}class m{static{this.INSTANCE=new m}constructor(){this.type=0}cmp(V){return this.type-V.type}equals(V){return V.type===this.type}substituteConstants(){return this}evaluate(V){return!1}serialize(){return"false"}keys(){return[]}map(V){return this}negate(){return d.INSTANCE}}e.$7i=m;class d{static{this.INSTANCE=new d}constructor(){this.type=1}cmp(V){return this.type-V.type}equals(V){return V.type===this.type}substituteConstants(){return this}evaluate(V){return!0}serialize(){return"true"}keys(){return[]}map(V){return this}negate(){return m.INSTANCE}}e.$8i=d;class S{static create(V,ie=null){const Ie=f.get(V);return typeof Ie=="boolean"?Ie?d.INSTANCE:m.INSTANCE:new S(V,ie)}constructor(V,ie){this.key=V,this.c=ie,this.type=2}cmp(V){return V.type!==this.type?this.type-V.type:le(this.key,V.key)}equals(V){return V.type===this.type?this.key===V.key:!1}substituteConstants(){const V=f.get(this.key);return typeof V=="boolean"?V?d.INSTANCE:m.INSTANCE:this}evaluate(V){return!!V.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(V){return V.mapDefined(this.key)}negate(){return this.c||(this.c=N.create(this.key,this)),this.c}}e.$9i=S;class M{static create(V,ie,Ie=null){if(typeof ie=="boolean")return ie?S.create(V,Ie):N.create(V,Ie);const Le=f.get(V);return typeof Le=="boolean"?ie===(Le?"true":"false")?d.INSTANCE:m.INSTANCE:new M(V,ie,Ie)}constructor(V,ie,Ie){this.c=V,this.d=ie,this.f=Ie,this.type=4}cmp(V){return V.type!==this.type?this.type-V.type:ve(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){const V=f.get(this.c);if(typeof V=="boolean"){const ie=V?"true":"false";return this.d===ie?d.INSTANCE:m.INSTANCE}return this}evaluate(V){return V.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(V){return V.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=D.create(this.c,this.d,this)),this.f}}e.$0i=M;class v{static create(V,ie){return new v(V,ie)}constructor(V,ie){this.d=V,this.f=ie,this.type=10,this.c=null}cmp(V){return V.type!==this.type?this.type-V.type:ve(this.d,this.f,V.d,V.f)}equals(V){return V.type===this.type?this.d===V.d&&this.f===V.f:!1}substituteConstants(){return this}evaluate(V){const ie=V.getValue(this.f),Ie=V.getValue(this.d);return Array.isArray(ie)?ie.includes(Ie):typeof Ie=="string"&&typeof ie=="object"&&ie!==null?A.call(ie,Ie):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(V){return V.mapIn(this.d,this.f)}negate(){return this.c||(this.c=E.create(this.d,this.f)),this.c}}e.$$i=v;class E{static create(V,ie){return new E(V,ie)}constructor(V,ie){this.d=V,this.f=ie,this.type=11,this.c=v.create(V,ie)}cmp(V){return V.type!==this.type?this.type-V.type:this.c.cmp(V.c)}equals(V){return V.type===this.type?this.c.equals(V.c):!1}substituteConstants(){return this}evaluate(V){return!this.c.evaluate(V)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(V){return V.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$_i=E;class D{static create(V,ie,Ie=null){if(typeof ie=="boolean")return ie?N.create(V,Ie):S.create(V,Ie);const Le=f.get(V);return typeof Le=="boolean"?ie===(Le?"true":"false")?m.INSTANCE:d.INSTANCE:new D(V,ie,Ie)}constructor(V,ie,Ie){this.c=V,this.d=ie,this.f=Ie,this.type=5}cmp(V){return V.type!==this.type?this.type-V.type:ve(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){const V=f.get(this.c);if(typeof V=="boolean"){const ie=V?"true":"false";return this.d===ie?m.INSTANCE:d.INSTANCE}return this}evaluate(V){return V.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(V){return V.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$aj=D;class N{static create(V,ie=null){const Ie=f.get(V);return typeof Ie=="boolean"?Ie?m.INSTANCE:d.INSTANCE:new N(V,ie)}constructor(V,ie){this.c=V,this.d=ie,this.type=3}cmp(V){return V.type!==this.type?this.type-V.type:le(this.c,V.c)}equals(V){return V.type===this.type?this.c===V.c:!1}substituteConstants(){const V=f.get(this.c);return typeof V=="boolean"?V?m.INSTANCE:d.INSTANCE:this}evaluate(V){return!V.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(V){return V.mapNot(this.c)}negate(){return this.d||(this.d=S.create(this.c,this)),this.d}}e.$bj=N;function O(Y,V){if(typeof Y=="string"){const ie=parseFloat(Y);isNaN(ie)||(Y=ie)}return typeof Y=="string"||typeof Y=="number"?V(Y):m.INSTANCE}class G{static create(V,ie,Ie=null){return O(ie,Le=>new G(V,Le,Ie))}constructor(V,ie,Ie){this.c=V,this.d=ie,this.f=Ie,this.type=12}cmp(V){return V.type!==this.type?this.type-V.type:ve(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(V){return V.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=P.create(this.c,this.d,this)),this.f}}e.$cj=G;class W{static create(V,ie,Ie=null){return O(ie,Le=>new W(V,Le,Ie))}constructor(V,ie,Ie){this.c=V,this.d=ie,this.f=Ie,this.type=13}cmp(V){return V.type!==this.type?this.type-V.type:ve(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(V){return V.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$dj=W;class z{static create(V,ie,Ie=null){return O(ie,Le=>new z(V,Le,Ie))}constructor(V,ie,Ie){this.c=V,this.d=ie,this.f=Ie,this.type=14}cmp(V){return V.type!==this.type?this.type-V.type:ve(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(V){return V.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=W.create(this.c,this.d,this)),this.f}}e.$ej=z;class P{static create(V,ie,Ie=null){return O(ie,Le=>new P(V,Le,Ie))}constructor(V,ie,Ie){this.c=V,this.d=ie,this.f=Ie,this.type=15}cmp(V){return V.type!==this.type?this.type-V.type:ve(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(V){return V.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=G.create(this.c,this.d,this)),this.f}}e.$fj=P;class I{static create(V,ie){return new I(V,ie)}constructor(V,ie){this.d=V,this.f=ie,this.type=7,this.c=null}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.d<V.d)return-1;if(this.d>V.d)return 1;const ie=this.f?this.f.source:"",Ie=V.f?V.f.source:"";return ie<Ie?-1:ie>Ie?1:0}equals(V){if(V.type===this.type){const ie=this.f?this.f.source:"",Ie=V.f?V.f.source:"";return this.d===V.d&&ie===Ie}return!1}substituteConstants(){return this}evaluate(V){const ie=V.getValue(this.d);return this.f?this.f.test(ie):!1}serialize(){const V=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${V}`}keys(){return[this.d]}map(V){return V.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=H.create(this)),this.c}}e.$gj=I;class H{static create(V){return new H(V)}constructor(V){this.c=V,this.type=8}cmp(V){return V.type!==this.type?this.type-V.type:this.c.cmp(V.c)}equals(V){return V.type===this.type?this.c.equals(V.c):!1}substituteConstants(){return this}evaluate(V){return!this.c.evaluate(V)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(V){return new H(this.c.map(V))}negate(){return this.c}}e.$hj=H;function ae(Y){let V=null;for(let ie=0,Ie=Y.length;ie<Ie;ie++){const Le=Y[ie].substituteConstants();if(Y[ie]!==Le&&V===null){V=[];for(let Ce=0;Ce<ie;Ce++)V[Ce]=Y[Ce]}V!==null&&(V[ie]=Le)}return V===null?Y:V}class de{static create(V,ie,Ie){return de.d(V,ie,Ie)}constructor(V,ie){this.expr=V,this.c=ie,this.type=6}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.expr.length<V.expr.length)return-1;if(this.expr.length>V.expr.length)return 1;for(let ie=0,Ie=this.expr.length;ie<Ie;ie++){const Le=g(this.expr[ie],V.expr[ie]);if(Le!==0)return Le}return 0}equals(V){if(V.type===this.type){if(this.expr.length!==V.expr.length)return!1;for(let ie=0,Ie=this.expr.length;ie<Ie;ie++)if(!this.expr[ie].equals(V.expr[ie]))return!1;return!0}return!1}substituteConstants(){const V=ae(this.expr);return V===this.expr?this:de.create(V,this.c,!1)}evaluate(V){for(let ie=0,Ie=this.expr.length;ie<Ie;ie++)if(!this.expr[ie].evaluate(V))return!1;return!0}static d(V,ie,Ie){const Le=[];let Ce=!1;for(const ce of V)if(ce){if(ce.type===1){Ce=!0;continue}if(ce.type===0)return m.INSTANCE;if(ce.type===6){Le.push(...ce.expr);continue}Le.push(ce)}if(Le.length===0&&Ce)return d.INSTANCE;if(Le.length!==0){if(Le.length===1)return Le[0];Le.sort(g);for(let ce=1;ce<Le.length;ce++)Le[ce-1].equals(Le[ce])&&(Le.splice(ce,1),ce--);if(Le.length===1)return Le[0];for(;Le.length>1;){const ce=Le[Le.length-1];if(ce.type!==9)break;Le.pop();const te=Le.pop(),Q=Le.length===0,ee=we.create(ce.expr.map(me=>de.create([me,te],null,Ie)),null,Q);ee&&(Le.push(ee),Le.sort(g))}if(Le.length===1)return Le[0];if(Ie){for(let ce=0;ce<Le.length;ce++)for(let te=ce+1;te<Le.length;te++)if(Le[ce].negate().equals(Le[te]))return m.INSTANCE;if(Le.length===1)return Le[0]}return new de(Le,ie)}}serialize(){return this.expr.map(V=>V.serialize()).join(" && ")}keys(){const V=[];for(const ie of this.expr)V.push(...ie.keys());return V}map(V){return new de(this.expr.map(ie=>ie.map(V)),null)}negate(){if(!this.c){const V=[];for(const ie of this.expr)V.push(ie.negate());this.c=we.create(V,this,!0)}return this.c}}e.$ij=de;class we{static create(V,ie,Ie){return we.d(V,ie,Ie)}constructor(V,ie){this.expr=V,this.c=ie,this.type=9}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.expr.length<V.expr.length)return-1;if(this.expr.length>V.expr.length)return 1;for(let ie=0,Ie=this.expr.length;ie<Ie;ie++){const Le=g(this.expr[ie],V.expr[ie]);if(Le!==0)return Le}return 0}equals(V){if(V.type===this.type){if(this.expr.length!==V.expr.length)return!1;for(let ie=0,Ie=this.expr.length;ie<Ie;ie++)if(!this.expr[ie].equals(V.expr[ie]))return!1;return!0}return!1}substituteConstants(){const V=ae(this.expr);return V===this.expr?this:we.create(V,this.c,!1)}evaluate(V){for(let ie=0,Ie=this.expr.length;ie<Ie;ie++)if(this.expr[ie].evaluate(V))return!0;return!1}static d(V,ie,Ie){let Le=[],Ce=!1;if(V){for(let ce=0,te=V.length;ce<te;ce++){const Q=V[ce];if(Q){if(Q.type===0){Ce=!0;continue}if(Q.type===1)return d.INSTANCE;if(Q.type===9){Le=Le.concat(Q.expr);continue}Le.push(Q)}}if(Le.length===0&&Ce)return m.INSTANCE;Le.sort(g)}if(Le.length!==0){if(Le.length===1)return Le[0];for(let ce=1;ce<Le.length;ce++)Le[ce-1].equals(Le[ce])&&(Le.splice(ce,1),ce--);if(Le.length===1)return Le[0];if(Ie){for(let ce=0;ce<Le.length;ce++)for(let te=ce+1;te<Le.length;te++)if(Le[ce].negate().equals(Le[te]))return d.INSTANCE;if(Le.length===1)return Le[0]}return new we(Le,ie)}}serialize(){return this.expr.map(V=>V.serialize()).join(" || ")}keys(){const V=[];for(const ie of this.expr)V.push(...ie.keys());return V}map(V){return new we(this.expr.map(ie=>ie.map(V)),null)}negate(){if(!this.c){const V=[];for(const ie of this.expr)V.push(ie.negate());for(;V.length>1;){const ie=V.shift(),Ie=V.shift(),Le=[];for(const Ce of ne(ie))for(const ce of ne(Ie))Le.push(de.create([Ce,ce],null,!1));V.unshift(we.create(Le,null,!1))}this.c=we.create(V,this,!0)}return this.c}}e.$jj=we;class ke extends S{static{this.d=[]}static all(){return ke.d.values()}constructor(V,ie,Ie){super(V,null),this.f=ie,typeof Ie=="object"?ke.d.push({...Ie,key:V}):Ie!==!0&&ke.d.push({key:V,description:Ie,type:ie!=null?typeof ie:void 0})}bindTo(V){return V.createKey(this.key,this.f)}getValue(V){return V.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(V){return M.create(this.key,V)}notEqualsTo(V){return D.create(this.key,V)}}e.$kj=ke,e.$lj=(0,L.$6h)("contextKeyService");function le(Y,V){return Y<V?-1:Y>V?1:0}function ve(Y,V,ie,Ie){return Y<ie?-1:Y>ie?1:V<Ie?-1:V>Ie?1:0}function se(Y,V){if(Y.type===0||V.type===1)return!0;if(Y.type===9)return V.type===9?be(Y.expr,V.expr):!1;if(V.type===9){for(const ie of V.expr)if(se(Y,ie))return!0;return!1}if(Y.type===6){if(V.type===6)return be(V.expr,Y.expr);for(const ie of Y.expr)if(se(ie,V))return!0;return!1}return Y.equals(V)}e.$mj=se;function be(Y,V){let ie=0,Ie=0;for(;ie<Y.length&&Ie<V.length;){const Le=Y[ie].cmp(V[Ie]);if(Le<0)return!1;Le===0&&ie++,Ie++}return ie===Y.length}function ne(Y){return Y.type===9?Y.expr:[Y]}}),define(Pe[183],Re([1,0,4]),function(ge,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bi=e.$ai=void 0,e.$ai=(0,y.$6h)("environmentService"),e.$bi=(0,y.$7h)(e.$ai)}),define(Pe[97],Re([1,0,151,4]),function(ge,e,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.ExtensionGalleryErrorCode=e.$zo=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$yo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=void 0,e.$mo="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$no=new RegExp(e.$mo),e.$oo="__web_extension",e.$po="skipWalkthrough",e.$qo="extensionsSync",e.$ro="dependecyOrPackExtensionInstall";function C(o){switch(o){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$so=C;function L(o){switch(o){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$to=L;function R(o,c){switch(o){case 3:return c==="x64"?"win32-x64":c==="arm64"?"win32-arm64":"unknown";case 2:return c==="x64"?"linux-x64":c==="arm64"?"linux-arm64":c==="arm"?"linux-armhf":"unknown";case"alpine":return c==="x64"?"alpine-x64":c==="arm64"?"alpine-arm64":"unknown";case 1:return c==="x64"?"darwin-x64":c==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$uo=R;function $(o,c){return c==="web"&&!o.includes("web")}e.$vo=$;function f(o,c,h){return $(c,h)?!1:o==="undefined"||o==="universal"?!0:o==="unknown"?!1:o===h}e.$wo=f;function b(o){return o&&typeof o=="object"&&typeof o.id=="string"&&(!o.uuid||typeof o.uuid=="string")}e.$xo=b;var A;(function(o){o[o.NoneOrRelevance=0]="NoneOrRelevance",o[o.LastUpdatedDate=1]="LastUpdatedDate",o[o.Title=2]="Title",o[o.PublisherName=3]="PublisherName",o[o.InstallCount=4]="InstallCount",o[o.PublishedDate=10]="PublishedDate",o[o.AverageRating=6]="AverageRating",o[o.WeightedRating=12]="WeightedRating"})(A||(e.SortBy=A={}));var k;(function(o){o[o.Default=0]="Default",o[o.Ascending=1]="Ascending",o[o.Descending=2]="Descending"})(k||(e.SortOrder=k={}));var l;(function(o){o.Install="install",o.Uninstall="uninstall"})(l||(e.StatisticType=l={}));var p;(function(o){o[o.None=1]="None",o[o.Install=2]="Install",o[o.Update=3]="Update",o[o.Migrate=4]="Migrate"})(p||(e.InstallOperation=p={})),e.$yo=(0,T.$6h)("extensionGalleryService");var w;(function(o){o.Unsupported="Unsupported",o.Deprecated="Deprecated",o.Malicious="Malicious",o.Incompatible="Incompatible",o.IncompatibleTargetPlatform="IncompatibleTargetPlatform",o.ReleaseVersionNotFound="ReleaseVersionNotFound",o.Invalid="Invalid",o.Download="Download",o.DownloadSignature="DownloadSignature",o.UpdateMetadata="UpdateMetadata",o.Extract="Extract",o.Scanning="Scanning",o.Delete="Delete",o.Rename="Rename",o.CorruptZip="CorruptZip",o.IncompleteZip="IncompleteZip",o.Signature="Signature",o.NotAllowed="NotAllowed",o.Gallery="Gallery",o.Unknown="Unknown",o.Internal="Internal"})(w||(e.ExtensionManagementErrorCode=w={}));var s;(function(o){o.UnknownError="UnknownError",o.PackageIsInvalidZip="PackageIsInvalidZip",o.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(s||(e.ExtensionSignaturetErrorCode=s={}));class a extends Error{constructor(c,h){super(c),this.code=h,this.name=h}}e.$zo=a;var r;(function(o){o.Timeout="Timeout",o.Cancelled="Cancelled",o.Failed="Failed"})(r||(e.ExtensionGalleryErrorCode=r={}));class n extends Error{constructor(c,h){super(c),this.code=h,this.name=h}}e.$Ao=n,e.$Bo=(0,T.$6h)("extensionManagementService"),e.$Co="extensionsIdentifiers/disabled",e.$Do="extensionsIdentifiers/enabled",e.$Eo=(0,T.$6h)("IGlobalExtensionEnablementService"),e.$Fo=(0,T.$6h)("IExtensionTipsService"),e.$Go=(0,y.localize)(0,null),e.$Ho={value:e.$Go,original:"Extensions"},e.$Io=(0,y.localize2)(1,"Preferences")}),define(Pe[41],Re([1,0,50,19,11,16,2,153,4,21,12,39]),function(ge,e,y,T,C,L,R,$,f,b,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zk=e.$Yk=e.$Xk=e.$Wk=e.$Vk=e.FileKind=e.$Uk=e.$Tk=e.$Sk=e.$Rk=e.$Qk=e.$Pk=e.$Ok=e.FileOperationResult=e.$Nk=e.$Mk=e.$Lk=e.$Kk=e.$Jk=e.FileChangeType=e.$Ik=e.FileOperation=e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.$Dk=e.$Ck=e.FileSystemProviderErrorCode=e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=e.$wk=e.$vk=e.$uk=e.$tk=e.FileSystemProviderCapabilities=e.$sk=e.FilePermission=e.FileType=e.$rk=e.$qk=void 0,e.$qk=(0,f.$6h)("fileService");function l(se){return se.create===!0}e.$rk=l;var p;(function(se){se[se.Unknown=0]="Unknown",se[se.File=1]="File",se[se.Directory=2]="Directory",se[se.SymbolicLink=64]="SymbolicLink"})(p||(e.FileType=p={}));var w;(function(se){se[se.Readonly=1]="Readonly",se[se.Locked=2]="Locked"})(w||(e.FilePermission=w={}));function s(se){const be=se;return!!be&&typeof be.onDidChange=="function"}e.$sk=s;var a;(function(se){se[se.None=0]="None",se[se.FileReadWrite=2]="FileReadWrite",se[se.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",se[se.FileReadStream=16]="FileReadStream",se[se.FileFolderCopy=8]="FileFolderCopy",se[se.PathCaseSensitive=1024]="PathCaseSensitive",se[se.Readonly=2048]="Readonly",se[se.Trash=4096]="Trash",se[se.FileWriteUnlock=8192]="FileWriteUnlock",se[se.FileAtomicRead=16384]="FileAtomicRead",se[se.FileAtomicWrite=32768]="FileAtomicWrite",se[se.FileAtomicDelete=65536]="FileAtomicDelete",se[se.FileClone=131072]="FileClone"})(a||(e.FileSystemProviderCapabilities=a={}));function r(se){return!!(se.capabilities&2)}e.$tk=r;function n(se){return!!(se.capabilities&8)}e.$uk=n;function o(se){return!!(se.capabilities&131072)}e.$vk=o;function c(se){return!!(se.capabilities&4)}e.$wk=c;function h(se){return!!(se.capabilities&16)}e.$xk=h;function t(se){return r(se)?!!(se.capabilities&16384):!1}e.$yk=t;function u(se){return r(se)?!!(se.capabilities&32768):!1}e.$zk=u;function i(se){return!!(se.capabilities&65536)}e.$Ak=i;function g(se){return!!(se.capabilities&2048)}e.$Bk=g;var m;(function(se){se.FileExists="EntryExists",se.FileNotFound="EntryNotFound",se.FileNotADirectory="EntryNotADirectory",se.FileIsADirectory="EntryIsADirectory",se.FileExceedsStorageQuota="EntryExceedsStorageQuota",se.FileTooLarge="EntryTooLarge",se.FileWriteLocked="EntryWriteLocked",se.NoPermissions="NoPermissions",se.Unavailable="Unavailable",se.Unknown="Unknown"})(m||(e.FileSystemProviderErrorCode=m={}));class d extends Error{static create(be,ne){const Y=new d(be.toString(),ne);return v(Y,ne),Y}constructor(be,ne){super(be),this.code=ne}}e.$Ck=d;function S(se,be){return d.create(se,be)}e.$Dk=S;function M(se){return se||S((0,$.localize)(0,null),m.Unknown)}e.$Ek=M;function v(se,be){return se.name=be?`${be} (FileSystemError)`:"FileSystemError",se}e.$Fk=v;function E(se){if(!se)return m.Unknown;if(se instanceof d)return se.code;const be=/^(.+) \(FileSystemError\)$/.exec(se.name);if(!be)return m.Unknown;switch(be[1]){case m.FileExists:return m.FileExists;case m.FileIsADirectory:return m.FileIsADirectory;case m.FileNotADirectory:return m.FileNotADirectory;case m.FileNotFound:return m.FileNotFound;case m.FileTooLarge:return m.FileTooLarge;case m.FileWriteLocked:return m.FileWriteLocked;case m.NoPermissions:return m.NoPermissions;case m.Unavailable:return m.Unavailable}return m.Unknown}e.$Gk=E;function D(se){if(se instanceof P)return se.fileOperationResult;switch(E(se)){case m.FileNotFound:return 1;case m.FileIsADirectory:return 0;case m.FileNotADirectory:return 9;case m.FileWriteLocked:return 5;case m.NoPermissions:return 6;case m.FileExists:return 4;case m.FileTooLarge:return 7;default:return 10}}e.$Hk=D;var N;(function(se){se[se.CREATE=0]="CREATE",se[se.DELETE=1]="DELETE",se[se.MOVE=2]="MOVE",se[se.COPY=3]="COPY",se[se.WRITE=4]="WRITE"})(N||(e.FileOperation=N={}));class O{constructor(be,ne,Y){this.resource=be,this.operation=ne,this.target=Y}isOperation(be){return this.operation===be}}e.$Ik=O;var G;(function(se){se[se.UPDATED=0]="UPDATED",se[se.ADDED=1]="ADDED",se[se.DELETED=2]="DELETED"})(G||(e.FileChangeType=G={}));class W{static{this.a=null}constructor(be,ne){this.c=ne,this.b=void 0,this.d=new k.$V(()=>{const Y=y.$_h.forUris(()=>this.c);return Y.fill(this.rawAdded.map(V=>[V,!0])),Y}),this.f=new k.$V(()=>{const Y=y.$_h.forUris(()=>this.c);return Y.fill(this.rawUpdated.map(V=>[V,!0])),Y}),this.g=new k.$V(()=>{const Y=y.$_h.forUris(()=>this.c);return Y.fill(this.rawDeleted.map(V=>[V,!0])),Y}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const Y of be){switch(Y.type){case 1:this.rawAdded.push(Y.resource);break;case 0:this.rawUpdated.push(Y.resource);break;case 2:this.rawDeleted.push(Y.resource);break}this.b!==W.a&&(typeof Y.cId=="number"?this.b===void 0?this.b=Y.cId:this.b!==Y.cId&&(this.b=W.a):this.b!==void 0&&(this.b=W.a))}}contains(be,...ne){return this.h(be,{includeChildren:!1},...ne)}affects(be,...ne){return this.h(be,{includeChildren:!0},...ne)}h(be,ne,...Y){if(!be)return!1;const V=Y.length>0;return!!((!V||Y.includes(1))&&(this.d.value.get(be)||ne.includeChildren&&this.d.value.findSuperstr(be))||(!V||Y.includes(0))&&(this.f.value.get(be)||ne.includeChildren&&this.f.value.findSuperstr(be))||(!V||Y.includes(2))&&(this.g.value.findSubstr(be)||ne.includeChildren&&this.g.value.findSuperstr(be)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(be){return this.b===be}hasCorrelation(){return typeof this.b=="number"}}e.$Jk=W;function z(se,be,ne){return!se||!be||se===be||be.length>se.length?!1:(be.charAt(be.length-1)!==T.sep&&(be+=T.sep),ne?(0,C.$af)(se,be):se.indexOf(be)===0)}e.$Kk=z;class P extends Error{constructor(be,ne,Y){super(be),this.fileOperationResult=ne,this.options=Y}}e.$Lk=P;class I extends P{constructor(be,ne,Y,V){super(be,ne,V),this.fileOperationResult=ne,this.size=Y}}e.$Mk=I;class H extends P{constructor(be,ne,Y){super(be,2,Y),this.stat=ne}}e.$Nk=H;var ae;(function(se){se[se.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",se[se.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",se[se.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",se[se.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",se[se.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",se[se.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",se[se.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",se[se.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",se[se.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",se[se.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",se[se.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ae||(e.FileOperationResult=ae={})),e.$Ok={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Pk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Qk="files.associations",e.$Rk="files.exclude",e.$Sk="files.readonlyInclude",e.$Tk="files.readonlyExclude",e.$Uk="files.readonlyFromPermissions";var de;(function(se){se[se.FILE=0]="FILE",se[se.FOLDER=1]="FOLDER",se[se.ROOT_FOLDER=2]="ROOT_FOLDER"})(de||(e.FileKind=de={})),e.$Vk="";function we(se){if(!(typeof se.size!="number"||typeof se.mtime!="number"))return se.mtime.toString(29)+se.size.toString(31)}e.$Wk=we;async function ke(se,be){if(!be.hasProvider(R.URI.from({scheme:se.scheme})))return new Promise(ne=>{const Y=be.onDidChangeFileSystemProviderRegistrations(V=>{V.scheme===se.scheme&&V.added&&(Y.dispose(),ne())})})}e.$Xk=ke;class le{static{this.KB=1024}static{this.MB=le.KB*le.KB}static{this.GB=le.MB*le.KB}static{this.TB=le.GB*le.KB}static formatSize(be){return(0,L.$Mf)(be)||(be=0),be<le.KB?(0,$.localize)(1,null,be.toFixed(0)):be<le.MB?(0,$.localize)(2,null,(be/le.KB).toFixed(2)):be<le.GB?(0,$.localize)(3,null,(be/le.MB).toFixed(2)):be<le.TB?(0,$.localize)(4,null,(be/le.GB).toFixed(2)):(0,$.localize)(5,null,(be/le.TB).toFixed(2))}}e.$Yk=le;function ve(se){const be=typeof se=="string"||se?.scheme===A.Schemas.vscodeRemote;return typeof se!="string"&&se?.scheme===A.Schemas.file?1024*le.MB:be?10*le.MB:b.$o?50*le.MB:1024*le.MB}e.$Zk=ve}),define(Pe[71],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=void 0;class y{constructor(...C){this.a=new Map;for(const[L,R]of C)this.set(L,R)}set(C,L){const R=this.a.get(C);return this.a.set(C,L),R}has(C){return this.a.has(C)}get(C){return this.a.get(C)}}e.$4h=y}),define(Pe[184],Re([1,0,13,15,6,69,182,4,71,185]),function(ge,e,y,T,C,L,R,$,f,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fq=e.$Eq=void 0;const A=!1;class k extends Error{constructor(a){super("cyclic dependency between services"),this.message=a.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${a.toString()}`}}class l{constructor(a=new f.$4h,r=!1,n,o=A){this.f=a,this.g=r,this.h=n,this.i=o,this.o=new Set,this.f.set($.$5h,this),this._globalGraph=o?n?._globalGraph??new R.$Dq(c=>c):void 0}createChild(a){return new l(a,this.g,this,this.i)}invokeFunction(a,...r){const n=w.traceInvocation(this.i,a);let o=!1;try{return a({get:h=>{if(o)throw(0,T.$8)("service accessor is only valid during the invocation of its target method");const t=this.m(h,n);if(!t)throw new Error(`[invokeFunction] unknown service '${h}'`);return t}},...r)}finally{o=!0,n.stop()}}createInstance(a,...r){let n,o;return a instanceof L.$3h?(n=w.traceCreation(this.i,a.ctor),o=this.j(a.ctor,a.staticArguments.concat(r),n)):(n=w.traceCreation(this.i,a),o=this.j(a,r,n)),n.stop(),o}j(a,r=[],n){const o=$._util.getServiceDependencies(a).sort((t,u)=>t.index-u.index),c=[];for(const t of o){const u=this.m(t.id,n);u||this.u(`[createInstance] ${a.name} depends on UNKNOWN service ${t.id}.`,!1),c.push(u)}const h=o.length>0?o[0].index:r.length;if(r.length!==h){console.trace(`[createInstance] First service dependency of ${a.name} at position ${h+1} conflicts with ${r.length} static arguments`);const t=h-r.length;t>0?r=r.concat(new Array(t)):r=r.slice(0,h)}return Reflect.construct(a,r.concat(c))}k(a,r){if(this.f.get(a)instanceof L.$3h)this.f.set(a,r);else if(this.h)this.h.k(a,r);else throw new Error("illegalState - setting UNKNOWN service instance")}l(a){const r=this.f.get(a);return!r&&this.h?this.h.l(a):r}m(a,r){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(a));const n=this.l(a);return n instanceof L.$3h?this.q(a,n,r.branch(a,!0)):(r.branch(a,!1),n)}q(a,r,n){if(this.o.has(a))throw new Error(`illegal state - RECURSIVELY instantiating service '${a}'`);this.o.add(a);try{return this.r(a,r,n)}finally{this.o.delete(a)}}r(a,r,n){const o=new R.$Dq(t=>t.id.toString());let c=0;const h=[{id:a,desc:r,_trace:n}];for(;h.length;){const t=h.pop();if(o.lookupOrInsertNode(t),c++>1e3)throw new k(o);for(const u of $._util.getServiceDependencies(t.desc.ctor)){const i=this.l(u.id);if(i||this.u(`[createInstance] ${a} depends on ${u.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(u.id)),i instanceof L.$3h){const g={id:u.id,desc:i,_trace:t._trace.branch(u.id,!0)};o.insertEdge(t,g),h.push(g)}}}for(;;){const t=o.roots();if(t.length===0){if(!o.isEmpty())throw new k(o);break}for(const{data:u}of t){if(this.l(u.id)instanceof L.$3h){const g=this.s(u.id,u.desc.ctor,u.desc.staticArguments,u.desc.supportsDelayedInstantiation,u._trace);this.k(u.id,g)}o.removeNode(u)}}return this.l(a)}s(a,r,n=[],o,c){if(this.f.get(a)instanceof L.$3h)return this.t(a,r,n,o,c);if(this.h)return this.h.s(a,r,n,o,c);throw new Error(`illegalState - creating UNKNOWN service instance ${r.name}`)}t(a,r,n=[],o,c){if(o){const h=new l(void 0,this.g,this,this.i);h.c=String(a);const t=new Map,u=new y.$mh(()=>{const i=h.j(r,n,c);for(const[g,m]of t){const d=i[g];if(typeof d=="function")for(const S of m)S.disposable=d.apply(i,S.listener)}return t.clear(),i});return new Proxy(Object.create(null),{get(i,g){if(!u.isInitialized&&typeof g=="string"&&(g.startsWith("onDid")||g.startsWith("onWill"))){let S=t.get(g);return S||(S=new b.$4c,t.set(g,S)),(v,E,D)=>{if(u.isInitialized)return u.value[g](v,E,D);{const N={listener:[v,E,D],disposable:void 0},O=S.push(N);return(0,C.$Rc)(()=>{O(),N.disposable?.dispose()})}}}if(g in i)return i[g];const m=u.value;let d=m[g];return typeof d!="function"||(d=d.bind(m),i[g]=d),d},set(i,g,m){return u.value[g]=m,!0},getPrototypeOf(i){return r.prototype}})}else return this.j(r,n,c)}u(a,r){if(r&&console.warn(a),this.g)throw new Error(a)}}e.$Eq=l;var p;(function(s){s[s.None=0]="None",s[s.Creation=1]="Creation",s[s.Invocation=2]="Invocation",s[s.Branch=3]="Branch"})(p||(p={}));class w{static{this.all=new Set}static{this.c=new class extends w{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(a,r){return a?new w(2,r.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):w.c}static traceCreation(a,r){return a?new w(1,r.name):w.c}static{this.f=0}constructor(a,r){this.type=a,this.name=r,this.g=Date.now(),this.h=[]}branch(a,r){const n=new w(3,a.toString());return this.h.push([a,r,n]),n}stop(){const a=Date.now()-this.g;w.f+=a;let r=!1;function n(c,h){const t=[],u=new Array(c+1).join("	");for(const[i,g,m]of h.h)if(g&&m){r=!0,t.push(`${u}CREATES -> ${i}`);const d=n(c+1,m);d&&t.push(d)}else t.push(`${u}uses -> ${i}`);return t.join(`
`)}const o=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${n(1,this)}`,`DONE, took ${a.toFixed(2)}ms (grand total ${w.f.toFixed(2)}ms)`];(a>2||r)&&w.all.add(o.join(`
`))}}e.$Fq=w}),define(Pe[14],Re([1,0,40,5,98,6,28,21,25,16,2,35,4]),function(ge,e,y,T,C,L,R,$,f,b,A,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.log=e.$qj=e.LogLevel=e.$pj=e.$oj=e.$nj=void 0,e.$nj=(0,l.$6h)("logService"),e.$oj=(0,l.$6h)("loggerService");function p(){return new Date().toISOString()}function w(v){return(0,b.$Mf)(v)}e.$pj=w;var s;(function(v){v[v.Off=0]="Off",v[v.Trace=1]="Trace",v[v.Debug=2]="Debug",v[v.Info=3]="Info",v[v.Warning=4]="Warning",v[v.Error=5]="Error"})(s||(e.LogLevel=s={})),e.$qj=s.Info;function a(v,E,D){switch(E){case s.Trace:v.trace(D);break;case s.Debug:v.debug(D);break;case s.Info:v.info(D);break;case s.Warning:v.warn(D);break;case s.Error:v.error(D);break;case s.Off:break;default:throw new Error(`Invalid log level ${E}`)}}e.log=a;function r(v,E=!1){let D="";for(let N=0;N<v.length;N++){let O=v[N];if(O instanceof Error&&(O=(0,y.$Qi)(O,E)),typeof O=="object")try{O=JSON.stringify(O)}catch{}D+=(N>0?" ":"")+O}return D}class n extends L.$Tc{constructor(){super(...arguments),this.b=e.$qj,this.c=this.B(new T.$Vd),this.onDidChangeLogLevel=this.c.event}setLevel(E){this.b!==E&&(this.b=E,this.c.fire(this.b))}getLevel(){return this.b}f(E){return this.b!==s.Off&&this.b<=E}}e.$sj=n;class o extends n{constructor(E){super(),this.h=E}f(E){return this.h||super.f(E)}trace(E,...D){this.f(s.Trace)&&this.g(s.Trace,r([E,...D],!0))}debug(E,...D){this.f(s.Debug)&&this.g(s.Debug,r([E,...D]))}info(E,...D){this.f(s.Info)&&this.g(s.Info,r([E,...D]))}warn(E,...D){this.f(s.Warning)&&this.g(s.Warning,r([E,...D]))}error(E,...D){if(this.f(s.Error))if(E instanceof Error){const N=Array.prototype.slice.call(arguments);N[0]=E.stack,this.g(s.Error,r(N))}else this.g(s.Error,r([E,...D]))}flush(){}}e.$tj=o;class c extends n{constructor(E=e.$qj){super(),this.setLevel(E),this.g=!$.$i}trace(E,...D){this.f(s.Trace)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,E,...D):console.log(`[main ${p()}]`,E,...D))}debug(E,...D){this.f(s.Debug)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,E,...D):console.log(`[main ${p()}]`,E,...D))}info(E,...D){this.f(s.Info)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,E,...D):console.log(`[main ${p()}]`,E,...D))}warn(E,...D){this.f(s.Warning)&&(this.g?console.warn(`\x1B[93m[main ${p()}]\x1B[0m`,E,...D):console.warn(`[main ${p()}]`,E,...D))}error(E,...D){this.f(s.Error)&&(this.g?console.error(`\x1B[91m[main ${p()}]\x1B[0m`,E,...D):console.error(`[main ${p()}]`,E,...D))}flush(){}}e.$uj=c;class h extends n{constructor(E=e.$qj,D=!0){super(),this.g=D,this.setLevel(E)}trace(E,...D){this.f(s.Trace)&&(this.g?console.log("%cTRACE","color: #888",E,...D):console.log(E,...D))}debug(E,...D){this.f(s.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",E,...D):console.log(E,...D))}info(E,...D){this.f(s.Info)&&(this.g?console.log("%c INFO","color: #33f",E,...D):console.log(E,...D))}warn(E,...D){this.f(s.Warning)&&(this.g?console.log("%c WARN","color: #993",E,...D):console.log(E,...D))}error(E,...D){this.f(s.Error)&&(this.g?console.log("%c  ERR","color: #f33",E,...D):console.error(E,...D))}flush(){}}e.$vj=h;class t extends n{constructor(E,D=e.$qj){super(),this.g=E,this.setLevel(D)}trace(E,...D){this.f(s.Trace)&&this.g.log(s.Trace,[this.h(E),...D])}debug(E,...D){this.f(s.Debug)&&this.g.log(s.Debug,[this.h(E),...D])}info(E,...D){this.f(s.Info)&&this.g.log(s.Info,[this.h(E),...D])}warn(E,...D){this.f(s.Warning)&&this.g.log(s.Warning,[this.h(E),...D])}error(E,...D){this.f(s.Error)&&this.g.log(s.Error,[this.h(E),...D])}h(E){return typeof E=="string"?E:(0,y.$Qi)(E,this.f(s.Trace))}flush(){}}e.$wj=t;class u extends n{constructor(E){super(),this.g=E,E.length&&this.setLevel(E[0].getLevel())}setLevel(E){for(const D of this.g)D.setLevel(E);super.setLevel(E)}trace(E,...D){for(const N of this.g)N.trace(E,...D)}debug(E,...D){for(const N of this.g)N.debug(E,...D)}info(E,...D){for(const N of this.g)N.info(E,...D)}warn(E,...D){for(const N of this.g)N.warn(E,...D)}error(E,...D){for(const N of this.g)N.error(E,...D)}flush(){for(const E of this.g)E.flush()}dispose(){for(const E of this.g)E.dispose();super.dispose()}}e.$xj=u;class i extends L.$Tc{constructor(E,D,N){if(super(),this.h=E,this.j=D,this.b=new R.$Ac,this.c=this.B(new T.$Vd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new T.$Vd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new T.$Vd),this.onDidChangeVisibility=this.g.event,N)for(const O of N)this.b.set(O.resource,{logger:void 0,info:O})}m(E){return(0,b.$If)(E)?[...this.b.values()].find(D=>D.info.id===E):this.b.get(E)}getLogger(E){return this.m(E)?.logger}createLogger(E,D){const N=this.n(E),O=(0,b.$If)(E)?E:D?.id??(0,C.$Ti)(N.toString()).toString(16);let G=this.b.get(N)?.logger;const W=D?.logLevel==="always"?s.Trace:D?.logLevel;G||(G=this.s(N,W??this.getLogLevel(N)??this.h,{...D,id:O}));const z={logger:G,info:{resource:N,id:O,logLevel:W,name:D?.name,hidden:D?.hidden,extensionId:D?.extensionId,when:D?.when}};return this.registerLogger(z.info),this.b.set(N,z),G}n(E){return(0,b.$If)(E)?(0,f.$Hg)(this.j,`${E}.log`):E}setLogLevel(E,D){if(A.URI.isUri(E)){const N=E,O=D,G=this.b.get(N);G&&O!==G.info.logLevel&&(G.info.logLevel=O===this.h?void 0:O,G.logger?.setLevel(O),this.b.set(G.info.resource,G),this.f.fire([N,O]))}else{this.h=E;for(const[N,O]of this.b.entries())this.b.get(N)?.info.logLevel===void 0&&O.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(E,D){const N=this.m(E);N&&D!==!N.info.hidden&&(N.info.hidden=!D,this.b.set(N.info.resource,N),this.g.fire([N.info.resource,D]))}getLogLevel(E){let D;return E&&(D=this.b.get(E)?.info.logLevel),D??this.h}registerLogger(E){const D=this.b.get(E.resource);D?D.info.hidden!==E.hidden&&this.setVisibility(E.resource,!E.hidden):(this.b.set(E.resource,{info:E,logger:void 0}),this.c.fire({added:[E],removed:[]}))}deregisterLogger(E){const D=this.b.get(E);D&&(D.logger&&D.logger.dispose(),this.b.delete(E),this.c.fire({added:[],removed:[D.info]}))}*getRegisteredLoggers(){for(const E of this.b.values())yield E.info}getRegisteredLogger(E){return this.b.get(E)?.info}dispose(){this.b.forEach(E=>E.logger?.dispose()),this.b.clear(),super.dispose()}}e.$yj=i;class g{constructor(){this.onDidChangeLogLevel=new T.$Vd().event}setLevel(E){}getLevel(){return s.Info}trace(E,...D){}debug(E,...D){}info(E,...D){}warn(E,...D){}error(E,...D){}critical(E,...D){}dispose(){}flush(){}}e.$zj=g;class m extends g{}e.$Aj=m;function d(v){if(v.verbose)return s.Trace;if(typeof v.logLevel=="string"){const E=M(v.logLevel.toLowerCase());if(E!==void 0)return E}return e.$qj}e.$Bj=d;function S(v){switch(v){case s.Trace:return"trace";case s.Debug:return"debug";case s.Info:return"info";case s.Warning:return"warn";case s.Error:return"error";case s.Off:return"off"}}e.$Cj=S;function M(v){switch(v){case"trace":return s.Trace;case"debug":return s.Debug;case"info":return s.Info;case"warn":return s.Warning;case"error":return s.Error;case"critical":return s.Error;case"off":return s.Off}}e.$Dj=M,e.$Ej=new k.$kj("logLevel",S(s.Info))}),define(Pe[186],Re([1,0,6,14]),function(ge,e,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uO=void 0;class C extends y.$Tc{constructor(R,$=[]){super(),this.a=new T.$xj([R,...$]),this.B(R.onDidChangeLogLevel(f=>this.setLevel(f)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(R){this.a.setLevel(R)}getLevel(){return this.a.getLevel()}trace(R,...$){this.a.trace(R,...$)}debug(R,...$){this.a.debug(R,...$)}info(R,...$){this.a.info(R,...$)}warn(R,...$){this.a.warn(R,...$)}error(R,...$){this.a.error(R,...$)}flush(){this.a.flush()}}e.$uO=C}),define(Pe[99],Re([1,0,31,154,4]),function(ge,e,y,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$At=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var L;(function(f){f[f.Unnecessary=1]="Unnecessary",f[f.Deprecated=2]="Deprecated"})(L||(e.MarkerTag=L={}));var R;(function(f){f[f.Hint=1]="Hint",f[f.Info=2]="Info",f[f.Warning=4]="Warning",f[f.Error=8]="Error"})(R||(e.MarkerSeverity=R={})),function(f){function b(w,s){return s-w}f.compare=b;const A=Object.create(null);A[f.Error]=(0,T.localize)(0,null),A[f.Warning]=(0,T.localize)(1,null),A[f.Info]=(0,T.localize)(2,null);function k(w){return A[w]||""}f.toString=k;function l(w){switch(w){case y.default.Error:return f.Error;case y.default.Warning:return f.Warning;case y.default.Info:return f.Info;case y.default.Ignore:return f.Hint}}f.fromSeverity=l;function p(w){switch(w){case f.Error:return y.default.Error;case f.Warning:return y.default.Warning;case f.Info:return y.default.Info;case f.Hint:return y.default.Ignore}}f.toSeverity=p}(R||(e.MarkerSeverity=R={}));var $;(function(f){const b="";function A(l){return k(l,!0)}f.makeKey=A;function k(l,p){const w=[b];return l.source?w.push(l.source.replace("\xA6","\\\xA6")):w.push(b),l.code?typeof l.code=="string"?w.push(l.code.replace("\xA6","\\\xA6")):w.push(l.code.value.replace("\xA6","\\\xA6")):w.push(b),l.severity!==void 0&&l.severity!==null?w.push(R.toString(l.severity)):w.push(b),l.message&&p?w.push(l.message.replace("\xA6","\\\xA6")):w.push(b),l.startLineNumber!==void 0&&l.startLineNumber!==null?w.push(l.startLineNumber.toString()):w.push(b),l.startColumn!==void 0&&l.startColumn!==null?w.push(l.startColumn.toString()):w.push(b),l.endLineNumber!==void 0&&l.endLineNumber!==null?w.push(l.endLineNumber.toString()):w.push(b),l.endColumn!==void 0&&l.endColumn!==null?w.push(l.endColumn.toString()):w.push(b),w.push(b),w.join("\xA6")}f.makeKeyOptionalMessage=k})($||(e.IMarkerData=$={})),e.$At=(0,C.$6h)("markerService")}),define(Pe[187],Re([1,0,5,31,4]),function(ge,e,y,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sv=e.$rv=e.NotificationsFilter=e.$qv=e.NeverShowAgainScope=e.NotificationPriority=e.$pv=e.Severity=void 0,e.Severity=T.default,e.$pv=(0,C.$6h)("notificationService");var L;(function(k){k[k.DEFAULT=0]="DEFAULT",k[k.SILENT=1]="SILENT",k[k.URGENT=2]="URGENT"})(L||(e.NotificationPriority=L={}));var R;(function(k){k[k.WORKSPACE=0]="WORKSPACE",k[k.PROFILE=1]="PROFILE",k[k.APPLICATION=2]="APPLICATION"})(R||(e.NeverShowAgainScope=R={}));function $(k){if(k){const l=k;return typeof l.id=="string"&&typeof l.label=="string"}return!1}e.$qv=$;var f;(function(k){k[k.OFF=0]="OFF",k[k.ERROR=1]="ERROR"})(f||(e.NotificationsFilter=f={}));class b{constructor(){this.progress=new A,this.onDidClose=y.Event.None,this.onDidChangeVisibility=y.Event.None}updateSeverity(l){}updateMessage(l){}updateActions(l){}close(){}}e.$rv=b;class A{infinite(){}done(){}total(l){}worked(l){}}e.$sv=A}),define(Pe[188],Re([1,0,4]),function(ge,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gj=e.$Fj=void 0,e.$Fj=(0,y.$6h)("productService"),e.$Gj="vscode://schemas/vscode-product"});var Je=this&&this.__decorate||function(ge,e,y,T){var C=arguments.length,L=C<3?e:T===null?T=Object.getOwnPropertyDescriptor(e,y):T,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(ge,e,y,T);else for(var $=ge.length-1;$>=0;$--)(R=ge[$])&&(L=(C<3?R(L):C>3?R(e,y,L):R(e,y))||L);return C>3&&L&&Object.defineProperty(e,y,L),L},Ke=this&&this.__param||function(ge,e){return function(y,T){e(y,T,ge)}};define(Pe[72],Re([1,0,13,20,6,4]),function(ge,e,y,T,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zv=e.$yv=e.$xv=e.$wv=e.$vv=e.$uv=e.ProgressLocation=e.$tv=void 0,e.$tv=(0,L.$6h)("progressService");var R;(function(k){k[k.Explorer=1]="Explorer",k[k.Scm=3]="Scm",k[k.Extensions=5]="Extensions",k[k.Window=10]="Window",k[k.Notification=15]="Notification",k[k.Dialog=20]="Dialog"})(R||(e.ProgressLocation=R={})),e.$uv=Object.freeze({total(){},worked(){},done(){}});class ${static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(l){this.b=l}report(l){this.a=l,this.b(this.a)}}e.$vv=$;class f{get value(){return this.a}constructor(l){this.e=l}report(l){this.b?this.b.push(l):this.b=[l],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const l=this.b.shift();this.a=l,await this.e(this.a)}}finally{this.c=!1;const l=this.d;this.d=void 0,l?.()}}drain(){return this.c?new Promise(l=>{const p=this.d;this.d=()=>{p?.(),l()}}):Promise.resolve()}}e.$wv=f;let b=class extends C.$Tc{constructor(l,p){super(),this.a=new y.$qh,p.withProgress(l,w=>(this.b=w,this.c&&w.report(this.c),this.a.p)),this.B((0,C.$Rc)(()=>this.a.complete()))}report(l){this.b?this.b.report(l):this.c=l}};e.$xv=b,e.$xv=b=Je([Ke(1,e.$tv)],b);class A extends C.$Tc{constructor(l){super(),this.g=l,this.a=0,this.b=this.B(new C.$Sc)}start(l){this.stop();const p=++this.a,w=new T.$6d;return this.f=setTimeout(()=>{p===this.a&&(this.c=this.g.show(!0))},l),this.b.add((0,C.$Rc)(()=>clearTimeout(this.f))),this.b.add((0,C.$Rc)(()=>w.cancel())),this.b.add((0,C.$Rc)(()=>this.c?this.c.done():void 0)),{id:p,token:w.token,stop:()=>this.h(p),isCurrent:()=>this.a===p}}stop(){this.h(this.a)}h(l){this.a===l&&this.b.clear()}}e.$yv=A,e.$zv=(0,L.$6h)("editorProgressService")}),define(Pe[30],Re([1,0,53,16]),function(ge,e,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hn=void 0;class C{constructor(){this.a=new Map}add(R,$){y.ok(T.$If(R)),y.ok(T.$Kf($)),y.ok(!this.a.has(R),"There is already an extension with this id"),this.a.set(R,$)}knows(R){return this.a.has(R)}as(R){return this.a.get(R)||null}}e.$Hn=new C}),define(Pe[73],Re([1,0,5,30]),function(ge,e,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$In=void 0,e.$In={JSONContribution:"base.contributions.json"};function C($){return $.length>0&&$.charAt($.length-1)==="#"?$.substring(0,$.length-1):$}class L{constructor(){this.b=new y.$Vd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(f,b){this.a[C(f)]=b,this.b.fire(f)}notifySchemaChanged(f){this.b.fire(f)}getSchemaContributions(){return{schemas:this.a}}}const R=new L;T.$Hn.add(e.$In.JSONContribution,R)}),define(Pe[54],Re([1,0,18,5,16,148,46,73,30]),function(ge,e,y,T,C,L,R,$,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2n=e.$1n=e.$Zn=e.$Yn=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.$On=e.$Nn=e.ConfigurationScope=e.$Mn=e.EditPresentationTypes=void 0;var b;(function(h){h.Multiline="multilineText",h.Singleline="singlelineText"})(b||(e.EditPresentationTypes=b={})),e.$Mn={Configuration:"base.contributions.configuration"};var A;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.MACHINE=2]="MACHINE",h[h.WINDOW=3]="WINDOW",h[h.RESOURCE=4]="RESOURCE",h[h.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",h[h.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(A||(e.ConfigurationScope=A={})),e.$Nn={properties:{},patternProperties:{}},e.$On={properties:{},patternProperties:{}},e.$Pn={properties:{},patternProperties:{}},e.$Qn={properties:{},patternProperties:{}},e.$Rn={properties:{},patternProperties:{}},e.$Sn={properties:{},patternProperties:{}},e.$Tn="vscode://schemas/settings/resourceLanguage",e.$Un="vscode://schemas/settings/configurationDefaults";const k=f.$Hn.as($.$In.JSONContribution);class l{constructor(){this.h=new Set,this.i=new T.$Vd,this.onDidSchemaChange=this.i.event,this.j=new T.$Vd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},k.registerSchema(e.$Tn,this.g),this.v()}registerConfiguration(t,u=!0){this.registerConfigurations([t],u)}registerConfigurations(t,u=!0){const i=new Set;this.n(t,u,i),k.registerSchema(e.$Tn,this.g),this.i.fire(),this.j.fire({properties:i})}deregisterConfigurations(t){const u=new Set;this.o(t,u),k.registerSchema(e.$Tn,this.g),this.i.fire(),this.j.fire({properties:u})}updateConfigurations({add:t,remove:u}){const i=new Set;this.o(u,i),this.n(t,!1,i),k.registerSchema(e.$Tn,this.g),this.i.fire(),this.j.fire({properties:i})}registerDefaultConfigurations(t){const u=new Set;this.k(t,u),this.i.fire(),this.j.fire({properties:u,defaultsOverrides:!0})}k(t,u){const i=[];for(const{overrides:g,source:m}of t)for(const d in g)if(u.add(d),e.$Wn.test(d)){const S=this.a.get(d),M=S?.valuesSources??new Map;if(m)for(const N of Object.keys(g[d]))M.set(N,m);const v={...S?.value||{},...g[d]};this.a.set(d,{source:m,value:v,valuesSources:M});const E=(0,R.$Ji)(d),D={type:"object",default:v,description:L.localize(1,null,E),$ref:e.$Tn,defaultDefaultValue:v,source:C.$If(m)?void 0:m,defaultValueSource:m};i.push(...s(d)),this.d[d]=D,this.b.properties[d]=D}else{this.a.set(d,{value:g[d],source:m});const S=this.d[d];S&&(this.w(d,S),this.r(d,S))}this.m(i)}deregisterDefaultConfigurations(t){const u=new Set;this.l(t,u),this.i.fire(),this.j.fire({properties:u,defaultsOverrides:!0})}l(t,u){for(const{overrides:i,source:g}of t)for(const m in i){const d=this.a.get(m),S=C.$If(g)?g:g?.id,M=C.$If(d?.source)?d?.source:d?.source?.id;if(S===M)if(u.add(m),this.a.delete(m),e.$Wn.test(m))delete this.d[m],delete this.b.properties[m];else{const v=this.d[m];v&&(this.w(m,v),this.r(m,v))}}this.u()}deltaConfiguration(t){let u=!1;const i=new Set;t.removedDefaults&&(this.l(t.removedDefaults,i),u=!0),t.addedDefaults&&(this.k(t.addedDefaults,i),u=!0),t.removedConfigurations&&this.o(t.removedConfigurations,i),t.addedConfigurations&&this.n(t.addedConfigurations,!1,i),this.i.fire(),this.j.fire({properties:i,defaultsOverrides:u})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const u of t)this.h.add(u);this.u()}n(t,u,i){t.forEach(g=>{this.p(g,u,g.extensionInfo,g.restrictedProperties,void 0,i),this.c.push(g),this.q(g)})}o(t,u){const i=g=>{if(g.properties)for(const m in g.properties){u.add(m);const d=this.d[m];d?.policy?.name&&this.e.delete(d.policy.name),delete this.d[m],this.s(m,g.properties[m])}g.allOf?.forEach(m=>i(m))};for(const g of t){i(g);const m=this.c.indexOf(g);m!==-1&&this.c.splice(m,1)}}p(t,u=!0,i,g,m=3,d){m=C.$Rf(t.scope)?m:t.scope;const S=t.properties;if(S)for(const v in S){const E=S[v];if(u&&o(v,E)){delete S[v];continue}if(E.source=i,E.defaultDefaultValue=S[v].default,this.w(v,E),e.$Wn.test(v)?E.scope=void 0:(E.scope=C.$Rf(E.scope)?m:E.scope,E.restricted=C.$Rf(E.restricted)?!!g?.includes(v):E.restricted),S[v].hasOwnProperty("included")&&!S[v].included){this.f[v]=S[v],delete S[v];continue}else this.d[v]=S[v],S[v].policy?.name&&this.e.set(S[v].policy.name,v);!S[v].deprecationMessage&&S[v].markdownDeprecationMessage&&(S[v].deprecationMessage=S[v].markdownDeprecationMessage),d.add(v)}const M=t.allOf;if(M)for(const v of M)this.p(v,u,i,g,m,d)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const u=i=>{const g=i.properties;if(g)for(const d in g)this.r(d,g[d]);i.allOf?.forEach(u)};u(t)}r(t,u){switch(e.$Nn.properties[t]=u,u.scope){case 1:e.$On.properties[t]=u;break;case 2:e.$Pn.properties[t]=u;break;case 6:e.$Qn.properties[t]=u;break;case 3:e.$Rn.properties[t]=u;break;case 4:e.$Sn.properties[t]=u;break;case 5:e.$Sn.properties[t]=u,this.g.properties[t]=u;break}}s(t,u){switch(delete e.$Nn.properties[t],u.scope){case 1:delete e.$On.properties[t];break;case 2:delete e.$Pn.properties[t];break;case 6:delete e.$Qn.properties[t];break;case 3:delete e.$Rn.properties[t];break;case 4:case 5:delete e.$Sn.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const u=`[${t}]`,i={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.$Tn};this.w(u,i),e.$Nn.properties[u]=i,e.$On.properties[u]=i,e.$Pn.properties[u]=i,e.$Qn.properties[u]=i,e.$Rn.properties[u]=i,e.$Sn.properties[u]=i}}v(){const t={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.$Tn};e.$Nn.patternProperties[e.$Vn]=t,e.$On.patternProperties[e.$Vn]=t,e.$Pn.patternProperties[e.$Vn]=t,e.$Qn.patternProperties[e.$Vn]=t,e.$Rn.patternProperties[e.$Vn]=t,e.$Sn.patternProperties[e.$Vn]=t,this.i.fire()}w(t,u){const i=this.a.get(t);let g=i?.value,m=i?.source;C.$Pf(g)&&(g=u.defaultDefaultValue,m=void 0),C.$Pf(g)&&(g=r(u.type)),u.default=g,u.defaultValueSource=m}}const p="\\[([^\\]]+)\\]",w=new RegExp(p,"g");e.$Vn=`^(${p})+$`,e.$Wn=new RegExp(e.$Vn);function s(h){const t=[];if(e.$Wn.test(h)){let u=w.exec(h);for(;u?.length;){const i=u[1].trim();i&&t.push(i),u=w.exec(h)}}return(0,y.$Mb)(t)}e.$Xn=s;function a(h){return h.reduce((t,u)=>`${t}[${u}]`,"")}e.$Yn=a;function r(h){switch(Array.isArray(h)?h[0]:h){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$Zn=r;const n=new l;f.$Hn.add(e.$Mn.Configuration,n);function o(h,t){return h.trim()?e.$Wn.test(h)?L.localize(7,null,h):n.getConfigurationProperties()[h]!==void 0?L.localize(8,null,h):t.policy?.name&&n.getPolicyConfigurations().get(t.policy?.name)!==void 0?L.localize(9,null,h,t.policy?.name,n.getPolicyConfigurations().get(t.policy?.name)):null:L.localize(6,null)}e.$1n=o;function c(){const h=[],t=n.getConfigurationProperties();for(const u of Object.keys(t))h.push([u,t[u].scope]);return h.push(["launch",4]),h.push(["task",4]),h}e.$2n=c}),define(Pe[189],Re([1,0,18,5,119,6,28,26,16,2,46,54,30]),function(ge,e,y,T,C,L,R,$,f,b,A,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=void 0;function p(u){return Object.isFrozen(u)?u:$.$wn(u)}class w{constructor(i={},g=[],m=[],d){this.b=i,this.c=g,this.d=m,this.raw=d,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const i=this.raw.map(g=>{if(g instanceof w)return g;const m=new s("");return m.parseRaw(g),m.configurationModel});this.f=i.reduce((g,m)=>m===g?m:g.merge(m),i[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(i){return i?(0,A.$Hi)(this.contents,i):this.contents}inspect(i,g){const m=this.rawConfiguration.getValue(i),d=g?this.rawConfiguration.getOverrideValue(i,g):void 0,S=g?this.rawConfiguration.override(g).getValue(i):m;return{value:m,override:d,merged:S}}getOverrideValue(i,g){const m=this.i(g);return m?i?(0,A.$Hi)(m,i):m:void 0}getKeysForOverrideIdentifier(i){const g=[];for(const m of this.overrides)m.identifiers.includes(i)&&g.push(...m.keys);return y.$Mb(g)}getAllOverrideIdentifiers(){const i=[];for(const g of this.overrides)i.push(...g.identifiers);return y.$Mb(i)}override(i){let g=this.a.get(i);return g||(g=this.g(i),this.a.set(i,g)),g}merge(...i){const g=$.$vn(this.contents),m=$.$vn(this.overrides),d=[...this.keys],S=this.raw?.length?[...this.raw]:[this];for(const M of i)if(S.push(...M.raw?.length?M.raw:[M]),!M.isEmpty()){this.h(g,M.contents);for(const v of M.overrides){const[E]=m.filter(D=>y.$ub(D.identifiers,v.identifiers));E?(this.h(E.contents,v.contents),E.keys.push(...v.keys),E.keys=y.$Mb(E.keys)):m.push($.$vn(v))}for(const v of M.keys)d.indexOf(v)===-1&&d.push(v)}return new w(g,d,m,S.every(M=>M instanceof w)?void 0:S)}g(i){const g=this.i(i);if(!g||typeof g!="object"||!Object.keys(g).length)return this;const m={};for(const d of y.$Mb([...Object.keys(this.contents),...Object.keys(g)])){let S=this.contents[d];const M=g[d];M&&(typeof S=="object"&&typeof M=="object"?(S=$.$vn(S),this.h(S,M)):S=M),m[d]=S}return new w(m,this.keys,this.overrides)}h(i,g){for(const m of Object.keys(g)){if(m in i&&f.$Kf(i[m])&&f.$Kf(g[m])){this.h(i[m],g[m]);continue}i[m]=$.$vn(g[m])}}i(i){let g=null,m=null;const d=S=>{S&&(m?this.h(m,S):m=$.$vn(S))};for(const S of this.overrides)S.identifiers.length===1&&S.identifiers[0]===i?g=S.contents:S.identifiers.includes(i)&&d(S.contents);return d(g),m}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(i,g){this.j(i,g,!0)}setValue(i,g){this.j(i,g,!1)}removeValue(i){const g=this.keys.indexOf(i);g!==-1&&(this.keys.splice(g,1),(0,A.$Gi)(this.contents,i),k.$Wn.test(i)&&this.overrides.splice(this.overrides.findIndex(m=>y.$ub(m.identifiers,(0,k.$Xn)(i))),1))}j(i,g,m){(0,A.$Fi)(this.contents,i,g,d=>console.error(d)),m=m||this.keys.indexOf(i)===-1,m&&this.keys.push(i),k.$Wn.test(i)&&this.overrides.push({identifiers:(0,k.$Xn)(i),keys:Object.keys(this.contents[i]),contents:(0,A.$Ei)(this.contents[i],d=>console.error(d))})}}e.$3n=w;class s{constructor(i){this.f=i,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new w}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(i,g){if(!f.$Rf(i)){const m=this.g(i);this.parseRaw(m,g)}}reparse(i){this.a&&this.parseRaw(this.a,i)}parseRaw(i,g){this.a=i;const{contents:m,keys:d,overrides:S,restricted:M,hasExcludedProperties:v}=this.h(i,g);this.b=new w(m,d,S,v?[i]:void 0),this.c=M||[]}g(i){let g={},m=null,d=[];const S=[],M=[];function v(D){Array.isArray(d)?d.push(D):m!==null&&(d[m]=D)}const E={onObjectBegin:()=>{const D={};v(D),S.push(d),d=D,m=null},onObjectProperty:D=>{m=D},onObjectEnd:()=>{d=S.pop()},onArrayBegin:()=>{const D=[];v(D),S.push(d),d=D,m=null},onArrayEnd:()=>{d=S.pop()},onLiteralValue:v,onError:(D,N,O)=>{M.push({error:D,offset:N,length:O})}};if(i)try{C.$jn(i,E),g=d[0]||{}}catch(D){console.error(`Error while parsing settings file ${this.f}: ${D}`),this.d=[D]}return g}h(i,g){const m=l.$Hn.as(k.$Mn.Configuration).getConfigurationProperties(),d=this.i(i,m,!0,g);i=d.raw;const S=(0,A.$Ei)(i,E=>console.error(`Conflict in settings file ${this.f}: ${E}`)),M=Object.keys(i),v=this.j(i,E=>console.error(`Conflict in settings file ${this.f}: ${E}`));return{contents:S,keys:M,overrides:v,restricted:d.restricted,hasExcludedProperties:d.hasExcludedProperties}}i(i,g,m,d){let S=!1;if(!d?.scopes&&!d?.skipRestricted&&!d?.exclude?.length)return{raw:i,restricted:[],hasExcludedProperties:S};const M={},v=[];for(const E in i)if(k.$Wn.test(E)&&m){const D=this.i(i[E],g,!1,d);M[E]=D.raw,S=S||D.hasExcludedProperties,v.push(...D.restricted)}else{const D=g[E],N=D?typeof D.scope<"u"?D.scope:3:void 0;D?.restricted&&v.push(E),!d.exclude?.includes(E)&&(d.include?.includes(E)||(N===void 0||d.scopes===void 0||d.scopes.includes(N))&&!(d.skipRestricted&&D?.restricted))?M[E]=i[E]:S=!0}return{raw:M,restricted:v,hasExcludedProperties:S}}j(i,g){const m=[];for(const d of Object.keys(i))if(k.$Wn.test(d)){const S={};for(const M in i[d])S[M]=i[d][M];m.push({identifiers:(0,k.$Xn)(d),keys:Object.keys(S),contents:(0,A.$Ei)(S,g)})}return m}}e.$4n=s;class a extends L.$Tc{constructor(i,g,m,d){super(),this.c=i,this.f=g,this.g=d,this.b=this.B(new T.$Vd),this.onDidChange=this.b.event,this.a=new s(this.c.toString()),this.B(this.g.watch(m.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(T.Event.any(T.Event.filter(this.g.onDidFilesChange,S=>S.contains(this.c)),T.Event.filter(this.g.onDidRunOperation,S=>(S.isOperation(0)||S.isOperation(3)||S.isOperation(1)||S.isOperation(4))&&m.isEqual(S.resource,i)))(()=>this.b.fire()))}async loadConfiguration(){try{const i=await this.g.readFile(this.c);return this.a.parse(i.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new w}}reparse(i){return i&&(this.f=i),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$5n=a;class r{constructor(i,g,m,d,S,M,v,E,D,N,O,G,W){this.a=i,this.b=g,this.c=m,this.overrideIdentifiers=d,this.d=S,this.f=M,this.g=v,this.h=E,this.i=D,this.j=N,this.k=O,this.l=G,this.m=W}get value(){return p(this.c)}n(i,g,m){const d=i.inspect(g,m);return{get value(){return p(d.value)},get override(){return p(d.override)},get merged(){return p(d.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class n{constructor(i,g,m,d,S=new w,M=new w,v=new R.$Ac,E=new w,D=new R.$Ac){this.c=i,this.d=g,this.f=m,this.g=d,this.h=S,this.i=M,this.j=v,this.l=E,this.m=D,this.a=null,this.b=new R.$Ac,this.n=null}getValue(i,g,m){return this.p(i,g,m).getValue(i)}updateValue(i,g,m={}){let d;m.resource?(d=this.m.get(m.resource),d||(d=new w,this.m.set(m.resource,d))):d=this.l,g===void 0?d.removeValue(i):d.setValue(i,g),m.resource||(this.a=null)}inspect(i,g,m){const d=this.p(i,g,m),S=this.t(g.resource,m),M=g.resource?this.m.get(g.resource)||this.l:this.l,v=new Set;for(const E of d.overrides)for(const D of E.identifiers)d.getOverrideValue(i,D)!==void 0&&v.add(D);return new r(i,g,d.getValue(i),v.size?[...v]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,m?this.i:void 0,S||void 0,M)}keys(i){const g=this.t(void 0,i);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:g?g.keys.slice(0):[]}}updateDefaultConfiguration(i){this.c=i,this.a=null,this.b.clear()}updatePolicyConfiguration(i){this.d=i}updateApplicationConfiguration(i){this.f=i,this.a=null,this.b.clear()}updateLocalUserConfiguration(i){this.g=i,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(i){this.h=i,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(i){this.i=i,this.a=null,this.b.clear()}updateFolderConfiguration(i,g){this.j.set(i,g),this.b.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this.b.delete(i)}compareAndUpdateDefaultConfiguration(i,g){const m=[];if(!g){const{added:d,updated:S,removed:M}=h(this.c,i);g=[...d,...S,...M]}for(const d of g)for(const S of(0,k.$Xn)(d)){const M=this.c.getKeysForOverrideIdentifier(S),v=i.getKeysForOverrideIdentifier(S),E=[...v.filter(D=>M.indexOf(D)===-1),...M.filter(D=>v.indexOf(D)===-1),...M.filter(D=>!$.$zn(this.c.override(S).getValue(D),i.override(S).getValue(D)))];m.push([S,E])}return this.updateDefaultConfiguration(i),{keys:g,overrides:m}}compareAndUpdatePolicyConfiguration(i){const{added:g,updated:m,removed:d}=h(this.d,i),S=[...g,...m,...d];return S.length&&this.updatePolicyConfiguration(i),{keys:S,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:g,updated:m,removed:d,overrides:S}=h(this.applicationConfiguration,i),M=[...g,...m,...d];return M.length&&this.updateApplicationConfiguration(i),{keys:M,overrides:S}}compareAndUpdateLocalUserConfiguration(i){const{added:g,updated:m,removed:d,overrides:S}=h(this.localUserConfiguration,i),M=[...g,...m,...d];return M.length&&this.updateLocalUserConfiguration(i),{keys:M,overrides:S}}compareAndUpdateRemoteUserConfiguration(i){const{added:g,updated:m,removed:d,overrides:S}=h(this.remoteUserConfiguration,i),M=[...g,...m,...d];return M.length&&this.updateRemoteUserConfiguration(i),{keys:M,overrides:S}}compareAndUpdateWorkspaceConfiguration(i){const{added:g,updated:m,removed:d,overrides:S}=h(this.workspaceConfiguration,i),M=[...g,...m,...d];return M.length&&this.updateWorkspaceConfiguration(i),{keys:M,overrides:S}}compareAndUpdateFolderConfiguration(i,g){const m=this.folderConfigurations.get(i),{added:d,updated:S,removed:M,overrides:v}=h(m,g),E=[...d,...S,...M];return(E.length||!m)&&this.updateFolderConfiguration(i,g),{keys:E,overrides:v}}compareAndDeleteFolderConfiguration(i){const g=this.folderConfigurations.get(i);if(!g)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:m,updated:d,removed:S,overrides:M}=h(g,void 0);return{keys:[...m,...d,...S],overrides:M}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(i,g,m){let d=this.q(g,m);return g.overrideIdentifier&&(d=d.override(g.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(i)!==void 0&&(d=d.merge(this.d)),d}q({resource:i},g){let m=this.r();if(g&&i){const d=g.getFolder(i);d&&(m=this.s(d.uri)||m);const S=this.m.get(i);S&&(m=m.merge(S))}return m}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(i){let g=this.b.get(i);if(!g){const m=this.r(),d=this.j.get(i);d?(g=m.merge(d),this.b.set(i,g)):g=m}return g}t(i,g){if(g&&i){const m=g.getFolder(i);if(m)return this.j.get(m.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((i,g)=>{const{contents:m,overrides:d,keys:S}=this.j.get(g);return i.push([g,{contents:m,overrides:d,keys:S}]),i},[])}}allKeys(){const i=new Set;return this.c.keys.forEach(g=>i.add(g)),this.userConfiguration.keys.forEach(g=>i.add(g)),this.i.keys.forEach(g=>i.add(g)),this.j.forEach(g=>g.keys.forEach(m=>i.add(m))),[...i.values()]}u(){const i=new Set;return this.c.getAllOverrideIdentifiers().forEach(g=>i.add(g)),this.userConfiguration.getAllOverrideIdentifiers().forEach(g=>i.add(g)),this.i.getAllOverrideIdentifiers().forEach(g=>i.add(g)),this.j.forEach(g=>g.getAllOverrideIdentifiers().forEach(m=>i.add(m))),[...i.values()]}v(i){const g=new Set;return this.c.getKeysForOverrideIdentifier(i).forEach(m=>g.add(m)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(m=>g.add(m)),this.i.getKeysForOverrideIdentifier(i).forEach(m=>g.add(m)),this.j.forEach(m=>m.getKeysForOverrideIdentifier(i).forEach(d=>g.add(d))),[...g.values()]}static parse(i){const g=this.w(i.defaults),m=this.w(i.policy),d=this.w(i.application),S=this.w(i.user),M=this.w(i.workspace),v=i.folders.reduce((E,D)=>(E.set(b.URI.revive(D[0]),this.w(D[1])),E),new R.$Ac);return new n(g,m,d,S,new w,M,v,new w,new R.$Ac)}static w(i){return new w(i.contents,i.keys,i.overrides)}}e.$6n=n;function o(...u){if(u.length===0)return{keys:[],overrides:[]};if(u.length===1)return u[0];const i=new Set,g=new Map;for(const d of u)d.keys.forEach(S=>i.add(S)),d.overrides.forEach(([S,M])=>{const v=(0,R.$xc)(g,S,new Set);M.forEach(E=>v.add(E))});const m=[];return g.forEach((d,S)=>m.push([S,[...d.values()]])),{keys:[...i.values()],overrides:m}}e.$7n=o;class c{constructor(i,g,m,d){this.change=i,this.f=g,this.g=m,this.h=d,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const S of i.keys)this.affectedKeys.add(S);for(const[,S]of i.overrides)for(const M of S)this.affectedKeys.add(M);this.d=this.a;for(const S of this.affectedKeys)this.d+=S+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=n.parse(this.f.data)),this.i}affectsConfiguration(i,g){const m=this.a+i,d=this.d.indexOf(m);if(d<0)return!1;const S=d+m.length;if(S>=this.d.length)return!1;const M=this.d.charCodeAt(S);if(M!==this.b&&M!==this.c)return!1;if(g){const v=this.previousConfiguration?this.previousConfiguration.getValue(i,g,this.f?.workspace):void 0,E=this.g.getValue(i,g,this.h);return!$.$zn(v,E)}return!0}}e.$8n=c;function h(u,i){const{added:g,removed:m,updated:d}=t(i?.rawConfiguration,u?.rawConfiguration),S=[],M=u?.getAllOverrideIdentifiers()||[],v=i?.getAllOverrideIdentifiers()||[];if(i){const E=v.filter(D=>!M.includes(D));for(const D of E)S.push([D,i.getKeysForOverrideIdentifier(D)])}if(u){const E=M.filter(D=>!v.includes(D));for(const D of E)S.push([D,u.getKeysForOverrideIdentifier(D)])}if(i&&u){for(const E of M)if(v.includes(E)){const D=t({contents:u.getOverrideValue(void 0,E)||{},keys:u.getKeysForOverrideIdentifier(E)},{contents:i.getOverrideValue(void 0,E)||{},keys:i.getKeysForOverrideIdentifier(E)});S.push([E,[...D.added,...D.removed,...D.updated]])}}return{added:g,removed:m,updated:d,overrides:S}}function t(u,i){const g=u?i?u.keys.filter(S=>i.keys.indexOf(S)===-1):[...u.keys]:[],m=i?u?i.keys.filter(S=>u.keys.indexOf(S)===-1):[...i.keys]:[],d=[];if(u&&i){for(const S of i.keys)if(u.keys.indexOf(S)!==-1){const M=(0,A.$Hi)(i.contents,S),v=(0,A.$Hi)(u.contents,S);$.$zn(M,v)||d.push(S)}}return{added:g,removed:m,updated:d}}}),define(Pe[100],Re([1,0,15,4]),function(ge,e,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_k=e.$$k=e.RemoteAuthorityResolverErrorCode=e.$0k=e.$9k=e.RemoteConnectionType=e.$8k=void 0,e.$8k=(0,T.$6h)("remoteAuthorityResolverService");var C;(function(A){A[A.WebSocket=0]="WebSocket",A[A.Managed=1]="Managed"})(C||(e.RemoteConnectionType=C={}));class L{constructor(k){this.id=k,this.type=1}toString(){return`Managed(${this.id})`}}e.$9k=L;class R{constructor(k,l){this.host=k,this.port=l,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$0k=R;var $;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound",A.InvalidAuthority="InvalidAuthority"})($||(e.RemoteAuthorityResolverErrorCode=$={}));class f extends y.$bb{static isNotAvailable(k){return k instanceof f&&k._code===$.NotAvailable}static isTemporarilyNotAvailable(k){return k instanceof f&&k._code===$.TemporarilyNotAvailable}static isNoResolverFound(k){return k instanceof f&&k._code===$.NoResolverFound}static isInvalidAuthority(k){return k instanceof f&&k._code===$.InvalidAuthority}static isHandled(k){return k instanceof f&&k.isHandled}constructor(k,l=$.Unknown,p){super(k),this._message=k,this._code=l,this._detail=p,this.isHandled=l===$.NotAvailable&&p===!0,Object.setPrototypeOf(this,f.prototype)}}e.$$k=f;function b(A){const k=A.indexOf("+");return k===-1?A:A.substring(0,k)}e.$_k=b}),define(Pe[55],Re([1,0,12]),function(ge,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$el=e.$dl=e.$cl=e.$bl=e.$al=void 0;function T(b){return b.scheme===y.Schemas.vscodeRemote?b.authority:void 0}e.$al=T;function C(b){if(!b)return;const A=b.indexOf("+");return A<0?b:b.substr(0,A)}e.$bl=C;function L(b){return`/${b.quality??"oss"}-${b.commit??"dev"}`}e.$cl=L;function R(b){const{host:A,port:k}=f(b);if(typeof k>"u")throw new Error(`Invalid remote authority: ${b}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:A,port:k}}e.$dl=R;function $(b,A){let{host:k,port:l}=f(b);return typeof l>"u"&&(l=A),{host:k,port:l}}e.$el=$;function f(b){const A=b.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(A)return{host:A[1],port:parseInt(A[2],10)};const k=b.match(/^(\[[0-9a-z:]+\])$/);if(k)return{host:k[1],port:void 0};const l=b.match(/(.*):(\d+)$/);return l?{host:l[1],port:parseInt(l[2],10)}:{host:b,port:void 0}}}),define(Pe[22],Re([1,0,11,4,55]),function(ge,e,y,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sm=e.$rm=e.$qm=e.$pm=e.$om=e.$nm=e.$mm=e.$lm=e.TargetPlatform=e.ExtensionType=e.$km=e.$jm=e.$im=e.$hm=e.$gm=e.$fm=void 0,e.$fm="extensions.user.cache",e.$gm="extensions.builtin.cache",e.$hm="undefined_publisher",e.$im=["ui","workspace","web"];function L(s){if(typeof s=="object"&&s!==null&&s.supported!==!0)return s.description}e.$jm=L,e.$km=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(s){s[s.System=0]="System",s[s.User=1]="User"})(R||(e.ExtensionType=R={}));var $;(function(s){s.WIN32_X64="win32-x64",s.WIN32_ARM64="win32-arm64",s.LINUX_X64="linux-x64",s.LINUX_ARM64="linux-arm64",s.LINUX_ARMHF="linux-armhf",s.ALPINE_X64="alpine-x64",s.ALPINE_ARM64="alpine-arm64",s.DARWIN_X64="darwin-x64",s.DARWIN_ARM64="darwin-arm64",s.WEB="web",s.UNIVERSAL="universal",s.UNKNOWN="unknown",s.UNDEFINED="undefined"})($||(e.TargetPlatform=$={}));class f{constructor(a){this.value=a,this._lower=a.toLowerCase()}static equals(a,r){if(typeof a>"u"||a===null)return typeof r>"u"||r===null;if(typeof r>"u"||r===null)return!1;if(typeof a=="string"||typeof r=="string"){const n=typeof a=="string"?a:a.value,o=typeof r=="string"?r:r.value;return y.$_e(n,o)}return a._lower===r._lower}static toKey(a){return typeof a=="string"?a.toLowerCase():a._lower}}e.$lm=f;class b{get size(){return this.c.size}constructor(a){if(this.c=new Set,a)for(const r of a)this.add(r)}add(a){this.c.add(f.toKey(a))}delete(a){return this.c.delete(f.toKey(a))}has(a){return this.c.has(f.toKey(a))}}e.$mm=b;class A{constructor(){this.c=new Map}clear(){this.c.clear()}delete(a){this.c.delete(f.toKey(a))}get(a){return this.c.get(f.toKey(a))}has(a){return this.c.has(f.toKey(a))}set(a,r){this.c.set(f.toKey(a),r)}values(){return this.c.values()}forEach(a){this.c.forEach(a)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$nm=A;function k(s){return l(s)}e.$om=k;function l(s){return s.contributes&&s.contributes.localizations?s.contributes.localizations.length>0:!1}e.$pm=l;function p(s){return s.contributes&&s.contributes.authentication?s.contributes.authentication.length>0:!1}e.$qm=p;function w(s,a){if(a){const r=`onResolveRemoteAuthority:${(0,C.$bl)(a)}`;return!!s.activationEvents?.includes(r)}return!1}e.$rm=w,e.$sm=(0,T.$6h)("IBuiltinExtensionsScannerService")}),define(Pe[101],Re([1,0,15,22]),function(ge,e,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hF=e.$gF=void 0;class C{constructor(){this.a=new Map,this.b=new WeakMap}register(R,$){this.a.set(R,$)}readActivationEvents(R){return this.b.has(R)||this.b.set(R,this.c(R)),this.b.get(R)}createActivationEventsMap(R){const $=Object.create(null);for(const f of R){const b=this.readActivationEvents(f);b.length>0&&($[T.$lm.toKey(f.identifier)]=b)}return $}c(R){if(typeof R.main>"u"&&typeof R.browser>"u")return[];const $=Array.isArray(R.activationEvents)?R.activationEvents.slice(0):[];for(let f=0;f<$.length;f++)$[f]==="onUri"&&($[f]=`onUri:${T.$lm.toKey(R.identifier)}`);if(!R.contributes)return $;for(const f in R.contributes){const b=this.a.get(f);if(!b)continue;const A=R.contributes[f],k=Array.isArray(A)?A:[A];try{b(k,$)}catch(l){(0,y.$1)(l)}}return $}}e.$gF=C,e.$hF=new C}),define(Pe[190],Re([1,0,21,74,33]),function(ge,e,y,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ko=e.$Jo=void 0;function L(f){if(y.$u===2&&/^penguin(\.|$)/i.test(f))return"chromebook"}function R(f,b,A,k,l,p,w,s,a){const r=Object.create(null);r["common.machineId"]=p,r["common.sqmId"]=w,r.sessionID=(0,C.$qg)()+Date.now(),r.commitHash=k,r.version=l,r["common.platformVersion"]=(f||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),r["common.platform"]=(0,y.$h)(y.$u),r["common.nodePlatform"]=T.$dc,r["common.nodeArch"]=A,r["common.product"]=a||"desktop",s&&(r["common.msftInternal"]=s);let n=0;const o=Date.now();Object.defineProperties(r,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-o,enumerable:!0},"common.sequence":{get:()=>n++,enumerable:!0}}),y.$l&&(r["common.snap"]="true");const c=L(b);return c&&(r["common.platformDetail"]=c),r}e.$Jo=R;function $(f){const b=T.env.USERDNSDOMAIN;if(!b)return!1;const A=b.toLowerCase();return f.some(k=>A===k)}e.$Ko=$}),define(Pe[191],Re([1,0,4]),function(ge,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$El=e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=e.$wl=e.$vl=e.$ul=void 0,e.$ul=(0,y.$6h)("telemetryService"),e.$vl=(0,y.$6h)("customEndpointTelemetryService"),e.$wl="telemetry.currentSessionDate",e.$xl="telemetry.firstSessionDate",e.$yl="telemetry.lastSessionDate",e.$zl="telemetry.machineId",e.$Al="telemetry.sqmId",e.$Bl="telemetry",e.$Cl="telemetry.telemetryLevel",e.$Dl="telemetry.enableCrashReporter",e.$El="telemetry.enableTelemetry";var T;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(T||(e.TelemetryLevel=T={}));var C;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(C||(e.TelemetryConfiguration=C={}))}),define(Pe[56],Re([1,0,26,16,55,190,191]),function(ge,e,y,T,C,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=e.$Mo=e.$Lo=void 0;class ${constructor(u){this.value=u,this.isTrustedTelemetryValue=!0}}e.$Lo=$;class f{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$Mo=f,e.$No=new f;class b{async publicLog(u,i,g){}async publicLogError(u,i,g){}}e.$Oo=b,e.$Po="telemetry",e.$Qo="extensionTelemetryLog",e.$Ro={log:()=>null,flush:()=>Promise.resolve(null)};function A(t,u){return!u.isBuilt&&!u.disableTelemetry?!0:!(u.disableTelemetry||!t.enableTelemetry)}e.$So=A;function k(t,u){return u.extensionTestsLocationURI?!0:!(u.isBuilt||u.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}e.$To=k;function l(t){const u=t.getValue(R.$Cl),i=t.getValue(R.$Dl);if(t.getValue(R.$El)===!1||i===!1)return 0;switch(u??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$Uo=l;function p(t){const u={},i={},g={};a(t,g);for(let m in g){m=m.length>150?m.substr(m.length-149):m;const d=g[m];typeof d=="number"?i[m]=d:typeof d=="boolean"?i[m]=d?1:0:typeof d=="string"?(d.length>8192&&console.warn(`Telemetry property: ${m} has been trimmed to 8192, the original length is ${d.length}`),u[m]=d.substring(0,8191)):typeof d<"u"&&d!==null&&(u[m]=d)}return{properties:u,measurements:i}}e.$Vo=p;const w=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function s(t){if(!t)return"none";const u=(0,C.$bl)(t);return w.has(u)?u:"other"}e.$Wo=s;function a(t,u,i=0,g){if(t)for(const m of Object.getOwnPropertyNames(t)){const d=t[m],S=g?g+m:m;Array.isArray(d)?u[S]=(0,y.$An)(d):d instanceof Date?u[S]=d.toISOString():(0,T.$Kf)(d)?i<2?a(d,u,i+1,S+"."):u[S]=(0,y.$An)(d):u[S]=d}}function r(t,u){const i=t.msftInternalDomains||[],g=u.getValue("telemetry.internalTesting");return(0,L.$Ko)(i)||g}e.$Xo=r;function n(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}e.$Yo=n;function o(t,u){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let i=t;const g=[];for(const M of u)for(;;){const v=M.exec(t);if(!v)break;g.push([v.index,M.lastIndex])}const m=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,d=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let S=0;for(i="";;){const M=d.exec(t);if(!M)break;const v=g.some(([E,D])=>M.index<D&&E<d.lastIndex);!m.test(M[0])&&!v&&(i+=t.substring(S,M.index)+"<REDACTED: user-file-path>",S=d.lastIndex)}return S<t.length&&(i+=t.substr(S)),i}function c(t){if(!t)return t;const u=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const i of u)if(i.regex.test(t))return`<REDACTED: ${i.label}>`;return t}function h(t,u){return(0,y.$xn)(t,i=>{if(i instanceof $||Object.hasOwnProperty.call(i,"isTrustedTelemetryValue"))return i.value;if(typeof i=="string"){let g=i.replaceAll("%20"," ");g=o(g,u);for(const m of u)g=g.replace(m,"");return g=c(g),g}})}e.$Zo=h}),define(Pe[192],Re([1,0,11,97,22,21,2,15,74,56]),function(ge,e,y,T,C,L,R,$,f,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=e.$2o=e.$1o=void 0;function A(i,g){return i.uuid&&g.uuid?i.uuid===g.uuid:i.id===g.id?!0:(0,y.$7e)(i.id,g.id)===0}e.$1o=A;const k=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class l{static create(g){const m=g.manifest?g.manifest.version:g.version,d=g.manifest?g.targetPlatform:g.properties.targetPlatform;return new l(g.identifier,m,d)}static parse(g){const m=k.exec(g);return m&&m[1]&&m[2]?new l({id:m[1]},m[2],m[4]||void 0):null}constructor(g,m,d="undefined"){this.version=m,this.targetPlatform=d,this.id=g.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(g){return g instanceof l?A(this,g)&&this.version===g.version&&this.targetPlatform===g.targetPlatform:!1}}e.$2o=l;const p=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function w(i){const g=p.exec(i);return g&&g[1]?[a(g[1]),g[2]]:[a(i),void 0]}e.$3o=w;function s(i,g){return`${i}.${g}`}e.$4o=s;function a(i){return i.toLowerCase()}e.$5o=a;function r(i,g){return a(s(i??C.$hm,g))}e.$6o=r;function n(i,g){const m=[],d=S=>{for(const M of m)if(M.some(v=>A(g(v),g(S))))return M;return null};for(const S of i){const M=d(S);M?M.push(S):m.push([S])}return m}e.$7o=n;function o(i){return{id:i.identifier.id,name:i.manifest.name,galleryId:null,publisherId:i.publisherId,publisherName:i.manifest.publisher,publisherDisplayName:i.publisherDisplayName,dependencies:i.manifest.extensionDependencies&&i.manifest.extensionDependencies.length>0}}e.$8o=o;function c(i){return{id:new b.$Lo(i.identifier.id),name:new b.$Lo(i.name),galleryId:i.identifier.uuid,publisherId:i.publisherId,publisherName:i.publisher,publisherDisplayName:i.publisherDisplayName,isPreReleaseVersion:i.properties.isPreReleaseVersion,dependencies:!!(i.properties.dependencies&&i.properties.dependencies.length>0),isSigned:i.isSigned,...i.telemetryData}}e.$9o=c,e.$0o=new C.$lm("pprice.better-merge");function h(i,g){const m=[],d=g.manifest.extensionDependencies?.slice(0)??[];for(;d.length;){const S=d.shift();if(S&&m.every(M=>!A(M.identifier,{id:S}))){const M=i.filter(v=>A(v.identifier,{id:S}));M.length===1&&(m.push(M[0]),d.push(...M[0].manifest.extensionDependencies?.slice(0)??[]))}}return m}e.$$o=h;async function t(i,g){if(!L.$k)return!1;let m;try{m=(await i.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{m=(await i.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch(S){g.debug("Error while getting the os-release file.",(0,$.$0)(S))}}return!!m&&(m.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function u(i,g){const m=await t(i,g),d=(0,T.$uo)(m?"alpine":L.$u,f.$ec);return g.debug("ComputeTargetPlatform:",d),d}e.$_o=u}),define(Pe[193],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rr=e.$Qr=e.$Pr=e.$Or=e.$Nr=e.$Mr=void 0;function y(f){return[...f.entries()]}e.$Mr=y;function T(f){return f?[...f.entries()]:[]}e.$Nr=T;function C(f){return new Map(f)}e.$Or=C;function L(f){return new Map(f??[])}e.$Pr=L;function R(f){return Array.from(f.entries()).map(b=>[b[0],y(b[1].map),T(b[1].descriptionMap)])}e.$Qr=R;function $(f){return new Map(f.map(b=>[b[0],{map:C(b[1]),descriptionMap:L(b[2])}]))}e.$Rr=$}),define(Pe[194],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Krb=void 0;class y{constructor(C){this.b=C,this.a=new Map}dispose(){for(const C of this.a.values())C.dispose()}startBuffering(C,L,R=5){const $=L(f=>{const b=typeof f=="string"?f:f.data;let A=this.a.get(C);if(A){A.data.push(b);return}const k=setTimeout(()=>this.flushBuffer(C),R);A={data:[b],timeoutId:k,dispose:()=>{clearTimeout(k),this.flushBuffer(C),$.dispose()}},this.a.set(C,A)});return $}stopBuffering(C){this.a.get(C)?.dispose()}flushBuffer(C){const L=this.a.get(C);L&&(this.a.delete(C),this.b(C,L.data.join("")))}}e.$Krb=y}),define(Pe[195],Re([1,0,13,90,44,5,16,2,155,73,30]),function(ge,e,y,T,C,L,R,$,f,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ew=e.$Dw=e.$Cw=e.$Bw=e.$Aw=e.$zw=e.$yw=e.$xw=e.IconFontDefinition=e.IconContribution=e.$ww=void 0,e.$ww={IconContribution:"base.contributions.icons"};var k;(function(c){function h(t,u){let i=t.defaults;for(;C.ThemeIcon.isThemeIcon(i);){const g=w.getIcon(i.id);if(!g)return;i=g.defaults}return i}c.getDefinition=h})(k||(e.IconContribution=k={}));var l;(function(c){function h(u){return{weight:u.weight,style:u.style,src:u.src.map(i=>({format:i.format,location:i.location.toString()}))}}c.toJSONObject=h;function t(u){const i=g=>(0,R.$If)(g)?g:void 0;if(u&&Array.isArray(u.src)&&u.src.every(g=>(0,R.$If)(g.format)&&(0,R.$If)(g.location)))return{weight:i(u.weight),style:i(u.style),src:u.src.map(g=>({format:g.format,location:$.URI.parse(g.location)}))}}c.fromJSONObject=t})(l||(e.IconFontDefinition=l={}));class p{constructor(){this.a=new L.$Vd,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,f.localize)(0,null)},fontCharacter:{type:"string",description:(0,f.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${C.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(h,t,u,i){const g=this.b[h];if(g){if(u&&!g.description){g.description=u,this.d.properties[h].markdownDescription=`${u} $(${h})`;const S=this.e.enum.indexOf(h);S!==-1&&(this.e.enumDescriptions[S]=u),this.a.fire()}return g}const m={id:h,description:u,defaults:t,deprecationMessage:i};this.b[h]=m;const d={$ref:"#/definitions/icons"};return i&&(d.deprecationMessage=i),u&&(d.markdownDescription=`${u}: $(${h})`),this.d.properties[h]=d,this.e.enum.push(h),this.e.enumDescriptions.push(u||""),this.a.fire(),{id:h}}deregisterIcon(h){delete this.b[h],delete this.d.properties[h];const t=this.e.enum.indexOf(h);t!==-1&&(this.e.enum.splice(t,1),this.e.enumDescriptions.splice(t,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(h=>this.b[h])}getIcon(h){return this.b[h]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(h,t){const u=this.f[h];return u||(this.f[h]=t,this.a.fire(),t)}deregisterIconFont(h){delete this.f[h]}getIconFont(h){return this.f[h]}toString(){const h=(g,m)=>g.id.localeCompare(m.id),t=g=>{for(;C.ThemeIcon.isThemeIcon(g.defaults);)g=this.b[g.defaults.id];return`codicon codicon-${g?g.id:""}`},u=[];u.push("| preview     | identifier                        | default codicon ID                | description"),u.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const i=Object.keys(this.b).map(g=>this.b[g]);for(const g of i.filter(m=>!!m.description).sort(h))u.push(`|<i class="${t(g)}"></i>|${g.id}|${C.ThemeIcon.isThemeIcon(g.defaults)?g.defaults.id:g.id}|${g.description||""}|`);u.push("| preview     | identifier                        "),u.push("| ----------- | --------------------------------- |");for(const g of i.filter(m=>!C.ThemeIcon.isThemeIcon(m.defaults)).sort(h))u.push(`|<i class="${t(g)}"></i>|${g.id}|`);return u.join(`
`)}}const w=new p;A.$Hn.add(e.$ww.IconContribution,w);function s(c,h,t,u){return w.registerIcon(c,h,t,u)}e.$xw=s;function a(){return w}e.$yw=a;function r(){const c=(0,T.$0j)();for(const h in c){const t="\\"+c[h].toString(16);w.registerIcon(h,{fontCharacter:t})}}r(),e.$zw="vscode://schemas/icons";const n=A.$Hn.as(b.$In.JSONContribution);n.registerSchema(e.$zw,w.getIconSchema());const o=new y.$fh(()=>n.notifySchemaChanged(e.$zw),200);w.onDidChange(()=>{o.isScheduled()||o.schedule()}),e.$Aw=s("widget-close",T.$_j.close,(0,f.localize)(2,null)),e.$Bw=s("goto-previous-location",T.$_j.arrowUp,(0,f.localize)(3,null)),e.$Cw=s("goto-next-location",T.$_j.arrowDown,(0,f.localize)(4,null)),e.$Dw=C.ThemeIcon.modify(T.$_j.sync,"spin"),e.$Ew=C.ThemeIcon.modify(T.$_j.loading,"spin")}),define(Pe[196],Re([1,0,5,46,4,14]),function(ge,e,y,T,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kv=e.$Jv=e.$Iv=e.$Hv=e.$Gv=e.$Fv=e.$Ev=e.$Dv=e.ProvidedOnAutoForward=e.$Cv=e.TunnelPrivacyId=e.TunnelProtocol=e.$Bv=e.$Av=void 0,e.$Av=(0,C.$6h)("tunnelService"),e.$Bv=(0,C.$6h)("sharedTunnelsService");var R;(function(a){a.Http="http",a.Https="https"})(R||(e.TunnelProtocol=R={}));var $;(function(a){a.ConstantPrivate="constantPrivate",a.Private="private",a.Public="public"})($||(e.TunnelPrivacyId=$={}));function f(a){return!!a.forwardPort}e.$Cv=f;var b;(function(a){a[a.Notify=1]="Notify",a[a.OpenBrowser=2]="OpenBrowser",a[a.OpenPreview=3]="OpenPreview",a[a.Silent=4]="Silent",a[a.Ignore=5]="Ignore",a[a.OpenBrowserOnce=6]="OpenBrowserOnce"})(b||(e.ProvidedOnAutoForward=b={}));function A(a){if(a.scheme!=="http"&&a.scheme!=="https")return;const r=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(a.authority);if(r)return{address:r[1],port:+r[2]}}e.$Dv=A,e.$Ev=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function k(a){return e.$Ev.indexOf(a)>=0}e.$Fv=k,e.$Gv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function l(a){return e.$Gv.indexOf(a)>=0}e.$Hv=l;function p(a,r,n,o){if(n===1)return!1;if(n===2&&l(r)){const c=/(\d+)\.(\d+)\.(\d+)/g.exec(o);if(c?.length===4&&parseInt(c[1])>=18)return!1}return a<1024}e.$Iv=p;class w{constructor(r,n,o){this.remoteAddress=r,this.localAddress=n,this.b=o,this.a=new y.$Vd,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Jv=w;let s=class{constructor(r,n){this.k=r,this.l=n,this.a=new y.$Vd,this.onTunnelOpened=this.a.event,this.b=new y.$Vd,this.onTunnelClosed=this.b.event,this.c=new y.$Vd,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const r=this.l.getValue("remote.localPortHost");return!r||r==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(r){return this.f=r,r?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(r){this.g=r.elevation,this.i=r.privacyOptions,this.h=r.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const r=[],n=Array.from(this.e.values());for(const o of n){const c=Array.from(o.values());for(const h of c){const t=await h.value;t&&typeof t!="string"&&r.push(t)}}return r}async dispose(){for(const r of this.e.values()){for(const{value:n}of r.values())await n.then(o=>typeof o!="string"?o?.dispose():void 0);r.clear()}this.e.clear()}setEnvironmentTunnel(r,n,o,c,h){this.q(r,n,Promise.resolve({tunnelRemoteHost:r,tunnelRemotePort:n,localAddress:o,privacy:c,protocol:h,dispose:()=>Promise.resolve()}))}async getExistingTunnel(r,n){(l(r)||k(r))&&(r=e.$Ev[0]);const o=this.s(r,n);if(o)return++o.refcount,o.value}openTunnel(r,n,o,c,h,t=!1,u,i){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${n}:${o} on local port ${h}.`);const g=this.f??r;if(!g)return;if(n||(n="localhost"),c||(c=this.m),this.f&&this.j.has(o)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const m=this.t(g,n,o,c,h,t,u,i);return m?m.then(d=>{if(d){if(typeof d=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(n,o),d}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(n,o);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const S=this.o(d);return(d.tunnelRemoteHost!==n||d.tunnelRemotePort!==o)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),u&&d.privacy!==u&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(S),S}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),m)}o(r){return{tunnelRemotePort:r.tunnelRemotePort,tunnelRemoteHost:r.tunnelRemoteHost,tunnelLocalPort:r.tunnelLocalPort,localAddress:r.localAddress,privacy:r.privacy,protocol:r.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${r.tunnelRemoteHost}:${r.tunnelRemotePort} `);const n=this.e.get(r.tunnelRemoteHost);if(n){const o=n.get(r.tunnelRemotePort);o&&(o.refcount--,await this.p(r.tunnelRemoteHost,r.tunnelRemotePort,o))}}}}async p(r,n,o){if(o.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${r}:${n}.`);const c=o.value.then(async h=>{h&&typeof h!="string"&&(await h.dispose(!0),this.b.fire({host:h.tunnelRemoteHost,port:h.tunnelRemotePort}))});return this.e.has(r)&&this.e.get(r).delete(n),c}}async closeTunnel(r,n){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${r}:${n} `);const o=this.e.get(r);if(o&&o.has(n)){const c=o.get(n);c.refcount=0,await this.p(r,n,c)}}q(r,n,o){this.e.has(r)||this.e.set(r,new Map),this.e.get(r).set(n,{refcount:1,value:o})}async r(r,n){const o=this.e.get(r);if(o){const c=o.get(n),h=c?await c.value:void 0;(!h||typeof h=="string")&&o.delete(n),o.size===0&&this.e.delete(r)}}s(r,n){const o=[r];k(r)?(o.push(...e.$Ev),o.push(...e.$Gv)):l(r)&&o.push(...e.$Gv);const c=o.map(h=>this.e.get(h));for(const h of c){const t=h?.get(n);if(t)return t}}canTunnel(r){return!!A(r)}u(r,n,o,c,h,t,u){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${n}:${o} on local port ${c}.`);const i=o;this.j.add(i);const g=c===void 0?o:c,m={elevationRequired:h?this.isPortPrivileged(g):!1},d={remoteAddress:{host:n,port:o},localAddressPort:c,privacy:t,public:t?t!==$.Private:void 0,protocol:u},S=r.forwardPort(d,m);return S?(this.q(n,o,S),S.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(i)})):this.j.delete(i),S}};e.$Kv=s,e.$Kv=s=Je([Ke(0,L.$nj),Ke(1,T.$zi)],s)}),define(Pe[197],Re([1,0,4]),function(ge,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$Lv=void 0,e.$Lv=(0,y.$6h)("editSessionIdentityService");var T;(function(C){C[C.Complete=100]="Complete",C[C.Partial=50]="Partial",C[C.None=0]="None"})(T||(e.EditSessionIdentityMatch=T={}))}),define(Pe[198],Re([1,0,12]),function(ge,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GK=e.$FK=e.$EK=e.$DK=e.$CK=void 0;function T(f){return f.scheme!==y.Schemas.file&&f.scheme!==y.Schemas.vscodeRemote}e.$CK=T;function C(f){if(f.folders.length)return f.folders.every(b=>T(b.uri))?f.folders[0].uri:void 0;if(f.configuration&&T(f.configuration))return f.configuration}e.$DK=C;function L(f){return C(f)?.scheme}e.$EK=L;function R(f){return C(f)?.authority}e.$FK=R;function $(f){return C(f)!==void 0}e.$GK=$}),define(Pe[47],Re([1,0,156,19,50,25,2,4,12]),function(ge,e,y,T,C,L,R,$,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.$li=e.$ki=e.WorkbenchState=e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=e.$di=e.$ci=void 0,e.$ci=(0,$.$6h)("contextService");function b(g){const m=g;return typeof m?.id=="string"&&R.URI.isUri(m.uri)}e.$di=b;function A(g){return typeof g?.id=="string"&&!b(g)&&!l(g)}e.$ei=A,e.$fi={id:"ext-dev"},e.$gi={id:"empty-window"};function k(g,m){if(typeof g=="string"||typeof g>"u")return typeof g=="string"?{id:(0,T.$nc)(g)}:m?e.$fi:e.$gi;const d=g;return d.configuration?{id:d.id,configPath:d.configuration}:d.folders.length===1?{id:d.id,uri:d.folders[0].uri}:{id:d.id}}e.$hi=k;function l(g){const m=g;return typeof m?.id=="string"&&R.URI.isUri(m.configPath)}e.$ii=l;function p(g){const m=g;if(m?.uri)return{id:m.id,uri:R.URI.revive(m.uri)};const d=g;if(d?.configPath)return{id:d.id,configPath:R.URI.revive(d.configPath)};if(g?.id)return{id:g.id}}e.$ji=p;var w;(function(g){g[g.EMPTY=1]="EMPTY",g[g.FOLDER=2]="FOLDER",g[g.WORKSPACE=3]="WORKSPACE"})(w||(e.WorkbenchState=w={}));function s(g){const m=g;return!!(m&&typeof m=="object"&&typeof m.id=="string"&&Array.isArray(m.folders))}e.$ki=s;function a(g){const m=g;return!!(m&&typeof m=="object"&&R.URI.isUri(m.uri)&&typeof m.name=="string"&&typeof m.toResource=="function")}e.$li=a;class r{constructor(m,d,S,M,v){this.h=m,this.j=S,this.k=M,this.l=v,this.c=C.$_h.forUris(this.l,()=>!0),this.folders=d}update(m){this.h=m.id,this.k=m.configuration,this.j=m.transient,this.l=m.l,this.folders=m.folders}get folders(){return this.g}set folders(m){this.g=m,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(m){this.k=m}getFolder(m){return m&&this.c.findSubstr(m)||null}n(){this.c=C.$_h.forUris(this.l,()=>!0);for(const m of this.folders)this.c.set(m.uri,m)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$mi=r;class n{constructor(m,d){this.raw=d,this.uri=m.uri,this.index=m.index,this.name=m.name}toResource(m){return(0,L.$Hg)(this.uri,m)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$ni=n;function o(g){return new n({uri:g,index:0,name:(0,L.$Dg)(g)},{uri:g.toString()})}e.$oi=o,e.$pi="code-workspace",e.$qi=`.${e.$pi}`,e.$ri=[{name:(0,y.localize)(0,null),extensions:[e.$pi]}],e.$si="workspace.json";function c(g,m){return L.$yg.isEqualOrParent(g,m.untitledWorkspacesHome)}e.$ti=c;function h(g){let m;return R.URI.isUri(g)?m=g:m=g.configuration,m?.scheme===f.Schemas.tmp}e.$ui=h,e.$vi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(g){return g.id===e.$vi}e.$wi=t;function u(g,m){return!c(g,m)&&!h(g)}e.$xi=u;function i(g){return(typeof g=="string"?(0,T.$oc)(g):(0,L.$Fg)(g))===e.$qi}e.$yi=i}),define(Pe[75],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4fc=void 0;class y{static{this.a=!1}constructor(C){this.d=C,this.b=new Map,this.c=1}add(C){const L=this.c++;return this.b.set(L,C),this.e(),L}get(C,L){return this.b.has(C)?this.b.get(C)[L]:void 0}delete(C){this.b.delete(C),this.e()}e(){y.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$4fc=y}),define(Pe[42],Re([1,0,12,25,4]),function(ge,e,y,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8fc=e.$7fc=void 0;class L{constructor(){this.a=new Set(Object.keys(y.Schemas)),this.b=new Map,this.extUri=new T.$wg($=>{const f=this.b.get($.scheme);return!(f===void 0||f&1024)})}$acceptProviderInfos($,f){f===null?this.b.delete($.scheme):this.b.set($.scheme,f)}isFreeScheme($){return!this.b.has($)&&!this.a.has($)}getCapabilities($){return this.b.get($)}}e.$7fc=L,e.$8fc=(0,C.$6h)("IExtHostFileSystemInfo")}),define(Pe[27],Re([1,0,4]),function(ge,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nN=void 0,e.$nN=(0,y.$6h)("IExtHostInitDataService")}),define(Pe[199],Re([1,0,161,14,186,27]),function(ge,e,y,T,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bic=void 0;let R=class extends C.$uO{constructor(f,b,A){const k=A.remote.isRemote?"remoteexthost":f?"workerexthost":"exthost",l=A.remote.isRemote?(0,y.localize)(0,null):f?(0,y.localize)(1,null):(0,y.localize)(2,null);super(b.createLogger(k,{name:l}))}};e.$bic=R,e.$bic=R=Je([Ke(1,T.$oj),Ke(2,L.$nN)],R)}),define(Pe[200],Re([1,0,13]),function(ge,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qgc=e.$Pgc=void 0;class T{constructor(R,$,f){this.h=new Map,this.a=R,this.b=$,this.c=f,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(b=>(this.f=b,this)),this.g=this.c.onDidChangeStorage(b=>{b.shared===this.b&&b.key===this.a&&(this.f=b.value)}),this.i=new y.$fh(()=>{const b=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const A of b.values())A.complete()}catch(A){for(const k of b.values())k.error(A)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,R])=>R!==void 0).map(([R])=>R)}get whenReady(){return this.d}get(R,$){let f=this.f[R];return typeof f>"u"&&(f=$),f}update(R,$){this.f[R]=$;const f=this.h.get(R);if(f!==void 0)return f.p;const b=new y.$qh;return this.h.set(R,b),this.i.isScheduled()||this.i.schedule(),b.p}dispose(){this.g.dispose()}}e.$Pgc=T;class C extends T{setKeysForSync(R){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},R)}constructor(R,$){super(R.identifier.value,!0,$),this.j=R}}e.$Qgc=C}),define(Pe[201],Re([1,0,5,2]),function(ge,e,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dhc=void 0;class C{constructor(R){this.c=R,this.a=new y.$Vd,this.onDidSaveNotebookDocument=this.a.event,this.b=new y.$Vd,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(R,$,f,b){const k=this.c.getNotebookDocument(T.URI.revive(R)).acceptModelChanged($.value,f,b);this.b.fire(k)}$acceptDirtyStateChanged(R,$){this.c.getNotebookDocument(T.URI.revive(R)).acceptDirty($)}$acceptModelSaved(R){const $=this.c.getNotebookDocument(T.URI.revive(R));this.a.fire($.apiNotebook)}}e.$Dhc=C}),define(Pe[17],Re([1,0,4]),function(ge,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$M=e.$0M=void 0,e.$0M=(0,y.$6h)("IExtHostRpcService");class T{constructor(L){this.getProxy=L.getProxy.bind(L),this.set=L.set.bind(L),this.dispose=L.dispose.bind(L),this.assertRegistered=L.assertRegistered.bind(L),this.drain=L.drain.bind(L)}}e.$$M=T}),define(Pe[202],Re([1,0,22,5]),function(ge,e,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xgc=void 0;class C{#e;constructor(R,$){this.b=new T.$Vd,this.onDidChange=this.b.event,this.a=y.$lm.toKey(R.identifier),this.#e=$,this.#e.onDidChangePassword(f=>{f.extensionId===this.a&&this.b.fire({key:f.key})})}get(R){return this.#e.get(this.a,R)}store(R,$){return this.#e.store(this.a,R,$)}delete(R){return this.#e.delete(this.a,R)}}e.$Xgc=C}),define(Pe[57],Re([1,0,4]),function(ge,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ogc=e.$ngc=void 0,e.$ngc=(0,y.$6h)("IURITransformerService");class T{constructor(L){L?(this.transformIncoming=L.transformIncoming.bind(L),this.transformOutgoing=L.transformOutgoing.bind(L),this.transformOutgoingURI=L.transformOutgoingURI.bind(L),this.transformOutgoingScheme=L.transformOutgoingScheme.bind(L)):(this.transformIncoming=R=>R,this.transformOutgoing=R=>R,this.transformOutgoingURI=R=>R,this.transformOutgoingScheme=R=>R)}}e.$ogc=T}),define(Pe[203],Re([1,0,24]),function(ge,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dlb=e.$clb=void 0;class T{constructor(){this.buffers=[]}add(f){let b=this.buffers.indexOf(f);return b<0&&(b=this.buffers.length,this.buffers.push(f)),b}}function C($,f){if(f.serializeBuffersForPostMessage){const b=new T,k=JSON.stringify($,(p,w)=>{if(w instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:b.add(w)};if(ArrayBuffer.isView(w)){const s=L(w);if(s)return{$$vscode_array_buffer_reference$$:!0,index:b.add(w.buffer),view:{type:s,byteLength:w.byteLength,byteOffset:w.byteOffset}}}return w}),l=b.buffers.map(p=>{const w=new Uint8Array(p);return y.$je.wrap(w)});return{message:k,buffers:l}}else return{message:JSON.stringify($),buffers:[]}}e.$clb=C;function L($){switch($.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function R($,f){const b=f.map(l=>{const p=new ArrayBuffer(l.byteLength);return new Uint8Array(p).set(l.buffer),p}),A=f.length?(l,p)=>{if(p&&typeof p=="object"&&p.$$vscode_array_buffer_reference$$){const w=p,{index:s}=w,a=b[s];if(w.view)switch(w.view.type){case 1:return new Int8Array(a,w.view.byteOffset,w.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(a,w.view.byteOffset,w.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(a,w.view.byteOffset,w.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(a,w.view.byteOffset,w.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(a,w.view.byteOffset,w.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(a,w.view.byteOffset,w.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(a,w.view.byteOffset,w.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(a,w.view.byteOffset,w.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(a,w.view.byteOffset,w.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(a,w.view.byteOffset,w.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(a,w.view.byteOffset,w.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return a}return p}:void 0;return{message:JSON.parse($,A),arrayBuffers:b}}e.$dlb=R}),define(Pe[102],Re([1,0,170,16,2,6,4,30,41,12,40,134,31]),function(ge,e,y,T,C,L,R,$,f,b,A,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5E=e.$4E=e.$3E=e.EditorsOrder=e.$2E=e.CloseDirection=e.$1E=e.$ZE=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$YE=e.$XE=e.$WE=e.$VE=e.$UE=e.$TE=e.$SE=e.$RE=e.EditorInputCapabilities=e.$QE=e.SaveReason=e.Verbosity=e.$PE=e.$OE=e.$NE=e.$ME=e.$LE=e.$KE=e.$JE=e.$IE=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$HE=e.$GE=e.$FE=e.$EE=e.$DE=void 0,e.$DE={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$EE={id:"default",displayName:(0,y.localize)(0,null),providerDisplayName:(0,y.localize)(1,null)},e.$FE="workbench.editor.sidebysideEditor",e.$GE="workbench.editors.textDiffEditor",e.$HE="workbench.editors.binaryResourceDiffEditor";var p;(function(ne){ne[ne.PROGRAMMATIC=1]="PROGRAMMATIC",ne[ne.USER=2]="USER",ne[ne.EDIT=3]="EDIT",ne[ne.NAVIGATION=4]="NAVIGATION",ne[ne.JUMP=5]="JUMP"})(p||(e.EditorPaneSelectionChangeReason=p={}));var w;(function(ne){ne[ne.IDENTICAL=1]="IDENTICAL",ne[ne.SIMILAR=2]="SIMILAR",ne[ne.DIFFERENT=3]="DIFFERENT"})(w||(e.EditorPaneSelectionCompareResult=w={}));function s(ne){const Y=ne;return!!Y&&typeof Y.getSelection=="function"&&!!Y.onDidChangeSelection}e.$IE=s;function a(ne,Y,V){for(const ie of V.visibleEditorPanes)if(ie.group.id===Y&&ne.matches(ie.input))return ie.getViewState()}e.$JE=a;function r(ne){if(S(ne))return!1;const Y=ne;return C.URI.isUri(Y?.resource)}e.$KE=r;function n(ne){if(S(ne))return!1;const Y=ne;return Y?.original!==void 0&&Y.modified!==void 0}e.$LE=n;function o(ne){if(S(ne))return!1;const Y=ne;return!Y||Y.resources&&!Array.isArray(Y.resources)?!1:!!Y.resources||!!Y.multiDiffSource}e.$ME=o;function c(ne){if(S(ne)||n(ne))return!1;const Y=ne;return Y?.primary!==void 0&&Y.secondary!==void 0}e.$NE=c;function h(ne){if(S(ne))return!1;const Y=ne;return Y?Y.resource===void 0||Y.resource.scheme===b.Schemas.untitled||Y.forceUntitled===!0:!1}e.$OE=h;function t(ne){if(S(ne))return!1;const Y=ne;return C.URI.isUri(Y?.base?.resource)&&C.URI.isUri(Y?.input1?.resource)&&C.URI.isUri(Y?.input2?.resource)&&C.URI.isUri(Y?.result?.resource)}e.$PE=t;var u;(function(ne){ne[ne.SHORT=0]="SHORT",ne[ne.MEDIUM=1]="MEDIUM",ne[ne.LONG=2]="LONG"})(u||(e.Verbosity=u={}));var i;(function(ne){ne[ne.EXPLICIT=1]="EXPLICIT",ne[ne.AUTO=2]="AUTO",ne[ne.FOCUS_CHANGE=3]="FOCUS_CHANGE",ne[ne.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(i||(e.SaveReason=i={}));class g{constructor(){this.a=new Map}registerSource(Y,V){let ie=this.a.get(Y);return ie||(ie={source:Y,label:V},this.a.set(Y,ie)),ie.source}getSourceLabel(Y){return this.a.get(Y)?.label??Y}}e.$QE=new g;var m;(function(ne){ne[ne.None=0]="None",ne[ne.Readonly=2]="Readonly",ne[ne.Untitled=4]="Untitled",ne[ne.Singleton=8]="Singleton",ne[ne.RequiresTrust=16]="RequiresTrust",ne[ne.CanSplitInGroup=32]="CanSplitInGroup",ne[ne.ForceDescription=64]="ForceDescription",ne[ne.CanDropIntoEditor=128]="CanDropIntoEditor",ne[ne.MultipleEditors=256]="MultipleEditors",ne[ne.Scratchpad=512]="Scratchpad",ne[ne.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(m||(e.EditorInputCapabilities=m={}));class d extends L.$Tc{}e.$RE=d;function S(ne){return ne instanceof d}e.$SE=S;function M(ne){const Y=ne;return C.URI.isUri(Y?.preferredResource)}function v(ne){const Y=ne;return S(Y?.primary)&&S(Y?.secondary)}e.$TE=v;function E(ne){const Y=ne;return S(Y?.modified)&&S(Y?.original)}e.$UE=E;function D(ne,Y,V,ie,Ie){return be(ie,[(0,k.$Pi)({id:"workbench.action.openLargeFile",label:(0,y.localize)(2,null),run:()=>{const Le={...V,limits:{size:Number.MAX_VALUE}};ne.openEditor(Y,Le)}}),(0,k.$Pi)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,y.localize)(3,null),run:()=>Ie.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:l.default.Warning})}e.$VE=D;function N(ne){return S(ne?.editor)}e.$WE=N;function O(ne){const Y=ne;return N(ne)&&Y?.group!==void 0}e.$XE=O;function G(ne){const Y=ne;return typeof Y?.groupId=="number"&&S(Y.editor)}e.$YE=G;var W;(function(ne){ne[ne.UNKNOWN=0]="UNKNOWN",ne[ne.REPLACE=1]="REPLACE",ne[ne.MOVE=2]="MOVE",ne[ne.UNPIN=3]="UNPIN"})(W||(e.EditorCloseContext=W={}));var z;(function(ne){ne[ne.GROUP_ACTIVE=0]="GROUP_ACTIVE",ne[ne.GROUP_INDEX=1]="GROUP_INDEX",ne[ne.GROUP_LABEL=2]="GROUP_LABEL",ne[ne.GROUP_LOCKED=3]="GROUP_LOCKED",ne[ne.EDITOR_OPEN=4]="EDITOR_OPEN",ne[ne.EDITOR_CLOSE=5]="EDITOR_CLOSE",ne[ne.EDITOR_MOVE=6]="EDITOR_MOVE",ne[ne.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",ne[ne.EDITOR_LABEL=8]="EDITOR_LABEL",ne[ne.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",ne[ne.EDITOR_PIN=10]="EDITOR_PIN",ne[ne.EDITOR_STICKY=11]="EDITOR_STICKY",ne[ne.EDITOR_DIRTY=12]="EDITOR_DIRTY",ne[ne.EDITOR_WILL_DISPOSE=13]="EDITOR_WILL_DISPOSE"})(z||(e.GroupModelChangeKind=z={}));var P;(function(ne){ne[ne.PRIMARY=1]="PRIMARY",ne[ne.SECONDARY=2]="SECONDARY",ne[ne.BOTH=3]="BOTH",ne[ne.ANY=4]="ANY"})(P||(e.SideBySideEditor=P={}));class I{getOriginalUri(Y,V){if(!Y)return;if(t(Y))return e.$1E.getOriginalUri(Y.result,V);if(V?.supportSideBySide){const{primary:Ie,secondary:Le}=this.a(Y);if(Ie&&Le){if(V?.supportSideBySide===P.BOTH)return{primary:this.getOriginalUri(Ie,{filterByScheme:V.filterByScheme}),secondary:this.getOriginalUri(Le,{filterByScheme:V.filterByScheme})};if(V?.supportSideBySide===P.ANY)return this.getOriginalUri(Ie,{filterByScheme:V.filterByScheme})??this.getOriginalUri(Le,{filterByScheme:V.filterByScheme});Y=V.supportSideBySide===P.PRIMARY?Ie:Le}}if(n(Y)||o(Y)||c(Y)||t(Y))return;const ie=M(Y)?Y.preferredResource:Y.resource;return!ie||!V||!V.filterByScheme?ie:this.b(ie,V.filterByScheme)}a(Y){return v(Y)||c(Y)?{primary:Y.primary,secondary:Y.secondary}:E(Y)||n(Y)?{primary:Y.modified,secondary:Y.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(Y,V){if(!Y)return;if(t(Y))return e.$1E.getCanonicalUri(Y.result,V);if(V?.supportSideBySide){const{primary:Ie,secondary:Le}=this.a(Y);if(Ie&&Le){if(V?.supportSideBySide===P.BOTH)return{primary:this.getCanonicalUri(Ie,{filterByScheme:V.filterByScheme}),secondary:this.getCanonicalUri(Le,{filterByScheme:V.filterByScheme})};if(V?.supportSideBySide===P.ANY)return this.getCanonicalUri(Ie,{filterByScheme:V.filterByScheme})??this.getCanonicalUri(Le,{filterByScheme:V.filterByScheme});Y=V.supportSideBySide===P.PRIMARY?Ie:Le}}if(n(Y)||o(Y)||c(Y)||t(Y))return;const ie=Y.resource;return!ie||!V||!V.filterByScheme?ie:this.b(ie,V.filterByScheme)}b(Y,V){if(Array.isArray(V)){if(V.some(ie=>Y.scheme===ie))return Y}else if(V===Y.scheme)return Y}}var H;(function(ne){ne[ne.UNKNOWN=0]="UNKNOWN",ne[ne.KEYBOARD=1]="KEYBOARD",ne[ne.MOUSE=2]="MOUSE"})(H||(e.EditorCloseMethod=H={}));function ae(ne,Y,V,ie){if(!ne.isSticky(Y))return!1;switch(ie.preventPinnedEditorClose){case"keyboardAndMouse":return V===H.MOUSE||V===H.KEYBOARD;case"mouse":return V===H.MOUSE;case"keyboard":return V===H.KEYBOARD}return!1}e.$ZE=ae,e.$1E=new I;var de;(function(ne){ne[ne.LEFT=0]="LEFT",ne[ne.RIGHT=1]="RIGHT"})(de||(e.CloseDirection=de={}));class we{constructor(){this.c=new Map,this.d=new Map}start(Y){const V=this.a=Y.get(R.$5h);for(const[ie,Ie]of this.c)this.e(ie,Ie,V);this.c.clear()}e(Y,V,ie){const Ie=ie.createInstance(V);this.d.set(Y,Ie)}registerFileEditorFactory(Y){if(this.b)throw new Error("Can only register one file editor factory.");this.b=Y}getFileEditorFactory(){return(0,T.$Tf)(this.b)}registerEditorSerializer(Y,V){if(this.c.has(Y)||this.d.has(Y))throw new Error(`A editor serializer with type ID '${Y}' was already registered.`);return this.a?this.e(Y,V,this.a):this.c.set(Y,V),(0,L.$Rc)(()=>{this.c.delete(Y),this.d.delete(Y)})}getEditorSerializer(Y){return this.d.get(typeof Y=="string"?Y:Y.typeId)}}$.$Hn.add(e.$DE.EditorFactory,new we);async function ke(ne,Y,V){return!ne||!ne.length?[]:await Promise.all(ne.map(async ie=>{const Ie=C.URI.revive(ie.fileUri);if(!Ie){V.info("Cannot resolve the path because it is not valid.",ie);return}if(!await Y.canHandleResource(Ie)){V.info("Cannot resolve the path because it cannot be handled",ie);return}let Ce=ie.exists,ce=ie.type;if(typeof Ce!="boolean"||typeof ce!="number")try{ce=(await Y.stat(Ie)).isDirectory?f.FileType.Directory:f.FileType.Unknown,Ce=!0}catch(Q){V.error(Q),Ce=!1}if(!Ce&&ie.openOnlyIfExists){V.info("Cannot resolve the path because it does not exist",ie);return}if(ce===f.FileType.Directory){V.info("Cannot resolve the path because it is a directory",ie);return}const te={...ie.options,pinned:!0};return Ce?{resource:Ie,options:te}:{resource:Ie,options:te,forceUntitled:!0}}))}e.$2E=ke;var le;(function(ne){ne[ne.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ne[ne.SEQUENTIAL=1]="SEQUENTIAL"})(le||(e.EditorsOrder=le={}));function ve(ne){const Y=ne;if(!Y)return!1;const V=Y;if(V.modified)return ve(V.modified);const ie=Y;return!!(ie.contributionsState&&ie.viewState&&Array.isArray(ie.cursorState))}e.$3E=ve;function se(ne){return(0,A.$Ri)(ne)}e.$4E=se;function be(ne,Y,V){const ie=(0,A.$Si)(ne,Y);return ie.forceMessage=V?.forceMessage,ie.forceSeverity=V?.forceSeverity,ie.allowDialog=V?.allowDialog,ie}e.$5E=be}),define(Pe[204],Re([1,0,5,171,4,6,28,30,18,26,90,195]),function(ge,e,y,T,C,L,R,$,f,b,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aF=e.$_E=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$$E=e.ViewContentGroups=e.$0E=e.$9E=e.ViewContainerLocation=e.Extensions=e.$8E=e.$7E=e.$6E=void 0,e.$6E="views",e.$7E=(0,T.localize)(0,null),e.$8E=(0,k.$xw)("default-view-icon",A.$_j.window,(0,T.localize)(1,null));var l;(function(u){u.ViewContainersRegistry="workbench.registry.view.containers",u.ViewsRegistry="workbench.registry.view"})(l||(e.Extensions=l={}));var p;(function(u){u[u.Sidebar=0]="Sidebar",u[u.Panel=1]="Panel",u[u.AuxiliaryBar=2]="AuxiliaryBar"})(p||(e.ViewContainerLocation=p={})),e.$9E=[0,1,2];function w(u){switch(u){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$0E=w;class s extends L.$Tc{constructor(){super(...arguments),this.c=this.B(new y.$Vd),this.onDidRegister=this.c.event,this.f=this.B(new y.$Vd),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,f.$Rb)([...this.g.values()])}registerViewContainer(i,g,m){const d=this.get(i.id);if(d)return d;const S=i;return S.openCommandActionDescriptor=m?.doNotRegisterOpenCommand?void 0:S.openCommandActionDescriptor??{id:S.id},(0,R.$xc)(this.g,g,[]).push(S),m?.isDefault&&this.h.push(S),this.c.fire({viewContainer:S,viewContainerLocation:g}),S}deregisterViewContainer(i){for(const g of this.g.keys()){const m=this.g.get(g),d=m?.indexOf(i);if(d!==-1){m?.splice(d,1),m.length===0&&this.g.delete(g),this.f.fire({viewContainer:i,viewContainerLocation:g});return}}}get(i){return this.all.filter(g=>g.id===i)[0]}getViewContainers(i){return[...this.g.get(i)||[]]}getViewContainerLocation(i){return[...this.g.keys()].filter(g=>this.getViewContainers(g).filter(m=>m?.id===i.id).length>0)[0]}getDefaultViewContainer(i){return this.h.find(g=>this.getViewContainerLocation(g)===i)}}$.$Hn.add(l.ViewContainersRegistry,new s);var a;(function(u){u.Open="2_open",u.Debug="4_debug",u.SCM="5_scm",u.More="9_more"})(a||(e.ViewContentGroups=a={}));function r(u,i){const g=u.group??a.More,m=i.group??a.More;return g!==m?g.localeCompare(m):(u.order??5)-(i.order??5)}class n extends L.$Tc{constructor(){super(...arguments),this.c=this.B(new y.$Vd),this.onViewsRegistered=this.c.event,this.f=this.B(new y.$Vd),this.onViewsDeregistered=this.f.event,this.g=this.B(new y.$Vd),this.onDidChangeContainer=this.g.event,this.h=this.B(new y.$Vd),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new R.$Gc}registerViews(i,g){this.registerViews2([{views:i,viewContainer:g}])}registerViews2(i){i.forEach(({views:g,viewContainer:m})=>this.r(g,m)),this.c.fire(i)}deregisterViews(i,g){const m=this.s(i,g);m.length&&this.f.fire({views:m,viewContainer:g})}moveViews(i,g){for(const m of this.m.keys())if(m!==g){const d=this.s(i,m);d.length&&(this.r(d,g),this.g.fire({views:d,from:m,to:g}))}}getViews(i){return this.m.get(i)||[]}getView(i){for(const g of this.j){const m=(this.m.get(g)||[]).filter(d=>d.id===i)[0];if(m)return m}return null}getViewContainer(i){for(const g of this.j)if((this.m.get(g)||[]).filter(d=>d.id===i)[0])return g;return null}registerViewWelcomeContent(i,g){return this.n.add(i,g),this.h.fire(i),(0,L.$Rc)(()=>{this.n.delete(i,g),this.h.fire(i)})}registerViewWelcomeContent2(i,g){const m=new Map;for(const[d,S]of g)this.n.add(i,S),m.set(d,(0,L.$Rc)(()=>{this.n.delete(i,S),this.h.fire(i)}));return this.h.fire(i),m}getViewWelcomeContent(i){const g=[];return this.n.forEach(i,m=>g.push(m)),g.sort(r)}r(i,g){let m=this.m.get(g);m||(m=[],this.m.set(g,m),this.j.push(g));for(const d of i){if(this.getView(d.id)!==null)throw new Error((0,T.localize)(2,null,d.id));m.push(d)}}s(i,g){const m=this.m.get(g);if(!m)return[];const d=[],S=[];for(const M of m)i.includes(M)?d.push(M):S.push(M);return d.length&&(S.length?this.m.set(g,S):(this.m.delete(g),this.j.splice(this.j.indexOf(g),1))),d}}$.$Hn.add(l.ViewsRegistry,new n),e.$$E=(0,C.$6h)("viewDescriptorService");var o;(function(u){u[u.Default=0]="Default",u[u.Expand=1]="Expand"})(o||(e.ViewVisibilityState=o={}));var c;(function(u){u[u.None=0]="None",u[u.Collapsed=1]="Collapsed",u[u.Expanded=2]="Expanded"})(c||(e.TreeItemCollapsibleState=c={}));class h{constructor(i,g){this.c=!1,this.d=!1,(0,b.$yn)(this,i),this.d=!!g,this.resolve=async m=>{if(g&&!this.c){const d=await g(m);d&&(this.tooltip=this.tooltip??d.tooltip,this.command=this.command??d.command)}m.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$_E=h;class t extends Error{constructor(i){super((0,T.localize)(3,null,i)),this.name="NoTreeViewError"}static is(i){return i.name==="NoTreeViewError"}}e.$aF=t}),define(Pe[205],Re([1,0,2,29,4]),function(ge,e,y,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5F=e.ChatAgentCopyKind=e.InteractiveSessionVoteDirection=e.$4F=e.$3F=void 0;function L(b){return!!b&&typeof b=="object"&&"uri"in b&&b.uri instanceof y.URI&&"version"in b&&typeof b.version=="number"&&"ranges"in b&&Array.isArray(b.ranges)&&b.ranges.every(T.$Us.isIRange)}e.$3F=L;function R(b){return!!b&&typeof b=="object"&&"documents"in b&&Array.isArray(b.documents)&&b.documents.every(L)}e.$4F=R;var $;(function(b){b[b.Down=0]="Down",b[b.Up=1]="Up"})($||(e.InteractiveSessionVoteDirection=$={}));var f;(function(b){b[b.Action=1]="Action",b[b.Toolbar=2]="Toolbar"})(f||(e.ChatAgentCopyKind=f={})),e.$5F=(0,C.$6h)("IChatService")}),define(Pe[206],Re([1,0,5,13,172]),function(ge,e,y,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ilb=void 0;class L{constructor(){this.f=new Map,this.k=[],this.m=new y.$Vd,this.n=new y.$Vd,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage($){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=$}onEvent($){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=$}onRequest($){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=$}sendResponse($){$.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${$.command}`)):this.s("response",$)}sendRequest($,f,b,A){const k={command:$};if(f&&Object.keys(f).length>0&&(k.arguments=f),this.s("request",k),typeof A=="number"){const l=setTimeout(()=>{clearTimeout(l);const p=this.f.get(k.seq);if(p){this.f.delete(k.seq);const w={type:"response",seq:0,request_seq:k.seq,success:!1,command:$,message:(0,C.localize)(0,null,A,$)};p(w)}},A)}return b&&this.f.set(k.seq,b),k.seq}acceptMessage($){this.j?this.j($):(this.k.push($),this.k.length===1&&this.q())}o($,f){return $.type!=="event"||f.type!=="event"}async q(){let $;for(;this.k.length;){if((!$||this.o(this.k[0],$))&&await(0,T.$7g)(0),$=this.k.shift(),!$)return;switch($.type){case"event":this.i?.($);break;case"request":this.g?.($);break;case"response":{const f=$,b=this.f.get(f.request_seq);b&&(this.f.delete(f.request_seq),b(f));break}}}}s($,f){f.type=$,f.seq=this.d++,this.sendMessage(f)}async u(){if(this.f.size===0)return Promise.resolve();const $=new Map;this.f.forEach((f,b)=>$.set(b,f)),await(0,T.$7g)(500),$.forEach((f,b)=>{f({type:"response",seq:0,request_seq:b,success:!1,command:"canceled",message:"canceled"}),this.f.delete(b)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$Ilb=L}),define(Pe[207],Re([1,0,173,35,4]),function(ge,e,y,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.$NH=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$MH=e.MemoryRangeType=e.$LH=e.State=e.$KH=e.$JH=e.$IH=e.$HH=e.$GH=e.$FH=e.$EH=e.$DH=e.$CH=e.$BH=e.$AH=e.$zH=e.$yH=e.$xH=e.$wH=e.$vH=e.$uH=e.$tH=e.$sH=e.$rH=e.$qH=e.$pH=e.$oH=e.$nH=e.$mH=e.$lH=e.$kH=e.$jH=e.$iH=e.$hH=e.$gH=e.$fH=e.$eH=e.$dH=e.$cH=e.$bH=e.$aH=e.$_G=e.$$G=e.$0G=e.$9G=e.$8G=e.$7G=e.$6G=e.$5G=e.$4G=e.$3G=e.$2G=e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=void 0,e.$IG="workbench.view.debug",e.$JG="workbench.debug.variablesView",e.$KG="workbench.debug.watchExpressionsView",e.$LG="workbench.debug.callStackView",e.$MG="workbench.debug.loadedScriptsView",e.$NG="workbench.debug.breakPointsView",e.$OG="workbench.debug.disassemblyView",e.$PG="workbench.panel.repl",e.$QG="workbench.panel.repl.view",e.$RG=new T.$kj("debugType",void 0,{type:"string",description:y.localize(0,null)}),e.$SG=new T.$kj("debugConfigurationType",void 0,{type:"string",description:y.localize(1,null)}),e.$TG=new T.$kj("debugState","inactive",{type:"string",description:y.localize(2,null)}),e.$UG="debugUx",e.$VG=new T.$kj(e.$UG,"default",{type:"string",description:y.localize(3,null)}),e.$WG=new T.$kj("hasDebugged",!1,{type:"boolean",description:y.localize(4,null)}),e.$XG=new T.$kj("inDebugMode",!1,{type:"boolean",description:y.localize(5,null)}),e.$YG=new T.$kj("inDebugRepl",!1,{type:"boolean",description:y.localize(6,null)}),e.$ZG=new T.$kj("breakpointWidgetVisible",!1,{type:"boolean",description:y.localize(7,null)}),e.$1G=new T.$kj("inBreakpointWidget",!1,{type:"boolean",description:y.localize(8,null)}),e.$2G=new T.$kj("breakpointsFocused",!0,{type:"boolean",description:y.localize(9,null)}),e.$3G=new T.$kj("watchExpressionsFocused",!0,{type:"boolean",description:y.localize(10,null)}),e.$4G=new T.$kj("watchExpressionsExist",!1,{type:"boolean",description:y.localize(11,null)}),e.$5G=new T.$kj("variablesFocused",!0,{type:"boolean",description:y.localize(12,null)}),e.$6G=new T.$kj("expressionSelected",!1,{type:"boolean",description:y.localize(13,null)}),e.$7G=new T.$kj("breakpointInputFocused",!1,{type:"boolean",description:y.localize(14,null)}),e.$8G=new T.$kj("callStackItemType",void 0,{type:"string",description:y.localize(15,null)}),e.$9G=new T.$kj("callStackSessionIsAttach",!1,{type:"boolean",description:y.localize(16,null)}),e.$0G=new T.$kj("callStackItemStopped",!1,{type:"boolean",description:y.localize(17,null)}),e.$$G=new T.$kj("callStackSessionHasOneThread",!1,{type:"boolean",description:y.localize(18,null)}),e.$_G=new T.$kj("watchItemType",void 0,{type:"string",description:y.localize(19,null)}),e.$aH=new T.$kj("canViewMemory",void 0,{type:"boolean",description:y.localize(20,null)}),e.$bH=new T.$kj("breakpointItemType",void 0,{type:"string",description:y.localize(21,null)}),e.$cH=new T.$kj("breakpointSupportsCondition",!1,{type:"boolean",description:y.localize(22,null)}),e.$dH=new T.$kj("loadedScriptsSupported",!1,{type:"boolean",description:y.localize(23,null)}),e.$eH=new T.$kj("loadedScriptsItemType",void 0,{type:"string",description:y.localize(24,null)}),e.$fH=new T.$kj("focusedSessionIsAttach",!1,{type:"boolean",description:y.localize(25,null)}),e.$gH=new T.$kj("focusedSessionIsNoDebug",!1,{type:"boolean",description:y.localize(26,null)}),e.$hH=new T.$kj("stepBackSupported",!1,{type:"boolean",description:y.localize(27,null)}),e.$iH=new T.$kj("restartFrameSupported",!1,{type:"boolean",description:y.localize(28,null)}),e.$jH=new T.$kj("stackFrameSupportsRestart",!1,{type:"boolean",description:y.localize(29,null)}),e.$kH=new T.$kj("jumpToCursorSupported",!1,{type:"boolean",description:y.localize(30,null)}),e.$lH=new T.$kj("stepIntoTargetsSupported",!1,{type:"boolean",description:y.localize(31,null)}),e.$mH=new T.$kj("breakpointsExist",!1,{type:"boolean",description:y.localize(32,null)}),e.$nH=new T.$kj("debuggersAvailable",!1,{type:"boolean",description:y.localize(33,null)}),e.$oH=new T.$kj("debugExtensionAvailable",!0,{type:"boolean",description:y.localize(34,null)}),e.$pH=new T.$kj("debugProtocolVariableMenuContext",void 0,{type:"string",description:y.localize(35,null)}),e.$qH=new T.$kj("debugSetVariableSupported",!1,{type:"boolean",description:y.localize(36,null)}),e.$rH=new T.$kj("debugSetExpressionSupported",!1,{type:"boolean",description:y.localize(37,null)}),e.$sH=new T.$kj("breakWhenValueChangesSupported",!1,{type:"boolean",description:y.localize(38,null)}),e.$tH=new T.$kj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:y.localize(39,null)}),e.$uH=new T.$kj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:y.localize(40,null)}),e.$vH=new T.$kj("terminateDebuggeeSupported",!1,{type:"boolean",description:y.localize(41,null)}),e.$wH=new T.$kj("suspendDebuggeeSupported",!1,{type:"boolean",description:y.localize(42,null)}),e.$xH=new T.$kj("variableEvaluateNamePresent",!1,{type:"boolean",description:y.localize(43,null)}),e.$yH=new T.$kj("variableIsReadonly",!1,{type:"boolean",description:y.localize(44,null)}),e.$zH=new T.$kj("exceptionWidgetVisible",!1,{type:"boolean",description:y.localize(45,null)}),e.$AH=new T.$kj("multiSessionRepl",!1,{type:"boolean",description:y.localize(46,null)}),e.$BH=new T.$kj("multiSessionDebug",!1,{type:"boolean",description:y.localize(47,null)}),e.$CH=new T.$kj("disassembleRequestSupported",!1,{type:"boolean",description:y.localize(48,null)}),e.$DH=new T.$kj("disassemblyViewFocus",!1,{type:"boolean",description:y.localize(49,null)}),e.$EH=new T.$kj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:y.localize(50,null)}),e.$FH=new T.$kj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:y.localize(51,null)});const L=l=>y.localize(52,null,l);e.$GH=L,e.$HH="editor.contrib.debug",e.$IH="editor.contrib.breakpoint",e.$JH="debug",e.$KH={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:y.localize(53,null)};var R;(function(l){l[l.Inactive=0]="Inactive",l[l.Initializing=1]="Initializing",l[l.Stopped=2]="Stopped",l[l.Running=3]="Running"})(R||(e.State=R={}));function $(l){switch(l){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$LH=$;var f;(function(l){l[l.Valid=0]="Valid",l[l.Unreadable=1]="Unreadable",l[l.Error=2]="Error"})(f||(e.MemoryRangeType=f={})),e.$MH="vscode-debug-memory";var b;(function(l){l[l.Initial=1]="Initial",l[l.Dynamic=2]="Dynamic"})(b||(e.DebugConfigurationProviderTriggerKind=b={}));var A;(function(l){l.UnverifiedBreakpoints="unverifiedBreakpoints"})(A||(e.DebuggerString=A={})),e.$NH=(0,C.$6h)("debugService");var k;(function(l){l[l.CONDITION=0]="CONDITION",l[l.HIT_COUNT=1]="HIT_COUNT",l[l.LOG_MESSAGE=2]="LOG_MESSAGE",l[l.TRIGGER_POINT=3]="TRIGGER_POINT"})(k||(e.BreakpointWidgetContext=k={}))}),define(Pe[208],Re([1,0,11,2,19,26,12,29,20,18]),function(ge,e,y,T,C,L,R,$,f,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=e.$eG=e.$dG=e.$cG=e.$bG=e.$aG=e.$_F=e.$$F=e.$0F=void 0;const A=/{([^}]+)}/g;function k(M,v,E){return M.replace(A,function(D,N){return v&&N.length>0&&N[0]!=="_"?D:E&&E.hasOwnProperty(N)?E[N]:D})}e.$0F=k;function l(M){const v={};for(const E of Object.keys(M))E.startsWith("!")||(v[E]=M[E]);return v}e.$$F=l;function p(M){return M.configuration.request==="attach"&&!w(M)&&(!M.parentSession||p(M.parentSession))}e.$_F=p;function w(M){let v=M.configuration.type;if(v)return v==="vslsShare"&&(v=M.configuration.adapterProxy.configuration.type),(0,y.$_e)(v,"extensionhost")||(0,y.$_e)(v,"pwa-extensionhost")?M:M.parentSession?w(M.parentSession):void 0}e.$aG=w;function s(M){return M.type&&(M.label||M.program||M.runtime)}e.$bG=s;function a(M,v,E){let D,N=0;const O=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let G=null;for(;G=O.exec(M);){const W=G.index+1,z=W+G[0].length;if(W<=v&&z>=E){D=G[0],N=W;break}}if(D){const W=/\w+/g;let z=null;for(;(z=W.exec(D))&&!(z.index+1+N+z[0].length>=E););z&&(D=D.substring(0,W.lastIndex))}return D?{start:N,end:N+D.length-1}:{start:0,end:0}}e.$cG=a;async function r(M,v,E,D){if(M.evaluatableExpressionProvider.has(v)){const N=M.evaluatableExpressionProvider.ordered(v),O=(0,b.$Hb)(await Promise.all(N.map(async G=>{try{return await G.provideEvaluatableExpression(v,E,D??f.CancellationToken.None)}catch{return}})));if(O.length>0){let G=O[0].expression;const W=O[0].range;return G||(G=v.getLineContent(E.lineNumber).substring(W.startColumn-1,W.endColumn-1)),{range:W,matchingExpression:G}}}else{const N=v.getLineContent(E.lineNumber),{start:O,end:G}=a(N,E.column,E.column),W=N.substring(O-1,G);return{matchingExpression:W,range:new $.$Us(E.lineNumber,O,E.lineNumber,O+W.length)}}return null}e.$dG=r;const n=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function o(M){return!!(M&&M.match(n))}e.$eG=o;function c(M){if(typeof M.path=="string"&&!(typeof M.sourceReference=="number"&&M.sourceReference>0)){if(o(M.path))return T.URI.parse(M.path);if((0,C.$ic)(M.path))return T.URI.file(M.path)}return M.path}function h(M){if(typeof M.path=="object"){const v=T.URI.revive(M.path);if(v)return v.scheme===R.Schemas.file?v.fsPath:v.toString()}return M.path}function t(M,v){const E=v?c:h,D=(0,L.$vn)(M);return i(D,(N,O)=>{N&&O&&(O.path=E(O))}),D}e.$fG=t;function u(M,v){const E=v?c:h,D=(0,L.$vn)(M);return i(D,(N,O)=>{!N&&O&&(O.path=E(O))}),D}e.$gG=u;function i(M,v){switch(M.type){case"event":{const E=M;switch(E.event){case"output":v(!1,E.body.source);break;case"loadedSource":v(!1,E.body.source);break;case"breakpoint":v(!1,E.body.breakpoint.source);break;default:break}break}case"request":{const E=M;switch(E.command){case"setBreakpoints":v(!0,E.arguments.source);break;case"breakpointLocations":v(!0,E.arguments.source);break;case"source":v(!0,E.arguments.source);break;case"gotoTargets":v(!0,E.arguments.source);break;case"launchVSCode":E.arguments.args.forEach(D=>v(!1,D));break;default:break}break}case"response":{const E=M;if(E.success&&E.body)switch(E.command){case"stackTrace":E.body.stackFrames.forEach(D=>v(!1,D.source));break;case"loadedSources":E.body.sources.forEach(D=>v(!1,D));break;case"scopes":E.body.scopes.forEach(D=>v(!1,D.source));break;case"setFunctionBreakpoints":E.body.breakpoints.forEach(D=>v(!1,D.source));break;case"setBreakpoints":E.body.breakpoints.forEach(D=>v(!1,D.source));break;case"disassemble":E.body?.instructions.forEach(N=>v(!1,N.location));break;default:break}break}}}function g(M){return M.filter(v=>!v.presentation?.hidden).sort((v,E)=>v.presentation?E.presentation?v.presentation.group?E.presentation.group?v.presentation.group!==E.presentation.group?v.presentation.group.localeCompare(E.presentation.group):m(v.presentation.order,E.presentation.order):-1:E.presentation.group?1:m(v.presentation.order,E.presentation.order):-1:E.presentation?1:0)}e.$hG=g;function m(M,v){return typeof M!="number"?typeof v!="number"?0:1:typeof v!="number"?-1:M-v}async function d(M,v){const E=M.getValue("debug.saveBeforeStart",{overrideIdentifier:v.activeTextEditorLanguageId});if(E!=="none"&&(await v.saveAll(),E==="allEditorsInActiveGroup")){const D=v.activeEditorPane;D&&D.input.resource?.scheme===R.Schemas.untitled&&await v.save({editor:D.input,groupId:D.group.id})}await M.reloadConfiguration()}e.$iG=d;const S=(M,v)=>!M||!v?M===v:M.name===v.name&&M.path===v.path&&M.sourceReference===v.sourceReference;e.$jG=S}),define(Pe[76],Re([1,0,24,34,67,68,12,19,21,35]),function(ge,e,y,T,C,L,R,$,f,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_I=e.$$I=e.$0I=e.$9I=e.CellStatusbarAlignment=e.$8I=e.$7I=e.$6I=e.NotebookEditorPriority=e.$5I=e.$4I=e.$3I=e.$2I=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$1I=e.$ZI=e.$YI=e.$XI=e.CellKind=e.$WI=e.$VI=e.$UI=void 0,e.$UI="workbench.editor.notebook",e.$VI="workbench.editor.notebookTextDiffEditor",e.$WI="workbench.editor.interactive";var A;(function(I){I[I.Markup=1]="Markup",I[I.Code=2]="Code"})(A||(e.CellKind=A={})),e.$XI=["application/json","application/javascript","text/html","image/svg+xml",L.$fs.latex,L.$fs.markdown,"image/png","image/jpeg",L.$fs.text],e.$YI=[L.$fs.latex,L.$fs.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",L.$fs.text],e.$ZI=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$1I="_notAvailable";var k;(function(I){I[I.Running=1]="Running",I[I.Idle=2]="Idle"})(k||(e.NotebookRunState=k={}));var l;(function(I){I[I.Unconfirmed=1]="Unconfirmed",I[I.Pending=2]="Pending",I[I.Executing=3]="Executing"})(l||(e.NotebookCellExecutionState=l={}));var p;(function(I){I[I.Unconfirmed=1]="Unconfirmed",I[I.Pending=2]="Pending",I[I.Executing=3]="Executing"})(p||(e.NotebookExecutionState=p={}));var w;(function(I){I[I.WithHardKernelDependency=0]="WithHardKernelDependency",I[I.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",I[I.Pure=2]="Pure",I[I.Never=3]="Never"})(w||(e.NotebookRendererMatch=w={}));var s;(function(I){I.Always="always",I.Never="never",I.Optional="optional"})(s||(e.RendererMessagingSpec=s={}));var a;(function(I){I[I.ModelChange=1]="ModelChange",I[I.Move=2]="Move",I[I.ChangeCellLanguage=5]="ChangeCellLanguage",I[I.Initialize=6]="Initialize",I[I.ChangeCellMetadata=7]="ChangeCellMetadata",I[I.Output=8]="Output",I[I.OutputItem=9]="OutputItem",I[I.ChangeCellContent=10]="ChangeCellContent",I[I.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",I[I.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",I[I.ChangeCellMime=13]="ChangeCellMime",I[I.Unknown=100]="Unknown"})(a||(e.NotebookCellsChangeType=a={}));var r;(function(I){I[I.Handle=0]="Handle",I[I.Index=1]="Index"})(r||(e.SelectionStateType=r={}));var n;(function(I){I[I.Replace=1]="Replace",I[I.Output=2]="Output",I[I.Metadata=3]="Metadata",I[I.CellLanguage=4]="CellLanguage",I[I.DocumentMetadata=5]="DocumentMetadata",I[I.Move=6]="Move",I[I.OutputItems=7]="OutputItems",I[I.PartialMetadata=8]="PartialMetadata",I[I.PartialInternalMetadata=9]="PartialInternalMetadata"})(n||(e.CellEditType=n={}));var o;(function(I){I.scheme=R.Schemas.vscodeNotebookCell;const H=["W","X","Y","Z","a","b","c","d","e","f"],ae=new RegExp(`^[${H.join("")}]+`),de=7;function we(ne,Y){const V=Y.toString(de),Ie=`${V.length<H.length?H[V.length-1]:"z"}${V}s${(0,y.$De)(y.$je.fromString(ne.scheme),!0,!0)}`;return ne.with({scheme:I.scheme,fragment:Ie})}I.generate=we;function ke(ne){if(ne.scheme!==I.scheme)return;const Y=ne.fragment.indexOf("s");if(Y<0)return;const V=parseInt(ne.fragment.substring(0,Y).replace(ae,""),de),ie=(0,y.$Ce)(ne.fragment.substring(Y+1)).toString();if(!isNaN(V))return{handle:V,notebook:ne.with({scheme:ie,fragment:null})}}I.parse=ke;function le(ne,Y){return ne.with({scheme:R.Schemas.vscodeNotebookCellOutput,fragment:`op${Y??""},${ne.scheme!==R.Schemas.file?ne.scheme:""}`})}I.generateCellOutputUri=le;function ve(ne){if(ne.scheme!==R.Schemas.vscodeNotebookCellOutput)return;const Y=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(ne.fragment);if(!Y)return;const V=Y[1]&&Y[1]!==""?Y[1]:void 0,ie=Y[2];return{outputId:V,notebook:ne.with({scheme:ie||R.Schemas.file,fragment:null})}}I.parseCellOutputUri=ve;function se(ne,Y,V){return I.generate(ne,Y).with({scheme:V})}I.generateCellPropertyUri=se;function be(ne,Y){if(ne.scheme===Y)return I.parse(ne.with({scheme:I.scheme}))}I.parseCellPropertyUri=be})(o||(e.CellUri=o={}));const c=I=>f.$i?I.replace(/\//g,"\\"):I;class h{constructor(H=[],ae=e.$XI){this.e=ae,this.d=[...new Set(H)].map(de=>({pattern:de,matches:T.$Mj(c(de))}))}sort(H){const ae=new Map(C.Iterable.map(H,we=>[we,c(we)]));let de=[];for(const{matches:we}of this.d)for(const[ke,le]of ae)if(we(le)){de.push(ke),ae.delete(ke);break}return ae.size&&(de=de.concat([...ae.keys()].sort((we,ke)=>this.e.indexOf(we)-this.e.indexOf(ke)))),de}prioritize(H,ae){const de=this.f(H);if(de===-1){this.d.unshift({pattern:H,matches:T.$Mj(c(H))});return}const we=new Set(ae.map(le=>this.f(le,de)));we.delete(-1);const ke=Array.from(we).sort();this.d.splice(de+1,0,...ke.map(le=>this.d[le]));for(let le=ke.length-1;le>=0;le--)this.d.splice(ke[le],1)}toArray(){return this.d.map(H=>H.pattern)}f(H,ae=this.d.length){const de=c(H);for(let we=0;we<ae;we++)if(this.d[we].matches(de))return we;return-1}}e.$2I=h;function t(I,H,ae,de=(we,ke)=>we===ke){const we=[];function ke(se,be,ne){if(be===0&&ne.length===0)return;const Y=we[we.length-1];Y&&Y.start+Y.deleteCount===se?(Y.deleteCount+=be,Y.toInsert.push(...ne)):we.push({start:se,deleteCount:be,toInsert:ne})}let le=0,ve=0;for(;;){if(le===I.length){ke(le,0,H.slice(ve));break}if(ve===H.length){ke(le,I.length-le,[]);break}const se=I[le],be=H[ve];if(de(se,be)){le+=1,ve+=1;continue}ae(be)?(ke(le,1,[]),le+=1):(ke(le,0,[be]),ve+=1)}return we}e.$3I=t,e.$4I=new b.$kj("notebookEditorCursorAtBoundary","none"),e.$5I=new b.$kj("notebookEditorCursorAtLineBoundary","none");var u;(function(I){I.default="default",I.option="option"})(u||(e.NotebookEditorPriority=u={}));function i(I){const H=I;return!!((typeof H.include=="string"||T.$Nj(H.include))&&(typeof H.exclude=="string"||T.$Nj(H.exclude)))}e.$6I=i;function g(I,H,ae){if(Array.isArray(I.viewType)&&I.viewType.indexOf(H)>=0||I.viewType===H)return!0;if(I.filenamePattern){const de=i(I.filenamePattern)?I.filenamePattern.include:I.filenamePattern,we=i(I.filenamePattern)?I.filenamePattern.exclude:void 0;if(T.$Lj(de,(0,$.$nc)(ae.fsPath).toLowerCase()))return!(we&&T.$Lj(we,(0,$.$nc)(ae.fsPath).toLowerCase()))}return!1}e.$7I=g,e.$8I={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell",cellChat:"notebook.experimental.cellChat"};var m;(function(I){I[I.Left=1]="Left",I[I.Right=2]="Right"})(m||(e.CellStatusbarAlignment=m={}));class d{static{this.d="notebook/"}static create(H){return`${d.d}${H}`}static parse(H){if(H.startsWith(d.d))return H.substring(d.d.length)}}e.$9I=d;function S(I){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(I)}e.$0I=S;const M=new TextDecoder;function v(I){const H=[];let ae=!1;for(const le of I)(H.length===0||ae)&&(H.push(le),ae=!0);let de=N(H);const we=y.$je.concat(H.map(le=>y.$je.wrap(le))),ke=P(we);return de=de||ke.byteLength!==we.byteLength,{data:ke,didCompression:de}}e.$$I=v,e.$_I=`${String.fromCharCode(27)}[A`;const E=e.$_I.split("").map(I=>I.charCodeAt(0)),D=10;function N(I){let H=!1;return I.forEach((ae,de)=>{if(de===0||ae.length<e.$_I.length)return;const we=I[de-1],ke=ae.subarray(0,e.$_I.length);if(ke[0]===E[0]&&ke[1]===E[1]&&ke[2]===E[2]){const le=we.lastIndexOf(D);if(le===-1)return;H=!0,I[de-1]=we.subarray(0,le),I[de]=ae.subarray(e.$_I.length)}}),H}function O(I){let H=I;do I=H,H=I.replace(/[^\n]\x08/gm,"");while(H.length<I.length);return I}function G(I){for(I=I.replace(/\r+\n/gm,`
`);I.search(/\r[^$]/g)>-1;){const H=I.match(/^(.*)\r+/m)[1];let ae=I.match(/\r+(.*)$/m)[1];ae=ae+H.slice(ae.length,H.length),I=I.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,ae)}return I}const W="\b".charCodeAt(0),z="\r".charCodeAt(0);function P(I){return!I.buffer.includes(W)&&!I.buffer.includes(z)?I:y.$je.fromString(G(O(M.decode(I.buffer))))}}),define(Pe[7],Re([1,0,18,15,52,28,68,11,16,2,33,22,41,100,76]),function(ge,e,y,T,C,L,R,$,f,b,A,k,l,p,w){"use strict";var s,a,r,n,o,c,h,t,u,i,g,m,d,S,M,v,E;Object.defineProperty(e,"__esModule",{value:!0}),e.SpeechToTextStatus=e.RelatedInformationType=e.ChatAgentResultFeedbackKind=e.$YM=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.$XM=e.ChatVariableLevel=e.ChatAgentCopyKind=e.InteractiveSessionVoteDirection=e.$WM=e.$VM=e.$UM=e.$TM=e.$SM=e.$RM=e.$QM=e.$PM=e.$OM=e.$NM=e.$MM=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$LM=e.$KM=e.$JM=e.$IM=e.$HM=e.$GM=e.$FM=e.$EM=e.TestRunProfileKind=e.TestResultState=e.$DM=e.$CM=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$BM=e.NotebookVariablesRequestKind=e.$AM=e.$zM=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$yM=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$xM=e.$wM=e.$vM=e.$uM=e.$tM=e.ColorThemeKind=e.$sM=e.$rM=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$qM=e.DebugConsoleMode=e.$pM=e.$oM=e.$nM=e.$mM=e.$lM=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$kM=e.$jM=e.FileChangeType=e.$iM=e.$hM=e.$gM=e.$fM=e.InlineCompletionTriggerKind=e.$eM=e.$dM=e.$cM=e.$bM=e.$aM=e.$_L=e.$$L=e.$0L=e.$9L=e.$8L=e.$7L=e.$6L=e.$5L=e.ConfigurationTarget=e.$4L=e.$3L=e.$2L=e.$1L=e.$ZL=e.$YL=e.$XL=e.$WL=e.$VL=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$UL=e.ViewBadge=e.ProgressLocation=e.$TL=e.$SL=e.TaskScope=e.ShellQuoting=e.$RL=e.$QL=e.$PL=e.TaskPanelKind=e.TaskRevealKind=e.$OL=e.TerminalLocation=e.$NL=e.$ML=e.$LL=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$KL=e.$JL=e.$IL=e.$HL=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$GL=e.StatusBarAlignment=e.ViewColumn=e.$FL=e.$EL=e.$DL=e.$CL=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$BL=e.$AL=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$zL=e.$yL=e.$xL=e.$wL=e.$vL=e.LanguageStatusSeverity=e.$uL=e.$tL=e.$sL=e.$rL=e.$qL=e.$pL=e.CodeActionTriggerKind=e.$oL=e.$nL=e.SymbolTag=e.SymbolKind=e.$mL=e.$lL=e.DocumentHighlightKind=e.$kL=e.$jL=e.$iL=e.$hL=e.DiagnosticSeverity=e.DiagnosticTag=e.$gL=e.$fL=e.FileEditType=e.$eL=e.$dL=e.$cL=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$bL=e.$aL=e.$_K=e.$$K=e.$0K=e.$9K=e.$8K=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function D(B){return Object.assign(B,{apply:function(...oe){if(oe.length===0)return Reflect.construct(B,[]);{const De=oe.length===1?[]:oe[1];return Reflect.construct(B,De,oe[0].constructor)}},call:function(...oe){if(oe.length===0)return Reflect.construct(B,[]);{const[De,...Ge]=oe;return Reflect.construct(B,Ge,De.constructor)}}})}var N;(function(B){B[B.Top=0]="Top",B[B.Bottom=1]="Bottom"})(N||(e.TerminalOutputAnchor=N={}));var O;(function(B){B[B.TerminalCommand=0]="TerminalCommand",B[B.Opener=1]="Opener",B[B.Command=3]="Command"})(O||(e.TerminalQuickFixType=O={}));let G=s=class{static from(...j){let oe=j;return new s(function(){if(oe){for(const De of oe)De&&typeof De.dispose=="function"&&De.dispose();oe=void 0}})}#e;constructor(j){this.#e=j}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$8K=G,e.$8K=G=s=Je([D],G);let W=a=class{static Min(...j){if(j.length===0)throw new TypeError;let oe=j[0];for(let De=1;De<j.length;De++){const Ge=j[De];Ge.isBefore(oe)&&(oe=Ge)}return oe}static Max(...j){if(j.length===0)throw new TypeError;let oe=j[0];for(let De=1;De<j.length;De++){const Ge=j[De];Ge.isAfter(oe)&&(oe=Ge)}return oe}static isPosition(j){if(!j)return!1;if(j instanceof a)return!0;const{line:oe,character:De}=j;return typeof oe=="number"&&typeof De=="number"}static of(j){if(j instanceof a)return j;if(this.isPosition(j))return new a(j.line,j.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(j,oe){if(j<0)throw(0,T.$7)("line must be non-negative");if(oe<0)throw(0,T.$7)("character must be non-negative");this.c=j,this.e=oe}isBefore(j){return this.c<j.c?!0:j.c<this.c?!1:this.e<j.e}isBeforeOrEqual(j){return this.c<j.c?!0:j.c<this.c?!1:this.e<=j.e}isAfter(j){return!this.isBeforeOrEqual(j)}isAfterOrEqual(j){return!this.isBefore(j)}isEqual(j){return this.c===j.c&&this.e===j.e}compareTo(j){return this.c<j.c?-1:this.c>j.line?1:this.e<j.e?-1:this.e>j.e?1:0}translate(j,oe=0){if(j===null||oe===null)throw(0,T.$7)();let De;return typeof j>"u"?De=0:typeof j=="number"?De=j:(De=typeof j.lineDelta=="number"?j.lineDelta:0,oe=typeof j.characterDelta=="number"?j.characterDelta:0),De===0&&oe===0?this:new a(this.line+De,this.character+oe)}with(j,oe=this.character){if(j===null||oe===null)throw(0,T.$7)();let De;return typeof j>"u"?De=this.line:typeof j=="number"?De=j:(De=typeof j.line=="number"?j.line:this.line,oe=typeof j.character=="number"?j.character:this.character),De===this.line&&oe===this.character?this:new a(De,oe)}toJSON(){return{line:this.line,character:this.character}}};e.$9K=W,e.$9K=W=a=Je([D],W);let z=r=class{static isRange(j){return j instanceof r?!0:j?W.isPosition(j.start)&&W.isPosition(j.end):!1}static of(j){if(j instanceof r)return j;if(this.isRange(j))return new r(j.start,j.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(j,oe,De,Ge){let xe,ut;if(typeof j=="number"&&typeof oe=="number"&&typeof De=="number"&&typeof Ge=="number"?(xe=new W(j,oe),ut=new W(De,Ge)):W.isPosition(j)&&W.isPosition(oe)&&(xe=W.of(j),ut=W.of(oe)),!xe||!ut)throw new Error("Invalid arguments");xe.isBefore(ut)?(this.c=xe,this.e=ut):(this.c=ut,this.e=xe)}contains(j){return r.isRange(j)?this.contains(j.start)&&this.contains(j.end):W.isPosition(j)?!(W.of(j).isBefore(this.c)||this.e.isBefore(j)):!1}isEqual(j){return this.c.isEqual(j.c)&&this.e.isEqual(j.e)}intersection(j){const oe=W.Max(j.start,this.c),De=W.Min(j.end,this.e);if(!oe.isAfter(De))return new r(oe,De)}union(j){if(this.contains(j))return this;if(j.contains(this))return j;const oe=W.Min(j.start,this.c),De=W.Max(j.end,this.end);return new r(oe,De)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(j,oe=this.end){if(j===null||oe===null)throw(0,T.$7)();let De;return j?W.isPosition(j)?De=j:(De=j.start||this.start,oe=j.end||this.end):De=this.start,De.isEqual(this.c)&&oe.isEqual(this.end)?this:new r(De,oe)}toJSON(){return[this.start,this.end]}};e.$0K=z,e.$0K=z=r=Je([D],z);let P=n=class extends z{static isSelection(j){return j instanceof n?!0:j?z.isRange(j)&&W.isPosition(j.anchor)&&W.isPosition(j.active)&&typeof j.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(j,oe,De,Ge){let xe,ut;if(typeof j=="number"&&typeof oe=="number"&&typeof De=="number"&&typeof Ge=="number"?(xe=new W(j,oe),ut=new W(De,Ge)):W.isPosition(j)&&W.isPosition(oe)&&(xe=W.of(j),ut=W.of(oe)),!xe||!ut)throw new Error("Invalid arguments");super(xe,ut),this.f=xe,this.g=ut}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$$K=P,e.$$K=P=n=Je([D],P);const I=B=>{if(typeof B!="string"||B.length===0||!/^[0-9A-Za-z_\-]+$/.test(B))throw(0,T.$7)("connectionToken")};class H{static isResolvedAuthority(j){return j&&typeof j=="object"&&typeof j.host=="string"&&typeof j.port=="number"&&(j.connectionToken===void 0||typeof j.connectionToken=="string")}constructor(j,oe,De){if(typeof j!="string"||j.length===0)throw(0,T.$7)("host");if(typeof oe!="number"||oe===0||Math.round(oe)!==oe)throw(0,T.$7)("port");typeof De<"u"&&I(De),this.host=j,this.port=Math.round(oe),this.connectionToken=De}}e.$_K=H;class ae{static isManagedResolvedAuthority(j){return j&&typeof j=="object"&&typeof j.makeConnection=="function"&&(j.connectionToken===void 0||typeof j.connectionToken=="string")}constructor(j,oe){this.makeConnection=j,this.connectionToken=oe,typeof oe<"u"&&I(oe)}}e.$aL=ae;class de extends Error{static NotAvailable(j,oe){return new de(j,p.RemoteAuthorityResolverErrorCode.NotAvailable,oe)}static TemporarilyNotAvailable(j){return new de(j,p.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(j,oe=p.RemoteAuthorityResolverErrorCode.Unknown,De){super(j),this._message=j,this._code=oe,this._detail=De,Object.setPrototypeOf(this,de.prototype)}}e.$bL=de;var we;(function(B){B[B.LF=1]="LF",B[B.CRLF=2]="CRLF"})(we||(e.EndOfLine=we={}));var ke;(function(B){B[B.Replace=1]="Replace",B[B.Append=2]="Append",B[B.Prepend=3]="Prepend"})(ke||(e.EnvironmentVariableMutatorType=ke={}));let le=o=class{static isTextEdit(j){return j instanceof o?!0:j?z.isRange(j)&&typeof j.newText=="string":!1}static replace(j,oe){return new o(j,oe)}static insert(j,oe){return o.replace(new z(j,j),oe)}static delete(j){return o.replace(j,"")}static setEndOfLine(j){const oe=new o(new z(new W(0,0),new W(0,0)),"");return oe.newEol=j,oe}get range(){return this.c}set range(j){if(j&&!z.isRange(j))throw(0,T.$7)("range");this.c=j}get newText(){return this.e||""}set newText(j){if(j&&typeof j!="string")throw(0,T.$7)("newText");this.e=j}get newEol(){return this.f}set newEol(j){if(j&&typeof j!="number")throw(0,T.$7)("newEol");this.f=j}constructor(j,oe){this.c=j,this.e=oe}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$cL=le,e.$cL=le=o=Je([D],le);let ve=c=class{static isNotebookCellEdit(j){return j instanceof c?!0:j?ei.isNotebookRange(j)&&Array.isArray(j.newCells):!1}static replaceCells(j,oe){return new c(j,oe)}static insertCells(j,oe){return new c(new ei(j,j),oe)}static deleteCells(j){return new c(j,[])}static updateCellMetadata(j,oe){const De=new c(new ei(j,j),[]);return De.newCellMetadata=oe,De}static updateNotebookMetadata(j){const oe=new c(new ei(0,0),[]);return oe.newNotebookMetadata=j,oe}constructor(j,oe){this.range=j,this.newCells=oe}};e.$dL=ve,e.$dL=ve=c=Je([D],ve);class se{static isSnippetTextEdit(j){return j instanceof se?!0:j?z.isRange(j.range)&&Y.isSnippetString(j.snippet):!1}static replace(j,oe){return new se(j,oe)}static insert(j,oe){return se.replace(new z(j,j),oe)}constructor(j,oe){this.range=j,this.snippet=oe}}e.$eL=se;var be;(function(B){B[B.File=1]="File",B[B.Text=2]="Text",B[B.Cell=3]="Cell",B[B.CellReplace=5]="CellReplace",B[B.Snippet=6]="Snippet"})(be||(e.FileEditType=be={}));let ne=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(j,oe,De,Ge){this.c.push({_type:1,from:j,to:oe,options:De,metadata:Ge})}createFile(j,oe,De){this.c.push({_type:1,from:void 0,to:j,options:oe,metadata:De})}deleteFile(j,oe,De){this.c.push({_type:1,from:j,to:void 0,options:oe,metadata:De})}e(j,oe,De){this.c.push({_type:3,metadata:De,uri:j,edit:{editType:5,metadata:oe},notebookMetadata:oe})}f(j,oe,De,Ge){const xe=oe.start,ut=oe.end;(xe!==ut||De.length>0)&&this.c.push({_type:5,uri:j,index:xe,count:ut-xe,cells:De,metadata:Ge})}g(j,oe,De,Ge){this.c.push({_type:3,metadata:Ge,uri:j,edit:{editType:3,index:oe,metadata:De}})}replace(j,oe,De,Ge){this.c.push({_type:2,uri:j,edit:new le(oe,De),metadata:Ge})}insert(j,oe,De,Ge){this.replace(j,new z(oe,oe),De,Ge)}delete(j,oe,De){this.replace(j,oe,"",De)}has(j){return this.c.some(oe=>oe._type===2&&oe.uri.toString()===j.toString())}set(j,oe){if(oe)for(const De of oe){if(!De)continue;let Ge,xe;Array.isArray(De)?(Ge=De[0],xe=De[1]):Ge=De,ve.isNotebookCellEdit(Ge)?Ge.newCellMetadata?this.g(j,Ge.range.start,Ge.newCellMetadata,xe):Ge.newNotebookMetadata?this.e(j,Ge.newNotebookMetadata,xe):this.f(j,Ge.range,Ge.newCells,xe):se.isSnippetTextEdit(Ge)?this.c.push({_type:6,uri:j,range:Ge.range,edit:Ge.snippet,metadata:xe}):this.c.push({_type:2,uri:j,edit:Ge,metadata:xe})}else{for(let De=0;De<this.c.length;De++){const Ge=this.c[De];switch(Ge._type){case 2:case 6:case 3:case 5:Ge.uri.toString()===j.toString()&&(this.c[De]=void 0);break}}(0,y.$Ib)(this.c)}}get(j){const oe=[];for(const De of this.c)De._type===2&&De.uri.toString()===j.toString()&&oe.push(De.edit);return oe}entries(){const j=new L.$Ac;for(const oe of this.c)if(oe._type===2){let De=j.get(oe.uri);De||(De=[oe.uri,[]],j.set(oe.uri,De)),De[1].push(oe.edit)}return[...j.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$fL=ne,e.$fL=ne=Je([D],ne);let Y=h=class{static isSnippetString(j){return j instanceof h?!0:j?typeof j.value=="string":!1}static c(j){return j.replace(/\$|}|\\/g,"\\$&")}constructor(j){this.e=1,this.value=j||""}appendText(j){return this.value+=h.c(j),this}appendTabstop(j=this.e++){return this.value+="$",this.value+=j,this}appendPlaceholder(j,oe=this.e++){if(typeof j=="function"){const De=new h;De.e=this.e,j(De),this.e=De.e,j=De.value}else j=h.c(j);return this.value+="${",this.value+=oe,this.value+=":",this.value+=j,this.value+="}",this}appendChoice(j,oe=this.e++){const De=j.map(Ge=>Ge.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=oe,this.value+="|",this.value+=De,this.value+="|}",this}appendVariable(j,oe){if(typeof oe=="function"){const De=new h;De.e=this.e,oe(De),this.e=De.e,oe=De.value}else typeof oe=="string"&&(oe=oe.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=j,oe&&(this.value+=":",this.value+=oe),this.value+="}",this}};e.$gL=Y,e.$gL=Y=h=Je([D],Y);var V;(function(B){B[B.Unnecessary=1]="Unnecessary",B[B.Deprecated=2]="Deprecated"})(V||(e.DiagnosticTag=V={}));var ie;(function(B){B[B.Hint=3]="Hint",B[B.Information=2]="Information",B[B.Warning=1]="Warning",B[B.Error=0]="Error"})(ie||(e.DiagnosticSeverity=ie={}));let Ie=t=class{static isLocation(j){return j instanceof t?!0:j?z.isRange(j.range)&&b.URI.isUri(j.uri):!1}constructor(j,oe){if(this.uri=j,oe)if(z.isRange(oe))this.range=z.of(oe);else if(W.isPosition(oe))this.range=new z(oe,oe);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$hL=Ie,e.$hL=Ie=t=Je([D],Ie);let Le=class{static is(j){return j?typeof j.message=="string"&&j.location&&z.isRange(j.location.range)&&b.URI.isUri(j.location.uri):!1}constructor(j,oe){this.location=j,this.message=oe}static isEqual(j,oe){return j===oe?!0:!j||!oe?!1:j.message===oe.message&&j.location.range.isEqual(oe.location.range)&&j.location.uri.toString()===oe.location.uri.toString()}};e.$iL=Le,e.$iL=Le=Je([D],Le);let Ce=class{constructor(j,oe,De=ie.Error){if(!z.isRange(j))throw new TypeError("range must be set");if(!oe)throw new TypeError("message must be set");this.range=j,this.message=oe,this.severity=De}toJSON(){return{severity:ie[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(j,oe){return j===oe?!0:!j||!oe?!1:j.message===oe.message&&j.severity===oe.severity&&j.code===oe.code&&j.severity===oe.severity&&j.source===oe.source&&j.range.isEqual(oe.range)&&(0,y.$ub)(j.tags,oe.tags)&&(0,y.$ub)(j.relatedInformation,oe.relatedInformation,Le.isEqual)}};e.$jL=Ce,e.$jL=Ce=Je([D],Ce);let ce=class{constructor(j,oe){if(!j)throw new Error("Illegal argument, contents must be defined");Array.isArray(j)?this.contents=j:this.contents=[j],this.range=oe}};e.$kL=ce,e.$kL=ce=Je([D],ce);var te;(function(B){B[B.Text=0]="Text",B[B.Read=1]="Read",B[B.Write=2]="Write"})(te||(e.DocumentHighlightKind=te={}));let Q=class{constructor(j,oe=te.Text){this.range=j,this.kind=oe}toJSON(){return{range:this.range,kind:te[this.kind]}}};e.$lL=Q,e.$lL=Q=Je([D],Q);let ee=class{constructor(j,oe){this.uri=j,this.highlights=oe}toJSON(){return{uri:this.uri,highlights:this.highlights.map(j=>j.toJSON())}}};e.$mL=ee,e.$mL=ee=Je([D],ee);var me;(function(B){B[B.File=0]="File",B[B.Module=1]="Module",B[B.Namespace=2]="Namespace",B[B.Package=3]="Package",B[B.Class=4]="Class",B[B.Method=5]="Method",B[B.Property=6]="Property",B[B.Field=7]="Field",B[B.Constructor=8]="Constructor",B[B.Enum=9]="Enum",B[B.Interface=10]="Interface",B[B.Function=11]="Function",B[B.Variable=12]="Variable",B[B.Constant=13]="Constant",B[B.String=14]="String",B[B.Number=15]="Number",B[B.Boolean=16]="Boolean",B[B.Array=17]="Array",B[B.Object=18]="Object",B[B.Key=19]="Key",B[B.Null=20]="Null",B[B.EnumMember=21]="EnumMember",B[B.Struct=22]="Struct",B[B.Event=23]="Event",B[B.Operator=24]="Operator",B[B.TypeParameter=25]="TypeParameter"})(me||(e.SymbolKind=me={}));var pe;(function(B){B[B.Deprecated=1]="Deprecated"})(pe||(e.SymbolTag=pe={}));let Ae=u=class{static validate(j){if(!j.name)throw new Error("name must not be falsy")}constructor(j,oe,De,Ge,xe){this.name=j,this.kind=oe,this.containerName=xe,typeof De=="string"&&(this.containerName=De),Ge instanceof Ie?this.location=Ge:De instanceof z&&(this.location=new Ie(Ge,De)),u.validate(this)}toJSON(){return{name:this.name,kind:me[this.kind],location:this.location,containerName:this.containerName}}};e.$nL=Ae,e.$nL=Ae=u=Je([D],Ae);let he=i=class{static validate(j){if(!j.name)throw new Error("name must not be falsy");if(!j.range.contains(j.selectionRange))throw new Error("selectionRange must be contained in fullRange");j.children?.forEach(i.validate)}constructor(j,oe,De,Ge,xe){this.name=j,this.detail=oe,this.kind=De,this.range=Ge,this.selectionRange=xe,this.children=[],i.validate(this)}};e.$oL=he,e.$oL=he=i=Je([D],he);var ye;(function(B){B[B.Invoke=1]="Invoke",B[B.Automatic=2]="Automatic"})(ye||(e.CodeActionTriggerKind=ye={}));let F=class{constructor(j,oe){this.title=j,this.kind=oe}};e.$pL=F,e.$pL=F=Je([D],F);let q=class{static{g=this}static{this.c="."}constructor(j){this.value=j}append(j){return new g(this.value?this.value+g.c+j:j)}intersects(j){return this.contains(j)||j.contains(this)}contains(j){return this.value===j.value||j.value.startsWith(this.value+g.c)}};e.$qL=q,e.$qL=q=g=Je([D],q),q.Empty=new q(""),q.QuickFix=q.Empty.append("quickfix"),q.Refactor=q.Empty.append("refactor"),q.RefactorExtract=q.Refactor.append("extract"),q.RefactorInline=q.Refactor.append("inline"),q.RefactorMove=q.Refactor.append("move"),q.RefactorRewrite=q.Refactor.append("rewrite"),q.Source=q.Empty.append("source"),q.SourceOrganizeImports=q.Source.append("organizeImports"),q.SourceFixAll=q.Source.append("fixAll"),q.Notebook=q.Empty.append("notebook");let K=class{constructor(j,oe){if(this.range=j,this.parent=oe,oe&&!oe.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$rL=K,e.$rL=K=Je([D],K);class U{constructor(j,oe,De,Ge,xe,ut){this.kind=j,this.name=oe,this.detail=De,this.uri=Ge,this.range=xe,this.selectionRange=ut}}e.$sL=U;class X{constructor(j,oe){this.fromRanges=oe,this.from=j}}e.$tL=X;class x{constructor(j,oe){this.fromRanges=oe,this.to=j}}e.$uL=x;var Ee;(function(B){B[B.Information=0]="Information",B[B.Warning=1]="Warning",B[B.Error=2]="Error"})(Ee||(e.LanguageStatusSeverity=Ee={}));let Te=class{constructor(j,oe){this.range=j,this.command=oe}get isResolved(){return!!this.command}};e.$vL=Te,e.$vL=Te=Je([D],Te);let Ve=m=class{#e;static isMarkdownString(j){return j instanceof m?!0:j&&j.appendCodeblock&&j.appendMarkdown&&j.appendText&&j.value!==void 0}constructor(j,oe=!1){this.#e=new C.$hk(j,{supportThemeIcons:oe})}get value(){return this.#e.value}set value(j){this.#e.value=j}get isTrusted(){return this.#e.isTrusted}set isTrusted(j){this.#e.isTrusted=j}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(j){this.#e.supportThemeIcons=j}get supportHtml(){return this.#e.supportHtml}set supportHtml(j){this.#e.supportHtml=j}get baseUri(){return this.#e.baseUri}set baseUri(j){this.#e.baseUri=j}appendText(j){return this.#e.appendText(j),this}appendMarkdown(j){return this.#e.appendMarkdown(j),this}appendCodeblock(j,oe){return this.#e.appendCodeblock(oe??"",j),this}};e.$wL=Ve,e.$wL=Ve=m=Je([D],Ve);let He=class{constructor(j,oe){this.label=j,this.documentation=oe}};e.$xL=He,e.$xL=He=Je([D],He);let Ye=class{constructor(j,oe){this.label=j,this.documentation=oe,this.parameters=[]}};e.$yL=Ye,e.$yL=Ye=Je([D],Ye);let st=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$zL=st,e.$zL=st=Je([D],st);var nt;(function(B){B[B.Invoke=1]="Invoke",B[B.TriggerCharacter=2]="TriggerCharacter",B[B.ContentChange=3]="ContentChange"})(nt||(e.SignatureHelpTriggerKind=nt={}));var tt;(function(B){B[B.Type=1]="Type",B[B.Parameter=2]="Parameter"})(tt||(e.InlayHintKind=tt={}));let at=class{constructor(j){this.value=j}};e.$AL=at,e.$AL=at=Je([D],at);let ct=class{constructor(j,oe,De){this.position=j,this.label=oe,this.kind=De}};e.$BL=ct,e.$BL=ct=Je([D],ct);var je;(function(B){B[B.Invoke=0]="Invoke",B[B.TriggerCharacter=1]="TriggerCharacter",B[B.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(je||(e.CompletionTriggerKind=je={}));var vt;(function(B){B[B.Text=0]="Text",B[B.Method=1]="Method",B[B.Function=2]="Function",B[B.Constructor=3]="Constructor",B[B.Field=4]="Field",B[B.Variable=5]="Variable",B[B.Class=6]="Class",B[B.Interface=7]="Interface",B[B.Module=8]="Module",B[B.Property=9]="Property",B[B.Unit=10]="Unit",B[B.Value=11]="Value",B[B.Enum=12]="Enum",B[B.Keyword=13]="Keyword",B[B.Snippet=14]="Snippet",B[B.Color=15]="Color",B[B.File=16]="File",B[B.Reference=17]="Reference",B[B.Folder=18]="Folder",B[B.EnumMember=19]="EnumMember",B[B.Constant=20]="Constant",B[B.Struct=21]="Struct",B[B.Event=22]="Event",B[B.Operator=23]="Operator",B[B.TypeParameter=24]="TypeParameter",B[B.User=25]="User",B[B.Issue=26]="Issue"})(vt||(e.CompletionItemKind=vt={}));var Z;(function(B){B[B.Deprecated=1]="Deprecated"})(Z||(e.CompletionItemTag=Z={}));let _=class{constructor(j,oe){this.label=j,this.kind=oe}toJSON(){return{label:this.label,kind:this.kind&&vt[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$CL=_,e.$CL=_=Je([D],_);let $e=class{constructor(j=[],oe=!1){this.items=j,this.isIncomplete=oe}};e.$DL=$e,e.$DL=$e=Je([D],$e);let Be=class{constructor(j,oe,De){this.insertText=j,this.range=oe,this.command=De}};e.$EL=Be,e.$EL=Be=Je([D],Be);let Qe=class{constructor(j){this.commands=void 0,this.suppressSuggestions=void 0,this.items=j}};e.$FL=Qe,e.$FL=Qe=Je([D],Qe);var it;(function(B){B[B.Active=-1]="Active",B[B.Beside=-2]="Beside",B[B.One=1]="One",B[B.Two=2]="Two",B[B.Three=3]="Three",B[B.Four=4]="Four",B[B.Five=5]="Five",B[B.Six=6]="Six",B[B.Seven=7]="Seven",B[B.Eight=8]="Eight",B[B.Nine=9]="Nine"})(it||(e.ViewColumn=it={}));var rt;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(rt||(e.StatusBarAlignment=rt={}));function Ne(B,j){return`${k.$lm.toKey(B)}.${j}`}e.$GL=Ne;var Pt;(function(B){B[B.Off=0]="Off",B[B.On=1]="On",B[B.Relative=2]="Relative"})(Pt||(e.TextEditorLineNumbersStyle=Pt={}));var Tt;(function(B){B[B.Manual=1]="Manual",B[B.AfterDelay=2]="AfterDelay",B[B.FocusOut=3]="FocusOut"})(Tt||(e.TextDocumentSaveReason=Tt={}));var Ht;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(Ht||(e.TextEditorRevealType=Ht={}));var Bt;(function(B){B[B.Keyboard=1]="Keyboard",B[B.Mouse=2]="Mouse",B[B.Command=3]="Command"})(Bt||(e.TextEditorSelectionChangeKind=Bt={}));var yt;(function(B){B[B.Undo=1]="Undo",B[B.Redo=2]="Redo"})(yt||(e.TextDocumentChangeReason=yt={}));var Kt;(function(B){B[B.OpenOpen=0]="OpenOpen",B[B.ClosedClosed=1]="ClosedClosed",B[B.OpenClosed=2]="OpenClosed",B[B.ClosedOpen=3]="ClosedOpen"})(Kt||(e.DecorationRangeBehavior=Kt={})),function(B){function j(oe){switch(oe){case"keyboard":return B.Keyboard;case"mouse":return B.Mouse;case"api":return B.Command}}B.fromValue=j}(Bt||(e.TextEditorSelectionChangeKind=Bt={}));var Nt;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(Nt||(e.SyntaxTokenType=Nt={})),function(B){function j(oe){switch(oe){case B.Other:return"other";case B.Comment:return"comment";case B.String:return"string";case B.RegEx:return"regex"}return"other"}B.toString=j}(Nt||(e.SyntaxTokenType=Nt={}));let Xt=class{constructor(j,oe){if(oe&&!b.URI.isUri(oe))throw(0,T.$7)("target");if(!z.isRange(j)||j.isEmpty)throw(0,T.$7)("range");this.range=j,this.target=oe}};e.$HL=Xt,e.$HL=Xt=Je([D],Xt);let zt=class{constructor(j,oe,De,Ge){this.red=j,this.green=oe,this.blue=De,this.alpha=Ge}};e.$IL=zt,e.$IL=zt=Je([D],zt);let Rt=class{constructor(j,oe){if(oe&&!(oe instanceof zt))throw(0,T.$7)("color");if(!z.isRange(j)||j.isEmpty)throw(0,T.$7)("range");this.range=j,this.color=oe}};e.$JL=Rt,e.$JL=Rt=Je([D],Rt);let Ze=class{constructor(j){if(!j||typeof j!="string")throw(0,T.$7)("label");this.label=j}};e.$KL=Ze,e.$KL=Ze=Je([D],Ze);var Gt;(function(B){B[B.RGB=0]="RGB",B[B.HEX=1]="HEX",B[B.HSL=2]="HSL"})(Gt||(e.ColorFormat=Gt={}));var Jt;(function(B){B[B.Error=0]="Error",B[B.Warning=1]="Warning",B[B.Information=2]="Information"})(Jt||(e.SourceControlInputBoxValidationType=Jt={}));var lt;(function(B){B[B.Unknown=0]="Unknown",B[B.Shutdown=1]="Shutdown",B[B.Process=2]="Process",B[B.User=3]="User",B[B.Extension=4]="Extension"})(lt||(e.TerminalExitReason=lt={}));class $t{constructor(j,oe,De){if(this.startIndex=j,this.length=oe,this.tooltip=De,typeof j!="number"||j<0)throw(0,T.$7)("startIndex");if(typeof oe!="number"||oe<1)throw(0,T.$7)("length");if(De!==void 0&&typeof De!="string")throw(0,T.$7)("tooltip")}}e.$LL=$t;class jt{constructor(j){this.uri=j}}e.$ML=jt;class Vt{constructor(j){this.terminalCommand=j}}e.$NL=Vt;var kt;(function(B){B[B.Panel=1]="Panel",B[B.Editor=2]="Editor"})(kt||(e.TerminalLocation=kt={}));class dt{constructor(j){if(this.options=j,typeof j!="object")throw(0,T.$7)("options")}}e.$OL=dt;var Ct;(function(B){B[B.Always=1]="Always",B[B.Silent=2]="Silent",B[B.Never=3]="Never"})(Ct||(e.TaskRevealKind=Ct={}));var xt;(function(B){B[B.Shared=1]="Shared",B[B.Dedicated=2]="Dedicated",B[B.New=3]="New"})(xt||(e.TaskPanelKind=xt={}));let Dt=class{static{d=this}static{this.Clean=new d("clean","Clean")}static{this.Build=new d("build","Build")}static{this.Rebuild=new d("rebuild","Rebuild")}static{this.Test=new d("test","Test")}static from(j){switch(j){case"clean":return d.Clean;case"build":return d.Build;case"rebuild":return d.Rebuild;case"test":return d.Test;default:return}}constructor(j,oe){if(this.label=oe,typeof j!="string"||typeof oe!="string")throw(0,T.$7)("name");this.c=j}get id(){return this.c}};e.$PL=Dt,e.$PL=Dt=d=Je([D],Dt);function qe(B){let j="";for(let oe=0;oe<B.length;oe++)j+=B[oe].replace(/,/g,",,")+",";return j}let Mt=class{constructor(j,oe,De){if(typeof j!="string")throw(0,T.$7)("process");this.e=[],this.c=j,oe!==void 0&&(Array.isArray(oe)?(this.e=oe,this.f=De):this.f=oe)}get process(){return this.c}set process(j){if(typeof j!="string")throw(0,T.$7)("process");this.c=j}get args(){return this.e}set args(j){Array.isArray(j)||(j=[]),this.e=j}get options(){return this.f}set options(j){this.f=j}computeId(){const j=[];if(j.push("process"),this.c!==void 0&&j.push(this.c),this.e&&this.e.length>0)for(const oe of this.e)j.push(oe);return qe(j)}};e.$QL=Mt,e.$QL=Mt=Je([D],Mt);let Wt=class{constructor(j,oe,De){if(this.f=[],Array.isArray(oe)){if(!j)throw(0,T.$7)("command can't be undefined or null");if(typeof j!="string"&&typeof j.value!="string")throw(0,T.$7)("command");this.e=j,this.f=oe,this.g=De}else{if(typeof j!="string")throw(0,T.$7)("commandLine");this.c=j,this.g=oe}}get commandLine(){return this.c}set commandLine(j){if(typeof j!="string")throw(0,T.$7)("commandLine");this.c=j}get command(){return this.e?this.e:""}set command(j){if(typeof j!="string"&&typeof j.value!="string")throw(0,T.$7)("command");this.e=j}get args(){return this.f}set args(j){this.f=j||[]}get options(){return this.g}set options(j){this.g=j}computeId(){const j=[];if(j.push("shell"),this.c!==void 0&&j.push(this.c),this.e!==void 0&&j.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const oe of this.f)j.push(typeof oe=="string"?oe:oe.value);return qe(j)}};e.$RL=Wt,e.$RL=Wt=Je([D],Wt);var Qt;(function(B){B[B.Escape=1]="Escape",B[B.Strong=2]="Strong",B[B.Weak=3]="Weak"})(Qt||(e.ShellQuoting=Qt={}));var ft;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace"})(ft||(e.TaskScope=ft={}));class Ft{constructor(j){this.c=j}computeId(){return"customExecution"+(0,A.$qg)()}set callback(j){this.c=j}get callback(){return this.c}}e.$SL=Ft;let Se=class{static{S=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(j,oe,De,Ge,xe,ut){this.k=!1,this.l=this.definition=j;let gt;typeof oe=="string"?(this.n=this.name=oe,this.u=this.source=De,this.execution=Ge,gt=xe,this.k=!0):oe===ft.Global||oe===ft.Workspace?(this.target=oe,this.n=this.name=De,this.u=this.source=Ge,this.execution=xe,gt=ut):(this.target=oe,this.n=this.name=De,this.u=this.source=Ge,this.execution=xe,gt=ut),typeof gt=="string"?(this.q=[gt],this.r=!0):Array.isArray(gt)?(this.q=gt,this.r=!0):(this.q=[],this.r=!1),this.t=!1,this.x=Object.create(null),this.y=Object.create(null)}get _id(){return this.j}set _id(j){this.j=j}get _deprecated(){return this.k}A(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.B())}B(){this.o instanceof Mt?this.l={type:S.e,id:this.o.computeId()}:this.o instanceof Wt?this.l={type:S.f,id:this.o.computeId()}:this.o instanceof Ft?this.l={type:S.c,id:this.o.computeId()}:this.l={type:S.g,id:(0,A.$qg)()}}get definition(){return this.l}set definition(j){if(j==null)throw(0,T.$7)("Kind can't be undefined or null");this.A(),this.l=j}get scope(){return this.m}set target(j){this.A(),this.m=j}get name(){return this.n}set name(j){if(typeof j!="string")throw(0,T.$7)("name");this.A(),this.n=j}get execution(){return this.o}set execution(j){j===null&&(j=void 0),this.A(),this.o=j;const oe=this.l.type;(S.g===oe||S.e===oe||S.f===oe||S.c===oe)&&this.B()}get problemMatchers(){return this.q}set problemMatchers(j){if(Array.isArray(j))this.A(),this.q=j,this.r=!0;else{this.A(),this.q=[],this.r=!1;return}}get hasDefinedMatchers(){return this.r}get isBackground(){return this.t}set isBackground(j){j!==!0&&j!==!1&&(j=!1),this.A(),this.t=j}get source(){return this.u}set source(j){if(typeof j!="string"||j.length===0)throw(0,T.$7)("source must be a string of length > 0");this.A(),this.u=j}get group(){return this.w}set group(j){j===null&&(j=void 0),this.A(),this.w=j}get detail(){return this.z}set detail(j){j===null&&(j=void 0),this.z=j}get presentationOptions(){return this.x}set presentationOptions(j){j==null&&(j=Object.create(null)),this.A(),this.x=j}get runOptions(){return this.y}set runOptions(j){j==null&&(j=Object.create(null)),this.A(),this.y=j}};e.$TL=Se,e.$TL=Se=S=Je([D],Se);var Fe;(function(B){B[B.SourceControl=1]="SourceControl",B[B.Window=10]="Window",B[B.Notification=15]="Notification"})(Fe||(e.ProgressLocation=Fe={}));var fe;(function(B){function j(oe){const De=oe;return(0,f.$Mf)(De.value)?De.tooltip&&!(0,f.$If)(De.tooltip)?(console.log("INVALID view badge, invalid tooltip",De.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",De.value),!1)}B.isViewBadge=j})(fe||(e.ViewBadge=fe={}));let J=M=class{static isTreeItem(j,oe){const De=j;if(De.checkboxState!==void 0){const Ge=(0,f.$Mf)(De.checkboxState)?De.checkboxState:(0,f.$Kf)(De.checkboxState)&&(0,f.$Mf)(De.checkboxState.state)?De.checkboxState.state:void 0,xe=!(0,f.$Mf)(De.checkboxState)&&(0,f.$Kf)(De.checkboxState)?De.checkboxState.tooltip:void 0;if(Ge===void 0||Ge!==Ue.Checked&&Ge!==Ue.Unchecked||xe!==void 0&&!(0,f.$If)(xe))return console.log("INVALID tree item, invalid checkboxState",De.checkboxState),!1}if(j instanceof M)return!0;if(De.label!==void 0&&!(0,f.$If)(De.label)&&!De.label?.label)return console.log("INVALID tree item, invalid label",De.label),!1;if(De.id!==void 0&&!(0,f.$If)(De.id))return console.log("INVALID tree item, invalid id",De.id),!1;if(De.iconPath!==void 0&&!(0,f.$If)(De.iconPath)&&!b.URI.isUri(De.iconPath)&&(!De.iconPath||!(0,f.$If)(De.iconPath.id))){const Ge=De.iconPath;if(!Ge||!(0,f.$If)(Ge.light)&&!b.URI.isUri(Ge.light)&&!(0,f.$If)(Ge.dark)&&!b.URI.isUri(Ge.dark))return console.log("INVALID tree item, invalid iconPath",De.iconPath),!1}return De.description!==void 0&&!(0,f.$If)(De.description)&&typeof De.description!="boolean"?(console.log("INVALID tree item, invalid description",De.description),!1):De.resourceUri!==void 0&&!b.URI.isUri(De.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",De.resourceUri),!1):De.tooltip!==void 0&&!(0,f.$If)(De.tooltip)&&!(De.tooltip instanceof Ve)?(console.log("INVALID tree item, invalid tooltip",De.tooltip),!1):De.command!==void 0&&!De.command.command?(console.log("INVALID tree item, invalid command",De.command),!1):De.collapsibleState!==void 0&&De.collapsibleState<Me.None&&De.collapsibleState>Me.Expanded?(console.log("INVALID tree item, invalid collapsibleState",De.collapsibleState),!1):De.contextValue!==void 0&&!(0,f.$If)(De.contextValue)?(console.log("INVALID tree item, invalid contextValue",De.contextValue),!1):De.accessibilityInformation!==void 0&&!De.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",De.accessibilityInformation),!1):!0}constructor(j,oe=Me.None){this.collapsibleState=oe,b.URI.isUri(j)?this.resourceUri=j:this.label=j}};e.$UL=J,e.$UL=J=M=Je([D],J);var Me;(function(B){B[B.None=0]="None",B[B.Collapsed=1]="Collapsed",B[B.Expanded=2]="Expanded"})(Me||(e.TreeItemCollapsibleState=Me={}));var Ue;(function(B){B[B.Unchecked=0]="Unchecked",B[B.Checked=1]="Checked"})(Ue||(e.TreeItemCheckboxState=Ue={}));let Xe=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(j){this.value=j}};e.$VL=Xe,e.$VL=Xe=Je([D],Xe);class We extends Xe{}e.$WL=We;class _e extends We{#e;constructor(j){super(""),this.#e=j}asFile(){return this.#e}}e.$XL=_e;class mt{constructor(j,oe,De,Ge){this.name=j,this.uri=oe,this._itemId=De,this.c=Ge}data(){return this.c()}}e.$YL=mt;let Ut=class{#e=new Map;constructor(j){for(const[oe,De]of j??[]){const Ge=this.#e.get(this.#t(oe));Ge?Ge.push(De):this.#e.set(this.#t(oe),[De])}}get(j){return this.#e.get(this.#t(j))?.[0]}set(j,oe){this.#e.set(this.#t(j),[oe])}forEach(j,oe){for(const[De,Ge]of this.#e)for(const xe of Ge)j.call(oe,xe,De,this)}*[Symbol.iterator](){for(const[j,oe]of this.#e)for(const De of oe)yield[j,De]}#t(j){return j.toLowerCase()}};e.$ZL=Ut,e.$ZL=Ut=Je([D],Ut);let Et=class{constructor(j){this.insertText=j}};e.$1L=Et,e.$1L=Et=Je([D],Et);let St=class{constructor(j,oe){this.label=oe,this.insertText=j}};e.$2L=St,e.$2L=St=Je([D],St);let bt=class{constructor(j,oe){this.id=j,this.color=oe}static isThemeIcon(j){return typeof j.id!="string"?(console.log("INVALID ThemeIcon, invalid id",j.id),!1):!0}};e.$3L=bt,e.$3L=bt=Je([D],bt),bt.File=new bt("file"),bt.Folder=new bt("folder");let gi=class{constructor(j){this.id=j}};e.$4L=gi,e.$4L=gi=Je([D],gi);var At;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace",B[B.WorkspaceFolder=3]="WorkspaceFolder"})(At||(e.ConfigurationTarget=At={}));let Si=class{get base(){return this.c}set base(j){this.c=j,this.e=b.URI.file(j)}get baseUri(){return this.e}set baseUri(j){this.e=j,this.c=j.fsPath}constructor(j,oe){if(typeof j!="string"&&(!j||!b.URI.isUri(j)&&!b.URI.isUri(j.uri)))throw(0,T.$7)("base");if(typeof oe!="string")throw(0,T.$7)("pattern");typeof j=="string"?this.baseUri=b.URI.file(j):b.URI.isUri(j)?this.baseUri=j:this.baseUri=j.uri,this.pattern=oe}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$5L=Si,e.$5L=Si=Je([D],Si);const Gi=new WeakMap;function It(B,j){Gi.set(B,j)}e.$6L=It;let ri=class{constructor(j,oe,De,Ge){this.enabled=typeof j=="boolean"?j:!0,typeof oe=="string"&&(this.condition=oe),typeof De=="string"&&(this.hitCondition=De),typeof Ge=="string"&&(this.logMessage=Ge)}get id(){return this.c||(this.c=Gi.get(this)??(0,A.$qg)()),this.c}};e.$7L=ri,e.$7L=ri=Je([D],ri);let mi=class extends ri{constructor(j,oe,De,Ge,xe){if(super(oe,De,Ge,xe),j===null)throw(0,T.$7)("location");this.location=j}};e.$8L=mi,e.$8L=mi=Je([D],mi);let ci=class extends ri{constructor(j,oe,De,Ge,xe){super(oe,De,Ge,xe),this.functionName=j}};e.$9L=ci,e.$9L=ci=Je([D],ci);let Ii=class extends ri{constructor(j,oe,De,Ge,xe,ut,gt){if(super(Ge,xe,ut,gt),!oe)throw(0,T.$7)("dataId");this.label=j,this.dataId=oe,this.canPersist=De}};e.$0L=Ii,e.$0L=Ii=Je([D],Ii);let Ci=class{constructor(j,oe,De){this.command=j,this.args=oe||[],this.options=De}};e.$$L=Ci,e.$$L=Ci=Je([D],Ci);let Ot=class{constructor(j,oe){this.port=j,this.host=oe}};e.$_L=Ot,e.$_L=Ot=Je([D],Ot);let $i=class{constructor(j){this.path=j}};e.$aM=$i,e.$aM=$i=Je([D],$i);let Pi=class{constructor(j){this.implementation=j}};e.$bM=Pi,e.$bM=Pi=Je([D],Pi);let ui=class{constructor(j,oe,De){this.session=j,this.threadId=oe,this.frameId=De}};e.$cM=ui,e.$cM=ui=Je([D],ui);let li=class{constructor(j,oe){this.session=j,this.threadId=oe}};e.$dM=li,e.$dM=li=Je([D],li);let ht=class{constructor(j,oe){this.range=j,this.expression=oe}};e.$eM=ht,e.$eM=ht=Je([D],ht);var Ji;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(Ji||(e.InlineCompletionTriggerKind=Ji={}));let _t=class{constructor(j,oe){this.range=j,this.text=oe}};e.$fM=_t,e.$fM=_t=Je([D],_t);let si=class{constructor(j,oe,De=!0){this.range=j,this.variableName=oe,this.caseSensitiveLookup=De}};e.$gM=si,e.$gM=si=Je([D],si);let pi=class{constructor(j,oe){this.range=j,this.expression=oe}};e.$hM=pi,e.$hM=pi=Je([D],pi);let Ri=class{constructor(j,oe){this.frameId=j,this.stoppedLocation=oe}};e.$iM=Ri,e.$iM=Ri=Je([D],Ri);var Qi;(function(B){B[B.Changed=1]="Changed",B[B.Created=2]="Created",B[B.Deleted=3]="Deleted"})(Qi||(e.FileChangeType=Qi={}));let Ai=v=class extends Error{static FileExists(j){return new v(j,l.FileSystemProviderErrorCode.FileExists,v.FileExists)}static FileNotFound(j){return new v(j,l.FileSystemProviderErrorCode.FileNotFound,v.FileNotFound)}static FileNotADirectory(j){return new v(j,l.FileSystemProviderErrorCode.FileNotADirectory,v.FileNotADirectory)}static FileIsADirectory(j){return new v(j,l.FileSystemProviderErrorCode.FileIsADirectory,v.FileIsADirectory)}static NoPermissions(j){return new v(j,l.FileSystemProviderErrorCode.NoPermissions,v.NoPermissions)}static Unavailable(j){return new v(j,l.FileSystemProviderErrorCode.Unavailable,v.Unavailable)}constructor(j,oe=l.FileSystemProviderErrorCode.Unknown,De){super(b.URI.isUri(j)?j.toString(!0):j),this.code=De?.name??"Unknown",(0,l.$Fk)(this,oe),Object.setPrototypeOf(this,v.prototype),typeof Error.captureStackTrace=="function"&&typeof De=="function"&&Error.captureStackTrace(this,De)}};e.$jM=Ai,e.$jM=Ai=v=Je([D],Ai);let vi=class{constructor(j,oe,De){this.start=j,this.end=oe,this.kind=De}};e.$kM=vi,e.$kM=vi=Je([D],vi);var Xi;(function(B){B[B.Comment=1]="Comment",B[B.Imports=2]="Imports",B[B.Region=3]="Region"})(Xi||(e.FoldingRangeKind=Xi={}));var Li;(function(B){B[B.Collapsed=0]="Collapsed",B[B.Expanded=1]="Expanded"})(Li||(e.CommentThreadCollapsibleState=Li={}));var hi;(function(B){B[B.Editing=0]="Editing",B[B.Preview=1]="Preview"})(hi||(e.CommentMode=hi={}));var Yi;(function(B){B[B.Published=0]="Published",B[B.Draft=1]="Draft"})(Yi||(e.CommentState=Yi={}));var wi;(function(B){B[B.Unresolved=0]="Unresolved",B[B.Resolved=1]="Resolved"})(wi||(e.CommentThreadState=wi={}));class Mi{constructor(j,oe=[]){this.tokenTypes=j,this.tokenModifiers=oe}}e.$lM=Mi;function un(B){return typeof B>"u"||(0,f.$Jf)(B)}class Fi{constructor(j){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,j){this.m=!0;for(let oe=0,De=j.tokenTypes.length;oe<De;oe++)this.k.set(j.tokenTypes[oe],oe);for(let oe=0,De=j.tokenModifiers.length;oe<De;oe++)this.l.set(j.tokenModifiers[oe],oe)}}push(j,oe,De,Ge,xe){if(typeof j=="number"&&typeof oe=="number"&&typeof De=="number"&&typeof Ge=="number"&&(typeof xe=="number"||typeof xe>"u"))return typeof xe>"u"&&(xe=0),this.o(j,oe,De,Ge,xe);if(z.isRange(j)&&typeof oe=="string"&&un(De))return this.n(j,oe,De);throw(0,T.$7)()}n(j,oe,De){if(!this.m)throw new Error("Legend must be provided in constructor");if(j.start.line!==j.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(oe))throw new Error("`tokenType` is not in the provided legend");const Ge=j.start.line,xe=j.start.character,ut=j.end.character-j.start.character,gt=this.k.get(oe);let qt=0;if(De)for(const Zt of De){if(!this.l.has(Zt))throw new Error("`tokenModifier` is not in the provided legend");const ii=this.l.get(Zt);qt|=1<<ii>>>0}this.o(Ge,xe,ut,gt,qt)}o(j,oe,De,Ge,xe){if(this.f&&(j<this.c||j===this.c&&oe<this.e)){this.f=!1;const qt=this.g.length/5|0;let Zt=0,ii=0;for(let ni=0;ni<qt;ni++){let ai=this.g[5*ni],Ki=this.g[5*ni+1];ai===0?(ai=Zt,Ki+=ii):ai+=Zt,this.g[5*ni]=ai,this.g[5*ni+1]=Ki,Zt=ai,ii=Ki}}let ut=j,gt=oe;this.f&&this.j>0&&(ut-=this.c,ut===0&&(gt-=this.e)),this.g[this.j++]=ut,this.g[this.j++]=gt,this.g[this.j++]=De,this.g[this.j++]=Ge,this.g[this.j++]=xe,this.c=j,this.e=oe}static q(j){const oe=[],De=j.length/5|0;for(let gt=0;gt<De;gt++)oe[gt]=gt;oe.sort((gt,qt)=>{const Zt=j[5*gt],ii=j[5*qt];if(Zt===ii){const ni=j[5*gt+1],ai=j[5*qt+1];return ni-ai}return Zt-ii});const Ge=new Uint32Array(j.length);let xe=0,ut=0;for(let gt=0;gt<De;gt++){const qt=5*oe[gt],Zt=j[qt+0],ii=j[qt+1],ni=j[qt+2],ai=j[qt+3],Ki=j[qt+4],In=Zt-xe,zn=In===0?ii-ut:ii,Hi=5*gt;Ge[Hi+0]=In,Ge[Hi+1]=zn,Ge[Hi+2]=ni,Ge[Hi+3]=ai,Ge[Hi+4]=Ki,xe=Zt,ut=ii}return Ge}build(j){return this.f?new oi(new Uint32Array(this.g),j):new oi(Fi.q(this.g),j)}}e.$mM=Fi;class oi{constructor(j,oe){this.resultId=oe,this.data=j}}e.$nM=oi;class ln{constructor(j,oe,De){this.start=j,this.deleteCount=oe,this.data=De}}e.$oM=ln;class hn{constructor(j,oe){this.resultId=oe,this.edits=j}}e.$pM=hn;var Zi;(function(B){B[B.Separate=0]="Separate",B[B.MergeWithParent=1]="MergeWithParent"})(Zi||(e.DebugConsoleMode=Zi={}));let di=class{static{this.Back={iconPath:new bt("arrow-left")}}constructor(){}};e.$qM=di,e.$qM=di=Je([D],di);var xi;(function(B){B[B.Separator=-1]="Separator",B[B.Default=0]="Default"})(xi||(e.QuickPickItemKind=xi={}));var _i;(function(B){B[B.Info=1]="Info",B[B.Warning=2]="Warning",B[B.Error=3]="Error"})(_i||(e.InputBoxValidationSeverity=_i={}));var bi;(function(B){B[B.UI=1]="UI",B[B.Workspace=2]="Workspace"})(bi||(e.ExtensionKind=bi={}));class en{static validate(j){if(typeof j.badge=="string"){let oe=(0,$.$jf)(j.badge,0);if(oe<j.badge.length&&(oe+=(0,$.$jf)(j.badge,oe)),j.badge.length>oe)throw new Error("The 'badge'-property must be undefined or a short character")}else if(j.badge&&!bt.isThemeIcon(j.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!j.color&&!j.badge&&!j.tooltip)throw new Error("The decoration is empty");return!0}constructor(j,oe,De){this.badge=j,this.tooltip=oe,this.color=De}}e.$rM=en;let Ti=class{constructor(j){this.kind=j}};e.$sM=Ti,e.$sM=Ti=Je([D],Ti);var Ni;(function(B){B[B.Light=1]="Light",B[B.Dark=2]="Dark",B[B.HighContrast=3]="HighContrast",B[B.HighContrastLight=4]="HighContrastLight"})(Ni||(e.ColorThemeKind=Ni={}));class ei{static isNotebookRange(j){return j instanceof ei?!0:j?typeof j.start=="number"&&typeof j.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(j,oe){if(j<0)throw(0,T.$7)("start must be positive");if(oe<0)throw(0,T.$7)("end must be positive");j<=oe?(this.c=j,this.e=oe):(this.c=oe,this.e=j)}with(j){let oe=this.c,De=this.e;return j.start!==void 0&&(oe=j.start),j.end!==void 0&&(De=j.end),oe===this.c&&De===this.e?this:new ei(oe,De)}}e.$tM=ei;class yi{static validate(j){if(typeof j.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof j.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof j.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(j){return Array.isArray(j)&&j.every(oe=>yi.isNotebookCellData(oe))}static isNotebookCellData(j){return!0}constructor(j,oe,De,Ge,xe,ut,gt){this.kind=j,this.value=oe,this.languageId=De,this.mime=Ge,this.outputs=xe??[],this.metadata=ut,this.executionSummary=gt,yi.validate(this)}}e.$uM=yi;class dn{constructor(j){this.cells=j}}e.$vM=dn;class Yt{static isNotebookCellOutputItem(j){return j instanceof Yt?!0:j?typeof j.mime=="string"&&j.data instanceof Uint8Array:!1}static error(j){const oe={name:j.name,message:j.message,stack:j.stack};return Yt.json(oe,"application/vnd.code.notebook.error")}static stdout(j){return Yt.text(j,"application/vnd.code.notebook.stdout")}static stderr(j){return Yt.text(j,"application/vnd.code.notebook.stderr")}static bytes(j,oe="application/octet-stream"){return new Yt(j,oe)}static#e=new TextEncoder;static text(j,oe=R.$fs.text){const De=Yt.#e.encode(String(j));return new Yt(De,oe)}static json(j,oe="text/x-json"){const De=JSON.stringify(j,void 0,"	");return Yt.text(De,oe)}constructor(j,oe){this.data=j,this.mime=oe;const De=(0,R.$js)(oe,!0);if(!De)throw new Error(`INVALID mime type: ${oe}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=De}}e.$wM=Yt;class Ei{static isNotebookCellOutput(j){return j instanceof Ei?!0:!j||typeof j!="object"?!1:typeof j.id=="string"&&Array.isArray(j.items)}static ensureUniqueMimeTypes(j,oe=!1){const De=new Set,Ge=new Set;for(let xe=0;xe<j.length;xe++){const ut=j[xe],gt=(0,R.$js)(ut.mime);if(!De.has(gt)||(0,w.$0I)(gt)){De.add(gt);continue}Ge.add(xe),oe&&console.warn(`DUPLICATED mime type '${ut.mime}' will be dropped`)}return Ge.size===0?j:j.filter((xe,ut)=>!Ge.has(ut))}constructor(j,oe,De){this.items=Ei.ensureUniqueMimeTypes(j,!0),typeof oe=="string"?(this.id=oe,this.metadata=De):(this.id=(0,A.$qg)(),this.metadata=oe??De)}}e.$xM=Ei;var ki;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(ki||(e.NotebookCellKind=ki={}));var Oi;(function(B){B[B.Idle=1]="Idle",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(Oi||(e.NotebookCellExecutionState=Oi={}));var ze;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(ze||(e.NotebookCellStatusBarAlignment=ze={}));var ti;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(ti||(e.NotebookEditorRevealType=ti={}));class tn{constructor(j,oe){this.text=j,this.alignment=oe}}e.$yM=tn;var et;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred"})(et||(e.NotebookControllerAffinity=et={}));var pt;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred",B[B.Hidden=-1]="Hidden"})(pt||(e.NotebookControllerAffinity2=pt={}));class fn{constructor(j,oe=[]){this.uri=j,this.provides=(0,y.$3b)(oe)}}e.$zM=fn;class gn{constructor(j){this.label=j}}e.$AM=gn;var zi;(function(B){B[B.Named=1]="Named",B[B.Indexed=2]="Indexed"})(zi||(e.NotebookVariablesRequestKind=zi={}));let ji=class{constructor(j,oe){this.label=j,this.timestamp=oe}};e.$BM=ji,e.$BM=ji=Je([D],ji);var fi;(function(B){B[B.Production=1]="Production",B[B.Development=2]="Development",B[B.Test=3]="Test"})(fi||(e.ExtensionMode=fi={}));var nn;(function(B){B[B.Node=1]="Node",B[B.Webworker=2]="Webworker"})(nn||(e.ExtensionRuntime=nn={}));var rn;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(rn||(e.StandardTokenType=rn={}));class mn{constructor(j,oe){this.ranges=j,this.wordPattern=oe}}e.$CM=mn;class sn{constructor(j){this.c=j}get autoForwardAction(){return this.c}}e.$DM=sn;var on;(function(B){B[B.Queued=1]="Queued",B[B.Running=2]="Running",B[B.Passed=3]="Passed",B[B.Failed=4]="Failed",B[B.Skipped=5]="Skipped",B[B.Errored=6]="Errored"})(on||(e.TestResultState=on={}));var an;(function(B){B[B.Run=1]="Run",B[B.Debug=2]="Debug",B[B.Coverage=3]="Coverage"})(an||(e.TestRunProfileKind=an={}));let Ui=class{constructor(j=void 0,oe=void 0,De=void 0,Ge=!1){this.include=j,this.exclude=oe,this.profile=De,this.continuous=Ge}};e.$EM=Ui,e.$EM=Ui=Je([D],Ui);let Bi=E=class{static diff(j,oe,De){const Ge=new E(j);return Ge.expectedOutput=oe,Ge.actualOutput=De,Ge}constructor(j){this.message=j}};e.$FM=Bi,e.$FM=Bi=E=Je([D],Bi);let Vi=class{constructor(j){this.id=j}};e.$GM=Vi,e.$GM=Vi=Je([D],Vi);class Di{constructor(j,oe){this.covered=j,this.total=oe}}e.$HM=Di;const Wi=B=>{if(B&&B.covered>B.total)throw new Error(`The total number of covered items (${B.covered}) cannot be greater than the total (${B.total})`)};class qi{static fromDetails(j,oe){const De=new Di(0,0),Ge=new Di(0,0),xe=new Di(0,0);for(const gt of oe)if("branches"in gt){De.total+=1,De.covered+=gt.executionCount>0?1:0;for(const qt of gt.branches)Ge.total+=1,Ge.covered+=qt.executionCount>0?1:0}else xe.total+=1,xe.covered+=gt.executionCount>0?1:0;const ut=new qi(j,De,Ge.total>0?Ge:void 0,xe.total>0?xe:void 0);return ut.detailedCoverage=oe,ut}constructor(j,oe,De,Ge){this.uri=j,this.statementCoverage=oe,this.branchCoverage=De,this.functionCoverage=Ge,Wi(oe),Wi(De),Wi(Ge)}}e.$IM=qi;class $n{constructor(j,oe,De=[]){this.executionCount=j,this.location=oe,this.branches=De}}e.$JM=$n;class pn{constructor(j,oe,De){this.executionCount=j,this.location=oe,this.label=De}}e.$KM=pn;class re{constructor(j,oe,De){this.name=j,this.executionCount=oe,this.location=De}}e.$LM=re;var ue;(function(B){B[B.None=0]="None",B[B.Option=1]="Option",B[B.Default=2]="Default",B[B.Preferred=3]="Preferred"})(ue||(e.ExternalUriOpenerPriority=ue={}));var Oe;(function(B){B[B.Untrusted=0]="Untrusted",B[B.Trusted=1]="Trusted",B[B.Unspecified=2]="Unspecified"})(Oe||(e.WorkspaceTrustState=Oe={}));var ot;(function(B){B[B.Notify=1]="Notify",B[B.OpenBrowser=2]="OpenBrowser",B[B.OpenPreview=3]="OpenPreview",B[B.Silent=4]="Silent",B[B.Ignore=5]="Ignore",B[B.OpenBrowserOnce=6]="OpenBrowserOnce"})(ot||(e.PortAutoForwardAction=ot={}));class wt{constructor(j,oe,De,Ge,xe,ut){this.kind=j,this.name=oe,this.detail=De,this.uri=Ge,this.range=xe,this.selectionRange=ut}}e.$MM=wt;class Lt{constructor(j){this.uri=j}}e.$NM=Lt;class cn{constructor(j,oe){this.original=j,this.modified=oe}}e.$OM=cn;class Cn{constructor(j,oe,De,Ge){this.base=j,this.input1=oe,this.input2=De,this.result=Ge}}e.$PM=Cn;class Pn{constructor(j,oe){this.uri=j,this.viewType=oe}}e.$QM=Pn;class Rn{constructor(j){this.viewType=j}}e.$RM=Rn;class An{constructor(j,oe){this.uri=j,this.notebookType=oe}}e.$SM=An;class Ln{constructor(j,oe,De){this.original=j,this.modified=oe,this.notebookType=De}}e.$TM=Ln;class Mn{constructor(){}}e.$UM=Mn;class Fn{constructor(j,oe){this.uri=j,this.inputBoxUri=oe}}e.$VM=Fn;class Tn{constructor(j){this.providerId=j}}e.$WM=Tn;var vn;(function(B){B[B.Down=0]="Down",B[B.Up=1]="Up"})(vn||(e.InteractiveSessionVoteDirection=vn={}));var wn;(function(B){B[B.Action=1]="Action",B[B.Toolbar=2]="Toolbar"})(wn||(e.ChatAgentCopyKind=wn={}));var bn;(function(B){B[B.Short=1]="Short",B[B.Medium=2]="Medium",B[B.Full=3]="Full"})(bn||(e.ChatVariableLevel=bn={}));class Nn{constructor(j,oe){this.label=j,this.values=oe}}e.$XM=Nn;var yn;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful",B[B.Undone=2]="Undone",B[B.Accepted=3]="Accepted",B[B.Bug=4]="Bug"})(yn||(e.InteractiveEditorResponseFeedbackKind=yn={}));var En;(function(B){B[B.System=0]="System",B[B.User=1]="User",B[B.Assistant=2]="Assistant",B[B.Function=3]="Function"})(En||(e.ChatMessageRole=En={}));class On{constructor(j,oe){this.role=j,this.content=oe}}e.$YM=On;var kn;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful"})(kn||(e.ChatAgentResultFeedbackKind=kn={}));var Dn;(function(B){B[B.SymbolInformation=1]="SymbolInformation",B[B.CommandInformation=2]="CommandInformation",B[B.SearchInformation=3]="SearchInformation",B[B.SettingInformation=4]="SettingInformation"})(Dn||(e.RelatedInformationType=Dn={}));var Sn;(function(B){B[B.Started=1]="Started",B[B.Recognizing=2]="Recognizing",B[B.Recognized=3]="Recognized",B[B.Stopped=4]="Stopped"})(Sn||(e.SpeechToTextStatus=Sn={}))}),define(Pe[103],Re([1,0,53,12,11,294,147,7,18]),function(ge,e,y,T,C,L,R,$,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bN=e.$aN=e.$_M=void 0;const b=new Map;function A(w,s){s?b.set(w,s):b.delete(w)}e.$_M=A;function k(w){return b.get(w)}class l extends L.$lv{constructor(s,a,r,n,o,c,h,t){super(a,r,n,o),this.c=s,this.m=c,this.q=h,this.notebook=t,this.b=!1}dispose(){(0,y.ok)(!this.b),this.b=!0,this.q=!1}equalLines(s){return(0,f.$ub)(this.f,s)}get document(){if(!this.a){const s=this;this.a={get uri(){return s.d},get fileName(){return s.d.fsPath},get isUntitled(){return s.d.scheme===T.Schemas.untitled},get languageId(){return s.m},get version(){return s.h},get isClosed(){return s.b},get isDirty(){return s.q},save(){return s.r()},getText(a){return a?s.s(a):s.getText()},get eol(){return s.g===`
`?$.EndOfLine.LF:$.EndOfLine.CRLF},get lineCount(){return s.f.length},lineAt(a){return s.t(a)},offsetAt(a){return s.u(a)},positionAt(a){return s.v(a)},validateRange(a){return s.w(a)},validatePosition(a){return s.x(a)},getWordRangeAtPosition(a,r){return s.y(a,r)}}}return Object.freeze(this.a)}_acceptLanguageId(s){(0,y.ok)(!this.b),this.m=s}_acceptIsDirty(s){(0,y.ok)(!this.b),this.q=s}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(s){const a=this.w(s);if(a.isEmpty)return"";if(a.isSingleLine)return this.f[a.start.line].substring(a.start.character,a.end.character);const r=this.g,n=a.start.line,o=a.end.line,c=[];c.push(this.f[n].substring(a.start.character));for(let h=n+1;h<o;h++)c.push(this.f[h]);return c.push(this.f[o].substring(0,a.end.character)),c.join(r)}t(s){let a;if(s instanceof $.$9K?a=s.line:typeof s=="number"&&(a=s),typeof a!="number"||a<0||a>=this.f.length||Math.floor(a)!==a)throw new Error("Illegal value for `line`");return new p(a,this.f[a],a===this.f.length-1)}u(s){return s=this.x(s),this.l(),this.j.getPrefixSum(s.line-1)+s.character}v(s){s=Math.floor(s),s=Math.max(0,s),this.l();const a=this.j.getIndexOf(s),r=this.f[a.index].length;return new $.$9K(a.index,Math.min(a.remainder,r))}w(s){if(!(s instanceof $.$0K))throw new Error("Invalid argument");const a=this.x(s.start),r=this.x(s.end);return a===s.start&&r===s.end?s:new $.$0K(a.line,a.character,r.line,r.character)}x(s){if(!(s instanceof $.$9K))throw new Error("Invalid argument");if(this.f.length===0)return s.with(0,0);let{line:a,character:r}=s,n=!1;if(a<0)a=0,r=0,n=!0;else if(a>=this.f.length)a=this.f.length-1,r=this.f[a].length,n=!0;else{const o=this.f[a].length;r<0?(r=0,n=!0):r>o&&(r=o,n=!0)}return n?new $.$9K(a,r):s}y(s,a){const r=this.x(s);if(!a)a=k(this.m);else if((0,C.$Ye)(a))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${a.source}' because it matches the empty string.`);const n=(0,R.$xs)(r.character+1,(0,R.$vs)(a),this.f[r.line],0);if(n)return new $.$0K(r.line,n.startColumn-1,r.line,n.endColumn-1)}}e.$aN=l;class p{constructor(s,a,r){this.a=s,this.b=a,this.c=r}get lineNumber(){return this.a}get text(){return this.b}get range(){return new $.$0K(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new $.$0K(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$bN=p}),define(Pe[209],Re([1,0,7,17,5]),function(ge,e,y,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2hc=void 0;let L=class{constructor($){this.a=new y.$sM(y.ColorThemeKind.Dark),this.b=new C.$Vd}get activeColorTheme(){return this.a}$onColorThemeChange($){let f;switch($){case"light":f=y.ColorThemeKind.Light;break;case"hcDark":f=y.ColorThemeKind.HighContrast;break;case"hcLight":f=y.ColorThemeKind.HighContrastLight;break;default:f=y.ColorThemeKind.Dark}this.a=new y.$sM(f),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$2hc=L,e.$2hc=L=Je([Ke(0,T.$0M)],L)}),define(Pe[210],Re([1,0,4]),function(ge,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bJ=e.CellExecutionUpdateType=void 0;var T;(function(C){C[C.Output=1]="Output",C[C.OutputItems=2]="OutputItems",C[C.ExecutionState=3]="ExecutionState"})(T||(e.CellExecutionUpdateType=T={})),e.$bJ=(0,y.$6h)("INotebookExecutionService")}),define(Pe[211],Re([1,0,6,29,144,94]),function(ge,e,y,T,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KQb=void 0;class R extends y.$Tc{constructor(f,b,A){super(),this._source=f,this.b=b,this.c=A,this.a=void 0}f(f){const b=f.getLineCount();return new T.$Us(1,1,b,this.g(f,b))}g(f,b){if(b<1||b>f.getLineCount())throw new Error("Illegal value for lineNumber");return f.getLineLength(b)+1}get inputTextBuffer(){if(!this.b){const f=new C.$cC;f.acceptChunk(this._source);const b=f.finish(!0),{textBuffer:A,disposable:k}=b.create(1);this.b=A,this.B(k)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(f=>{const b=new C.$cC;b.acceptChunk(f);const A=b.finish(!0),{textBuffer:k,disposable:l}=A.create(1);return this.B(l),k})),this.a}findInInputs(f){const A=new L.$3B(f,!1,!1,null).parseSearchRequest();if(!A)return[];const k=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(k,A,!0,5e3)}findInOutputs(f){const A=new L.$3B(f,!1,!1,null).parseSearchRequest();return A?this.outputTextBuffers.map(k=>{const l=k.findMatchesLineByLine(this.f(k),A,!0,5e3);if(l.length!==0)return{textBuffer:k,matches:l}}).filter(k=>!!k):[]}}e.$KQb=R}),define(Pe[48],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XJ=e.TestPosition=e.TestIdPathParts=void 0;var y;(function(L){L.Delimiter="\0"})(y||(e.TestIdPathParts=y={}));var T;(function(L){L[L.IsSame=0]="IsSame",L[L.Disconnected=1]="Disconnected",L[L.IsChild=2]="IsChild",L[L.IsParent=3]="IsParent"})(T||(e.TestPosition=T={}));class C{static fromExtHostTestItem(R,$,f=R.parent){if(R._isRoot)return new C([$]);const b=[R.id];for(let A=f;A&&A.id!==$;A=A.parent)b.push(A.id);return b.push($),new C(b.reverse())}static isRoot(R){return!R.includes("\0")}static root(R){const $=R.indexOf("\0");return $===-1?R:R.slice(0,$)}static fromString(R){return new C(R.split("\0"))}static join(R,$){return new C([...R.path,$])}static joinToString(R,$){return R.toString()+"\0"+$}static parentId(R){const $=R.lastIndexOf("\0");return $===-1?void 0:R.slice(0,$)}static localId(R){const $=R.lastIndexOf("\0");return $===-1?R:R.slice($+1)}static isChild(R,$){return $.startsWith(R)&&$[R.length]==="\0"}static compare(R,$){return R===$?0:C.isChild(R,$)?2:C.isChild($,R)?3:1}constructor(R,$=R.length){if(this.path=R,this.d=$,R.length===0||$<1)throw new Error("cannot create test with empty path")}get rootId(){return new C(this.path,1)}get parentId(){return this.d>1?new C(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let R=1;R<=this.d;R++)yield new C(this.path,R)}*idsToRoot(){for(let R=this.d;R>0;R--)yield new C(this.path,R)}compare(R){if(typeof R=="string")return C.compare(this.toString(),R);for(let $=0;$<R.d&&$<this.d;$++)if(R.path[$]!==this.path[$])return 1;return R.d>this.d?2:R.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let R=1;R<this.d;R++)this.c+="\0",this.c+=this.path[R]}return this.c}}e.$XJ=C}),define(Pe[58],Re([1,0,2,92,29,48]),function(ge,e,y,T,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6J=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IFunctionCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$5J=e.IFileCoverage=e.ICoveredCount=e.TestResultItem=e.$4J=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$3J=e.$2J=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$1J=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$ZJ=e.$YJ=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var R;(function(P){P[P.Unset=0]="Unset",P[P.Queued=1]="Queued",P[P.Running=2]="Running",P[P.Passed=3]="Passed",P[P.Failed=4]="Failed",P[P.Skipped=5]="Skipped",P[P.Errored=6]="Errored"})(R||(e.TestResultState=R={}));var $;(function(P){P[P.Run=1]="Run",P[P.Debug=2]="Debug",P[P.Coverage=3]="Coverage"})($||(e.ExtTestRunProfileKind=$={}));var f;(function(P){P[P.Run=2]="Run",P[P.Debug=4]="Debug",P[P.Coverage=8]="Coverage",P[P.HasNonDefaultProfile=16]="HasNonDefaultProfile",P[P.HasConfigurable=32]="HasConfigurable",P[P.SupportsContinuousRun=64]="SupportsContinuousRun"})(f||(e.TestRunProfileBitset=f={})),e.$YJ=[2,4,8,16,32,64];const b=P=>"runId"in P;e.$ZJ=b;var A;(function(P){P.serialize=I=>({range:I.range.toJSON(),uri:I.uri.toJSON()}),P.deserialize=(I,H)=>({range:C.$Us.lift(H.range),uri:I.asCanonicalUri(y.URI.revive(H.uri))})})(A||(e.IRichLocation=A={}));var k;(function(P){P[P.Error=0]="Error",P[P.Output=1]="Output"})(k||(e.TestMessageType=k={}));var l;(function(P){P.serialize=I=>({message:I.message,type:0,expected:I.expected,actual:I.actual,contextValue:I.contextValue,location:I.location&&A.serialize(I.location)}),P.deserialize=(I,H)=>({message:H.message,type:0,expected:H.expected,actual:H.actual,contextValue:H.contextValue,location:H.location&&A.deserialize(I,H.location)})})(l||(e.ITestErrorMessage=l={}));const p=(P,I)=>`${I?"s":"e"}${P}`;e.$1J=p;var w;(function(P){P.serialize=I=>({message:I.message,type:1,offset:I.offset,length:I.length,location:I.location&&A.serialize(I.location)}),P.deserialize=(I,H)=>({message:H.message,type:1,offset:H.offset,length:H.length,location:H.location&&A.deserialize(I,H.location)})})(w||(e.ITestOutputMessage=w={}));var s;(function(P){P.serialize=I=>I.type===0?l.serialize(I):w.serialize(I),P.deserialize=(I,H)=>H.type===0?l.deserialize(I,H):w.deserialize(I,H)})(s||(e.ITestMessage=s={}));var a;(function(P){P.serializeWithoutMessages=I=>({state:I.state,duration:I.duration,messages:[]}),P.serialize=I=>({state:I.state,duration:I.duration,messages:I.messages.map(s.serialize)}),P.deserialize=(I,H)=>({state:H.state,duration:H.duration,messages:H.messages.map(ae=>s.deserialize(I,ae))})})(a||(e.ITestTaskState=a={}));const r="\0",n=(P,I)=>P+r+I;e.$2J=n;const o=P=>{const I=P.indexOf(r);return{ctrlId:P.slice(0,I),tagId:P.slice(I+1)}};e.$3J=o;var c;(function(P){P.serialize=I=>({extId:I.extId,label:I.label,tags:I.tags,busy:I.busy,children:void 0,uri:I.uri?.toJSON(),range:I.range?.toJSON()||null,description:I.description,error:I.error,sortText:I.sortText}),P.deserialize=(I,H)=>({extId:H.extId,label:H.label,tags:H.tags,busy:H.busy,children:void 0,uri:H.uri?I.asCanonicalUri(y.URI.revive(H.uri)):void 0,range:H.range?C.$Us.lift(H.range):null,description:H.description,error:H.error,sortText:H.sortText})})(c||(e.ITestItem=c={}));var h;(function(P){P[P.NotExpandable=0]="NotExpandable",P[P.Expandable=1]="Expandable",P[P.BusyExpanding=2]="BusyExpanding",P[P.Expanded=3]="Expanded"})(h||(e.TestItemExpandState=h={}));var t;(function(P){P.serialize=I=>({expand:I.expand,item:c.serialize(I.item)}),P.deserialize=(I,H)=>({controllerId:L.$XJ.root(H.item.extId),expand:H.expand,item:c.deserialize(I,H.item)})})(t||(e.InternalTestItem=t={}));var u;(function(P){P.serialize=I=>{let H;return I.item&&(H={},I.item.label!==void 0&&(H.label=I.item.label),I.item.tags!==void 0&&(H.tags=I.item.tags),I.item.busy!==void 0&&(H.busy=I.item.busy),I.item.uri!==void 0&&(H.uri=I.item.uri?.toJSON()),I.item.range!==void 0&&(H.range=I.item.range?.toJSON()),I.item.description!==void 0&&(H.description=I.item.description),I.item.error!==void 0&&(H.error=I.item.error),I.item.sortText!==void 0&&(H.sortText=I.item.sortText)),{extId:I.extId,expand:I.expand,item:H}},P.deserialize=I=>{let H;return I.item&&(H={},I.item.label!==void 0&&(H.label=I.item.label),I.item.tags!==void 0&&(H.tags=I.item.tags),I.item.busy!==void 0&&(H.busy=I.item.busy),I.item.range!==void 0&&(H.range=I.item.range?C.$Us.lift(I.item.range):null),I.item.description!==void 0&&(H.description=I.item.description),I.item.error!==void 0&&(H.error=I.item.error),I.item.sortText!==void 0&&(H.sortText=I.item.sortText)),{extId:I.extId,expand:I.expand,item:H}}})(u||(e.ITestItemUpdate=u={}));const i=(P,I)=>{I.expand!==void 0&&(P.expand=I.expand),I.item!==void 0&&(P.item=P.item?Object.assign(P.item,I.item):I.item)};e.$4J=i;var g;(function(P){P.serializeWithoutMessages=I=>({...t.serialize(I),ownComputedState:I.ownComputedState,computedState:I.computedState,tasks:I.tasks.map(a.serializeWithoutMessages)}),P.serialize=I=>({...t.serialize(I),ownComputedState:I.ownComputedState,computedState:I.computedState,tasks:I.tasks.map(a.serialize)}),P.deserialize=(I,H)=>({...t.deserialize(I,H),ownComputedState:H.ownComputedState,computedState:H.computedState,tasks:H.tasks.map(ae=>a.deserialize(I,ae)),retired:!0})})(g||(e.TestResultItem=g={}));var m;(function(P){P.empty=()=>({covered:0,total:0}),P.sum=(I,H)=>{I.covered+=H.covered,I.total+=H.total}})(m||(e.ICoveredCount=m={}));var d;(function(P){P.serialize=I=>({statement:I.statement,branch:I.branch,function:I.function,details:I.details?.map(E.serialize),uri:I.uri.toJSON()}),P.deserialize=(I,H)=>({statement:H.statement,branch:H.branch,function:H.function,details:H.details?.map(E.deserialize),uri:I.asCanonicalUri(y.URI.revive(H.uri))})})(d||(e.IFileCoverage=d={}));function S(P){return{...P,location:P.location?.toJSON()}}function M(P){return P.location=P.location?T.$Ts.isIPosition(P.location)?T.$Ts.lift(P.location):C.$Us.lift(P.location):void 0,P}e.$5J=3;var v;(function(P){P[P.Function=0]="Function",P[P.Statement=1]="Statement",P[P.Branch=2]="Branch"})(v||(e.DetailType=v={}));var E;(function(P){P.serialize=I=>I.type===0?N.serialize(I):O.serialize(I),P.deserialize=I=>I.type===0?N.deserialize(I):O.deserialize(I)})(E||(e.CoverageDetails=E={}));var D;(function(P){P.serialize=S,P.deserialize=M})(D||(e.IBranchCoverage=D={}));var N;(function(P){P.serialize=S,P.deserialize=M})(N||(e.IFunctionCoverage=N={}));var O;(function(P){P.serialize=I=>({...S(I),branches:I.branches?.map(D.serialize)}),P.deserialize=I=>({...M(I),branches:I.branches?.map(D.deserialize)})})(O||(e.IStatementCoverage=O={}));var G;(function(P){P[P.Add=0]="Add",P[P.Update=1]="Update",P[P.DocumentSynced=2]="DocumentSynced",P[P.Remove=3]="Remove",P[P.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",P[P.Retire=5]="Retire",P[P.AddTag=6]="AddTag",P[P.RemoveTag=7]="RemoveTag"})(G||(e.TestDiffOpType=G={}));var W;(function(P){P.deserialize=(I,H)=>H.op===0?{op:H.op,item:t.deserialize(I,H.item)}:H.op===1?{op:H.op,item:u.deserialize(H.item)}:H.op===2?{op:H.op,uri:I.asCanonicalUri(y.URI.revive(H.uri)),docv:H.docv}:H,P.serialize=I=>I.op===0?{op:I.op,item:t.serialize(I.item)}:I.op===1?{op:I.op,item:u.serialize(I.item)}:I})(W||(e.TestsDiffOp=W={}));class z{constructor(I){this.k=I,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(I){const H=this.v();for(const ae of I)switch(ae.op){case 0:this.l(t.deserialize(this.k,ae.item),H);break;case 1:this.o(u.deserialize(ae.item),H);break;case 3:this.p(ae.itemId,H);break;case 5:this.q(ae.itemId);break;case 4:this.updatePendingRoots(ae.amount);break;case 6:this.c.set(ae.tag.id,ae.tag);break;case 7:this.c.delete(ae.id);break}H.complete?.()}l(I,H){const ae=L.$XJ.parentId(I.item.extId)?.toString();let de;if(!ae)de=this.w(I),this.g.add(de),this.f.set(I.item.extId,de);else if(this.f.has(ae)){const we=this.f.get(ae);we.children.add(I.item.extId),de=this.w(I,we),this.f.set(I.item.extId,de)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(I)}`);return}return H.add?.(de),I.expand===2&&this.h++,de}o(I,H){const ae=this.f.get(I.extId);if(ae)return I.expand!==void 0&&(ae.expand===2&&this.h--,I.expand===2&&this.h++),(0,e.$4J)(ae,I),H.update?.(ae),ae}p(I,H){const ae=this.f.get(I);if(!ae)return;const de=L.$XJ.parentId(ae.item.extId)?.toString();de?this.f.get(de).children.delete(ae.item.extId):this.g.delete(ae);const we=[[I]];for(;we.length;)for(const ke of we.pop()){const le=this.f.get(ke);le&&(we.push(le.children),this.f.delete(ke),H.remove?.(le,le!==ae),le.expand===2&&this.h--)}}q(I){}updatePendingRoots(I){this.j+=I}v(){return{}}}e.$6J=z}),define(Pe[77],Re([1,0,13,5,6,53,58,48]),function(ge,e,y,T,C,L,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4M=e.$3M=e.$2M=e.$1M=e.$ZM=e.TestItemEventOp=void 0;var f;(function(n){n[n.Upsert=0]="Upsert",n[n.SetTags=1]="SetTags",n[n.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",n[n.RemoveChild=3]="RemoveChild",n[n.SetProp=4]="SetProp",n[n.Bulk=5]="Bulk",n[n.DocumentSynced=6]="DocumentSynced"})(f||(e.TestItemEventOp=f={}));const b=(n,o)=>n===o,k=Object.entries({range:(n,o)=>n===o?!0:!n||!o?!1:n.equalsRange(o),busy:b,label:b,description:b,error:b,sortText:b,tags:(n,o)=>!(n.length!==o.length||n.some(c=>!o.includes(c)))}),l=(n,o)=>{let c;for(const[h,t]of k)t(n[h],o[h])||(c?c[h]=o[h]:c={[h]:o[h]});return c};class p extends C.$Tc{get root(){return this.s.root}constructor(o){super(),this.s=o,this.f=this.B(new y.$fh(()=>this.flushDiff(),200)),this.g=this.B(new T.$Vd),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(o){this.h=o;for(const c of this.tree.values())this.J(c)}get resolveHandler(){return this.h}collectDiff(){const o=this.m;return this.m=[],o}pushDiff(o){switch(o.op){case 2:{for(const c of this.m)if(c.op===2&&c.uri===o.uri){c.docv=o.docv;return}break}case 1:{const c=this.m[this.m.length-1];if(c){if(c.op===1&&c.item.extId===o.item.extId){(0,R.$4J)(c.item,o.item);return}if(c.op===0&&c.item.item.extId===o.item.extId){(0,R.$4J)(c.item,o.item);return}}break}}this.m.push(o),this.f.isScheduled()||this.f.schedule()}expand(o,c){const h=this.tree.get(o);if(h){if((h.expandLevels===void 0||c>h.expandLevels)&&(h.expandLevels=c),h.expand===1){const t=this.M(h);return t.isOpen()?this.L(h,c-1):t.wait().then(()=>this.L(h,c-1))}else if(h.expand===3)return h.resolveBarrier?.isOpen()===!1?h.resolveBarrier.wait().then(()=>this.L(h,c-1)):this.L(h,c-1)}}dispose(){for(const o of this.tree.values())this.s.getApiFor(o.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(o,c){switch(c.op){case 3:this.O($.$XJ.joinToString(o.fullId,c.id));break;case 0:this.z(c.item,o);break;case 5:for(const h of c.ops)this.w(o,h);break;case 1:this.C(c.new,c.old,o.fullId.toString());break;case 2:this.J(o);break;case 4:this.pushDiff({op:1,item:{extId:o.fullId.toString(),item:c.update}});break;case 6:this.y(o.actual.uri);break;default:(0,L.$6c)(c)}}y(o){o&&this.pushDiff({op:2,uri:o,docv:this.s.getDocumentVersion(o)})}z(o,c){const h=$.$XJ.fromExtHostTestItem(o,this.root.id,c?.actual),t=this.s.getApiFor(o);t.parent&&t.parent!==c?.actual&&this.s.getChildren(t.parent).delete(o.id);let u=this.tree.get(h.toString());if(!u){u={fullId:h,actual:o,expandLevels:c?.expandLevels?c.expandLevels-1:void 0,expand:0},o.tags.forEach(this.D,this),this.tree.set(u.fullId.toString(),u),this.G(o,c),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:u.expand,item:this.s.toITestItem(o)}}),this.I(o,u,c);return}if(u.actual===o){this.H(o,u,c);return}if(u.actual.uri?.toString()!==o.uri?.toString())return this.O(h.toString()),this.z(o,c);const i=this.s.getChildren(u.actual),g=u.actual,m=l(this.s.toITestItem(g),this.s.toITestItem(o));this.s.getApiFor(g).listener=void 0,u.actual=o,u.expand=0,m&&(m.hasOwnProperty("tags")&&(this.C(o.tags,g.tags,h.toString()),delete m.tags),this.w(u,{op:4,update:m})),this.I(o,u,c);for(const[d,S]of i)this.s.getChildren(o).get(S.id)||this.O($.$XJ.joinToString(h,S.id));this.y(u.actual.uri)}C(o,c,h){const t=new Set(c.map(u=>u.id));for(const u of o)t.delete(u.id)||this.D(u);this.pushDiff({op:1,item:{extId:h,item:{tags:o.map(u=>(0,R.$2J)(this.s.controllerId,u.id))}}}),t.forEach(this.F,this)}D(o){const c=this.j.get(o.id);c?c.refCount++:(this.j.set(o.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,R.$2J)(this.s.controllerId,o.id)}}))}F(o){const c=this.j.get(o);c&&!--c.refCount&&(this.j.delete(o),this.pushDiff({op:7,id:(0,R.$2J)(this.s.controllerId,o)}))}G(o,c){this.s.getApiFor(o).parent=c&&c.actual!==this.root?c.actual:void 0}H(o,c,h){this.G(o,h);const t=this.s.getApiFor(o);t.parent=h?.actual,t.listener=u=>this.w(c,u),this.J(c)}I(o,c,h){this.H(o,c,h);for(const[t,u]of this.s.getChildren(o))this.z(u,c)}J(o){let c;this.h?o.resolveBarrier?c=o.resolveBarrier.isOpen()?3:2:c=o.actual.canResolveChildren?1:0:c=0,c!==o.expand&&(o.expand=c,this.pushDiff({op:1,item:{extId:o.fullId.toString(),expand:c}}),c===1&&o.expandLevels!==void 0&&this.M(o))}L(o,c){if(c<0)return;const h=[];for(const[t,u]of this.s.getChildren(o.actual)){const i=this.expand($.$XJ.joinToString(o.fullId,u.id),c);(0,y.$Sg)(i)&&h.push(i)}if(h.length)return Promise.all(h).then(()=>{})}M(o){if(o.resolveBarrier)return o.resolveBarrier;if(!this.h){const u=new y.$5g;return u.open(),u}o.expand=2,this.N(o);const c=o.resolveBarrier=new y.$5g,h=u=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,u)};let t;try{t=this.h(o.actual===this.root?void 0:o.actual)}catch(u){h(u)}return(0,y.$Sg)(t)?t.catch(h).then(()=>{c.open(),this.J(o)}):(c.open(),this.J(o)),o.resolveBarrier}N(o){this.pushDiff({op:1,item:{extId:o.fullId.toString(),expand:o.expand}})}O(o){const c=this.tree.get(o);if(!c)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:o});const h=[c];for(;h.length;){const t=h.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const u of t.actual.tags)this.F(u.id);this.tree.delete(t.fullId.toString());for(const[u,i]of this.s.getChildren(t.actual))h.push(this.tree.get($.$XJ.joinToString(t.fullId,i.id)))}}}flushDiff(){const o=this.collectDiff();o.length&&this.g.fire(o)}}e.$ZM=p;class w extends Error{constructor(o){super(`Attempted to insert a duplicate test item ID ${o}`)}}e.$1M=w;class s extends Error{constructor(o){super(`TestItem with ID "${o}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$2M=s;class a extends Error{constructor(o,c,h){super(`TestItem with ID "${o}" is from controller "${c}" and cannot be added as a child of an item from controller "${h}".`)}}e.$3M=a;const r=(n,o,c)=>{let h=new Map;return{get size(){return h.size},forEach(t,u){for(const i of h.values())t.call(u,i,this)},[Symbol.iterator](){return h.entries()},replace(t){const u=new Map,i=new Set(h.keys()),g={op:5,ops:[]};for(const m of t){if(!(m instanceof c))throw new s(m.id);const d=o(m).controllerId;if(d!==n.controllerId)throw new a(m.id,d,n.controllerId);if(u.has(m.id))throw new w(m.id);u.set(m.id,m),i.delete(m.id),g.ops.push({op:0,item:m})}for(const m of i.keys())g.ops.push({op:3,id:m});n.listener?.(g),h=u},add(t){if(!(t instanceof c))throw new s(t.id);h.set(t.id,t),n.listener?.({op:0,item:t})},delete(t){h.delete(t)&&n.listener?.({op:3,id:t})},get(t){return h.get(t)},toJSON(){return Array.from(h.values())}}};e.$4M=r}),define(Pe[104],Re([1,0,77]),function(ge,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6M=e.$5M=void 0;const T=new WeakMap,C=(R,$)=>{const f={controllerId:$};return T.set(R,f),f};e.$5M=C;const L=R=>{const $=T.get(R);if(!$)throw new y.$2M(R?.id||"<unknown>");return $};e.$6M=L}),define(Pe[78],Re([1,0,12,2]),function(ge,e,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xvb=e.$wvb=e.$vvb=e.$uvb=e.$tvb=void 0,e.$tvb="vscode-cdn.net",e.$uvb=`vscode-resource.${e.$tvb}`,e.$vvb=`'self' https://*.${e.$tvb}`;function C($,f){return $.scheme===y.Schemas.http||$.scheme===y.Schemas.https?$:(f&&f.authority&&f.isRemote&&$.scheme===y.Schemas.file&&($=T.URI.from({scheme:y.Schemas.vscodeRemote,authority:f.authority,path:$.path})),T.URI.from({scheme:y.Schemas.https,authority:`${$.scheme}+${L($.authority)}.${e.$uvb}`,path:$.path,fragment:$.fragment,query:$.query}))}e.$wvb=C;function L($){return $.replace(/./g,f=>{const b=f.charCodeAt(0);return b>=97&&b<=122||b>=65&&b<=90||b>=48&&b<=57?f:"-"+b.toString(16).padStart(4,"0")})}function R($){return $.replace(/-([0-9a-f]{4})/g,(f,b)=>String.fromCharCode(parseInt(b,16)))}e.$xvb=R}),define(Pe[212],Re([1,0,5,6,78]),function(ge,e,y,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lgc=void 0;class L{constructor($,f,b){this.d=$,this.e=f,this.f=b,this.a=0,this.b=new T.$Sc,this.c=new Map,this.b.add(f.onDidChangeVisibleTextEditors(()=>{const A=f.getVisibleTextEditors();for(const k of this.c.values())A.indexOf(k.editor)<0&&k.inset.dispose()}))}dispose(){this.c.forEach($=>$.inset.dispose()),this.b.dispose()}createWebviewEditorInset($,f,b,A,k){let l;for(const o of this.e.getVisibleTextEditors(!0))if(o.value===$){l=o;break}if(!l)throw new Error("not a visible editor");const p=this,w=this.a++,s=new y.$Vd,a=new y.$Vd,r=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(o){return(0,C.$wvb)(o,p.f)}get cspSource(){return C.$vvb}set options(o){this.b=o,p.d.$setOptions(w,o)}get options(){return this.b}set html(o){this.a=o,p.d.$setHtml(w,o)}get html(){return this.a}get onDidReceiveMessage(){return s.event}postMessage(o){return p.d.$postMessage(w,o)}},n=new class{constructor(){this.editor=$,this.line=f,this.height=b,this.webview=r,this.onDidDispose=a.event}dispose(){p.c.has(w)&&(p.c.delete(w),p.d.$disposeEditorInset(w),a.fire(),a.dispose(),s.dispose())}};return this.d.$createEditorInset(w,l.id,l.value.document.uri,f+1,b,A||{},k.identifier,k.extensionLocation),this.c.set(w,{editor:$,inset:n,onDidReceiveMessage:s}),n}$onDidDispose($){const f=this.c.get($);f&&f.inset.dispose()}$onDidReceiveMessage($,f){this.c.get($)?.onDidReceiveMessage.fire(f)}}e.$lgc=L}),define(Pe[213],Re([1,0,4]),function(ge,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WN=e.VariableKind=e.$VN=void 0,e.$VN=(0,y.$6h)("configurationResolverService");var T;(function(L){L.Unknown="unknown",L.Env="env",L.Config="config",L.Command="command",L.Input="input",L.ExtensionInstallFolder="extensionInstallFolder",L.WorkspaceFolder="workspaceFolder",L.Cwd="cwd",L.WorkspaceFolderBasename="workspaceFolderBasename",L.UserHome="userHome",L.LineNumber="lineNumber",L.SelectedText="selectedText",L.File="file",L.FileWorkspaceFolder="fileWorkspaceFolder",L.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",L.RelativeFile="relativeFile",L.RelativeFileDirname="relativeFileDirname",L.FileDirname="fileDirname",L.FileExtname="fileExtname",L.FileBasename="fileBasename",L.FileBasenameNoExtension="fileBasenameNoExtension",L.FileDirnameBasename="fileDirnameBasename",L.ExecPath="execPath",L.ExecInstallFolder="execInstallFolder",L.PathSeparator="pathSeparator",L.PathSeparatorAlias="/"})(T||(e.VariableKind=T={}));class C extends Error{constructor(R,$){super($),this.variable=R}}e.$WN=C}),define(Pe[214],Re([1,0,19,74,16,26,21,95,176,213,11]),function(ge,e,y,T,C,L,R,$,f,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$N=void 0;class k{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(p,w,s,a){this.h=new Map,this.a=p,this.b=w,this.g=s,a&&(this.c=a.then(r=>this.i(r)))}i(p){if(R.$i){const w=Object.create(null);return Object.keys(p).forEach(s=>{w[s.toLowerCase()]=p[s]}),w}return p}resolveWithEnvironment(p,w,s){return this.l({env:this.i(p),userHome:void 0},w?w.uri:void 0,s)}async resolveAsync(p,w){const s={env:await this.c,userHome:await this.g};return this.l(s,p?p.uri:void 0,w)}async j(p,w,s,a){const r=L.$vn(w);R.$i&&r.windows?Object.keys(r.windows).forEach(o=>r[o]=r.windows[o]):R.$j&&r.osx?Object.keys(r.osx).forEach(o=>r[o]=r.osx[o]):R.$k&&r.linux&&Object.keys(r.linux).forEach(o=>r[o]=r.linux[o]),delete r.windows,delete r.osx,delete r.linux;const n={env:await this.c,userHome:await this.g};return this.l(n,p?p.uri:void 0,r,s,a)}async resolveAnyAsync(p,w,s){return this.j(p,w,s)}async resolveAnyMap(p,w,s){const a=new Map;return{newConfig:await this.j(p,w,s,a),resolvedVariables:a}}resolveWithInteractionReplace(p,w,s,a){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(p,w,s,a){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(p,w){if(this.h.has(p))throw new Error("Variable "+p+" is contributed twice.");this.h.set(p,w)}async l(p,w,s,a,r){if(C.$If(s))return this.m(p,w,s,a,r);if(Array.isArray(s))return Promise.all(s.map(n=>this.l(p,w,n,a,r)));if(C.$Kf(s)){const n=Object.create(null),o=await Promise.all(Object.keys(s).map(async c=>[await this.m(p,w,c,a,r),await this.l(p,w,s[c],a,r)]));for(const[c,h]of o)n[c]=h;return n}return s}m(p,w,s,a,r){return(0,A.$4e)(s,k.VARIABLE_REGEXP,async(n,o)=>{if(o.includes(k.VARIABLE_LHS))return n;let c=await this.o(p,n,o,w,a);return r?.set(o,c),c!==n&&C.$If(c)&&c.match(k.VARIABLE_REGEXP)&&(c=await this.m(p,w,c,a,r)),c})}n(p){return this.b?this.b.getUriLabel(p,{noPrefix:!0}):p.fsPath}async o(p,w,s,a,r){let n;const o=s.split(":");o.length>1&&(s=o[0],n=o[1]);const c=u=>{const i=this.a.getFilePath();if(i)return(0,$.$Wv)(i);throw new b.$WN(u,(0,f.localize)(0,null,w))},h=u=>{const i=c(u);if(this.a.getWorkspaceFolderPathForFile){const g=this.a.getWorkspaceFolderPathForFile();if(g)return(0,$.$Wv)(g)}throw new b.$WN(u,(0,f.localize)(1,null,w,y.$nc(i)))},t=u=>{if(n){const i=this.a.getFolderUri(n);if(i)return i;throw new b.$WN(u,(0,f.localize)(2,null,w,n))}if(a)return a;throw this.a.getWorkspaceFolderCount()>1?new b.$WN(u,(0,f.localize)(3,null,w)):new b.$WN(u,(0,f.localize)(4,null,w))};switch(s){case"env":if(n){if(p.env){const u=p.env[R.$i?n.toLowerCase():n];if(C.$If(u))return u}return""}throw new b.$WN(b.VariableKind.Env,(0,f.localize)(5,null,w));case"config":if(n){const u=this.a.getConfigurationValue(a,n);if(C.$Rf(u))throw new b.$WN(b.VariableKind.Config,(0,f.localize)(6,null,w,n));if(C.$Kf(u))throw new b.$WN(b.VariableKind.Config,(0,f.localize)(7,null,w,n));return u}throw new b.$WN(b.VariableKind.Config,(0,f.localize)(8,null,w));case"command":return this.p(b.VariableKind.Command,w,n,r,"command");case"input":return this.p(b.VariableKind.Input,w,n,r,"input");case"extensionInstallFolder":if(n){const u=await this.a.getExtension(n);if(!u)throw new b.$WN(b.VariableKind.ExtensionInstallFolder,(0,f.localize)(9,null,w,n));return this.n(u.extensionLocation)}throw new b.$WN(b.VariableKind.ExtensionInstallFolder,(0,f.localize)(10,null,w));default:switch(s){case"workspaceRoot":case"workspaceFolder":return(0,$.$Wv)(this.n(t(b.VariableKind.WorkspaceFolder)));case"cwd":return a||n?(0,$.$Wv)(this.n(t(b.VariableKind.Cwd))):T.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,$.$Wv)(y.$nc(this.n(t(b.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(p.userHome)return p.userHome;throw new b.$WN(b.VariableKind.UserHome,(0,f.localize)(11,null,w))}case"lineNumber":{const u=this.a.getLineNumber();if(u)return u;throw new b.$WN(b.VariableKind.LineNumber,(0,f.localize)(12,null,w))}case"selectedText":{const u=this.a.getSelectedText();if(u)return u;throw new b.$WN(b.VariableKind.SelectedText,(0,f.localize)(13,null,w))}case"file":return c(b.VariableKind.File);case"fileWorkspaceFolder":return h(b.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return y.$nc(h(b.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return a||n?y.$lc(this.n(t(b.VariableKind.RelativeFile)),c(b.VariableKind.RelativeFile)):c(b.VariableKind.RelativeFile);case"relativeFileDirname":{const u=y.$mc(c(b.VariableKind.RelativeFileDirname));if(a||n){const i=y.$lc(this.n(t(b.VariableKind.RelativeFileDirname)),u);return i.length===0?".":i}return u}case"fileDirname":return y.$mc(c(b.VariableKind.FileDirname));case"fileExtname":return y.$oc(c(b.VariableKind.FileExtname));case"fileBasename":return y.$nc(c(b.VariableKind.FileBasename));case"fileBasenameNoExtension":{const u=y.$nc(c(b.VariableKind.FileBasenameNoExtension));return u.slice(0,u.length-y.$oc(u).length)}case"fileDirnameBasename":return y.$nc(y.$mc(c(b.VariableKind.FileDirnameBasename)));case"execPath":{const u=this.a.getExecPath();return u||w}case"execInstallFolder":{const u=this.a.getAppRoot();return u||w}case"pathSeparator":case"/":return y.sep;default:try{const u=n?`${s}:${n}`:s;return this.p(b.VariableKind.Unknown,w,u,r,void 0)}catch{return w}}}}p(p,w,s,a,r){if(s&&a){const n=r===void 0?a[s]:a[r+":"+s];if(typeof n=="string")return n;throw new b.$WN(p,(0,f.localize)(14,null,w))}return w}}e.$$N=k}),define(Pe[105],Re([1,0,4,102]),function(ge,e,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_C=e.$$C=e.OpenEditorContext=e.GroupsOrder=e.$0C=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$9C=void 0,e.$9C=(0,y.$6h)("editorGroupsService");var C;(function(w){w[w.UP=0]="UP",w[w.DOWN=1]="DOWN",w[w.LEFT=2]="LEFT",w[w.RIGHT=3]="RIGHT"})(C||(e.GroupDirection=C={}));var L;(function(w){w[w.HORIZONTAL=0]="HORIZONTAL",w[w.VERTICAL=1]="VERTICAL"})(L||(e.GroupOrientation=L={}));var R;(function(w){w[w.FIRST=0]="FIRST",w[w.LAST=1]="LAST",w[w.NEXT=2]="NEXT",w[w.PREVIOUS=3]="PREVIOUS"})(R||(e.GroupLocation=R={}));var $;(function(w){w[w.MAXIMIZE=0]="MAXIMIZE",w[w.EXPAND=1]="EXPAND",w[w.EVEN=2]="EVEN"})($||(e.GroupsArrangement=$={}));var f;(function(w){w[w.COPY_EDITORS=0]="COPY_EDITORS",w[w.MOVE_EDITORS=1]="MOVE_EDITORS"})(f||(e.MergeGroupMode=f={}));function b(w){const s=w;return(0,T.$SE)(s?.editor)&&(0,T.$SE)(s?.replacement)}e.$0C=b;var A;(function(w){w[w.CREATION_TIME=0]="CREATION_TIME",w[w.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",w[w.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(A||(e.GroupsOrder=A={}));var k;(function(w){w[w.NEW_EDITOR=1]="NEW_EDITOR",w[w.MOVE_EDITOR=2]="MOVE_EDITOR",w[w.COPY_EDITOR=3]="COPY_EDITOR"})(k||(e.OpenEditorContext=k={}));function l(w){const s=w;return!!s&&typeof s.id=="number"&&Array.isArray(s.editors)}e.$$C=l;function p(w){return w.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$_C=p}),define(Pe[215],Re([1,0,4,105]),function(ge,e,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eD=e.$dD=e.$cD=e.$bD=e.$aD=void 0,e.$aD=(0,y.$6h)("editorService"),e.$bD=-1,e.$cD=-2,e.$dD=-3;function C(L){const R=L;return typeof L=="number"||(0,T.$$C)(R)}e.$eD=C}),define(Pe[216],Re([1,0,4,183]),function(ge,e,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qK=void 0,e.$qK=(0,y.$7h)(T.$ai)}),define(Pe[106],Re([1,0,22,5,19,6]),function(ge,e,y,T,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$k8b=e.$j8b=e.$i8b=e.$h8b=e.$g8b=void 0;class R{constructor(r,n){this.versionId=r,this.removedDueToLooping=n}}e.$g8b=R;class ${static isHostExtension(r,n,o){if(n.getExtensionDescription(r))return!1;const c=o.getExtensionDescription(r);return c?!!((c.main||c.browser)&&c.api==="none"):!1}constructor(r,n){this.j=r,this.c=new T.$Vd,this.onDidChange=this.c.event,this.d=0,this.e=n,this.k()}k(){this.e.sort(w),this.f=new y.$nm,this.g=[],this.h=new Map;for(const r of this.e){if(this.f.has(r.identifier)){console.error("Extension `"+r.identifier.value+"` is already registered");continue}this.f.set(r.identifier,r),this.g.push(r);const n=this.j.readActivationEvents(r);for(const o of n)this.h.has(o)||this.h.set(o,[]),this.h.get(o).push(r)}}set(r){return this.e=r,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(r,n){this.e=s(this.e,n),this.e=this.e.concat(r);const o=$.l(this.e);return this.e=s(this.e,o.map(c=>c.identifier)),this.k(),this.d++,this.c.fire(void 0),new R(this.d,o)}static l(r){const n=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(u){this.d.has(u)||(this.d.add(u),this.e.push(u))}addArc(u,i){this.addNode(u),this.addNode(i),this.c.has(u)?this.c.get(u).push(i):this.c.set(u,[i])}getArcs(u){return this.c.has(u)?this.c.get(u):[]}hasOnlyGoodArcs(u,i){const g=n.getArcs(u);for(let m=0;m<g.length;m++)if(!i.has(g[m]))return!1;return!0}getNodes(){return this.e}},o=new y.$nm;for(const u of r)if(o.set(u.identifier,u),u.extensionDependencies)for(const i of u.extensionDependencies)n.addArc(y.$lm.toKey(u.identifier),y.$lm.toKey(i));const c=new Set;n.getNodes().filter(u=>n.getArcs(u).length===0).forEach(u=>c.add(u));const h=n.getNodes().filter(u=>!c.has(u));let t;do{t=!1;for(let u=0;u<h.length;u++){const i=h[u];n.hasOnlyGoodArcs(i,c)&&(h.splice(u,1),u--,c.add(i),t=!0)}}while(t);return h.map(u=>o.get(u))}containsActivationEvent(r){return this.h.has(r)}containsExtension(r){return this.f.has(r)}getExtensionDescriptionsForActivationEvent(r){const n=this.h.get(r);return n?n.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new f(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(r){const n=this.f.get(r);return n||void 0}getExtensionDescriptionByUUID(r){for(const n of this.g)if(n.uuid===r)return n}getExtensionDescriptionByIdOrUUID(r,n){return this.getExtensionDescription(r)??(n?this.getExtensionDescriptionByUUID(n):void 0)}}e.$h8b=$;class f{constructor(r,n){this.versionId=r,this.extensions=n}}e.$i8b=f;class b{constructor(r){this.d=new l,this.c=new $(r,[])}async acquireLock(r){const n=await this.d.acquire(r);return new A(this,n)}deltaExtensions(r,n,o){if(!r.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(n,o)}containsActivationEvent(r){return this.c.containsActivationEvent(r)}containsExtension(r){return this.c.containsExtension(r)}getExtensionDescriptionsForActivationEvent(r){return this.c.getExtensionDescriptionsForActivationEvent(r)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(r){return this.c.getExtensionDescription(r)}getExtensionDescriptionByUUID(r){return this.c.getExtensionDescriptionByUUID(r)}getExtensionDescriptionByIdOrUUID(r,n){return this.c.getExtensionDescriptionByIdOrUUID(r,n)}}e.$j8b=b;class A extends L.$Tc{constructor(r,n){super(),this.f=r,this.c=!1,this.B(n)}isAcquiredFor(r){return!this.c&&this.f===r}}e.$k8b=A;class k{constructor(r){this.name=r,this.promise=new Promise((n,o)=>{this.c=n})}resolve(r){this.c(r)}}class l{constructor(){this.c=[],this.d=!1}async acquire(r){const n=new k(r);return this.c.push(n),this.e(),n.promise}e(){if(this.d||this.c.length===0)return;const r=this.c.shift();this.d=!0;let n=!0;const o=setTimeout(()=>{n&&console.warn(`The customer named ${r.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),c=()=>{n&&(clearTimeout(o),n=!1,this.d=!1,this.e())};r.resolve((0,L.$Rc)(c))}}var p;(function(a){a[a.Builtin=0]="Builtin",a[a.User=1]="User",a[a.Dev=2]="Dev"})(p||(p={}));function w(a,r){const n=a.isBuiltin?0:a.isUnderDevelopment?2:1,o=r.isBuiltin?0:r.isUnderDevelopment?2:1;if(n!==o)return n-o;const c=C.$gc.basename(a.extensionLocation.path),h=C.$gc.basename(r.extensionLocation.path);return c<h?-1:c>h?1:0}function s(a,r){const n=new y.$mm(r);return a.filter(o=>!n.has(o.identifier))}}),define(Pe[79],Re([1,0,24]),function(ge,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$um=e.$tm=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var T;(function(b){b[b.Desktop=1]="Desktop",b[b.Web=2]="Web"})(T||(e.UIKind=T={}));var C;(function(b){b[b.VersionMismatch=55]="VersionMismatch",b[b.UnexpectedError=81]="UnexpectedError"})(C||(e.ExtensionHostExitCode=C={}));var L;(function(b){b[b.Initialized=0]="Initialized",b[b.Ready=1]="Ready",b[b.Terminate=2]="Terminate"})(L||(e.MessageType=L={}));function R(b){const A=y.$je.alloc(1);switch(b){case 0:A.writeUInt8(1,0);break;case 1:A.writeUInt8(2,0);break;case 2:A.writeUInt8(3,0);break}return A}e.$tm=R;function $(b,A){if(b.byteLength!==1)return!1;switch(b.readUInt8(0)){case 1:return A===0;case 2:return A===1;case 3:return A===2;default:return!1}}e.$um=$;var f;(function(b){b.Start="START_NATIVE_LOG",b.End="END_NATIVE_LOG"})(f||(e.NativeLogMarkers=f={}))}),define(Pe[59],Re([1,0,4,5,14,27,79,55,56,26,2,6,164]),function(ge,e,y,T,C,L,R,$,f,b,A,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rN=e.$qN=e.$pN=e.$oN=void 0;let p=class extends k.$Tc{constructor(r,n){super(),this.s=r,this.t=n,this.a=this.B(new T.$Vd),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new T.$Vd),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=A.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=n.createLogger(this.m,{id:f.$Qo,name:(0,l.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(n.onDidChangeLogLevel(o=>{(0,C.$pj)(o)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===C.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(r,n,o){const c=this.getTelemetryDetails(),h=new w(n,o,r,this.n,this.j,this.getBuiltInCommonProperties(r),{isUsageEnabled:c.isUsageEnabled,isErrorsEnabled:c.isErrorsEnabled}),t=this.r.get(r.identifier.value)??[];return this.r.set(r.identifier.value,[...t,h]),h.apiTelemetryLogger}$initializeTelemetryLevel(r,n,o){this.f=r,this.g=n,this.c=o??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(r){const n=Object.create(null);switch(n["common.extname"]=`${r.publisher}.${r.name}`,n["common.extversion"]=r.version,n["common.vscodemachineid"]=this.s.telemetryInfo.machineId,n["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,n["common.sqmid"]=this.s.telemetryInfo.sqmId,n["common.vscodeversion"]=this.s.version,n["common.isnewappinstall"]=s(this.s.telemetryInfo.firstSessionDate),n["common.product"]=this.s.environment.appHost,this.s.uiKind){case R.UIKind.Web:n["common.uikind"]="web";break;case R.UIKind.Desktop:n["common.uikind"]="desktop";break;default:n["common.uikind"]="unknown"}return n["common.remotename"]=(0,$.$bl)((0,f.$Wo)(this.s.remote.authority)),n}$onDidChangeTelemetryLevel(r){this.h=this.getTelemetryConfiguration(),this.f=r;const n=this.getTelemetryDetails();this.r.forEach((o,c)=>{const h=o.filter(t=>!t.isDisposed);h.length===0?this.r.delete(c):this.r.set(c,h)}),this.r.forEach(o=>{for(const c of o)c.updateTelemetryEnablements(n.isUsageEnabled,n.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(r,n){const c=this.r.get(r.value)?.filter(t=>!t.isDisposed);if(!c)return this.r.delete(r.value),!1;let h=!1;for(const t of c)t.ignoreUnhandledExtHostErrors||(t.logError(n),h=!0);return h}};e.$oN=p,e.$oN=p=Je([Ke(0,L.$nN),Ke(1,C.$oj)],p);class w{static validateSender(r){if(typeof r!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof r.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof r.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof r.flush<"u"&&typeof r.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(r,n,o,c,h,t,u){this.g=o,this.h=c,this.i=h,this.j=t,this.a=new T.$Vd,this.ignoreUnhandledExtHostErrors=n?.ignoreUnhandledErrors??!1,this.b=n?.ignoreBuiltInCommonProperties??!1,this.c=n?.additionalCommonProperties,this.f=r,this.d={isUsageEnabled:u.isUsageEnabled,isErrorsEnabled:u.isErrorsEnabled}}updateTelemetryEnablements(r,n){this.e&&(this.d={isUsageEnabled:r,isErrorsEnabled:n},this.a.fire(this.e))}mixInCommonPropsAndCleanData(r){let n="properties"in r?r.properties??{}:r;return n=(0,f.$Zo)(n,[]),this.c&&(n=(0,b.$yn)(n,this.c)),this.b||(n=(0,b.$yn)(n,this.j)),"properties"in r?r.properties=n:r=n,r}k(r,n){this.f&&(this.g.publisher==="vscode"?r=this.g.name+"/"+r:r=this.g.identifier.value+"/"+r,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f?.sendEventData(r,n),this.h.trace(r,n))}logUsage(r,n){this.d.isUsageEnabled&&this.k(r,n)}logError(r,n){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof r=="string")this.k(r,n);else{const o={name:r.name,message:r.message,stack:r.stack,cause:r.cause},c=(0,f.$Zo)(o,[]),h=new Error(c.message,{cause:c.cause});h.stack=c.stack,h.name=c.name,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f.sendErrorData(h,n),this.h.trace("exception",n)}}get apiTelemetryLogger(){if(!this.e){const r=this,n={logUsage:r.logUsage.bind(r),get isUsageEnabled(){return r.d.isUsageEnabled},get isErrorsEnabled(){return r.d.isErrorsEnabled},logError:r.logError.bind(r),dispose:r.dispose.bind(r),onDidChangeEnableStates:r.a.event.bind(r)};this.e=Object.freeze(n)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let r=this.f;this.f=void 0,Promise.resolve(r.flush()).then(r=void 0),this.e=void 0}else this.f=void 0}}e.$pN=w;function s(a){const r=Date.now()-new Date(a).getTime();return isNaN(r)?!1:r<1e3*60*60*24}e.$qN=s,e.$rN=(0,y.$6h)("IExtHostTelemetry")}),define(Pe[23],Re([1,0,5,2,192,101,22,4]),function(ge,e,y,T,C,L,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HF=e.$GF=e.$FF=e.ActivationKind=e.$EF=e.$DF=e.$CF=e.$BF=e.$AF=e.ExtensionHostStartup=e.$zF=e.$yF=e.$xF=e.$wF=void 0,e.$wF=Object.freeze({identifier:new R.$lm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:T.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$xF="extensions.webWorker",e.$yF=(0,$.$6h)("extensionService");class f{constructor(h){this.dependency=h}}e.$zF=f;var b;(function(c){c[c.EagerAutoStart=1]="EagerAutoStart",c[c.EagerManualStart=2]="EagerManualStart",c[c.Lazy=3]="Lazy"})(b||(e.ExtensionHostStartup=b={}));class A{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(h,t,u){this.c=h,this.d=t.slice(0),this.e=u.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:L.$hF.createActivationEventsMap(this.d)}}set(h,t,u){if(this.c>h)throw new Error(`ExtensionHostExtensions: invalid versionId ${h} (current: ${this.c})`);const i=[],g=[],m=[],d=[],S=k(this.d),M=k(t),v=(G,W)=>G.extensionLocation.toString()===W.extensionLocation.toString()||G.isBuiltin===W.isBuiltin||G.isUserBuiltin===W.isUserBuiltin||G.isUnderDevelopment===W.isUnderDevelopment;for(const G of this.d){const W=M.get(G.identifier);if(!W){i.push(G.identifier),S.delete(G.identifier);continue}if(!v(G,W)){i.push(G.identifier),S.delete(G.identifier);continue}}for(const G of t){const W=S.get(G.identifier);if(!W){g.push(G);continue}if(!v(W,G)){i.push(W.identifier),S.delete(W.identifier);continue}}const E=new R.$mm(this.e),D=new R.$mm(u);for(const G of this.e)D.has(G)||m.push(G);for(const G of u)E.has(G)||d.push(G);const N=L.$hF.createActivationEventsMap(g),O={versionId:h,toRemove:i,toAdd:g,addActivationEvents:N,myToRemove:m,myToAdd:d};return this.delta(O),O}delta(h){if(this.c>=h.versionId)return null;const{toRemove:t,toAdd:u,myToRemove:i,myToAdd:g}=h,m=new R.$mm(t),d=new R.$mm(i);for(let S=0;S<this.d.length;S++)m.has(this.d[S].identifier)&&(this.d.splice(S,1),S--);for(let S=0;S<this.e.length;S++)d.has(this.e[S])&&(this.e.splice(S,1),S--);for(const S of u)this.d.push(S);for(const S of g)this.e.push(S);return this.f=null,h}containsExtension(h){for(const t of this.e)if(R.$lm.equals(t,h))return!0;return!1}containsActivationEvent(h){return this.f||(this.f=this.g()),this.f.has(h)}g(){const h=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const u=L.$hF.readActivationEvents(t);for(const i of u)h.add(i)}return h}}e.$AF=A;function k(c){const h=new R.$nm;for(const t of c)h.set(t.identifier,t);return h}function l(c,h){return c.enabledApiProposals?c.enabledApiProposals.includes(h):!1}e.$BF=l;function p(c,h){if(!l(c,h))throw new Error(`Extension '${c.identifier.value}' CANNOT use API proposal: ${h}.
Its package.json#enabledApiProposals-property declares: ${c.enabledApiProposals?.join(", ")??"[]"} but NOT ${h}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${c.identifier.value}`)}e.$CF=p;class w{constructor(h,t,u,i){this.codeLoadingTime=h,this.activateCallTime=t,this.activateResolvedTime=u,this.activationReason=i}}e.$DF=w;class s{constructor(h,t){this.description=h,this.value=t}}e.$EF=s;var a;(function(c){c[c.Normal=0]="Normal",c[c.Immediate=1]="Immediate"})(a||(e.ActivationKind=a={}));function r(c){return{type:c.isBuiltin?0:1,isBuiltin:c.isBuiltin||c.isUserBuiltin,identifier:{id:(0,C.$6o)(c.publisher,c.name),uuid:c.uuid},manifest:c,location:c.extensionLocation,targetPlatform:c.targetPlatform,validations:[],isValid:!0}}e.$FF=r;function n(c,h){return{identifier:new R.$lm((0,C.$4o)(c.manifest.publisher,c.manifest.name)),isBuiltin:c.type===0,isUserBuiltin:c.type===1&&c.isBuiltin,isUnderDevelopment:!!h,extensionLocation:c.location,...c.manifest,uuid:c.identifier.uuid,targetPlatform:c.targetPlatform}}e.$GF=n;class o{constructor(){this.onDidRegisterExtensions=y.Event.None,this.onDidChangeExtensionsStatus=y.Event.None,this.onDidChangeExtensions=y.Event.None,this.onWillActivateByEvent=y.Event.None,this.onDidChangeResponsiveChange=y.Event.None,this.onWillStop=y.Event.None,this.extensions=[]}activateByEvent(h){return Promise.resolve(void 0)}activateById(h,t){return Promise.resolve(void 0)}activationEventIsDone(h){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(h){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(h,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(h){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$HF=o}),define(Pe[217],Re([1,0,15,106,22,23,14,13]),function(ge,e,y,T,C,L,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mgc=e.$Lgc=e.$Kgc=e.$Jgc=e.$Igc=e.$Hgc=void 0;class f{static{this.NONE=new f(!1,-1,-1,-1)}constructor(r,n,o,c){this.startup=r,this.codeLoadingTime=n,this.activateCallTime=o,this.activateResolvedTime=c}}e.$Hgc=f;class b{constructor(r){this.a=r,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(r,n){return r===-1||n===-1?-1:n-r}build(){return new f(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$Igc=b;class A{constructor(r,n,o,c,h,t){this.activationFailed=r,this.activationFailedError=n,this.activationTimes=o,this.module=c,this.exports=h,this.subscriptions=t}}e.$Jgc=A;class k extends A{constructor(r){super(!1,null,r,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Kgc=k;class l extends A{constructor(){super(!1,null,f.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Lgc=l;class p extends A{constructor(r){super(!0,r,f.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let w=class{constructor(r,n,o,c){this.g=c,this.a=r,this.b=n,this.c=o,this.d=new C.$nm,this.f=Object.create(null)}dispose(){for(const[r,n]of this.d)n.dispose()}async waitForActivatingExtensions(){const r=[];for(const[n,o]of this.d)r.push(o.wait());await Promise.all(r)}isActivated(r){const n=this.d.get(r);return!!(n&&n.value)}getActivatedExtension(r){const n=this.d.get(r);if(!n||!n.value)throw new Error(`Extension '${r.value}' is not known or not activated`);return n.value}async activateByEvent(r,n){if(this.f[r])return;const o=this.a.getExtensionDescriptionsForActivationEvent(r);await this.h(o.map(c=>({id:c.identifier,reason:{startup:n,extensionId:c.identifier,activationEvent:r}}))),this.f[r]=!0}activateById(r,n){const o=this.a.getExtensionDescription(r);if(!o)throw new Error(`Extension '${r}' is not known`);return this.h([{id:o.identifier,reason:n}])}async h(r){const n=r.filter(o=>!this.isActivated(o.id)).map(o=>this.j(o));await Promise.all(n.map(o=>o.wait()))}j(r){if(this.d.has(r.id))return this.d.get(r.id);if(this.l(r.id))return this.k(r,null,[],null);const n=this.a.getExtensionDescription(r.id);if(!n){const h=new Error(`Cannot activate unknown extension '${r.id.value}'`),t=this.k(r,null,[],new p(h));return this.c.onExtensionActivationError(r.id,h,new L.$zF(r.id.value)),t}const o=[],c=typeof n.extensionDependencies>"u"?[]:n.extensionDependencies;for(const h of c){if(this.m(h))continue;const t=this.d.get(h);if(t){o.push(t);continue}if(this.l(h)){o.push(this.j({id:this.b.getExtensionDescription(h).identifier,reason:r.reason}));continue}const u=this.a.getExtensionDescription(h);if(u){if(!u.main&&!u.browser)continue;o.push(this.j({id:u.identifier,reason:r.reason}));continue}const i=n.displayName||n.identifier.value,g=new Error(`Cannot activate the '${i}' extension because it depends on unknown extension '${h}'`),m=this.k(r,n.displayName,[],new p(g));return this.c.onExtensionActivationError(n.identifier,g,new L.$zF(h)),m}return this.k(r,n.displayName,o,null)}k(r,n,o,c){const h=new s(r.id,n,r.reason,o,c,this.c,this.g);return this.d.set(r.id,h),h}l(r){return T.$h8b.isHostExtension(r,this.a,this.b)}m(r){const n=this.b.getExtensionDescription(r);return n?!n.main&&!n.browser:!1}};e.$Mgc=w,e.$Mgc=w=Je([Ke(3,R.$nj)],w);let s=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(r,n,o,c,h,t,u){this.c=r,this.d=n,this.f=o,this.g=c,this.h=h,this.j=t,this.k=u,this.a=new $.$5g,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let r=0;r<this.g.length;r++){const n=this.g[r];if(n.value&&!n.value.activationFailed){this.g.splice(r,1),r--;continue}if(n.value&&n.value.activationFailed){const o=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${n.friendlyName}' failed to activate`);o.detail=n.value.activationFailedError,this.h=new p(o),this.j.onExtensionActivationError(this.c,o,null);return}}this.g.length>0&&await Promise.race(this.g.map(r=>r.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(r){const n=new Error;if(r&&r.name&&(n.name=r.name),r&&r.message?n.message=`Activating extension '${this.c.value}' failed: ${r.message}.`:n.message=`Activating extension '${this.c.value}' failed: ${r}.`,r&&r.stack&&(n.stack=r.stack),this.h=new p(n),this.b&&y.$4(r))return;this.j.onExtensionActivationError(this.c,n,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(r)}}};s=Je([Ke(6,R.$nj)],s)}),define(Pe[8],Re([1,0,18,24,127,218,52,28,120,51,68,26,16,2,29,80,99,104,102,76,48,58,215,23,7]),function(ge,e,y,T,C,L,R,$,f,b,A,k,l,p,w,s,a,r,n,o,c,h,t,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatAgentCompletionItem=e.ChatResponseProgress=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$9M=e.$8M=e.MarkdownString=e.$7M=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var g;(function(Se){function Fe(J){const{selectionStartLineNumber:Me,selectionStartColumn:Ue,positionLineNumber:Xe,positionColumn:We}=J,_e=new i.$9K(Me-1,Ue-1),mt=new i.$9K(Xe-1,We-1);return new i.$$K(_e,mt)}Se.to=Fe;function fe(J){const{anchor:Me,active:Ue}=J;return{selectionStartLineNumber:Me.line+1,selectionStartColumn:Me.character+1,positionLineNumber:Ue.line+1,positionColumn:Ue.character+1}}Se.from=fe})(g||(e.Selection=g={}));var m;(function(Se){function Fe(J){if(!J)return;const{start:Me,end:Ue}=J;return{startLineNumber:Me.line+1,startColumn:Me.character+1,endLineNumber:Ue.line+1,endColumn:Ue.character+1}}Se.from=Fe;function fe(J){if(!J)return;const{startLineNumber:Me,startColumn:Ue,endLineNumber:Xe,endColumn:We}=J;return new i.$0K(Me-1,Ue-1,Xe-1,We-1)}Se.to=fe})(m||(e.Range=m={}));var d;(function(Se){function Fe(fe){switch(fe){case 1:return i.StandardTokenType.Comment;case 0:return i.StandardTokenType.Other;case 3:return i.StandardTokenType.RegEx;case 2:return i.StandardTokenType.String}}Se.to=Fe})(d||(e.TokenType=d={}));var S;(function(Se){function Fe(J){return new i.$9K(J.lineNumber-1,J.column-1)}Se.to=Fe;function fe(J){return{lineNumber:J.line+1,column:J.character+1}}Se.from=fe})(S||(e.Position=S={}));var M;(function(Se){function Fe(Me,Ue,Xe){return(0,y.$Hb)((0,y.$3b)(Me).map(We=>fe(We,Ue,Xe)))}Se.from=Fe;function fe(Me,Ue,Xe){if(typeof Me=="string")return{$serialized:!0,language:Me,isBuiltin:Xe?.isBuiltin};if(Me)return{$serialized:!0,language:Me.language,scheme:J(Me.scheme,Ue),pattern:Z.from(Me.pattern)??void 0,exclusive:Me.exclusive,notebookType:Me.notebookType,isBuiltin:Xe?.isBuiltin}}function J(Me,Ue){return Ue&&typeof Me=="string"?Ue.transformOutgoingScheme(Me):Me}})(M||(e.DocumentSelector=M={}));var v;(function(Se){function Fe(J){switch(J){case i.DiagnosticTag.Unnecessary:return 1;case i.DiagnosticTag.Deprecated:return 2}}Se.from=Fe;function fe(J){switch(J){case 1:return i.DiagnosticTag.Unnecessary;case 2:return i.DiagnosticTag.Deprecated;default:return}}Se.to=fe})(v||(e.DiagnosticTag=v={}));var E;(function(Se){function Fe(J){let Me;return J.code&&((0,l.$If)(J.code)||(0,l.$Mf)(J.code)?Me=String(J.code):Me={value:String(J.code.value),target:J.code.target}),{...m.from(J.range),message:J.message,source:J.source,code:Me,severity:N.from(J.severity),relatedInformation:J.relatedInformation&&J.relatedInformation.map(D.from),tags:Array.isArray(J.tags)?(0,y.$Hb)(J.tags.map(v.from)):void 0}}Se.from=Fe;function fe(J){const Me=new i.$jL(m.to(J),J.message,N.to(J.severity));return Me.source=J.source,Me.code=(0,l.$If)(J.code)?J.code:J.code?.value,Me.relatedInformation=J.relatedInformation&&J.relatedInformation.map(D.to),Me.tags=J.tags&&(0,y.$Hb)(J.tags.map(v.to)),Me}Se.to=fe})(E||(e.Diagnostic=E={}));var D;(function(Se){function Fe(J){return{...m.from(J.location.range),message:J.message,resource:J.location.uri}}Se.from=Fe;function fe(J){return new i.$iL(new i.$hL(J.resource,m.to(J)),J.message)}Se.to=fe})(D||(e.DiagnosticRelatedInformation=D={}));var N;(function(Se){function Fe(J){switch(J){case i.DiagnosticSeverity.Error:return a.MarkerSeverity.Error;case i.DiagnosticSeverity.Warning:return a.MarkerSeverity.Warning;case i.DiagnosticSeverity.Information:return a.MarkerSeverity.Info;case i.DiagnosticSeverity.Hint:return a.MarkerSeverity.Hint}return a.MarkerSeverity.Error}Se.from=Fe;function fe(J){switch(J){case a.MarkerSeverity.Info:return i.DiagnosticSeverity.Information;case a.MarkerSeverity.Warning:return i.DiagnosticSeverity.Warning;case a.MarkerSeverity.Error:return i.DiagnosticSeverity.Error;case a.MarkerSeverity.Hint:return i.DiagnosticSeverity.Hint;default:return i.DiagnosticSeverity.Error}}Se.to=fe})(N||(e.DiagnosticSeverity=N={}));var O;(function(Se){function Fe(J){return typeof J=="number"&&J>=i.ViewColumn.One?J-1:J===i.ViewColumn.Beside?t.$cD:t.$bD}Se.from=Fe;function fe(J){if(typeof J=="number"&&J>=0)return J+1;throw new Error("invalid 'EditorGroupColumn'")}Se.to=fe})(O||(e.ViewColumn=O={}));function G(Se){return typeof Se.range<"u"}function W(Se){return Se.length===0?!0:!!G(Se[0])}e.$7M=W;var z;(function(Se){function Fe(We){return We.map(Se.from)}Se.fromMany=Fe;function fe(We){return We&&typeof We=="object"&&typeof We.language=="string"&&typeof We.value=="string"}function J(We){let _e;if(fe(We)){const{language:St,value:bt}=We;_e={value:"```"+St+`
`+bt+"\n```\n"}}else i.$wL.isMarkdownString(We)?_e={value:We.value,isTrusted:We.isTrusted,supportThemeIcons:We.supportThemeIcons,supportHtml:We.supportHtml,baseUri:We.baseUri}:typeof We=="string"?_e={value:We}:_e={value:""};const mt=Object.create(null);_e.uris=mt;const Ut=St=>{try{let bt=p.URI.parse(St,!0);bt=bt.with({query:Me(bt.query,mt)}),mt[St]=bt}catch{}return""},Et=new f.marked.Renderer;return Et.link=Ut,Et.image=St=>typeof St=="string"?Ut(R.$pk(St).href):"",(0,f.marked)(_e.value,{renderer:Et}),_e}Se.from=J;function Me(We,_e){if(!We)return We;let mt;try{mt=(0,b.$Bh)(We)}catch{}if(!mt)return We;let Ut=!1;return mt=(0,k.$xn)(mt,Et=>{if(p.URI.isUri(Et)){const St=`__uri_${Math.random().toString(16).slice(2,8)}`;return _e[St]=Et,Ut=!0,St}else return}),Ut?JSON.stringify(mt):We}function Ue(We){const _e=new i.$wL(We.value,We.supportThemeIcons);return _e.isTrusted=We.isTrusted,_e.supportHtml=We.supportHtml,_e.baseUri=We.baseUri?p.URI.from(We.baseUri):void 0,_e}Se.to=Ue;function Xe(We){if(We)return typeof We=="string"?We:Se.from(We)}Se.fromStrict=Xe})(z||(e.MarkdownString=z={}));function P(Se){return W(Se)?Se.map(Fe=>({range:m.from(Fe.range),hoverMessage:Array.isArray(Fe.hoverMessage)?z.fromMany(Fe.hoverMessage):Fe.hoverMessage?z.from(Fe.hoverMessage):void 0,renderOptions:Fe.renderOptions})):Se.map(Fe=>({range:m.from(Fe)}))}e.$8M=P;function I(Se){return typeof Se>"u"?Se:typeof Se=="string"?p.URI.file(Se):Se}e.$9M=I;var H;(function(Se){function Fe(fe){return typeof fe>"u"?fe:{contentText:fe.contentText,contentIconPath:fe.contentIconPath?I(fe.contentIconPath):void 0,border:fe.border,borderColor:fe.borderColor,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,color:fe.color,backgroundColor:fe.backgroundColor,margin:fe.margin,width:fe.width,height:fe.height}}Se.from=Fe})(H||(e.ThemableDecorationAttachmentRenderOptions=H={}));var ae;(function(Se){function Fe(fe){return typeof fe>"u"?fe:{backgroundColor:fe.backgroundColor,outline:fe.outline,outlineColor:fe.outlineColor,outlineStyle:fe.outlineStyle,outlineWidth:fe.outlineWidth,border:fe.border,borderColor:fe.borderColor,borderRadius:fe.borderRadius,borderSpacing:fe.borderSpacing,borderStyle:fe.borderStyle,borderWidth:fe.borderWidth,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,cursor:fe.cursor,color:fe.color,opacity:fe.opacity,letterSpacing:fe.letterSpacing,gutterIconPath:fe.gutterIconPath?I(fe.gutterIconPath):void 0,gutterIconSize:fe.gutterIconSize,overviewRulerColor:fe.overviewRulerColor,before:fe.before?H.from(fe.before):void 0,after:fe.after?H.from(fe.after):void 0}}Se.from=Fe})(ae||(e.ThemableDecorationRenderOptions=ae={}));var de;(function(Se){function Fe(fe){if(typeof fe>"u")return fe;switch(fe){case i.DecorationRangeBehavior.OpenOpen:return 0;case i.DecorationRangeBehavior.ClosedClosed:return 1;case i.DecorationRangeBehavior.OpenClosed:return 2;case i.DecorationRangeBehavior.ClosedOpen:return 3}}Se.from=Fe})(de||(e.DecorationRangeBehavior=de={}));var we;(function(Se){function Fe(fe){return{isWholeLine:fe.isWholeLine,rangeBehavior:fe.rangeBehavior?de.from(fe.rangeBehavior):void 0,overviewRulerLane:fe.overviewRulerLane,light:fe.light?ae.from(fe.light):void 0,dark:fe.dark?ae.from(fe.dark):void 0,backgroundColor:fe.backgroundColor,outline:fe.outline,outlineColor:fe.outlineColor,outlineStyle:fe.outlineStyle,outlineWidth:fe.outlineWidth,border:fe.border,borderColor:fe.borderColor,borderRadius:fe.borderRadius,borderSpacing:fe.borderSpacing,borderStyle:fe.borderStyle,borderWidth:fe.borderWidth,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,cursor:fe.cursor,color:fe.color,opacity:fe.opacity,letterSpacing:fe.letterSpacing,gutterIconPath:fe.gutterIconPath?I(fe.gutterIconPath):void 0,gutterIconSize:fe.gutterIconSize,overviewRulerColor:fe.overviewRulerColor,before:fe.before?H.from(fe.before):void 0,after:fe.after?H.from(fe.after):void 0}}Se.from=Fe})(we||(e.DecorationRenderOptions=we={}));var ke;(function(Se){function Fe(J){return{text:J.newText,eol:J.newEol&&tt.from(J.newEol),range:m.from(J.range)}}Se.from=Fe;function fe(J){const Me=new i.$cL(m.to(J.range),J.text);return Me.newEol=typeof J.eol>"u"?void 0:tt.to(J.eol),Me}Se.to=fe})(ke||(e.TextEdit=ke={}));var le;(function(Se){function Fe(J,Me){const Ue={edits:[]};if(J instanceof i.$fL){const Xe=new $.$Bc;for(const We of J._allEntries())We._type===1&&p.URI.isUri(We.to)&&We.from===void 0&&Xe.add(We.to);for(const We of J._allEntries())if(We._type===1){let _e;We.options?.contents&&(ArrayBuffer.isView(We.options.contents)?_e={type:"base64",value:(0,T.$De)(T.$je.wrap(We.options.contents))}:_e={type:"dataTransferItem",id:We.options.contents._itemId}),Ue.edits.push({oldResource:We.from,newResource:We.to,options:{...We.options,contents:_e},metadata:We.metadata})}else We._type===2?Ue.edits.push({resource:We.uri,textEdit:ke.from(We.edit),versionId:Xe.has(We.uri)?void 0:Me?.getTextDocumentVersion(We.uri),metadata:We.metadata}):We._type===6?Ue.edits.push({resource:We.uri,textEdit:{range:m.from(We.range),text:We.edit.value,insertAsSnippet:!0},versionId:Xe.has(We.uri)?void 0:Me?.getTextDocumentVersion(We.uri),metadata:We.metadata}):We._type===3?Ue.edits.push({metadata:We.metadata,resource:We.uri,cellEdit:We.edit,notebookMetadata:We.notebookMetadata,notebookVersionId:Me?.getNotebookDocumentVersion(We.uri)}):We._type===5&&Ue.edits.push({metadata:We.metadata,resource:We.uri,notebookVersionId:Me?.getNotebookDocumentVersion(We.uri),cellEdit:{editType:1,index:We.index,count:We.count,cells:We.cells.map(Pt.from)}})}return Ue}Se.from=Fe;function fe(J){const Me=new i.$fL,Ue=new $.$Ac;for(const Xe of J.edits)if(Xe.textEdit){const We=Xe,_e=p.URI.revive(We.resource),mt=m.to(We.textEdit.range),Ut=We.textEdit.text,Et=We.textEdit.insertAsSnippet;let St;Et?St=i.$eL.replace(mt,new i.$gL(Ut)):St=i.$cL.replace(mt,Ut);const bt=Ue.get(_e);bt?bt.push(St):Ue.set(_e,[St])}else Me.renameFile(p.URI.revive(Xe.oldResource),p.URI.revive(Xe.newResource),Xe.options);for(const[Xe,We]of Ue)Me.set(Xe,We);return Me}Se.to=fe})(le||(e.WorkspaceEdit=le={}));var ve;(function(Se){const Fe=Object.create(null);Fe[i.SymbolKind.File]=0,Fe[i.SymbolKind.Module]=1,Fe[i.SymbolKind.Namespace]=2,Fe[i.SymbolKind.Package]=3,Fe[i.SymbolKind.Class]=4,Fe[i.SymbolKind.Method]=5,Fe[i.SymbolKind.Property]=6,Fe[i.SymbolKind.Field]=7,Fe[i.SymbolKind.Constructor]=8,Fe[i.SymbolKind.Enum]=9,Fe[i.SymbolKind.Interface]=10,Fe[i.SymbolKind.Function]=11,Fe[i.SymbolKind.Variable]=12,Fe[i.SymbolKind.Constant]=13,Fe[i.SymbolKind.String]=14,Fe[i.SymbolKind.Number]=15,Fe[i.SymbolKind.Boolean]=16,Fe[i.SymbolKind.Array]=17,Fe[i.SymbolKind.Object]=18,Fe[i.SymbolKind.Key]=19,Fe[i.SymbolKind.Null]=20,Fe[i.SymbolKind.EnumMember]=21,Fe[i.SymbolKind.Struct]=22,Fe[i.SymbolKind.Event]=23,Fe[i.SymbolKind.Operator]=24,Fe[i.SymbolKind.TypeParameter]=25;function fe(Me){return typeof Fe[Me]=="number"?Fe[Me]:6}Se.from=fe;function J(Me){for(const Ue in Fe)if(Fe[Ue]===Me)return Number(Ue);return i.SymbolKind.Property}Se.to=J})(ve||(e.SymbolKind=ve={}));var se;(function(Se){function Fe(J){switch(J){case i.SymbolTag.Deprecated:return 1}}Se.from=Fe;function fe(J){switch(J){case 1:return i.SymbolTag.Deprecated}}Se.to=fe})(se||(e.SymbolTag=se={}));var be;(function(Se){function Fe(J){return{name:J.name,kind:ve.from(J.kind),tags:J.tags&&J.tags.map(se.from),containerName:J.containerName,location:Ie.from(J.location)}}Se.from=Fe;function fe(J){const Me=new i.$nL(J.name,ve.to(J.kind),J.containerName,Ie.to(J.location));return Me.tags=J.tags&&J.tags.map(se.to),Me}Se.to=fe})(be||(e.WorkspaceSymbol=be={}));var ne;(function(Se){function Fe(J){const Me={name:J.name||"!!MISSING: name!!",detail:J.detail,range:m.from(J.range),selectionRange:m.from(J.selectionRange),kind:ve.from(J.kind),tags:J.tags?.map(se.from)??[]};return J.children&&(Me.children=J.children.map(Fe)),Me}Se.from=Fe;function fe(J){const Me=new i.$oL(J.name,J.detail,ve.to(J.kind),m.to(J.range),m.to(J.selectionRange));return(0,y.$Lb)(J.tags)&&(Me.tags=J.tags.map(se.to)),J.children&&(Me.children=J.children.map(fe)),Me}Se.to=fe})(ne||(e.DocumentSymbol=ne={}));var Y;(function(Se){function Fe(J){const Me=new i.$sL(ve.to(J.kind),J.name,J.detail||"",p.URI.revive(J.uri),m.to(J.range),m.to(J.selectionRange));return Me._sessionId=J._sessionId,Me._itemId=J._itemId,Me}Se.to=Fe;function fe(J,Me,Ue){if(Me=Me??J._sessionId,Ue=Ue??J._itemId,Me===void 0||Ue===void 0)throw new Error("invalid item");return{_sessionId:Me,_itemId:Ue,name:J.name,detail:J.detail,kind:ve.from(J.kind),uri:J.uri,range:m.from(J.range),selectionRange:m.from(J.selectionRange),tags:J.tags?.map(se.from)}}Se.from=fe})(Y||(e.CallHierarchyItem=Y={}));var V;(function(Se){function Fe(fe){return new i.$tL(Y.to(fe.from),fe.fromRanges.map(J=>m.to(J)))}Se.to=Fe})(V||(e.CallHierarchyIncomingCall=V={}));var ie;(function(Se){function Fe(fe){return new i.$uL(Y.to(fe.to),fe.fromRanges.map(J=>m.to(J)))}Se.to=Fe})(ie||(e.CallHierarchyOutgoingCall=ie={}));var Ie;(function(Se){function Fe(J){return{range:J.range&&m.from(J.range),uri:J.uri}}Se.from=Fe;function fe(J){return new i.$hL(p.URI.revive(J.uri),m.to(J.range))}Se.to=fe})(Ie||(e.location=Ie={}));var Le;(function(Se){function Fe(J){const Me=J,Ue=J;return{originSelectionRange:Me.originSelectionRange?m.from(Me.originSelectionRange):void 0,uri:Me.targetUri?Me.targetUri:Ue.uri,range:m.from(Me.targetRange?Me.targetRange:Ue.range),targetSelectionRange:Me.targetSelectionRange?m.from(Me.targetSelectionRange):void 0}}Se.from=Fe;function fe(J){return{targetUri:p.URI.revive(J.uri),targetRange:m.to(J.range),targetSelectionRange:J.targetSelectionRange?m.to(J.targetSelectionRange):void 0,originSelectionRange:J.originSelectionRange?m.to(J.originSelectionRange):void 0}}Se.to=fe})(Le||(e.DefinitionLink=Le={}));var Ce;(function(Se){function Fe(J){return{range:m.from(J.range),contents:z.fromMany(J.contents)}}Se.from=Fe;function fe(J){return new i.$kL(J.contents.map(z.to),m.to(J.range))}Se.to=fe})(Ce||(e.Hover=Ce={}));var ce;(function(Se){function Fe(J){return{range:m.from(J.range),expression:J.expression}}Se.from=Fe;function fe(J){return new i.$eM(m.to(J.range),J.expression)}Se.to=fe})(ce||(e.EvaluatableExpression=ce={}));var te;(function(Se){function Fe(J){if(J instanceof i.$fM)return{type:"text",range:m.from(J.range),text:J.text};if(J instanceof i.$gM)return{type:"variable",range:m.from(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};if(J instanceof i.$hM)return{type:"expression",range:m.from(J.range),expression:J.expression};throw new Error("Unknown 'InlineValue' type")}Se.from=Fe;function fe(J){switch(J.type){case"text":return{range:m.to(J.range),text:J.text};case"variable":return{range:m.to(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};case"expression":return{range:m.to(J.range),expression:J.expression}}}Se.to=fe})(te||(e.InlineValue=te={}));var Q;(function(Se){function Fe(J){return{frameId:J.frameId,stoppedLocation:m.from(J.stoppedLocation)}}Se.from=Fe;function fe(J){return new i.$iM(J.frameId,m.to(J.stoppedLocation))}Se.to=fe})(Q||(e.InlineValueContext=Q={}));var ee;(function(Se){function Fe(J){return{range:m.from(J.range),kind:J.kind}}Se.from=Fe;function fe(J){return new i.$lL(m.to(J.range),J.kind)}Se.to=fe})(ee||(e.DocumentHighlight=ee={}));var me;(function(Se){function Fe(J){return{uri:J.uri,highlights:J.highlights.map(ee.from)}}Se.from=Fe;function fe(J){return new i.$mL(p.URI.revive(J.uri),J.highlights.map(ee.to))}Se.to=fe})(me||(e.MultiDocumentHighlight=me={}));var pe;(function(Se){function Fe(fe){switch(fe){case 1:return i.CompletionTriggerKind.TriggerCharacter;case 2:return i.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return i.CompletionTriggerKind.Invoke}}Se.to=Fe})(pe||(e.CompletionTriggerKind=pe={}));var Ae;(function(Se){function Fe(fe){return{triggerKind:pe.to(fe.triggerKind),triggerCharacter:fe.triggerCharacter}}Se.to=Fe})(Ae||(e.CompletionContext=Ae={}));var he;(function(Se){function Fe(J){switch(J){case i.CompletionItemTag.Deprecated:return 1}}Se.from=Fe;function fe(J){switch(J){case 1:return i.CompletionItemTag.Deprecated}}Se.to=fe})(he||(e.CompletionItemTag=he={}));var ye;(function(Se){const Fe=new Map([[i.CompletionItemKind.Method,0],[i.CompletionItemKind.Function,1],[i.CompletionItemKind.Constructor,2],[i.CompletionItemKind.Field,3],[i.CompletionItemKind.Variable,4],[i.CompletionItemKind.Class,5],[i.CompletionItemKind.Interface,7],[i.CompletionItemKind.Struct,6],[i.CompletionItemKind.Module,8],[i.CompletionItemKind.Property,9],[i.CompletionItemKind.Unit,12],[i.CompletionItemKind.Value,13],[i.CompletionItemKind.Constant,14],[i.CompletionItemKind.Enum,15],[i.CompletionItemKind.EnumMember,16],[i.CompletionItemKind.Keyword,17],[i.CompletionItemKind.Snippet,27],[i.CompletionItemKind.Text,18],[i.CompletionItemKind.Color,19],[i.CompletionItemKind.File,20],[i.CompletionItemKind.Reference,21],[i.CompletionItemKind.Folder,23],[i.CompletionItemKind.Event,10],[i.CompletionItemKind.Operator,11],[i.CompletionItemKind.TypeParameter,24],[i.CompletionItemKind.Issue,26],[i.CompletionItemKind.User,25]]);function fe(Ue){return Fe.get(Ue)??9}Se.from=fe;const J=new Map([[0,i.CompletionItemKind.Method],[1,i.CompletionItemKind.Function],[2,i.CompletionItemKind.Constructor],[3,i.CompletionItemKind.Field],[4,i.CompletionItemKind.Variable],[5,i.CompletionItemKind.Class],[7,i.CompletionItemKind.Interface],[6,i.CompletionItemKind.Struct],[8,i.CompletionItemKind.Module],[9,i.CompletionItemKind.Property],[12,i.CompletionItemKind.Unit],[13,i.CompletionItemKind.Value],[14,i.CompletionItemKind.Constant],[15,i.CompletionItemKind.Enum],[16,i.CompletionItemKind.EnumMember],[17,i.CompletionItemKind.Keyword],[27,i.CompletionItemKind.Snippet],[18,i.CompletionItemKind.Text],[19,i.CompletionItemKind.Color],[20,i.CompletionItemKind.File],[21,i.CompletionItemKind.Reference],[23,i.CompletionItemKind.Folder],[10,i.CompletionItemKind.Event],[11,i.CompletionItemKind.Operator],[24,i.CompletionItemKind.TypeParameter],[25,i.CompletionItemKind.User],[26,i.CompletionItemKind.Issue]]);function Me(Ue){return J.get(Ue)??i.CompletionItemKind.Property}Se.to=Me})(ye||(e.CompletionItemKind=ye={}));var F;(function(Se){function Fe(fe,J){const Me=new i.$CL(fe.label);return Me.insertText=fe.insertText,Me.kind=ye.to(fe.kind),Me.tags=fe.tags?.map(he.to),Me.detail=fe.detail,Me.documentation=R.$jk(fe.documentation)?z.to(fe.documentation):fe.documentation,Me.sortText=fe.sortText,Me.filterText=fe.filterText,Me.preselect=fe.preselect,Me.commitCharacters=fe.commitCharacters,w.$Us.isIRange(fe.range)?Me.range=m.to(fe.range):typeof fe.range=="object"&&(Me.range={inserting:m.to(fe.range.insert),replacing:m.to(fe.range.replace)}),Me.keepWhitespace=typeof fe.insertTextRules>"u"?!1:!!(fe.insertTextRules&1),typeof fe.insertTextRules<"u"&&fe.insertTextRules&4?Me.insertText=new i.$gL(fe.insertText):(Me.insertText=fe.insertText,Me.textEdit=Me.range instanceof i.$0K?new i.$cL(Me.range,Me.insertText):void 0),fe.additionalTextEdits&&fe.additionalTextEdits.length>0&&(Me.additionalTextEdits=fe.additionalTextEdits.map(Ue=>ke.to(Ue))),Me.command=J&&fe.command?J.fromInternal(fe.command):void 0,Me}Se.to=Fe})(F||(e.CompletionItem=F={}));var q;(function(Se){function Fe(J){if(typeof J.label!="string"&&!Array.isArray(J.label))throw new TypeError("Invalid label");return{label:J.label,documentation:z.fromStrict(J.documentation)}}Se.from=Fe;function fe(J){return{label:J.label,documentation:R.$jk(J.documentation)?z.to(J.documentation):J.documentation}}Se.to=fe})(q||(e.ParameterInformation=q={}));var K;(function(Se){function Fe(J){return{label:J.label,documentation:z.fromStrict(J.documentation),parameters:Array.isArray(J.parameters)?J.parameters.map(q.from):[],activeParameter:J.activeParameter}}Se.from=Fe;function fe(J){return{label:J.label,documentation:R.$jk(J.documentation)?z.to(J.documentation):J.documentation,parameters:Array.isArray(J.parameters)?J.parameters.map(q.to):[],activeParameter:J.activeParameter}}Se.to=fe})(K||(e.SignatureInformation=K={}));var U;(function(Se){function Fe(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(K.from):[]}}Se.from=Fe;function fe(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(K.to):[]}}Se.to=fe})(U||(e.SignatureHelp=U={}));var X;(function(Se){function Fe(fe,J){const Me=new i.$BL(S.to(J.position),typeof J.label=="string"?J.label:J.label.map(x.to.bind(void 0,fe)),J.kind&&Ee.to(J.kind));return Me.textEdits=J.textEdits&&J.textEdits.map(ke.to),Me.tooltip=R.$jk(J.tooltip)?z.to(J.tooltip):J.tooltip,Me.paddingLeft=J.paddingLeft,Me.paddingRight=J.paddingRight,Me}Se.to=Fe})(X||(e.InlayHint=X={}));var x;(function(Se){function Fe(fe,J){const Me=new i.$AL(J.label);return Me.tooltip=R.$jk(J.tooltip)?z.to(J.tooltip):J.tooltip,s.Command.is(J.command)&&(Me.command=fe.fromInternal(J.command)),J.location&&(Me.location=Ie.to(J.location)),Me}Se.to=Fe})(x||(e.InlayHintLabelPart=x={}));var Ee;(function(Se){function Fe(J){return J}Se.from=Fe;function fe(J){return J}Se.to=fe})(Ee||(e.InlayHintKind=Ee={}));var Te;(function(Se){function Fe(J){return{range:m.from(J.range),url:J.target,tooltip:J.tooltip}}Se.from=Fe;function fe(J){let Me;if(J.url)try{Me=typeof J.url=="string"?p.URI.parse(J.url,!0):p.URI.revive(J.url)}catch{}return new i.$HL(m.to(J.range),Me)}Se.to=fe})(Te||(e.DocumentLink=Te={}));var Ve;(function(Se){function Fe(J){const Me=new i.$KL(J.label);return J.textEdit&&(Me.textEdit=ke.to(J.textEdit)),J.additionalTextEdits&&(Me.additionalTextEdits=J.additionalTextEdits.map(Ue=>ke.to(Ue))),Me}Se.to=Fe;function fe(J){return{label:J.label,textEdit:J.textEdit?ke.from(J.textEdit):void 0,additionalTextEdits:J.additionalTextEdits?J.additionalTextEdits.map(Me=>ke.from(Me)):void 0}}Se.from=fe})(Ve||(e.ColorPresentation=Ve={}));var He;(function(Se){function Fe(J){return new i.$IL(J[0],J[1],J[2],J[3])}Se.to=Fe;function fe(J){return[J.red,J.green,J.blue,J.alpha]}Se.from=fe})(He||(e.Color=He={}));var Ye;(function(Se){function Fe(J){return{range:m.from(J.range)}}Se.from=Fe;function fe(J){return new i.$rL(m.to(J.range))}Se.to=fe})(Ye||(e.SelectionRange=Ye={}));var st;(function(Se){function Fe(fe){switch(fe){case 2:return i.TextDocumentSaveReason.AfterDelay;case 1:return i.TextDocumentSaveReason.Manual;case 3:case 4:return i.TextDocumentSaveReason.FocusOut}}Se.to=Fe})(st||(e.TextDocumentSaveReason=st={}));var nt;(function(Se){function Fe(J){switch(J){case i.TextEditorLineNumbersStyle.Off:return 0;case i.TextEditorLineNumbersStyle.Relative:return 2;case i.TextEditorLineNumbersStyle.On:default:return 1}}Se.from=Fe;function fe(J){switch(J){case 0:return i.TextEditorLineNumbersStyle.Off;case 2:return i.TextEditorLineNumbersStyle.Relative;case 1:default:return i.TextEditorLineNumbersStyle.On}}Se.to=fe})(nt||(e.TextEditorLineNumbersStyle=nt={}));var tt;(function(Se){function Fe(J){if(J===i.EndOfLine.CRLF)return 1;if(J===i.EndOfLine.LF)return 0}Se.from=Fe;function fe(J){if(J===1)return i.EndOfLine.CRLF;if(J===0)return i.EndOfLine.LF}Se.to=fe})(tt||(e.EndOfLine=tt={}));var at;(function(Se){function Fe(fe){if(typeof fe=="object")return fe.viewId;switch(fe){case i.ProgressLocation.SourceControl:return 3;case i.ProgressLocation.Window:return 10;case i.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Se.from=Fe})(at||(e.ProgressLocation=at={}));var ct;(function(Se){function Fe(J){const Me={start:J.start+1,end:J.end+1};return J.kind&&(Me.kind=je.from(J.kind)),Me}Se.from=Fe;function fe(J){const Me={start:J.start-1,end:J.end-1};return J.kind&&(Me.kind=je.to(J.kind)),Me}Se.to=fe})(ct||(e.FoldingRange=ct={}));var je;(function(Se){function Fe(J){if(J)switch(J){case i.FoldingRangeKind.Comment:return s.$Kt.Comment;case i.FoldingRangeKind.Imports:return s.$Kt.Imports;case i.FoldingRangeKind.Region:return s.$Kt.Region}}Se.from=Fe;function fe(J){if(J)switch(J.value){case s.$Kt.Comment.value:return i.FoldingRangeKind.Comment;case s.$Kt.Imports.value:return i.FoldingRangeKind.Imports;case s.$Kt.Region.value:return i.FoldingRangeKind.Region}}Se.to=fe})(je||(e.FoldingRangeKind=je={}));var vt;(function(Se){function Fe(fe){if(fe)return{pinned:typeof fe.preview=="boolean"?!fe.preview:void 0,inactive:fe.background,preserveFocus:fe.preserveFocus,selection:typeof fe.selection=="object"?m.from(fe.selection):void 0,override:typeof fe.override=="boolean"?n.$EE.id:void 0}}Se.from=Fe})(vt||(e.TextEditorOpenOptions=vt={}));var Z;(function(Se){function Fe(Ue){return Ue instanceof i.$5L?Ue.toJSON():typeof Ue=="string"?Ue:fe(Ue)||J(Ue)?new i.$5L(Ue.baseUri??Ue.base,Ue.pattern).toJSON():Ue}Se.from=Fe;function fe(Ue){const Xe=Ue;return Xe?p.URI.isUri(Xe.baseUri)&&typeof Xe.pattern=="string":!1}function J(Ue){const Xe=Ue;return Xe?typeof Xe.base=="string"&&typeof Xe.pattern=="string":!1}function Me(Ue){return typeof Ue=="string"?Ue:new i.$5L(p.URI.revive(Ue.baseUri),Ue.pattern)}Se.to=Me})(Z||(e.GlobPattern=Z={}));var _;(function(Se){function Fe(fe){if(fe){if(Array.isArray(fe))return fe.map(Fe);if(typeof fe=="string")return fe;{const J=fe;return{language:J.language,scheme:J.scheme,pattern:Z.from(J.pattern),exclusive:J.exclusive,notebookType:J.notebookType}}}else return}Se.from=Fe})(_||(e.LanguageSelector=_={}));var $e;(function(Se){function Fe(J){return!!J&&typeof J=="object"&&"documents"in J&&Array.isArray(J.documents)&&J.documents.every(Me=>Array.isArray(Me)&&Me.every(Ue=>Ue&&typeof Ue=="object"&&"uri"in Ue&&p.URI.isUri(Ue.uri)&&"version"in Ue&&typeof Ue.version=="number"&&"ranges"in Ue&&Array.isArray(Ue.ranges)&&Ue.ranges.every(Xe=>Xe instanceof i.$0K)))}Se.is=Fe;function fe(J){return{documents:J.documents.map(Me=>Me.map(Ue=>({uri:p.URI.from(Ue.uri),version:Ue.version,ranges:Ue.ranges.map(Xe=>m.from(Xe))})))}}Se.from=fe})($e||(e.MappedEditsContext=$e={}));var Be;(function(Se){function Fe(J){return{start:J.start,end:J.end}}Se.from=Fe;function fe(J){return new i.$tM(J.start,J.end)}Se.to=fe})(Be||(e.NotebookRange=Be={}));var Qe;(function(Se){function Fe(J){return{timing:typeof J.runStartTime=="number"&&typeof J.runEndTime=="number"?{startTime:J.runStartTime,endTime:J.runEndTime}:void 0,executionOrder:J.executionOrder,success:J.lastRunSuccess}}Se.to=Fe;function fe(J){return{lastRunSuccess:J.success,runStartTime:J.timing?.startTime,runEndTime:J.timing?.endTime,executionOrder:J.executionOrder}}Se.from=fe})(Qe||(e.NotebookCellExecutionSummary=Qe={}));var it;(function(Se){function Fe(fe){if(fe===o.NotebookCellExecutionState.Unconfirmed)return i.NotebookCellExecutionState.Pending;if(fe===o.NotebookCellExecutionState.Pending)return;if(fe===o.NotebookCellExecutionState.Executing)return i.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${fe}`)}Se.to=Fe})(it||(e.NotebookCellExecutionState=it={}));var rt;(function(Se){function Fe(J){switch(J){case i.NotebookCellKind.Markup:return o.CellKind.Markup;case i.NotebookCellKind.Code:default:return o.CellKind.Code}}Se.from=Fe;function fe(J){switch(J){case o.CellKind.Markup:return i.NotebookCellKind.Markup;case o.CellKind.Code:default:return i.NotebookCellKind.Code}}Se.to=fe})(rt||(e.NotebookCellKind=rt={}));var Ne;(function(Se){function Fe(J){const Me={metadata:J.metadata??Object.create(null),cells:[]};for(const Ue of J.cells)i.$uM.validate(Ue),Me.cells.push(Pt.from(Ue));return Me}Se.from=Fe;function fe(J){const Me=new i.$vM(J.cells.map(Pt.to));return(0,l.$Vf)(J.metadata)||(Me.metadata=J.metadata),Me}Se.to=fe})(Ne||(e.NotebookData=Ne={}));var Pt;(function(Se){function Fe(J){return{cellKind:rt.from(J.kind),language:J.languageId,mime:J.mime,source:J.value,metadata:J.metadata,internalMetadata:Qe.from(J.executionSummary??{}),outputs:J.outputs?J.outputs.map(Ht.from):[]}}Se.from=Fe;function fe(J){return new i.$uM(rt.to(J.cellKind),J.source,J.language,J.mime,J.outputs?J.outputs.map(Ht.to):void 0,J.metadata,J.internalMetadata?Qe.to(J.internalMetadata):void 0)}Se.to=fe})(Pt||(e.NotebookCellData=Pt={}));var Tt;(function(Se){function Fe(J){return{mime:J.mime,valueBytes:T.$je.wrap(J.data)}}Se.from=Fe;function fe(J){return new i.$wM(J.valueBytes.buffer,J.mime)}Se.to=fe})(Tt||(e.NotebookCellOutputItem=Tt={}));var Ht;(function(Se){function Fe(J){return{outputId:J.id,items:J.items.map(Tt.from),metadata:J.metadata}}Se.from=Fe;function fe(J){const Me=J.items.map(Tt.to);return new i.$xM(Me,J.outputId,J.metadata)}Se.to=fe})(Ht||(e.NotebookCellOutput=Ht={}));var Bt;(function(Se){function Fe(Me){return J(Me)?{include:Z.from(Me.include)??void 0,exclude:Z.from(Me.exclude)??void 0}:Z.from(Me)??void 0}Se.from=Fe;function fe(Me){return J(Me)?{include:Z.to(Me.include),exclude:Z.to(Me.exclude)}:Z.to(Me)}Se.to=fe;function J(Me){const Ue=Me;return Ue?!(0,l.$Rf)(Ue.include)&&!(0,l.$Rf)(Ue.exclude):!1}})(Bt||(e.NotebookExclusiveDocumentPattern=Bt={}));var yt;(function(Se){function Fe(fe,J,Me){const Ue=typeof fe.command=="string"?{title:"",command:fe.command}:fe.command;return{alignment:fe.alignment===i.NotebookCellStatusBarAlignment.Left?1:2,command:J.toInternal(Ue,Me),text:fe.text,tooltip:fe.tooltip,accessibilityInformation:fe.accessibilityInformation,priority:fe.priority}}Se.from=Fe})(yt||(e.NotebookStatusBarItem=yt={}));var Kt;(function(Se){function Fe(fe,J,Me){const Ue=typeof fe.command=="string"?{title:"",command:fe.command}:fe.command;return{command:J.toInternal(Ue,Me),label:fe.label,description:fe.description,detail:fe.detail,documentation:fe.documentation}}Se.from=Fe})(Kt||(e.NotebookKernelSourceAction=Kt={}));var Nt;(function(Se){function Fe(fe){return{transientOutputs:fe?.transientOutputs??!1,transientCellMetadata:fe?.transientCellMetadata??{},transientDocumentMetadata:fe?.transientDocumentMetadata??{},cellContentMetadata:fe?.cellContentMetadata??{}}}Se.from=Fe})(Nt||(e.NotebookDocumentContentOptions=Nt={}));var Xt;(function(Se){function Fe(J){return{uri:J.uri,provides:J.provides}}Se.from=Fe;function fe(J){return new i.$zM(p.URI.revive(J.uri),J.provides)}Se.to=fe})(Xt||(e.NotebookRendererScript=Xt={}));var zt;(function(Se){function Fe(J){return{message:z.fromStrict(J.message)||"",type:0,expected:J.expectedOutput,actual:J.actualOutput,contextValue:J.contextValue,location:J.location&&{range:m.from(J.location.range),uri:J.location.uri}}}Se.from=Fe;function fe(J){const Me=new i.$FM(typeof J.message=="string"?J.message:z.to(J.message));return Me.actualOutput=J.actual,Me.expectedOutput=J.expected,Me.contextValue=J.contextValue,Me.location=J.location?Ie.to(J.location):void 0,Me}Se.to=fe})(zt||(e.TestMessage=zt={}));var Rt;(function(Se){Se.namespace=h.$2J,Se.denamespace=h.$3J})(Rt||(e.TestTag=Rt={}));var Ze;(function(Se){function Fe(J){const Me=(0,r.$6M)(J).controllerId;return{extId:c.$XJ.fromExtHostTestItem(J,Me).toString(),label:J.label,uri:p.URI.revive(J.uri),busy:J.busy,tags:J.tags.map(Ue=>Rt.namespace(Me,Ue.id)),range:w.$Us.lift(m.from(J.range)),description:J.description||null,sortText:J.sortText||null,error:J.error&&z.fromStrict(J.error)||null}}Se.from=Fe;function fe(J){return{parent:void 0,error:void 0,id:c.$XJ.fromString(J.extId).localId,label:J.label,uri:p.URI.revive(J.uri),tags:(J.tags||[]).map(Me=>{const{tagId:Ue}=Rt.denamespace(Me);return new i.$GM(Ue)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:m.to(J.range||void 0),canResolveChildren:!1,busy:J.busy,description:J.description||void 0,sortText:J.sortText||void 0}}Se.toPlain=fe})(Ze||(e.TestItem=Ze={})),function(Se){function Fe(J){return{id:J.id}}Se.from=Fe;function fe(J){return new i.$GM(J.id)}Se.to=fe}(Rt||(e.TestTag=Rt={}));var Gt;(function(Se){const Fe=(J,Me)=>{const Ue=[];for(const[We,_e]of Me)c.$XJ.compare(_e.item.extId,We)===2&&(Me.delete(We),Ue.push(_e));const Xe={...Ze.toPlain(J.item),parent:void 0,taskStates:J.tasks.map(We=>({state:We.state,duration:We.duration,messages:We.messages.filter(_e=>_e.type===0).map(zt.to)})),children:Ue.map(We=>Fe(We,Me))};for(const We of Xe.children)We.parent=Xe;return Xe};function fe(J){const Me=[],Ue=new Map;for(const Xe of J.items){Ue.set(Xe.item.extId,Xe);const We=c.$XJ.root(Xe.item.extId);J.request.targets.some(_e=>_e.controllerId===We&&_e.testIds.includes(Xe.item.extId))&&Me.push(Xe)}return{completedAt:J.completedAt,results:Me.map(Xe=>Fe(Xe,Ue))}}Se.to=fe})(Gt||(e.TestResults=Gt={}));var Jt;(function(Se){function Fe(Ue){return{covered:Ue.covered,total:Ue.total}}function fe(Ue){return"line"in Ue?S.from(Ue):m.from(Ue)}function J(Ue){return"branches"in Ue?{count:Ue.executionCount,location:fe(Ue.location),type:1,branches:Ue.branches.length?Ue.branches.map(Xe=>({count:Xe.executionCount,location:Xe.location&&fe(Xe.location),label:Xe.label})):void 0}:{type:0,name:Ue.name,count:Ue.executionCount,location:fe(Ue.location)}}Se.fromDetailed=J;function Me(Ue){return{uri:Ue.uri,statement:Fe(Ue.statementCoverage),branch:Ue.branchCoverage&&Fe(Ue.branchCoverage),function:Ue.functionCoverage&&Fe(Ue.functionCoverage),details:Ue.detailedCoverage?.map(J)}}Se.fromFile=Me})(Jt||(e.TestCoverage=Jt={}));var lt;(function(Se){function Fe(fe){switch(fe){case 1:return i.CodeActionTriggerKind.Invoke;case 2:return i.CodeActionTriggerKind.Automatic}}Se.to=Fe})(lt||(e.CodeActionTriggerKind=lt={}));var $t;(function(Se){function Fe(J){const Me=new i.$MM(ve.to(J.kind),J.name,J.detail||"",p.URI.revive(J.uri),m.to(J.range),m.to(J.selectionRange));return Me._sessionId=J._sessionId,Me._itemId=J._itemId,Me}Se.to=Fe;function fe(J,Me,Ue){if(Me=Me??J._sessionId,Ue=Ue??J._itemId,Me===void 0||Ue===void 0)throw new Error("invalid item");return{_sessionId:Me,_itemId:Ue,kind:ve.from(J.kind),name:J.name,detail:J.detail??"",uri:J.uri,range:m.from(J.range),selectionRange:m.from(J.selectionRange),tags:J.tags?.map(se.from)}}Se.from=fe})($t||(e.TypeHierarchyItem=$t={}));var jt;(function(Se){function Fe(fe){if(fe)return{value:fe.value,tooltip:fe.tooltip}}Se.from=Fe})(jt||(e.ViewBadge=jt={}));var Vt;(function(Se){function Fe(Ue,Xe,We){const _e=Xe.fileData;return _e?new i.$XL(new i.$YL(_e.name,p.URI.revive(_e.uri),_e.id,(0,L.$db)(()=>We(_e.id)))):Ue===A.$fs.uriList&&Xe.uriListData?new i.$WL(Me(Xe.uriListData)):new i.$WL(Xe.asString)}Se.to=Fe;async function fe(Ue,Xe){const We=await Xe.asString();if(Ue===A.$fs.uriList)return{asString:We,fileData:void 0,uriListData:J(We)};const _e=Xe.asFile();return{asString:We,fileData:_e?{name:_e.name,uri:_e.uri,id:_e._itemId??_e.id}:void 0}}Se.from=fe;function J(Ue){return C.$rt.split(Ue).map(Xe=>{if(Xe.startsWith("#"))return Xe;try{return p.URI.parse(Xe)}catch{}return Xe})}function Me(Ue){return C.$rt.create(Ue.map(Xe=>typeof Xe=="string"?Xe:p.URI.revive(Xe)))}})(Vt||(e.DataTransferItem=Vt={}));var kt;(function(Se){function Fe(J,Me){const Ue=J.items.map(([Xe,We])=>[Xe,Vt.to(Xe,We,Me)]);return new i.$ZL(Ue)}Se.toDataTransfer=Fe;async function fe(J){const Me={items:[]},Ue=[];for(const[Xe,We]of J)Ue.push((async()=>{Me.items.push([Xe,await Vt.from(Xe,We)])})());return await Promise.all(Ue),Me}Se.from=fe})(kt||(e.DataTransfer=kt={}));var dt;(function(Se){function Fe(fe){return{kind:"reply",message:fe.message,title:fe.title,tooltip:fe.tooltip}}Se.from=Fe})(dt||(e.ChatReplyFollowup=dt={}));var Ct;(function(Se){function Fe(fe){return typeof fe=="string"?{title:fe,message:fe,kind:"reply"}:"commandId"in fe?{kind:"command",title:fe.title??"",commandId:fe.commandId??"",when:fe.when??"",args:fe.args}:dt.from(fe)}Se.from=Fe})(Ct||(e.ChatFollowup=Ct={}));var xt;(function(Se){function Fe(J){const Me=new i.$YM(Dt.to(J.role),J.content);return Me.name=J.name,Me}Se.to=Fe;function fe(J){return{role:Dt.from(J.role),content:J.content,name:J.name}}Se.from=fe})(xt||(e.ChatMessage=xt={}));var Dt;(function(Se){function Fe(J){switch(J){case 0:return i.ChatMessageRole.System;case 1:return i.ChatMessageRole.User;case 2:return i.ChatMessageRole.Assistant;case 3:return i.ChatMessageRole.Function}}Se.to=Fe;function fe(J){switch(J){case i.ChatMessageRole.System:return 0;case i.ChatMessageRole.Assistant:return 2;case i.ChatMessageRole.Function:return 3;case i.ChatMessageRole.User:default:return 1}}Se.from=fe})(Dt||(e.ChatMessageRole=Dt={}));var qe;(function(Se){function Fe(Me){const Ue={};for(const Xe of Object.keys(Me))Ue[Xe]=Me[Xe].map(Se.to);return Ue}Se.objectTo=Fe;function fe(Me){return{level:Mt.to(Me.level),kind:Me.kind,value:(0,p.$vc)(Me.value)?p.URI.revive(Me.value):Me.value,description:Me.description}}Se.to=fe;function J(Me){return{level:Mt.from(Me.level),kind:Me.kind,value:Me.value,description:Me.description}}Se.from=J})(qe||(e.ChatVariable=qe={}));var Mt;(function(Se){function Fe(J){switch(J){case"short":return i.ChatVariableLevel.Short;case"medium":return i.ChatVariableLevel.Medium;case"full":default:return i.ChatVariableLevel.Full}}Se.to=Fe;function fe(J){switch(J){case i.ChatVariableLevel.Short:return"short";case i.ChatVariableLevel.Medium:return"medium";case i.ChatVariableLevel.Full:default:return"full"}}Se.from=fe})(Mt||(e.ChatVariableLevel=Mt={}));var Wt;(function(Se){function Fe(fe){switch(fe){case 1:return i.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return i.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return i.InteractiveEditorResponseFeedbackKind.Undone;case 3:return i.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return i.InteractiveEditorResponseFeedbackKind.Bug}}Se.to=Fe})(Wt||(e.InteractiveEditorResponseFeedbackKind=Wt={}));var Qt;(function(Se){function Fe(fe,J){return"placeholder"in J&&"resolvedContent"in J?{content:J.placeholder,kind:"asyncContent"}:"markdownContent"in J?((0,u.$CF)(fe,"chatAgents2Additions"),{content:z.from(J.markdownContent),kind:"markdownContent"}):"content"in J?"vulnerabilities"in J&&J.vulnerabilities?((0,u.$CF)(fe,"chatAgents2Additions"),{content:J.content,vulnerabilities:J.vulnerabilities,kind:"vulnerability"}):typeof J.content=="string"?{content:J.content,kind:"content"}:((0,u.$CF)(fe,"chatAgents2Additions"),{content:z.from(J.content),kind:"markdownContent"}):"documents"in J?{documents:J.documents.map(Me=>({uri:Me.uri,version:Me.version,ranges:Me.ranges.map(Ue=>m.from(Ue))})),kind:"usedContext"}:"reference"in J?{reference:"uri"in J.reference?{uri:J.reference.uri,range:m.from(J.reference.range)}:J.reference,kind:"reference"}:"inlineReference"in J?{inlineReference:"uri"in J.inlineReference?{uri:J.inlineReference.uri,range:m.from(J.inlineReference.range)}:J.inlineReference,name:J.title,kind:"inlineReference"}:"agentName"in J?((0,u.$CF)(fe,"chatAgents2Additions"),{agentName:J.agentName,command:J.command,kind:"agentDetection"}):"treeData"in J?{treeData:J.treeData,kind:"treeData"}:"message"in J?{content:z.from(J.message),kind:"progressMessage"}:void 0}Se.from=Fe})(Qt||(e.ChatResponseProgress=Qt={}));var ft;(function(Se){function Fe(fe){return{label:fe.label,values:fe.values.map(qe.from),insertText:fe.insertText,detail:fe.detail,documentation:fe.documentation}}Se.from=Fe})(ft||(e.ChatAgentCompletionItem=ft={}));var Ft;(function(Se){function Fe(fe,J,Me){return"terminalCommand"in fe?{terminalCommand:fe.terminalCommand,shouldExecute:fe.shouldExecute}:"uri"in fe?{uri:fe.uri}:J.toInternal(fe,Me)}Se.from=Fe})(Ft||(e.TerminalQuickFix=Ft={}))}),define(Pe[219],Re([1,0,2,15,7,8,185]),function(ge,e,y,T,C,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ghc=void 0;class ${constructor(b,A,k,l={timeout:1500,errors:3}){this.c=b,this.d=A,this.f=k,this.g=l,this.a=new R.$4c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(b){return(A,k,l)=>{const w={dispose:this.a.push([A,k,b])};return Array.isArray(l)&&l.push(w),w}}async $participateInSave(b,A){const k=y.URI.revive(b);let l=!1;const p=setTimeout(()=>l=!0,this.g.timeout),w=[];try{for(const s of[...this.a]){if(l)break;const a=this.d.getDocument(k),r=await this.h(s,{document:a,reason:L.TextDocumentSaveReason.to(A)});w.push(r)}}finally{clearTimeout(p)}return w}h([b,A,k],l){const p=this.b.get(b);return typeof p=="number"&&p>this.g.errors?Promise.resolve(!1):this.i(k,b,A,l).then(()=>!0,w=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' threw ERROR`),this.c.error(w),!(w instanceof Error)||w.message!=="concurrent_edits"){const s=this.b.get(b);this.b.set(b,s?s+1:1),typeof s=="number"&&s>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(b,A,k,l){const p=[],w=Date.now(),{document:s,reason:a}=l,{version:r}=s,n=Object.freeze({document:s,reason:a,waitUntil(o){if(Object.isFrozen(p))throw(0,T.$8)("waitUntil can not be called async");p.push(Promise.resolve(o))}});try{A.apply(k,[n])}catch(o){return Promise.reject(o)}return Object.freeze(p),new Promise((o,c)=>{const h=setTimeout(()=>c(new Error("timeout")),this.g.timeout);return Promise.all(p).then(t=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${b.identifier.value}' finished after ${Date.now()-w}ms`),clearTimeout(h),o(t)}).catch(t=>{clearTimeout(h),c(t)})}).then(o=>{const c={edits:[]};for(const h of o)if(Array.isArray(h)&&h.every(t=>t instanceof C.$cL))for(const{newText:t,newEol:u,range:i}of h)c.edits.push({resource:s.uri,versionId:void 0,textEdit:{range:i&&L.Range.from(i),text:t,eol:u&&L.EndOfLine.from(u)}});if(c.edits.length!==0)return r===s.version?this.f.$tryApplyWorkspaceEdit(c):Promise.reject(new Error("concurrent_edits"))})}}e.$ghc=$}),define(Pe[220],Re([1,0,12,2,8,7,76]),function(ge,e,y,T,C,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mhc=e.$lhc=void 0;class ${constructor(k,l,p,w){this.start=k,this.deletedCount=l,this.deletedItems=p,this.items=w}asApiEvent(){return{range:new L.$tM(this.start,this.start+this.deletedCount),addedCells:this.items.map(k=>k.apiCell),removedCells:this.deletedItems}}}class f{static asModelAddData(k,l){return{EOL:l.eol,lines:l.source,languageId:l.language,uri:l.uri,isDirty:!1,versionId:1,notebook:k}}constructor(k,l,p){this.notebook=k,this.h=l,this.j=p,this.handle=p.handle,this.uri=T.URI.revive(p.uri),this.cellKind=p.cellKind,this.a=p.outputs.map(C.NotebookCellOutput.to),this.e=p.internalMetadata??{},this.b=Object.freeze(p.metadata??{}),this.d=Object.freeze(C.NotebookCellExecutionSummary.to(p.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const k=this,l=this.h.getDocument(this.uri);if(!l)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const p={get index(){return k.notebook.getCellIndex(k)},notebook:k.notebook.apiNotebook,kind:C.NotebookCellKind.to(this.j.cellKind),document:l.document,get mime(){return k.g},set mime(w){k.g=w},get outputs(){return k.a.slice(0)},get metadata(){return k.b},get executionSummary(){return k.d}};this.f=Object.freeze(p)}return this.f}setOutputs(k){this.a=k.map(C.NotebookCellOutput.to)}setOutputItems(k,l,p){const w=p.map(C.NotebookCellOutputItem.to),s=this.a.find(a=>a.id===k);if(s&&(l||(s.items.length=0),s.items.push(...w),s.items.length>1&&s.items.every(a=>R.$0I(a.mime)))){const a=new Map,r=[];s.items.forEach(n=>{let o;a.has(n.mime)?o=a.get(n.mime):(o=[],a.set(n.mime,o),r.push(n.mime)),o.push(n.data)}),s.items.length=0,r.forEach(n=>{const o=R.$$I(a.get(n));s.items.push({mime:n,data:o.data.buffer})})}}setMetadata(k){this.b=Object.freeze(k)}setInternalMetadata(k){this.e=k,this.d=Object.freeze(C.NotebookCellExecutionSummary.to(k))}setMime(k){}}e.$lhc=f;class b{static{this.a=0}constructor(k,l,p,w,s){this.k=k,this.l=l,this.m=p,this.uri=w,this.handle=b.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=s.viewType,this.f=Object.freeze(s.metadata??Object.create(null)),this.r([[0,0,s.cells]],!0,void 0),this.g=s.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const k=this,l={get uri(){return k.uri},get version(){return k.g},get notebookType(){return k.d},get isDirty(){return k.h},get isUntitled(){return k.uri.scheme===y.Schemas.untitled},get isClosed(){return k.j},get metadata(){return k.f},get cellCount(){return k.b.length},cellAt(p){return p=k.n(p),k.b[p].apiCell},getCells(p){return(p?k.p(p):k.b).map(s=>s.apiCell)},save(){return k.q()}};this.e=Object.freeze(l)}return this.e}acceptDocumentPropertiesChanged(k){k.metadata&&(this.f=Object.freeze({...this.f,...k.metadata}))}acceptDirty(k){this.h=k}acceptModelChanged(k,l,p){this.g=k.versionId,this.h=l,this.acceptDocumentPropertiesChanged({metadata:p});const w={notebook:this.apiNotebook,metadata:p,cellChanges:[],contentChanges:[]},s=[];for(const r of k.rawEvents)r.kind===R.NotebookCellsChangeType.ModelChange?this.r(r.changes,!1,w.contentChanges):r.kind===R.NotebookCellsChangeType.Move?this.s(r.index,r.length,r.newIdx,w.contentChanges):r.kind===R.NotebookCellsChangeType.Output?(this.t(r.index,r.outputs),s.push({cell:this.b[r.index].apiCell,outputs:this.b[r.index].apiCell.outputs})):r.kind===R.NotebookCellsChangeType.OutputItem?(this.u(r.index,r.outputId,r.append,r.outputItems),s.push({cell:this.b[r.index].apiCell,outputs:this.b[r.index].apiCell.outputs})):r.kind===R.NotebookCellsChangeType.ChangeCellLanguage?(this.v(r.index,r.language),s.push({cell:this.b[r.index].apiCell,document:this.b[r.index].apiCell.document})):r.kind===R.NotebookCellsChangeType.ChangeCellContent?s.push({cell:this.b[r.index].apiCell,document:this.b[r.index].apiCell.document}):r.kind===R.NotebookCellsChangeType.ChangeCellMime?this.w(r.index,r.mime):r.kind===R.NotebookCellsChangeType.ChangeCellMetadata?(this.x(r.index,r.metadata),s.push({cell:this.b[r.index].apiCell,metadata:this.b[r.index].apiCell.metadata})):r.kind===R.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(r.index,r.internalMetadata),s.push({cell:this.b[r.index].apiCell,executionSummary:this.b[r.index].apiCell.executionSummary}));const a=new Map;for(let r=0;r<s.length;r++){const n=s[r],o=a.get(n.cell);if(o===void 0){const c=w.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...n});a.set(n.cell,c-1)}else w.cellChanges[o]={...w.cellChanges[o],...n}}return Object.freeze(w),Object.freeze(w.cellChanges),Object.freeze(w.contentChanges),w}n(k){return k=k|0,k<0?0:k>=this.b.length?this.b.length-1:k}o(k){let l=k.start|0,p=k.end|0;return l<0&&(l=0),p>this.b.length&&(p=this.b.length),k.with({start:l,end:p})}p(k){k=this.o(k);const l=[];for(let p=k.start;p<k.end;p++)l.push(this.b[p]);return l}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(k,l,p){if(this.j)return;const w=[],s=[],a=[];if(k.reverse().forEach(r=>{const o=r[2].map(t=>{const u=new f(this,this.l,t);return l||s.push(f.asModelAddData(this.apiNotebook,t)),u}),c=new $(r[0],r[1],[],o),h=this.b.splice(r[0],r[1],...o);for(const t of h)a.push(t.uri),c.deletedItems.push(t.apiCell);w.push(c)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:s,removedDocuments:a}),p)for(const r of w)p.push(r.asApiEvent())}s(k,l,p,w){const s=this.b.splice(k,l);this.b.splice(p,0,...s);const a=[new $(k,l,s.map(r=>r.apiCell),[]),new $(p,0,[],s)];for(const r of a)w.push(r.asApiEvent())}t(k,l){this.b[k].setOutputs(l)}u(k,l,p,w){this.b[k].setOutputItems(l,p,w)}v(k,l){const p=this.b[k];p.apiCell.document.languageId!==l&&this.m.$acceptModelLanguageChanged(p.uri,l)}w(k,l){const p=this.b[k];p.apiCell.mime=l}x(k,l){this.b[k].setMetadata(l)}y(k,l){this.b[k].setInternalMetadata(l)}getCellFromApiCell(k){return this.b.find(l=>l.apiCell===k)}getCellFromIndex(k){return this.b[k]}getCell(k){return this.b.find(l=>l.handle===k)}getCellIndex(k){return this.b.indexOf(k)}}e.$mhc=b}),define(Pe[221],Re([1,0,5,2,8,7]),function(ge,e,y,T,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Chc=void 0;class R{constructor(f,b,A,k={timeout:1500,errors:3}){this.b=f,this.c=b,this.d=A,this.f=k,this.a=new y.$Xd}dispose(){}getOnWillSaveNotebookDocumentEvent(f){return(b,A,k)=>{const l=function(w){b.call(A,w)};return l.extension=f,this.a.event(l,void 0,k)}}async $participateInSave(f,b,A){const k=T.URI.revive(f),l=this.c.getNotebookDocument(k);if(!l)throw new Error("Unable to resolve notebook document");const p=[];if(await this.a.fireAsync({notebook:l.apiNotebook,reason:C.TextDocumentSaveReason.to(b)},A,async(s,a)=>{const r=Date.now(),n=await await Promise.resolve(s);Date.now()-r>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",a.extension.identifier),!A.isCancellationRequested&&n&&(n instanceof L.$fL?p.push(n):this.b.warn("onWillSaveNotebookDocument-listener from extension",a.extension.identifier,"ignored due to invalid data"))}),A.isCancellationRequested)return!1;if(p.length===0)return!0;const w={edits:[]};for(const s of p){const{edits:a}=C.WorkspaceEdit.from(s);w.edits=w.edits.concat(a)}return this.d.$tryApplyWorkspaceEdit(w)}}e.$Chc=R}),define(Pe[107],Re([1,0,15,8,7]),function(ge,e,y,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nhc=void 0;class L{static{this.apiEditorsToExtHost=new WeakMap}constructor($,f,b,A,k,l){this.id=$,this.f=f,this.notebookData=b,this.a=[],this.b=[],this.d=!1,this.a=k,this.b=A,this.c=l}get apiEditor(){if(!this.e){const $=this;this.e={get notebook(){return $.notebookData.apiNotebook},get selection(){return $.a[0]},set selection(f){this.selections=[f]},get selections(){return $.a},set selections(f){if(!Array.isArray(f)||!f.every(C.$tM.isNotebookRange))throw(0,y.$7)("selections");$.a=f,$.g(f)},get visibleRanges(){return $.b},revealRange(f,b){$.f.$tryRevealRange($.id,T.NotebookRange.from(f),b??C.NotebookEditorRevealType.Default)},get viewColumn(){return $.c}},L.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility($){this.d=$}_acceptVisibleRanges($){this.b=$}_acceptSelections($){this.a=$}g($){this.f.$trySetSelections(this.id,$.map(T.NotebookRange.from))}_acceptViewColumn($){this.c=$}}e.$nhc=L}),define(Pe[222],Re([1,0,5,14,8]),function(ge,e,y,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ehc=void 0;let L=class{constructor($,f){this.c=$,this.d=f,this.a=new y.$Vd,this.b=new y.$Vd,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged($,f){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",$,f);const b=this.d.getEditorById($);f.visibleRanges&&b._acceptVisibleRanges(f.visibleRanges.ranges.map(C.NotebookRange.to)),f.selections&&b._acceptSelections(f.selections.selections.map(C.NotebookRange.to)),f.visibleRanges&&this.b.fire({notebookEditor:b.apiEditor,visibleRanges:b.apiEditor.visibleRanges}),f.selections&&this.a.fire(Object.freeze({notebookEditor:b.apiEditor,selections:b.apiEditor.selections}))}$acceptEditorViewColumns($){for(const f in $)this.d.getEditorById(f)._acceptViewColumn(C.ViewColumn.to($[f]))}};e.$Ehc=L,e.$Ehc=L=Je([Ke(0,T.$nj)],L)}),define(Pe[223],Re([1,0,8,72,20,66,15]),function(ge,e,y,T,C,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lhc=void 0;class ${constructor(k){this.b=0,this.c=new Map,this.a=k}async withProgress(k,l,p){const w=this.b++,{title:s,location:a,cancellable:r}=l,n={label:k.displayName||k.name,id:k.identifier.value};return this.a.$startProgress(w,{location:y.ProgressLocation.from(a),title:s,source:n,cancellable:r},k.isUnderDevelopment?void 0:k.identifier.value).catch(R.$2),this.d(w,p,!!r)}d(k,l,p){let w;p&&(w=new C.$6d,this.c.set(k,w));const s=r=>{this.a.$progressEnd(r),this.c.delete(r),w?.dispose()};let a;try{a=l(new b(this.a,k),p&&w?w.token:C.CancellationToken.None)}catch(r){throw s(k),r}return a.then(r=>s(k),r=>s(k)),a}$acceptProgressCanceled(k){const l=this.c.get(k);l&&(l.cancel(),this.c.delete(k))}}e.$Lhc=$;function f(A,k){return A.message=k.message,typeof k.increment=="number"&&(typeof A.increment=="number"?A.increment+=k.increment:A.increment=k.increment),A}class b extends T.$vv{constructor(k,l){super(p=>this.throttledReport(p)),this.c=k,this.d=l}throttledReport(k){this.c.$progressReport(this.d,k)}}Je([(0,L.$zh)(100,(A,k)=>f(A,k),()=>Object.create(null))],b.prototype,"throttledReport",null)}),define(Pe[108],Re([1,0,29,104,48,77,58,8,2]),function(ge,e,y,T,C,L,R,$,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mN=e.$lN=e.$kN=e.$jN=void 0;const b=(o,c,h,t)=>{let u=c;return{enumerable:!0,configurable:!1,get(){return u},set(i){if(!h(u,i)){const g=u;u=i,o.listener?.(t(i,g))}}}},A=(o,c)=>o===c,k={range:(o,c)=>o===c?!0:!o||!c?!1:o.isEqual(c),label:A,description:A,sortText:A,busy:A,error:A,canResolveChildren:A,tags:(o,c)=>!(o.length!==c.length||o.some(h=>!c.find(t=>h.id===t.id)))},l=o=>c=>({op:4,update:o(c)}),p=(o,c)=>({range:(()=>{let h;const t=l(u=>({range:y.$Us.lift($.Range.from(u))}));return{enumerable:!0,configurable:!1,get(){return h},set(u){o.listener?.({op:6}),k.range(h,u)||(h=u,o.listener?.(t(u)))}}})(),label:b(o,c,k.label,l(h=>({label:h}))),description:b(o,void 0,k.description,l(h=>({description:h}))),sortText:b(o,void 0,k.sortText,l(h=>({sortText:h}))),canResolveChildren:b(o,!1,k.canResolveChildren,h=>({op:2,state:h})),busy:b(o,!1,k.busy,l(h=>({busy:h}))),error:b(o,void 0,k.error,l(h=>({error:$.MarkdownString.fromStrict(h)||null}))),tags:b(o,[],k.tags,(h,t)=>({op:1,new:h.map($.TestTag.from),old:t.map($.TestTag.from)}))}),w=o=>{const c=C.$XJ.fromString(o.extId),h=new a(c.controllerId,c.localId,o.label,f.URI.revive(o.uri)||void 0);return h.range=$.Range.to(o.range||void 0),h.description=o.description||void 0,h.sortText=o.sortText||void 0,h.tags=o.tags.map(t=>$.TestTag.to({id:(0,R.$3J)(t).tagId})),h},s=o=>{let c;for(const h of o.tests){const t=w(h.item);(0,T.$6M)(t).parent=c,c=t}return c};e.$jN=s;class a{constructor(c,h,t,u){if(h.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(h)} symbol`);const i=(0,T.$5M)(this,c);Object.defineProperties(this,{id:{value:h,enumerable:!0,writable:!1},uri:{value:u,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return i.parent instanceof r?void 0:i.parent}},children:{value:(0,L.$4M)(i,T.$6M,a),enumerable:!0,writable:!1},...p(i,t)})}}e.$kN=a;class r extends a{constructor(c,h){super(c,c,h,void 0),this._isRoot=!0}}e.$lN=r;class n extends L.$ZM{constructor(c,h,t){super({controllerId:c,getDocumentVersion:u=>u&&t.getDocument(u)?.version,getApiFor:T.$6M,getChildren:u=>u.children,root:new r(c,h),toITestItem:$.TestItem.from})}}e.$mN=n}),define(Pe[109],Re([1,0,53,15,89,8,7]),function(ge,e,y,T,C,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gN=e.$fN=e.$eN=void 0;class ${static{this.c=new C.$cN("TextEditorDecorationType")}constructor(l,p,w){const s=$.c.nextId();l.$registerTextEditorDecorationType(p.identifier,s,L.DecorationRenderOptions.from(w)),this.value=Object.freeze({key:s,dispose(){l.$removeTextEditorDecorationType(s)}})}}e.$eN=$;class f{constructor(l,p){this.g=[],this.h=void 0,this.j=!1,this.c=l,this.d=l.version,this.e=p.undoStopBefore,this.f=p.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(l,p){this.k();let w=null;if(l instanceof R.$9K)w=new R.$0K(l,l);else if(l instanceof R.$0K)w=l;else throw new Error("Unrecognized location");this.l(w,p,!1)}insert(l,p){this.k(),this.l(new R.$0K(l,l),p,!0)}delete(l){this.k();let p=null;if(l instanceof R.$0K)p=l;else throw new Error("Unrecognized location");this.l(p,null,!0)}l(l,p,w){const s=this.c.validateRange(l);this.g.push({range:s,text:p,forceMoveMarkers:w})}setEndOfLine(l){if(this.k(),l!==R.EndOfLine.LF&&l!==R.EndOfLine.CRLF)throw(0,T.$7)("endOfLine");this.h=l}}class b{constructor(l,p,w,s){this.c=l,this.d=p,this._accept(w),this.e=s;const a=this;this.value={get tabSize(){return a.f},set tabSize(r){a.n(r)},get indentSize(){return a.g},set indentSize(r){a.p(r)},get insertSpaces(){return a.j},set insertSpaces(r){a.s(r)},get cursorStyle(){return a.k},set cursorStyle(r){a.t(r)},get lineNumbers(){return a.l},set lineNumbers(r){a.u(r)}}}_accept(l){this.f=l.tabSize,this.g=l.indentSize,this.h=l.originalIndentSize,this.j=l.insertSpaces,this.k=l.cursorStyle,this.l=L.TextEditorLineNumbersStyle.to(l.lineNumbers)}m(l){if(l==="auto")return"auto";if(typeof l=="number"){const p=Math.floor(l);return p>0?p:null}if(typeof l=="string"){const p=parseInt(l,10);return isNaN(p)?null:p>0?p:null}return null}n(l){const p=this.m(l);if(p!==null){if(typeof p=="number"){if(this.f===p)return;this.f=p}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:p}))}}o(l){if(l==="tabSize")return"tabSize";if(typeof l=="number"){const p=Math.floor(l);return p>0?p:null}if(typeof l=="string"){const p=parseInt(l,10);return isNaN(p)?null:p>0?p:null}return null}p(l){const p=this.o(l);if(p!==null){if(typeof p=="number"){if(this.h===p)return;this.g=p,this.h=p}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:p}))}}q(l){return l==="auto"?"auto":l==="false"?!1:!!l}s(l){const p=this.q(l);if(typeof p=="boolean"){if(this.j===p)return;this.j=p}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:p}))}t(l){this.k!==l&&(this.k=l,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:l})))}u(l){this.l!==l&&(this.l=l,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:L.TextEditorLineNumbersStyle.from(l)})))}assign(l){const p={};let w=!1;if(typeof l.tabSize<"u"){const s=this.m(l.tabSize);s==="auto"?(w=!0,p.tabSize=s):typeof s=="number"&&this.f!==s&&(this.f=s,w=!0,p.tabSize=s)}if(typeof l.indentSize<"u"){const s=this.o(l.indentSize);s==="tabSize"?(w=!0,p.indentSize=s):typeof s=="number"&&this.h!==s&&(this.g=s,this.h=s,w=!0,p.indentSize=s)}if(typeof l.insertSpaces<"u"){const s=this.q(l.insertSpaces);s==="auto"?(w=!0,p.insertSpaces=s):this.j!==s&&(this.j=s,w=!0,p.insertSpaces=s)}typeof l.cursorStyle<"u"&&this.k!==l.cursorStyle&&(this.k=l.cursorStyle,w=!0,p.cursorStyle=l.cursorStyle),typeof l.lineNumbers<"u"&&this.l!==l.lineNumbers&&(this.l=l.lineNumbers,w=!0,p.lineNumbers=L.TextEditorLineNumbersStyle.from(l.lineNumbers)),w&&this.v("setOptions",this.c.$trySetOptions(this.d,p))}v(l,p){p.catch(w=>{this.e.warn(`ExtHostTextEditorOptions '${l}' failed:'`),this.e.warn(w)})}}e.$fN=b;class A{constructor(l,p,w,s,a,r,n,o){this.id=l,this.j=p,this.k=w,this.g=!1,this.h=new Set,this.c=a,this.d=new b(this.j,this.id,r,w),this.e=n,this.f=o;const c=this;this.value=Object.freeze({get document(){return s.value},set document(h){throw new T.$9("document")},get selection(){return c.c&&c.c[0]},set selection(h){if(!(h instanceof R.$$K))throw(0,T.$7)("selection");c.c=[h],c.l()},get selections(){return c.c},set selections(h){if(!Array.isArray(h)||h.some(t=>!(t instanceof R.$$K)))throw(0,T.$7)("selections");c.c=h,c.l()},get visibleRanges(){return c.e},set visibleRanges(h){throw new T.$9("visibleRanges")},get options(){return c.d.value},set options(h){c.g||c.d.assign(h)},get viewColumn(){return c.f},set viewColumn(h){throw new T.$9("viewColumn")},edit(h,t={undoStopBefore:!0,undoStopAfter:!0}){if(c.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const u=new f(s.value,t);return h(u),c.m(u)},insertSnippet(h,t,u={undoStopBefore:!0,undoStopAfter:!0}){if(c.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let i;if(!t||Array.isArray(t)&&t.length===0)i=c.c.map(g=>L.Range.from(g));else if(t instanceof R.$9K){const{lineNumber:g,column:m}=L.Position.from(t);i=[{startLineNumber:g,startColumn:m,endLineNumber:g,endColumn:m}]}else if(t instanceof R.$0K)i=[L.Range.from(t)];else{i=[];for(const g of t)if(g instanceof R.$0K)i.push(L.Range.from(g));else{const{lineNumber:m,column:d}=L.Position.from(g);i.push({startLineNumber:m,startColumn:d,endLineNumber:m,endColumn:d})}}return p.$tryInsertSnippet(l,s.value.version,h.value,i,u)},setDecorations(h,t){const u=t.length===0;u&&!c.h.has(h.key)||(u?c.h.delete(h.key):c.h.add(h.key),c.n(()=>{if(L.$7M(t))return p.$trySetDecorations(l,h.key,L.$8M(t));{const i=new Array(4*t.length);for(let g=0,m=t.length;g<m;g++){const d=t[g];i[4*g]=d.start.line+1,i[4*g+1]=d.start.character+1,i[4*g+2]=d.end.line+1,i[4*g+3]=d.end.character+1}return p.$trySetDecorationsFast(l,h.key,i)}}))},revealRange(h,t){c.n(()=>p.$tryRevealRange(l,L.Range.from(h),t||R.TextEditorRevealType.Default))},show(h){p.$tryShowEditor(l,L.ViewColumn.from(h))},hide(){p.$tryHideEditor(l)}})}dispose(){(0,y.ok)(!this.g),this.g=!0}_acceptOptions(l){(0,y.ok)(!this.g),this.d._accept(l)}_acceptVisibleRanges(l){(0,y.ok)(!this.g),this.e=l}_acceptViewColumn(l){(0,y.ok)(!this.g),this.f=l}_acceptSelections(l){(0,y.ok)(!this.g),this.c=l}async l(){const l=this.c.map(L.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,l)),this.value}m(l){const p=l.finalize();if(p.edits.length===0&&!p.setEndOfLine)return Promise.resolve(!0);const w=p.edits.map(a=>a.range);w.sort((a,r)=>a.end.line===r.end.line?a.end.character===r.end.character?a.start.line===r.start.line?a.start.character-r.start.character:a.start.line-r.start.line:a.end.character-r.end.character:a.end.line-r.end.line);for(let a=0,r=w.length-1;a<r;a++){const n=w[a].end;if(w[a+1].start.isBefore(n))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const s=p.edits.map(a=>({range:L.Range.from(a.range),text:a.text,forceMoveMarkers:a.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,p.documentVersionId,s,{setEndOfLine:typeof p.setEndOfLine=="number"?L.EndOfLine.from(p.setEndOfLine):void 0,undoStopBefore:p.undoStopBefore,undoStopAfter:p.undoStopAfter})}n(l){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):l().then(()=>this,p=>(p instanceof Error&&p.name==="DISPOSED"||this.k.warn(p),null))}}e.$gN=A}),define(Pe[224],Re([1,0,166,25,2,5,6,204,13,7,16,18,8,52,20,132,23]),function(ge,e,y,T,C,L,R,$,f,b,A,k,l,p,w,s,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5hc=void 0;function r(c,h){if((0,A.$If)(c))return{label:c};if(c&&typeof c=="object"&&typeof c.label=="string"){let t;return Array.isArray(c.highlights)&&(t=c.highlights.filter(u=>u.length===2&&typeof u[0]=="number"&&typeof u[1]=="number"),t=t.length?t:void 0),{label:c.label,highlights:t}}}class n extends R.$Tc{constructor(h,t,u){super(),this.f=h,this.g=t,this.h=u,this.a=new Map,this.b=new s.$j8;function i(g){return g&&g.$treeViewId&&(g.$treeItemHandle||g.$selectedTreeItems||g.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:g=>i(g)?this.r(g):Array.isArray(g)&&g.length>0?g.map(m=>i(m)?this.r(m):m):g})}registerTreeDataProvider(h,t,u){const i=this.createTreeView(h,{treeDataProvider:t},u);return{dispose:()=>i.dispose()}}createTreeView(h,t,u){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const i=t.dragAndDropController?.dropMimeTypes??[],g=t.dragAndDropController?.dragMimeTypes??[],m=!!t.dragAndDropController?.handleDrag,d=!!t.dragAndDropController?.handleDrop,S=this.m(h,t,u),M={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:i,dragMimeTypes:g,hasHandleDrag:m,hasHandleDrop:d,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},v=this.f.$registerTreeViewDataProvider(h,M),E={get onDidCollapseElement(){return S.onDidCollapseElement},get onDidExpandElement(){return S.onDidExpandElement},get selection(){return S.selectedElements},get onDidChangeSelection(){return S.onDidChangeSelection},get activeItem(){return(0,a.$CF)(u,"treeViewActiveItem"),S.focusedElement},get onDidChangeActiveItem(){return(0,a.$CF)(u,"treeViewActiveItem"),S.onDidChangeActiveItem},get visible(){return S.visible},get onDidChangeVisibility(){return S.onDidChangeVisibility},get onDidChangeCheckboxState(){return S.onDidChangeCheckboxState},get message(){return S.message},set message(D){(0,p.$jk)(D)&&(0,a.$CF)(u,"treeViewMarkdownMessage"),S.message=D},get title(){return S.title},set title(D){S.title=D},get description(){return S.description},set description(D){S.description=D},get badge(){return S.badge},set badge(D){D!==void 0&&b.ViewBadge.isViewBadge(D)?S.badge={value:Math.floor(Math.abs(D.value)),tooltip:D.tooltip}:D===void 0&&(S.badge=void 0)},reveal:(D,N)=>S.reveal(D,N),dispose:async()=>{await v,this.a.delete(h),S.dispose()}};return this.B(E),E}$getChildren(h,t){const u=this.a.get(h);return u?u.getChildren(t):Promise.reject(new $.$aF(h))}async $handleDrop(h,t,u,i,g,m,d,S){const M=this.a.get(h);if(!M)return Promise.reject(new $.$aF(h));const v=l.DataTransfer.toDataTransfer(u,async E=>(await this.f.$resolveDropFileData(h,t,E)).buffer);return d===h&&S&&await this.j(v,M,S,g,m),M.onDrop(v,i,g)}async j(h,t,u,i,g){const m=this.b.removeDragOperationTransfer(g);if(m)(await m)?.forEach((d,S)=>{d&&h.set(S,d)});else if(g&&t.handleDrag){const d=t.handleDrag(u,h,i);this.b.addDragOperationTransfer(g,d),await d}return h}async $handleDrag(h,t,u,i){const g=this.a.get(h);if(!g)return Promise.reject(new $.$aF(h));const m=await this.j(new b.$ZL,g,t,i,u);if(!(!m||i.isCancellationRequested))return l.DataTransfer.from(m)}async $hasResolve(h){const t=this.a.get(h);if(!t)throw new $.$aF(h);return t.hasResolve}$resolve(h,t,u){const i=this.a.get(h);if(!i)throw new $.$aF(h);return i.resolveTreeItem(t,u)}$setExpanded(h,t,u){const i=this.a.get(h);if(!i)throw new $.$aF(h);i.setExpanded(t,u)}$setSelectionAndFocus(h,t,u){const i=this.a.get(h);if(!i)throw new $.$aF(h);i.setSelectionAndFocus(t,u)}$setVisible(h,t){const u=this.a.get(h);if(!u){if(!t)return;throw new $.$aF(h)}u.setVisible(t)}$changeCheckboxState(h,t){const u=this.a.get(h);if(!u)throw new $.$aF(h);u.setCheckboxState(t)}m(h,t,u){const i=this.B(new o(h,t,this.f,this.g.converter,this.h,u));return this.a.set(h,i),i}r(h){const t=this.a.get(h.$treeViewId);return t&&"$treeItemHandle"in h?t.getExtensionElement(h.$treeItemHandle):t&&"$focusedTreeItem"in h&&h.$focusedTreeItem?t.focusedElement:null}}e.$5hc=n;class o extends R.$Tc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(h=>this.getExtensionElement(h)).filter(h=>!(0,A.$Rf)(h))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(h,t,u,i,g,m){if(super(),this.I=h,this.J=u,this.L=i,this.M=g,this.N=m,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new L.$Vd),this.onDidExpandElement=this.u.event,this.w=this.B(new L.$Vd),this.onDidCollapseElement=this.w.event,this.y=this.B(new L.$Vd),this.onDidChangeSelection=this.y.event,this.z=this.B(new L.$Vd),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new L.$Vd),this.onDidChangeVisibility=this.C.event,this.D=this.B(new L.$Vd),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new L.$Vd),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new w.$6d,m.contributes&&m.contributes.views)for(const v in m.contributes.views)for(const E of m.contributes.views[v])E.id===h&&(this.P=E.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(v=>this.F.fire({message:!1,element:v})));let d,S;const M=L.Event.debounce(this.F.event,(v,E)=>(v||(v={message:!1,elements:[]}),E.element!==!1&&(d||(d=new Promise(D=>S=D),this.G=this.G.then(()=>d)),Array.isArray(E.element)?v.elements.push(...E.element):v.elements.push(E.element)),E.message&&(v.message=!0),v),200,!0);this.B(M(({message:v,elements:E})=>{E.length&&(this.H=this.H.then(()=>{const D=S;return d=null,this.$(E).then(()=>D())})),v&&this.J.$setMessage(this.I,l.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(h){const t=h?this.getExtensionElement(h):void 0;if(h&&!t)return this.M.error(`No tree item with id '${h}' found.`),Promise.resolve([]);let u=this.X(h);return u||(u=await this.Y(t)),u?u.map(i=>i.item):void 0}getExtensionElement(h){return this.j.get(h)}reveal(h,t){t=t||{select:!0,focus:!1};const u=(0,A.$Rf)(t.select)?!0:t.select,i=(0,A.$Rf)(t.focus)?!1:t.focus,g=(0,A.$Rf)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):h?this.G.then(()=>this.S(h)).then(m=>this.W(h,m[m.length-1]).then(d=>this.J.$reveal(this.I,{item:d.item,parentChain:m.map(S=>S.item)},{select:u,focus:i,expand:g})),m=>this.M.error(m)):this.J.$reveal(this.I,void 0,{select:u,focus:i,expand:g})}get message(){return this.O}set message(h){this.O=h,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(h){this.P=h,this.J.$setTitle(this.I,h,this.Q)}get description(){return this.Q}set description(h){this.Q=h,this.J.$setTitle(this.I,this.P,h)}get badge(){return this.R}set badge(h){this.R?.value===h?.value&&this.R?.tooltip===h?.tooltip||(this.R=l.ViewBadge.from(h),this.J.$setBadge(this.I,h))}setExpanded(h,t){const u=this.getExtensionElement(h);u&&(t?this.u.fire(Object.freeze({element:u})):this.w.fire(Object.freeze({element:u})))}setSelectionAndFocus(h,t){const u=!(0,k.$ub)(this.s,h);this.s=h;const i=this.t!==t;this.t=t,u&&this.y.fire(Object.freeze({selection:this.selectedElements})),i&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(h){h!==this.r&&(this.r=h,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(h){const t=(await Promise.all(h.map(async u=>{const i=this.getExtensionElement(u.treeItemHandle);return i?{extensionItem:i,treeItem:await this.f.getTreeItem(i),newState:u.newState?b.TreeItemCheckboxState.Checked:b.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(u=>u!==void 0);t.forEach(u=>{u.treeItem.checkboxState=u.newState?b.TreeItemCheckboxState.Checked:b.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(u=>[u.extensionItem,u.newState])})}async handleDrag(h,t,u){const i=[];for(const g of h){const m=this.getExtensionElement(g);m&&i.push(m)}if(!(!this.g?.handleDrag||i.length===0))return await this.g.handleDrag(i,t,u),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(h,t,u){const i=t?this.getExtensionElement(t):void 0;if(!(!i&&t||!this.g?.handleDrop))return(0,f.$Yg)(()=>this.g?.handleDrop?this.g.handleDrop(i,h,u):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(h,t){if(!this.f.resolveTreeItem)return;const u=this.j.get(h);if(u){const i=this.m.get(u);if(i){const g=await this.f.resolveTreeItem(i.extensionItem,u,t)??i.extensionItem;return this.hb(g),i.item.tooltip=this.eb(g.tooltip),i.item.command=this.fb(i.disposableStore,g.command),i.item}}}S(h){return this.U(h).then(t=>t?this.S(t).then(u=>this.W(t,u[u.length-1]).then(i=>(u.push(i),u))):Promise.resolve([]))}U(h){const t=this.m.get(h);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,f.$Yg)(()=>this.f.getParent(h))}W(h,t){const u=this.m.get(h);return u?Promise.resolve(u):(0,f.$Yg)(()=>this.f.getTreeItem(h)).then(i=>this.kb(h,i,t,!0)).then(i=>this.getChildren(t?t.item.handle:void 0).then(()=>{const g=this.getExtensionElement(i);if(g){const m=this.m.get(g);if(m)return Promise.resolve(m)}throw new Error(`Cannot resolve tree item for element ${i} from extension ${this.N.identifier.value}`)}))}X(h){if(h){let t;if(typeof h=="string"){const u=this.getExtensionElement(h);t=u?this.m.get(u):void 0}else t=h;return t&&t.children||void 0}return this.h}async Y(h){this.rb(h);const t=new w.$6d(this.Z.token);try{const u=h?this.m.get(h):void 0,i=await this.f.getChildren(h);if(t.token.isCancellationRequested)return;const g=(0,k.$Hb)(i||[]),m=await Promise.all((0,k.$Hb)(g).map(S=>this.f.getTreeItem(S)));if(t.token.isCancellationRequested)return;const d=m.map((S,M)=>S?this.db(g[M],S,u):null);return(0,k.$Hb)(d)}finally{t.dispose()}}$(h){if(h.some(u=>!u))return this.Z.dispose(!0),this.Z=new w.$6d,this.tb(),this.J.$refresh(this.I);{const u=this.ab(h);if(u.length)return this.bb(u)}return Promise.resolve(void 0)}ab(h){const t=new Set,u=h.map(g=>this.m.get(g));for(const g of u)if(g&&!t.has(g.item.handle)){let m=g;for(;m&&m.parent&&u.findIndex(d=>m&&m.parent&&d&&d.item.handle===m.parent.item.handle)===-1;){const d=this.j.get(m.parent.item.handle);m=d?this.m.get(d):void 0}m&&!m.parent&&t.add(g.item.handle)}const i=[];return t.forEach(g=>{const m=this.j.get(g);if(m){const d=this.m.get(m);d&&(!d.parent||!t.has(d.parent.item.handle))&&i.push(g)}}),i}bb(h){const t={};return Promise.all(h.map(u=>this.cb(u).then(i=>{i&&(t[u]=i.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(h){const t=this.getExtensionElement(h);if(t){const u=this.m.get(t);if(u)return this.rb(t),(0,f.$Yg)(()=>this.f.getTreeItem(t)).then(i=>{if(i){const g=this.ib(t,i,u.parent);return this.pb(t,g,u,u.parent),u.dispose(),g}return null})}return Promise.resolve(null)}db(h,t,u){const i=this.ib(h,t,u);if(t.id&&this.j.has(i.item.handle))throw new Error((0,y.localize)(0,null,t.id));return this.ob(h,i),this.qb(i,u),i}eb(h){return b.$wL.isMarkdownString(h)?l.MarkdownString.from(h):h}fb(h,t){return t?{...this.L.toInternal(t,h),originalId:t.command}:void 0}gb(h){if(h.checkboxState===void 0)return;let t,u,i;return typeof h.checkboxState=="number"?t=h.checkboxState:(t=h.checkboxState.state,u=h.checkboxState.tooltip,i=h.checkboxState.accessibilityInformation),{isChecked:t===b.TreeItemCheckboxState.Checked,tooltip:u,accessibilityInformation:i}}hb(h){if(!b.$UL.isTreeItem(h,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(h,t,u){this.hb(t);const i=this.B(new R.$Sc),g=this.kb(h,t,u),m=this.lb(t);return{item:{handle:g,parentHandle:u?u.item.handle:void 0,label:r(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(i,t.command),contextValue:t.contextValue,icon:m,iconDark:this.mb(t)||m,themeIcon:this.jb(t),collapsibleState:(0,A.$Rf)(t.collapsibleState)?b.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:u,children:void 0,disposableStore:i,dispose(){i.dispose()}}}jb(h){return h.iconPath instanceof b.$3L?h.iconPath:void 0}kb(h,{id:t,label:u,resourceUri:i},g,m){if(t)return`${o.b}/${t}`;const d=r(u,this.N),S=g?g.item.handle:o.a;let M=d?d.label:i?(0,T.$Eg)(i):"";M=M.indexOf("/")!==-1?M.replace("/","//"):M;const v=this.m.has(h)?this.m.get(h).item.handle:void 0,E=this.X(g)||[];let D,N=0;do{if(D=`${S}/${N}:${M}`,m||!this.j.has(D)||v===D)break;N++}while(N<=E.length);return D}lb(h){if(h.iconPath&&!(h.iconPath instanceof b.$3L))return typeof h.iconPath=="string"||C.URI.isUri(h.iconPath)?this.nb(h.iconPath):this.nb(h.iconPath.light)}mb(h){if(h.iconPath&&!(h.iconPath instanceof b.$3L)&&h.iconPath.dark)return this.nb(h.iconPath.dark)}nb(h){return C.URI.isUri(h)?h:C.URI.file(h)}ob(h,t){this.j.set(t.item.handle,h),this.m.set(h,t)}pb(h,t,u,i){this.j.delete(t.item.handle),this.m.delete(h),t.item.handle!==u.item.handle&&this.j.delete(u.item.handle),this.ob(h,t);const g=this.X(i)||[],m=g.filter(d=>d.item.handle===u.item.handle)[0];m&&g.splice(g.indexOf(m),1,t)}qb(h,t){t?(t.children||(t.children=[]),t.children.push(h)):(this.h||(this.h=[]),this.h.push(h))}rb(h){if(h){const t=this.m.get(h);if(t){if(t.children)for(const u of t.children){const i=this.j.get(u.item.handle);i&&this.sb(i)}t.children=void 0}}else this.tb()}sb(h){const t=this.m.get(h);if(t){if(t.children)for(const u of t.children){const i=this.j.get(u.item.handle);i&&this.sb(i)}this.m.delete(h),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(h=>h.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Pe[225],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2.d.ts",chatAgents2Additions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2Additions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",defaultChatAgent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatAgent.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",testingActiveProfile:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testingActiveProfile.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Pe[226],Re([1,0,178,15,31,97,73,30,22,225,188,101]),function(ge,e,y,T,C,L,R,$,f,b,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vF=e.$uF=e.$tF=e.$sF=e.$rF=e.$qF=void 0;const l=$.$Hn.as(R.$In.JSONContribution);class p{constructor(h,t,u){this.a=h,this.b=t,this.c=u}d(h,t){this.a({type:h,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(h){this.d(C.default.Error,h)}warn(h){this.d(C.default.Warning,h)}info(h){this.d(C.default.Info,h)}}e.$qF=p;class w{static a(h){const t=new f.$mm;for(let u=0,i=h.length;u<i;u++)t.add(h[u].description.identifier);return t}static compute(h,t){if(!h||!h.length)return new w(t,[]);if(!t||!t.length)return new w([],h);const u=this.a(h),i=this.a(t),g=t.filter(d=>!u.has(d.description.identifier)),m=h.filter(d=>!i.has(d.description.identifier));return new w(g,m)}constructor(h,t){this.added=h,this.removed=t}}e.$rF=w;class s{constructor(h,t){this.name=h,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(h){if(this.a!==null)throw new Error("Handler already set!");this.a=h,this.d()}acceptUsers(h){this.c=w.compute(this.b,h),this.b=h,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(h){(0,T.$1)(h)}}}e.$sF=s;const a={type:"string",enum:["ui","workspace"],enumDescriptions:[y.localize(0,null),y.localize(1,null)]},r="vscode://schemas/vscode-extensions";e.$tF={properties:{engines:{type:"object",description:y.localize(2,null),properties:{vscode:{type:"string",description:y.localize(3,null),default:"^1.22.0"}}},publisher:{description:y.localize(4,null),type:"string"},displayName:{description:y.localize(5,null),type:"string"},categories:{description:y.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:f.$km},{type:"string",const:"Languages",deprecationMessage:y.localize(7,null)}]}},galleryBanner:{type:"object",description:y.localize(8,null),properties:{color:{description:y.localize(9,null),type:"string"},theme:{description:y.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:y.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:y.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:y.localize(13,null)},enabledApiProposals:{markdownDescription:y.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(b.allApiProposals),markdownEnumDescriptions:Object.values(b.allApiProposals)}},api:{markdownDescription:y.localize(15,null),type:"string",enum:["none"],enumDescriptions:[y.localize(16,null)]},activationEvents:{description:y.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:y.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:y.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:y.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:y.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:y.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:y.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:y.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:y.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:y.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:y.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:y.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:y.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:y.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:y.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:y.localize(32,null)},{label:"onUri",body:"onUri",description:y.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:y.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:y.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:y.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:y.localize(37,null)},{label:"onRenderer",description:y.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:y.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:y.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:y.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:y.localize(42,null)},{label:"*",description:y.localize(43,null),body:"*"}]}},badges:{type:"array",description:y.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:y.localize(45,null)},href:{type:"string",description:y.localize(46,null)},description:{type:"string",description:y.localize(47,null)}}}},markdown:{type:"string",description:y.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:y.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:y.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.$mo}},extensionPack:{description:y.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.$mo}},extensionKind:{description:y.localize(52,null),type:"array",items:a,default:["workspace"],defaultSnippets:[{body:["ui"],description:y.localize(53,null)},{body:["workspace"],description:y.localize(54,null)},{body:["ui","workspace"],description:y.localize(55,null)},{body:["workspace","ui"],description:y.localize(56,null)},{body:[],description:y.localize(57,null)}]},capabilities:{description:y.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:y.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:y.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[y.localize(61,null),y.localize(62,null),y.localize(63,null)]},description:{type:"string",markdownDescription:y.localize(64,null)}}},untrustedWorkspaces:{description:y.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:y.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[y.localize(67,null),y.localize(68,null),y.localize(69,null)]},restrictedConfigurations:{description:y.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:y.localize(71,null)}}}}},sponsor:{description:y.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:y.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:y.localize(74,null),type:"string"},"vscode:uninstall":{description:y.localize(75,null),type:"string"}}},icon:{type:"string",description:y.localize(76,null)},l10n:{type:"string",description:y.localize(77,null)},pricing:{type:"string",markdownDescription:y.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class n{constructor(){this.a=new Map}registerExtensionPoint(h){if(this.a.has(h.extensionPoint))throw new Error("Duplicate extension point: "+h.extensionPoint);const t=new s(h.extensionPoint,h.defaultExtensionKind);return this.a.set(h.extensionPoint,t),h.activationEventsGenerator&&k.$hF.register(h.extensionPoint,h.activationEventsGenerator),e.$tF.properties.contributes.properties[h.extensionPoint]=h.jsonSchema,l.registerSchema(r,e.$tF),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$uF=n;const o={ExtensionsRegistry:"ExtensionsRegistry"};$.$Hn.add(o.ExtensionsRegistry,new n),e.$vF=$.$Hn.as(o.ExtensionsRegistry),l.registerSchema(r,e.$tF),l.registerSchema(A.$Gj,{properties:{extensionEnabledApiProposals:{description:y.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(b.allApiProposals),markdownEnumDescriptions:Object.values(b.allApiProposals)}}]}}}})}),define(Pe[227],Re([1,0,174,16,26,226,35,5]),function(ge,e,y,T,C,L,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xG=void 0;const f={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:y.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:y.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:y.localize(2,null),default:""}}};var b;(function(l){function p(w,s,a){if(!w)return;const r=T.$If(w.type)?w.type:void 0;if(!r||r.length===0){a.error(y.localize(3,null));return}const n=[];if(Array.isArray(w.required))for(const o of w.required)T.$If(o)&&n.push(o);return{extensionId:s.value,taskType:r,required:n,properties:w.properties?C.$vn(w.properties):{},when:w.when?R.$4i.deserialize(w.when):void 0}}l.from=p})(b||(b={}));const A=L.$vF.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(l,p)=>{for(const w of l)w.type&&p.push(`onTaskType:${w.type}`)},jsonSchema:{description:y.localize(4,null),type:"array",items:f}});class k{constructor(){this.d=new $.$Vd,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((p,w)=>{A.setHandler((s,a)=>{this.c=void 0;try{for(const r of a.removed){const n=r.value;for(const o of n)this.a&&o.type&&this.a[o.type]&&delete this.a[o.type]}for(const r of a.added){const n=r.value;for(const o of n){const c=b.from(o,r.description.identifier,r.collector);c&&(this.a[c.taskType]=c)}}(a.removed.length>0||a.added.length>0)&&this.d.fire()}catch{}p(void 0)})})}onReady(){return this.b}get(p){return this.a[p]}all(){return Object.keys(this.a).map(p=>this.a[p])}getJsonSchema(){if(this.c===void 0){const p=[];for(const w of this.all()){const s={type:"object",additionalProperties:!1};w.required.length>0&&(s.required=w.required.slice(0)),w.properties!==void 0?s.properties=C.$vn(w.properties):s.properties=Object.create(null),s.properties.type={type:"string",enum:[w.taskType]},p.push(s)}this.c={oneOf:p}}return this.c}}e.$xG=new k}),define(Pe[228],Re([1,0,175,16,25,26,35,227]),function(ge,e,y,T,C,L,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$HG=e.JsonSchemaVersion=e.ExecutionEngine=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$BG=e.ShellQuoting=e.$AG=e.$zG=e.$yG=void 0,e.$yG="settings",e.$zG=new R.$kj("taskRunning",!1,y.localize(0,null)),e.$AG={value:y.localize(1,null),original:"Tasks"};var f;(function(P){P[P.Escape=1]="Escape",P[P.Strong=2]="Strong",P[P.Weak=3]="Weak"})(f||(e.ShellQuoting=f={})),e.$BG="$customized",function(P){function I(H){if(!H)return P.Strong;switch(H.toLowerCase()){case"escape":return P.Escape;case"strong":return P.Strong;case"weak":return P.Weak;default:return P.Strong}}P.from=I}(f||(e.ShellQuoting=f={}));var b;(function(P){P.defaults={cwd:"${workspaceFolder}"}})(b||(e.CommandOptions=b={}));var A;(function(P){P[P.Always=1]="Always",P[P.Silent=2]="Silent",P[P.Never=3]="Never"})(A||(e.RevealKind=A={})),function(P){function I(H){switch(H.toLowerCase()){case"always":return P.Always;case"silent":return P.Silent;case"never":return P.Never;default:return P.Always}}P.fromString=I}(A||(e.RevealKind=A={}));var k;(function(P){P[P.Never=1]="Never",P[P.OnProblem=2]="OnProblem",P[P.Always=3]="Always"})(k||(e.RevealProblemKind=k={})),function(P){function I(H){switch(H.toLowerCase()){case"always":return P.Always;case"never":return P.Never;case"onproblem":return P.OnProblem;default:return P.OnProblem}}P.fromString=I}(k||(e.RevealProblemKind=k={}));var l;(function(P){P[P.Shared=1]="Shared",P[P.Dedicated=2]="Dedicated",P[P.New=3]="New"})(l||(e.PanelKind=l={})),function(P){function I(H){switch(H.toLowerCase()){case"shared":return P.Shared;case"dedicated":return P.Dedicated;case"new":return P.New;default:return P.Shared}}P.fromString=I}(l||(e.PanelKind=l={}));var p;(function(P){P.defaults={echo:!0,reveal:A.Always,revealProblems:k.Never,focus:!1,panel:l.Shared,showReuseMessage:!0,clear:!1}})(p||(e.PresentationOptions=p={}));var w;(function(P){P[P.Shell=1]="Shell",P[P.Process=2]="Process",P[P.CustomExecution=3]="CustomExecution"})(w||(e.RuntimeType=w={})),function(P){function I(ae){switch(ae.toLowerCase()){case"shell":return P.Shell;case"process":return P.Process;case"customExecution":return P.CustomExecution;default:return P.Process}}P.fromString=I;function H(ae){switch(ae){case P.Shell:return"shell";case P.Process:return"process";case P.CustomExecution:return"customExecution";default:return"process"}}P.toString=H}(w||(e.RuntimeType=w={}));var s;(function(P){function I(H){return T.$If(H)?H:H.value}P.value=I})(s||(e.CommandString=s={}));var a;(function(P){P.Clean={_id:"clean",isDefault:!1},P.Build={_id:"build",isDefault:!1},P.Rebuild={_id:"rebuild",isDefault:!1},P.Test={_id:"test",isDefault:!1};function I(ae){return ae===P.Clean._id||ae===P.Build._id||ae===P.Rebuild._id||ae===P.Test._id}P.is=I;function H(ae){if(ae!==void 0)return T.$If(ae)?I(ae)?{_id:ae,isDefault:!1}:void 0:ae}P.from=H})(a||(e.TaskGroup=a={}));var r;(function(P){P[P.Global=1]="Global",P[P.Workspace=2]="Workspace",P[P.Folder=3]="Folder"})(r||(e.TaskScope=r={}));var n;(function(P){P.Workspace="workspace",P.Extension="extension",P.InMemory="inMemory",P.WorkspaceFile="workspaceFile",P.User="user";function I(H){switch(H){case P.User:return 2;case P.WorkspaceFile:return 5;default:return 6}}P.toConfigurationTarget=I})(n||(e.TaskSourceKind=n={}));var o;(function(P){P.parallel="parallel",P.sequence="sequence"})(o||(e.DependsOrder=o={}));var c;(function(P){P[P.default=1]="default",P[P.folderOpen=2]="folderOpen"})(c||(e.RunOnOptions=c={}));var h;(function(P){P.defaults={reevaluateOnRerun:!0,runOn:c.default,instanceLimit:1}})(h||(e.RunOptions=h={}));class t{constructor(I,H,ae,de,we,ke){this._label="",this._id=I,H&&(this._label=H),ae&&(this.type=ae),this.runOptions=de,this.configurationProperties=we,this._source=ke}getDefinition(I){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const I={folder:this.d(),id:this._id};return JSON.stringify(I)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(I,H=!1){if(I===void 0)return!1;if(T.$If(I))return I===this._label||I===this.configurationProperties.identifier||H&&I===this._id;const ae=this.getDefinition(!0);return ae!==void 0&&ae._key===I._key}getQualifiedLabel(){const I=this.getWorkspaceFolder();return I?`${this._label} (${I.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(I){this.c===void 0&&(this.c=[]),I&&(this.c=this.c.concat(I))}get taskLoadMessages(){return this.c}}e.$CG=t;class u extends t{constructor(I,H,ae,de,we,ke,le,ve){super(I,ae,void 0,le,ve,H),this.command={},this._source=H,this.hasDefinedMatchers=ke,we&&(this.command=we)}clone(){return new u(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(I=!1){if(I&&this._source.customizes!==void 0)return this._source.customizes;{let H;switch(this.command?this.command.runtime:void 0){case w.Shell:H="shell";break;case w.Process:H="process";break;case w.CustomExecution:H="customExecution";break;case void 0:H="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:H,_key:this._id,id:this._id}}}static is(I){return I instanceof u}getMapKey(){const I=this._source.config.workspaceFolder;return I?`${I.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===n.User?e.$yG:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const I=this.d();if(!I)return;let H=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(H+=this._source.kind);const ae={type:e.$BG,folder:I,id:H};return JSON.stringify(ae)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?C.$Eg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(I){return new u(I._id,I._source,I._label,I.type,I.command,I.hasDefinedMatchers,I.runOptions,I.configurationProperties)}}e.$DG=u;class i extends t{constructor(I,H,ae,de,we,ke,le){super(I,ae,de,ke,le,H),this._source=H,this.configures=we}static is(I){return I instanceof i}f(I){return I}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?C.$Eg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===n.User?e.$yG:this._source.config.workspaceFolder?.uri.toString()}getKey(){const I=this.d();if(!I)return;let H=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(H+=this._source.kind);const ae={type:e.$BG,folder:I,id:H};return JSON.stringify(ae)}}e.$EG=i;class g extends t{constructor(I,H,ae,de,we,ke,le,ve,se){super(I,ae,de,ve,se,H),this.defines=we,this.hasDefinedMatchers=le,this.command=ke,this.icon=se.icon,this.hide=se.hide}clone(){return new g(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(I){return I instanceof g}getMapKey(){const I=this._source.workspaceFolder;return I?`${this._source.scope.toString()}|${I.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const I={type:"contributed",scope:this._source.scope,id:this._id};return I.folder=this.d(),JSON.stringify(I)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(I){return new g(I._id,I._source,I._label,I.type,I.defines,I.command,I.hasDefinedMatchers,I.runOptions,I.configurationProperties)}}e.$FG=g;class m extends t{constructor(I,H,ae,de,we,ke){super(I,ae,de,we,ke,H),this._source=H}clone(){return new m(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(I){return I instanceof m}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(I){return new m(I._id,I._source,I._label,I.type,I.runOptions,I.configurationProperties)}}e.$GG=m;var d;(function(P){P[P.Process=1]="Process",P[P.Terminal=2]="Terminal"})(d||(e.ExecutionEngine=d={})),function(P){P._default=P.Terminal}(d||(e.ExecutionEngine=d={}));var S;(function(P){P[P.V0_1_0=1]="V0_1_0",P[P.V2_0_0=2]="V2_0_0"})(S||(e.JsonSchemaVersion=S={}));class M{constructor(I){this.c=new Map;for(let H=0;H<I.length;H++)this.c.set(I[H].uri.toString(),H)}compare(I,H){const ae=I.getWorkspaceFolder(),de=H.getWorkspaceFolder();if(ae&&de){let we=this.c.get(ae.uri.toString());we=we===void 0?0:we+1;let ke=this.c.get(de.uri.toString());return ke=ke===void 0?0:ke+1,we===ke?I._label.localeCompare(H._label):we-ke}else return!ae&&de?-1:ae&&!de?1:0}}e.$HG=M;var v;(function(P){P.DependsOnStarted="dependsOnStarted",P.AcquiredInput="acquiredInput",P.Start="start",P.ProcessStarted="processStarted",P.Active="active",P.Inactive="inactive",P.Changed="changed",P.Terminated="terminated",P.ProcessEnded="processEnded",P.End="end"})(v||(e.TaskEventKind=v={}));var E;(function(P){P.SingleRun="singleRun",P.Background="background"})(E||(e.TaskRunType=E={}));var D;(function(P){P[P.System=0]="System",P[P.User=1]="User",P[P.FolderOpen=2]="FolderOpen",P[P.ConfigurationChange=3]="ConfigurationChange",P[P.Reconnect=4]="Reconnect"})(D||(e.TaskRunSource=D={}));var N;(function(P){function I(ve){return{taskId:ve._id,taskName:ve.configurationProperties.name,runType:ve.configurationProperties.isBackground?"background":"singleRun",group:ve.configurationProperties.group,__task:ve}}function H(ve,se,be){return{...I(ve),kind:"start",terminalId:se,resolvedVariables:be}}P.start=H;function ae(ve,se,be){return{...I(ve),kind:"processStarted",terminalId:se,processId:be}}P.processStarted=ae;function de(ve,se,be){return{...I(ve),kind:"processEnded",terminalId:se,exitCode:be}}P.processEnded=de;function we(ve,se,be){return{...I(ve),kind:"terminated",exitReason:be,terminalId:se}}P.terminated=we;function ke(ve,se,be){return{...I(se),kind:ve,terminalId:be}}P.general=ke;function le(){return{kind:"changed"}}P.changed=le})(N||(e.TaskEvent=N={}));var O;(function(P){function I(ae){const de=Object.keys(ae).sort();let we="";for(const ke of de){let le=ae[ke];le instanceof Object?le=I(le):typeof le=="string"&&(le=le.replace(/,/g,",,")),we+=ke+","+le+","}return we}function H(ae){const we={_key:I(ae),type:ae.taskType};return Object.assign(we,ae),we}P.create=H})(O||(e.KeyedTaskIdentifier=O={}));var G;(function(P){P.AutoDetect="task.autoDetect",P.SaveBeforeRun="task.saveBeforeRun",P.ShowDecorations="task.showDecorations",P.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",P.SlowProviderWarning="task.slowProviderWarning",P.QuickOpenHistory="task.quickOpen.history",P.QuickOpenDetail="task.quickOpen.detail",P.QuickOpenSkip="task.quickOpen.skip",P.QuickOpenShowAll="task.quickOpen.showAll",P.AllowAutomaticTasks="task.allowAutomaticTasks",P.Reconnection="task.reconnection",P.VerboseLogging="task.verboseLogging"})(G||(e.TaskSettingId=G={}));var W;(function(P){P.Tasks="tasks",P.SuppressTaskName="tasks.suppressTaskName",P.Windows="tasks.windows",P.Osx="tasks.osx",P.Linux="tasks.linux",P.ShowOutput="tasks.showOutput",P.IsShellCommand="tasks.isShellCommand",P.ServiceTestSetting="tasks.service.testSetting"})(W||(e.TasksSchemaProperties=W={}));var z;(function(P){function I(H,ae){const de=$.$xG.get(H.type);if(de===void 0){const ve=L.$vn(H);return delete ve._key,O.create(ve)}const we=Object.create(null);we.type=de.taskType;const ke=new Set;de.required.forEach(ve=>ke.add(ve));const le=de.properties;for(const ve of Object.keys(le)){const se=H[ve];if(se!=null)we[ve]=se;else if(ke.has(ve)){const be=le[ve];if(be.default!==void 0)we[ve]=L.$vn(be.default);else switch(be.type){case"boolean":we[ve]=!1;break;case"number":case"integer":we[ve]=0;break;case"string":we[ve]="";break;default:ae.error(y.localize(2,null,JSON.stringify(H,void 0,0),ve));return}}}return O.create(we)}P.createTaskIdentifier=I})(z||(e.TaskDefinition=z={}))}),define(Pe[229],Re([1,0,15]),function(ge,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$m8b=e.$l8b=void 0;class T{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((R,$)=>{this.b=R,this.d=$,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(R){this.f||this.h||(this.f=!0,this.g=R,this.a&&this.b(R))}resolveErr(R){this.f||this.h||(this.h=!0,this.i=R,this.a?this.d(R):(0,y.$1)(R))}then(R,$){return this.j().then(R,$)}catch(R){return this.j().then(void 0,R)}finally(R){return this.j().finally(R)}}e.$l8b=T;class C extends T{constructor(){super(),this.h=!0,this.i=new y.$5}}e.$m8b=C}),define(Pe[49],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tv=e.$Sv=e.$Rv=e.$Qv=void 0;class y{static{this.count=0}constructor(f){this._proxyIdentifierBrand=void 0,this.sid=f,this.nid=++y.count}}e.$Qv=y;const T=[];function C($){const f=new y($);return T[f.nid]=f,f}e.$Rv=C;function L($){return T[$].sid}e.$Sv=L;class R{constructor(f){this.value=f}}e.$Tv=R}),define(Pe[3],Re([1,0,49]),function(ge,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7K=e.$6K=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$5K=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var T;(function(s){s[s.Default=0]="Default",s[s.InCenter=1]="InCenter",s[s.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",s[s.AtTop=3]="AtTop"})(T||(e.TextEditorRevealType=T={}));var C;(function(s){s[s.UnknownInput=0]="UnknownInput",s[s.TextInput=1]="TextInput",s[s.TextDiffInput=2]="TextDiffInput",s[s.TextMergeInput=3]="TextMergeInput",s[s.NotebookInput=4]="NotebookInput",s[s.NotebookDiffInput=5]="NotebookDiffInput",s[s.CustomEditorInput=6]="CustomEditorInput",s[s.WebviewEditorInput=7]="WebviewEditorInput",s[s.TerminalEditorInput=8]="TerminalEditorInput",s[s.InteractiveEditorInput=9]="InteractiveEditorInput",s[s.ChatEditorInput=10]="ChatEditorInput"})(C||(e.TabInputKind=C={}));var L;(function(s){s[s.TAB_OPEN=0]="TAB_OPEN",s[s.TAB_CLOSE=1]="TAB_CLOSE",s[s.TAB_UPDATE=2]="TAB_UPDATE",s[s.TAB_MOVE=3]="TAB_MOVE"})(L||(e.TabModelOperationKind=L={}));var R;(function(s){s[s.Editable=0]="Editable",s[s.SupportsHotExit=1]="SupportsHotExit"})(R||(e.WebviewEditorCapabilities=R={}));var $;(function(s){s[s.Int8Array=1]="Int8Array",s[s.Uint8Array=2]="Uint8Array",s[s.Uint8ClampedArray=3]="Uint8ClampedArray",s[s.Int16Array=4]="Int16Array",s[s.Uint16Array=5]="Uint16Array",s[s.Int32Array=6]="Int32Array",s[s.Uint32Array=7]="Uint32Array",s[s.Float32Array=8]="Float32Array",s[s.Float64Array=9]="Float64Array",s[s.BigInt64Array=10]="BigInt64Array",s[s.BigUint64Array=11]="BigUint64Array"})($||(e.WebviewMessageArrayBufferViewType=$={}));var f;(function(s){s[s.Text=1]="Text",s[s.Error=2]="Error",s[s.Rich=3]="Rich"})(f||(e.CellOutputKind=f={}));var b;(function(s){s[s.Default=0]="Default",s[s.InCenter=1]="InCenter",s[s.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",s[s.AtTop=3]="AtTop"})(b||(e.NotebookEditorRevealType=b={}));var A;(function(s){s[s.None=0]="None",s[s.Process=1]="Process",s[s.Output=2]="Output"})(A||(e.CandidatePortSource=A={}));class k{static{this.a=0}static mixin(a){return a._id=k.a++,a}}e.$5K=k;var l;(function(s){s.label="a",s.kind="b",s.detail="c",s.documentation="d",s.sortText="e",s.filterText="f",s.preselect="g",s.insertText="h",s.insertTextRules="i",s.range="j",s.commitCharacters="k",s.additionalTextEdits="l",s.kindModifier="m",s.commandIdent="n",s.commandId="o",s.commandArguments="p"})(l||(e.ISuggestDataDtoField=l={}));var p;(function(s){s.defaultRanges="a",s.completions="b",s.isIncomplete="c",s.duration="d"})(p||(e.ISuggestResultDtoField=p={}));var w;(function(s){s[s.Workspace=0]="Workspace",s[s.TextDocument=1]="TextDocument"})(w||(e.ExtHostTestingResource=w={})),e.$6K={MainThreadAuthentication:(0,y.$Rv)("MainThreadAuthentication"),MainThreadBulkEdits:(0,y.$Rv)("MainThreadBulkEdits"),MainThreadChatProvider:(0,y.$Rv)("MainThreadChatProvider"),MainThreadChatAgents2:(0,y.$Rv)("MainThreadChatAgents2"),MainThreadChatVariables:(0,y.$Rv)("MainThreadChatVariables"),MainThreadClipboard:(0,y.$Rv)("MainThreadClipboard"),MainThreadCommands:(0,y.$Rv)("MainThreadCommands"),MainThreadComments:(0,y.$Rv)("MainThreadComments"),MainThreadConfiguration:(0,y.$Rv)("MainThreadConfiguration"),MainThreadConsole:(0,y.$Rv)("MainThreadConsole"),MainThreadDebugService:(0,y.$Rv)("MainThreadDebugService"),MainThreadDecorations:(0,y.$Rv)("MainThreadDecorations"),MainThreadDiagnostics:(0,y.$Rv)("MainThreadDiagnostics"),MainThreadDialogs:(0,y.$Rv)("MainThreadDiaglogs"),MainThreadDocuments:(0,y.$Rv)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,y.$Rv)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,y.$Rv)("MainThreadTextEditors"),MainThreadEditorInsets:(0,y.$Rv)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,y.$Rv)("MainThreadEditorTabs"),MainThreadErrors:(0,y.$Rv)("MainThreadErrors"),MainThreadTreeViews:(0,y.$Rv)("MainThreadTreeViews"),MainThreadDownloadService:(0,y.$Rv)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,y.$Rv)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,y.$Rv)("MainThreadLanguages"),MainThreadLogger:(0,y.$Rv)("MainThreadLogger"),MainThreadMessageService:(0,y.$Rv)("MainThreadMessageService"),MainThreadOutputService:(0,y.$Rv)("MainThreadOutputService"),MainThreadProgress:(0,y.$Rv)("MainThreadProgress"),MainThreadQuickDiff:(0,y.$Rv)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,y.$Rv)("MainThreadQuickOpen"),MainThreadStatusBar:(0,y.$Rv)("MainThreadStatusBar"),MainThreadSecretState:(0,y.$Rv)("MainThreadSecretState"),MainThreadStorage:(0,y.$Rv)("MainThreadStorage"),MainThreadSpeech:(0,y.$Rv)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,y.$Rv)("MainThreadTelemetry"),MainThreadTerminalService:(0,y.$Rv)("MainThreadTerminalService"),MainThreadWebviews:(0,y.$Rv)("MainThreadWebviews"),MainThreadWebviewPanels:(0,y.$Rv)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,y.$Rv)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,y.$Rv)("MainThreadCustomEditors"),MainThreadUrls:(0,y.$Rv)("MainThreadUrls"),MainThreadUriOpeners:(0,y.$Rv)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,y.$Rv)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,y.$Rv)("MainThreadWorkspace"),MainThreadFileSystem:(0,y.$Rv)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,y.$Rv)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,y.$Rv)("MainThreadExtensionService"),MainThreadSCM:(0,y.$Rv)("MainThreadSCM"),MainThreadSearch:(0,y.$Rv)("MainThreadSearch"),MainThreadShare:(0,y.$Rv)("MainThreadShare"),MainThreadTask:(0,y.$Rv)("MainThreadTask"),MainThreadWindow:(0,y.$Rv)("MainThreadWindow"),MainThreadLabelService:(0,y.$Rv)("MainThreadLabelService"),MainThreadNotebook:(0,y.$Rv)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,y.$Rv)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,y.$Rv)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,y.$Rv)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,y.$Rv)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,y.$Rv)("MainThreadInteractive"),MainThreadChat:(0,y.$Rv)("MainThreadChat"),MainThreadInlineChat:(0,y.$Rv)("MainThreadInlineChatShape"),MainThreadTheming:(0,y.$Rv)("MainThreadTheming"),MainThreadTunnelService:(0,y.$Rv)("MainThreadTunnelService"),MainThreadManagedSockets:(0,y.$Rv)("MainThreadManagedSockets"),MainThreadTimeline:(0,y.$Rv)("MainThreadTimeline"),MainThreadTesting:(0,y.$Rv)("MainThreadTesting"),MainThreadLocalization:(0,y.$Rv)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,y.$Rv)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,y.$Rv)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,y.$Rv)("MainThreadIssueReporter")},e.$7K={ExtHostCommands:(0,y.$Rv)("ExtHostCommands"),ExtHostConfiguration:(0,y.$Rv)("ExtHostConfiguration"),ExtHostDiagnostics:(0,y.$Rv)("ExtHostDiagnostics"),ExtHostDebugService:(0,y.$Rv)("ExtHostDebugService"),ExtHostDecorations:(0,y.$Rv)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,y.$Rv)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,y.$Rv)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,y.$Rv)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,y.$Rv)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,y.$Rv)("ExtHostEditors"),ExtHostTreeViews:(0,y.$Rv)("ExtHostTreeViews"),ExtHostFileSystem:(0,y.$Rv)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,y.$Rv)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,y.$Rv)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,y.$Rv)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,y.$Rv)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,y.$Rv)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,y.$Rv)("ExtHostQuickDiff"),ExtHostStatusBar:(0,y.$Rv)("ExtHostStatusBar"),ExtHostShare:(0,y.$Rv)("ExtHostShare"),ExtHostExtensionService:(0,y.$Rv)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,y.$Rv)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,y.$Rv)("ExtHostTerminalService"),ExtHostSCM:(0,y.$Rv)("ExtHostSCM"),ExtHostSearch:(0,y.$Rv)("ExtHostSearch"),ExtHostTask:(0,y.$Rv)("ExtHostTask"),ExtHostWorkspace:(0,y.$Rv)("ExtHostWorkspace"),ExtHostWindow:(0,y.$Rv)("ExtHostWindow"),ExtHostWebviews:(0,y.$Rv)("ExtHostWebviews"),ExtHostWebviewPanels:(0,y.$Rv)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,y.$Rv)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,y.$Rv)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,y.$Rv)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,y.$Rv)("ExtHostEditorTabs"),ExtHostProgress:(0,y.$Rv)("ExtHostProgress"),ExtHostComments:(0,y.$Rv)("ExtHostComments"),ExtHostSecretState:(0,y.$Rv)("ExtHostSecretState"),ExtHostStorage:(0,y.$Rv)("ExtHostStorage"),ExtHostUrls:(0,y.$Rv)("ExtHostUrls"),ExtHostUriOpeners:(0,y.$Rv)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,y.$Rv)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,y.$Rv)("ExtHostOutputService"),ExtHostLabelService:(0,y.$Rv)("ExtHostLabelService"),ExtHostNotebook:(0,y.$Rv)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,y.$Rv)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,y.$Rv)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,y.$Rv)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,y.$Rv)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,y.$Rv)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,y.$Rv)("ExtHostInteractive"),ExtHostInlineChat:(0,y.$Rv)("ExtHostInlineChatShape"),ExtHostChat:(0,y.$Rv)("ExtHostChat"),ExtHostChatAgents2:(0,y.$Rv)("ExtHostChatAgents"),ExtHostChatVariables:(0,y.$Rv)("ExtHostChatVariables"),ExtHostChatProvider:(0,y.$Rv)("ExtHostChatProvider"),ExtHostSpeech:(0,y.$Rv)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,y.$Rv)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,y.$Rv)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,y.$Rv)("ExtHostTheming"),ExtHostTunnelService:(0,y.$Rv)("ExtHostTunnelService"),ExtHostManagedSockets:(0,y.$Rv)("ExtHostManagedSockets"),ExtHostAuthentication:(0,y.$Rv)("ExtHostAuthentication"),ExtHostTimeline:(0,y.$Rv)("ExtHostTimeline"),ExtHostTesting:(0,y.$Rv)("ExtHostTesting"),ExtHostTelemetry:(0,y.$Rv)("ExtHostTelemetry"),ExtHostLocalization:(0,y.$Rv)("ExtHostLocalization"),ExtHostIssueReporter:(0,y.$Rv)("ExtHostIssueReporter")}}),define(Pe[230],Re([1,0,3,7]),function(ge,e,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5fc=void 0;class C{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(y.$6K.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(R,$,f){if(this.a.size===0)throw new Error("No related information providers registered");const b=this.a.get(R);if(!b)throw new Error("related information provider not found");return await b.provideRelatedInformation($,f)??[]}getRelatedInformation(R,$,f){return this.c.$getAiRelatedInformation($,f)}registerRelatedInformationProvider(R,$,f){const b=this.b;return this.b++,this.a.set(b,f),this.c.$registerAiRelatedInformationProvider(b,$),new T.$8K(()=>{this.c.$unregisterAiRelatedInformationProvider(b),this.a.delete(b)})}}e.$5fc=C}),define(Pe[81],Re([1,0,4,14,3,17]),function(ge,e,y,T,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$agc=e.$_fc=e.$$fc=void 0,e.$$fc=(0,y.$6h)("IExtHostApiDeprecationService");let R=class{constructor(f,b){this.c=b,this.a=new Set,this.b=f.getProxy(C.$6K.MainThreadTelemetry)}report(f,b,A){const k=this.d(f,b);this.a.has(k)||(this.a.add(k),b.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${f}' is deprecated. ${A}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:b.identifier.value,apiId:f}))}d(f,b){return`${f}-${b.identifier.value}`}};e.$_fc=R,e.$_fc=R=Je([Ke(0,L.$0M),Ke(1,T.$nj)],R),e.$agc=Object.freeze(new class{report($,f,b){}})}),define(Pe[231],Re([1,0,5,3,7,22]),function(ge,e,y,T,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dgc=void 0;class R{constructor(b){this.b=new Map,this.c=new y.$Vd,this.onDidChangeSessions=this.c.event,this.d=new $,this.f=new $,this.a=b.getProxy(T.$6K.MainThreadAuthentication)}async getSession(b,A,k,l={}){const p=L.$lm.toKey(b.identifier),w=[...k].sort().join(" ");return await this.d.getOrCreate(`${p} ${A} ${w}`,async()=>{await this.a.$ensureProvider(A);const s=b.displayName||b.name;return this.a.$getSession(A,k,p,s,l)})}async getSessions(b,A,k){const l=L.$lm.toKey(b.identifier),p=[...k].sort().join(" ");return await this.f.getOrCreate(`${l} ${p}`,async()=>{await this.a.$ensureProvider(A);const w=b.displayName||b.name;return this.a.$getSessions(A,k,l,w)})}async removeSession(b,A){const k=this.b.get(b);return k?k.provider.removeSession(A):this.a.$removeSession(b,A)}registerAuthenticationProvider(b,A,k,l){if(this.b.get(b))throw new Error(`An authentication provider with id '${b}' is already registered.`);this.b.set(b,{label:A,provider:k,options:l??{supportsMultipleAccounts:!1}});const p=k.onDidChangeSessions(w=>this.a.$sendDidChangeSessions(b,w));return this.a.$registerAuthenticationProvider(b,A,l?.supportsMultipleAccounts??!1),new C.$8K(()=>{p.dispose(),this.b.delete(b),this.a.$unregisterAuthenticationProvider(b)})}$createSession(b,A,k){const l=this.b.get(b);if(l)return Promise.resolve(l.provider.createSession(A,k));throw new Error(`Unable to find authentication provider with handle: ${b}`)}$removeSession(b,A){const k=this.b.get(b);if(k)return Promise.resolve(k.provider.removeSession(A));throw new Error(`Unable to find authentication provider with handle: ${b}`)}$getSessions(b,A){const k=this.b.get(b);if(k)return Promise.resolve(k.provider.getSessions(A));throw new Error(`Unable to find authentication provider with handle: ${b}`)}$onDidChangeAuthenticationSessions(b,A){return this.c.fire({provider:{id:b,label:A}}),Promise.resolve()}}e.$dgc=R;class ${constructor(){this.a=new Map}getOrCreate(b,A){const k=this.a.get(b);if(k)return k;const l=A().finally(()=>this.a.delete(b));return this.a.set(b,l),l}}}),define(Pe[232],Re([1,0,3,17,8]),function(ge,e,y,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$egc=void 0;let L=class{constructor($,f){this.a=$.getProxy(y.$6K.MainThreadBulkEdits),this.b={getTextDocumentVersion:b=>f.getDocument(b)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit($,f,b){const A=C.WorkspaceEdit.from($,this.b);return this.a.$tryApplyWorkspaceEdit(A,void 0,b?.isRefactoring??!1)}};e.$egc=L,e.$egc=L=Je([Ke(0,T.$0M)],L)}),define(Pe[233],Re([1,0,67,6,3,8]),function(ge,e,y,T,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fgc=void 0;class R{static{this.a=0}constructor(b,A){this.extension=b,this.provider=A,this.handle=R.a++}}class ${static{this.a=0}constructor(b){this.b=new Map,this.c=new Map,this.d=b.getProxy(C.$6K.MainThreadChat)}registerChatProvider(b,A,k){const l=new R(b,k);return this.b.set(l.handle,l),this.d.$registerChatProvider(l.handle,A),(0,T.$Rc)(()=>{this.d.$unregisterChatProvider(l.handle),this.b.delete(l.handle)})}transferChatSession(b,A){const k=y.Iterable.find(this.c.keys(),l=>this.c.get(l)===b)??0;typeof k=="number"&&this.d.$transferChatSession(k,A)}sendInteractiveRequestToProvider(b,A){this.d.$sendRequestToProvider(b,A)}async $prepareChat(b,A){const k=this.b.get(b);if(!k)return;const l=await k.provider.prepareSession(A);if(!l)return;const p=$.a++;return this.c.set(p,l),{id:p,requesterUsername:l.requester?.name,requesterAvatarIconUri:l.requester?.icon,responderUsername:l.responder?.name,responderAvatarIconUri:l.responder?.icon,inputPlaceholder:l.inputPlaceholder}}async $provideWelcomeMessage(b,A){const k=this.b.get(b);if(!k||!k.provider.provideWelcomeMessage)return;const l=await k.provider.provideWelcomeMessage(A);if(l)return l.map(p=>typeof p=="string"?p:Array.isArray(p)?p.map(w=>L.ChatReplyFollowup.from(w)):L.MarkdownString.from(p))}async $provideSampleQuestions(b,A){const k=this.b.get(b);if(!k||!k.provider.provideSampleQuestions)return;const l=await k.provider.provideSampleQuestions(A);if(l)return l?.map(p=>L.ChatReplyFollowup.from(p))}$releaseSession(b){this.c.delete(b)}}e.$fgc=$}),define(Pe[234],Re([1,0,13,20,40,5,60,16,2,157,72,3,8,7,205,23]),function(ge,e,y,T,C,L,R,$,f,b,A,k,l,p,w,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hgc=void 0;class a{static{this.a=0}constructor(o,c,h){this.i=c,this.j=h,this.b=new Map,this.g=new Map,this.h=new Map,this.d=o.getProxy(k.$6K.MainThreadChatAgents2)}createChatAgent(o,c,h){const t=a.a++,u=new r(o,c,this.d,t,h);return this.b.set(t,u),this.d.$registerAgent(t,c,{}),u.apiAgent}async $invokeAgent(o,c,h,t,u,i){this.g.delete(c);const g=this.b.get(o);if(!g)throw new Error(`[CHAT](${o}) CANNOT invoke agent because the agent is not registered`);let m=!1;function d(){if(m)throw new Error("Only valid while executing the command")}const S=new y.$qh;i.onCancellationRequested(()=>S.complete()),this.i.allowListExtensionWhile(g.extension.identifier,S.p);const M=t.command?await g.validateSlashCommand(t.command):void 0,v=R.$Rd.create(!1);let E;try{const D=g.invoke({prompt:t.message,variables:l.ChatVariable.objectTo(t.variables),slashCommand:M},{history:u.history.map(l.ChatMessage.to)},new A.$vv(N=>{d(),typeof E>"u"&&"content"in N&&(E=v.elapsed());const O=l.ChatResponseProgress.from(g.extension,N);if(!O){this.j.error("Unknown progress type: "+JSON.stringify(N));return}if("placeholder"in N&&"resolvedContent"in N){const G=Promise.all([this.d.$handleProgressChunk(h,O),N.resolvedContent]);(0,y.$Ug)(G,i).then(W=>{if(!W)return;const[z,P]=W,I=l.ChatResponseProgress.from(g.extension,P);if(!I){this.j.error("Unknown progress type: "+JSON.stringify(P));return}this.d.$handleProgressChunk(h,I,z??void 0)})}else this.d.$handleProgressChunk(h,O)}),i);return await(0,y.$Ug)(Promise.resolve(D).then(N=>{if(N){this.g.set(c,N);let O=this.h.get(c);O||(O=new Map,this.h.set(c,O)),O.set(h,N);const G={firstProgress:E,totalElapsed:v.elapsed()};return{errorDetails:N.errorDetails,timings:G}}else this.g.delete(c)}),i)}catch(D){return this.j.error(D,g.extension),{errorDetails:{message:(0,b.localize)(0,null,(0,C.$Qi)(D)),responseIsIncomplete:!0}}}finally{m=!0,S.complete()}}$releaseSession(o){this.g.delete(o),this.h.delete(o)}async $provideSlashCommands(o,c){const h=this.b.get(o);return h?h.provideSlashCommand(c):[]}$provideFollowups(o,c,h){const t=this.b.get(o);if(!t)return Promise.resolve([]);const u=this.g.get(c);return u?t.provideFollowups(u,h):Promise.resolve([])}$acceptFeedback(o,c,h,t,u){const i=this.b.get(o);if(!i)return;const g=this.h.get(c)?.get(h);if(!g)return;let m;switch(t){case w.InteractiveSessionVoteDirection.Down:m=p.ChatAgentResultFeedbackKind.Unhelpful;break;case w.InteractiveSessionVoteDirection.Up:m=p.ChatAgentResultFeedbackKind.Helpful;break}i.acceptFeedback(Object.freeze(u?{result:g,kind:m,reportIssue:u}:{result:g,kind:m}))}$acceptAction(o,c,h,t){const u=this.b.get(o);if(!u)return;const i=this.h.get(c)?.get(h);i&&t.action.kind!=="vote"&&u.acceptAction(Object.freeze({action:t.action,result:i}))}async $invokeCompletionProvider(o,c,h){const t=this.b.get(o);return t?(await t.invokeCompletionProvider(c,h)).map(l.ChatAgentCompletionItem.from):[]}}e.$hgc=a;class r{constructor(o,c,h,t,u){this.extension=o,this.t=c,this.u=h,this.w=t,this.x=u,this.o=new L.$Vd,this.q=new L.$Vd}acceptFeedback(o){this.o.fire(o)}acceptAction(o){this.q.fire(o)}async invokeCompletionProvider(o,c){return this.s?await this.s.provider.provideCompletionItems(o,c)??[]:[]}async validateSlashCommand(o){this.b||(await this.provideSlashCommand(T.CancellationToken.None),(0,$.$Sf)(this.b));const c=this.b.find(h=>h.name===o);if(!c)throw new Error(`Unknown slashCommand: ${o}`);return c}async provideSlashCommand(o){if(!this.a)return[];const c=await this.a.provideSlashCommands(o);return c?(this.b=c,c.map(h=>({name:h.name,description:h.description,followupPlaceholder:h.followupPlaceholder,shouldRepopulate:h.shouldRepopulate,sampleRequest:h.sampleRequest}))):[]}async provideFollowups(o,c){if(!this.d)return[];const h=await this.d.provideFollowups(o,c);return h?h.map(t=>l.ChatFollowup.from(t)):[]}get apiAgent(){let o=!1,c=!1;const h=()=>{o||c||(c=!0,queueMicrotask(()=>{this.u.$updateAgent(this.w,{description:this.g??"",fullName:this.h,icon:this.i?this.i instanceof f.URI?this.i:"light"in this.i?this.i.light:void 0:void 0,iconDark:this.i&&"dark"in this.i?this.i.dark:void 0,themeIcon:this.i instanceof p.$3L?this.i:void 0,hasSlashCommands:this.a!==void 0,hasFollowups:this.d!==void 0,isDefault:this.j,isSecondary:this.n,helpTextPrefix:!this.k||typeof this.k=="string"?this.k:l.MarkdownString.from(this.k),helpTextPostfix:!this.l||typeof this.l=="string"?this.l:l.MarkdownString.from(this.l),sampleRequest:this.m,supportIssueReporting:this.r}),c=!1}))},t=this;return{get name(){return t.t},get description(){return t.g??""},set description(u){t.g=u,h()},get fullName(){return t.h??t.extension.displayName??t.extension.name},set fullName(u){t.h=u,h()},get iconPath(){return t.i},set iconPath(u){t.i=u,h()},get slashCommandProvider(){return t.a},set slashCommandProvider(u){t.a=u,h()},get followupProvider(){return t.d},set followupProvider(u){t.d=u,h()},get isDefault(){return(0,s.$CF)(t.extension,"defaultChatAgent"),t.j},set isDefault(u){(0,s.$CF)(t.extension,"defaultChatAgent"),t.j=u,h()},get helpTextPrefix(){return(0,s.$CF)(t.extension,"defaultChatAgent"),t.k},set helpTextPrefix(u){if((0,s.$CF)(t.extension,"defaultChatAgent"),!t.j)throw new Error("helpTextPrefix is only available on the default chat agent");t.k=u,h()},get helpTextPostfix(){return(0,s.$CF)(t.extension,"defaultChatAgent"),t.l},set helpTextPostfix(u){if((0,s.$CF)(t.extension,"defaultChatAgent"),!t.j)throw new Error("helpTextPostfix is only available on the default chat agent");t.l=u,h()},get isSecondary(){return(0,s.$CF)(t.extension,"defaultChatAgent"),t.n},set isSecondary(u){(0,s.$CF)(t.extension,"defaultChatAgent"),t.n=u,h()},get sampleRequest(){return t.m},set sampleRequest(u){t.m=u,h()},get supportIssueReporting(){return(0,s.$CF)(t.extension,"chatAgents2Additions"),t.r},set supportIssueReporting(u){(0,s.$CF)(t.extension,"chatAgents2Additions"),t.r=u,h()},get onDidReceiveFeedback(){return t.o.event},set agentVariableProvider(u){if(t.s=u,u){if(!u.triggerCharacters.length)throw new Error("triggerCharacters are required");t.u.$registerAgentCompletionsProvider(t.w,u.triggerCharacters)}else t.u.$unregisterAgentCompletionsProvider(t.w)},get agentVariableProvider(){return t.s},onDidPerformAction:(0,s.$BF)(this.extension,"chatAgents2Additions")?this.q.event:void 0,dispose(){o=!0,t.a=void 0,t.d=void 0,t.o.dispose(),t.u.$unregisterAgent(t.w)}}}invoke(o,c,h,t){return this.x(o,c,h,t)}}}),define(Pe[235],Re([1,0,20,6,3,8,72,22,13,5]),function(ge,e,y,T,C,L,R,$,f,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ggc=void 0;class A{constructor(w,s){this.stream=new f.$wh,this.stream=s??new f.$wh;const a=this;this.apiObj={option:w,response:a.stream.asyncIterable}}}class k{constructor(w,s){this.a=new b.$Vd,this.b=new Map,this.c=new f.$wh,this.d=!1;const a=this;this.apiObject={result:w,response:a.c.asyncIterable,onDidStartResponseStream:a.a.event,cancel(){s.cancel()}},w.finally(()=>{if(this.d=!0,this.b.size>0)for(const[,r]of this.b)r.stream.resolve();else this.c.resolve()})}handleFragment(w){if(this.d)return;let s=this.b.get(w.index);s||(this.b.size===0?s=new A(w.index,this.c):s=new A(w.index),this.b.set(w.index,s),this.a.fire(s.apiObj)),s.stream.emitOne(w.part)}}class l{static{this.a=1}constructor(w,s){this.d=s,this.c=new Map,this.e=new Map,this.f=new $.$nm,this.b=w.getProxy(C.$6K.MainThreadChatProvider)}registerProvider(w,s,a,r){const n=l.a++;return this.c.set(n,{extension:w,provider:a}),this.b.$registerProvider(n,s,{extension:w,model:r.name??""}),(0,T.$Rc)(()=>{this.b.$unregisterProvider(n),this.c.delete(n)})}async $provideChatResponse(w,s,a,r,n){const o=this.c.get(w);if(!o)return;const c=new R.$vv(async h=>{if(n.isCancellationRequested){this.d.warn(`[CHAT](${o.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(s,{index:h.index,part:h.part})});return o.provider.provideChatResponse(a.map(L.ChatMessage.to),r,c,n)}allowListExtensionWhile(w,s){this.f.set(w,s),s.finally(()=>this.f.delete(w))}async requestChatResponseProvider(w,s){if(!this.f.has(w))throw new Error("Extension is NOT allowed to make chat requests");const a=await this.b.$prepareChatAccess(s);if(!a)throw new Error(`ChatAccess '${s}' NOT found`);const r=this;return{get model(){return a.model},get isRevoked(){return!r.f.has(w)},makeRequest(n,o,c){if(!r.f.has(w))throw new Error("Access to chat has been revoked");const h=new y.$6d(c),t=Math.random()*1e6|0,u=r.b.$fetchResponse(w,s,t,n.map(L.ChatMessage.from),o??{},h.token),i=new k(u,h);return r.e.set(t,{res:i}),u.finally(()=>{r.e.delete(t)}),i.apiObject}}}async $handleResponseFragment(w,s){const a=this.e.get(w);a&&a.res.handleFragment(s)}}e.$ggc=l}),define(Pe[236],Re([1,0,6,3,15,8]),function(ge,e,y,T,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$igc=void 0;class R{static{this.a=0}constructor(f){this.b=new Map,this.c=f.getProxy(T.$6K.MainThreadChatVariables)}async $resolveVariable(f,b,A){const k=this.b.get(f);if(k)try{const l=await k.resolver.resolve(k.data.name,{prompt:b},A);if(l)return l.map(L.ChatVariable.from)}catch(l){(0,C.$2)(l)}}registerVariableResolver(f,b,A,k){const l=R.a++;return this.b.set(l,{extension:f.identifier,data:{name:b,description:A},resolver:k}),this.c.$registerVariable(l,{name:b,description:A}),(0,y.$Rc)(()=>{this.b.delete(l),this.c.$unregisterVariable(l)})}}e.$igc=R}),define(Pe[237],Re([1,0,3]),function(ge,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jgc=void 0;class T{constructor(L){const R=L.getProxy(y.$6K.MainThreadClipboard);this.value=Object.freeze({readText(){return R.$readText()},writeText($){return R.$writeText($)}})}}e.$jgc=T}),define(Pe[32],Re([1,0,16,7,8,26,3,18,14,51,29,92,2,6,4,17,108,24,49,40,60,56,59,33]),function(ge,e,y,T,C,L,R,$,f,b,A,k,l,p,w,s,a,r,n,o,c,h,t,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xN=e.$wN=e.$vN=e.$uN=e.$tN=e.$sN=void 0;let i=class{#e;#t;#i;constructor(v,E,D){this.b=new Map,this.c=new Map,this.#e=v.getProxy(R.$6K.MainThreadCommands),this.d=E,this.#i=D,this.#t=v.getProxy(R.$6K.MainThreadTelemetry),this.converter=new g(this,N=>{const O=this.c.get(N);return O?.result===d.Void?O:void 0},E),this.f=[{processArgument(N){return(0,b.$Ch)(N)}},{processArgument(N){return(0,L.$xn)(N,function(O){if(A.$Us.isIRange(O))return C.Range.to(O);if(k.$Ts.isIPosition(O))return C.Position.to(O);if(A.$Us.isIRange(O.range)&&l.URI.isUri(O.uri))return C.location.to(O);if(O instanceof r.$je)return O.buffer.buffer;if(!Array.isArray(O))return O})}}]}registerArgumentProcessor(v){this.f.push(v)}registerApiCommand(v){const E=this.registerCommand(!1,v.id,async(...D)=>{const N=v.args.map((G,W)=>{if(!G.validate(D[W]))throw new Error(`Invalid argument '${G.name}' when running '${v.id}', received: ${typeof D[W]=="object"?JSON.stringify(D[W],null,"	"):D[W]} `);return G.convert(D[W])}),O=await this.executeCommand(v.internalId,...N);return v.result.convert(O,D,this.converter)},void 0,{description:v.description,args:v.args,returns:v.result.description});return this.c.set(v.id,v),new T.$8K(()=>{E.dispose(),this.c.delete(v.id)})}registerCommand(v,E,D,N,O,G){if(this.d.trace("ExtHostCommands#registerCommand",E),!E.trim().length)throw new Error("invalid id");if(this.b.has(E))throw new Error(`command '${E}' already exists`);return this.b.set(E,{callback:D,thisArg:N,metadata:O,extension:G}),v&&this.#e.$registerCommand(E),new T.$8K(()=>{this.b.delete(E)&&v&&this.#e.$unregisterCommand(E)})}executeCommand(v,...E){return this.d.trace("ExtHostCommands#executeCommand",v),this.g(v,E,!0)}async g(v,E,D){if(this.b.has(v))return this.#e.$fireCommandActivationEvent(v),this.h(v,E,!1);{let N=!1;const O=(0,L.$xn)(E,function(G){if(G instanceof T.$9K)return C.Position.from(G);if(G instanceof T.$0K)return C.Range.from(G);if(G instanceof T.$hL)return C.location.from(G);if(T.$tM.isNotebookRange(G))return C.NotebookRange.from(G);if(G instanceof ArrayBuffer)return N=!0,r.$je.wrap(new Uint8Array(G));if(G instanceof Uint8Array)return N=!0,r.$je.wrap(G);if(G instanceof r.$je)return N=!0,G;if(!Array.isArray(G))return G});try{const G=await this.#e.$executeCommand(v,N?new n.$Tv(O):O,D);return(0,b.$Ch)(G)}catch(G){if(G instanceof Error&&G.message==="$executeCommand:retry")return this.g(v,E,!1);throw G}}}async h(v,E,D){const N=this.b.get(v);if(!N)throw new Error("Unknown command");const{callback:O,thisArg:G,metadata:W}=N;if(W?.args)for(let P=0;P<W.args.length;P++)try{(0,y.$Zf)(E[P],W.args[P].constraint)}catch{throw new Error(`Running the contributed command: '${v}' failed. Illegal argument '${W.args[P].name}' - ${W.args[P].description}`)}const z=c.$Rd.create();try{return await O.apply(G,E)}catch(P){if(v===this.converter.delegatingCommandId){const I=this.converter.getActualCommand(...E);I&&(v=I.command)}if(this.d.error(P,v,N.extension?.identifier),!D)throw P;if(N.extension?.identifier){const I=this.#i.onExtensionError(N.extension.identifier,P);this.d.trace("forwarded error to extension?",I,N.extension?.identifier)}throw new class extends Error{constructor(){super((0,o.$Qi)(P)),this.id=v,this.source=N.extension?.displayName??N.extension?.name}}}finally{this.j(N,v,z.elapsed())}}j(v,E,D){v.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:v.extension.identifier.value,id:new h.$Lo(E),duration:D})}$executeContributedCommand(v,...E){this.d.trace("ExtHostCommands#$executeContributedCommand",v);const D=this.b.get(v);return D?(E=E.map(N=>this.f.reduce((O,G)=>G.processArgument(O,D.extension?.identifier),N)),this.h(v,E,!0)):Promise.reject(new Error(`Contributed command '${v}' does not exist.`))}getCommands(v=!1){return this.d.trace("ExtHostCommands#getCommands",v),this.#e.$getCommands().then(E=>(v&&(E=E.filter(D=>D[0]!=="_")),E))}$getContributedCommandMetadata(){const v=Object.create(null);for(const[E,D]of this.b){const{metadata:N}=D;N&&(v[E]=N)}return Promise.resolve(v)}};e.$sN=i,e.$sN=i=Je([Ke(0,s.$0M),Ke(1,f.$nj),Ke(2,t.$rN)],i),e.$tN=(0,w.$6h)("IExtHostCommands");class g{constructor(v,E,D){this.d=v,this.f=E,this.g=D,this.delegatingCommandId=`__vsc${(0,u.$qg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(v,E){if(!v)return;const D={$ident:void 0,id:v.command,title:v.title,tooltip:v.tooltip};if(!v.command)return D;const N=this.f(v.command);if(N)D.id=N.internalId,D.arguments=N.args.map((O,G)=>O.convert(v.arguments&&v.arguments[G]));else if((0,$.$Lb)(v.arguments)){const O=`${v.command} /${++this.c}`;this.b.set(O,v),E.add((0,p.$Rc)(()=>{this.b.delete(O),this.g.trace("CommandsConverter#DISPOSE",O)})),D.$ident=O,D.id=this.delegatingCommandId,D.arguments=[O],this.g.trace("CommandsConverter#CREATE",v.command,O)}return D}fromInternal(v){return typeof v.$ident=="string"?this.b.get(v.$ident):{command:v.id,title:v.title,arguments:v.arguments}}getActualCommand(...v){return this.b.get(v[0])}h(...v){const E=this.getActualCommand(...v);return this.g.trace("CommandsConverter#EXECUTE",v[0],E?E.command:"MISSING"),E?this.d.executeCommand(E.command,...E.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${v[0]}`)}}e.$uN=g;class m{static{this.Uri=new m("uri","Uri of a text document",v=>l.URI.isUri(v),v=>v)}static{this.Position=new m("position","A position in a text document",v=>T.$9K.isPosition(v),C.Position.from)}static{this.Range=new m("range","A range in a text document",v=>T.$0K.isRange(v),C.Range.from)}static{this.Selection=new m("selection","A selection in a text document",v=>T.$$K.isSelection(v),C.Selection.from)}static{this.Number=new m("number","",v=>typeof v=="number",v=>v)}static{this.String=new m("string","",v=>typeof v=="string",v=>v)}static{this.StringArray=m.Arr(m.String)}static Arr(v){return new m(`${v.name}_array`,`Array of ${v.name}, ${v.description}`,E=>Array.isArray(E)&&E.every(D=>v.validate(D)),E=>E.map(D=>v.convert(D)))}static{this.CallHierarchyItem=new m("item","A call hierarchy item",v=>v instanceof T.$sL,C.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new m("item","A type hierarchy item",v=>v instanceof T.$MM,C.TypeHierarchyItem.from)}static{this.TestItem=new m("testItem","A VS Code TestItem",v=>v instanceof a.$kN,C.TestItem.from)}constructor(v,E,D,N){this.name=v,this.description=E,this.validate=D,this.convert=N}optional(){return new m(this.name,`(optional) ${this.description}`,v=>v==null||this.validate(v),v=>v===void 0?void 0:v===null?null:this.convert(v))}with(v,E){return new m(v??this.name,E??this.description,this.validate,this.convert)}}e.$vN=m;class d{static{this.Void=new d("no result",v=>v)}constructor(v,E){this.description=v,this.convert=E}}e.$wN=d;class S{constructor(v,E,D,N,O){this.id=v,this.internalId=E,this.description=D,this.args=N,this.result=O}}e.$xN=S}),define(Pe[238],Re([1,0,18,12,2,80,96,35,32,8,7]),function(ge,e,y,T,C,L,R,$,f,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cgc=void 0;const k=[new f.$xN("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[f.$vN.Uri,f.$vN.Position],new f.$wN("A promise that resolves to an array of DocumentHighlight-instances.",p(b.DocumentHighlight.to))),new f.$xN("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[f.$vN.Uri],new f.$wN("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(s,a)=>{if((0,y.$Kb)(s))return;class r extends A.$nL{static to(o){const c=new r(o.name,b.SymbolKind.to(o.kind),o.containerName||"",new A.$hL(a[0],b.Range.to(o.range)));return c.detail=o.detail,c.range=c.location.range,c.selectionRange=b.Range.to(o.selectionRange),c.children=o.children?o.children.map(r.to):[],c}}return s.map(r.to)})),new f.$xN("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[f.$vN.Uri,new f.$vN("options","Formatting options",s=>!0,s=>s)],new f.$wN("A promise that resolves to an array of TextEdits.",p(b.TextEdit.to))),new f.$xN("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[f.$vN.Uri,f.$vN.Range,new f.$vN("options","Formatting options",s=>!0,s=>s)],new f.$wN("A promise that resolves to an array of TextEdits.",p(b.TextEdit.to))),new f.$xN("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[f.$vN.Uri,f.$vN.Position,new f.$vN("ch","Trigger character",s=>typeof s=="string",s=>s),new f.$vN("options","Formatting options",s=>!0,s=>s)],new f.$wN("A promise that resolves to an array of TextEdits.",p(b.TextEdit.to))),new f.$xN("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[f.$vN.Uri,f.$vN.Position],new f.$wN("A promise that resolves to an array of Location or LocationLink instances.",w)),new f.$xN("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[f.$vN.Uri,f.$vN.Position],new f.$wN("A promise that resolves to an array of Location or LocationLink instances.",w)),new f.$xN("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[f.$vN.Uri,f.$vN.Position],new f.$wN("A promise that resolves to an array of Location or LocationLink instances.",w)),new f.$xN("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[f.$vN.Uri,f.$vN.Position],new f.$wN("A promise that resolves to an array of Location or LocationLink instances.",w)),new f.$xN("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[f.$vN.Uri,f.$vN.Position],new f.$wN("A promise that resolves to an array of Location-instances.",p(b.location.to))),new f.$xN("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[f.$vN.Uri,f.$vN.Position],new f.$wN("A promise that resolves to an array of Hover-instances.",p(b.Hover.to))),new f.$xN("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[f.$vN.Uri,new f.$vN("position","A position in a text document",s=>Array.isArray(s)&&s.every(a=>A.$9K.isPosition(a)),s=>s.map(b.Position.from))],new f.$wN("A promise that resolves to an array of ranges.",s=>s.map(a=>{let r;for(const n of a.reverse())r=new A.$rL(b.Range.to(n),r);return r}))),new f.$xN("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[f.$vN.String.with("query","Search string")],new f.$wN("A promise that resolves to an array of SymbolInformation-instances.",s=>s.map(b.WorkspaceSymbol.to))),new f.$xN("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[f.$vN.Uri,f.$vN.Position],new f.$wN("A promise that resolves to an array of CallHierarchyItem-instances",s=>s.map(b.CallHierarchyItem.to))),new f.$xN("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[f.$vN.CallHierarchyItem],new f.$wN("A promise that resolves to an array of CallHierarchyIncomingCall-instances",s=>s.map(b.CallHierarchyIncomingCall.to))),new f.$xN("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[f.$vN.CallHierarchyItem],new f.$wN("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",s=>s.map(b.CallHierarchyOutgoingCall.to))),new f.$xN("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[f.$vN.Uri,f.$vN.Position],new f.$wN("A promise that resolves to a range and placeholder text.",s=>{if(s)return{range:b.Range.to(s.range),placeholder:s.text}})),new f.$xN("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[f.$vN.Uri,f.$vN.Position,f.$vN.String.with("newName","The new symbol name")],new f.$wN("A promise that resolves to a WorkspaceEdit.",s=>{if(s){if(s.rejectReason)throw new Error(s.rejectReason);return b.WorkspaceEdit.to(s)}})),new f.$xN("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[f.$vN.Uri,f.$vN.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new f.$wN("A promise that resolves to an array of DocumentLink-instances.",s=>s.map(b.DocumentLink.to))),new f.$xN("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[f.$vN.Uri],new f.$wN("A promise that resolves to SemanticTokensLegend.",s=>{if(s)return new A.$lM(s.tokenTypes,s.tokenModifiers)})),new f.$xN("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[f.$vN.Uri],new f.$wN("A promise that resolves to SemanticTokens.",s=>{if(!s)return;const a=(0,R.$t$)(s);if(a.type==="full")return new A.$nM(a.data,void 0)})),new f.$xN("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[f.$vN.Uri,f.$vN.Range.optional()],new f.$wN("A promise that resolves to SemanticTokensLegend.",s=>{if(s)return new A.$lM(s.tokenTypes,s.tokenModifiers)})),new f.$xN("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[f.$vN.Uri,f.$vN.Range],new f.$wN("A promise that resolves to SemanticTokens.",s=>{if(!s)return;const a=(0,R.$t$)(s);if(a.type==="full")return new A.$nM(a.data,void 0)})),new f.$xN("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[f.$vN.Uri,f.$vN.Position,f.$vN.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),f.$vN.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new f.$wN("A promise that resolves to a CompletionList-instance.",(s,a,r)=>{if(!s)return new A.$DL([]);const n=s.suggestions.map(o=>b.CompletionItem.to(o,r));return new A.$DL(n,s.incomplete)})),new f.$xN("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[f.$vN.Uri,f.$vN.Position,f.$vN.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new f.$wN("A promise that resolves to SignatureHelp.",s=>{if(s)return b.SignatureHelp.to(s)})),new f.$xN("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[f.$vN.Uri,f.$vN.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new f.$wN("A promise that resolves to an array of CodeLens-instances.",(s,a,r)=>p(n=>new A.$vL(b.Range.to(n.range),n.command&&r.fromInternal(n.command)))(s))),new f.$xN("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[f.$vN.Uri,new f.$vN("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",s=>A.$0K.isRange(s),s=>A.$$K.isSelection(s)?b.Selection.from(s):b.Range.from(s)),f.$vN.String.with("kind","Code action kind to return code actions for").optional(),f.$vN.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new f.$wN("A promise that resolves to an array of Command-instances.",(s,a,r)=>p(n=>{if(n._isSynthetic){if(!n.command)throw new Error("Synthetic code actions must have a command");return r.fromInternal(n.command)}else{const o=new A.$pL(n.title,n.kind?new A.$qL(n.kind):void 0);return n.edit&&(o.edit=b.WorkspaceEdit.to(n.edit)),n.command&&(o.command=r.fromInternal(n.command)),o.isPreferred=n.isPreferred,o}})(s))),new f.$xN("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[f.$vN.Uri],new f.$wN("A promise that resolves to an array of ColorInformation objects.",s=>s?s.map(a=>new A.$JL(b.Range.to(a.range),b.Color.to(a.color))):[])),new f.$xN("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new f.$vN("color","The color to show and insert",s=>s instanceof A.$IL,b.Color.from),new f.$vN("context","Context object with uri and range",s=>!0,s=>({uri:s.uri,range:b.Range.from(s.range)}))],new f.$wN("A promise that resolves to an array of ColorPresentation objects.",s=>s?s.map(b.ColorPresentation.to):[])),new f.$xN("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[f.$vN.Uri,f.$vN.Range],new f.$wN("A promise that resolves to an array of Inlay objects",(s,a,r)=>s.map(b.InlayHint.to.bind(void 0,r)))),new f.$xN("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[f.$vN.Uri],new f.$wN("A promise that resolves to an array of FoldingRange objects",(s,a)=>{if(s)return s.map(b.FoldingRange.to)})),new f.$xN("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new f.$wN("A promise that resolves to an array of NotebookContentProvider static info objects.",p(s=>({viewType:s.viewType,displayName:s.displayName,options:{transientOutputs:s.options.transientOutputs,transientCellMetadata:s.options.transientCellMetadata,transientDocumentMetadata:s.options.transientDocumentMetadata},filenamePattern:s.filenamePattern.map(a=>b.NotebookExclusiveDocumentPattern.to(a))})))),new f.$xN("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[f.$vN.Uri,f.$vN.Range,new f.$vN("context","An InlineValueContext",s=>s&&typeof s.frameId=="number"&&s.stoppedLocation instanceof A.$0K,s=>b.InlineValueContext.from(s))],new f.$wN("A promise that resolves to an array of InlineValue objects",s=>s.map(b.InlineValue.to))),new f.$xN("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new f.$vN("uriOrString","Uri-instance or string (only http/https)",s=>C.URI.isUri(s)||typeof s=="string"&&(0,T.$fg)(s,T.Schemas.http,T.Schemas.https),s=>s),new f.$vN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="number"||typeof s=="object",s=>s&&(typeof s=="number"?[b.ViewColumn.from(s),void 0]:[b.ViewColumn.from(s.viewColumn),b.TextEditorOpenOptions.from(s)])).optional(),f.$vN.String.with("label","").optional()],f.$wN.Void),new f.$xN("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[f.$vN.Uri.with("resource","Resource to open"),f.$vN.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new f.$vN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="number"||typeof s=="object",s=>s&&(typeof s=="number"?[b.ViewColumn.from(s),void 0]:[b.ViewColumn.from(s.viewColumn),b.TextEditorOpenOptions.from(s)])).optional()],f.$wN.Void),new f.$xN("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[f.$vN.Uri.with("left","Left-hand side resource of the diff editor"),f.$vN.Uri.with("right","Right-hand side resource of the diff editor"),f.$vN.String.with("title","Human readable title for the diff editor").optional(),new f.$vN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="object",s=>s&&[b.ViewColumn.from(s.viewColumn),b.TextEditorOpenOptions.from(s)]).optional()],f.$wN.Void),new f.$xN("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[f.$vN.String.with("title","Human readable title for the changes editor"),new f.$vN("resourceList","List of resources to compare",s=>{for(const a of s){if(a.length!==3)return!1;const[r,n,o]=a;if(!C.URI.isUri(r)||!C.URI.isUri(n)&&n!==void 0&&n!==null||!C.URI.isUri(o)&&o!==void 0&&o!==null)return!1}return!0},s=>s)],f.$wN.Void),new f.$xN("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[f.$vN.Uri,f.$vN.Position],new f.$wN("A promise that resolves to an array of TypeHierarchyItem-instances",s=>s.map(b.TypeHierarchyItem.to))),new f.$xN("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[f.$vN.TypeHierarchyItem],new f.$wN("A promise that resolves to an array of TypeHierarchyItem-instances",s=>s.map(b.TypeHierarchyItem.to))),new f.$xN("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[f.$vN.TypeHierarchyItem],new f.$wN("A promise that resolves to an array of TypeHierarchyItem-instances",s=>s.map(b.TypeHierarchyItem.to))),new f.$xN("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[f.$vN.TestItem],f.$wN.Void),new f.$xN("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[f.$vN.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],f.$wN.Void),new f.$xN("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[f.$vN.String.with("name","The context key name"),new f.$vN("value","The context key value",()=>!0,s=>s)],f.$wN.Void),new f.$xN("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[f.$vN.Uri,f.$vN.StringArray,new f.$vN("MappedEditsContext","Mapped Edits Context",s=>b.MappedEditsContext.is(s),s=>b.MappedEditsContext.from(s))],new f.$wN("A promise that resolves to a workspace edit or null",s=>s?b.WorkspaceEdit.to(s):null))];class l{static register(a){k.forEach(a.registerApiCommand,a),this.a(a)}static a(a){a.registerCommand(!1,"_validateWhenClauses",$.$5i)}}e.$cgc=l;function p(s){return a=>{if(Array.isArray(a))return a.map(s)}}function w(s){if(!Array.isArray(s))return;const a=[];for(const r of s)L.$Gt(r)?a.push(b.DefinitionLink.to(r)):a.push(b.location.to(r));return a}}),define(Pe[239],Re([1,0,13,66,5,6,2,80,22,8,7,3,23]),function(ge,e,y,T,C,L,R,$,f,b,A,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mgc=void 0;function p(w,s,a){const r=w.getProxy(k.$6K.MainThreadComments);class n{static{this.a=0}constructor(){this.b=new Map,this.c=new f.$nm,s.registerArgumentProcessor({processArgument:d=>{if(d&&d.$mid===6){const S=this.b.get(d.handle);return S?S.value:d}else if(d&&d.$mid===7){const S=this.b.get(d.commentControlHandle);if(!S)return d;const M=S.getCommentThread(d.commentThreadHandle);return M?M.value:d}else if(d&&(d.$mid===9||d.$mid===8)){const S=this.b.get(d.thread.commentControlHandle);if(!S)return d;const M=S.getCommentThread(d.thread.commentThreadHandle);return M?d.$mid===8?M.value:{thread:M.value,text:d.text}:d}else if(d&&d.$mid===10){const S=this.b.get(d.thread.commentControlHandle);if(!S)return d;const M=S.getCommentThread(d.thread.commentThreadHandle);if(!M)return d;const v=d.commentUniqueId,E=M.getCommentByUniqueId(v);return E||d}else if(d&&d.$mid===11){const S=this.b.get(d.thread.commentControlHandle);if(!S)return d;const M=S.getCommentThread(d.thread.commentThreadHandle);if(!M)return d;const v=d.text,E=d.commentUniqueId,D=M.getCommentByUniqueId(E);return D?(typeof D.body=="string"?D.body=v:D.body=new A.$wL(v),D):d}return d}})}createCommentController(d,S,M){const v=n.a++,E=new c(d,v,S,M);this.b.set(E.handle,E);const D=this.c.get(d.identifier)||[];return D.push(E),this.c.set(d.identifier,D),E.value}async $createCommentThreadTemplate(d,S,M){const v=this.b.get(d);v&&v.$createCommentThreadTemplate(S,M)}async $updateCommentThreadTemplate(d,S,M){const v=this.b.get(d);v&&v.$updateCommentThreadTemplate(S,M)}$deleteCommentThread(d,S){this.b.get(d)?.$deleteCommentThread(S)}$provideCommentingRanges(d,S,M){const v=this.b.get(d);if(!v||!v.commentingRangeProvider)return Promise.resolve(void 0);const E=a.getDocument(R.URI.revive(S));return(0,y.$Yg)(async()=>{const D=await v.commentingRangeProvider.provideCommentingRanges(E,M);let N;return Array.isArray(D)?N={ranges:D,fileComments:!1}:D?N={ranges:D.ranges||[],fileComments:D.fileComments||!1}:N=D??void 0,N}).then(D=>{let N;return D&&(N={ranges:D.ranges.map(O=>b.Range.from(O)),fileComments:D.fileComments}),N})}$toggleReaction(d,S,M,v,E){const D=this.b.get(d);return!D||!D.reactionHandler?Promise.resolve(void 0):(0,y.$Yg)(()=>{const N=D.getCommentThread(S);if(N){const O=N.getCommentByUniqueId(v.uniqueIdInThread);if(D!==void 0&&O&&D.reactionHandler)return D.reactionHandler(O,u(E))}return Promise.resolve(void 0)})}}class o{static{this.a=0}set threadId(d){this.n=d}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(d){(d===void 0!=(this.p===void 0)||!d||!this.p||!d.isEqual(this.p))&&(this.p=d,this.b.range=d,this.c.fire())}get range(){return this.p}set canReply(d){this.d!==d&&(this.d=d,this.b.canReply=d,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(d){this.e=d,this.b.label=d,this.c.fire()}get contextValue(){return this.f}set contextValue(d){this.f=d,this.b.contextValue=d,this.c.fire()}get comments(){return this.q}set comments(d){this.q=d,this.b.comments=d,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(d){this.g=d,this.b.collapsibleState=d,this.c.fire()}get state(){return this.h}set state(d){this.h=d,this.b.state=d,this.c.fire()}get isDisposed(){return this.j}constructor(d,S,M,v,E,D,N,O){this.m=S,this.n=M,this.o=v,this.p=E,this.q=D,this.extensionDescription=N,this.r=O,this.handle=o.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new C.$Vd,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new L.$Uc,this.l.value=new L.$Sc,this.n===void 0&&(this.n=`${d}.${this.handle}`),r.$createCommentThread(S,this.handle,this.n,this.o,b.Range.from(this.p),N.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=D,this.i.push({dispose:()=>{r.$deleteCommentThread(S,this.handle)}});const G=this;this.value={get uri(){return G.uri},get range(){return G.range},set range(W){G.range=W},get comments(){return G.comments},set comments(W){G.comments=W},get collapsibleState(){return G.collapsibleState},set collapsibleState(W){G.collapsibleState=W},get canReply(){return G.canReply},set canReply(W){G.canReply=W},get contextValue(){return G.contextValue},set contextValue(W){G.contextValue=W},get label(){return G.label},set label(W){G.label=W},get state(){return G.state},set state(W){G.state=W},dispose:()=>{G.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new L.$Sc);const d=M=>Object.prototype.hasOwnProperty.call(this.b,M),S={};d("range")&&(S.range=b.Range.from(this.p)),d("label")&&(S.label=this.label),d("contextValue")&&(S.contextValue=this.contextValue??null),d("comments")&&(S.comments=this.q.map(M=>h(this,M,this.k,this.extensionDescription))),d("collapsibleState")&&(S.collapseState=i(this.g)),d("canReply")&&(S.canReply=this.canReply),d("state")&&(S.state=g(this.h)),d("isTemplate")&&(S.isTemplate=this.r),this.b={},r.$updateCommentThread(this.m,this.handle,this.n,this.o,S)}getCommentByUniqueId(d){for(const S of this.k){const M=S[0],v=S[1];if(d===v)return M}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(d=>d.dispose())}}Je([(0,T.$yh)(100)],o.prototype,"eventuallyUpdateCommentThread",null);class c{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(d){this.b=d,r.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(d){this.c=d,r.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!d})}get options(){return this.d}set options(d){this.d=d,r.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(d,S,M,v){this.f=d,this.g=S,this.h=M,this.i=v,this.a=new Map,r.$registerCommentController(this.handle,M,v,this.f.identifier.value);const E=this;this.value=Object.freeze({id:E.id,label:E.label,get options(){return E.options},set options(D){E.options=D},get commentingRangeProvider(){return E.commentingRangeProvider},set commentingRangeProvider(D){E.commentingRangeProvider=D},get reactionHandler(){return E.reactionHandler},set reactionHandler(D){E.reactionHandler=D},createCommentThread(D,N,O){return E.createCommentThread(D,N,O).value},dispose:()=>{E.dispose()}}),this.e=[],this.e.push({dispose:()=>{r.$unregisterCommentController(this.handle)}})}createCommentThread(d,S,M){S===void 0&&(0,l.$CF)(this.f,"fileComments");const v=new o(this.id,this.handle,void 0,d,S,M,this.f,!1);return this.a.set(v.handle,v),v}$createCommentThreadTemplate(d,S){const M=new o(this.id,this.handle,void 0,R.URI.revive(d),b.Range.to(S),[],this.f,!0);return M.collapsibleState=$.CommentThreadCollapsibleState.Expanded,this.a.set(M.handle,M),M}$updateCommentThreadTemplate(d,S){const M=this.a.get(d);M&&(M.range=b.Range.to(S))}$deleteCommentThread(d){this.a.get(d)?.dispose(),this.a.delete(d)}getCommentThread(d){return this.a.get(d)}dispose(){this.a.forEach(d=>{d.dispose()}),this.e.forEach(d=>d.dispose())}}function h(m,d,S,M){let v=S.get(d);return v||(v=++m.commentHandle,S.set(d,v)),d.state!==void 0&&(0,l.$CF)(M,"commentsDraftState"),d.reactions?.some(E=>E.reactors!==void 0)&&(0,l.$CF)(M,"commentReactor"),{mode:d.mode,contextValue:d.contextValue,uniqueIdInThread:v,body:typeof d.body=="string"?d.body:b.MarkdownString.from(d.body),userName:d.author.name,userIconPath:d.author.iconPath,label:d.label,commentReactions:d.reactions?d.reactions.map(E=>t(E)):void 0,state:d.state,timestamp:d.timestamp?.toJSON()}}function t(m){return{label:m.label,iconPath:m.iconPath?b.$9M(m.iconPath):void 0,count:m.count,hasReacted:m.authorHasReacted,reactors:m.reactors&&m.reactors.length>0&&typeof m.reactors[0]!="string"?m.reactors.map(d=>d.name):m.reactors}}function u(m){return{label:m.label||"",count:m.count||0,iconPath:m.iconPath?R.URI.revive(m.iconPath):"",authorHasReacted:m.hasReacted||!1,reactors:m.reactors?.map(d=>({name:d}))}}function i(m){if(m!==void 0)switch(m){case A.CommentThreadCollapsibleState.Expanded:return $.CommentThreadCollapsibleState.Expanded;case A.CommentThreadCollapsibleState.Collapsed:return $.CommentThreadCollapsibleState.Collapsed}return $.CommentThreadCollapsibleState.Collapsed}function g(m){if(m!==void 0)switch(m){case A.CommentThreadState.Unresolved:return $.CommentThreadState.Unresolved;case A.CommentThreadState.Resolved:return $.CommentThreadState.Resolved}return $.CommentThreadState.Unresolved}return new n}e.$mgc=p}),define(Pe[240],Re([1,0,26,3,27,17]),function(ge,e,y,T,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aic=void 0;let R=class{constructor(A,k){this.a=A.getProxy(T.$6K.MainThreadConsole),this.b=k.consoleForward.includeStack,this.c=k.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(A,k){const l=this,p=console[A];Object.defineProperty(console,A,{set:()=>{},get:()=>function(){l.e(A,k,p,arguments)}})}e(A,k,l,p){this.a.$logExtensionHostMessage({type:"__$console",severity:k,arguments:f(p,this.b)}),this.c&&this.f(A,l,p)}};e.$aic=R,e.$aic=R=Je([Ke(0,L.$0M),Ke(1,C.$nN)],R);const $=1e5;function f(b,A){const k=[];if(b.length)for(let l=0;l<b.length;l++){let p=b[l];if(typeof p>"u")p="undefined";else if(p instanceof Error){const w=p;w.stack?p=w.stack:p=w.toString()}k.push(p)}if(A){const l=new Error().stack;l&&k.push({__$stack:l.split(`
`).slice(3).join(`
`)})}try{const l=(0,y.$An)(k);return l.length>$?"Output omitted for a large object that exceeds the limits":l}catch(l){return`Output omitted for an object that cannot be inspected ('${l.toString()}')`}}}),define(Pe[110],Re([1,0,2,3,7,4,17,14,18,11,19,23]),function(ge,e,y,T,C,L,R,$,f,b,A,k){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$dhc=e.$chc=void 0;let p=class{static{l=this}static{this.c=0}static{this.d=250}constructor(s,a){this.h=a,this.f=new Map,this.g=s.getProxy(T.$6K.MainThreadDecorations)}registerFileDecorationProvider(s,a){const r=l.c++;this.f.set(r,{provider:s,extensionDescription:a}),this.g.$registerDecorationProvider(r,a.identifier.value);const n=s.onDidChangeFileDecorations&&s.onDidChangeFileDecorations(o=>{if(!o){this.g.$onDidChange(r,null);return}const c=(0,f.$3b)(o);if(c.length<=l.d){this.g.$onDidChange(r,c);return}this.h.warn("[Decorations] CAPPING events from decorations provider",a.identifier.value,c.length);const h=c.map(i=>({uri:i,rank:(0,b.$Pe)(i.path,"/")})),t=(0,f.$zb)(h,(i,g)=>i.rank-g.rank||(0,b.$5e)(i.uri.path,g.uri.path)),u=[];e:for(const i of t){let g;for(const m of i){const d=(0,A.$mc)(m.uri.path);if(g!==d&&(g=d,u.push(m.uri)>=l.d))break e}}this.g.$onDidChange(r,u)});return new C.$8K(()=>{n?.dispose(),this.g.$unregisterDecorationProvider(r),this.f.delete(r)})}async $provideDecorations(s,a,r){if(!this.f.has(s))return Object.create(null);const n=Object.create(null),{provider:o,extensionDescription:c}=this.f.get(s);return await Promise.all(a.map(async h=>{try{const{uri:t,id:u}=h,i=await Promise.resolve(o.provideFileDecoration(y.URI.revive(t),r));if(!i)return;try{C.$rM.validate(i),i.badge&&typeof i.badge!="string"&&(0,k.$CF)(c,"codiconDecoration"),n[u]=[i.propagate,i.tooltip,i.badge,i.color]}catch(g){this.h.warn(`INVALID decoration from extension '${c.identifier.value}': ${g}`)}}catch(t){this.h.error(t)}})),n}};e.$chc=p,e.$chc=p=l=Je([Ke(0,R.$0M),Ke(1,$.$nj)],p),e.$dhc=(0,L.$6h)("IExtHostDecorations")}),define(Pe[241],Re([1,0,158,99,2,3,7,8,5,14,28,42]),function(ge,e,y,T,C,L,R,$,f,b,A,k){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$0fc=e.$9fc=void 0;class p{#e;#t;#i;constructor(a,r,n,o,c,h,t,u){this.d=a,this.e=r,this.f=n,this.g=o,this.h=c,this.c=!1,this.f=Math.max(o,n),this.#i=new A.$Ac(i=>h.getComparisonKey(i)),this.#e=t,this.#t=u}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(a,r){if(!a){this.clear();return}this.j();let n=[];if(C.URI.isUri(a)){if(!r){this.delete(a);return}this.#i.set(a,r.slice()),n=[a]}else if(Array.isArray(a)){n=[];let h;a=[...a].sort(p.k);for(const t of a){const[u,i]=t;if((!h||u.toString()!==h.toString())&&(h&&this.#i.get(h).length===0&&this.#i.delete(h),h=u,n.push(u),this.#i.set(u,[])),i)this.#i.get(u)?.push(...i);else{const g=this.#i.get(u);g&&(g.length=0)}}}if(this.#t.fire(n),!this.#e)return;const o=[];let c=0;for(const h of n){let t=[];const u=this.#i.get(h);if(u)if(u.length>this.g){t=[];const i=[R.DiagnosticSeverity.Error,R.DiagnosticSeverity.Warning,R.DiagnosticSeverity.Information,R.DiagnosticSeverity.Hint];e:for(let g=0;g<4;g++)for(const m of u)if(m.severity===i[g]&&t.push({...$.Diagnostic.from(m),modelVersionId:this.h(h)})===this.g)break e;t.push({severity:T.MarkerSeverity.Info,message:(0,y.localize)(0,null,u.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=u.map(i=>({...$.Diagnostic.from(i),modelVersionId:this.h(h)}));if(o.push([h,t]),c+=t.length,c>this.f)break}this.#e.$changeMany(this.e,o)}delete(a){this.j(),this.#t.fire([a]),this.#i.delete(a),this.#e?.$changeMany(this.e,[[a,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(a,r){this.j();for(const[n,o]of this)a.call(r,n,o,this)}*[Symbol.iterator](){this.j();for(const a of this.#i.keys())yield[a,this.get(a)]}get(a){this.j();const r=this.#i.get(a);return Array.isArray(r)?Object.freeze(r.slice(0)):[]}has(a){return this.j(),Array.isArray(this.#i.get(a))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(a,r){return a[0].toString()<r[0].toString()?-1:a[0].toString()>r[0].toString()?1:0}}e.$9fc=p;let w=class{static{l=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*l.d}static _mapper(a){const r=new A.$Ac;for(const n of a)r.set(n,n);return{uris:Object.freeze(Array.from(r.values()))}}constructor(a,r,n,o){this.j=r,this.k=n,this.l=o,this.g=new Map,this.h=new f.$Zd({merge:c=>c.flat(),delay:50}),this.onDidChangeDiagnostics=f.Event.map(this.h.event,l._mapper),this.f=a.getProxy(L.$6K.MainThreadDiagnostics)}createDiagnosticCollection(a,r){const{g:n,f:o,h:c,j:h,k:t,l:u}=this,i=new class{$changeMany(d,S){o.$changeMany(d,S),h.trace("[DiagnosticCollection] change many (extension, owner, uris)",a.value,d,S.length===0?"CLEARING":S)}$clear(d){o.$clear(d),h.trace("[DiagnosticCollection] remove all (extension, owner)",a.value,d)}dispose(){o.dispose()}};let g;if(!r)r="_generated_diagnostic_collection_name_#"+l.c++,g=r;else if(!n.has(r))g=r;else{this.j.warn(`DiagnosticCollection with name '${r}' does already exist.`);do g=r+l.c++;while(n.has(g))}return new class extends p{constructor(){super(r,g,l.e,l.d,d=>u.getDocument(d)?.version,t.extUri,i,c),n.set(g,this)}dispose(){super.dispose(),n.delete(g)}}}getDiagnostics(a){if(a)return this.m(a);{const r=new Map,n=[];for(const o of this.g.values())o.forEach((c,h)=>{let t=r.get(c.toString());typeof t>"u"&&(t=n.length,r.set(c.toString(),t),n.push([c,[]])),n[t][1]=n[t][1].concat(...h)});return n}}m(a){let r=[];for(const n of this.g.values())n.has(a)&&(r=r.concat(n.get(a)));return r}$acceptMarkersChange(a){if(!this.n){const r="_generated_mirror",n=new p(r,r,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,o=>{},this.k.extUri,void 0,this.h);this.g.set(r,n),this.n=n}for(const[r,n]of a)this.n.set(C.URI.revive(r),n.map($.Diagnostic.to))}};e.$0fc=w,e.$0fc=w=l=Je([Ke(1,b.$nj),Ke(2,k.$8fc)],w)}),define(Pe[242],Re([1,0,2,3,23]),function(ge,e,y,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ehc=void 0;class L{constructor($){this.a=$.getProxy(T.$6K.MainThreadDialogs)}showOpenDialog($,f){return f?.allowUIResources&&(0,C.$CF)($,"showLocal"),this.a.$showOpenDialog(f).then(b=>b?b.map(A=>y.URI.revive(A)):void 0)}showSaveDialog($){return this.a.$showSaveDialog($).then(f=>f?y.URI.revive(f):void 0)}}e.$ehc=L}),define(Pe[243],Re([1,0,15,2,7,3,12,20,11]),function(ge,e,y,T,C,L,R,$,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fhc=void 0;class b{static{this.a=0}constructor(k,l,p){this.d=l,this.e=p,this.b=new Map,this.c=k.getProxy(L.$6K.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(k,l){if(Object.keys(R.Schemas).indexOf(k)>=0)throw new Error(`scheme '${k}' already registered`);const p=b.a++;this.b.set(p,l),this.c.$registerTextContentProvider(p,k);let w;if(typeof l.onDidChange=="function"){let s;w=l.onDidChange(async a=>{if(a.scheme!==k){this.e.warn(`Provider for scheme '${k}' is firing event for schema '${a.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(a))return;s&&await s;const r=this.$provideTextDocumentContent(p,a).then(async n=>{if(!n&&typeof n!="string")return;const o=this.d.getDocument(a);if(!o)return;const c=(0,f.$Ze)(n);if(!o.equalLines(c))return this.c.$onVirtualDocumentChange(a,n)}).catch(y.$1).finally(()=>{s===r&&(s=void 0)});s=r})}return new C.$8K(()=>{this.b.delete(p)&&this.c.$unregisterTextContentProvider(p),w&&(w.dispose(),w=void 0)})}$provideTextDocumentContent(k,l){const p=this.b.get(k);return p?Promise.resolve(p.provideTextDocumentContent(T.URI.revive(l),$.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${l.scheme}`))}}e.$fhc=b}),define(Pe[244],Re([1,0,5,6,2,3,103,8,16,26,7]),function(ge,e,y,T,C,L,R,$,f,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6fc=void 0;class k{constructor(p,w){this.a=new y.$Vd,this.b=new y.$Vd,this.c=new y.$Vd,this.d=new y.$Vd,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new T.$Sc,this.h=new Map,this.f=p.getProxy(L.$6K.MainThreadDocuments),this.g=w,this.g.onDidRemoveDocuments(s=>{for(const a of s)this.b.fire(a.document)},void 0,this.e),this.g.onDidAddDocuments(s=>{for(const a of s)this.a.fire(a.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(p){if(!p)return;const w=this.g.getDocument(p);if(w)return w}getDocument(p){const w=this.getDocumentData(p);if(!w?.document)throw new Error(`Unable to retrieve document from URI '${p}'`);return w.document}ensureDocumentData(p){const w=this.g.getDocument(p);if(w)return Promise.resolve(w);let s=this.h.get(p.toString());return s||(s=this.f.$tryOpenDocument(p).then(a=>{this.h.delete(p.toString());const r=C.URI.revive(a);return(0,f.$Tf)(this.g.getDocument(r))},a=>(this.h.delete(p.toString()),Promise.reject(a))),this.h.set(p.toString(),s)),s}createDocumentData(p){return this.f.$tryCreateDocument(p).then(w=>C.URI.revive(w))}$acceptModelLanguageChanged(p,w){const s=C.URI.revive(p),a=this.g.getDocument(s);if(!a)throw new Error("unknown document");this.b.fire(a.document),a._acceptLanguageId(w),this.a.fire(a.document)}$acceptModelSaved(p){const w=C.URI.revive(p),s=this.g.getDocument(w);if(!s)throw new Error("unknown document");this.$acceptDirtyStateChanged(p,!1),this.d.fire(s.document)}$acceptDirtyStateChanged(p,w){const s=C.URI.revive(p),a=this.g.getDocument(s);if(!a)throw new Error("unknown document");a._acceptIsDirty(w),this.c.fire({document:a.document,contentChanges:[],reason:void 0})}$acceptModelChanged(p,w,s){const a=C.URI.revive(p),r=this.g.getDocument(a);if(!r)throw new Error("unknown document");r._acceptIsDirty(s),r.onEvents(w);let n;w.isUndoing?n=A.TextDocumentChangeReason.Undo:w.isRedoing&&(n=A.TextDocumentChangeReason.Redo),this.c.fire((0,b.$wn)({document:r.document,contentChanges:w.changes.map(o=>({range:$.Range.to(o.range),rangeOffset:o.rangeOffset,rangeLength:o.rangeLength,text:o.text})),reason:n}))}setWordDefinitionFor(p,w){(0,R.$_M)(p,w)}}e.$6fc=k}),define(Pe[61],Re([1,0,53,5,6,2,4,3,103,17,109,8,14,28,12,67,39]),function(ge,e,y,T,C,L,R,$,f,b,A,k,l,p,w,s,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iN=e.$hN=void 0;class r{constructor(c){this.value=c,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let n=class{constructor(c,h){this.h=c,this.i=h,this.a=null,this.b=new Map,this.c=new p.$Ac,this.d=new T.$Vd,this.e=new T.$Vd,this.f=new T.$Vd,this.g=new T.$Vd,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(c){this.acceptDocumentsAndEditorsDelta(c)}acceptDocumentsAndEditorsDelta(c){const h=[],t=[],u=[];if(c.removedDocuments)for(const i of c.removedDocuments){const g=L.URI.revive(i),m=this.c.get(g);m?.unref()&&(this.c.delete(g),h.push(m.value))}if(c.addedDocuments)for(const i of c.addedDocuments){const g=L.URI.revive(i.uri);let m=this.c.get(g);if(m&&g.scheme!==w.Schemas.vscodeNotebookCell&&g.scheme!==w.Schemas.vscodeInteractiveInput)throw new Error(`document '${g} already exists!'`);m||(m=new r(new f.$aN(this.h.getProxy($.$6K.MainThreadDocuments),g,i.lines,i.EOL,i.versionId,i.languageId,i.isDirty,i.notebook)),this.c.set(g,m),t.push(m.value)),m.ref()}if(c.removedEditors)for(const i of c.removedEditors){const g=this.b.get(i);this.b.delete(i),g&&u.push(g)}if(c.addedEditors)for(const i of c.addedEditors){const g=L.URI.revive(i.documentUri);y.ok(this.c.has(g),`document '${g}' does not exist`),y.ok(!this.b.has(i.id),`editor '${i.id}' already exists!`);const m=this.c.get(g).value,d=new A.$gN(i.id,this.h.getProxy($.$6K.MainThreadTextEditors),this.i,new a.$V(()=>m.document),i.selections.map(k.Selection.to),i.options,i.visibleRanges.map(S=>k.Range.to(S)),typeof i.editorPosition=="number"?k.ViewColumn.to(i.editorPosition):void 0);this.b.set(i.id,d)}c.newActiveEditor!==void 0&&(y.ok(c.newActiveEditor===null||this.b.has(c.newActiveEditor),`active editor '${c.newActiveEditor}' does not exist`),this.a=c.newActiveEditor),(0,C.$Oc)(h),(0,C.$Oc)(u),c.removedDocuments&&this.e.fire(h),c.addedDocuments&&this.d.fire(t),(c.removedEditors||c.addedEditors)&&this.f.fire(this.allEditors().map(i=>i.value)),c.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(c){return this.c.get(c)?.value}allDocuments(){return s.Iterable.map(this.c.values(),c=>c.value)}getEditor(c){return this.b.get(c)}activeEditor(c){if(!this.a)return;const h=this.b.get(this.a);return c?h:h?.value}allEditors(){return[...this.b.values()]}};e.$hN=n,e.$hN=n=Je([Ke(0,b.$0M),Ke(1,l.$nj)],n),e.$iN=(0,R.$6h)("IExtHostDocumentsAndEditors")}),define(Pe[62],Re([1,0,245,5,16,2,4,3,17,8,7]),function(ge,e,y,T,C,L,R,$,f,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ggc=e.$Fgc=void 0,e.$Fgc=(0,R.$6h)("IExtHostEditorTabs");class k{constructor(a,r,n){this.e=n,this.d=r,this.acceptDtoUpdate(a)}get apiObject(){if(!this.a){const a=this,r={get isActive(){return a.b.id===a.e()},get label(){return a.b.label},get input(){return a.c},get isDirty(){return a.b.isDirty},get isPinned(){return a.b.isPinned},get isPreview(){return a.b.isPreview},get group(){return a.d.apiObject}};this.a=Object.freeze(r)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(a){this.b=a,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new A.$NM(L.URI.revive(this.b.input.uri));case 2:return new A.$OM(L.URI.revive(this.b.input.original),L.URI.revive(this.b.input.modified));case 3:return new A.$PM(L.URI.revive(this.b.input.base),L.URI.revive(this.b.input.input1),L.URI.revive(this.b.input.input2),L.URI.revive(this.b.input.result));case 6:return new A.$QM(L.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new A.$RM(this.b.input.viewType);case 4:return new A.$SM(L.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new A.$TM(L.URI.revive(this.b.input.original),L.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new A.$UM;case 9:return new A.$VM(L.URI.revive(this.b.input.uri),L.URI.revive(this.b.input.inputBoxUri));case 10:return new A.$WM(this.b.input.providerId);default:return}}}class l{constructor(a,r){this.c=[],this.d="",this.b=a,this.e=r;for(const n of a.tabs)n.isActive&&(this.d=n.id),this.c.push(new k(n,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const a=this,r={get isActive(){return a.b.groupId===a.e()},get viewColumn(){return b.ViewColumn.to(a.b.viewColumn)},get activeTab(){return a.c.find(n=>n.tabId===a.d)?.apiObject},get tabs(){return Object.freeze(a.c.map(n=>n.apiObject))}};this.a=Object.freeze(r)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(a){this.b=a}acceptTabOperation(a){if(a.kind===0){const n=new k(a.tabDto,this,()=>this.activeTabId());return this.c.splice(a.index,0,n),a.tabDto.isActive&&(this.d=n.tabId),n}else if(a.kind===1){const n=this.c.splice(a.index,1)[0];if(!n)throw new Error(`Tab close updated received for index ${a.index} which does not exist`);return n.tabId===this.d&&(this.d=""),n}else if(a.kind===3){if(a.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const n=this.c.splice(a.oldIndex,1)[0];if(!n)throw new Error(`Tab move updated received for index ${a.oldIndex} which does not exist`);return this.c.splice(a.index,0,n),n}const r=this.c.find(n=>n.tabId===a.tabDto.id);if(!r)throw new Error("INVALID tab");return a.tabDto.isActive?this.d=a.tabDto.id:this.d===a.tabDto.id&&!a.tabDto.isActive&&(this.d=""),r.acceptDtoUpdate(a.tabDto),r}activeTabId(){return this.d}}let p=class{constructor(a){this.b=new T.$Vd,this.c=new T.$Vd,this.e=[],this.a=a.getProxy($.$6K.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const a=this,r={onDidChangeTabGroups:a.c.event,onDidChangeTabs:a.b.event,get all(){return Object.freeze(a.e.map(n=>n.apiObject))},get activeTabGroup(){const n=a.d;return(0,C.$Tf)(a.e.find(c=>c.groupId===n)?.apiObject)},close:async(n,o)=>{const c=Array.isArray(n)?n:[n];return c.length?w(c[0])?this.j(c,o):this.i(c,o):!0}};this.f=Object.freeze(r)}return this.f}$acceptEditorTabModel(a){const r=new Set(this.e.map(i=>i.groupId)),n=new Set(a.map(i=>i.groupId)),o=(0,y.$L)(r,n),c=this.e.filter(i=>o.removed.includes(i.groupId)).map(i=>i.apiObject),h=[],t=[];this.e=a.map(i=>{const g=new l(i,()=>this.d);return o.added.includes(g.groupId)?h.push(g.apiObject):t.push(g.apiObject),g});const u=(0,C.$Tf)(a.find(i=>i.isActive===!0)?.groupId);u!==void 0&&this.d!==u&&(this.d=u),this.c.fire(Object.freeze({opened:h,closed:c,changed:t}))}$acceptTabGroupUpdate(a){const r=this.e.find(n=>n.groupId===a.groupId);if(!r)throw new Error("Update Group IPC call received before group creation.");r.acceptGroupDtoUpdate(a),a.isActive&&(this.d=a.groupId),this.c.fire(Object.freeze({changed:[r.apiObject],opened:[],closed:[]}))}$acceptTabOperation(a){const r=this.e.find(o=>o.groupId===a.groupId);if(!r)throw new Error("Update Tabs IPC call received before group creation.");const n=r.acceptTabOperation(a);switch(a.kind){case 0:this.b.fire(Object.freeze({opened:[n.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[n.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[n.apiObject]}));return}}g(a){for(const r of this.e)for(const n of r.tabs)if(n.apiObject===a)return n}h(a){return this.e.find(r=>r.apiObject===a)}async i(a,r){const n=[];for(const o of a){const c=this.g(o);if(!c)throw new Error("Tab close: Invalid tab not found!");n.push(c.tabId)}return this.a.$closeTab(n,r)}async j(a,r){const n=[];for(const o of a){const c=this.h(o);if(!c)throw new Error("Group close: Invalid group not found!");n.push(c.groupId)}return this.a.$closeGroup(n,r)}};e.$Ggc=p,e.$Ggc=p=Je([Ke(0,f.$0M)],p);function w(s){return s.tabs!==void 0}}),define(Pe[246],Re([1,0,3,7]),function(ge,e,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hhc=void 0;class C{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(y.$6K.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(R,$,f){if(this.a.size===0)throw new Error("No embedding vector providers registered");const b=this.a.get(R);if(!b)throw new Error("Embedding vector provider not found");const A=await b.provideEmbeddingVector($,f);if(!A)throw new Error("Embedding vector provider returned undefined");return A}registerEmbeddingVectorProvider(R,$,f){const b=this.b;return this.b++,this.a.set(b,f),this.c.$registerAiEmbeddingVectorProvider($,b),new T.$8K(()=>{this.c.$unregisterAiEmbeddingVectorProvider(b),this.a.delete(b)})}}e.$hhc=C}),define(Pe[247],Re([1,0,2,3,6,7,8,295,11,24,23,52]),function(ge,e,y,T,C,L,R,$,f,b,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ihc=void 0;class l{constructor(){this.a=[]}add(s){this.b=void 0,this.a.push(s)}delete(s){const a=this.a.indexOf(s);a>=0&&(this.a.splice(a,1),this.b=void 0)}c(){if(!this.b){const s=this.a.sort(),a=[];let r,n,o=14,c=14;for(const h of s){let t=r?(0,f.$bf)(r,h):0;for(t===0?n=1:n=c;t<h.length;t++)t+1===h.length?(o=c,c=9):c+=1,a.push([n,h.toUpperCase().charCodeAt(t),c]),a.push([n,h.toLowerCase().charCodeAt(t),c]),n=c;r=h,c=o}a.push([9,58,10]),a.push([10,47,12]),this.b=new $.$uZ(a)}}provideDocumentLinks(s){this.c();const a=[],r=$.$vZ.computeLinks({getLineContent(n){return s.lineAt(n-1).text},getLineCount(){return s.lineCount}},this.b);for(const n of r){const o=R.DocumentLink.to(n);o.target&&a.push(o)}return a}}class p{constructor(s,a){this.i=a,this.b=new l,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=s.getProxy(T.$6K.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(s,a,r,n={}){if(p.j(r),this.d.has(a))throw new Error(`a provider for the scheme '${a}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(s,"*",this.b));const o=this.h++;this.b.add(a),this.d.add(a),this.c.set(o,r);let c=2;n.isCaseSensitive&&(c+=1024),n.isReadonly&&(c+=2048),typeof r.copy=="function"&&(c+=8),typeof r.open=="function"&&typeof r.close=="function"&&typeof r.read=="function"&&typeof r.write=="function"&&((0,A.$CF)(s,"fsChunks"),c+=4);let h;n.isReadonly&&(0,k.$jk)(n.isReadonly)&&(h={value:n.isReadonly.value,isTrusted:n.isReadonly.isTrusted,supportThemeIcons:n.isReadonly.supportThemeIcons,supportHtml:n.isReadonly.supportHtml,baseUri:n.isReadonly.baseUri,uris:n.isReadonly.uris}),this.a.$registerFileSystemProvider(o,a,c,h).catch(u=>{console.error(`FAILED to register filesystem provider of ${s.identifier.value}-extension for the scheme ${a}`),console.error(u)});const t=r.onDidChangeFile(u=>{const i=[];for(const g of u){const{uri:m,type:d}=g;if(m.scheme!==a)continue;let S;switch(d){case L.FileChangeType.Changed:S=0;break;case L.FileChangeType.Created:S=1;break;case L.FileChangeType.Deleted:S=2;break;default:throw new Error("Unknown FileChangeType")}i.push({resource:m,type:S})}this.a.$onFileSystemChange(o,i)});return(0,C.$Rc)(()=>{t.dispose(),this.b.delete(a),this.d.delete(a),this.c.delete(o),this.a.$unregisterProvider(o)})}static j(s){if(!s)throw new Error("MISSING provider");if(typeof s.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof s.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof s.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof s.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof s.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof s.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof s.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof s.rename!="function")throw new Error("Provider does NOT implement rename")}static k(s){const{type:a,ctime:r,mtime:n,size:o,permissions:c}=s;return{type:a,ctime:r,mtime:n,size:o,permissions:c}}$stat(s,a){return Promise.resolve(this.l(s).stat(y.URI.revive(a))).then(r=>p.k(r))}$readdir(s,a){return Promise.resolve(this.l(s).readDirectory(y.URI.revive(a)))}$readFile(s,a){return Promise.resolve(this.l(s).readFile(y.URI.revive(a))).then(r=>b.$je.wrap(r))}$writeFile(s,a,r,n){return Promise.resolve(this.l(s).writeFile(y.URI.revive(a),r.buffer,n))}$delete(s,a,r){return Promise.resolve(this.l(s).delete(y.URI.revive(a),r))}$rename(s,a,r,n){return Promise.resolve(this.l(s).rename(y.URI.revive(a),y.URI.revive(r),n))}$copy(s,a,r,n){const o=this.l(s);if(!o.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(o.copy(y.URI.revive(a),y.URI.revive(r),n))}$mkdir(s,a){return Promise.resolve(this.l(s).createDirectory(y.URI.revive(a)))}$watch(s,a,r,n){const o=this.l(s).watch(y.URI.revive(r),n);this.f.set(a,o)}$unwatch(s,a){const r=this.f.get(a);r&&(r.dispose(),this.f.delete(a))}$open(s,a,r){const n=this.l(s);if(!n.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(n.open(y.URI.revive(a),r))}$close(s,a){const r=this.l(s);if(!r.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(r.close(a))}$read(s,a,r,n){const o=this.l(s);if(!o.read)throw new Error('FileSystemProvider does not implement "read"');const c=b.$je.alloc(n);return Promise.resolve(o.read(a,r,c.buffer,0,n)).then(h=>c.slice(0,h))}$write(s,a,r,n){const o=this.l(s);if(!o.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(o.write(a,r,n.buffer,0,n.byteLength))}l(s){const a=this.c.get(s);if(!a){const r=new Error;throw r.name="ENOPRO",r.message="no provider",r}return a}}e.$ihc=p}),define(Pe[63],Re([1,0,3,41,7,24,4,17,42,6,13,25,12]),function(ge,e,y,T,C,L,R,$,f,b,A,k,l){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$vgc=e.$ugc=void 0;let w=p=class{constructor(a,r){this.b=new Map,this.c=new A.$ch,this.a=a.getProxy(y.$6K.MainThreadFileSystem);const n=this;this.value=Object.freeze({async stat(o){try{let c;const h=n.b.get(o.scheme);return h?(await n.a.$ensureActivation(o.scheme),c=await h.impl.stat(o)):c=await n.a.$stat(o),{type:c.type,ctime:c.ctime,mtime:c.mtime,size:c.size,permissions:c.permissions===T.FilePermission.Readonly?1:void 0}}catch(c){p.e(c)}},async readDirectory(o){try{const c=n.b.get(o.scheme);return c?(await n.a.$ensureActivation(o.scheme),(await c.impl.readDirectory(o)).slice()):await n.a.$readdir(o)}catch(c){return p.e(c)}},async createDirectory(o){try{const c=n.b.get(o.scheme);return c&&!c.isReadonly?(await n.a.$ensureActivation(o.scheme),await n.d(c.impl,c.extUri,o)):await n.a.$mkdir(o)}catch(c){return p.e(c)}},async readFile(o){try{const c=n.b.get(o.scheme);return c?(await n.a.$ensureActivation(o.scheme),(await c.impl.readFile(o)).slice()):(await n.a.$readFile(o)).buffer}catch(c){return p.e(c)}},async writeFile(o,c){try{const h=n.b.get(o.scheme);return h&&!h.isReadonly?(await n.a.$ensureActivation(o.scheme),await n.d(h.impl,h.extUri,h.extUri.dirname(o)),await n.c.queueFor(o,()=>Promise.resolve(h.impl.writeFile(o,c,{create:!0,overwrite:!0})))):await n.a.$writeFile(o,L.$je.wrap(c))}catch(h){return p.e(h)}},async delete(o,c){try{const h=n.b.get(o.scheme);return h&&!h.isReadonly&&!c?.useTrash?(await n.a.$ensureActivation(o.scheme),await h.impl.delete(o,{recursive:!1,...c})):await n.a.$delete(o,{recursive:!1,useTrash:!1,atomic:!1,...c})}catch(h){return p.e(h)}},async rename(o,c,h){try{return await n.a.$rename(o,c,{overwrite:!1,...h})}catch(t){return p.e(t)}},async copy(o,c,h){try{return await n.a.$copy(o,c,{overwrite:!1,...h})}catch(t){return p.e(t)}},isWritableFileSystem(o){const c=r.getCapabilities(o);if(typeof c=="number")return!(c&2048)}})}async d(a,r,n){const o=[];for(;!r.isEqual(n,r.dirname(n));)try{if(!((await a.stat(n)).type&T.FileType.Directory))throw C.$jM.FileExists(`Unable to create folder '${n.scheme===l.Schemas.file?n.fsPath:n.toString(!0)}' that already exists but is not a directory`);break}catch(c){if(T.$Gk(c)!==T.FileSystemProviderErrorCode.FileNotFound)throw c;o.push(r.basename(n)),n=r.dirname(n)}for(let c=o.length-1;c>=0;c--){n=r.joinPath(n,o[c]);try{await a.createDirectory(n)}catch(h){if(T.$Gk(h)!==T.FileSystemProviderErrorCode.FileExists)throw h}}}static e(a){if(a instanceof C.$jM)throw a;if(a instanceof T.$Ck)switch(a.code){case T.FileSystemProviderErrorCode.FileExists:throw C.$jM.FileExists(a.message);case T.FileSystemProviderErrorCode.FileNotFound:throw C.$jM.FileNotFound(a.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw C.$jM.FileNotADirectory(a.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw C.$jM.FileIsADirectory(a.message);case T.FileSystemProviderErrorCode.NoPermissions:throw C.$jM.NoPermissions(a.message);case T.FileSystemProviderErrorCode.Unavailable:throw C.$jM.Unavailable(a.message);default:throw new C.$jM(a.message,a.name)}if(!(a instanceof Error))throw new C.$jM(String(a));if(a.name==="ENOPRO"||a.message.includes("ENOPRO"))throw C.$jM.Unavailable(a.message);switch(a.name){case T.FileSystemProviderErrorCode.FileExists:throw C.$jM.FileExists(a.message);case T.FileSystemProviderErrorCode.FileNotFound:throw C.$jM.FileNotFound(a.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw C.$jM.FileNotADirectory(a.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw C.$jM.FileIsADirectory(a.message);case T.FileSystemProviderErrorCode.NoPermissions:throw C.$jM.NoPermissions(a.message);case T.FileSystemProviderErrorCode.Unavailable:throw C.$jM.Unavailable(a.message);default:throw new C.$jM(a.message,a.name)}}addFileSystemProvider(a,r,n){return this.b.set(a,{impl:r,extUri:n?.isCaseSensitive?k.$xg:k.$zg,isReadonly:!!n?.isReadonly}),(0,b.$Rc)(()=>this.b.delete(a))}getFileSystemProviderExtUri(a){return this.b.get(a)?.extUri??k.$xg}};e.$ugc=w,e.$ugc=w=p=Je([Ke(0,$.$0M),Ke(1,f.$8fc)],w),e.$vgc=(0,R.$6h)("IExtHostConsumerFileSystem")}),define(Pe[248],Re([1,0,5,34,2,3,8,7,39]),function(ge,e,y,T,C,L,R,$,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jhc=void 0;class b{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(p,w,s,a,r,n){this.a=Math.random(),this.b=new y.$Vd,this.c=new y.$Vd,this.d=new y.$Vd,this.h=0,n?.ignoreCreateEvents&&(this.h+=1),n?.ignoreChangeEvents&&(this.h+=2),n?.ignoreDeleteEvents&&(this.h+=4);const o=(0,T.$Mj)(r),c=typeof r=="string",h=n?.correlate,t=a(u=>{if(!(typeof u.session=="number"&&u.session!==this.a)&&!(h&&typeof u.session>"u")){if(!n?.ignoreCreateEvents)for(const i of u.created){const g=C.URI.revive(i);o(g.fsPath)&&(!c||w.getWorkspaceFolder(g))&&this.b.fire(g)}if(!n?.ignoreChangeEvents)for(const i of u.changed){const g=C.URI.revive(i);o(g.fsPath)&&(!c||w.getWorkspaceFolder(g))&&this.c.fire(g)}if(!n?.ignoreDeleteEvents)for(const i of u.deleted){const g=C.URI.revive(i);o(g.fsPath)&&(!c||w.getWorkspaceFolder(g))&&this.d.fire(g)}}});this.g=$.$8K.from(this.i(p,s,r,n,n?.correlate),this.b,this.c,this.d,t)}i(p,w,s,a,r){const n=$.$8K.from();if(typeof s=="string")return n;const o=p.getProxy(L.$6K.MainThreadFileSystemEventService);let c=!1;return(s.pattern.includes(T.$Ij)||s.pattern.includes(T.$Jj))&&(c=!0),o.$watch(w.identifier.value,this.a,s.baseUri,{recursive:c,excludes:a?.excludes??[]},!!r),$.$8K.from({dispose:()=>o.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class A{constructor(p){this.a=p,this.session=this.a.session,this.b=new f.$V(()=>this.a.created.map(C.URI.revive)),this.c=new f.$V(()=>this.a.changed.map(C.URI.revive)),this.d=new f.$V(()=>this.a.deleted.map(C.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class k{constructor(p,w,s){this.j=p,this.k=w,this.l=s,this.a=new y.$Vd,this.b=new y.$Vd,this.c=new y.$Vd,this.d=new y.$Vd,this.g=new y.$Xd,this.h=new y.$Xd,this.i=new y.$Xd,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(p,w,s,a){return new b(this.j,p,w,this.a.event,R.GlobPattern.from(s),a)}$onFileEvent(p){this.a.fire(new A(p))}$onDidRunFileOperation(p,w){switch(p){case 2:this.b.fire(Object.freeze({files:w.map(s=>({oldUri:C.URI.revive(s.source),newUri:C.URI.revive(s.target)}))}));break;case 1:this.d.fire(Object.freeze({files:w.map(s=>C.URI.revive(s.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:w.map(s=>C.URI.revive(s.target))}));break;default:}}getOnWillRenameFileEvent(p){return this.m(p,this.g)}getOnWillCreateFileEvent(p){return this.m(p,this.h)}getOnWillDeleteFileEvent(p){return this.m(p,this.i)}m(p,w){return(s,a,r)=>{const n=function(c){s.call(a,c)};return n.extension=p,w.event(n,void 0,r)}}async $onWillRunFileOperation(p,w,s,a){switch(p){case 2:return await this.n(this.g,{files:w.map(r=>({oldUri:C.URI.revive(r.source),newUri:C.URI.revive(r.target)}))},s,a);case 1:return await this.n(this.i,{files:w.map(r=>C.URI.revive(r.target))},s,a);case 0:case 3:return await this.n(this.h,{files:w.map(r=>C.URI.revive(r.target))},s,a)}}async n(p,w,s,a){const r=new Set,n=[];if(await p.fireAsync(w,a,async(c,h)=>{const t=Date.now(),u=await Promise.resolve(c);u instanceof $.$fL&&(n.push([h.extension,u]),r.add(h.extension.displayName??h.extension.identifier.value)),Date.now()-t>s&&this.k.warn("SLOW file-participant",h.extension.identifier)}),a.isCancellationRequested||n.length===0)return;const o={edits:[]};for(const[,c]of n){const{edits:h}=R.WorkspaceEdit.from(c,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});o.edits=o.edits.concat(h)}return{edit:o,extensionNames:Array.from(r)}}}e.$jhc=k}),define(Pe[249],Re([1,0,6,2,3,8,7,32,13]),function(ge,e,y,T,C,L,R,$,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$khc=void 0;class b{static{this.a=0}constructor(p,w){this.extension=p,this.provider=w,this.handle=b.a++}}class A{constructor(p){this.session=p,this.responses=[]}}class k{static{this.a=0}constructor(p,w,s,a){this.f=s,this.g=a,this.b=new Map,this.d=new Map,this.e=p.getProxy(C.$6K.MainThreadInlineChat),w.registerApiCommand(new $.$xN("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new $.$vN("Run arguments","",r=>!0,r=>{if(r)return{initialRange:r.initialRange?L.Range.from(r.initialRange):void 0,initialSelection:r.initialSelection?L.Selection.from(r.initialSelection):void 0,message:r.message,autoSend:r.autoSend,position:r.position?L.Position.from(r.position):void 0}})],$.$wN.Void))}registerProvider(p,w,s){const a=new b(p,w);return this.b.set(a.handle,a),this.e.$registerInteractiveEditorProvider(a.handle,s?.label??p.displayName??p.name,p.identifier.value,typeof w.handleInteractiveEditorResponseFeedback=="function",typeof w.provideFollowups=="function",s?.supportReportIssue??!1),(0,y.$Rc)(()=>{this.e.$unregisterInteractiveEditorProvider(a.handle),this.b.delete(a.handle)})}async $prepareSession(p,w,s,a){const r=this.b.get(p);if(!r){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const n=this.f.getDocument(T.URI.revive(w)),o=L.Selection.to(s),c=await r.provider.prepareInteractiveEditorSession({document:n,selection:o},a);if(!c)return;if(c.wholeRange&&!c.wholeRange.contains(o))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const h=k.a++;return this.d.set(h,new A(c)),{id:h,placeholder:c.placeholder,input:c.input,slashCommands:c.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:L.Range.from(c.wholeRange),message:c.message}}async $provideResponse(p,w,s,a){const r=this.b.get(p);if(!r)return;const n=this.d.get(w.id);if(!n)return;const o={prompt:s.prompt,selection:L.Selection.to(s.selection),wholeRange:L.Range.to(s.wholeRange),attempt:s.attempt,live:s.live,withIntentDetection:s.withIntentDetection};let c=!1;const h={report:async M=>{if(!s.live&&M.edits?.length)throw new Error("Progress reporting is only supported for live sessions");c||a.isCancellationRequested||await this.e.$handleProgressChunk(s.requestId,{message:M.message,edits:M.edits?.map(L.TextEdit.from),editsShouldBeInstant:M.editsShouldBeInstant,slashCommand:M.slashCommand?.command,markdownFragment:R.$wL.isMarkdownString(M.content)?M.content.value:M.content})}},t=Promise.resolve(r.provider.provideInteractiveEditorResponse(n.session,o,h,a));let u;try{u=await(0,f.$Ug)(t,a)}finally{c=!0}if(!u)return;const i=n.responses.push(u)-1,g={wholeRange:L.Range.from(u.wholeRange),placeholder:u.placeholder};if(!k.h(u))return{...g,id:i,type:"editorEdit",message:L.MarkdownString.from(u.contents),edits:[]};const{edits:m,contents:d}=u,S=d!==void 0?L.MarkdownString.from(d):void 0;return m instanceof R.$fL?{...g,id:i,type:"bulkEdit",edits:L.WorkspaceEdit.from(m),message:S}:{...g,id:i,type:"editorEdit",edits:m.map(L.TextEdit.from),message:S}}async $provideFollowups(p,w,s,a){const r=this.b.get(p),n=this.d.get(w),o=n?.responses[s];if(r&&o&&r.provider.provideFollowups){const c=Promise.resolve(r.provider.provideFollowups(n.session,o,a));return(await(0,f.$Ug)(c,a))?.map(L.ChatReplyFollowup.from)}}$handleFeedback(p,w,s,a){const r=this.b.get(p),n=this.d.get(w),o=n?.responses[s];if(r&&o){const c=L.InteractiveEditorResponseFeedbackKind.to(a);r.provider.handleInteractiveEditorResponseFeedback?.(n.session,o,c)}}$releaseSession(p,w){}static h(p){return typeof p=="object"&&typeof p.edits=="object"}}e.$khc=k}),define(Pe[250],Re([1,0,2,32]),function(ge,e,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xhc=void 0;class C{constructor(R,$,f,b,A){this.a=$,this.b=f,this.c=b;const k=new T.$xN("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new T.$vN("showOptions","Show Options",l=>!0,l=>l),new T.$vN("resource","Interactive resource Uri",l=>!0,l=>l),new T.$vN("controllerId","Notebook controller Id",l=>!0,l=>l),new T.$vN("title","Interactive editor title",l=>!0,l=>l)],new T.$wN("Notebook and input URI",l=>{if(A.debug("[ExtHostInteractive] open iw with notebook editor id",l.notebookEditorId),l.notebookEditorId!==void 0){const p=this.a.getEditorById(l.notebookEditorId);return A.debug("[ExtHostInteractive] notebook editor found",p.id),{notebookUri:y.URI.revive(l.notebookUri),inputUri:y.URI.revive(l.inputUri),notebookEditor:p.apiEditor}}return A.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",l.notebookUri,l.inputUri),{notebookUri:y.URI.revive(l.notebookUri),inputUri:y.URI.revive(l.inputUri)}}));this.c.registerApiCommand(k)}$willAddInteractiveDocument(R,$,f,b){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:$,lines:[""],languageId:f,uri:R,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(y.URI.revive(b))?.apiNotebook}]})}$willRemoveInteractiveDocument(R,$){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[R]})}}e.$xhc=C}),define(Pe[251],Re([1,0,3,7]),function(ge,e,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yhc=void 0;class C{constructor(R){this.a=new Map,this.b=new Map,this.c=R.getProxy(y.$6K.MainThreadIssueReporter)}async $getIssueReporterUri(R,$){if(this.a.size===0)throw new Error("No issue request handlers registered");const f=this.a.get(R);if(!f)throw new Error("Issue request handler not found");const b=await f.handleIssueUrlRequest();if(!b)throw new Error("Issue request handler returned no result");return b}async $getIssueReporterData(R,$){if(this.b.size===0)throw new Error("No issue request handlers registered");const f=this.b.get(R);if(!f)throw new Error("Issue data provider not found");const b=await f.provideIssueData($);if(!b)throw new Error("Issue data provider returned no result");return b}async $getIssueReporterTemplate(R,$){if(this.b.size===0)throw new Error("No issue request handlers registered");const f=this.b.get(R);if(!f)throw new Error("Issue data provider not found");const b=await f.provideIssueTemplate($);if(!b)throw new Error("Issue template provider returned no result");return b}registerIssueUriRequestHandler(R,$){const f=R.identifier.value;return this.a.set(f,$),this.c.$registerIssueUriRequestHandler(f),new T.$8K(()=>{this.c.$unregisterIssueUriRequestHandler(f),this.a.delete(f)})}registerIssueDataProvider(R,$){const f=R.identifier.value;return this.b.set(f,$),this.c.$registerIssueDataProvider(f),new T.$8K(()=>{this.c.$unregisterIssueDataProvider(f),this.b.delete(f)})}}e.$yhc=C}),define(Pe[252],Re([1,0,6,3]),function(ge,e,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zhc=void 0;class C{constructor(R){this.b=0,this.a=R.getProxy(T.$6K.MainThreadLabelService)}$registerResourceLabelFormatter(R){const $=this.b++;return this.a.$registerResourceLabelFormatter($,R),(0,y.$Rc)(()=>{this.a.$unregisterResourceLabelFormatter($)})}}e.$zhc=C}),define(Pe[253],Re([1,0,2,26,8,7,80,3,11,29,18,16,296,20,22,6,96,89,75,60,15,13,23,160]),function(ge,e,y,T,C,L,R,$,f,b,A,k,l,p,w,s,a,r,n,o,c,h,t,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bgc=void 0;class i{constructor(F,q){this.d=F,this.e=q}async provideDocumentSymbols(F,q){const K=this.d.getDocument(F),U=await this.e.provideDocumentSymbols(K,q);if(!(0,A.$Kb)(U))return U[0]instanceof L.$oL?U.map(C.DocumentSymbol.from):i.f(U)}static f(F){F=F.slice(0).sort((U,X)=>{let x=U.location.range.start.compareTo(X.location.range.start);return x===0&&(x=X.location.range.end.compareTo(U.location.range.end)),x});const q=[],K=[];for(const U of F){const X={name:U.name||"!!MISSING: name!!",kind:C.SymbolKind.from(U.kind),tags:U.tags?.map(C.SymbolTag.from)||[],detail:"",containerName:U.containerName,range:C.Range.from(U.location.range),selectionRange:C.Range.from(U.location.range),children:[]};for(;;){if(K.length===0){K.push(X),q.push(X);break}const x=K[K.length-1];if(b.$Us.containsRange(x.range,X.range)&&!b.$Us.equalsRange(x.range,X.range)){x.children?.push(X),K.push(X);break}K.pop()}}return q}}class g{constructor(F,q,K,U,X,x){this.f=F,this.g=q,this.h=K,this.j=U,this.k=X,this.l=x,this.d=new n.$4fc("CodeLens"),this.e=new Map}async provideCodeLenses(F,q){const K=this.f.getDocument(F),U=await this.h.provideCodeLenses(K,q);if(!U||q.isCancellationRequested)return;const X=this.d.add(U),x=new s.$Sc;this.e.set(X,x);const Ee={cacheId:X,lenses:[]};for(let Te=0;Te<U.length;Te++)Ee.lenses.push({cacheId:[X,Te],range:C.Range.from(U[Te].range),command:this.g.toInternal(U[Te].command,x)});return Ee}async resolveCodeLens(F,q){const K=F.cacheId&&this.d.get(...F.cacheId);if(!K)return;let U;if(typeof this.h.resolveCodeLens!="function"||K.isResolved?U=K:U=await this.h.resolveCodeLens(K,q),U||(U=K),q.isCancellationRequested)return;const X=F.cacheId&&this.e.get(F.cacheId[0]);if(X){if(!U.command){const x=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,x),this.l.error(x);return}return F.command=this.g.toInternal(U.command,X),F}}releaseCodeLenses(F){this.e.get(F)?.dispose(),this.e.delete(F),this.d.delete(F)}}function m(ye){return Array.isArray(ye)?ye.map(C.DefinitionLink.from):ye?[C.DefinitionLink.from(ye)]:[]}class d{constructor(F,q){this.d=F,this.e=q}async provideDefinition(F,q,K){const U=this.d.getDocument(F),X=C.Position.to(q),x=await this.e.provideDefinition(U,X,K);return m(x)}}class S{constructor(F,q){this.d=F,this.e=q}async provideDeclaration(F,q,K){const U=this.d.getDocument(F),X=C.Position.to(q),x=await this.e.provideDeclaration(U,X,K);return m(x)}}class M{constructor(F,q){this.d=F,this.e=q}async provideImplementation(F,q,K){const U=this.d.getDocument(F),X=C.Position.to(q),x=await this.e.provideImplementation(U,X,K);return m(x)}}class v{constructor(F,q){this.d=F,this.e=q}async provideTypeDefinition(F,q,K){const U=this.d.getDocument(F),X=C.Position.to(q),x=await this.e.provideTypeDefinition(U,X,K);return m(x)}}class E{constructor(F,q){this.d=F,this.e=q}async provideHover(F,q,K){const U=this.d.getDocument(F),X=C.Position.to(q),x=await this.e.provideHover(U,X,K);if(!(!x||(0,A.$Kb)(x.contents)))return x.range||(x.range=U.getWordRangeAtPosition(X)),x.range||(x.range=new L.$0K(X,X)),C.Hover.from(x)}}class D{constructor(F,q){this.d=F,this.e=q}async provideEvaluatableExpression(F,q,K){const U=this.d.getDocument(F),X=C.Position.to(q),x=await this.e.provideEvaluatableExpression(U,X,K);if(x)return C.EvaluatableExpression.from(x)}}class N{constructor(F,q){this.d=F,this.e=q}async provideInlineValues(F,q,K,U){const X=this.d.getDocument(F),x=await this.e.provideInlineValues(X,C.Range.to(q),C.InlineValueContext.to(K),U);if(Array.isArray(x))return x.map(Ee=>C.InlineValue.from(Ee))}}class O{constructor(F,q){this.d=F,this.e=q}async provideDocumentHighlights(F,q,K){const U=this.d.getDocument(F),X=C.Position.to(q),x=await this.e.provideDocumentHighlights(U,X,K);if(Array.isArray(x))return x.map(C.DocumentHighlight.from)}}class G{constructor(F,q){this.d=F,this.e=q}async provideMultiDocumentHighlights(F,q,K,U){const X=this.d.getDocument(F),x=K.map(Ve=>this.d.getDocument(Ve)),Ee=C.Position.to(q),Te=await this.e.provideMultiDocumentHighlights(X,Ee,x,U);if(Array.isArray(Te))return Te.map(C.MultiDocumentHighlight.from)}}class W{constructor(F,q){this.d=F,this.e=q}async provideLinkedEditingRanges(F,q,K){const U=this.d.getDocument(F),X=C.Position.to(q),x=await this.e.provideLinkedEditingRanges(U,X,K);if(x&&Array.isArray(x.ranges))return{ranges:(0,A.$Hb)(x.ranges.map(C.Range.from)),wordPattern:x.wordPattern}}}class z{constructor(F,q){this.d=F,this.e=q}async provideReferences(F,q,K,U){const X=this.d.getDocument(F),x=C.Position.to(q),Ee=await this.e.provideReferences(X,x,K,U);if(Array.isArray(Ee))return Ee.map(C.location.from)}}class P{static{this.d=1e3}constructor(F,q,K,U,X,x,Ee){this.g=F,this.h=q,this.j=K,this.k=U,this.l=X,this.m=x,this.n=Ee,this.e=new n.$4fc("CodeAction"),this.f=new Map}async provideCodeActions(F,q,K,U){const X=this.g.getDocument(F),x=l.$Ws.isISelection(q)?C.Selection.to(q):C.Range.to(q),Ee=[];for(const nt of this.j.getDiagnostics(F))if(x.intersection(nt.range)&&Ee.push(nt)>P.d)break;const Te={diagnostics:Ee,only:K.only?new L.$qL(K.only):void 0,triggerKind:C.CodeActionTriggerKind.to(K.trigger)},Ve=await this.k.provideCodeActions(X,x,Te,U);if(!(0,A.$Lb)(Ve)||U.isCancellationRequested)return;const He=this.e.add(Ve),Ye=new s.$Sc;this.f.set(He,Ye);const st=[];for(let nt=0;nt<Ve.length;nt++){const tt=Ve[nt];tt&&(P.o(tt)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),st.push({_isSynthetic:!0,title:tt.title,command:this.h.toInternal(tt,Ye)})):(Te.only&&(tt.kind?Te.only.contains(tt.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Te.only.value} 'requested but returned code action is of kind '${tt.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Te.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),st.push({cacheId:[He,nt],title:tt.title,command:tt.command&&this.h.toInternal(tt.command,Ye),diagnostics:tt.diagnostics&&tt.diagnostics.map(C.Diagnostic.from),edit:tt.edit&&C.WorkspaceEdit.from(tt.edit,void 0),kind:tt.kind&&tt.kind.value,isPreferred:tt.isPreferred,isAI:(0,t.$BF)(this.m,"codeActionAI")?tt.isAI:!1,disabled:tt.disabled?.reason})))}return{cacheId:He,actions:st}}async resolveCodeAction(F,q){const[K,U]=F,X=this.e.get(K,U);if(!X||P.o(X))return{};if(!this.k.resolveCodeAction)return{};const x=await this.k.resolveCodeAction(X,q)??X;let Ee;x.edit&&(Ee=C.WorkspaceEdit.from(x.edit,void 0));let Te;if(x.command){const Ve=this.f.get(K);Ve&&(Te=this.h.toInternal(x.command,Ve))}return{edit:Ee,command:Te}}releaseCodeActions(F){this.f.get(F)?.dispose(),this.f.delete(F),this.e.delete(F)}static o(F){return typeof F.command=="string"&&typeof F.title=="string"}}class I{static toInternalProviderId(F,q){return F+"."+q}constructor(F,q,K,U,X){this.d=F,this.e=q,this.f=K,this.g=U,this.h=X}async prepareDocumentPaste(F,q,K,U){if(!this.f.prepareDocumentPaste)return;const X=this.e.getDocument(F),x=q.map(Ve=>C.Range.to(Ve)),Ee=C.DataTransfer.toDataTransfer(K,()=>{throw new c.$$});if(await this.f.prepareDocumentPaste(X,x,Ee,U),U.isCancellationRequested)return;const Te=Array.from(Ee).filter(([,Ve])=>!(Ve instanceof L.$WL));return C.DataTransfer.from(Te)}async providePasteEdits(F,q,K,U,X){if(!this.f.provideDocumentPasteEdits)return;const x=this.e.getDocument(q),Ee=K.map(He=>C.Range.to(He)),Te=C.DataTransfer.toDataTransfer(U,async He=>(await this.d.$resolvePasteFileData(this.g,F,He)).buffer),Ve=await this.f.provideDocumentPasteEdits(x,Ee,Te,X);if(Ve)return{label:Ve.label??(0,u.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:Ve.yieldTo?.map(He=>"mimeType"in He?He:{providerId:I.toInternalProviderId(He.extensionId,He.providerId)}),insertText:typeof Ve.insertText=="string"?Ve.insertText:{snippet:Ve.insertText.value},additionalEdit:Ve.additionalEdit?C.WorkspaceEdit.from(Ve.additionalEdit,void 0):void 0}}}class H{constructor(F,q){this.d=F,this.e=q}async provideDocumentFormattingEdits(F,q,K){const U=this.d.getDocument(F),X=await this.e.provideDocumentFormattingEdits(U,q,K);if(Array.isArray(X))return X.map(C.TextEdit.from)}}class ae{constructor(F,q){this.d=F,this.e=q}async provideDocumentRangeFormattingEdits(F,q,K,U){const X=this.d.getDocument(F),x=C.Range.to(q),Ee=await this.e.provideDocumentRangeFormattingEdits(X,x,K,U);if(Array.isArray(Ee))return Ee.map(C.TextEdit.from)}async provideDocumentRangesFormattingEdits(F,q,K,U){(0,k.$Sf)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const X=this.d.getDocument(F),x=q.map(C.Range.to),Ee=await this.e.provideDocumentRangesFormattingEdits(X,x,K,U);if(Array.isArray(Ee))return Ee.map(C.TextEdit.from)}}class de{constructor(F,q){this.d=F,this.e=q,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(F,q,K,U,X){const x=this.d.getDocument(F),Ee=C.Position.to(q),Te=await this.e.provideOnTypeFormattingEdits(x,Ee,K,U,X);if(Array.isArray(Te))return Te.map(C.TextEdit.from)}}class we{constructor(F,q){this.e=F,this.f=q,this.d=new n.$4fc("WorkspaceSymbols")}async provideWorkspaceSymbols(F,q){const K=await this.e.provideWorkspaceSymbols(F,q);if(!(0,A.$Lb)(K))return{symbols:[]};const U=this.d.add(K),X={cacheId:U,symbols:[]};for(let x=0;x<K.length;x++){const Ee=K[x];if(!Ee||!Ee.name){this.f.warn("INVALID SymbolInformation",Ee);continue}X.symbols.push({...C.WorkspaceSymbol.from(Ee),cacheId:[U,x]})}return X}async resolveWorkspaceSymbol(F,q){if(typeof this.e.resolveWorkspaceSymbol!="function"||!F.cacheId)return F;const K=this.d.get(...F.cacheId);if(K){const U=await this.e.resolveWorkspaceSymbol(K,q);return U&&(0,T.$yn)(F,C.WorkspaceSymbol.from(U),!0)}}releaseWorkspaceSymbols(F){this.d.delete(F)}}class ke{static supportsResolving(F){return typeof F.prepareRename=="function"}constructor(F,q,K){this.d=F,this.e=q,this.f=K}async provideRenameEdits(F,q,K,U){const X=this.d.getDocument(F),x=C.Position.to(q);try{const Ee=await this.e.provideRenameEdits(X,x,K,U);return Ee?C.WorkspaceEdit.from(Ee):void 0}catch(Ee){const Te=ke.g(Ee);return Te?{rejectReason:Te,edits:void 0}:Promise.reject(Ee)}}async resolveRenameLocation(F,q,K){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const U=this.d.getDocument(F),X=C.Position.to(q);try{const x=await this.e.prepareRename(U,X,K);let Ee,Te;if(L.$0K.isRange(x)?(Ee=x,Te=U.getText(x)):(0,k.$Kf)(x)&&(Ee=x.range,Te=x.placeholder),!Ee||!Te)return;if(Ee.start.line>X.line||Ee.end.line<X.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:C.Range.from(Ee),text:Te}}catch(x){const Ee=ke.g(x);return Ee?{rejectReason:Ee,range:void 0,text:void 0}:Promise.reject(x)}}static g(F){return typeof F=="string"?F:F instanceof Error&&typeof F.message=="string"?F.message:void 0}}class le{constructor(F,q){this.resultId=F,this.tokens=q}}class ve{constructor(F,q){this.f=F,this.g=q,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(F,q,K){const U=this.f.getDocument(F),X=q!==0?this.d.get(q):null;let x=typeof X?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(U,X.resultId,K):await this.g.provideDocumentSemanticTokens(U,K);return X&&this.d.delete(q),x?(x=ve.h(x),this.o(ve.n(X,x),x)):null}async releaseDocumentSemanticColoring(F){this.d.delete(F)}static h(F){return ve.j(F)?ve.k(F)?F:new L.$nM(new Uint32Array(F.data),F.resultId):ve.l(F)?ve.m(F)?F:new L.$pM(F.edits.map(q=>new L.$oM(q.start,q.deleteCount,q.data?new Uint32Array(q.data):q.data)),F.resultId):F}static j(F){return F&&!!F.data}static k(F){return F.data instanceof Uint32Array}static l(F){return F&&Array.isArray(F.edits)}static m(F){for(const q of F.edits)if(!(q.data instanceof Uint32Array))return!1;return!0}static n(F,q){if(!ve.j(q)||!F||!F.tokens)return q;const K=F.tokens,U=K.length,X=q.data,x=X.length;let Ee=0;const Te=Math.min(U,x);for(;Ee<Te&&K[Ee]===X[Ee];)Ee++;if(Ee===U&&Ee===x)return new L.$pM([],q.resultId);let Ve=0;const He=Te-Ee;for(;Ve<He&&K[U-Ve-1]===X[x-Ve-1];)Ve++;return new L.$pM([{start:Ee,deleteCount:U-Ee-Ve,data:X.subarray(Ee,x-Ve)}],q.resultId)}o(F,q){if(ve.j(F)){const K=this.e++;return this.d.set(K,new le(F.resultId,F.data)),(0,a.$s$)({id:K,type:"full",data:F.data})}if(ve.l(F)){const K=this.e++;return ve.j(q)?this.d.set(K,new le(q.resultId,q.data)):this.d.set(K,new le(F.resultId)),(0,a.$s$)({id:K,type:"delta",deltas:(F.edits||[]).map(U=>({start:U.start,deleteCount:U.deleteCount,data:U.data}))})}return null}}class se{constructor(F,q){this.d=F,this.e=q}async provideDocumentRangeSemanticTokens(F,q,K){const U=this.d.getDocument(F),X=await this.e.provideDocumentRangeSemanticTokens(U,C.Range.to(q),K);return X?this.f(X):null}f(F){return(0,a.$s$)({id:0,type:"full",data:F.data})}}class be{static supportsResolving(F){return typeof F.resolveCompletionItem=="function"}constructor(F,q,K,U,X){this.f=F,this.g=q,this.h=K,this.j=U,this.k=X,this.d=new n.$4fc("CompletionItem"),this.e=new Map}async provideCompletionItems(F,q,K,U){const X=this.f.getDocument(F),x=C.Position.to(q),Ee=X.getWordRangeAtPosition(x)||new L.$0K(x,x),Te=Ee.with({end:x}),Ve=new o.$Rd,He=await this.h.provideCompletionItems(X,x,U,C.CompletionContext.to(K));if(!He||U.isCancellationRequested)return;const Ye=Array.isArray(He)?new L.$DL(He):He,st=be.supportsResolving(this.h)?this.d.add(Ye.items):this.d.add([]),nt=new s.$Sc;this.e.set(st,nt);const tt=[],at={x:st,b:tt,a:{replace:C.Range.from(Ee),insert:C.Range.from(Te)},c:Ye.isIncomplete||void 0,d:Ve.elapsed()};for(let ct=0;ct<Ye.items.length;ct++){const je=Ye.items[ct],vt=this.l(je,[st,ct],Te,Ee);tt.push(vt)}return at}async resolveCompletionItem(F,q){if(typeof this.h.resolveCompletionItem!="function")return;const K=this.d.get(...F);if(!K)return;const U=this.l(K,F),X=await this.h.resolveCompletionItem(K,q);if(!X)return;const x=this.l(X,F);return(U.h!==x.h||U.i!==x.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(U.n!==x.n||U.o!==x.o||!(0,T.$zn)(U.p,x.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...U,d:x.d,c:x.c,l:x.l,h:x.h,i:x.i,n:x.n,o:x.o,p:x.p}}releaseCompletionItems(F){this.e.get(F)?.dispose(),this.e.delete(F),this.d.delete(F)}l(F,q,K,U){const X=this.e.get(q[0]);if(!X)throw Error("DisposableStore is missing...");const x=this.g.toInternal(F.command,X),Ee={x:q,a:F.label,b:F.kind!==void 0?C.CompletionItemKind.from(F.kind):void 0,m:F.tags&&F.tags.map(C.CompletionItemTag.from),c:F.detail,d:typeof F.documentation>"u"?void 0:C.MarkdownString.fromStrict(F.documentation),e:F.sortText!==F.label?F.sortText:void 0,f:F.filterText!==F.label?F.filterText:void 0,g:F.preselect||void 0,i:F.keepWhitespace?1:0,k:F.commitCharacters?.join(""),l:F.additionalTextEdits&&F.additionalTextEdits.map(C.TextEdit.from),n:x?.$ident,o:x?.id,p:x?.$ident?void 0:x?.arguments};F.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Ee.h=F.textEdit.newText):typeof F.insertText=="string"?Ee.h=F.insertText:F.insertText instanceof L.$gL&&(Ee.h=F.insertText.value,Ee.i|=4);let Te;return F.textEdit?Te=F.textEdit.range:F.range&&(Te=F.range),L.$0K.isRange(Te)?Ee.j=C.Range.from(Te):Te&&(!K?.isEqual(Te.inserting)||!U?.isEqual(Te.replacing))&&(Ee.j={insert:C.Range.from(Te.inserting),replace:C.Range.from(Te.replacing)}),Ee}}class ne{async provideInlineCompletions(F,q,K,U){}disposeCompletions(F){}handleDidShowCompletionItem(F,q,K){}handlePartialAccept(F,q,K){}}class Y extends ne{constructor(F,q,K,U){super(),this.f=F,this.g=q,this.h=K,this.j=U,this.d=new V,this.e=(0,t.$BF)(this.f,"inlineCompletionsAdditions"),this.k={[R.InlineCompletionTriggerKind.Automatic]:L.InlineCompletionTriggerKind.Automatic,[R.InlineCompletionTriggerKind.Explicit]:L.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.$BF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(F,q,K,U){const X=this.g.getDocument(F),x=C.Position.to(q),Ee=await this.h.provideInlineCompletionItems(X,x,{selectedCompletionInfo:K.selectedSuggestionInfo?{range:C.Range.to(K.selectedSuggestionInfo.range),text:K.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[K.triggerKind]},U);if(!Ee||U.isCancellationRequested)return;const Te=Array.isArray(Ee)?Ee:Ee.items,Ve=this.e?Array.isArray(Ee)?[]:Ee.commands||[]:[],He=this.e&&!Array.isArray(Ee)?Ee.enableForwardStability:void 0;let Ye;return{pid:this.d.createReferenceId({dispose(){Ye?.dispose()},items:Te}),items:Te.map((nt,tt)=>{let at;nt.command&&(Ye||(Ye=new s.$Sc),at=this.j.toInternal(nt.command,Ye));const ct=nt.insertText;return{insertText:typeof ct=="string"?ct:{snippet:ct.value},filterText:nt.filterText,range:nt.range?C.Range.from(nt.range):void 0,command:at,idx:tt,completeBracketPairs:this.e?nt.completeBracketPairs:!1}}),commands:Ve.map(nt=>(Ye||(Ye=new s.$Sc),this.j.toInternal(nt,Ye))),suppressSuggestions:!1,enableForwardStability:He}}disposeCompletions(F){this.d.disposeReferenceId(F)?.dispose()}handleDidShowCompletionItem(F,q,K){const U=this.d.get(F)?.items[q];U&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(U,K)}handlePartialAccept(F,q,K){const U=this.d.get(F)?.items[q];U&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(U,K)}}class V{constructor(){this.d=new Map,this.e=1}createReferenceId(F){const q=this.e++;return this.d.set(q,F),q}disposeReferenceId(F){const q=this.d.get(F);return this.d.delete(F),q}get(F){return this.d.get(F)}}class ie{constructor(F,q){this.e=F,this.f=q,this.d=new n.$4fc("SignatureHelp")}async provideSignatureHelp(F,q,K,U){const X=this.e.getDocument(F),x=C.Position.to(q),Ee=this.g(K),Te=await this.f.provideSignatureHelp(X,x,U,Ee);if(Te){const Ve=this.d.add([Te]);return{...C.SignatureHelp.from(Te),id:Ve}}}g(F){let q;if(F.activeSignatureHelp){const K=C.SignatureHelp.to(F.activeSignatureHelp),U=this.d.get(F.activeSignatureHelp.id,0);U?(q=U,q.activeSignature=K.activeSignature,q.activeParameter=K.activeParameter):q=K}return{...F,activeSignatureHelp:q}}releaseSignatureHelp(F){this.d.delete(F)}}class Ie{constructor(F,q,K,U,X){this.f=F,this.g=q,this.h=K,this.j=U,this.k=X,this.d=new n.$4fc("InlayHints"),this.e=new Map}async provideInlayHints(F,q,K){const U=this.f.getDocument(F),X=C.Range.to(q),x=await this.h.provideInlayHints(U,X,K);if(!Array.isArray(x)||x.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(q)}`);return}if(K.isCancellationRequested)return;const Ee=this.d.add(x);this.e.set(Ee,new s.$Sc);const Te={hints:[],cacheId:Ee};for(let Ve=0;Ve<x.length;Ve++)this.l(x[Ve],X)&&Te.hints.push(this.m(x[Ve],[Ee,Ve]));return this.j.trace(`[InlayHints] ${Te.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(q)}`),Te}async resolveInlayHint(F,q){if(typeof this.h.resolveInlayHint!="function")return;const K=this.d.get(...F);if(!K)return;const U=await this.h.resolveInlayHint(K,q);if(U&&this.l(U))return this.m(U,F)}releaseHints(F){this.e.get(F)?.dispose(),this.e.delete(F),this.d.delete(F)}l(F,q){return F.label.length===0||Array.isArray(F.label)&&F.label.every(K=>K.value.length===0)?(console.log("INVALID inlay hint, empty label",F),!1):!(q&&!q.contains(F.position))}m(F,q){const K=this.e.get(q[0]);if(!K)throw Error("DisposableStore is missing...");const U={label:"",cacheId:q,tooltip:C.MarkdownString.fromStrict(F.tooltip),position:C.Position.from(F.position),textEdits:F.textEdits&&F.textEdits.map(C.TextEdit.from),kind:F.kind&&C.InlayHintKind.from(F.kind),paddingLeft:F.paddingLeft,paddingRight:F.paddingRight};if(typeof F.label=="string")U.label=F.label;else{const X=[];U.label=X;for(const x of F.label){if(!x.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Ee={label:x.value,tooltip:C.MarkdownString.fromStrict(x.tooltip)};L.$hL.isLocation(x.location)&&(Ee.location=C.location.from(x.location)),x.command&&(Ee.command=this.g.toInternal(x.command,K)),X.push(Ee)}}return U}}class Le{constructor(F,q){this.e=F,this.f=q,this.d=new n.$4fc("DocumentLink")}async provideLinks(F,q){const K=this.e.getDocument(F),U=await this.f.provideDocumentLinks(K,q);if(!(!Array.isArray(U)||U.length===0)&&!q.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:U.filter(Le.g).map(C.DocumentLink.from)};{const X=this.d.add(U),x={links:[],cacheId:X};for(let Ee=0;Ee<U.length;Ee++){if(!Le.g(U[Ee]))continue;const Te=C.DocumentLink.from(U[Ee]);Te.cacheId=[X,Ee],x.links.push(Te)}return x}}}static g(F){return F.target&&F.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(F,q){if(typeof this.f.resolveDocumentLink!="function")return;const K=this.d.get(...F);if(!K)return;const U=await this.f.resolveDocumentLink(K,q);if(!(!U||!Le.g(U)))return C.DocumentLink.from(U)}releaseLinks(F){this.d.delete(F)}}class Ce{constructor(F,q){this.d=F,this.e=q}async provideColors(F,q){const K=this.d.getDocument(F),U=await this.e.provideDocumentColors(K,q);return Array.isArray(U)?U.map(x=>({color:C.Color.from(x.color),range:C.Range.from(x.range)})):[]}async provideColorPresentations(F,q,K){const U=this.d.getDocument(F),X=C.Range.to(q.range),x=C.Color.to(q.color),Ee=await this.e.provideColorPresentations(x,{document:U,range:X},K);if(Array.isArray(Ee))return Ee.map(C.ColorPresentation.from)}}class ce{constructor(F,q){this.d=F,this.e=q}async provideFoldingRanges(F,q,K){const U=this.d.getDocument(F),X=await this.e.provideFoldingRanges(U,q,K);if(Array.isArray(X))return X.map(C.FoldingRange.from)}}class te{constructor(F,q,K){this.d=F,this.e=q,this.f=K}async provideSelectionRanges(F,q,K){const U=this.d.getDocument(F),X=q.map(C.Position.to),x=await this.e.provideSelectionRanges(U,X,K);if(!(0,A.$Lb)(x))return[];if(x.length!==X.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Ee=[];for(let Te=0;Te<X.length;Te++){const Ve=[];Ee.push(Ve);let He=X[Te],Ye=x[Te];for(;;){if(!Ye.range.contains(He))throw new Error("INVALID selection range, must contain the previous range");if(Ve.push(C.SelectionRange.from(Ye)),!Ye.parent)break;He=Ye.range,Ye=Ye.parent}}return Ee}}class Q{constructor(F,q){this.f=F,this.g=q,this.d=new r.$cN(""),this.e=new Map}async prepareSession(F,q,K){const U=this.f.getDocument(F),X=C.Position.to(q),x=await this.g.prepareCallHierarchy(U,X,K);if(!x)return;const Ee=this.d.nextId();return this.e.set(Ee,new Map),Array.isArray(x)?x.map(Te=>this.h(Ee,Te)):[this.h(Ee,x)]}async provideCallsTo(F,q,K){const U=this.j(F,q);if(!U)throw new Error("missing call hierarchy item");const X=await this.g.provideCallHierarchyIncomingCalls(U,K);if(X)return X.map(x=>({from:this.h(F,x.from),fromRanges:x.fromRanges.map(Ee=>C.Range.from(Ee))}))}async provideCallsFrom(F,q,K){const U=this.j(F,q);if(!U)throw new Error("missing call hierarchy item");const X=await this.g.provideCallHierarchyOutgoingCalls(U,K);if(X)return X.map(x=>({to:this.h(F,x.to),fromRanges:x.fromRanges.map(Ee=>C.Range.from(Ee))}))}releaseSession(F){this.e.delete(F)}h(F,q){const K=this.e.get(F),U=C.CallHierarchyItem.from(q,F,K.size.toString(36));return K.set(U._itemId,q),U}j(F,q){return this.e.get(F)?.get(q)}}class ee{constructor(F,q){this.f=F,this.g=q,this.d=new r.$cN(""),this.e=new Map}async prepareSession(F,q,K){const U=this.f.getDocument(F),X=C.Position.to(q),x=await this.g.prepareTypeHierarchy(U,X,K);if(!x)return;const Ee=this.d.nextId();return this.e.set(Ee,new Map),Array.isArray(x)?x.map(Te=>this.h(Ee,Te)):[this.h(Ee,x)]}async provideSupertypes(F,q,K){const U=this.j(F,q);if(!U)throw new Error("missing type hierarchy item");const X=await this.g.provideTypeHierarchySupertypes(U,K);if(X)return X.map(x=>this.h(F,x))}async provideSubtypes(F,q,K){const U=this.j(F,q);if(!U)throw new Error("missing type hierarchy item");const X=await this.g.provideTypeHierarchySubtypes(U,K);if(X)return X.map(x=>this.h(F,x))}releaseSession(F){this.e.delete(F)}h(F,q){const K=this.e.get(F),U=C.TypeHierarchyItem.from(q,F,K.size.toString(36));return K.set(U._itemId,q),U}j(F,q){return this.e.get(F)?.get(q)}}class me{static toInternalProviderId(F,q){return F+"."+q}constructor(F,q,K,U,X){this.d=F,this.e=q,this.f=K,this.g=U,this.h=X}async provideDocumentOnDropEdits(F,q,K,U,X){const x=this.e.getDocument(q),Ee=C.Position.to(K),Te=C.DataTransfer.toDataTransfer(U,async He=>(await this.d.$resolveDocumentOnDropFileData(this.g,F,He)).buffer),Ve=await this.f.provideDocumentDropEdits(x,Ee,Te,X);if(Ve)return{label:Ve.label??(0,u.localize)(1,null,this.h.displayName||this.h.name),yieldTo:Ve.yieldTo?.map(He=>"mimeType"in He?He:{providerId:me.toInternalProviderId(He.extensionId,He.providerId)}),insertText:typeof Ve.insertText=="string"?Ve.insertText:{snippet:Ve.insertText.value},additionalEdit:Ve.additionalEdit?C.WorkspaceEdit.from(Ve.additionalEdit,void 0):void 0}}}class pe{constructor(F,q){this.d=F,this.e=q}async provideMappedEdits(F,q,K,U){const X=y.URI.revive(F),x=this.d.getDocument(X),Ee=K.documents.map(He=>He.map(Ye=>({uri:y.URI.revive(Ye.uri),version:Ye.version,ranges:Ye.ranges.map(st=>C.Range.to(st))}))),Te={documents:Ee,selections:Ee[0]?.[0]?.ranges??[]},Ve=await this.e.provideMappedEdits(x,q,Te,U);return Ve?C.WorkspaceEdit.from(Ve):null}}class Ae{constructor(F,q){this.adapter=F,this.extension=q}}class he{static{this.d=0}constructor(F,q,K,U,X,x,Ee,Te){this.g=q,this.h=K,this.j=U,this.k=X,this.l=x,this.m=Ee,this.n=Te,this.f=new Map,this.e=F.getProxy($.$6K.MainThreadLanguageFeatures)}o(F,q){return C.DocumentSelector.from(F,this.g,q)}p(F){return new L.$8K(()=>{this.f.delete(F),this.e.$unregister(F)})}q(){return he.d++}async s(F,q,K,U,X,x=!1){const Ee=this.f.get(F);if(!Ee||!(Ee.adapter instanceof q))return U;const Te=Date.now();x||this.l.trace(`[${Ee.extension.identifier.value}] INVOKE provider '${K.toString().replace(/[\r\n]/g,"")}'`);const Ve=K(Ee.adapter,Ee.extension);return Promise.resolve(Ve).catch(He=>{(0,c.$4)(He)||(this.l.error(`[${Ee.extension.identifier.value}] provider FAILED`),this.l.error(He),this.n.onExtensionError(Ee.extension.identifier,He))}).finally(()=>{x||this.l.trace(`[${Ee.extension.identifier.value}] provider DONE after ${Date.now()-Te}ms`)}),p.CancellationToken.isCancellationToken(X)?(0,h.$Vg)(Ve,X):Ve}t(F,q){const K=this.q();return this.f.set(K,new Ae(F,q)),K}static u(F){return F.displayName||F.name}registerDocumentSymbolProvider(F,q,K,U){const X=this.t(new i(this.h,K),F),x=U&&U.label||he.u(F);return this.e.$registerDocumentSymbolProvider(X,this.o(q,F),x),this.p(X)}$provideDocumentSymbols(F,q,K){return this.s(F,i,U=>U.provideDocumentSymbols(y.URI.revive(q),K),void 0,K)}registerCodeLensProvider(F,q,K){const U=this.q(),X=typeof K.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(U,new Ae(new g(this.h,this.j.converter,K,F,this.n,this.l),F)),this.e.$registerCodeLensSupport(U,this.o(q,F),X);let x=this.p(U);if(X!==void 0){const Ee=K.onDidChangeCodeLenses(Te=>this.e.$emitCodeLensEvent(X));x=L.$8K.from(x,Ee)}return x}$provideCodeLenses(F,q,K){return this.s(F,g,U=>U.provideCodeLenses(y.URI.revive(q),K),void 0,K)}$resolveCodeLens(F,q,K){return this.s(F,g,U=>U.resolveCodeLens(q,K),void 0,void 0)}$releaseCodeLenses(F,q){this.s(F,g,K=>Promise.resolve(K.releaseCodeLenses(q)),void 0,void 0)}registerDefinitionProvider(F,q,K){const U=this.t(new d(this.h,K),F);return this.e.$registerDefinitionSupport(U,this.o(q,F)),this.p(U)}$provideDefinition(F,q,K,U){return this.s(F,d,X=>X.provideDefinition(y.URI.revive(q),K,U),[],U)}registerDeclarationProvider(F,q,K){const U=this.t(new S(this.h,K),F);return this.e.$registerDeclarationSupport(U,this.o(q,F)),this.p(U)}$provideDeclaration(F,q,K,U){return this.s(F,S,X=>X.provideDeclaration(y.URI.revive(q),K,U),[],U)}registerImplementationProvider(F,q,K){const U=this.t(new M(this.h,K),F);return this.e.$registerImplementationSupport(U,this.o(q,F)),this.p(U)}$provideImplementation(F,q,K,U){return this.s(F,M,X=>X.provideImplementation(y.URI.revive(q),K,U),[],U)}registerTypeDefinitionProvider(F,q,K){const U=this.t(new v(this.h,K),F);return this.e.$registerTypeDefinitionSupport(U,this.o(q,F)),this.p(U)}$provideTypeDefinition(F,q,K,U){return this.s(F,v,X=>X.provideTypeDefinition(y.URI.revive(q),K,U),[],U)}registerHoverProvider(F,q,K,U){const X=this.t(new E(this.h,K),F);return this.e.$registerHoverProvider(X,this.o(q,F)),this.p(X)}$provideHover(F,q,K,U){return this.s(F,E,X=>X.provideHover(y.URI.revive(q),K,U),void 0,U)}registerEvaluatableExpressionProvider(F,q,K,U){const X=this.t(new D(this.h,K),F);return this.e.$registerEvaluatableExpressionProvider(X,this.o(q,F)),this.p(X)}$provideEvaluatableExpression(F,q,K,U){return this.s(F,D,X=>X.provideEvaluatableExpression(y.URI.revive(q),K,U),void 0,U)}registerInlineValuesProvider(F,q,K,U){const X=typeof K.onDidChangeInlineValues=="function"?this.q():void 0,x=this.t(new N(this.h,K),F);this.e.$registerInlineValuesProvider(x,this.o(q,F),X);let Ee=this.p(x);if(X!==void 0){const Te=K.onDidChangeInlineValues(Ve=>this.e.$emitInlineValuesEvent(X));Ee=L.$8K.from(Ee,Te)}return Ee}$provideInlineValues(F,q,K,U,X){return this.s(F,N,x=>x.provideInlineValues(y.URI.revive(q),K,U,X),void 0,X)}registerDocumentHighlightProvider(F,q,K){const U=this.t(new O(this.h,K),F);return this.e.$registerDocumentHighlightProvider(U,this.o(q,F)),this.p(U)}registerMultiDocumentHighlightProvider(F,q,K){const U=this.t(new G(this.h,K),F);return this.e.$registerMultiDocumentHighlightProvider(U,this.o(q,F)),this.p(U)}$provideDocumentHighlights(F,q,K,U){return this.s(F,O,X=>X.provideDocumentHighlights(y.URI.revive(q),K,U),void 0,U)}$provideMultiDocumentHighlights(F,q,K,U,X){return this.s(F,G,x=>x.provideMultiDocumentHighlights(y.URI.revive(q),K,U.map(Ee=>y.URI.revive(Ee)),X),void 0,X)}registerLinkedEditingRangeProvider(F,q,K){const U=this.t(new W(this.h,K),F);return this.e.$registerLinkedEditingRangeProvider(U,this.o(q,F)),this.p(U)}$provideLinkedEditingRanges(F,q,K,U){return this.s(F,W,async X=>{const x=await X.provideLinkedEditingRanges(y.URI.revive(q),K,U);if(x)return{ranges:x.ranges,wordPattern:x.wordPattern?he.w(x.wordPattern):void 0}},void 0,U)}registerReferenceProvider(F,q,K){const U=this.t(new z(this.h,K),F);return this.e.$registerReferenceSupport(U,this.o(q,F)),this.p(U)}$provideReferences(F,q,K,U,X){return this.s(F,z,x=>x.provideReferences(y.URI.revive(q),K,U,X),void 0,X)}registerCodeActionProvider(F,q,K,U){const X=new s.$Sc,x=this.t(new P(this.h,this.j.converter,this.k,K,this.l,F,this.m),F);return this.e.$registerQuickFixSupport(x,this.o(q,F),{providedKinds:U?.providedCodeActionKinds?.map(Ee=>Ee.value),documentation:U?.documentation?.map(Ee=>({kind:Ee.kind.value,command:this.j.converter.toInternal(Ee.command,X)}))},he.u(F),!!K.resolveCodeAction),X.add(this.p(x)),X}$provideCodeActions(F,q,K,U,X){return this.s(F,P,x=>x.provideCodeActions(y.URI.revive(q),K,U,X),void 0,X)}$resolveCodeAction(F,q,K){return this.s(F,P,U=>U.resolveCodeAction(q,K),{},void 0)}$releaseCodeActions(F,q){this.s(F,P,K=>Promise.resolve(K.releaseCodeActions(q)),void 0,void 0)}registerDocumentFormattingEditProvider(F,q,K){const U=this.t(new H(this.h,K),F);return this.e.$registerDocumentFormattingSupport(U,this.o(q,F),F.identifier,F.displayName||F.name),this.p(U)}$provideDocumentFormattingEdits(F,q,K,U){return this.s(F,H,X=>X.provideDocumentFormattingEdits(y.URI.revive(q),K,U),void 0,U)}registerDocumentRangeFormattingEditProvider(F,q,K){const U=typeof K.provideDocumentRangesFormattingEdits=="function",X=this.t(new ae(this.h,K),F);return this.e.$registerRangeFormattingSupport(X,this.o(q,F),F.identifier,F.displayName||F.name,U),this.p(X)}$provideDocumentRangeFormattingEdits(F,q,K,U,X){return this.s(F,ae,x=>x.provideDocumentRangeFormattingEdits(y.URI.revive(q),K,U,X),void 0,X)}$provideDocumentRangesFormattingEdits(F,q,K,U,X){return this.s(F,ae,x=>x.provideDocumentRangesFormattingEdits(y.URI.revive(q),K,U,X),void 0,X)}registerOnTypeFormattingEditProvider(F,q,K,U){const X=this.t(new de(this.h,K),F);return this.e.$registerOnTypeFormattingSupport(X,this.o(q,F),U,F.identifier),this.p(X)}$provideOnTypeFormattingEdits(F,q,K,U,X,x){return this.s(F,de,Ee=>Ee.provideOnTypeFormattingEdits(y.URI.revive(q),K,U,X,x),void 0,x)}registerWorkspaceSymbolProvider(F,q){const K=this.t(new we(q,this.l),F);return this.e.$registerNavigateTypeSupport(K,typeof q.resolveWorkspaceSymbol=="function"),this.p(K)}$provideWorkspaceSymbols(F,q,K){return this.s(F,we,U=>U.provideWorkspaceSymbols(q,K),{symbols:[]},K)}$resolveWorkspaceSymbol(F,q,K){return this.s(F,we,U=>U.resolveWorkspaceSymbol(q,K),void 0,void 0)}$releaseWorkspaceSymbols(F,q){this.s(F,we,K=>K.releaseWorkspaceSymbols(q),void 0,void 0)}registerRenameProvider(F,q,K){const U=this.t(new ke(this.h,K,this.l),F);return this.e.$registerRenameSupport(U,this.o(q,F),ke.supportsResolving(K)),this.p(U)}$provideRenameEdits(F,q,K,U,X){return this.s(F,ke,x=>x.provideRenameEdits(y.URI.revive(q),K,U,X),void 0,X)}$resolveRenameLocation(F,q,K,U){return this.s(F,ke,X=>X.resolveRenameLocation(y.URI.revive(q),K,U),void 0,U)}registerDocumentSemanticTokensProvider(F,q,K,U){const X=this.t(new ve(this.h,K),F),x=typeof K.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(X,this.o(q,F),U,x);let Ee=this.p(X);if(x){const Te=K.onDidChangeSemanticTokens(Ve=>this.e.$emitDocumentSemanticTokensEvent(x));Ee=L.$8K.from(Ee,Te)}return Ee}$provideDocumentSemanticTokens(F,q,K,U){return this.s(F,ve,X=>X.provideDocumentSemanticTokens(y.URI.revive(q),K,U),null,U)}$releaseDocumentSemanticTokens(F,q){this.s(F,ve,K=>K.releaseDocumentSemanticColoring(q),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(F,q,K,U){const X=this.t(new se(this.h,K),F);return this.e.$registerDocumentRangeSemanticTokensProvider(X,this.o(q,F),U),this.p(X)}$provideDocumentRangeSemanticTokens(F,q,K,U){return this.s(F,se,X=>X.provideDocumentRangeSemanticTokens(y.URI.revive(q),K,U),null,U)}registerCompletionItemProvider(F,q,K,U){const X=this.t(new be(this.h,this.j.converter,K,this.m,F),F);return this.e.$registerCompletionsProvider(X,this.o(q,F),U,be.supportsResolving(K),F.identifier),this.p(X)}$provideCompletionItems(F,q,K,U,X){return this.s(F,be,x=>x.provideCompletionItems(y.URI.revive(q),K,U,X),void 0,X)}$resolveCompletionItem(F,q,K){return this.s(F,be,U=>U.resolveCompletionItem(q,K),void 0,K)}$releaseCompletionItems(F,q){this.s(F,be,K=>K.releaseCompletionItems(q),void 0,void 0)}registerInlineCompletionsProvider(F,q,K,U){const X=new Y(F,this.h,K,this.j.converter),x=this.t(X,F);return this.e.$registerInlineCompletionsSupport(x,this.o(q,F),X.supportsHandleEvents,w.$lm.toKey(F.identifier.value),U?.yieldTo?.map(Ee=>w.$lm.toKey(Ee))||[]),this.p(x)}$provideInlineCompletions(F,q,K,U,X){return this.s(F,ne,x=>x.provideInlineCompletions(y.URI.revive(q),K,U,X),void 0,X)}$handleInlineCompletionDidShow(F,q,K,U){this.s(F,ne,async X=>{X.handleDidShowCompletionItem(q,K,U)},void 0,void 0)}$handleInlineCompletionPartialAccept(F,q,K,U){this.s(F,ne,async X=>{X.handlePartialAccept(q,K,U)},void 0,void 0)}$freeInlineCompletionsList(F,q){this.s(F,ne,async K=>{K.disposeCompletions(q)},void 0,void 0)}registerSignatureHelpProvider(F,q,K,U){const X=Array.isArray(U)?{triggerCharacters:U,retriggerCharacters:[]}:U,x=this.t(new ie(this.h,K),F);return this.e.$registerSignatureHelpProvider(x,this.o(q,F),X),this.p(x)}$provideSignatureHelp(F,q,K,U,X){return this.s(F,ie,x=>x.provideSignatureHelp(y.URI.revive(q),K,U,X),void 0,X)}$releaseSignatureHelp(F,q){this.s(F,ie,K=>K.releaseSignatureHelp(q),void 0,void 0)}registerInlayHintsProvider(F,q,K){const U=typeof K.onDidChangeInlayHints=="function"?this.q():void 0,X=this.t(new Ie(this.h,this.j.converter,K,this.l,F),F);this.e.$registerInlayHintsProvider(X,this.o(q,F),typeof K.resolveInlayHint=="function",U,he.u(F));let x=this.p(X);if(U!==void 0){const Ee=K.onDidChangeInlayHints(Te=>this.e.$emitInlayHintsEvent(U));x=L.$8K.from(x,Ee)}return x}$provideInlayHints(F,q,K,U){return this.s(F,Ie,X=>X.provideInlayHints(y.URI.revive(q),K,U),void 0,U)}$resolveInlayHint(F,q,K){return this.s(F,Ie,U=>U.resolveInlayHint(q,K),void 0,K)}$releaseInlayHints(F,q){this.s(F,Ie,K=>K.releaseHints(q),void 0,void 0)}registerDocumentLinkProvider(F,q,K){const U=this.t(new Le(this.h,K),F);return this.e.$registerDocumentLinkProvider(U,this.o(q,F),typeof K.resolveDocumentLink=="function"),this.p(U)}$provideDocumentLinks(F,q,K){return this.s(F,Le,U=>U.provideLinks(y.URI.revive(q),K),void 0,K,q.scheme==="output")}$resolveDocumentLink(F,q,K){return this.s(F,Le,U=>U.resolveLink(q,K),void 0,void 0,!0)}$releaseDocumentLinks(F,q){this.s(F,Le,K=>K.releaseLinks(q),void 0,void 0,!0)}registerColorProvider(F,q,K){const U=this.t(new Ce(this.h,K),F);return this.e.$registerDocumentColorProvider(U,this.o(q,F)),this.p(U)}$provideDocumentColors(F,q,K){return this.s(F,Ce,U=>U.provideColors(y.URI.revive(q),K),[],K)}$provideColorPresentations(F,q,K,U){return this.s(F,Ce,X=>X.provideColorPresentations(y.URI.revive(q),K,U),void 0,U)}registerFoldingRangeProvider(F,q,K){const U=this.q(),X=typeof K.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(U,new Ae(new ce(this.h,K),F)),this.e.$registerFoldingRangeProvider(U,this.o(q,F),F.identifier,X);let x=this.p(U);if(X!==void 0){const Ee=K.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(X));x=L.$8K.from(x,Ee)}return x}$provideFoldingRanges(F,q,K,U){return this.s(F,ce,X=>X.provideFoldingRanges(y.URI.revive(q),K,U),void 0,U)}registerSelectionRangeProvider(F,q,K){const U=this.t(new te(this.h,K,this.l),F);return this.e.$registerSelectionRangeProvider(U,this.o(q,F)),this.p(U)}$provideSelectionRanges(F,q,K,U){return this.s(F,te,X=>X.provideSelectionRanges(y.URI.revive(q),K,U),[],U)}registerCallHierarchyProvider(F,q,K){const U=this.t(new Q(this.h,K),F);return this.e.$registerCallHierarchyProvider(U,this.o(q,F)),this.p(U)}$prepareCallHierarchy(F,q,K,U){return this.s(F,Q,X=>Promise.resolve(X.prepareSession(y.URI.revive(q),K,U)),void 0,U)}$provideCallHierarchyIncomingCalls(F,q,K,U){return this.s(F,Q,X=>X.provideCallsTo(q,K,U),void 0,U)}$provideCallHierarchyOutgoingCalls(F,q,K,U){return this.s(F,Q,X=>X.provideCallsFrom(q,K,U),void 0,U)}$releaseCallHierarchy(F,q){this.s(F,Q,K=>Promise.resolve(K.releaseSession(q)),void 0,void 0)}registerTypeHierarchyProvider(F,q,K){const U=this.t(new ee(this.h,K),F);return this.e.$registerTypeHierarchyProvider(U,this.o(q,F)),this.p(U)}$prepareTypeHierarchy(F,q,K,U){return this.s(F,ee,X=>Promise.resolve(X.prepareSession(y.URI.revive(q),K,U)),void 0,U)}$provideTypeHierarchySupertypes(F,q,K,U){return this.s(F,ee,X=>X.provideSupertypes(q,K,U),void 0,U)}$provideTypeHierarchySubtypes(F,q,K,U){return this.s(F,ee,X=>X.provideSubtypes(q,K,U),void 0,U)}$releaseTypeHierarchy(F,q){this.s(F,ee,K=>Promise.resolve(K.releaseSession(q)),void 0,void 0)}registerDocumentOnDropEditProvider(F,q,K,U){const X=this.q();this.f.set(X,new Ae(new me(this.e,this.h,K,X,F),F));const x=(0,t.$BF)(F,"dropMetadata")&&U?me.toInternalProviderId(F.identifier.value,U.id):void 0;return this.e.$registerDocumentOnDropEditProvider(X,this.o(q,F),x,(0,t.$BF)(F,"dropMetadata")?U:void 0),this.p(X)}$provideDocumentOnDropEdits(F,q,K,U,X,x){return this.s(F,me,Ee=>Promise.resolve(Ee.provideDocumentOnDropEdits(q,y.URI.revive(K),U,X,x)),void 0,void 0)}registerMappedEditsProvider(F,q,K){const U=this.t(new pe(this.h,K),F);return this.e.$registerMappedEditsProvider(U,this.o(q,F)),this.p(U)}$provideMappedEdits(F,q,K,U,X){return this.s(F,pe,x=>Promise.resolve(x.provideMappedEdits(q,K,U,X)),null,X)}registerDocumentPasteEditProvider(F,q,K,U){const X=this.q();this.f.set(X,new Ae(new I(this.e,this.h,K,X,F),F));const x=I.toInternalProviderId(F.identifier.value,U.id);return this.e.$registerPasteEditProvider(X,this.o(q,F),x,{supportsCopy:!!K.prepareDocumentPaste,supportsPaste:!!K.provideDocumentPasteEdits,copyMimeTypes:U.copyMimeTypes,pasteMimeTypes:U.pasteMimeTypes}),this.p(X)}$prepareDocumentPaste(F,q,K,U,X){return this.s(F,I,x=>x.prepareDocumentPaste(y.URI.revive(q),K,U,X),void 0,X)}$providePasteEdits(F,q,K,U,X,x){return this.s(F,I,Ee=>Ee.providePasteEdits(q,y.URI.revive(K),U,X,x),void 0,x)}static w(F){return{pattern:F.source,flags:F.flags}}static y(F){return{decreaseIndentPattern:he.w(F.decreaseIndentPattern),increaseIndentPattern:he.w(F.increaseIndentPattern),indentNextLinePattern:F.indentNextLinePattern?he.w(F.indentNextLinePattern):void 0,unIndentedLinePattern:F.unIndentedLinePattern?he.w(F.unIndentedLinePattern):void 0}}static z(F){return{beforeText:he.w(F.beforeText),afterText:F.afterText?he.w(F.afterText):void 0,previousLineText:F.previousLineText?he.w(F.previousLineText):void 0,action:F.action}}static B(F){return F.map(he.z)}static C(F){return{open:F.open,close:F.close,notIn:F.notIn?F.notIn.map(q=>L.SyntaxTokenType.toString(q)):void 0}}static D(F){return F.map(he.C)}setLanguageConfiguration(F,q,K){const{wordPattern:U}=K;if(U&&(0,f.$Ye)(U))throw new Error(`Invalid language configuration: wordPattern '${U}' is not allowed to match the empty string.`);U?this.h.setWordDefinitionFor(q,U):this.h.setWordDefinitionFor(q,void 0),K.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",F,"Do not use."),K.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",F,"Do not use.");const X=this.q(),x={comments:K.comments,brackets:K.brackets,wordPattern:K.wordPattern?he.w(K.wordPattern):void 0,indentationRules:K.indentationRules?he.y(K.indentationRules):void 0,onEnterRules:K.onEnterRules?he.B(K.onEnterRules):void 0,__electricCharacterSupport:K.__electricCharacterSupport,__characterPairSupport:K.__characterPairSupport,autoClosingPairs:K.autoClosingPairs?he.D(K.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(X,q,x),this.p(X)}$setWordDefinitions(F){for(const q of F)this.h.setWordDefinitionFor(q.languageId,new RegExp(q.regexSource,q.regexFlags))}}e.$bgc=he}),define(Pe[254],Re([1,0,3,8,7,31,13,6,23]),function(ge,e,y,T,C,L,R,$,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ahc=void 0;class b{constructor(k,l,p,w){this.c=l,this.d=p,this.e=w,this.b=[],this.f=0,this.g=new Set,this.a=k.getProxy(y.$6K.MainThreadLanguages)}$acceptLanguageIds(k){this.b=k}async getLanguages(){return this.b.slice(0)}async changeLanguage(k,l){await this.a.$changeLanguage(k,l);const p=this.c.getDocumentData(k);if(!p)throw new Error(`document '${k.toString()}' NOT found`);return p.document}async tokenAtPosition(k,l){const p=k.version,w=T.Position.from(l),s=await this.a.$tokensAtPosition(k.uri,w),a={type:C.StandardTokenType.Other,range:k.getWordRangeAtPosition(l)??new C.$0K(l.line,l.character,l.line,l.character)};if(!s)return a;const r={range:T.Range.to(s.range),type:T.TokenType.to(s.type)};return!r.range.contains(l)||p!==k.version?a:r}createLanguageStatusItem(k,l,p){const w=this.f++,s=this.a,a=this.g,r=`${k.identifier.value}/${l}`;if(a.has(r))throw new Error(`LanguageStatusItem with id '${l}' ALREADY exists`);a.add(r);const n={selector:p,id:l,name:k.displayName??k.name,severity:C.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let o;const c=new $.$Sc,h=()=>{if(o?.dispose(),!a.has(r)){console.warn(`LanguageStatusItem (${l}) from ${k.identifier.value} has been disposed and CANNOT be updated anymore`);return}o=(0,R.$8g)(()=>{c.clear(),this.a.$setLanguageStatus(w,{id:r,name:n.name??k.displayName??k.name,source:k.displayName??k.name,selector:T.DocumentSelector.from(n.selector,this.e),label:n.text,detail:n.detail??"",severity:n.severity===C.LanguageStatusSeverity.Error?L.default.Error:n.severity===C.LanguageStatusSeverity.Warning?L.default.Warning:L.default.Info,command:n.command&&this.d.toInternal(n.command,c),accessibilityInfo:n.accessibilityInformation,busy:n.busy})},0)},t={dispose(){c.dispose(),o?.dispose(),s.$removeLanguageStatus(w),a.delete(r)},get id(){return n.id},get name(){return n.name},set name(u){n.name=u,h()},get selector(){return n.selector},set selector(u){n.selector=u,h()},get text(){return n.text},set text(u){n.text=u,h()},set text2(u){(0,f.$CF)(k,"languageStatusText"),n.text=u,h()},get text2(){return(0,f.$CF)(k,"languageStatusText"),n.text},get detail(){return n.detail},set detail(u){n.detail=u,h()},get severity(){return n.severity},set severity(u){n.severity=u,h()},get accessibilityInformation(){return n.accessibilityInformation},set accessibilityInformation(u){n.accessibilityInformation=u,h()},get command(){return n.command},set command(u){n.command=u,h()},get busy(){return n.busy},set busy(u){n.busy=u,h()}};return h(),t}}e.$Ahc=b}),define(Pe[82],Re([1,0,21,11,2,4,14,3,27,17]),function(ge,e,y,T,C,L,R,$,f,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zgc=e.$Ygc=void 0;let A=class{constructor(l,p,w){this.f=w,this.d=new Map,this.a=p.getProxy($.$6K.MainThreadLocalization),this.b=l.environment.appLanguage,this.c=this.b===y.$g}getMessage(l,p){const{message:w,args:s,comment:a}=p;if(this.c)return(0,T.$Le)(w,s??{});let r=w;a&&a.length>0&&(r+=`/${Array.isArray(a)?a.join(""):a}`);const n=this.d.get(l)?.contents[r];return n||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${r}`),(0,T.$Le)(n??w,s??{})}getBundle(l){return this.d.get(l)?.contents}getBundleUri(l){return this.d.get(l)?.uri}async initializeLocalizedMessages(l){if(this.c||!l.l10n&&!l.isBuiltin||this.d.has(l.identifier.value))return;let p;const w=await this.g(l);if(!w){this.f.error(`No bundle location found for extension ${l.identifier.value}`);return}try{const s=await this.a.$fetchBundleContents(w),a=JSON.parse(s);p=l.isBuiltin?a.contents?.bundle:a}catch(s){this.f.error(`Failed to load translations for ${l.identifier.value} from ${w}: ${s.message}`);return}p&&this.d.set(l.identifier.value,{contents:p,uri:w})}async g(l){if(l.isBuiltin){const p=await this.a.$fetchBuiltInBundleUri(l.identifier.value,this.b);return C.URI.revive(p)}return l.l10n?C.URI.joinPath(l.extensionLocation,l.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$Ygc=A,e.$Ygc=A=Je([Ke(0,f.$nN),Ke(1,b.$0M),Ke(2,R.$nj)],A),e.$Zgc=(0,L.$6h)("IExtHostLocalizationService")}),define(Pe[255],Re([1,0,14,3,27,17,2,51]),function(ge,e,y,T,C,L,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_hc=void 0;let f=class extends y.$yj{constructor(k,l){super(l.logLevel,l.logsLocation,l.loggers.map(p=>(0,$.$Ch)(p))),this.r=k.getProxy(T.$6K.MainThreadLogger)}$setLogLevel(k,l){l?this.setLogLevel(R.URI.revive(l),k):this.setLogLevel(k)}setVisibility(k,l){super.setVisibility(k,l),this.r.$setVisibility(k,l)}s(k,l,p){return new b(this.r,k,l,p)}};e.$_hc=f,e.$_hc=f=Je([Ke(0,L.$0M),Ke(1,C.$nN)],f);class b extends y.$tj{constructor(k,l,p,w){super(w?.logLevel==="always"),this.r=k,this.s=l,this.m=!1,this.n=[],this.setLevel(p),this.r.$createLogger(l,w).then(()=>{this.u(this.n),this.m=!0})}g(k,l){const p=[[k,l]];this.m?this.u(p):this.n.push(...p)}u(k){this.r.$log(this.s,k)}flush(){this.r.$flush(this.s)}}}),define(Pe[83],Re([1,0,3,4,6,17,24]),function(ge,e,y,T,C,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2gc=e.$1gc=void 0,e.$1gc=(0,T.$6h)("IExtHostManagedSockets");let $=class{constructor(k){this.b=0,this.c=null,this.d=new Map,this.a=k.getProxy(y.$6K.MainThreadManagedSockets)}setFactory(k,l){for(const p of this.d.values())p.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new f(k,l),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(k){if(!this.c||this.c.socketFactoryId!==k)throw new Error(`No socket factory with id ${k}`);const l=++this.b,p=await this.c.makeConnection(),w=new C.$Sc;return this.d.set(l,new b(l,p,w)),w.add((0,C.$Rc)(()=>this.d.delete(l))),w.add(p.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(l),w.dispose()})),w.add(p.onDidClose(s=>{this.a.$onDidManagedSocketClose(l,s?.stack??s?.message),w.dispose()})),w.add(p.onDidReceiveMessage(s=>this.a.$onDidManagedSocketHaveData(l,R.$je.wrap(s)))),l}$remoteSocketWrite(k,l){this.d.get(k)?.actual.send(l.buffer)}$remoteSocketEnd(k){const l=this.d.get(k);l&&(l.actual.end(),l.dispose())}async $remoteSocketDrain(k){await this.d.get(k)?.actual.drain?.()}};e.$2gc=$,e.$2gc=$=Je([Ke(0,L.$0M)],$);class f{constructor(k,l){this.socketFactoryId=k,this.makeConnection=l}}class b extends C.$Tc{constructor(k,l,p){super(),this.socketId=k,this.actual=l,this.B(p)}}}),define(Pe[256],Re([1,0,3,14,23]),function(ge,e,y,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bhc=void 0;function L($){return $&&$.title}let R=class{constructor(f,b){this.b=b,this.a=f.getProxy(y.$6K.MainThreadMessageService)}showMessage(f,b,A,k,l){const p={source:{identifier:f.identifier,label:f.displayName||f.name}};let w;typeof k=="string"||L(k)?w=[k,...l]:(p.modal=k?.modal,p.useCustom=k?.useCustom,p.detail=k?.detail,w=l),p.useCustom&&(0,C.$CF)(f,"resolvers");const s=[];let a=!1;for(let r=0;r<w.length;r++){const n=w[r];if(typeof n=="string")s.push({title:n,handle:r,isCloseAffordance:!1});else if(typeof n=="object"){const{title:o,isCloseAffordance:c}=n;s.push({title:o,isCloseAffordance:!!c,handle:r}),c&&(a?this.b.warn(`[${f.identifier}] Only one message item can have 'isCloseAffordance':`,n):a=!0)}else this.b.warn(`[${f.identifier}] Invalid message item:`,n)}return this.a.$showMessage(b,A,p,s).then(r=>{if(typeof r=="number")return w[r]})}};e.$Bhc=R,e.$Bhc=R=Je([Ke(1,T.$nj)],R)}),define(Pe[257],Re([1,0,18,13,20,5,6,28,2,22,14,3,32,8,7,78,210,23,49]),function(ge,e,y,T,C,L,R,$,f,b,A,k,l,p,w,s,a,r,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ghc=e.$Fhc=void 0;let o=class{constructor(d,S,M,v,E){this.m=S,this.n=M,this.o=v,this.q=E,this.b=new $.$Ac,this.c=new $.$Ac,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new L.$Vd,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=d.getProxy(k.$6K.MainThreadNotebookKernels);const D=new l.$xN("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new l.$vN("options","Select kernel options",N=>!0,N=>{if(N&&"notebookEditor"in N&&"id"in N){const O=this.n.getIdByEditor(N.notebookEditor);return{id:N.id,extension:N.extension,notebookEditorId:O}}else if(N&&"notebookEditor"in N){const O=this.n.getIdByEditor(N.notebookEditor);if(O===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${N.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:O}}return N})],l.$wN.Void);this.o.registerApiCommand(D)}createNotebookController(d,S,M,v,E,D){for(const se of this.j.values())if(se.controller.id===S&&b.$lm.equals(d.identifier,se.extensionId))throw new Error(`notebook controller with id '${S}' ALREADY exist`);const N=this.k++,O=this;this.q.trace(`NotebookController[${N}], CREATED by ${d.identifier.value}, ${S}`);const G=()=>console.warn(`NO execute handler from notebook controller '${I.id}' of extension: '${d.identifier}'`);let W=!1;const z=new L.$Vd,P=new L.$Vd,I={id:g(d.identifier,S),notebookType:M,extensionId:d.identifier,extensionLocation:d.extensionLocation,label:v||d.identifier.value,preloads:D?D.map(p.NotebookRendererScript.from):[]};let H=E??G,ae,de;this.a.$addKernel(N,I).catch(se=>{console.log(se),W=!0});let we=0;const ke=()=>{if(W)return;const se=++we;Promise.resolve().then(()=>{se===we&&this.a.$updateKernel(N,I)})},le=new $.$Ac,ve={get id(){return S},get notebookType(){return I.notebookType},onDidChangeSelectedNotebooks:z.event,get label(){return I.label},set label(se){I.label=se??d.displayName??d.name,ke()},get detail(){return I.detail??""},set detail(se){I.detail=se,ke()},get description(){return I.description??""},set description(se){I.description=se,ke()},get supportedLanguages(){return I.supportedLanguages},set supportedLanguages(se){I.supportedLanguages=se,ke()},get supportsExecutionOrder(){return I.supportsExecutionOrder??!1},set supportsExecutionOrder(se){I.supportsExecutionOrder=se,ke()},get rendererScripts(){return I.preloads?I.preloads.map(p.NotebookRendererScript.to):[]},get executeHandler(){return H},set executeHandler(se){H=se??G},get interruptHandler(){return ae},set interruptHandler(se){ae=se,I.supportsInterrupt=!!se,ke()},set variableProvider(se){(0,r.$CF)(d,"notebookVariableProvider"),de=se,I.hasVariableProvider=!!se,se?.onDidChangeVariables(be=>O.a.$variablesUpdated(be.uri)),ke()},get variableProvider(){return de},createNotebookCellExecution(se){if(W)throw new Error("notebook controller is DISPOSED");if(!le.has(se.notebook.uri))throw O.q.trace(`NotebookController[${N}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(le.keys()).map(be=>be.toString())),new Error(`notebook controller is NOT associated to notebook: ${se.notebook.uri.toString()}`);return O._createNotebookCellExecution(se,g(d.identifier,this.id))},createNotebookExecution(se){if((0,r.$CF)(d,"notebookExecution"),W)throw new Error("notebook controller is DISPOSED");if(!le.has(se.uri))throw O.q.trace(`NotebookController[${N}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(le.keys()).map(be=>be.toString())),new Error(`notebook controller is NOT associated to notebook: ${se.uri.toString()}`);return O._createNotebookExecution(se,g(d.identifier,this.id))},dispose:()=>{W||(this.q.trace(`NotebookController[${N}], DISPOSED`),W=!0,this.j.delete(N),z.dispose(),P.dispose(),this.a.$removeKernel(N))},updateNotebookAffinity(se,be){be===w.NotebookControllerAffinity2.Hidden&&(0,r.$CF)(d,"notebookControllerAffinityHidden"),O.a.$updateNotebookPriority(N,se.uri,be)},onDidReceiveMessage:P.event,postMessage(se,be){return(0,r.$CF)(d,"notebookMessaging"),O.a.$postMessage(N,be&&O.n.getIdByEditor(be),se)},asWebviewUri(se){return(0,r.$CF)(d,"notebookMessaging"),(0,s.$wvb)(se,O.m.remote)}};return this.j.set(N,{extensionId:d.identifier,controller:ve,onDidReceiveMessage:P,onDidChangeSelection:z,associatedNotebooks:le}),ve}getIdByController(d){for(const[S,M]of this.j)if(M.controller===d)return g(M.extensionId,d.id);return null}createNotebookControllerDetectionTask(d,S){const M=this.g++,v=this;this.q.trace(`NotebookControllerDetectionTask[${M}], CREATED by ${d.identifier.value}`),this.a.$addKernelDetectionTask(M,S);const E={dispose:()=>{this.f.delete(M),v.a.$removeKernelDetectionTask(M)}};return this.f.set(M,E),E}registerKernelSourceActionProvider(d,S,M){const v=this.i++,E=typeof M.onDidChangeNotebookKernelSourceActions=="function"?v:void 0,D=this;this.h.set(v,M),this.q.trace(`NotebookKernelSourceActionProvider[${v}], CREATED by ${d.identifier.value}`),this.a.$addKernelSourceActionProvider(v,v,S);let N;return E!==void 0&&(N=M.onDidChangeNotebookKernelSourceActions(O=>this.a.$emitNotebookKernelSourceActionsChangeEvent(E))),{dispose:()=>{this.h.delete(v),D.a.$removeKernelSourceActionProvider(v,v),N?.dispose()}}}async $provideKernelSourceActions(d,S){const M=this.h.get(d);if(M){const v=new R.$Sc;return(await M.provideNotebookKernelSourceActions(S)??[]).map(D=>p.NotebookKernelSourceAction.from(D,this.o.converter,v))}return[]}$acceptNotebookAssociation(d,S,M){const v=this.j.get(d);if(v){const E=this.n.getNotebookDocument(f.URI.revive(S));M?v.associatedNotebooks.set(E.uri,!0):v.associatedNotebooks.delete(E.uri),this.q.trace(`NotebookController[${d}] ASSOCIATE notebook`,E.uri.toString(),M),v.onDidChangeSelection.fire({selected:M,notebook:E.apiNotebook})}}async $executeCells(d,S,M){const v=this.j.get(d);if(!v)return;const E=this.n.getNotebookDocument(f.URI.revive(S)),D=[];for(const N of M){const O=E.getCell(N);O&&D.push(O.apiCell)}try{this.q.trace(`NotebookController[${d}] EXECUTE cells`,E.uri.toString(),D.length),await v.controller.executeHandler.call(v.controller,D,E.apiNotebook,v.controller)}catch(N){this.q.error(`NotebookController[${d}] execute cells FAILED`,N),console.error(N)}}async $cancelCells(d,S,M){const v=this.j.get(d);if(!v)return;const E=this.n.getNotebookDocument(f.URI.revive(S));if(v.controller.interruptHandler)await v.controller.interruptHandler.call(v.controller,E.apiNotebook);else for(const D of M){const N=E.getCell(D);N&&this.b.get(N.uri)?.cancel()}if(v.controller.interruptHandler){const D=this.c.get(E.uri);M.length&&Array.isArray(D)&&D.length&&D.forEach(N=>N.dispose())}}async $provideVariables(d,S,M,v,E,D,N){const O=this.j.get(d);if(!O)return;const G=this.n.getNotebookDocument(f.URI.revive(M)),W=O.controller.variableProvider;if(!W)return;let z;if(v){if(z=this.s[v],!z)return}else this.s={};const P=E==="named"?w.NotebookVariablesRequestKind.Named:w.NotebookVariablesRequestKind.Indexed,I=W.provideVariables(G.apiNotebook,z,P,D,N);for await(const H of I){if(N.isCancellationRequested)return;const ae={id:this.r++,name:H.variable.name,value:H.variable.value,hasNamedChildren:H.hasNamedChildren,indexedChildrenCount:H.indexedChildrenCount};this.s[ae.id]=H.variable,this.a.$receiveVariable(S,ae)}}$acceptKernelMessageFromRenderer(d,S,M){const v=this.j.get(d);if(!v)return;const E=this.n.getEditorById(S);v.onDidReceiveMessage.fire(Object.freeze({editor:E.apiEditor,message:M}))}$cellExecutionChanged(d,S,M){const E=this.n.getNotebookDocument(f.URI.revive(d)).getCell(S);if(E){const D=M?p.NotebookCellExecutionState.to(M):w.NotebookCellExecutionState.Idle;D!==void 0&&this.l.fire({cell:E.apiCell,state:D})}}_createNotebookCellExecution(d,S){if(d.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const v=this.n.getNotebookDocument(d.notebook.uri).getCellFromApiCell(d);if(!v)throw new Error("invalid cell");if(this.b.has(v.uri))throw new Error(`duplicate execution for ${v.uri}`);const E=new h(S,v,this.a);this.b.set(v.uri,E);const D=E.onDidChangeState(()=>{E.state===c.Resolved&&(E.dispose(),D.dispose(),this.b.delete(v.uri))});return E.asApiObject()}_createNotebookExecution(d,S){const M=this.n.getNotebookDocument(d.uri),v=d.getCells().find(N=>{const O=M.getCellFromApiCell(N);return O&&this.b.has(O.uri)});if(v)throw new Error(`duplicate cell execution for ${v.document.uri}`);if(this.c.has(M.uri))throw new Error(`duplicate notebook execution for ${M.uri}`);const E=new u(S,M,this.a),D=E.onDidChangeState(()=>{E.state===t.Resolved&&(E.dispose(),D.dispose(),this.c.delete(M.uri))});return this.c.set(M.uri,[E,D]),E.asApiObject()}};e.$Fhc=o,e.$Fhc=o=Je([Ke(4,A.$nj)],o);var c;(function(m){m[m.Init=0]="Init",m[m.Started=1]="Started",m[m.Resolved=2]="Resolved"})(c||(c={}));class h extends R.$Tc{static{this.a=0}get state(){return this.f}constructor(d,S,M){super(),this.m=S,this.n=M,this.b=h.a++,this.c=new L.$Vd,this.onDidChangeState=this.c.event,this.f=c.Init,this.g=this.B(new C.$6d),this.h=new i(10,v=>this.s(v)),this.j=S.internalMetadata.executionOrder,this.n.$createExecution(this.b,d,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(d){await this.h.addItem(d)}async s(d){const S=Array.isArray(d)?d:[d];return this.n.$updateExecution(this.b,new n.$Tv(S))}t(){if(this.f===c.Init)throw new Error("Must call start before modifying cell output");if(this.f===c.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(d){let S=this.m;if(d&&(S=this.m.notebook.getCellFromApiCell(d)),!S)throw new Error("INVALID cell");return S.handle}y(d){return d.map(S=>{const M=w.$xM.ensureUniqueMimeTypes(S.items,!0);return M===S.items?p.NotebookCellOutput.from(S):p.NotebookCellOutput.from({items:M,id:S.id,metadata:S.metadata})})}async z(d,S,M){const v=this.w(S),E=this.y((0,y.$3b)(d));return this.r({editType:a.CellExecutionUpdateType.Output,cellHandle:v,append:M,outputs:E})}async C(d,S,M){return d=w.$xM.ensureUniqueMimeTypes((0,y.$3b)(d),!0),this.r({editType:a.CellExecutionUpdateType.OutputItems,items:d.map(p.NotebookCellOutputItem.from),outputId:S.id,append:M})}asApiObject(){const d=this;return Object.freeze({get token(){return d.g.token},get cell(){return d.m.apiCell},get executionOrder(){return d.j},set executionOrder(M){d.j=M,d.s([{editType:a.CellExecutionUpdateType.ExecutionState,executionOrder:d.j}])},start(M){if(d.f===c.Resolved||d.f===c.Started)throw new Error("Cannot call start again");d.f=c.Started,d.c.fire(),d.s({editType:a.CellExecutionUpdateType.ExecutionState,runStartTime:M})},end(M,v){if(d.f===c.Resolved)throw new Error("Cannot call resolve twice");d.f=c.Resolved,d.c.fire(),d.h.flush(),d.n.$completeExecution(d.b,new n.$Tv({runEndTime:v,lastRunSuccess:M}))},clearOutput(M){return d.t(),d.z([],M,!1)},appendOutput(M,v){return d.t(),d.z(M,v,!0)},replaceOutput(M,v){return d.t(),d.z(M,v,!1)},appendOutputItems(M,v){return d.t(),d.C(M,v,!0)},replaceOutputItems(M,v){return d.t(),d.C(M,v,!1)}})}}var t;(function(m){m[m.Init=0]="Init",m[m.Started=1]="Started",m[m.Resolved=2]="Resolved"})(t||(t={}));class u extends R.$Tc{static{this.a=0}get state(){return this.f}constructor(d,S,M){super(),this.h=S,this.j=M,this.b=u.a++,this.c=new L.$Vd,this.onDidChangeState=this.c.event,this.f=t.Init,this.g=this.B(new C.$6d),this.j.$createNotebookExecution(this.b,d,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===t.Resolved||this.f===t.Started)throw new Error("Cannot call start again");this.f=t.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===t.Resolved)throw new Error("Cannot call resolve twice");this.f=t.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class i{constructor(d,S){this.f=d,this.g=S,this.a=[],this.b=Date.now()}addItem(d){return this.a.push(d),this.c||(this.c=new T.$qh,this.b=Date.now(),(0,T.$7g)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const d=this.c;this.c=void 0;const S=this.a;return this.a=[],this.g(S).finally(()=>d.complete())}}function g(m,d){return`${m.value}/${d}`}e.$Ghc=g}),define(Pe[258],Re([1,0,5,3,107]),function(ge,e,y,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hhc=void 0;class L{constructor($,f){this.c=f,this.a=new Map,this.b=$.getProxy(T.$6K.MainThreadNotebookRenderers)}$postRendererMessage($,f,b){const A=this.c.getEditorById($);this.a.get(f)?.fire({editor:A.apiEditor,message:b})}createRendererMessaging($,f){if(!$.contributes?.notebookRenderer?.some(A=>A.id===f))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${f})`);return{onDidReceiveMessage:(A,k,l)=>this.d(f).event(A,k,l),postMessage:(A,k)=>{C.$nhc.apiEditorsToExtHost.has(A)&&([A,k]=[k,A]);const l=k&&C.$nhc.apiEditorsToExtHost.get(k);return this.b.$postMessage(l?.id,f,A)}}}d($){let f=this.a.get($);return f||(f=new y.$Vd({onDidRemoveLastListener:()=>{f?.dispose(),this.a.delete($)}}),this.a.set($,f),f)}}e.$Hhc=L}),define(Pe[259],Re([1,0,6,16,2,23,3]),function(ge,e,y,T,C,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Khc=void 0;class ${constructor(b){this.b=new Map,this.a=b.getProxy(R.$6K.MainThreadProfileContentHandlers)}registerProfileContentHandler(b,A,k){if((0,L.$CF)(b,"profileContentHandlers"),this.b.has(A))throw new Error(`Handler with id '${A}' already registered`);return this.b.set(A,k),this.a.$registerProfileContentHandler(A,k.name,k.description,b.identifier.value),(0,y.$Rc)(()=>{this.b.delete(A),this.a.$unregisterProfileContentHandler(A)})}async $saveProfile(b,A,k,l){const p=this.b.get(b);if(!p)throw new Error(`Unknown handler with id: ${b}`);return p.saveProfile(A,k,l)}async $readProfile(b,A,k){const l=this.b.get(b);if(!l)throw new Error(`Unknown handler with id: ${b}`);return l.readProfile((0,T.$If)(A)?A:C.URI.revive(A),k)}}e.$Khc=$}),define(Pe[260],Re([1,0,2,3,13,8]),function(ge,e,y,T,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mhc=void 0;class R{static{this.a=0}constructor(f,b){this.d=b,this.c=new Map,this.b=f.getProxy(T.$6K.MainThreadQuickDiff)}$provideOriginalResource(f,b,A){const k=y.URI.revive(b),l=this.c.get(f);return l?(0,C.$Yg)(()=>l.provideOriginalResource(k,A)).then(p=>p||null):Promise.resolve(null)}registerQuickDiffProvider(f,b,A,k){const l=R.a++;return this.c.set(l,b),this.b.$registerQuickDiffProvider(l,L.DocumentSelector.from(f,this.d),A,k),{dispose:()=>{this.b.$unregisterQuickDiffProvider(l),this.c.delete(l)}}}}e.$Mhc=R}),define(Pe[261],Re([1,0,20,5,6,3,2,7,15,18,31,44,23,8]),function(ge,e,y,T,C,L,R,$,f,b,A,k,l,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nhc=void 0;function w(s,a,r){const n=s.getProxy(L.$6K.MainThreadQuickOpen);class o{constructor(S,M){this.e=new Map,this.f=0,this.a=S,this.b=M}showQuickPick(S,M,v,E=y.CancellationToken.None){this.c=void 0;const D=Promise.resolve(M),N=++this.f,O=n.$show(N,{title:v?.title,placeHolder:v?.placeHolder,matchOnDescription:v?.matchOnDescription,matchOnDetail:v?.matchOnDetail,ignoreFocusLost:v?.ignoreFocusOut,canPickMany:v?.canPickMany},E),G={},W=O.then(()=>G);return Promise.race([W,D]).then(z=>{if(z===G)return;const P=(0,l.$BF)(S,"quickPickItemTooltip");return D.then(I=>{const H=[];for(let ae=0;ae<I.length;ae++){const de=I[ae];if(typeof de=="string")H.push({label:de,handle:ae});else if(de.kind===$.QuickPickItemKind.Separator)H.push({type:"separator",label:de.label});else{de.tooltip&&!P&&console.warn(`Extension '${S.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${S.identifier.value}`);const we=de.iconPath?i(de.iconPath):void 0;H.push({label:de.label,iconPath:we?.iconPath,iconClass:we?.iconClass,description:de.description,detail:de.detail,picked:de.picked,alwaysShow:de.alwaysShow,tooltip:P?p.MarkdownString.fromStrict(de.tooltip):void 0,handle:ae})}}return v&&typeof v.onDidSelectItem=="function"&&(this.c=ae=>{v.onDidSelectItem(I[ae])}),n.$setItems(N,H),O.then(ae=>{if(typeof ae=="number")return I[ae];if(Array.isArray(ae))return ae.map(de=>I[de])})})}).then(void 0,z=>{if(!(0,f.$4)(z))return n.$setError(N,z),Promise.reject(z)})}$onItemSelected(S){this.c?.(S)}showInput(S,M=y.CancellationToken.None){return this.d=S?.validateInput,n.$input(S,typeof this.d=="function",M).then(void 0,v=>{if(!(0,f.$4)(v))return Promise.reject(v)})}async $validateInput(S){if(!this.d)return;const M=await this.d(S);if(!M||typeof M=="string")return M;let v;switch(M.severity){case $.InputBoxValidationSeverity.Info:v=A.default.Info;break;case $.InputBoxValidationSeverity.Warning:v=A.default.Warning;break;case $.InputBoxValidationSeverity.Error:v=A.default.Error;break;default:v=M.message?A.default.Error:A.default.Ignore;break}return{content:M.message,severity:v}}async showWorkspaceFolderPick(S,M=y.CancellationToken.None){const v=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[S]);if(!v)return;const E=await this.a.getWorkspaceFolders2();if(E)return E.find(D=>D.uri.toString()===v.uri.toString())}createQuickPick(S){const M=new g(S,()=>this.e.delete(M._id));return this.e.set(M._id,M),M}createInputBox(S){const M=new m(S,()=>this.e.delete(M._id));return this.e.set(M._id,M),M}$onDidChangeValue(S,M){this.e.get(S)?._fireDidChangeValue(M)}$onDidAccept(S){this.e.get(S)?._fireDidAccept()}$onDidChangeActive(S,M){const v=this.e.get(S);v instanceof g&&v._fireDidChangeActive(M)}$onDidChangeSelection(S,M){const v=this.e.get(S);v instanceof g&&v._fireDidChangeSelection(M)}$onDidTriggerButton(S,M){this.e.get(S)?._fireDidTriggerButton(M)}$onDidTriggerItemButton(S,M,v){const E=this.e.get(S);E instanceof g&&E._fireDidTriggerItemButton(M,v)}$onDidHide(S){this.e.get(S)?._fireDidHide()}}class c{static{this.a=1}constructor(S,M){this.x=S,this.y=M,this._id=g.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new T.$Vd,this.q=new T.$Vd,this.r=new T.$Vd,this.s=new T.$Vd,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(S){this.b=S,this.z({title:S})}get step(){return this.c}set step(S){this.c=S,this.z({step:S})}get totalSteps(){return this.d}set totalSteps(S){this.d=S,this.z({totalSteps:S})}get enabled(){return this.g}set enabled(S){this.g=S,this.z({enabled:S})}get busy(){return this.j}set busy(S){this.j=S,this.z({busy:S})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(S){this.k=S,this.z({ignoreFocusOut:S})}get value(){return this.l}set value(S){this.l=S,this.z({value:S})}get placeholder(){return this.m}set placeholder(S){this.m=S,this.z({placeholder:S})}get buttons(){return this.n}set buttons(S){this.n=S.slice(),this.o.clear(),S.forEach((M,v)=>{const E=M===$.$qM.Back?-1:v;this.o.set(E,M)}),this.z({buttons:S.map((M,v)=>({...i(M.iconPath),tooltip:M.tooltip,handle:M===$.$qM.Back?-1:v}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(S){this.l=S,this.q.fire(S)}_fireDidTriggerButton(S){const M=this.o.get(S);M&&this.r.fire(M)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,C.$Oc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),n.$dispose(this._id))}z(S){if(!this.v){for(const M of Object.keys(S)){const v=S[M];this.u[M]=v===void 0?null:v}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){n.$createOrUpdate(this.u),this.u={id:this._id}}}function h(d){if(d instanceof $.$3L)return{id:d.id};const S=u(d),M=t(d);return{dark:typeof S=="string"?R.URI.file(S):S,light:typeof M=="string"?R.URI.file(M):M}}function t(d){return typeof d=="object"&&"light"in d?d.light:d}function u(d){return typeof d=="object"&&"dark"in d?d.dark:d}function i(d){const S=h(d);let M,v;return"id"in S?v=k.ThemeIcon.asClassName(S):M=S,{iconPath:M,iconClass:v}}class g extends c{constructor(S,M){super(S.identifier,M),this.O=S,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new T.$Vd,this.L=[],this.M=new T.$Vd,this.N=new T.$Vd,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(S){this.B=S.slice(),this.C.clear(),this.D.clear(),S.forEach((E,D)=>{this.C.set(D,E),this.D.set(E,D)});const M=(0,l.$BF)(this.O,"quickPickItemTooltip"),v=[];for(let E=0;E<S.length;E++){const D=S[E];if(D.kind===$.QuickPickItemKind.Separator)v.push({type:"separator",label:D.label});else{D.tooltip&&!M&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const N=D.iconPath?i(D.iconPath):void 0;v.push({handle:E,label:D.label,iconPath:N?.iconPath,iconClass:N?.iconClass,description:D.description,detail:D.detail,picked:D.picked,alwaysShow:D.alwaysShow,tooltip:M?p.MarkdownString.fromStrict(D.tooltip):void 0,buttons:D.buttons?.map((O,G)=>({...i(O.iconPath),tooltip:O.tooltip,handle:G}))})}}this.z({items:v})}get canSelectMany(){return this.E}set canSelectMany(S){this.E=S,this.z({canSelectMany:S})}get matchOnDescription(){return this.F}set matchOnDescription(S){this.F=S,this.z({matchOnDescription:S})}get matchOnDetail(){return this.G}set matchOnDetail(S){this.G=S,this.z({matchOnDetail:S})}get sortByLabel(){return this.H}set sortByLabel(S){this.H=S,this.z({sortByLabel:S})}get keepScrollPosition(){return this.I}set keepScrollPosition(S){this.I=S,this.z({keepScrollPosition:S})}get activeItems(){return this.J}set activeItems(S){this.J=S.filter(M=>this.D.has(M)),this.z({activeItems:this.J.map(M=>this.D.get(M))})}get selectedItems(){return this.L}set selectedItems(S){this.L=S.filter(M=>this.D.has(M)),this.z({selectedItems:this.L.map(M=>this.D.get(M))})}_fireDidChangeActive(S){const M=(0,b.$Hb)(S.map(v=>this.C.get(v)));this.J=M,this.K.fire(M)}_fireDidChangeSelection(S){const M=(0,b.$Hb)(S.map(v=>this.C.get(v)));this.L=M,this.M.fire(M)}_fireDidTriggerItemButton(S,M){const v=this.C.get(S);if(!v||!v.buttons||!v.buttons.length)return;const E=v.buttons[M];E&&this.N.fire({button:E,item:v})}}class m extends c{constructor(S,M){super(S.identifier,M),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(S){this.B=S,this.z({password:S})}get prompt(){return this.C}set prompt(S){this.C=S,this.z({prompt:S})}get valueSelection(){return this.D}set valueSelection(S){this.D=S,this.z({valueSelection:S})}get validationMessage(){return this.E}set validationMessage(S){this.E=S,S?typeof S=="string"?this.z({validationMessage:S,severity:A.default.Error}):this.z({validationMessage:S.message,severity:S.severity??A.default.Error}):this.z({validationMessage:void 0,severity:A.default.Ignore})}}return new o(a,r)}e.$Nhc=w}),define(Pe[262],Re([1,0,2,5,66,6,13,3,18,138,14,22,44,8,23,12,21]),function(ge,e,y,T,C,L,R,$,f,b,A,k,l,p,w,s,a){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.$Phc=e.$Ohc=void 0;function n(N){return N instanceof y.URI}function o(N,O){return N.scheme===s.Schemas.file&&O.scheme===s.Schemas.file&&a.$k?N.toString()===O.toString():N.toString().toLowerCase()===O.toString().toLowerCase()}function c(N){if(N)return typeof N.iconPath=="string"?y.URI.file(N.iconPath):y.URI.isUri(N.iconPath)||l.ThemeIcon.isThemeIcon(N.iconPath)?N.iconPath:void 0}function h(N){if(N.icon){if(y.URI.isUri(N.icon))return N.icon;if(l.ThemeIcon.isThemeIcon(N.icon))return N.icon;{const O=N.icon;return{light:O.light,dark:O.dark}}}else return}function t(N,O){if(!N.iconPath&&!O.iconPath)return 0;if(N.iconPath){if(!O.iconPath)return 1}else return-1;const G=typeof N.iconPath=="string"?N.iconPath:y.URI.isUri(N.iconPath)?N.iconPath.fsPath:N.iconPath.id,W=typeof O.iconPath=="string"?O.iconPath:y.URI.isUri(O.iconPath)?O.iconPath.fsPath:O.iconPath.id;return(0,b.$Sq)(G,W)}function u(N,O){let G=0;if(N.strikeThrough!==O.strikeThrough)return N.strikeThrough?1:-1;if(N.faded!==O.faded)return N.faded?1:-1;if(N.tooltip!==O.tooltip)return(N.tooltip||"").localeCompare(O.tooltip||"");if(G=t(N,O),G!==0)return G;if(N.light&&O.light)G=t(N.light,O.light);else{if(N.light)return 1;if(O.light)return-1}if(G!==0)return G;if(N.dark&&O.dark)G=t(N.dark,O.dark);else{if(N.dark)return 1;if(O.dark)return-1}return G}function i(N,O){if(N.command!==O.command)return N.command<O.command?-1:1;if(N.title!==O.title)return N.title<O.title?-1:1;if(N.tooltip!==O.tooltip){if(N.tooltip!==void 0&&O.tooltip!==void 0)return N.tooltip<O.tooltip?-1:1;if(N.tooltip!==void 0)return 1;if(O.tooltip!==void 0)return-1}if(N.arguments===O.arguments)return 0;if(N.arguments)if(O.arguments){if(N.arguments.length!==O.arguments.length)return N.arguments.length-O.arguments.length}else return 1;else return-1;for(let G=0;G<N.arguments.length;G++){const W=N.arguments[G],z=O.arguments[G];if(W!==z&&!(n(W)&&n(z)&&o(W,z)))return W<z?-1:1}return 0}function g(N,O){let G=(0,b.$Sq)(N.resourceUri.fsPath,O.resourceUri.fsPath,!0);if(G!==0)return G;if(N.command&&O.command)G=i(N.command,O.command);else{if(N.command)return 1;if(O.command)return-1}if(G!==0)return G;if(N.decorations&&O.decorations)G=u(N.decorations,O.decorations);else{if(N.decorations)return 1;if(O.decorations)return-1}if(N.multiFileDiffEditorModifiedUri&&O.multiFileDiffEditorModifiedUri)G=(0,b.$Sq)(N.multiFileDiffEditorModifiedUri.fsPath,O.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(N.multiFileDiffEditorModifiedUri)return 1;if(O.multiFileDiffEditorModifiedUri)return-1}if(N.multiDiffEditorOriginalUri&&O.multiDiffEditorOriginalUri)G=(0,b.$Sq)(N.multiDiffEditorOriginalUri.fsPath,O.multiDiffEditorOriginalUri.fsPath,!0);else{if(N.multiDiffEditorOriginalUri)return 1;if(O.multiDiffEditorOriginalUri)return-1}return G}function m(N,O){for(let G=0;G<N.length;G++)if(N[G]!==O[G])return!1;return!0}function d(N,O){return N.command===O.command&&N.title===O.title&&N.tooltip===O.tooltip&&(N.arguments&&O.arguments?m(N.arguments,O.arguments):N.arguments===O.arguments)}function S(N,O){return(0,f.$ub)(N,O,d)}class M{#e;#t;get value(){return this.d}set value(O){O=O??"",this.#e.$setInputBoxValue(this.l,O),this.n(O)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(O){this.#e.$setInputBoxPlaceholder(this.l,O),this.f=O}get validateInput(){return(0,w.$CF)(this.k,"scmValidation"),this.g}set validateInput(O){if((0,w.$CF)(this.k,"scmValidation"),O&&typeof O!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=O,this.#e.$setValidationProviderIsEnabled(this.l,!!O)}get enabled(){return this.h}set enabled(O){O=!!O,this.h!==O&&(this.h=O,this.#e.$setInputBoxEnablement(this.l,O))}get visible(){return this.j}set visible(O){O=!!O,this.j!==O&&(this.j=O,this.#e.$setInputBoxVisibility(this.l,O))}get document(){return(0,w.$CF)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(O,G,W,z,P){this.k=O,this.l=z,this.m=P,this.d="",this.e=new T.$Vd,this.f="",this.h=!0,this.j=!0,this.#t=G,this.#e=W}showValidationMessage(O,G){(0,w.$CF)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,O,G)}$onInputBoxValueChange(O){this.n(O)}n(O){this.d=O,this.e.fire(O)}}e.$Ohc=M;class v{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(O){this.v=O,this.q.$updateGroupLabel(this.t,this.handle,O)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(O){this.p=O,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(O){this.f=[...O],this.k.fire()}constructor(O,G,W,z,P,I,H){this.q=O,this.s=G,this.t=W,this.u=z,this.v=P,this.multiDiffEditorEnableViewChanges=I,this.w=H,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new T.$Vd,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new T.$Vd,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=v.d++}getResourceState(O){return this.g.get(O)}$executeResourceCommand(O,G){const W=this.h.get(O);return W?(0,R.$Yg)(()=>this.s.executeCommand(W.command,...W.arguments||[],G)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const O=[...this.f].sort(g),W=(0,f.$Db)(this.o,O,g).map(I=>{const H=I.toInsert.map(ae=>{const de=this.e++;this.g.set(de,ae);const we=ae.resourceUri;let ke;if(ae.command)if(ae.command.command==="vscode.open"||ae.command.command==="vscode.diff"||ae.command.command==="vscode.changes"){const te=new L.$Sc;ke=this.s.converter.toInternal(ae.command,te),this.j.set(de,te)}else this.h.set(de,ae.command);const le=(0,w.$BF)(this.w,"scmMultiDiffEditor"),ve=le?ae.multiDiffEditorOriginalUri:void 0,se=le?ae.multiFileDiffEditorModifiedUri:void 0,be=c(ae.decorations),ne=ae.decorations&&c(ae.decorations.light)||be,Y=ae.decorations&&c(ae.decorations.dark)||be,V=[ne,Y],ie=ae.decorations&&ae.decorations.tooltip||"",Ie=ae.decorations&&!!ae.decorations.strikeThrough,Le=ae.decorations&&!!ae.decorations.faded,Ce=ae.contextValue||"";return{rawResource:[de,we,V,ie,Ie,Le,Ce,ke,ve,se],handle:de}});return{start:I.start,deleteCount:I.deleteCount,toInsert:H}}),z=W.map(({start:I,deleteCount:H,toInsert:ae})=>[I,H,ae.map(de=>de.rawResource)]),P=W.reverse();for(const{start:I,deleteCount:H,toInsert:ae}of P){const de=ae.map(ke=>ke.handle),we=this.n.splice(I,H,...de);for(const ke of we)this.g.delete(ke),this.h.delete(ke),this.j.get(ke)?.dispose(),this.j.delete(ke)}return this.o=O,z}dispose(){this.l=!0,this.m.fire()}}class E{static{this.d=0}#e;get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(O){this.g!==O&&(this.g=O,this.#e.$updateSourceControl(this.w,{count:O}))}get quickDiffProvider(){return this.h}set quickDiffProvider(O){this.h=O;let G;(0,w.$BF)(this.x,"quickDiffProvider")&&(G=O?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!O,quickDiffLabel:G})}get historyProvider(){return(0,w.$CF)(this.x,"scmHistoryProvider"),this.j}set historyProvider(O){(0,w.$CF)(this.x,"scmHistoryProvider"),this.j=O,this.k.value=new L.$Sc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!O}),O&&this.k.value.add(O.onDidChangeCurrentHistoryItemGroup(()=>{this.l=O?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(O){O!==this.m&&(this.m=O,this.#e.$updateSourceControl(this.w,{commitTemplate:O}))}get acceptInputCommand(){return this.o}set acceptInputCommand(O){this.n.value=new L.$Sc,this.o=O;const G=this.y.converter.toInternal(O,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:G})}get actionButton(){return(0,w.$CF)(this.x,"scmActionButton"),this.q}set actionButton(O){(0,w.$CF)(this.x,"scmActionButton"),this.p.value=new L.$Sc,this.q=O;const G=O!==void 0?{command:this.y.converter.toInternal(O.command,this.p.value),secondaryCommands:O.secondaryCommands?.map(W=>W.map(z=>this.y.converter.toInternal(z,this.p.value))),description:O.description,enabled:O.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:G??null})}get statusBarCommands(){return this.t}set statusBarCommands(O){if(this.t&&O&&S(this.t,O))return;this.s.value=new L.$Sc,this.t=O;const G=(O||[]).map(W=>this.y.converter.toInternal(W,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:G})}get selected(){return this.u}constructor(O,G,W,z,P,I,H){this.x=O,this.y=z,this.z=P,this.A=I,this.B=H,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new L.$Uc,this.m=void 0,this.n=new L.$Uc,this.o=void 0,this.p=new L.$Uc,this.s=new L.$Uc,this.t=void 0,this.u=!1,this.v=new T.$Vd,this.onDidChangeSelection=this.v.event,this.w=E.d++,this.C=new Map,this.D=new Set,this.#e=W;const ae=y.URI.from({scheme:s.Schemas.vscodeSourceControl,path:`${P}/scm${this.w}/input`,query:H?`rootUri=${encodeURIComponent(H.toString())}`:void 0});this.f=new M(O,G,this.#e,this.w,ae),this.#e.$registerSourceControl(this.w,P,I,H,ae)}createResourceGroup(O,G,W){const z=(0,w.$BF)(this.x,"scmMultiDiffEditor")&&W?.multiDiffEditorEnableViewChanges===!0,P=new v(this.#e,this.y,this.w,O,G,z,this.x),I=T.Event.once(P.onDidDispose)(()=>this.C.delete(P));return this.C.set(P,I),this.eventuallyAddResourceGroups(),P}eventuallyAddResourceGroups(){const O=[],G=[];for(const[W,z]of this.C){z.dispose();const P=W.onDidUpdateResourceStates(()=>{this.D.add(W),this.eventuallyUpdateResourceStates()});T.Event.once(W.onDidDispose)(()=>{this.D.delete(W),P.dispose(),this.e.delete(W.handle),this.#e.$unregisterGroup(this.w,W.handle)}),O.push([W.handle,W.id,W.label,W.features,W.multiDiffEditorEnableViewChanges]);const I=W._takeResourceStateSnapshot();I.length>0&&G.push([W.handle,I]),this.e.set(W.handle,W)}this.#e.$registerGroups(this.w,O,G),this.C.clear()}eventuallyUpdateResourceStates(){const O=[];this.D.forEach(G=>{const W=G._takeResourceStateSnapshot();W.length!==0&&O.push([G.handle,W])}),O.length>0&&this.#e.$spliceResourceStates(this.w,O),this.D.clear()}getResourceGroup(O){return this.e.get(O)}setSelectionState(O){this.u=O,this.v.fire(O)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(O=>O.dispose()),this.#e.$unregisterSourceControl(this.w)}}Je([(0,C.$yh)(100)],E.prototype,"eventuallyAddResourceGroups",null),Je([(0,C.$yh)(100)],E.prototype,"eventuallyUpdateResourceStates",null);let D=class{static{r=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(O,G,W,z){this.l=G,this.m=W,this.n=z,this.g=new Map,this.h=new k.$nm,this.j=new T.$Vd,this.e=O.getProxy($.$6K.MainThreadSCM),this.f=O.getProxy($.$6K.MainThreadTelemetry),G.registerArgumentProcessor({processArgument:P=>{if(P&&P.$mid===3){const I=this.g.get(P.sourceControlHandle);if(!I)return P;const H=I.getResourceGroup(P.groupHandle);return H?H.getResourceState(P.handle):P}else if(P&&P.$mid===4){const I=this.g.get(P.sourceControlHandle);return I?I.getResourceGroup(P.groupHandle):P}else if(P&&P.$mid===5){const I=this.g.get(P.handle);return I||P}return P}})}createSourceControl(O,G,W,z){this.n.trace("ExtHostSCM#createSourceControl",O.identifier.value,G,W,z),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:O.identifier.value});const P=r.d++,I=new E(O,this.m,this.e,this.l,G,W,z);this.g.set(P,I);const H=this.h.get(O.identifier)||[];return H.push(I),this.h.set(O.identifier,H),I}getLastInputBox(O){this.n.trace("ExtHostSCM#getLastInputBox",O.identifier.value);const G=this.h.get(O.identifier),W=G&&G[G.length-1];return W&&W.inputBox}$provideOriginalResource(O,G,W){const z=y.URI.revive(G);this.n.trace("ExtHostSCM#$provideOriginalResource",O,z.toString());const P=this.g.get(O);return!P||!P.quickDiffProvider||!P.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,R.$Yg)(()=>P.quickDiffProvider.provideOriginalResource(z,W)).then(I=>I||null)}$onInputBoxValueChange(O,G){this.n.trace("ExtHostSCM#$onInputBoxValueChange",O);const W=this.g.get(O);return W&&W.inputBox.$onInputBoxValueChange(G),Promise.resolve(void 0)}$executeResourceCommand(O,G,W,z){this.n.trace("ExtHostSCM#$executeResourceCommand",O,G,W);const P=this.g.get(O);if(!P)return Promise.resolve(void 0);const I=P.getResourceGroup(G);return I?I.$executeResourceCommand(W,z):Promise.resolve(void 0)}$validateInput(O,G,W){this.n.trace("ExtHostSCM#$validateInput",O);const z=this.g.get(O);return!z||!z.inputBox.validateInput?Promise.resolve(void 0):(0,R.$Yg)(()=>z.inputBox.validateInput(G,W)).then(P=>{if(!P)return Promise.resolve(void 0);const I=p.MarkdownString.fromStrict(P.message);return I?Promise.resolve([I,P.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(O){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",O),O!==void 0&&this.g.get(O)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=O,Promise.resolve(void 0)}async $resolveHistoryItemGroupBase(O,G,W){return await this.g.get(O)?.historyProvider?.resolveHistoryItemGroupBase(G,W)??void 0}async $resolveHistoryItemGroupCommonAncestor(O,G,W,z){return await this.g.get(O)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(G,W,z)??void 0}async $provideHistoryItems(O,G,W,z){return(await this.g.get(O)?.historyProvider?.provideHistoryItems(G,W,z))?.map(H=>({...H,icon:h(H)}))??void 0}async $provideHistoryItemSummary(O,G,W,z){const P=this.g.get(O)?.historyProvider;if(typeof P?.provideHistoryItemSummary!="function")return;const I=await P.provideHistoryItemSummary(G,W,z);return I?{...I,icon:h(I)}:void 0}async $provideHistoryItemChanges(O,G,W,z){return await this.g.get(O)?.historyProvider?.provideHistoryItemChanges(G,W,z)??void 0}};e.$Phc=D,e.$Phc=D=r=Je([Ke(3,A.$nj)],D)}),define(Pe[84],Re([1,0,3,5,4]),function(ge,e,y,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wgc=e.$Vgc=void 0;class L{constructor($){this.b=new T.$Vd,this.onDidChangePassword=this.b.event,this.a=$.getProxy(y.$6K.MainThreadSecretState)}async $onDidChangePassword($){this.b.fire($)}get($,f){return this.a.$getPassword($,f)}store($,f,b){return this.a.$setPassword($,f,b)}delete($,f){return this.a.$deletePassword($,f)}}e.$Vgc=L,e.$Wgc=(0,C.$6h)("IExtHostSecretState")}),define(Pe[263],Re([1,0,3,8,2]),function(ge,e,y,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qhc=void 0;class L{static{this.a=0}constructor($,f){this.d=f,this.c=new Map,this.b=$.getProxy(y.$6K.MainThreadShare)}async $provideShare($,f,b){return await this.c.get($)?.provideShare({selection:T.Range.to(f.selection),resourceUri:C.URI.revive(f.resourceUri)},b)??void 0}registerShareProvider($,f){const b=L.a++;return this.c.set(b,f),this.b.$registerShareProvider(b,T.DocumentSelector.from($,this.d),f.id,f.label,f.priority),{dispose:()=>{this.b.$unregisterShareProvider(b),this.c.delete(b)}}}}e.$Qhc=L}),define(Pe[264],Re([1,0,20,6,3]),function(ge,e,y,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rhc=void 0;class L{static{this.a=1}constructor($){this.c=new Map,this.d=new Map,this.b=$.getProxy(C.$6K.MainThreadSpeech)}async $createSpeechToTextSession($,f){const b=this.c.get($);if(!b)return;const A=new T.$Sc,k=new y.$6d;this.d.set(f,k);const l=A.add(b.provideSpeechToTextSession(k.token));A.add(l.onDidChange(p=>{k.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(f,p)})),A.add(k.token.onCancellationRequested(()=>A.dispose()))}async $cancelSpeechToTextSession($){this.d.get($)?.dispose(!0),this.d.delete($)}registerProvider($,f,b){const A=L.a++;return this.c.set(A,b),this.b.$registerProvider(A,f,{extension:$,displayName:$.value}),(0,T.$Rc)(()=>{this.b.$unregisterProvider(A),this.c.delete(A)})}}e.$Rhc=L}),define(Pe[265],Re([1,0,7,3,163,6,8,16]),function(ge,e,y,T,C,L,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Thc=e.$Shc=void 0;class f{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new y.$4L("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new y.$4L("statusBarItem.warningForeground")]])}#e;#t;constructor(l,p,w,s,a,r=y.StatusBarAlignment.Left,n){if(this.i=!1,this.k="",this.q=new L.$Sc,this.#e=l,this.#t=p,a&&s){this.c=(0,y.$GL)(s.identifier,a);const o=w.get(this.c);o&&(r=o.alignLeft?y.StatusBarAlignment.Left:y.StatusBarAlignment.Right,n=o.priority,this.j=!0,this.name=o.name,this.text=o.text,this.tooltip=o.tooltip,this.command=o.command,this.accessibilityInformation=o.accessibilityInformation)}else this.c=String(f.a++);this.e=s,this.f=a,this.g=r,this.h=this.u(n)}u(l){if((0,$.$Mf)(l))return l===Number.POSITIVE_INFINITY?Number.MAX_VALUE:l===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:l}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(l){this.k=l,this.v()}set name(l){this.m=l,this.v()}set tooltip(l){this.l=l,this.v()}set color(l){this.n=l,this.v()}set backgroundColor(l){l&&!f.b.has(l.id)&&(l=void 0),this.o=l,this.v()}set command(l){this.r?.fromApi!==l&&(this.p&&this.q.add(this.p),this.p=new L.$Sc,typeof l=="string"?this.r={fromApi:l,internal:this.#t.toInternal({title:"",command:l},this.p)}:l?this.r={fromApi:l,internal:this.#t.toInternal(l,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(l){this.t=l,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let l;this.e?this.f?l=`${this.e.identifier.value}.${this.f}`:l=this.e.identifier.value:l=this.f;let p;this.m?p=this.m:p=(0,C.localize)(0,null,this.e.displayName||this.e.name);let w=this.n;this.o&&(w=f.b.get(this.o.id));const s=R.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,l,this.e?.identifier.value,p,this.k,s,this.r?.internal,w,this.o,this.g===y.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$Shc=f;class b{constructor(l){this.b=[],this.a=l.createStatusBarEntry(void 0,"status.extensionMessage",y.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,C.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(l){const p={message:l};return this.b.unshift(p),this.c(),new y.$8K(()=>{const w=this.b.indexOf(p);w>=0&&(this.b.splice(w,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class A{constructor(l,p){this.e=new Map,this.a=l.getProxy(T.$6K.MainThreadStatusBar),this.b=p,this.c=new b(this)}$acceptStaticEntries(l){for(const p of l)this.e.set(p.entryId,p)}createStatusBarEntry(l,p,w,s){return new f(this.a,this.b,this.e,l,p,w,s)}setStatusBarMessage(l,p){const w=this.c.setMessage(l);let s;return typeof p=="number"?s=setTimeout(()=>w.dispose(),p):typeof p<"u"&&p.then(()=>w.dispose(),()=>w.dispose()),new y.$8K(()=>{w.dispose(),clearTimeout(s)})}}e.$Thc=A}),define(Pe[85],Re([1,0,3,5,4]),function(ge,e,y,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ogc=e.$Ngc=void 0;class L{constructor($,f){this.c=f,this.b=new T.$Vd,this.onDidChangeStorage=this.b.event,this.a=$.getProxy(y.$6K.MainThreadStorage)}registerExtensionStorageKeysToSync($,f){this.a.$registerExtensionStorageKeysToSync($,f)}async initializeExtensionStorage($,f,b){const A=await this.a.$initializeExtensionStorage($,f);let k;return A&&(k=this.d($,f,A)),k||b}setValue($,f,b){return this.a.$setValue($,f,b)}$acceptValue($,f,b){const A=this.d($,f,b);A&&this.b.fire({shared:$,key:f,value:A})}d($,f,b){try{return JSON.parse(b)}catch(A){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${f}, global: ${$}): ${A}`)}}}e.$Ngc=L,e.$Ogc=(0,C.$6h)("IExtHostStorage")}),define(Pe[86],Re([1,0,4,27,14,63,2]),function(ge,e,y,T,C,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xgc=e.$wgc=void 0,e.$wgc=(0,y.$6h)("IExtensionStoragePaths");let $=class{constructor(b,A,k){this.d=A,this.f=k,this.a=b.workspace??void 0,this.b=b.environment,this.whenReady=this.h().then(l=>this.c=l)}async g(b){return R.URI.joinPath(this.b.workspaceStorageHome,b)}async h(){if(!this.a)return Promise.resolve(void 0);const b=this.a.id,A=await this.g(b);try{return await this.f.value.stat(A),this.d.trace("[ExtHostStorage] storage dir already exists",A),A}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",A),await this.f.value.createDirectory(A),await this.f.value.writeFile(R.URI.joinPath(A,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:R.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),A}catch(k){this.d.error("[ExtHostStorage]",k);return}}workspaceValue(b){if(this.c)return R.URI.joinPath(this.c,b.identifier.value)}globalValue(b){return R.URI.joinPath(this.b.globalStorageHome,b.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$xgc=$,e.$xgc=$=Je([Ke(0,T.$nN),Ke(1,C.$nj),Ke(2,L.$vgc)],$)}),define(Pe[64],Re([1,0,5,3,4,2,17,6,7,165,15,193,20,33,194,44,13,8,32]),function(ge,e,y,T,C,L,R,$,f,b,A,k,l,p,w,s,a,r,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ugc=e.$Tgc=e.$Sgc=e.$Rgc=void 0,e.$Rgc=(0,C.$6h)("IExtHostTerminalService");class o{constructor(v,E,D,N){this.l=v,this._id=E,this.m=D,this.n=N,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(G=>this.f=G);const O=this;this.value={get name(){return O.n||""},get processId(){return O.b},get creationOptions(){return O.m},get exitStatus(){return O.h},get state(){return O.j},get selection(){return O.k},sendText(G,W=!0){O.q(),O.l.$sendText(O._id,G,W)},show(G){O.q(),O.l.$show(O._id,G)},hide(){O.q(),O.l.$hide(O._id)},dispose(){O.a||(O.a=!0,O.l.$dispose(O._id))},get dimensions(){if(!(O.d===void 0||O.g===void 0))return{columns:O.d,rows:O.g}}}}async create(v,E){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:v.name,shellPath:v.shellPath??void 0,shellArgs:v.shellArgs??void 0,cwd:v.cwd??E?.cwd??void 0,env:v.env??void 0,icon:m(v.iconPath)??void 0,color:s.ThemeColor.isThemeColor(v.color)?v.color.id:void 0,initialText:v.message??void 0,strictEnv:v.strictEnv??void 0,hideFromUser:v.hideFromUser??void 0,isFeatureTerminal:E?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:E?.useShellEnvironment??void 0,location:E?.location||this.o(v.location,E?.resolvedExtHostIdentifier),isTransient:v.isTransient??void 0})}async createExtensionTerminal(v,E,D,N,O){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:N,color:s.ThemeColor.isThemeColor(O)?O.id:void 0,location:E?.location||this.o(v,D),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(v,E){return typeof v=="object"?"parentTerminal"in v&&v.parentTerminal&&E?{parentTerminal:E}:"viewColumn"in v?{viewColumn:r.ViewColumn.from(v.viewColumn),preserveFocus:v.preserveFocus}:void 0:v}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(v){this.n=v}setExitStatus(v,E){this.h=Object.freeze({code:v,reason:E})}setDimensions(v,E){return v===this.d&&E===this.g||v===0||E===0?!1:(this.d=v,this.g=E,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(v){this.k=v}_setProcessId(v){this.f?(this.f(v),this.f=void 0):this.b.then(E=>{E!==v&&(this.b=Promise.resolve(v))})}}e.$Sgc=o;class c{get onProcessReady(){return this.b.event}constructor(v){this.g=v,this.id=0,this.shouldPersist=!1,this.a=new y.$Vd,this.onProcessData=this.a.event,this.b=new y.$Vd,this.d=new y.$Vd,this.onDidChangeProperty=this.d.event,this.f=new y.$Vd,this.onProcessExit=this.f.event}refreshProperty(v){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${v}`)}updateProperty(v,E){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${v}, value: ${E}`)}async start(){}shutdown(){this.g.close()}input(v){this.g.handleInput?.(v)}resize(v,E){this.g.setDimensions?.({columns:v,rows:E})}clearBuffer(){}async processBinary(v){}acknowledgeDataEvent(v){}async setUnicodeVersion(v){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(v){this.g.onDidWrite(E=>this.a.fire(E)),this.g.onDidClose?.((E=void 0)=>{this.f.fire(E===void 0?void 0:E)}),this.g.onDidOverrideDimensions?.(E=>{E&&this.d.fire({type:"overrideDimensions",value:{cols:E.columns,rows:E.rows}})}),this.g.onDidChangeName?.(E=>{this.d.fire({type:"title",value:E})}),this.g.open(v||void 0),v&&this.g.setDimensions?.(v),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let h=1,t=class extends $.$Tc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(v=>v.value)}constructor(v,E,D){super(),this.Q=E,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new $.$Uc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new y.$Vd,this.onDidCloseTerminal=this.H.event,this.I=new y.$Vd,this.onDidOpenTerminal=this.I.event,this.J=new y.$Vd,this.onDidChangeActiveTerminal=this.J.event,this.L=new y.$Vd,this.onDidChangeTerminalDimensions=this.L.event,this.M=new y.$Vd,this.onDidChangeTerminalState=this.M.event,this.N=new y.$Vd,this.onDidChangeShell=this.N.event,this.O=new y.$Vd({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new y.$Vd({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=D.getProxy(T.$6K.MainThreadTerminalService),this.y=new w.$Krb(this.a.$sendProcessData),this.a.$registerProcessSupport(v),this.Q.registerArgumentProcessor({processArgument:N=>{const O=G=>{const W=G;return this.W(W.instanceId)?.value};switch(N?.$mid){case 15:return O(N);default:{if(Array.isArray(N))for(let G=0;G<N.length&&N[G].$mid===15;G++)N[G]=O(N[G]);return N}}}}),this.B({dispose:()=>{for(const[N,O]of this.g)O.shutdown(!0)}})}getDefaultShell(v){return(v?this.u:this.s)?.path||""}getDefaultShellArgs(v){return(v?this.u:this.s)?.args||[]}createExtensionTerminal(v,E){const D=new o(this.a,(0,p.$qg)(),v,v.name),N=new c(v.pty);return D.createExtensionTerminal(v.location,E,this.R(v,E).resolvedExtHostIdentifier,m(v.iconPath),d(v.color)).then(O=>{const G=this.S(O,N);this.h[O]=G}),this.f.push(D),D.value}R(v,E){if(E=E||{},v.location&&typeof v.location=="object"&&"parentTerminal"in v.location){const D=v.location.parentTerminal;if(D){const N=this.f.find(O=>O.value===D);N&&(E.resolvedExtHostIdentifier=N._id)}}else v.location&&typeof v.location!="object"?E.location=v.location:E.location&&typeof E.location=="object"&&"splitActiveTerminal"in E.location&&(E.location={splitActiveTerminal:!0});return E}attachPtyToTerminal(v,E){if(!this.W(v))throw new Error(`Cannot resolve terminal with id ${v} for virtual process`);const N=new c(E),O=this.S(v,N);this.h[v]=O}async $acceptActiveTerminalChanged(v){const E=this.b;if(v===null){this.b=void 0,E!==this.b&&this.J.fire(this.b);return}const D=this.W(v);D&&(this.b=D,E!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(v,E){const D=this.W(v);D&&this.O.fire({terminal:D.value,data:E})}async $acceptTerminalDimensions(v,E,D){const N=this.W(v);N&&N.setDimensions(E,D)&&this.L.fire({terminal:N.value,dimensions:N.value.dimensions})}async $acceptDidExecuteCommand(v,E){const D=this.W(v);D&&this.P.fire({terminal:D.value,...E})}async $acceptTerminalMaximumDimensions(v,E,D){this.g.get(v)?.resize(E,D)}async $acceptTerminalTitleChange(v,E){const D=this.W(v);D&&(D.name=E)}async $acceptTerminalClosed(v,E,D){const N=this.Y(this.f,v);if(N!==null){const O=this.f.splice(N,1)[0];O.setExitStatus(E,D),this.H.fire(O.value)}}$acceptTerminalOpened(v,E,D,N){if(E){const W=this.Y(this.f,E);if(W!==null){this.f[W]._id=v,this.I.fire(this.terminals[W]),this.f[W].isOpen=!0;return}}const O={name:N.name,shellPath:N.executable,shellArgs:N.args,cwd:typeof N.cwd=="string"?N.cwd:L.URI.revive(N.cwd),env:N.env,hideFromUser:N.hideFromUser},G=new o(this.a,v,O,D);this.f.push(G),this.I.fire(G.value),G.isOpen=!0}async $acceptTerminalProcessId(v,E){this.W(v)?._setProcessId(E)}async $startExtensionTerminal(v,E){const D=this.W(v);if(!D)return{message:(0,b.localize)(0,null,v)};D.isOpen||await new Promise(O=>{const G=this.onDidOpenTerminal(async W=>{W===D.value&&(G.dispose(),O())})});const N=this.g.get(v);N?N.startSendingEvents(E):this.j[v]={initialDimensions:E}}S(v,E){const D=new $.$Sc;D.add(E.onProcessReady(O=>this.a.$sendProcessReady(v,O.pid,O.cwd,O.windowsPty))),D.add(E.onDidChangeProperty(O=>this.a.$sendProcessProperty(v,O))),this.y.startBuffering(v,E.onProcessData),D.add(E.onProcessExit(O=>this.U(v,O))),this.g.set(v,E);const N=this.j[v];return N&&E instanceof c&&(E.startSendingEvents(N.initialDimensions),delete this.j[v]),D}$acceptProcessAckDataEvent(v,E){this.g.get(v)?.acknowledgeDataEvent(E)}$acceptProcessInput(v,E){this.g.get(v)?.input(E)}$acceptTerminalInteraction(v){const E=this.W(v);E?.setInteractedWith()&&this.M.fire(E.value)}$acceptTerminalSelection(v,E){this.W(v)?.setSelection(E)}$acceptProcessResize(v,E,D){try{this.g.get(v)?.resize(E,D)}catch(N){if(N.code!=="EPIPE"&&N.code!=="ERR_IPC_CHANNEL_CLOSED")throw N}}$acceptProcessShutdown(v,E){this.g.get(v)?.shutdown(E)}$acceptProcessRequestInitialCwd(v){this.g.get(v)?.getInitialCwd().then(E=>this.a.$sendProcessProperty(v,{type:"initialCwd",value:E}))}$acceptProcessRequestCwd(v){this.g.get(v)?.getCwd().then(E=>this.a.$sendProcessProperty(v,{type:"cwd",value:E}))}$acceptProcessRequestLatency(v){return Promise.resolve(v)}registerLinkProvider(v){return this.z.add(v),this.z.size===1&&this.a.$startLinkProvider(),new f.$8K(()=>{this.z.delete(v),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(v,E,D){if(this.C.has(E))throw new Error(`Terminal profile provider "${E}" already registered`);return this.C.set(E,D),this.a.$registerProfileProvider(E,v.identifier.value),new f.$8K(()=>{this.C.delete(E),this.a.$unregisterProfileProvider(E)})}registerTerminalQuickFixProvider(v,E,D){if(this.D.has(v))throw new Error(`Terminal quick fix provider "${v}" is already registered`);return this.D.set(v,D),this.a.$registerQuickFixProvider(v,E),new f.$8K(()=>{this.D.delete(v),this.a.$unregisterQuickFixProvider(v)})}async $provideTerminalQuickFixes(v,E){const D=new l.$6d().token;if(D.isCancellationRequested)return;const N=this.D.get(v);if(!N)return;const O=await N.provideTerminalQuickFixes(E,D);if(O===null||Array.isArray(O)&&O.length===0)return;const G=new $.$Sc;if(this.w.value=G,!Array.isArray(O))return O?r.TerminalQuickFix.from(O,this.Q.converter,G):void 0;const W=[];for(const z of O){const P=r.TerminalQuickFix.from(z,this.Q.converter,G);P&&W.push(P)}return W}async $createContributedProfileTerminal(v,E){const D=new l.$6d().token;let N=await this.C.get(v)?.provideTerminalProfile(D);if(!D.isCancellationRequested){if(N&&!("options"in N)&&(N={options:N}),!N||!("options"in N))throw new Error(`No terminal profile options provided for id "${v}"`);if("pty"in N.options){this.createExtensionTerminal(N.options,E);return}this.createTerminalFromOptions(N.options,E)}}async $provideLinks(v,E){const D=this.W(v);if(!D)return[];this.F.delete(v),this.G.get(v)?.dispose(!0);const O=new l.$6d;this.G.set(v,O);const G=[],W={terminal:D.value,line:E},z=[];for(const H of this.z)z.push(a.Promises.withAsyncBody(async ae=>{O.token.onCancellationRequested(()=>ae({provider:H,links:[]}));const de=await H.provideTerminalLinks(W,O.token)||[];O.token.isCancellationRequested||ae({provider:H,links:de})}));const P=await Promise.all(z);if(O.token.isCancellationRequested)return[];const I=new Map;for(const H of P)H&&H.links.length>0&&G.push(...H.links.map(ae=>{const de={id:h++,startIndex:ae.startIndex,length:ae.length,label:ae.tooltip};return I.set(de.id,{provider:H.provider,link:ae}),de}));return this.F.set(v,I),G}$activateLink(v,E){const D=this.F.get(v)?.get(E);D&&D.provider.handleTerminalLink(D.link)}U(v,E){this.y.stopBuffering(v),this.g.delete(v),delete this.j[v];const D=this.h[v];D&&(D.dispose(),delete this.h[v]),this.a.$sendProcessExit(v,E)}W(v){return this.X(this.f,v)}X(v,E){const D=this.Y(v,E);return D!==null?v[D]:null}Y(v,E){const D=v.findIndex(N=>N._id===E);return D===-1?null:D}getEnvironmentVariableCollection(v){let E=this.n.get(v.identifier.value);return E||(E=new u,this.$(v.identifier.value,E)),E.getScopedEnvironmentVariableCollection(void 0)}Z(v,E){const D=(0,k.$Mr)(E.map),N=(0,k.$Nr)(E.descriptionMap);this.a.$setEnvironmentVariableCollection(v,E.persistent,D.length===0?void 0:D,N)}$initEnvironmentVariableCollections(v){v.forEach(E=>{const D=E[0],N=new u(E[1]);this.$(D,N)})}$acceptDefaultProfile(v,E){const D=this.s;this.s=v,this.u=E,D?.path!==v.path&&this.N.fire(v.path)}$(v,E){this.n.set(v,E),E.onDidChangeCollection(()=>{this.Z(v,E)})}};e.$Tgc=t,e.$Tgc=t=Je([Ke(1,n.$tN),Ke(2,R.$0M)],t);class u{get persistent(){return this.b}set persistent(v){this.b=v,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(v){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new y.$Vd,this.map=new Map(v)}getScopedEnvironmentVariableCollection(v){const E=this.h(v);let D=this.a.get(E);return D||(D=new i(this,v),this.a.set(E,D),D.onDidChangeCollection(()=>this.d.fire())),D}replace(v,E,D,N){this.f(v,{value:E,type:f.EnvironmentVariableMutatorType.Replace,options:D??{applyAtProcessCreation:!0},scope:N})}append(v,E,D,N){this.f(v,{value:E,type:f.EnvironmentVariableMutatorType.Append,options:D??{applyAtProcessCreation:!0},scope:N})}prepend(v,E,D,N){this.f(v,{value:E,type:f.EnvironmentVariableMutatorType.Prepend,options:D??{applyAtProcessCreation:!0},scope:N})}f(v,E){if(E.options&&E.options.applyAtProcessCreation===!1&&!E.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const D=this.g(v,E.scope),N=this.map.get(D),O=E.options?{applyAtProcessCreation:E.options.applyAtProcessCreation??!1,applyAtShellIntegration:E.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!N||N.value!==E.value||N.type!==E.type||N.options?.applyAtProcessCreation!==O.applyAtProcessCreation||N.options?.applyAtShellIntegration!==O.applyAtShellIntegration||N.scope?.workspaceFolder?.index!==E.scope?.workspaceFolder?.index){const G=this.g(v,E.scope),W={variable:v,...E,options:O};this.map.set(G,W),this.d.fire()}}get(v,E){const D=this.g(v,E),N=this.map.get(D);return N?S(N):void 0}g(v,E){const D=this.h(E);return D.length?`${v}:::${D}`:v}h(v){return this.j(v?.workspaceFolder)??""}j(v){return v?v.uri.toString():void 0}getVariableMap(v){const E=new Map;for(const[D,N]of this.map)this.h(N.scope)===this.h(v)&&E.set(N.variable,S(N));return E}delete(v,E){const D=this.g(v,E);this.map.delete(D),this.d.fire()}clear(v){if(v?.workspaceFolder){for(const[E,D]of this.map)D.scope?.workspaceFolder?.index===v.workspaceFolder.index&&this.map.delete(E);this.k(v)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(v,E){const D=this.h(E),N=this.descriptionMap.get(D);if(!N||N.description!==v){let O;typeof v=="string"?O=v:O=v?.value.split(`

`)[0];const G={description:O,scope:E};this.descriptionMap.set(D,G),this.d.fire()}}getDescription(v){const E=this.h(v);return this.descriptionMap.get(E)?.description}k(v){const E=this.h(v);this.descriptionMap.delete(E)}}class i{get persistent(){return this.b.persistent}set persistent(v){this.b.persistent=v}get onDidChangeCollection(){return this.a&&this.a.event}constructor(v,E){this.b=v,this.d=E,this.a=new y.$Vd}getScoped(v){return this.b.getScopedEnvironmentVariableCollection(v)}replace(v,E,D){this.b.replace(v,E,D,this.d)}append(v,E,D){this.b.append(v,E,D,this.d)}prepend(v,E,D){this.b.prepend(v,E,D,this.d)}get(v){return this.b.get(v,this.d)}forEach(v,E){this.b.getVariableMap(this.d).forEach((D,N)=>v.call(E,N,D,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(v){this.b.delete(v,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(v){this.b.setDescription(v,this.d)}get description(){return this.b.getDescription(this.d)}}let g=class extends t{constructor(v,E){super(!1,v,E)}createTerminal(v,E,D){throw new A.$_}createTerminalFromOptions(v,E){throw new A.$_}};e.$Ugc=g,e.$Ugc=g=Je([Ke(0,n.$tN),Ke(1,R.$0M)],g);function m(M){if(!(!M||typeof M=="string"))return"id"in M?{id:M.id,color:M.color}:M}function d(M){return s.ThemeColor.isThemeColor(M)?M:void 0}function S(M){const v={...M};return delete v.scope,v.options=v.options??void 0,delete v.variable,v}}),define(Pe[266],Re([1,0,13,24,20,5,218,98,6,26,16,33,14,3,17,108,8,7,48,77,58,23]),function(ge,e,y,T,C,L,R,$,f,b,A,k,l,p,w,s,a,r,n,o,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1hc=e.$Zhc=e.$Yhc=e.$Xhc=void 0;let t=class extends f.$Tc{constructor(z,P,I,H){super(),this.w=H,this.f=this.B(new L.$Vd),this.g=new Map,this.s=this.B(new L.$Vd),this.onResultsChanged=this.f.event,this.results=[],this.h=z.getProxy(p.$6K.MainThreadTesting),this.m=new D(this.h),this.j=new m(this.h,P),I.registerArgumentProcessor({processArgument:ae=>{switch(ae?.$mid){case 16:{const de=ae,we=de.tests[de.tests.length-1].item.extId;return this.g.get(n.$XJ.root(we))?.collection.tree.get(we)?.actual??(0,s.$jN)(ae)}case 18:{const{extId:de,message:we}=ae;return{test:this.g.get(n.$XJ.root(de))?.collection.tree.get(de)?.actual,message:a.TestMessage.to(we)}}default:return ae}}}),I.registerCommand(!1,"testing.getExplorerSelection",async()=>{const ae=await I.executeCommand("_testing.getExplorerSelection"),de=we=>{const ke=this.g.get(n.$XJ.root(we));if(ke)return n.$XJ.isRoot(we)?ke.controller:ke.collection.tree.get(we)?.actual};return{include:ae?.include.map(de).filter(A.$Qf)||[],exclude:ae?.exclude.map(de).filter(A.$Qf)||[]}})}createTestController(z,P,I,H){if(this.g.has(P))throw new Error(`Attempt to insert a duplicate controller with ID "${P}"`);const ae=new f.$Sc,de=ae.add(new s.$mN(P,I,this.w));de.root.label=I;const we=new Map,ke=new Set,le=this.h,ve={items:de.root.children,get label(){return I},set label(be){I=be,de.root.label=be,le.$updateController(P,{label:I})},get refreshHandler(){return H},set refreshHandler(be){H=be,le.$updateController(P,{canRefresh:!!be})},get id(){return P},createRunProfile:(be,ne,Y,V,ie,Ie)=>{let Le=(0,$.$Ti)(be);for(;we.has(Le);)Le++;return new O(this.h,we,z,ke,this.s.event,P,Le,be,ne,Y,V,ie,Ie)},createTestItem(be,ne,Y){return new s.$kN(P,be,ne,Y)},createTestRun:(be,ne,Y=!0)=>this.j.createTestRun(z,P,de,be,ne,Y),invalidateTestResults:be=>{if(be===void 0)this.h.$markTestRetired(void 0);else{const ne=be instanceof Array?be:[be];this.h.$markTestRetired(ne.map(Y=>n.$XJ.fromExtHostTestItem(Y,P).toString()))}},set resolveHandler(be){de.resolveHandler=be},get resolveHandler(){return de.resolveHandler},dispose:()=>{ae.dispose()}};le.$registerTestController(P,I,!!H),ae.add((0,f.$Rc)(()=>le.$unregisterTestController(P)));const se={controller:ve,collection:de,profiles:we,extension:z,activeProfiles:ke};return this.g.set(P,se),ae.add((0,f.$Rc)(()=>this.g.delete(P))),ae.add(de.onDidGenerateDiff(be=>le.$publishDiff(P,be.map(c.TestsDiffOp.serialize)))),ve}createTestObserver(){return this.m.checkout()}async runTests(z,P=C.CancellationToken.None){const I=d(z);if(!I)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const H=this.g.get(I.controllerId);if(!H)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:z.include?.map(ae=>n.$XJ.fromExtHostTestItem(ae,H.collection.root.id).toString())??[H.collection.root.id],profileGroup:G[I.kind],profileId:I.profileId,controllerId:I.controllerId}],exclude:z.exclude?.map(ae=>ae.id)},P)}$syncTests(){for(const{collection:z}of this.g.values())z.flushDiff();return Promise.resolve()}async $provideFileCoverage(z,P,I){return await this.j.getCoverageReport(z,P)?.provideFileCoverage(I)??[]}async $resolveFileCoverage(z,P,I,H){return await this.j.getCoverageReport(z,P)?.resolveFileCoverage(I,H)??[]}$configureRunProfile(z,P){this.g.get(z)?.profiles.get(P)?.configureHandler?.()}$setDefaultRunProfiles(z){const P=new Map;for(const[I,H]of Object.entries(z)){const ae=this.g.get(I);if(!ae)continue;const de=new Map,we=H.filter(le=>!ae.activeProfiles.has(le)),ke=[...ae.activeProfiles].filter(le=>!H.includes(le));for(const le of we)de.set(le,!0),ae.activeProfiles.add(le);for(const le of ke)de.set(le,!1),ae.activeProfiles.delete(le);de.size&&P.set(I,de)}this.s.fire(P)}async $refreshTests(z,P){await this.g.get(z)?.controller.refreshHandler?.(P)}$publishTestResults(z){this.results=Object.freeze(z.map(P=>(0,b.$wn)(a.TestResults.to(P))).concat(this.results).sort((P,I)=>I.completedAt-P.completedAt).slice(0,32)),this.f.fire()}async $expandTest(z,P){const I=this.g.get(n.$XJ.fromString(z).controllerId)?.collection;I&&(await I.expand(z,P<0?1/0:P),I.flushDiff())}$acceptDiff(z){this.m.applyDiff(z.map(P=>c.TestsDiffOp.deserialize({asCanonicalUri:I=>I},P)))}async $runControllerTests(z,P){return Promise.all(z.map(I=>this.y(I,!1,P)))}async $startContinuousRun(z,P){const I=new C.$6d(P),H=await Promise.all(z.map(ae=>this.y(ae,!0,I.token)));return!P.isCancellationRequested&&!H.some(ae=>ae.error)&&await new Promise(ae=>P.onCancellationRequested(ae)),I.dispose(!0),H}async y(z,P,I){const H=this.g.get(z.controllerId);if(!H)return{};const{collection:ae,profiles:de,extension:we}=H,ke=de.get(z.profileId);if(!ke)return{};const le=z.testIds.map(ne=>ae.tree.get(ne)).filter(A.$Qf),ve=z.excludeExtIds.map(ne=>H.collection.tree.get(ne)).filter(A.$Qf).filter(ne=>le.some(Y=>Y.fullId.compare(ne.fullId)===2));if(!le.length)return{};const se=new r.$EM(le.some(ne=>ne.actual instanceof s.$lN)?void 0:le.map(ne=>ne.actual),ve.map(ne=>ne.actual),ke,P),be=(0,c.$ZJ)(z)&&this.j.prepareForMainThreadTestRun(se,S.fromInternal(z,H.collection),we,I);try{return await ke.runHandler(se,I),{}}catch(ne){return{error:String(ne)}}finally{be&&(be.hasRunningTasks&&!I.isCancellationRequested&&await L.Event.toPromise(be.onEnd),be.dispose())}}$cancelExtensionTestRun(z){z===void 0?this.j.cancelAllRuns():this.j.cancelRunById(z)}};e.$Xhc=t,e.$Xhc=t=Je([Ke(0,w.$0M),Ke(1,l.$nj)],t);const u=1e4;var i;(function(W){W[W.Running=0]="Running",W[W.Cancelling=1]="Cancelling",W[W.Ended=2]="Ended"})(i||(i={}));class g extends f.$Tc{get hasRunningTasks(){return this.f.size>0}get id(){return this.s.id}constructor(z,P,I,H,ae){super(),this.s=z,this.w=P,this.y=I,this.z=H,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new L.$Vd),this.m=this.B(new L.$Vd),this.onDidCoverage=this.m.event,this.onEnd=this.j.event,this.h=this.B(new C.$6d(ae));const de=this.B(new y.$fh(()=>this.C(),u));this.B(this.h.token.onCancellationRequested(()=>de.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.C()}createRun(z){const P=this.s.id,I=this.s.controllerId,H=(0,k.$qg)(),ae=this.y,de=this.m;let we;const ke=be=>(ne,...Y)=>{if(ve){this.z.warn(`Setting the state of test "${ne.id}" is a no-op after the run ends.`);return}this.s.isIncluded(ne)&&(this.F(ne),be(ne,...Y))},le=(be,ne)=>{const Y=ne instanceof Array?ne.map(a.TestMessage.from):[a.TestMessage.from(ne)];if(be.uri&&be.range){const V={range:a.Range.from(be.range),uri:be.uri};for(const ie of Y)ie.location=ie.location||V}this.w.$appendTestMessagesInRun(P,H,n.$XJ.fromExtHostTestItem(be,I).toString(),Y)};let ve=!1;const se={isPersisted:this.s.isPersisted,token:this.h.token,name:z,get coverageProvider(){return we?.provider},set coverageProvider(be){(0,h.$CF)(ae,"testCoverage"),we=be&&new M(be),de.fire({taskId:H,runId:P,coverage:we})},enqueued:ke(be=>{this.w.$updateTestStateInRun(P,H,n.$XJ.fromExtHostTestItem(be,I).toString(),1)}),skipped:ke(be=>{this.w.$updateTestStateInRun(P,H,n.$XJ.fromExtHostTestItem(be,I).toString(),5)}),started:ke(be=>{this.w.$updateTestStateInRun(P,H,n.$XJ.fromExtHostTestItem(be,I).toString(),2)}),errored:ke((be,ne,Y)=>{le(be,ne),this.w.$updateTestStateInRun(P,H,n.$XJ.fromExtHostTestItem(be,I).toString(),6,Y)}),failed:ke((be,ne,Y)=>{le(be,ne),this.w.$updateTestStateInRun(P,H,n.$XJ.fromExtHostTestItem(be,I).toString(),4,Y)}),passed:ke((be,ne)=>{this.w.$updateTestStateInRun(P,H,n.$XJ.fromExtHostTestItem(be,this.s.controllerId).toString(),3,ne)}),appendOutput:(be,ne,Y)=>{ve||(Y&&(this.s.isIncluded(Y)?this.F(Y):Y=void 0),this.w.$appendOutputToRun(P,H,T.$je.fromString(be),ne&&a.location.from(ne),Y&&n.$XJ.fromExtHostTestItem(Y,I).toString()))},end:()=>{ve||(ve=!0,this.w.$finishedTestRunTask(P,H),this.f.delete(H),this.f.size||this.D())}};return this.f.set(H,{run:se}),this.w.$startedTestRunTask(P,{id:H,name:z,running:!0}),se}C(){for(const{run:z}of this.f.values())z.end()}D(){this.c!==2&&(this.c=2,this.j.fire())}F(z){if(!(z instanceof s.$kN))throw new o.$2M(z.id);if(this.g.has(n.$XJ.fromExtHostTestItem(z,this.s.controllerId).toString()))return;const P=[],I=this.s.colllection.root;for(;;){const H=a.TestItem.from(z);if(P.unshift(H),this.g.has(H.extId)||(this.g.add(H.extId),z===I))break;z=z.parent||I}this.w.$addTestsToRun(this.s.controllerId,this.s.id,P)}dispose(){this.D(),super.dispose()}}class m{get trackers(){return this.c.values()}constructor(z,P){this.g=z,this.h=P,this.c=new Map,this.f=[]}getCoverageReport(z,P){return this.f.find(I=>I.runId===z)?.coverage.get(P)}prepareForMainThreadTestRun(z,P,I,H){return this.j(z,P,I,H)}cancelRunById(z){for(const P of this.c.values())if(P.id===z){P.cancel();return}}cancelAllRuns(){for(const z of this.c.values())z.cancel()}createTestRun(z,P,I,H,ae,de){const we=this.c.get(H);if(we)return we.createRun(ae);const ke=S.fromPublic(P,I,H,de),le=d(H);this.g.$startedExtensionTestRun({controllerId:P,continuous:!!H.continuous,profile:le&&{group:G[le.kind],id:le.profileId},exclude:H.exclude?.map(se=>n.$XJ.fromExtHostTestItem(se,I.root.id).toString())??[],id:ke.id,include:H.include?.map(se=>n.$XJ.fromExtHostTestItem(se,I.root.id).toString())??[I.root.id],persist:de});const ve=this.j(H,ke,z);return L.Event.once(ve.onEnd)(()=>{this.g.$finishedExtensionTestRun(ke.id),ve.dispose()}),ve.createRun(ae)}j(z,P,I,H){const ae=new g(P,this.g,I,this.h,H);this.c.set(z,ae);let de;const we=ae.onDidCoverage(({runId:ke,taskId:le,coverage:ve})=>{de||(de={runId:ke,coverage:new Map},this.f.unshift(de),this.f.length>c.$5J&&this.f.pop()),de.coverage.set(le,ve),this.g.$signalCoverageAvailable(ke,le,!!ve)});return L.Event.once(ae.onEnd)(()=>{this.c.delete(z),we.dispose()}),ae}}e.$Yhc=m;const d=W=>{if(W.profile){if(!(W.profile instanceof O))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return W.profile}};class S{static fromPublic(z,P,I,H){return new S(z,(0,k.$qg)(),I.include?.map(ae=>n.$XJ.fromExtHostTestItem(ae,z).toString())??[z],I.exclude?.map(ae=>n.$XJ.fromExtHostTestItem(ae,z).toString())??[],H,P)}static fromInternal(z,P){return new S(z.controllerId,z.runId,z.testIds,z.excludeExtIds,!0,P)}constructor(z,P,I,H,ae,de){this.controllerId=z,this.id=P,this.isPersisted=ae,this.colllection=de,this.c=I.map(we=>we+"\0"),this.f=H.map(we=>we+"\0")}isIncluded(z){const P=n.$XJ.fromExtHostTestItem(z,this.controllerId).toString()+"\0";for(const I of this.f)if(P===I||P.startsWith(I))return!1;for(const I of this.c)if(P===I||P.startsWith(I))return!0;return!1}}e.$Zhc=S;class M{constructor(z){this.provider=z}async provideFileCoverage(z){this.c||(this.c=(async()=>this.provider.provideFileCoverage(z))());try{return(await this.c)?.map(a.TestCoverage.fromFile)??[]}catch(P){throw this.c=void 0,P}}async resolveFileCoverage(z,P){const I=await this.c;let H=I?.[z];return!this.provider||!I||!H?[]:(H.detailedCoverage||(H=I[z]=await this.provider.resolveFileCoverage?.(H,P)??H),H.detailedCoverage?.map(a.TestCoverage.fromDetailed)??[])}}class v{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(z){this.j=z,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(z){this.c.add(z)}update(z){Object.assign(z.revived,a.TestItem.toPlain(z.item)),this.c.has(z)||this.f.add(z)}remove(z){if(this.c.has(z)){this.c.delete(z);return}this.f.delete(z);const P=n.$XJ.parentId(z.item.extId);if(P&&this.h.has(P.toString())){this.h.add(z.item.extId);return}this.g.add(z)}getChangeEvent(){const{c:z,f:P,g:I}=this;return{get added(){return[...z].map(H=>H.revived)},get updated(){return[...P].map(H=>H.revived)},get removed(){return[...I].map(H=>H.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class E extends c.$6J{constructor(){super(...arguments),this.s=new L.$Vd,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(z){return this.f.get(z)}getMirroredTestDataByReference(z){return this.f.get(z.id)}w(z,P){return{...z,revived:a.TestItem.toPlain(z.item),depth:P?P.depth+1:0,children:new Set}}v(){return new v(this.s)}}class D{constructor(z){this.f=z}checkout(){this.c||(this.c=this.g());const z=this.c;return z.observers++,{onDidChangeTest:z.tests.onDidChangeTests,get tests(){return[...z.tests.rootTests].map(P=>P.revived)},dispose:(0,R.$db)(()=>{--z.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(z){return this.c?.tests.getMirroredTestDataByReference(z)}applyDiff(z){this.c?.tests.apply(z)}g(){const z=new E({asCanonicalUri:P=>P});return this.f.$subscribeToDiffs(),{observers:0,tests:z}}}const N=(W,z,P,I)=>{P?Object.assign(P,I):z.$updateTestRunConfig(W.controllerId,W.profileId,I)};class O{#e;#t;#i;#o;#n;#r;get label(){return this.f}set label(z){z!==this.f&&(this.f=z,N(this,this.#e,this.#n,{label:z}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(z){z!==this.g&&(this.g=z,N(this,this.#e,this.#n,{supportsContinuousRun:z}))}get isDefault(){return this.#i.has(this.profileId)}set isDefault(z){z!==this.isDefault&&(z?this.#i.add(this.profileId):this.#i.delete(this.profileId),N(this,this.#e,this.#n,{isDefault:z}))}get tag(){return this._tag}set tag(z){z?.id!==this._tag?.id&&(this._tag=z,N(this,this.#e,this.#n,{tag:z?a.TestTag.namespace(this.controllerId,z.id):null}))}get configureHandler(){return this.c}set configureHandler(z){z!==this.c&&(this.c=z,N(this,this.#e,this.#n,{hasConfigurationHandler:!!z}))}get onDidChangeDefault(){return(0,h.$CF)(this.#t,"testingActiveProfile"),L.Event.chain(this.#o,z=>z.map(P=>P.get(this.controllerId)?.get(this.profileId)).filter(A.$Qf))}constructor(z,P,I,H,ae,de,we,ke,le,ve,se=!1,be=void 0,ne=!1){this.controllerId=de,this.profileId=we,this.f=ke,this.kind=le,this.runHandler=ve,this._tag=be,this.g=ne,this.#e=z,this.#r=P,this.#t=I,this.#i=H,this.#o=ae,P.set(we,this);const Y=G[le];if(typeof Y!="number")throw new Error(`Unknown TestRunProfile.group ${le}`);se&&H.add(we),this.#n={profileId:we,controllerId:de,tag:be?a.TestTag.namespace(this.controllerId,be.id):null,label:ke,group:Y,isDefault:se,hasConfigurationHandler:!1,supportsContinuousRun:ne},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#r?.delete(this.profileId)&&(this.#r=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$1hc=O;const G={[r.TestRunProfileKind.Coverage]:8,[r.TestRunProfileKind.Debug]:4,[r.TestRunProfileKind.Run]:2}}),define(Pe[267],Re([1,0,18,5,3,109,8,7]),function(ge,e,y,T,C,L,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kgc=void 0;class f{constructor(A,k){this.i=k,this.a=new T.$Vd,this.b=new T.$Vd,this.c=new T.$Vd,this.d=new T.$Vd,this.f=new T.$Vd,this.g=new T.$Vd,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=A.getProxy(C.$6K.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(l=>this.g.fire(l)),this.i.onDidChangeActiveTextEditor(l=>this.f.fire(l))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(A){const k=this.i.allEditors();return A?k:k.map(l=>l.value)}async showTextDocument(A,k,l){let p;typeof k=="number"?p={position:R.ViewColumn.from(k),preserveFocus:l}:typeof k=="object"?p={position:R.ViewColumn.from(k.viewColumn),preserveFocus:k.preserveFocus,selection:typeof k.selection=="object"?R.Range.from(k.selection):void 0,pinned:typeof k.preview=="boolean"?!k.preview:void 0}:p={preserveFocus:!1};const w=await this.h.$tryShowTextDocument(A.uri,p),s=w&&this.i.getEditor(w);if(s)return s.value;throw w?new Error(`Could NOT open editor for "${A.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${A.uri.toString()}".`)}createTextEditorDecorationType(A,k){return new L.$eN(this.h,A,k).value}$acceptEditorPropertiesChanged(A,k){const l=this.i.getEditor(A);if(!l)throw new Error("unknown text editor");if(k.options&&l._acceptOptions(k.options),k.selections){const p=k.selections.selections.map(R.Selection.to);l._acceptSelections(p)}if(k.visibleRanges){const p=y.$Hb(k.visibleRanges.map(R.Range.to));l._acceptVisibleRanges(p)}if(k.options&&this.b.fire({textEditor:l.value,options:{...k.options,lineNumbers:R.TextEditorLineNumbersStyle.to(k.options.lineNumbers)}}),k.selections){const p=$.TextEditorSelectionChangeKind.fromValue(k.selections.source),w=k.selections.selections.map(R.Selection.to);this.a.fire({textEditor:l.value,selections:w,kind:p})}if(k.visibleRanges){const p=y.$Hb(k.visibleRanges.map(R.Range.to));this.c.fire({textEditor:l.value,visibleRanges:p})}}$acceptEditorPositionData(A){for(const k in A){const l=this.i.getEditor(k);if(!l)throw new Error("Unknown text editor");const p=R.ViewColumn.to(A[k]);l.value.viewColumn!==p&&(l._acceptViewColumn(p),this.d.fire({textEditor:l.value,viewColumn:p}))}}getDiffInformation(A){return Promise.resolve(this.h.$getDiffInformation(A))}}e.$kgc=f}),define(Pe[268],Re([1,0,2,4,3,6,7,8,22,16]),function(ge,e,y,T,C,L,R,$,f,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4hc=e.$3hc=void 0,e.$3hc=(0,T.$6h)("IExtHostTimeline");class A{constructor(p,w){this.b=new Map,this.c=new Map,this.a=p.getProxy(C.$6K.MainThreadTimeline),w.registerArgumentProcessor({processArgument:(s,a)=>{if(s&&s.$mid===12)if(this.b.get(s.source)&&f.$lm.equals(a,this.b.get(s.source)?.extension)){const r=s.uri===void 0?void 0:y.URI.revive(s.uri);return this.c.get(s.source)?.get(k(r))?.get(s.handle)}else return;return s}})}async $getTimeline(p,w,s,a){return this.b.get(p)?.provider.provideTimeline(y.URI.revive(w),s,a)}registerTimelineProvider(p,w,s,a){const r=new L.$Sc,n=this.d(w.id,a,r).bind(this);let o;w.onDidChange&&(o=w.onDidChange(h=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...h,id:w.id}),this));const c=this.c;return this.f({...w,scheme:p,onDidChange:void 0,async provideTimeline(h,t,u){t?.resetCache&&(r.clear(),c.get(w.id)?.clear());const i=await w.provideTimeline(h,t,u);if(i==null)return;const g=n(h,t);return{...i,source:w.id,items:i.items.map(g)}},dispose(){for(const h of c.values())h.get(w.id)?.clear();o?.dispose(),r.dispose()}},s)}d(p,w,s){return(a,r)=>{let n;if(r?.cacheResults){let o=this.c.get(p);o===void 0&&(o=new Map,this.c.set(p,o));const c=k(a);n=o.get(c),n===void 0&&(n=new Map,o.set(c,n))}return o=>{const{iconPath:c,...h}=o,t=`${p}|${o.id??o.timestamp}`;n?.set(t,o);let u,i,g;o.iconPath&&(c instanceof R.$3L?g={id:c.id,color:c.color}:y.URI.isUri(c)?(u=c,i=c):{light:u,dark:i}=c);let m;return R.$wL.isMarkdownString(h.tooltip)?m=$.MarkdownString.from(h.tooltip):(0,b.$If)(h.tooltip)?m=h.tooltip:R.$wL.isMarkdownString(h.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),m=$.MarkdownString.from(h.detail)):(0,b.$If)(h.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),m=h.detail),{...h,id:h.id??void 0,handle:t,source:p,command:o.command?w.toInternal(o.command,s):void 0,icon:u,iconDark:i,themeIcon:g,tooltip:m,accessibilityInformation:o.accessibilityInformation}}}}f(p,w){if(this.b.get(p.id))throw new Error(`Timeline Provider ${p.id} already exists.`);return this.a.$registerTimelineProvider({id:p.id,label:p.label,scheme:p.scheme}),this.b.set(p.id,{provider:p,extension:w}),(0,L.$Rc)(()=>{for(const a of this.c.values())a.get(p.id)?.clear();this.b.delete(p.id),this.a.$unregisterTimelineProvider(p.id),p.dispose()})}}e.$4hc=A;function k(l){return l?.toString()}}),define(Pe[87],Re([1,0,20,5,6,167,4,14,196,3,27,17,7]),function(ge,e,y,T,C,L,R,$,f,b,A,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pyb=e.$oyb=e.TunnelDtoConverter=void 0;class p extends f.$Jv{}var w;(function(a){function r(o){return{remoteAddress:o.remoteAddress,localAddress:o.localAddress,public:!!o.public,privacy:o.privacy??(o.public?f.TunnelPrivacyId.Public:f.TunnelPrivacyId.Private),protocol:o.protocol}}a.fromApiTunnel=r;function n(o){return{remoteAddress:{host:o.tunnelRemoteHost,port:o.tunnelRemotePort},localAddress:o.localAddress,public:o.privacy!==f.TunnelPrivacyId.ConstantPrivate&&o.privacy!==f.TunnelPrivacyId.ConstantPrivate,privacy:o.privacy,protocol:o.protocol}}a.fromServiceTunnel=n})(w||(e.TunnelDtoConverter=w={})),e.$oyb=(0,R.$6h)("IExtHostTunnelService");let s=class extends C.$Tc{constructor(r,n,o){super(),this.s=o,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new T.$Vd,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=r.getProxy(b.$6K.MainThreadTunnelService)}async openTunnel(r,n){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${r.identifier.value} called openTunnel API for ${n.remoteAddress.host}:${n.remoteAddress.port}.`);const o=await this.a.$openTunnel(n,r.displayName);if(o){const c=new p(o.remoteAddress,o.localAddress,()=>this.a.$closeTunnel(o.remoteAddress));return this.B(c),c}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(r,n){const o=this.u();return this.r.set(o,{selector:r,provider:n}),this.a.$registerPortsAttributesProvider(r,o),new l.$8K(()=>{this.r.delete(o),this.a.$unregisterPortsAttributesProvider(o)})}async $providePortAttributes(r,n,o,c,h){const t=[];for(const i of r){const g=this.r.get(i);if(!g)return[];t.push(...await Promise.all(n.map(async m=>{let d;try{d=await g.provider.providePortAttributes({port:m,pid:o,commandLine:c},h)}catch{d=await g.provider.providePortAttributes(m,o,c,h)}return{providedAttributes:d,port:m}})))}const u=t.filter(i=>!!i.providedAttributes);return u.length>0?u.map(i=>({autoForwardAction:i.providedAttributes.autoForwardAction,port:i.port})):[]}async $registerCandidateFinder(r){}registerTunnelProvider(r,n){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(c,h)=>await r.provideTunnel(c,h,new y.$6d().token)??void 0;const o=n.tunnelFeatures?{elevation:!!n.tunnelFeatures?.elevation,privacyOptions:n.tunnelFeatures?.privacyOptions,protocol:n.tunnelFeatures.protocol===void 0?!0:n.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(o),Promise.resolve((0,C.$Rc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(r,n){if(r){r.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(r.candidatePortSource),r.showCandidatePort&&(this.f=r.showCandidatePort,this.a.$setCandidateFilter());const o=r.tunnelFactory??(n?this.w(n):void 0);if(o){this.b=o;let c=r.tunnelFeatures?.privacyOptions??[];r.tunnelFeatures?.public&&c.length===0&&(c=[{id:"private",label:L.localize(0,null),themeIcon:"lock"},{id:"public",label:L.localize(1,null),themeIcon:"eye"}]);const h=r.tunnelFeatures?{elevation:!!r.tunnelFeatures?.elevation,public:!!r.tunnelFeatures?.public,privacyOptions:c,protocol:!0}:void 0;this.a.$setTunnelProvider(h)}}else this.b=void 0;return(0,C.$Rc)(()=>{this.b=void 0})}w(r){}async $closeTunnel(r,n){if(this.g.has(r.host)){const o=this.g.get(r.host);o.has(r.port)&&(n&&o.get(r.port).disposeListener.dispose(),await o.get(r.port).tunnel.dispose(),o.delete(r.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(r,n){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const o=this.b(r,n);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),o!==void 0){const c=await o;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),c===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(r.remoteAddress.host)||this.g.set(r.remoteAddress.host,new Map);const h=this.B(c.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(c.remoteAddress))));return this.g.get(r.remoteAddress.host).set(r.remoteAddress.port,{tunnel:c,disposeListener:h}),w.fromApiTunnel(c)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(o){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),o instanceof Error)return o.message}}async $applyCandidateFilter(r){const n=await Promise.all(r.map(c=>this.f(c.host,c.port,c.detail??""))),o=r.filter((c,h)=>n[h]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${r.map(c=>c.port).join(", ")} to ${o.map(c=>c.port).join(", ")}`),o}};e.$pyb=s,e.$pyb=s=Je([Ke(0,k.$0M),Ke(1,A.$nN),Ke(2,$.$nj)],s)}),define(Pe[269],Re([1,0,6,12,2,3]),function(ge,e,y,T,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6hc=void 0;class R{static{this.a=new Set([T.Schemas.http,T.Schemas.https])}constructor(f){this.c=new Map,this.b=f.getProxy(L.$6K.MainThreadUriOpeners)}registerExternalUriOpener(f,b,A,k){if(this.c.has(b))throw new Error(`Opener with id '${b}' already registered`);const l=k.schemes.find(p=>!R.a.has(p));if(l)throw new Error(`Scheme '${l}' is not supported. Only http and https are currently supported.`);return this.c.set(b,A),this.b.$registerUriOpener(b,k.schemes,f,k.label),(0,y.$Rc)(()=>{this.c.delete(b),this.b.$unregisterUriOpener(b)})}async $canOpenUri(f,b,A){const k=this.c.get(f);if(!k)throw new Error(`Unknown opener with id: ${f}`);const l=C.URI.revive(b);return k.canOpenExternalUri(l,A)}async $openUri(f,b,A){const k=this.c.get(f);if(!k)throw new Error(`Unknown opener id: '${f}'`);return k.openExternalUri(C.URI.revive(b.resolvedUri),{sourceUri:C.URI.revive(b.sourceUri)},A)}}e.$6hc=R}),define(Pe[270],Re([1,0,3,2,6,15,22]),function(ge,e,y,T,C,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7hc=void 0;class ${static{this.a=0}constructor(b){this.c=new R.$mm,this.d=new Map,this.b=b.getProxy(y.$6K.MainThreadUrls)}registerUriHandler(b,A){const k=b.identifier;if(this.c.has(k))throw new Error(`Protocol handler already registered for extension ${k}`);const l=$.a++;return this.c.add(k),this.d.set(l,A),this.b.$registerUriHandler(l,k,b.displayName||b.name),(0,C.$Rc)(()=>{this.c.delete(k),this.d.delete(l),this.b.$unregisterUriHandler(l)})}$handleExternalUri(b,A){const k=this.d.get(b);if(!k)return Promise.resolve(void 0);try{k.handleUri(T.URI.revive(A))}catch(l){(0,L.$1)(l)}return Promise.resolve(void 0)}async createAppUri(b){return T.URI.revive(await this.b.$createAppUri(b))}}e.$7hc=$}),define(Pe[65],Re([1,0,5,6,12,26,2,181,203,78,3]),function(ge,e,y,T,C,L,R,$,f,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cgc=e.$Bgc=e.$Agc=e.$zgc=e.$ygc=void 0;class k{#e;#t;#i;#o;#n;#r;#a;#s;#c;#u;#l;#d;constructor(c,h,t,u,i,g,m){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new y.$Vd,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new y.$Vd,this._onDidDispose=this.#h.event,this.#e=c,this.#t=h,this.#s=t,this.#o=u,this.#n=i,this.#r=g,this.#l=l(g),this.#d=p(g),this.#i=m}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(c){return this.#u=!0,(0,b.$wvb)(c,this.#o)}get cspSource(){const c=this.#r.extensionLocation;if(c.scheme===C.Schemas.https||c.scheme===C.Schemas.http){let h=c.toString();return h.endsWith("/")||(h+="/"),h+" "+b.$vvb}return b.$vvb}get html(){return this.a(),this.#a}set html(c){this.a(),this.#a!==c&&(this.#a=c,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(c)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(c)))}get options(){return this.a(),this.#s}set options(c){this.a(),L.$zn(this.#s,c)||this.#t.$setOptions(this.#e,a(this.#r,this.#n,c)),this.#s=c}async postMessage(c){if(this.#c)return!1;const h=(0,f.$clb)(c,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,h.message,...h.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(c){if(!this.#d)return c;const h=this.#r.extensionLocation?.scheme===C.Schemas.vscodeRemote,t=this.#r.extensionLocation.scheme===C.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return c.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(u,i,g,m,d,S)=>{const M=R.URI.from({scheme:m||"file",path:decodeURIComponent(d)}),v=(0,b.$wvb)(M,{isRemote:h,authority:t}).toString();return`${i}${v}${S}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(u,i,g,m,d,S)=>{const M=R.URI.from({scheme:m||"file",path:decodeURIComponent(d)}),v=(0,b.$wvb)(M,{isRemote:h,authority:t}).toString();return`${i}${v}${S}`})}}e.$ygc=k;function l(o){try{const c=(0,$.$cp)((0,$.$bp)(o.engines.vscode));return!!c&&c.majorBase>=1&&c.minorBase>=57}catch{return!1}}e.$zgc=l;function p(o){try{const c=(0,$.$cp)((0,$.$bp)(o.engines.vscode));return c?c.majorBase<1||c.majorBase===1&&c.minorBase<60:!1}catch{return!1}}class w extends T.$Tc{constructor(c,h,t,u,i){super(),this.c=h,this.f=t,this.g=u,this.h=i,this.b=new Map,this.a=c.getProxy(A.$6K.MainThreadWebviews)}dispose(){super.dispose();for(const c of this.b.values())c.dispose();this.b.clear()}$onMessage(c,h,t){const u=this.j(c);if(u){const{message:i}=(0,f.$dlb)(h,t.value);u._onMessageEmitter.fire(i)}}$onMissingCsp(c,h){this.g.warn(`${h} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(c,h,t){const u=new k(c,this.a,r(h),this.c,this.f,t,this.h);this.b.set(c,u);const i=u._onDidDispose(()=>{i.dispose(),this.deleteWebview(c)});return u}deleteWebview(c){this.b.delete(c)}j(c){return this.b.get(c)}}e.$Agc=w;function s(o){return{id:o.identifier,location:o.extensionLocation}}e.$Bgc=s;function a(o,c,h){return{enableCommandUris:h.enableCommandUris,enableScripts:h.enableScripts,enableForms:h.enableForms,portMapping:h.portMapping,localResourceRoots:h.localResourceRoots||n(o,c)}}e.$Cgc=a;function r(o){return{enableCommandUris:o.enableCommandUris,enableScripts:o.enableScripts,enableForms:o.enableForms,portMapping:o.portMapping,localResourceRoots:o.localResourceRoots?.map(c=>R.URI.from(c))}}function n(o,c){return[...(c?.getWorkspaceFolders()||[]).map(h=>h.uri),o.extensionLocation]}}),define(Pe[271],Re([1,0,20,98,6,12,25,2,8,65,75,3,7]),function(ge,e,y,T,C,L,R,$,f,b,A,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Egc=void 0;class p{constructor(u,i){this.document=u,this.b=i,this.a=1,this.c=new A.$4fc("custom documents")}addEdit(u){return this.c.add([u])}async undo(u,i){await this.f(u).undo(),i||this.disposeBackup()}async redo(u,i){await this.f(u).redo(),i||this.disposeBackup()}disposeEdits(u){for(const i of u)this.c.delete(i)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const u=h(this.document.uri)+this.a++;return(0,R.$Hg)(this.b,u)}updateBackup(u){this.d?.delete(),this.d=u}disposeBackup(){this.d?.delete(),this.d=void 0}f(u){const i=this.c.get(u,0);if(!i)throw new Error("No edit found");return i}}class w{constructor(){this.a=new Map}get(u,i){return this.a.get(this.b(u,i))}add(u,i,g){const m=this.b(u,i.uri);if(this.a.has(m))throw new Error(`Document already exists for viewType:${u} resource:${i.uri}`);const d=new p(i,g);return this.a.set(m,d),d}delete(u,i){const g=this.b(u,i.uri);this.a.delete(g)}b(u,i){return`${u}@@@${i}`}}var s;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(s||(s={}));class a{constructor(){this.a=new Map}addTextProvider(u,i,g){return this.b(0,u,i,g)}addCustomProvider(u,i,g){return this.b(1,u,i,g)}get(u){return this.a.get(u)}b(u,i,g,m){if(this.a.has(i))throw new Error(`Provider for viewType:${i} already registered`);return this.a.set(i,{type:u,extension:g,provider:m}),new l.$8K(()=>this.a.delete(i))}}class r{constructor(u,i,g,m,d){this.d=i,this.f=g,this.g=m,this.h=d,this.b=new a,this.c=new w,this.a=u.getProxy(k.$6K.MainThreadCustomEditors)}registerCustomEditorProvider(u,i,g,m){const d=new C.$Sc;return o(g)?(d.add(this.b.addTextProvider(i,u,g)),this.a.$registerTextEditorProvider((0,b.$Bgc)(u),i,m.webviewOptions||{},{supportsMove:!!g.moveCustomTextEditor},(0,b.$zgc)(u))):(d.add(this.b.addCustomProvider(i,u,g)),n(g)&&d.add(g.onDidChangeCustomDocument(S=>{const M=this.i(i,S.document.uri);if(c(S)){const v=M.addEdit(S);this.a.$onDidEdit(S.document.uri,i,v,S.label)}else this.a.$onContentChange(S.document.uri,i)})),this.a.$registerCustomEditorProvider((0,b.$Bgc)(u),i,m.webviewOptions||{},!!m.supportsMultipleEditorsPerDocument,(0,b.$zgc)(u))),l.$8K.from(d,new l.$8K(()=>{this.a.$unregisterEditorProvider(i)}))}async $createCustomDocument(u,i,g,m,d){const S=this.b.get(i);if(!S)throw new Error(`No provider found for '${i}'`);if(S.type!==1)throw new Error(`Invalid provide type for '${i}'`);const M=$.URI.revive(u),v=await S.provider.openCustomDocument(M,{backupId:g,untitledDocumentData:m?.buffer},d);let E;return n(S.provider)&&this.f&&(E=this.f.workspaceValue(S.extension)??this.f.globalValue(S.extension)),this.c.add(i,v,E),{editable:n(S.provider)}}async $disposeCustomDocument(u,i){const g=this.b.get(i);if(!g)throw new Error(`No provider found for '${i}'`);if(g.type!==1)throw new Error(`Invalid provider type for '${i}'`);const m=$.URI.revive(u),{document:d}=this.i(i,m);this.c.delete(i,d),d.dispose()}async $resolveCustomEditor(u,i,g,m,d,S){const M=this.b.get(g);if(!M)throw new Error(`No provider found for '${g}'`);const v=f.ViewColumn.to(d),E=this.g.createNewWebview(i,m.contentOptions,M.extension),D=this.h.createNewWebviewPanel(i,g,m.title,v,m.options,E,m.active),N=$.URI.revive(u);switch(M.type){case 1:{const{document:O}=this.i(g,N);return M.provider.resolveCustomEditor(O,D,S)}case 0:{const O=this.d.getDocument(N);return M.provider.resolveCustomTextEditor(O,D,S)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(u,i,g){this.i(i,u).disposeEdits(g)}async $onMoveCustomEditor(u,i,g){const m=this.b.get(g);if(!m)throw new Error(`No provider found for '${g}'`);if(!m.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${g}'`);const d=this.h.getWebviewPanel(u);if(!d)throw new Error("No webview found");const S=$.URI.revive(i),M=this.d.getDocument(S);await m.provider.moveCustomTextEditor(M,d,y.CancellationToken.None)}async $undo(u,i,g,m){return this.i(i,u).undo(g,m)}async $redo(u,i,g,m){return this.i(i,u).redo(g,m)}async $revert(u,i,g){const m=this.i(i,u);await this.j(i).revertCustomDocument(m.document,g),m.disposeBackup()}async $onSave(u,i,g){const m=this.i(i,u);await this.j(i).saveCustomDocument(m.document,g),m.disposeBackup()}async $onSaveAs(u,i,g,m){const d=this.i(i,u);return this.j(i).saveCustomDocumentAs(d.document,$.URI.revive(g),m)}async $backup(u,i,g){const m=this.i(i,u),S=await this.j(i).backupCustomDocument(m.document,{destination:m.getNewBackupUri()},g);return m.updateBackup(S),S.id}i(u,i){const g=this.c.get(u,$.URI.revive(i));if(!g)throw new Error("No custom document found");return g}j(u){const g=this.b.get(u)?.provider;if(!g||!n(g))throw new Error("Custom document is not editable");return g}}e.$Egc=r;function n(t){return!!t.onDidChangeCustomDocument}function o(t){return typeof t.resolveCustomTextEditor=="function"}function c(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function h(t){const u=t.scheme===L.Schemas.file||t.scheme===L.Schemas.untitled?t.fsPath:t.toString();return(0,T.$Ti)(u)+""}}),define(Pe[272],Re([1,0,5,6,2,33,8,65,3,7]),function(ge,e,y,T,C,L,R,$,f,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dgc=void 0;class A extends T.$Tc{#e;#t;#i;#o;#n;#r;#a;#s;#c;#u;#l;#d;#h;constructor(w,s,a,r){super(),this.#s=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new y.$Vd),this.onDidDispose=this.#d.event,this.#h=this.B(new y.$Vd),this.onDidChangeViewState=this.#h.event,this.#e=w,this.#t=s,this.#o=a,this.#i=r.viewType,this.#n=r.panelOptions,this.#s=r.viewColumn,this.#r=r.title,this.#u=r.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#o.dispose(),super.dispose())}get webview(){return this.c(),this.#o}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(w){this.c(),this.#r!==w&&(this.#r=w,this.#t.$setTitle(this.#e,w))}get iconPath(){return this.c(),this.#a}set iconPath(w){this.c(),this.#a!==w&&(this.#a=w,this.#t.$setIconPath(this.#e,C.URI.isUri(w)?{light:w,dark:w}:w))}get options(){return this.#n}get viewColumn(){if(this.c(),!(typeof this.#s=="number"&&this.#s<0))return this.#s}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(w){this.#l||(this.active!==w.active||this.visible!==w.visible||this.viewColumn!==w.viewColumn)&&(this.#u=w.active,this.#c=w.visible,this.#s=w.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(w,s){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof w>"u"?void 0:R.ViewColumn.from(w),preserveFocus:!!s})}c(){if(this.#l)throw new Error("Webview is disposed")}}class k extends T.$Tc{static c(){return(0,L.$qg)()}constructor(w,s,a){super(),this.j=s,this.m=a,this.g=new Map,this.h=new Map,this.f=w.getProxy(f.$6K.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(w=>w.dispose()),this.g.clear()}createWebviewPanel(w,s,a,r,n={}){const o=typeof r=="object"?r.viewColumn:r,c={viewColumn:R.ViewColumn.from(o),preserveFocus:typeof r=="object"&&!!r.preserveFocus},h=(0,$.$zgc)(w),t=k.c();this.f.$createWebviewPanel((0,$.$Bgc)(w),t,s,{title:a,panelOptions:l(n),webviewOptions:(0,$.$Cgc)(w,this.m,n),serializeBuffersForPostMessage:h},c);const u=this.j.createNewWebview(t,n,w);return this.createNewWebviewPanel(t,s,a,o,n,u,!0)}$onDidChangeWebviewPanelViewStates(w){const s=Object.keys(w);s.sort((a,r)=>{const n=w[a],o=w[r];return n.active?1:o.active?-1:+n.visible-+o.visible});for(const a of s){const r=this.getWebviewPanel(a);if(!r)continue;const n=w[a];r._updateViewState({active:n.active,visible:n.visible,viewColumn:R.ViewColumn.to(n.position)})}}async $onDidDisposeWebviewPanel(w){this.getWebviewPanel(w)?.dispose(),this.g.delete(w),this.j.deleteWebview(w)}registerWebviewPanelSerializer(w,s,a){if(this.h.has(s))throw new Error(`Serializer for '${s}' already registered`);return this.h.set(s,{serializer:a,extension:w}),this.f.$registerSerializer(s,{serializeBuffersForPostMessage:(0,$.$zgc)(w)}),new b.$8K(()=>{this.h.delete(s),this.f.$unregisterSerializer(s)})}async $deserializeWebviewPanel(w,s,a,r){const n=this.h.get(s);if(!n)throw new Error(`No serializer found for '${s}'`);const{serializer:o,extension:c}=n,h=this.j.createNewWebview(w,a.webviewOptions,c),t=this.createNewWebviewPanel(w,s,a.title,r,a.panelOptions,h,a.active);await o.deserializeWebviewPanel(t,a.state)}createNewWebviewPanel(w,s,a,r,n,o,c){const h=new A(w,this.f,o,{viewType:s,title:a,viewColumn:r,panelOptions:n,active:c});return this.g.set(w,h),h}getWebviewPanel(w){return this.g.get(w)}}e.$Dgc=k;function l(p){return{enableFindWidget:p.enableFindWidget,retainContextWhenHidden:p.retainContextWhenHidden}}}),define(Pe[273],Re([1,0,5,6,65,8,3,7]),function(ge,e,y,T,C,L,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8hc=void 0;class f extends T.$Tc{#e;#t;#i;#o;#n;#r;#a;#s;#c;constructor(k,l,p,w,s,a){super(),this.#n=!1,this.#u=this.B(new y.$Vd),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new y.$Vd),this.onDidDispose=this.#l.event,this.#i=p,this.#a=w,this.#e=k,this.#t=l,this.#o=s,this.#r=a}dispose(){this.#n||(this.#n=!0,this.#l.fire(),this.#o.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(k){this.a(),this.#a!==k&&(this.#a=k,this.#t.$setWebviewViewTitle(this.#e,k))}get description(){return this.a(),this.#s}set description(k){this.a(),this.#s!==k&&(this.#s=k,this.#t.$setWebviewViewDescription(this.#e,k))}get visible(){return this.#r}get webview(){return this.#o}get viewType(){return this.#i}_setVisible(k){k===this.#r||this.#n||(this.#r=k,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(k){this.a(),!(k?.value===this.#c?.value&&k?.tooltip===this.#c?.tooltip)&&(this.#c=L.ViewBadge.from(k),this.#t.$setWebviewViewBadge(this.#e,k))}show(k){this.a(),this.#t.$show(this.#e,!!k)}a(){if(this.#n)throw new Error("Webview is disposed")}}class b{constructor(k,l){this.d=l,this.b=new Map,this.c=new Map,this.a=k.getProxy(R.$6K.MainThreadWebviewViews)}registerWebviewViewProvider(k,l,p,w){if(this.b.has(l))throw new Error(`View provider for '${l}' already registered`);return this.b.set(l,{provider:p,extension:k}),this.a.$registerWebviewViewProvider((0,C.$Bgc)(k),l,{retainContextWhenHidden:w?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,C.$zgc)(k)}),new $.$8K(()=>{this.b.delete(l),this.a.$unregisterWebviewViewProvider(l)})}async $resolveWebviewView(k,l,p,w,s){const a=this.b.get(l);if(!a)throw new Error(`No view provider found for '${l}'`);const{provider:r,extension:n}=a,o=this.d.createNewWebview(k,{},n),c=new f(k,this.a,l,p,o,!0);this.c.set(k,c),await r.resolveWebviewView(c,{state:w},s)}async $onDidChangeWebviewViewVisibility(k,l){this.e(k)._setVisible(l)}async $disposeWebviewView(k){const l=this.e(k);this.c.delete(k),l.dispose(),this.d.deleteWebview(k)}e(k){const l=this.c.get(k);if(!l)throw new Error("No webview found");return l}}e.$8hc=b}),define(Pe[111],Re([1,0,5,3,2,12,11,4,17,23]),function(ge,e,y,T,C,L,R,$,f,b){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.$0hc=e.$9hc=void 0;let k=class{static{A=this}static{this.a={focused:!0,active:!0}}getState(p){const w=this.d;return{get focused(){return w.focused},get active(){return(0,b.$CF)(p,"windowActivity"),w.active}}}constructor(p){this.c=new y.$Vd,this.onDidChangeWindowState=this.c.event,this.d=A.a,this.b=p.getProxy(T.$6K.MainThreadWindow),this.b.$getInitialState().then(({isFocused:w,isActive:s})=>{this.onDidChangeWindowProperty("focused",w),this.onDidChangeWindowProperty("active",s)})}$onDidChangeWindowFocus(p){this.onDidChangeWindowProperty("focused",p)}$onDidChangeWindowActive(p){this.onDidChangeWindowProperty("active",p)}onDidChangeWindowProperty(p,w){w!==this.d[p]&&(this.d={...this.d,[p]:w},this.c.fire(this.d))}openUri(p,w){let s;if(typeof p=="string"){s=p;try{p=C.URI.parse(p)}catch{return Promise.reject(`Invalid uri - '${p}'`)}}return(0,R.$Je)(p.scheme)?Promise.reject("Invalid scheme - cannot be empty"):p.scheme===L.Schemas.command?Promise.reject(`Invalid scheme '${p.scheme}'`):this.b.$openUri(p,s,w)}async asExternalUri(p,w){if((0,R.$Je)(p.scheme))return Promise.reject("Invalid scheme - cannot be empty");const s=await this.b.$asExternalUri(p,w);return C.URI.from(s)}};e.$9hc=k,e.$9hc=k=A=Je([Ke(0,f.$0M)],k),e.$0hc=(0,$.$6h)("IExtHostWindow")}),define(Pe[274],Re([1,0,240,27,17]),function(ge,e,y,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jkc=void 0;let L=class extends y.$aic{constructor($,f){super($,f)}f($,f,b){f.apply(console,b)}};e.$jkc=L,e.$jkc=L=Je([Ke(0,C.$0M),Ke(1,T.$nN)],L)}),define(Pe[275],Re([1,0,13,24,20,15,5,6,139,229,49]),function(ge,e,y,T,C,L,R,$,f,b,A){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$p8b=e.ResponsiveState=e.RequestInitiator=e.$o8b=e.$n8b=void 0;function l(D,N){try{return JSON.stringify(D,N)}catch{return"null"}}const p="$$ref$$",w={[p]:-1};class s{constructor(N,O){this.jsonString=N,this.referencedBuffers=O}}function a(D,N=null,O=!1){const G=[];return{jsonString:(O?l:JSON.stringify)(D,(z,P)=>{if(typeof P>"u")return w;if(typeof P=="object"){if(P instanceof T.$je){const I=G.push(P)-1;return{[p]:I}}if(N)return N(z,P)}return P}),referencedBuffers:G}}e.$n8b=a;function r(D,N,O){return JSON.parse(D,(G,W)=>{if(W){const z=W[p];if(typeof z=="number")return N[z];if(O&&W.$mid===1)return O.transformIncoming(W)}return W})}e.$o8b=r;function n(D,N){return JSON.stringify(D,N)}function o(D){return D?(N,O)=>O&&O.$mid===1?D.transformOutgoing(O):O:null}var c;(function(D){D[D.LocalSide=0]="LocalSide",D[D.OtherSide=1]="OtherSide"})(c||(e.RequestInitiator=c={}));var h;(function(D){D[D.Responsive=0]="Responsive",D[D.Unresponsive=1]="Unresponsive"})(h||(e.ResponsiveState=h={}));const t=()=>{},u=Symbol.for("rpcProtocol"),i=Symbol.for("rpcProxy");class g extends $.$Tc{static{k=u}static{this.a=3*1e3}constructor(N,O=null,G=null){super(),this[k]=!0,this.b=this.B(new R.$Vd),this.onDidChangeResponsiveState=this.b.event,this.c=N,this.f=O,this.g=G,this.h=o(this.g),this.j=!1,this.m=[],this.s=[];for(let W=0,z=A.$Qv.count;W<z;W++)this.m[W]=null,this.s[W]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new y.$fh(()=>this.H(),1e3)),this.c.onMessage(W=>this.L(W))}dispose(){this.j=!0,Object.keys(this.w).forEach(N=>{const O=this.w[N];delete this.w[N],O.resolveErr(L.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(N){this.z===0&&(this.C=Date.now()+g.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(N){this.C=Date.now()+g.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(N){this.y!==N&&(this.y=N,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(N){return this.g?(0,f.$7m)(N,this.g):N}getProxy(N){const{nid:O,sid:G}=N;return this.s[O]||(this.s[O]=this.J(O,G)),this.s[O]}J(N,O){const G={get:(W,z)=>(typeof z=="string"&&!W[z]&&z.charCodeAt(0)===36&&(W[z]=(...P)=>this.U(N,z,P)),z===i?O:W[z])};return new Proxy(Object.create(null),G)}set(N,O){return this.m[N.nid]=O,O}assertRegistered(N){for(let O=0,G=N.length;O<G;O++){const W=N[O];if(!this.m[W.nid])throw new Error(`Missing proxy instance ${W.sid}`)}}L(N){if(this.j)return;const O=N.byteLength,G=d.read(N,0),W=G.readUInt8(),z=G.readUInt32();switch(W){case 1:case 2:{let{rpcId:P,method:I,args:H}=M.deserializeRequestJSONArgs(G);this.g&&(H=(0,f.$7m)(H,this.g)),this.M(O,z,P,I,H,W===2);break}case 3:case 4:{let{rpcId:P,method:I,args:H}=M.deserializeRequestMixedArgs(G);this.g&&(H=(0,f.$7m)(H,this.g)),this.M(O,z,P,I,H,W===4);break}case 5:{this.f?.logIncoming(O,z,0,"ack"),this.G(z);break}case 6:{this.N(O,z);break}case 7:{this.O(O,z,void 0);break}case 9:{let P=M.deserializeReplyOKJSON(G);this.g&&(P=(0,f.$7m)(P,this.g)),this.O(O,z,P);break}case 10:{const P=M.deserializeReplyOKJSONWithBuffers(G,this.g);this.O(O,z,P);break}case 8:{const P=M.deserializeReplyOKVSBuffer(G);this.O(O,z,P);break}case 11:{let P=M.deserializeReplyErrError(G);this.g&&(P=(0,f.$7m)(P,this.g)),this.P(O,z,P);break}case 12:{this.P(O,z,void 0);break}default:console.error("received unexpected message"),console.error(N)}}M(N,O,G,W,z,P){this.f?.logIncoming(N,O,1,`receiveRequest ${(0,A.$Sv)(G)}.${W}(`,z);const I=String(O);let H,ae;if(P){const we=new C.$6d;z.push(we.token),H=this.Q(G,W,z),ae=()=>we.cancel()}else H=this.Q(G,W,z),ae=t;this.u[I]=ae;const de=M.serializeAcknowledged(O);this.f?.logOutgoing(de.byteLength,O,1,"ack"),this.c.send(de),H.then(we=>{delete this.u[I];const ke=M.serializeReplyOK(O,we,this.h);this.f?.logOutgoing(ke.byteLength,O,1,"reply:",we),this.c.send(ke)},we=>{delete this.u[I];const ke=M.serializeReplyErr(O,we);this.f?.logOutgoing(ke.byteLength,O,1,"replyErr:",we),this.c.send(ke)})}N(N,O){this.f?.logIncoming(N,O,1,"receiveCancel");const G=String(O);this.u[G]?.()}O(N,O,G){this.f?.logIncoming(N,O,0,"receiveReply:",G);const W=String(O);if(!this.w.hasOwnProperty(W))return;const z=this.w[W];delete this.w[W],z.resolveOk(G)}P(N,O,G){this.f?.logIncoming(N,O,0,"receiveReplyErr:",G);const W=String(O);if(!this.w.hasOwnProperty(W))return;const z=this.w[W];delete this.w[W];let P;G&&(G.$isError?(P=new Error,P.name=G.name,P.message=G.message,P.stack=G.stack):P=G),z.resolveErr(P)}Q(N,O,G){try{return Promise.resolve(this.S(N,O,G))}catch(W){return Promise.reject(W)}}S(N,O,G){const W=this.m[N];if(!W)throw new Error("Unknown actor "+(0,A.$Sv)(N));const z=W[O];if(typeof z!="function")throw new Error("Unknown method "+O+" on actor "+(0,A.$Sv)(N));return z.apply(W,G)}U(N,O,G){if(this.j)return new b.$m8b;let W=null;if(G.length>0&&C.CancellationToken.isCancellationToken(G[G.length-1])&&(W=G.pop()),W&&W.isCancellationRequested)return Promise.reject(L.$6());const z=M.serializeRequestArguments(G,this.h),P=++this.t,I=String(P),H=new b.$l8b,ae=new $.$Sc;W&&ae.add(W.onCancellationRequested(()=>{const we=M.serializeCancel(P);this.f?.logOutgoing(we.byteLength,P,0,"cancel"),this.c.send(M.serializeCancel(P))})),this.w[I]=new m(H,ae),this.F(P);const de=M.serializeRequest(P,N,O,z,!!W);return this.f?.logOutgoing(de.byteLength,P,0,`request: ${(0,A.$Sv)(N)}.${O}(`,G),this.c.send(de),H}}e.$p8b=g;class m{constructor(N,O){this.a=N,this.b=O}resolveOk(N){this.a.resolveOk(N),this.b.dispose()}resolveErr(N){this.a.resolveErr(N),this.b.dispose()}}class d{static alloc(N,O,G){const W=new d(T.$je.alloc(G+1+4),0);return W.writeUInt8(N),W.writeUInt32(O),W}static read(N,O){return new d(N,O)}get buffer(){return this.a}constructor(N,O){this.a=N,this.b=O}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(N){this.a.writeUInt8(N,this.b),this.b+=1}readUInt8(){const N=this.a.readUInt8(this.b);return this.b+=1,N}writeUInt32(N){this.a.writeUInt32BE(N,this.b),this.b+=4}readUInt32(){const N=this.a.readUInt32BE(this.b);return this.b+=4,N}static sizeShortString(N){return 1+N.byteLength}writeShortString(N){this.a.writeUInt8(N.byteLength,this.b),this.b+=1,this.a.set(N,this.b),this.b+=N.byteLength}readShortString(){const N=this.a.readUInt8(this.b);this.b+=1;const G=this.a.slice(this.b,this.b+N).toString();return this.b+=N,G}static sizeLongString(N){return 4+N.byteLength}writeLongString(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}readLongString(){const N=this.a.readUInt32BE(this.b);this.b+=4;const G=this.a.slice(this.b,this.b+N).toString();return this.b+=N,G}writeBuffer(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}static sizeVSBuffer(N){return 4+N.byteLength}writeVSBuffer(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}readVSBuffer(){const N=this.a.readUInt32BE(this.b);this.b+=4;const O=this.a.slice(this.b,this.b+N);return this.b+=N,O}static sizeMixedArray(N){let O=0;O+=1;for(let G=0,W=N.length;G<W;G++){const z=N[G];switch(O+=1,z.type){case 1:O+=this.sizeLongString(z.value);break;case 2:O+=this.sizeVSBuffer(z.value);break;case 3:O+=this.sizeUInt32,O+=this.sizeLongString(z.value);for(let P=0;P<z.buffers.length;++P)O+=this.sizeVSBuffer(z.buffers[P]);break;case 4:break}}return O}writeMixedArray(N){this.a.writeUInt8(N.length,this.b),this.b+=1;for(let O=0,G=N.length;O<G;O++){const W=N[O];switch(W.type){case 1:this.writeUInt8(1),this.writeLongString(W.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(W.value);break;case 3:this.writeUInt8(3),this.writeUInt32(W.buffers.length),this.writeLongString(W.value);for(let z=0;z<W.buffers.length;++z)this.writeBuffer(W.buffers[z]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const N=this.a.readUInt8(this.b);this.b+=1;const O=new Array(N);for(let G=0;G<N;G++)switch(this.readUInt8()){case 1:O[G]=this.readLongString();break;case 2:O[G]=this.readVSBuffer();break;case 3:{const z=this.readUInt32(),P=this.readLongString(),I=[];for(let H=0;H<z;++H)I.push(this.readVSBuffer());O[G]=new A.$Tv(r(P,I,null));break}case 4:O[G]=void 0;break}return O}}var S;(function(D){D[D.Simple=0]="Simple",D[D.Mixed=1]="Mixed"})(S||(S={}));class M{static a(N){for(let O=0,G=N.length;O<G;O++)if(N[O]instanceof T.$je||N[O]instanceof A.$Tv||typeof N[O]>"u")return!0;return!1}static serializeRequestArguments(N,O){if(this.a(N)){const G=[];for(let W=0,z=N.length;W<z;W++){const P=N[W];if(P instanceof T.$je)G[W]={type:2,value:P};else if(typeof P>"u")G[W]={type:4};else if(P instanceof A.$Tv){const{jsonString:I,referencedBuffers:H}=a(P.value,O);G[W]={type:3,value:T.$je.fromString(I),buffers:H}}else G[W]={type:1,value:T.$je.fromString(n(P,O))}}return{type:1,args:G}}return{type:0,args:n(N,O)}}static serializeRequest(N,O,G,W,z){switch(W.type){case 0:return this.b(N,O,G,W.args,z);case 1:return this.c(N,O,G,W.args,z)}}static b(N,O,G,W,z){const P=T.$je.fromString(G),I=T.$je.fromString(W);let H=0;H+=d.sizeUInt8(),H+=d.sizeShortString(P),H+=d.sizeLongString(I);const ae=d.alloc(z?2:1,N,H);return ae.writeUInt8(O),ae.writeShortString(P),ae.writeLongString(I),ae.buffer}static deserializeRequestJSONArgs(N){const O=N.readUInt8(),G=N.readShortString(),W=N.readLongString();return{rpcId:O,method:G,args:JSON.parse(W)}}static c(N,O,G,W,z){const P=T.$je.fromString(G);let I=0;I+=d.sizeUInt8(),I+=d.sizeShortString(P),I+=d.sizeMixedArray(W);const H=d.alloc(z?4:3,N,I);return H.writeUInt8(O),H.writeShortString(P),H.writeMixedArray(W),H.buffer}static deserializeRequestMixedArgs(N){const O=N.readUInt8(),G=N.readShortString(),W=N.readMixedArray(),z=new Array(W.length);for(let P=0,I=W.length;P<I;P++){const H=W[P];typeof H=="string"?z[P]=JSON.parse(H):z[P]=H}return{rpcId:O,method:G,args:z}}static serializeAcknowledged(N){return d.alloc(5,N,0).buffer}static serializeCancel(N){return d.alloc(6,N,0).buffer}static serializeReplyOK(N,O,G){if(typeof O>"u")return this.d(N);if(O instanceof T.$je)return this.e(N,O);if(O instanceof A.$Tv){const{jsonString:W,referencedBuffers:z}=a(O.value,G,!0);return this.g(N,W,z)}else return this.f(N,l(O,G))}static d(N){return d.alloc(7,N,0).buffer}static e(N,O){let G=0;G+=d.sizeVSBuffer(O);const W=d.alloc(8,N,G);return W.writeVSBuffer(O),W.buffer}static deserializeReplyOKVSBuffer(N){return N.readVSBuffer()}static f(N,O){const G=T.$je.fromString(O);let W=0;W+=d.sizeLongString(G);const z=d.alloc(9,N,W);return z.writeLongString(G),z.buffer}static g(N,O,G){const W=T.$je.fromString(O);let z=0;z+=d.sizeUInt32,z+=d.sizeLongString(W);for(const I of G)z+=d.sizeVSBuffer(I);const P=d.alloc(10,N,z);P.writeUInt32(G.length),P.writeLongString(W);for(const I of G)P.writeBuffer(I);return P.buffer}static deserializeReplyOKJSON(N){const O=N.readLongString();return JSON.parse(O)}static deserializeReplyOKJSONWithBuffers(N,O){const G=N.readUInt32(),W=N.readLongString(),z=[];for(let P=0;P<G;++P)z.push(N.readVSBuffer());return new A.$Tv(r(W,z,O))}static serializeReplyErr(N,O){const G=O?l(L.$3(O),null):void 0;if(typeof G!="string")return this.h(N);const W=T.$je.fromString(G);let z=0;z+=d.sizeLongString(W);const P=d.alloc(11,N,z);return P.writeLongString(W),P.buffer}static deserializeReplyErrError(N){const O=N.readLongString();return JSON.parse(O)}static h(N){return d.alloc(12,N,0).buffer}}var v;(function(D){D[D.RequestJSONArgs=1]="RequestJSONArgs",D[D.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",D[D.RequestMixedArgs=3]="RequestMixedArgs",D[D.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",D[D.Acknowledged=5]="Acknowledged",D[D.Cancel=6]="Cancel",D[D.ReplyOKEmpty=7]="ReplyOKEmpty",D[D.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",D[D.ReplyOKJSON=9]="ReplyOKJSON",D[D.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",D[D.ReplyErrError=11]="ReplyErrError",D[D.ReplyErrEmpty=12]="ReplyErrEmpty"})(v||(v={}));var E;(function(D){D[D.String=1]="String",D[D.VSBuffer=2]="VSBuffer",D[D.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",D[D.Undefined=4]="Undefined"})(E||(E={}))}),define(Pe[276],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lkc=void 0;const y=function(L){const R=$=>{globalThis.removeEventListener("message",R);const f=$.data;Object.defineProperties(globalThis,{postMessage:{value(b,A){f.postMessage(b,A)}},onmessage:{get(){return f.onmessage},set(b){f.onmessage=b}}}),f.addEventListener("message",b=>{globalThis.dispatchEvent(new MessageEvent("message",{data:b.data,ports:b.ports?[...b.ports]:void 0}))}),f.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(L)};globalThis.addEventListener("message",R)}.toString();class T extends EventTarget{constructor(L,R,$){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const f=`((${y})('${R}'))`,b=new Blob([f],{type:"application/javascript"}),A=URL.createObjectURL(b),k=new MessageChannel,l=A,p={type:"_newWorker",id:l,port:k.port2,url:A,options:$};L(p,[k.port2]),this.postMessage=k.port1.postMessage.bind(k.port1),this.terminate=()=>{L({type:"_terminateWorker",id:l}),URL.revokeObjectURL(A),k.port1.close(),k.port2.close()},Object.defineProperties(this,{onmessage:{get(){return k.port1.onmessage},set(w){k.port1.onmessage=w}},onmessageerror:{get(){return k.port1.onmessageerror},set(w){k.port1.onmessageerror=w}}}),k.port1.addEventListener("messageerror",w=>{const s=new MessageEvent("messageerror",{data:w.data});this.dispatchEvent(s)}),k.port1.addEventListener("message",w=>{const s=new MessageEvent("message",{data:w.data});this.dispatchEvent(s)}),k.port1.start()}}e.$lkc=T}),define(Pe[277],Re([1,0,5,30,35,4]),function(ge,e,y,T,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pK=e.$oK=e.OutputChannelUpdateMode=e.$nK=e.$mK=e.$lK=e.$kK=e.$jK=e.$iK=e.$hK=e.$gK=e.$fK=e.$eK=void 0,e.$eK="text/x-code-output",e.$fK="output",e.$gK="Log",e.$hK="text/x-code-log-output",e.$iK="log",e.$jK="workbench.panel.output",e.$kK=new C.$kj("inOutput",!1),e.$lK=new C.$kj("activeLogOutput",!1),e.$mK=new C.$kj("outputView.scrollLock",!1),e.$nK=(0,L.$6h)("outputService");var R;(function(f){f[f.Append=1]="Append",f[f.Replace=2]="Replace",f[f.Clear=3]="Clear"})(R||(e.OutputChannelUpdateMode=R={})),e.$oK={OutputChannels:"workbench.contributions.outputChannels"};class ${constructor(){this.a=new Map,this.b=new y.$Vd,this.onDidRegisterChannel=this.b.event,this.c=new y.$Vd,this.onDidRemoveChannel=this.c.event}registerChannel(b){this.a.has(b.id)||(this.a.set(b.id,b),this.b.fire(b.id))}getChannels(){const b=[];return this.a.forEach(A=>b.push(A)),b}getChannel(b){return this.a.get(b)}removeChannel(b){this.a.delete(b),this.c.fire(b)}}T.$Hn.add(e.$oK.OutputChannels,new $),e.$pK=new C.$kj("activeOutputChannel","")}),define(Pe[112],Re([1,0,3,4,17,22,14,277,63,27,42,136,24,16,41,5,6]),function(ge,e,y,T,C,L,R,$,f,b,A,k,l,p,w,s,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jhc=e.$Ihc=void 0;class r extends R.$tj{get disposed(){return this.n}constructor(h,t,u,i,g){super(),this.id=h,this.name=t,this.r=u,this.s=i,this.extension=g,this.m=0,this.n=!1,this.visible=!1,this.setLevel(u.getLevel()),this.B(u.onDidChangeLogLevel(m=>this.setLevel(m)))}get logLevel(){return this.getLevel()}appendLine(h){this.append(h+`
`)}append(h){this.info(h)}clear(){const h=this.m;this.r.flush(),this.s.$update(this.id,$.OutputChannelUpdateMode.Clear,h)}replace(h){const t=this.m;this.info(h),this.s.$update(this.id,$.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(h,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof h=="boolean"?h:t))}hide(){this.s.$close(this.id)}g(h,t){this.m+=l.$je.fromString(t).byteLength,(0,R.log)(this.r,h,t),this.visible&&(this.r.flush(),this.s.$update(this.id,$.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class n extends r{appendLine(h){this.append(h)}}let o=class{constructor(h,t,u,i,g,m){this.i=t,this.j=u,this.k=i,this.l=g,this.m=m,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=h.getProxy(y.$6K.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,k.$wm)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(h){this.h=h;for(const[t,u]of this.g)u.visible=t===this.h}createOutputChannel(h,t,u){if(h=h.trim(),!h)throw new Error("illegal argument `name`. must not be falsy");const i=typeof t=="object"&&t.log,g=(0,p.$If)(t)?t:void 0;if((0,p.$If)(g)&&!g.trim())throw new Error("illegal argument `languageId`. must not be empty");let m;const d=this.i.environment.extensionLogLevel?.find(([M])=>L.$lm.equals(u.identifier,M))?.[1];d&&(m=(0,R.$Dj)(d));const S=i?this.o(h,m,u):this.n(h,g,u);return S.then(M=>{this.g.set(M.id,M),M.visible=M.id===this.h}),i?this.r(h,m??this.m.getLevel(),S):this.q(h,S)}async n(h,t,u){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const i=await this.c,g=this.k.extUri.joinPath(i,`${this.f++}-${h.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),m=this.l.createLogger(g,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),d=await this.a.$register(h,g,t,u.identifier.value);return new r(d,h,m,this.a,u)}async o(h,t,u){const i=await this.p(u),g=h.replace(/[\\/:\*\?"<>\|]/g,""),m=this.k.extUri.joinPath(i,`${g}.log`),d=`${u.identifier.value}.${g}`,S=this.l.createLogger(m,{id:d,name:h,logLevel:t,extensionId:u.identifier.value});return new n(d,h,S,this.a,u)}p(h){let t=this.d.get(h.identifier.value);if(!t){const u=this.k.extUri.joinPath(this.i.logsLocation,h.identifier.value);this.d.set(h.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(u)}catch(i){if((0,w.$Gk)(i)!==w.FileSystemProviderErrorCode.FileExists)throw i}return u})())}return t}q(h,t){let u=!1;const i=()=>{if(u)throw new Error("Channel has been closed")};return{get name(){return h},append(g){i(),t.then(m=>m.append(g))},appendLine(g){i(),t.then(m=>m.appendLine(g))},clear(){i(),t.then(g=>g.clear())},replace(g){i(),t.then(m=>m.replace(g))},show(g,m){i(),t.then(d=>d.show(g,m))},hide(){i(),t.then(g=>g.hide())},dispose(){u=!0,t.then(g=>g.dispose())}}}r(h,t,u){const i=new a.$Sc,g=()=>{if(i.isDisposed)throw new Error("Channel has been closed")},m=i.add(new s.$Vd);function d(S){t=S,m.fire(S)}return u.then(S=>{i.add(S),S.logLevel!==t&&d(S.logLevel),i.add(S.onDidChangeLogLevel(M=>d(M)))}),{...this.q(h,u),get logLevel(){return t},onDidChangeLogLevel:m.event,trace(S,...M){g(),u.then(v=>v.trace(S,...M))},debug(S,...M){g(),u.then(v=>v.debug(S,...M))},info(S,...M){g(),u.then(v=>v.info(S,...M))},warn(S,...M){g(),u.then(v=>v.warn(S,...M))},error(S,...M){g(),u.then(v=>v.error(S,...M))},dispose(){i.dispose()}}}};e.$Ihc=o,e.$Ihc=o=Je([Ke(0,C.$0M),Ke(1,b.$nN),Ke(2,f.$vgc),Ke(3,A.$8fc),Ke(4,R.$oj),Ke(5,R.$nj)],o),e.$Jhc=(0,T.$6h)("IExtHostOutputService")}),define(Pe[113],Re([1,0,4,13]),function(ge,e,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mm=e.$Lm=void 0,e.$Lm=(0,y.$6h)("remoteAgentService"),e.$Mm=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(C){let L=1/0;for(let $=0;$<this.maxSampleCount;$++){const f=await C.getRoundTripTime();if(f===void 0)return;L=Math.min(L,f/2),await(0,T.$7g)(this.sampleDelay)}this.average.push(L),this.average.length>this.maxAverageCount&&this.average.shift();let R;return this.initial.length<this.maxInitialCount?this.initial.push(L):R=this.initial.reduce(($,f)=>$+f,0)/this.initial.length,this.lastMeasurement={initial:R,current:L,average:this.average.reduce(($,f)=>$+f,0)/this.average.length,high:(()=>typeof R>"u"?!1:L>this.highLatencyMaxThreshold||L>this.highLatencyMinThreshold&&L>R*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(Pe[278],Re([1,0,169,54,30,47,46,6,5,113,21,26]),function(ge,e,y,T,C,L,R,$,f,b,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XH=e.$WH=e.$VH=e.$UH=e.$TH=e.$SH=e.$RH=void 0,e.$RH=Object.freeze({id:"application",order:100,title:(0,y.localize)(0,null),type:"object"}),e.$SH=Object.freeze({id:"workbench",order:7,title:(0,y.localize)(1,null),type:"object"}),e.$TH=Object.freeze({id:"security",scope:1,title:(0,y.localize)(2,null),type:"object",order:7}),e.$UH=Object.freeze({id:"problems",title:(0,y.localize)(3,null),type:"object",order:101}),e.$VH={ConfigurationMigration:"base.contributions.configuration.migration"};class l{constructor(){this.migrations=[],this.a=new f.$Vd,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(r){this.migrations.push(...r)}}const p=new l;C.$Hn.add(e.$VH.ConfigurationMigration,p);let w=class extends $.$Tc{constructor(r,n){super(),this.a=r,this.b=n,this.B(this.b.onDidChangeWorkspaceFolders(async o=>{for(const c of o.added)await this.f(c,p.migrations)})),this.c(p.migrations),this.B(p.onDidRegisterConfigurationMigration(o=>this.c(o)))}async c(r){await this.f(void 0,r);for(const n of this.b.getWorkspace().folders)await this.f(n,r)}async f(r,n){await Promise.all([n.map(o=>this.g(o,r?.uri))])}async g(r,n){const o=this.a.inspect(r.key,{resource:n}),c=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[h,t]of c){const u=[];for(const g of o.overrideIdentifiers??[]){const m=await this.h(r,{resource:n,overrideIdentifier:g},h);for(const d of m??[]){let S=u.find(([[M,v]])=>M===d[0]&&(0,k.$zn)(v.value,d[1].value));S||u.push(S=[d,[]]),S[1].push(g)}}const i=await this.h(r,{resource:n},h,o);for(const g of i??[])u.push([g,[]]);u.length&&await Promise.allSettled(u.map(async([[g,m],d])=>this.a.updateValue(g,m.value,{resource:n,overrideIdentifiers:d},t)))}}async h(r,n,o,c){const h=g=>t(this.a.inspect(g,n)),t=g=>{const m=g[o];return n.overrideIdentifier?m?.override:m?.value},u=c?t(c):h(r.key);if(u===void 0)return;const i=await r.migrateFn(u,h);return Array.isArray(i)?i:[[r.key,i]]}};e.$WH=w,e.$WH=w=Je([Ke(0,R.$zi),Ke(1,L.$ci)],w);let s=class extends $.$Tc{constructor(r){super(),(async()=>{if(!A.$i&&(await r.getEnvironment())?.os!==1)return;C.$Hn.as(T.$Mn.Configuration).registerConfiguration({...e.$TH,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,y.localize)(4,null)},default:[],markdownDescription:(0,y.localize)(5,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,y.localize)(6,null),scope:2}}})})()}};e.$XH=s,e.$XH=s=Je([Ke(0,b.$Lm)],s)}),define(Pe[279],Re([1,0,34,12,19,25,177,278,54,4,30]),function(ge,e,y,T,C,L,R,$,f,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fdb=e.$edb=e.ResolvedStatus=e.RegisteredEditorPriority=e.$ddb=e.$cdb=void 0,e.$cdb=(0,b.$6h)("editorResolverService"),e.$ddb="workbench.editorAssociations";const k=A.$Hn.as(f.$Mn.Configuration),l={...$.$SH,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,R.localize)(0,null),additionalProperties:{type:"string"}}}};k.registerConfiguration(l);var p;(function(r){r.builtin="builtin",r.option="option",r.exclusive="exclusive",r.default="default"})(p||(e.RegisteredEditorPriority=p={}));var w;(function(r){r[r.ABORT=1]="ABORT",r[r.NONE=2]="NONE"})(w||(e.ResolvedStatus=w={}));function s(r){switch(r){case p.exclusive:return 5;case p.default:return 4;case p.builtin:return 3;case p.option:default:return 1}}e.$edb=s;function a(r,n){if(new Set([T.Schemas.extension,T.Schemas.webviewPanel,T.Schemas.vscodeWorkspaceTrust,T.Schemas.vscodeSettings]).has(n.scheme))return!1;const h=typeof r=="string"&&r.indexOf(C.$gc.sep)>=0?`${n.scheme}:${n.path}`:(0,L.$Eg)(n);return y.$Lj(typeof r=="string"?r.toLowerCase():r,h.toLowerCase())}e.$fdb=a}),define(Pe[280],Re([1,0,45,12,19,21,25,2,4,198,47,216,113]),function(ge,e,y,T,C,L,R,$,f,b,A,k,l){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$IK=e.$HK=void 0,e.$HK=(0,f.$6h)("pathService");let w=p=class{constructor(a,r,n,o){this.d=a,this.e=r,this.f=n,this.g=o,this.a=(async()=>(await this.e.getEnvironment())?.os||L.OS)(),this.b=(async()=>{const c=await this.e.getEnvironment();return this.c=c?.userHome??a})()}hasValidBasename(a,r,n){return typeof r=="string"||typeof r>"u"?this.a.then(o=>this.h(a,o,r)):this.h(a,r,n)}h(a,r,n){return a.scheme===T.Schemas.file||a.scheme===T.Schemas.vscodeRemote?(0,y.$6f)(n??(0,R.$Eg)(a),r===1):!0}get defaultUriScheme(){return p.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(a,r){if(a.remoteAuthority)return T.Schemas.vscodeRemote;const n=(0,b.$EK)(r.getWorkspace());if(n)return n;const o=r.getWorkspace().folders[0];if(o)return o.uri.scheme;const c=r.getWorkspace().configuration;return c?c.scheme:T.Schemas.file}userHome(a){return a?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(a=>a===1?C.$fc:C.$gc)}async fileURI(a){let r="";if(await this.a===1&&(a=a.replace(/\\/g,"/")),a[0]==="/"&&a[1]==="/"){const o=a.indexOf("/",2);o===-1?(r=a.substring(2),a="/"):(r=a.substring(2,o),a=a.substring(o)||"/")}return $.URI.from({scheme:T.Schemas.file,authority:r,path:a,query:"",fragment:""})}};e.$IK=w,e.$IK=w=p=Je([Ke(1,l.$Lm),Ke(2,k.$qK),Ke(3,A.$ci)],w)}),define(Pe[114],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$kJ=e.$jJ=void 0;class y{constructor(R,$){this.line=R,this.character=$}isBefore(R){return!1}isBeforeOrEqual(R){return!1}isAfter(R){return!1}isAfterOrEqual(R){return!1}isEqual(R){return!1}compareTo(R){return 0}translate(R,$){return new y(0,0)}with(R){return new y(0,0)}}e.$jJ=y;class T{constructor(R,$,f,b){this.isEmpty=!1,this.isSingleLine=!1,this.start=new y(R,$),this.end=new y(f,b)}contains(R){return!1}isEqual(R){return!1}intersection(R){}union(R){return new T(0,0,0,0)}with(R){return new T(0,0,0,0)}}e.$kJ=T;var C;(function(L){L[L.Information=1]="Information",L[L.Warning=2]="Warning"})(C||(e.TextSearchCompleteMessageType=C={}))}),define(Pe[43],Re([1,0,18,34,26,45,11,4,19,15,114,13]),function(ge,e,y,T,C,L,R,$,f,b,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LJ=e.$KJ=e.$JJ=e.$IJ=e.$HJ=e.$GJ=e.$FJ=e.$EJ=e.$DJ=e.$CJ=e.$BJ=e.$AJ=e.SearchErrorCode=e.$zJ=e.$yJ=e.SearchSortOrder=e.ViewMode=e.$xJ=e.$wJ=e.$vJ=e.$uJ=e.SearchCompletionExitCode=e.$tJ=e.$sJ=e.$rJ=e.QueryType=e.SearchProviderType=e.$qJ=e.$pJ=e.$oJ=e.$nJ=e.$mJ=e.$lJ=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return A.TextSearchCompleteMessageType}}),e.$lJ="workbench.view.search",e.$mJ="workbench.panel.search",e.$nJ="workbench.view.search",e.$oJ="search-result",e.$pJ="search.exclude";const l="\u27EA ",p=" characters skipped \u27EB",w=(l.length+p.length+5)*2;e.$qJ=(0,$.$6h)("searchService");var s;(function(le){le[le.file=0]="file",le[le.text=1]="text"})(s||(e.SearchProviderType=s={}));var a;(function(le){le[le.File=1]="File",le[le.Text=2]="Text"})(a||(e.QueryType=a={}));function r(le){return!!le.preview}e.$rJ=r;function n(le){return!!le.resource}e.$sJ=n;function o(le){return!!le.message}e.$tJ=o;var c;(function(le){le[le.Normal=0]="Normal",le[le.NewSearchStarted=1]="NewSearchStarted"})(c||(e.SearchCompletionExitCode=c={}));class h{constructor(ve){this.resource=ve,this.results=[]}}e.$uJ=h;class t{constructor(ve,se,be,ne){this.ranges=se,this.webviewIndex=ne;const Y=Array.isArray(se)?se:[se];if(be&&be.matchLines===1&&u(Y)){ve=(0,R.$Bf)(ve,be.matchLines);let V="",ie=0,Ie=0;const Le=Math.floor(be.charsPerLine/5),Ce=[];for(const ce of Y){const te=Math.max(ce.startColumn-Le,0),Q=ce.startColumn+be.charsPerLine;if(te>Ie+Le+w){const ee=l+(te-Ie)+p;V+=ee+ve.slice(te,Q),ie+=te-(Ie+ee.length)}else V+=ve.slice(Ie,Q);Ce.push(new g(0,ce.startColumn-ie,ce.endColumn-ie)),Ie=Q}this.preview={text:V,matches:Array.isArray(this.ranges)?Ce:Ce[0]}}else{const V=Array.isArray(se)?se[0].startLineNumber:se.startLineNumber;this.preview={text:ve,matches:(0,y.$2b)(se,ie=>new i(ie.startLineNumber-V,ie.startColumn,ie.endLineNumber-V,ie.endColumn))}}}}e.$vJ=t;function u(le){const ve=le[0].startLineNumber;for(const se of le)if(se.startLineNumber!==ve||se.endLineNumber!==ve)return!1;return!0}class i{constructor(ve,se,be,ne){this.startLineNumber=ve,this.startColumn=se,this.endLineNumber=be,this.endColumn=ne}}e.$wJ=i;class g extends i{constructor(ve,se,be){super(ve,se,ve,be)}}e.$xJ=g;var m;(function(le){le.List="list",le.Tree="tree"})(m||(e.ViewMode=m={}));var d;(function(le){le.Default="default",le.FileNames="fileNames",le.Type="type",le.Modified="modified",le.CountDescending="countDescending",le.CountAscending="countAscending"})(d||(e.SearchSortOrder=d={}));function S(le,ve=!0){const se=le&&le.files&&le.files.exclude,be=ve&&le&&le.search&&le.search.exclude;if(!se&&!be)return;if(!se||!be)return se||be;let ne=Object.create(null);return ne=C.$yn(ne,C.$vn(se)),ne=C.$yn(ne,C.$vn(be),!0),ne}e.$yJ=S;function M(le,ve){return le.excludePattern&&T.$Lj(le.excludePattern,ve)?!1:le.includePattern||le.usingSearchPaths?le.includePattern&&T.$Lj(le.includePattern,ve)?!0:le.usingSearchPaths?!!le.folderQueries&&le.folderQueries.some(se=>{const be=se.folder.fsPath;if(L.$8f(ve,be)){const ne=f.$lc(be,ve);return!se.includePattern||!!T.$Lj(se.includePattern,ne)}else return!1}):!1:!0}e.$zJ=M;var v;(function(le){le[le.unknownEncoding=1]="unknownEncoding",le[le.regexParseError=2]="regexParseError",le[le.globParseError=3]="globParseError",le[le.invalidLiteral=4]="invalidLiteral",le[le.rgProcessError=5]="rgProcessError",le[le.other=6]="other",le[le.canceled=7]="canceled"})(v||(e.SearchErrorCode=v={}));class E extends Error{constructor(ve,se){super(ve),this.code=se}}e.$AJ=E;function D(le){const ve=le.message;if((0,b.$4)(le))return new E(ve,v.canceled);try{const se=JSON.parse(ve);return new E(se.message,se.code)}catch{return new E(ve,v.other)}}e.$BJ=D;function N(le){const ve={message:le.message,code:le.code};return new Error(JSON.stringify(ve))}e.$CJ=N;function O(le){return le.type==="error"?!0:le.type==="success"}e.$DJ=O;function G(le){return le.type==="success"}e.$EJ=G;function W(le){return!!le.path}e.$FJ=W;function z(le,ve){const se=le.searchPath?le.searchPath:le.relativePath;return(0,R.$yf)(se,ve)}e.$GJ=z;class P{constructor(ve){this.path=ve,this.results=[]}addMatch(ve){this.results.push(ve)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$HJ=P;function I(le,ve){const se={...le||{},...ve||{}};return Object.keys(se).filter(be=>{const ne=se[be];return typeof ne=="boolean"&&ne})}e.$IJ=I;class H{constructor(ve,se){this.c=null,this.a={...ve.excludePattern||{},...se.excludePattern||{}},this.b=T.$Mj(this.a);let be=ve.includePattern;se.includePattern&&(be?be={...be,...se.includePattern}:be=se.includePattern),be&&(this.c=T.$Mj(be))}matchesExcludesSync(ve,se,be){return!!(this.b&&this.b(ve,se,be))}includedInQuerySync(ve,se,be){return!(this.b&&this.b(ve,se,be)||this.c&&!this.c(ve,se,be))}includedInQuery(ve,se,be){const ne=this.b(ve,se,be),Y=()=>this.c?!!this.c(ve,se,be):!0;return(0,k.$Sg)(ne)?ne.then(V=>V?!1:Y()):Y()}hasSiblingExcludeClauses(){return ae(this.a)}}e.$JJ=H;function ae(le){for(const ve in le)if(typeof le[ve]!="boolean")return!0;return!1}function de(le){if(!le)return;let ve;return se=>(ve||(ve=(le()||Promise.resolve([])).then(be=>be?ke(be):{})),ve.then(be=>!!be[se]))}e.$KJ=de;function we(le){if(!le)return;let ve;return se=>{if(!ve){const be=le();ve=be?ke(be):{}}return!!ve[se]}}e.$LJ=we;function ke(le){const ve={};for(const se of le)ve[se]=!0;return ve}}),define(Pe[36],Re([1,0,18,13,20,5,6,50,12,122,25,11,2,168,4,14,187,47,42,27,17,8,7,57,43,3,51]),function(ge,e,y,T,C,L,R,$,f,b,A,k,l,p,w,s,a,r,n,o,c,h,t,u,i,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qgc=e.$pgc=void 0;function d(G,W,z){return new A.$wg(P=>E(P,z)).isEqual(G,W)}function S(G,W,z){return d(G.uri,W.uri,z)?0:(0,k.$5e)(G.uri.toString(),W.uri.toString())}function M(G,W,z){return G.index!==W.index?G.index<W.index?-1:1:d(G.uri,W.uri,z)?(0,k.$5e)(G.name,W.name):(0,k.$5e)(G.uri.toString(),W.uri.toString())}function v(G,W,z,P){const I=G.slice(0).sort((ae,de)=>z(ae,de,P)),H=W.slice(0).sort((ae,de)=>z(ae,de,P));return(0,y.$Eb)(I,H,(ae,de)=>z(ae,de,P))}function E(G,W){const z=W.getCapabilities(G.scheme);return!(z&&z&1024)}class D extends r.$mi{static toExtHostWorkspace(W,z,P,I){if(!W)return{workspace:null,added:[],removed:[]};const{id:H,name:ae,folders:de,configuration:we,transient:ke,isUntitled:le}=W,ve=[],se=z;z?de.forEach((V,ie)=>{const Ie=l.URI.revive(V.uri),Le=D.o(P||z,Ie,I);Le?(Le.name=V.name,Le.index=V.index,ve.push(Le)):ve.push({uri:Ie,name:V.name,index:ie})}):ve.push(...de.map(({uri:V,name:ie,index:Ie})=>({uri:l.URI.revive(V),name:ie,index:Ie}))),ve.sort((V,ie)=>V.index<ie.index?-1:1);const be=new D(H,ae,ve,!!ke,we?l.URI.revive(we):null,!!le,V=>E(V,I)),{added:ne,removed:Y}=v(se?se.workspaceFolders:[],be.workspaceFolders,S,I);return{workspace:be,added:ne,removed:Y}}static o(W,z,P){for(let I=0;I<W.folders.length;I++){const H=W.workspaceFolders[I];if(d(H.uri,z,P))return H}}constructor(W,z,P,I,H,ae,de){super(W,P.map(we=>new r.$ni(we)),I,H,de),this.t=z,this.u=ae,this.q=[],this.s=$.$_h.forUris(de),P.forEach(we=>{this.q.push(we),this.s.set(we.uri,we)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(W,z){return z&&this.s.get(W)&&(W=(0,A.$Gg)(W)),this.s.findSubstr(W)}resolveWorkspaceFolder(W){return this.s.get(W)}}let N=class{constructor(W,z,P,I,H){this.c=new L.$Vd,this.onDidChangeWorkspace=this.c.event,this.g=new L.$Vd,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new L.$Xd,this.B=new Map,this.h=I,this.s=P,this.t=H,this.j=new b.$9l,this.k=new T.$5g,this.o=W.getProxy(g.$6K.MainThreadWorkspace),this.q=W.getProxy(g.$6K.MainThreadMessageService);const ae=z.workspace;this.l=ae?new D(ae.id,ae.name,[],!!ae.transient,ae.configuration?l.URI.revive(ae.configuration):null,!!ae.isUntitled,de=>E(de,P)):void 0}$initializeWorkspace(W,z){this.v=z,this.$acceptWorkspaceData(W),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?l.URI.from({scheme:f.Schemas.untitled,path:(0,A.$Eg)((0,A.$Gg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(W,z,P,...I){const H=[];if(Array.isArray(I)&&I.forEach(le=>{l.URI.isUri(le.uri)&&!H.some(ve=>d(ve.uri,le.uri,this.s))&&H.push({uri:le.uri,name:le.name||(0,A.$Dg)(le.uri)})}),this.n||[z,P].some(le=>typeof le!="number"||le<0)||P===0&&H.length===0)return!1;const ae=this.x?this.x.workspaceFolders:[];if(z+P>ae.length)return!1;const de=ae.slice(0);de.splice(z,P,...H.map(le=>({uri:le.uri,name:le.name||(0,A.$Dg)(le.uri),index:void 0})));for(let le=0;le<de.length;le++){const ve=de[le];if(de.some((se,be)=>be!==le&&d(ve.uri,se.uri,this.s)))return!1}de.forEach((le,ve)=>le.index=ve);const{added:we,removed:ke}=v(ae,de,M,this.s);if(we.length===0&&ke.length===0)return!1;if(this.o){const le=W.displayName||W.name;this.o.$updateWorkspaceFolders(le,z,P,H).then(void 0,ve=>{this.n=void 0;const se={source:{identifier:W.identifier,label:W.displayName||W.name}};this.q.$showMessage(a.Severity.Error,(0,p.localize)(0,null,le,ve.toString()),se,[])})}return this.y(de),!0}getWorkspaceFolder(W,z){if(this.x)return this.x.getWorkspaceFolder(W,z)}async getWorkspaceFolder2(W,z){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(W,z)}async resolveWorkspaceFolder(W){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(W)}getPath(){if(!this.x)return;const{folders:W}=this.x;if(W.length!==0)return W[0].uri.fsPath}getRelativePath(W,z){let P,I="";if(typeof W=="string"?(P=l.URI.file(W),I=W):typeof W<"u"&&(P=W,I=W.fsPath),!P)return I;const H=this.getWorkspaceFolder(P,!0);if(!H)return I;typeof z>"u"&&this.x&&(z=this.x.folders.length>1);let ae=(0,A.$Jg)(H.uri,P);return z&&H.name&&(ae=`${H.name}/${ae}`),ae}y(W){this.x&&(this.n=D.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:W,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(W){const{workspace:z,added:P,removed:I}=D.toExtHostWorkspace(W,this.l,this.n,this.s);this.l=z||void 0,this.n=void 0,this.c.fire(Object.freeze({added:P,removed:I}))}findFiles(W,z,P,I,H=C.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${I.value}, entryPoint: findFiles`);let ae;if(z===null?ae=!1:z&&(typeof z=="string"?ae=z:ae=z.pattern),H&&H.isCancellationRequested)return Promise.resolve([]);const{includePattern:de,folder:we}=O(h.GlobPattern.from(W));return this.o.$startFileSearch(de??null,we??null,ae??null,P??null,H).then(ke=>Array.isArray(ke)?ke.map(le=>l.URI.revive(le)):[])}async findTextInFiles(W,z,P,I,H=C.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${I.value}, entryPoint: findTextInFiles`);const ae=this.j.getNext(),de=typeof z.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:z.previewOptions,{includePattern:we,folder:ke}=O(h.GlobPattern.from(z.include)),le=typeof z.exclude=="string"?z.exclude:z.exclude?z.exclude.pattern:void 0,ve={ignoreSymlinks:typeof z.followSymlinks=="boolean"?!z.followSymlinks:void 0,disregardIgnoreFiles:typeof z.useIgnoreFiles=="boolean"?!z.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof z.useGlobalIgnoreFiles=="boolean"?!z.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof z.useParentIgnoreFiles=="boolean"?!z.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof z.useDefaultExcludes=="boolean"?!z.useDefaultExcludes:!0,fileEncoding:z.encoding,maxResults:z.maxResults,previewOptions:de,afterContext:z.afterContext,beforeContext:z.beforeContext,includePattern:we,excludePattern:le},se=!1;if(this.u[ae]=be=>{if(se)return;const ne=l.URI.revive(be.resource);be.results.forEach(Y=>{const V=(0,m.$Ch)(Y);(0,i.$rJ)(V)?P({uri:ne,preview:{text:V.preview.text,matches:(0,y.$2b)(V.preview.matches,ie=>new t.$0K(ie.startLineNumber,ie.startColumn,ie.endLineNumber,ie.endColumn))},ranges:(0,y.$2b)(V.ranges,ie=>new t.$0K(ie.startLineNumber,ie.startColumn,ie.endLineNumber,ie.endColumn))}):P({uri:ne,text:V.text,lineNumber:V.lineNumber})})},H.isCancellationRequested)return{};try{const be=await this.o.$startTextSearch(W,ke??null,ve,ae,H);return delete this.u[ae],be||{}}catch(be){throw delete this.u[ae],be}}$handleTextSearchResult(W,z){this.u[z]?.(W)}async save(W){const z=await this.o.$save(W,{saveAs:!1});return l.URI.revive(z)}async saveAs(W){const z=await this.o.$save(W,{saveAs:!0});return l.URI.revive(z)}saveAll(W){return this.o.$saveAll(W)}resolveProxy(W){return this.o.$resolveProxy(W)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(W){return this.o.$requestWorkspaceTrust(W)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(W,z){if(this.w.has(W))throw new Error(`A provider has already been registered for scheme ${W}`);this.w.set(W,z);const P=this.t.transformOutgoingScheme(W),I=this.z++;return this.o.$registerEditSessionIdentityProvider(I,P),(0,R.$Rc)(()=>{this.w.delete(W),this.o.$unregisterEditSessionIdentityProvider(I)})}async $getEditSessionIdentifier(W,z){this.h.info("Getting edit session identifier for workspaceFolder",W);const P=await this.resolveWorkspaceFolder(l.URI.revive(W));if(!P){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",P);const I=this.w.get(P.uri.scheme);if(this.h.info(`Provider for scheme ${P.uri.scheme} is defined: `,!!I),!I)return;const H=await I.provideEditSessionIdentity(P,z);if(this.h.info("Provider returned edit session identifier: ",H),!!H)return H}async $provideEditSessionIdentityMatch(W,z,P,I){this.h.info("Getting edit session identifier for workspaceFolder",W);const H=await this.resolveWorkspaceFolder(l.URI.revive(W));if(!H){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",H);const ae=this.w.get(H.uri.scheme);if(this.h.info(`Provider for scheme ${H.uri.scheme} is defined: `,!!ae),!ae)return;const de=await ae.provideEditSessionIdentityMatch?.(z,P,I);if(this.h.info("Provider returned edit session identifier match result: ",de),!!de)return de}getOnWillCreateEditSessionIdentityEvent(W){return(z,P,I)=>{const H=function(de){z.call(P,de)};return H.extension=W,this.A.event(H,void 0,I)}}async $onWillCreateEditSessionIdentity(W,z,P){const I=await this.resolveWorkspaceFolder(l.URI.revive(W));if(I===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:I},z,async(H,ae)=>{const de=Date.now();await Promise.resolve(H),Date.now()-de>P&&this.h.warn("SLOW edit session create-participant",ae.extension.identifier)}),z.isCancellationRequested}registerCanonicalUriProvider(W,z){if(this.B.has(W))throw new Error(`A provider has already been registered for scheme ${W}`);this.B.set(W,z);const P=this.t.transformOutgoingScheme(W),I=this.z++;return this.o.$registerCanonicalUriProvider(I,P),(0,R.$Rc)(()=>{this.B.delete(W),this.o.$unregisterCanonicalUriProvider(I)})}async provideCanonicalUri(W,z,P){const I=this.B.get(W.scheme);if(!I)return;const H=await I.provideCanonicalUri?.(l.URI.revive(W),z,P);if(H)return H}async $provideCanonicalUri(W,z,P){return this.provideCanonicalUri(l.URI.revive(W),{targetScheme:z},P)}};e.$pgc=N,e.$pgc=N=Je([Ke(0,c.$0M),Ke(1,o.$nN),Ke(2,n.$8fc),Ke(3,s.$nj),Ke(4,u.$ngc)],N),e.$qgc=(0,w.$6h)("IExtHostWorkspace");function O(G){let W,z;return G&&(typeof G=="string"?W=G:(W=G.pattern,z=l.URI.revive(G.baseUri))),{includePattern:W,folder:z}}}),define(Pe[37],Re([1,0,26,5,36,3,7,189,54,16,13,4,17,14,2]),function(ge,e,y,T,C,L,R,$,f,b,A,k,l,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tgc=e.$sgc=e.$rgc=void 0;function s(u,i){if(i){const g=i.split(".");let m=u;for(let d=0;m&&d<g.length;d++)m=m[g[d]];return m}}function a(u){return u instanceof w.URI}function r(u){return u&&u.uri instanceof w.URI&&u.languageId&&typeof u.languageId=="string"}function n(u){return u&&!u.uri&&u.languageId&&typeof u.languageId=="string"}function o(u){return u&&u.uri instanceof w.URI&&(!u.name||typeof u.name=="string")&&(!u.index||typeof u.index=="number")}function c(u){if(a(u))return{resource:u};if(r(u))return{resource:u.uri,overrideIdentifier:u.languageId};if(n(u))return{overrideIdentifier:u.languageId};if(o(u))return{resource:u.uri};if(u===null)return{resource:null}}let h=class{constructor(i,g,m){this.a=i.getProxy(L.$6K.MainThreadConfiguration),this.c=g,this.b=m,this.d=new A.$5g,this.e=null}getConfigProvider(){return this.d.wait().then(i=>this.e)}$initializeConfiguration(i){this.e=new t(this.a,this.c,i,this.b),this.d.open()}$acceptConfigurationChanged(i,g){this.getConfigProvider().then(m=>m.$acceptConfigurationChanged(i,g))}};e.$rgc=h,e.$rgc=h=Je([Ke(0,l.$0M),Ke(1,C.$qgc),Ke(2,p.$nj)],h);class t{constructor(i,g,m,d){this.a=new T.$Vd,this.b=i,this.f=d,this.c=g,this.e=$.$6n.parse(m),this.d=this.k(m.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(i,g){const m={data:this.e.toData(),workspace:this.c.workspace};this.e=$.$6n.parse(i),this.d=this.k(i.configurationScopes),this.a.fire(this.j(g,m))}getConfiguration(i,g,m){const d=c(g)||{},S=this.g(i?s(this.e.getValue(void 0,d,this.c.workspace),i):this.e.getValue(void 0,d,this.c.workspace));i&&this.h(i,d,m?.identifier);function M(E){if(E==null)return null;if(typeof E=="boolean")return E?2:5;switch(E){case R.ConfigurationTarget.Global:return 2;case R.ConfigurationTarget.Workspace:return 5;case R.ConfigurationTarget.WorkspaceFolder:return 6}}const v={has(E){return typeof s(S,E)<"u"},get:(E,D)=>{this.h(i?`${i}.${E}`:E,d,m?.identifier);let N=s(S,E);if(typeof N>"u")N=D;else{let O;const G=(W,z)=>{if((0,b.$Kf)(W)){let P;const I=()=>{O=O||(0,y.$vn)(S),P=P||s(O,z)};return new Proxy(W,{get:(H,ae)=>{if(typeof ae=="string"&&ae.toLowerCase()==="tojson")return I(),()=>P;if(O)return P=P||s(O,z),P[ae];const de=H[ae];return typeof ae=="string"?G(de,`${z}.${ae}`):de},set:(H,ae,de)=>(I(),P&&(P[ae]=de),!0),deleteProperty:(H,ae)=>(I(),P&&delete P[ae],!0),defineProperty:(H,ae,de)=>(I(),P&&Object.defineProperty(P,ae,de),!0)})}return Array.isArray(W)?(0,y.$vn)(W):W};N=G(N,E)}return N},update:(E,D,N,O)=>{E=i?`${i}.${E}`:E;const G=M(N);return D!==void 0?this.b.$updateConfigurationOption(G,E,D,d,O):this.b.$removeConfigurationOption(G,E,d,O)},inspect:E=>{E=i?`${i}.${E}`:E;const D=this.e.inspect(E,d,this.c.workspace);if(D)return{key:E,defaultValue:(0,y.$vn)(D.policy?.value??D.default?.value),globalValue:(0,y.$vn)(D.user?.value??D.application?.value),workspaceValue:(0,y.$vn)(D.workspace?.value),workspaceFolderValue:(0,y.$vn)(D.workspaceFolder?.value),defaultLanguageValue:(0,y.$vn)(D.default?.override),globalLanguageValue:(0,y.$vn)(D.user?.override??D.application?.override),workspaceLanguageValue:(0,y.$vn)(D.workspace?.override),workspaceFolderLanguageValue:(0,y.$vn)(D.workspaceFolder?.override),languageIds:(0,y.$vn)(D.overrideIdentifiers)}}};return typeof S=="object"&&(0,y.$yn)(v,S,!1),Object.freeze(v)}g(i){const g=m=>(0,b.$Kf)(m)?new Proxy(m,{get:(d,S)=>g(d[S]),set:(d,S,M)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(S)}' of object`)},deleteProperty:(d,S)=>{throw new Error(`TypeError: Cannot delete read only property '${String(S)}' of object`)},defineProperty:(d,S)=>{throw new Error(`TypeError: Cannot define property '${String(S)}' for a readonly object`)},setPrototypeOf:d=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):m;return g(i)}h(i,g,m){const d=f.$Wn.test(i)?4:this.d.get(i),S=m?`[${m.value}] `:"";if(d===4){typeof g?.resource>"u"&&this.f.warn(`${S}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${i}', provide the URI of a resource or 'null' for any resource.`);return}if(d===3){g?.resource&&this.f.warn(`${S}Accessing a window scoped configuration for a resource is not expected. To associate '${i}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(i,g){const m=new $.$8n(i,g,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(d,S)=>m.affectsConfiguration(d,c(S))})}k(i){return i.reduce((g,m)=>(g.set(m[0],m[1]),g),new Map)}}e.$sgc=t,e.$tgc=(0,k.$6h)("IExtHostConfiguration")}),define(Pe[115],Re([1,0,2,13,5,3,7,36,61,37,20,64,17,27,4,12,21,14,81,228,15]),function(ge,e,y,T,C,L,R,$,f,b,A,k,l,p,w,s,a,r,n,o,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Whc=e.$Vhc=e.$Uhc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var h;(function(G){function W(P){if(P!=null)return P}G.from=W;function z(P){if(P!=null)return P}G.to=z})(h||(h={}));var t;(function(G){function W(P){if(P!=null)return P}G.from=W;function z(P){if(P!=null)return P}G.to=z})(t||(t={}));var u;(function(G){function W(P){if(P!=null)return P}G.from=W;function z(P){if(P!=null)return P}G.to=z})(u||(u={}));var i;(function(G){function W(I){if(I){const H=I;return H&&!!H.process}else return!1}G.is=W;function z(I){if(I==null)return;const H={process:I.process,args:I.args};return I.options&&(H.options=u.from(I.options)),H}G.from=z;function P(I){if(I!=null)return new R.$QL(I.process,I.args,I.options)}G.to=P})(i||(i={}));var g;(function(G){function W(P){if(P!=null)return P}G.from=W;function z(P){if(P!=null)return P}G.to=z})(g||(g={}));var m;(function(G){function W(I){if(I){const H=I;return H&&(!!H.commandLine||!!H.command)}else return!1}G.is=W;function z(I){if(I==null)return;const H={};return I.commandLine!==void 0?H.commandLine=I.commandLine:(H.command=I.command,H.args=I.args),I.options&&(H.options=g.from(I.options)),H}G.from=z;function P(I){if(!(I==null||I.command===void 0&&I.commandLine===void 0))return I.commandLine?new R.$RL(I.commandLine,I.options):new R.$RL(I.command,I.args?I.args:[],I.options)}G.to=P})(m||(m={}));var d;(function(G){function W(I){if(I){const H=I;return H&&H.customExecution==="customExecution"}else return!1}G.is=W;function z(I){return{customExecution:"customExecution"}}G.from=z;function P(I,H){return H.get(I)}G.to=P})(d||(e.CustomExecutionDTO=d={}));var S;(function(G){function W(z,P){let I;return z.scope!==void 0&&typeof z.scope!="number"?I=z.scope.uri:z.scope!==void 0&&typeof z.scope=="number"&&(z.scope===R.TaskScope.Workspace&&P&&P.workspaceFile?I=P.workspaceFile:I=o.$yG),{id:z._id,workspaceFolder:I}}G.from=W})(S||(e.TaskHandleDTO=S={}));var M;(function(G){function W(z){if(z!=null)return{_id:z.id,isDefault:z.isDefault}}G.from=W})(M||(M={}));var v;(function(G){function W(I,H){if(I==null)return[];const ae=[];for(const de of I){const we=z(de,H);we&&ae.push(we)}return ae}G.fromMany=W;function z(I,H){if(I==null)return;let ae;I.execution instanceof R.$QL?ae=i.from(I.execution):I.execution instanceof R.$RL?ae=m.from(I.execution):I.execution&&I.execution instanceof R.$SL&&(ae=d.from(I.execution));const de=h.from(I.definition);let we;return I.scope?typeof I.scope=="number"?we=I.scope:we=I.scope.uri:we=R.TaskScope.Workspace,!de||!we?void 0:{_id:I._id,definition:de,name:I.name,source:{extensionId:H.identifier.value,label:I.source,scope:we},execution:ae,isBackground:I.isBackground,group:M.from(I.group),presentationOptions:t.from(I.presentationOptions),problemMatchers:I.problemMatchers,hasDefinedMatchers:I.hasDefinedMatchers,runOptions:I.runOptions?I.runOptions:{reevaluateOnRerun:!0},detail:I.detail}}G.from=z;async function P(I,H,ae){if(I==null)return;let de;i.is(I.execution)?de=i.to(I.execution):m.is(I.execution)?de=m.to(I.execution):d.is(I.execution)&&(de=d.to(I._id,ae));const we=h.to(I.definition);let ke;if(I.source&&(I.source.scope!==void 0?typeof I.source.scope=="number"?ke=I.source.scope:ke=await H.resolveWorkspaceFolder(y.URI.revive(I.source.scope)):ke=R.TaskScope.Workspace),!we||!ke)return;const le=new R.$TL(we,ke,I.name,I.source.label,de,I.problemMatchers);return I.isBackground!==void 0&&(le.isBackground=I.isBackground),I.group!==void 0&&(le.group=R.$PL.from(I.group._id),le.group&&I.group.isDefault&&(le.group=new R.$PL(le.group.id,le.group.label),I.group.isDefault===!0&&(le.group.isDefault=I.group.isDefault))),I.presentationOptions&&(le.presentationOptions=t.to(I.presentationOptions)),I._id&&(le._id=I._id),I.detail&&(le.detail=I.detail),le}G.to=P})(v||(e.TaskDTO=v={}));var E;(function(G){function W(P){return P}G.from=W;function z(P){if(P)return Object.assign(Object.create(null),P)}G.to=z})(E||(E={}));class D{#e;constructor(W,z,P){this._id=z,this.a=P,this.#e=W}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(W){}fireDidEndProcess(W){}}let N=class{constructor(W,z,P,I,H,ae,de,we){this.q=new C.$Vd,this.r=new C.$Vd,this.s=new C.$Vd,this.u=new C.$Vd,this.a=W.getProxy(L.$6K.MainThreadTask),this.b=P,this.c=I,this.d=H,this.e=ae,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=de,this.g=we,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(W,z,P){if(!P)return new R.$8K(()=>{});const I=this.x();return this.j.set(I,{type:z,provider:P,extension:W}),this.a.$registerTaskProvider(I,z),new R.$8K(()=>{this.j.delete(I),this.a.$unregisterTaskProvider(I)})}registerTaskSystem(W,z){this.a.$registerTaskSystem(W,z)}fetchTasks(W){return this.a.$fetchTasks(E.from(W)).then(async z=>{const P=[];for(const I of z){const H=await v.to(I,this.b,this.m);H&&P.push(H)}return P})}get taskExecutions(){const W=[];return this.k.forEach(z=>W.push(z)),W}terminateTask(W){if(!(W instanceof D))throw new Error("No valid task execution provided");return this.a.$terminateTask(W._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(W,z,P){const I=this.m.get(W.id);I&&(this.o.set(W.id,I),this.e.attachPtyToTerminal(z,await I.callback(P))),this.p=W.id,this.q.fire({execution:await this.z(W)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(W){if(!this.l.has(W.id))return;const z=await this.z(W);this.l.delete(W.id),this.k.delete(W.id),this.B(W),this.r.fire({execution:z})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(W){const z=await this.z(W.id);this.s.fire({execution:z,processId:W.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(W){const z=await this.z(W.id);this.u.fire({execution:z,exitCode:W.exitCode})}$provideTasks(W,z){const P=this.j.get(W);if(!P)return Promise.reject(new Error("no handler found"));const I=[],H=(0,T.$Yg)(()=>P.provider.provideTasks(A.CancellationToken.None)).then(ae=>this.v(z,I,P,ae));return new Promise(ae=>{H.then(de=>{Promise.all(I).then(()=>{ae(de)})})})}async $resolveTask(W,z){const P=this.j.get(W);if(!P)return Promise.reject(new Error("no handler found"));if(z.definition.type!==P.type)throw new Error(`Unexpected: Task of type [${z.definition.type}] cannot be resolved by provider of type [${P.type}].`);const I=await v.to(z,this.b,this.m);if(!I)throw new Error("Unexpected: Task cannot be resolved.");const H=await P.provider.resolveTask(I,A.CancellationToken.None);if(!H)return;this.A(H,P);const ae=v.from(H,P.extension);if(!ae)throw new Error("Unexpected: Task cannot be resolved.");if(H.definition!==I.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return d.is(ae.execution)&&await this.y(ae,H,!0),await this.w(ae)}x(){return this.h++}async y(W,z,P){const I=await this.a.$createTaskId(W);!P&&!this.m.has(I)&&(this.n.add(I),this.o.set(I,z.execution)),this.m.set(I,z.execution)}async z(W,z){if(typeof W=="string"){const H=this.l.get(W);if(!H)throw new c.$bb("Unexpected: The specified task is missing an execution");return H}const P=this.l.get(W.id);if(P)return P;let I;return z?I=Promise.resolve(new D(this,W.id,z)):I=v.to(W.task,this.b,this.m).then(H=>{if(!H)throw new c.$bb("Unexpected: Task does not exist.");return new D(this,W.id,H)}),this.l.set(W.id,I),I.then(H=>(this.k.set(W.id,H),H))}A(W,z){W._deprecated&&this.g.report("Task.constructor",z.extension,"Use the Task constructor that takes a `scope` instead.")}B(W){this.o.get(W.id)&&this.o.delete(W.id),this.n.has(W.id)&&this.p!==W.id&&(this.m.delete(W.id),this.n.delete(W.id));const P=this.n.values();let I=P.next();for(;!I.done;)!this.o.has(I.value)&&this.p!==I.value&&(this.m.delete(I.value),this.n.delete(I.value)),I=P.next()}};e.$Uhc=N,e.$Uhc=N=Je([Ke(0,l.$0M),Ke(1,p.$nN),Ke(2,$.$qgc),Ke(3,f.$iN),Ke(4,b.$tgc),Ke(5,k.$Rgc),Ke(6,r.$nj),Ke(7,n.$$fc)],N);let O=class extends N{constructor(W,z,P,I,H,ae,de,we){super(W,z,P,I,H,ae,de,we),this.registerTaskSystem(s.Schemas.vscodeRemote,{scheme:s.Schemas.vscodeRemote,authority:"",platform:a.$h(0)})}async executeTask(W,z){if(!z.execution)throw new Error("Tasks to execute must include an execution");const P=v.from(z,W);if(P===void 0)throw new Error("Task is not valid");if(d.is(P.execution))await this.y(P,z,!1);else throw new c.$_;const I=await this.z(await this.a.$getTaskExecution(P),z);return this.a.$executeTask(P).catch(H=>{throw new Error(H)}),I}v(W,z,P,I){const H=[];if(I)for(const ae of I){if(this.A(ae,P),!ae.definition||!W[ae.definition.type]){const we=ae.source?ae.source:"No task source";this.f.warn(`The task [${we}, ${ae.name}] uses an undefined task type. The task will be ignored in the future.`)}const de=v.from(ae,P.extension);de&&d.is(de.execution)?(H.push(de),z.push(this.y(de,ae,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:H,extension:P.extension}}async w(W){if(d.is(W.execution))return W;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(W,z){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(W,z,P){}};e.$Vhc=O,e.$Vhc=O=Je([Ke(0,l.$0M),Ke(1,p.$nN),Ke(2,$.$qgc),Ke(3,f.$iN),Ke(4,b.$tgc),Ke(5,k.$Rgc),Ke(6,r.$nj),Ke(7,n.$$fc)],O),e.$Whc=(0,w.$6h)("IExtHostTask")}),define(Pe[281],Re([1,0,43,29]),function(ge,e,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TJ=e.$SJ=e.$RJ=void 0;function C(R){return"cellResults"in R}e.$RJ=C,e.$SJ="rawCell#";function L(R,$){let f=-1;const b=[];let A=[];return R.forEach(l=>{l.range.startLineNumber!==f&&A.length>0&&(b.push([...A]),A=[]),A.push(l),f=l.range.endLineNumber}),A.length>0&&b.push([...A]),b.map(l=>{const p=[],w=l[0].range.startLineNumber,s=l[l.length-1].range.endLineNumber;for(let a=w;a<=s;a++)p.push($.getLineContent(a));return new y.$vJ(p.join(`
`)+`
`,l.map(a=>new T.$Us(a.range.startLineNumber-1,a.range.startColumn-1,a.range.endLineNumber-1,a.range.endColumn-1)))})}e.$TJ=L}),define(Pe[282],Re([1,0,162,24,5,6,28,11,16,2,41,75,3,32,8,7,49,220,107,26,12,211,281,279]),function(ge,e,y,T,C,L,R,$,f,b,A,k,l,p,w,s,a,r,n,o,c,h,t,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$whc=void 0;class i{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(m=>m.apiEditor)}constructor(m,d,S,M,v,E){this.q=S,this.r=M,this.s=v,this.t=E,this.f=new Map,this.g=new R.$Ac,this.h=new Map,this.j=new C.$Vd,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new C.$Vd,this.onDidOpenNotebookDocument=this.m.event,this.n=new C.$Vd,this.onDidCloseNotebookDocument=this.n.event,this.o=new C.$Vd,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new k.$4fc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=m.getProxy(l.$6K.MainThreadNotebook),this.c=m.getProxy(l.$6K.MainThreadNotebookDocuments),this.d=m.getProxy(l.$6K.MainThreadNotebookEditors),this.i=d.converter,d.registerArgumentProcessor({processArgument:D=>{if(D&&D.$mid===13){const N=D.notebookEditor?.notebookUri,O=D.cell.handle,W=this.g.get(N)?.getCell(O);if(W)return W.apiCell}if(D&&D.$mid===14){const N=D.uri,O=this.g.get(N);if(O)return O.apiNotebook}return D}}),i.B(d)}getEditorById(m){const d=this.h.get(m);if(!d)throw new Error(`unknown text editor: ${m}. known editors: ${[...this.h.keys()]} `);return d}getIdByEditor(m){for(const[d,S]of this.h)if(S.apiEditor===m)return d}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(m,d){const S=this.g.get(m);if(!S&&!d)throw new Error(`NO notebook document for '${m}'`);return S}static u(m,d){if(!d)return;const S=d.filenamePattern.map(M=>w.NotebookExclusiveDocumentPattern.from(M)).filter(M=>M!==void 0);if(d.filenamePattern&&!S){console.warn(`Notebook content provider view options file name pattern is invalid ${d.filenamePattern}`);return}return{extension:m.identifier,providerDisplayName:m.displayName||m.name,displayName:d.displayName,filenamePattern:S,exclusive:d.exclusive||!1}}registerNotebookCellStatusBarItemProvider(m,d,S){const M=i.a++,v=typeof S.onDidChangeCellStatusBarItems=="function"?i.a++:void 0;this.f.set(M,S),this.b.$registerNotebookCellStatusBarItemProvider(M,v,d);let E;return v!==void 0&&(E=S.onDidChangeCellStatusBarItems(D=>this.b.$emitCellStatusBarEvent(v))),new s.$8K(()=>{this.f.delete(M),this.b.$unregisterNotebookCellStatusBarItemProvider(M,v),E?.dispose()})}async createNotebookDocument(m){const d=await this.c.$tryCreateNotebook({viewType:m.viewType,content:m.content&&w.NotebookData.from(m.content)});return b.URI.revive(d)}async openNotebookDocument(m){const d=this.g.get(m);if(d)return d.apiNotebook;const S=await this.c.$tryOpenNotebook(m),M=this.g.get(b.URI.revive(S));return(0,f.$Tf)(M?.apiNotebook)}async showNotebookDocument(m,d){b.URI.isUri(m)&&(m=await this.openNotebookDocument(m));let S;typeof d=="object"?S={position:w.ViewColumn.from(d.viewColumn),preserveFocus:d.preserveFocus,selections:d.selections&&d.selections.map(w.NotebookRange.from),pinned:typeof d.preview=="boolean"?!d.preview:void 0}:S={preserveFocus:!1};const M=await this.d.$tryShowNotebookDocument(m.uri,m.notebookType,S),v=M&&this.h.get(M)?.apiEditor;if(v)return v;throw M?new Error(`Could NOT open editor for "${m.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${m.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(m,d,S,M){const v=this.f.get(m),E=b.URI.revive(d),D=this.g.get(E);if(!D||!v)return;const N=D.getCellFromIndex(S);if(!N)return;const O=await v.provideCellStatusBarItems(N.apiCell,M);if(!O)return;const G=new L.$Sc,W=this.p.add([G]),P=(Array.isArray(O)?O:[O]).map(I=>w.NotebookStatusBarItem.from(I,this.i,G));return{cacheId:W,items:P}}$releaseNotebookCellStatusBarItems(m){this.p.delete(m)}registerNotebookSerializer(m,d,S,M,v){if((0,$.$Je)(d))throw new Error("viewType cannot be empty or just whitespace");const E=this.w++;return this.x.set(E,{viewType:d,serializer:S,options:M}),this.b.$registerNotebookSerializer(E,{id:m.identifier,location:m.extensionLocation},d,w.NotebookDocumentContentOptions.from(M),i.u(m,v)),(0,L.$Rc)(()=>{this.b.$unregisterNotebookSerializer(E)})}async $dataToNotebook(m,d,S){const M=this.x.get(m);if(!M)throw new Error("NO serializer found");const v=await M.serializer.deserializeNotebook(d.buffer,S);return new a.$Tv(w.NotebookData.from(v))}async $notebookToData(m,d,S){const M=this.x.get(m);if(!M)throw new Error("NO serializer found");const v=await M.serializer.serializeNotebook(w.NotebookData.to(d.value),S);return T.$je.wrap(v)}async $saveNotebook(m,d,S,M,v){const E=b.URI.revive(d),D=this.x.get(m);if(!D)throw new Error("NO serializer found");const N=this.g.get(E);if(!N)throw new Error("Document NOT found");if(N.versionId!==S)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(E.scheme))throw new A.$Lk((0,y.localize)(0,null,this.z(E)),6);await this.y(E,M);const O={metadata:(0,o.$Dn)(N.apiNotebook.metadata,I=>!(D.options?.transientDocumentMetadata??{})[I]),cells:[]};for(const I of N.apiNotebook.getCells()){const H=new s.$uM(I.kind,I.document.getText(),I.document.languageId,I.mime,D.options?.transientOutputs?[]:[...I.outputs],I.metadata,I.executionSummary);H.metadata=(0,o.$Dn)(I.metadata,ae=>!(D.options?.transientCellMetadata??{})[ae]),O.cells.push(H)}const G=await D.serializer.serializeNotebook(O,v);await this.s.value.writeFile(E,G);const W=this.s.getFileSystemProviderExtUri(E.scheme),z=await this.s.value.stat(E);return{name:W.basename(E),isFile:(z.type&A.FileType.File)!==0,isDirectory:(z.type&A.FileType.Directory)!==0,isSymbolicLink:(z.type&A.FileType.SymbolicLink)!==0,mtime:z.mtime,ctime:z.ctime,size:z.size,readonly:!!((z.permissions??0)&A.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(E.scheme),locked:!!((z.permissions??0)&A.FilePermission.Locked),etag:A.$Wk({mtime:z.mtime,size:z.size}),children:void 0}}async $searchInNotebooks(m,d,S,M,v){const E=this.x.get(m)?.serializer;if(!E)return{limitHit:!1,results:[]};const D=new R.$Bc;await(async(z,P,I)=>{await Promise.all(z.map(async H=>await Promise.all(H.filenamePatterns.map(ae=>{const de={_reason:I._reason,folderQueries:I.folderQueries,includePattern:I.includePattern,excludePattern:I.excludePattern,maxResults:I.maxResults,type:1,filePattern:ae};return this.t.doInternalFileSearchWithCustomCallback(de,P,we=>{we.forEach(ke=>{D.has(ke)||M.some(ve=>H.isFromSettings&&!ve.isFromSettings?!1:ve.filenamePatterns.some(se=>(0,u.$fdb)(se,ke)))||D.add(ke)})})}))))})(S,v,d);const O=new R.$Ac;let G=!1;const W=Array.from(D).map(async z=>{const P=[];try{if(v.isCancellationRequested)return;if(d.maxResults&&[...O.values()].reduce((de,we)=>de+we.cellResults.length,0)>d.maxResults){G=!0;return}const I=[],H=this.g.get(z);if(H)H.apiNotebook.getCells().forEach(we=>I.push({input:we.document.getText(),outputs:we.outputs.flatMap(ke=>ke.items.map(le=>le.data.toString()))}));else{const de=await this.s.value.readFile(z),we=T.$je.fromString(de.toString()),ke=await E.deserializeNotebook(we.buffer,v);if(v.isCancellationRequested)return;w.NotebookData.from(ke).cells.forEach(ve=>I.push({input:ve.source,outputs:ve.outputs.flatMap(se=>se.items.map(be=>be.valueBytes.toString()))}))}if(v.isCancellationRequested)return;I.forEach((de,we)=>{const ke=d.contentPattern.pattern,le=new h.$KQb(de.input,void 0,de.outputs),ve=le.findInInputs(ke),se=le.findInOutputs(ke),be=se.flatMap(ne=>(0,t.$TJ)(ne.matches,ne.textBuffer)).map((ne,Y)=>(ne.webviewIndex=Y,ne));if(ve.length>0||se.length>0){const ne={index:we,contentResults:(0,t.$TJ)(ve,le.inputTextBuffer),webviewResults:be};P.push(ne)}});const ae={resource:z,cellResults:P};O.set(z,ae);return}catch{return}});return await Promise.all(W),{limitHit:G,results:[...O.values()]}}async y(m,d){const S=await this.s.value.stat(m);if(typeof d?.mtime=="number"&&typeof d.etag=="string"&&d.etag!==A.$Vk&&typeof S.mtime=="number"&&typeof S.size=="number"&&d.mtime<S.mtime&&d.etag!==A.$Wk({mtime:d.mtime,size:S.size}))throw new A.$Lk((0,y.localize)(1,null),3,d)}z(m){return m.scheme===c.Schemas.file?m.fsPath:m.toString()}A(m,d,S){if(this.h.has(d))throw new Error(`editor with id ALREADY EXSIST: ${d}`);const M=new n.$nhc(d,this.d,m,S.visibleRanges.map(w.NotebookRange.to),S.selections.map(w.NotebookRange.to),typeof S.viewColumn=="number"?w.ViewColumn.to(S.viewColumn):void 0);this.h.set(d,M)}$acceptDocumentAndEditorsDelta(m){if(m.value.removedDocuments)for(const S of m.value.removedDocuments){const M=b.URI.revive(S),v=this.g.get(M);v&&(v.dispose(),this.g.delete(M),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:v.apiNotebook.getCells().map(E=>E.document.uri)}),this.n.fire(v.apiNotebook));for(const E of this.h.values())E.notebookData.uri.toString()===M.toString()&&this.h.delete(E.id)}if(m.value.addedDocuments){const S=[];for(const M of m.value.addedDocuments){const v=b.URI.revive(M.uri);if(this.g.has(v))throw new Error(`adding EXISTING notebook ${v} `);const E=new r.$mhc(this.c,this.q,this.r,v,M);S.push(...M.cells.map(D=>r.$lhc.asModelAddData(E.apiNotebook,D))),this.g.get(v)?.dispose(),this.g.set(v,E),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:S}),this.m.fire(E.apiNotebook)}}if(m.value.addedEditors)for(const S of m.value.addedEditors){if(this.h.has(S.id))return;const M=b.URI.revive(S.documentUri),v=this.g.get(M);v&&this.A(v,S.id,S)}const d=[];if(m.value.removedEditors)for(const S of m.value.removedEditors){const M=this.h.get(S);M&&(this.h.delete(S),this.k?.id===M.id&&(this.k=void 0),d.push(M))}if(m.value.visibleEditors){this.l=m.value.visibleEditors.map(M=>this.h.get(M)).filter(M=>!!M);const S=new Set;this.l.forEach(M=>S.add(M.id));for(const M of this.h.values()){const v=S.has(M.id);M._acceptVisibility(v)}this.l=[...this.h.values()].map(M=>M).filter(M=>M.visible),this.o.fire(this.visibleNotebookEditors)}m.value.newActiveEditor===null?this.k=void 0:m.value.newActiveEditor&&(this.h.get(m.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${m.value.newActiveEditor}`),this.k=this.h.get(m.value.newActiveEditor)),m.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(m){const d=p.$vN.String.with("notebookType","A notebook type"),S=new p.$xN("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[d,new p.$vN("data","Bytes to convert to data",v=>v instanceof Uint8Array,v=>T.$je.wrap(v))],new p.$wN("Notebook Data",v=>w.NotebookData.to(v.value))),M=new p.$xN("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[d,new p.$vN("NotebookData","Notebook data to convert to bytes",v=>!0,v=>new a.$Tv(w.NotebookData.from(v)))],new p.$wN("Bytes",v=>v.buffer));m.registerApiCommand(S),m.registerApiCommand(M)}}e.$whc=i}),define(Pe[283],Re([1,0,19,20,40,34,25,60,43]),function(ge,e,y,T,C,L,R,$,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ohc=void 0;class b{constructor(l,p,w){this.k=l,this.l=p,this.o=w,this.e=!1,this.f=0,this.g=!1,this.a=l.filePattern,this.b=l.includePattern&&L.$Mj(l.includePattern),this.c=l.maxResults||void 0,this.d=l.exists,this.h=new Set,this.j=l.excludePattern&&L.$Mj(l.excludePattern)}cancel(){this.g=!0,this.h.forEach(l=>l.cancel()),this.h=new Set}search(l){const p=this.k.folderQueries||[];return new Promise((w,s)=>{const a=r=>{this.f++,l(r)};if(this.g)return w({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(r=>{const n=r.toString(),o=y.$nc(n);this.j&&this.j(n,o)||this.v(a,{base:r,basename:o})}),Promise.all(p.map(r=>this.p(r,a))).then(r=>{w({limitHit:this.e,stats:r[0]||void 0})},r=>{s(new Error((0,C.$Qi)(r)))})})}async p(l,p){const w=new T.$6d,s=this.q(l),a=this.r(),r=new f.$JJ(this.k,l),n=!r.hasSiblingExcludeClauses();let o;try{this.h.add(w),o=$.$Rd.create();const c=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},s,w.token),h=o.elapsed(),t=$.$Rd.create();return this.g&&!this.e||(c&&c.forEach(u=>{const i=y.$gc.relative(l.folder.path,u.path);if(n){const g=y.$nc(u.path);this.v(p,{base:l.folder,relativePath:i,basename:g});return}this.s(a,l.folder,i,p)}),this.g&&!this.e)?null:(this.u(a,r,p),{providerTime:h,postProcessTime:t.elapsed()})}finally{w.dispose(),this.h.delete(w)}}q(l){const p=(0,f.$IJ)(this.k.includePattern,l.includePattern),w=(0,f.$IJ)(this.k.excludePattern,l.excludePattern);return{folder:l.folder,excludes:w,includes:p,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!l.disregardParentIgnoreFiles,followSymlinks:!l.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}s({pathToEntries:l},p,w,s){if(w===this.a){const r=y.$nc(this.a);this.v(s,{base:p,relativePath:this.a,basename:r})}function a(r){const n=y.$nc(r),o=y.$mc(r);let c=l[o];c||(c=l[o]=[],a(o)),c.push({base:p,relativePath:r,basename:n})}a(w)}u({rootEntries:l,pathToEntries:p},w,s){const a=this,r=this.a;function n(o){const c=(0,f.$LJ)(()=>o.map(h=>h.basename));for(let h=0,t=o.length;h<t;h++){const u=o[h],{relativePath:i,basename:g}=u;if(w.matchesExcludesSync(i,g,r!==g?c:void 0))continue;const m=p[i];if(m)n(m);else{if(i===r)continue;a.v(s,u)}if(a.e)break}}n(l)}v(l,p){(!this.b||p.relativePath&&this.b(p.relativePath,p.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||l(p))}}class A{constructor(){this.b=new Map}static{this.a=512}fileSearch(l,p,w,s){const a=this.c(l.cacheKey),r=new b(l,p,a&&a.token);let n=0;const o=c=>{n+=c.length,w(c.map(h=>this.d(h)))};return this.e(r,A.a,o,s).then(c=>({limitHit:c.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:n,detailStats:c.stats}}))}clearCache(l){this.c(l)?.cancel()}c(l){if(l)return this.b.has(l)||this.b.set(l,new T.$6d),this.b.get(l)}d(l){return l.relativePath?{resource:R.$Hg(l.base,l.relativePath)}:{resource:l.base}}e(l,p,w,s){const a=s.onCancellationRequested(()=>{l.cancel()}),r=o=>{o&&(n.push(o),p>0&&n.length>=p&&(w(n),n=[]))};let n=[];return l.search(r).then(o=>(n.length&&w(n),a.dispose(),o),o=>(n.length&&w(n),a.dispose(),Promise.reject(o)))}}e.$ohc=A}),define(Pe[284],Re([1,0,18,245,34,95,28,12,19,25,11,16,2,94,179,46,14,47,105,280,43]),function(ge,e,y,T,C,L,R,$,f,b,A,k,l,p,w,s,a,r,n,o,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KK=e.$JK=void 0;let h=class{constructor(E,D,N,O,G){this.a=E,this.b=D,this.c=N,this.d=O,this.e=G}text(E,D,N={}){E=this.f(E,N);const O=this.a.getValue(),G=D&&D.some(z=>!this.a.getValue({resource:z}).search.useRipgrep);return{...this.h(D?.map(r.$oi),N),type:2,contentPattern:E,previewOptions:N.previewOptions,maxFileSize:N.maxFileSize,usePCRE2:O.search.usePCRE2||G||!1,beforeContext:N.beforeContext,afterContext:N.afterContext,userDisabledExcludesAndIgnoreFiles:N.disregardExcludeSettings&&N.disregardIgnoreFiles}}f(E,D){const N=this.a.getValue();E.isRegExp&&(E.pattern=E.pattern.replace(/\r?\n/g,"\\n"));const O={...E,wordSeparators:N.editor.wordSeparators};return this.j(E,D)&&(O.isCaseSensitive=!0),this.k(E)&&(O.isMultiline=!0),D.notebookSearchConfig?.includeMarkupInput&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookMarkdownInput=D.notebookSearchConfig.includeMarkupInput),D.notebookSearchConfig?.includeMarkupPreview&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookMarkdownPreview=D.notebookSearchConfig.includeMarkupPreview),D.notebookSearchConfig?.includeCodeInput&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookCellInput=D.notebookSearchConfig.includeCodeInput),D.notebookSearchConfig?.includeOutput&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookCellOutput=D.notebookSearchConfig.includeOutput),O}file(E,D={}){return{...this.h(E,D),type:1,filePattern:D.filePattern?D.filePattern.trim():D.filePattern,exists:D.exists,sortByScore:D.sortByScore,cacheKey:D.cacheKey}}g(E,D){return E?(E=Array.isArray(E)?E.map(m):m(E),D?this.parseSearchPaths(E):{pattern:u(...Array.isArray(E)?E:[E])}):{}}h(E=[],D={}){const N=this.g(D.includePattern,D.expandPatterns),O=this.g(D.excludePattern,D.expandPatterns),G=E.length>1,W=(N.searchPaths&&N.searchPaths.length?N.searchPaths.map(I=>this.q(I,D,O)):E.map(I=>this.r(I,D,O,G))).filter(I=>!!I),z={_reason:D._reason,folderQueries:W,usingSearchPaths:!!(N.searchPaths&&N.searchPaths.length),extraFileResources:D.extraFileResources,excludePattern:O.pattern,includePattern:N.pattern,onlyOpenEditors:D.onlyOpenEditors,maxResults:D.maxResults};if(D.onlyOpenEditors){const I=y.$Hb(y.$Rb(this.c.groups.map(de=>de.editors.map(we=>we.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(I));const H=I.filter(de=>(0,c.$zJ)(z,de.fsPath)),ae=this.i(H);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(ae)),{...z,...ae}}const P=D.extraFileResources&&D.extraFileResources.filter(I=>(0,c.$zJ)(z,I.fsPath));return z.extraFileResources=P&&P.length?P:void 0,z}i(E){const D=[],N=new R.$Ac,O={};let G=!1;return E.forEach(W=>{if(W.scheme===$.Schemas.walkThrough)return;if((0,b.$Lg)(W)){const P=this.b.getWorkspaceFolder(W)?.uri??W.with({path:f.$mc(W.fsPath)});let I=N.get(P);I||(G=!0,I={folder:P,includePattern:{}},D.push(I),N.set(P,I));const H=f.$lc(P.fsPath,W.fsPath);(0,k.$Tf)(I.includePattern)[H.replace(/\\/g,"/")]=!0}else W.fsPath&&(G=!0,O[W.fsPath]=!0)}),{folderQueries:D,includePattern:O,usingSearchPaths:!0,excludePattern:G?void 0:{"**/*":!0}}}j(E,D){if(D.isSmartCase){if(E.isRegExp){if(A.$zf(E.pattern,!0))return!0}else if(A.$zf(E.pattern))return!0}return!!E.isCaseSensitive}k(E){return E.isMultiline||E.isRegExp&&(0,p.$4B)(E.pattern)||E.pattern.indexOf(`
`)>=0?!0:!!E.isMultiline}parseSearchPaths(E){const D=ae=>f.$ic(ae)||/^\.\.?([\/\\]|$)/.test(ae),O=(Array.isArray(E)?E:i(E)).map(ae=>{const de=this.e.resolvedUserHome;return de?(0,L.$Yv)(ae,de.scheme===$.Schemas.file?de.fsPath:de.path):ae}),G=T.$K(O,ae=>D(ae)?"searchPaths":"exprSegments"),W=(G.exprSegments||[]).map(ae=>A.$Ue(ae,"/")).map(ae=>A.$Ue(ae,"\\")).map(ae=>(ae[0]==="."&&(ae="*"+ae),g(ae))),z={},P=this.m(G.searchPaths||[]);P&&P.length&&(z.searchPaths=P);const I=y.$Rb(W),H=u(...I);return H&&(z.pattern=H),z}l(E,D){return D.disregardExcludeSettings?void 0:(0,c.$yJ)(E,!D.disregardSearchExcludeSettings)}m(E){if(!E||!E.length)return[];const D=E.flatMap(O=>{let{pathPortion:G,globPortion:W}=t(O);return W&&(W=d(W)),this.n(G).flatMap(P=>this.o(P,W))}),N=new Map;return D.forEach(O=>{const G=O.searchPath.toString(),W=N.get(G);W?O.pattern&&(W.pattern=W.pattern||{},W.pattern[O.pattern]=!0):N.set(G,{searchPath:O.searchPath,pattern:O.pattern?u(O.pattern):void 0})}),Array.from(N.values())}n(E){if(f.$ic(E)){const D=this.b.getWorkspace().folders;return D[0]&&D[0].uri.scheme!==$.Schemas.file?[{searchPath:D[0].uri.with({path:E})}]:[{searchPath:l.URI.file(f.$hc(E))}]}if(this.b.getWorkbenchState()===2){const D=this.b.getWorkspace().folders[0].uri;if(E=m(E),E.startsWith("../")||E===".."){const O=f.$gc.resolve(D.path,E);return[{searchPath:D.with({path:O})}]}const N=d(E);return[{searchPath:D,pattern:N}]}else{if(E==="./"||E===".\\")return[];{const D=E.replace(/^\.[\/\\]/,""),O=this.b.getWorkspace().folders.map(G=>{const W=D.match(new RegExp(`^${A.$Oe(G.name)}(?:/(.*)|$)`));return W?{match:W,folder:G}:null}).filter(k.$Qf);if(O.length)return O.map(G=>{const W=G.match[1];return{searchPath:G.folder.uri,pattern:W&&d(W)}});{const G=E.match(/\.[\/\\](.+)[\/\\]?/),W=G?G[1]:E,z=w.localize(0,null,W);throw new Error(z)}}}}o(E,D){const N=E.pattern&&D?`${E.pattern}/${D}`:E.pattern||D,O=[{searchPath:E.searchPath,pattern:N}];return N&&!N.endsWith("**")&&O.push({searchPath:E.searchPath,pattern:N+"/**"}),O}q(E,D,N){const O=this.r((0,r.$oi)(E.searchPath),D,N,!1);return O?{...O,includePattern:E.pattern}:null}r(E,D,N,O){let G;const W=l.URI.isUri(E)?E:E.uri;if(N.searchPaths){const ae=N.searchPaths.filter(de=>(0,b.$Ag)(de.searchPath,W))[0];if(ae&&!ae.pattern)return null;ae&&(G=ae.pattern)}const z=this.a.getValue({resource:W}),I={...this.l(z,D)||{},...G||{}},H=l.URI.isUri(E)?(0,b.$Eg)(E):E.name;return{folder:W,folderName:O?H:void 0,excludePattern:Object.keys(I).length>0?I:void 0,fileEncoding:z.files&&z.files.encoding,disregardIgnoreFiles:typeof D.disregardIgnoreFiles=="boolean"?D.disregardIgnoreFiles:!z.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof D.disregardGlobalIgnoreFiles=="boolean"?D.disregardGlobalIgnoreFiles:!z.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof D.disregardParentIgnoreFiles=="boolean"?D.disregardParentIgnoreFiles:!z.search.useParentIgnoreFiles,ignoreSymlinks:typeof D.ignoreSymlinks=="boolean"?D.ignoreSymlinks:!z.search.followSymlinks}}};e.$JK=h,e.$JK=h=Je([Ke(0,s.$zi),Ke(1,r.$ci),Ke(2,n.$9C),Ke(3,a.$nj),Ke(4,o.$HK)],h);function t(v){const E=v.match(/[\*\{\}\(\)\[\]\?]/);if(E){const D=E.index,N=v.substr(0,D).match(/[/|\\][^/\\]*$/);if(N){let O=v.substr(0,N.index);return O.match(/[/\\]/)||(O+="/"),{pathPortion:O,globPortion:v.substr((N.index||0)+1)}}}return{pathPortion:v}}function u(...v){return v.length?v.reduce((E,D)=>(E[D]=!0,E),Object.create(null)):void 0}function i(v){return C.$Kj(v,",").map(E=>E.trim()).filter(E=>!!E.length)}function g(v){return[`**/${v}/**`,`**/${v}`].map(D=>D.replace(/\*\*\/\*\*/g,"**"))}function m(v){return v.replace(/\\/g,"/")}function d(v){return m(v).replace(/^\.\//,"").replace(/\/+$/g,"")}function S(v){return v.replace(/([?*[\]])/g,"[$1]")}function M(v,E){v=y.$Mb(v,O=>O.toString());const D=[],N=E.getWorkspace();return v&&v.forEach(O=>{let G;if(E.getWorkbenchState()===2)G=(0,b.$Jg)(N.folders[0].uri,O),G&&G!=="."&&(G="./"+G);else{const W=E.getWorkspaceFolder(O);if(W){const z=W.name;if(N.folders.filter(I=>I.name===z).length===1){const I=(0,b.$Jg)(W.uri,O);I===""?G=`./${W.name}`:G=`./${W.name}/${I}`}else G=O.fsPath}}G&&D.push(S(G))}),D}e.$KK=M}),define(Pe[285],Re([1,0,25,2,20,15,4,284,43,47]),function(ge,e,y,T,C,L,R,$,f,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rsb=e.$qsb=void 0;const A=7e3;function k(s,a){const r=a.activationEvents;if(!r)return Promise.resolve(void 0);const n=[],o=[];for(const g of r)if(/^workspaceContains:/.test(g)){const m=g.substr(18);m.indexOf("*")>=0||m.indexOf("?")>=0||s.forceUsingSearch?o.push(m):n.push(m)}if(n.length===0&&o.length===0)return Promise.resolve(void 0);let c;const h=new Promise((g,m)=>{c=g}),t=g=>c({activationEvent:g}),u=Promise.all(n.map(g=>l(s,g,t))).then(()=>{}),i=p(s,a.identifier,o,t);return Promise.all([u,i]).then(()=>{c(void 0)}),h}e.$qsb=k;async function l(s,a,r){for(const n of s.folders)if(await s.exists(y.$Hg(T.URI.revive(n),a))){r(`workspaceContains:${a}`);return}}async function p(s,a,r,n){if(r.length===0)return Promise.resolve(void 0);const o=new C.$6d,c=s.checkExists(s.folders,r,o.token),h=setTimeout(async()=>{o.cancel(),s.logService.info(`Not activating extension '${a.value}': Timed out while searching for 'workspaceContains' pattern ${r.join(",")}`)},A);let t=!1;try{t=await c}catch(u){L.$4(u)||L.$1(u)}o.dispose(),clearTimeout(h),t&&n(`workspaceContains:${r.join(",")}`)}function w(s,a,r,n){const o=s.get(R.$5h),c=s.get(f.$qJ),t=o.createInstance($.$JK).file(a.map(u=>(0,b.$oi)(T.URI.revive(u))),{_reason:"checkExists",includePattern:r,exists:!0});return c.fileSearch(t,n).then(u=>!!u.limitHit,u=>L.$4(u)?!1:Promise.reject(u))}e.$rsb=w}),define(Pe[38],Re([1,0,159,19,88,25,13,6,50,2,14,3,37,217,85,36,23,106,15,22,24,200,7,100,4,27,86,17,71,87,64,5,285,84,202,12,82,60,21,83]),function(ge,e,y,T,C,L,R,$,f,b,A,k,l,p,w,s,a,r,n,o,c,h,t,u,i,g,m,d,S,M,v,E,D,N,O,G,W,z,P,I){"use strict";var H;Object.defineProperty(e,"__esModule",{value:!0}),e.$7gc=e.$6gc=e.$5gc=e.$4gc=e.$3gc=void 0,e.$3gc=(0,i.$6h)("IHostUtils");let ae=H=class extends $.$Tc{constructor(Y,V,ie,Ie,Le,Ce,ce,te,Q,ee,me,pe){super(),this.X=pe,this.a=this.B(new E.$Vd),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=V,this.g=ie,this.f=ce,this.j=Ie,this.m=Le,this.s=Ce,this.t=Q,this.u=ee,this.w=me,this.y=this.g.getProxy(k.$6K.MainThreadWorkspace),this.z=this.g.getProxy(k.$6K.MainThreadTelemetry),this.C=this.g.getProxy(k.$6K.MainThreadExtensionService),this.D=new R.$5g,this.F=new R.$5g,this.G=new R.$5g,this.H=new R.$5g,this.I=new be(this.f.extensions.activationEvents),this.L=new r.$h8b(this.I,this.f.extensions.allExtensions);const Ae=new o.$mm(this.f.extensions.myExtensions);this.J=new r.$h8b(this.I,ve(this.L,Ae)),P.$t&&(this.s.info(`Creating extension host with the following global extensions: ${ke(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${ke(this.J)}`)),this.M=new w.$Ngc(this.g,this.s),this.N=new N.$Vgc(this.g),this.O=te,this.h=Y.createChild(new S.$4h([w.$Ogc,this.M],[N.$Wgc,this.N])),this.P=this.B(new p.$Mgc(this.J,this.L,{onExtensionActivationError:(he,ye,F)=>{this.C.$onExtensionActivationError(he,n.$3(ye),F)},actualActivateExtension:async(he,ye)=>{if(r.$h8b.isHostExtension(he,this.J,this.L))return await this.C.$activateExtension(he,ye),new p.$Lgc;const F=this.J.getExtensionDescription(he);return this.db(F,ye)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),C.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(Y){n.$1(Y)}}async Y(){this.O.onWillDeactivateAll();let Y=[];try{Y=this.J.getAllExtensionDescriptions().map(Le=>Le.identifier).filter(Le=>this.isActivated(Le)).map(Le=>this.cb(Le))}catch{}await Promise.all(Y)}terminate(Y,V=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${Y}`),this.s.flush(),this.u.dispose(),this.P.dispose(),n.setUnexpectedErrorHandler(Ie=>{this.s.error(Ie)}),this.g.dispose();const ie=this.Y();Promise.race([(0,R.$7g)(5e3),ie]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${V}`):this.s.info(`Extension host exiting with code ${V}`),this.s.flush(),this.s.dispose(),this.c.exit(V)})}isActivated(Y){return this.G.isOpen()?this.P.isActivated(Y):!1}async getExtension(Y){const V=await this.C.$getExtension(Y);return V&&{...V,identifier:new o.$lm(V.identifier.value),extensionLocation:b.URI.revive(V.extensionLocation)}}Z(Y,V){return this.P.activateByEvent(Y,V)}$(Y,V){return this.P.activateById(Y,V)}activateByIdWithErrors(Y,V){return this.$(Y,V).then(()=>{const ie=this.P.getActivatedExtension(Y);if(ie.activationFailed)return Promise.reject(ie.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(Y=>this.J)}getExtensionExports(Y){if(this.G.isOpen())return this.P.getActivatedExtension(Y).exports;try{return this.P.getActivatedExtension(Y).exports}catch{return null}}async ab(Y){if(Y.scheme===G.Schemas.file&&this.c.fsRealpath){const V=await this.c.fsRealpath(Y.fsPath);return b.URI.file(V)}return Y}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(Y=>new se(Y))),this.Q}async bb(Y){const V=f.$_h.forUris(ie=>L.$yg.ignorePathCasing(ie));return await Promise.all(Y.map(async ie=>{if(this.ub(ie)){const Ie=await this.ab(ie.extensionLocation);V.set(Ie,ie)}})),V}cb(Y){let V=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(Y))return V;const ie=this.P.getActivatedExtension(Y);if(!ie)return V;try{typeof ie.module.deactivate=="function"&&(V=Promise.resolve(ie.module.deactivate()).then(void 0,Ie=>(this.s.error(Ie),Promise.resolve(void 0))))}catch(Ie){this.s.error(`An error occurred when deactivating the extension '${Y.value}':`),this.s.error(Ie)}try{(0,$.$Oc)(ie.subscriptions)}catch(Ie){this.s.error(`An error occurred when deactivating the subscriptions for extension '${Y.value}':`),this.s.error(Ie)}return V}async db(Y,V){return this.f.remote.isRemote?this.C.$onWillActivateExtension(Y.identifier):await this.C.$onWillActivateExtension(Y.identifier),this.fb(Y,V).then(ie=>{const Ie=ie.activationTimes;return this.C.$onDidActivateExtension(Y.identifier,Ie.codeLoadingTime,Ie.activateCallTime,Ie.activateResolvedTime,V),this.eb(Y,V,"success",Ie),ie},ie=>{throw this.eb(Y,V,"failure"),ie})}eb(Y,V,ie,Ie){const Le=we(Y,V);this.z.$publicLog2("extensionActivationTimes",{...Le,...Ie||{},outcome:ie})}fb(Y,V){const ie=we(Y,V);this.z.$publicLog2("activatePlugin",ie);const Ie=this.ub(Y);if(!Ie)return Promise.resolve(new p.$Kgc(p.$Hgc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${Y.identifier.value}, startup: ${V.startup}, activationEvent: '${V.activationEvent}'${Y.identifier.value!==V.extensionId.value?`, root cause: ${V.extensionId.value}`:""}`),this.s.flush();const Le=new p.$Igc(V.startup);return Promise.all([this.vb(Y,(0,L.$Hg)(Y.extensionLocation,Ie),Le),this.gb(Y)]).then(Ce=>(C.mark(`code/extHost/willActivateExtension/${Y.identifier.value}`),H.hb(this.s,Y.identifier,Ce[0],Ce[1],Le))).then(Ce=>(C.mark(`code/extHost/didActivateExtension/${Y.identifier.value}`),Ce))}gb(Y){const V=new h.$Qgc(Y,this.M),ie=new h.$Pgc(Y.identifier.value,!1,this.M),Ie=new O.$Xgc(Y,this.N),Le=Y.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,Ce=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${Y.identifier.value}`),Promise.all([V.whenReady,ie.whenReady,this.O.whenReady]).then(()=>{const ce=this;let te,Q;const ee=(0,a.$BF)(Y,"ipc")?this.f.messagePorts?.get(o.$lm.toKey(Y.identifier)):void 0;return Object.freeze({globalState:V,workspaceState:ie,secrets:Ie,subscriptions:[],get extensionUri(){return Y.extensionLocation},get extensionPath(){return Y.extensionLocation.fsPath},asAbsolutePath(me){return T.$jc(Y.extensionLocation.fsPath,me)},get storagePath(){return ce.O.workspaceValue(Y)?.fsPath},get globalStoragePath(){return ce.O.globalValue(Y).fsPath},get logPath(){return T.$jc(ce.f.logsLocation.fsPath,Y.identifier.value)},get logUri(){return b.URI.joinPath(ce.f.logsLocation,Y.identifier.value)},get storageUri(){return ce.O.workspaceValue(Y)},get globalStorageUri(){return ce.O.globalValue(Y)},get extensionMode(){return Le},get extension(){return te===void 0&&(te=new le(ce,Y.identifier,Y,Ce,!1)),te},get extensionRuntime(){return(0,a.$CF)(Y,"extensionRuntime"),ce.extensionRuntime},get environmentVariableCollection(){return ce.u.getEnvironmentVariableCollection(Y)},get messagePassingProtocol(){if(!Q){if(!ee)return;const me=E.Event.buffer(E.Event.fromDOMEventEmitter(ee,"message",pe=>pe.data));ee.start(),Q={onDidReceiveMessage:me,postMessage:ee.postMessage.bind(ee)}}return Q}})})}static hb(Y,V,ie,Ie,Le){return ie=ie||{activate:void 0,deactivate:void 0},this.ib(Y,V,ie,Ie,Le).then(Ce=>new p.$Jgc(!1,null,Le.build(),ie,Ce,Ie.subscriptions))}static ib(Y,V,ie,Ie,Le){if(typeof ie.activate=="function")try{Le.activateCallStart(),Y.trace(`ExtensionService#_callActivateOptional ${V.value}`);const Ce=typeof global=="object"?global:self,ce=ie.activate.apply(Ce,[Ie]);return Le.activateCallStop(),Le.activateResolveStart(),Promise.resolve(ce).then(te=>(Le.activateResolveStop(),te))}catch(Ce){return Promise.reject(Ce)}else return Promise.resolve(ie)}jb(Y,V){this.$(Y.identifier,{startup:!1,extensionId:Y.identifier,activationEvent:V}).then(void 0,ie=>{this.s.error(ie)})}kb(Y,V=0){const Ie=Date.now();(0,P.$B)(()=>{for(let Le=V;Le<Y.length;Le+=1){const Ce=Y[Le];for(const ce of Ce.activationEvents??[])if(ce==="onStartupFinished")if(Date.now()-Ie>50){this.kb(Y,Le);break}else this.jb(Ce,ce)}})}lb(){this.C.$setPerformanceMarks(C.getMarks()),this.m.getConfigProvider().then(Y=>{const V=Y.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ie=this.J.getAllExtensionDescriptions();if(V)this.kb(ie);else for(const Ie of ie)if(Ie.activationEvents)for(const Le of Ie.activationEvents)Le==="onStartupFinished"&&this.jb(Ie,Le)})}mb(){const Y=this.Z("*",!0).then(void 0,Ce=>{this.s.error(Ce)});this.B(this.j.onDidChangeWorkspace(Ce=>this.nb(Ce.added)));const V=this.j.workspace?this.j.workspace.folders:[],ie=this.nb(V),Ie=this.pb(),Le=Promise.all([Ie,Y,ie]).then(()=>{});return Promise.race([Le,(0,R.$7g)(1e4)]).then(()=>{this.lb()}),Le}nb(Y){return Y.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(V=>this.ob(Y,V))).then(()=>{})}async ob(Y,V){if(this.isActivated(V.identifier))return;const ie=!this.f.remote.isRemote&&!!this.f.remote.authority,Ie={logService:this.s,folders:Y.map(Ce=>Ce.uri),forceUsingSearch:ie||!this.c.fsExists,exists:Ce=>this.c.fsExists(Ce.fsPath),checkExists:(Ce,ce,te)=>this.y.$checkExists(Ce,ce,te)},Le=await(0,D.$qsb)(Ie,V);if(Le)return this.$(V.identifier,{startup:!0,extensionId:V.identifier,activationEvent:Le.activationEvent}).then(void 0,Ce=>this.s.error(Ce))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(Y){throw console.error(Y),Y}}async qb(){const{extensionDevelopmentLocationURI:Y,extensionTestsLocationURI:V}=this.f.environment;if(!Y||!V)throw new Error(y.localize(0,null));const ie=await this.vb(null,V,new p.$Igc(!1));if(!ie||typeof ie.run!="function")throw new Error(y.localize(1,null,V.toString()));return new Promise((Ie,Le)=>{const Ce=(Q,ee)=>{Q?(P.$t&&this.s.error("Test runner called back with error",Q),Le(Q)):(P.$t&&(ee?this.s.info(`Test runner called back with ${ee} failures.`):this.s.info("Test runner called back with successful outcome.")),Ie(typeof ee=="number"&&ee>0?1:0))},ce=(0,L.$vg)(V),te=ie.run(ce,Ce);te&&te.then&&te.then(()=>{P.$t&&this.s.info("Test runner finished successfully."),Ie(0)}).catch(Q=>{P.$t&&this.s.error("Test runner finished with error",Q),Le(Q instanceof Error&&Q.stack?Q.stack:String(Q))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,R.$7g)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(Y,V){return this.R[Y]=V,(0,$.$Rc)(()=>{delete this.R[Y]})}async getRemoteExecServer(Y){const{resolver:V}=await this.sb(Y);return V?.resolveExecServer?.(Y,{resolveAttempt:0})}async sb(Y){const V=Y.indexOf("+");if(V===-1)throw new t.$bL("Not an authority that can be resolved!",u.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ie=Y.substr(0,V);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${ie}`,!1),{authorityPrefix:ie,resolver:this.R[ie]}}async $resolveAuthority(Y,V){const ie=z.$Rd.create(!1),Ie=()=>`[resolveAuthority(${(0,u.$_k)(Y)},${V})][${ie.elapsed()}ms] `,Le=K=>this.s.info(`${Ie()}${K}`),Ce=K=>this.s.warn(`${Ie()}${K}`),ce=(K,U=void 0)=>this.s.error(`${Ie()}${K}`,U),te=K=>{if(K instanceof t.$bL)return{type:"error",error:{code:K._code,message:K._message,detail:K._detail}};throw K},Q=async K=>{Le(`activating resolver for ${K}...`);const{resolver:U,authorityPrefix:X}=await this.sb(K);if(!U)throw ce(`no resolver for ${X}`),new t.$bL(`No remote extension installed to resolve ${X}.`,u.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:U,authorityPrefix:X,remoteAuthority:K}},ee=Y.split(/@|%40/g).reverse();Le(`activating remote resolvers ${ee.join(" -> ")}`);let me;try{me=await Promise.all(ee.map(Q)).catch(async K=>{if(!(K instanceof t.$bL)||K._code!==u.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw K;return Ce(`resolving nested authorities failed: ${K.message}`),[await Q(Y)]})}catch(K){return te(K)}const pe=new R.$eh;pe.cancelAndSet(()=>Le("waiting..."),1e3);let Ae,he;for(const[K,{authorityPrefix:U,resolver:X,remoteAuthority:x}]of me.entries())try{if(K===me.length-1)Le("invoking final resolve()..."),C.mark(`code/extHost/willResolveAuthority/${U}`),Ae=await X.resolve(x,{resolveAttempt:V,execServer:he}),C.mark(`code/extHost/didResolveAuthorityOK/${U}`),Le("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(X,t.$aL.isManagedResolvedAuthority(Ae)?Ae:void 0));else{if(Le(`invoking resolveExecServer() for ${x}`),C.mark(`code/extHost/willResolveExecServer/${U}`),he=await X.resolveExecServer?.(x,{resolveAttempt:V,execServer:he}),!he)throw new t.$bL(`Exec server was not available for ${x}`,u.RemoteAuthorityResolverErrorCode.NoResolverFound);C.mark(`code/extHost/didResolveExecServerOK/${U}`)}}catch(Ee){return C.mark(`code/extHost/didResolveAuthorityError/${U}`),ce("returned an error",Ee),pe.dispose(),te(Ee)}pe.dispose();const ye={environmentTunnels:Ae.environmentTunnels,features:Ae.tunnelFeatures?{elevation:Ae.tunnelFeatures.elevation,privacyOptions:Ae.tunnelFeatures.privacyOptions,protocol:Ae.tunnelFeatures.protocol===void 0?!0:Ae.tunnelFeatures.protocol}:void 0},F={extensionHostEnv:Ae.extensionHostEnv,isTrusted:Ae.isTrusted,authenticationSession:Ae.authenticationSessionForInitializingExtensions?{id:Ae.authenticationSessionForInitializingExtensions.id,providerId:Ae.authenticationSessionForInitializingExtensions.providerId}:void 0};Le(`returned ${t.$aL.isManagedResolvedAuthority(Ae)?"managed authority":`${Ae.host}:${Ae.port}`}`);let q;if(t.$aL.isManagedResolvedAuthority(Ae)){const K=V;this.X.setFactory(K,Ae.makeConnection),q={authority:Y,connectTo:new u.$9k(K),connectionToken:Ae.connectionToken}}else q={authority:Y,connectTo:new u.$0k(Ae.host,Ae.port),connectionToken:Ae.connectionToken};return{type:"ok",value:{authority:q,options:F,tunnelInformation:ye}}}async $getCanonicalURI(Y,V){this.s.info(`$getCanonicalURI invoked for authority (${(0,u.$_k)(Y)})`);const{resolver:ie}=await this.sb(Y);if(!ie)return null;const Ie=b.URI.revive(V);if(typeof ie.getCanonicalURI>"u")return Ie;const Le=await(0,R.$Yg)(()=>ie.getCanonicalURI(Ie));return Le||Ie}$startExtensionHost(Y){Y.toAdd.forEach(Ie=>Ie.extensionLocation=b.URI.revive(Ie.extensionLocation));const{globalRegistry:V,myExtensions:ie}=de(this.I,this.L,this.J,Y);return this.L.set(V.getAllExtensionDescriptions()),this.J.set(ie),P.$t&&(this.s.info(`$startExtensionHost: global extensions: ${ke(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${ke(this.J)}`)),this.rb()}$activateByEvent(Y,V){return V===1?this.D.wait().then(ie=>this.Z(Y,!1)):this.G.wait().then(ie=>this.Z(Y,!1))}async $activate(Y,V){return await this.G.wait(),this.J.getExtensionDescription(Y)?(await this.$(Y,V),!0):!1}async $deltaExtensions(Y){Y.toAdd.forEach(Ce=>Ce.extensionLocation=b.URI.revive(Ce.extensionLocation));const{globalRegistry:V,myExtensions:ie}=de(this.I,this.L,this.J,Y),Ie=await this.bb(ie);return(await this.getExtensionPathIndex()).setSearchTree(Ie),this.L.set(V.getAllExtensionDescriptions()),this.J.set(ie),P.$t&&(this.s.info(`$deltaExtensions: global extensions: ${ke(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${ke(this.J)}`)),Promise.resolve(void 0)}async $test_latency(Y){return Y}async $test_up(Y){return Y.byteLength}async $test_down(Y){const V=c.$je.alloc(Y),ie=Math.random()%256;for(let Ie=0;Ie<Y;Ie++)V.writeUInt8(ie,Ie);return V}async $updateRemoteConnectionData(Y){this.W=Y,this.a.fire()}};e.$4gc=ae,e.$4gc=ae=H=Je([Ke(0,i.$5h),Ke(1,e.$3gc),Ke(2,d.$0M),Ke(3,s.$qgc),Ke(4,l.$tgc),Ke(5,A.$nj),Ke(6,g.$nN),Ke(7,m.$wgc),Ke(8,M.$oyb),Ke(9,v.$Rgc),Ke(10,W.$Zgc),Ke(11,I.$1gc)],ae);function de(ne,Y,V,ie){ne.addActivationEvents(ie.addActivationEvents);const Ie=new r.$h8b(ne,Y.getAllExtensionDescriptions());Ie.deltaExtensions(ie.toAdd,ie.toRemove);const Le=new o.$mm(V.getAllExtensionDescriptions().map(ce=>ce.identifier));for(const ce of ie.myToRemove)Le.delete(ce);for(const ce of ie.myToAdd)Le.add(ce);const Ce=ve(Ie,Le);return{globalRegistry:Ie,myExtensions:Ce}}function we(ne,Y){return{id:ne.identifier.value,name:ne.name,extensionVersion:ne.version,publisherDisplayName:ne.publisher,activationEvents:ne.activationEvents?ne.activationEvents.join(","):null,isBuiltin:ne.isBuiltin,reason:Y.activationEvent,reasonId:Y.extensionId.value}}function ke(ne){return ne.getAllExtensionDescriptions().map(Y=>Y.identifier.value).join(",")}e.$5gc=(0,i.$6h)("IExtHostExtensionService");class le{#e;#t;#i;constructor(Y,V,ie,Ie,Le){this.#e=Y,this.#t=V,this.#i=ie.identifier,this.id=ie.identifier.value,this.extensionUri=ie.extensionLocation,this.extensionPath=T.$hc((0,L.$vg)(ie.extensionLocation)),this.packageJSON=ie,this.extensionKind=Ie,this.isFromDifferentExtensionHost=Le}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$6gc=le;function ve(ne,Y){return ne.getAllExtensionDescriptions().filter(V=>Y.has(V.identifier))}class se{constructor(Y){this.a=Y}setSearchTree(Y){this.a=Y}findSubstr(Y){return this.a.findSubstr(Y)}forEach(Y){return this.a.forEach(Y)}}e.$7gc=se;class be{constructor(Y){this.a=new o.$nm,this.addActivationEvents(Y)}readActivationEvents(Y){return this.a.get(Y.identifier)??[]}addActivationEvents(Y){for(const V of Object.keys(Y))this.a.set(V,Y[V])}}}),define(Pe[286],Re([1,0,88,2,3,37,23,22,17,27,4,38,14,11]),function(ge,e,y,T,C,L,R,$,f,b,A,k,l,p){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.$cic=void 0;let s=class{constructor(c,h,t,u,i,g,m){this.c=c,this.d=h,this.e=t,this.f=u,this.g=i,this.h=g,this.i=m,this.a=new Map,this.b=[]}async install(){this.j(),y.mark("code/extHost/willWaitForConfig");const c=await this.f.getConfigProvider();y.mark("code/extHost/didWaitForConfig");const h=await this.g.getExtensionPathIndex();this.register(new r(this.c,h,this.d,c,this.i)),this.register(this.e.createInstance(a)),this.h.remote.isRemote&&this.register(this.e.createInstance(n,h,this.h.environment.appUriScheme))}register(c){if("nodeModuleName"in c)if(Array.isArray(c.nodeModuleName))for(const h of c.nodeModuleName)this.a.set(h,c);else this.a.set(c.nodeModuleName,c);typeof c.alternativeModuleName=="function"&&this.b.push(h=>c.alternativeModuleName(h))}};e.$cic=s,e.$cic=s=Je([Ke(2,A.$5h),Ke(3,L.$tgc),Ke(4,k.$5gc),Ke(5,b.$nN),Ke(6,l.$nj)],s);let a=class{static{w=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(c){if(c.environment.appRoot&&w.a.size){const h=(0,p.$Oe)(this.c(c.environment.appRoot.fsPath)),t="[a-z0-9_.-]",u=`@${t}+\\/${t}+|${t}+`,i="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${h}/${i}\\/)(${u})(.*)$`,"i")}}alternativeModuleName(c){if(!this.b)return;const h=this.b.exec(this.c(c));if(!h)return;const[,t,u,i]=h,g=w.a.get(u);if(g!==void 0)return console.warn(`${u} as been renamed to ${g}, please update your imports`),t+g+i}c(c){return c.replace(/\\/g,"/")}};a=w=Je([Ke(0,b.$nN)],a);class r{constructor(c,h,t,u,i){this.c=c,this.d=h,this.e=t,this.f=u,this.g=i,this.nodeModuleName="vscode",this.a=new $.$nm}load(c,h){const t=this.d.findSubstr(h);if(t){let u=this.a.get(t.identifier);return u||(u=this.c(t,this.e,this.f),this.a.set(t.identifier,u)),u}if(!this.b){let u="";this.d.forEach((i,g)=>u+=`	${g} -> ${i.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${h}. These are the extension path mappings: 
${u}`),this.b=this.c(R.$wF,this.e,this.f)}return this.b}}let n=class{constructor(c,h,t){this.e=c,this.f=h,this.nodeModuleName=["open","opn"],this.d=t.getProxy(C.$6K.MainThreadTelemetry);const u=t.getProxy(C.$6K.MainThreadWindow);this.c=(i,g)=>{const m=T.URI.parse(i);return g?this.g(i,g):m.scheme==="http"||m.scheme==="https"?u.$openUri(m,i,{allowTunneling:!0}):m.scheme==="mailto"||m.scheme===this.f?u.$openUri(m,i,{}):this.g(i,g)}}load(c,h,t){const u=this.e.findSubstr(h);return u&&(this.a=u.identifier.value,this.h()),this.b=t(c),this.c}g(c,h){return this.i(),this.b(c,h)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};n=Je([Ke(2,f.$0M)],n)}),define(Pe[116],Re([1,0,39,6,19,74,4,61,62,38,7,36,214,37]),function(ge,e,y,T,C,L,R,$,f,b,A,k,l,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9gc=e.$8gc=void 0,e.$8gc=(0,R.$6h)("IExtHostVariableResolverProvider");class w extends l.$$N{constructor(r,n,o,c,h,t,u){function i(){if(o){const g=o.activeEditor();if(g)return g.document.uri;const m=c.tabGroups.all.find(d=>d.isActive)?.activeTab;if(m!==void 0){if(m.input instanceof A.$OM||m.input instanceof A.$TM)return m.input.modified;if(m.input instanceof A.$NM||m.input instanceof A.$SM||m.input instanceof A.$QM)return m.input.uri}}}super({getFolderUri:g=>{const m=t.folders.filter(d=>d.name===g);if(m&&m.length>0)return m[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(g,m)=>h.getConfiguration(void 0,g).get(m),getAppRoot:()=>L.cwd(),getExecPath:()=>L.env.VSCODE_EXEC_PATH,getFilePath:()=>{const g=i();if(g)return C.$hc(g.fsPath)},getWorkspaceFolderPathForFile:()=>{if(n){const g=i();if(g){const m=n.getWorkspaceFolder(g);if(m)return C.$hc(m.uri.fsPath)}}},getSelectedText:()=>{if(o){const g=o.activeEditor();if(g&&!g.selection.isEmpty)return g.document.getText(g.selection)}},getLineNumber:()=>{if(o){const g=o.activeEditor();if(g)return String(g.selection.end.line+1)}},getExtension:g=>r.getExtension(g)},void 0,u?Promise.resolve(u):void 0,Promise.resolve(L.env))}}let s=class extends T.$Tc{constructor(r,n,o,c,h){super(),this.b=r,this.c=n,this.g=o,this.h=c,this.j=h,this.a=new y.$V(async()=>{const t=await this.h.getConfigProvider(),i={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async g=>{i.folders=await this.c.getWorkspaceFolders2()||[]})),new w(this.b,this.c,this.g,this.j,t,i,this.m())})}getResolver(){return this.a.value}m(){}};e.$9gc=s,e.$9gc=s=Je([Ke(0,b.$5gc),Ke(1,k.$qgc),Ke(2,$.$iN),Ke(3,p.$tgc),Ke(4,f.$Fgc)],s)}),define(Pe[117],Re([1,0,13,5,2,4,3,62,38,17,7,36,206,208,37,116]),function(ge,e,y,T,C,L,R,$,f,b,A,k,l,p,w,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bhc=e.$ahc=e.$_gc=e.$$gc=e.$0gc=void 0,e.$0gc=(0,L.$6h)("IExtHostDebugService");let a=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(u,i,g,m,d,S){this.E=i,this.F=g,this.G=m,this.H=d,this.I=S,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new T.$Vd,this.n=new T.$Vd,this.o=new T.$Vd,this.u=new T.$Vd,this.k=u.getProxy(R.$6K.MainThreadDebugService),this.y=new T.$Vd,this.A=new T.$Vd,this.v=new n(this.k),this.w=new Map,this.F.getExtensionRegistry().then(M=>{M.onDidChange(v=>{this.J(M)}),this.J(M)})}asDebugSourceUri(u,i){const g=u;if(typeof g.sourceReference=="number"&&g.sourceReference>0){let m=`debug:${encodeURIComponent(g.path||"")}`,d="?";return i&&(m+=`${d}session=${encodeURIComponent(i.id)}`,d="&"),m+=`${d}ref=${g.sourceReference}`,C.URI.parse(m)}else{if(g.path)return C.URI.file(g.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(u){const i=[];for(const g of u.getAllExtensionDescriptions())if(g.contributes){const m=g.contributes.debuggers;if(m&&m.length>0)for(const d of m)(0,p.$bG)(d)&&i.push(d.type)}this.k.$registerDebugTypes(i)}get stackFrameFocus(){return this.z}get onDidChangeStackFrameFocus(){return this.A.event}get onDidChangeBreakpoints(){return this.y.event}get breakpoints(){const u=[];return this.w.forEach(i=>u.push(i)),u}addBreakpoints(u){const i=u.filter(d=>{const S=d.id;return this.w.has(S)?!1:(this.w.set(S,d),!0)});this.U(i,[],[]);const g=[],m=new Map;for(const d of i)if(d instanceof A.$8L){let S=m.get(d.location.uri.toString());S||(S={type:"sourceMulti",uri:d.location.uri,lines:[]},m.set(d.location.uri.toString(),S),g.push(S)),S.lines.push({id:d.id,enabled:d.enabled,condition:d.condition,hitCondition:d.hitCondition,logMessage:d.logMessage,line:d.location.range.start.line,character:d.location.range.start.character})}else d instanceof A.$9L&&g.push({type:"function",id:d.id,enabled:d.enabled,hitCondition:d.hitCondition,logMessage:d.logMessage,condition:d.condition,functionName:d.functionName});return this.k.$registerBreakpoints(g)}removeBreakpoints(u){const i=u.filter(S=>this.w.delete(S.id));this.U([],i,[]);const g=i.filter(S=>S instanceof A.$8L).map(S=>S.id),m=i.filter(S=>S instanceof A.$9L).map(S=>S.id),d=i.filter(S=>S instanceof A.$0L).map(S=>S.id);return this.k.$unregisterBreakpoints(g,m,d)}startDebugging(u,i,g){return this.k.$startDebugging(u?u.uri:void 0,i,{parentSessionID:g.parentSession?g.parentSession.id:void 0,lifecycleManagedByParent:g.lifecycleManagedByParent,repl:g.consoleMode===A.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:g.noDebug,compact:g.compact,suppressSaveBeforeStart:g.suppressSaveBeforeStart,suppressDebugStatusbar:g.suppressDebugStatusbar??g.debugUI?.simple,suppressDebugToolbar:g.suppressDebugToolbar??g.debugUI?.simple,suppressDebugView:g.suppressDebugView??g.debugUI?.simple})}stopDebugging(u){return this.k.$stopDebugging(u?u.id:void 0)}registerDebugConfigurationProvider(u,i,g){if(!i)return new A.$8K(()=>{});const m=this.d++;return this.f.push({type:u,handle:m,provider:i}),this.k.$registerDebugConfigurationProvider(u,g,!!i.provideDebugConfigurations,!!i.resolveDebugConfiguration,!!i.resolveDebugConfigurationWithSubstitutedVariables,m),new A.$8K(()=>{this.f=this.f.filter(d=>d.provider!==i),this.k.$unregisterDebugConfigurationProvider(m)})}registerDebugAdapterDescriptorFactory(u,i,g){if(!g)return new A.$8K(()=>{});if(!this.Q(u,i))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${i}' debugger.`);if(this.N(i))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const m=this.g++;return this.h.push({type:i,handle:m,factory:g}),this.k.$registerDebugAdapterDescriptorFactory(i,m),new A.$8K(()=>{this.h=this.h.filter(d=>d.factory!==g),this.k.$unregisterDebugAdapterDescriptorFactory(m)})}registerDebugAdapterTrackerFactory(u,i){if(!i)return new A.$8K(()=>{});const g=this.i++;return this.j.push({type:u,handle:g,factory:i}),new A.$8K(()=>{this.j=this.j.filter(m=>m.factory!==i)})}async $runInTerminal(u,i){return Promise.resolve(void 0)}async $substituteVariables(u,i){let g;const m=await this.W(u);return m&&(g={uri:m.uri,name:m.name,index:m.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync(g,i)}K(u,i){if(u.type==="implementation")return new c(u.implementation)}L(){}async $startDASession(u,i){const g=this,m=await this.V(i);return this.S(this.N(m.type),m).then(d=>{if(!d)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${m.type}' (extension might have failed to activate)`);const S=this.M(d),M=this.K(S,m);if(!M)throw new Error(`Couldn't create a debug adapter for type '${m.type}'.`);const v=M;return this.B.set(u,v),this.R(m).then(E=>(E&&this.C.set(u,E),v.onMessage(async D=>{if(D.type==="request"&&D.command==="handshake"){const N=D,O={type:"response",seq:0,command:N.command,request_seq:N.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const G=await this.D.sign(N.arguments.value);O.body={signature:G},v.sendResponse(O)}else throw new Error("no signer")}catch(G){O.success=!1,O.message=G.message,v.sendResponse(O)}}else E&&E.onDidSendMessage&&E.onDidSendMessage(D),D=(0,p.$gG)(D,!0),g.k.$acceptDAMessage(u,D)}),v.onError(D=>{E&&E.onError&&E.onError(D),this.k.$acceptDAError(u,D.name,D.message,D.stack)}),v.onExit(D=>{E&&E.onExit&&E.onExit(D??void 0,void 0),this.k.$acceptDAExit(u,D??void 0,void 0)}),E&&E.onWillStartSession&&E.onWillStartSession(),v.startSession()))})}$sendDAMessage(u,i){i=(0,p.$fG)(i,!1);const g=this.C.get(u);g&&g.onWillReceiveMessage&&g.onWillReceiveMessage(i),this.B.get(u)?.sendMessage(i)}$stopDASession(u){const i=this.C.get(u);this.C.delete(u),i&&i.onWillStopSession&&i.onWillStopSession();const g=this.B.get(u);return this.B.delete(u),g?g.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(u){const i=[],g=[],m=[];if(u.added)for(const d of u.added){const S=d.id;if(S&&!this.w.has(S)){let M;if(d.type==="function")M=new A.$9L(d.functionName,d.enabled,d.condition,d.hitCondition,d.logMessage);else if(d.type==="data")M=new A.$0L(d.label,d.dataId,d.canPersist,d.enabled,d.hitCondition,d.condition,d.logMessage);else{const v=C.URI.revive(d.uri);M=new A.$8L(new A.$hL(v,new A.$9K(d.line,d.character)),d.enabled,d.condition,d.hitCondition,d.logMessage)}(0,A.$6L)(M,S),this.w.set(S,M),i.push(M)}}if(u.removed)for(const d of u.removed){const S=this.w.get(d);S&&(this.w.delete(d),g.push(S))}if(u.changed){for(const d of u.changed)if(d.id){const S=this.w.get(d.id);if(S){if(S instanceof A.$9L&&d.type==="function"){const M=S;M.enabled=d.enabled,M.condition=d.condition,M.hitCondition=d.hitCondition,M.logMessage=d.logMessage,M.functionName=d.functionName}else if(S instanceof A.$8L&&d.type==="source"){const M=S;M.enabled=d.enabled,M.condition=d.condition,M.hitCondition=d.hitCondition,M.logMessage=d.logMessage,M.location=new A.$hL(C.URI.revive(d.uri),new A.$9K(d.line,d.character))}m.push(S)}}}this.U(i,g,m)}async $acceptStackFrameFocus(u){let i;const g=u.sessionId?await this.V(u.sessionId):void 0;if(!g)throw new Error("no DebugSession found for debug focus context");u.kind==="thread"?i=new A.$dM(g,u.threadId):i=new A.$cM(g,u.threadId,u.frameId),this.z=i,this.A.fire(this.z)}$provideDebugConfigurations(u,i,g){return(0,y.$Yg)(async()=>{const m=this.P(u);if(!m)throw new Error("no DebugConfigurationProvider found");if(!m.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const d=await this.W(i);return m.provideDebugConfigurations(d,g)}).then(m=>{if(!m)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return m})}$resolveDebugConfiguration(u,i,g,m){return(0,y.$Yg)(async()=>{const d=this.P(u);if(!d)throw new Error("no DebugConfigurationProvider found");if(!d.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const S=await this.W(i);return d.resolveDebugConfiguration(S,g,m)})}$resolveDebugConfigurationWithSubstitutedVariables(u,i,g,m){return(0,y.$Yg)(async()=>{const d=this.P(u);if(!d)throw new Error("no DebugConfigurationProvider found");if(!d.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const S=await this.W(i);return d.resolveDebugConfigurationWithSubstitutedVariables(S,g,m)})}async $provideDebugAdapter(u,i){const g=this.O(u);if(!g)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const m=await this.V(i);return this.S(g,m).then(d=>{if(!d)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${m.type}'`);return this.M(d)})}async $acceptDebugSessionStarted(u){const i=await this.V(u);this.m.fire(i)}async $acceptDebugSessionTerminated(u){const i=await this.V(u);i&&(this.n.fire(i),this.l.delete(i.id))}async $acceptDebugSessionActiveChanged(u){this.q=u?await this.V(u):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(u,i){(await this.V(u))?._acceptNameChanged(i)}async $acceptDebugSessionCustomEvent(u,i){const m={session:await this.V(u),event:i.event,body:i.body};this.u.fire(m)}M(u){if(u instanceof A.$$L)return{type:"executable",command:u.command,args:u.args,options:u.options};if(u instanceof A.$_L)return{type:"server",port:u.port,host:u.host};if(u instanceof A.$aM)return{type:"pipeServer",path:u.path};if(u instanceof A.$bM)return{type:"implementation",implementation:u.implementation};throw new Error("convertToDto unexpected type")}N(u){const i=this.h.filter(g=>g.type===u);if(i.length>0)return i[0].factory}O(u){const i=this.h.filter(g=>g.handle===u);if(i.length>0)return i[0].factory}P(u){const i=this.f.filter(g=>g.handle===u);if(i.length>0)return i[0].provider}Q(u,i){if(u.contributes){const g=u.contributes.debuggers;if(g&&g.length>0){for(const m of g)if(m.label&&m.type&&m.type===i)return!0}}return!1}R(u){const g=u.configuration.type,m=this.j.filter(d=>d.type===g||d.type==="*").map(d=>(0,y.$Yg)(()=>d.factory.createDebugAdapterTracker(u)).then(S=>S,S=>null));return Promise.race([Promise.all(m).then(d=>{const S=d.filter(M=>!!M);if(S.length>0)return new o(S)}),new Promise(d=>setTimeout(()=>d(void 0),1e3))]).catch(d=>{})}async S(u,i){const g=i.configuration.debugServer;if(typeof g=="number")return Promise.resolve(new A.$_L(g));if(u){const d=await this.F.getExtensionRegistry();return(0,y.$Yg)(()=>u.createDebugAdapterDescriptor(i,this.T(i,d))).then(S=>{if(S)return S})}const m=await this.F.getExtensionRegistry();return Promise.resolve(this.T(i,m))}T(u,i){}U(u,i,g){(u.length>0||i.length>0||g.length>0)&&this.y.fire(Object.freeze({added:u,removed:i,changed:g}))}async V(u){if(u)if(typeof u=="string"){const i=this.l.get(u);if(i)return i}else{let i=this.l.get(u.id);if(!i){const g=await this.W(u.folderUri),m=u.parent?this.l.get(u.parent):void 0;i=new r(this.k,u.id,u.type,u.name,g,u.configuration,m),this.l.set(i.id,i),this.k.$sessionCached(i.id)}return i}throw new Error("cannot find session")}W(u){if(u){const i=C.URI.revive(u);return this.E.resolveWorkspaceFolder(i)}return Promise.resolve(void 0)}};e.$$gc=a,e.$$gc=a=Je([Ke(0,b.$0M),Ke(1,k.$qgc),Ke(2,f.$5gc),Ke(3,w.$tgc),Ke(4,$.$Fgc),Ke(5,s.$8gc)],a);class r{constructor(u,i,g,m,d,S,M){this.d=u,this.f=i,this.g=g,this.h=m,this.i=d,this.j=S,this.k=M}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(u){this.h=u,this.d.$setDebugSessionName(this.f,u)}get parentSession(){return this.k}_acceptNameChanged(u){this.h=u}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(u,i){return this.d.$customDebugAdapterRequest(this.f,u,i)}getDebugProtocolBreakpoint(u){return this.d.$getDebugProtocolBreakpoint(this.f,u.id)}}e.$_gc=r;class n{constructor(u){this.value=Object.freeze({append(i){u.$appendDebugConsole(i)},appendLine(i){this.append(i+`
`)}})}}e.$ahc=n;class o{constructor(u){this.d=u}onWillStartSession(){this.d.forEach(u=>u.onWillStartSession?u.onWillStartSession():void 0)}onWillReceiveMessage(u){this.d.forEach(i=>i.onWillReceiveMessage?i.onWillReceiveMessage(u):void 0)}onDidSendMessage(u){this.d.forEach(i=>i.onDidSendMessage?i.onDidSendMessage(u):void 0)}onWillStopSession(){this.d.forEach(u=>u.onWillStopSession?u.onWillStopSession():void 0)}onError(u){this.d.forEach(i=>i.onError?i.onError(u):void 0)}onExit(u,i){this.d.forEach(g=>g.onExit?g.onExit(u,i):void 0)}}class c extends l.$Ilb{constructor(u){super(),this.h=u,u.onDidSendMessage(i=>{this.acceptMessage(i)})}startSession(){return Promise.resolve(void 0)}sendMessage(u){this.h.handleMessage(u)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let h=class extends a{constructor(u,i,g,m,d,S){super(u,i,g,m,d,S)}};e.$bhc=h,e.$bhc=h=Je([Ke(0,b.$0M),Ke(1,k.$qgc),Ke(2,f.$5gc),Ke(3,w.$tgc),Ke(4,$.$Fgc),Ke(5,s.$8gc)],h)}),define(Pe[287],Re([1,0,15,88,2,3,275,14,70,71,27,184,17,57,38,59]),function(ge,e,y,T,C,L,R,$,f,b,A,k,l,p,w,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eic=e.$dic=void 0;class a{static async installEarlyHandler(o){Error.stackTraceLimit=100;const c=o.get($.$nj),t=o.get(l.$0M).getProxy(L.$6K.MainThreadErrors);y.setUnexpectedErrorHandler(u=>{c.error(u);const i=y.$3(u);t.$onUnexpectedError(i)})}static async installFullHandler(o){const c=o.get($.$nj),h=o.get(l.$0M),t=o.get(w.$5gc),u=o.get(s.$rN),i=h.getProxy(L.$6K.MainThreadExtensionService),g=h.getProxy(L.$6K.MainThreadErrors),m=await t.getExtensionPathIndex(),d=new WeakMap;function S(E,D){if(d.has(E))return d.get(E).stack;let N="",O,G;for(const z of D)N+=`
	at ${z.toString()}`,G=z.getFileName(),!O&&G&&(O=m.findSubstr(C.URI.file(G)));const W=`${E.name||"Error"}: ${E.message||""}${N}`;return d.set(E,{extensionIdentifier:O?.identifier,stack:W}),W}const M=Symbol("prepareStackTrace wrapped");let v=S;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return v},set(E){if(E===S||!E||E[M]){v=E||S;return}v=function(D,N){return S(D,N),E.call(Error,D,N)},Object.assign(v,{[M]:!0})}}),y.setUnexpectedErrorHandler(E=>{c.error(E);const D=y.$3(E),N=d.get(E);if(!N?.extensionIdentifier){g.$onUnexpectedError(D);return}i.$onExtensionRuntimeError(N.extensionIdentifier,D);const O=u.onExtensionError(N.extensionIdentifier,E);c.trace("forwarded error to extension?",O,N)})}}e.$dic=a;class r{constructor(o,c,h,t,u){this.a=h,this.b=new R.$p8b(o,null,t),c=r.e(c,this.b);const i=new b.$4h(...(0,f.$Zr)());i.set(A.$nN,{_serviceBrand:void 0,...c,messagePorts:u}),i.set(l.$0M,new l.$$M(this.b)),i.set(p.$ngc,new p.$ogc(t)),i.set(w.$3gc,h);const g=new k.$Eq(i,!0);g.invokeFunction(a.installEarlyHandler),this.d=g.invokeFunction(m=>m.get($.$nj)),T.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",c),this.c=g.invokeFunction(m=>m.get(w.$5gc)),this.c.initialize(),g.invokeFunction(a.installFullHandler)}async asBrowserUri(o){const c=this.b.getProxy(L.$6K.MainThreadExtensionService);return C.URI.revive(await c.$asBrowserUri(o))}terminate(o){this.c.terminate(o)}static e(o,c){o.extensions.allExtensions.forEach(t=>{t.extensionLocation=C.URI.revive(c.transformIncomingURIs(t.extensionLocation))}),o.environment.appRoot=C.URI.revive(c.transformIncomingURIs(o.environment.appRoot));const h=o.environment.extensionDevelopmentLocationURI;return h&&(o.environment.extensionDevelopmentLocationURI=h.map(t=>C.URI.revive(c.transformIncomingURIs(t)))),o.environment.extensionTestsLocationURI=C.URI.revive(c.transformIncomingURIs(o.environment.extensionTestsLocationURI)),o.environment.globalStorageHome=C.URI.revive(c.transformIncomingURIs(o.environment.globalStorageHome)),o.environment.workspaceStorageHome=C.URI.revive(c.transformIncomingURIs(o.environment.workspaceStorageHome)),o.environment.extensionTelemetryLogResource=C.URI.revive(c.transformIncomingURIs(o.environment.extensionTelemetryLogResource)),o.nlsBaseUrl=C.URI.revive(c.transformIncomingURIs(o.nlsBaseUrl)),o.logsLocation=C.URI.revive(c.transformIncomingURIs(o.logsLocation)),o.workspace=c.transformIncomingURIs(o.workspace),o}}e.$eic=r}),define(Pe[288],Re([1,0,18,13,20,40,12,19,25,2,43]),function(ge,e,y,T,C,L,R,$,f,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$shc=e.$rhc=e.$qhc=e.$phc=void 0;class k{constructor(n,o,c,h){this.d=n,this.e=o,this.f=c,this.g=h,this.a=null,this.b=!1,this.c=0}search(n,o){const c=this.d.folderQueries||[],h=new C.$6d(o);return new Promise((t,u)=>{this.a=new p(n);let i=!1;const g=(m,d)=>{if(!i&&!this.b){const S=this.h(m);s(m)&&typeof this.d.maxResults=="number"&&this.c+S>this.d.maxResults&&(this.b=!0,i=!0,h.cancel(),m=this.j(m,this.d.maxResults-this.c));const M=this.h(m);this.c+=M,(M>0||!s(m))&&this.a.add(m,d)}};Promise.all(c.map((m,d)=>this.k(m,S=>g(S,d),h.token))).then(m=>{h.dispose(),this.a.flush();const d=m.some(S=>!!S&&!!S.limitHit);t({limitHit:this.b||d,messages:(0,y.$Rb)(m.map(S=>S?.message?Array.isArray(S.message)?S.message:[S.message]:[])),stats:{type:this.g}})},m=>{h.dispose();const d=(0,L.$Qi)(m);u(new Error(d))})})}h(n){return s(n)?Array.isArray(n.ranges)?n.ranges.length:1:0}j(n,o){const c=Array.isArray(n.ranges)?n.ranges:[n.ranges],h=Array.isArray(n.preview.matches)?n.preview.matches:[n.preview.matches];return{ranges:c.slice(0,o),preview:{matches:h.slice(0,o),text:n.preview.text},uri:n.uri}}async k(n,o,c){const h=new A.$JJ(this.d,n),t=[],u={report:m=>{if(!this.l(m))return;const d=n.folder.scheme===R.Schemas.file?(0,A.$KJ)(()=>this.f.readdir(f.$Gg(m.uri))):void 0,S=f.$Jg(n.folder,m.uri);if(S){const M=h.includedInQuery(S,$.$nc(S),d);(0,T.$Sg)(M)?t.push(M.then(v=>{v&&o(m)})):M&&o(m)}}},i=this.n(n),g=await this.e.provideTextSearchResults(l(this.d.contentPattern),i,u,c);return t.length&&await Promise.all(t),g}l(n){if(s(n)){if(Array.isArray(n.ranges)){if(!Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(n.preview.matches.length!==n.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(n){const o=(0,A.$IJ)(this.d.includePattern,n.includePattern),c=(0,A.$IJ)(this.d.excludePattern,n.excludePattern),h={folder:b.URI.from(n.folder),excludes:c,includes:o,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!n.disregardParentIgnoreFiles,followSymlinks:!n.ignoreSymlinks,encoding:n.fileEncoding&&this.f.toCanonicalName(n.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return h.usePCRE2=this.d.usePCRE2,h}}e.$phc=k;function l(r){return{isCaseSensitive:r.isCaseSensitive||!1,isRegExp:r.isRegExp||!1,isWordMatch:r.isWordMatch||!1,isMultiline:r.isMultiline||!1,pattern:r.pattern}}class p{constructor(n){this.e=n,this.b=-1,this.d=null,this.a=new a(512,o=>this.g(o))}add(n,o){this.d&&(this.b!==o||!f.$Ag(this.c,n.uri))&&(this.f(),this.d=null),this.d||(this.b=o,this.d={resource:n.uri,results:[]}),this.d.results.push(w(n))}f(){const n=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,n)}flush(){this.f(),this.a.flush()}g(n){this.e(n)}}e.$qhc=p;function w(r){return s(r)?{preview:{matches:(0,y.$2b)(r.preview.matches,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character})),text:r.preview.text},ranges:(0,y.$2b)(r.ranges,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character}))}:{text:r.text,lineNumber:r.lineNumber}}function s(r){return!!r.preview}e.$rhc=s;class a{static{this.a=4e3}static{this.b=50}constructor(n,o){this.g=n,this.h=o,this.c=0,this.d=[],this.e=0}addItem(n,o){n&&this.j(n,o)}addItems(n,o){n&&this.k(n,o)}j(n,o){this.d.push(n),this.e+=o,this.l()}k(n,o){this.d=this.d.concat(n),this.e+=o,this.l()}l(){this.c<a.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},a.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$shc=a}),define(Pe[118],Re([1,0,6,3,4,283,17,57,14,2,288]),function(ge,e,y,T,C,L,R,$,f,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vhc=e.$uhc=e.$thc=void 0,e.$thc=(0,C.$6h)("IExtHostSearch");let k=class{constructor(s,a,r){this.k=s,this.l=a,this.n=r,this.c=this.k.getProxy(T.$6K.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new L.$ohc}o(s){return this.l.transformOutgoingScheme(s)}registerTextSearchProvider(s,a){if(this.g.has(s))throw new Error(`a text search provider for the scheme '${s}' is already registered`);this.g.add(s);const r=this.d++;return this.e.set(r,a),this.c.$registerTextSearchProvider(r,this.o(s)),(0,y.$Rc)(()=>{this.g.delete(s),this.e.delete(r),this.c.$unregisterProvider(r)})}registerFileSearchProvider(s,a){if(this.i.has(s))throw new Error(`a file search provider for the scheme '${s}' is already registered`);this.i.add(s);const r=this.d++;return this.h.set(r,a),this.c.$registerFileSearchProvider(r,this.o(s)),(0,y.$Rc)(()=>{this.i.delete(s),this.h.delete(r),this.c.$unregisterProvider(r)})}$provideFileSearchResults(s,a,r,n){const o=l(r),c=this.h.get(s);if(c)return this.j.fileSearch(o,c,h=>{this.c.$handleFileMatch(s,a,h.map(t=>t.resource))},n);throw new Error("unknown provider: "+s)}async doInternalFileSearchWithCustomCallback(s,a,r){return{messages:[]}}$clearCache(s){return this.j.clearCache(s),Promise.resolve(void 0)}$provideTextSearchResults(s,a,r,n){const o=this.e.get(s);if(!o||!o.provideTextSearchResults)throw new Error(`Unknown provider ${s}`);const c=l(r);return this.q(c,o).search(t=>this.c.$handleTextMatch(s,a,t),n)}$enableExtensionHostSearch(){}q(s,a){return new A.$phc(s,a,{readdir:r=>Promise.resolve([]),toCanonicalName:r=>r},"textSearchProvider")}};e.$uhc=k,e.$uhc=k=Je([Ke(0,R.$0M),Ke(1,$.$ngc),Ke(2,f.$nj)],k);function l(w){return{...w,folderQueries:w.folderQueries&&w.folderQueries.map(p),extraFileResources:w.extraFileResources&&w.extraFileResources.map(s=>b.URI.revive(s))}}e.$vhc=l;function p(w){return{...w,folder:b.URI.revive(w.folder)}}}),define(Pe[289],Re([1,0,20,15,5,6,12,31,2,146,142,130,93,22,41,14,55,56,197,3,230,238,81,231,232,233,234,235,236,237,212,32,239,37,271,117,110,241,242,243,219,244,61,62,246,38,247,63,248,42,27,249,250,251,252,253,254,82,83,256,282,221,201,222,257,258,112,259,223,260,261,17,262,118,84,263,264,265,85,86,115,59,64,266,267,209,268,224,87,8,7,269,57,270,65,272,273,111,36,207,79,23,114]),function(ge,e,y,T,C,L,R,$,f,b,A,k,l,p,w,s,a,r,n,o,c,h,t,u,i,g,m,d,S,M,v,E,D,N,O,G,W,z,P,I,H,ae,de,we,ke,le,ve,se,be,ne,Y,V,ie,Ie,Le,Ce,ce,te,Q,ee,me,pe,Ae,he,ye,F,q,K,U,X,x,Ee,Te,Ve,He,Ye,st,nt,tt,at,ct,je,vt,Z,_,$e,Be,Qe,it,rt,Ne,Pt,Tt,Ht,Bt,yt,Kt,Nt,Xt,zt,Rt,Ze,Gt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$hc=void 0;function Jt(lt){const $t=lt.get(Y.$nN),jt=lt.get(ne.$8fc),Vt=lt.get(se.$vgc),kt=lt.get(le.$5gc),dt=lt.get(Xt.$qgc),Ct=lt.get(je.$rN),xt=lt.get(N.$tgc),Dt=lt.get(Tt.$ngc),qe=lt.get(Ee.$0M),Mt=lt.get(tt.$Ogc),Wt=lt.get(at.$wgc),Qt=lt.get(s.$oj),ft=lt.get(s.$nj),Ft=lt.get(it.$oyb),Se=lt.get(t.$$fc),Fe=lt.get(Nt.$0hc),fe=lt.get(He.$Wgc),J=lt.get(we.$Fgc),Me=lt.get(Q.$1gc);qe.set(o.$7K.ExtHostFileSystemInfo,jt),qe.set(o.$7K.ExtHostLogLevelServiceShape,Qt),qe.set(o.$7K.ExtHostWorkspace,dt),qe.set(o.$7K.ExtHostConfiguration,xt),qe.set(o.$7K.ExtHostExtensionService,kt),qe.set(o.$7K.ExtHostStorage,Mt),qe.set(o.$7K.ExtHostTunnelService,Ft),qe.set(o.$7K.ExtHostWindow,Fe),qe.set(o.$7K.ExtHostSecretState,fe),qe.set(o.$7K.ExtHostTelemetry,Ct),qe.set(o.$7K.ExtHostEditorTabs,J),qe.set(o.$7K.ExtHostManagedSockets,Me);const Ue=qe.set(o.$7K.ExtHostDecorations,lt.get(W.$dhc)),Xe=qe.set(o.$7K.ExtHostDocumentsAndEditors,lt.get(de.$iN)),We=qe.set(o.$7K.ExtHostCommands,lt.get(E.$tN)),_e=qe.set(o.$7K.ExtHostTerminalService,lt.get(vt.$Rgc)),mt=qe.set(o.$7K.ExtHostDebugService,lt.get(G.$0gc)),Ut=qe.set(o.$7K.ExtHostSearch,lt.get(Ve.$thc)),Et=qe.set(o.$7K.ExtHostTask,lt.get(ct.$Whc)),St=qe.set(o.$7K.ExtHostOutputService,lt.get(q.$Jhc)),bt=qe.set(o.$7K.ExtHostLocalization,lt.get(te.$Zgc)),gi=qe.set(o.$7K.ExtHostUrls,new Ht.$7hc(qe)),At=qe.set(o.$7K.ExtHostDocuments,new ae.$6fc(qe,Xe)),Si=qe.set(o.$7K.ExtHostDocumentContentProviders,new I.$fhc(qe,Xe,ft)),Gi=qe.set(o.$7K.ExtHostDocumentSaveParticipant,new H.$ghc(ft,At,qe.getProxy(o.$6K.MainThreadBulkEdits))),It=qe.set(o.$7K.ExtHostNotebook,new me.$whc(qe,We,Xe,At,Vt,Ut)),ri=qe.set(o.$7K.ExtHostNotebookDocuments,new Ae.$Dhc(It)),mi=qe.set(o.$7K.ExtHostNotebookEditors,new he.$Ehc(ft,It)),ci=qe.set(o.$7K.ExtHostNotebookKernels,new ye.$Fhc(qe,$t,It,We,ft)),Ii=qe.set(o.$7K.ExtHostNotebookRenderers,new F.$Hhc(qe,It)),Ci=qe.set(o.$7K.ExtHostNotebookDocumentSaveParticipant,new pe.$Chc(ft,It,qe.getProxy(o.$6K.MainThreadBulkEdits))),Ot=qe.set(o.$7K.ExtHostEditors,new _.$kgc(qe,Xe)),$i=qe.set(o.$7K.ExtHostTreeViews,new Qe.$5hc(qe.getProxy(o.$6K.MainThreadTreeViews),We,ft)),Pi=qe.set(o.$7K.ExtHostEditorInsets,new v.$lgc(qe.getProxy(o.$6K.MainThreadEditorInsets),Ot,$t.remote)),ui=qe.set(o.$7K.ExtHostDiagnostics,new z.$0fc(qe,ft,jt,Xe)),li=qe.set(o.$7K.ExtHostLanguages,new ce.$Ahc(qe,At,We.converter,Dt)),ht=qe.set(o.$7K.ExtHostLanguageFeatures,new Ce.$bgc(qe,Dt,At,We,ui,ft,Se,Ct)),Ji=qe.set(o.$7K.ExtHostFileSystem,new ve.$ihc(qe,ht)),_t=qe.set(o.$7K.ExtHostFileSystemEventService,new be.$jhc(qe,ft,Xe)),si=qe.set(o.$7K.ExtHostQuickOpen,(0,x.$Nhc)(qe,dt,We)),pi=qe.set(o.$7K.ExtHostSCM,new Te.$Phc(qe,We,At,ft)),Ri=qe.set(o.$7K.ExtHostQuickDiff,new X.$Mhc(qe,Dt)),Qi=qe.set(o.$7K.ExtHostShare,new Ye.$Qhc(qe,Dt)),Ai=qe.set(o.$7K.ExtHostComments,(0,D.$mgc)(qe,We,At)),vi=qe.set(o.$7K.ExtHostProgress,new U.$Lhc(qe.getProxy(o.$6K.MainThreadProgress))),Xi=qe.set(o.$7K.ExtHostLabelService,new Le.$zhc(qe)),Li=qe.set(o.$7K.ExtHostTheming,new $e.$2hc(qe)),hi=qe.set(o.$7K.ExtHostAuthentication,new u.$dgc(qe)),Yi=qe.set(o.$7K.ExtHostTimeline,new Be.$4hc(qe,We)),wi=qe.set(o.$7K.ExtHostWebviews,new Bt.$Agc(qe,$t.remote,dt,ft,Se)),Mi=qe.set(o.$7K.ExtHostWebviewPanels,new yt.$Dgc(qe,wi,dt)),un=qe.set(o.$7K.ExtHostCustomEditors,new O.$Egc(qe,At,Wt,wi,Mi)),Fi=qe.set(o.$7K.ExtHostWebviewViews,new Kt.$8hc(qe,wi)),oi=qe.set(o.$7K.ExtHostTesting,new Z.$Xhc(qe,ft,We,Xe)),ln=qe.set(o.$7K.ExtHostUriOpeners,new Pt.$6hc(qe)),hn=qe.set(o.$7K.ExtHostProfileContentHandlers,new K.$Khc(qe));qe.set(o.$7K.ExtHostInteractive,new ie.$xhc(qe,It,Xe,We,ft));const Zi=qe.set(o.$7K.ExtHostInlineChat,new V.$khc(qe,We,At,ft)),di=qe.set(o.$7K.ExtHostChatProvider,new d.$ggc(qe,ft)),xi=qe.set(o.$7K.ExtHostChatAgents2,new m.$hgc(qe,di,ft)),_i=qe.set(o.$7K.ExtHostChatVariables,new S.$igc(qe)),bi=qe.set(o.$7K.ExtHostChat,new g.$fgc(qe)),en=qe.set(o.$7K.ExtHostAiRelatedInformation,new c.$5fc(qe)),Ti=qe.set(o.$7K.ExtHostAiEmbeddingVector,new ke.$hhc(qe)),Ni=qe.set(o.$7K.ExtHostIssueReporter,new Ie.$yhc(qe)),ei=qe.set(o.$7K.ExtHostStatusBar,new nt.$Thc(qe,We.converter)),yi=qe.set(o.$7K.ExtHostSpeech,new st.$Rhc(qe)),dn=Object.values(o.$7K);qe.assertRegistered(dn);const Yt=new i.$egc(qe,Xe),Ei=new M.$jgc(qe),ki=new ee.$Bhc(qe,ft),Oi=new P.$ehc(qe);return h.$cgc.register(We),function(ze,ti,tn){function et(re){return(ue,Oe,ot)=>{const wt=re(Lt=>{try{ue.call(Oe,Lt)}catch(cn){T.$2(new Error(`[ExtensionListenerError] Extension '${ze.identifier.value}' FAILED to handle event`,{cause:cn})),Ct.onExtensionError(ze.identifier,cn)}});return ot?.push(wt),wt}}const pt=function(){let re=!ze.isUnderDevelopment;function ue(){re||(ft.info(`Extension '${ze.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),re=!0)}return function Oe(ot){if(Array.isArray(ot))ot.forEach(Oe);else if(typeof ot=="string")ue();else{const wt=ot;typeof wt.scheme>"u"&&ue(),typeof wt.exclusive=="boolean"&&(0,Ze.$CF)(ze,"documentFiltersExclusive")}return ot}}(),fn={getSession(re,ue,Oe){return hi.getSession(ze,re,ue,Oe)},getSessions(re,ue){return(0,Ze.$CF)(ze,"authGetSessions"),hi.getSessions(ze,re,ue)},async hasSession(re,ue){return(0,Ze.$CF)(ze,"authSession"),!!await hi.getSession(ze,re,ue,{silent:!0})},get onDidChangeSessions(){return et(hi.onDidChangeSessions)},registerAuthenticationProvider(re,ue,Oe,ot){return hi.registerAuthenticationProvider(re,ue,Oe,ot)}},gn={registerCommand(re,ue,Oe){return We.registerCommand(!0,re,ue,Oe,void 0,ze)},registerTextEditorCommand(re,ue,Oe){return We.registerCommand(!0,re,(...ot)=>{const wt=Ot.getActiveTextEditor();if(!wt){ft.warn("Cannot execute "+re+" because there is no active text editor.");return}return wt.edit(Lt=>{ue.apply(Oe,[wt,Lt,...ot])}).then(Lt=>{Lt||ft.warn("Edits from command "+re+" were not applied.")},Lt=>{ft.warn("An error occurred while running command "+re,Lt)})},void 0,void 0,ze)},registerDiffInformationCommand:(re,ue,Oe)=>((0,Ze.$CF)(ze,"diffCommand"),We.registerCommand(!0,re,async(...ot)=>{const wt=Xe.activeEditor(!0);if(!wt){ft.warn("Cannot execute "+re+" because there is no active text editor.");return}const Lt=await Ot.getDiffInformation(wt.id);ue.apply(Oe,[Lt,...ot])},void 0,void 0,ze)),executeCommand(re,...ue){return We.executeCommand(re,...ue)},getCommands(re=!1){return We.getCommands(re)}},zi={get machineId(){return $t.telemetryInfo.machineId},get sessionId(){return $t.telemetryInfo.sessionId},get language(){return $t.environment.appLanguage},get appName(){return $t.environment.appName},get appRoot(){return $t.environment.appRoot?.fsPath??""},get appHost(){return $t.environment.appHost},get uriScheme(){return $t.environment.appUriScheme},get clipboard(){return Ei.value},get shell(){return _e.getDefaultShell(!1)},get onDidChangeShell(){return et(_e.onDidChangeShell)},get isTelemetryEnabled(){return Ct.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return et(Ct.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,Ze.$CF)(ze,"telemetry"),Ct.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ze.$CF)(ze,"telemetry"),et(Ct.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,je.$qN)($t.telemetryInfo.firstSessionDate)},createTelemetryLogger(re,ue){return je.$pN.validateSender(re),Ct.instantiateLogger(ze,re,ue)},openExternal(re,ue){return Fe.openUri(re,{allowTunneling:!!$t.remote.authority,allowContributedOpeners:ue?.allowContributedOpeners})},async asExternalUri(re){if(re.scheme===$t.environment.appUriScheme)return gi.createAppUri(re);try{return await Fe.asExternalUri(re,{allowTunneling:!!$t.remote.authority})}catch(ue){if((0,R.$eg)(re,R.Schemas.http)||(0,R.$eg)(re,R.Schemas.https))return re;throw ue}},get remoteName(){return(0,a.$bl)($t.remote.authority)},get remoteAuthority(){return(0,Ze.$CF)(ze,"resolvers"),$t.remote.authority},get uiKind(){return $t.uiKind},get logLevel(){return ft.getLevel()},get onDidChangeLogLevel(){return et(ft.onDidChangeLogLevel)},registerIssueUriRequestHandler(re){return(0,Ze.$CF)(ze,"handleIssueUri"),Ni.registerIssueUriRequestHandler(ze,re)},registerIssueDataProvider(re){return(0,Ze.$CF)(ze,"handleIssueUri"),Ni.registerIssueDataProvider(ze,re)},get appQuality(){return(0,Ze.$CF)(ze,"resolvers"),$t.quality},get appCommit(){return(0,Ze.$CF)(ze,"resolvers"),$t.commit}};$t.environment.extensionTestsLocationURI||Object.freeze(zi);const ji={createTestController(re,ue,Oe){return oi.createTestController(ze,re,ue,Oe)},createTestObserver(){return(0,Ze.$CF)(ze,"testObserver"),oi.createTestObserver()},runTests(re){return(0,Ze.$CF)(ze,"testObserver"),oi.runTests(re)},get onDidChangeTestResults(){return(0,Ze.$CF)(ze,"testObserver"),et(oi.onResultsChanged)},get testResults(){return(0,Ze.$CF)(ze,"testObserver"),oi.results}},fi=$t.remote.isRemote?Ne.ExtensionKind.Workspace:Ne.ExtensionKind.UI,nn={getExtension(re,ue){(0,Ze.$BF)(ze,"extensionsAny")||(ue=!1);const Oe=ti.mine.getExtensionDescription(re);if(Oe)return new le.$6gc(kt,ze.identifier,Oe,fi,!1);if(ue){const ot=ti.all.getExtensionDescription(re);if(ot)return new le.$6gc(kt,ze.identifier,ot,fi,!0)}},get all(){const re=[];for(const ue of ti.mine.getAllExtensionDescriptions())re.push(new le.$6gc(kt,ze.identifier,ue,fi,!1));return re},get allAcrossExtensionHosts(){(0,Ze.$CF)(ze,"extensionsAny");const re=new p.$mm(ti.mine.getAllExtensionDescriptions().map(Oe=>Oe.identifier)),ue=[];for(const Oe of ti.all.getAllExtensionDescriptions()){const ot=!re.has(Oe.identifier);ue.push(new le.$6gc(kt,ze.identifier,Oe,fi,ot))}return ue},get onDidChange(){return(0,Ze.$BF)(ze,"extensionsAny")?et(C.Event.any(ti.mine.onDidChange,ti.all.onDidChange)):et(ti.mine.onDidChange)}},rn={createDiagnosticCollection(re){return ui.createDiagnosticCollection(ze.identifier,re)},get onDidChangeDiagnostics(){return et(ui.onDidChangeDiagnostics)},getDiagnostics:re=>ui.getDiagnostics(re),getLanguages(){return li.getLanguages()},setTextDocumentLanguage(re,ue){return li.changeLanguage(re.uri,ue)},match(re,ue){const Oe=At.getDocumentData(ue.uri)?.notebook;return(0,A.$Bt)(rt.LanguageSelector.from(re),ue.uri,ue.languageId,!0,Oe?.uri,Oe?.notebookType)},registerCodeActionsProvider(re,ue,Oe){return ht.registerCodeActionProvider(ze,pt(re),ue,Oe)},registerDocumentPasteEditProvider(re,ue,Oe){return(0,Ze.$CF)(ze,"documentPaste"),ht.registerDocumentPasteEditProvider(ze,pt(re),ue,Oe)},registerCodeLensProvider(re,ue){return ht.registerCodeLensProvider(ze,pt(re),ue)},registerDefinitionProvider(re,ue){return ht.registerDefinitionProvider(ze,pt(re),ue)},registerDeclarationProvider(re,ue){return ht.registerDeclarationProvider(ze,pt(re),ue)},registerImplementationProvider(re,ue){return ht.registerImplementationProvider(ze,pt(re),ue)},registerTypeDefinitionProvider(re,ue){return ht.registerTypeDefinitionProvider(ze,pt(re),ue)},registerHoverProvider(re,ue){return ht.registerHoverProvider(ze,pt(re),ue,ze.identifier)},registerEvaluatableExpressionProvider(re,ue){return ht.registerEvaluatableExpressionProvider(ze,pt(re),ue,ze.identifier)},registerInlineValuesProvider(re,ue){return ht.registerInlineValuesProvider(ze,pt(re),ue,ze.identifier)},registerDocumentHighlightProvider(re,ue){return ht.registerDocumentHighlightProvider(ze,pt(re),ue)},registerMultiDocumentHighlightProvider(re,ue){return ht.registerMultiDocumentHighlightProvider(ze,pt(re),ue)},registerLinkedEditingRangeProvider(re,ue){return ht.registerLinkedEditingRangeProvider(ze,pt(re),ue)},registerReferenceProvider(re,ue){return ht.registerReferenceProvider(ze,pt(re),ue)},registerRenameProvider(re,ue){return ht.registerRenameProvider(ze,pt(re),ue)},registerDocumentSymbolProvider(re,ue,Oe){return ht.registerDocumentSymbolProvider(ze,pt(re),ue,Oe)},registerWorkspaceSymbolProvider(re){return ht.registerWorkspaceSymbolProvider(ze,re)},registerDocumentFormattingEditProvider(re,ue){return ht.registerDocumentFormattingEditProvider(ze,pt(re),ue)},registerDocumentRangeFormattingEditProvider(re,ue){return ht.registerDocumentRangeFormattingEditProvider(ze,pt(re),ue)},registerOnTypeFormattingEditProvider(re,ue,Oe,...ot){return ht.registerOnTypeFormattingEditProvider(ze,pt(re),ue,[Oe].concat(ot))},registerDocumentSemanticTokensProvider(re,ue,Oe){return ht.registerDocumentSemanticTokensProvider(ze,pt(re),ue,Oe)},registerDocumentRangeSemanticTokensProvider(re,ue,Oe){return ht.registerDocumentRangeSemanticTokensProvider(ze,pt(re),ue,Oe)},registerSignatureHelpProvider(re,ue,Oe,...ot){return typeof Oe=="object"?ht.registerSignatureHelpProvider(ze,pt(re),ue,Oe):ht.registerSignatureHelpProvider(ze,pt(re),ue,typeof Oe>"u"?[]:[Oe,...ot])},registerCompletionItemProvider(re,ue,...Oe){return ht.registerCompletionItemProvider(ze,pt(re),ue,Oe)},registerInlineCompletionItemProvider(re,ue,Oe){return ue.handleDidShowCompletionItem&&(0,Ze.$CF)(ze,"inlineCompletionsAdditions"),ue.handleDidPartiallyAcceptCompletionItem&&(0,Ze.$CF)(ze,"inlineCompletionsAdditions"),Oe&&(0,Ze.$CF)(ze,"inlineCompletionsAdditions"),ht.registerInlineCompletionsProvider(ze,pt(re),ue,Oe)},registerDocumentLinkProvider(re,ue){return ht.registerDocumentLinkProvider(ze,pt(re),ue)},registerColorProvider(re,ue){return ht.registerColorProvider(ze,pt(re),ue)},registerFoldingRangeProvider(re,ue){return ht.registerFoldingRangeProvider(ze,pt(re),ue)},registerSelectionRangeProvider(re,ue){return ht.registerSelectionRangeProvider(ze,re,ue)},registerCallHierarchyProvider(re,ue){return ht.registerCallHierarchyProvider(ze,re,ue)},registerTypeHierarchyProvider(re,ue){return ht.registerTypeHierarchyProvider(ze,re,ue)},setLanguageConfiguration:(re,ue)=>ht.setLanguageConfiguration(ze,re,ue),getTokenInformationAtPosition(re,ue){return(0,Ze.$CF)(ze,"tokenInformation"),li.tokenAtPosition(re,ue)},registerInlayHintsProvider(re,ue){return ht.registerInlayHintsProvider(ze,re,ue)},createLanguageStatusItem(re,ue){return li.createLanguageStatusItem(ze,re,ue)},registerDocumentDropEditProvider(re,ue,Oe){return ht.registerDocumentOnDropEditProvider(ze,re,ue,(0,Ze.$BF)(ze,"dropMetadata")?Oe:void 0)}},mn={get activeTextEditor(){return Ot.getActiveTextEditor()},get visibleTextEditors(){return Ot.getVisibleTextEditors()},get activeTerminal(){return _e.activeTerminal},get terminals(){return _e.terminals},async showTextDocument(re,ue,Oe){const ot=await(f.URI.isUri(re)?Promise.resolve(sn.openTextDocument(re)):Promise.resolve(re));return Ot.showTextDocument(ot,ue,Oe)},createTextEditorDecorationType(re){return Ot.createTextEditorDecorationType(ze,re)},onDidChangeActiveTextEditor(re,ue,Oe){return et(Ot.onDidChangeActiveTextEditor)(re,ue,Oe)},onDidChangeVisibleTextEditors(re,ue,Oe){return et(Ot.onDidChangeVisibleTextEditors)(re,ue,Oe)},onDidChangeTextEditorSelection(re,ue,Oe){return et(Ot.onDidChangeTextEditorSelection)(re,ue,Oe)},onDidChangeTextEditorOptions(re,ue,Oe){return et(Ot.onDidChangeTextEditorOptions)(re,ue,Oe)},onDidChangeTextEditorVisibleRanges(re,ue,Oe){return et(Ot.onDidChangeTextEditorVisibleRanges)(re,ue,Oe)},onDidChangeTextEditorViewColumn(re,ue,Oe){return et(Ot.onDidChangeTextEditorViewColumn)(re,ue,Oe)},onDidCloseTerminal(re,ue,Oe){return et(_e.onDidCloseTerminal)(re,ue,Oe)},onDidOpenTerminal(re,ue,Oe){return et(_e.onDidOpenTerminal)(re,ue,Oe)},onDidChangeActiveTerminal(re,ue,Oe){return et(_e.onDidChangeActiveTerminal)(re,ue,Oe)},onDidChangeTerminalDimensions(re,ue,Oe){return(0,Ze.$CF)(ze,"terminalDimensions"),et(_e.onDidChangeTerminalDimensions)(re,ue,Oe)},onDidChangeTerminalState(re,ue,Oe){return et(_e.onDidChangeTerminalState)(re,ue,Oe)},onDidWriteTerminalData(re,ue,Oe){return(0,Ze.$CF)(ze,"terminalDataWriteEvent"),et(_e.onDidWriteTerminalData)(re,ue,Oe)},onDidExecuteTerminalCommand(re,ue,Oe){return(0,Ze.$CF)(ze,"terminalExecuteCommandEvent"),et(_e.onDidExecuteTerminalCommand)(re,ue,Oe)},get state(){return Fe.getState(ze)},onDidChangeWindowState(re,ue,Oe){return et(Fe.onDidChangeWindowState)(re,ue,Oe)},showInformationMessage(re,...ue){return ki.showMessage(ze,$.default.Info,re,ue[0],ue.slice(1))},showWarningMessage(re,...ue){return ki.showMessage(ze,$.default.Warning,re,ue[0],ue.slice(1))},showErrorMessage(re,...ue){return ki.showMessage(ze,$.default.Error,re,ue[0],ue.slice(1))},showQuickPick(re,ue,Oe){return si.showQuickPick(ze,re,ue,Oe)},showWorkspaceFolderPick(re){return si.showWorkspaceFolderPick(re)},showInputBox(re,ue){return si.showInput(re,ue)},showOpenDialog(re){return Oi.showOpenDialog(ze,re)},showSaveDialog(re){return Oi.showSaveDialog(re)},createStatusBarItem(re,ue,Oe){let ot,wt,Lt;return typeof re=="string"?(ot=re,wt=ue,Lt=Oe):(wt=re,Lt=ue),ei.createStatusBarEntry(ze,ot,wt,Lt)},setStatusBarMessage(re,ue){return ei.setStatusBarMessage(re,ue)},withScmProgress(re){return Se.report("window.withScmProgress",ze,"Use 'withProgress' instead."),vi.withProgress(ze,{location:Ne.ProgressLocation.SourceControl},(ue,Oe)=>re({report(ot){}}))},withProgress(re,ue){return vi.withProgress(ze,re,ue)},createOutputChannel(re,ue){return St.createOutputChannel(re,ue,ze)},createWebviewPanel(re,ue,Oe,ot){return Mi.createWebviewPanel(ze,re,ue,Oe,ot)},createWebviewTextEditorInset(re,ue,Oe,ot){return(0,Ze.$CF)(ze,"editorInsets"),Pi.createWebviewEditorInset(re,ue,Oe,ot,ze)},createTerminal(re,ue,Oe){return typeof re=="object"?"pty"in re?_e.createExtensionTerminal(re):_e.createTerminalFromOptions(re):_e.createTerminal(re,ue,Oe)},registerTerminalLinkProvider(re){return _e.registerLinkProvider(re)},registerTerminalProfileProvider(re,ue){return _e.registerProfileProvider(ze,re,ue)},registerTerminalQuickFixProvider(re,ue){return(0,Ze.$CF)(ze,"terminalQuickFixProvider"),_e.registerTerminalQuickFixProvider(re,ze.identifier.value,ue)},registerTreeDataProvider(re,ue){return $i.registerTreeDataProvider(re,ue,ze)},createTreeView(re,ue){return $i.createTreeView(re,ue,ze)},registerWebviewPanelSerializer:(re,ue)=>Mi.registerWebviewPanelSerializer(ze,re,ue),registerCustomEditorProvider:(re,ue,Oe={})=>un.registerCustomEditorProvider(ze,re,ue,Oe),registerFileDecorationProvider(re){return Ue.registerFileDecorationProvider(re,ze)},registerUriHandler(re){return gi.registerUriHandler(ze,re)},createQuickPick(){return si.createQuickPick(ze)},createInputBox(){return si.createInputBox(ze)},get activeColorTheme(){return Li.activeColorTheme},onDidChangeActiveColorTheme(re,ue,Oe){return et(Li.onDidChangeActiveColorTheme)(re,ue,Oe)},registerWebviewViewProvider(re,ue,Oe){return Fi.registerWebviewViewProvider(ze,re,ue,Oe?.webviewOptions)},get activeNotebookEditor(){return It.activeNotebookEditor},onDidChangeActiveNotebookEditor(re,ue,Oe){return et(It.onDidChangeActiveNotebookEditor)(re,ue,Oe)},get visibleNotebookEditors(){return It.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return et(It.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(re,ue,Oe){return et(mi.onDidChangeNotebookEditorSelection)(re,ue,Oe)},onDidChangeNotebookEditorVisibleRanges(re,ue,Oe){return et(mi.onDidChangeNotebookEditorVisibleRanges)(re,ue,Oe)},showNotebookDocument(re,ue){return It.showNotebookDocument(re,ue)},registerExternalUriOpener(re,ue,Oe){return(0,Ze.$CF)(ze,"externalUriOpener"),ln.registerExternalUriOpener(ze.identifier,re,ue,Oe)},registerProfileContentHandler(re,ue){return(0,Ze.$CF)(ze,"profileContentHandlers"),hn.registerProfileContentHandler(ze,re,ue)},registerQuickDiffProvider(re,ue,Oe,ot){return(0,Ze.$CF)(ze,"quickDiffProvider"),Ri.registerQuickDiffProvider(pt(re),ue,Oe,ot)},get tabGroups(){return J.tabGroups},registerShareProvider(re,ue){return(0,Ze.$CF)(ze,"shareProvider"),Qi.registerShareProvider(pt(re),ue)}},sn={get rootPath(){return Se.report("workspace.rootPath",ze,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),dt.getPath()},set rootPath(re){throw new T.$9("rootPath")},getWorkspaceFolder(re){return dt.getWorkspaceFolder(re)},get workspaceFolders(){return dt.getWorkspaceFolders()},get name(){return dt.name},set name(re){throw new T.$9("name")},get workspaceFile(){return dt.workspaceFile},set workspaceFile(re){throw new T.$9("workspaceFile")},updateWorkspaceFolders:(re,ue,...Oe)=>dt.updateWorkspaceFolders(ze,re,ue||0,...Oe),onDidChangeWorkspaceFolders:function(re,ue,Oe){return et(dt.onDidChangeWorkspace)(re,ue,Oe)},asRelativePath:(re,ue)=>dt.getRelativePath(re,ue),findFiles:(re,ue,Oe,ot)=>dt.findFiles(re,ue,Oe,ze.identifier,ot),findTextInFiles:(re,ue,Oe,ot)=>{(0,Ze.$CF)(ze,"findTextInFiles");let wt,Lt;return typeof ue=="object"?(wt=ue,Lt=Oe):(wt={},Lt=ue,ot=Oe),dt.findTextInFiles(re,wt||{},Lt,ze.identifier,ot)},save:re=>dt.save(re),saveAs:re=>dt.saveAs(re),saveAll:re=>dt.saveAll(re),applyEdit(re,ue){return Yt.applyWorkspaceEdit(re,ze,ue)},createFileSystemWatcher:(re,ue,Oe,ot)=>{let wt;return typeof ue=="boolean"?wt={ignoreCreateEvents:!!ue,ignoreChangeEvents:!!Oe,ignoreDeleteEvents:!!ot,correlate:!1}:ue&&((0,Ze.$CF)(ze,"createFileSystemWatcher"),wt={...ue,correlate:!0}),_t.createFileSystemWatcher(dt,ze,re,wt)},get textDocuments(){return At.getAllDocumentData().map(re=>re.document)},set textDocuments(re){throw new T.$9("textDocuments")},openTextDocument(re){let ue;const Oe=re;if(typeof re=="string")ue=Promise.resolve(f.URI.file(re));else if(f.URI.isUri(re))ue=Promise.resolve(re);else if(!Oe||typeof Oe=="object")ue=At.createDocumentData(Oe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ue.then(ot=>At.ensureDocumentData(ot).then(wt=>wt.document))},onDidOpenTextDocument:(re,ue,Oe)=>et(At.onDidAddDocument)(re,ue,Oe),onDidCloseTextDocument:(re,ue,Oe)=>et(At.onDidRemoveDocument)(re,ue,Oe),onDidChangeTextDocument:(re,ue,Oe)=>et(At.onDidChangeDocument)(re,ue,Oe),onDidSaveTextDocument:(re,ue,Oe)=>et(At.onDidSaveDocument)(re,ue,Oe),onWillSaveTextDocument:(re,ue,Oe)=>et(Gi.getOnWillSaveTextDocumentEvent(ze))(re,ue,Oe),get notebookDocuments(){return It.notebookDocuments.map(re=>re.apiNotebook)},async openNotebookDocument(re,ue){let Oe;if(f.URI.isUri(re))Oe=re,await It.openNotebookDocument(re);else if(typeof re=="string")Oe=f.URI.revive(await It.createNotebookDocument({viewType:re,content:ue}));else throw new Error("Invalid arguments");return It.getNotebookDocument(Oe).apiNotebook},onDidSaveNotebookDocument(re,ue,Oe){return et(ri.onDidSaveNotebookDocument)(re,ue,Oe)},onDidChangeNotebookDocument(re,ue,Oe){return et(ri.onDidChangeNotebookDocument)(re,ue,Oe)},onWillSaveNotebookDocument(re,ue,Oe){return et(Ci.getOnWillSaveNotebookDocumentEvent(ze))(re,ue,Oe)},get onDidOpenNotebookDocument(){return et(It.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return et(It.onDidCloseNotebookDocument)},registerNotebookSerializer(re,ue,Oe,ot){return It.registerNotebookSerializer(ze,re,ue,Oe,(0,Ze.$BF)(ze,"notebookLiveShare")?ot:void 0)},onDidChangeConfiguration:(re,ue,Oe)=>et(tn.onDidChangeConfiguration)(re,ue,Oe),getConfiguration(re,ue){return ue=arguments.length===1?void 0:ue,tn.getConfiguration(re,ue,ze)},registerTextDocumentContentProvider(re,ue){return Si.registerTextDocumentContentProvider(re,ue)},registerTaskProvider:(re,ue)=>(Se.report("window.registerTaskProvider",ze,"Use the corresponding function on the 'tasks' namespace instead"),Et.registerTaskProvider(ze,re,ue)),registerFileSystemProvider(re,ue,Oe){return(0,L.$Qc)(Ji.registerFileSystemProvider(ze,re,ue,Oe),Vt.addFileSystemProvider(re,ue,Oe))},get fs(){return Vt.value},registerFileSearchProvider:(re,ue)=>((0,Ze.$CF)(ze,"fileSearchProvider"),Ut.registerFileSearchProvider(re,ue)),registerTextSearchProvider:(re,ue)=>((0,Ze.$CF)(ze,"textSearchProvider"),Ut.registerTextSearchProvider(re,ue)),registerRemoteAuthorityResolver:(re,ue)=>((0,Ze.$CF)(ze,"resolvers"),kt.registerRemoteAuthorityResolver(re,ue)),registerResourceLabelFormatter:re=>((0,Ze.$CF)(ze,"resolvers"),Xi.$registerResourceLabelFormatter(re)),getRemoteExecServer:re=>((0,Ze.$CF)(ze,"resolvers"),kt.getRemoteExecServer(re)),onDidCreateFiles:(re,ue,Oe)=>et(_t.onDidCreateFile)(re,ue,Oe),onDidDeleteFiles:(re,ue,Oe)=>et(_t.onDidDeleteFile)(re,ue,Oe),onDidRenameFiles:(re,ue,Oe)=>et(_t.onDidRenameFile)(re,ue,Oe),onWillCreateFiles:(re,ue,Oe)=>et(_t.getOnWillCreateFileEvent(ze))(re,ue,Oe),onWillDeleteFiles:(re,ue,Oe)=>et(_t.getOnWillDeleteFileEvent(ze))(re,ue,Oe),onWillRenameFiles:(re,ue,Oe)=>et(_t.getOnWillRenameFileEvent(ze))(re,ue,Oe),openTunnel:re=>((0,Ze.$CF)(ze,"tunnels"),Ft.openTunnel(ze,re).then(ue=>{if(!ue)throw new Error("cannot open tunnel");return ue})),get tunnels(){return(0,Ze.$CF)(ze,"tunnels"),Ft.getTunnels()},onDidChangeTunnels:(re,ue,Oe)=>((0,Ze.$CF)(ze,"tunnels"),et(Ft.onDidChangeTunnels)(re,ue,Oe)),registerPortAttributesProvider:(re,ue)=>((0,Ze.$CF)(ze,"portsAttributes"),Ft.registerPortsAttributesProvider(re,ue)),registerTunnelProvider:(re,ue)=>((0,Ze.$CF)(ze,"tunnelFactory"),Ft.registerTunnelProvider(re,ue)),registerTimelineProvider:(re,ue)=>((0,Ze.$CF)(ze,"timeline"),Yi.registerTimelineProvider(re,ue,ze.identifier,We.converter)),get isTrusted(){return dt.trusted},requestWorkspaceTrust:re=>((0,Ze.$CF)(ze,"workspaceTrust"),dt.requestWorkspaceTrust(re)),onDidGrantWorkspaceTrust:(re,ue,Oe)=>et(dt.onDidGrantWorkspaceTrust)(re,ue,Oe),registerEditSessionIdentityProvider:(re,ue)=>((0,Ze.$CF)(ze,"editSessionIdentityProvider"),dt.registerEditSessionIdentityProvider(re,ue)),onWillCreateEditSessionIdentity:(re,ue,Oe)=>((0,Ze.$CF)(ze,"editSessionIdentityProvider"),et(dt.getOnWillCreateEditSessionIdentityEvent(ze))(re,ue,Oe)),registerCanonicalUriProvider:(re,ue)=>((0,Ze.$CF)(ze,"canonicalUriProvider"),dt.registerCanonicalUriProvider(re,ue)),getCanonicalUri:(re,ue,Oe)=>((0,Ze.$CF)(ze,"canonicalUriProvider"),dt.provideCanonicalUri(re,ue,Oe))},on={get inputBox(){return Se.report("scm.inputBox",ze,"Use 'SourceControl.inputBox' instead"),pi.getLastInputBox(ze)},createSourceControl(re,ue,Oe){return pi.createSourceControl(ze,re,ue,Oe)}},an={createCommentController(re,ue){return Ai.createCommentController(ze,re,ue)}},Ui={get activeDebugSession(){return mt.activeDebugSession},get activeDebugConsole(){return mt.activeDebugConsole},get breakpoints(){return mt.breakpoints},get stackFrameFocus(){return mt.stackFrameFocus},onDidStartDebugSession(re,ue,Oe){return et(mt.onDidStartDebugSession)(re,ue,Oe)},onDidTerminateDebugSession(re,ue,Oe){return et(mt.onDidTerminateDebugSession)(re,ue,Oe)},onDidChangeActiveDebugSession(re,ue,Oe){return et(mt.onDidChangeActiveDebugSession)(re,ue,Oe)},onDidReceiveDebugSessionCustomEvent(re,ue,Oe){return et(mt.onDidReceiveDebugSessionCustomEvent)(re,ue,Oe)},onDidChangeBreakpoints(re,ue,Oe){return et(mt.onDidChangeBreakpoints)(re,ue,Oe)},onDidChangeStackFrameFocus(re,ue,Oe){return(0,Ze.$CF)(ze,"debugFocus"),et(mt.onDidChangeStackFrameFocus)(re,ue,Oe)},registerDebugConfigurationProvider(re,ue,Oe){return mt.registerDebugConfigurationProvider(re,ue,Oe||zt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(re,ue){return mt.registerDebugAdapterDescriptorFactory(ze,re,ue)},registerDebugAdapterTrackerFactory(re,ue){return mt.registerDebugAdapterTrackerFactory(re,ue)},startDebugging(re,ue,Oe){return!Oe||typeof Oe=="object"&&"configuration"in Oe?mt.startDebugging(re,ue,{parentSession:Oe}):mt.startDebugging(re,ue,Oe||{})},stopDebugging(re){return mt.stopDebugging(re)},addBreakpoints(re){return mt.addBreakpoints(re)},removeBreakpoints(re){return mt.removeBreakpoints(re)},asDebugSourceUri(re,ue){return mt.asDebugSourceUri(re,ue)}},Bi={registerTaskProvider:(re,ue)=>Et.registerTaskProvider(ze,re,ue),fetchTasks:re=>Et.fetchTasks(re),executeTask:re=>Et.executeTask(ze,re),get taskExecutions(){return Et.taskExecutions},onDidStartTask:(re,ue,Oe)=>et(Et.onDidStartTask)(re,ue,Oe),onDidEndTask:(re,ue,Oe)=>et(Et.onDidEndTask)(re,ue,Oe),onDidStartTaskProcess:(re,ue,Oe)=>et(Et.onDidStartTaskProcess)(re,ue,Oe),onDidEndTaskProcess:(re,ue,Oe)=>et(Et.onDidEndTaskProcess)(re,ue,Oe)},Vi={createNotebookController(re,ue,Oe,ot,wt){return ci.createNotebookController(ze,re,ue,Oe,ot,(0,Ze.$BF)(ze,"notebookMessaging")?wt:void 0)},registerNotebookCellStatusBarItemProvider:(re,ue)=>It.registerNotebookCellStatusBarItemProvider(ze,re,ue),createRendererMessaging(re){return Ii.createRendererMessaging(ze,re)},createNotebookControllerDetectionTask(re){return(0,Ze.$CF)(ze,"notebookKernelSource"),ci.createNotebookControllerDetectionTask(ze,re)},registerKernelSourceActionProvider(re,ue){return(0,Ze.$CF)(ze,"notebookKernelSource"),ci.registerKernelSourceActionProvider(ze,re,ue)},onDidChangeNotebookCellExecutionState(re,ue,Oe){return(0,Ze.$CF)(ze,"notebookCellExecutionState"),et(ci.onDidChangeNotebookCellExecutionState)(re,ue,Oe)}},Di={t(...re){if(typeof re[0]=="string"){const ue=re.shift(),Oe=!re||typeof re[0]!="object"?re:re[0];return bt.getMessage(ze.identifier.value,{message:ue,args:Oe})}return bt.getMessage(ze.identifier.value,re[0])},get bundle(){return bt.getBundle(ze.identifier.value)},get uri(){return bt.getBundleUri(ze.identifier.value)}},Wi={_version:1,registerInteractiveEditorSessionProvider(re,ue){return(0,Ze.$CF)(ze,"interactive"),Zi.registerProvider(ze,re,ue)},registerInteractiveSessionProvider(re,ue){return(0,Ze.$CF)(ze,"interactive"),bi.registerChatProvider(ze,re,ue)},sendInteractiveRequestToProvider(re,ue){return(0,Ze.$CF)(ze,"interactive"),bi.sendInteractiveRequestToProvider(re,ue)},transferChatSession(re,ue){return(0,Ze.$CF)(ze,"interactive"),bi.transferChatSession(re,ue)}},qi={getRelatedInformation(re,ue){return(0,Ze.$CF)(ze,"aiRelatedInformation"),en.getRelatedInformation(ze,re,ue)},registerRelatedInformationProvider(re,ue){return(0,Ze.$CF)(ze,"aiRelatedInformation"),en.registerRelatedInformationProvider(ze,re,ue)},registerEmbeddingVectorProvider(re,ue){return(0,Ze.$CF)(ze,"aiRelatedInformation"),Ti.registerEmbeddingVectorProvider(ze,re,ue)}},$n={registerChatResponseProvider(re,ue,Oe){return(0,Ze.$CF)(ze,"chatProvider"),di.registerProvider(ze.identifier,re,ue,Oe)},requestChatAccess(re){return(0,Ze.$CF)(ze,"chatRequestAccess"),di.requestChatResponseProvider(ze.identifier,re)},registerVariable(re,ue,Oe){return(0,Ze.$CF)(ze,"chatAgents2"),_i.registerVariableResolver(ze,re,ue,Oe)},registerMappedEditsProvider(re,ue){return(0,Ze.$CF)(ze,"mappedEditsProvider"),ht.registerMappedEditsProvider(ze,re,ue)},createChatAgent(re,ue){return(0,Ze.$CF)(ze,"chatAgents2"),xi.createChatAgent(ze,re,ue)}},pn={registerSpeechProvider(re,ue){return(0,Ze.$CF)(ze,"speech"),yi.registerProvider(ze.identifier,re,ue)}};return{version:$t.version,ai:qi,authentication:fn,commands:gn,comments:an,chat:$n,debug:Ui,env:zi,extensions:nn,interactive:Wi,l10n:Di,languages:rn,notebooks:Vi,scm:on,speech:pn,tasks:Bi,tests:ji,window:mn,workspace:sn,Breakpoint:Ne.$7L,TerminalOutputAnchor:Ne.TerminalOutputAnchor,ChatAgentResultFeedbackKind:Ne.ChatAgentResultFeedbackKind,ChatMessage:Ne.$YM,ChatMessageRole:Ne.ChatMessageRole,ChatVariableLevel:Ne.ChatVariableLevel,ChatAgentCompletionItem:Ne.$XM,CallHierarchyIncomingCall:Ne.$tL,CallHierarchyItem:Ne.$sL,CallHierarchyOutgoingCall:Ne.$uL,CancellationError:T.$5,CancellationTokenSource:y.$6d,CandidatePortSource:o.CandidatePortSource,CodeAction:Ne.$pL,CodeActionKind:Ne.$qL,CodeActionTriggerKind:Ne.CodeActionTriggerKind,CodeLens:Ne.$vL,Color:Ne.$IL,ColorInformation:Ne.$JL,ColorPresentation:Ne.$KL,ColorThemeKind:Ne.ColorThemeKind,CommentMode:Ne.CommentMode,CommentState:Ne.CommentState,CommentThreadCollapsibleState:Ne.CommentThreadCollapsibleState,CommentThreadState:Ne.CommentThreadState,CompletionItem:Ne.$CL,CompletionItemKind:Ne.CompletionItemKind,CompletionItemTag:Ne.CompletionItemTag,CompletionList:Ne.$DL,CompletionTriggerKind:Ne.CompletionTriggerKind,ConfigurationTarget:Ne.ConfigurationTarget,CustomExecution:Ne.$SL,DebugAdapterExecutable:Ne.$$L,DebugAdapterInlineImplementation:Ne.$bM,DebugAdapterNamedPipeServer:Ne.$aM,DebugAdapterServer:Ne.$_L,DebugConfigurationProviderTriggerKind:zt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Ne.DebugConsoleMode,DecorationRangeBehavior:Ne.DecorationRangeBehavior,Diagnostic:Ne.$jL,DiagnosticRelatedInformation:Ne.$iL,DiagnosticSeverity:Ne.DiagnosticSeverity,DiagnosticTag:Ne.DiagnosticTag,Disposable:Ne.$8K,DocumentHighlight:Ne.$lL,DocumentHighlightKind:Ne.DocumentHighlightKind,MultiDocumentHighlight:Ne.$mL,DocumentLink:Ne.$HL,DocumentSymbol:Ne.$oL,EndOfLine:Ne.EndOfLine,EnvironmentVariableMutatorType:Ne.EnvironmentVariableMutatorType,EvaluatableExpression:Ne.$eM,InlineValueText:Ne.$fM,InlineValueVariableLookup:Ne.$gM,InlineValueEvaluatableExpression:Ne.$hM,InlineCompletionTriggerKind:Ne.InlineCompletionTriggerKind,EventEmitter:C.$Vd,ExtensionKind:Ne.ExtensionKind,ExtensionMode:Ne.ExtensionMode,ExternalUriOpenerPriority:Ne.ExternalUriOpenerPriority,FileChangeType:Ne.FileChangeType,FileDecoration:Ne.$rM,FileDecoration2:Ne.$rM,FileSystemError:Ne.$jM,FileType:w.FileType,FilePermission:w.FilePermission,FoldingRange:Ne.$kM,FoldingRangeKind:Ne.FoldingRangeKind,FunctionBreakpoint:Ne.$9L,InlineCompletionItem:Ne.$EL,InlineCompletionList:Ne.$FL,Hover:Ne.$kL,IndentAction:k.IndentAction,Location:Ne.$hL,MarkdownString:Ne.$wL,OverviewRulerLane:l.OverviewRulerLane,ParameterInformation:Ne.$xL,PortAutoForwardAction:Ne.PortAutoForwardAction,Position:Ne.$9K,ProcessExecution:Ne.$QL,ProgressLocation:Ne.ProgressLocation,QuickInputButtons:Ne.$qM,Range:Ne.$0K,RelativePattern:Ne.$5L,Selection:Ne.$$K,SelectionRange:Ne.$rL,SemanticTokens:Ne.$nM,SemanticTokensBuilder:Ne.$mM,SemanticTokensEdit:Ne.$oM,SemanticTokensEdits:Ne.$pM,SemanticTokensLegend:Ne.$lM,ShellExecution:Ne.$RL,ShellQuoting:Ne.ShellQuoting,SignatureHelp:Ne.$zL,SignatureHelpTriggerKind:Ne.SignatureHelpTriggerKind,SignatureInformation:Ne.$yL,SnippetString:Ne.$gL,SourceBreakpoint:Ne.$8L,StandardTokenType:Ne.StandardTokenType,StatusBarAlignment:Ne.StatusBarAlignment,SymbolInformation:Ne.$nL,SymbolKind:Ne.SymbolKind,SymbolTag:Ne.SymbolTag,Task:Ne.$TL,TaskGroup:Ne.$PL,TaskPanelKind:Ne.TaskPanelKind,TaskRevealKind:Ne.TaskRevealKind,TaskScope:Ne.TaskScope,TerminalLink:Ne.$LL,TerminalQuickFixTerminalCommand:Ne.$NL,TerminalQuickFixOpener:Ne.$ML,TerminalLocation:Ne.TerminalLocation,TerminalProfile:Ne.$OL,TerminalExitReason:Ne.TerminalExitReason,TextDocumentSaveReason:Ne.TextDocumentSaveReason,TextEdit:Ne.$cL,SnippetTextEdit:Ne.$eL,TextEditorCursorStyle:b.TextEditorCursorStyle,TextEditorLineNumbersStyle:Ne.TextEditorLineNumbersStyle,TextEditorRevealType:Ne.TextEditorRevealType,TextEditorSelectionChangeKind:Ne.TextEditorSelectionChangeKind,SyntaxTokenType:Ne.SyntaxTokenType,TextDocumentChangeReason:Ne.TextDocumentChangeReason,ThemeColor:Ne.$4L,ThemeIcon:Ne.$3L,TreeItem:Ne.$UL,TreeItemCheckboxState:Ne.TreeItemCheckboxState,TreeItemCollapsibleState:Ne.TreeItemCollapsibleState,TypeHierarchyItem:Ne.$MM,UIKind:Rt.UIKind,Uri:f.URI,ViewColumn:Ne.ViewColumn,WorkspaceEdit:Ne.$fL,DocumentDropEdit:Ne.$1L,DocumentPasteEdit:Ne.$2L,InlayHint:Ne.$BL,InlayHintLabelPart:Ne.$AL,InlayHintKind:Ne.InlayHintKind,RemoteAuthorityResolverError:Ne.$bL,ResolvedAuthority:Ne.$_K,ManagedResolvedAuthority:Ne.$aL,SourceControlInputBoxValidationType:Ne.SourceControlInputBoxValidationType,ExtensionRuntime:Ne.ExtensionRuntime,TimelineItem:Ne.$BM,NotebookRange:Ne.$tM,NotebookCellKind:Ne.NotebookCellKind,NotebookCellExecutionState:Ne.NotebookCellExecutionState,NotebookCellData:Ne.$uM,NotebookData:Ne.$vM,NotebookRendererScript:Ne.$zM,NotebookCellStatusBarAlignment:Ne.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Ne.NotebookEditorRevealType,NotebookCellOutput:Ne.$xM,NotebookCellOutputItem:Ne.$wM,NotebookCellStatusBarItem:Ne.$yM,NotebookControllerAffinity:Ne.NotebookControllerAffinity,NotebookControllerAffinity2:Ne.NotebookControllerAffinity2,NotebookEdit:Ne.$dL,NotebookKernelSourceAction:Ne.$AM,NotebookVariablesRequestKind:Ne.NotebookVariablesRequestKind,PortAttributes:Ne.$DM,LinkedEditingRanges:Ne.$CM,TestResultState:Ne.TestResultState,TestRunRequest:Ne.$EM,TestMessage:Ne.$FM,TestMessage2:Ne.$FM,TestTag:Ne.$GM,TestRunProfileKind:Ne.TestRunProfileKind,TextSearchCompleteMessageType:Gt.TextSearchCompleteMessageType,DataTransfer:Ne.$ZL,DataTransferItem:Ne.$VL,CoveredCount:Ne.$HM,FileCoverage:Ne.$IM,StatementCoverage:Ne.$JM,BranchCoverage:Ne.$KM,FunctionCoverage:Ne.$LM,WorkspaceTrustState:Ne.WorkspaceTrustState,LanguageStatusSeverity:Ne.LanguageStatusSeverity,QuickPickItemKind:Ne.QuickPickItemKind,InputBoxValidationSeverity:Ne.InputBoxValidationSeverity,TabInputText:Ne.$NM,TabInputTextDiff:Ne.$OM,TabInputTextMerge:Ne.$PM,TabInputCustom:Ne.$QM,TabInputNotebook:Ne.$SM,TabInputNotebookDiff:Ne.$TM,TabInputWebview:Ne.$RM,TabInputTerminal:Ne.$UM,TabInputInteractiveWindow:Ne.$VM,TabInputChat:Ne.$WM,TelemetryTrustedValue:r.$Lo,LogLevel:s.LogLevel,EditSessionIdentityMatch:n.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Ne.InteractiveSessionVoteDirection,ChatAgentCopyKind:Ne.ChatAgentCopyKind,InteractiveEditorResponseFeedbackKind:Ne.InteractiveEditorResponseFeedbackKind,StackFrameFocus:Ne.$cM,ThreadFocus:Ne.$dM,RelatedInformationType:Ne.RelatedInformationType,SpeechToTextStatus:Ne.SpeechToTextStatus}}}e.$$hc=Jt}),define(Pe[290],Re([1,0,70,112,36,110,37,32,61,64,115,117,118,85,87,81,111,63,42,84,59,62,255,14,116,82,83]),function(ge,e,y,T,C,L,R,$,f,b,A,k,l,p,w,s,a,r,n,o,c,h,t,u,i,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,y.$Yr)(g.$Zgc,g.$Ygc,1),(0,y.$Yr)(u.$oj,t.$_hc,1),(0,y.$Yr)(s.$$fc,s.$_fc,1),(0,y.$Yr)($.$tN,$.$sN,0),(0,y.$Yr)(R.$tgc,R.$rgc,0),(0,y.$Yr)(r.$vgc,r.$ugc,0),(0,y.$Yr)(k.$0gc,k.$bhc,0),(0,y.$Yr)(L.$dhc,L.$chc,0),(0,y.$Yr)(f.$iN,f.$hN,0),(0,y.$Yr)(m.$1gc,m.$2gc,0),(0,y.$Yr)(n.$8fc,n.$7fc,0),(0,y.$Yr)(T.$Jhc,T.$Ihc,1),(0,y.$Yr)(l.$thc,l.$uhc,0),(0,y.$Yr)(p.$Ogc,p.$Ngc,0),(0,y.$Yr)(A.$Whc,A.$Vhc,0),(0,y.$Yr)(b.$Rgc,b.$Ugc,0),(0,y.$Yr)(w.$oyb,w.$pyb,0),(0,y.$Yr)(a.$0hc,a.$9hc,0),(0,y.$Yr)(C.$qgc,C.$pgc,0),(0,y.$Yr)(o.$Wgc,o.$Vgc,0),(0,y.$Yr)(c.$rN,c.$oN,0),(0,y.$Yr)(h.$Fgc,h.$Ggc,0),(0,y.$Yr)(i.$8gc,i.$9gc,0)}),define(Pe[291],Re([1,0,289,38,2,286,7,13,274]),function(ge,e,y,T,C,L,R,$,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kkc=void 0;class b extends L.$cic{j(){}getModule(p,w){for(const s of this.b){const a=s(p);if(a){p=a;break}}if(this.a.has(p))return this.a.get(p).load(p,w,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class A extends T.$4gc{constructor(){super(...arguments),this.extensionRuntime=R.ExtensionRuntime.Webworker}async tb(){this.h.createInstance(f.$jkc);const p=this.h.invokeFunction(y.$$hc);this.r=this.h.createInstance(b,p,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.zb()}ub(p){return p.browser}async vb(p,w,s){w=w.with({path:k(w.path,".js")});const a=p?.identifier.value;a&&performance.mark(`code/extHost/willFetchExtensionCode/${a}`);const r=C.URI.revive(await this.C.$asBrowserUri(w)),n=await fetch(r.toString(!0));if(a&&performance.mark(`code/extHost/didFetchExtensionCode/${a}`),n.status!==200)throw new Error(n.statusText);const o=await n.text(),c=`${w.toString(!0)}#vscode-extension`,h=`${o}
//# sourceURL=${c}`;let t;try{t=new Function("module","exports","require",h)}catch(m){throw console.error(a?`Loading code for extension ${a} failed: ${m.message}`:`Loading code failed: ${m.message}`),console.error(`${w.toString(!0)}${typeof m.line=="number"?` line ${m.line}`:""}${typeof m.column=="number"?` column ${m.column}`:""}`),console.error(m),m}p&&await this.w.initializeLocalizedMessages(p);const u={},i={exports:u},g=m=>{const d=this.r.getModule(m,w);if(d===void 0)throw new Error(`Cannot load module '${m}'`);return d};try{return s.codeLoadingStart(),a&&performance.mark(`code/extHost/willLoadExtensionCode/${a}`),t(i,u,g),i.exports!==u?i.exports:u}finally{a&&performance.mark(`code/extHost/didLoadExtensionCode/${a}`),s.codeLoadingStop()}}async $setRemoteEnvironment(p){}async zb(p=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const w=Date.now()+p;for(;Date.now()<w&&!("__jsDebugIsReady"in globalThis);)await(0,$.$7g)(10)}}e.$kkc=A;function k(l,p){return l.endsWith(p)?l:l+p}}),define(Pe[292],Re([1,0,69,70,14,38,199,86,291]),function(ge,e,y,T,C,L,R,$,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,T.$Yr)(C.$nj,new y.$3h(R.$bic,[!0],!0)),(0,T.$Yr)(L.$5gc,f.$kkc,0),(0,T.$Yr)($.$wgc,$.$xgc,0)}),define(Pe[297],Re([1,0,24,5,79,287,276,19,88,12,2,290,292]),function(ge,e,y,T,C,L,R,$,f,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const k=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const l=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function p(t){return/^(file|vscode-remote):/i.test(t)}const w=fetch.bind(self);function s(t){self.fetch=async function(u,i){return u instanceof Request||p(String(u))&&(u=(await t(A.URI.parse(String(u)))).toString(!0)),w(u,i)},self.XMLHttpRequest=class extends XMLHttpRequest{open(u,i,g,m,d){(async()=>(p(i.toString())&&(i=(await t(A.URI.parse(i.toString()))).toString(!0)),super.open(u,i,g??!0,m,d)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const t=self.Worker;Worker=function(u,i){if(/^file:/i.test(u.toString()))u=b.$og.uriToBrowserUri(A.URI.parse(u.toString())).toString(!0);else if(/^vscode-remote:/i.test(u.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const m=`(${function(v){function E(O){return typeof O=="string"||O instanceof URL?String(O).replace(/^file:\/\//i,"vscode-file://vscode-app"):O}const D=fetch.bind(self);self.fetch=function(O,G){return O instanceof Request?D(O,G):D(E(O),G)},self.XMLHttpRequest=class extends XMLHttpRequest{open(O,G,W,z,P){return super.open(O,E(G),W??!0,z,P)}};const N=importScripts.bind(self);self.importScripts=(...O)=>{N(...O.map(E))},N(v)}.toString()}('${u}'))`;i=i||{},i.name=i.name||$.$nc(u.toString());const d=new Blob([m],{type:"application/javascript"}),S=URL.createObjectURL(d);return new t(S,i)}}else self.Worker=class extends R.$lkc{constructor(t,u){super(l,t,{name:$.$nc(t.toString()),...u})}};const a=new class{constructor(){this.pid=void 0}exit(t){k()}};class r{constructor(){const u=new MessageChannel,i=new T.$Vd;let g=!1;l(u.port2,[u.port2]),u.port1.onmessage=m=>{const{data:d}=m;if(!(d instanceof ArrayBuffer)){console.warn("UNKNOWN data received",d);return}const S=y.$je.wrap(new Uint8Array(d,0,d.byteLength));if((0,C.$um)(S,2)){g=!0,o("received terminate message from renderer");return}i.fire(S)},this.protocol={onMessage:i.event,send:m=>{if(!g){const d=m.buffer.buffer.slice(m.buffer.byteOffset,m.buffer.byteOffset+m.buffer.byteLength);u.port1.postMessage(d,[d])}}}}}function n(t){return new Promise(u=>{const i=t.onMessage(g=>{i.dispose();const m=JSON.parse(g.toString());t.send((0,C.$tm)(0)),u({protocol:t,initData:m})});t.send((0,C.$tm)(1))})}let o=t=>k();function c(t){return!!t&&typeof t=="object"&&t.type==="vscode.init"&&t.data instanceof Map}function h(){f.mark("code/extHost/willConnectToRenderer");const t=new r;return{onmessage(u){c(u)&&n(t.protocol).then(i=>{f.mark("code/extHost/didWaitForInitData");const g=new L.$eic(i.protocol,i.initData,a,null,u.data);s(m=>g.asBrowserUri(m)),o=m=>g.terminate(m)})}}}e.create=h})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/2c8f29174a63b3ace3d00ad0028cdc7ed9853b8b/core/vs/workbench/api/worker/extensionHostWorker.js.map
